/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/path","vs/base/common/strings","vs/base/common/platform","vs/base/common/types","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/errors","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/workbench/api/common/extHostTypeConverters","vs/base/common/cancellation","vs/base/common/map","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/base/node/pfs","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/extpath","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/base/common/glob","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","fs","child_process","vs/workbench/api/common/extHostDocumentsAndEditors","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/editor/common/core/range","vs/platform/files/common/files","vs/workbench/api/common/extHostDebugService","vs/base/common/stopwatch","os","vs/editor/common/core/position","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostCommands","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/json","vs/base/common/linkedList","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/hash","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/node/processes","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/processes","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/node/powershell","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/common/externalTerminal","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/contrib/terminal/node/terminalProfiles","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],ge=function(G){for(var e=[],b=0,I=G.length;b<I;b++)e[b]=me[G[b]];return e};define(me[52],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function b(I,T){if(!I)throw new Error(T?`Assertion failed (${T})`:"Assertion Failed")}e.ok=b}),define(me[53],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupByNumber=e.groupBy=e.forEach=e.values=void 0;const b=Object.prototype.hasOwnProperty;function I(C){const f=[];for(let m in C)b.call(C,m)&&f.push(C[m]);return f}e.values=I;function T(C,f){for(let m in C)if(b.call(C,m)&&f({key:m,value:C[m]},function(){delete C[m]})===!1)return}e.forEach=T;function A(C,f){const m=Object.create(null);for(const l of C){const d=f(l);let E=m[d];E||(E=m[d]=[]),E.push(l)}return m}e.groupBy=A;function y(C,f){const m=new Map;for(const l of C){const d=f(l);let E=m.get(d);E||(E=[],m.set(d,E)),E.push(l)}return m}e.groupByNumber=y;function P(C){const f=Object.create(null);return C&&C.forEach((m,l)=>{f[l]=m}),f}e.fromMap=P;function D(C,f){const m=[],l=[];for(let d of C)f.has(d)||m.push(d);for(let d of f)C.has(d)||l.push(d);return{removed:m,added:l}}e.diffSets=D;function k(C,f){const m=[],l=[];for(let[d,E]of C)f.has(d)||m.push(E);for(let[d,E]of f)C.has(d)||l.push(E);return{removed:m,added:l}}e.diffMaps=k;class i{constructor(){this.map=new Map}add(f,m){let l=this.map.get(f);l||(l=new Set,this.map.set(f,l)),l.add(m)}delete(f,m){const l=this.map.get(f);!l||(l.delete(m),l.size===0&&this.map.delete(f))}forEach(f,m){const l=this.map.get(f);!l||l.forEach(m)}}e.SetMap=i}),define(me[54],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function b(y){return(P,D,k)=>{let i=null,C=null;if(typeof k.value=="function"?(i="value",C=k.value):typeof k.get=="function"&&(i="get",C=k.get),!C)throw new Error("not supported");k[i]=y(C,D)}}e.createDecorator=b;function I(y,P,D){let k=null,i=null;if(typeof D.value=="function"?(k="value",i=D.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(k="get",i=D.get),!i)throw new Error("not supported");const C=`$memoize$${P}`;D[k]=function(...f){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,f)}),this[C]}}e.memoize=I;function T(y,P,D){return b((k,i)=>{const C=`$debounce$${i}`,f=`$debounce$result$${i}`;return function(...m){this[f]||(this[f]=D?D():void 0),clearTimeout(this[C]),P&&(this[f]=P(this[f],...m),m=[this[f]]),this[C]=setTimeout(()=>{k.apply(this,m),this[f]=D?D():void 0},y)}})}e.debounce=T;function A(y,P,D){return b((k,i)=>{const C=`$throttle$timer$${i}`,f=`$throttle$result$${i}`,m=`$throttle$lastRun$${i}`,l=`$throttle$pending$${i}`;return function(...d){if(this[f]||(this[f]=D?D():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),P&&(this[f]=P(this[f],...d)),!this[l]){const E=this[m]+y;E<=Date.now()?(this[m]=Date.now(),k.apply(this,[this[f]]),this[f]=D?D():void 0):(this[l]=!0,this[C]=setTimeout(()=>{this[l]=!1,this[m]=Date.now(),k.apply(this,[this[f]]),this[f]=D?D():void 0},E-Date.now()))}}})}e.throttle=A}),define(me[16],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class b{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=b,e.errorHandler=new b;function I(v){e.errorHandler.setUnexpectedErrorHandler(v)}e.setUnexpectedErrorHandler=I;function T(v){D(v)||e.errorHandler.onUnexpectedError(v)}e.onUnexpectedError=T;function A(v){D(v)||e.errorHandler.onUnexpectedExternalError(v)}e.onUnexpectedExternalError=A;function y(v){if(v instanceof Error){let{name:t,message:n}=v;const o=v.stacktrace||v.stack;return{$isError:!0,name:t,message:n,stack:o}}return v}e.transformErrorForSerialization=y;const P="Canceled";function D(v){return v instanceof Error&&v.name===P&&v.message===P}e.isPromiseCanceledError=D;class k extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=k;function i(){const v=new Error(P);return v.name=v.message,v}e.canceled=i;function C(v){return v?new Error(`Illegal argument: ${v}`):new Error("Illegal argument")}e.illegalArgument=C;function f(v){return v?new Error(`Illegal state: ${v}`):new Error("Illegal state")}e.illegalState=f;function m(v){return v?new Error(`readonly property '${v} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function l(v){const t=new Error(`${v} has been disposed`);return t.name="DISPOSED",t}e.disposed=l;function d(v){return v?v.message?v.message:v.stack?v.stack.split(`
`)[0]:String(v):"Error"}e.getErrorMessage=d;class E extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=E;class w extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=w;class S extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=S;function g(v){const t=v;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=g;function a(v,t=Object.create(null)){const n=new Error(v);return t.actions&&(n.actions=t.actions),n}e.createErrorWithActions=a}),define(me[17],ge([0,1,16]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function I(U,L=0){return U[U.length-(1+L)]}e.tail=I;function T(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}e.tail2=T;function A(U,L,N=(M,F)=>M===F){if(U===L)return!0;if(!U||!L||U.length!==L.length)return!1;for(let M=0,F=U.length;M<F;M++)if(!N(U[M],L[M]))return!1;return!0}e.equals=A;function y(U,L,N){let M=0,F=U.length-1;for(;M<=F;){const W=(M+F)/2|0,q=N(U[W],L);if(q<0)M=W+1;else if(q>0)F=W-1;else return W}return-(M+1)}e.binarySearch=y;function P(U,L){let N=0,M=U.length;if(M===0)return 0;for(;N<M;){const F=Math.floor((N+M)/2);L(U[F])?M=F:N=F+1}return N}e.findFirstInSorted=P;function D(U,L,N){if(U=U|0,U>=L.length)throw new TypeError("invalid index");let M=L[Math.floor(L.length*Math.random())],F=[],W=[],q=[];for(let Q of L){const le=N(Q,M);le<0?F.push(Q):le>0?W.push(Q):q.push(Q)}return U<F.length?D(U,F,N):U<F.length+q.length?q[0]:D(U-(F.length+q.length),W,N)}e.quickSelect=D;function k(U,L){const N=[];let M;for(const F of U.slice(0).sort(L))!M||L(M[0],F)!==0?(M=[F],N.push(M)):M.push(F);return N}e.groupBy=k;function i(U,L,N){const M=[];function F(Q,le,ve){if(!(le===0&&ve.length===0)){const Re=M[M.length-1];Re&&Re.start+Re.deleteCount===Q?(Re.deleteCount+=le,Re.toInsert.push(...ve)):M.push({start:Q,deleteCount:le,toInsert:ve})}}let W=0,q=0;for(;;){if(W===U.length){F(W,0,L.slice(q));break}if(q===L.length){F(W,U.length-W,[]);break}const Q=U[W],le=L[q],ve=N(Q,le);ve===0?(W+=1,q+=1):ve<0?(F(W,1,[]),W+=1):ve>0&&(F(W,0,[le]),q+=1)}return M}e.sortedDiff=i;function C(U,L,N){const M=i(U,L,N),F=[],W=[];for(const q of M)F.push(...U.slice(q.start,q.start+q.deleteCount)),W.push(...q.toInsert);return{removed:F,added:W}}e.delta=C;function f(U,L,N){if(N===0)return[];const M=U.slice(0,N).sort(L);return l(U,L,M,N,U.length),M}e.top=f;function m(U,L,N,M,F){return N===0?Promise.resolve([]):new Promise((W,q)=>{(async()=>{const Q=U.length,le=U.slice(0,N).sort(L);for(let ve=N,Re=Math.min(N+M,Q);ve<Q;ve=Re,Re=Math.min(Re+M,Q)){if(ve>N&&await new Promise(Se=>setTimeout(Se)),F&&F.isCancellationRequested)throw(0,b.canceled)();l(U,L,le,ve,Re)}return le})().then(W,q)})}e.topAsync=m;function l(U,L,N,M,F){for(const W=N.length;M<F;M++){const q=U[M];if(L(q,N[W-1])<0){N.pop();const Q=P(N,le=>L(q,le)<0);N.splice(Q,0,q)}}}function d(U){return U.filter(L=>!!L)}e.coalesce=d;function E(U){let L=0;for(let N=0;N<U.length;N++)U[N]&&(U[L]=U[N],L+=1);U.length=L}e.coalesceInPlace=E;function w(U,L,N){U.splice(N,0,U.splice(L,1)[0])}e.move=w;function S(U){return!Array.isArray(U)||U.length===0}e.isFalsyOrEmpty=S;function g(U){return Array.isArray(U)&&U.length>0}e.isNonEmptyArray=g;function a(U,L){if(!L)return U.filter((M,F)=>U.indexOf(M)===F);const N=Object.create(null);return U.filter(M=>{const F=L(M);return N[F]?!1:(N[F]=!0,!0)})}e.distinct=a;function v(U){const L=new Set;return U.filter(N=>L.has(N)?!1:(L.add(N),!0))}e.distinctES6=v;function t(U){const L=Object.create(null);return N=>{const M=U(N);return L[M]?!1:(L[M]=!0,!0)}}e.uniqueFilter=t;function n(U,L){for(let N=U.length-1;N>=0;N--){const M=U[N];if(L(M))return N}return-1}e.lastIndex=n;function o(U,L){return U.length>0?U[0]:L}e.firstOrDefault=o;function r(U,L,N=(M,F)=>M===F){let M=0;for(let F=0,W=Math.min(U.length,L.length);F<W&&N(U[F],L[F]);F++)M++;return M}e.commonPrefixLength=r;function s(U){return[].concat(...U)}e.flatten=s;function c(U,L){let N=typeof L=="number"?U:0;typeof L=="number"?N=U:(N=0,L=U);const M=[];if(N<=L)for(let F=N;F<L;F++)M.push(F);else for(let F=N;F>L;F--)M.push(F);return M}e.range=c;function h(U,L,N){return U.reduce((M,F)=>(M[L(F)]=N?N(F):F,M),Object.create(null))}e.index=h;function _(U,L){return U.push(L),()=>u(U,L)}e.insert=_;function u(U,L){const N=U.indexOf(L);if(N>-1)return U.splice(N,1),L}e.remove=u;function p(U,L,N){const M=U.slice(0,L),F=U.slice(L);return M.concat(N,F)}e.arrayInsert=p;function R(U,L){let N;if(typeof L=="number"){let M=L;N=()=>{const F=Math.sin(M++)*179426549;return F-Math.floor(F)}}else N=Math.random;for(let M=U.length-1;M>0;M-=1){const F=Math.floor(N()*(M+1)),W=U[M];U[M]=U[F],U[F]=W}}e.shuffle=R;function O(U,L){const N=U.indexOf(L);N>-1&&(U.splice(N,1),U.unshift(L))}e.pushToStart=O;function j(U,L){const N=U.indexOf(L);N>-1&&(U.splice(N,1),U.push(L))}e.pushToEnd=j;function ie(U,L){return Array.isArray(U)?U.map(L):L(U)}e.mapArrayOrNot=ie;function K(U){return Array.isArray(U)?U:[U]}e.asArray=K;function x(U){return U[Math.floor(Math.random()*U.length)]}e.getRandomElement=x;function $(U,L){for(const N of U){const M=L(N);if(M!==void 0)return M}}e.mapFind=$}),define(me[71],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function b(I){const T=this;let A=!1,y;return function(){return A||(A=!0,y=I.apply(T,arguments)),y}}e.once=b}),define(me[72],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class b{constructor(T){this._prefix=T,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=b,e.defaultGenerator=new b("id#")}),define(me[55],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var b;(function(I){function T(v){return v&&typeof v=="object"&&typeof v[Symbol.iterator]=="function"}I.is=T;const A=Object.freeze([]);function y(){return A}I.empty=y;function*P(v){yield v}I.single=P;function D(v){return v||A}I.from=D;function k(v){return!v||v[Symbol.iterator]().next().done===!0}I.isEmpty=k;function i(v){return v[Symbol.iterator]().next().value}I.first=i;function C(v,t){for(const n of v)if(t(n))return!0;return!1}I.some=C;function f(v,t){for(const n of v)if(t(n))return n}I.find=f;function*m(v,t){for(const n of v)t(n)&&(yield n)}I.filter=m;function*l(v,t){for(const n of v)yield t(n)}I.map=l;function*d(...v){for(const t of v)for(const n of t)yield n}I.concat=d;function*E(v){for(const t of v)for(const n of t)yield n}I.concatNested=E;function w(v,t,n){let o=n;for(const r of v)o=t(o,r);return o}I.reduce=w;function*S(v,t,n=v.length){for(t<0&&(t+=v.length),n<0?n+=v.length:n>v.length&&(n=v.length);t<n;t++)yield v[t]}I.slice=S;function g(v,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,v];const o=v[Symbol.iterator]();for(let r=0;r<t;r++){const s=o.next();if(s.done)return[n,I.empty()];n.push(s.value)}return[n,{[Symbol.iterator](){return o}}]}I.consume=g;function a(v,t,n=(o,r)=>o===r){const o=v[Symbol.iterator](),r=t[Symbol.iterator]();for(;;){const s=o.next(),c=r.next();if(s.done!==c.done)return!1;if(s.done)return!0;if(!n(s.value,c.value))return!1}}I.equals=a})(b=e.Iterable||(e.Iterable={}))}),define(me[56],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var b;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(b=e.ScanError||(e.ScanError={}));var I;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(I=e.SyntaxKind||(e.SyntaxKind={}));var T;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(T=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function y(t,n=!1){let o=0,r=t.length,s="",c=0,h=16,_=0;function u(x){let $=0,U=0;for(;$<x;){const L=t.charCodeAt(o);if(L>=48&&L<=57)U=U*16+L-48;else if(L>=65&&L<=70)U=U*16+L-65+10;else if(L>=97&&L<=102)U=U*16+L-97+10;else break;o++,$++}return $<x&&(U=-1),U}function p(x){o=x,s="",c=0,h=16,_=0}function R(){const x=o;if(t.charCodeAt(o)===48)o++;else for(o++;o<t.length&&k(t.charCodeAt(o));)o++;if(o<t.length&&t.charCodeAt(o)===46)if(o++,o<t.length&&k(t.charCodeAt(o)))for(o++;o<t.length&&k(t.charCodeAt(o));)o++;else return _=3,t.substring(x,o);let $=o;if(o<t.length&&(t.charCodeAt(o)===69||t.charCodeAt(o)===101))if(o++,(o<t.length&&t.charCodeAt(o)===43||t.charCodeAt(o)===45)&&o++,o<t.length&&k(t.charCodeAt(o))){for(o++;o<t.length&&k(t.charCodeAt(o));)o++;$=o}else _=3;return t.substring(x,$)}function O(){let x="",$=o;for(;;){if(o>=r){x+=t.substring($,o),_=2;break}const U=t.charCodeAt(o);if(U===34){x+=t.substring($,o),o++;break}if(U===92){if(x+=t.substring($,o),o++,o>=r){_=2;break}switch(t.charCodeAt(o++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:const N=u(4);N>=0?x+=String.fromCharCode(N):_=4;break;default:_=5}$=o;continue}if(U>=0&&U<=31)if(D(U)){x+=t.substring($,o),_=2;break}else _=6;o++}return x}function j(){if(s="",_=0,c=o,o>=r)return c=r,h=17;let x=t.charCodeAt(o);if(P(x)){do o++,s+=String.fromCharCode(x),x=t.charCodeAt(o);while(P(x));return h=15}if(D(x))return o++,s+=String.fromCharCode(x),x===13&&t.charCodeAt(o)===10&&(o++,s+=`
`),h=14;switch(x){case 123:return o++,h=1;case 125:return o++,h=2;case 91:return o++,h=3;case 93:return o++,h=4;case 58:return o++,h=6;case 44:return o++,h=5;case 34:return o++,s=O(),h=10;case 47:const $=o-1;if(t.charCodeAt(o+1)===47){for(o+=2;o<r&&!D(t.charCodeAt(o));)o++;return s=t.substring($,o),h=12}if(t.charCodeAt(o+1)===42){o+=2;const U=r-1;let L=!1;for(;o<U;){if(t.charCodeAt(o)===42&&t.charCodeAt(o+1)===47){o+=2,L=!0;break}o++}return L||(o++,_=1),s=t.substring($,o),h=13}return s+=String.fromCharCode(x),o++,h=16;case 45:if(s+=String.fromCharCode(x),o++,o===r||!k(t.charCodeAt(o)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=R(),h=11;default:for(;o<r&&ie(x);)o++,x=t.charCodeAt(o);if(c!==o){switch(s=t.substring(c,o),s){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return s+=String.fromCharCode(x),o++,h=16}}function ie(x){if(P(x)||D(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function K(){let x;do x=j();while(x>=12&&x<=15);return x}return{setPosition:p,getPosition:()=>o,scan:n?K:j,getToken:()=>h,getTokenValue:()=>s,getTokenOffset:()=>c,getTokenLength:()=>o-c,getTokenError:()=>_}}e.createScanner=y;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function D(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function C(t,n){const o=[],r=new Object;let s;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function _(u,p,R,O){c.value=u,c.offset=p,c.length=R,c.type=O,c.colonOffset=void 0,s=c}try{g(t,{onObjectBegin:(u,p)=>{if(n<=u)throw r;s=void 0,h=n>u,o.push("")},onObjectProperty:(u,p,R)=>{if(n<p||(_(u,p,R,"property"),o[o.length-1]=u,n<=p+R))throw r},onObjectEnd:(u,p)=>{if(n<=u)throw r;s=void 0,o.pop()},onArrayBegin:(u,p)=>{if(n<=u)throw r;s=void 0,o.push(0)},onArrayEnd:(u,p)=>{if(n<=u)throw r;s=void 0,o.pop()},onLiteralValue:(u,p,R)=>{if(n<p||(_(u,p,R,v(u)),n<=p+R))throw r},onSeparator:(u,p,R)=>{if(n<=p)throw r;if(u===":"&&s&&s.type==="property")s.colonOffset=p,h=!1,s=void 0;else if(u===","){const O=o[o.length-1];typeof O=="number"?o[o.length-1]=O+1:(h=!0,o[o.length-1]=""),s=void 0}}})}catch(u){if(u!==r)throw u}return{path:o,previousNode:s,isAtPropertyKey:h,matches:u=>{let p=0;for(let R=0;p<u.length&&R<o.length;R++)if(u[p]===o[R]||u[p]==="*")p++;else if(u[p]!=="**")return!1;return p===u.length}}}e.getLocation=C;function f(t,n=[],o=A.DEFAULT){let r=null,s=[];const c=[];function h(u){Array.isArray(s)?s.push(u):r!==null&&(s[r]=u)}return g(t,{onObjectBegin:()=>{const u={};h(u),c.push(s),s=u,r=null},onObjectProperty:u=>{r=u},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{const u=[];h(u),c.push(s),s=u,r=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:h,onError:(u,p,R)=>{n.push({error:u,offset:p,length:R})}},o),s[0]}e.parse=f;function m(t,n=[],o=A.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(u){r.type==="property"&&(r.length=u-r.offset,r=r.parent)}function c(u){return r.children.push(u),u}g(t,{onObjectBegin:u=>{r=c({type:"object",offset:u,length:-1,parent:r,children:[]})},onObjectProperty:(u,p,R)=>{r=c({type:"property",offset:p,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:u,offset:p,length:R,parent:r})},onObjectEnd:(u,p)=>{r.length=u+p-r.offset,r=r.parent,s(u+p)},onArrayBegin:(u,p)=>{r=c({type:"array",offset:u,length:-1,parent:r,children:[]})},onArrayEnd:(u,p)=>{r.length=u+p-r.offset,r=r.parent,s(u+p)},onLiteralValue:(u,p,R)=>{c({type:v(u),offset:p,length:R,parent:r,value:u}),s(p+R)},onSeparator:(u,p,R)=>{r.type==="property"&&(u===":"?r.colonOffset=p:u===","&&s(p))},onError:(u,p,R)=>{n.push({error:u,offset:p,length:R})}},o);const _=r.children[0];return _&&delete _.parent,_}e.parseTree=m;function l(t,n){if(!!t){let o=t;for(let r of n)if(typeof r=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let s=!1;for(const c of o.children)if(Array.isArray(c.children)&&c.children[0].value===r){o=c.children[1],s=!0;break}if(!s)return}else{const s=r;if(o.type!=="array"||s<0||!Array.isArray(o.children)||s>=o.children.length)return;o=o.children[s]}return o}}e.findNodeAtLocation=l;function d(t){if(!t.parent||!t.parent.children)return[];const n=d(t.parent);if(t.parent.type==="property"){const o=t.parent.children[0].value;n.push(o)}else if(t.parent.type==="array"){const o=t.parent.children.indexOf(t);o!==-1&&n.push(o)}return n}e.getNodePath=d;function E(t){switch(t.type){case"array":return t.children.map(E);case"object":const n=Object.create(null);for(let o of t.children){const r=o.children[1];r&&(n[o.children[0].value]=E(r))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=E;function w(t,n,o=!1){return n>=t.offset&&n<t.offset+t.length||o&&n===t.offset+t.length}e.contains=w;function S(t,n,o=!1){if(w(t,n,o)){const r=t.children;if(Array.isArray(r))for(let s=0;s<r.length&&r[s].offset<=n;s++){const c=S(r[s],n,o);if(c)return c}return t}}e.findNodeAtOffset=S;function g(t,n,o=A.DEFAULT){const r=y(t,!1);function s(le){return le?()=>le(r.getTokenOffset(),r.getTokenLength()):()=>!0}function c(le){return le?ve=>le(ve,r.getTokenOffset(),r.getTokenLength()):()=>!0}const h=s(n.onObjectBegin),_=c(n.onObjectProperty),u=s(n.onObjectEnd),p=s(n.onArrayBegin),R=s(n.onArrayEnd),O=c(n.onLiteralValue),j=c(n.onSeparator),ie=s(n.onComment),K=c(n.onError),x=o&&o.disallowComments,$=o&&o.allowTrailingComma;function U(){for(;;){const le=r.scan();switch(r.getTokenError()){case 4:L(14);break;case 5:L(15);break;case 3:L(13);break;case 1:x||L(11);break;case 2:L(12);break;case 6:L(16);break}switch(le){case 12:case 13:x?L(10):ie();break;case 16:L(1);break;case 15:case 14:break;default:return le}}}function L(le,ve=[],Re=[]){if(K(le),ve.length+Re.length>0){let Se=r.getToken();for(;Se!==17;){if(ve.indexOf(Se)!==-1){U();break}else if(Re.indexOf(Se)!==-1)break;Se=U()}}}function N(le){const ve=r.getTokenValue();return le?O(ve):_(ve),U(),!0}function M(){switch(r.getToken()){case 11:let le=0;try{le=JSON.parse(r.getTokenValue()),typeof le!="number"&&(L(2),le=0)}catch(ve){L(2)}O(le);break;case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return U(),!0}function F(){return r.getToken()!==10?(L(3,[],[2,5]),!1):(N(!1),r.getToken()===6?(j(":"),U(),Q()||L(4,[],[2,5])):L(5,[],[2,5]),!0)}function W(){h(),U();let le=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(le||L(4,[],[]),j(","),U(),r.getToken()===2&&$)break}else le&&L(6,[],[]);F()||L(4,[],[2,5]),le=!0}return u(),r.getToken()!==2?L(7,[2],[]):U(),!0}function q(){p(),U();let le=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(le||L(4,[],[]),j(","),U(),r.getToken()===4&&$)break}else le&&L(6,[],[]);Q()||L(4,[],[4,5]),le=!0}return R(),r.getToken()!==4?L(8,[4],[]):U(),!0}function Q(){switch(r.getToken()){case 3:return q();case 1:return W();case 10:return N(!0);default:return M()}}return U(),r.getToken()===17?o.allowEmptyContent?!0:(L(4,[],[]),!1):Q()?(r.getToken()!==17&&L(9,[],[]),!0):(L(4,[],[]),!1)}e.visit=g;function a(t,n){let o=y(t),r=[],s,c=0,h;do switch(h=o.getPosition(),s=o.scan(),s){case 12:case 13:case 17:c!==h&&r.push(t.substring(c,h)),n!==void 0&&r.push(o.getTokenValue().replace(/[^\r\n]/g,n)),c=o.getPosition();break}while(s!==17);return r.join("")}e.stripComments=a;function v(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),define(me[133],ge([0,1,56]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function I(D,k,i){let C,f,m,l,d;if(k){for(l=k.offset,d=l+k.length,m=l;m>0&&!P(D,m-1);)m--;let c=d;for(;c<D.length&&!P(D,c);)c++;f=D.substring(m,c),C=A(f,i)}else f=D,C=0,m=0,l=0,d=D.length;const E=y(i,D);let w=!1,S=0,g;i.insertSpaces?g=T(" ",i.tabSize||4):g="	";const a=(0,b.createScanner)(f,!1);let v=!1;function t(){return E+T(g,C+S)}function n(){let c=a.scan();for(w=!1;c===15||c===14;)w=w||c===14,c=a.scan();return v=c===16||a.getTokenError()!==0,c}const o=[];function r(c,h,_){!v&&h<d&&_>l&&D.substring(h,_)!==c&&o.push({offset:h,length:_-h,content:c})}let s=n();if(s!==17){const c=a.getTokenOffset()+m,h=T(g,C);r(h,m,c)}for(;s!==17;){let c=a.getTokenOffset()+a.getTokenLength()+m,h=n(),_="";for(;!w&&(h===12||h===13);){const p=a.getTokenOffset()+m;r(" ",c,p),c=a.getTokenOffset()+a.getTokenLength()+m,_=h===12?t():"",h=n()}if(h===2)s!==1&&(S--,_=t());else if(h===4)s!==3&&(S--,_=t());else{switch(s){case 3:case 1:S++,_=t();break;case 5:case 12:_=t();break;case 13:w?_=t():_=" ";break;case 6:_=" ";break;case 10:if(h===6){_="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?_=" ":h!==5&&h!==17&&(v=!0);break;case 16:v=!0;break}w&&(h===12||h===13)&&(_=t())}const u=a.getTokenOffset()+m;r(_,c,u),s=h}return o}e.format=I;function T(D,k){let i="";for(let C=0;C<k;C++)i+=D;return i}function A(D,k){let i=0,C=0;const f=k.tabSize||4;for(;i<D.length;){const m=D.charAt(i);if(m===" ")C++;else if(m==="	")C+=f;else break;i++}return Math.floor(C/f)}function y(D,k){for(let i=0;i<k.length;i++){const C=k.charAt(i);if(C==="\r")return i+1<k.length&&k.charAt(i+1)===`
`?`\r
`:"\r";if(C===`
`)return`
`}return D&&D.eol||`
`}e.getEOL=y;function P(D,k){return`\r
`.indexOf(D.charAt(k))!==-1}e.isEOL=P}),define(me[134],ge([0,1,56,133]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function T(k,i,C){return A(k,i,void 0,C)}e.removeProperty=T;function A(k,i,C,f,m){const l=i.slice(),d=[],E=(0,b.parseTree)(k,d);let w,S;for(;l.length>0&&(S=l.pop(),w=(0,b.findNodeAtLocation)(E,l),w===void 0&&C!==void 0);)typeof S=="string"?C={[S]:C}:C=[C];if(w)if(w.type==="object"&&typeof S=="string"&&Array.isArray(w.children)){const g=(0,b.findNodeAtLocation)(w,[S]);if(g!==void 0)if(C===void 0){if(!g.parent)throw new Error("Malformed AST");const a=w.children.indexOf(g.parent);let v,t=g.parent.offset+g.parent.length;if(a>0){const n=w.children[a-1];v=n.offset+n.length}else v=w.offset+1,w.children.length>1&&(t=w.children[1].offset);return y(k,{offset:v,length:t-v,content:""},f)}else return y(k,{offset:g.offset,length:g.length,content:JSON.stringify(C)},f);else{if(C===void 0)return[];const a=`${JSON.stringify(S)}: ${JSON.stringify(C)}`,v=m?m(w.children.map(n=>n.children[0].value)):w.children.length;let t;if(v>0){const n=w.children[v-1];t={offset:n.offset+n.length,length:0,content:","+a}}else w.children.length===0?t={offset:w.offset+1,length:0,content:a}:t={offset:w.offset+1,length:0,content:a+","};return y(k,t,f)}}else if(w.type==="array"&&typeof S=="number"&&Array.isArray(w.children))if(C!==void 0){const g=`${JSON.stringify(C)}`;let a;if(w.children.length===0||S===0)a={offset:w.offset+1,length:0,content:w.children.length===0?g:g+","};else{const v=S===-1||S>w.children.length?w.children.length:S,t=w.children[v-1];a={offset:t.offset+t.length,length:0,content:","+g}}return y(k,a,f)}else{const g=S,a=w.children[g];let v;if(w.children.length===1)v={offset:w.offset+1,length:w.length-2,content:""};else if(w.children.length-1===g){const t=w.children[g-1],n=t.offset+t.length,o=w.offset+w.length;v={offset:n,length:o-2-n,content:""}}else v={offset:a.offset,length:w.children[g+1].offset-a.offset,content:""};return y(k,v,f)}else throw new Error(`Can not add ${typeof S!="number"?"index":"property"} to parent of type ${w.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return y(k,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(C)},f)}}e.setProperty=A;function y(k,i,C){let f=P(k,i),m=i.offset,l=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;m>0&&!(0,I.isEOL)(f,m-1);)m--;for(;l<f.length&&!(0,I.isEOL)(f,l);)l++}const d=(0,I.format)(f,{offset:m,length:l-m},C);for(let w=d.length-1;w>=0;w--){const S=d[w];f=P(f,S),m=Math.min(m,S.offset),l=Math.max(l,S.offset+S.length),l+=S.content.length-S.length}const E=k.length-(f.length-l)-m;return[{offset:m,length:E,content:f.substring(m,l)}]}e.withFormatting=y;function P(k,i){return k.substring(0,i.offset)+i.content+k.substring(i.offset+i.length)}e.applyEdit=P;function D(k,i){let C=i.slice(0).sort((m,l)=>{const d=m.offset-l.offset;return d===0?m.length-l.length:d}),f=k.length;for(let m=C.length-1;m>=0;m--){let l=C[m];if(l.offset+l.length<=f)k=P(k,l);else throw new Error("Overlapping edit");f=l.offset}return k}e.applyEdits=D}),define(me[135],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class b{constructor(T){this.executor=T,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(T){this._error=T}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(T){return new b(()=>T(this.getValue()))}}e.Lazy=b}),define(me[6],ge([0,1,71,55]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const T=!1;let A=null;function y(g){A=g}if(e.setDisposableTracker=y,T){const g="__is_disposable_tracked__";A=new class{trackDisposable(a){const v=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[g]||console.log(v)},3e3)}markTracked(a){if(a&&a!==d.None)try{a[g]=!0}catch(v){}}}}function P(g){!A||A.markTracked(g)}function D(g){return A&&A.trackDisposable(g),g}e.trackDisposable=D;class k extends Error{constructor(a){super(`Encountered errors while disposing of store. Errors: [${a.join(", ")}]`);this.errors=a}}e.MultiDisposeError=k;function i(g){return typeof g.dispose=="function"&&g.dispose.length===0}e.isDisposable=i;function C(g){if(I.Iterable.is(g)){let a=[];for(const v of g)if(v){P(v);try{v.dispose()}catch(t){a.push(t)}}if(a.length===1)throw a[0];if(a.length>1)throw new k(a);return Array.isArray(g)?[]:g}else if(g)return P(g),g.dispose(),g}e.dispose=C;function f(...g){return g.forEach(P),m(()=>C(g))}e.combinedDisposable=f;function m(g){const a=D({dispose:()=>{P(a),g()}});return a}e.toDisposable=m;class l{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(P(this),this._isDisposed=!0,this.clear())}clear(){try{C(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return P(a),this._isDisposed?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=l,l.DISABLE_DISPOSED_WARNING=!1;class d{constructor(){this._store=new l,D(this)}dispose(){P(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=d,d.None=Object.freeze({dispose(){}});class E{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){var v;this._isDisposed||a===this._value||((v=this._value)===null||v===void 0||v.dispose(),a&&P(a),this._value=a)}clear(){this.value=void 0}dispose(){var a;this._isDisposed=!0,P(this),(a=this._value)===null||a===void 0||a.dispose(),this._value=void 0}}e.MutableDisposable=E;class w{constructor(){this.references=new Map}acquire(a,...v){let t=this.references.get(a);t||(t={counter:0,object:this.createReferencedObject(a,...v)},this.references.set(a,t));const{object:n}=t,o=(0,b.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(a,t.object),this.references.delete(a))});return t.counter++,{object:n,dispose:o}}}e.ReferenceCollection=w;class S{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=S}),define(me[57],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class b{constructor(A){this.element=A,this.next=b.Undefined,this.prev=b.Undefined}}b.Undefined=new b(void 0);class I{constructor(){this._first=b.Undefined,this._last=b.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===b.Undefined}clear(){let A=this._first;for(;A!==b.Undefined;){const y=A.next;A.prev=b.Undefined,A.next=b.Undefined,A=y}this._first=b.Undefined,this._last=b.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,y){const P=new b(A);if(this._first===b.Undefined)this._first=P,this._last=P;else if(y){const k=this._last;this._last=P,P.prev=k,k.next=P}else{const k=this._first;this._first=P,P.next=k,k.prev=P}this._size+=1;let D=!1;return()=>{D||(D=!0,this._remove(P))}}shift(){if(this._first!==b.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==b.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==b.Undefined&&A.next!==b.Undefined){const y=A.prev;y.next=A.next,A.next.prev=y}else A.prev===b.Undefined&&A.next===b.Undefined?(this._first=b.Undefined,this._last=b.Undefined):A.next===b.Undefined?(this._last=this._last.prev,this._last.next=b.Undefined):A.prev===b.Undefined&&(this._first=this._first.next,this._first.prev=b.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==b.Undefined;)yield A.element,A=A.next}}e.LinkedList=I}),function(G,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(G=typeof globalThis!="undefined"?globalThis:G||self,G.marked=e())}(this,function(){"use strict";function G(De,ye){for(var Pe=0;Pe<ye.length;Pe++){var oe=ye[Pe];oe.enumerable=oe.enumerable||!1,oe.configurable=!0,"value"in oe&&(oe.writable=!0),Object.defineProperty(De,oe.key,oe)}}function e(De,ye,Pe){return ye&&G(De.prototype,ye),Pe&&G(De,Pe),De}function b(De,ye){if(!!De){if(typeof De=="string")return I(De,ye);var Pe=Object.prototype.toString.call(De).slice(8,-1);if(Pe==="Object"&&De.constructor&&(Pe=De.constructor.name),Pe==="Map"||Pe==="Set")return Array.from(De);if(Pe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Pe))return I(De,ye)}}function I(De,ye){(ye==null||ye>De.length)&&(ye=De.length);for(var Pe=0,oe=new Array(ye);Pe<ye;Pe++)oe[Pe]=De[Pe];return oe}function T(De,ye){var Pe;if(typeof Symbol=="undefined"||De[Symbol.iterator]==null){if(Array.isArray(De)||(Pe=b(De))||ye&&De&&typeof De.length=="number"){Pe&&(De=Pe);var oe=0;return function(){return oe>=De.length?{done:!0}:{done:!1,value:De[oe++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Pe=De[Symbol.iterator](),Pe.next.bind(Pe)}function A(De){var ye={exports:{}};return De(ye,ye.exports),ye.exports}var y=A(function(De){function ye(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Pe(oe){De.exports.defaults=oe}De.exports={defaults:ye(),getDefaults:ye,changeDefaults:Pe}}),P=/[&<>"']/,D=/[&<>"']/g,k=/[<>"']|&(?!#?\w+;)/,i=/[<>"']|&(?!#?\w+;)/g,C={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},f=function(ye){return C[ye]};function m(De,ye){if(ye){if(P.test(De))return De.replace(D,f)}else if(k.test(De))return De.replace(i,f);return De}var l=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(De){return De.replace(l,function(ye,Pe){return Pe=Pe.toLowerCase(),Pe==="colon"?":":Pe.charAt(0)==="#"?Pe.charAt(1)==="x"?String.fromCharCode(parseInt(Pe.substring(2),16)):String.fromCharCode(+Pe.substring(1)):""})}var E=/(^|[^\[])\^/g;function w(De,ye){De=De.source||De,ye=ye||"";var Pe={replace:function(ue,H){return H=H.source||H,H=H.replace(E,"$1"),De=De.replace(ue,H),Pe},getRegex:function(){return new RegExp(De,ye)}};return Pe}var S=/[^\w:]/g,g=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function a(De,ye,Pe){if(De){var oe;try{oe=decodeURIComponent(d(Pe)).replace(S,"").toLowerCase()}catch(ue){return null}if(oe.indexOf("javascript:")===0||oe.indexOf("vbscript:")===0||oe.indexOf("data:")===0)return null}ye&&!g.test(Pe)&&(Pe=r(ye,Pe));try{Pe=encodeURI(Pe).replace(/%25/g,"%")}catch(ue){return null}return Pe}var v={},t=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(De,ye){v[" "+De]||(t.test(De)?v[" "+De]=De+"/":v[" "+De]=_(De,"/",!0)),De=v[" "+De];var Pe=De.indexOf(":")===-1;return ye.substring(0,2)==="//"?Pe?ye:De.replace(n,"$1")+ye:ye.charAt(0)==="/"?Pe?ye:De.replace(o,"$1")+ye:De+ye}var s={exec:function(){}};function c(De){for(var ye=1,Pe,oe;ye<arguments.length;ye++){Pe=arguments[ye];for(oe in Pe)Object.prototype.hasOwnProperty.call(Pe,oe)&&(De[oe]=Pe[oe])}return De}function h(De,ye){var Pe=De.replace(/\|/g,function(H,Z,ce){for(var Ie=!1,Ae=Z;--Ae>=0&&ce[Ae]==="\\";)Ie=!Ie;return Ie?"|":" |"}),oe=Pe.split(/ \|/),ue=0;if(oe.length>ye)oe.splice(ye);else for(;oe.length<ye;)oe.push("");for(;ue<oe.length;ue++)oe[ue]=oe[ue].trim().replace(/\\\|/g,"|");return oe}function _(De,ye,Pe){var oe=De.length;if(oe===0)return"";for(var ue=0;ue<oe;){var H=De.charAt(oe-ue-1);if(H===ye&&!Pe)ue++;else if(H!==ye&&Pe)ue++;else break}return De.substr(0,oe-ue)}function u(De,ye){if(De.indexOf(ye[1])===-1)return-1;for(var Pe=De.length,oe=0,ue=0;ue<Pe;ue++)if(De[ue]==="\\")ue++;else if(De[ue]===ye[0])oe++;else if(De[ue]===ye[1]&&(oe--,oe<0))return ue;return-1}function p(De){De&&De.sanitize&&!De.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(De,ye){if(ye<1)return"";for(var Pe="";ye>1;)ye&1&&(Pe+=De),ye>>=1,De+=De;return Pe+De}var O={escape:m,unescape:d,edit:w,cleanUrl:a,resolveUrl:r,noopTest:s,merge:c,splitCells:h,rtrim:_,findClosingBracket:u,checkSanitizeDeprecation:p,repeatString:R},j=y.defaults,ie=O.rtrim,K=O.splitCells,x=O.escape,$=O.findClosingBracket;function U(De,ye,Pe){var oe=ye.href,ue=ye.title?x(ye.title):null,H=De[1].replace(/\\([\[\]])/g,"$1");return De[0].charAt(0)!=="!"?{type:"link",raw:Pe,href:oe,title:ue,text:H}:{type:"image",raw:Pe,href:oe,title:ue,text:x(H)}}function L(De,ye){var Pe=De.match(/^(\s+)(?:```)/);if(Pe===null)return ye;var oe=Pe[1];return ye.split(`
`).map(function(ue){var H=ue.match(/^\s+/);if(H===null)return ue;var Z=H[0];return Z.length>=oe.length?ue.slice(oe.length):ue}).join(`
`)}var N=function(){function De(Pe){this.options=Pe||j}var ye=De.prototype;return ye.space=function(oe){var ue=this.rules.block.newline.exec(oe);if(ue)return ue[0].length>1?{type:"space",raw:ue[0]}:{raw:`
`}},ye.code=function(oe){var ue=this.rules.block.code.exec(oe);if(ue){var H=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?H:ie(H,`
`)}}},ye.fences=function(oe){var ue=this.rules.block.fences.exec(oe);if(ue){var H=ue[0],Z=L(H,ue[3]||"");return{type:"code",raw:H,lang:ue[2]?ue[2].trim():ue[2],text:Z}}},ye.heading=function(oe){var ue=this.rules.block.heading.exec(oe);if(ue){var H=ue[2].trim();if(/#$/.test(H)){var Z=ie(H,"#");(this.options.pedantic||!Z||/ $/.test(Z))&&(H=Z.trim())}return{type:"heading",raw:ue[0],depth:ue[1].length,text:H}}},ye.nptable=function(oe){var ue=this.rules.block.nptable.exec(oe);if(ue){var H={type:"table",header:K(ue[1].replace(/^ *| *\| *$/g,"")),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[],raw:ue[0]};if(H.header.length===H.align.length){var Z=H.align.length,ce;for(ce=0;ce<Z;ce++)/^ *-+: *$/.test(H.align[ce])?H.align[ce]="right":/^ *:-+: *$/.test(H.align[ce])?H.align[ce]="center":/^ *:-+ *$/.test(H.align[ce])?H.align[ce]="left":H.align[ce]=null;for(Z=H.cells.length,ce=0;ce<Z;ce++)H.cells[ce]=K(H.cells[ce],H.header.length);return H}}},ye.hr=function(oe){var ue=this.rules.block.hr.exec(oe);if(ue)return{type:"hr",raw:ue[0]}},ye.blockquote=function(oe){var ue=this.rules.block.blockquote.exec(oe);if(ue){var H=ue[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ue[0],text:H}}},ye.list=function(oe){var ue=this.rules.block.list.exec(oe);if(ue){var H=ue[0],Z=ue[2],ce=Z.length>1,Ie={type:"list",raw:H,ordered:ce,start:ce?+Z.slice(0,-1):"",loose:!1,items:[]},Ae=ue[0].match(this.rules.block.item),Le=!1,$e,Xe,rt,tt,Qe,mt,wt,be,he=Ae.length;rt=this.rules.block.listItemStart.exec(Ae[0]);for(var ae=0;ae<he;ae++){if($e=Ae[ae],H=$e,ae!==he-1){if(tt=this.rules.block.listItemStart.exec(Ae[ae+1]),this.options.pedantic?tt[1].length>rt[1].length:tt[1].length>rt[0].length||tt[1].length>3){Ae.splice(ae,2,Ae[ae]+`
`+Ae[ae+1]),ae--,he--;continue}else(!this.options.pedantic||this.options.smartLists?tt[2][tt[2].length-1]!==Z[Z.length-1]:ce===(tt[2].length===1))&&(Qe=Ae.slice(ae+1).join(`
`),Ie.raw=Ie.raw.substring(0,Ie.raw.length-Qe.length),ae=he-1);rt=tt}Xe=$e.length,$e=$e.replace(/^ *([*+-]|\d+[.)]) ?/,""),~$e.indexOf(`
 `)&&(Xe-=$e.length,$e=this.options.pedantic?$e.replace(/^ {1,4}/gm,""):$e.replace(new RegExp("^ {1,"+Xe+"}","gm"),"")),mt=Le||/\n\n(?!\s*$)/.test($e),ae!==he-1&&(Le=$e.charAt($e.length-1)===`
`,mt||(mt=Le)),mt&&(Ie.loose=!0),this.options.gfm&&(wt=/^\[[ xX]\] /.test($e),be=void 0,wt&&(be=$e[1]!==" ",$e=$e.replace(/^\[[ xX]\] +/,""))),Ie.items.push({type:"list_item",raw:H,task:wt,checked:be,loose:mt,text:$e})}return Ie}},ye.html=function(oe){var ue=this.rules.block.html.exec(oe);if(ue)return{type:this.options.sanitize?"paragraph":"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):x(ue[0]):ue[0]}},ye.def=function(oe){var ue=this.rules.block.def.exec(oe);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var H=ue[1].toLowerCase().replace(/\s+/g," ");return{tag:H,raw:ue[0],href:ue[2],title:ue[3]}}},ye.table=function(oe){var ue=this.rules.block.table.exec(oe);if(ue){var H={type:"table",header:K(ue[1].replace(/^ *| *\| *$/g,"")),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[]};if(H.header.length===H.align.length){H.raw=ue[0];var Z=H.align.length,ce;for(ce=0;ce<Z;ce++)/^ *-+: *$/.test(H.align[ce])?H.align[ce]="right":/^ *:-+: *$/.test(H.align[ce])?H.align[ce]="center":/^ *:-+ *$/.test(H.align[ce])?H.align[ce]="left":H.align[ce]=null;for(Z=H.cells.length,ce=0;ce<Z;ce++)H.cells[ce]=K(H.cells[ce].replace(/^ *\| *| *\| *$/g,""),H.header.length);return H}}},ye.lheading=function(oe){var ue=this.rules.block.lheading.exec(oe);if(ue)return{type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1]}},ye.paragraph=function(oe){var ue=this.rules.block.paragraph.exec(oe);if(ue)return{type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1]}},ye.text=function(oe){var ue=this.rules.block.text.exec(oe);if(ue)return{type:"text",raw:ue[0],text:ue[0]}},ye.escape=function(oe){var ue=this.rules.inline.escape.exec(oe);if(ue)return{type:"escape",raw:ue[0],text:x(ue[1])}},ye.tag=function(oe,ue,H){var Z=this.rules.inline.tag.exec(oe);if(Z)return!ue&&/^<a /i.test(Z[0])?ue=!0:ue&&/^<\/a>/i.test(Z[0])&&(ue=!1),!H&&/^<(pre|code|kbd|script)(\s|>)/i.test(Z[0])?H=!0:H&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Z[0])&&(H=!1),{type:this.options.sanitize?"text":"html",raw:Z[0],inLink:ue,inRawBlock:H,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):x(Z[0]):Z[0]}},ye.link=function(oe){var ue=this.rules.inline.link.exec(oe);if(ue){var H=ue[2].trim();if(!this.options.pedantic&&/^</.test(H)){if(!/>$/.test(H))return;var Z=ie(H.slice(0,-1),"\\");if((H.length-Z.length)%2==0)return}else{var ce=$(ue[2],"()");if(ce>-1){var Ie=ue[0].indexOf("!")===0?5:4,Ae=Ie+ue[1].length+ce;ue[2]=ue[2].substring(0,ce),ue[0]=ue[0].substring(0,Ae).trim(),ue[3]=""}}var Le=ue[2],$e="";if(this.options.pedantic){var Xe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Le);Xe&&(Le=Xe[1],$e=Xe[3])}else $e=ue[3]?ue[3].slice(1,-1):"";return Le=Le.trim(),/^</.test(Le)&&(this.options.pedantic&&!/>$/.test(H)?Le=Le.slice(1):Le=Le.slice(1,-1)),U(ue,{href:Le&&Le.replace(this.rules.inline._escapes,"$1"),title:$e&&$e.replace(this.rules.inline._escapes,"$1")},ue[0])}},ye.reflink=function(oe,ue){var H;if((H=this.rules.inline.reflink.exec(oe))||(H=this.rules.inline.nolink.exec(oe))){var Z=(H[2]||H[1]).replace(/\s+/g," ");if(Z=ue[Z.toLowerCase()],!Z||!Z.href){var ce=H[0].charAt(0);return{type:"text",raw:ce,text:ce}}return U(H,Z,H[0])}},ye.emStrong=function(oe,ue,H){H===void 0&&(H="");var Z=this.rules.inline.emStrong.lDelim.exec(oe);if(!!Z&&!(Z[3]&&H.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ce=Z[1]||Z[2]||"";if(!ce||ce&&(H===""||this.rules.inline.punctuation.exec(H))){var Ie=Z[0].length-1,Ae,Le,$e=Ie,Xe=0,rt=Z[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(rt.lastIndex=0,ue=ue.slice(-1*oe.length+Ie);(Z=rt.exec(ue))!=null;)if(Ae=Z[1]||Z[2]||Z[3]||Z[4]||Z[5]||Z[6],!!Ae){if(Le=Ae.length,Z[3]||Z[4]){$e+=Le;continue}else if((Z[5]||Z[6])&&Ie%3&&!((Ie+Le)%3)){Xe+=Le;continue}if($e-=Le,!($e>0)){if($e+Xe-Le<=0&&!ue.slice(rt.lastIndex).match(rt)&&(Le=Math.min(Le,Le+$e+Xe)),Math.min(Ie,Le)%2)return{type:"em",raw:oe.slice(0,Ie+Z.index+Le+1),text:oe.slice(1,Ie+Z.index+Le)};if(Math.min(Ie,Le)%2==0)return{type:"strong",raw:oe.slice(0,Ie+Z.index+Le+1),text:oe.slice(2,Ie+Z.index+Le-1)}}}}}},ye.codespan=function(oe){var ue=this.rules.inline.code.exec(oe);if(ue){var H=ue[2].replace(/\n/g," "),Z=/[^ ]/.test(H),ce=/^ /.test(H)&&/ $/.test(H);return Z&&ce&&(H=H.substring(1,H.length-1)),H=x(H,!0),{type:"codespan",raw:ue[0],text:H}}},ye.br=function(oe){var ue=this.rules.inline.br.exec(oe);if(ue)return{type:"br",raw:ue[0]}},ye.del=function(oe){var ue=this.rules.inline.del.exec(oe);if(ue)return{type:"del",raw:ue[0],text:ue[2]}},ye.autolink=function(oe,ue){var H=this.rules.inline.autolink.exec(oe);if(H){var Z,ce;return H[2]==="@"?(Z=x(this.options.mangle?ue(H[1]):H[1]),ce="mailto:"+Z):(Z=x(H[1]),ce=Z),{type:"link",raw:H[0],text:Z,href:ce,tokens:[{type:"text",raw:Z,text:Z}]}}},ye.url=function(oe,ue){var H;if(H=this.rules.inline.url.exec(oe)){var Z,ce;if(H[2]==="@")Z=x(this.options.mangle?ue(H[0]):H[0]),ce="mailto:"+Z;else{var Ie;do Ie=H[0],H[0]=this.rules.inline._backpedal.exec(H[0])[0];while(Ie!==H[0]);Z=x(H[0]),H[1]==="www."?ce="http://"+Z:ce=Z}return{type:"link",raw:H[0],text:Z,href:ce,tokens:[{type:"text",raw:Z,text:Z}]}}},ye.inlineText=function(oe,ue,H){var Z=this.rules.inline.text.exec(oe);if(Z){var ce;return ue?ce=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):x(Z[0]):Z[0]:ce=x(this.options.smartypants?H(Z[0]):Z[0]),{type:"text",raw:Z[0],text:ce}}},De}(),M=O.noopTest,F=O.edit,W=O.merge,q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:M,table:M,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=F(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,q.item=F(q.item,"gm").replace(/bull/g,q.bullet).getRegex(),q.listItemStart=F(/^( *)(bull)/).replace("bull",q.bullet).getRegex(),q.list=F(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=F(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=F(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.blockquote=F(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=W({},q),q.gfm=W({},q.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.nptable=F(q.gfm.nptable).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.gfm.table=F(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.pedantic=W({},q.normal,{html:F(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:M,paragraph:F(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:M,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:M,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Q.punctuation=F(Q.punctuation).replace(/punctuation/g,Q._punctuation).getRegex(),Q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Q.escapedEmSt=/\\\*|\\_/g,Q._comment=F(q._comment).replace("(?:-->|$)","-->").getRegex(),Q.emStrong.lDelim=F(Q.emStrong.lDelim).replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimAst=F(Q.emStrong.rDelimAst,"g").replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimUnd=F(Q.emStrong.rDelimUnd,"g").replace(/punct/g,Q._punctuation).getRegex(),Q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Q.autolink=F(Q.autolink).replace("scheme",Q._scheme).replace("email",Q._email).getRegex(),Q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Q.tag=F(Q.tag).replace("comment",Q._comment).replace("attribute",Q._attribute).getRegex(),Q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Q.link=F(Q.link).replace("label",Q._label).replace("href",Q._href).replace("title",Q._title).getRegex(),Q.reflink=F(Q.reflink).replace("label",Q._label).getRegex(),Q.reflinkSearch=F(Q.reflinkSearch,"g").replace("reflink",Q.reflink).replace("nolink",Q.nolink).getRegex(),Q.normal=W({},Q),Q.pedantic=W({},Q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:F(/^!?\[(label)\]\((.*?)\)/).replace("label",Q._label).getRegex(),reflink:F(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Q._label).getRegex()}),Q.gfm=W({},Q.normal,{escape:F(Q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),Q.gfm.url=F(Q.gfm.url,"i").replace("email",Q.gfm._extended_email).getRegex(),Q.breaks=W({},Q.gfm,{br:F(Q.br).replace("{2,}","*").getRegex(),text:F(Q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var le={block:q,inline:Q},ve=y.defaults,Re=le.block,Se=le.inline,Oe=O.repeatString;function z(De){return De.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Y(De){var ye="",Pe,oe,ue=De.length;for(Pe=0;Pe<ue;Pe++)oe=De.charCodeAt(Pe),Math.random()>.5&&(oe="x"+oe.toString(16)),ye+="&#"+oe+";";return ye}var ee=function(){function De(Pe){this.tokens=[],this.tokens.links=Object.create(null),this.options=Pe||ve,this.options.tokenizer=this.options.tokenizer||new N,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var oe={block:Re.normal,inline:Se.normal};this.options.pedantic?(oe.block=Re.pedantic,oe.inline=Se.pedantic):this.options.gfm&&(oe.block=Re.gfm,this.options.breaks?oe.inline=Se.breaks:oe.inline=Se.gfm),this.tokenizer.rules=oe}De.lex=function(oe,ue){var H=new De(ue);return H.lex(oe)},De.lexInline=function(oe,ue){var H=new De(ue);return H.inlineTokens(oe)};var ye=De.prototype;return ye.lex=function(oe){return oe=oe.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(oe,this.tokens,!0),this.inline(this.tokens),this.tokens},ye.blockTokens=function(oe,ue,H){ue===void 0&&(ue=[]),H===void 0&&(H=!0),this.options.pedantic&&(oe=oe.replace(/^ +$/gm,""));for(var Z,ce,Ie,Ae;oe;){if(Z=this.tokenizer.space(oe)){oe=oe.substring(Z.raw.length),Z.type&&ue.push(Z);continue}if(Z=this.tokenizer.code(oe)){oe=oe.substring(Z.raw.length),Ae=ue[ue.length-1],Ae&&Ae.type==="paragraph"?(Ae.raw+=`
`+Z.raw,Ae.text+=`
`+Z.text):ue.push(Z);continue}if(Z=this.tokenizer.fences(oe)){oe=oe.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.heading(oe)){oe=oe.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.nptable(oe)){oe=oe.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.hr(oe)){oe=oe.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.blockquote(oe)){oe=oe.substring(Z.raw.length),Z.tokens=this.blockTokens(Z.text,[],H),ue.push(Z);continue}if(Z=this.tokenizer.list(oe)){for(oe=oe.substring(Z.raw.length),Ie=Z.items.length,ce=0;ce<Ie;ce++)Z.items[ce].tokens=this.blockTokens(Z.items[ce].text,[],!1);ue.push(Z);continue}if(Z=this.tokenizer.html(oe)){oe=oe.substring(Z.raw.length),ue.push(Z);continue}if(H&&(Z=this.tokenizer.def(oe))){oe=oe.substring(Z.raw.length),this.tokens.links[Z.tag]||(this.tokens.links[Z.tag]={href:Z.href,title:Z.title});continue}if(Z=this.tokenizer.table(oe)){oe=oe.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.lheading(oe)){oe=oe.substring(Z.raw.length),ue.push(Z);continue}if(H&&(Z=this.tokenizer.paragraph(oe))){oe=oe.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.text(oe)){oe=oe.substring(Z.raw.length),Ae=ue[ue.length-1],Ae&&Ae.type==="text"?(Ae.raw+=`
`+Z.raw,Ae.text+=`
`+Z.text):ue.push(Z);continue}if(oe){var Le="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(Le);break}else throw new Error(Le)}}return ue},ye.inline=function(oe){var ue,H,Z,ce,Ie,Ae,Le=oe.length;for(ue=0;ue<Le;ue++)switch(Ae=oe[ue],Ae.type){case"paragraph":case"text":case"heading":{Ae.tokens=[],this.inlineTokens(Ae.text,Ae.tokens);break}case"table":{for(Ae.tokens={header:[],cells:[]},ce=Ae.header.length,H=0;H<ce;H++)Ae.tokens.header[H]=[],this.inlineTokens(Ae.header[H],Ae.tokens.header[H]);for(ce=Ae.cells.length,H=0;H<ce;H++)for(Ie=Ae.cells[H],Ae.tokens.cells[H]=[],Z=0;Z<Ie.length;Z++)Ae.tokens.cells[H][Z]=[],this.inlineTokens(Ie[Z],Ae.tokens.cells[H][Z]);break}case"blockquote":{this.inline(Ae.tokens);break}case"list":{for(ce=Ae.items.length,H=0;H<ce;H++)this.inline(Ae.items[H].tokens);break}}return oe},ye.inlineTokens=function(oe,ue,H,Z){ue===void 0&&(ue=[]),H===void 0&&(H=!1),Z===void 0&&(Z=!1);var ce,Ie,Ae=oe,Le,$e,Xe;if(this.tokens.links){var rt=Object.keys(this.tokens.links);if(rt.length>0)for(;(Le=this.tokenizer.rules.inline.reflinkSearch.exec(Ae))!=null;)rt.includes(Le[0].slice(Le[0].lastIndexOf("[")+1,-1))&&(Ae=Ae.slice(0,Le.index)+"["+Oe("a",Le[0].length-2)+"]"+Ae.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Le=this.tokenizer.rules.inline.blockSkip.exec(Ae))!=null;)Ae=Ae.slice(0,Le.index)+"["+Oe("a",Le[0].length-2)+"]"+Ae.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Le=this.tokenizer.rules.inline.escapedEmSt.exec(Ae))!=null;)Ae=Ae.slice(0,Le.index)+"++"+Ae.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;oe;){if($e||(Xe=""),$e=!1,ce=this.tokenizer.escape(oe)){oe=oe.substring(ce.raw.length),ue.push(ce);continue}if(ce=this.tokenizer.tag(oe,H,Z)){oe=oe.substring(ce.raw.length),H=ce.inLink,Z=ce.inRawBlock;var tt=ue[ue.length-1];tt&&ce.type==="text"&&tt.type==="text"?(tt.raw+=ce.raw,tt.text+=ce.text):ue.push(ce);continue}if(ce=this.tokenizer.link(oe)){oe=oe.substring(ce.raw.length),ce.type==="link"&&(ce.tokens=this.inlineTokens(ce.text,[],!0,Z)),ue.push(ce);continue}if(ce=this.tokenizer.reflink(oe,this.tokens.links)){oe=oe.substring(ce.raw.length);var Qe=ue[ue.length-1];ce.type==="link"?(ce.tokens=this.inlineTokens(ce.text,[],!0,Z),ue.push(ce)):Qe&&ce.type==="text"&&Qe.type==="text"?(Qe.raw+=ce.raw,Qe.text+=ce.text):ue.push(ce);continue}if(ce=this.tokenizer.emStrong(oe,Ae,Xe)){oe=oe.substring(ce.raw.length),ce.tokens=this.inlineTokens(ce.text,[],H,Z),ue.push(ce);continue}if(ce=this.tokenizer.codespan(oe)){oe=oe.substring(ce.raw.length),ue.push(ce);continue}if(ce=this.tokenizer.br(oe)){oe=oe.substring(ce.raw.length),ue.push(ce);continue}if(ce=this.tokenizer.del(oe)){oe=oe.substring(ce.raw.length),ce.tokens=this.inlineTokens(ce.text,[],H,Z),ue.push(ce);continue}if(ce=this.tokenizer.autolink(oe,Y)){oe=oe.substring(ce.raw.length),ue.push(ce);continue}if(!H&&(ce=this.tokenizer.url(oe,Y))){oe=oe.substring(ce.raw.length),ue.push(ce);continue}if(ce=this.tokenizer.inlineText(oe,Z,z)){oe=oe.substring(ce.raw.length),ce.raw.slice(-1)!=="_"&&(Xe=ce.raw.slice(-1)),$e=!0,Ie=ue[ue.length-1],Ie&&Ie.type==="text"?(Ie.raw+=ce.raw,Ie.text+=ce.text):ue.push(ce);continue}if(oe){var mt="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(mt);break}else throw new Error(mt)}}return ue},e(De,null,[{key:"rules",get:function(){return{block:Re,inline:Se}}}]),De}(),se=y.defaults,fe=O.cleanUrl,Ee=O.escape,Be=function(){function De(Pe){this.options=Pe||se}var ye=De.prototype;return ye.code=function(oe,ue,H){var Z=(ue||"").match(/\S*/)[0];if(this.options.highlight){var ce=this.options.highlight(oe,Z);ce!=null&&ce!==oe&&(H=!0,oe=ce)}return oe=oe.replace(/\n$/,"")+`
`,Z?'<pre><code class="'+this.options.langPrefix+Ee(Z,!0)+'">'+(H?oe:Ee(oe,!0))+`</code></pre>
`:"<pre><code>"+(H?oe:Ee(oe,!0))+`</code></pre>
`},ye.blockquote=function(oe){return`<blockquote>
`+oe+`</blockquote>
`},ye.html=function(oe){return oe},ye.heading=function(oe,ue,H,Z){return this.options.headerIds?"<h"+ue+' id="'+this.options.headerPrefix+Z.slug(H)+'">'+oe+"</h"+ue+`>
`:"<h"+ue+">"+oe+"</h"+ue+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(oe,ue,H){var Z=ue?"ol":"ul",ce=ue&&H!==1?' start="'+H+'"':"";return"<"+Z+ce+`>
`+oe+"</"+Z+`>
`},ye.listitem=function(oe){return"<li>"+oe+`</li>
`},ye.checkbox=function(oe){return"<input "+(oe?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(oe){return"<p>"+oe+`</p>
`},ye.table=function(oe,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+oe+`</thead>
`+ue+`</table>
`},ye.tablerow=function(oe){return`<tr>
`+oe+`</tr>
`},ye.tablecell=function(oe,ue){var H=ue.header?"th":"td",Z=ue.align?"<"+H+' align="'+ue.align+'">':"<"+H+">";return Z+oe+"</"+H+`>
`},ye.strong=function(oe){return"<strong>"+oe+"</strong>"},ye.em=function(oe){return"<em>"+oe+"</em>"},ye.codespan=function(oe){return"<code>"+oe+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(oe){return"<del>"+oe+"</del>"},ye.link=function(oe,ue,H){if(oe=fe(this.options.sanitize,this.options.baseUrl,oe),oe===null)return H;var Z='<a href="'+Ee(oe)+'"';return ue&&(Z+=' title="'+ue+'"'),Z+=">"+H+"</a>",Z},ye.image=function(oe,ue,H){if(oe=fe(this.options.sanitize,this.options.baseUrl,oe),oe===null)return H;var Z='<img src="'+oe+'" alt="'+H+'"';return ue&&(Z+=' title="'+ue+'"'),Z+=this.options.xhtml?"/>":">",Z},ye.text=function(oe){return oe},De}(),pe=function(){function De(){}var ye=De.prototype;return ye.strong=function(oe){return oe},ye.em=function(oe){return oe},ye.codespan=function(oe){return oe},ye.del=function(oe){return oe},ye.html=function(oe){return oe},ye.text=function(oe){return oe},ye.link=function(oe,ue,H){return""+H},ye.image=function(oe,ue,H){return""+H},ye.br=function(){return""},De}(),Ce=function(){function De(){this.seen={}}var ye=De.prototype;return ye.serialize=function(oe){return oe.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(oe,ue){var H=oe,Z=0;if(this.seen.hasOwnProperty(H)){Z=this.seen[oe];do Z++,H=oe+"-"+Z;while(this.seen.hasOwnProperty(H))}return ue||(this.seen[oe]=Z,this.seen[H]=0),H},ye.slug=function(oe,ue){ue===void 0&&(ue={});var H=this.serialize(oe);return this.getNextSafeSlug(H,ue.dryrun)},De}(),Me=y.defaults,ze=O.unescape,_e=function(){function De(Pe){this.options=Pe||Me,this.options.renderer=this.options.renderer||new Be,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new pe,this.slugger=new Ce}De.parse=function(oe,ue){var H=new De(ue);return H.parse(oe)},De.parseInline=function(oe,ue){var H=new De(ue);return H.parseInline(oe)};var ye=De.prototype;return ye.parse=function(oe,ue){ue===void 0&&(ue=!0);var H="",Z,ce,Ie,Ae,Le,$e,Xe,rt,tt,Qe,mt,wt,be,he,ae,J,Ne,Fe,Ye=oe.length;for(Z=0;Z<Ye;Z++)switch(Qe=oe[Z],Qe.type){case"space":continue;case"hr":{H+=this.renderer.hr();continue}case"heading":{H+=this.renderer.heading(this.parseInline(Qe.tokens),Qe.depth,ze(this.parseInline(Qe.tokens,this.textRenderer)),this.slugger);continue}case"code":{H+=this.renderer.code(Qe.text,Qe.lang,Qe.escaped);continue}case"table":{for(rt="",Xe="",Ae=Qe.header.length,ce=0;ce<Ae;ce++)Xe+=this.renderer.tablecell(this.parseInline(Qe.tokens.header[ce]),{header:!0,align:Qe.align[ce]});for(rt+=this.renderer.tablerow(Xe),tt="",Ae=Qe.cells.length,ce=0;ce<Ae;ce++){for($e=Qe.tokens.cells[ce],Xe="",Le=$e.length,Ie=0;Ie<Le;Ie++)Xe+=this.renderer.tablecell(this.parseInline($e[Ie]),{header:!1,align:Qe.align[Ie]});tt+=this.renderer.tablerow(Xe)}H+=this.renderer.table(rt,tt);continue}case"blockquote":{tt=this.parse(Qe.tokens),H+=this.renderer.blockquote(tt);continue}case"list":{for(mt=Qe.ordered,wt=Qe.start,be=Qe.loose,Ae=Qe.items.length,tt="",ce=0;ce<Ae;ce++)ae=Qe.items[ce],J=ae.checked,Ne=ae.task,he="",ae.task&&(Fe=this.renderer.checkbox(J),be?ae.tokens.length>0&&ae.tokens[0].type==="text"?(ae.tokens[0].text=Fe+" "+ae.tokens[0].text,ae.tokens[0].tokens&&ae.tokens[0].tokens.length>0&&ae.tokens[0].tokens[0].type==="text"&&(ae.tokens[0].tokens[0].text=Fe+" "+ae.tokens[0].tokens[0].text)):ae.tokens.unshift({type:"text",text:Fe}):he+=Fe),he+=this.parse(ae.tokens,be),tt+=this.renderer.listitem(he,Ne,J);H+=this.renderer.list(tt,mt,wt);continue}case"html":{H+=this.renderer.html(Qe.text);continue}case"paragraph":{H+=this.renderer.paragraph(this.parseInline(Qe.tokens));continue}case"text":{for(tt=Qe.tokens?this.parseInline(Qe.tokens):Qe.text;Z+1<Ye&&oe[Z+1].type==="text";)Qe=oe[++Z],tt+=`
`+(Qe.tokens?this.parseInline(Qe.tokens):Qe.text);H+=ue?this.renderer.paragraph(tt):tt;continue}default:{var et='Token with "'+Qe.type+'" type was not found.';if(this.options.silent){console.error(et);return}else throw new Error(et)}}return H},ye.parseInline=function(oe,ue){ue=ue||this.renderer;var H="",Z,ce,Ie=oe.length;for(Z=0;Z<Ie;Z++)switch(ce=oe[Z],ce.type){case"escape":{H+=ue.text(ce.text);break}case"html":{H+=ue.html(ce.text);break}case"link":{H+=ue.link(ce.href,ce.title,this.parseInline(ce.tokens,ue));break}case"image":{H+=ue.image(ce.href,ce.title,ce.text);break}case"strong":{H+=ue.strong(this.parseInline(ce.tokens,ue));break}case"em":{H+=ue.em(this.parseInline(ce.tokens,ue));break}case"codespan":{H+=ue.codespan(ce.text);break}case"br":{H+=ue.br();break}case"del":{H+=ue.del(this.parseInline(ce.tokens,ue));break}case"text":{H+=ue.text(ce.text);break}default:{var Ae='Token with "'+ce.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}return H},De}(),Ke=O.merge,X=O.checkSanitizeDeprecation,ne=O.escape,we=y.getDefaults,xe=y.changeDefaults,je=y.defaults;function Ve(De,ye,Pe){if(typeof De=="undefined"||De===null)throw new Error("marked(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");if(typeof ye=="function"&&(Pe=ye,ye=null),ye=Ke({},Ve.defaults,ye||{}),X(ye),Pe){var oe=ye.highlight,ue;try{ue=ee.lex(De,ye)}catch(Ie){return Pe(Ie)}var H=function(Ae){var Le;if(!Ae)try{Le=_e.parse(ue,ye)}catch($e){Ae=$e}return ye.highlight=oe,Ae?Pe(Ae):Pe(null,Le)};if(!oe||oe.length<3||(delete ye.highlight,!ue.length))return H();var Z=0;Ve.walkTokens(ue,function(Ie){Ie.type==="code"&&(Z++,setTimeout(function(){oe(Ie.text,Ie.lang,function(Ae,Le){if(Ae)return H(Ae);Le!=null&&Le!==Ie.text&&(Ie.text=Le,Ie.escaped=!0),Z--,Z===0&&H()})},0))}),Z===0&&H();return}try{var ce=ee.lex(De,ye);return ye.walkTokens&&Ve.walkTokens(ce,ye.walkTokens),_e.parse(ce,ye)}catch(Ie){if(Ie.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+ne(Ie.message+"",!0)+"</pre>";throw Ie}}Ve.options=Ve.setOptions=function(De){return Ke(Ve.defaults,De),xe(Ve.defaults),Ve},Ve.getDefaults=we,Ve.defaults=je,Ve.use=function(De){var ye=Ke({},De);if(De.renderer&&function(){var oe=Ve.defaults.renderer||new Be,ue=function(ce){var Ie=oe[ce];oe[ce]=function(){for(var Ae=arguments.length,Le=new Array(Ae),$e=0;$e<Ae;$e++)Le[$e]=arguments[$e];var Xe=De.renderer[ce].apply(oe,Le);return Xe===!1&&(Xe=Ie.apply(oe,Le)),Xe}};for(var H in De.renderer)ue(H);ye.renderer=oe}(),De.tokenizer&&function(){var oe=Ve.defaults.tokenizer||new N,ue=function(ce){var Ie=oe[ce];oe[ce]=function(){for(var Ae=arguments.length,Le=new Array(Ae),$e=0;$e<Ae;$e++)Le[$e]=arguments[$e];var Xe=De.tokenizer[ce].apply(oe,Le);return Xe===!1&&(Xe=Ie.apply(oe,Le)),Xe}};for(var H in De.tokenizer)ue(H);ye.tokenizer=oe}(),De.walkTokens){var Pe=Ve.defaults.walkTokens;ye.walkTokens=function(oe){De.walkTokens(oe),Pe&&Pe(oe)}}Ve.setOptions(ye)},Ve.walkTokens=function(De,ye){for(var Pe=T(De),oe;!(oe=Pe()).done;){var ue=oe.value;switch(ye(ue),ue.type){case"table":{for(var H=T(ue.tokens.header),Z;!(Z=H()).done;){var ce=Z.value;Ve.walkTokens(ce,ye)}for(var Ie=T(ue.tokens.cells),Ae;!(Ae=Ie()).done;)for(var Le=Ae.value,$e=T(Le),Xe;!(Xe=$e()).done;){var rt=Xe.value;Ve.walkTokens(rt,ye)}break}case"list":{Ve.walkTokens(ue.items,ye);break}default:ue.tokens&&Ve.walkTokens(ue.tokens,ye)}}},Ve.parseInline=function(De,ye){if(typeof De=="undefined"||De===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");ye=Ke({},Ve.defaults,ye||{}),X(ye);try{var Pe=ee.lexInline(De,ye);return ye.walkTokens&&Ve.walkTokens(Pe,ye.walkTokens),_e.parseInline(Pe,ye)}catch(oe){if(oe.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+ne(oe.message+"",!0)+"</pre>";throw oe}},Ve.Parser=_e,Ve.parser=_e.parse,Ve.Renderer=Be,Ve.TextRenderer=pe,Ve.Lexer=ee,Ve.lexer=ee.lex,Ve.Tokenizer=N,Ve.Slugger=Ce,Ve.parse=Ve;var Ze=Ve;return Ze}),define(me[73],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function b(y,P,D){return Math.min(Math.max(y,P),D)}e.clamp=b;function I(y,P){return(P+y%P)%P}e.rot=I;class T{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=T;class A{constructor(){this._n=1,this._val=0}update(P){return this._val=this._val+(P-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=A});"use strict";(function(){function G(T){const A=[];typeof T=="number"&&A.push("code/timeOrigin",T);function y(D){A.push(D,Date.now())}function P(){const D=[];for(let k=0;k<A.length;k+=2)D.push({name:A[k],startTime:A[k+1]});return D}return{mark:y,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(T){performance.mark(T)},getMarks(){let T=performance.timeOrigin;typeof T!="number"&&(T=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(T)}];for(const y of performance.getEntriesByType("mark"))A.push({name:y.name,startTime:Math.round(T+y.startTime)});return A}};if(typeof process=="object"){const T=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(T)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function b(T){return T.MonacoPerformanceMarks||(T.MonacoPerformanceMarks=e()),T.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return b(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=b(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=b(I))})(),define(me[10],ge([0,1]),function(G,e){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const I="en";let T=!1,A=!1,y=!1,P=!1,D=!1,k=!1,i=!1,C,f=I,m,l;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode!="undefined"?d=e.globals.vscode.process:typeof process!="undefined"&&(d=process);const E=typeof((b=d==null?void 0:d.versions)===null||b===void 0?void 0:b.electron)=="string"&&d.type==="renderer";if(e.isElectronSandboxed=E&&(d==null?void 0:d.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const r=d==null?void 0:d.env.VSCODE_BROWSER_CODE_LOADING;if(typeof r=="string")return r==="none"||r==="code"||r==="bypassHeatCheck"||r==="bypassHeatCheckAndEagerCompile"?r:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!E)l=navigator.userAgent,T=l.indexOf("Windows")>=0,A=l.indexOf("Macintosh")>=0,i=(l.indexOf("Macintosh")>=0||l.indexOf("iPad")>=0||l.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=l.indexOf("Linux")>=0,k=!0,C=navigator.language,f=C;else if(typeof d=="object"){T=d.platform==="win32",A=d.platform==="darwin",y=d.platform==="linux",P=y&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,C=I,f=I;const r=d.env.VSCODE_NLS_CONFIG;if(r)try{const s=JSON.parse(r),c=s.availableLanguages["*"];C=s.locale,f=c||I,m=s._translationsConfigFile}catch(s){}D=!0}else console.error("Unable to resolve platform.");var w;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function S(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=S;let g=0;A?g=1:T?g=3:y&&(g=2),e.isWindows=T,e.isMacintosh=A,e.isLinux=y,e.isLinuxSnap=P,e.isNative=D,e.isWeb=k,e.isIOS=i,e.platform=g,e.userAgent=l,e.language=f;var a;(function(r){function s(){return e.language}r.value=s;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=c;function h(){return e.language==="en"}r.isDefault=h})(a=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=m,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let c=[];e.globals.addEventListener("message",_=>{if(_.data&&_.data.vscodeSetImmediateId)for(let u=0,p=c.length;u<p;u++){const R=c[u];if(R.id===_.data.vscodeSetImmediateId){c.splice(u,1),R.callback();return}}});let h=0;return _=>{const u=++h;c.push({id:u,callback:_}),e.globals.postMessage({vscodeSetImmediateId:u},"*")}}if(typeof(d==null?void 0:d.nextTick)=="function")return d.nextTick.bind(d);const s=Promise.resolve();return c=>s.then(c)}();var v;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(v=e.OperatingSystem||(e.OperatingSystem={})),e.OS=A||i?2:T?1:3;let t=!0,n=!1;function o(){if(!n){n=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,t=new Uint16Array(r.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=o}),define(me[36],ge([0,1,10]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let I;if(typeof b.globals.vscode!="undefined"){const T=b.globals.vscode.process;I={get platform(){return T.platform},get env(){return T.env},cwd(){return T.cwd()},nextTick(A){return(0,b.setImmediate)(A)}}}else typeof process!="undefined"?I={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(T){return process.nextTick(T)}}:I={get platform(){return b.isWindows?"win32":b.isMacintosh?"darwin":"linux"},nextTick(T){return(0,b.setImmediate)(T)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=I.cwd,e.env=I.env,e.platform=I.platform,e.nextTick=I.nextTick}),define(me[8],ge([0,1,36]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const I=65,T=97,A=90,y=122,P=46,D=47,k=92,i=58,C=63;class f extends Error{constructor(a,v,t){let n;typeof v=="string"&&v.indexOf("not ")===0?(n="must not be",v=v.replace(/^not /,"")):n="must be";const o=a.indexOf(".")!==-1?"property":"argument";let r=`The "${a}" ${o} ${n} of type ${v}`;r+=`. Received type ${typeof t}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function m(g,a){if(typeof g!="string")throw new f(a,"string",g)}function l(g){return g===D||g===k}function d(g){return g===D}function E(g){return g>=I&&g<=A||g>=T&&g<=y}function w(g,a,v,t){let n="",o=0,r=-1,s=0,c=0;for(let h=0;h<=g.length;++h){if(h<g.length)c=g.charCodeAt(h);else{if(t(c))break;c=D}if(t(c)){if(!(r===h-1||s===1))if(s===2){if(n.length<2||o!==2||n.charCodeAt(n.length-1)!==P||n.charCodeAt(n.length-2)!==P){if(n.length>2){const _=n.lastIndexOf(v);_===-1?(n="",o=0):(n=n.slice(0,_),o=n.length-1-n.lastIndexOf(v)),r=h,s=0;continue}else if(n.length!==0){n="",o=0,r=h,s=0;continue}}a&&(n+=n.length>0?`${v}..`:"..",o=2)}else n.length>0?n+=`${v}${g.slice(r+1,h)}`:n=g.slice(r+1,h),o=h-r-1;r=h,s=0}else c===P&&s!==-1?++s:s=-1}return n}function S(g,a){if(a===null||typeof a!="object")throw new f("pathObject","Object",a);const v=a.dir||a.root,t=a.base||`${a.name||""}${a.ext||""}`;return v?v===a.root?`${v}${t}`:`${v}${g}${t}`:t}e.win32={resolve(...g){let a="",v="",t=!1;for(let n=g.length-1;n>=-1;n--){let o;if(n>=0){if(o=g[n],m(o,"path"),o.length===0)continue}else a.length===0?o=b.cwd():(o=b.env[`=${a}`]||b.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==a.toLowerCase()&&o.charCodeAt(2)===k)&&(o=`${a}\\`));const r=o.length;let s=0,c="",h=!1;const _=o.charCodeAt(0);if(r===1)l(_)&&(s=1,h=!0);else if(l(_))if(h=!0,l(o.charCodeAt(1))){let u=2,p=u;for(;u<r&&!l(o.charCodeAt(u));)u++;if(u<r&&u!==p){const R=o.slice(p,u);for(p=u;u<r&&l(o.charCodeAt(u));)u++;if(u<r&&u!==p){for(p=u;u<r&&!l(o.charCodeAt(u));)u++;(u===r||u!==p)&&(c=`\\\\${R}\\${o.slice(p,u)}`,s=u)}}}else s=1;else E(_)&&o.charCodeAt(1)===i&&(c=o.slice(0,2),s=2,r>2&&l(o.charCodeAt(2))&&(h=!0,s=3));if(c.length>0)if(a.length>0){if(c.toLowerCase()!==a.toLowerCase())continue}else a=c;if(t){if(a.length>0)break}else if(v=`${o.slice(s)}\\${v}`,t=h,h&&a.length>0)break}return v=w(v,!t,"\\",l),t?`${a}\\${v}`:`${a}${v}`||"."},normalize(g){m(g,"path");const a=g.length;if(a===0)return".";let v=0,t,n=!1;const o=g.charCodeAt(0);if(a===1)return d(o)?"\\":g;if(l(o))if(n=!0,l(g.charCodeAt(1))){let s=2,c=s;for(;s<a&&!l(g.charCodeAt(s));)s++;if(s<a&&s!==c){const h=g.slice(c,s);for(c=s;s<a&&l(g.charCodeAt(s));)s++;if(s<a&&s!==c){for(c=s;s<a&&!l(g.charCodeAt(s));)s++;if(s===a)return`\\\\${h}\\${g.slice(c)}\\`;s!==c&&(t=`\\\\${h}\\${g.slice(c,s)}`,v=s)}}}else v=1;else E(o)&&g.charCodeAt(1)===i&&(t=g.slice(0,2),v=2,a>2&&l(g.charCodeAt(2))&&(n=!0,v=3));let r=v<a?w(g.slice(v),!n,"\\",l):"";return r.length===0&&!n&&(r="."),r.length>0&&l(g.charCodeAt(a-1))&&(r+="\\"),t===void 0?n?`\\${r}`:r:n?`${t}\\${r}`:`${t}${r}`},isAbsolute(g){m(g,"path");const a=g.length;if(a===0)return!1;const v=g.charCodeAt(0);return l(v)||a>2&&E(v)&&g.charCodeAt(1)===i&&l(g.charCodeAt(2))},join(...g){if(g.length===0)return".";let a,v;for(let o=0;o<g.length;++o){const r=g[o];m(r,"path"),r.length>0&&(a===void 0?a=v=r:a+=`\\${r}`)}if(a===void 0)return".";let t=!0,n=0;if(typeof v=="string"&&l(v.charCodeAt(0))){++n;const o=v.length;o>1&&l(v.charCodeAt(1))&&(++n,o>2&&(l(v.charCodeAt(2))?++n:t=!1))}if(t){for(;n<a.length&&l(a.charCodeAt(n));)n++;n>=2&&(a=`\\${a.slice(n)}`)}return e.win32.normalize(a)},relative(g,a){if(m(g,"from"),m(a,"to"),g===a)return"";const v=e.win32.resolve(g),t=e.win32.resolve(a);if(v===t||(g=v.toLowerCase(),a=t.toLowerCase(),g===a))return"";let n=0;for(;n<g.length&&g.charCodeAt(n)===k;)n++;let o=g.length;for(;o-1>n&&g.charCodeAt(o-1)===k;)o--;const r=o-n;let s=0;for(;s<a.length&&a.charCodeAt(s)===k;)s++;let c=a.length;for(;c-1>s&&a.charCodeAt(c-1)===k;)c--;const h=c-s,_=r<h?r:h;let u=-1,p=0;for(;p<_;p++){const O=g.charCodeAt(n+p);if(O!==a.charCodeAt(s+p))break;O===k&&(u=p)}if(p!==_){if(u===-1)return t}else{if(h>_){if(a.charCodeAt(s+p)===k)return t.slice(s+p+1);if(p===2)return t.slice(s+p)}r>_&&(g.charCodeAt(n+p)===k?u=p:p===2&&(u=3)),u===-1&&(u=0)}let R="";for(p=n+u+1;p<=o;++p)(p===o||g.charCodeAt(p)===k)&&(R+=R.length===0?"..":"\\..");return s+=u,R.length>0?`${R}${t.slice(s,c)}`:(t.charCodeAt(s)===k&&++s,t.slice(s,c))},toNamespacedPath(g){if(typeof g!="string")return g;if(g.length===0)return"";const a=e.win32.resolve(g);if(a.length<=2)return g;if(a.charCodeAt(0)===k){if(a.charCodeAt(1)===k){const v=a.charCodeAt(2);if(v!==C&&v!==P)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(E(a.charCodeAt(0))&&a.charCodeAt(1)===i&&a.charCodeAt(2)===k)return`\\\\?\\${a}`;return g},dirname(g){m(g,"path");const a=g.length;if(a===0)return".";let v=-1,t=0;const n=g.charCodeAt(0);if(a===1)return l(n)?g:".";if(l(n)){if(v=t=1,l(g.charCodeAt(1))){let s=2,c=s;for(;s<a&&!l(g.charCodeAt(s));)s++;if(s<a&&s!==c){for(c=s;s<a&&l(g.charCodeAt(s));)s++;if(s<a&&s!==c){for(c=s;s<a&&!l(g.charCodeAt(s));)s++;if(s===a)return g;s!==c&&(v=t=s+1)}}}}else E(n)&&g.charCodeAt(1)===i&&(v=a>2&&l(g.charCodeAt(2))?3:2,t=v);let o=-1,r=!0;for(let s=a-1;s>=t;--s)if(l(g.charCodeAt(s))){if(!r){o=s;break}}else r=!1;if(o===-1){if(v===-1)return".";o=v}return g.slice(0,o)},basename(g,a){a!==void 0&&m(a,"ext"),m(g,"path");let v=0,t=-1,n=!0,o;if(g.length>=2&&E(g.charCodeAt(0))&&g.charCodeAt(1)===i&&(v=2),a!==void 0&&a.length>0&&a.length<=g.length){if(a===g)return"";let r=a.length-1,s=-1;for(o=g.length-1;o>=v;--o){const c=g.charCodeAt(o);if(l(c)){if(!n){v=o+1;break}}else s===-1&&(n=!1,s=o+1),r>=0&&(c===a.charCodeAt(r)?--r==-1&&(t=o):(r=-1,t=s))}return v===t?t=s:t===-1&&(t=g.length),g.slice(v,t)}for(o=g.length-1;o>=v;--o)if(l(g.charCodeAt(o))){if(!n){v=o+1;break}}else t===-1&&(n=!1,t=o+1);return t===-1?"":g.slice(v,t)},extname(g){m(g,"path");let a=0,v=-1,t=0,n=-1,o=!0,r=0;g.length>=2&&g.charCodeAt(1)===i&&E(g.charCodeAt(0))&&(a=t=2);for(let s=g.length-1;s>=a;--s){const c=g.charCodeAt(s);if(l(c)){if(!o){t=s+1;break}continue}n===-1&&(o=!1,n=s+1),c===P?v===-1?v=s:r!==1&&(r=1):v!==-1&&(r=-1)}return v===-1||n===-1||r===0||r===1&&v===n-1&&v===t+1?"":g.slice(v,n)},format:S.bind(null,"\\"),parse(g){m(g,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return a;const v=g.length;let t=0,n=g.charCodeAt(0);if(v===1)return l(n)?(a.root=a.dir=g,a):(a.base=a.name=g,a);if(l(n)){if(t=1,l(g.charCodeAt(1))){let u=2,p=u;for(;u<v&&!l(g.charCodeAt(u));)u++;if(u<v&&u!==p){for(p=u;u<v&&l(g.charCodeAt(u));)u++;if(u<v&&u!==p){for(p=u;u<v&&!l(g.charCodeAt(u));)u++;u===v?t=u:u!==p&&(t=u+1)}}}}else if(E(n)&&g.charCodeAt(1)===i){if(v<=2)return a.root=a.dir=g,a;if(t=2,l(g.charCodeAt(2))){if(v===3)return a.root=a.dir=g,a;t=3}}t>0&&(a.root=g.slice(0,t));let o=-1,r=t,s=-1,c=!0,h=g.length-1,_=0;for(;h>=t;--h){if(n=g.charCodeAt(h),l(n)){if(!c){r=h+1;break}continue}s===-1&&(c=!1,s=h+1),n===P?o===-1?o=h:_!==1&&(_=1):o!==-1&&(_=-1)}return s!==-1&&(o===-1||_===0||_===1&&o===s-1&&o===r+1?a.base=a.name=g.slice(r,s):(a.name=g.slice(r,o),a.base=g.slice(r,s),a.ext=g.slice(o,s))),r>0&&r!==t?a.dir=g.slice(0,r-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...g){let a="",v=!1;for(let t=g.length-1;t>=-1&&!v;t--){const n=t>=0?g[t]:b.cwd();m(n,"path"),n.length!==0&&(a=`${n}/${a}`,v=n.charCodeAt(0)===D)}return a=w(a,!v,"/",d),v?`/${a}`:a.length>0?a:"."},normalize(g){if(m(g,"path"),g.length===0)return".";const a=g.charCodeAt(0)===D,v=g.charCodeAt(g.length-1)===D;return g=w(g,!a,"/",d),g.length===0?a?"/":v?"./":".":(v&&(g+="/"),a?`/${g}`:g)},isAbsolute(g){return m(g,"path"),g.length>0&&g.charCodeAt(0)===D},join(...g){if(g.length===0)return".";let a;for(let v=0;v<g.length;++v){const t=g[v];m(t,"path"),t.length>0&&(a===void 0?a=t:a+=`/${t}`)}return a===void 0?".":e.posix.normalize(a)},relative(g,a){if(m(g,"from"),m(a,"to"),g===a||(g=e.posix.resolve(g),a=e.posix.resolve(a),g===a))return"";const v=1,t=g.length,n=t-v,o=1,r=a.length-o,s=n<r?n:r;let c=-1,h=0;for(;h<s;h++){const u=g.charCodeAt(v+h);if(u!==a.charCodeAt(o+h))break;u===D&&(c=h)}if(h===s)if(r>s){if(a.charCodeAt(o+h)===D)return a.slice(o+h+1);if(h===0)return a.slice(o+h)}else n>s&&(g.charCodeAt(v+h)===D?c=h:h===0&&(c=0));let _="";for(h=v+c+1;h<=t;++h)(h===t||g.charCodeAt(h)===D)&&(_+=_.length===0?"..":"/..");return`${_}${a.slice(o+c)}`},toNamespacedPath(g){return g},dirname(g){if(m(g,"path"),g.length===0)return".";const a=g.charCodeAt(0)===D;let v=-1,t=!0;for(let n=g.length-1;n>=1;--n)if(g.charCodeAt(n)===D){if(!t){v=n;break}}else t=!1;return v===-1?a?"/":".":a&&v===1?"//":g.slice(0,v)},basename(g,a){a!==void 0&&m(a,"ext"),m(g,"path");let v=0,t=-1,n=!0,o;if(a!==void 0&&a.length>0&&a.length<=g.length){if(a===g)return"";let r=a.length-1,s=-1;for(o=g.length-1;o>=0;--o){const c=g.charCodeAt(o);if(c===D){if(!n){v=o+1;break}}else s===-1&&(n=!1,s=o+1),r>=0&&(c===a.charCodeAt(r)?--r==-1&&(t=o):(r=-1,t=s))}return v===t?t=s:t===-1&&(t=g.length),g.slice(v,t)}for(o=g.length-1;o>=0;--o)if(g.charCodeAt(o)===D){if(!n){v=o+1;break}}else t===-1&&(n=!1,t=o+1);return t===-1?"":g.slice(v,t)},extname(g){m(g,"path");let a=-1,v=0,t=-1,n=!0,o=0;for(let r=g.length-1;r>=0;--r){const s=g.charCodeAt(r);if(s===D){if(!n){v=r+1;break}continue}t===-1&&(n=!1,t=r+1),s===P?a===-1?a=r:o!==1&&(o=1):a!==-1&&(o=-1)}return a===-1||t===-1||o===0||o===1&&a===t-1&&a===v+1?"":g.slice(a,t)},format:S.bind(null,"/"),parse(g){m(g,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return a;const v=g.charCodeAt(0)===D;let t;v?(a.root="/",t=1):t=0;let n=-1,o=0,r=-1,s=!0,c=g.length-1,h=0;for(;c>=t;--c){const _=g.charCodeAt(c);if(_===D){if(!s){o=c+1;break}continue}r===-1&&(s=!1,r=c+1),_===P?n===-1?n=c:h!==1&&(h=1):n!==-1&&(h=-1)}if(r!==-1){const _=o===0&&v?1:o;n===-1||h===0||h===1&&n===r-1&&n===o+1?a.base=a.name=g.slice(_,r):(a.name=g.slice(_,n),a.base=g.slice(_,r),a.ext=g.slice(n,r))}return o>0?a.dir=g.slice(0,o-1):v&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=b.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=b.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=b.platform==="win32"?e.win32.join:e.posix.join,e.resolve=b.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=b.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=b.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=b.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=b.platform==="win32"?e.win32.extname:e.posix.extname,e.format=b.platform==="win32"?e.win32.format:e.posix.format,e.parse=b.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=b.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=b.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=b.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(me[95],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var b;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(b=e.Source||(e.Source={}));var I;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(I=e.TerminateResponseCode||(e.TerminateResponseCode={}));function T(A,...y){const P=y.reduce((i,C)=>(i[C]=!0,i),{}),D=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(A).filter(i=>!P[i]).forEach(i=>{for(let C=0;C<D.length;C++)if(i.search(D[C])!==-1){delete A[i];break}})}e.sanitizeProcessEnvironment=T}),define(me[47],ge([0,1,10]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const I=b.globals.performance&&typeof b.globals.performance.now=="function";class T{constructor(y){this._highResolution=I&&y,this._startTime=this._now(),this._stopTime=-1}static create(y=!0){return new T(y)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?b.globals.performance.now():Date.now()}}e.StopWatch=T}),define(me[3],ge([0,1,16,71,6,57,47]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(w){w.None=()=>T.Disposable.None;function S(K){return(x,$=null,U)=>{let L=!1,N;return N=K(M=>{if(!L)return N?N.dispose():L=!0,x.call($,M)},null,U),L&&N.dispose(),N}}w.once=S;function g(K,x){return r(($,U=null,L)=>K(N=>$.call(U,x(N)),null,L))}w.map=g;function a(K,x){return r(($,U=null,L)=>K(N=>{x(N),$.call(U,N)},null,L))}w.forEach=a;function v(K,x){return r(($,U=null,L)=>K(N=>x(N)&&$.call(U,N),null,L))}w.filter=v;function t(K){return K}w.signal=t;function n(...K){return(x,$=null,U)=>(0,T.combinedDisposable)(...K.map(L=>L(N=>x.call($,N),null,U)))}w.any=n;function o(K,x,$){let U=$;return g(K,L=>(U=x(U,L),U))}w.reduce=o;function r(K){let x;const $=new f({onFirstListenerAdd(){x=K($.fire,$)},onLastListenerRemove(){x.dispose()}});return $.event}w.snapshot=r;function s(K,x,$=100,U=!1,L){let N,M,F,W=0;const q=new f({leakWarningThreshold:L,onFirstListenerAdd(){N=K(Q=>{W++,M=x(M,Q),U&&!F&&(q.fire(M),M=void 0),clearTimeout(F),F=setTimeout(()=>{const le=M;M=void 0,F=void 0,(!U||W>1)&&q.fire(le),W=0},$)})},onLastListenerRemove(){N.dispose()}});return q.event}w.debounce=s;function c(K){const x=new Date().getTime();return g(S(K),$=>new Date().getTime()-x)}w.stopwatch=c;function h(K){let x=!0,$;return v(K,U=>{const L=x||U!==$;return x=!1,$=U,L})}w.latch=h;function _(K,x=!1,$=[]){let U=$.slice(),L=K(F=>{U?U.push(F):M.fire(F)});const N=()=>{U&&U.forEach(F=>M.fire(F)),U=null},M=new f({onFirstListenerAdd(){L||(L=K(F=>M.fire(F)))},onFirstListenerDidAdd(){U&&(x?setTimeout(N):N())},onLastListenerRemove(){L&&L.dispose(),L=null}});return M.event}w.buffer=_;class u{constructor(x){this.event=x}map(x){return new u(g(this.event,x))}forEach(x){return new u(a(this.event,x))}filter(x){return new u(v(this.event,x))}reduce(x,$){return new u(o(this.event,x,$))}latch(){return new u(h(this.event))}debounce(x,$=100,U=!1,L){return new u(s(this.event,x,$,U,L))}on(x,$,U){return this.event(x,$,U)}once(x,$,U){return S(this.event)(x,$,U)}}function p(K){return new u(K)}w.chain=p;function R(K,x,$=U=>U){const U=(...F)=>M.fire($(...F)),L=()=>K.on(x,U),N=()=>K.removeListener(x,U),M=new f({onFirstListenerAdd:L,onLastListenerRemove:N});return M.event}w.fromNodeEventEmitter=R;function O(K,x,$=U=>U){const U=(...F)=>M.fire($(...F)),L=()=>K.addEventListener(x,U),N=()=>K.removeEventListener(x,U),M=new f({onFirstListenerAdd:L,onLastListenerRemove:N});return M.event}w.fromDOMEventEmitter=O;function j(K){const x=new f;let $=!1;return K.then(void 0,()=>null).then(()=>{$?x.fire(void 0):setTimeout(()=>x.fire(void 0),0)}),$=!0,x.event}w.fromPromise=j;function ie(K){return new Promise(x=>S(K)(x))}w.toPromise=ie})(P=e.Event||(e.Event={}));class D{constructor(S){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${S}_${D._idPool++}`}start(S){this._stopWatch=new y.StopWatch(!0),this._listenerCount=S}stop(){if(this._stopWatch){const S=this._stopWatch.elapsed();this._elapsedOverall+=S,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${S.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}D._idPool=0;let k=-1;function i(w){const S=k;return k=w,{dispose(){k=S}}}e.setGlobalLeakWarningThreshold=i;class C{constructor(S,g=Math.random().toString(18).slice(2,5)){this.customThreshold=S,this.name=g,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(S){let g=k;if(typeof this.customThreshold=="number"&&(g=this.customThreshold),!(g<=0||S<g)){this._stacks||(this._stacks=new Map);const a=new Error().stack.split(`
`).slice(3).join(`
`),v=this._stacks.get(a)||0;if(this._stacks.set(a,v+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=g*.5;let t,n=0;for(const[o,r]of this._stacks)(!t||n<r)&&(t=o,n=r);console.warn(`[${this.name}] potential listener LEAK detected, having ${S} listeners already. MOST frequent listener (${n}):`),console.warn(t)}return()=>{const t=this._stacks.get(a)||0;this._stacks.set(a,t-1)}}}}class f{constructor(S){var g;this._disposed=!1,this._options=S,this._leakageMon=k>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((g=this._options)===null||g===void 0?void 0:g._profName)?new D(this._options._profName):void 0}get event(){return this._event||(this._event=(S,g,a)=>{var v;this._listeners||(this._listeners=new A.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(g?[S,g]:S);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,S,g);const o=(v=this._leakageMon)===null||v===void 0?void 0:v.check(this._listeners.size);let r;return r={dispose:()=>{o&&o(),r.dispose=f._noop,this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},a instanceof T.DisposableStore?a.add(r):Array.isArray(a)&&a.push(r),r}),this._event}fire(S){var g,a;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new A.LinkedList);for(let v of this._listeners)this._deliveryQueue.push([v,S]);for((g=this._perfMon)===null||g===void 0||g.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[v,t]=this._deliveryQueue.shift();try{typeof v=="function"?v.call(void 0,t):v[0].call(v[1],t)}catch(n){(0,b.onUnexpectedError)(n)}}(a=this._perfMon)===null||a===void 0||a.stop()}}dispose(){var S,g,a;(S=this._listeners)===null||S===void 0||S.clear(),(g=this._deliveryQueue)===null||g===void 0||g.clear(),(a=this._leakageMon)===null||a===void 0||a.dispose(),this._disposed=!0}}e.Emitter=f,f._noop=function(){};class m extends f{constructor(S){super(S);this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=S==null?void 0:S.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const S=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(S))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(S){this._listeners&&(this._isPaused!==0?this._eventQueue.push(S):super.fire(S))}}e.PauseableEmitter=m;class l{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new f({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(S){const g={event:S,listener:null};this.events.push(g),this.hasListeners&&this.hook(g);const a=()=>{this.hasListeners&&this.unhook(g);const v=this.events.indexOf(g);this.events.splice(v,1)};return(0,T.toDisposable)((0,I.once)(a))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(S=>this.hook(S))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(S=>this.unhook(S))}hook(S){S.listener=S.event(g=>this.emitter.fire(g))}unhook(S){S.listener&&S.listener.dispose(),S.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=l;class d{constructor(){this.buffers=[]}wrapEvent(S){return(g,a,v)=>S(t=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>g.call(a,t)):g.call(a,t)},void 0,v)}bufferEvents(S){const g=[];this.buffers.push(g);const a=S();return this.buffers.pop(),g.forEach(v=>v()),a}}e.EventBufferer=d;class E{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=T.Disposable.None,this.emitter=new f({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(S){this.inputEvent=S,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=S(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=E}),define(me[21],ge([0,1,3]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const I=Object.freeze(function(P,D){const k=setTimeout(P.bind(D),0);return{dispose(){clearTimeout(k)}}});var T;(function(P){function D(k){return k===P.None||k===P.Cancelled||k instanceof A?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}P.isCancellationToken=D,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:b.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:I})})(T=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?I:(this._emitter||(this._emitter=new b.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(D){this._token=void 0,this._parentListener=void 0,this._parentListener=D&&D.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=T.Cancelled}dispose(D=!1){D&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=T.None}}e.CancellationTokenSource=y}),define(me[43],ge([0,1,3]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class I{constructor(){this._icons=new Map,this._onDidRegister=new b.Emitter}add(C){const f=this._icons.get(C.id);f?C.description?f.description=C.description:console.error(`Duplicate registration of codicon ${C.id}`):(this._icons.set(C.id,C),this._onDidRegister.fire(C))}get(C){return this._icons.get(C)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const T=new I;e.iconRegistry=T;function A(i,C){return new P(i,C)}e.registerCodicon=A;function y(i){return i?i.replace(/\$\((.*?)\)/g,(C,f)=>` ${f} `).trim():""}e.getCodiconAriaLabel=y;class P{constructor(C,f,m){this.id=C,this.definition=f,this.description=m,T.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=P;function D(i,C){const f=["codicon","codicon-"+i];return C&&f.push("codicon-modifier-"+C),f}e.getClassNamesArray=D;var k;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const C=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function f(d){if(d instanceof P)return["codicon","codicon-"+d.id];const E=C.exec(d.id);if(!E)return f(P.error);let[,w,S]=E;const g=["codicon","codicon-"+w];return S&&g.push("codicon-modifier-"+S.substr(1)),g}i.asClassNameArray=f;function m(d){return f(d).join(" ")}i.asClassName=m;function l(d){return"."+f(d).join(".")}i.asCSSSelector=l})(k=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(P=e.Codicon||(e.Codicon={}))}),define(me[96],ge([0,1,16,6]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function T(g){const a=g;return a?[a.on,a.pause,a.resume,a.destroy].every(v=>typeof v=="function"):!1}e.isReadableStream=T;function A(g){const a=g;return a?T(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=A;function y(g,a){return new P(g,a)}e.newWriteableStream=y;class P{constructor(a,v){this.reducer=a,this.options=v,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){var v;if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof((v=this.options)===null||v===void 0?void 0:v.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a!="undefined"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(v=>v(a))}emitError(a){this.listeners.error.length===0?(0,b.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(v=>v(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,v){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(v),this.resume();break;case"end":this.listeners.end.push(v),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(v),this.state.flowing&&this.flowErrors();break}}removeListener(a,v){if(!this.state.destroyed){let t;switch(a){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const n=t.indexOf(v);n>=0&&t.splice(n,1)}}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const v=[...this.pendingWritePromises];this.pendingWritePromises.length=0,v.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(g,a){const v=[];let t;for(;(t=g.read())!==null;)v.push(t);return a(v)}e.consumeReadable=D;function k(g,a,v){const t=[];let n;for(;(n=g.read())!==null&&t.length<v;)t.push(n);return n===null&&t.length>0?a(t):{read:()=>{if(t.length>0)return t.shift();if(typeof n!="undefined"){const o=n;return n=void 0,o}return g.read()}}}e.peekReadable=k;function i(g,a){return new Promise((v,t)=>{const n=[];C(g,{onData:o=>{a&&n.push(o)},onError:o=>{a?t(o):v(void 0)},onEnd:()=>{v(a?a(n):void 0)}})})}e.consumeStream=i;function C(g,a){g.on("error",v=>a.onError(v)),g.on("end",()=>a.onEnd()),g.on("data",v=>a.onData(v))}e.listenStream=C;function f(g,a){return new Promise((v,t)=>{const n=new I.DisposableStore,o=[],r=h=>{if(o.push(h),o.length>a)return n.dispose(),g.pause(),v({stream:g,buffer:o,ended:!1})},s=h=>t(h),c=()=>v({stream:g,buffer:o,ended:!0});n.add((0,I.toDisposable)(()=>g.removeListener("error",s))),g.on("error",s),n.add((0,I.toDisposable)(()=>g.removeListener("end",c))),g.on("end",c),n.add((0,I.toDisposable)(()=>g.removeListener("data",r))),g.on("data",r)})}e.peekStream=f;function m(g,a){const v=y(a);return v.end(g),v}e.toStream=m;function l(){const g=y(()=>{throw new Error("not supported")});return g.end(),g}e.emptyStream=l;function d(g){let a=!1;return{read:()=>a?null:(a=!0,g)}}e.toReadable=d;function E(g,a,v){const t=y(v);return C(g,{onData:n=>t.write(a.data(n)),onError:n=>t.error(a.error?a.error(n):n),onEnd:()=>t.end()}),t}e.transform=E;function w(g,a,v){let t=!1;return{read:()=>{const n=a.read();return t?n:(t=!0,n!==null?v([g,n]):g)}}}e.prefixedReadable=w;function S(g,a,v){let t=!1;const n=y(v);return C(a,{onData:o=>t?n.write(o):(t=!0,n.write(v([g,o]))),onError:o=>n.error(o),onEnd:()=>{t||(t=!0,n.write(g)),n.end()}}),n}e.prefixedStream=S}),define(me[9],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function b(H){return!H||typeof H!="string"?!0:H.trim().length===0}e.isFalsyOrWhitespace=b;const I=/{(\d+)}/g;function T(H,...Z){return Z.length===0?H:H.replace(I,function(ce,Ie){const Ae=parseInt(Ie,10);return isNaN(Ae)||Ae<0||Ae>=Z.length?ce:Z[Ae]})}e.format=T;function A(H){return H.replace(/[<>&]/g,function(Z){switch(Z){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Z}})}e.escape=A;function y(H){return H.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function P(H,Z){let ce=0;const Ie=Z.charCodeAt(0);for(let Ae=H.length-1;Ae>=0;Ae--)H.charCodeAt(Ae)===Ie&&ce++;return ce}e.count=P;function D(H,Z,ce="\u2026"){return H.length<=Z?H:`${H.substr(0,Z)}${ce}`}e.truncate=D;function k(H,Z=" "){const ce=i(H,Z);return C(ce,Z)}e.trim=k;function i(H,Z){if(!H||!Z)return H;const ce=Z.length;if(ce===0||H.length===0)return H;let Ie=0;for(;H.indexOf(Z,Ie)===Ie;)Ie=Ie+ce;return H.substring(Ie)}e.ltrim=i;function C(H,Z){if(!H||!Z)return H;const ce=Z.length,Ie=H.length;if(ce===0||Ie===0)return H;let Ae=Ie,Le=-1;for(;Le=H.lastIndexOf(Z,Ae-1),!(Le===-1||Le+ce!==Ae);){if(Le===0)return"";Ae=Le}return H.substring(0,Ae)}e.rtrim=C;function f(H){return H.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=f;function m(H){return H.replace(/\*/g,"")}e.stripWildcards=m;function l(H,Z,ce={}){if(!H)throw new Error("Cannot create regex from empty string");Z||(H=y(H)),ce.wholeWord&&(/\B/.test(H.charAt(0))||(H="\\b"+H),/\B/.test(H.charAt(H.length-1))||(H=H+"\\b"));let Ie="";return ce.global&&(Ie+="g"),ce.matchCase||(Ie+="i"),ce.multiline&&(Ie+="m"),ce.unicode&&(Ie+="u"),new RegExp(H,Ie)}e.createRegExp=l;function d(H){return H.source==="^"||H.source==="^$"||H.source==="$"||H.source==="^\\s*$"?!1:!!(H.exec("")&&H.lastIndex===0)}e.regExpLeadsToEndlessLoop=d;function E(H){return!!H.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=E;function w(H){return(H.global?"g":"")+(H.ignoreCase?"i":"")+(H.multiline?"m":"")+(H.unicode?"u":"")}e.regExpFlags=w;function S(H){return H.split(/\r\n|\r|\n/)}e.splitLines=S;function g(H){for(let Z=0,ce=H.length;Z<ce;Z++){const Ie=H.charCodeAt(Z);if(Ie!==32&&Ie!==9)return Z}return-1}e.firstNonWhitespaceIndex=g;function a(H,Z=0,ce=H.length){for(let Ie=Z;Ie<ce;Ie++){const Ae=H.charCodeAt(Ie);if(Ae!==32&&Ae!==9)return H.substring(Z,Ie)}return H.substring(Z,ce)}e.getLeadingWhitespace=a;function v(H,Z=H.length-1){for(let ce=Z;ce>=0;ce--){const Ie=H.charCodeAt(ce);if(Ie!==32&&Ie!==9)return ce}return-1}e.lastNonWhitespaceIndex=v;function t(H,Z){return H<Z?-1:H>Z?1:0}e.compare=t;function n(H,Z,ce=0,Ie=H.length,Ae=0,Le=Z.length){for(;ce<Ie&&Ae<Le;ce++,Ae++){let rt=H.charCodeAt(ce),tt=Z.charCodeAt(Ae);if(rt<tt)return-1;if(rt>tt)return 1}const $e=Ie-ce,Xe=Le-Ae;return $e<Xe?-1:$e>Xe?1:0}e.compareSubstring=n;function o(H,Z){return r(H,Z,0,H.length,0,Z.length)}e.compareIgnoreCase=o;function r(H,Z,ce=0,Ie=H.length,Ae=0,Le=Z.length){for(;ce<Ie&&Ae<Le;ce++,Ae++){let rt=H.charCodeAt(ce),tt=Z.charCodeAt(Ae);if(rt!==tt){const Qe=rt-tt;if(!(Qe===32&&c(tt))&&!(Qe===-32&&c(rt)))return s(rt)&&s(tt)?Qe:n(H.toLowerCase(),Z.toLowerCase(),ce,Ie,Ae,Le)}}const $e=Ie-ce,Xe=Le-Ae;return $e<Xe?-1:$e>Xe?1:0}e.compareSubstringIgnoreCase=r;function s(H){return H>=97&&H<=122}e.isLowerAsciiLetter=s;function c(H){return H>=65&&H<=90}e.isUpperAsciiLetter=c;function h(H){return s(H)||c(H)}function _(H,Z){return H.length===Z.length&&u(H,Z)}e.equalsIgnoreCase=_;function u(H,Z,ce=H.length){for(let Ie=0;Ie<ce;Ie++){const Ae=H.charCodeAt(Ie),Le=Z.charCodeAt(Ie);if(Ae!==Le){if(h(Ae)&&h(Le)){const $e=Math.abs(Ae-Le);if($e!==0&&$e!==32)return!1}else if(String.fromCharCode(Ae).toLowerCase()!==String.fromCharCode(Le).toLowerCase())return!1}}return!0}function p(H,Z){const ce=Z.length;return Z.length>H.length?!1:u(H,Z,ce)}e.startsWithIgnoreCase=p;function R(H,Z){let ce,Ie=Math.min(H.length,Z.length);for(ce=0;ce<Ie;ce++)if(H.charCodeAt(ce)!==Z.charCodeAt(ce))return ce;return Ie}e.commonPrefixLength=R;function O(H,Z){let ce,Ie=Math.min(H.length,Z.length);const Ae=H.length-1,Le=Z.length-1;for(ce=0;ce<Ie;ce++)if(H.charCodeAt(Ae-ce)!==Z.charCodeAt(Le-ce))return ce;return Ie}e.commonSuffixLength=O;function j(H){return 55296<=H&&H<=56319}e.isHighSurrogate=j;function ie(H){return 56320<=H&&H<=57343}e.isLowSurrogate=ie;function K(H,Z){return(H-55296<<10)+(Z-56320)+65536}e.computeCodePoint=K;function x(H,Z,ce){const Ie=H.charCodeAt(ce);if(j(Ie)&&ce+1<Z){const Ae=H.charCodeAt(ce+1);if(ie(Ae))return K(Ie,Ae)}return Ie}e.getNextCodePoint=x;function $(H,Z){const ce=H.charCodeAt(Z-1);if(ie(ce)&&Z>1){const Ie=H.charCodeAt(Z-2);if(j(Ie))return K(Ie,ce)}return ce}function U(H,Z){const ce=Ve.getInstance(),Ie=Z,Ae=H.length,Le=x(H,Ae,Z);Z+=Le>=65536?2:1;let $e=ce.getGraphemeBreakType(Le);for(;Z<Ae;){const Xe=x(H,Ae,Z),rt=ce.getGraphemeBreakType(Xe);if(xe($e,rt))break;Z+=Xe>=65536?2:1,$e=rt}return Z-Ie}e.nextCharLength=U;function L(H,Z){const ce=Ve.getInstance(),Ie=Z,Ae=$(H,Z);Z-=Ae>=65536?2:1;let Le=ce.getGraphemeBreakType(Ae);for(;Z>0;){const $e=$(H,Z),Xe=ce.getGraphemeBreakType($e);if(xe(Xe,Le))break;Z-=$e>=65536?2:1,Le=Xe}return Ie-Z}e.prevCharLength=L;function N(H,Z){const ce=Ve.getInstance(),Ie=H.length,Ae=Z,Le=x(H,Ie,Z),$e=ce.getGraphemeBreakType(Le);Z+=Le>=65536?2:1;let Xe=$e;for(;Z<Ie;){const tt=x(H,Ie,Z),Qe=ce.getGraphemeBreakType(tt);if(xe(Xe,Qe))break;Z+=tt>=65536?2:1,Xe=Qe}const rt=Z;for(Z=Ae,Xe=$e;Z>0;){const tt=$(H,Z),Qe=ce.getGraphemeBreakType(tt);if(xe(Qe,Xe))break;Z-=tt>=65536?2:1,Xe=Qe}return[Z,rt]}function M(H,Z){return Z>0&&ie(H.charCodeAt(Z))?N(H,Z-1):N(H,Z)}e.getCharContainingOffset=M;function F(H){const Z=H.length;let ce=0,Ie=0;for(;Ie<Z;){const $e=x(H,Z,Ie);Ie+=$e>=65536?2:1,$e<128?ce+=1:$e<2048?ce+=2:$e<65536?ce+=3:ce+=4}const Ae=new Uint8Array(ce);Ie=0;let Le=0;for(;Ie<Z;){const $e=x(H,Z,Ie);Ie+=$e>=65536?2:1,$e<128?Ae[Le++]=$e:$e<2048?(Ae[Le++]=192|($e&1984)>>>6,Ae[Le++]=128|($e&63)>>>0):$e<65536?(Ae[Le++]=224|($e&61440)>>>12,Ae[Le++]=128|($e&4032)>>>6,Ae[Le++]=128|($e&63)>>>0):(Ae[Le++]=240|($e&1835008)>>>18,Ae[Le++]=128|($e&258048)>>>12,Ae[Le++]=128|($e&4032)>>>6,Ae[Le++]=128|($e&63)>>>0)}return Ae}e.encodeUTF8=F;function W(H){const Z=H.byteLength,ce=[];let Ie=0;for(;Ie<Z;){const Ae=H[Ie];let Le;if(Ae>=240&&Ie+3<Z?Le=(H[Ie++]&7)<<18>>>0|(H[Ie++]&63)<<12>>>0|(H[Ie++]&63)<<6>>>0|(H[Ie++]&63)<<0>>>0:Ae>=224&&Ie+2<Z?Le=(H[Ie++]&15)<<12>>>0|(H[Ie++]&63)<<6>>>0|(H[Ie++]&63)<<0>>>0:Ae>=192&&Ie+1<Z?Le=(H[Ie++]&31)<<6>>>0|(H[Ie++]&63)<<0>>>0:Le=H[Ie++],Le>=0&&Le<=55295||Le>=57344&&Le<=65535)ce.push(String.fromCharCode(Le));else if(Le>=65536&&Le<=1114111){const $e=Le-65536,Xe=55296+(($e&1047552)>>>10),rt=56320+(($e&1023)>>>0);ce.push(String.fromCharCode(Xe)),ce.push(String.fromCharCode(rt))}else ce.push(String.fromCharCode(65533))}return ce.join("")}e.decodeUTF8=W;const q=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Q(H){return q.test(H)}e.containsRTL=Q;const le=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function ve(H){return le.test(H)}e.containsEmoji=ve;const Re=/^[\t\n\r\x20-\x7E]*$/;function Se(H){return Re.test(H)}e.isBasicASCII=Se,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Oe(H){return e.UNUSUAL_LINE_TERMINATORS.test(H)}e.containsUnusualLineTerminators=Oe;function z(H){for(let Z=0,ce=H.length;Z<ce;Z++)if(Y(H.charCodeAt(Z)))return!0;return!1}e.containsFullWidthCharacter=z;function Y(H){return H=+H,H>=11904&&H<=55215||H>=63744&&H<=64255||H>=65281&&H<=65374}e.isFullWidthCharacter=Y;function ee(H){return H>=127462&&H<=127487||H===8986||H===8987||H===9200||H===9203||H>=9728&&H<=10175||H===11088||H===11093||H>=127744&&H<=128591||H>=128640&&H<=128764||H>=128992&&H<=129003||H>=129280&&H<=129535||H>=129648&&H<=129750}e.isEmojiImprecise=ee;function se(H,Z){if(H.length<Z)return H;const ce=/\b/g;let Ie=0;for(;ce.test(H)&&!(H.length-ce.lastIndex<Z);)Ie=ce.lastIndex,ce.lastIndex+=1;return H.substring(Ie).replace(/^\s/,"")}e.lcut=se;const fe=/\x1B\x5B[12]?K/g,Ee=/\x1b\[\d+m/g,Be=/\x1b\[0?m/g;function pe(H){return H&&(H=H.replace(fe,""),H=H.replace(Ee,""),H=H.replace(Be,"")),H}e.removeAnsiEscapeCodes=pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(H){return!!(H&&H.length>0&&H.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function Me(H){return Ce(H)?H.substr(1):H}e.stripUTF8BOM=Me;function ze(H,Z){if(!H||!Z||H.length<Z.length)return!1;const ce=Z.length,Ie=H.toLowerCase();let Ae=0,Le=-1;for(;Ae<ce;){const $e=Ie.indexOf(Z[Ae],Le+1);if($e<0)return!1;Le=$e,Ae++}return!0}e.fuzzyContains=ze;function _e(H,Z=!1){return H?(Z&&(H=H.replace(/\\./g,"")),H.toLowerCase()!==H):!1}e.containsUppercaseCharacter=_e;function Ke(H){return H.charAt(0).toUpperCase()+H.slice(1)}e.uppercaseFirstLetter=Ke;function X(H,Z=1){if(Z===0)return"";let ce=-1;do ce=H.indexOf(`
`,ce+1),Z--;while(Z>0&&ce>=0);return ce===-1?H:(H[ce-1]==="\r"&&ce--,H.substr(0,ce))}e.getNLines=X;function ne(H){const Z=90-65+1;return H=H%(2*Z),H<Z?String.fromCharCode(97+H):String.fromCharCode(65+H-Z)}e.singleLetterHash=ne;function we(H){return Ve.getInstance().getGraphemeBreakType(H)}e.getGraphemeBreakType=we;function xe(H,Z){return H===0?Z!==5&&Z!==7:H===2&&Z===3?!1:H===4||H===2||H===3||Z===4||Z===2||Z===3?!0:!(H===8&&(Z===8||Z===9||Z===11||Z===12)||(H===11||H===9)&&(Z===9||Z===10)||(H===12||H===10)&&Z===10||Z===5||Z===13||Z===7||H===1||H===13&&Z===14||H===6&&Z===6)}e.breakBetweenGraphemeBreakType=xe;var je;(function(H){H[H.Other=0]="Other",H[H.Prepend=1]="Prepend",H[H.CR=2]="CR",H[H.LF=3]="LF",H[H.Control=4]="Control",H[H.Extend=5]="Extend",H[H.Regional_Indicator=6]="Regional_Indicator",H[H.SpacingMark=7]="SpacingMark",H[H.L=8]="L",H[H.V=9]="V",H[H.T=10]="T",H[H.LV=11]="LV",H[H.LVT=12]="LVT",H[H.ZWJ=13]="ZWJ",H[H.Extended_Pictographic=14]="Extended_Pictographic"})(je=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ve{constructor(){this._data=Ze()}static getInstance(){return Ve._INSTANCE||(Ve._INSTANCE=new Ve),Ve._INSTANCE}getGraphemeBreakType(Z){if(Z<32)return Z===10?3:Z===13?2:4;if(Z<127)return 0;const ce=this._data,Ie=ce.length/3;let Ae=1;for(;Ae<=Ie;)if(Z<ce[3*Ae])Ae=2*Ae;else if(Z>ce[3*Ae+1])Ae=2*Ae+1;else return ce[3*Ae+2];return 0}}Ve._INSTANCE=null;function Ze(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function De(H,Z){if(H===0)return 0;const ce=ye(H,Z);if(ce!==void 0)return ce;const Ie=$(Z,H);return H-=Pe(Ie),H}e.getLeftDeleteOffset=De;function ye(H,Z){let ce=$(Z,H);for(H-=Pe(ce);oe(ce)||ce===65039||ce===8419;){if(H===0)return;ce=$(Z,H),H-=Pe(ce)}if(!!ee(ce)){if(H>=0){const Ie=$(Z,H);Ie===8205&&(H-=Pe(Ie))}return H}}function Pe(H){return H>=65536?2:1}function oe(H){return 127995<=H&&H<=127999}var ue;(function(H){H[H.zwj=8205]="zwj",H[H.emojiVariantSelector=65039]="emojiVariantSelector",H[H.enclosingKeyCap=8419]="enclosingKeyCap"})(ue||(ue={}))}),define(me[23],ge([0,1,9,96]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const T=typeof Buffer!="undefined",A=typeof TextEncoder!="undefined",y=typeof TextDecoder!="undefined";let P,D;class k{constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}static alloc(h){return T?new k(Buffer.allocUnsafe(h)):new k(new Uint8Array(h))}static wrap(h){return T&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new k(h)}static fromString(h,_){return!((_==null?void 0:_.dontUseNodeBuffer)||!1)&&T?new k(Buffer.from(h)):A?(P||(P=new TextEncoder),new k(P.encode(h))):new k(b.encodeUTF8(h))}static concat(h,_){if(typeof _=="undefined"){_=0;for(let R=0,O=h.length;R<O;R++)_+=h[R].byteLength}const u=k.alloc(_);let p=0;for(let R=0,O=h.length;R<O;R++){const j=h[R];u.set(j,p),p+=j.byteLength}return u}toString(){return T?this.buffer.toString():y?(D||(D=new TextDecoder),D.decode(this.buffer)):b.decodeUTF8(this.buffer)}slice(h,_){return new k(this.buffer.subarray(h,_))}set(h,_){h instanceof k?this.buffer.set(h.buffer,_):this.buffer.set(h,_)}readUInt32BE(h){return f(this.buffer,h)}writeUInt32BE(h,_){m(this.buffer,h,_)}readUInt32LE(h){return l(this.buffer,h)}writeUInt32LE(h,_){d(this.buffer,h,_)}readUInt8(h){return E(this.buffer,h)}writeUInt8(h,_){w(this.buffer,h,_)}}e.VSBuffer=k;function i(c,h){return c[h+0]<<0>>>0|c[h+1]<<8>>>0}e.readUInt16LE=i;function C(c,h,_){c[_+0]=h&255,h=h>>>8,c[_+1]=h&255}e.writeUInt16LE=C;function f(c,h){return c[h]*2**24+c[h+1]*2**16+c[h+2]*2**8+c[h+3]}e.readUInt32BE=f;function m(c,h,_){c[_+3]=h,h=h>>>8,c[_+2]=h,h=h>>>8,c[_+1]=h,h=h>>>8,c[_]=h}e.writeUInt32BE=m;function l(c,h){return c[h+0]<<0>>>0|c[h+1]<<8>>>0|c[h+2]<<16>>>0|c[h+3]<<24>>>0}e.readUInt32LE=l;function d(c,h,_){c[_+0]=h&255,h=h>>>8,c[_+1]=h&255,h=h>>>8,c[_+2]=h&255,h=h>>>8,c[_+3]=h&255}e.writeUInt32LE=d;function E(c,h){return c[h]}e.readUInt8=E;function w(c,h,_){c[_]=h}e.writeUInt8=w;function S(c){return I.consumeReadable(c,h=>k.concat(h))}e.readableToBuffer=S;function g(c){return I.toReadable(c)}e.bufferToReadable=g;function a(c){return I.consumeStream(c,h=>k.concat(h))}e.streamToBuffer=a;async function v(c){return c.ended?k.concat(c.buffer):k.concat([...c.buffer,await a(c.stream)])}e.bufferedStreamToBuffer=v;function t(c){return I.toStream(c,h=>k.concat(h))}e.bufferToStream=t;function n(c){return I.transform(c,{data:h=>typeof h=="string"?k.fromString(h):k.wrap(h)},h=>k.concat(h))}e.streamToBufferReadableStream=n;function o(c){return I.newWriteableStream(h=>k.concat(h),c)}e.newWriteableBufferStream=o;function r(c,h){return I.prefixedReadable(c,h,_=>k.concat(_))}e.prefixedBufferReadable=r;function s(c,h){return I.prefixedStream(c,h,_=>k.concat(_))}e.prefixedBufferStream=s}),define(me[74],ge([0,1,9]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function I(w){return T(w,0)}e.hash=I;function T(w,S){switch(typeof w){case"object":return w===null?A(349,S):Array.isArray(w)?D(w,S):k(w,S);case"string":return P(w,S);case"boolean":return y(w,S);case"number":return A(w,S);case"undefined":return A(937,S);default:return A(617,S)}}e.doHash=T;function A(w,S){return(S<<5)-S+w|0}function y(w,S){return A(w?433:863,S)}function P(w,S){S=A(149417,S);for(let g=0,a=w.length;g<a;g++)S=A(w.charCodeAt(g),S);return S}e.stringHash=P;function D(w,S){return S=A(104579,S),w.reduce((g,a)=>T(a,g),S)}function k(w,S){return S=A(181387,S),Object.keys(w).sort().reduce((g,a)=>(g=P(a,g),T(w[a],g)),S)}class i{constructor(){this._value=0}get value(){return this._value}hash(S){return this._value=T(S,this._value),this._value}}e.Hasher=i;var C;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function f(w,S,g=32){const a=g-S,v=~((1<<a)-1);return(w<<S|(v&w)>>>a)>>>0}function m(w,S=0,g=w.byteLength,a=0){for(let v=0;v<g;v++)w[S+v]=a}function l(w,S,g="0"){for(;w.length<S;)w=g+w;return w}function d(w,S=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(g=>g.toString(16).padStart(2,"0")).join(""):l((w>>>0).toString(16),S/4)}e.toHexString=d;class E{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(S){const g=S.length;if(g!==0){const a=this._buff;let v=this._buffLen,t=this._leftoverHighSurrogate,n,o;for(t!==0?(n=t,o=-1,t=0):(n=S.charCodeAt(0),o=0);;){let r=n;if(b.isHighSurrogate(n))if(o+1<g){const s=S.charCodeAt(o+1);b.isLowSurrogate(s)?(o++,r=b.computeCodePoint(n,s)):r=65533}else{t=n;break}else b.isLowSurrogate(n)&&(r=65533);if(v=this._push(a,v,r),o++,o<g)n=S.charCodeAt(o);else break}this._buffLen=v,this._leftoverHighSurrogate=t}}_push(S,g,a){return a<128?S[g++]=a:a<2048?(S[g++]=192|(a&1984)>>>6,S[g++]=128|(a&63)>>>0):a<65536?(S[g++]=224|(a&61440)>>>12,S[g++]=128|(a&4032)>>>6,S[g++]=128|(a&63)>>>0):(S[g++]=240|(a&1835008)>>>18,S[g++]=128|(a&258048)>>>12,S[g++]=128|(a&4032)>>>6,S[g++]=128|(a&63)>>>0),g>=64&&(this._step(),g-=64,this._totalLen+=64,S[0]=S[64+0],S[1]=S[64+1],S[2]=S[64+2]),g}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),d(this._h0)+d(this._h1)+d(this._h2)+d(this._h3)+d(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const S=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(S/4294967296),!1),this._buffDV.setUint32(60,S%4294967296,!1),this._step()}_step(){const S=E._bigBlock32,g=this._buffDV;for(let h=0;h<64;h+=4)S.setUint32(h,g.getUint32(h,!1),!1);for(let h=64;h<320;h+=4)S.setUint32(h,f(S.getUint32(h-12,!1)^S.getUint32(h-32,!1)^S.getUint32(h-56,!1)^S.getUint32(h-64,!1),1),!1);let a=this._h0,v=this._h1,t=this._h2,n=this._h3,o=this._h4,r,s,c;for(let h=0;h<80;h++)h<20?(r=v&t|~v&n,s=1518500249):h<40?(r=v^t^n,s=1859775393):h<60?(r=v&t|v&n|t&n,s=2400959708):(r=v^t^n,s=3395469782),c=f(a,5)+r+o+s+S.getUint32(h*4,!1)&4294967295,o=n,n=t,t=f(v,30),v=a,a=c;this._h0=this._h0+a&4294967295,this._h1=this._h1+v&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+o&4294967295}}e.StringSHA1=E,E._bigBlock32=new DataView(new ArrayBuffer(320))}),define(me[58],ge([0,1,9]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var I;(function(T){T[T.Ignore=0]="Ignore",T[T.Info=1]="Info",T[T.Warning=2]="Warning",T[T.Error=3]="Error"})(I||(I={})),function(T){const A="error",y="warning",P="warn",D="info",k="ignore";function i(f){return f?b.equalsIgnoreCase(A,f)?T.Error:b.equalsIgnoreCase(y,f)||b.equalsIgnoreCase(P,f)?T.Warning:b.equalsIgnoreCase(D,f)?T.Info:T.Ignore:T.Ignore}T.fromValue=i;function C(f){switch(f){case T.Error:return A;case T.Warning:return y;case T.Info:return D;default:return k}}T.toString=C}(I||(I={})),e.default=I}),define(me[11],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function b(h){return Array.isArray(h)}e.isArray=b;function I(h){return typeof h=="string"}e.isString=I;function T(h){return Array.isArray(h)&&h.every(_=>I(_))}e.isStringArray=T;function A(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}e.isObject=A;function y(h){return typeof h=="number"&&!isNaN(h)}e.isNumber=y;function P(h){return!!h&&typeof h[Symbol.iterator]=="function"}e.isIterable=P;function D(h){return h===!0||h===!1}e.isBoolean=D;function k(h){return typeof h=="undefined"}e.isUndefined=k;function i(h){return!C(h)}e.isDefined=i;function C(h){return k(h)||h===null}e.isUndefinedOrNull=C;function f(h,_){if(!h)throw new Error(_?`Unexpected type, expected '${_}'`:"Unexpected type")}e.assertType=f;function m(h){if(C(h))throw new Error("Assertion Failed: argument is undefined or null");return h}e.assertIsDefined=m;function l(...h){const _=[];for(let u=0;u<h.length;u++){const p=h[u];if(C(p))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);_.push(p)}return _}e.assertAllDefined=l;const d=Object.prototype.hasOwnProperty;function E(h){if(!A(h))return!1;for(let _ in h)if(d.call(h,_))return!1;return!0}e.isEmptyObject=E;function w(h){return typeof h=="function"}e.isFunction=w;function S(...h){return h.length>0&&h.every(w)}e.areFunctions=S;function g(h,_){const u=Math.min(h.length,_.length);for(let p=0;p<u;p++)a(h[p],_[p])}e.validateConstraints=g;function a(h,_){if(I(_)){if(typeof h!==_)throw new Error(`argument does not match constraint: typeof ${_}`)}else if(w(_)){try{if(h instanceof _)return}catch(u){}if(!C(h)&&h.constructor===_||_.length===1&&_.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function v(h){let _=[],u=Object.getPrototypeOf(h);for(;Object.prototype!==u;)_=_.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return _}e.getAllPropertyNames=v;function t(h){const _=[];for(const u of v(h))typeof h[u]=="function"&&_.push(u);return _}e.getAllMethodNames=t;function n(h,_){const u=R=>function(){const O=Array.prototype.slice.call(arguments,0);return _(R,O)};let p={};for(const R of h)p[R]=u(R);return p}e.createProxyObject=n;function o(h){return h===null?void 0:h}e.withNullAsUndefined=o;function r(h){return typeof h=="undefined"?null:h}e.withUndefinedAsNull=r;function s(h){return class{constructor(){return new Proxy({},{get(_,u){if(_[u])return _[u];throw new Error(`Not Implemented: ${h}->${String(u)}`)}})}}}e.NotImplementedProxy=s;function c(h){throw new Error("Unreachable")}e.assertNever=c}),define(me[29],ge([0,1,10,9,8,11]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function y(n){return n===47||n===92}e.isPathSeparator=y;function P(n){return n.replace(/[\\/]/g,T.posix.sep)}e.toSlashes=P;function D(n,o=T.posix.sep){if(!n)return"";const r=n.length,s=n.charCodeAt(0);if(y(s)){if(y(n.charCodeAt(1))&&!y(n.charCodeAt(2))){let h=3;const _=h;for(;h<r&&!y(n.charCodeAt(h));h++);if(_!==h&&!y(n.charCodeAt(h+1))){for(h+=1;h<r;h++)if(y(n.charCodeAt(h)))return n.slice(0,h+1).replace(/[\\/]/g,o)}}return o}else if(E(s)&&n.charCodeAt(1)===58)return y(n.charCodeAt(2))?n.slice(0,2)+o:n.slice(0,2);let c=n.indexOf("://");if(c!==-1){for(c+=3;c<r;c++)if(y(n.charCodeAt(c)))return n.slice(0,c+1)}return""}e.getRoot=D;function k(n){if(!b.isWindows||!n||n.length<5)return!1;let o=n.charCodeAt(0);if(o!==92||(o=n.charCodeAt(1),o!==92))return!1;let r=2;const s=r;for(;r<n.length&&(o=n.charCodeAt(r),o!==92);r++);return!(s===r||(o=n.charCodeAt(r+1),isNaN(o)||o===92))}e.isUNC=k;const i=/[\\/:\*\?"<>\|]/g,C=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(n,o=b.isWindows){const r=o?i:C;return!(!n||n.length===0||/^\s+$/.test(n)||(r.lastIndex=0,r.test(n))||o&&f.test(n)||n==="."||n===".."||o&&n[n.length-1]==="."||o&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=m;function l(n,o,r){const s=n===o;return!r||s?s:!n||!o?!1:(0,I.equalsIgnoreCase)(n,o)}e.isEqual=l;function d(n,o,r,s=T.sep){if(n===o)return!0;if(!n||!o||o.length>n.length)return!1;if(r){if(!(0,I.startsWithIgnoreCase)(n,o))return!1;if(o.length===n.length)return!0;let h=o.length;return o.charAt(o.length-1)===s&&h--,n.charAt(h)===s}return o.charAt(o.length-1)!==s&&(o+=s),n.indexOf(o)===0}e.isEqualOrParent=d;function E(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=E;function w(n,o){return b.isWindows&&n.endsWith(":")&&(n+=T.sep),(0,T.isAbsolute)(n)||(n=(0,T.join)(o,n)),n=(0,T.normalize)(n),b.isWindows?(n=(0,I.rtrim)(n,T.sep),n.endsWith(":")&&(n+=T.sep)):(n=(0,I.rtrim)(n,T.sep),n||(n=T.sep)),n}e.sanitizeFilePath=w;function S(n){const o=(0,T.normalize)(n);return b.isWindows?n.length>3?!1:g(o)&&(n.length===2||o.charCodeAt(2)===92):o===T.posix.sep}e.isRootOrDriveLetter=S;function g(n){return b.isWindows?E(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=g;function a(n){return g(n)?n[0]:void 0}e.getDriveLetter=a;function v(n,o,r){return o.length>n.length?-1:n===o?0:(r&&(n=n.toLowerCase(),o=o.toLowerCase()),n.indexOf(o))}e.indexOfPath=v;function t(n){const o=n.split(":");let r,s,c;if(o.forEach(h=>{const _=Number(h);(0,A.isNumber)(_)?s===void 0?s=_:c===void 0&&(c=_):r=r?[r,h].join(":"):h}),!r)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:r,line:s!==void 0?s:void 0,column:c!==void 0?c:s!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(me[24],ge([0,1,11]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function I(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const E=Array.isArray(d)?[]:{};return Object.keys(d).forEach(w=>{d[w]&&typeof d[w]=="object"?E[w]=I(d[w]):E[w]=d[w]}),E}e.deepClone=I;function T(d){if(!d||typeof d!="object")return d;const E=[d];for(;E.length>0;){const w=E.shift();Object.freeze(w);for(const S in w)if(A.call(w,S)){const g=w[S];typeof g=="object"&&!Object.isFrozen(g)&&E.push(g)}}return d}e.deepFreeze=T;const A=Object.prototype.hasOwnProperty;function y(d,E){return P(d,E,new Set)}e.cloneAndChange=y;function P(d,E,w){if((0,b.isUndefinedOrNull)(d))return d;const S=E(d);if(typeof S!="undefined")return S;if((0,b.isArray)(d)){const g=[];for(const a of d)g.push(P(a,E,w));return g}if((0,b.isObject)(d)){if(w.has(d))throw new Error("Cannot clone recursive data-structure");w.add(d);const g={};for(let a in d)A.call(d,a)&&(g[a]=P(d[a],E,w));return w.delete(d),g}return d}function D(d,E,w=!0){return(0,b.isObject)(d)?((0,b.isObject)(E)&&Object.keys(E).forEach(S=>{S in d?w&&((0,b.isObject)(d[S])&&(0,b.isObject)(E[S])?D(d[S],E[S],w):d[S]=E[S]):d[S]=E[S]}),d):E}e.mixin=D;function k(d,E){if(d===E)return!0;if(d==null||E===null||E===void 0||typeof d!=typeof E||typeof d!="object"||Array.isArray(d)!==Array.isArray(E))return!1;let w,S;if(Array.isArray(d)){if(d.length!==E.length)return!1;for(w=0;w<d.length;w++)if(!k(d[w],E[w]))return!1}else{const g=[];for(S in d)g.push(S);g.sort();const a=[];for(S in E)a.push(S);if(a.sort(),!k(g,a))return!1;for(w=0;w<g.length;w++)if(!k(d[g[w]],E[g[w]]))return!1}return!0}e.equals=k;function i(d){const E=new Set;return JSON.stringify(d,(w,S)=>{if((0,b.isObject)(S)||Array.isArray(S)){if(E.has(S))return"[Circular]";E.add(S)}return S})}e.safeStringify=i;function C(d,E,w){const S=E(d);return typeof S=="undefined"?w:S}e.getOrDefault=C;function f(d,E){const w=Object.create(null);return!d||!E||Object.keys(E).forEach(g=>{const a=d[g],v=E[g];k(a,v)||(w[g]=v)}),w}e.distinct=f;function m(d,E){const w=E.toLowerCase(),S=Object.keys(d).find(g=>g.toLowerCase()===w);return S?d[S]:d[E]}e.getCaseInsensitive=m;function l(d,E){const w=Object.create(null);for(const S of Object.keys(d))E(S,d[S])&&(w[S]=d[S]);return w}e.filter=l}),define(me[97],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var b;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(b=e.Constants||(e.Constants={}));function I(A){return A<0?0:A>255?255:A|0}e.toUint8=I;function T(A){return A<0?0:A>4294967295?4294967295:A|0}e.toUint32=T}),define(me[2],ge([0,1,10,8]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const T=/^\w[\w\d+.-]*$/,A=/^\//,y=/^\/\//;function P(o,r){if(!o.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!T.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!A.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function D(o,r){return!o&&!r?"file":o}function k(o,r){switch(o){case"https":case"http":case"file":r?r[0]!==C&&(r=C+r):r=C;break}return r}const i="",C="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(r,s,c,h,_,u=!1){typeof r=="object"?(this.scheme=r.scheme||i,this.authority=r.authority||i,this.path=r.path||i,this.query=r.query||i,this.fragment=r.fragment||i):(this.scheme=D(r,u),this.authority=s||i,this.path=k(this.scheme,c||i),this.query=h||i,this.fragment=_||i,P(this,u))}static isUri(r){return r instanceof m?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return g(this,!1)}with(r){if(!r)return this;let{scheme:s,authority:c,path:h,query:_,fragment:u}=r;return s===void 0?s=this.scheme:s===null&&(s=i),c===void 0?c=this.authority:c===null&&(c=i),h===void 0?h=this.path:h===null&&(h=i),_===void 0?_=this.query:_===null&&(_=i),u===void 0?u=this.fragment:u===null&&(u=i),s===this.scheme&&c===this.authority&&h===this.path&&_===this.query&&u===this.fragment?this:new d(s,c,h,_,u)}static parse(r,s=!1){const c=f.exec(r);return c?new d(c[2]||i,n(c[4]||i),n(c[5]||i),n(c[7]||i),n(c[9]||i),s):new d(i,i,i,i,i)}static file(r){let s=i;if(b.isWindows&&(r=r.replace(/\\/g,C)),r[0]===C&&r[1]===C){const c=r.indexOf(C,2);c===-1?(s=r.substring(2),r=C):(s=r.substring(2,c),r=r.substring(c)||C)}return new d("file",s,r,i,i)}static from(r){return new d(r.scheme,r.authority,r.path,r.query,r.fragment)}static joinPath(r,...s){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return b.isWindows&&r.scheme==="file"?c=m.file(I.win32.join(g(r,!0),...s)).path:c=I.posix.join(r.path,...s),r.with({path:c})}toString(r=!1){return a(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof m)return r;{const s=new d(r);return s._formatted=r.external,s._fsPath=r._sep===l?r.fsPath:null,s}}else return r}}e.URI=m;const l=b.isWindows?1:void 0;class d extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(r=!1){return r?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=l),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const E={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(o,r){let s,c=-1;for(let h=0;h<o.length;h++){const _=o.charCodeAt(h);if(_>=97&&_<=122||_>=65&&_<=90||_>=48&&_<=57||_===45||_===46||_===95||_===126||r&&_===47)c!==-1&&(s+=encodeURIComponent(o.substring(c,h)),c=-1),s!==void 0&&(s+=o.charAt(h));else{s===void 0&&(s=o.substr(0,h));const u=E[_];u!==void 0?(c!==-1&&(s+=encodeURIComponent(o.substring(c,h)),c=-1),s+=u):c===-1&&(c=h)}}return c!==-1&&(s+=encodeURIComponent(o.substring(c))),s!==void 0?s:o}function S(o){let r;for(let s=0;s<o.length;s++){const c=o.charCodeAt(s);c===35||c===63?(r===void 0&&(r=o.substr(0,s)),r+=E[c]):r!==void 0&&(r+=o[s])}return r!==void 0?r:o}function g(o,r){let s;return o.authority&&o.path.length>1&&o.scheme==="file"?s=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?r?s=o.path.substr(1):s=o.path[1].toLowerCase()+o.path.substr(2):s=o.path,b.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=g;function a(o,r){const s=r?S:w;let c="",{scheme:h,authority:_,path:u,query:p,fragment:R}=o;if(h&&(c+=h,c+=":"),(_||h==="file")&&(c+=C,c+=C),_){let O=_.indexOf("@");if(O!==-1){const j=_.substr(0,O);_=_.substr(O+1),O=j.indexOf(":"),O===-1?c+=s(j,!1):(c+=s(j.substr(0,O),!1),c+=":",c+=s(j.substr(O+1),!1)),c+="@"}_=_.toLowerCase(),O=_.indexOf(":"),O===-1?c+=s(_,!1):(c+=s(_.substr(0,O),!1),c+=_.substr(O))}if(u){if(u.length>=3&&u.charCodeAt(0)===47&&u.charCodeAt(2)===58){const O=u.charCodeAt(1);O>=65&&O<=90&&(u=`/${String.fromCharCode(O+32)}:${u.substr(3)}`)}else if(u.length>=2&&u.charCodeAt(1)===58){const O=u.charCodeAt(0);O>=65&&O<=90&&(u=`${String.fromCharCode(O+32)}:${u.substr(2)}`)}c+=s(u,!0)}return p&&(c+="?",c+=s(p,!1)),R&&(c+="#",c+=r?R:w(R,!1)),c}function v(o){try{return decodeURIComponent(o)}catch(r){return o.length>3?o.substr(0,3)+v(o.substr(3)):o}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(o){return o.match(t)?o.replace(t,r=>v(r)):o}});var it=this&&this.__classPrivateFieldSet||function(G,e,b,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,b):T?T.value=b:e.set(G,b),b},We=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)};define(me[22],ge([0,1,2,9]),function(G,e,b,I){"use strict";var T,A,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(t,n,o){let r=t.get(n);return r===void 0&&(r=o,t.set(n,r)),r}e.getOrSet=P;function D(t){const n=[];return t.forEach((o,r)=>{n.push(`${r} => ${o}`)}),`Map(${t.size}) {${n.join(", ")}}`}e.mapToString=D;function k(t){const n=[];return t.forEach(o=>{n.push(o)}),`Set(${t.size}) {${n.join(", ")}}`}e.setToString=k;class i{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const o=n.charCodeAt(0),r=this._value.charCodeAt(this._pos);return o-r}value(){return this._value[this._pos]}}e.StringIterator=i;class C{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,I.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class f{constructor(n=!0,o=!0){this._splitOnBackslash=n,this._caseSensitive=o}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,I.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=f;var m;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(m||(m={}));class l{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new f(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,I.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,I.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,I.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,I.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=l;class d{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class E{constructor(n){this._iter=n}static forUris(n=()=>!1){return new E(new l(n))}static forPaths(){return new E(new f)}static forStrings(){return new E(new i)}static forConfigKeys(){return new E(new C)}clear(){this._root=void 0}set(n,o){const r=this._iter.reset(n);let s;for(this._root||(this._root=new d,this._root.segment=r.value()),s=this._root;;){const h=r.cmp(s.segment);if(h>0)s.left||(s.left=new d,s.left.segment=r.value()),s=s.left;else if(h<0)s.right||(s.right=new d,s.right.segment=r.value()),s=s.right;else if(r.hasNext())r.next(),s.mid||(s.mid=new d,s.mid.segment=r.value()),s=s.mid;else break}const c=s.value;return s.value=o,s.key=n,c}get(n){var o;return(o=this._getNode(n))===null||o===void 0?void 0:o.value}_getNode(n){const o=this._iter.reset(n);let r=this._root;for(;r;){const s=o.cmp(r.segment);if(s>0)r=r.left;else if(s<0)r=r.right;else if(o.hasNext())o.next(),r=r.mid;else break}return r}has(n){const o=this._getNode(n);return!((o==null?void 0:o.value)===void 0&&(o==null?void 0:o.mid)===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,o){const r=this._iter.reset(n),s=[];let c=this._root;for(;c;){const h=r.cmp(c.segment);if(h>0)s.push([1,c]),c=c.left;else if(h<0)s.push([-1,c]),c=c.right;else if(r.hasNext())r.next(),s.push([0,c]),c=c.mid;else{for(o?(c.left=void 0,c.mid=void 0,c.right=void 0):c.value=void 0;s.length>0&&c.isEmpty();){let[_,u]=s.pop();switch(_){case 1:u.left=void 0;break;case 0:u.mid=void 0;break;case-1:u.right=void 0;break}c=u}break}}}findSubstr(n){const o=this._iter.reset(n);let r=this._root,s;for(;r;){const c=o.cmp(r.segment);if(c>0)r=r.left;else if(c<0)r=r.right;else if(o.hasNext())o.next(),s=r.value||s,r=r.mid;else break}return r&&r.value||s}findSuperstr(n){const o=this._iter.reset(n);let r=this._root;for(;r;){const s=o.cmp(r.segment);if(s>0)r=r.left;else if(s<0)r=r.right;else if(o.hasNext())o.next(),r=r.mid;else return r.mid?this._entries(r.mid):void 0}}forEach(n){for(const[o,r]of this)n(r,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){n&&(yield*this._entries(n.left),n.value&&(yield[n.key,n.value]),yield*this._entries(n.mid),yield*this._entries(n.right))}}e.TernarySearchTree=E;class w{constructor(n,o){this[T]="ResourceMap",n instanceof w?(this.map=new Map(n.map),this.toKey=o!=null?o:w.defaultToKey):(this.map=new Map,this.toKey=n!=null?n:w.defaultToKey)}set(n,o){return this.map.set(this.toKey(n),o),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,o){typeof o!="undefined"&&(n=n.bind(o));for(let[r,s]of this.map)n(s,b.URI.parse(r),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield b.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[b.URI.parse(n[0]),n[1]]}*[(T=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[b.URI.parse(n[0]),n[1]]}}e.ResourceMap=w,w.defaultToKey=t=>t.toString();var S;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(S=e.Touch||(e.Touch={}));class g{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var n;return(n=this._head)===null||n===void 0?void 0:n.value}get last(){var n;return(n=this._tail)===null||n===void 0?void 0:n.value}has(n){return this._map.has(n)}get(n,o=0){const r=this._map.get(n);if(!!r)return o!==0&&this.touch(r,o),r.value}set(n,o,r=0){let s=this._map.get(n);if(s)s.value=o,r!==0&&this.touch(s,r);else{switch(s={key:n,value:o,next:void 0,previous:void 0},r){case 0:this.addItemLast(s);break;case 1:this.addItemFirst(s);break;case 2:this.addItemLast(s);break;default:this.addItemLast(s);break}this._map.set(n,s),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const o=this._map.get(n);if(!!o)return this._map.delete(n),this.removeItem(o),this._size--,o.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}}forEach(n,o){const r=this._state;let s=this._head;for(;s;){if(o?n.bind(o)(s.value,s.key,this):n(s.value,s.key,this),this._state!==r)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const n=this,o=this._state;let r=this._head;const s={[Symbol.iterator](){return s},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(r){const c={value:r.key,done:!1};return r=r.next,c}else return{value:void 0,done:!0}}};return s}values(){const n=this,o=this._state;let r=this._head;const s={[Symbol.iterator](){return s},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(r){const c={value:r.value,done:!1};return r=r.next,c}else return{value:void 0,done:!0}}};return s}entries(){const n=this,o=this._state;let r=this._head;const s={[Symbol.iterator](){return s},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(r){const c={value:[r.key,r.value],done:!1};return r=r.next,c}else return{value:void 0,done:!0}}};return s}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(!(n>=this.size)){if(n===0){this.clear();return}let o=this._head,r=this.size;for(;o&&r>n;)this._map.delete(o.key),o=o.next,r--;this._head=o,this._size=r,o&&(o.previous=void 0),this._state++}}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const o=n.next,r=n.previous;if(!o||!r)throw new Error("Invalid list");o.previous=r,r.next=o}n.next=void 0,n.previous=void 0,this._state++}touch(n,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(n===this._head)return;const r=n.next,s=n.previous;n===this._tail?(s.next=void 0,this._tail=s):(r.previous=s,s.next=r),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(o===2){if(n===this._tail)return;const r=n.next,s=n.previous;n===this._head?(r.previous=void 0,this._head=r):(r.previous=s,s.next=r),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((o,r)=>{n.push([r,o])}),n}fromJSON(n){this.clear();for(const[o,r]of n)this.set(o,r)}}e.LinkedMap=g;class a extends g{constructor(n,o=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,o=2){return super.get(n,o)}peek(n){return super.get(n,0)}set(n,o){return super.set(n,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class v{constructor(n){y.set(this,void 0),it(this,y,n,"f")}get size(){return We(this,y,"f").size}forEach(n,o){We(this,y,"f").forEach(n,o)}get(n){return We(this,y,"f").get(n)}has(n){return We(this,y,"f").has(n)}entries(){return We(this,y,"f").entries()}keys(){return We(this,y,"f").keys()}values(){return We(this,y,"f").values()}[(y=new WeakMap,Symbol.iterator)](){return We(this,y,"f").entries()}}e.ReadonlyMapView=v}),define(me[98],ge([0,1,22,9]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function T(...pe){return function(Ce,Me){for(let ze=0,_e=pe.length;ze<_e;ze++){const Ke=pe[ze](Ce,Me);if(Ke)return Ke}return null}}e.or=T,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(pe,Ce,Me){if(!Me||Me.length<Ce.length)return null;let ze;return pe?ze=I.startsWithIgnoreCase(Me,Ce):ze=Me.indexOf(Ce)===0,ze?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function y(pe,Ce){const Me=Ce.toLowerCase().indexOf(pe.toLowerCase());return Me===-1?null:[{start:Me,end:Me+pe.length}]}e.matchesContiguousSubString=y;function P(pe,Ce){return D(pe.toLowerCase(),Ce.toLowerCase(),0,0)}e.matchesSubString=P;function D(pe,Ce,Me,ze){if(Me===pe.length)return[];if(ze===Ce.length)return null;if(pe[Me]===Ce[ze]){let _e=null;return(_e=D(pe,Ce,Me+1,ze+1))?w({start:ze,end:ze+1},_e):null}return D(pe,Ce,Me,ze+1)}function k(pe){return 97<=pe&&pe<=122}function i(pe){return 65<=pe&&pe<=90}e.isUpper=i;function C(pe){return 48<=pe&&pe<=57}function f(pe){return pe===32||pe===9||pe===10||pe===13}const m=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(pe=>m.add(pe.charCodeAt(0)));function l(pe){return f(pe)||m.has(pe)}function d(pe,Ce){return pe===Ce||l(pe)&&l(Ce)}function E(pe){return k(pe)||i(pe)||C(pe)}function w(pe,Ce){return Ce.length===0?Ce=[pe]:pe.end===Ce[0].start?Ce[0].start=pe.start:Ce.unshift(pe),Ce}function S(pe,Ce){for(let Me=Ce;Me<pe.length;Me++){const ze=pe.charCodeAt(Me);if(i(ze)||C(ze)||Me>0&&!E(pe.charCodeAt(Me-1)))return Me}return pe.length}function g(pe,Ce,Me,ze){if(Me===pe.length)return[];if(ze===Ce.length)return null;if(pe[Me]!==Ce[ze].toLowerCase())return null;{let _e=null,Ke=ze+1;for(_e=g(pe,Ce,Me+1,ze+1);!_e&&(Ke=S(Ce,Ke))<Ce.length;)_e=g(pe,Ce,Me+1,Ke),Ke++;return _e===null?null:w({start:ze,end:ze+1},_e)}}function a(pe){let Ce=0,Me=0,ze=0,_e=0,Ke=0;for(let je=0;je<pe.length;je++)Ke=pe.charCodeAt(je),i(Ke)&&Ce++,k(Ke)&&Me++,E(Ke)&&ze++,C(Ke)&&_e++;const X=Ce/pe.length,ne=Me/pe.length,we=ze/pe.length,xe=_e/pe.length;return{upperPercent:X,lowerPercent:ne,alphaPercent:we,numericPercent:xe}}function v(pe){const{upperPercent:Ce,lowerPercent:Me}=pe;return Me===0&&Ce>.6}function t(pe){const{upperPercent:Ce,lowerPercent:Me,alphaPercent:ze,numericPercent:_e}=pe;return Me>.2&&Ce<.8&&ze>.6&&_e<.2}function n(pe){let Ce=0,Me=0,ze=0,_e=0;for(let Ke=0;Ke<pe.length;Ke++)ze=pe.charCodeAt(Ke),i(ze)&&Ce++,k(ze)&&Me++,f(ze)&&_e++;return(Ce===0||Me===0)&&_e===0?pe.length<=30:Ce<=5}function o(pe,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!n(pe)||Ce.length>60)return null;const Me=a(Ce);if(!t(Me)){if(!v(Me))return null;Ce=Ce.toLowerCase()}let ze=null,_e=0;for(pe=pe.toLowerCase();_e<Ce.length&&(ze=g(pe,Ce,0,_e))===null;)_e=S(Ce,_e+1);return ze}e.matchesCamelCase=o;function r(pe,Ce,Me=!1){if(!Ce||Ce.length===0)return null;let ze=null,_e=0;for(pe=pe.toLowerCase(),Ce=Ce.toLowerCase();_e<Ce.length&&(ze=s(pe,Ce,0,_e,Me))===null;)_e=c(Ce,_e+1);return ze}e.matchesWords=r;function s(pe,Ce,Me,ze,_e){if(Me===pe.length)return[];if(ze===Ce.length)return null;if(d(pe.charCodeAt(Me),Ce.charCodeAt(ze))){let Ke=null,X=ze+1;if(Ke=s(pe,Ce,Me+1,ze+1,_e),!_e)for(;!Ke&&(X=c(Ce,X))<Ce.length;)Ke=s(pe,Ce,Me+1,X,_e),X++;return Ke===null?null:w({start:ze,end:ze+1},Ke)}else return null}function c(pe,Ce){for(let Me=Ce;Me<pe.length;Me++)if(l(pe.charCodeAt(Me))||Me>0&&l(pe.charCodeAt(Me-1)))return Me;return pe.length}const h=T(e.matchesPrefix,o,y),_=T(e.matchesPrefix,o,P),u=new b.LRUCache(1e4);function p(pe,Ce,Me=!1){if(typeof pe!="string"||typeof Ce!="string")return null;let ze=u.get(pe);ze||(ze=new RegExp(I.convertSimple2RegExpPattern(pe),"i"),u.set(pe,ze));const _e=ze.exec(Ce);return _e?[{start:_e.index,end:_e.index+_e[0].length}]:Me?_(pe,Ce):h(pe,Ce)}e.matchesFuzzy=p;function R(pe,Ce){const Me=z(pe,pe.toLowerCase(),0,Ce,Ce.toLowerCase(),0,!0);return Me?j(Me):null}e.matchesFuzzy2=R;function O(pe,Ce,Me,ze,_e,Ke){const X=Math.min(13,pe.length);for(;Me<X;Me++){const ne=z(pe,Ce,Me,ze,_e,Ke,!1);if(ne)return ne}return[0,Ke]}e.anyScore=O;function j(pe){if(typeof pe=="undefined")return[];const Ce=[],Me=pe[1];for(let ze=pe.length-1;ze>1;ze--){const _e=pe[ze]+Me,Ke=Ce[Ce.length-1];Ke&&Ke.end===_e?Ke.end=_e+1:Ce.push({start:_e,end:_e+1})}return Ce}e.createMatches=j;const ie=128;function K(){const pe=[],Ce=[];for(let Me=0;Me<=ie;Me++)Ce[Me]=0;for(let Me=0;Me<=ie;Me++)pe.push(Ce.slice(0));return pe}function x(pe){const Ce=[];for(let Me=0;Me<=pe;Me++)Ce[Me]=0;return Ce}const $=x(2*ie),U=x(2*ie),L=K(),N=K(),M=K(),F=!1;function W(pe,Ce,Me,ze,_e){function Ke(ne,we,xe=" "){for(;ne.length<we;)ne=xe+ne;return ne}let X=` |   |${ze.split("").map(ne=>Ke(ne,3)).join("|")}
`;for(let ne=0;ne<=Me;ne++)ne===0?X+=" |":X+=`${Ce[ne-1]}|`,X+=pe[ne].slice(0,_e+1).map(we=>Ke(we.toString(),3)).join("|")+`
`;return X}function q(pe,Ce,Me,ze){pe=pe.substr(Ce),Me=Me.substr(ze),console.log(W(N,pe,pe.length,Me,Me.length)),console.log(W(M,pe,pe.length,Me,Me.length)),console.log(W(L,pe,pe.length,Me,Me.length))}function Q(pe,Ce){if(Ce<0||Ce>=pe.length)return!1;const Me=pe.codePointAt(Ce);switch(Me){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!I.isEmojiImprecise(Me)}}function le(pe,Ce){if(Ce<0||Ce>=pe.length)return!1;switch(pe.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function ve(pe,Ce,Me){return Ce[pe]!==Me[pe]}function Re(pe,Ce,Me,ze,_e,Ke,X=!1){for(;Ce<Me&&_e<Ke;)pe[Ce]===ze[_e]&&(X&&($[Ce]=_e),Ce+=1),_e+=1;return Ce===Me}e.isPatternInWord=Re;var Se;(function(pe){pe[pe.Diag=1]="Diag",pe[pe.Left=2]="Left",pe[pe.LeftLeft=3]="LeftLeft"})(Se||(Se={}));var Oe;(function(pe){pe.Default=[-100,0];function Ce(Me){return!Me||Me.length===2&&Me[0]===-100&&Me[1]===0}pe.isDefault=Ce})(Oe=e.FuzzyScore||(e.FuzzyScore={}));function z(pe,Ce,Me,ze,_e,Ke,X){const ne=pe.length>ie?ie:pe.length,we=ze.length>ie?ie:ze.length;if(!(Me>=ne||Ke>=we||ne-Me>we-Ke)&&!!Re(Ce,Me,ne,_e,Ke,we,!0)){Y(ne,we,Me,Ke,Ce,_e);let xe=1,je=1,Ve=Me,Ze=Ke;const De=[!1];for(xe=1,Ve=Me;Ve<ne;xe++,Ve++){const H=$[Ve],Z=U[Ve],ce=Ve+1<ne?U[Ve+1]:we;for(je=H-Ke+1,Ze=H;Ze<ce;je++,Ze++){let Ie=Number.MIN_SAFE_INTEGER,Ae=!1;Ze<=Z&&(Ie=ee(pe,Ce,Ve,Me,ze,_e,Ze,we,Ke,L[xe-1][je-1]===0,De));let Le=0;Ie!==Number.MAX_SAFE_INTEGER&&(Ae=!0,Le=Ie+N[xe-1][je-1]);const $e=Ze>H,Xe=$e?N[xe][je-1]+(L[xe][je-1]>0?-5:0):0,rt=Ze>H+1&&L[xe][je-1]>0,tt=rt?N[xe][je-2]+(L[xe][je-2]>0?-5:0):0;if(rt&&(!$e||tt>=Xe)&&(!Ae||tt>=Le))N[xe][je]=tt,M[xe][je]=3,L[xe][je]=0;else if($e&&(!Ae||Xe>=Le))N[xe][je]=Xe,M[xe][je]=2,L[xe][je]=0;else if(Ae)N[xe][je]=Le,M[xe][je]=1,L[xe][je]=L[xe-1][je-1]+1;else throw new Error("not possible")}}if(F&&q(pe,Me,ze,Ke),!(!De[0]&&!X)){xe--,je--;const ye=[N[xe][je],Ke];let Pe=0,oe=0;for(;xe>=1;){let H=je;do{const Z=M[xe][H];if(Z===3)H=H-2;else if(Z===2)H=H-1;else break}while(H>=1);Pe>1&&Ce[Me+xe-1]===_e[Ke+je-1]&&!ve(H+Ke-1,ze,_e)&&Pe+1>L[xe][H]&&(H=je),H===je?Pe++:Pe=1,oe||(oe=H),xe--,je=H-1,ye.push(je)}we===ne&&(ye[0]+=2);const ue=oe-ne;return ye[0]-=ue,ye}}}e.fuzzyScore=z;function Y(pe,Ce,Me,ze,_e,Ke){let X=pe-1,ne=Ce-1;for(;X>=Me&&ne>=ze;)_e[X]===Ke[ne]&&(U[X]=ne,X--),ne--}function ee(pe,Ce,Me,ze,_e,Ke,X,ne,we,xe,je){if(Ce[Me]!==Ke[X])return Number.MIN_SAFE_INTEGER;let Ve=1,Ze=!1;return X===Me-ze?Ve=pe[Me]===_e[X]?7:5:ve(X,_e,Ke)&&(X===0||!ve(X-1,_e,Ke))?(Ve=pe[Me]===_e[X]?7:5,Ze=!0):Q(Ke,X)&&(X===0||!Q(Ke,X-1))?Ve=5:(Q(Ke,X-1)||le(Ke,X-1))&&(Ve=5,Ze=!0),Ve>1&&Me===ze&&(je[0]=!0),Ze||(Ze=ve(X,_e,Ke)||Q(Ke,X-1)||le(Ke,X-1)),Me===ze?X>we&&(Ve-=Ze?3:5):xe?Ve+=Ze?2:0:Ve+=Ze?0:1,X+1===ne&&(Ve-=Ze?3:5),Ve}function se(pe,Ce,Me,ze,_e,Ke,X){return Ee(pe,Ce,Me,ze,_e,Ke,!0,X)}e.fuzzyScoreGracefulAggressive=se;function fe(pe,Ce,Me,ze,_e,Ke,X){return Ee(pe,Ce,Me,ze,_e,Ke,!1,X)}e.fuzzyScoreGraceful=fe;function Ee(pe,Ce,Me,ze,_e,Ke,X,ne){let we=z(pe,Ce,Me,ze,_e,Ke,ne);if(we&&!X)return we;if(pe.length>=3){const xe=Math.min(7,pe.length-1);for(let je=Me+1;je<xe;je++){const Ve=Be(pe,je);if(Ve){const Ze=z(Ve,Ve.toLowerCase(),Me,ze,_e,Ke,ne);Ze&&(Ze[0]-=3,(!we||Ze[0]>we[0])&&(we=Ze))}}}return we}function Be(pe,Ce){if(!(Ce+1>=pe.length)){const Me=pe[Ce],ze=pe[Ce+1];if(Me!==ze)return pe.slice(0,Ce)+ze+Me+pe.slice(Ce+2)}}}),define(me[136],ge([0,1,43,98,9]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${b.CSSIcon.iconNameExpression}(?:${b.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(`(\\\\)?${A.source}`,"g");function P(d){return d.replace(y,(E,w)=>w?E:`\\${E}`)}e.escapeIcons=P;const D=new RegExp(`\\\\${A.source}`,"g");function k(d){return d.replace(D,E=>`\\${E}`)}e.markdownEscapeEscapedIcons=k;const i=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function C(d){return d.indexOf(e.iconStartMarker)===-1?d:d.replace(i,(E,w,S,g)=>S?E:w||g||"")}e.stripIcons=C;function f(d){const E=d.indexOf(e.iconStartMarker);return E===-1?{text:d}:m(d,E)}e.parseLabelWithIcons=f;function m(d,E){const w=[];let S="";function g(c){if(c){S+=c;for(const h of c)w.push(t)}}let a=-1,v="",t=0,n,o,r=E;const s=d.length;for(g(d.substr(0,E));r<s;)n=d[r],o=d[r+1],n===e.iconStartMarker[0]&&o===e.iconStartMarker[1]?(a=r,g(v),v=e.iconStartMarker,r++):n===")"&&a!==-1?(t+=r-a+1,a=-1,v=""):a!==-1?/^[a-z0-9\-]$/i.test(n)?v+=n:(g(v),a=-1,v=""):g(n),r++;return g(v),{text:S,iconOffsets:w}}function l(d,E,w=!1){const{text:S,iconOffsets:g}=E;if(!g||g.length===0)return(0,I.matchesFuzzy)(d,S,w);const a=(0,T.ltrim)(S," "),v=S.length-a.length,t=(0,I.matchesFuzzy)(d,a,w);if(t)for(const n of t){const o=g[n.start+v]+v;n.start+=o,n.end+=o}return t}e.matchesFuzzyIconAware=l}),define(me[99],ge([0,1,17,136,16]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(d="",E=!1){var w,S;if(this.value=d,typeof this.value!="string")throw(0,T.illegalArgument)("value");typeof E=="boolean"?(this.isTrusted=E,this.supportThemeIcons=!1):(this.isTrusted=(w=E.isTrusted)!==null&&w!==void 0?w:void 0,this.supportThemeIcons=(S=E.supportThemeIcons)!==null&&S!==void 0?S:!1)}appendText(d,E=0){return this.value+=C(this.supportThemeIcons?(0,I.escapeIcons)(d):d).replace(/([ \t]+)/g,(w,S)=>"&nbsp;".repeat(S.length)).replace(/^>/gm,"\\>").replace(/\n/g,E===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,E){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=E,this.value+="\n```\n",this}}e.MarkdownString=y;function P(l){return D(l)?!l.value:Array.isArray(l)?l.every(P):!0}e.isEmptyMarkdownString=P;function D(l){return l instanceof y?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}e.isMarkdownString=D;function k(l,d){return!l&&!d?!0:!l||!d?!1:Array.isArray(l)&&Array.isArray(d)?(0,b.equals)(l,d,i):D(l)&&D(d)?i(l,d):!1}e.markedStringsEquals=k;function i(l,d){return l===d?!0:!l||!d?!1:l.value===d.value&&l.isTrusted===d.isTrusted&&l.supportThemeIcons===d.supportThemeIcons}function C(l){return l.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function f(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=f;function m(l){const d=[],E=l.split("|").map(S=>S.trim());l=E[0];const w=E[1];if(w){const S=/height=(\d+)/.exec(w),g=/width=(\d+)/.exec(w),a=S?S[1]:"",v=g?g[1]:"",t=isFinite(parseInt(v)),n=isFinite(parseInt(a));t&&d.push(`width="${v}"`),n&&d.push(`height="${a}"`)}return{href:l,dimensions:d}}e.parseHrefAndDimensions=m}),define(me[59],ge([0,1,23,9,2]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(k){return JSON.stringify(k,P)}e.stringify=A;function y(k){let i=JSON.parse(k);return i=D(i),i}e.parse=y;function P(k,i){return i instanceof RegExp?{$mid:2,source:i.source,flags:(0,I.regExpFlags)(i)}:i}function D(k,i=0){if(!k||i>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return T.URI.revive(k);case 2:return new RegExp(k.source,k.flags)}if(k instanceof b.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let C=0;C<k.length;++C)k[C]=D(k[C],i+1);else for(const C in k)Object.hasOwnProperty.call(k,C)&&(k[C]=D(k[C],i+1))}return k}e.revive=D}),define(me[12],ge([0,1,2,10]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var T;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp"})(T=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,k,i){this._hosts[D]=k,this._ports[D]=i}setConnectionToken(D,k){this._connectionTokens[D]=k}rewrite(D){if(this._delegate)return this._delegate(D);const k=D.authority;let i=this._hosts[k];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const C=this._ports[k],f=this._connectionTokens[k];let m=`path=${encodeURIComponent(D.path)}`;return typeof f=="string"&&(m+=`&tkn=${encodeURIComponent(f)}`),b.URI.from({scheme:I.isWeb?this._preferredWebSchema:T.vscodeRemoteResource,authority:`${i}:${C}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new A;class y{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(D,k,i){const C=this.toUri(D,k);return C.scheme===T.vscodeRemote?e.RemoteAuthorities.rewrite(C):I.isNative&&(i||I.isPreferringBrowserCodeLoad)&&C.scheme===T.file?C.with({scheme:T.vscodeFileResource,authority:C.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):C}asFileUri(D,k){const i=this.toUri(D,k);return i.scheme===T.vscodeFileResource?i.with({scheme:T.file,authority:i.authority!==this.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(D,k){return b.URI.isUri(D)?D:b.URI.parse(k.toUrl(D))}}e.FileAccess=new y}),define(me[75],ge([0,1,22]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const I=new b.LRUCache(1e4);function T(k){return D(k,"NFC",I)}e.normalizeNFC=T;const A=new b.LRUCache(1e4);function y(k){return D(k,"NFD",A)}e.normalizeNFD=y;const P=/[^\u0000-\u0080]/;function D(k,i,C){if(!e.canNormalize||!k)return k;const f=C.get(k);if(f)return f;let m;return P.test(k)?m=k.normalize(i):m=k,C.set(k,m),m}e.removeAccents=function(){if(e.canNormalize){const k=/[\u0300-\u036f]/g;return function(i){return y(i).replace(k,"")}}else return function(k){return k}}()}),define(me[25],ge([0,1,29,8,2,9,12,10]),function(G,e,b,I,T,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(m){return(0,T.uriToFsPath)(m,!0)}e.originalFSPath=D;class k{constructor(l){this._ignorePathCasing=l}compare(l,d,E=!1){return l===d?0:(0,A.compare)(this.getComparisonKey(l,E),this.getComparisonKey(d,E))}isEqual(l,d,E=!1){return l===d?!0:!l||!d?!1:this.getComparisonKey(l,E)===this.getComparisonKey(d,E)}getComparisonKey(l,d=!1){return l.with({path:this._ignorePathCasing(l)?l.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(l){return this._ignorePathCasing(l)}isEqualOrParent(l,d,E=!1){if(l.scheme===d.scheme){if(l.scheme===y.Schemas.file)return b.isEqualOrParent(D(l),D(d),this._ignorePathCasing(l))&&l.query===d.query&&(E||l.fragment===d.fragment);if((0,e.isEqualAuthority)(l.authority,d.authority))return b.isEqualOrParent(l.path,d.path,this._ignorePathCasing(l),"/")&&l.query===d.query&&(E||l.fragment===d.fragment)}return!1}joinPath(l,...d){return T.URI.joinPath(l,...d)}basenameOrAuthority(l){return(0,e.basename)(l)||l.authority}basename(l){return I.posix.basename(l.path)}extname(l){return I.posix.extname(l.path)}dirname(l){if(l.path.length===0)return l;let d;return l.scheme===y.Schemas.file?d=T.URI.file(I.dirname(D(l))).path:(d=I.posix.dirname(l.path),l.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${l.toString})) resulted in a relative path`),d="/")),l.with({path:d})}normalizePath(l){if(!l.path.length)return l;let d;return l.scheme===y.Schemas.file?d=T.URI.file(I.normalize(D(l))).path:d=I.posix.normalize(l.path),l.with({path:d})}relativePath(l,d){if(!(l.scheme!==d.scheme||!(0,e.isEqualAuthority)(l.authority,d.authority))){if(l.scheme===y.Schemas.file){const S=I.relative(D(l),D(d));return P.isWindows?b.toSlashes(S):S}let E=l.path||"/",w=d.path||"/";if(this._ignorePathCasing(l)){let S=0;for(const g=Math.min(E.length,w.length);S<g&&!(E.charCodeAt(S)!==w.charCodeAt(S)&&E.charAt(S).toLowerCase()!==w.charAt(S).toLowerCase());S++);E=w.substr(0,S)+E.substr(S)}return I.posix.relative(E,w)}}resolvePath(l,d){if(l.scheme===y.Schemas.file){const E=T.URI.file(I.resolve(D(l),d));return l.with({authority:E.authority,path:E.path})}return d.indexOf("/")===-1&&(d=b.toSlashes(d),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d)),l.with({path:I.posix.resolve(l.path,d)})}isAbsolutePath(l){return!!l.path&&l.path[0]==="/"}isEqualAuthority(l,d){return l===d||(0,A.equalsIgnoreCase)(l,d)}hasTrailingPathSeparator(l,d=I.sep){if(l.scheme===y.Schemas.file){const E=D(l);return E.length>b.getRoot(E).length&&E[E.length-1]===d}else{const E=l.path;return E.length>1&&E.charCodeAt(E.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(l.fsPath)}}removeTrailingPathSeparator(l,d=I.sep){return(0,e.hasTrailingPathSeparator)(l,d)?l.with({path:l.path.substr(0,l.path.length-1)}):l}addTrailingPathSeparator(l,d=I.sep){let E=!1;if(l.scheme===y.Schemas.file){const w=D(l);E=w!==void 0&&w.length===b.getRoot(w).length&&w[w.length-1]===d}else{d="/";const w=l.path;E=w.length===1&&w.charCodeAt(w.length-1)===47}return!E&&!(0,e.hasTrailingPathSeparator)(l,d)?l.with({path:l.path+"/"}):l}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(m=>m.scheme===y.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new k(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(m,l){const d=[];for(let E=0;E<m.length;E++){const w=l(m[E]);m.some((S,g)=>g===E?!1:(0,e.isEqualOrParent)(w,l(S)))||d.push(m[E])}return d}e.distinctParents=i;var C;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function l(d){const E=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(g=>{const[a,v]=g.split(":");a&&v&&E.set(a,v)});const S=d.path.substring(0,d.path.indexOf(";"));return S&&E.set(m.META_DATA_MIME,S),E}m.parseMetaData=l})(C=e.DataUri||(e.DataUri={}));function f(m,l,d){if(l){let E=m.path;return E&&E[0]!==I.posix.sep&&(E=I.posix.sep+E),m.with({scheme:d,authority:l,path:E})}return m.with({scheme:d})}e.toLocalResource=f}),define(me[13],ge([0,1,21,16,3,6,57,25]),function(G,e,b,I,T,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function D(N){return!!N&&typeof N.then=="function"}e.isThenable=D;function k(N){const M=new b.CancellationTokenSource,F=N(M.token),W=new Promise((q,Q)=>{M.token.onCancellationRequested(()=>{Q((0,I.canceled)())}),Promise.resolve(F).then(le=>{M.dispose(),q(le)},le=>{M.dispose(),Q(le)})});return new class{cancel(){M.cancel()}then(q,Q){return W.then(q,Q)}catch(q){return this.then(void 0,q)}finally(q){return W.finally(q)}}}e.createCancelablePromise=k;function i(N,M,F){return Promise.race([N,new Promise(W=>M.onCancellationRequested(()=>W(F)))])}e.raceCancellation=i;async function C(N){let M=-1;const F=N.map((q,Q)=>q.then(le=>(M=Q,le))),W=await Promise.race(F);return N.forEach((q,Q)=>{Q!==M&&q.cancel()}),W}e.raceCancellablePromises=C;function f(N,M,F){let W;const q=setTimeout(()=>{W==null||W(void 0),F==null||F()},M);return Promise.race([N.finally(()=>clearTimeout(q)),new Promise(Q=>W=Q)])}e.raceTimeout=f;function m(N){return new Promise((M,F)=>{const W=N();D(W)?W.then(M,F):M(W)})}e.asPromise=m;class l{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(M){if(this.activePromise){if(this.queuedPromiseFactory=M,!this.queuedPromise){const F=()=>{this.queuedPromise=null;const W=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,W};this.queuedPromise=new Promise(W=>{this.activePromise.then(F,F).then(W)})}return new Promise((F,W)=>{this.queuedPromise.then(F,W)})}return this.activePromise=M(),new Promise((F,W)=>{this.activePromise.then(q=>{this.activePromise=null,F(q)},q=>{this.activePromise=null,W(q)})})}}e.Throttler=l;class d{constructor(){this.current=Promise.resolve(null)}queue(M){return this.current=this.current.then(()=>M(),()=>M())}}e.Sequencer=d;class E{constructor(){this.promiseMap=new Map}queue(M,F){var W;const Q=((W=this.promiseMap.get(M))!==null&&W!==void 0?W:Promise.resolve()).catch(()=>{}).then(F).finally(()=>{this.promiseMap.get(M)===Q&&this.promiseMap.delete(M)});return this.promiseMap.set(M,Q),Q}}e.SequencerByKey=E;class w{constructor(M){this.defaultDelay=M,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(M,F=this.defaultDelay){return this.task=M,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((W,q)=>{this.doResolve=W,this.doReject=q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const W=this.task;return this.task=null,W()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},F),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,I.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=w;class S{constructor(M){this.delayer=new w(M),this.throttler=new l}trigger(M,F){return this.delayer.trigger(()=>this.throttler.queue(M),F)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=S;class g{constructor(){this._isOpen=!1,this._promise=new Promise((M,F)=>{this._completePromise=M})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=g;class a extends g{constructor(M){super();this._timeout=setTimeout(()=>this.open(),M)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function v(N,M){return M?new Promise((F,W)=>{const q=setTimeout(F,N);M.onCancellationRequested(()=>{clearTimeout(q),W((0,I.canceled)())})}):k(F=>v(N,F))}e.timeout=v;function t(N,M=0){const F=setTimeout(N,M);return(0,A.toDisposable)(()=>clearTimeout(F))}e.disposableTimeout=t;function n(N){return N.then(void 0,M=>{})}e.ignoreErrors=n;function o(N){const M=[];let F=0;const W=N.length;function q(){return F<W?N[F++]():null}function Q(le){le!=null&&M.push(le);const ve=q();return ve?ve.then(Q):Promise.resolve(M)}return Promise.resolve(null).then(Q)}e.sequence=o;function r(N,M=W=>!!W,F=null){let W=0;const q=N.length,Q=()=>{if(W>=q)return Promise.resolve(F);const le=N[W++];return Promise.resolve(le()).then(Re=>M(Re)?Promise.resolve(Re):Q())};return Q()}e.first=r;function s(N,M=W=>!!W,F=null){if(N.length===0)return Promise.resolve(F);let W=N.length;const q=()=>{var Q,le;W=-1;for(const ve of N)(le=(Q=ve).cancel)===null||le===void 0||le.call(Q)};return new Promise((Q,le)=>{for(const ve of N)ve.then(Re=>{--W>=0&&M(Re)?(q(),Q(Re)):W===0&&Q(F)}).catch(Re=>{--W>=0&&(q(),le(Re))})})}e.firstParallel=s;class c{constructor(M){this._size=0,this.maxDegreeOfParalellism=M,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new T.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(M){return this._size++,new Promise((F,W)=>{this.outstandingPromises.push({factory:M,c:F,e:W}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const M=this.outstandingPromises.shift();this.runningPromises++;const F=M.factory();F.then(M.c,M.e),F.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=c;class h extends c{constructor(){super(1)}}e.Queue=h;class _{constructor(){this.queues=new Map}queueFor(M,F=P.extUri){const W=F.getComparisonKey(M);let q=this.queues.get(W);return q||(q=new h,T.Event.once(q.onFinished)(()=>{q==null||q.dispose(),this.queues.delete(W)}),this.queues.set(W,q)),q}dispose(){this.queues.forEach(M=>M.dispose()),this.queues.clear()}}e.ResourceQueue=_;class u{constructor(M,F){this._token=-1,typeof M=="function"&&typeof F=="number"&&this.setIfNotSet(M,F)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(M,F){this.cancel(),this._token=setTimeout(()=>{this._token=-1,M()},F)}setIfNotSet(M,F){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,M()},F))}}e.TimeoutTimer=u;class p{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(M,F){this.cancel(),this._token=setInterval(()=>{M()},F)}}e.IntervalTimer=p;class R{constructor(M,F){this.timeoutToken=-1,this.runner=M,this.timeout=F,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(M=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,M)}get delay(){return this.timeout}set delay(M){this.timeout=M}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class O extends R{constructor(M,F){super(M,F);this.units=[]}work(M){this.units.push(M),this.isScheduled()||this.schedule()}doRun(){const M=this.units;this.units=[],this.runner&&this.runner(M)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=O,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const N=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=M=>{const F=setTimeout(()=>M(N));let W=!1;return{dispose(){W||(W=!0,clearTimeout(F))}}}}else e.runWhenIdle=(N,M)=>{const F=requestIdleCallback(N,typeof M=="number"?{timeout:M}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(F))}}}}();class j{constructor(M){this._didRun=!1,this._executor=()=>{try{this._value=M()}catch(F){this._error=F}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=j;async function ie(N,M,F){let W;for(let q=0;q<F;q++)try{return await N()}catch(Q){W=Q,await v(M)}throw W}e.retry=ie;class K{hasPending(M){return this._pending?typeof M=="number"?this._pending.taskId===M:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var M;(M=this._pending)===null||M===void 0||M.cancel()}setPending(M,F,W){return this._pending={taskId:M,cancel:()=>W==null?void 0:W(),promise:F},F.then(()=>this.donePending(M),()=>this.donePending(M)),F}donePending(M){this._pending&&M===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const M=this._next;this._next=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}setNext(M){if(this._next)this._next.run=M;else{let F,W;const q=new Promise((Q,le)=>{F=Q,W=le});this._next={run:M,promise:q,promiseResolve:F,promiseReject:W}}return this._next.promise}}e.TaskSequentializer=K;class x{constructor(M){this.interval=M,this.lastIncrementTime=0,this.value=0}increment(){const M=Date.now();return M-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=M,this.value=0),this.value++,this.value}}e.IntervalCounter=x;class ${constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((M,F)=>{this.completeCallback=M,this.errorCallback=F})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(M){return new Promise(F=>{this.completeCallback(M),this.resolved=!0,F()})}error(M){return new Promise(F=>{this.errorCallback(M),this.rejected=!0,F()})}cancel(){new Promise(M=>{this.errorCallback((0,I.canceled)()),this.rejected=!0,M()})}}e.DeferredPromise=$;class U extends T.Emitter{async fireAsync(M,F,W){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new y.LinkedList);for(const q of this._listeners)this._asyncDeliveryQueue.push([q,M]);for(;this._asyncDeliveryQueue.size>0&&!F.isCancellationRequested;){const[q,Q]=this._asyncDeliveryQueue.shift(),le=[],ve=Object.assign(Object.assign({},Q),{waitUntil:Re=>{if(Object.isFrozen(le))throw new Error("waitUntil can NOT be called asynchronous");W&&(Re=W(Re,typeof q=="function"?q:q[0])),le.push(Re)}});try{typeof q=="function"?q.call(void 0,ve):q[0].call(q[1],ve)}catch(Re){(0,I.onUnexpectedError)(Re);continue}Object.freeze(le),await L.settled(le).catch(Re=>(0,I.onUnexpectedError)(Re))}}}}e.AsyncEmitter=U;var L;(function(N){async function M(Q){return typeof Promise.allSettled=="function"?F(Q):W(Q)}N.allSettled=M;async function F(Q){return Promise.allSettled(Q)}async function W(Q){return Promise.all(Q.map(le=>le.then(ve=>({status:"fulfilled",value:ve}),ve=>({status:"rejected",reason:ve}))))}async function q(Q){let le;const ve=await Promise.all(Q.map(Re=>Re.then(Se=>Se,Se=>{le||(le=Se)})));if(typeof le!="undefined")throw le;return ve}N.settled=q})(L=e.Promises||(e.Promises={}))}),define(me[100],ge([0,1,8,13]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const T=new I.IdleValue(()=>{const u=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:u,collatorIsNumeric:u.resolvedOptions().numeric}}),A=new I.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new I.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(u,p,R=!1){const O=u||"",j=p||"",ie=T.value.collator.compare(O,j);return T.value.collatorIsNumeric&&ie===0&&O!==j?O<j?-1:1:ie}e.compareFileNames=P;function D(u,p){const R=A.value.collator;return u=u||"",p=p||"",v(R,u,p)}e.compareFileNamesDefault=D;function k(u,p){const R=A.value.collator;return u=u||"",p=p||"",r(u,p)||v(R,u,p)}e.compareFileNamesUpper=k;function i(u,p){const R=A.value.collator;return u=u||"",p=p||"",o(u,p)||v(R,u,p)}e.compareFileNamesLower=i;function C(u,p){return u=u||"",p=p||"",u===p?0:u<p?-1:1}e.compareFileNamesUnicode=C;function f(u,p,R=!1){R||(u=u&&u.toLowerCase(),p=p&&p.toLowerCase());const[O,j]=g(u),[ie,K]=g(p);return O!==ie?O<ie?-1:1:j===K?0:j<K?-1:1}e.noIntlCompareFileNames=f;function m(u,p){const[R,O]=g(u),[j,ie]=g(p);let K=T.value.collator.compare(O,ie);if(K===0){if(T.value.collatorIsNumeric&&O!==ie)return O<ie?-1:1;if(K=T.value.collator.compare(R,j),T.value.collatorIsNumeric&&K===0&&R!==j)return R<j?-1:1}return K}e.compareFileExtensions=m;function l(u,p){u=u||"",p=p||"";const R=a(u),O=a(p),j=A.value.collator,ie=y.value.collator;return v(ie,R,O)||v(j,u,p)}e.compareFileExtensionsDefault=l;function d(u,p){u=u||"",p=p||"";const R=a(u),O=a(p),j=A.value.collator,ie=y.value.collator;return v(ie,R,O)||r(u,p)||v(j,u,p)}e.compareFileExtensionsUpper=d;function E(u,p){u=u||"",p=p||"";const R=a(u),O=a(p),j=A.value.collator,ie=y.value.collator;return v(ie,R,O)||o(u,p)||v(j,u,p)}e.compareFileExtensionsLower=E;function w(u,p){u=u||"",p=p||"";const R=a(u).toLowerCase(),O=a(p).toLowerCase();return R!==O?R<O?-1:1:u!==p?u<p?-1:1:0}e.compareFileExtensionsUnicode=w;const S=/^(.*?)(\.([^.]*))?$/;function g(u,p=!1){const R=u?S.exec(u):[];let O=[R&&R[1]||"",R&&R[3]||""];return p&&(!O[0]&&O[1]||O[0]&&O[0].charAt(0)===".")&&(O=[O[0]+"."+O[1],""]),O}function a(u){const p=u?S.exec(u):[];return p&&p[1]&&p[1].charAt(0)!=="."&&p[3]||""}function v(u,p,R){let O=u.compare(p,R);return O!==0?O:p.length!==R.length?p.length<R.length?-1:1:0}function t(u){const p=u.charAt(0);return p.toLocaleUpperCase()!==p}function n(u){const p=u.charAt(0);return p.toLocaleLowerCase()!==p}function o(u,p){return t(u)&&n(p)?-1:n(u)&&t(p)?1:0}function r(u,p){return n(u)&&t(p)?-1:t(u)&&n(p)?1:0}function s(u,p,R=!1){return R||(u=u&&u.toLowerCase(),p=p&&p.toLowerCase()),u===p?0:u<p?-1:1}function c(u,p,R=!1){const O=u.split(b.sep),j=p.split(b.sep),ie=O.length-1,K=j.length-1;let x,$;for(let U=0;;U++){if(x=ie===U,$=K===U,x&&$)return P(O[U],j[U],R);if(x)return-1;if($)return 1;const L=s(O[U],j[U],R);if(L!==0)return L}}e.comparePaths=c;function h(u,p,R){const O=u.toLowerCase(),j=p.toLowerCase(),ie=_(u,p,R);if(ie)return ie;const K=O.endsWith(R),x=j.endsWith(R);if(K!==x)return K?-1:1;const $=P(O,j);return $!==0?$:O.localeCompare(j)}e.compareAnything=h;function _(u,p,R){const O=u.toLowerCase(),j=p.toLowerCase(),ie=O.startsWith(R),K=j.startsWith(R);if(ie!==K)return ie?-1:1;if(ie&&K){if(O.length<j.length)return-1;if(O.length>j.length)return 1}return 0}e.compareByPrefix=_}),define(me[101],ge([0,1,100,98,8,10,9]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const P=0,D=[P,[]];function k(x,$,U,L){if(!x||!$)return D;const N=x.length,M=$.length;if(N<M)return D;const F=x.toLowerCase();return!L&&!F.includes(U)?D:i($,U,M,x,F,N)}e.scoreFuzzy=k;function i(x,$,U,L,N,M){const F=[],W=[];for(let ve=0;ve<U;ve++){const Re=ve*M,Se=Re-M,Oe=ve>0,z=x[ve],Y=$[ve];for(let ee=0;ee<M;ee++){const se=ee>0,fe=Re+ee,Ee=fe-1,Be=Se+ee-1,pe=se?F[Ee]:0,Ce=Oe&&se?F[Be]:0,Me=Oe&&se?W[Be]:0;let ze;!Ce&&Oe?ze=0:ze=C(z,Y,L,N,ee,Me),ze&&Ce+ze>=pe?(W[fe]=Me+1,F[fe]=Ce+ze):(W[fe]=P,F[fe]=pe)}}const q=[];let Q=U-1,le=M-1;for(;Q>=0&&le>=0;){const ve=Q*M+le;W[ve]===P||(q.push(le),Q--),le--}return[F[U*M-1],q.reverse()]}function C(x,$,U,L,N,M){let F=0;if(!f($,L[N]))return F;if(F+=1,M>0&&(F+=M*5),x===U[N]&&(F+=1),N===0)F+=8;else{const W=m(U.charCodeAt(N-1));W?F+=W:(0,I.isUpper)(U.charCodeAt(N))&&(F+=2)}return F}function f(x,$){return x===$?!0:x==="/"||x==="\\"?$==="/"||$==="\\":!1}function m(x){switch(x){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const l=[void 0,[]];function d(x,$,U=0,L=0){const N=$;return N.values&&N.values.length>1?E(x,N.values,U,L):w(x,$,U,L)}e.scoreFuzzy2=d;function E(x,$,U,L){let N=0;const M=[];for(const F of $){const[W,q]=w(x,F,U,L);if(typeof W!="number")return l;N+=W,M.push(...q)}return[N,c(M)]}function w(x,$,U,L){const N=(0,I.fuzzyScore)($.original,$.originalLowercase,U,x,x.toLowerCase(),L,!0);return N?[N[0],(0,I.createMatches)(N)]:l}const S=Object.freeze({score:0}),g=1<<18,a=1<<17,v=1<<16;function t(x,$,U,L,N){if(!x||!$.normalized)return S;const M=L.getItemLabel(x);if(!M)return S;const F=L.getItemDescription(x);let W;F?W=`${M}${F}${$.normalized}${Array.isArray($.values)?$.values.length:""}${U}`:W=`${M}${$.normalized}${Array.isArray($.values)?$.values.length:""}${U}`;const q=N[W];if(q)return q;const Q=n(M,F,L.getItemPath(x),$,U);return N[W]=Q,Q}e.scoreItemFuzzy=t;function n(x,$,U,L,N){const M=!U||!L.containsPathSeparator;return U&&(A.isLinux?L.pathNormalized===U:(0,y.equalsIgnoreCase)(L.pathNormalized,U))?{score:g,labelMatch:[{start:0,end:x.length}],descriptionMatch:$?[{start:0,end:$.length}]:void 0}:L.values&&L.values.length>1?o(x,$,U,L.values,M,N):r(x,$,U,L,M,N)}function o(x,$,U,L,N,M){let F=0;const W=[],q=[];for(const Q of L){const{score:le,labelMatch:ve,descriptionMatch:Re}=r(x,$,U,Q,N,M);if(le===P)return S;F+=le,ve&&W.push(...ve),Re&&q.push(...Re)}return{score:F,labelMatch:c(W),descriptionMatch:c(q)}}function r(x,$,U,L,N,M){if(N||!$){const[F,W]=k(x,L.normalized,L.normalizedLowercase,M);if(F){const q=(0,I.matchesPrefix)(L.normalized,x);let Q;return q?(Q=a,Q+=Math.round(L.normalized.length/x.length*100)):Q=v,{score:Q+F,labelMatch:q||s(W)}}}if($){let F=$;U&&(F=`${$}${T.sep}`);const W=F.length,q=`${F}${x}`,[Q,le]=k(q,L.normalized,L.normalizedLowercase,M);if(Q){const ve=s(le),Re=[],Se=[];return ve.forEach(Oe=>{Oe.start<W&&Oe.end>W?(Re.push({start:0,end:Oe.end-W}),Se.push({start:Oe.start,end:W})):Oe.start>=W?Re.push({start:Oe.start-W,end:Oe.end-W}):Se.push(Oe)}),{score:Q,labelMatch:Re,descriptionMatch:Se}}}return S}function s(x){const $=[];if(!x)return $;let U;for(const L of x)U&&U.end===L?U.end+=1:(U={start:L,end:L+1},$.push(U));return $}function c(x){const $=x.sort((N,M)=>N.start-M.start),U=[];let L;for(const N of $)!L||!h(L,N)?(L=N,U.push(N)):(L.start=Math.min(L.start,N.start),L.end=Math.max(L.end,N.end));return U}function h(x,$){return!(x.end<$.start||$.end<x.start)}function _(x,$,U,L,N,M){const F=t(x,U,L,N,M),W=t($,U,L,N,M),q=F.score,Q=W.score;if((q===g||Q===g)&&q!==Q)return q===g?-1:1;if(q>v||Q>v){if(q!==Q)return q>Q?-1:1;if(q<a&&Q<a){const Y=p(F.labelMatch,W.labelMatch);if(Y!==0)return Y}const Oe=N.getItemLabel(x)||"",z=N.getItemLabel($)||"";if(Oe.length!==z.length)return Oe.length-z.length}if(q!==Q)return q>Q?-1:1;const le=Array.isArray(F.labelMatch)&&F.labelMatch.length>0,ve=Array.isArray(W.labelMatch)&&W.labelMatch.length>0;if(le&&!ve)return-1;if(ve&&!le)return 1;const Re=u(x,F,N),Se=u($,W,N);return Re&&Se&&Re!==Se?Se>Re?-1:1:R(x,$,U,N)}e.compareItemsByFuzzyScore=_;function u(x,$,U){let L=-1,N=-1;if($.descriptionMatch&&$.descriptionMatch.length?L=$.descriptionMatch[0].start:$.labelMatch&&$.labelMatch.length&&(L=$.labelMatch[0].start),$.labelMatch&&$.labelMatch.length){if(N=$.labelMatch[$.labelMatch.length-1].end,$.descriptionMatch&&$.descriptionMatch.length){const M=U.getItemDescription(x);M&&(N+=M.length)}}else $.descriptionMatch&&$.descriptionMatch.length&&(N=$.descriptionMatch[$.descriptionMatch.length-1].end);return N-L}function p(x,$){if(!x&&!$||(!x||!x.length)&&(!$||!$.length))return 0;if(!$||!$.length)return-1;if(!x||!x.length)return 1;const U=x[0].start,N=x[x.length-1].end-U,M=$[0].start,W=$[$.length-1].end-M;return N===W?0:W<N?1:-1}function R(x,$,U,L){const N=L.getItemLabel(x)||"",M=L.getItemLabel($)||"",F=L.getItemDescription(x),W=L.getItemDescription($),q=N.length+(F?F.length:0),Q=M.length+(W?W.length:0);if(q!==Q)return q-Q;const le=L.getItemPath(x),ve=L.getItemPath($);return le&&ve&&le.length!==ve.length?le.length-ve.length:N!==M?(0,b.compareAnything)(N,M,U.normalized):F&&W&&F!==W?(0,b.compareAnything)(F,W,U.normalized):le&&ve&&le!==ve?(0,b.compareAnything)(le,ve,U.normalized):0}const O=" ";function j(x){typeof x!="string"&&(x="");const $=x.toLowerCase(),{pathNormalized:U,normalized:L,normalizedLowercase:N}=ie(x),M=U.indexOf(T.sep)>=0;let F;const W=x.split(O);if(W.length>1)for(const q of W){const{pathNormalized:Q,normalized:le,normalizedLowercase:ve}=ie(q);le&&(F||(F=[]),F.push({original:q,originalLowercase:q.toLowerCase(),pathNormalized:Q,normalized:le,normalizedLowercase:ve}))}return{original:x,originalLowercase:$,pathNormalized:U,normalized:L,normalizedLowercase:N,values:F,containsPathSeparator:M}}e.prepareQuery=j;function ie(x){let $;A.isWindows?$=x.replace(/\//g,T.sep):$=x.replace(/\\/g,T.sep);const U=(0,y.stripWildcards)($).replace(/\s/g,"");return{pathNormalized:$,normalized:U,normalizedLowercase:U.toLowerCase()}}function K(x){return Array.isArray(x)?j(x.map($=>$.original).join(O)):j(x.original)}e.pieceToQuery=K}),define(me[33],ge([0,1,9,29,8,22,13]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const D="**",k="/",i="[/\\\\]",C="[^/\\\\]",f=/\//g;function m(F){switch(F){case 0:return"";case 1:return`${C}*?`;default:return`(?:${i}|${C}+${i}|${i}${C}+)*?`}}function l(F,W){if(!F)return[];const q=[];let Q=!1,le=!1,ve="";for(const Re of F){switch(Re){case W:if(!Q&&!le){q.push(ve),ve="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":le=!0;break;case"]":le=!1;break}ve+=Re}return ve&&q.push(ve),q}e.splitGlobAware=l;function d(F){if(!F)return"";let W="";const q=l(F,k);if(q.every(Q=>Q===D))W=".*";else{let Q=!1;q.forEach((le,ve)=>{if(le===D){Q||(W+=m(2),Q=!0);return}let Re=!1,Se="",Oe=!1,z="";for(const Y of le){if(Y!=="}"&&Re){Se+=Y;continue}if(Oe&&(Y!=="]"||!z)){let ee;Y==="-"?ee=Y:(Y==="^"||Y==="!")&&!z?ee="^":Y===k?ee="":ee=b.escapeRegExpCharacters(Y),z+=ee;continue}switch(Y){case"{":Re=!0;continue;case"[":Oe=!0;continue;case"}":W+=`(?:${l(Se,",").map(fe=>d(fe)).join("|")})`,Re=!1,Se="";break;case"]":W+="["+z+"]",Oe=!1,z="";break;case"?":W+=C;continue;case"*":W+=m(1);continue;default:W+=b.escapeRegExpCharacters(Y)}}ve<q.length-1&&(q[ve+1]!==D||ve+2<q.length)&&(W+=i),Q=!1})}return W}const E=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,S=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,g=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.LRUCache(1e4),n=function(){return!1},o=function(){return null};function r(F,W){if(!F)return o;let q;typeof F!="string"?q=F.pattern:q=F,q=q.trim();const Q=`${q}_${!!W.trimForExclusions}`;let le=t.get(Q);if(le)return s(le,F);let ve;if(E.test(q)){const Re=q.substr(4);le=function(Se,Oe){return typeof Se=="string"&&Se.endsWith(Re)?q:null}}else(ve=w.exec(c(q,W)))?le=h(ve[1],q):(W.trimForExclusions?g:S).test(q)?le=_(q,W):(ve=a.exec(c(q,W)))?le=u(ve[1].substr(1),q,!0):(ve=v.exec(c(q,W)))?le=u(ve[1],q,!1):le=p(q);return t.set(Q,le),s(le,F)}function s(F,W){return typeof W=="string"?F:function(q,Q){return I.isEqualOrParent(q,W.base)?F(T.relative(W.base,q),Q):null}}function c(F,W){return W.trimForExclusions&&F.endsWith("/**")?F.substr(0,F.length-2):F}function h(F,W){const q=`/${F}`,Q=`\\${F}`,le=function(Re,Se){return typeof Re!="string"?null:Se?Se===F?W:null:Re===F||Re.endsWith(q)||Re.endsWith(Q)?W:null},ve=[F];return le.basenames=ve,le.patterns=[W],le.allBasenames=ve,le}function _(F,W){const q=M(F.slice(1,-1).split(",").map(Se=>r(Se,W)).filter(Se=>Se!==o),F),Q=q.length;if(!Q)return o;if(Q===1)return q[0];const le=function(Se,Oe){for(let z=0,Y=q.length;z<Y;z++)if(q[z](Se,Oe))return F;return null},ve=q.find(Se=>!!Se.allBasenames);ve&&(le.allBasenames=ve.allBasenames);const Re=q.reduce((Se,Oe)=>Oe.allPaths?Se.concat(Oe.allPaths):Se,[]);return Re.length&&(le.allPaths=Re),le}function u(F,W,q){const Q=T.sep===T.posix.sep,le=Q?F:F.replace(f,T.sep),ve=T.sep+le,Re=T.posix.sep+F,Se=q?function(Oe,z){return typeof Oe=="string"&&(Oe===le||Oe.endsWith(ve)||!Q&&(Oe===F||Oe.endsWith(Re)))?W:null}:function(Oe,z){return typeof Oe=="string"&&(Oe===le||!Q&&Oe===F)?W:null};return Se.allPaths=[(q?"*/":"./")+F],Se}function p(F){try{const W=new RegExp(`^${d(F)}$`);return function(q){return W.lastIndex=0,typeof q=="string"&&W.test(q)?F:null}}catch(W){return o}}function R(F,W,q){return!F||typeof W!="string"?!1:O(F)(W,void 0,q)}e.match=R;function O(F,W={}){if(!F)return n;if(typeof F=="string"||x(F)){const q=r(F,W);if(q===o)return n;const Q=function(le,ve){return!!q(le,ve)};return q.allBasenames&&(Q.allBasenames=q.allBasenames),q.allPaths&&(Q.allPaths=q.allPaths),Q}return L(F,W)}e.parse=O;function j(F){if(!!F){let W;return q=>(W||(W=(F()||Promise.resolve([])).then(Q=>Q?K(Q):{})),W.then(Q=>!!Q[q]))}}e.hasSiblingPromiseFn=j;function ie(F){if(!!F){let W;return q=>{if(!W){const Q=F();W=Q?K(Q):{}}return!!W[q]}}}e.hasSiblingFn=ie;function K(F){const W={};for(const q of F)W[q]=!0;return W}function x(F){const W=F;return W&&typeof W.base=="string"&&typeof W.pattern=="string"}e.isRelativePattern=x;function $(F){return F.allBasenames||[]}e.getBasenameTerms=$;function U(F){return F.allPaths||[]}e.getPathTerms=U;function L(F,W){const q=M(Object.getOwnPropertyNames(F).map(Se=>N(Se,F[Se],W)).filter(Se=>Se!==o)),Q=q.length;if(!Q)return o;if(!q.some(Se=>!!Se.requiresSiblings)){if(Q===1)return q[0];const Se=function(Y,ee){for(let se=0,fe=q.length;se<fe;se++){const Ee=q[se](Y,ee);if(Ee)return Ee}return null},Oe=q.find(Y=>!!Y.allBasenames);Oe&&(Se.allBasenames=Oe.allBasenames);const z=q.reduce((Y,ee)=>ee.allPaths?Y.concat(ee.allPaths):Y,[]);return z.length&&(Se.allPaths=z),Se}const le=function(Se,Oe,z){let Y;for(let ee=0,se=q.length;ee<se;ee++){const fe=q[ee];fe.requiresSiblings&&z&&(Oe||(Oe=T.basename(Se)),Y||(Y=Oe.substr(0,Oe.length-T.extname(Se).length)));const Ee=fe(Se,Oe,Y,z);if(Ee)return Ee}return null},ve=q.find(Se=>!!Se.allBasenames);ve&&(le.allBasenames=ve.allBasenames);const Re=q.reduce((Se,Oe)=>Oe.allPaths?Se.concat(Oe.allPaths):Se,[]);return Re.length&&(le.allPaths=Re),le}function N(F,W,q){if(W===!1)return o;const Q=r(F,q);if(Q===o)return o;if(typeof W=="boolean")return Q;if(W){const le=W.when;if(typeof le=="string"){const ve=(Re,Se,Oe,z)=>{if(!z||!Q(Re,Se))return null;const Y=le.replace("$(basename)",Oe),ee=z(Y);return(0,y.isThenable)(ee)?ee.then(se=>se?F:null):ee?F:null};return ve.requiresSiblings=!0,ve}}return Q}function M(F,W){const q=F.filter(Se=>!!Se.basenames);if(q.length<2)return F;const Q=q.reduce((Se,Oe)=>{const z=Oe.basenames;return z?Se.concat(z):Se},[]);let le;if(W){le=[];for(let Se=0,Oe=Q.length;Se<Oe;Se++)le.push(W)}else le=q.reduce((Se,Oe)=>{const z=Oe.patterns;return z?Se.concat(z):Se},[]);const ve=function(Se,Oe){if(typeof Se!="string")return null;if(!Oe){let Y;for(Y=Se.length;Y>0;Y--){const ee=Se.charCodeAt(Y-1);if(ee===47||ee===92)break}Oe=Se.substr(Y)}const z=Q.indexOf(Oe);return z!==-1?le[z]:null};ve.basenames=Q,ve.patterns=le,ve.allBasenames=Q;const Re=F.filter(Se=>!Se.basenames);return Re.push(ve),Re}}),define(me[76],ge([0,1,2,8,9,12,10,25,29]),function(G,e,b,I,T,A,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function k(r,s,c){if(typeof r=="string"&&(r=b.URI.file(r)),c){const _=c.getWorkspaceFolder(r);if(_){const u=c.getWorkspace().folders.length>1;let p;if((0,P.isEqual)(_.uri,r)?p="":p=(0,P.relativePath)(_.uri,r),u){const R=_.name?_.name:(0,P.basename)(_.uri);p=p?R+" \u2022 "+p:R}return p}}if(r.scheme!==A.Schemas.file&&r.scheme!==A.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,D.hasDriveLetter)(r.fsPath))return(0,I.normalize)(C(r.fsPath));let h=(0,I.normalize)(r.fsPath);return!y.isWindows&&(s==null?void 0:s.userHome)&&(h=m(h,s.userHome.fsPath)),h}e.getPathLabel=k;function i(r){if(!!r){typeof r=="string"&&(r=b.URI.file(r));const s=(0,P.basename)(r)||(r.scheme===A.Schemas.file?r.fsPath:r.path);return y.isWindows&&(0,D.isRootOrDriveLetter)(s)?C(s):s}}e.getBaseLabel=i;function C(r){return(0,D.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=C;let f=Object.create(null);function m(r,s){if(y.isWindows||!r||!s)return r;let c=f.original===s?f.normalized:void 0;return c||(c=`${(0,T.rtrim)(s,I.posix.sep)}${I.posix.sep}`,f={original:s,normalized:c}),(y.isLinux?r.startsWith(c):(0,T.startsWithIgnoreCase)(r,c))&&(r=`~/${r.substr(c.length)}`),r}e.tildify=m;function l(r,s){return r.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=l;const d="\u2026",E="\\\\",w="~";function S(r,s=I.sep){const c=new Array(r.length);let h=!1;for(let _=0;_<r.length;_++){let u=r[_];if(u===""){c[_]=`.${s}`;continue}if(!u){c[_]=u;continue}h=!0;let p="";u.indexOf(E)===0?(p=u.substr(0,u.indexOf(E)+E.length),u=u.substr(u.indexOf(E)+E.length)):u.indexOf(s)===0?(p=u.substr(0,u.indexOf(s)+s.length),u=u.substr(u.indexOf(s)+s.length)):u.indexOf(w)===0&&(p=u.substr(0,u.indexOf(w)+w.length),u=u.substr(u.indexOf(w)+w.length));const R=u.split(s);for(let O=1;h&&O<=R.length;O++)for(let j=R.length-O;h&&j>=0;j--){h=!1;let ie=R.slice(j,j+O).join(s);for(let K=0;!h&&K<r.length;K++)if(K!==_&&r[K]&&r[K].indexOf(ie)>-1){const x=j+O===R.length,$=j>0&&r[K].indexOf(s)>-1?s+ie:ie,U=r[K].endsWith($);h=!x||U}if(!h){let K="";(R[0].endsWith(":")||p!=="")&&(j===1&&(j=0,O++,ie=R[0]+s+ie),j>0&&(K=R[0]+s),K=p+K),j>0&&(K=K+d+s),K=K+ie,j+O<R.length&&(K=K+s+d),c[_]=K}}h&&(c[_]=u)}return c}e.shorten=S;var g;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function a(r,s=Object.create(null)){const c=[];let h=!1,_="";for(const u of r)if(u==="$"||h&&u==="{")_&&c.push({value:_,type:g.TEXT}),_="",h=!0;else if(u==="}"&&h){const p=s[_];if(typeof p=="string")p.length&&c.push({value:p,type:g.VARIABLE});else if(p){const R=c[c.length-1];(!R||R.type!==g.SEPARATOR)&&c.push({value:p.label,type:g.SEPARATOR})}_="",h=!1}else _+=u;return _&&!h&&c.push({value:_,type:g.TEXT}),c.filter((u,p)=>{if(u.type===g.SEPARATOR){const R=c[p-1],O=c[p+1];return[R,O].every(j=>j&&(j.type===g.VARIABLE||j.type===g.TEXT)&&j.value.length>0)}return!0}).map(u=>u.value).join("")}e.template=a;function v(r,s){return y.isMacintosh||s?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,y.isMacintosh?"&":"&&"):r.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.mnemonicMenuLabel=v;function t(r,s){return y.isMacintosh||s?r.replace(/\(&&\w\)|&&/g,""):y.isWindows?r.replace(/&&|&/g,c=>c==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function n(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=n;function o(r){const s=r.indexOf("/")!==-1?I.posix:I.win32,c=s.basename(r),h=s.dirname(r);return c.length?{name:c,parentPath:h}:{name:h,parentPath:""}}e.splitName=o}),define(me[102],ge([0,1,2]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function I(i){return i.toJSON()}class T{constructor(C){this._uriTransformer=C}transformIncoming(C){const f=this._uriTransformer.transformIncoming(C);return f===C?C:I(b.URI.from(f))}transformOutgoing(C){const f=this._uriTransformer.transformOutgoing(C);return f===C?C:I(b.URI.from(f))}transformOutgoingURI(C){const f=this._uriTransformer.transformOutgoing(C);return f===C?C:b.URI.from(f)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=T,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function A(i,C,f){if(!i||f>200)return null;if(typeof i=="object"){if(i instanceof b.URI)return C.transformOutgoing(i);for(let m in i)if(Object.hasOwnProperty.call(i,m)){const l=A(i[m],C,f+1);l!==null&&(i[m]=l)}}return null}function y(i,C){const f=A(i,C,0);return f===null?i:f}e.transformOutgoingURIs=y;function P(i,C,f,m){if(!i||m>200)return null;if(typeof i=="object"){if(i.$mid===1)return f?b.URI.revive(C.transformIncoming(i)):C.transformIncoming(i);for(let l in i)if(Object.hasOwnProperty.call(i,l)){const d=P(i[l],C,f,m+1);d!==null&&(i[l]=d)}}return null}function D(i,C){const f=P(i,C,!1,0);return f===null?i:f}e.transformIncomingURIs=D;function k(i,C){const f=P(i,C,!0,0);return f===null?i:f}e.transformAndReviveIncomingURIs=k}),define(me[30],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const b=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function I(D){return b.test(D)}e.isUUID=I;const T=new Uint8Array(16),A=[];for(let D=0;D<256;D++)A.push(D.toString(16).padStart(2,"0"));let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(D){for(let k=0;k<D.length;k++)D[k]=Math.floor(Math.random()*256);return D};function P(){y(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let D=0,k="";return k+=A[T[D++]],k+=A[T[D++]],k+=A[T[D++]],k+=A[T[D++]],k+="-",k+=A[T[D++]],k+=A[T[D++]],k+="-",k+=A[T[D++]],k+=A[T[D++]],k+="-",k+=A[T[D++]],k+=A[T[D++]],k+="-",k+=A[T[D++]],k+=A[T[D++]],k+=A[T[D++]],k+=A[T[D++]],k+=A[T[D++]],k+=A[T[D++]],k}e.generateUuid=P}),define(me[137],ge([0,1,103]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class I{constructor(A="utf8"){this.stringDecoder=new b.StringDecoder(A),this.remaining=null}write(A){const y=[],P=this.remaining?this.remaining+this.stringDecoder.write(A):this.stringDecoder.write(A);if(P.length<1)return y;let D=0,k,i=D;for(;i<P.length;)if(k=P.charCodeAt(i),k===13||k===10){if(y.push(P.substring(D,i)),i++,i<P.length){const C=k;k=P.charCodeAt(i),(C===13&&k===10||C===10&&k===13)&&i++}D=i}else i++;return this.remaining=D<P.length?P.substr(D):null,y}end(){return this.remaining}}e.LineDecoder=I}),define(me[26],ge([0,1,37,48,8,13,10,29,30,75,25,2]),function(G,e,b,I,T,A,y,P,D,k,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var f;(function($){$[$.UNLINK=0]="UNLINK",$[$.MOVE=1]="MOVE"})(f=e.RimRafMode||(e.RimRafMode={}));async function m($,U=f.UNLINK){if((0,P.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");return U===f.UNLINK?d($):l($)}e.rimraf=m;async function l($){try{const U=(0,T.join)((0,I.tmpdir)(),(0,D.generateUuid)());try{await b.promises.rename($,U)}catch(L){return d($)}d(U).catch(L=>{})}catch(U){if(U.code!=="ENOENT")throw U}}async function d($){return b.promises.rmdir($,{recursive:!0,maxRetries:3})}function E($){if((0,P.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");b.rmdirSync($,{recursive:!0})}e.rimrafSync=E;async function w($,U){return a(await(U?S($):b.promises.readdir($)))}e.readdir=w;async function S($){try{return await b.promises.readdir($,{withFileTypes:!0})}catch(N){console.warn("[node.js fs] readdir with filetypes failed with error: ",N)}const U=[],L=await w($);for(const N of L){let M=!1,F=!1,W=!1;try{const q=await b.promises.lstat((0,T.join)($,N));M=q.isFile(),F=q.isDirectory(),W=q.isSymbolicLink()}catch(q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",q)}U.push({name:N,isFile:()=>M,isDirectory:()=>F,isSymbolicLink:()=>W})}return U}function g($){return a(b.readdirSync($))}e.readdirSync=g;function a($){return $.map(U=>typeof U=="string"?y.isMacintosh?(0,k.normalizeNFC)(U):U:(U.name=y.isMacintosh?(0,k.normalizeNFC)(U.name):U.name,U))}async function v($){const U=await w($),L=[];for(const N of U)await n.existsDirectory((0,T.join)($,N))&&L.push(N);return L}e.readDirsInDir=v;function t($,U=1e3){return new Promise(L=>{let N=!1;const M=setInterval(()=>{N||(N=!0,b.access($,F=>{N=!1,F&&(clearInterval(M),L(void 0))}))},U)})}e.whenDeleted=t;var n;(function($){async function U(M){let F;try{if(F=await b.promises.lstat(M),!F.isSymbolicLink())return{stat:F}}catch(W){}try{return{stat:await b.promises.stat(M),symbolicLink:(F==null?void 0:F.isSymbolicLink())?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};if(y.isWindows&&W.code==="EACCES")try{return{stat:await b.promises.stat(await b.promises.readlink(M)),symbolicLink:{dangling:!1}}}catch(q){if(q.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};throw q}throw W}}$.stat=U;async function L(M){try{const{stat:F,symbolicLink:W}=await $.stat(M);return F.isFile()&&(W==null?void 0:W.dangling)!==!0}catch(F){}return!1}$.existsFile=L;async function N(M){try{const{stat:F,symbolicLink:W}=await $.stat(M);return F.isDirectory()&&(W==null?void 0:W.dangling)!==!0}catch(F){}return!1}$.existsDirectory=N})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const o=new A.ResourceQueue;function r($,U,L){return o.queueFor(C.URI.file($),i.extUriBiasedIgnorePathCase).queue(()=>{const N=_(L);return new Promise((M,F)=>c($,U,N,W=>W?F(W):M()))})}e.writeFile=r;let s=!0;function c($,U,L,N){if(!s)return b.writeFile($,U,{mode:L.mode,flag:L.flag},N);b.open($,L.flag,L.mode,(M,F)=>{if(M)return N(M);b.writeFile(F,U,W=>{if(W)return b.close(F,()=>N(W));b.fdatasync(F,q=>(q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",q),s=!1),b.close(F,Q=>N(Q))))})})}function h($,U,L){const N=_(L);if(!s)return b.writeFileSync($,U,{mode:N.mode,flag:N.flag});const M=b.openSync($,N.flag,N.mode);try{b.writeFileSync(M,U);try{b.fdatasyncSync(M)}catch(F){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",F),s=!1}}finally{b.closeSync(M)}}e.writeFileSync=h;function _($){return $?{mode:typeof $.mode=="number"?$.mode:438,flag:typeof $.flag=="string"?$.flag:"w"}:{mode:438,flag:"w"}}async function u($,U){if($!==U){async function L(N){try{const M=await b.promises.lstat(N);if(M.isDirectory()||M.isSymbolicLink())return;const F=await b.promises.open(N,"a");try{await F.utimes(M.atime,new Date)}finally{await F.close()}}catch(M){}}try{await b.promises.rename($,U),await L(U)}catch(N){if($.toLowerCase()!==U.toLowerCase()&&N.code==="EXDEV"||$.endsWith("."))await p($,U,{preserveSymlinks:!1}),await m($,f.MOVE),await L(U);else throw N}}}e.move=u;async function p($,U,L){return O($,U,{root:{source:$,target:U},options:L,handledSourcePaths:new Set})}e.copy=p;const R=511;async function O($,U,L){if(!L.handledSourcePaths.has($)){L.handledSourcePaths.add($);const{stat:N,symbolicLink:M}=await n.stat($);if(M){if(L.options.preserveSymlinks)try{return await K($,U,L)}catch(F){console.warn("[node.js fs] copy of symlink failed: ",F)}if(M.dangling)return}return N.isDirectory()?j($,U,N.mode&R,L):ie($,U,N.mode&R)}}async function j($,U,L,N){await b.promises.mkdir(U,{recursive:!0,mode:L});const M=await w($);for(const F of M)await O((0,T.join)($,F),(0,T.join)(U,F),N)}async function ie($,U,L){await b.promises.copyFile($,U),await b.promises.chmod(U,L)}async function K($,U,L){let N=await b.promises.readlink($);(0,P.isEqualOrParent)(N,L.root.source,!y.isLinux)&&(N=(0,T.join)(L.root.target,N.substr(L.root.source.length+1))),await b.promises.symlink(N,U)}async function x($){try{return await b.promises.access($),!0}catch(U){return!1}}e.exists=x}),define(me[104],ge([0,1,37,284,9,8,26]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function P(C){const f=(0,A.dirname)(C);if(C===f)return C;const m=((0,A.basename)(C)||C).toLowerCase();try{const d=(0,y.readdirSync)(f).filter(E=>E.toLowerCase()===m);if(d.length===1){const E=P(f);if(E)return(0,A.join)(E,d[0])}else if(d.length>1){const E=d.indexOf(m);if(E>=0){const w=P(f);if(w)return(0,A.join)(w,d[E])}}}catch(l){}return null}e.realcaseSync=P;async function D(C){try{return await(0,I.promisify)(b.realpath)(C)}catch(f){const m=i(C);return await b.promises.access(m,b.constants.R_OK),m}}e.realpath=D;function k(C){try{return b.realpathSync(C)}catch(f){const m=i(C);return b.accessSync(m,b.constants.R_OK),m}}e.realpathSync=k;function i(C){return(0,T.rtrim)((0,A.normalize)(C),A.sep)}});var Et=this&&this.__await||function(G){return this instanceof Et?(this.v=G,this):new Et(G)},Mn=this&&this.__asyncGenerator||function(G,e,b){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var I=b.apply(G,e||[]),T,A=[];return T={},y("next"),y("throw"),y("return"),T[Symbol.asyncIterator]=function(){return this},T;function y(f){I[f]&&(T[f]=function(m){return new Promise(function(l,d){A.push([f,m,l,d])>1||P(f,m)})})}function P(f,m){try{D(I[f](m))}catch(l){C(A[0][3],l)}}function D(f){f.value instanceof Et?Promise.resolve(f.value.v).then(k,i):C(A[0][2],f)}function k(f){P("next",f)}function i(f){P("throw",f)}function C(f,m){f(m),A.shift(),A.length&&P(A[0][0],A[0][1])}},mn=this&&this.__asyncValues||function(G){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=G[Symbol.asyncIterator],b;return e?e.call(G):(G=typeof __values=="function"?__values(G):G[Symbol.iterator](),b={},I("next"),I("throw"),I("return"),b[Symbol.asyncIterator]=function(){return this},b);function I(A){b[A]=G[A]&&function(y){return new Promise(function(P,D){y=G[A](y),T(P,D,y.done,y.value)})}}function T(A,y,P,D){Promise.resolve(D).then(function(k){A({value:k,done:P})},y)}};define(me[105],ge([0,1,26,48,8]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,y=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var D;(function(a){a[a.x64=0]="x64",a[a.x86=1]="x86",a[a.ARM=2]="ARM"})(D||(D={}));let k;switch(process.arch){case"ia32":case"x32":k=1;break;case"arm":case"arm64":k=2;break;default:k=0;break}let i;process.env.PROCESSOR_ARCHITEW6432?i=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?i=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?i=1:i=0;class C{constructor(v,t,n){this.exePath=v,this.displayName=t,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await b.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function f({useAlternateBitness:a=!1}={}){return a?k===0?process.env["ProgramFiles(x86)"]||null:i===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:a=!1,findPreview:v=!1}={}){const t=f({useAlternateBitness:a});if(!t)return null;const n=T.join(t,"PowerShell");if(!await b.SymlinkSupport.existsDirectory(n))return null;let o=-1,r=null;for(const h of await b.readdir(n)){let _=-1;if(v){const p=h.indexOf("-");if(p<0)continue;const R=h.substring(0,p);if(!A.test(R)||h.substring(p+1)!=="preview")continue;_=parseInt(R,10)}else{if(!A.test(h))continue;_=parseInt(h,10)}if(!(_<=o)){const u=T.join(n,h,"pwsh.exe");!await b.SymlinkSupport.existsFile(u)||(r=u,o=_)}}if(!r)return null;const s=t.includes("x86")?" (x86)":"",c=v?" Preview":"";return new C(r,`PowerShell${c}${s}`,!0)}async function l({findPreview:a}={}){if(!process.env.LOCALAPPDATA)return null;const v=T.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await b.SymlinkSupport.existsDirectory(v))return null;const{pwshMsixDirRegex:t,pwshMsixName:n}=a?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:y,pwshMsixName:"PowerShell (Store)"};for(const o of await b.readdir(v))if(t.test(o)){const r=T.join(v,o,"pwsh.exe");return new C(r,n)}return null}function d(){const a=T.join(I.homedir(),".dotnet","tools","pwsh.exe");return new C(a,".NET Core PowerShell Global Tool")}function E(){const a=T.join(process.env.windir,k===1&&i!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(a,"Windows PowerShell",!0)}function w(){return Mn(this,arguments,function*(){let v=yield Et(m());v&&(yield yield Et(v)),v=yield Et(m({useAlternateBitness:!0})),v&&(yield yield Et(v)),v=yield Et(l()),v&&(yield yield Et(v)),v=d(),v&&(yield yield Et(v)),v=yield Et(m({findPreview:!0})),v&&(yield yield Et(v)),v=yield Et(l({findPreview:!0})),v&&(yield yield Et(v)),v=yield Et(m({useAlternateBitness:!0,findPreview:!0})),v&&(yield yield Et(v)),v=E(),v&&(yield yield Et(v))})}function S(){return Mn(this,arguments,function*(){var v,t;try{for(var n=mn(w()),o;o=yield Et(n.next()),!o.done;){const r=o.value;(yield Et(r.exists()))&&(yield yield Et(r))}}catch(r){v={error:r}}finally{try{o&&!o.done&&(t=n.return)&&(yield Et(t.call(n)))}finally{if(v)throw v.error}}})}e.enumeratePowerShellInstallations=S;async function g(){var a,v;try{for(var t=mn(S()),n;n=await t.next(),!n.done;)return n.value}catch(o){a={error:o}}finally{try{n&&!n.done&&(v=t.return)&&await v.call(t)}finally{if(a)throw a.error}}return null}e.getFirstAvailablePowerShellInstallation=g});var qe=this&&this.__decorate||function(G,e,b,I){var T=arguments.length,A=T<3?e:I===null?I=Object.getOwnPropertyDescriptor(e,b):I,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(G,e,b,I);else for(var P=G.length-1;P>=0;P--)(y=G[P])&&(A=(T<3?y(A):T>3?y(e,b,A):y(e,b))||A);return T>3&&A&&Object.defineProperty(e,b,A),A};define(me[106],ge([0,1,3,6,13,21,16,23,17,11,59,9,54]),function(G,e,b,I,T,A,y,P,D,k,i,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var m;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(m=e.RequestType||(e.RequestType={}));function l(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(d=e.ResponseType||(e.ResponseType={}));function E(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var w;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(w||(w={}));class S{constructor(F){this.buffer=F,this.pos=0}read(F){const W=this.buffer.slice(this.pos,this.pos+F);return this.pos+=W.byteLength,W}}class g{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(F){this.buffers.push(F)}}var a;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(a||(a={}));function v(M){const F=P.VSBuffer.alloc(4);return F.writeUInt32BE(M,0),F}function t(M){return M.read(4).readUInt32BE(0)}function n(M){const F=P.VSBuffer.alloc(1);return F.writeUInt8(M,0),F}const o={Undefined:n(a.Undefined),String:n(a.String),Buffer:n(a.Buffer),VSBuffer:n(a.VSBuffer),Array:n(a.Array),Object:n(a.Object)},r=typeof Buffer!="undefined";function s(M,F){if(typeof F=="undefined")M.write(o.Undefined);else if(typeof F=="string"){const W=P.VSBuffer.fromString(F);M.write(o.String),M.write(v(W.byteLength)),M.write(W)}else if(r&&Buffer.isBuffer(F)){const W=P.VSBuffer.wrap(F);M.write(o.Buffer),M.write(v(W.byteLength)),M.write(W)}else if(F instanceof P.VSBuffer)M.write(o.VSBuffer),M.write(v(F.byteLength)),M.write(F);else if(Array.isArray(F)){M.write(o.Array),M.write(v(F.length));for(const W of F)s(M,W)}else{const W=P.VSBuffer.fromString(JSON.stringify(F));M.write(o.Object),M.write(v(W.byteLength)),M.write(W)}}function c(M){switch(M.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return M.read(t(M)).toString();case a.Buffer:return M.read(t(M)).buffer;case a.VSBuffer:return M.read(t(M));case a.Array:{const W=t(M),q=[];for(let Q=0;Q<W;Q++)q.push(c(M));return q}case a.Object:return JSON.parse(M.read(t(M)).toString())}}class h{constructor(F,W,q=null,Q=1e3){this.protocol=F,this.ctx=W,this.logger=q,this.timeoutDelay=Q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(le=>this.onRawMessage(le)),this.sendResponse({type:200})}registerChannel(F,W){this.channels.set(F,W),setTimeout(()=>this.flushPendingRequests(F),0)}sendResponse(F){switch(F.type){case 200:{const W=this.send([F.type]);this.logger&&this.logger.logOutgoing(W,0,1,E(F.type));return}case 201:case 202:case 204:case 203:{const W=this.send([F.type,F.id],F.data);this.logger&&this.logger.logOutgoing(W,F.id,1,E(F.type),F.data);return}}}send(F,W=void 0){const q=new g;return s(q,F),s(q,W),this.sendBuffer(q.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch(W){return 0}}onRawMessage(F){const W=new S(F),q=c(W),Q=c(W),le=q[0];switch(le){case 100:return this.logger&&this.logger.logIncoming(F.byteLength,q[1],1,`${l(le)}: ${q[2]}.${q[3]}`,Q),this.onPromise({type:le,id:q[1],channelName:q[2],name:q[3],arg:Q});case 102:return this.logger&&this.logger.logIncoming(F.byteLength,q[1],1,`${l(le)}: ${q[2]}.${q[3]}`,Q),this.onEventListen({type:le,id:q[1],channelName:q[2],name:q[3],arg:Q});case 101:return this.logger&&this.logger.logIncoming(F.byteLength,q[1],1,`${l(le)}`),this.disposeActiveRequest({type:le,id:q[1]});case 103:return this.logger&&this.logger.logIncoming(F.byteLength,q[1],1,`${l(le)}`),this.disposeActiveRequest({type:le,id:q[1]})}}onPromise(F){const W=this.channels.get(F.channelName);if(!W){this.collectPendingRequest(F);return}const q=new A.CancellationTokenSource;let Q;try{Q=W.call(this.ctx,F.name,F.arg,q.token)}catch(Re){Q=Promise.reject(Re)}const le=F.id;Q.then(Re=>{this.sendResponse({id:le,data:Re,type:201}),this.activeRequests.delete(F.id)},Re=>{Re instanceof Error?this.sendResponse({id:le,data:{message:Re.message,name:Re.name,stack:Re.stack?Re.stack.split?Re.stack.split(`
`):Re.stack:void 0},type:202}):this.sendResponse({id:le,data:Re,type:203}),this.activeRequests.delete(F.id)});const ve=(0,I.toDisposable)(()=>q.cancel());this.activeRequests.set(F.id,ve)}onEventListen(F){const W=this.channels.get(F.channelName);if(!W){this.collectPendingRequest(F);return}const q=F.id,le=W.listen(this.ctx,F.name,F.arg)(ve=>this.sendResponse({id:q,data:ve,type:204}));this.activeRequests.set(F.id,le)}disposeActiveRequest(F){const W=this.activeRequests.get(F.id);W&&(W.dispose(),this.activeRequests.delete(F.id))}collectPendingRequest(F){let W=this.pendingRequests.get(F.channelName);W||(W=[],this.pendingRequests.set(F.channelName,W));const q=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.sendResponse({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:F,timeoutTimer:q})}flushPendingRequests(F){const W=this.pendingRequests.get(F);if(W){for(const q of W)switch(clearTimeout(q.timeoutTimer),q.request.type){case 100:this.onPromise(q.request);break;case 102:this.onEventListen(q.request);break}this.pendingRequests.delete(F)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(F=>F.dispose()),this.activeRequests.clear()}}e.ChannelServer=h;var _;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(_=e.RequestInitiator||(e.RequestInitiator={}));class u{constructor(F,W=null){this.protocol=F,this.isDisposed=!1,this.state=w.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new b.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(q=>this.onBuffer(q)),this.logger=W}getChannel(F){const W=this;return{call(q,Q,le){return W.isDisposed?Promise.reject(y.canceled()):W.requestPromise(F,q,Q,le)},listen(q,Q){return W.isDisposed?Promise.reject(y.canceled()):W.requestEvent(F,q,Q)}}}requestPromise(F,W,q,Q=A.CancellationToken.None){const le=this.lastRequestId++,Re={id:le,type:100,channelName:F,name:W,arg:q};if(Q.isCancellationRequested)return Promise.reject(y.canceled());let Se;return new Promise((z,Y)=>{if(Q.isCancellationRequested)return Y(y.canceled());const ee=()=>{const Be=pe=>{switch(pe.type){case 201:this.handlers.delete(le),z(pe.data);break;case 202:this.handlers.delete(le);const Ce=new Error(pe.data.message);Ce.stack=pe.data.stack,Ce.name=pe.data.name,Y(Ce);break;case 203:this.handlers.delete(le),Y(pe.data);break}};this.handlers.set(le,Be),this.sendRequest(Re)};let se=null;this.state===w.Idle?ee():(se=(0,T.createCancelablePromise)(Be=>this.whenInitialized()),se.then(()=>{se=null,ee()}));const fe=()=>{se?(se.cancel(),se=null):this.sendRequest({id:le,type:101}),Y(y.canceled())},Ee=Q.onCancellationRequested(fe);Se=(0,I.combinedDisposable)((0,I.toDisposable)(fe),Ee),this.activeRequests.add(Se)}).finally(()=>{this.activeRequests.delete(Se)})}requestEvent(F,W,q){const Q=this.lastRequestId++,ve={id:Q,type:102,channelName:F,name:W,arg:q};let Re=null;const Se=new b.Emitter({onFirstListenerAdd:()=>{Re=(0,T.createCancelablePromise)(z=>this.whenInitialized()),Re.then(()=>{Re=null,this.activeRequests.add(Se),this.sendRequest(ve)})},onLastListenerRemove:()=>{Re?(Re.cancel(),Re=null):(this.activeRequests.delete(Se),this.sendRequest({id:Q,type:103}))}}),Oe=z=>Se.fire(z.data);return this.handlers.set(Q,Oe),Se.event}sendRequest(F){switch(F.type){case 100:case 102:{const W=this.send([F.type,F.id,F.channelName,F.name],F.arg);this.logger&&this.logger.logOutgoing(W,F.id,0,`${l(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const W=this.send([F.type,F.id]);this.logger&&this.logger.logOutgoing(W,F.id,0,l(F.type));return}}}send(F,W=void 0){const q=new g;return s(q,F),s(q,W),this.sendBuffer(q.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch(W){return 0}}onBuffer(F){const W=new S(F),q=c(W),Q=c(W),le=q[0];switch(le){case 200:return this.logger&&this.logger.logIncoming(F.byteLength,0,0,E(le)),this.onResponse({type:q[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(F.byteLength,q[1],0,E(le),Q),this.onResponse({type:q[0],id:q[1],data:Q})}}onResponse(F){if(F.type===200){this.state=w.Idle,this._onDidInitialize.fire();return}const W=this.handlers.get(F.id);W&&W(F)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===w.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(F=>F.dispose()),this.activeRequests.clear()}}qe([f.memoize],u.prototype,"onDidInitializePromise",null),e.ChannelClient=u;class p{constructor(F){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new b.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new b.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,F(({protocol:W,onDidClientDisconnect:q})=>{b.Event.once(W.onMessage)(le=>{const ve=new S(le),Re=c(ve),Se=new h(W,Re),Oe=new u(W);this.channels.forEach((Y,ee)=>Se.registerChannel(ee,Y));const z={channelServer:Se,channelClient:Oe,ctx:Re};this._connections.add(z),this._onDidAddConnection.fire(z),q(()=>{Se.dispose(),Oe.dispose(),this._connections.delete(z),this._onDidRemoveConnection.fire(z)})})})}get connections(){const F=[];return this._connections.forEach(W=>F.push(W)),F}getChannel(F,W){const q=this;return{call(Q,le,ve){let Re;if((0,k.isFunction)(W)){let Oe=(0,D.getRandomElement)(q.connections.filter(W));Re=Oe?Promise.resolve(Oe):b.Event.toPromise(b.Event.filter(q.onDidAddConnection,W))}else Re=W.routeCall(q,Q,le);const Se=Re.then(Oe=>Oe.channelClient.getChannel(F));return O(Se).call(Q,le,ve)},listen(Q,le){if((0,k.isFunction)(W))return q.getMulticastEvent(F,W,Q,le);const ve=W.routeEvent(q,Q,le).then(Re=>Re.channelClient.getChannel(F));return O(ve).listen(Q,le)}}}getMulticastEvent(F,W,q,Q){const le=this;let ve=new I.DisposableStore;const Re=new b.Emitter({onFirstListenerAdd:()=>{ve=new I.DisposableStore;const Se=new b.EventMultiplexer,Oe=new Map,z=ee=>{const fe=ee.channelClient.getChannel(F).listen(q,Q),Ee=Se.add(fe);Oe.set(ee,Ee)},Y=ee=>{const se=Oe.get(ee);!se||(se.dispose(),Oe.delete(ee))};le.connections.filter(W).forEach(z),b.Event.filter(le.onDidAddConnection,W)(z,void 0,ve),le.onDidRemoveConnection(Y,void 0,ve),Se.event(Re.fire,Re,ve),ve.add(Se)},onLastListenerRemove:()=>{ve.dispose()}});return Re.event}registerChannel(F,W){this.channels.set(F,W),this._connections.forEach(q=>{q.channelServer.registerChannel(F,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=p;class R{constructor(F,W,q=null){const Q=new g;s(Q,W),F.send(Q.buffer),this.channelClient=new u(F,q),this.channelServer=new h(F,W,q)}getChannel(F){return this.channelClient.getChannel(F)}registerChannel(F,W){this.channelServer.registerChannel(F,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=R;function O(M){return{call(F,W,q){return M.then(Q=>Q.call(F,W,q))},listen(F,W){const q=new b.Relay;return M.then(Q=>q.input=Q.listen(F,W)),q.event}}}e.getDelayedChannel=O;function j(M){let F=!1;return{call(W,q,Q){return F?M.call(W,q,Q):(0,T.timeout)(0).then(()=>F=!0).then(()=>M.call(W,q,Q))},listen(W,q){if(F)return M.listen(W,q);const Q=new b.Relay;return(0,T.timeout)(0).then(()=>F=!0).then(()=>Q.input=M.listen(W,q)),Q.event}}}e.getNextTickChannel=j;class ie{constructor(F){this.fn=F}routeCall(F){return this.route(F)}routeEvent(F){return this.route(F)}async route(F){for(const W of F.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await b.Event.toPromise(F.onDidAddConnection),await this.route(F)}}e.StaticRouter=ie;var K;(function(M){function F(Q,le){const ve=Q,Re=le&&le.disableMarshalling,Se=new Map;for(const Oe in ve)q(Oe)&&Se.set(Oe,b.Event.buffer(ve[Oe],!0));return new class{listen(Oe,z){const Y=Se.get(z);if(Y)return Y;throw new Error(`Event not found: ${z}`)}call(Oe,z,Y){const ee=ve[z];if(typeof ee=="function"){if(!Re&&Array.isArray(Y))for(let se=0;se<Y.length;se++)Y[se]=(0,i.revive)(Y[se]);return ee.apply(ve,Y)}throw new Error(`Method not found: ${z}`)}}}M.fromService=F;function W(Q,le){const ve=le&&le.disableMarshalling;return new Proxy({},{get(Re,Se){var Oe;if(typeof Se=="string")return((Oe=le==null?void 0:le.properties)===null||Oe===void 0?void 0:Oe.has(Se))?le.properties.get(Se):q(Se)?Q.listen(Se):async function(...z){let Y;le&&!(0,k.isUndefinedOrNull)(le.context)?Y=[le.context,...z]:Y=z;const ee=await Q.call(Se,Y);return ve?ee:(0,i.revive)(ee)};throw new Error(`Property not found: ${String(Se)}`)}})}M.toService=W;function q(Q){return Q[0]==="o"&&Q[1]==="n"&&C.isUpperAsciiLetter(Q.charCodeAt(2))}})(K=e.ProxyChannel||(e.ProxyChannel={}));const x=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function $(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){let F=M.toString();if(F!=="[object Object]")return F}return M}function U(M){return Array.isArray(M)?M.map($):$(M)}function L(M,F,W,q,Q,le,ve){ve=U(ve);const Re=x[Q],Se=Re[q%Re.length];let Oe=[`%c[${M}]%c[${String(F).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(q).padStart(5," ")} - ${le}`,"color: darkgreen","color: grey","color: grey",`color: ${Se}`];/\($/.test(le)?(Oe=Oe.concat(ve),Oe.push(")")):Oe.push(ve),console.log.apply(console,Oe)}e.logWithColors=L;class N{constructor(F,W){this._outgoingPrefix=F,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(F,W,q,Q,le){this._totalOutgoing+=F,L(this._outgoingPrefix,this._totalOutgoing,F,W,q,Q,le)}logIncoming(F,W,q,Q,le){this._totalIncoming+=F,L(this._incomingPrefix,this._totalIncoming,F,W,q,Q,le)}}e.IPCLogger=N}),define(me[107],ge([0,1,3,106,6,23,10,36]),function(G,e,b,I,T,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let D=null;function k(){return D||(D=A.VSBuffer.alloc(0)),D}class i{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,r){if(o===0)return k();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const _=this._chunks[0];return r&&(this._chunks.shift(),this._totalLength-=o),_}if(this._chunks[0].byteLength>o){const _=this._chunks[0].slice(0,o);return r&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),_}let s=A.VSBuffer.alloc(o),c=0,h=0;for(;o>0;){const _=this._chunks[h];if(_.byteLength>o){const u=_.slice(0,o);s.set(u,c),c+=o,r&&(this._chunks[h]=_.slice(o),this._totalLength-=o),o-=o}else s.set(_,c),c+=_.byteLength,r?(this._chunks.shift(),this._totalLength-=_.byteLength):h++,o-=_.byteLength}return s}}e.ChunkStream=i;var C;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.KeepAlive=4]="KeepAlive",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest"})(C||(C={}));var f;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",n[n.KeepAliveTime=5e3]="KeepAliveTime",n[n.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(f=e.ProtocolConstants||(e.ProtocolConstants={}));class m{constructor(o,r,s,c){this.type=o,this.id=r,this.ack=s,this.data=c,this.writtenTime=0}get size(){return this.data.byteLength}}class l extends T.Disposable{constructor(o){super();this._onMessage=this._register(new b.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new i,this._register(this._socket.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const r=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=r.readUInt32BE(9),this._state.messageType=r.readUInt8(0),this._state.id=r.readUInt32BE(1),this._state.ack=r.readUInt32BE(5);else{const s=this._state.messageType,c=this._state.id,h=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new m(s,c,h,r)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class d{constructor(o){this._isDisposed=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(o){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(o){if(!this._isDisposed){o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=A.VSBuffer.alloc(13);r.writeUInt8(o.type,0),r.writeUInt32BE(o.id,1),r.writeUInt32BE(o.ack,5),r.writeUInt32BE(o.data.byteLength,9),this._writeSoon(r,o.data)}}_bufferAdd(o,r){const s=this._totalLength===0;return this._data.push(o,r),this._totalLength+=o.byteLength+r.byteLength,s}_bufferTake(){const o=A.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,r){this._bufferAdd(o,r)&&y.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class E extends T.Disposable{constructor(o){super();this._onMessage=new b.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new b.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new d(this._socket)),this._socketReader=this._register(new l(this._socket)),this._register(this._socketReader.onMessage(r=>{r.type===1&&this._onMessage.fire(r.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new m(1,0,0,o))}}e.Protocol=E;class w extends I.IPCClient{constructor(o,r,s=null){super(o,r,s);this.protocol=o}static fromSocket(o,r){return new w(new E(o),r)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=w;class S{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new b.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,P.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=S;class g{constructor(o){this.data=o,this.next=null}}class a{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let o=[],r=0,s=this._first;for(;s;)o[r++]=s.data,s=s.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const r=new g(o);if(!this._first){this._first=r,this._last=r;return}this._last.next=r,this._last=r}}class v{constructor(){this.lastRuns=[];const o=Date.now();for(let r=0;r<v._HISTORY_LENGTH;r++)this.lastRuns[r]=o-1e3*r;setInterval(()=>{for(let r=v._HISTORY_LENGTH;r>=1;r--)this.lastRuns[r]=this.lastRuns[r-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return v._INSTANCE||(v._INSTANCE=new v),v._INSTANCE}load(){const o=Date.now(),r=(1+v._HISTORY_LENGTH)*1e3;let s=0;for(let c=0;c<v._HISTORY_LENGTH;c++)o-this.lastRuns[c]<=r&&s++;return 1-s/v._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}v._HISTORY_LENGTH=10,v._INSTANCE=null;class t{constructor(o,r=null){this._loadEstimator=v.getInstance(),this._onControlMessage=new S,this.onControlMessage=this._onControlMessage.event,this._onMessage=new S,this.onMessage=this._onMessage.event,this._onDidDispose=new S,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new S,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new S,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new a,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=o,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new l(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(s=>this._receiveMessage(s))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),r&&this._socketReader.acceptChunk(r),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,T.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new m(5,0,0,k());this._socketWriter.write(o),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const o=Date.now()-this._socketWriter.lastWriteTime;if(o>=5e3){const r=new m(4,0,0,k());this._socketWriter.write(r),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-o+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const o=Date.now()-this._socketReader.lastReadTime;if(o>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-o,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,r){this._isReconnecting=!0,this._socketDisposables=(0,T.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=o,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new l(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(s=>this._receiveMessage(s))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(r)}endAcceptReconnection(){this._isReconnecting=!1;const o=this._outgoingUnackMsg.toArray();for(let r=0,s=o.length;r<s;r++)this._socketWriter.write(o[r]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const r=this._outgoingUnackMsg.peek();if(r&&r.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(o.type===1){if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const r=Date.now();r-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=r,this._socketWriter.write(new m(6,0,0,k())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data)}else if(o.type===2)this._onControlMessage.fire(o.data);else if(o.type===5)this._onDidDispose.fire();else if(o.type===6){const r=this._outgoingUnackMsg.toArray();for(let s=0,c=r.length;s<c;s++)this._socketWriter.write(r[s]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const r=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const s=new m(1,r,this._incomingAckId,o);this._outgoingUnackMsg.push(s),this._isReconnecting||(this._socketWriter.write(s),this._recvAckCheck())}sendControl(o){const r=new m(2,0,0,o);this._socketWriter.write(r)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const o=this._outgoingUnackMsg.peek(),r=Date.now()-o.writtenTime;if(r>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-r,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const o=new m(3,0,this._incomingAckId,k());this._socketWriter.write(o)}}}e.PersistentProtocol=t}),define(me[108],ge([0,1,97]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class I{constructor(P){let D=(0,b.toUint8)(P);this._defaultValue=D,this._asciiMap=I._createAsciiMap(D),this._map=new Map}static _createAsciiMap(P){let D=new Uint8Array(256);for(let k=0;k<256;k++)D[k]=P;return D}set(P,D){let k=(0,b.toUint8)(D);P>=0&&P<256?this._asciiMap[P]=k:this._map.set(P,k)}get(P){return P>=0&&P<256?this._asciiMap[P]:this._map.get(P)||this._defaultValue}}e.CharacterClassifier=I;var T;(function(y){y[y.False=0]="False",y[y.True=1]="True"})(T||(T={}));class A{constructor(){this._actual=new I(0)}add(P){this._actual.set(P,1)}has(P){return this._actual.get(P)===1}}e.CharacterSet=A}),define(me[138],ge([0,1,108]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var I;(function(y){y[y.Regular=0]="Regular",y[y.Whitespace=1]="Whitespace",y[y.WordSeparator=2]="WordSeparator"})(I=e.WordCharacterClass||(e.WordCharacterClass={}));class T extends b.CharacterClassifier{constructor(P){super(0);for(let D=0,k=P.length;D<k;D++)this.set(P.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=T;function A(y){let P={};return D=>(P.hasOwnProperty(D)||(P[D]=y(D)),P[D])}e.getMapForWordSeparators=A(y=>new T(y))}),define(me[49],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class b{constructor(T,A){this.lineNumber=T,this.column=A}with(T=this.lineNumber,A=this.column){return T===this.lineNumber&&A===this.column?this:new b(T,A)}delta(T=0,A=0){return this.with(this.lineNumber+T,this.column+A)}equals(T){return b.equals(this,T)}static equals(T,A){return!T&&!A?!0:!!T&&!!A&&T.lineNumber===A.lineNumber&&T.column===A.column}isBefore(T){return b.isBefore(this,T)}static isBefore(T,A){return T.lineNumber<A.lineNumber?!0:A.lineNumber<T.lineNumber?!1:T.column<A.column}isBeforeOrEqual(T){return b.isBeforeOrEqual(this,T)}static isBeforeOrEqual(T,A){return T.lineNumber<A.lineNumber?!0:A.lineNumber<T.lineNumber?!1:T.column<=A.column}static compare(T,A){let y=T.lineNumber|0,P=A.lineNumber|0;if(y===P){let D=T.column|0,k=A.column|0;return D-k}return y-P}clone(){return new b(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(T){return new b(T.lineNumber,T.column)}static isIPosition(T){return T&&typeof T.lineNumber=="number"&&typeof T.column=="number"}}e.Position=b}),define(me[44],ge([0,1,49]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class I{constructor(A,y,P,D){A>P||A===P&&y>D?(this.startLineNumber=P,this.startColumn=D,this.endLineNumber=A,this.endColumn=y):(this.startLineNumber=A,this.startColumn=y,this.endLineNumber=P,this.endColumn=D)}isEmpty(){return I.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return I.containsPosition(this,A)}static containsPosition(A,y){return!(y.lineNumber<A.startLineNumber||y.lineNumber>A.endLineNumber||y.lineNumber===A.startLineNumber&&y.column<A.startColumn||y.lineNumber===A.endLineNumber&&y.column>A.endColumn)}containsRange(A){return I.containsRange(this,A)}static containsRange(A,y){return!(y.startLineNumber<A.startLineNumber||y.endLineNumber<A.startLineNumber||y.startLineNumber>A.endLineNumber||y.endLineNumber>A.endLineNumber||y.startLineNumber===A.startLineNumber&&y.startColumn<A.startColumn||y.endLineNumber===A.endLineNumber&&y.endColumn>A.endColumn)}strictContainsRange(A){return I.strictContainsRange(this,A)}static strictContainsRange(A,y){return!(y.startLineNumber<A.startLineNumber||y.endLineNumber<A.startLineNumber||y.startLineNumber>A.endLineNumber||y.endLineNumber>A.endLineNumber||y.startLineNumber===A.startLineNumber&&y.startColumn<=A.startColumn||y.endLineNumber===A.endLineNumber&&y.endColumn>=A.endColumn)}plusRange(A){return I.plusRange(this,A)}static plusRange(A,y){let P,D,k,i;return y.startLineNumber<A.startLineNumber?(P=y.startLineNumber,D=y.startColumn):y.startLineNumber===A.startLineNumber?(P=y.startLineNumber,D=Math.min(y.startColumn,A.startColumn)):(P=A.startLineNumber,D=A.startColumn),y.endLineNumber>A.endLineNumber?(k=y.endLineNumber,i=y.endColumn):y.endLineNumber===A.endLineNumber?(k=y.endLineNumber,i=Math.max(y.endColumn,A.endColumn)):(k=A.endLineNumber,i=A.endColumn),new I(P,D,k,i)}intersectRanges(A){return I.intersectRanges(this,A)}static intersectRanges(A,y){let P=A.startLineNumber,D=A.startColumn,k=A.endLineNumber,i=A.endColumn,C=y.startLineNumber,f=y.startColumn,m=y.endLineNumber,l=y.endColumn;return P<C?(P=C,D=f):P===C&&(D=Math.max(D,f)),k>m?(k=m,i=l):k===m&&(i=Math.min(i,l)),P>k||P===k&&D>i?null:new I(P,D,k,i)}equalsRange(A){return I.equalsRange(this,A)}static equalsRange(A,y){return!!A&&!!y&&A.startLineNumber===y.startLineNumber&&A.startColumn===y.startColumn&&A.endLineNumber===y.endLineNumber&&A.endColumn===y.endColumn}getEndPosition(){return I.getEndPosition(this)}static getEndPosition(A){return new b.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return I.getStartPosition(this)}static getStartPosition(A){return new b.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,y){return new I(this.startLineNumber,this.startColumn,A,y)}setStartPosition(A,y){return new I(A,y,this.endLineNumber,this.endColumn)}collapseToStart(){return I.collapseToStart(this)}static collapseToStart(A){return new I(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}static fromPositions(A,y=A){return new I(A.lineNumber,A.column,y.lineNumber,y.column)}static lift(A){return A?new I(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,y){return!(A.endLineNumber<y.startLineNumber||A.endLineNumber===y.startLineNumber&&A.endColumn<y.startColumn||y.endLineNumber<A.startLineNumber||y.endLineNumber===A.startLineNumber&&y.endColumn<A.startColumn)}static areIntersecting(A,y){return!(A.endLineNumber<y.startLineNumber||A.endLineNumber===y.startLineNumber&&A.endColumn<=y.startColumn||y.endLineNumber<A.startLineNumber||y.endLineNumber===A.startLineNumber&&y.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,y){if(A&&y){const k=A.startLineNumber|0,i=y.startLineNumber|0;if(k===i){const C=A.startColumn|0,f=y.startColumn|0;if(C===f){const m=A.endLineNumber|0,l=y.endLineNumber|0;if(m===l){const d=A.endColumn|0,E=y.endColumn|0;return d-E}return m-l}return C-f}return k-i}return(A?1:0)-(y?1:0)}static compareRangesUsingEnds(A,y){return A.endLineNumber===y.endLineNumber?A.endColumn===y.endColumn?A.startLineNumber===y.startLineNumber?A.startColumn-y.startColumn:A.startLineNumber-y.startLineNumber:A.endColumn-y.endColumn:A.endLineNumber-y.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}}e.Range=I}),define(me[139],ge([0,1,49,44]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var T;(function(y){y[y.LTR=0]="LTR",y[y.RTL=1]="RTL"})(T=e.SelectionDirection||(e.SelectionDirection={}));class A extends I.Range{constructor(P,D,k,i){super(P,D,k,i);this.selectionStartLineNumber=P,this.selectionStartColumn=D,this.positionLineNumber=k,this.positionColumn=i}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(P){return A.selectionsEqual(this,P)}static selectionsEqual(P,D){return P.selectionStartLineNumber===D.selectionStartLineNumber&&P.selectionStartColumn===D.selectionStartColumn&&P.positionLineNumber===D.positionLineNumber&&P.positionColumn===D.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(P,D){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,P,D):new A(P,D,this.startLineNumber,this.startColumn)}getPosition(){return new b.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(P,D){return this.getDirection()===0?new A(P,D,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,P,D)}static fromPositions(P,D=P){return new A(P.lineNumber,P.column,D.lineNumber,D.column)}static liftSelection(P){return new A(P.selectionStartLineNumber,P.selectionStartColumn,P.positionLineNumber,P.positionColumn)}static selectionsArrEqual(P,D){if(P&&!D||!P&&D)return!1;if(!P&&!D)return!0;if(P.length!==D.length)return!1;for(let k=0,i=P.length;k<i;k++)if(!this.selectionsEqual(P[k],D[k]))return!1;return!0}static isISelection(P){return P&&typeof P.selectionStartLineNumber=="number"&&typeof P.selectionStartColumn=="number"&&typeof P.positionLineNumber=="number"&&typeof P.positionColumn=="number"}static createWithDirection(P,D,k,i,C){return C===0?new A(P,D,k,i):new A(k,i,P,D)}}e.Selection=A}),define(me[109],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var b;(function(m){m[m.Left=1]="Left",m[m.Center=2]="Center",m[m.Right=4]="Right",m[m.Full=7]="Full"})(b=e.OverviewRulerLane||(e.OverviewRulerLane={}));var I;(function(m){m[m.Inline=1]="Inline",m[m.Gutter=2]="Gutter"})(I=e.MinimapPosition||(e.MinimapPosition={}));var T;(function(m){m[m.TextDefined=0]="TextDefined",m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(T=e.EndOfLinePreference||(e.EndOfLinePreference={}));var A;(function(m){m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(A=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(m){m[m.LF=0]="LF",m[m.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class P{constructor(l){this.tabSize=Math.max(1,l.tabSize|0),this.indentSize=l.tabSize|0,this.insertSpaces=Boolean(l.insertSpaces),this.defaultEOL=l.defaultEOL|0,this.trimAutoWhitespace=Boolean(l.trimAutoWhitespace)}equals(l){return this.tabSize===l.tabSize&&this.indentSize===l.indentSize&&this.insertSpaces===l.insertSpaces&&this.defaultEOL===l.defaultEOL&&this.trimAutoWhitespace===l.trimAutoWhitespace}createChangeEvent(l){return{tabSize:this.tabSize!==l.tabSize,indentSize:this.indentSize!==l.indentSize,insertSpaces:this.insertSpaces!==l.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==l.trimAutoWhitespace}}}e.TextModelResolvedOptions=P;class D{constructor(l,d){this.range=l,this.matches=d}}e.FindMatch=D;var k;(function(m){m[m.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",m[m.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",m[m.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",m[m.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var i;(function(m){m[m.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(i=e.ModelConstants||(e.ModelConstants={}));class C{constructor(l,d,E,w,S,g){this.identifier=l,this.range=d,this.text=E,this.forceMoveMarkers=w,this.isAutoWhitespaceEdit=S,this._isTracked=g}}e.ValidAnnotatedEditOperation=C;class f{constructor(l,d,E){this.reverseEdits=l,this.changes=d,this.trimAutoWhitespaceLineNumbers=E}}e.ApplyEditsResult=f}),define(me[140],ge([0,1,9,138,49,44,109]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const P=999;class D{constructor(g,a,v,t){this.searchString=g,this.isRegex=a,this.matchCase=v,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let g;this.isRegex?g=k(this.searchString):g=this.searchString.indexOf(`
`)>=0;let a=null;try{a=b.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:g,global:!0,unicode:!0})}catch(t){return null}if(!a)return null;let v=!this.isRegex&&!g;return v&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(v=this.matchCase),new i(a,this.wordSeparators?(0,I.getMapForWordSeparators)(this.wordSeparators):null,v?this.searchString:null)}}e.SearchParams=D;function k(S){if(!S||S.length===0)return!1;for(let g=0,a=S.length;g<a;g++)if(S.charCodeAt(g)===92){if(g++,g>=a)break;const t=S.charCodeAt(g);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=k;class i{constructor(g,a,v){this.regex=g,this.wordSeparators=a,this.simpleSearch=v}}e.SearchData=i;function C(S,g,a){if(!a)return new y.FindMatch(S,null);let v=[];for(let t=0,n=g.length;t<n;t++)v[t]=g[t];return new y.FindMatch(S,v)}e.createFindMatch=C;class f{constructor(g){let a=[],v=0;for(let t=0,n=g.length;t<n;t++)g.charCodeAt(t)===10&&(a[v++]=t);this._lineFeedsOffsets=a}findLineFeedCountBeforeOffset(g){const a=this._lineFeedsOffsets;let v=0,t=a.length-1;if(t===-1||g<=a[0])return 0;for(;v<t;){const n=v+((t-v)/2>>0);a[n]>=g?t=n-1:a[n+1]>=g?(v=n,t=n):v=n+1}return v+1}}class m{static findMatches(g,a,v,t,n){const o=a.parseSearchRequest();return o?o.regex.multiline?this._doFindMatchesMultiline(g,v,new w(o.wordSeparators,o.regex),t,n):this._doFindMatchesLineByLine(g,v,o,t,n):[]}static _getMultilineMatchRange(g,a,v,t,n,o){let r,s=0;t?(s=t.findLineFeedCountBeforeOffset(n),r=a+n+s):r=a+n;let c;if(t){let p=t.findLineFeedCountBeforeOffset(n+o.length)-s;c=r+o.length+p}else c=r+o.length;const h=g.getPositionAt(r),_=g.getPositionAt(c);return new A.Range(h.lineNumber,h.column,_.lineNumber,_.column)}static _doFindMatchesMultiline(g,a,v,t,n){const o=g.getOffsetAt(a.getStartPosition()),r=g.getValueInRange(a,1),s=g.getEOL()===`\r
`?new f(r):null,c=[];let h=0,_;for(v.reset(0);_=v.next(r);)if(c[h++]=C(this._getMultilineMatchRange(g,o,r,s,_.index,_[0]),_,t),h>=n)return c;return c}static _doFindMatchesLineByLine(g,a,v,t,n){const o=[];let r=0;if(a.startLineNumber===a.endLineNumber){const c=g.getLineContent(a.startLineNumber).substring(a.startColumn-1,a.endColumn-1);return r=this._findMatchesInLine(v,c,a.startLineNumber,a.startColumn-1,r,o,t,n),o}const s=g.getLineContent(a.startLineNumber).substring(a.startColumn-1);r=this._findMatchesInLine(v,s,a.startLineNumber,a.startColumn-1,r,o,t,n);for(let c=a.startLineNumber+1;c<a.endLineNumber&&r<n;c++)r=this._findMatchesInLine(v,g.getLineContent(c),c,0,r,o,t,n);if(r<n){const c=g.getLineContent(a.endLineNumber).substring(0,a.endColumn-1);r=this._findMatchesInLine(v,c,a.endLineNumber,0,r,o,t,n)}return o}static _findMatchesInLine(g,a,v,t,n,o,r,s){const c=g.wordSeparators;if(!r&&g.simpleSearch){const u=g.simpleSearch,p=u.length,R=a.length;let O=-p;for(;(O=a.indexOf(u,O+p))!==-1;)if((!c||E(c,a,R,O,p))&&(o[n++]=new y.FindMatch(new A.Range(v,O+1+t,v,O+1+p+t),null),n>=s))return n;return n}const h=new w(g.wordSeparators,g.regex);let _;h.reset(0);do if(_=h.next(a),_&&(o[n++]=C(new A.Range(v,_.index+1+t,v,_.index+1+_[0].length+t),_,r),n>=s))return n;while(_);return n}static findNextMatch(g,a,v,t){const n=a.parseSearchRequest();if(!n)return null;const o=new w(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindNextMatchMultiline(g,v,o,t):this._doFindNextMatchLineByLine(g,v,o,t)}static _doFindNextMatchMultiline(g,a,v,t){const n=new T.Position(a.lineNumber,1),o=g.getOffsetAt(n),r=g.getLineCount(),s=g.getValueInRange(new A.Range(n.lineNumber,n.column,r,g.getLineMaxColumn(r)),1),c=g.getEOL()===`\r
`?new f(s):null;v.reset(a.column-1);let h=v.next(s);return h?C(this._getMultilineMatchRange(g,o,s,c,h.index,h[0]),h,t):a.lineNumber!==1||a.column!==1?this._doFindNextMatchMultiline(g,new T.Position(1,1),v,t):null}static _doFindNextMatchLineByLine(g,a,v,t){const n=g.getLineCount(),o=a.lineNumber,r=g.getLineContent(o),s=this._findFirstMatchInLine(v,r,o,a.column,t);if(s)return s;for(let c=1;c<=n;c++){const h=(o+c-1)%n,_=g.getLineContent(h+1),u=this._findFirstMatchInLine(v,_,h+1,1,t);if(u)return u}return null}static _findFirstMatchInLine(g,a,v,t,n){g.reset(t-1);const o=g.next(a);return o?C(new A.Range(v,o.index+1,v,o.index+1+o[0].length),o,n):null}static findPreviousMatch(g,a,v,t){const n=a.parseSearchRequest();if(!n)return null;const o=new w(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindPreviousMatchMultiline(g,v,o,t):this._doFindPreviousMatchLineByLine(g,v,o,t)}static _doFindPreviousMatchMultiline(g,a,v,t){const n=this._doFindMatchesMultiline(g,new A.Range(1,1,a.lineNumber,a.column),v,t,10*P);if(n.length>0)return n[n.length-1];const o=g.getLineCount();return a.lineNumber!==o||a.column!==g.getLineMaxColumn(o)?this._doFindPreviousMatchMultiline(g,new T.Position(o,g.getLineMaxColumn(o)),v,t):null}static _doFindPreviousMatchLineByLine(g,a,v,t){const n=g.getLineCount(),o=a.lineNumber,r=g.getLineContent(o).substring(0,a.column-1),s=this._findLastMatchInLine(v,r,o,t);if(s)return s;for(let c=1;c<=n;c++){const h=(n+o-c-1)%n,_=g.getLineContent(h+1),u=this._findLastMatchInLine(v,_,h+1,t);if(u)return u}return null}static _findLastMatchInLine(g,a,v,t){let n=null,o;for(g.reset(0);o=g.next(a);)n=C(new A.Range(v,o.index+1,v,o.index+1+o[0].length),o,t);return n}}e.TextModelSearch=m;function l(S,g,a,v,t){if(v===0)return!0;const n=g.charCodeAt(v-1);if(S.get(n)!==0||n===13||n===10)return!0;if(t>0){const o=g.charCodeAt(v);if(S.get(o)!==0)return!0}return!1}function d(S,g,a,v,t){if(v+t===a)return!0;const n=g.charCodeAt(v+t);if(S.get(n)!==0||n===13||n===10)return!0;if(t>0){const o=g.charCodeAt(v+t-1);if(S.get(o)!==0)return!0}return!1}function E(S,g,a,v,t){return l(S,g,a,v,t)&&d(S,g,a,v,t)}e.isValidMatch=E;class w{constructor(g,a){this._wordSeparators=g,this._searchRegex=a,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(g){this._searchRegex.lastIndex=g,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(g){const a=g.length;let v;do{if(this._prevMatchStartIndex+this._prevMatchLength===a||(v=this._searchRegex.exec(g),!v))return null;const t=v.index,n=v[0].length;if(t===this._prevMatchStartIndex&&n===this._prevMatchLength){if(n===0){b.getNextCodePoint(g,a,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=n,!this._wordSeparators||E(this._wordSeparators,g,a,t,n))return v}while(v);return null}}e.Searcher=w}),define(me[110],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function b(P=""){let D="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.USUAL_WORD_SEPARATORS)P.indexOf(k)>=0||(D+="\\"+k);return D+="\\s]+)",new RegExp(D,"g")}e.DEFAULT_WORD_REGEXP=b();function I(P){let D=e.DEFAULT_WORD_REGEXP;if(P&&P instanceof RegExp)if(P.global)D=P;else{let k="g";P.ignoreCase&&(k+="i"),P.multiline&&(k+="m"),P.unicode&&(k+="u"),D=new RegExp(P.source,k)}return D.lastIndex=0,D}e.ensureValidWordDefinition=I;const T={maxLen:1e3,windowSize:15,timeBudget:150};function A(P,D,k,i,C=T){if(k.length>C.maxLen){let E=P-C.maxLen/2;return E<0?E=0:i+=E,k=k.substring(E,P+C.maxLen/2),A(P,D,k,i,C)}const f=Date.now(),m=P-1-i;let l=-1,d=null;for(let E=1;!(Date.now()-f>=C.timeBudget);E++){const w=m-C.windowSize*E;D.lastIndex=Math.max(0,w);const S=y(D,k,m,l);if(!S&&d||(d=S,w<=0))break;l=w}if(d){let E={word:d[0],startColumn:i+1+d.index,endColumn:i+1+d.index+d[0].length};return D.lastIndex=0,E}return null}e.getWordAtText=A;function y(P,D,k,i){let C;for(;C=P.exec(D);){const f=C.index||0;if(f<=k&&P.lastIndex>=k)return C;if(i>0&&f>i)return null}return null}}),define(me[141],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var b;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(b=e.IndentAction||(e.IndentAction={}));class I{constructor(P){if(this.open=P.open,this.close=P.close,this._standardTokenMask=0,Array.isArray(P.notIn))for(let D=0,k=P.notIn.length;D<k;D++)switch(P.notIn[D]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(P){return(this._standardTokenMask&P)==0}}e.StandardAutoClosingPairConditional=I;class T{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of P)A(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),A(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),A(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),A(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&A(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=T;function A(y,P,D){y.has(P)?y.get(P).push(D):y.set(P,[D])}}),define(me[77],ge([0,1,33,8]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function T(A,y,P,D){if(Array.isArray(A)){let k=0;for(const i of A){const C=T(i,y,P,D);if(C===10)return C;C>k&&(k=C)}return k}else{if(typeof A=="string")return D?A==="*"?5:A===P?10:0:0;if(A){const{language:k,pattern:i,scheme:C,hasAccessToAllModels:f}=A;if(!D&&!f)return 0;let m=0;if(C)if(C===y.scheme)m=10;else if(C==="*")m=5;else return 0;if(k)if(k===P)m=10;else if(k==="*")m=Math.max(m,5);else return 0;if(i){let l;if(typeof i=="string"?l=i:l=Object.assign(Object.assign({},i),{base:(0,I.normalize)(i.base)}),l===y.fsPath||(0,b.match)(l,y.fsPath))m=10;else return 0}return m}else return 0}}e.score=T}),define(me[142],ge([0,1,108]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var I;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(I=e.State||(e.State={}));class T{constructor(l,d,E){const w=new Uint8Array(l*d);for(let S=0,g=l*d;S<g;S++)w[S]=E;this._data=w,this.rows=l,this.cols=d}get(l,d){return this._data[l*this.cols+d]}set(l,d,E){this._data[l*this.cols+d]=E}}e.Uint8Matrix=T;class A{constructor(l){let d=0,E=0;for(let S=0,g=l.length;S<g;S++){let[a,v,t]=l[S];v>d&&(d=v),a>E&&(E=a),t>E&&(E=t)}d++,E++;let w=new T(E,d,0);for(let S=0,g=l.length;S<g;S++){let[a,v,t]=l[S];w.set(a,v,t)}this._states=w,this._maxCharCode=d}nextState(l,d){return d<0||d>=this._maxCharCode?0:this._states.get(l,d)}}e.StateMachine=A;let y=null;function P(){return y===null&&(y=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),y}var D;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(D||(D={}));let k=null;function i(){if(k===null){k=new b.CharacterClassifier(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let d=0;d<m.length;d++)k.set(m.charCodeAt(d),1);const l=".,;";for(let d=0;d<l.length;d++)k.set(l.charCodeAt(d),2)}return k}class C{static _createLink(l,d,E,w,S){let g=S-1;do{const a=d.charCodeAt(g);if(l.get(a)!==2)break;g--}while(g>w);if(w>0){const a=d.charCodeAt(w-1),v=d.charCodeAt(g);(a===40&&v===41||a===91&&v===93||a===123&&v===125)&&g--}return{range:{startLineNumber:E,startColumn:w+1,endLineNumber:E,endColumn:g+2},url:d.substring(w,g+1)}}static computeLinks(l,d=P()){const E=i();let w=[];for(let S=1,g=l.getLineCount();S<=g;S++){const a=l.getLineContent(S),v=a.length;let t=0,n=0,o=0,r=1,s=!1,c=!1,h=!1,_=!1;for(;t<v;){let u=!1;const p=a.charCodeAt(t);if(r===13){let R;switch(p){case 40:s=!0,R=0;break;case 41:R=s?0:1;break;case 91:h=!0,c=!0,R=0;break;case 93:h=!1,R=c?0:1;break;case 123:_=!0,R=0;break;case 125:R=_?0:1;break;case 39:R=o===34||o===96?0:1;break;case 34:R=o===39||o===96?0:1;break;case 96:R=o===39||o===34?0:1;break;case 42:R=o===42?1:0;break;case 124:R=o===124?1:0;break;case 32:R=h?0:1;break;default:R=E.get(p)}R===1&&(w.push(C._createLink(E,a,S,n,t)),u=!0)}else if(r===12){let R;p===91?(c=!0,R=0):R=E.get(p),R===1?u=!0:r=13}else r=d.nextState(r,p),r===0&&(u=!0);u&&(r=1,s=!1,c=!1,_=!1,n=t+1,o=p),t++}r===13&&w.push(C._createLink(E,a,S,n,v))}return w}}e.LinkComputer=C;function f(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:C.computeLinks(m)}e.computeLinks=f}),define(me[143],ge([0,1,3,6]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class T{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new b.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(y){this._onDidChange.fire({changedLanguages:y,changedColorMap:!1})}register(y,P){return this._map.set(y,P),this.fire([y]),(0,I.toDisposable)(()=>{this._map.get(y)===P&&(this._map.delete(y),this.fire([y]))})}registerPromise(y,P){let D=null,k=!1;return this._promises.set(y,P.then(i=>{this._promises.delete(y),!(k||!i)&&(D=this.register(y,i))})),(0,I.toDisposable)(()=>{k=!0,D&&D.dispose()})}getPromise(y){const P=this.get(y);if(P)return Promise.resolve(P);const D=this._promises.get(y);return D?D.then(k=>this.get(y)):null}get(y){return this._map.get(y)||null}setColorMap(y){this._colorMap=y,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=T}),define(me[111],ge([0,1,23,10]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var T;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(T||(T={}));function A(C){for(let f=0,m=C.length;f<m;f+=4){const l=C[f+0],d=C[f+1],E=C[f+2],w=C[f+3];C[f+0]=w,C[f+1]=E,C[f+2]=d,C[f+3]=l}}function y(C){const f=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return I.isLittleEndian()||A(f),b.VSBuffer.wrap(f)}function P(C){const f=C.buffer;if(I.isLittleEndian()||A(f),f.byteOffset%4==0)return new Uint32Array(f.buffer,f.byteOffset,f.length/4);{const m=new Uint8Array(f.byteLength);return m.set(f),new Uint32Array(m.buffer,m.byteOffset,m.length/4)}}function D(C){const f=new Uint32Array(k(C));let m=0;if(f[m++]=C.id,C.type==="full")f[m++]=1,f[m++]=C.data.length,f.set(C.data,m),m+=C.data.length;else{f[m++]=2,f[m++]=C.deltas.length;for(const l of C.deltas)f[m++]=l.start,f[m++]=l.deleteCount,l.data?(f[m++]=l.data.length,f.set(l.data,m),m+=l.data.length):f[m++]=0}return y(f)}e.encodeSemanticTokensDto=D;function k(C){let f=0;if(f+=1+1,C.type==="full")f+=1+C.data.length;else{f+=1,f+=(1+1+1)*C.deltas.length;for(const m of C.deltas)m.data&&(f+=m.data.length)}return f}function i(C){const f=P(C);let m=0;const l=f[m++];if(f[m++]===1){const S=f[m++],g=f.subarray(m,m+S);return m+=S,{id:l,type:"full",data:g}}const E=f[m++];let w=[];for(let S=0;S<E;S++){const g=f[m++],a=f[m++],v=f[m++];let t;v>0&&(t=f.subarray(m,m+v),m+=v),w[S]={start:g,deleteCount:a,data:t}}return{id:l,type:"delta",deltas:w}}e.decodeSemanticTokensDto=i}),define(me[112],ge([0,1,97]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class I{constructor(y,P){this.index=y,this.remainder=P}}e.PrefixSumIndexOfResult=I;class T{constructor(y){this.values=y,this.prefixSum=new Uint32Array(y.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(y,P){y=(0,b.toUint32)(y);const D=this.values,k=this.prefixSum,i=P.length;return i===0?!1:(this.values=new Uint32Array(D.length+i),this.values.set(D.subarray(0,y),0),this.values.set(D.subarray(y),y+i),this.values.set(P,y),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(y,P){return y=(0,b.toUint32)(y),P=(0,b.toUint32)(P),this.values[y]===P?!1:(this.values[y]=P,y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),!0)}removeValues(y,P){y=(0,b.toUint32)(y),P=(0,b.toUint32)(P);const D=this.values,k=this.prefixSum;if(y>=D.length)return!1;let i=D.length-y;return P>=i&&(P=i),P===0?!1:(this.values=new Uint32Array(D.length-P),this.values.set(D.subarray(0,y),0),this.values.set(D.subarray(y+P),y),this.prefixSum=new Uint32Array(this.values.length),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(y){return y<0?0:(y=(0,b.toUint32)(y),this._getAccumulatedValue(y))}_getAccumulatedValue(y){if(y<=this.prefixSumValidIndex[0])return this.prefixSum[y];let P=this.prefixSumValidIndex[0]+1;P===0&&(this.prefixSum[0]=this.values[0],P++),y>=this.values.length&&(y=this.values.length-1);for(let D=P;D<=y;D++)this.prefixSum[D]=this.prefixSum[D-1]+this.values[D];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],y),this.prefixSum[y]}getIndexOf(y){y=Math.floor(y),this.getTotalValue();let P=0,D=this.values.length-1,k=0,i=0,C=0;for(;P<=D;)if(k=P+(D-P)/2|0,i=this.prefixSum[k],C=i-this.values[k],y<C)D=k-1;else if(y>=i)P=k+1;else break;return new I(k,y-C)}}e.PrefixSumComputer=T}),define(me[144],ge([0,1,9,49,112]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(P,D,k,i){this._uri=P,this._lines=D,this._eol=k,this._versionId=i,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(P){P.eol&&P.eol!==this._eol&&(this._eol=P.eol,this._lineStarts=null);const D=P.changes;for(const k of D)this._acceptDeleteRange(k.range),this._acceptInsertText(new I.Position(k.range.startLineNumber,k.range.startColumn),k.text);this._versionId=P.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const P=this._eol.length,D=this._lines.length,k=new Uint32Array(D);for(let i=0;i<D;i++)k[i]=this._lines[i].length+P;this._lineStarts=new T.PrefixSumComputer(k)}}_setLineText(P,D){this._lines[P]=D,this._lineStarts&&this._lineStarts.changeValue(P,this._lines[P].length+this._eol.length)}_acceptDeleteRange(P){if(P.startLineNumber===P.endLineNumber){if(P.startColumn===P.endColumn)return;this._setLineText(P.startLineNumber-1,this._lines[P.startLineNumber-1].substring(0,P.startColumn-1)+this._lines[P.startLineNumber-1].substring(P.endColumn-1));return}this._setLineText(P.startLineNumber-1,this._lines[P.startLineNumber-1].substring(0,P.startColumn-1)+this._lines[P.endLineNumber-1].substring(P.endColumn-1)),this._lines.splice(P.startLineNumber,P.endLineNumber-P.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(P.startLineNumber,P.endLineNumber-P.startLineNumber)}_acceptInsertText(P,D){if(D.length!==0){let k=(0,b.splitLines)(D);if(k.length===1){this._setLineText(P.lineNumber-1,this._lines[P.lineNumber-1].substring(0,P.column-1)+k[0]+this._lines[P.lineNumber-1].substring(P.column-1));return}k[k.length-1]+=this._lines[P.lineNumber-1].substring(P.column-1),this._setLineText(P.lineNumber-1,this._lines[P.lineNumber-1].substring(0,P.column-1)+k[0]);let i=new Uint32Array(k.length-1);for(let C=1;C<k.length;C++)this._lines.splice(P.lineNumber+C-1,0,k[C]),i[C-1]=k[C].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(P.lineNumber,i)}}}e.MirrorTextModel=A}),define(me[145],ge([18,19]),function(G,e){return G.create("vs/base/common/date",e)}),define(me[146],ge([0,1,145]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const I=60,T=I*60,A=T*24,y=A*7,P=A*30,D=A*365;function k(C,f){typeof C!="number"&&(C=C.getTime());const m=Math.round((new Date().getTime()-C)/1e3);if(m<-30)return(0,b.localize)(0,null,k(new Date().getTime()+m*1e3,!1));if(m<30)return(0,b.localize)(1,null);let l;return m<I?(l=m,f?l===1?(0,b.localize)(2,null,l):(0,b.localize)(3,null,l):l===1?(0,b.localize)(4,null,l):(0,b.localize)(5,null,l)):m<T?(l=Math.floor(m/I),f?l===1?(0,b.localize)(6,null,l):(0,b.localize)(7,null,l):l===1?(0,b.localize)(8,null,l):(0,b.localize)(9,null,l)):m<A?(l=Math.floor(m/T),f?l===1?(0,b.localize)(10,null,l):(0,b.localize)(11,null,l):l===1?(0,b.localize)(12,null,l):(0,b.localize)(13,null,l)):m<y?(l=Math.floor(m/A),f?l===1?(0,b.localize)(14,null,l):(0,b.localize)(15,null,l):l===1?(0,b.localize)(16,null,l):(0,b.localize)(17,null,l)):m<P?(l=Math.floor(m/y),f?l===1?(0,b.localize)(18,null,l):(0,b.localize)(19,null,l):l===1?(0,b.localize)(20,null,l):(0,b.localize)(21,null,l)):m<D?(l=Math.floor(m/P),f?l===1?(0,b.localize)(22,null,l):(0,b.localize)(23,null,l):l===1?(0,b.localize)(24,null,l):(0,b.localize)(25,null,l)):(l=Math.floor(m/D),f?l===1?(0,b.localize)(26,null,l):(0,b.localize)(27,null,l):l===1?(0,b.localize)(28,null,l):(0,b.localize)(29,null,l))}e.fromNow=k;function i(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(me[147],ge([18,19]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(me[60],ge([0,1,147,11,17]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(k,i){return i&&(k.stack||k.stacktrace)?b.localize(0,null,P(k),y(k.stack)||y(k.stacktrace)):P(k)}function y(k){return Array.isArray(k)?k.join(`
`):k}function P(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?b.localize(1,null,k.message):k.message||b.localize(2,null)}function D(k=null,i=!1){if(!k)return b.localize(3,null);if(Array.isArray(k)){const C=T.coalesce(k),f=D(C[0],i);return C.length>1?b.localize(4,null,f,C.length):f}if(I.isString(k))return k;if(k.detail){const C=k.detail;if(C.error)return A(C.error,i);if(C.exception)return A(C.exception,i)}return k.stack?A(k,i):k.message?k.message:b.localize(5,null)}e.toErrorMessage=D}),define(me[148],ge([18,19]),function(G,e){return G.create("vs/base/node/processes",e)}),define(me[78],ge([0,1,8,37,26,38,148,36,11,24,29,10,137,12]),function(G,e,b,I,T,A,y,P,D,k,i,C,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function l(v){switch(v){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(v,t){if(C.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};t&&(n.cwd=t);const o=A.execFile("taskkill",["/T","/F","/PID",v.pid.toString()],n);return new Promise(r=>{o.once("error",s=>{r({success:!1,error:s})}),o.once("exit",(s,c)=>{r(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?l(n.status):1})}else if(C.isLinux||C.isMacintosh)try{const n=m.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",G).fsPath;return new Promise(o=>{A.execFile(n,[v.pid.toString()],{encoding:"utf8",shell:!0},(r,s,c)=>{o(r?{success:!1,error:r}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else v.kill("SIGKILL");return Promise.resolve({success:!0})}function E(v=P.env){return v.comspec||"cmd.exe"}e.getWindowsShell=E;class w{constructor(t,n,o,r){if(n!==void 0&&o!==void 0&&r!==void 0)this.cmd=t,this.args=n,this.shell=o,this.options=r;else{const s=t;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(P.env).forEach(c=>{s[c]=P.env[c]}),Object.keys(this.options.env).forEach(c=>{s[c]=this.options.env[c]}),this.options.env=s}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const n=t.lastIndexOf(b.sep);return n!==-1&&(t=t.substring(n+1)),w.WellKnowCommands[t]?t:"other"}start(t){return C.isWindows&&(this.options&&this.options.cwd&&i.isUNC(this.options.cwd)||!this.options&&i.isUNC(P.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(n=>{let o,r;const s=new Promise((c,h)=>{o=c,r=h});if(n){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=A.exec(c,this.options,(h,_,u)=>{this.childProcess=null;const p=h;p&&p.killed?r({killed:this.terminateRequested,stdout:_.toString(),stderr:u.toString()}):this.handleExec(o,t,h,_,u)})}else{let c=null;const h=_=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(_,o,t,r);const u={terminated:this.terminateRequested};D.isNumber(_)&&(u.cmdCode=_),o(u)};if(this.shell&&C.isWindows){const _=k.deepClone(this.options);_.windowsVerbatimArguments=!0,_.detached=!1;let u=!1,p=!1;const R=[];let O=this.ensureQuotes(this.cmd);R.push(O.value),u=O.quoted,this.args&&this.args.forEach(ie=>{O=this.ensureQuotes(ie),R.push(O.value),p=p&&O.quoted});const j=["/s","/c"];u?p?j.push('"'+R.join(" ")+'"'):R.length>1?j.push('"'+R[0]+'" '+R.slice(1).join(" ")):j.push('"'+R[0]+'"'):j.push(R.join(" ")),c=A.spawn(E(),j,_)}else this.cmd&&(c=A.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(D.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",_=>{this.childProcess=null,r({terminated:this.terminateRequested,error:_})}),c.pid&&(this.childProcess.on("close",h),this.handleSpawn(c,o,t,r,!0)))}return s})}handleClose(t,n,o,r){}ensureQuotes(t){return w.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,d(t,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!C.isWindows)return t(!1);const n=A.spawn(E(),["/s","/c"]);n.on("error",o=>t(!0)),n.on("exit",o=>t(!1))})}}e.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class S extends w{constructor(t,n,o,r){super(t,n,o,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,n,o,r,s){[r,s].forEach((c,h)=>{const _=new f.LineDecoder;_.write(c).forEach(R=>{n({line:R,source:h===0?0:1})});const p=_.end();p&&n({line:p,source:h===0?0:1})}),t({terminated:this.terminateRequested,error:o})}handleSpawn(t,n,o,r,s){const c=new f.LineDecoder,h=new f.LineDecoder;t.stdout.on("data",_=>{c.write(_).forEach(p=>o({line:p,source:0}))}),t.stderr.on("data",_=>{h.write(_).forEach(p=>o({line:p,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=h}handleClose(t,n,o,r){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&o({line:s,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&o({line:c,source:1})}}e.LineProcess=S;function g(v){let t=[],n=!1;const o=function(r){if(n){t.push(r);return}(!v.send(r,c=>{if(c&&console.error(c),n=!1,t.length>0){const h=t.slice(0);t=[],h.forEach(_=>o(_))}})||C.isWindows)&&(n=!0)};return{send:o}}e.createQueuedSender=g;var a;(function(v){async function t(n,o,r){if(b.isAbsolute(n))return n;if(o===void 0&&(o=P.cwd()),b.dirname(n)!=="."||(r===void 0&&D.isString(P.env.PATH)&&(r=P.env.PATH.split(b.delimiter)),r===void 0||r.length===0))return b.join(o,n);async function c(h){return await T.exists(h)?!(await I.promises.stat(h)).isDirectory():!1}for(let h of r){let _;if(b.isAbsolute(h)?_=b.join(h,n):_=b.join(o,h,n),await c(_))return _;let u=_+".com";if(await c(u)||(u=_+".exe",await c(u)))return u}return b.join(o,n)}v.findExecutable=t})(a=e.win32||(e.win32={}))}),define(me[149],ge([0,1,48,10,105,78]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function y(m,l){return m===1?I.isWindows?C():A.getWindowsShell(l):k(m,l)}e.getSystemShell=y;function P(m,l){return m===1?I.isWindows?f(l):A.getWindowsShell(l):k(m,l)}e.getSystemShellSync=P;let D=null;function k(m,l){if(I.isLinux&&m===2||I.isMacintosh&&m===3)return"/bin/bash";if(!D){let d;if(I.isWindows)d="/bin/bash";else{if(d=l.SHELL,!d)try{d=(0,b.userInfo)().shell}catch(E){}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}D=d}return D}let i=null;async function C(){return i||(i=(await(0,T.getFirstAvailablePowerShellInstallation)()).exePath),i}function f(m){if(i)return i;const l=I.isWindows&&parseFloat((0,b.release)())>=10,d=m.hasOwnProperty("PROCESSOR_ARCHITEW6432"),E=`${m.windir}\\${d?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return l?E:A.getWindowsShell(m)}}),define(me[150],ge([18,19]),function(G,e){return G.create("vs/editor/common/config/editorOptions",e)}),define(me[151],ge([0,1,150,10,110]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var A;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(A=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(ne){this._values=ne}hasChanged(ne){return this._values[ne]}}e.ConfigurationChangedEvent=y;class P{constructor(){this._values=[]}_read(ne){return this._values[ne]}get(ne){return this._values[ne]}_write(ne,we){this._values[ne]=we}}e.ValidatedEditorOptions=P;class D{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=D;class k{constructor(ne,we,xe,je){this.id=ne,this.name=we,this.defaultValue=xe,this.schema=je}compute(ne,we,xe){return xe}}class i{constructor(ne,we=null){this.schema=void 0,this.id=ne,this.name="_never_",this.defaultValue=void 0,this.deps=we}validate(ne){return this.defaultValue}}class C{constructor(ne,we,xe,je){this.id=ne,this.name=we,this.defaultValue=xe,this.schema=je}validate(ne){return typeof ne=="undefined"?this.defaultValue:ne}compute(ne,we,xe){return xe}}function f(X,ne){return typeof X=="undefined"?ne:X==="false"?!1:Boolean(X)}e.boolean=f;class m extends C{constructor(ne,we,xe,je=void 0){typeof je!="undefined"&&(je.type="boolean",je.default=xe),super(ne,we,xe,je)}validate(ne){return f(ne,this.defaultValue)}}class l extends C{constructor(ne,we,xe,je,Ve,Ze=void 0){typeof Ze!="undefined"&&(Ze.type="integer",Ze.default=xe,Ze.minimum=je,Ze.maximum=Ve),super(ne,we,xe,Ze),this.minimum=je,this.maximum=Ve}static clampedInt(ne,we,xe,je){if(typeof ne=="undefined")return we;let Ve=parseInt(ne,10);return isNaN(Ve)?we:(Ve=Math.max(xe,Ve),Ve=Math.min(je,Ve),Ve|0)}validate(ne){return l.clampedInt(ne,this.defaultValue,this.minimum,this.maximum)}}class d extends C{constructor(ne,we,xe,je,Ve){typeof Ve!="undefined"&&(Ve.type="number",Ve.default=xe),super(ne,we,xe,Ve),this.validationFn=je}static clamp(ne,we,xe){return ne<we?we:ne>xe?xe:ne}static float(ne,we){if(typeof ne=="number")return ne;if(typeof ne=="undefined")return we;const xe=parseFloat(ne);return isNaN(xe)?we:xe}validate(ne){return this.validationFn(d.float(ne,this.defaultValue))}}class E extends C{static string(ne,we){return typeof ne!="string"?we:ne}constructor(ne,we,xe,je=void 0){typeof je!="undefined"&&(je.type="string",je.default=xe),super(ne,we,xe,je)}validate(ne){return E.string(ne,this.defaultValue)}}function w(X,ne,we){return typeof X!="string"||we.indexOf(X)===-1?ne:X}e.stringSet=w;class S extends C{constructor(ne,we,xe,je,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="string",Ve.enum=je,Ve.default=xe),super(ne,we,xe,Ve),this._allowedValues=je}validate(ne){return w(ne,this.defaultValue,this._allowedValues)}}class g extends k{constructor(ne,we,xe,je,Ve,Ze,De=void 0){typeof De!="undefined"&&(De.type="string",De.enum=Ve,De.default=je),super(ne,we,xe,De),this._allowedValues=Ve,this._convert=Ze}validate(ne){return typeof ne!="string"?this.defaultValue:this._allowedValues.indexOf(ne)===-1?this.defaultValue:this._convert(ne)}}function a(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class v extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",description:b.localize(3,null)})}validate(ne){switch(ne){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ne,we,xe){return xe===0?ne.accessibilitySupport:xe}}class t extends k{constructor(){const ne={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",ne,{"editor.comments.insertSpace":{type:"boolean",default:ne.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ne.ignoreEmptyLines,description:b.localize(5,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const we=ne;return{insertSpace:f(we.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:f(we.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function o(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var r;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(r=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function s(X){switch(X){case r.Line:return"line";case r.Block:return"block";case r.Underline:return"underline";case r.LineThin:return"line-thin";case r.BlockOutline:return"block-outline";case r.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=s;function c(X){switch(X){case"line":return r.Line;case"block":return r.Block;case"underline":return r.Underline;case"line-thin":return r.LineThin;case"block-outline":return r.BlockOutline;case"underline-thin":return r.UnderlineThin}}class h extends i{constructor(){super(123,[62,31])}compute(ne,we,xe){const je=["monaco-editor"];return we.get(31)&&je.push(we.get(31)),ne.extraEditorClassName&&je.push(ne.extraEditorClassName),we.get(62)==="default"?je.push("mouse-default"):we.get(62)==="copy"&&je.push("mouse-copy"),we.get(97)&&je.push("showUnused"),we.get(121)&&je.push("showDeprecated"),je.join(" ")}}class _ extends m{constructor(){super(30,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(ne,we,xe){return xe&&ne.emptySelectionClipboard}}class u extends k{constructor(){const ne={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",ne,{"editor.find.cursorMoveOnType":{type:"boolean",default:ne.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:ne.seedSearchStringFromSelection,description:b.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ne.autoFindInSelection,enumDescriptions:[b.localize(9,null),b.localize(10,null),b.localize(11,null)],description:b.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ne.globalFindClipboard,description:b.localize(13,null),included:I.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ne.addExtraSpaceOnTop,description:b.localize(14,null)},"editor.find.loop":{type:"boolean",default:ne.loop,description:b.localize(15,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const we=ne;return{cursorMoveOnType:f(we.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:f(we.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof ne.autoFindInSelection=="boolean"?ne.autoFindInSelection?"always":"never":w(we.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:f(we.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:f(we.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:f(we.loop,this.defaultValue.loop)}}}class p extends k{constructor(){super(41,"fontLigatures",p.OFF,{anyOf:[{type:"boolean",description:b.localize(16,null)},{type:"string",description:b.localize(17,null)}],description:b.localize(18,null),default:!1})}validate(ne){return typeof ne=="undefined"?this.defaultValue:typeof ne=="string"?ne==="false"?p.OFF:ne==="true"?p.ON:ne:Boolean(ne)?p.ON:p.OFF}}e.EditorFontLigatures=p,p.OFF='"liga" off, "calt" off',p.ON='"liga" on, "calt" on';class R extends i{constructor(){super(40)}compute(ne,we,xe){return ne.fontInfo}}class O extends C{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(19,null)})}validate(ne){let we=d.float(ne,this.defaultValue);return we===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(we,6,100)}compute(ne,we,xe){return ne.fontInfo.fontSize}}class j extends k{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:j.MINIMUM_VALUE,maximum:j.MAXIMUM_VALUE,errorMessage:b.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:j.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(21,null)})}validate(ne){return ne==="normal"||ne==="bold"?ne:String(l.clampedInt(ne,e.EDITOR_FONT_DEFAULTS.fontWeight,j.MINIMUM_VALUE,j.MAXIMUM_VALUE))}}j.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],j.MINIMUM_VALUE=1,j.MAXIMUM_VALUE=1e3;class ie extends k{constructor(){const ne={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},we={type:"string",enum:["peek","gotoAndPeek","goto"],default:ne.multiple,enumDescriptions:[b.localize(22,null),b.localize(23,null),b.localize(24,null)]},xe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",ne,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:b.localize(26,null)},we),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:b.localize(27,null)},we),"editor.gotoLocation.multipleDeclarations":Object.assign({description:b.localize(28,null)},we),"editor.gotoLocation.multipleImplementations":Object.assign({description:b.localize(29,null)},we),"editor.gotoLocation.multipleReferences":Object.assign({description:b.localize(30,null)},we),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ne.alternativeDefinitionCommand,enum:xe,description:b.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ne.alternativeTypeDefinitionCommand,enum:xe,description:b.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ne.alternativeDeclarationCommand,enum:xe,description:b.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ne.alternativeImplementationCommand,enum:xe,description:b.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ne.alternativeReferenceCommand,enum:xe,description:b.localize(35,null)}})}validate(ne){var we,xe,je,Ve,Ze;if(!ne||typeof ne!="object")return this.defaultValue;const De=ne;return{multiple:w(De.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(we=De.multipleDefinitions)!==null&&we!==void 0?we:w(De.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(xe=De.multipleTypeDefinitions)!==null&&xe!==void 0?xe:w(De.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(je=De.multipleDeclarations)!==null&&je!==void 0?je:w(De.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(Ve=De.multipleImplementations)!==null&&Ve!==void 0?Ve:w(De.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Ze=De.multipleReferences)!==null&&Ze!==void 0?Ze:w(De.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:E.string(De.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:E.string(De.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:E.string(De.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:E.string(De.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:E.string(De.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class K extends k{constructor(){const ne={enabled:!0,delay:300,sticky:!0};super(50,"hover",ne,{"editor.hover.enabled":{type:"boolean",default:ne.enabled,description:b.localize(36,null)},"editor.hover.delay":{type:"number",default:ne.delay,description:b.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:ne.sticky,description:b.localize(38,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const we=ne;return{enabled:f(we.enabled,this.defaultValue.enabled),delay:l.clampedInt(we.delay,this.defaultValue.delay,0,1e4),sticky:f(we.sticky,this.defaultValue.sticky)}}}var x;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(x=e.RenderMinimap||(e.RenderMinimap={}));class $ extends i{constructor(){super(126,[46,54,35,61,89,56,57,91,113,116,117,118,2])}compute(ne,we,xe){return $.computeLayout(we,{memory:ne.memory,outerWidth:ne.outerWidth,outerHeight:ne.outerHeight,isDominatedByLongLines:ne.isDominatedByLongLines,lineHeight:ne.fontInfo.lineHeight,viewLineCount:ne.viewLineCount,lineNumbersDigitCount:ne.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ne.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ne.fontInfo.maxDigitWidth,pixelRatio:ne.pixelRatio})}static computeContainedMinimapLineCount(ne){const we=ne.height/ne.lineHeight,xe=ne.scrollBeyondLastLine?we-1:0,je=(ne.viewLineCount+xe)/(ne.pixelRatio*ne.height),Ve=Math.floor(ne.viewLineCount/je);return{typicalViewportLineCount:we,extraLinesBeyondLastLine:xe,desiredRatio:je,minimapLineCount:Ve}}static _computeMinimapLayout(ne,we){const xe=ne.outerWidth,je=ne.outerHeight,Ve=ne.pixelRatio;if(!ne.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ve*je),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:je};const Ze=we.stableMinimapLayoutInput,De=Ze&&ne.outerHeight===Ze.outerHeight&&ne.lineHeight===Ze.lineHeight&&ne.typicalHalfwidthCharacterWidth===Ze.typicalHalfwidthCharacterWidth&&ne.pixelRatio===Ze.pixelRatio&&ne.scrollBeyondLastLine===Ze.scrollBeyondLastLine&&ne.minimap.enabled===Ze.minimap.enabled&&ne.minimap.side===Ze.minimap.side&&ne.minimap.size===Ze.minimap.size&&ne.minimap.showSlider===Ze.minimap.showSlider&&ne.minimap.renderCharacters===Ze.minimap.renderCharacters&&ne.minimap.maxColumn===Ze.minimap.maxColumn&&ne.minimap.scale===Ze.minimap.scale&&ne.verticalScrollbarWidth===Ze.verticalScrollbarWidth&&ne.isViewportWrapping===Ze.isViewportWrapping,ye=ne.lineHeight,Pe=ne.typicalHalfwidthCharacterWidth,oe=ne.scrollBeyondLastLine,ue=ne.minimap.renderCharacters;let H=Ve>=2?Math.round(ne.minimap.scale*2):ne.minimap.scale;const Z=ne.minimap.maxColumn,ce=ne.minimap.size,Ie=ne.minimap.side,Ae=ne.verticalScrollbarWidth,Le=ne.viewLineCount,$e=ne.remainingWidth,Xe=ne.isViewportWrapping,rt=ue?2:3;let tt=Math.floor(Ve*je);const Qe=tt/Ve;let mt=!1,wt=!1,be=rt*H,he=H/Ve,ae=1;if(ce==="fill"||ce==="fit"){const{typicalViewportLineCount:ht,extraLinesBeyondLastLine:Je,desiredRatio:at,minimapLineCount:ft}=$.computeContainedMinimapLineCount({viewLineCount:Le,scrollBeyondLastLine:oe,height:je,lineHeight:ye,pixelRatio:Ve});if(Le/ft>1)mt=!0,wt=!0,H=1,be=1,he=H/Ve;else{let St=!1,vt=H+1;if(ce==="fit"){const Pt=Math.ceil((Le+Je)*be);Xe&&De&&$e<=we.stableFitRemainingWidth?(St=!0,vt=we.stableFitMaxMinimapScale):(St=Pt>tt,Xe&&St?(we.stableMinimapLayoutInput=ne,we.stableFitRemainingWidth=$e):(we.stableMinimapLayoutInput=null,we.stableFitRemainingWidth=0))}if(ce==="fill"||St){mt=!0;const Pt=H;be=Math.min(ye*Ve,Math.max(1,Math.floor(1/at))),H=Math.min(vt,Math.max(1,Math.floor(be/rt))),H>Pt&&(ae=Math.min(2,H/Pt)),he=H/Ve/ae,tt=Math.ceil(Math.max(ht,Le+Je)*be),Xe&&St&&(we.stableFitMaxMinimapScale=H)}}}const J=Math.floor(Z*he),Ne=Math.min(J,Math.max(0,Math.floor(($e-Ae-2)*he/(Pe+he)))+e.MINIMAP_GUTTER_WIDTH);let Fe=Math.floor(Ve*Ne);const Ye=Fe/Ve;Fe=Math.floor(Fe*ae);const et=ue?1:2,ut=Ie==="left"?0:xe-Ne-Ae;return{renderMinimap:et,minimapLeft:ut,minimapWidth:Ne,minimapHeightIsEditorHeight:mt,minimapIsSampling:wt,minimapScale:H,minimapLineHeight:be,minimapCanvasInnerWidth:Fe,minimapCanvasInnerHeight:tt,minimapCanvasOuterWidth:Ye,minimapCanvasOuterHeight:Qe}}static computeLayout(ne,we){const xe=we.outerWidth|0,je=we.outerHeight|0,Ve=we.lineHeight|0,Ze=we.lineNumbersDigitCount|0,De=we.typicalHalfwidthCharacterWidth,ye=we.maxDigitWidth,Pe=we.pixelRatio,oe=we.viewLineCount,ue=ne.get(118),H=ue==="inherit"?ne.get(117):ue,Z=H==="inherit"?ne.get(113):H,ce=ne.get(116),Ie=ne.get(2),Ae=we.isDominatedByLongLines,Le=ne.get(46),$e=ne.get(56).renderType!==0,Xe=ne.get(57),rt=ne.get(91),tt=ne.get(61),Qe=ne.get(89),mt=Qe.verticalScrollbarSize,wt=Qe.verticalHasArrows,be=Qe.arrowSize,he=Qe.horizontalScrollbarSize,ae=ne.get(54),J=ne.get(35);let Ne;if(typeof ae=="string"&&/^\d+(\.\d+)?ch$/.test(ae)){const _t=parseFloat(ae.substr(0,ae.length-2));Ne=l.clampedInt(_t*De,0,0,1e3)}else Ne=l.clampedInt(ae,0,0,1e3);J&&(Ne+=16);let Fe=0;if($e){const _t=Math.max(Ze,Xe);Fe=Math.round(_t*ye)}let Ye=0;Le&&(Ye=Ve);let et=0,ut=et+Ye,ht=ut+Fe,Je=ht+Ne;const at=xe-Ye-Fe-Ne;let ft=!1,lt=!1,St=-1;Ie!==2&&(H==="inherit"&&Ae?(ft=!0,lt=!0):Z==="on"||Z==="bounded"?lt=!0:Z==="wordWrapColumn"&&(St=ce));const vt=$._computeMinimapLayout({outerWidth:xe,outerHeight:je,lineHeight:Ve,typicalHalfwidthCharacterWidth:De,pixelRatio:Pe,scrollBeyondLastLine:rt,minimap:tt,verticalScrollbarWidth:mt,viewLineCount:oe,remainingWidth:at,isViewportWrapping:lt},we.memory||new D);vt.renderMinimap!==0&&vt.minimapLeft===0&&(et+=vt.minimapWidth,ut+=vt.minimapWidth,ht+=vt.minimapWidth,Je+=vt.minimapWidth);const Pt=at-vt.minimapWidth,Tt=Math.max(1,Math.floor((Pt-mt-2)/De)),Rt=wt?be:0;return lt&&(St=Math.max(1,Tt),Z==="bounded"&&(St=Math.min(St,ce))),{width:xe,height:je,glyphMarginLeft:et,glyphMarginWidth:Ye,lineNumbersLeft:ut,lineNumbersWidth:Fe,decorationsLeft:ht,decorationsWidth:Ne,contentLeft:Je,contentWidth:Pt,minimap:vt,viewportColumn:Tt,isWordWrapMinified:ft,isViewportWrapping:lt,wrappingColumn:St,verticalScrollbarWidth:mt,horizontalScrollbarHeight:he,overviewRuler:{top:Rt,width:mt,height:je-2*Rt,right:0}}}}e.EditorLayoutInfoComputer=$;class U extends k{constructor(){const ne={enabled:!0};super(53,"lightbulb",ne,{"editor.lightbulb.enabled":{type:"boolean",default:ne.enabled,description:b.localize(39,null)}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{enabled:f(ne.enabled,this.defaultValue.enabled)}}}class L extends k{constructor(){const ne={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(122,"inlayHints",ne,{"editor.inlayHints.enabled":{type:"boolean",default:ne.enabled,description:b.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:ne.fontSize,description:b.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:ne.fontFamily,description:b.localize(42,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const we=ne;return{enabled:f(we.enabled,this.defaultValue.enabled),fontSize:l.clampedInt(we.fontSize,this.defaultValue.fontSize,0,100),fontFamily:E.string(we.fontFamily,this.defaultValue.fontFamily)}}}class N extends l{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:b.localize(43,null)})}compute(ne,we,xe){return ne.fontInfo.lineHeight}}class M extends k{constructor(){const ne={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",ne,{"editor.minimap.enabled":{type:"boolean",default:ne.enabled,description:b.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(45,null),b.localize(46,null),b.localize(47,null)],default:ne.size,description:b.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ne.side,description:b.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ne.showSlider,description:b.localize(50,null)},"editor.minimap.scale":{type:"number",default:ne.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ne.renderCharacters,description:b.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:ne.maxColumn,description:b.localize(53,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const we=ne;return{enabled:f(we.enabled,this.defaultValue.enabled),size:w(we.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(we.side,this.defaultValue.side,["right","left"]),showSlider:w(we.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:f(we.renderCharacters,this.defaultValue.renderCharacters),scale:l.clampedInt(we.scale,1,1,3),maxColumn:l.clampedInt(we.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function F(X){return X==="ctrlCmd"?I.isMacintosh?"metaKey":"ctrlKey":"altKey"}class W extends k{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(55,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const we=ne;return{top:l.clampedInt(we.top,0,0,1e3),bottom:l.clampedInt(we.bottom,0,0,1e3)}}}class q extends k{constructor(){const ne={enabled:!0,cycle:!1};super(72,"parameterHints",ne,{"editor.parameterHints.enabled":{type:"boolean",default:ne.enabled,description:b.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:ne.cycle,description:b.localize(57,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const we=ne;return{enabled:f(we.enabled,this.defaultValue.enabled),cycle:f(we.cycle,this.defaultValue.cycle)}}}class Q extends i{constructor(){super(124)}compute(ne,we,xe){return ne.pixelRatio}}class le extends k{constructor(){const ne={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",ne,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ne.strings,description:b.localize(58,null)},comments:{type:"boolean",default:ne.comments,description:b.localize(59,null)},other:{type:"boolean",default:ne.other,description:b.localize(60,null)}}}],default:ne,description:b.localize(61,null)});this.defaultValue=ne}validate(ne){if(typeof ne=="boolean")return ne;if(ne&&typeof ne=="object"){const we=ne,xe={other:f(we.other,this.defaultValue.other),comments:f(we.comments,this.defaultValue.comments),strings:f(we.strings,this.defaultValue.strings)};return xe.other&&xe.comments&&xe.strings?!0:!xe.other&&!xe.comments&&!xe.strings?!1:xe}return this.defaultValue}}var ve;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(ve=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Re extends k{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(62,null),b.localize(63,null),b.localize(64,null),b.localize(65,null)],default:"on",description:b.localize(66,null)})}validate(ne){let we=this.defaultValue.renderType,xe=this.defaultValue.renderFn;return typeof ne!="undefined"&&(typeof ne=="function"?(we=4,xe=ne):ne==="interval"?we=3:ne==="relative"?we=2:ne==="on"?we=1:we=0),{renderType:we,renderFn:xe}}}function Se(X){const ne=X.get(84);return ne==="editable"?X.get(77):ne!=="on"}e.filterValidationDecorations=Se;class Oe extends k{constructor(){const ne=[],we={type:"number",description:b.localize(67,null)};super(88,"rulers",ne,{type:"array",items:{anyOf:[we,{type:["object"],properties:{column:we,color:{type:"string",description:b.localize(68,null),format:"color-hex"}}}]},default:ne,description:b.localize(69,null)})}validate(ne){if(Array.isArray(ne)){let we=[];for(let xe of ne)if(typeof xe=="number")we.push({column:l.clampedInt(xe,0,0,1e4),color:null});else if(xe&&typeof xe=="object"){const je=xe;we.push({column:l.clampedInt(je.column,0,0,1e4),color:je.color})}return we.sort((xe,je)=>xe.column-je.column),we}return this.defaultValue}}function z(X,ne){if(typeof X!="string")return ne;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class Y extends k{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const we=ne,xe=l.clampedInt(we.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),je=l.clampedInt(we.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:l.clampedInt(we.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:z(we.vertical,this.defaultValue.vertical),horizontal:z(we.horizontal,this.defaultValue.horizontal),useShadows:f(we.useShadows,this.defaultValue.useShadows),verticalHasArrows:f(we.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:f(we.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:f(we.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:f(we.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:xe,horizontalSliderSize:l.clampedInt(we.horizontalSliderSize,xe,0,1e3),verticalScrollbarSize:je,verticalSliderSize:l.clampedInt(we.verticalSliderSize,je,0,1e3),scrollByPage:f(we.scrollByPage,this.defaultValue.scrollByPage)}}}class ee extends k{constructor(){const ne={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",ne,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(70,null),b.localize(71,null)],default:ne.insertMode,description:b.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ne.filterGraceful,description:b.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:ne.localityBonus,description:b.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ne.shareSuggestSelections,markdownDescription:b.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ne.snippetsPreventQuickSuggestions,description:b.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:ne.showIcons,description:b.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ne.showStatusBar,description:b.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ne.showInlineDetails,description:b.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(109,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const we=ne;return{insertMode:w(we.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:f(we.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:f(we.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:f(we.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:f(we.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:f(we.showIcons,this.defaultValue.showIcons),showStatusBar:f(we.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:f(we.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:f(we.showMethods,this.defaultValue.showMethods),showFunctions:f(we.showFunctions,this.defaultValue.showFunctions),showConstructors:f(we.showConstructors,this.defaultValue.showConstructors),showFields:f(we.showFields,this.defaultValue.showFields),showVariables:f(we.showVariables,this.defaultValue.showVariables),showClasses:f(we.showClasses,this.defaultValue.showClasses),showStructs:f(we.showStructs,this.defaultValue.showStructs),showInterfaces:f(we.showInterfaces,this.defaultValue.showInterfaces),showModules:f(we.showModules,this.defaultValue.showModules),showProperties:f(we.showProperties,this.defaultValue.showProperties),showEvents:f(we.showEvents,this.defaultValue.showEvents),showOperators:f(we.showOperators,this.defaultValue.showOperators),showUnits:f(we.showUnits,this.defaultValue.showUnits),showValues:f(we.showValues,this.defaultValue.showValues),showConstants:f(we.showConstants,this.defaultValue.showConstants),showEnums:f(we.showEnums,this.defaultValue.showEnums),showEnumMembers:f(we.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:f(we.showKeywords,this.defaultValue.showKeywords),showWords:f(we.showWords,this.defaultValue.showWords),showColors:f(we.showColors,this.defaultValue.showColors),showFiles:f(we.showFiles,this.defaultValue.showFiles),showReferences:f(we.showReferences,this.defaultValue.showReferences),showFolders:f(we.showFolders,this.defaultValue.showFolders),showTypeParameters:f(we.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:f(we.showSnippets,this.defaultValue.showSnippets),showUsers:f(we.showUsers,this.defaultValue.showUsers),showIssues:f(we.showIssues,this.defaultValue.showIssues)}}}class se extends k{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(110,null),default:!0,type:"boolean"}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:f(ne.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class fe extends i{constructor(){super(125,[77])}compute(ne,we,xe){return we.get(77)?!0:ne.tabFocusMode}}var Ee;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(Ee=e.WrappingIndent||(e.WrappingIndent={}));function Be(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class pe extends i{constructor(){super(127,[126])}compute(ne,we,xe){const je=we.get(126);return{isDominatedByLongLines:ne.isDominatedByLongLines,isWordWrapMinified:je.isWordWrapMinified,isViewportWrapping:je.isViewportWrapping,wrappingColumn:je.wrappingColumn}}}const Ce="Consolas, 'Courier New', monospace",Me="Menlo, Monaco, 'Courier New', monospace",ze="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:I.isMacintosh?Me:I.isLinux?ze:Ce,fontWeight:"normal",fontSize:I.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function _e(X){return e.editorOptionsRegistry[X.id]=X,X}var Ke;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.autoClosingBrackets=5]="autoClosingBrackets",X[X.autoClosingDelete=6]="autoClosingDelete",X[X.autoClosingOvertype=7]="autoClosingOvertype",X[X.autoClosingQuotes=8]="autoClosingQuotes",X[X.autoIndent=9]="autoIndent",X[X.automaticLayout=10]="automaticLayout",X[X.autoSurround=11]="autoSurround",X[X.codeLens=12]="codeLens",X[X.codeLensFontFamily=13]="codeLensFontFamily",X[X.codeLensFontSize=14]="codeLensFontSize",X[X.colorDecorators=15]="colorDecorators",X[X.columnSelection=16]="columnSelection",X[X.comments=17]="comments",X[X.contextmenu=18]="contextmenu",X[X.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",X[X.cursorBlinking=20]="cursorBlinking",X[X.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",X[X.cursorStyle=22]="cursorStyle",X[X.cursorSurroundingLines=23]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",X[X.cursorWidth=25]="cursorWidth",X[X.disableLayerHinting=26]="disableLayerHinting",X[X.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",X[X.domReadOnly=28]="domReadOnly",X[X.dragAndDrop=29]="dragAndDrop",X[X.emptySelectionClipboard=30]="emptySelectionClipboard",X[X.extraEditorClassName=31]="extraEditorClassName",X[X.fastScrollSensitivity=32]="fastScrollSensitivity",X[X.find=33]="find",X[X.fixedOverflowWidgets=34]="fixedOverflowWidgets",X[X.folding=35]="folding",X[X.foldingStrategy=36]="foldingStrategy",X[X.foldingHighlight=37]="foldingHighlight",X[X.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=39]="fontFamily",X[X.fontInfo=40]="fontInfo",X[X.fontLigatures=41]="fontLigatures",X[X.fontSize=42]="fontSize",X[X.fontWeight=43]="fontWeight",X[X.formatOnPaste=44]="formatOnPaste",X[X.formatOnType=45]="formatOnType",X[X.glyphMargin=46]="glyphMargin",X[X.gotoLocation=47]="gotoLocation",X[X.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",X[X.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",X[X.hover=50]="hover",X[X.inDiffEditor=51]="inDiffEditor",X[X.letterSpacing=52]="letterSpacing",X[X.lightbulb=53]="lightbulb",X[X.lineDecorationsWidth=54]="lineDecorationsWidth",X[X.lineHeight=55]="lineHeight",X[X.lineNumbers=56]="lineNumbers",X[X.lineNumbersMinChars=57]="lineNumbersMinChars",X[X.linkedEditing=58]="linkedEditing",X[X.links=59]="links",X[X.matchBrackets=60]="matchBrackets",X[X.minimap=61]="minimap",X[X.mouseStyle=62]="mouseStyle",X[X.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=64]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",X[X.multiCursorModifier=66]="multiCursorModifier",X[X.multiCursorPaste=67]="multiCursorPaste",X[X.occurrencesHighlight=68]="occurrencesHighlight",X[X.overviewRulerBorder=69]="overviewRulerBorder",X[X.overviewRulerLanes=70]="overviewRulerLanes",X[X.padding=71]="padding",X[X.parameterHints=72]="parameterHints",X[X.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",X[X.quickSuggestions=75]="quickSuggestions",X[X.quickSuggestionsDelay=76]="quickSuggestionsDelay",X[X.readOnly=77]="readOnly",X[X.renameOnType=78]="renameOnType",X[X.renderControlCharacters=79]="renderControlCharacters",X[X.renderIndentGuides=80]="renderIndentGuides",X[X.renderFinalNewline=81]="renderFinalNewline",X[X.renderLineHighlight=82]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=84]="renderValidationDecorations",X[X.renderWhitespace=85]="renderWhitespace",X[X.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",X[X.roundedSelection=87]="roundedSelection",X[X.rulers=88]="rulers",X[X.scrollbar=89]="scrollbar",X[X.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=91]="scrollBeyondLastLine",X[X.scrollPredominantAxis=92]="scrollPredominantAxis",X[X.selectionClipboard=93]="selectionClipboard",X[X.selectionHighlight=94]="selectionHighlight",X[X.selectOnLineNumbers=95]="selectOnLineNumbers",X[X.showFoldingControls=96]="showFoldingControls",X[X.showUnused=97]="showUnused",X[X.snippetSuggestions=98]="snippetSuggestions",X[X.smartSelect=99]="smartSelect",X[X.smoothScrolling=100]="smoothScrolling",X[X.stickyTabStops=101]="stickyTabStops",X[X.stopRenderingLineAfter=102]="stopRenderingLineAfter",X[X.suggest=103]="suggest",X[X.suggestFontSize=104]="suggestFontSize",X[X.suggestLineHeight=105]="suggestLineHeight",X[X.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",X[X.suggestSelection=107]="suggestSelection",X[X.tabCompletion=108]="tabCompletion",X[X.tabIndex=109]="tabIndex",X[X.unusualLineTerminators=110]="unusualLineTerminators",X[X.useTabStops=111]="useTabStops",X[X.wordSeparators=112]="wordSeparators",X[X.wordWrap=113]="wordWrap",X[X.wordWrapBreakAfterCharacters=114]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=115]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=116]="wordWrapColumn",X[X.wordWrapOverride1=117]="wordWrapOverride1",X[X.wordWrapOverride2=118]="wordWrapOverride2",X[X.wrappingIndent=119]="wrappingIndent",X[X.wrappingStrategy=120]="wrappingStrategy",X[X.showDeprecated=121]="showDeprecated",X[X.inlayHints=122]="inlayHints",X[X.editorClassName=123]="editorClassName",X[X.pixelRatio=124]="pixelRatio",X[X.tabFocusMode=125]="tabFocusMode",X[X.layoutInfo=126]="layoutInfo",X[X.wrappingInfo=127]="wrappingInfo"})(Ke=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:_e(new m(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(111,null)})),acceptSuggestionOnEnter:_e(new S(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(112,null),""],markdownDescription:b.localize(113,null)})),accessibilitySupport:_e(new v),accessibilityPageSize:_e(new l(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(114,null)})),ariaLabel:_e(new E(4,"ariaLabel",b.localize(115,null))),autoClosingBrackets:_e(new S(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(116,null),b.localize(117,null),""],description:b.localize(118,null)})),autoClosingDelete:_e(new S(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(119,null),""],description:b.localize(120,null)})),autoClosingOvertype:_e(new S(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(121,null),""],description:b.localize(122,null)})),autoClosingQuotes:_e(new S(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(123,null),b.localize(124,null),""],description:b.localize(125,null)})),autoIndent:_e(new g(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],a,{enumDescriptions:[b.localize(126,null),b.localize(127,null),b.localize(128,null),b.localize(129,null),b.localize(130,null)],description:b.localize(131,null)})),automaticLayout:_e(new m(10,"automaticLayout",!1)),autoSurround:_e(new S(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(132,null),b.localize(133,null),b.localize(134,null),""],description:b.localize(135,null)})),stickyTabStops:_e(new m(101,"stickyTabStops",!1,{description:b.localize(136,null)})),codeLens:_e(new m(12,"codeLens",!0,{description:b.localize(137,null)})),codeLensFontFamily:_e(new E(13,"codeLensFontFamily","",{description:b.localize(138,null)})),codeLensFontSize:_e(new l(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:b.localize(139,null)})),colorDecorators:_e(new m(15,"colorDecorators",!0,{description:b.localize(140,null)})),columnSelection:_e(new m(16,"columnSelection",!1,{description:b.localize(141,null)})),comments:_e(new t),contextmenu:_e(new m(18,"contextmenu",!0)),copyWithSyntaxHighlighting:_e(new m(19,"copyWithSyntaxHighlighting",!0,{description:b.localize(142,null)})),cursorBlinking:_e(new g(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],o,{description:b.localize(143,null)})),cursorSmoothCaretAnimation:_e(new m(21,"cursorSmoothCaretAnimation",!1,{description:b.localize(144,null)})),cursorStyle:_e(new g(22,"cursorStyle",r.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],c,{description:b.localize(145,null)})),cursorSurroundingLines:_e(new l(23,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(146,null)})),cursorSurroundingLinesStyle:_e(new S(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(147,null),b.localize(148,null)],description:b.localize(149,null)})),cursorWidth:_e(new l(25,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(150,null)})),disableLayerHinting:_e(new m(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:_e(new m(27,"disableMonospaceOptimizations",!1)),domReadOnly:_e(new m(28,"domReadOnly",!1)),dragAndDrop:_e(new m(29,"dragAndDrop",!0,{description:b.localize(151,null)})),emptySelectionClipboard:_e(new _),extraEditorClassName:_e(new E(31,"extraEditorClassName","")),fastScrollSensitivity:_e(new d(32,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:b.localize(152,null)})),find:_e(new u),fixedOverflowWidgets:_e(new m(34,"fixedOverflowWidgets",!1)),folding:_e(new m(35,"folding",!0,{description:b.localize(153,null)})),foldingStrategy:_e(new S(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(154,null),b.localize(155,null)],description:b.localize(156,null)})),foldingHighlight:_e(new m(37,"foldingHighlight",!0,{description:b.localize(157,null)})),unfoldOnClickAfterEndOfLine:_e(new m(38,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(158,null)})),fontFamily:_e(new E(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(159,null)})),fontInfo:_e(new R),fontLigatures2:_e(new p),fontSize:_e(new O),fontWeight:_e(new j),formatOnPaste:_e(new m(44,"formatOnPaste",!1,{description:b.localize(160,null)})),formatOnType:_e(new m(45,"formatOnType",!1,{description:b.localize(161,null)})),glyphMargin:_e(new m(46,"glyphMargin",!0,{description:b.localize(162,null)})),gotoLocation:_e(new ie),hideCursorInOverviewRuler:_e(new m(48,"hideCursorInOverviewRuler",!1,{description:b.localize(163,null)})),highlightActiveIndentGuide:_e(new m(49,"highlightActiveIndentGuide",!0,{description:b.localize(164,null)})),hover:_e(new K),inDiffEditor:_e(new m(51,"inDiffEditor",!1)),letterSpacing:_e(new d(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>d.clamp(X,-5,20),{description:b.localize(165,null)})),lightbulb:_e(new U),lineDecorationsWidth:_e(new C(54,"lineDecorationsWidth",10)),lineHeight:_e(new N),lineNumbers:_e(new Re),lineNumbersMinChars:_e(new l(57,"lineNumbersMinChars",5,1,300)),linkedEditing:_e(new m(58,"linkedEditing",!1,{description:b.localize(166,null)})),links:_e(new m(59,"links",!0,{description:b.localize(167,null)})),matchBrackets:_e(new S(60,"matchBrackets","always",["always","near","never"],{description:b.localize(168,null)})),minimap:_e(new M),mouseStyle:_e(new S(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:_e(new d(63,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:b.localize(169,null)})),mouseWheelZoom:_e(new m(64,"mouseWheelZoom",!1,{markdownDescription:b.localize(170,null)})),multiCursorMergeOverlapping:_e(new m(65,"multiCursorMergeOverlapping",!0,{description:b.localize(171,null)})),multiCursorModifier:_e(new g(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],F,{markdownEnumDescriptions:[b.localize(172,null),b.localize(173,null)],markdownDescription:b.localize(174,null)})),multiCursorPaste:_e(new S(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(175,null),b.localize(176,null)],markdownDescription:b.localize(177,null)})),occurrencesHighlight:_e(new m(68,"occurrencesHighlight",!0,{description:b.localize(178,null)})),overviewRulerBorder:_e(new m(69,"overviewRulerBorder",!0,{description:b.localize(179,null)})),overviewRulerLanes:_e(new l(70,"overviewRulerLanes",3,0,3)),padding:_e(new W),parameterHints:_e(new q),peekWidgetDefaultFocus:_e(new S(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(180,null),b.localize(181,null)],description:b.localize(182,null)})),definitionLinkOpensInPeek:_e(new m(74,"definitionLinkOpensInPeek",!1,{description:b.localize(183,null)})),quickSuggestions:_e(new le),quickSuggestionsDelay:_e(new l(76,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(184,null)})),readOnly:_e(new m(77,"readOnly",!1)),renameOnType:_e(new m(78,"renameOnType",!1,{description:b.localize(185,null),markdownDeprecationMessage:b.localize(186,null)})),renderControlCharacters:_e(new m(79,"renderControlCharacters",!1,{description:b.localize(187,null)})),renderIndentGuides:_e(new m(80,"renderIndentGuides",!0,{description:b.localize(188,null)})),renderFinalNewline:_e(new m(81,"renderFinalNewline",!0,{description:b.localize(189,null)})),renderLineHighlight:_e(new S(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(190,null)],description:b.localize(191,null)})),renderLineHighlightOnlyWhenFocus:_e(new m(83,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(192,null)})),renderValidationDecorations:_e(new S(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:_e(new S(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(193,null),b.localize(194,null),b.localize(195,null),""],description:b.localize(196,null)})),revealHorizontalRightPadding:_e(new l(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:_e(new m(87,"roundedSelection",!0,{description:b.localize(197,null)})),rulers:_e(new Oe),scrollbar:_e(new Y),scrollBeyondLastColumn:_e(new l(90,"scrollBeyondLastColumn",5,0,1073741824,{description:b.localize(198,null)})),scrollBeyondLastLine:_e(new m(91,"scrollBeyondLastLine",!0,{description:b.localize(199,null)})),scrollPredominantAxis:_e(new m(92,"scrollPredominantAxis",!0,{description:b.localize(200,null)})),selectionClipboard:_e(new m(93,"selectionClipboard",!0,{description:b.localize(201,null),included:I.isLinux})),selectionHighlight:_e(new m(94,"selectionHighlight",!0,{description:b.localize(202,null)})),selectOnLineNumbers:_e(new m(95,"selectOnLineNumbers",!0)),showFoldingControls:_e(new S(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[b.localize(203,null),b.localize(204,null)],description:b.localize(205,null)})),showUnused:_e(new m(97,"showUnused",!0,{description:b.localize(206,null)})),showDeprecated:_e(new m(121,"showDeprecated",!0,{description:b.localize(207,null)})),inlayHints:_e(new L),snippetSuggestions:_e(new S(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(208,null),b.localize(209,null),b.localize(210,null),b.localize(211,null)],description:b.localize(212,null)})),smartSelect:_e(new se),smoothScrolling:_e(new m(100,"smoothScrolling",!1,{description:b.localize(213,null)})),stopRenderingLineAfter:_e(new l(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:_e(new ee),suggestFontSize:_e(new l(104,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(214,null)})),suggestLineHeight:_e(new l(105,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(215,null)})),suggestOnTriggerCharacters:_e(new m(106,"suggestOnTriggerCharacters",!0,{description:b.localize(216,null)})),suggestSelection:_e(new S(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(217,null),b.localize(218,null),b.localize(219,null)],description:b.localize(220,null)})),tabCompletion:_e(new S(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(221,null),b.localize(222,null),b.localize(223,null)],description:b.localize(224,null)})),tabIndex:_e(new l(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:_e(new S(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(225,null),b.localize(226,null),b.localize(227,null)],description:b.localize(228,null)})),useTabStops:_e(new m(111,"useTabStops",!0,{description:b.localize(229,null)})),wordSeparators:_e(new E(112,"wordSeparators",T.USUAL_WORD_SEPARATORS,{description:b.localize(230,null)})),wordWrap:_e(new S(113,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(231,null),b.localize(232,null),b.localize(233,null),b.localize(234,null)],description:b.localize(235,null)})),wordWrapBreakAfterCharacters:_e(new E(114,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:_e(new E(115,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:_e(new l(116,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(236,null)})),wordWrapOverride1:_e(new S(117,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:_e(new S(118,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:_e(new g(119,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Be,{enumDescriptions:[b.localize(237,null),b.localize(238,null),b.localize(239,null),b.localize(240,null)],description:b.localize(241,null)})),wrappingStrategy:_e(new S(120,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[b.localize(242,null),b.localize(243,null)],description:b.localize(244,null)})),editorClassName:_e(new h),pixelRatio:_e(new Q),tabFocusMode:_e(new fe),layoutInfo:_e(new $),wrappingInfo:_e(new pe)}}),define(me[152],ge([18,19]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(me[153],ge([18,19]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(me[154],ge([18,19]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(me[155],ge([18,19]),function(G,e){return G.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(me[156],ge([18,19]),function(G,e){return G.create("vs/platform/files/common/files",e)}),define(me[157],ge([18,19]),function(G,e){return G.create("vs/platform/markers/common/markers",e)}),define(me[158],ge([18,19]),function(G,e){return G.create("vs/platform/theme/common/iconRegistry",e)}),define(me[159],ge([18,19]),function(G,e){return G.create("vs/platform/workspaces/common/workspaces",e)}),define(me[160],ge([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHost.api.impl",e)}),define(me[161],ge([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(me[162],ge([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostExtensionService",e)}),define(me[163],ge([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostProgress",e)}),define(me[164],ge([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostStatusBar",e)}),define(me[165],ge([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostTerminalService",e)}),define(me[166],ge([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostTreeViews",e)}),define(me[167],ge([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostWorkspace",e)}),define(me[168],ge([18,19]),function(G,e){return G.create("vs/workbench/api/node/extHostDebugService",e)}),define(me[169],ge([18,19]),function(G,e){return G.create("vs/workbench/common/views",e)}),define(me[170],ge([18,19]),function(G,e){return G.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(me[171],ge([18,19]),function(G,e){return G.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(me[172],ge([18,19]),function(G,e){return G.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(me[173],ge([18,19]),function(G,e){return G.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(me[174],ge([18,19]),function(G,e){return G.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(me[175],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var b;(function(y){y[y.ACTIVATE=0]="ACTIVATE",y[y.RESTORE=1]="RESTORE",y[y.PRESERVE=2]="PRESERVE"})(b=e.EditorActivation||(e.EditorActivation={}));var I;(function(y){y[y.PICK=1]="PICK",y[y.DISABLED=2]="DISABLED"})(I=e.EditorOverride||(e.EditorOverride={}));var T;(function(y){y[y.API=0]="API",y[y.USER=1]="USER"})(T=e.EditorOpenContext||(e.EditorOpenContext={}));var A;(function(y){y[y.Center=0]="Center",y[y.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",y[y.NearTop=2]="NearTop",y[y.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(me[176],ge([0,1,154]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function T(C){return C=C.trim(),C==="*"||I.test(C)}e.isValidVersionStr=T;function A(C){if(!T(C))return null;if(C=C.trim(),C==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let f=C.match(I);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=A;function y(C){if(!C)return null;let f=C.majorBase,m=C.majorMustEqual,l=C.minorBase,d=C.minorMustEqual,E=C.patchBase,w=C.patchMustEqual;return C.hasCaret&&(f===0||(d=!1),w=!1),{majorBase:f,majorMustEqual:m,minorBase:l,minorMustEqual:d,patchBase:E,patchMustEqual:w,isMinimum:C.hasGreaterEquals}}e.normalizeVersion=y;function P(C,f){let m;typeof C=="string"?m=y(A(C)):m=C;let l;if(typeof f=="string"?l=y(A(f)):l=f,!m||!l)return!1;let d=m.majorBase,E=m.minorBase,w=m.patchBase,S=l.majorBase,g=l.minorBase,a=l.patchBase,v=l.majorMustEqual,t=l.minorMustEqual,n=l.patchMustEqual;return l.isMinimum?d>S?!0:d<S?!1:E>g?!0:E<g?!1:w>=a:(d===1&&S===0&&(!v||!t||!n)&&(S=1,g=0,a=0,v=!0,t=!1,n=!1),d<S?!1:d>S?!v:E<g?!1:E>g?!t:w<a?!1:w>a?!n:!0)}e.isValidVersion=P;function D(C,f,m){return f.isBuiltin||typeof f.main=="undefined"?!0:i(C,f.engines.vscode,m)}e.isValidExtensionVersion=D;function k(C,f){return C==="*"||i(f,C)}e.isEngineValid=k;function i(C,f,m=[]){let l=y(A(f));if(!l)return m.push(b.localize(0,null,f)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return m.push(b.localize(1,null,f)),!1}else if(!l.majorMustEqual)return m.push(b.localize(2,null,f)),!1;return P(C,l)?!0:(m.push(b.localize(3,null,C,f)),!1)}e.isVersionValid=i}),define(me[113],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class b{constructor(A,y=[],P=!1){this.ctor=A,this.staticArguments=y,this.supportsDelayedInstantiation=P}}e.SyncDescriptor=b;const I=(T,...A)=>new b(T,A);e.createSyncDescriptor=I}),define(me[79],ge([0,1,113]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const I=[];function T(y,P,D){P instanceof b.SyncDescriptor||(P=new b.SyncDescriptor(P,[],D)),I.push([y,P])}e.registerSingleton=T;function A(){return I}e.getSingletonServiceDescriptors=A}),define(me[177],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class b{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=b;class I{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let y of this._nodes.values())y.outgoing.size===0&&A.push(y);return A}insertEdge(A,y){const P=this.lookupOrInsertNode(A),D=this.lookupOrInsertNode(y);P.outgoing.set(this._hashFn(y),D),D.incoming.set(this._hashFn(A),P)}removeNode(A){const y=this._hashFn(A);this._nodes.delete(y);for(let P of this._nodes.values())P.outgoing.delete(y),P.incoming.delete(y)}lookupOrInsertNode(A){const y=this._hashFn(A);let P=this._nodes.get(y);return P||(P=new b(A),this._nodes.set(y,P)),P}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[y,P]of this._nodes)A.push(`${y}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,y]of this._nodes){const P=new Set([A]),D=this._findCycle(y,P);if(D)return D}}_findCycle(A,y){for(let[P,D]of A.outgoing){if(y.has(P))return[...y,P].join(" -> ");y.add(P);const k=this._findCycle(D,y);if(k)return k;y.delete(P)}}}e.Graph=I}),define(me[4],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var b;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function D(k){return k[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=D})(b=e._util||(e._util={})),e.IInstantiationService=T("instantiationService");function I(P,D,k,i){D[b.DI_TARGET]===D?D[b.DI_DEPENDENCIES].push({id:P,index:k,optional:i}):(D[b.DI_DEPENDENCIES]=[{id:P,index:k,optional:i}],D[b.DI_TARGET]=D)}function T(P){if(b.serviceIds.has(P))return b.serviceIds.get(P);const D=function(k,i,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");I(D,k,C,!1)};return D.toString=()=>P,b.serviceIds.set(P,D),D}e.createDecorator=T;function A(P){return P}e.refineServiceDecorator=A;function y(P){return function(D,k,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");I(P,D,i,!0)}}e.optional=y}),define(me[178],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,b.createDecorator)("modelService");function I(T){return!T.isTooLargeForSyncing()&&!T.isForSimpleWidget}e.shouldSynchronizeModel=I}),define(me[179],ge([0,1,3,74,6,22,73,77,178]),function(G,e,b,I,T,A,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function k(f){return typeof f=="string"?!1:Array.isArray(f)?f.every(k):!!f.exclusive}class i{constructor(){this._clock=0,this._entries=[],this._onDidChange=new b.Emitter}get onDidChange(){return this._onDidChange.event}register(m,l){let d={selector:m,provider:l,_score:-1,_time:this._clock++};return this._entries.push(d),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,T.toDisposable)(()=>{if(d){let E=this._entries.indexOf(d);E>=0&&(this._entries.splice(E,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),d=void 0)}})}has(m){return this.all(m).length>0}all(m){if(!m)return[];this._updateScores(m);const l=[];for(let d of this._entries)d._score>0&&l.push(d.provider);return l}ordered(m){const l=[];return this._orderedForEach(m,d=>l.push(d.provider)),l}orderedGroups(m){const l=[];let d,E;return this._orderedForEach(m,w=>{d&&E===w._score?d.push(w.provider):(E=w._score,d=[w.provider],l.push(d))}),l}_orderedForEach(m,l){if(!!m){this._updateScores(m);for(const d of this._entries)d._score>0&&l(d)}}_updateScores(m){let l={uri:m.uri.toString(),language:m.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===l.language&&this._lastCandidate.uri===l.uri)){this._lastCandidate=l;for(let d of this._entries)if(d._score=(0,P.score)(d.selector,m.uri,m.getLanguageIdentifier().language,(0,D.shouldSynchronizeModel)(m)),k(d.selector)&&d._score>0){for(let E of this._entries)E._score=0;d._score=1e3;break}this._entries.sort(i._compareByScoreAndTime)}}static _compareByScoreAndTime(m,l){return m._score<l._score?1:m._score>l._score?-1:m._time<l._time?1:m._time>l._time?-1:0}}e.LanguageFeatureRegistry=i;class C{constructor(m,l,d=Number.MAX_SAFE_INTEGER){this._registry=m,this.min=l,this.max=d,this._cache=new A.LRUCache(50,.7)}_key(m){return m.id+(0,I.hash)(this._registry.all(m))}_clamp(m){return m===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(m*1.3)))}get(m){const l=this._key(m),d=this._cache.get(l);return this._clamp(d==null?void 0:d.value)}update(m,l){const d=this._key(m);let E=this._cache.get(d);return E||(E=new y.MovingAverage,this._cache.set(d,E)),E.update(l),this.get(m)}}e.LanguageFeatureRequestDelays=C}),define(me[80],ge([0,1,2,44,179,143,43]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var P;(function(u){u[u.Null=0]="Null",u[u.PlainText=1]="PlainText"})(P=e.LanguageId||(e.LanguageId={}));class D{constructor(p,R){this.language=p,this.id=R}}e.LanguageIdentifier=D;var k;(function(u){u[u.NotSet=-1]="NotSet",u[u.None=0]="None",u[u.Italic=1]="Italic",u[u.Bold=2]="Bold",u[u.Underline=4]="Underline"})(k=e.FontStyle||(e.FontStyle={}));var i;(function(u){u[u.None=0]="None",u[u.DefaultForeground=1]="DefaultForeground",u[u.DefaultBackground=2]="DefaultBackground"})(i=e.ColorId||(e.ColorId={}));var C;(function(u){u[u.Other=0]="Other",u[u.Comment=1]="Comment",u[u.String=2]="String",u[u.RegEx=4]="RegEx"})(C=e.StandardTokenType||(e.StandardTokenType={}));var f;(function(u){u[u.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",u[u.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",u[u.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",u[u.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",u[u.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",u[u.ITALIC_MASK=2048]="ITALIC_MASK",u[u.BOLD_MASK=4096]="BOLD_MASK",u[u.UNDERLINE_MASK=8192]="UNDERLINE_MASK",u[u.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",u[u.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",u[u.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",u[u.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",u[u.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",u[u.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",u[u.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",u[u.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",u[u.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",u[u.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(f=e.MetadataConsts||(e.MetadataConsts={}));class m{static getLanguageId(p){return(p&255)>>>0}static getTokenType(p){return(p&1792)>>>8}static getFontStyle(p){return(p&14336)>>>11}static getForeground(p){return(p&8372224)>>>14}static getBackground(p){return(p&4286578688)>>>23}static getClassNameFromMetadata(p){let R=this.getForeground(p),O="mtk"+R,j=this.getFontStyle(p);return j&1&&(O+=" mtki"),j&2&&(O+=" mtkb"),j&4&&(O+=" mtku"),O}static getInlineStyleFromMetadata(p,R){const O=this.getForeground(p),j=this.getFontStyle(p);let ie=`color: ${R[O]};`;return j&1&&(ie+="font-style: italic;"),j&2&&(ie+="font-weight: bold;"),j&4&&(ie+="text-decoration: underline;"),ie}}e.TokenMetadata=m;var l;(function(u){u[u.Method=0]="Method",u[u.Function=1]="Function",u[u.Constructor=2]="Constructor",u[u.Field=3]="Field",u[u.Variable=4]="Variable",u[u.Class=5]="Class",u[u.Struct=6]="Struct",u[u.Interface=7]="Interface",u[u.Module=8]="Module",u[u.Property=9]="Property",u[u.Event=10]="Event",u[u.Operator=11]="Operator",u[u.Unit=12]="Unit",u[u.Value=13]="Value",u[u.Constant=14]="Constant",u[u.Enum=15]="Enum",u[u.EnumMember=16]="EnumMember",u[u.Keyword=17]="Keyword",u[u.Text=18]="Text",u[u.Color=19]="Color",u[u.File=20]="File",u[u.Reference=21]="Reference",u[u.Customcolor=22]="Customcolor",u[u.Folder=23]="Folder",u[u.TypeParameter=24]="TypeParameter",u[u.User=25]="User",u[u.Issue=26]="Issue",u[u.Snippet=27]="Snippet"})(l=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let u=Object.create(null);return u[0]="symbol-method",u[1]="symbol-function",u[2]="symbol-constructor",u[3]="symbol-field",u[4]="symbol-variable",u[5]="symbol-class",u[6]="symbol-struct",u[7]="symbol-interface",u[8]="symbol-module",u[9]="symbol-property",u[10]="symbol-event",u[11]="symbol-operator",u[12]="symbol-unit",u[13]="symbol-value",u[14]="symbol-constant",u[15]="symbol-enum",u[16]="symbol-enum-member",u[17]="symbol-keyword",u[27]="symbol-snippet",u[18]="symbol-text",u[19]="symbol-color",u[20]="symbol-file",u[21]="symbol-reference",u[22]="symbol-customcolor",u[23]="symbol-folder",u[24]="symbol-type-parameter",u[25]="account",u[26]="issues",function(p){const R=u[p];let O=R&&y.iconRegistry.get(R);return O||(console.info("No codicon found for CompletionItemKind "+p),O=y.Codicon.symbolProperty),O.classNames}}(),e.completionKindFromString=function(){let u=Object.create(null);return u.method=0,u.function=1,u.constructor=2,u.field=3,u.variable=4,u.class=5,u.struct=6,u.interface=7,u.module=8,u.property=9,u.event=10,u.operator=11,u.unit=12,u.value=13,u.constant=14,u.enum=15,u["enum-member"]=16,u.enumMember=16,u.keyword=17,u.snippet=27,u.text=18,u.color=19,u.file=20,u.reference=21,u.customcolor=22,u.folder=23,u["type-parameter"]=24,u.typeParameter=24,u.account=25,u.issue=26,function(p,R){let O=u[p];return typeof O=="undefined"&&!R&&(O=9),O}}();var d;(function(u){u[u.Deprecated=1]="Deprecated"})(d=e.CompletionItemTag||(e.CompletionItemTag={}));var E;(function(u){u[u.KeepWhitespace=1]="KeepWhitespace",u[u.InsertAsSnippet=4]="InsertAsSnippet"})(E=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var w;(function(u){u[u.Invoke=0]="Invoke",u[u.TriggerCharacter=1]="TriggerCharacter",u[u.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var S;(function(u){u[u.Invoke=1]="Invoke",u[u.Auto=2]="Auto"})(S=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var g;(function(u){u[u.Invoke=1]="Invoke",u[u.TriggerCharacter=2]="TriggerCharacter",u[u.ContentChange=3]="ContentChange"})(g=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var a;(function(u){u[u.Text=0]="Text",u[u.Read=1]="Read",u[u.Write=2]="Write"})(a=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function v(u){return u&&b.URI.isUri(u.uri)&&I.Range.isIRange(u.range)&&(I.Range.isIRange(u.originSelectionRange)||I.Range.isIRange(u.targetSelectionRange))}e.isLocationLink=v;var t;(function(u){u[u.File=0]="File",u[u.Module=1]="Module",u[u.Namespace=2]="Namespace",u[u.Package=3]="Package",u[u.Class=4]="Class",u[u.Method=5]="Method",u[u.Property=6]="Property",u[u.Field=7]="Field",u[u.Constructor=8]="Constructor",u[u.Enum=9]="Enum",u[u.Interface=10]="Interface",u[u.Function=11]="Function",u[u.Variable=12]="Variable",u[u.Constant=13]="Constant",u[u.String=14]="String",u[u.Number=15]="Number",u[u.Boolean=16]="Boolean",u[u.Array=17]="Array",u[u.Object=18]="Object",u[u.Key=19]="Key",u[u.Null=20]="Null",u[u.EnumMember=21]="EnumMember",u[u.Struct=22]="Struct",u[u.Event=23]="Event",u[u.Operator=24]="Operator",u[u.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var n;(function(u){u[u.Deprecated=1]="Deprecated"})(n=e.SymbolTag||(e.SymbolTag={}));var o;(function(u){const p=new Map;p.set("file",0),p.set("module",1),p.set("namespace",2),p.set("package",3),p.set("class",4),p.set("method",5),p.set("property",6),p.set("field",7),p.set("constructor",8),p.set("enum",9),p.set("interface",10),p.set("function",11),p.set("variable",12),p.set("constant",13),p.set("string",14),p.set("number",15),p.set("boolean",16),p.set("array",17),p.set("object",18),p.set("key",19),p.set("null",20),p.set("enum-member",21),p.set("struct",22),p.set("event",23),p.set("operator",24),p.set("type-parameter",25);const R=new Map;R.set(0,"file"),R.set(1,"module"),R.set(2,"namespace"),R.set(3,"package"),R.set(4,"class"),R.set(5,"method"),R.set(6,"property"),R.set(7,"field"),R.set(8,"constructor"),R.set(9,"enum"),R.set(10,"interface"),R.set(11,"function"),R.set(12,"variable"),R.set(13,"constant"),R.set(14,"string"),R.set(15,"number"),R.set(16,"boolean"),R.set(17,"array"),R.set(18,"object"),R.set(19,"key"),R.set(20,"null"),R.set(21,"enum-member"),R.set(22,"struct"),R.set(23,"event"),R.set(24,"operator"),R.set(25,"type-parameter");function O(K){return p.get(K)}u.fromString=O;function j(K){return R.get(K)}u.toString=j;function ie(K,x){const $=R.get(K);let U=$&&y.iconRegistry.get("symbol-"+$);return U||(console.info("No codicon found for SymbolKind "+K),U=y.Codicon.symbolProperty),`${x?"inline":"block"} ${U.classNames}`}u.toCssClassName=ie})(o=e.SymbolKinds||(e.SymbolKinds={}));class r{constructor(p){this.value=p}}e.FoldingRangeKind=r,r.Comment=new r("comment"),r.Imports=new r("imports"),r.Region=new r("region");var s;(function(u){u[u.Collapsed=0]="Collapsed",u[u.Expanded=1]="Expanded"})(s=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var c;(function(u){u[u.Editing=0]="Editing",u[u.Preview=1]="Preview"})(c=e.CommentMode||(e.CommentMode={}));var h;(function(u){u[u.Other=0]="Other",u[u.Type=1]="Type",u[u.Parameter=2]="Parameter"})(h=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new T.LanguageFeatureRegistry,e.RenameProviderRegistry=new T.LanguageFeatureRegistry,e.CompletionProviderRegistry=new T.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new T.LanguageFeatureRegistry,e.HoverProviderRegistry=new T.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new T.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new T.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new T.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new T.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new T.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new T.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new T.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new T.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new T.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.LinkProviderRegistry=new T.LanguageFeatureRegistry,e.ColorProviderRegistry=new T.LanguageFeatureRegistry,e.SelectionRangeRegistry=new T.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new T.LanguageFeatureRegistry,e.TokenizationRegistry=new A.TokenizationRegistryImpl;var _;(function(u){u[u.None=0]="None",u[u.Option=1]="Option",u[u.Default=2]="Default",u[u.Preferred=3]="Preferred"})(_=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(me[180],ge([0,1,6,11,4,3,57,55]),function(G,e,b,I,T,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,T.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new A.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(D,k){if(!D)throw new Error("invalid command");if(typeof D=="string"){if(!k)throw new Error("invalid command");return this.registerCommand({id:D,handler:k})}if(D.description){const l=[];for(let E of D.description.args)l.push(E.constraint);const d=D.handler;D.handler=function(E,...w){return(0,I.validateConstraints)(w,l),d(E,...w)}}const{id:i}=D;let C=this._commands.get(i);C||(C=new y.LinkedList,this._commands.set(i,C));let f=C.unshift(D),m=(0,b.toDisposable)(()=>{f();const l=this._commands.get(i);(l==null?void 0:l.isEmpty())&&this._commands.delete(i)});return this._onDidRegisterCommand.fire(i),m}registerCommandAlias(D,k){return e.CommandsRegistry.registerCommand(D,(i,...C)=>i.get(e.ICommandService).executeCommand(k,...C))}getCommand(D){const k=this._commands.get(D);if(!(!k||k.isEmpty()))return P.Iterable.first(k)}getCommands(){const D=new Map;for(const k of this._commands.keys()){const i=this.getCommand(k);i&&D.set(k,i)}return D}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>b.Disposable.None,onDidExecuteCommand:()=>b.Disposable.None,executeCommand(){return Promise.resolve(void 0)}},e.CommandsRegistry.registerCommand("noop",()=>{})}),define(me[81],ge([0,1,9,4,10]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=T.userAgent||"";const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",T.isMacintosh),y.set("isLinux",T.isLinux),y.set("isWindows",T.isWindows),y.set("isWeb",T.isWeb),y.set("isMacNative",T.isMacintosh&&!T.isWeb),y.set("isEdge",A.indexOf("Edg/")>=0),y.set("isFirefox",A.indexOf("Firefox")>=0),y.set("isChrome",A.indexOf("Chrome")>=0),y.set("isSafari",A.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var D;(function(u){u[u.False=0]="False",u[u.True=1]="True",u[u.Defined=2]="Defined",u[u.Not=3]="Not",u[u.Equals=4]="Equals",u[u.NotEquals=5]="NotEquals",u[u.And=6]="And",u[u.Regex=7]="Regex",u[u.NotRegex=8]="NotRegex",u[u.Or=9]="Or",u[u.In=10]="In",u[u.NotIn=11]="NotIn",u[u.Greater=12]="Greater",u[u.GreaterEquals=13]="GreaterEquals",u[u.Smaller=14]="Smaller",u[u.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class k{static false(){return C.INSTANCE}static true(){return f.INSTANCE}static has(p){return m.create(p)}static equals(p,R){return l.create(p,R)}static notEquals(p,R){return w.create(p,R)}static regex(p,R){return n.create(p,R)}static in(p,R){return d.create(p,R)}static not(p){return S.create(p)}static and(...p){return r.create(p)}static or(...p){return s.create(p)}static greater(p,R){return g.create(p,R)}static less(p,R){return v.create(p,R)}static deserialize(p,R=!1){if(!!p)return this._deserializeOrExpression(p,R)}static _deserializeOrExpression(p,R){let O=p.split("||");return s.create(O.map(j=>this._deserializeAndExpression(j,R)))}static _deserializeAndExpression(p,R){let O=p.split("&&");return r.create(O.map(j=>this._deserializeOne(j,R)))}static _deserializeOne(p,R){if(p=p.trim(),p.indexOf("!=")>=0){let O=p.split("!=");return w.create(O[0].trim(),this._deserializeValue(O[1],R))}if(p.indexOf("==")>=0){let O=p.split("==");return l.create(O[0].trim(),this._deserializeValue(O[1],R))}if(p.indexOf("=~")>=0){let O=p.split("=~");return n.create(O[0].trim(),this._deserializeRegexValue(O[1],R))}if(p.indexOf(" in ")>=0){let O=p.split(" in ");return d.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(p)){const O=p.split(">=");return a.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(p)){const O=p.split(">");return g.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(p)){const O=p.split("<=");return t.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(p)){const O=p.split("<");return v.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(p)?S.create(p.substr(1).trim()):m.create(p)}static _deserializeValue(p,R){if(p=p.trim(),p==="true")return!0;if(p==="false")return!1;let O=/^'([^']*)'$/.exec(p);return O?O[1].trim():p}static _deserializeRegexValue(p,R){if((0,b.isFalsyOrWhitespace)(p)){if(R)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=p.indexOf("/"),j=p.lastIndexOf("/");if(O===j||O<0){if(R)throw new Error(`bad regexp-value '${p}', missing /-enclosure`);return console.warn(`bad regexp-value '${p}', missing /-enclosure`),null}let ie=p.slice(O+1,j),K=p[j+1]==="i"?"i":"";try{return new RegExp(ie,K)}catch(x){if(R)throw new Error(`bad regexp-value '${p}', parse error: ${x}`);return console.warn(`bad regexp-value '${p}', parse error: ${x}`),null}}}e.ContextKeyExpr=k;function i(u,p){return u.cmp(p)}class C{constructor(){this.type=0}cmp(p){return this.type-p.type}equals(p){return p.type===this.type}evaluate(p){return!1}serialize(){return"false"}keys(){return[]}map(p){return this}negate(){return f.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class f{constructor(){this.type=1}cmp(p){return this.type-p.type}equals(p){return p.type===this.type}evaluate(p){return!0}serialize(){return"true"}keys(){return[]}map(p){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=f,f.INSTANCE=new f;class m{constructor(p){this.key=p,this.type=2}static create(p){const R=y.get(p);return typeof R=="boolean"?R?f.INSTANCE:C.INSTANCE:new m(p)}cmp(p){return p.type!==this.type?this.type-p.type:h(this.key,p.key)}equals(p){return p.type===this.type?this.key===p.key:!1}evaluate(p){return!!p.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(p){return p.mapDefined(this.key)}negate(){return S.create(this.key)}}e.ContextKeyDefinedExpr=m;class l{constructor(p,R){this.key=p,this.value=R,this.type=4}static create(p,R){if(typeof R=="boolean")return R?m.create(p):S.create(p);const O=y.get(p);return typeof O=="boolean"?R===(O?"true":"false")?f.INSTANCE:C.INSTANCE:new l(p,R)}cmp(p){return p.type!==this.type?this.type-p.type:_(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return p.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(p){return p.mapEquals(this.key,this.value)}negate(){return w.create(this.key,this.value)}}e.ContextKeyEqualsExpr=l;class d{constructor(p,R){this.key=p,this.valueKey=R,this.type=10}static create(p,R){return new d(p,R)}cmp(p){return p.type!==this.type?this.type-p.type:_(this.key,this.valueKey,p.key,p.valueKey)}equals(p){return p.type===this.type?this.key===p.key&&this.valueKey===p.valueKey:!1}evaluate(p){const R=p.getValue(this.valueKey),O=p.getValue(this.key);return Array.isArray(R)?R.indexOf(O)>=0:typeof O=="string"&&typeof R=="object"&&R!==null?P.call(R,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(p){return p.mapIn(this.key,this.valueKey)}negate(){return E.create(this)}}e.ContextKeyInExpr=d;class E{constructor(p){this._actual=p,this.type=11}static create(p){return new E(p)}cmp(p){return p.type!==this.type?this.type-p.type:this._actual.cmp(p._actual)}equals(p){return p.type===this.type?this._actual.equals(p._actual):!1}evaluate(p){return!this._actual.evaluate(p)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(p){return new E(this._actual.map(p))}negate(){return this._actual}}e.ContextKeyNotInExpr=E;class w{constructor(p,R){this.key=p,this.value=R,this.type=5}static create(p,R){if(typeof R=="boolean")return R?S.create(p):m.create(p);const O=y.get(p);return typeof O=="boolean"?R===(O?"true":"false")?C.INSTANCE:f.INSTANCE:new w(p,R)}cmp(p){return p.type!==this.type?this.type-p.type:_(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return p.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(p){return p.mapNotEquals(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=w;class S{constructor(p){this.key=p,this.type=3}static create(p){const R=y.get(p);return typeof R=="boolean"?R?C.INSTANCE:f.INSTANCE:new S(p)}cmp(p){return p.type!==this.type?this.type-p.type:h(this.key,p.key)}equals(p){return p.type===this.type?this.key===p.key:!1}evaluate(p){return!p.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(p){return p.mapNot(this.key)}negate(){return m.create(this.key)}}e.ContextKeyNotExpr=S;class g{constructor(p,R){this.key=p,this.value=R,this.type=12}static create(p,R){return new g(p,R)}cmp(p){return p.type!==this.type?this.type-p.type:_(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return parseFloat(p.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(p){return p.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=g;class a{constructor(p,R){this.key=p,this.value=R,this.type=13}static create(p,R){return new a(p,R)}cmp(p){return p.type!==this.type?this.type-p.type:_(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return parseFloat(p.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(p){return p.mapGreaterEquals(this.key,this.value)}negate(){return v.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=a;class v{constructor(p,R){this.key=p,this.value=R,this.type=14}static create(p,R){return new v(p,R)}cmp(p){return p.type!==this.type?this.type-p.type:_(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return parseFloat(p.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(p){return p.mapSmaller(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeySmallerExpr=v;class t{constructor(p,R){this.key=p,this.value=R,this.type=15}static create(p,R){return new t(p,R)}cmp(p){return p.type!==this.type?this.type-p.type:_(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return parseFloat(p.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(p){return p.mapSmallerEquals(this.key,this.value)}negate(){return g.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class n{constructor(p,R){this.key=p,this.regexp=R,this.type=7}static create(p,R){return new n(p,R)}cmp(p){if(p.type!==this.type)return this.type-p.type;if(this.key<p.key)return-1;if(this.key>p.key)return 1;const R=this.regexp?this.regexp.source:"",O=p.regexp?p.regexp.source:"";return R<O?-1:R>O?1:0}equals(p){if(p.type===this.type){const R=this.regexp?this.regexp.source:"",O=p.regexp?p.regexp.source:"";return this.key===p.key&&R===O}return!1}evaluate(p){let R=p.getValue(this.key);return this.regexp?this.regexp.test(R):!1}serialize(){const p=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${p}`}keys(){return[this.key]}map(p){return p.mapRegex(this.key,this.regexp)}negate(){return o.create(this)}}e.ContextKeyRegexExpr=n;class o{constructor(p){this._actual=p,this.type=8}static create(p){return new o(p)}cmp(p){return p.type!==this.type?this.type-p.type:this._actual.cmp(p._actual)}equals(p){return p.type===this.type?this._actual.equals(p._actual):!1}evaluate(p){return!this._actual.evaluate(p)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(p){return new o(this._actual.map(p))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=o;class r{constructor(p){this.expr=p,this.type=6}static create(p){return r._normalizeArr(p)}cmp(p){if(p.type!==this.type)return this.type-p.type;if(this.expr.length<p.expr.length)return-1;if(this.expr.length>p.expr.length)return 1;for(let R=0,O=this.expr.length;R<O;R++){const j=i(this.expr[R],p.expr[R]);if(j!==0)return j}return 0}equals(p){if(p.type===this.type){if(this.expr.length!==p.expr.length)return!1;for(let R=0,O=this.expr.length;R<O;R++)if(!this.expr[R].equals(p.expr[R]))return!1;return!0}return!1}evaluate(p){for(let R=0,O=this.expr.length;R<O;R++)if(!this.expr[R].evaluate(p))return!1;return!0}static _normalizeArr(p){const R=[];let O=!1;for(const j of p)if(!!j){if(j.type===1){O=!0;continue}if(j.type===0)return C.INSTANCE;if(j.type===6){R.push(...j.expr);continue}R.push(j)}if(R.length===0&&O)return f.INSTANCE;if(R.length!==0){if(R.length===1)return R[0];for(R.sort(i);R.length>1;){const j=R[R.length-1];if(j.type!==9)break;R.pop();const ie=R.pop(),K=s.create(j.expr.map(x=>r.create([x,ie])));K&&(R.push(K),R.sort(i))}return R.length===1?R[0]:new r(R)}}serialize(){return this.expr.map(p=>p.serialize()).join(" && ")}keys(){const p=[];for(let R of this.expr)p.push(...R.keys());return p}map(p){return new r(this.expr.map(R=>R.map(p)))}negate(){let p=[];for(let R of this.expr)p.push(R.negate());return s.create(p)}}e.ContextKeyAndExpr=r;class s{constructor(p){this.expr=p,this.type=9}static create(p){const R=s._normalizeArr(p);if(R.length!==0)return R.length===1?R[0]:new s(R)}cmp(p){if(p.type!==this.type)return this.type-p.type;if(this.expr.length<p.expr.length)return-1;if(this.expr.length>p.expr.length)return 1;for(let R=0,O=this.expr.length;R<O;R++){const j=i(this.expr[R],p.expr[R]);if(j!==0)return j}return 0}equals(p){if(p.type===this.type){if(this.expr.length!==p.expr.length)return!1;for(let R=0,O=this.expr.length;R<O;R++)if(!this.expr[R].equals(p.expr[R]))return!1;return!0}return!1}evaluate(p){for(let R=0,O=this.expr.length;R<O;R++)if(this.expr[R].evaluate(p))return!0;return!1}static _normalizeArr(p){let R=[],O=!1;if(p){for(let j=0,ie=p.length;j<ie;j++){const K=p[j];if(!!K){if(K.type===0){O=!0;continue}if(K.type===1)return[f.INSTANCE];if(K.type===9){R=R.concat(K.expr);continue}R.push(K)}}if(R.length===0&&O)return[C.INSTANCE];R.sort(i)}return R}serialize(){return this.expr.map(p=>p.serialize()).join(" || ")}keys(){const p=[];for(let R of this.expr)p.push(...R.keys());return p}map(p){return new s(this.expr.map(R=>R.map(p)))}negate(){let p=[];for(let O of this.expr)p.push(O.negate());const R=O=>O.type===9?O.expr:[O];for(;p.length>1;){const O=p.shift(),j=p.shift(),ie=[];for(const K of R(O))for(const x of R(j))ie.push(k.and(K,x));p.unshift(k.or(...ie))}return p[0]}}e.ContextKeyOrExpr=s;class c extends m{constructor(p,R,O){super(p);this._defaultValue=R,typeof O=="object"?c._info.push(Object.assign(Object.assign({},O),{key:p})):O!==!0&&c._info.push({key:p,description:O,type:R!=null?typeof R:void 0})}static all(){return c._info.values()}bindTo(p){return p.createKey(this.key,this._defaultValue)}getValue(p){return p.getContextKeyValue(this.key)}toNegated(){return k.not(this.key)}isEqualTo(p){return k.equals(this.key,p)}notEqualsTo(p){return k.notEquals(this.key,p)}}e.RawContextKey=c,c._info=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function h(u,p){return u<p?-1:u>p?1:0}function _(u,p,R,O){return u<R?-1:u>R?1:p<O?-1:p>O?1:0}}),define(me[181],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,b.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,b.refineServiceDecorator)(e.IEnvironmentService)}),define(me[182],ge([0,1,153,4,12]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function A(C){return C&&typeof C=="object"&&typeof C.id=="string"&&(!C.uuid||typeof C.uuid=="string")}e.isIExtensionIdentifier=A;var y;(function(C){C[C.NoneOrRelevance=0]="NoneOrRelevance",C[C.LastUpdatedDate=1]="LastUpdatedDate",C[C.Title=2]="Title",C[C.PublisherName=3]="PublisherName",C[C.InstallCount=4]="InstallCount",C[C.PublishedDate=5]="PublishedDate",C[C.AverageRating=6]="AverageRating",C[C.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var P;(function(C){C[C.Default=0]="Default",C[C.Ascending=1]="Ascending",C[C.Descending=2]="Descending"})(P=e.SortOrder||(e.SortOrder={}));var D;(function(C){C.Uninstall="uninstall"})(D=e.StatisticType||(e.StatisticType={}));var k;(function(C){C[C.None=0]="None",C[C.Install=1]="Install",C[C.Update=2]="Update"})(k=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,I.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class i extends Error{constructor(f,m){super(f);this.code=m}}e.ExtensionManagementError=i,e.IExtensionManagementService=(0,I.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,I.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,I.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=T.FileAccess.asBrowserUri("./media/defaultIcon.png",G).toString(!0),e.ExtensionsLabel=(0,b.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,b.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,I.createDecorator)("IExtensionManagementCLIService")}),define(me[27],ge([0,1,9,4]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function T(k){return k&&typeof k=="object"&&typeof k.id=="string"&&(!k.uuid||typeof k.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(k){k[k.System=0]="System",k[k.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class y{constructor(i){this.value=i,this._lower=i.toLowerCase()}static equals(i,C){if(typeof i=="undefined"||i===null)return typeof C=="undefined"||C===null;if(typeof C=="undefined"||C===null)return!1;if(typeof i=="string"||typeof C=="string"){let f=typeof i=="string"?i:i.value,m=typeof C=="string"?C:C.value;return b.equalsIgnoreCase(f,m)}return i._lower===C._lower}static toKey(i){return typeof i=="string"?i.toLowerCase():i._lower}}e.ExtensionIdentifier=y;function P(k){return k.contributes&&k.contributes.localizations?k.contributes.localizations.length>0:!1}e.isLanguagePackExtension=P;function D(k){return k.contributes&&k.contributes.authentication?k.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=D,e.IBuiltinExtensionsScannerService=(0,I.createDecorator)("IBuiltinExtensionsScannerService")}),define(me[183],ge([0,1,9,27]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function T(m,l){return m.uuid&&l.uuid?m.uuid===l.uuid:m.id===l.id?!0:(0,b.compareIgnoreCase)(m.id,l.id)===0}e.areSameExtensions=T;class A{constructor(l,d){this.version=d,this.id=l.id,this.uuid=l.uuid}key(){return`${this.id}-${this.version}`}equals(l){return l instanceof A?T(this,l)&&this.version===l.version:!1}}e.ExtensionIdentifierWithVersion=A;function y(m,l){return`${m}.${l}`}e.getExtensionId=y;function P(m){return m.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function D(m,l){return P(y(m,l))}e.getGalleryExtensionId=D;function k(m,l){const d=[],E=w=>{for(const S of d)if(S.some(g=>T(l(g),l(w))))return S;return null};for(const w of m){const S=E(w);S?S.push(w):d.push([w])}return d}e.groupByExtension=k;function i(m){return{id:m.identifier.id,name:m.manifest.name,galleryId:null,publisherId:m.publisherId,publisherName:m.manifest.publisher,publisherDisplayName:m.publisherDisplayName,dependencies:m.manifest.extensionDependencies&&m.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function C(m){return Object.assign({id:m.identifier.id,name:m.name,galleryId:m.identifier.uuid,publisherId:m.publisherId,publisherName:m.publisher,publisherDisplayName:m.publisherDisplayName,dependencies:!!(m.properties.dependencies&&m.properties.dependencies.length>0)},m.telemetryData)}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function f(m){const l=new Set;for(const d of m)d.malicious&&l.add(d.id.id);return l}e.getMaliciousExtensionsSet=f}),define(me[184],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,b.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,b.createDecorator)("externalTerminal")}),define(me[45],ge([0,1,156,8,2,4,9,11,22]),function(G,e,b,I,T,A,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,A.createDecorator)("fileService");function k(K){return K.create===!0}e.isFileOpenForWriteOptions=k;var i;(function(K){K[K.Unknown=0]="Unknown",K[K.File=1]="File",K[K.Directory=2]="Directory",K[K.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var C;(function(K){K[K.FileReadWrite=2]="FileReadWrite",K[K.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",K[K.FileReadStream=16]="FileReadStream",K[K.FileFolderCopy=8]="FileFolderCopy",K[K.PathCaseSensitive=1024]="PathCaseSensitive",K[K.Readonly=2048]="Readonly",K[K.Trash=4096]="Trash",K[K.FileWriteUnlock=8192]="FileWriteUnlock"})(C=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(K){return!!(K.capabilities&2)}e.hasReadWriteCapability=f;function m(K){return!!(K.capabilities&8)}e.hasFileFolderCopyCapability=m;function l(K){return!!(K.capabilities&4)}e.hasOpenReadWriteCloseCapability=l;function d(K){return!!(K.capabilities&16)}e.hasFileReadStreamCapability=d;var E;(function(K){K.FileExists="EntryExists",K.FileNotFound="EntryNotFound",K.FileNotADirectory="EntryNotADirectory",K.FileIsADirectory="EntryIsADirectory",K.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",K.FileTooLarge="EntryTooLarge",K.FileWriteLocked="EntryWriteLocked",K.NoPermissions="NoPermissions",K.Unavailable="Unavailable",K.Unknown="Unknown"})(E=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class w extends Error{constructor(x,$){super(x);this.code=$}}e.FileSystemProviderError=w;function S(K,x){const $=new w(K.toString(),x);return a($,x),$}e.createFileSystemProviderError=S;function g(K){return K||S((0,b.localize)(0,null),E.Unknown)}e.ensureFileSystemProviderError=g;function a(K,x){return K.name=x?`${x} (FileSystemError)`:"FileSystemError",K}e.markAsFileSystemProviderError=a;function v(K){if(!K)return E.Unknown;if(K instanceof w)return K.code;const x=/^(.+) \(FileSystemError\)$/.exec(K.name);if(!x)return E.Unknown;switch(x[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileExceedsMemoryLimit:return E.FileExceedsMemoryLimit;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.toFileSystemProviderErrorCode=v;function t(K){if(K instanceof h)return K.fileOperationResult;switch(v(K)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 10;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileExceedsMemoryLimit:return 9;case E.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var n;(function(K){K[K.CREATE=0]="CREATE",K[K.DELETE=1]="DELETE",K[K.MOVE=2]="MOVE",K[K.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class o{constructor(x,$,U){this.resource=x,this.operation=$,this.target=U}isOperation(x){return this.operation===x}}e.FileOperationEvent=o;var r;(function(K){K[K.UPDATED=0]="UPDATED",K[K.ADDED=1]="ADDED",K[K.DELETED=2]="DELETED"})(r=e.FileChangeType||(e.FileChangeType={}));class s{constructor(x,$){this.ignorePathCasing=$,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=x;for(const U of x)switch(U.type){case 1:this.added||(this.added=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(U.resource,U);break;case 0:this.updated||(this.updated=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(U.resource,U);break;case 2:this.deleted||(this.deleted=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(U.resource,U);break}}contains(x,...$){return this.doContains(x,{includeChildren:!1},...$)}affects(x,...$){return this.doContains(x,{includeChildren:!0},...$)}doContains(x,$,...U){var L,N,M,F,W,q;if(!x)return!1;const Q=U.length>0;return!!((!Q||U.includes(1))&&(((L=this.added)===null||L===void 0?void 0:L.get(x))||$.includeChildren&&((N=this.added)===null||N===void 0?void 0:N.findSuperstr(x)))||(!Q||U.includes(0))&&(((M=this.updated)===null||M===void 0?void 0:M.get(x))||$.includeChildren&&((F=this.updated)===null||F===void 0?void 0:F.findSuperstr(x)))||(!Q||U.includes(2))&&(((W=this.deleted)===null||W===void 0?void 0:W.findSubstr(x))||$.includeChildren&&((q=this.deleted)===null||q===void 0?void 0:q.findSuperstr(x))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(x){const $=[],U=x===1?this.added:x===0?this.updated:this.deleted;if(U)for(const[,L]of U)$.push(L);return $}filter(x){return new s(this.changes.filter($=>x($)),this.ignorePathCasing)}}e.FileChangesEvent=s;function c(K,x,$){return!K||!x||K===x||x.length>K.length?!1:(x.charAt(x.length-1)!==I.sep&&(x+=I.sep),$?(0,y.startsWithIgnoreCase)(K,x):K.indexOf(x)===0)}e.isParent=c;class h extends Error{constructor(x,$,U){super(x);this.fileOperationResult=$,this.options=U}static isFileOperationError(x){return x instanceof Error&&!(0,P.isUndefinedOrNull)(x.fileOperationResult)}}e.FileOperationError=h;var _;(function(K){K[K.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",K[K.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",K[K.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",K[K.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",K[K.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",K[K.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",K[K.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",K[K.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",K[K.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",K[K.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",K[K.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",K[K.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(_=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var u;(function(K){K[K.FILE=0]="FILE",K[K.FOLDER=1]="FOLDER",K[K.ROOT_FOLDER=2]="ROOT_FOLDER"})(u=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function p(K){if(!(typeof K.size!="number"||typeof K.mtime!="number"))return K.mtime.toString(29)+K.size.toString(31)}e.etag=p;async function R(K,x){if(!x.canHandleResource(T.URI.from({scheme:K.scheme})))return new Promise($=>{const U=x.onDidChangeFileSystemProviderRegistrations(L=>{L.scheme===K.scheme&&L.added&&(U.dispose(),$())})})}e.whenProviderRegistered=R,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class O{static formatSize(x){return(0,P.isNumber)(x)||(x=0),x<O.KB?(0,b.localize)(1,null,x.toFixed(0)):x<O.MB?(0,b.localize)(2,null,(x/O.KB).toFixed(2)):x<O.GB?(0,b.localize)(3,null,(x/O.MB).toFixed(2)):x<O.TB?(0,b.localize)(4,null,(x/O.GB).toFixed(2)):(0,b.localize)(5,null,(x/O.TB).toFixed(2))}}e.ByteSize=O,O.KB=1024,O.MB=O.KB*O.KB,O.GB=O.MB*O.KB,O.TB=O.GB*O.KB;var j;(function(K){K[K.IA32=0]="IA32",K[K.OTHER=1]="OTHER"})(j=e.Arch||(e.Arch={}));function ie(K){return{maxFileSize:K===0?300*O.MB:16*O.GB,maxHeapSize:K===0?700*O.MB:2*700*O.MB}}e.getPlatformLimits=ie}),define(me[82],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class b{constructor(...T){this._entries=new Map;for(let[A,y]of T)this.set(A,y)}set(T,A){const y=this._entries.get(T);return this._entries.set(T,A),y}has(T){return this._entries.has(T)}get(T){return this._entries.get(T)}}e.ServiceCollection=b}),define(me[185],ge([0,1,16,177,113,4,82,13]),function(G,e,b,I,T,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const D=!1;class k extends Error{constructor(l){var d;super("cyclic dependency between services");this.message=(d=l.findCycleSlow())!==null&&d!==void 0?d:`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class i{constructor(l=new y.ServiceCollection,d=!1,E){this._activeInstantiations=new Set,this._services=l,this._strict=d,this._parent=E,this._services.set(A.IInstantiationService,this)}createChild(l){return new i(l,this._strict,this)}invokeFunction(l,...d){let E=f.traceInvocation(l),w=!1;try{return l({get:(g,a)=>{if(w)throw(0,b.illegalState)("service accessor is only valid during the invocation of its target method");const v=this._getOrCreateServiceInstance(g,E);if(!v&&a!==A.optional)throw new Error(`[invokeFunction] unknown service '${g}'`);return v}},...d)}finally{w=!0,E.stop()}}createInstance(l,...d){let E,w;return l instanceof T.SyncDescriptor?(E=f.traceCreation(l.ctor),w=this._createInstance(l.ctor,l.staticArguments.concat(d),E)):(E=f.traceCreation(l),w=this._createInstance(l,d,E)),E.stop(),w}_createInstance(l,d=[],E){let w=A._util.getServiceDependencies(l).sort((a,v)=>a.index-v.index),S=[];for(const a of w){let v=this._getOrCreateServiceInstance(a.id,E);if(!v&&this._strict&&!a.optional)throw new Error(`[createInstance] ${l.name} depends on UNKNOWN service ${a.id}.`);S.push(v)}let g=w.length>0?w[0].index:d.length;if(d.length!==g){console.warn(`[createInstance] First service dependency of ${l.name} at position ${g+1} conflicts with ${d.length} static arguments`);let a=g-d.length;a>0?d=d.concat(new Array(a)):d=d.slice(0,g)}return new l(...[...d,...S])}_setServiceInstance(l,d){if(this._services.get(l)instanceof T.SyncDescriptor)this._services.set(l,d);else if(this._parent)this._parent._setServiceInstance(l,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(l){let d=this._services.get(l);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(l):d}_getOrCreateServiceInstance(l,d){let E=this._getServiceInstanceOrDescriptor(l);return E instanceof T.SyncDescriptor?this._safeCreateAndCacheServiceInstance(l,E,d.branch(l,!0)):(d.branch(l,!1),E)}_safeCreateAndCacheServiceInstance(l,d,E){if(this._activeInstantiations.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this._activeInstantiations.add(l);try{return this._createAndCacheServiceInstance(l,d,E)}finally{this._activeInstantiations.delete(l)}}_createAndCacheServiceInstance(l,d,E){const w=new I.Graph(a=>a.id.toString());let S=0;const g=[{id:l,desc:d,_trace:E}];for(;g.length;){const a=g.pop();if(w.lookupOrInsertNode(a),S++>1e3)throw new k(w);for(let v of A._util.getServiceDependencies(a.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(v.id);if(!t&&!v.optional&&console.warn(`[createInstance] ${l} depends on ${v.id} which is NOT registered.`),t instanceof T.SyncDescriptor){const n={id:v.id,desc:t,_trace:a._trace.branch(v.id,!0)};w.insertEdge(a,n),g.push(n)}}}for(;;){const a=w.roots();if(a.length===0){if(!w.isEmpty())throw new k(w);break}for(const{data:v}of a){if(this._getServiceInstanceOrDescriptor(v.id)instanceof T.SyncDescriptor){const n=this._createServiceInstanceWithOwner(v.id,v.desc.ctor,v.desc.staticArguments,v.desc.supportsDelayedInstantiation,v._trace);this._setServiceInstance(v.id,n)}w.removeNode(v)}}return this._getServiceInstanceOrDescriptor(l)}_createServiceInstanceWithOwner(l,d,E=[],w,S){if(this._services.get(l)instanceof T.SyncDescriptor)return this._createServiceInstance(d,E,w,S);if(this._parent)return this._parent._createServiceInstanceWithOwner(l,d,E,w,S);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(l,d=[],E,w){if(E){const S=new P.IdleValue(()=>this._createInstance(l,d,w));return new Proxy(Object.create(null),{get(g,a){if(a in g)return g[a];let v=S.value,t=v[a];return typeof t!="function"||(t=t.bind(v),g[a]=t),t},set(g,a,v){return S.value[a]=v,!0}})}else return this._createInstance(l,d,w)}}e.InstantiationService=i;var C;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(C||(C={}));class f{constructor(l,d){this.type=l,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(l){return D?new f(1,l.name||l.toString().substring(0,42).replace(/\n/g,"")):f._None}static traceCreation(l){return D?new f(0,l.name):f._None}branch(l,d){let E=new f(2,l.toString());return this._dep.push([l,d,E]),E}stop(){let l=Date.now()-this._start;f._totals+=l;let d=!1;function E(S,g){let a=[],v=new Array(S+1).join("	");for(const[t,n,o]of g._dep)if(n&&o){d=!0,a.push(`${v}CREATES -> ${t}`);let r=E(S+1,o);r&&a.push(r)}else a.push(`${v}uses -> ${t}`);return a.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(l>2||d)&&console.log(w.join(`
`))}}f._None=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f._totals=0}),define(me[14],ge([0,1,4,6,10,3,60]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,b.createDecorator)("logService"),e.ILoggerService=(0,b.createDecorator)("loggerService");function P(){return new Date().toISOString()}var D;(function(v){v[v.Trace=0]="Trace",v[v.Debug=1]="Debug",v[v.Info=2]="Info",v[v.Warning=3]="Warning",v[v.Error=4]="Error",v[v.Critical=5]="Critical",v[v.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;class k extends I.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new A.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class i extends k{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(D.Trace)&&this.log(D.Trace,this.format([t,...n]))}debug(t,...n){this.checkLogLevel(D.Debug)&&this.log(D.Debug,this.format([t,...n]))}info(t,...n){this.checkLogLevel(D.Info)&&this.log(D.Info,this.format([t,...n]))}warn(t,...n){this.checkLogLevel(D.Warning)&&this.log(D.Warning,this.format([t,...n]))}error(t,...n){if(this.checkLogLevel(D.Error))if(t instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=t.stack,this.log(D.Error,this.format(o))}else this.log(D.Error,this.format([t,...n]))}critical(t,...n){this.checkLogLevel(D.Critical)&&this.log(D.Critical,this.format([t,...n]))}flush(){}format(t){let n="";for(let o=0;o<t.length;o++){let r=t[o];if(typeof r=="object")try{r=JSON.stringify(r)}catch(s){}n+=(o>0?" ":"")+r}return n}}e.AbstractMessageLogger=i;class C extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!T.isWindows}trace(t,...n){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...n):console.log(`[main ${P()}]`,t,...n))}debug(t,...n){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...n):console.log(`[main ${P()}]`,t,...n))}info(t,...n){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...n):console.log(`[main ${P()}]`,t,...n))}warn(t,...n){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,t,...n):console.warn(`[main ${P()}]`,t,...n))}error(t,...n){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,t,...n):console.error(`[main ${P()}]`,t,...n))}critical(t,...n){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,t,...n):console.error(`[main ${P()}]`,t,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=C;class f extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...n){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}e.ConsoleLogger=f;class m extends k{constructor(t,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:(0,y.toErrorMessage)(t,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class l extends k{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const o of this.logServices)o.trace(t,...n)}debug(t,...n){for(const o of this.logServices)o.debug(t,...n)}info(t,...n){for(const o of this.logServices)o.info(t,...n)}warn(t,...n){for(const o of this.logServices)o.warn(t,...n)}error(t,...n){for(const o of this.logServices)o.error(t,...n)}critical(t,...n){for(const o of this.logServices)o.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=l;class d extends I.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}e.LogService=d;class E extends I.Disposable{constructor(t,n){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(o))}))}createLogger(t,n){let o=this.loggers.get(t.toString());return o||(o=this.doCreateLogger(t,(n==null?void 0:n.always)?D.Trace:this.logLevel,n),this.loggers.set(t.toString(),o),(n==null?void 0:n.always)||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=E;class w{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(t){}getLevel(){return D.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}e.NullLogService=w;function S(v){if(v.verbose)return D.Trace;if(typeof v.logLevel=="string"){const t=g(v.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=S;function g(v){switch(v){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=g;function a(v){switch(v){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=a}),define(me[114],ge([0,1,14,45]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function T(D,k,i,C){try{const f=await new Promise((m,l)=>{G(["spdlog"],m,l)});return f.setAsyncMode(8192,500),f.createRotatingLoggerAsync(D,k,i,C)}catch(f){console.error(f)}return null}function A(D,k,i,C){return G.__$__nodeRequire("spdlog").createRotatingLogger(D,k,i,C)}e.createRotatingLogger=A;function y(D,k,i){switch(k){case b.LogLevel.Trace:D.trace(i);break;case b.LogLevel.Debug:D.debug(i);break;case b.LogLevel.Info:D.info(i);break;case b.LogLevel.Warning:D.warn(i);break;case b.LogLevel.Error:D.error(i);break;case b.LogLevel.Critical:D.critical(i);break;default:throw new Error("Invalid log level")}}class P extends b.AbstractMessageLogger{constructor(k,i,C,f){super();this.name=k,this.filepath=i,this.rotating=C,this.buffer=[],this.setLevel(f),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(m=>{this._logger&&this._logger.setLevel(m)}))}_createSpdLogLogger(){const k=this.rotating?6:1,i=30/k*I.ByteSize.MB;return T(this.name,this.filepath,i,k).then(C=>{if(C){this._logger=C,this._logger.setLevel(this.getLevel());for(const{level:f,message:m}of this.buffer)y(this._logger,f,m);this.buffer=[]}})}log(k,i){this._logger?y(this._logger,k,i):this.getLevel()<=k&&this.buffer.push({level:k,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=P}),define(me[115],ge([0,1,4,157,58]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var y;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function k(l,d){return d-l}D.compare=k;const i=Object.create(null);i[D.Error]=(0,I.localize)(0,null),i[D.Warning]=(0,I.localize)(1,null),i[D.Info]=(0,I.localize)(2,null);function C(l){return i[l]||""}D.toString=C;function f(l){switch(l){case T.default.Error:return D.Error;case T.default.Warning:return D.Warning;case T.default.Info:return D.Info;case T.default.Ignore:return D.Hint}}D.fromSeverity=f;function m(l){switch(l){case D.Error:return T.default.Error;case D.Warning:return T.default.Warning;case D.Info:return T.default.Info;case D.Hint:return T.default.Ignore}}D.toSeverity=m}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(D){const k="";function i(f){return C(f,!0)}D.makeKey=i;function C(f,m){let l=[k];return f.source?l.push(f.source.replace("\xA6","\\\xA6")):l.push(k),f.code?typeof f.code=="string"?l.push(f.code.replace("\xA6","\\\xA6")):l.push(f.code.value.replace("\xA6","\\\xA6")):l.push(k),f.severity!==void 0&&f.severity!==null?l.push(y.toString(f.severity)):l.push(k),f.message&&m?l.push(f.message.replace("\xA6","\\\xA6")):l.push(k),f.startLineNumber!==void 0&&f.startLineNumber!==null?l.push(f.startLineNumber.toString()):l.push(k),f.startColumn!==void 0&&f.startColumn!==null?l.push(f.startColumn.toString()):l.push(k),f.endLineNumber!==void 0&&f.endLineNumber!==null?l.push(f.endLineNumber.toString()):l.push(k),f.endColumn!==void 0&&f.endColumn!==null?l.push(f.endColumn.toString()):l.push(k),l.push(k),l.join("\xA6")}D.makeKeyOptionalMessage=C})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,b.createDecorator)("markerService")}),define(me[186],ge([0,1,58,4,3]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=b.default,e.INotificationService=(0,I.createDecorator)("notificationService");var A;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new D,this.onDidClose=T.Event.None,this.onDidChangeVisibility=T.Event.None}updateSeverity(i){}updateMessage(i){}updateActions(i){}close(){}}e.NoOpNotification=P;class D{infinite(){}done(){}total(i){}worked(i){}}e.NoOpProgress=D}),define(me[187],ge([0,1,12,10,36,25]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let y;if(typeof I.globals.vscode!="undefined"){const P=I.globals.vscode.context.configuration();if(P)y=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(G==null?void 0:G.__$__nodeRequire)=="function"){const P=(0,A.dirname)(b.FileAccess.asFileUri("",G));y=G.__$__nodeRequire((0,A.joinPath)(P,"product.json").fsPath);const D=G.__$__nodeRequire((0,A.joinPath)(P,"package.json").fsPath);T.env.VSCODE_DEV&&Object.assign(y,{nameShort:`${y.nameShort} Dev`,nameLong:`${y.nameLong} Dev`,dataFolderName:`${y.dataFolderName}-dev`}),Object.assign(y,{version:D.version})}else y={},Object.keys(y).length===0&&Object.assign(y,{version:"1.57.0-dev",nameShort:I.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:I.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});e.default=y});var He=this&&this.__param||function(G,e){return function(b,I){e(b,I,G)}};define(me[116],ge([0,1,4,21,6,13]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,b.createDecorator)("progressService");var y;(function(i){i[i.Explorer=1]="Explorer",i[i.Scm=3]="Scm",i[i.Extensions=5]="Extensions",i[i.Window=10]="Window",i[i.Notification=15]="Notification",i[i.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{constructor(C){this.callback=C}get value(){return this._value}report(C){this._value=C,this.callback(this._value)}}e.Progress=P,P.None=Object.freeze({report(){}});let D=class extends T.Disposable{constructor(C,f){super();this.deferred=new A.DeferredPromise,f.withProgress(C,m=>(this.reporter=m,this.lastStep&&m.report(this.lastStep),this.deferred.p)),this._register((0,T.toDisposable)(()=>this.deferred.complete()))}report(C){this.reporter?this.reporter.report(C):this.lastStep=C}};D=qe([He(1,e.IProgressService)],D),e.UnmanagedProgress=D;class k extends T.Disposable{constructor(C){super();this.progressIndicator=C,this.currentOperationId=0,this.currentOperationDisposables=this._register(new T.DisposableStore)}start(C){this.stop();const f=++this.currentOperationId,m=new I.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{f===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},C),this.currentOperationDisposables.add((0,T.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,T.toDisposable)(()=>m.cancel())),this.currentOperationDisposables.add((0,T.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:f,token:m.token,stop:()=>this.doStop(f),isCurrent:()=>this.currentOperationId===f}}stop(){this.doStop(this.currentOperationId)}doStop(C){this.currentOperationId===C&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,b.createDecorator)("editorProgressService")}),define(me[40],ge([0,1,11,52]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class T{constructor(){this.data=new Map}add(y,P){I.ok(b.isString(y)),I.ok(b.isObject(P)),I.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,P)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}e.Registry=new T}),define(me[117],ge([0,1,40,3]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function T(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class A{constructor(){this._onDidChangeSchema=new I.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,k){this.schemasById[T(D)]=k,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new A;b.Registry.add(e.Extensions.JSONContribution,y)}),define(me[83],ge([0,1,152,3,40,11,117]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const D=T.Registry.as(y.Extensions.JSONContribution);class k{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new I.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new I.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:b.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(w,S=!0){this.registerConfigurations([w],S)}registerConfigurations(w,S=!0){const g=[];w.forEach(a=>{g.push(...this.validateAndRegisterProperties(a,S,a.extensionInfo)),this.configurationContributors.push(a),this.registerJSONConfiguration(a)}),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(g)}deregisterConfigurations(w){const S=[],g=a=>{if(a.properties)for(const v in a.properties)S.push(v),delete this.configurationProperties[v],this.removeFromSchema(v,a.properties[v]);a.allOf&&a.allOf.forEach(v=>g(v))};for(const a of w){g(a);const v=this.configurationContributors.indexOf(a);v!==-1&&this.configurationContributors.splice(v,1)}D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}registerDefaultConfigurations(w){const S=[],g=[];for(const a of w)for(const v in a)if(S.push(v),e.OVERRIDE_PROPERTY_PATTERN.test(v)){this.defaultValues[v]=Object.assign(Object.assign({},this.defaultValues[v]||{}),a[v]);const t={type:"object",default:this.defaultValues[v],description:b.localize(1,null,v),$ref:e.resourceLanguageSettingsSchemaId};g.push(C(v)),this.configurationProperties[v]=t,this.defaultLanguageConfigurationOverridesNode.properties[v]=t}else{this.defaultValues[v]=a[v];const t=this.configurationProperties[v];t&&(this.updatePropertyDefaultValue(v,t),this.updateSchema(v,t))}this.registerOverrideIdentifiers(g),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}deregisterDefaultConfigurations(w){const S=[];for(const g of w)for(const a in g)if(S.push(a),delete this.defaultValues[a],e.OVERRIDE_PROPERTY_PATTERN.test(a))delete this.configurationProperties[a],delete this.defaultLanguageConfigurationOverridesNode.properties[a];else{const v=this.configurationProperties[a];v&&(this.updatePropertyDefaultValue(a,v),this.updateSchema(a,v))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}notifyConfigurationSchemaUpdated(...w){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(w){for(const S of w)this.overrideIdentifiers.add(S);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(w,S=!0,g,a=3){var v;a=A.isUndefinedOrNull(w.scope)?a:w.scope;let t=[],n=w.properties;if(n)for(let r in n){if(S&&l(r)){delete n[r];continue}const s=n[r];if(this.updatePropertyDefaultValue(r,s),e.OVERRIDE_PROPERTY_PATTERN.test(r)?s.scope=void 0:(s.scope=A.isUndefinedOrNull(s.scope)?a:s.scope,s.restricted=A.isUndefinedOrNull(s.restricted)?!!((v=g==null?void 0:g.restrictedConfigurations)===null||v===void 0?void 0:v.includes(r)):s.restricted),n[r].hasOwnProperty("included")&&!n[r].included){this.excludedConfigurationProperties[r]=n[r],delete n[r];continue}else this.configurationProperties[r]=n[r];!n[r].deprecationMessage&&n[r].markdownDeprecationMessage&&(n[r].deprecationMessage=n[r].markdownDeprecationMessage),t.push(r)}let o=w.allOf;if(o)for(let r of o)t.push(...this.validateAndRegisterProperties(r,S,g,a));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(w){const S=g=>{let a=g.properties;if(a)for(const t in a)this.updateSchema(t,a[t]);let v=g.allOf;v&&v.forEach(S)};S(w)}updateSchema(w,S){switch(e.allSettings.properties[w]=S,S.scope){case 1:e.applicationSettings.properties[w]=S;break;case 2:e.machineSettings.properties[w]=S;break;case 6:e.machineOverridableSettings.properties[w]=S;break;case 3:e.windowSettings.properties[w]=S;break;case 4:e.resourceSettings.properties[w]=S;break;case 5:e.resourceSettings.properties[w]=S,this.resourceLanguageSettingsSchema.properties[w]=S;break}}removeFromSchema(w,S){switch(delete e.allSettings.properties[w],S.scope){case 1:delete e.applicationSettings.properties[w];break;case 2:delete e.machineSettings.properties[w];break;case 6:delete e.machineOverridableSettings.properties[w];break;case 3:delete e.windowSettings.properties[w];break;case 4:case 5:delete e.resourceSettings.properties[w];break}}updateOverridePropertyPatternKey(){for(const w of this.overrideIdentifiers.values()){const S=`[${w}]`,g={type:"object",description:b.localize(2,null),errorMessage:b.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(S,g),e.allSettings.properties[S]=g,e.applicationSettings.properties[S]=g,e.machineSettings.properties[S]=g,e.machineOverridableSettings.properties[S]=g,e.windowSettings.properties[S]=g,e.resourceSettings.properties[S]=g}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(w,S){let g=this.defaultValues[w];A.isUndefined(g)&&(g=S.default),A.isUndefined(g)&&(g=f(S.type)),S.default=g}}const i="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(i);function C(E){return E.substring(1,E.length-1)}e.overrideIdentifierFromKey=C;function f(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const m=new k;T.Registry.add(e.Extensions.Configuration,m);function l(E){return E.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(E)?b.localize(5,null,E):m.getConfigurationProperties()[E]!==void 0?b.localize(6,null,E):null:b.localize(4,null)}e.validateProperty=l;function d(){const E=[],w=m.getConfigurationProperties();for(const S of Object.keys(w))E.push([S,w[S].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.getScopes=d}),define(me[84],ge([0,1,24,11,2,40,4,83]),function(G,e,b,I,T,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function D(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof T.URI)}e.isConfigurationOverrides=D;var k;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function C(n,o){const r=o?n?o.keys.filter(R=>n.keys.indexOf(R)===-1):[...o.keys]:[],s=n?o?n.keys.filter(R=>o.keys.indexOf(R)===-1):[...n.keys]:[],c=[];if(o&&n){for(const R of n.keys)if(o.keys.indexOf(R)!==-1){const O=w(n.contents,R),j=w(o.contents,R);b.equals(O,j)||c.push(R)}}const h=[],_=R=>{const O={};for(const j of R)for(const ie of j.identifiers)O[v(ie)]=j;return O},u=o?_(o.overrides):{},p=n?_(n.overrides):{};if(Object.keys(u).length)for(const R of r){const O=u[R];O&&h.push([(0,P.overrideIdentifierFromKey)(R),O.keys])}if(Object.keys(p).length)for(const R of s){const O=p[R];O&&h.push([(0,P.overrideIdentifierFromKey)(R),O.keys])}if(Object.keys(u).length&&Object.keys(p).length)for(const R of c){const O=p[R],j=u[R];if(O&&j){const ie=C({contents:O.contents,keys:O.keys,overrides:[]},{contents:j.contents,keys:j.keys,overrides:[]});h.push([(0,P.overrideIdentifierFromKey)(R),[...ie.added,...ie.removed,...ie.updated]])}}return{added:r,removed:s,updated:c,overrides:h}}e.compare=C;function f(n,o){const r=[];for(const s of Object.keys(n))if(P.OVERRIDE_PROPERTY_PATTERN.test(s)){const c={};for(const h in n[s])c[h]=n[s][h];r.push({identifiers:[(0,P.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(c),contents:m(c,o)})}return r}e.toOverrides=f;function m(n,o){const r=Object.create(null);for(let s in n)l(r,s,n[s],o);return r}e.toValuesTree=m;function l(n,o,r,s){const c=o.split("."),h=c.pop();let _=n;for(let u=0;u<c.length;u++){let p=c[u],R=_[p];switch(typeof R){case"undefined":R=_[p]=Object.create(null);break;case"object":break;default:s(`Ignoring ${o} as ${c.slice(0,u+1).join(".")} is ${JSON.stringify(R)}`);return}_=R}if(typeof _=="object"&&_!==null)try{_[h]=r}catch(u){s(`Ignoring ${o} as ${c.join(".")} is ${JSON.stringify(_)}`)}else s(`Ignoring ${o} as ${c.join(".")} is ${JSON.stringify(_)}`)}e.addToValueTree=l;function d(n,o){const r=o.split(".");E(n,r)}e.removeFromValueTree=d;function E(n,o){const r=o.shift();if(o.length===0){delete n[r];return}if(Object.keys(n).indexOf(r)!==-1){const s=n[r];typeof s=="object"&&!Array.isArray(s)&&(E(s,o),Object.keys(s).length===0&&delete n[r])}}function w(n,o,r){function s(_,u){let p=_;for(const R of u){if(typeof p!="object"||p===null)return;p=p[R]}return p}const c=o.split("."),h=s(n,c);return typeof h=="undefined"?r:h}e.getConfigurationValue=w;function S(n,o,r){Object.keys(o).forEach(s=>{s!=="__proto__"&&(s in n?I.isObject(n[s])&&I.isObject(o[s])?S(n[s],o[s],r):r&&(n[s]=o[s]):n[s]=o[s])})}e.merge=S;function g(){const n=A.Registry.as(P.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}e.getConfigurationKeys=g;function a(){const n=Object.create(null),o=A.Registry.as(P.Extensions.Configuration).getConfigurationProperties();for(let r in o){let s=o[r].default;l(n,r,s,c=>console.error(`Conflict in default settings: ${c}`))}return n}e.getDefaultValues=a;function v(n){return`[${n}]`}e.keyFromOverrideIdentifier=v;function t(n,o,r){const s=n.inspect(o),c=n.inspect(r);return typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:s.defaultValue}e.getMigratedSettingValue=t}),define(me[188],ge([0,1,56,22,17,11,24,2,83,84,40,6,3]),function(G,e,b,I,T,A,y,P,D,k,i,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(t={},n=[],o=[]){this._contents=t,this._keys=n,this._overrides=o,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,k.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,n){const o=this.getContentsForOverrideIdentifer(n);return o?t?(0,k.getConfigurationValue)(o,t):o:void 0}getKeysForOverrideIdentifier(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.keys;return[]}override(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let o={};for(const r of T.distinct([...Object.keys(this.contents),...Object.keys(n)])){let s=this.contents[r],c=n[r];c&&(typeof s=="object"&&typeof c=="object"?(s=y.deepClone(s),this.mergeContents(s,c)):s=c),o[r]=s}return new m(o,this.keys,this.overrides)}merge(...t){const n=y.deepClone(this.contents),o=y.deepClone(this.overrides),r=[...this.keys];for(const s of t){this.mergeContents(n,s.contents);for(const c of s.overrides){const[h]=o.filter(_=>T.equals(_.identifiers,c.identifiers));h?this.mergeContents(h.contents,c.contents):o.push(y.deepClone(c))}for(const c of s.keys)r.indexOf(c)===-1&&r.push(c)}return new m(n,r,o)}freeze(){return this.isFrozen=!0,this}mergeContents(t,n){for(const o of Object.keys(n)){if(o in t&&A.isObject(t[o])&&A.isObject(n[o])){this.mergeContents(t[o],n[o]);continue}t[o]=y.deepClone(n[o])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?y.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),(0,k.addToValueTree)(this.contents,t,n,o=>{throw new Error(o)})}removeValue(t){this.removeKey(t)&&(0,k.removeFromValueTree)(this.contents,t)}addKey(t){let n=this.keys.length;for(let o=0;o<n;o++)t.indexOf(this.keys[o])===0&&(n=o);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=m;class l extends m{constructor(){const t=(0,k.getDefaultValues)(),n=(0,k.getConfigurationKeys)(),o=[];for(const r of Object.keys(t))D.OVERRIDE_PROPERTY_PATTERN.test(r)&&o.push({identifiers:[(0,D.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(t[r]),contents:(0,k.toValuesTree)(t[r],s=>console.error(`Conflict in default settings file: ${s}`))});super(t,n,o)}}e.DefaultConfigurationModel=l;class d{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,n){if(!A.isUndefinedOrNull(t)){const o=this.doParseContent(t);this.parseRaw(o,n)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,n){this._raw=t;const{contents:o,keys:r,overrides:s,restricted:c}=this.doParseRaw(t,n);this._configurationModel=new m(o,r,s),this._restrictedConfigurations=c||[]}doParseContent(t){let n={},o=null,r=[],s=[],c=[];function h(u){Array.isArray(r)?r.push(u):o&&(r[o]=u)}let _={onObjectBegin:()=>{let u={};h(u),s.push(r),r=u,o=null},onObjectProperty:u=>{o=u},onObjectEnd:()=>{r=s.pop()},onArrayBegin:()=>{let u=[];h(u),s.push(r),r=u,o=null},onArrayEnd:()=>{r=s.pop()},onLiteralValue:h,onError:(u,p,R)=>{c.push({error:u,offset:p,length:R})}};if(t)try{b.visit(t,_),n=r[0]||{}}catch(u){console.error(`Error while parsing settings file ${this._name}: ${u}`),this._parseErrors=[u]}return n}doParseRaw(t,n){const o=i.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),r=this.filter(t,o,!0,n);t=r.raw;const s=(0,k.toValuesTree)(t,_=>console.error(`Conflict in settings file ${this._name}: ${_}`)),c=Object.keys(t),h=(0,k.toOverrides)(t,_=>console.error(`Conflict in settings file ${this._name}: ${_}`));return{contents:s,keys:c,overrides:h,restricted:r.restricted}}filter(t,n,o,r){if(!(r==null?void 0:r.scopes)&&!(r==null?void 0:r.skipRestricted))return{raw:t,restricted:[]};const s={},c=[];for(let h in t)if(D.OVERRIDE_PROPERTY_PATTERN.test(h)&&o){const _=this.filter(t[h],n,!1,r);s[h]=_.raw,c.push(..._.restricted)}else{const _=n[h],u=_?typeof _.scope!="undefined"?_.scope:3:void 0;(_==null?void 0:_.restricted)&&c.push(h),(u===void 0||r.scopes===void 0||r.scopes.includes(u))&&(r.skipRestricted&&(_==null?void 0:_.restricted)||(s[h]=t[h]))}return{raw:s,restricted:c}}}e.ConfigurationModelParser=d;class E extends C.Disposable{constructor(t,n,o,r){super();this.userSettingsResource=t,this.scopes=n,this.fileService=r,this._onDidChange=this._register(new f.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(f.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=E;class w{constructor(t,n,o=new m,r=new m,s=new I.ResourceMap,c=new m,h=new I.ResourceMap,_=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=o,this._workspaceConfiguration=r,this._folderConfigurations=s,this._memoryConfiguration=c,this._memoryConfigurationByResource=h,this._freeze=_,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new I.ResourceMap,this._userConfiguration=null}getValue(t,n,o){return this.getConsolidateConfigurationModel(n,o).getValue(t)}updateValue(t,n,o={}){let r;o.resource?(r=this._memoryConfigurationByResource.get(o.resource),r||(r=new m,this._memoryConfigurationByResource.set(o.resource,r))):r=this._memoryConfiguration,n===void 0?r.removeValue(t):r.setValue(t,n),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,o){const r=this.getConsolidateConfigurationModel(n,o),s=this.getFolderConfigurationModelForResource(n.resource,o),c=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,h=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),_=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),u=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),p=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),R=o?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,O=s?n.overrideIdentifier?s.freeze().override(n.overrideIdentifier).getValue(t):s.freeze().getValue(t):void 0,j=n.overrideIdentifier?c.override(n.overrideIdentifier).getValue(t):c.getValue(t),ie=r.getValue(t),K=T.distinct(T.flatten(r.overrides.map(x=>x.identifiers))).filter(x=>r.getOverrideValue(t,x)!==void 0);return{defaultValue:h,userValue:_,userLocalValue:u,userRemoteValue:p,workspaceValue:R,workspaceFolderValue:O,memoryValue:j,value:ie,default:h!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:_!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:u!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:p!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:s==null?void 0:s.freeze().getValue(t),override:n.overrideIdentifier?s==null?void 0:s.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:j!==void 0?{value:c.getValue(t),override:n.overrideIdentifier?c.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:K.length?K:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const o=n.filter(r=>D.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const s=(0,D.overrideIdentifierFromKey)(r),c=this._defaultConfiguration.getKeysForOverrideIdentifier(s),h=t.getKeysForOverrideIdentifier(s),_=[...h.filter(u=>c.indexOf(u)===-1),...c.filter(u=>h.indexOf(u)===-1),...c.filter(u=>!y.equals(this._defaultConfiguration.override(s).getValue(u),t.override(s).getValue(u)))];return[s,_]});return this.updateDefaultConfiguration(t),{keys:n,overrides:o}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:o,removed:r,overrides:s}=(0,k.compare)(this.localUserConfiguration,t),c=[...n,...o,...r];return c.length&&this.updateLocalUserConfiguration(t),{keys:c,overrides:s}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:o,removed:r,overrides:s}=(0,k.compare)(this.remoteUserConfiguration,t);let c=[...n,...o,...r];return c.length&&this.updateRemoteUserConfiguration(t),{keys:c,overrides:s}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:o,removed:r,overrides:s}=(0,k.compare)(this.workspaceConfiguration,t);let c=[...n,...o,...r];return c.length&&this.updateWorkspaceConfiguration(t),{keys:c,overrides:s}}compareAndUpdateFolderConfiguration(t,n){const o=this.folderConfigurations.get(t),{added:r,updated:s,removed:c,overrides:h}=(0,k.compare)(o,n);let _=[...r,...s,...c];return(_.length||!o)&&this.updateFolderConfiguration(t,n),{keys:_,overrides:h}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:o,updated:r,removed:s,overrides:c}=(0,k.compare)(n,void 0);return{keys:[...o,...r,...s],overrides:c}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let o=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?o.override(t.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:t},n){let o=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const r=n.getFolder(t);r&&(o=this.getFolderConsolidatedConfiguration(r.uri)||o);const s=this._memoryConfigurationByResource.get(t);s&&(o=o.merge(s))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const o=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(t);r?(n=o.merge(r),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=o}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const o=n.getFolder(t);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:o,overrides:r,keys:s}=this._folderConfigurations.get(n);return t.push([n,{contents:o,overrides:r,keys:s}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(o=>t.add(o))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),o=this.parseConfigurationModel(t.user),r=this.parseConfigurationModel(t.workspace),s=t.folders.reduce((c,h)=>(c.set(P.URI.revive(h[0]),this.parseConfigurationModel(h[1])),c),new I.ResourceMap);return new w(n,o,new m,r,s,new m,new I.ResourceMap,!1)}static parseConfigurationModel(t){return new m(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=w;function S(...v){if(v.length===0)return{keys:[],overrides:[]};if(v.length===1)return v[0];const t=new Set,n=new Map;for(const r of v)r.keys.forEach(s=>t.add(s)),r.overrides.forEach(([s,c])=>{const h=(0,I.getOrSet)(n,s,new Set);c.forEach(_=>h.add(_))});const o=[];return n.forEach((r,s)=>o.push([s,[...r.values()]])),{keys:[...t.values()],overrides:o}}e.mergeChanges=S;class g{constructor(t,n,o,r){this.change=t,this.previous=n,this.currentConfiguraiton=o,this.currentWorkspace=r,this._previousConfiguration=void 0;const s=new Set;t.keys.forEach(h=>s.add(h)),t.overrides.forEach(([,h])=>h.forEach(_=>s.add(_))),this.affectedKeys=[...s.values()];const c=new m;this.affectedKeys.forEach(h=>c.setValue(h,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){var o;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,n,(o=this.previous)===null||o===void 0?void 0:o.workspace):void 0,s=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!y.equals(r,s)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let o=(0,k.toValuesTree)({[n]:!0},()=>{}),r;for(;typeof o=="object"&&(r=Object.keys(o)[0]);){if(t=t[r],!t)return!1;o=o[r]}return!0}}e.ConfigurationChangeEvent=g;class a extends g{constructor(t,n,o,r){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=o,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=a}),define(me[189],ge([0,1,38,8,78,155,26,10,184,84,4,12,95]),function(G,e,b,I,T,A,y,P,D,k,i,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const m=A.localize(0,null);class l{async getDefaultTerminalForPlatforms(){const t=await w.getDefaultTerminalLinuxReady();return{windows:d.getDefaultTerminalWindows(),linux:t,osx:"xterm"}}}let d=class jt extends l{constructor(t){super();this._configurationService=t}openTerminal(t){const n=this._configurationService.getValue();return this.spawnTerminal(b,n,T.getWindowsShell(),t)}spawnTerminal(t,n,o,r){const s=n.terminal.external,c=(s==null?void 0:s.windowsExec)||jt.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const h=I.basename(c).toLowerCase();if(h==="cmder"||h==="cmder.exe")return t.spawn(c,r?[r]:void 0),Promise.resolve(void 0);const _=["/c","start","/wait"];return c.indexOf(" ")>=0&&_.push('""'),_.push(c),(h==="wt"||h==="wt.exe")&&_.push("-d ."),new Promise((u,p)=>{const R=S(process),O=t.spawn(o,_,{cwd:r,env:R});O.on("error",p),O.on("exit",()=>u())})}runInTerminal(t,n,o,r,s){const c=s.windowsExec||jt.getDefaultTerminalWindows();return new Promise((h,_)=>{const u=`"${n} - ${m}"`,p=`""${o.join('" "')}" & pause"`,R=["/c","start",u,"/wait",c,"/c",p],O=Object.assign({},S(process),r);Object.keys(O).filter(K=>O[K]===null).forEach(K=>delete O[K]);const j={cwd:n,env:O,windowsVerbatimArguments:!0};b.spawn(jt.CMD,R,j).on("error",K=>{_(g(K))}),h(void 0)})}static getDefaultTerminalWindows(){if(!jt._DEFAULT_TERMINAL_WINDOWS){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");jt._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return jt._DEFAULT_TERMINAL_WINDOWS}};d.CMD="cmd.exe",d=qe([He(0,(0,i.optional)(k.IConfigurationService))],d),e.WindowsExternalTerminalService=d;let E=class Nn extends l{constructor(t){super();this._configurationService=t}openTerminal(t){const n=this._configurationService.getValue();return this.spawnTerminal(b,n,t)}runInTerminal(t,n,o,r,s){const c=s.osxExec||D.DEFAULT_TERMINAL_OSX;return new Promise((h,_)=>{if(c===D.DEFAULT_TERMINAL_OSX||c==="iTerm.app"){const u=c===D.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",R=[C.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${u}.scpt`,G).fsPath,"-t",t||m,"-w",n];for(let ie of o)R.push("-a"),R.push(ie);if(r)for(let ie in r){const K=r[ie];K===null?(R.push("-u"),R.push(ie)):(R.push("-e"),R.push(`${ie}=${K}`))}let O="";const j=b.spawn(Nn.OSASCRIPT,R);j.on("error",ie=>{_(g(ie))}),j.stderr.on("data",ie=>{O+=ie.toString()}),j.on("exit",ie=>{if(ie===0)h(void 0);else if(O){const K=O.split(`
`,1);_(new Error(K[0]))}else _(new Error(A.localize(1,null,u,ie)))})}else _(new Error(A.localize(2,null,c)))})}spawnTerminal(t,n,o){const r=n.terminal.external,s=(r==null?void 0:r.osxExec)||D.DEFAULT_TERMINAL_OSX;return new Promise((c,h)=>{const _=["-a",s];o&&_.push(o);const u=t.spawn("/usr/bin/open",_);u.on("error",h),u.on("exit",()=>c())})}};E.OSASCRIPT="/usr/bin/osascript",E=qe([He(0,(0,i.optional)(k.IConfigurationService))],E),e.MacExternalTerminalService=E;let w=class qt extends l{constructor(t){super();this._configurationService=t}openTerminal(t){const n=this._configurationService.getValue();return this.spawnTerminal(b,n,t)}runInTerminal(t,n,o,r,s){const c=s.linuxExec?Promise.resolve(s.linuxExec):qt.getDefaultTerminalLinuxReady();return new Promise((h,_)=>{let u=[];c.then(p=>{p.indexOf("gnome-terminal")>=0?u.push("-x"):u.push("-e"),u.push("bash"),u.push("-c");const R=`${a(o)}; echo; read -p "${qt.WAIT_MESSAGE}" -n1;`;u.push(`''${R}''`);const O=Object.assign({},process.env,r);Object.keys(O).filter(x=>O[x]===null).forEach(x=>delete O[x]);const j={cwd:n,env:O};let ie="";const K=b.spawn(p,u,j);K.on("error",x=>{_(g(x))}),K.stderr.on("data",x=>{ie+=x.toString()}),K.on("exit",x=>{if(x===0)h(void 0);else if(ie){const $=ie.split(`
`,1);_(new Error($[0]))}else _(new Error(A.localize(4,null,p,x)))})})})}static async getDefaultTerminalLinuxReady(){return qt._DEFAULT_TERMINAL_LINUX_READY||(qt._DEFAULT_TERMINAL_LINUX_READY=new Promise(async t=>{P.isLinux?await y.exists("/etc/debian_version")?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm"):t("xterm")})),qt._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(t,n,o){const r=n.terminal.external,s=(r==null?void 0:r.linuxExec)?Promise.resolve(r.linuxExec):qt.getDefaultTerminalLinuxReady();return new Promise((c,h)=>{s.then(_=>{const u=S(process),p=t.spawn(_,[],{cwd:o,env:u});p.on("error",h),p.on("exit",()=>c())})})}};w.WAIT_MESSAGE=A.localize(3,null),w=qe([He(0,(0,i.optional)(k.IConfigurationService))],w),e.LinuxExternalTerminalService=w;function S(v){const t=v.env;return(0,f.sanitizeProcessEnvironment)(t),t}function g(v){return"errno"in v&&v.errno==="ENOENT"&&"path"in v&&typeof v.path=="string"?new Error(A.localize(5,null,v.path)):v}function a(v){let t="";for(let n of v)n.indexOf(" ")>=0?t+='"'+n+'"':t+=n,t+=" ";return t}}),define(me[85],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.RemoteTrustOption=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,b.createDecorator)("remoteAuthorityResolverService");var I;(function(y){y[y.Unknown=0]="Unknown",y[y.DisableTrust=1]="DisableTrust",y[y.MachineTrusted=2]="MachineTrusted"})(I=e.RemoteTrustOption||(e.RemoteTrustOption={}));var T;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(T=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends Error{constructor(P,D=T.Unknown,k){super(P);this._message=P,this._code=D,this._detail=k,this.isHandled=D===T.NotAvailable&&k===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,A.prototype)}static isTemporarilyNotAvailable(P){return P instanceof A&&P._code===T.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof A&&P._code===T.NoResolverFound}static isHandled(P){return P instanceof A&&P.isHandled}}e.RemoteAuthorityResolverError=A}),define(me[118],ge([0,1,12]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function I(D){return D.scheme===b.Schemas.vscodeRemote?D.authority:void 0}e.getRemoteAuthority=I;function T(D){if(!!D){const k=D.indexOf("+");return k<0?D:D.substr(0,k)}}e.getRemoteName=T;function A(D){return D.scheme!==b.Schemas.file&&D.scheme!==b.Schemas.vscodeRemote}function y(D){if(D.folders.length)return D.folders.every(k=>A(k.uri))?D.folders[0].uri:void 0;if(D.configuration&&A(D.configuration))return D.configuration}e.getVirtualWorkspaceLocation=y;function P(D){var k;return(k=y(D))===null||k===void 0?void 0:k.scheme}e.getVirtualWorkspaceScheme=P}),define(me[190],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class b{vsda(){return new Promise((T,A)=>G(["vsda"],T,A))}async sign(T){try{const A=await this.vsda(),y=new A.signer;if(y)return y.sign(T)}catch(A){}return T}}e.SignService=b}),define(me[191],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class b{constructor(T){this._callback=T,this._terminalBufferMap=new Map}dispose(){for(const T of this._terminalBufferMap.values())T.dispose()}startBuffering(T,A,y=5){let P;return P=A(D=>{const k=typeof D=="string"?D:D.data;let i=this._terminalBufferMap.get(T);if(i){i.data.push(k);return}const C=setTimeout(()=>this.flushBuffer(T),y);i={data:[k],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(T),P.dispose()}},this._terminalBufferMap.set(T,i)}),P}stopBuffering(T){const A=this._terminalBufferMap.get(T);A&&A.dispose()}flushBuffer(T){const A=this._terminalBufferMap.get(T);A&&(this._terminalBufferMap.delete(T),this._callback(T,A.data.join("")))}}e.TerminalDataBufferer=b}),define(me[192],ge([0,1,48,8,36,26,11,24,10]),function(G,e,b,I,T,A,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function k(){const C=/(\d+)\.(\d+)\.(\d+)/g.exec(b.release());let f=0;return C&&C.length===4&&(f=parseInt(C[3])),f}e.getWindowsBuildNumber=k;async function i(C,f,m,l=T.env,d=A.exists){if(I.isAbsolute(C))return await d(C)?C:void 0;if(f===void 0&&(f=T.cwd()),I.dirname(C)!=="."){const g=I.join(f,C);return await d(g)?g:void 0}const w=(0,P.getCaseInsensitive)(l,"PATH");if(m===void 0&&(0,y.isString)(w)&&(m=w.split(I.delimiter)),m===void 0||m.length===0){const g=I.join(f,C);return await d(g)?g:void 0}for(let g of m){let a;if(I.isAbsolute(g)?a=I.join(g,C):a=I.join(f,g,C),await d(a))return a;if(D.isWindows){let v=a+".com";if(await d(v)||(v=a+".exe",await d(v)))return v}}const S=I.join(f,C);return await d(S)?S:void 0}e.findExecutable=i}),define(me[193],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var b;(function(I){I.DARK="dark",I.LIGHT="light",I.HIGH_CONTRAST="hc"})(b=e.ColorScheme||(e.ColorScheme={}))}),define(me[194],ge([0,1,4,6,40,3,193,43]),function(G,e,b,I,T,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,b.createDecorator)("themeService");var D;(function(E){function w(S){return S&&typeof S=="object"&&typeof S.id=="string"}E.isThemeColor=w})(D=e.ThemeColor||(e.ThemeColor={}));function k(E){return{id:E}}e.themeColorFromId=k;var i;(function(E){function w(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||D.isThemeColor(t.color))}E.isThemeIcon=w;const S=new RegExp(`^\\$\\((${P.CSSIcon.iconNameExpression}(?:${P.CSSIcon.iconModifierExpression})?)\\)$`);function g(t){const n=S.exec(t);if(!!n){let[,o]=n;return{id:o}}}E.fromString=g;function a(t,n){let o=t.id;const r=o.lastIndexOf("~");return r!==-1&&(o=o.substring(0,r)),n&&(o=`${o}~${n}`),{id:o}}E.modify=a;function v(t,n){var o,r;return t.id===n.id&&((o=t.color)===null||o===void 0?void 0:o.id)===((r=n.color)===null||r===void 0?void 0:r.id)}E.isEqual=v,E.asClassNameArray=P.CSSIcon.asClassNameArray,E.asClassName=P.CSSIcon.asClassName,E.asCSSSelector=P.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=P.Codicon.file,e.FolderThemeIcon=P.Codicon.folder;function C(E){switch(E){case y.ColorScheme.DARK:return"vs-dark";case y.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class f{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new A.Emitter}onColorThemeChange(w){return this.themingParticipants.push(w),this.onThemingParticipantAddedEmitter.fire(w),(0,I.toDisposable)(()=>{const S=this.themingParticipants.indexOf(w);this.themingParticipants.splice(S,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new f;T.Registry.add(e.Extensions.ThemingContribution,m);function l(E){return m.onColorThemeChange(E)}e.registerThemingParticipant=l;class d extends I.Disposable{constructor(w){super();this.themeService=w,this.theme=w.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(S=>this.onThemeChange(S)))}onThemeChange(w){this.theme=w,this.updateStyles()}updateStyles(){}getColor(w,S){let g=this.theme.getColor(w);return g&&S&&(g=S(g,this.theme)),g?g.toString():null}}e.Themable=d}),define(me[195],ge([0,1,40,194,3,158,117,13,43]),function(G,e,b,I,T,A,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class k{constructor(){this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,A.localize)(0,null)},fontCharacter:{type:"string",description:(0,A.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${D.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(w,S,g,a){const v=this.iconsById[w];if(v){if(g&&!v.description){v.description=g,this.iconSchema.properties[w].markdownDescription=`${g} $(${w})`;const o=this.iconReferenceSchema.enum.indexOf(w);o!==-1&&(this.iconReferenceSchema.enumDescriptions[o]=g),this._onDidChange.fire()}return v}let t={id:w,description:g,defaults:S,deprecationMessage:a};this.iconsById[w]=t;let n={$ref:"#/definitions/icons"};return a&&(n.deprecationMessage=a),g&&(n.markdownDescription=`${g}: $(${w})`),this.iconSchema.properties[w]=n,this.iconReferenceSchema.enum.push(w),this.iconReferenceSchema.enumDescriptions.push(g||""),this._onDidChange.fire(),{id:w}}deregisterIcon(w){delete this.iconsById[w],delete this.iconSchema.properties[w];const S=this.iconReferenceSchema.enum.indexOf(w);S!==-1&&(this.iconReferenceSchema.enum.splice(S,1),this.iconReferenceSchema.enumDescriptions.splice(S,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(w=>this.iconsById[w])}getIcon(w){return this.iconsById[w]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(w,S){const g=this.iconFontsById[w];if(g)return g;let a={id:w,definition:S};return this.iconFontsById[w]=a,this._onDidChange.fire(),a}deregisterIconFont(w){delete this.iconFontsById[w]}getIconFonts(){return Object.keys(this.iconFontsById).map(w=>this.iconFontsById[w])}getIconFont(w){return this.iconFontsById[w]}toString(){const w=(v,t)=>v.id.localeCompare(t.id),S=v=>{for(;I.ThemeIcon.isThemeIcon(v.defaults);)v=this.iconsById[v.defaults.id];return`codicon codicon-${v?v.id:""}`};let g=[];g.push("| preview     | identifier                        | default codicon ID                | description"),g.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const a=Object.keys(this.iconsById).map(v=>this.iconsById[v]);for(const v of a.filter(t=>!!t.description).sort(w))g.push(`|<i class="${S(v)}"></i>|${v.id}|${I.ThemeIcon.isThemeIcon(v.defaults)?v.defaults.id:v.id}|${v.description||""}|`);g.push("| preview     | identifier                        "),g.push("| ----------- | --------------------------------- |");for(const v of a.filter(t=>!I.ThemeIcon.isThemeIcon(t.defaults)).sort(w))g.push(`|<i class="${S(v)}"></i>|${v.id}|`);return g.join(`
`)}}const i=new k;b.Registry.add(e.Extensions.IconContribution,i);function C(E,w,S,g){return i.registerIcon(E,w,S,g)}e.registerIcon=C;function f(){return i}e.getIconRegistry=f;function m(){for(const E of D.iconRegistry.all)i.registerIcon(E.id,E.definition,E.description);D.iconRegistry.onDidRegister(E=>i.registerIcon(E.id,E.definition,E.description))}m(),e.iconsSchemaId="vscode://schemas/icons";let l=b.Registry.as(y.Extensions.JSONContribution);l.registerSchema(e.iconsSchemaId,i.getIconSchema());const d=new P.RunOnceScheduler(()=>l.notifySchemaChanged(e.iconsSchemaId),200);i.onDidChange(()=>{d.isScheduled()||d.schedule()}),e.widgetClose=C("widget-close",D.Codicon.close,(0,A.localize)(2,null)),e.gotoPreviousLocation=C("goto-previous-location",D.Codicon.arrowUp,(0,A.localize)(3,null)),e.gotoNextLocation=C("goto-next-location",D.Codicon.arrowDown,(0,A.localize)(4,null)),e.syncing=I.ThemeIcon.modify(D.Codicon.sync,"spin")}),define(me[61],ge([0,1,2,25,4,22]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");var y;(function(f){f[f.EMPTY=1]="EMPTY",f[f.FOLDER=2]="FOLDER",f[f.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function P(f){const m=f;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=P;function D(f){const m=f;return!!(m&&typeof m=="object"&&b.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=D;class k{constructor(m,l,d,E){this._id=m,this._configuration=d,this._ignorePathCasing=E,this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=l}update(m){this._id=m.id,this._configuration=m.configuration,this._ignorePathCasing=m._ignorePathCasing,this.folders=m.folders}get folders(){return this._folders}set folders(m){this._folders=m,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(m){this._configuration=m}getFolder(m){return m&&this._foldersMap.findSubstr(m.with({scheme:m.scheme,authority:m.authority,path:m.path}))||null}updateFoldersMap(){this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing);for(const m of this.folders)this._foldersMap.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=k;class i{constructor(m,l){this.raw=l,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,I.joinPath)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function C(f){return new i({uri:f,index:0,name:(0,I.basenameOrAuthority)(f)},{uri:f.toString()})}e.toWorkspaceFolder=C}),define(me[119],ge([0,1,4,159,61,2,10,8,25,134,56,12,76,29,118]),function(G,e,b,I,T,A,y,P,D,k,i,C,f,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const d=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E($){return(typeof $=="string"?(0,P.extname)($):(0,D.extname)($))===d}e.hasWorkspaceFileExtension=E,e.IWorkspacesService=(0,b.createDecorator)("workspacesService");function w($){return $.hasOwnProperty("workspace")}e.isRecentWorkspace=w;function S($){return $.hasOwnProperty("folderUri")}e.isRecentFolder=S;function g($){return $.hasOwnProperty("fileUri")}e.isRecentFile=g;function a($){const U=$;return typeof(U==null?void 0:U.id)=="string"&&A.URI.isUri(U.uri)}e.isSingleFolderWorkspaceIdentifier=a;function v($){if($.configuration)return{id:$.id,configPath:$.configuration};if($.folders.length===1)return{id:$.id,uri:$.folders[0].uri}}e.toWorkspaceIdentifier=v;function t($){const U=$;return typeof(U==null?void 0:U.id)=="string"&&A.URI.isUri(U.configPath)}e.isWorkspaceIdentifier=t;function n($){const U=$;if(U==null?void 0:U.uri)return{id:U.id,uri:A.URI.revive(U.uri)};const L=$;if(L==null?void 0:L.configPath)return{id:L.id,configPath:A.URI.revive(L.configPath)};if($==null?void 0:$.id)return{id:$.id}}e.reviveIdentifier=n;function o($,U){return D.extUriBiasedIgnorePathCase.isEqualOrParent($,U.untitledWorkspacesHome)}e.isUntitledWorkspace=o;function r($){return s($)||c($)}e.isStoredWorkspaceFolder=r;function s($){const U=$;return typeof(U==null?void 0:U.path)=="string"&&(!U.name||typeof U.name=="string")}e.isRawFileWorkspaceFolder=s;function c($){const U=$;return typeof(U==null?void 0:U.uri)=="string"&&(!U.name||typeof U.name=="string")}e.isRawUriWorkspaceFolder=c;function h($,U,L,N,M=!y.isWindows,F){if($.scheme!==N.scheme)return{name:L,uri:$.toString(!0)};let W=U?void 0:F.relativePath(N,$);if(W!==void 0)W.length===0?W=".":y.isWindows&&$.scheme===C.Schemas.file&&!M&&(W=W.replace(/\//g,"\\"));else if($.scheme===C.Schemas.file)W=$.fsPath,y.isWindows&&(W=(0,f.normalizeDriveLetter)(W),M&&(W=(0,m.toSlashes)(W)));else{if(!F.isEqualAuthority($.authority,N.authority))return{name:L,uri:$.toString(!0)};W=$.path}return{name:L,path:W}}e.getStoredWorkspaceFolder=h;function _($,U,L){let N=[],M=new Set;const F=L.dirname(U);for(let W of $){let q;if(s(W))W.path&&(q=L.resolvePath(F,W.path));else if(c(W))try{q=A.URI.parse(W.uri),q.path[0]!=="/"&&(q=q.with({path:"/"+q.path}))}catch(Q){console.warn(Q)}if(q){let Q=L.getComparisonKey(q);if(!M.has(Q)){M.add(Q);const le=W.name||L.basenameOrAuthority(q);N.push(new T.WorkspaceFolder({uri:q,name:le,index:N.length},W))}}}return N}e.toWorkspaceFolders=_;function u($,U,L,N,M){let F=p(U,$);const W=M.dirname(U),q=M.dirname(N),Q=[],le=R(F.folders);for(const Oe of F.folders){const z=s(Oe)?M.resolvePath(W,Oe.path):A.URI.parse(Oe.uri);let Y;L?Y=!1:Y=!s(Oe)||(0,P.isAbsolute)(Oe.path),Q.push(h(z,Y,Oe.name,q,le,M))}const ve={insertSpaces:!1,tabSize:4,eol:y.isLinux||y.isMacintosh?`
`:`\r
`},Re=k.setProperty($,["folders"],Q,ve);let Se=k.applyEdits($,Re);return F.remoteAuthority===(0,l.getRemoteAuthority)(N)&&(Se=k.applyEdits(Se,k.removeProperty(Se,["remoteAuthority"],ve))),Se}e.rewriteWorkspaceFileForNewLocation=u;function p($,U){let L=i.parse(U);if(L&&Array.isArray(L.folders))L.folders=L.folders.filter(N=>r(N));else throw new Error(`${$} looks like an invalid workspace file.`);return L}function R($){return y.isWindows?$.some(U=>s(U)&&U.path.indexOf("/")>=0):!0}e.useSlashForPath=R;function O($){return $.workspace&&typeof $.workspace=="object"&&typeof $.workspace.id=="string"&&typeof $.workspace.configPath=="string"}function j($){return typeof $.folderUri=="string"}function ie($){return typeof $.fileUri=="string"}function K($,U){const L={workspaces:[],files:[]};if($){const N=function(F,W){for(let q=0;q<F.length;q++)try{W(F[q],q)}catch(Q){U.warn(`Error restoring recent entry ${JSON.stringify(F[q])}: ${Q.toString()}. Skip entry.`)}},M=$;if(Array.isArray(M.entries))N(M.entries,F=>{const W=F.label,q=F.remoteAuthority;O(F)?L.workspaces.push({label:W,remoteAuthority:q,workspace:{id:F.workspace.id,configPath:A.URI.parse(F.workspace.configPath)}}):j(F)?L.workspaces.push({label:W,remoteAuthority:q,folderUri:A.URI.parse(F.folderUri)}):ie(F)&&L.files.push({label:W,remoteAuthority:q,fileUri:A.URI.parse(F.fileUri)})});else{const F=$;Array.isArray(F.workspaces3)&&N(F.workspaces3,(W,q)=>{const Q=Array.isArray(F.workspaceLabels)&&F.workspaceLabels[q]||void 0;typeof W=="object"&&typeof W.id=="string"&&typeof W.configURIPath=="string"?L.workspaces.push({label:Q,workspace:{id:W.id,configPath:A.URI.parse(W.configURIPath)}}):typeof W=="string"&&L.workspaces.push({label:Q,folderUri:A.URI.parse(W)})}),Array.isArray(F.files2)&&N(F.files2,(W,q)=>{const Q=Array.isArray(F.fileLabels)&&F.fileLabels[q]||void 0;typeof W=="string"&&L.files.push({label:Q,fileUri:A.URI.parse(W)})})}}return L}e.restoreRecentlyOpened=K;function x($){const U={entries:[]};for(const L of $.workspaces)S(L)?U.entries.push({folderUri:L.folderUri.toString(),label:L.label,remoteAuthority:L.remoteAuthority}):U.entries.push({workspace:{id:L.workspace.id,configPath:L.workspace.configPath.toString()},label:L.label,remoteAuthority:L.remoteAuthority});for(const L of $.files)U.entries.push({fileUri:L.fileUri.toString(),label:L.label,remoteAuthority:L.remoteAuthority});return U}e.toStoreData=x}),define(me[86],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class b{constructor(T){this.id=T,this._data=new Map,this._idPool=1}add(T){const A=this._idPool++;return this._data.set(A,T),this.logDebugInfo(),A}get(T,A){return this._data.has(T)?this._data.get(T)[A]:void 0}delete(T){this._data.delete(T),this.logDebugInfo()}logDebugInfo(){!b.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=b,b.enableDebugLogging=!1}),define(me[196],ge([0,1,2,3]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class T{constructor(){this._onDidChangeTabs=new I.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(y){this._tabs=y.map(P=>({name:P.name,group:P.group,resource:b.URI.revive(P.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=T}),define(me[62],ge([0,1,12,4]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class T{constructor(){this._systemSchemes=new Set(Object.keys(b.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(y,P){P===null?this._providerInfo.delete(y):this._providerInfo.set(y,P)}isFreeScheme(y){return!this._providerInfo.has(y)&&!this._systemSchemes.has(y)}getCapabilities(y){return this._providerInfo.get(y)}}e.ExtHostFileSystemInfo=T,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(me[28],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,b.createDecorator)("IExtHostInitDataService")}),define(me[197],ge([0,1,13]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class I{constructor(y,P,D){this._deferredPromises=new Map,this._id=y,this._shared=P,this._storage=D,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(k=>(this._value=k,this)),this._storageListener=this._storage.onDidChangeStorage(k=>{k.shared===this._shared&&k.key===this._id&&(this._value=k.value)}),this._scheduler=new b.RunOnceScheduler(()=>{const k=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const i of k.values())i.complete()}catch(i){for(const C of k.values())C.error(i)}})()},0)}get whenReady(){return this._init}get(y,P){let D=this._value[y];return typeof D=="undefined"&&(D=P),D}update(y,P){this._value[y]=P;let D=this._deferredPromises.get(y);if(D!==void 0)return D.p;const k=new b.DeferredPromise;return this._deferredPromises.set(y,k),this._scheduler.isScheduled()||this._scheduler.schedule(),k.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=I;class T extends I{constructor(y,P){super(y.identifier.value,!0,P);this._extension=y}setKeysForSync(y){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},y)}}e.ExtensionGlobalMemento=T}),define(me[15],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,b.createDecorator)("IExtHostRpcService");class I{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=I});var it=this&&this.__classPrivateFieldSet||function(G,e,b,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,b):T?T.value=b:e.set(G,b),b},We=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)};define(me[198],ge([0,1,27,3]),function(G,e,b,I){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(P,D){T.set(this,void 0),this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._id=b.ExtensionIdentifier.toKey(P.identifier),it(this,T,D,"f"),We(this,T,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(P){return We(this,T,"f").get(this._id,P)}store(P,D){return We(this,T,"f").store(this._id,P,D)}delete(P){return We(this,T,"f").delete(this._id,P)}}e.ExtensionSecrets=A,T=new WeakMap}),define(me[120],ge([0,1,4,3]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class T{constructor(){this._onDidChangeTelemetryEnabled=new I.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(y){this._enabled=y}$onDidChangeTelemetryEnabled(y){this._enabled=y,this._onDidChangeTelemetryEnabled.fire(y)}}e.ExtHostTelemetry=T,e.IExtHostTelemetry=(0,b.createDecorator)("IExtHostTelemetry")}),define(me[87],ge([0,1,3]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var I;(function(y){y[y.NewChild=0]="NewChild",y[y.Disposed=1]="Disposed",y[y.Invalidated=2]="Invalidated",y[y.SetProp=3]="SetProp"})(I=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const T=new WeakMap,A=y=>{let P=T.get(y);return P||(P={children:new Map,bus:new b.Emitter},T.set(y,P)),P};e.getPrivateApiFor=A}),define(me[50],ge([0,1,4,3,15]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var A;(function(P){function D(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public}}P.fromApiTunnel=D;function k(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.public}}P.fromServiceTunnel=k})(A=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,b.createDecorator)("IExtHostTunnelService");let y=class{constructor(D){this.onDidChangeTunnels=new I.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,k){}async getTunnels(){return[]}async setTunnelExtensionFunctions(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,k){return{dispose:()=>{}}}async $providePortAttributes(D,k,i,C,f){return[]}async $forwardPort(D,k){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};y=qe([He(0,T.IExtHostRpcService)],y),e.ExtHostTunnelService=y});var it=this&&this.__classPrivateFieldSet||function(G,e,b,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,b):T?T.value=b:e.set(G,b),b},We=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)},Jt=this&&this.__rest||function(G,e){var b={};for(var I in G)Object.prototype.hasOwnProperty.call(G,I)&&e.indexOf(I)<0&&(b[I]=G[I]);if(G!=null&&typeof Object.getOwnPropertySymbols=="function")for(var T=0,I=Object.getOwnPropertySymbols(G);T<I.length;T++)e.indexOf(I[T])<0&&Object.prototype.propertyIsEnumerable.call(G,I[T])&&(b[I[T]]=G[I[T]]);return b};define(me[7],ge([0,1,17,16,99,22,9,11,2,30,45,85,87]),function(G,e,b,I,T,A,y,P,D,k,i,C,f){"use strict";var m,l,d,E,w,S,g,a,v,t,n,o,r,s,c,h;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelPreload=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function _(V){function B(){return Reflect.construct(V,arguments,this.constructor)}return Object.defineProperty(B,"name",Object.getOwnPropertyDescriptor(V,"name")),Object.setPrototypeOf(B,V),Object.setPrototypeOf(B.prototype,V.prototype),B}let u=d=class{constructor(B){m.set(this,void 0),it(this,m,B,"f")}static from(...B){let re=B;return new d(function(){if(re){for(const ke of re)ke&&typeof ke.dispose=="function"&&ke.dispose();re=void 0}})}dispose(){typeof We(this,m,"f")=="function"&&(We(this,m,"f").call(this),it(this,m,void 0,"f"))}};m=new WeakMap,u=d=qe([_],u),e.Disposable=u;let p=E=class{constructor(B,re){if(B<0)throw(0,I.illegalArgument)("line must be non-negative");if(re<0)throw(0,I.illegalArgument)("character must be non-negative");this._line=B,this._character=re}static Min(...B){if(B.length===0)throw new TypeError;let re=B[0];for(let ke=1;ke<B.length;ke++){const Ge=B[ke];Ge.isBefore(re)&&(re=Ge)}return re}static Max(...B){if(B.length===0)throw new TypeError;let re=B[0];for(let ke=1;ke<B.length;ke++){const Ge=B[ke];Ge.isAfter(re)&&(re=Ge)}return re}static isPosition(B){if(!B)return!1;if(B instanceof E)return!0;let{line:re,character:ke}=B;return typeof re=="number"&&typeof ke=="number"}get line(){return this._line}get character(){return this._character}isBefore(B){return this._line<B._line?!0:B._line<this._line?!1:this._character<B._character}isBeforeOrEqual(B){return this._line<B._line?!0:B._line<this._line?!1:this._character<=B._character}isAfter(B){return!this.isBeforeOrEqual(B)}isAfterOrEqual(B){return!this.isBefore(B)}isEqual(B){return this._line===B._line&&this._character===B._character}compareTo(B){return this._line<B._line?-1:this._line>B.line?1:this._character<B._character?-1:this._character>B._character?1:0}translate(B,re=0){if(B===null||re===null)throw(0,I.illegalArgument)();let ke;return typeof B=="undefined"?ke=0:typeof B=="number"?ke=B:(ke=typeof B.lineDelta=="number"?B.lineDelta:0,re=typeof B.characterDelta=="number"?B.characterDelta:0),ke===0&&re===0?this:new E(this.line+ke,this.character+re)}with(B,re=this.character){if(B===null||re===null)throw(0,I.illegalArgument)();let ke;return typeof B=="undefined"?ke=this.line:typeof B=="number"?ke=B:(ke=typeof B.line=="number"?B.line:this.line,re=typeof B.character=="number"?B.character:this.character),ke===this.line&&re===this.character?this:new E(ke,re)}toJSON(){return{line:this.line,character:this.character}}};p=E=qe([_],p),e.Position=p;let R=w=class{constructor(B,re,ke,Ge){let nt,ot;if(typeof B=="number"&&typeof re=="number"&&typeof ke=="number"&&typeof Ge=="number"?(nt=new p(B,re),ot=new p(ke,Ge)):B instanceof p&&re instanceof p&&(nt=B,ot=re),!nt||!ot)throw new Error("Invalid arguments");nt.isBefore(ot)?(this._start=nt,this._end=ot):(this._start=ot,this._end=nt)}static isRange(B){return B instanceof w?!0:B?p.isPosition(B.start)&&p.isPosition(B.end):!1}get start(){return this._start}get end(){return this._end}contains(B){return B instanceof w?this.contains(B._start)&&this.contains(B._end):B instanceof p?!(B.isBefore(this._start)||this._end.isBefore(B)):!1}isEqual(B){return this._start.isEqual(B._start)&&this._end.isEqual(B._end)}intersection(B){const re=p.Max(B.start,this._start),ke=p.Min(B.end,this._end);if(!re.isAfter(ke))return new w(re,ke)}union(B){if(this.contains(B))return this;if(B.contains(this))return B;const re=p.Min(B.start,this._start),ke=p.Max(B.end,this.end);return new w(re,ke)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(B,re=this.end){if(B===null||re===null)throw(0,I.illegalArgument)();let ke;return B?p.isPosition(B)?ke=B:(ke=B.start||this.start,re=B.end||this.end):ke=this.start,ke.isEqual(this._start)&&re.isEqual(this.end)?this:new w(ke,re)}toJSON(){return[this.start,this.end]}};R=w=qe([_],R),e.Range=R;let O=S=class extends R{constructor(B,re,ke,Ge){let nt,ot;if(typeof B=="number"&&typeof re=="number"&&typeof ke=="number"&&typeof Ge=="number"?(nt=new p(B,re),ot=new p(ke,Ge)):B instanceof p&&re instanceof p&&(nt=B,ot=re),!nt||!ot)throw new Error("Invalid arguments");super(nt,ot);this._anchor=nt,this._active=ot}static isSelection(B){return B instanceof S?!0:B?R.isRange(B)&&p.isPosition(B.anchor)&&p.isPosition(B.active)&&typeof B.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};O=S=qe([_],O),e.Selection=O;class j{constructor(B,re,ke){if(typeof B!="string"||B.length===0)throw(0,I.illegalArgument)("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw(0,I.illegalArgument)("port");if(typeof ke!="undefined"&&(typeof ke!="string"||ke.length===0||!/^[0-9A-Za-z\-]+$/.test(ke)))throw(0,I.illegalArgument)("connectionToken");this.host=B,this.port=Math.round(re),this.connectionToken=ke}}e.ResolvedAuthority=j;class ie extends Error{constructor(B,re=C.RemoteAuthorityResolverErrorCode.Unknown,ke){super(B);this._message=B,this._code=re,this._detail=ke,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,ie.prototype)}static NotAvailable(B,re){return new ie(B,C.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(B){return new ie(B,C.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=ie;var K;(function(V){V[V.LF=1]="LF",V[V.CRLF=2]="CRLF"})(K=e.EndOfLine||(e.EndOfLine={}));var x;(function(V){V[V.Replace=1]="Replace",V[V.Append=2]="Append",V[V.Prepend=3]="Prepend"})(x=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let $=g=class{constructor(B,re){this._range=B,this._newText=re}static isTextEdit(B){return B instanceof g?!0:B?R.isRange(B)&&typeof B.newText=="string":!1}static replace(B,re){return new g(B,re)}static insert(B,re){return g.replace(new R(B,B),re)}static delete(B){return g.replace(B,"")}static setEndOfLine(B){const re=new g(new R(new p(0,0),new p(0,0)),"");return re.newEol=B,re}get range(){return this._range}set range(B){if(B&&!R.isRange(B))throw(0,I.illegalArgument)("range");this._range=B}get newText(){return this._newText||""}set newText(B){if(B&&typeof B!="string")throw(0,I.illegalArgument)("newText");this._newText=B}get newEol(){return this._newEol}set newEol(B){if(B&&typeof B!="number")throw(0,I.illegalArgument)("newEol");this._newEol=B}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};$=g=qe([_],$),e.TextEdit=$;var U;(function(V){V[V.File=1]="File",V[V.Text=2]="Text",V[V.Cell=3]="Cell",V[V.CellOutput=4]="CellOutput",V[V.CellReplace=5]="CellReplace",V[V.CellOutputItem=6]="CellOutputItem"})(U=e.FileEditType||(e.FileEditType={}));let L=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(B,re,ke,Ge){this._edits.push({_type:1,from:B,to:re,options:ke,metadata:Ge})}createFile(B,re,ke){this._edits.push({_type:1,from:void 0,to:B,options:re,metadata:ke})}deleteFile(B,re,ke){this._edits.push({_type:1,from:B,to:void 0,options:re,metadata:ke})}replaceNotebookMetadata(B,re,ke){this._edits.push({_type:3,metadata:ke,uri:B,edit:{editType:5,metadata:re},notebookMetadata:re})}replaceNotebookCells(B,re,ke,Ge,nt){let ot,dt,yt=[],kt;if($t.isNotebookRange(re)&&Mt.isNotebookCellDataArray(ke)&&!Mt.isNotebookCellDataArray(Ge)?(ot=re.start,dt=re.end,yt=ke,kt=Ge):typeof re=="number"&&typeof ke=="number"&&Mt.isNotebookCellDataArray(Ge)&&(ot=re,dt=ke,yt=Ge,kt=nt),ot===void 0||dt===void 0)throw new Error("Invalid arguments");(ot!==dt||yt.length>0)&&this._edits.push({_type:5,uri:B,index:ot,count:dt-ot,cells:yt,metadata:kt})}replaceNotebookCellMetadata(B,re,ke,Ge){this._edits.push({_type:3,metadata:Ge,uri:B,edit:{editType:8,index:re,metadata:ke}})}replace(B,re,ke,Ge){this._edits.push({_type:2,uri:B,edit:new $(re,ke),metadata:Ge})}insert(B,re,ke,Ge){this.replace(B,new R(re,re),ke,Ge)}delete(B,re,ke){this.replace(B,re,"",ke)}has(B){return this._edits.some(re=>re._type===2&&re.uri.toString()===B.toString())}set(B,re){if(re)for(const ke of re)ke&&this._edits.push({_type:2,uri:B,edit:ke});else{for(let ke=0;ke<this._edits.length;ke++){const Ge=this._edits[ke];Ge._type===2&&Ge.uri.toString()===B.toString()&&(this._edits[ke]=void 0)}(0,b.coalesceInPlace)(this._edits)}}get(B){const re=[];for(let ke of this._edits)ke._type===2&&ke.uri.toString()===B.toString()&&re.push(ke.edit);return re}entries(){const B=new A.ResourceMap;for(let re of this._edits)if(re._type===2){let ke=B.get(re.uri);ke||(ke=[re.uri,[]],B.set(re.uri,ke)),ke[1].push(re.edit)}return[...B.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};L=qe([_],L),e.WorkspaceEdit=L;let N=a=class{constructor(B){this._tabstop=1,this.value=B||""}static isSnippetString(B){return B instanceof a?!0:B?typeof B.value=="string":!1}static _escape(B){return B.replace(/\$|}|\\/g,"\\$&")}appendText(B){return this.value+=a._escape(B),this}appendTabstop(B=this._tabstop++){return this.value+="$",this.value+=B,this}appendPlaceholder(B,re=this._tabstop++){if(typeof B=="function"){const ke=new a;ke._tabstop=this._tabstop,B(ke),this._tabstop=ke._tabstop,B=ke.value}else B=a._escape(B);return this.value+="${",this.value+=re,this.value+=":",this.value+=B,this.value+="}",this}appendChoice(B,re=this._tabstop++){const ke=B.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(B,re){if(typeof re=="function"){const ke=new a;ke._tabstop=this._tabstop,re(ke),this._tabstop=ke._tabstop,re=ke.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=B,re&&(this.value+=":",this.value+=re),this.value+="}",this}};N=a=qe([_],N),e.SnippetString=N;var M;(function(V){V[V.Unnecessary=1]="Unnecessary",V[V.Deprecated=2]="Deprecated"})(M=e.DiagnosticTag||(e.DiagnosticTag={}));var F;(function(V){V[V.Hint=3]="Hint",V[V.Information=2]="Information",V[V.Warning=1]="Warning",V[V.Error=0]="Error"})(F=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let W=v=class{constructor(B,re){if(this.uri=B,re)if(re instanceof R)this.range=re;else if(re instanceof p)this.range=new R(re,re);else throw new Error("Illegal argument")}static isLocation(B){return B instanceof v?!0:B?R.isRange(B.range)&&D.URI.isUri(B.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};W=v=qe([_],W),e.Location=W;let q=class{constructor(B,re){this.location=B,this.message=re}static is(B){return B?typeof B.message=="string"&&B.location&&R.isRange(B.location.range)&&D.URI.isUri(B.location.uri):!1}static isEqual(B,re){return B===re?!0:!B||!re?!1:B.message===re.message&&B.location.range.isEqual(re.location.range)&&B.location.uri.toString()===re.location.uri.toString()}};q=qe([_],q),e.DiagnosticRelatedInformation=q;let Q=class{constructor(B,re,ke=F.Error){if(!R.isRange(B))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=B,this.message=re,this.severity=ke}toJSON(){return{severity:F[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(B,re){return B===re?!0:!B||!re?!1:B.message===re.message&&B.severity===re.severity&&B.code===re.code&&B.severity===re.severity&&B.source===re.source&&B.range.isEqual(re.range)&&(0,b.equals)(B.tags,re.tags)&&(0,b.equals)(B.relatedInformation,re.relatedInformation,q.isEqual)}};Q=qe([_],Q),e.Diagnostic=Q;let le=class{constructor(B,re){if(!B)throw new Error("Illegal argument, contents must be defined");Array.isArray(B)?this.contents=B:(0,T.isMarkdownString)(B)?this.contents=[B]:this.contents=[B],this.range=re}};le=qe([_],le),e.Hover=le;var ve;(function(V){V[V.Text=0]="Text",V[V.Read=1]="Read",V[V.Write=2]="Write"})(ve=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Re=class{constructor(B,re=ve.Text){this.range=B,this.kind=re}toJSON(){return{range:this.range,kind:ve[this.kind]}}};Re=qe([_],Re),e.DocumentHighlight=Re;var Se;(function(V){V[V.File=0]="File",V[V.Module=1]="Module",V[V.Namespace=2]="Namespace",V[V.Package=3]="Package",V[V.Class=4]="Class",V[V.Method=5]="Method",V[V.Property=6]="Property",V[V.Field=7]="Field",V[V.Constructor=8]="Constructor",V[V.Enum=9]="Enum",V[V.Interface=10]="Interface",V[V.Function=11]="Function",V[V.Variable=12]="Variable",V[V.Constant=13]="Constant",V[V.String=14]="String",V[V.Number=15]="Number",V[V.Boolean=16]="Boolean",V[V.Array=17]="Array",V[V.Object=18]="Object",V[V.Key=19]="Key",V[V.Null=20]="Null",V[V.EnumMember=21]="EnumMember",V[V.Struct=22]="Struct",V[V.Event=23]="Event",V[V.Operator=24]="Operator",V[V.TypeParameter=25]="TypeParameter"})(Se=e.SymbolKind||(e.SymbolKind={}));var Oe;(function(V){V[V.Deprecated=1]="Deprecated"})(Oe=e.SymbolTag||(e.SymbolTag={}));let z=t=class{constructor(B,re,ke,Ge,nt){this.name=B,this.kind=re,this.containerName=nt,typeof ke=="string"&&(this.containerName=ke),Ge instanceof W?this.location=Ge:ke instanceof R&&(this.location=new W(Ge,ke)),t.validate(this)}static validate(B){if(!B.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Se[this.kind],location:this.location,containerName:this.containerName}}};z=t=qe([_],z),e.SymbolInformation=z;let Y=n=class{constructor(B,re,ke,Ge,nt){this.name=B,this.detail=re,this.kind=ke,this.range=Ge,this.selectionRange=nt,this.children=[],n.validate(this)}static validate(B){if(!B.name)throw new Error("name must not be falsy");if(!B.range.contains(B.selectionRange))throw new Error("selectionRange must be contained in fullRange");B.children&&B.children.forEach(n.validate)}};Y=n=qe([_],Y),e.DocumentSymbol=Y;var ee;(function(V){V[V.Invoke=1]="Invoke",V[V.Automatic=2]="Automatic"})(ee=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let se=class{constructor(B,re){this.title=B,this.kind=re}};se=qe([_],se),e.CodeAction=se;let fe=o=class{constructor(B){this.value=B}append(B){return new o(this.value?this.value+o.sep+B:B)}intersects(B){return this.contains(B)||B.contains(this)}contains(B){return this.value===B.value||B.value.startsWith(this.value+o.sep)}};fe.sep=".",fe=o=qe([_],fe),e.CodeActionKind=fe,fe.Empty=new fe(""),fe.QuickFix=fe.Empty.append("quickfix"),fe.Refactor=fe.Empty.append("refactor"),fe.RefactorExtract=fe.Refactor.append("extract"),fe.RefactorInline=fe.Refactor.append("inline"),fe.RefactorRewrite=fe.Refactor.append("rewrite"),fe.Source=fe.Empty.append("source"),fe.SourceOrganizeImports=fe.Source.append("organizeImports"),fe.SourceFixAll=fe.Source.append("fixAll");let Ee=class{constructor(B,re){if(this.range=B,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Ee=qe([_],Ee),e.SelectionRange=Ee;class Be{constructor(B,re,ke,Ge,nt,ot){this.kind=B,this.name=re,this.detail=ke,this.uri=Ge,this.range=nt,this.selectionRange=ot}}e.CallHierarchyItem=Be;class pe{constructor(B,re){this.fromRanges=re,this.from=B}}e.CallHierarchyIncomingCall=pe;class Ce{constructor(B,re){this.fromRanges=re,this.to=B}}e.CallHierarchyOutgoingCall=Ce;let Me=class{constructor(B,re){this.range=B,this.command=re}get isResolved(){return!!this.command}};Me=qe([_],Me),e.CodeLens=Me;let ze=r=class{constructor(B,re=!1){l.set(this,void 0),it(this,l,new T.MarkdownString(B,{supportThemeIcons:re}),"f")}static isMarkdownString(B){return B instanceof r?!0:B&&B.appendCodeblock&&B.appendMarkdown&&B.appendText&&B.value!==void 0}get value(){return We(this,l,"f").value}set value(B){We(this,l,"f").value=B}get isTrusted(){return We(this,l,"f").isTrusted}set isTrusted(B){We(this,l,"f").isTrusted=B}get supportThemeIcons(){return We(this,l,"f").supportThemeIcons}appendText(B){return We(this,l,"f").appendText(B),this}appendMarkdown(B){return We(this,l,"f").appendMarkdown(B),this}appendCodeblock(B,re){return We(this,l,"f").appendCodeblock(re!=null?re:"",B),this}};l=new WeakMap,ze=r=qe([_],ze),e.MarkdownString=ze;let _e=class{constructor(B,re){this.label=B,this.documentation=re}};_e=qe([_],_e),e.ParameterInformation=_e;let Ke=class{constructor(B,re){this.label=B,this.documentation=re,this.parameters=[]}};Ke=qe([_],Ke),e.SignatureInformation=Ke;let X=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};X=qe([_],X),e.SignatureHelp=X;var ne;(function(V){V[V.Invoke=1]="Invoke",V[V.TriggerCharacter=2]="TriggerCharacter",V[V.ContentChange=3]="ContentChange"})(ne=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var we;(function(V){V[V.Other=0]="Other",V[V.Type=1]="Type",V[V.Parameter=2]="Parameter"})(we=e.InlayHintKind||(e.InlayHintKind={}));let xe=class{constructor(B,re,ke){this.text=B,this.position=re,this.kind=ke}};xe=qe([_],xe),e.InlayHint=xe;var je;(function(V){V[V.Invoke=0]="Invoke",V[V.TriggerCharacter=1]="TriggerCharacter",V[V.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(je=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ve;(function(V){V[V.Text=0]="Text",V[V.Method=1]="Method",V[V.Function=2]="Function",V[V.Constructor=3]="Constructor",V[V.Field=4]="Field",V[V.Variable=5]="Variable",V[V.Class=6]="Class",V[V.Interface=7]="Interface",V[V.Module=8]="Module",V[V.Property=9]="Property",V[V.Unit=10]="Unit",V[V.Value=11]="Value",V[V.Enum=12]="Enum",V[V.Keyword=13]="Keyword",V[V.Snippet=14]="Snippet",V[V.Color=15]="Color",V[V.File=16]="File",V[V.Reference=17]="Reference",V[V.Folder=18]="Folder",V[V.EnumMember=19]="EnumMember",V[V.Constant=20]="Constant",V[V.Struct=21]="Struct",V[V.Event=22]="Event",V[V.Operator=23]="Operator",V[V.TypeParameter=24]="TypeParameter",V[V.User=25]="User",V[V.Issue=26]="Issue"})(Ve=e.CompletionItemKind||(e.CompletionItemKind={}));var Ze;(function(V){V[V.Deprecated=1]="Deprecated"})(Ze=e.CompletionItemTag||(e.CompletionItemTag={}));let De=class{constructor(B,re){this.label=B,this.kind=re}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&Ve[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};De=qe([_],De),e.CompletionItem=De;let ye=class{constructor(B=[],re=!1){this.items=B,this.isIncomplete=re}};ye=qe([_],ye),e.CompletionList=ye;var Pe;(function(V){V[V.Active=-1]="Active",V[V.Beside=-2]="Beside",V[V.One=1]="One",V[V.Two=2]="Two",V[V.Three=3]="Three",V[V.Four=4]="Four",V[V.Five=5]="Five",V[V.Six=6]="Six",V[V.Seven=7]="Seven",V[V.Eight=8]="Eight",V[V.Nine=9]="Nine"})(Pe=e.ViewColumn||(e.ViewColumn={}));var oe;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(oe=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ue;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative"})(ue=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var H;(function(V){V[V.Manual=1]="Manual",V[V.AfterDelay=2]="AfterDelay",V[V.FocusOut=3]="FocusOut"})(H=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Z;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(Z=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ce;(function(V){V[V.Keyboard=1]="Keyboard",V[V.Mouse=2]="Mouse",V[V.Command=3]="Command"})(ce=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Ie;(function(V){V[V.OpenOpen=0]="OpenOpen",V[V.ClosedClosed=1]="ClosedClosed",V[V.OpenClosed=2]="OpenClosed",V[V.ClosedOpen=3]="ClosedOpen"})(Ie=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(V){function B(re){switch(re){case"keyboard":return V.Keyboard;case"mouse":return V.Mouse;case"api":return V.Command}}V.fromValue=B}(ce=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ae=class{constructor(B,re){if(re&&!D.URI.isUri(re))throw(0,I.illegalArgument)("target");if(!R.isRange(B)||B.isEmpty)throw(0,I.illegalArgument)("range");this.range=B,this.target=re}};Ae=qe([_],Ae),e.DocumentLink=Ae;let Le=class{constructor(B,re,ke,Ge){this.red=B,this.green=re,this.blue=ke,this.alpha=Ge}};Le=qe([_],Le),e.Color=Le;let $e=class{constructor(B,re){if(re&&!(re instanceof Le))throw(0,I.illegalArgument)("color");if(!R.isRange(B)||B.isEmpty)throw(0,I.illegalArgument)("range");this.range=B,this.color=re}};$e=qe([_],$e),e.ColorInformation=$e;let Xe=class{constructor(B){if(!B||typeof B!="string")throw(0,I.illegalArgument)("label");this.label=B}};Xe=qe([_],Xe),e.ColorPresentation=Xe;var rt;(function(V){V[V.RGB=0]="RGB",V[V.HEX=1]="HEX",V[V.HSL=2]="HSL"})(rt=e.ColorFormat||(e.ColorFormat={}));var tt;(function(V){V[V.Error=0]="Error",V[V.Warning=1]="Warning",V[V.Information=2]="Information"})(tt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Qe;(function(V){V[V.Always=1]="Always",V[V.Silent=2]="Silent",V[V.Never=3]="Never"})(Qe=e.TaskRevealKind||(e.TaskRevealKind={}));var mt;(function(V){V[V.Shared=1]="Shared",V[V.Dedicated=2]="Dedicated",V[V.New=3]="New"})(mt=e.TaskPanelKind||(e.TaskPanelKind={}));let wt=s=class{constructor(B,re){if(typeof B!="string"||typeof re!="string")throw(0,I.illegalArgument)("name");this._id=B}static from(B){switch(B){case"clean":return s.Clean;case"build":return s.Build;case"rebuild":return s.Rebuild;case"test":return s.Test;default:return}}get id(){return this._id}};wt.Clean=new s("clean","Clean"),wt.Build=new s("build","Build"),wt.Rebuild=new s("rebuild","Rebuild"),wt.Test=new s("test","Test"),wt=s=qe([_],wt),e.TaskGroup=wt;function be(V){let B="";for(let re=0;re<V.length;re++)B+=V[re].replace(/,/g,",,")+",";return B}let he=class{constructor(B,re,ke){if(typeof B!="string")throw(0,I.illegalArgument)("process");this._args=[],this._process=B,re!==void 0&&(Array.isArray(re)?(this._args=re,this._options=ke):this._options=re)}get process(){return this._process}set process(B){if(typeof B!="string")throw(0,I.illegalArgument)("process");this._process=B}get args(){return this._args}set args(B){Array.isArray(B)||(B=[]),this._args=B}get options(){return this._options}set options(B){this._options=B}computeId(){const B=[];if(B.push("process"),this._process!==void 0&&B.push(this._process),this._args&&this._args.length>0)for(let re of this._args)B.push(re);return be(B)}};he=qe([_],he),e.ProcessExecution=he;let ae=class{constructor(B,re,ke){if(this._args=[],Array.isArray(re)){if(!B)throw(0,I.illegalArgument)("command can't be undefined or null");if(typeof B!="string"&&typeof B.value!="string")throw(0,I.illegalArgument)("command");this._command=B,this._args=re,this._options=ke}else{if(typeof B!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=B,this._options=re}}get commandLine(){return this._commandLine}set commandLine(B){if(typeof B!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=B}get command(){return this._command?this._command:""}set command(B){if(typeof B!="string"&&typeof B.value!="string")throw(0,I.illegalArgument)("command");this._command=B}get args(){return this._args}set args(B){this._args=B||[]}get options(){return this._options}set options(B){this._options=B}computeId(){const B=[];if(B.push("shell"),this._commandLine!==void 0&&B.push(this._commandLine),this._command!==void 0&&B.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let re of this._args)B.push(typeof re=="string"?re:re.value);return be(B)}};ae=qe([_],ae),e.ShellExecution=ae;var J;(function(V){V[V.Escape=1]="Escape",V[V.Strong=2]="Strong",V[V.Weak=3]="Weak"})(J=e.ShellQuoting||(e.ShellQuoting={}));var Ne;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace"})(Ne=e.TaskScope||(e.TaskScope={}));class Fe{constructor(B){this._callback=B}computeId(){return"customExecution"+(0,k.generateUuid)()}set callback(B){this._callback=B}get callback(){return this._callback}}e.CustomExecution=Fe;let Ye=c=class{constructor(B,re,ke,Ge,nt,ot){this.__deprecated=!1,this._definition=this.definition=B;let dt;typeof re=="string"?(this._name=this.name=re,this._source=this.source=ke,this.execution=Ge,dt=nt,this.__deprecated=!0):re===Ne.Global||re===Ne.Workspace?(this.target=re,this._name=this.name=ke,this._source=this.source=Ge,this.execution=nt,dt=ot):(this.target=re,this._name=this.name=ke,this._source=this.source=Ge,this.execution=nt,dt=ot),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(B){this.__id=B}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof he?this._definition={type:c.ProcessType,id:this._execution.computeId()}:this._execution instanceof ae?this._definition={type:c.ShellType,id:this._execution.computeId()}:this._execution instanceof Fe?this._definition={type:c.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:c.EmptyType,id:(0,k.generateUuid)()}}get definition(){return this._definition}set definition(B){if(B==null)throw(0,I.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=B}get scope(){return this._scope}set target(B){this.clear(),this._scope=B}get name(){return this._name}set name(B){if(typeof B!="string")throw(0,I.illegalArgument)("name");this.clear(),this._name=B}get execution(){return this._execution}set execution(B){B===null&&(B=void 0),this.clear(),this._execution=B;const re=this._definition.type;(c.EmptyType===re||c.ProcessType===re||c.ShellType===re||c.ExtensionCallbackType===re)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(B){if(Array.isArray(B))this.clear(),this._problemMatchers=B,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(B){B!==!0&&B!==!1&&(B=!1),this.clear(),this._isBackground=B}get source(){return this._source}set source(B){if(typeof B!="string"||B.length===0)throw(0,I.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=B}get group(){return this._group}set group(B){B===null&&(B=void 0),this.clear(),this._group=B}get detail(){return this._detail}set detail(B){B===null&&(B=void 0),this._detail=B}get presentationOptions(){return this._presentationOptions}set presentationOptions(B){B==null&&(B=Object.create(null)),this.clear(),this._presentationOptions=B}get runOptions(){return this._runOptions}set runOptions(B){B==null&&(B=Object.create(null)),this.clear(),this._runOptions=B}};Ye.ExtensionCallbackType="customExecution",Ye.ProcessType="process",Ye.ShellType="shell",Ye.EmptyType="$empty",Ye=c=qe([_],Ye),e.Task=Ye;var et;(function(V){V[V.SourceControl=1]="SourceControl",V[V.Window=10]="Window",V[V.Notification=15]="Notification"})(et=e.ProgressLocation||(e.ProgressLocation={}));let ut=class{constructor(B,re=ht.None){this.collapsibleState=re,D.URI.isUri(B)?this.resourceUri=B:this.label=B}};ut=qe([_],ut),e.TreeItem=ut;var ht;(function(V){V[V.None=0]="None",V[V.Collapsed=1]="Collapsed",V[V.Expanded=2]="Expanded"})(ht=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Je=class{constructor(B,re){this.id=B,this.color=re}};Je=qe([_],Je),e.ThemeIcon=Je,Je.File=new Je("file"),Je.Folder=new Je("folder");let at=class{constructor(B){this.id=B}};at=qe([_],at),e.ThemeColor=at;var ft;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace",V[V.WorkspaceFolder=3]="WorkspaceFolder"})(ft=e.ConfigurationTarget||(e.ConfigurationTarget={}));let lt=class{constructor(B,re){if(typeof B!="string"&&(!B||!D.URI.isUri(B)&&!D.URI.isUri(B.uri)))throw(0,I.illegalArgument)("base");if(typeof re!="string")throw(0,I.illegalArgument)("pattern");typeof B=="string"?(this.baseFolder=D.URI.file(B),this.base=B):D.URI.isUri(B)?(this.baseFolder=B,this.base=B.fsPath):(this.baseFolder=B.uri,this.base=B.uri.fsPath),this.pattern=re}};lt=qe([_],lt),e.RelativePattern=lt;let St=class{constructor(B,re,ke,Ge){this.enabled=typeof B=="boolean"?B:!0,typeof re=="string"&&(this.condition=re),typeof ke=="string"&&(this.hitCondition=ke),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=(0,k.generateUuid)()),this._id}};St=qe([_],St),e.Breakpoint=St;let vt=class extends St{constructor(B,re,ke,Ge,nt){super(re,ke,Ge,nt);if(B===null)throw(0,I.illegalArgument)("location");this.location=B}};vt=qe([_],vt),e.SourceBreakpoint=vt;let Pt=class extends St{constructor(B,re,ke,Ge,nt){super(re,ke,Ge,nt);this.functionName=B}};Pt=qe([_],Pt),e.FunctionBreakpoint=Pt;let Tt=class extends St{constructor(B,re,ke,Ge,nt,ot,dt){super(Ge,nt,ot,dt);if(!re)throw(0,I.illegalArgument)("dataId");this.label=B,this.dataId=re,this.canPersist=ke}};Tt=qe([_],Tt),e.DataBreakpoint=Tt;let Rt=class{constructor(B,re,ke){this.command=B,this.args=re||[],this.options=ke}};Rt=qe([_],Rt),e.DebugAdapterExecutable=Rt;let _t=class{constructor(B,re){this.port=B,this.host=re}};_t=qe([_],_t),e.DebugAdapterServer=_t;let Zt=class{constructor(B){this.path=B}};Zt=qe([_],Zt),e.DebugAdapterNamedPipeServer=Zt;let en=class{constructor(B){this.implementation=B}};en=qe([_],en),e.DebugAdapterInlineImplementation=en;let gt=class{constructor(B,re){this.range=B,this.expression=re}};gt=qe([_],gt),e.EvaluatableExpression=gt;let tn=class{constructor(B,re){this.range=B,this.text=re}};tn=qe([_],tn),e.InlineValueText=tn;let Dt=class{constructor(B,re,ke=!0){this.range=B,this.variableName=re,this.caseSensitiveLookup=ke}};Dt=qe([_],Dt),e.InlineValueVariableLookup=Dt;let Gt=class{constructor(B,re){this.range=B,this.expression=re}};Gt=qe([_],Gt),e.InlineValueEvaluatableExpression=Gt;let nn=class{constructor(B,re){this.frameId=B,this.stoppedLocation=re}};nn=qe([_],nn),e.InlineValueContext=nn;var Qt;(function(V){V[V.Changed=1]="Changed",V[V.Created=2]="Created",V[V.Deleted=3]="Deleted"})(Qt=e.FileChangeType||(e.FileChangeType={}));let ct=h=class extends Error{constructor(B,re=i.FileSystemProviderErrorCode.Unknown,ke){var Ge;super(D.URI.isUri(B)?B.toString(!0):B);this.code=(Ge=ke==null?void 0:ke.name)!==null&&Ge!==void 0?Ge:"Unknown",(0,i.markAsFileSystemProviderError)(this,re),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,h.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}static FileExists(B){return new h(B,i.FileSystemProviderErrorCode.FileExists,h.FileExists)}static FileNotFound(B){return new h(B,i.FileSystemProviderErrorCode.FileNotFound,h.FileNotFound)}static FileNotADirectory(B){return new h(B,i.FileSystemProviderErrorCode.FileNotADirectory,h.FileNotADirectory)}static FileIsADirectory(B){return new h(B,i.FileSystemProviderErrorCode.FileIsADirectory,h.FileIsADirectory)}static NoPermissions(B){return new h(B,i.FileSystemProviderErrorCode.NoPermissions,h.NoPermissions)}static Unavailable(B){return new h(B,i.FileSystemProviderErrorCode.Unavailable,h.Unavailable)}};ct=h=qe([_],ct),e.FileSystemError=ct;let rn=class{constructor(B,re,ke){this.start=B,this.end=re,this.kind=ke}};rn=qe([_],rn),e.FoldingRange=rn;var Lt;(function(V){V[V.Comment=1]="Comment",V[V.Imports=2]="Imports",V[V.Region=3]="Region"})(Lt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Wt;(function(V){V[V.Collapsed=0]="Collapsed",V[V.Expanded=1]="Expanded"})(Wt=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var gn;(function(V){V[V.Editing=0]="Editing",V[V.Preview=1]="Preview"})(gn=e.CommentMode||(e.CommentMode={}));class Dn{constructor(B,re=[]){this.tokenTypes=B,this.tokenModifiers=re}}e.SemanticTokensLegend=Dn;function pn(V){return typeof V=="undefined"||(0,P.isStringArray)(V)}class sn{constructor(B){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,B){this._hasLegend=!0;for(let re=0,ke=B.tokenTypes.length;re<ke;re++)this._tokenTypeStrToInt.set(B.tokenTypes[re],re);for(let re=0,ke=B.tokenModifiers.length;re<ke;re++)this._tokenModifierStrToInt.set(B.tokenModifiers[re],re)}}push(B,re,ke,Ge,nt){if(typeof B=="number"&&typeof re=="number"&&typeof ke=="number"&&typeof Ge=="number"&&(typeof nt=="number"||typeof nt=="undefined"))return typeof nt=="undefined"&&(nt=0),this._pushEncoded(B,re,ke,Ge,nt);if(R.isRange(B)&&typeof re=="string"&&pn(ke))return this._push(B,re,ke);throw(0,I.illegalArgument)()}_push(B,re,ke){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(B.start.line!==B.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(re))throw new Error("`tokenType` is not in the provided legend");const Ge=B.start.line,nt=B.start.character,ot=B.end.character-B.start.character,dt=this._tokenTypeStrToInt.get(re);let yt=0;if(ke)for(const kt of ke){if(!this._tokenModifierStrToInt.has(kt))throw new Error("`tokenModifier` is not in the provided legend");const It=this._tokenModifierStrToInt.get(kt);yt|=1<<It>>>0}this._pushEncoded(Ge,nt,ot,dt,yt)}_pushEncoded(B,re,ke,Ge,nt){if(this._dataIsSortedAndDeltaEncoded&&(B<this._prevLine||B===this._prevLine&&re<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let kt=0,It=0;for(let At=0;At<yt;At++){let Ot=this._data[5*At],hn=this._data[5*At+1];Ot===0?(Ot=kt,hn+=It):Ot+=kt,this._data[5*At]=Ot,this._data[5*At+1]=hn,kt=Ot,It=hn}}let ot=B,dt=re;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ot-=this._prevLine,ot===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=ot,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=ke,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=nt,this._prevLine=B,this._prevChar=re}static _sortAndDeltaEncode(B){let re=[];const ke=B.length/5|0;for(let dt=0;dt<ke;dt++)re[dt]=dt;re.sort((dt,yt)=>{const kt=B[5*dt],It=B[5*yt];if(kt===It){const At=B[5*dt+1],Ot=B[5*yt+1];return At-Ot}return kt-It});const Ge=new Uint32Array(B.length);let nt=0,ot=0;for(let dt=0;dt<ke;dt++){const yt=5*re[dt],kt=B[yt+0],It=B[yt+1],At=B[yt+2],Ot=B[yt+3],hn=B[yt+4],On=kt-nt,Wn=On===0?It-ot:It,fn=5*dt;Ge[fn+0]=On,Ge[fn+1]=Wn,Ge[fn+2]=At,Ge[fn+3]=Ot,Ge[fn+4]=hn,nt=kt,ot=It}return Ge}build(B){return this._dataIsSortedAndDeltaEncoded?new Xt(new Uint32Array(this._data),B):new Xt(sn._sortAndDeltaEncode(this._data),B)}}e.SemanticTokensBuilder=sn;class Xt{constructor(B,re){this.resultId=re,this.data=B}}e.SemanticTokens=Xt;class Ut{constructor(B,re,ke){this.start=B,this.deleteCount=re,this.data=ke}}e.SemanticTokensEdit=Ut;class Cn{constructor(B,re){this.resultId=re,this.edits=B}}e.SemanticTokensEdits=Cn;var on;(function(V){V[V.Separate=0]="Separate",V[V.MergeWithParent=1]="MergeWithParent"})(on=e.DebugConsoleMode||(e.DebugConsoleMode={}));var an;(function(V){V[V.Initial=1]="Initial",V[V.Dynamic=2]="Dynamic"})(an=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Yt=class{constructor(){}};Yt.Back={iconPath:new Je("arrow-left")},Yt=qe([_],Yt),e.QuickInputButtons=Yt;var kn;(function(V){V[V.UI=1]="UI",V[V.Workspace=2]="Workspace"})(kn=e.ExtensionKind||(e.ExtensionKind={}));class Ft{constructor(B,re,ke){this.badge=B,this.tooltip=re,this.color=ke}static validate(B){if(B.badge&&B.badge.length!==1&&B.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!B.color&&!B.badge&&!B.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Ft;let ln=class{constructor(B){this.kind=B}};ln=qe([_],ln),e.ColorTheme=ln;var Pn;(function(V){V[V.Light=1]="Light",V[V.Dark=2]="Dark",V[V.HighContrast=3]="HighContrast"})(Pn=e.ColorThemeKind||(e.ColorThemeKind={}));class $t{constructor(B,re){if(B<0)throw(0,I.illegalArgument)("start must be positive");if(re<0)throw(0,I.illegalArgument)("end must be positive");B<=re?(this._start=B,this._end=re):(this._start=re,this._end=B)}static isNotebookRange(B){return B instanceof $t?!0:B?typeof B.start=="number"&&typeof B.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(B){let re=this._start,ke=this._end;return B.start!==void 0&&(re=B.start),B.end!==void 0&&(ke=B.end),re===this._start&&ke===this._end?this:new $t(re,ke)}}e.NotebookRange=$t;class cn{constructor(B,re){typeof B=="object"?Object.assign(this,B):(this.inputCollapsed=B,this.outputCollapsed=re)}with(B){let{inputCollapsed:re,outputCollapsed:ke}=B,Ge=Jt(B,["inputCollapsed","outputCollapsed"]);return re===void 0?re=this.inputCollapsed:re===null&&(re=void 0),ke===void 0?ke=this.outputCollapsed:ke===null&&(ke=void 0),re===this.inputCollapsed&&ke===this.outputCollapsed&&Object.keys(Ge).length===0?this:new cn(Object.assign({inputCollapsed:re,outputCollapsed:ke},Ge))}}e.NotebookCellMetadata=cn;class xt{constructor(B={}){Object.assign(this,B)}with(B){return new xt(B)}}e.NotebookDocumentMetadata=xt;class Mt{constructor(B,re,ke,Ge,nt,ot){this.kind=B,this.source=re,this.language=ke,this.outputs=Ge!=null?Ge:[],this.metadata=nt,this.latestExecutionSummary=ot}static isNotebookCellDataArray(B){return Array.isArray(B)&&B.every(re=>Mt.isNotebookCellData(re))}static isNotebookCellData(B){return!0}}e.NotebookCellData=Mt;class vn{constructor(B,re){this.cells=B,this.metadata=re!=null?re:new xt}}e.NotebookData=vn;class Ht{constructor(B,re,ke){if(this.mime=B,this.value=re,this.metadata=ke,(0,y.isFalsyOrWhitespace)(this.mime))throw new Error("INVALID mime type, must not be empty or falsy")}static isNotebookCellOutputItem(B){return B instanceof Ht}}e.NotebookCellOutputItem=Ht;class Ue{constructor(B,re,ke){this.outputs=B,typeof re=="string"?(this.id=re,this.metadata=ke):(this.id=(0,k.generateUuid)(),this.metadata=re!=null?re:ke)}}e.NotebookCellOutput=Ue;var un;(function(V){V[V.Markdown=1]="Markdown",V[V.Code=2]="Code"})(un=e.NotebookCellKind||(e.NotebookCellKind={}));var dn;(function(V){V[V.Idle=1]="Idle",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(dn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var pt;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(pt=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var In;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(In=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class An{constructor(B,re,ke,Ge,nt,ot){this.text=B,this.alignment=re,this.command=ke,this.tooltip=Ge,this.priority=nt,this.accessibilityInformation=ot}}e.NotebookCellStatusBarItem=An;var wn;(function(V){V[V.Default=1]="Default",V[V.Preferred=2]="Preferred"})(wn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class bn{constructor(B,re=[]){this.uri=B,this.provides=typeof re=="string"?[re]:re}}e.NotebookKernelPreload=bn;let zt=class{constructor(B,re){this.label=B,this.timestamp=re}};zt=qe([_],zt),e.TimelineItem=zt;var Tn;(function(V){V[V.Production=1]="Production",V[V.Development=2]="Development",V[V.Test=3]="Test"})(Tn=e.ExtensionMode||(e.ExtensionMode={}));var Rn;(function(V){V[V.Node=1]="Node",V[V.Webworker=2]="Webworker"})(Rn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ln;(function(V){V[V.Other=0]="Other",V[V.Comment=1]="Comment",V[V.String=2]="String",V[V.RegEx=4]="RegEx"})(Ln=e.StandardTokenType||(e.StandardTokenType={}));class _n{constructor(B,re){this.ranges=B,this.wordPattern=re}}e.LinkedEditingRanges=_n;var Fn;(function(V){V[V.Unset=0]="Unset",V[V.Queued=1]="Queued",V[V.Running=2]="Running",V[V.Passed=3]="Passed",V[V.Failed=4]="Failed",V[V.Skipped=5]="Skipped",V[V.Errored=6]="Errored"})(Fn=e.TestResultState||(e.TestResultState={}));var En;(function(V){V[V.Error=0]="Error",V[V.Warning=1]="Warning",V[V.Information=2]="Information",V[V.Hint=3]="Hint"})(En=e.TestMessageSeverity||(e.TestMessageSeverity={}));var Sn;(function(V){V[V.Pending=0]="Pending",V[V.Resolved=1]="Resolved"})(Sn=e.TestItemStatus||(e.TestItemStatus={}));const Bt=(V,B,re,ke)=>{let Ge=re;return{enumerable:!0,configurable:!1,get(){return Ge},set(nt){ke(Ge,nt)||(Ge=nt,V.bus.fire([3,B,nt]))}}},Vt=(V,B)=>V===B,te=(V,B)=>V===B?!0:!V||!B?!1:V.isEqual(B);class de{constructor(B,re,ke,Ge){this.label=re,this.data=Ge;const nt=(0,f.getPrivateApiFor)(this);Object.defineProperties(this,{id:{value:B,enumerable:!0,writable:!1},uri:{value:ke,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>nt.parent},children:{value:new A.ReadonlyMapView(nt.children),enumerable:!0,writable:!1},range:Bt(nt,"range",void 0,te),description:Bt(nt,"description",void 0,Vt),runnable:Bt(nt,"runnable",!0,Vt),debuggable:Bt(nt,"debuggable",!1,Vt),status:Bt(nt,"status",Sn.Resolved,Vt),error:Bt(nt,"error",void 0,Vt)})}invalidate(){(0,f.getPrivateApiFor)(this).bus.fire([2])}dispose(){const B=(0,f.getPrivateApiFor)(this);B.parent&&(0,f.getPrivateApiFor)(B.parent).children.delete(this.id),B.bus.fire([1])}addChild(B){if(!(B instanceof de))throw new Error("Test child must be created through vscode.test.createTestItem()");const re=(0,f.getPrivateApiFor)(this);if(re.children.has(B.id))throw new Error(`Attempted to insert a duplicate test item ID ${B.id}`);re.children.set(B.id,B),re.bus.fire([0,B])}}e.TestItemImpl=de;class Te{constructor(B){this.message=B,this.severity=En.Error}static diff(B,re,ke){const Ge=new Te(B);return Ge.expectedOutput=re,Ge.actualOutput=ke,Ge}}e.TestMessage=Te;var st;(function(V){V[V.None=0]="None",V[V.Option=1]="Option",V[V.Default=2]="Default",V[V.Preferred=3]="Preferred"})(st=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var bt;(function(V){V[V.Untrusted=0]="Untrusted",V[V.Trusted=1]="Trusted",V[V.Unspecified=2]="Unspecified"})(bt=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Ct;(function(V){V[V.Notify=1]="Notify",V[V.OpenBrowser=2]="OpenBrowser",V[V.OpenPreview=3]="OpenPreview",V[V.Silent=4]="Silent",V[V.Ignore=5]="Ignore"})(Ct=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(me[121],ge([0,1,52,12,9,144,110,7,17]),function(G,e,b,I,T,A,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const k=new Map;function i(l,d){d?k.set(l,d):k.delete(l)}e.setWordDefinitionFor=i;function C(l){return k.get(l)}e.getWordDefinitionFor=C;class f extends A.MirrorTextModel{constructor(d,E,w,S,g,a,v,t){super(E,w,S,g);this._proxy=d,this._languageId=a,this._isDirty=v,this._notebook=t,this._isDisposed=!1}dispose(){(0,b.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(d){return(0,D.equals)(this._lines,d)}get document(){if(!this._document){const d=this;this._document={get uri(){return d._uri},get fileName(){return d._uri.fsPath},get isUntitled(){return d._uri.scheme===I.Schemas.untitled},get languageId(){return d._languageId},get version(){return d._versionId},get isClosed(){return d._isDisposed},get isDirty(){return d._isDirty},get notebook(){return d._notebook},save(){return d._save()},getText(E){return E?d._getTextInRange(E):d.getText()},get eol(){return d._eol===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return d._lines.length},lineAt(E){return d._lineAt(E)},offsetAt(E){return d._offsetAt(E)},positionAt(E){return d._positionAt(E)},validateRange(E){return d._validateRange(E)},validatePosition(E){return d._validatePosition(E)},getWordRangeAtPosition(E,w){return d._getWordRangeAtPosition(E,w)}}}return Object.freeze(this._document)}_acceptLanguageId(d){(0,b.ok)(!this._isDisposed),this._languageId=d}_acceptIsDirty(d){(0,b.ok)(!this._isDisposed),this._isDirty=d}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(d){const E=this._validateRange(d);if(E.isEmpty)return"";if(E.isSingleLine)return this._lines[E.start.line].substring(E.start.character,E.end.character);const w=this._eol,S=E.start.line,g=E.end.line,a=[];a.push(this._lines[S].substring(E.start.character));for(let v=S+1;v<g;v++)a.push(this._lines[v]);return a.push(this._lines[g].substring(0,E.end.character)),a.join(w)}_lineAt(d){let E;if(d instanceof P.Position?E=d.line:typeof d=="number"&&(E=d),typeof E!="number"||E<0||E>=this._lines.length||Math.floor(E)!==E)throw new Error("Illegal value for `line`");return new m(E,this._lines[E],E===this._lines.length-1)}_offsetAt(d){return d=this._validatePosition(d),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(d.line-1)+d.character}_positionAt(d){d=Math.floor(d),d=Math.max(0,d),this._ensureLineStarts();const E=this._lineStarts.getIndexOf(d),w=this._lines[E.index].length;return new P.Position(E.index,Math.min(E.remainder,w))}_validateRange(d){if(!(d instanceof P.Range))throw new Error("Invalid argument");const E=this._validatePosition(d.start),w=this._validatePosition(d.end);return E===d.start&&w===d.end?d:new P.Range(E.line,E.character,w.line,w.character)}_validatePosition(d){if(!(d instanceof P.Position))throw new Error("Invalid argument");if(this._lines.length===0)return d.with(0,0);let{line:E,character:w}=d,S=!1;if(E<0)E=0,w=0,S=!0;else if(E>=this._lines.length)E=this._lines.length-1,w=this._lines[E].length,S=!0;else{const g=this._lines[E].length;w<0?(w=0,S=!0):w>g&&(w=g,S=!0)}return S?new P.Position(E,w):d}_getWordRangeAtPosition(d,E){const w=this._validatePosition(d);if(!E)E=C(this._languageId);else if((0,T.regExpLeadsToEndlessLoop)(E))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${E.source}' because it matches the empty string.`);const S=(0,y.getWordAtText)(w.character+1,(0,y.ensureValidWordDefinition)(E),this._lines[w.line],0);if(S)return new P.Range(w.line,S.startColumn-1,w.line,S.endColumn-1)}}e.ExtHostDocumentData=f;class m{constructor(d,E,w){this._line=d,this._text=E,this._isLastLine=w}get lineNumber(){return this._line}get text(){return this._text}get range(){return new P.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new P.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=m}),define(me[199],ge([0,1,7,3,112,6,77,22,2,30]),function(G,e,b,I,T,A,y,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class i{constructor(f,m,l,d){this._notebook=l,this._selector=d,this._disposables=new A.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:(0,k.generateUuid)()}),this._init(),this._disposables.add(m.onDidChangeDocument(w=>{const S=this._cellUris.get(w.document.uri);S!==void 0&&(this._cellLengths.changeValue(S,this._cells[S].document.getText().length+1),this._cellLines.changeValue(S,this._cells[S].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const E=w=>{w===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(f.onDidChangeNotebookCells(w=>E(w.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new P.ResourceMap;const f=[],m=[];for(const l of this._notebook.getCells())l.kind===b.NotebookCellKind.Code&&(!this._selector||(0,y.score)(this._selector,l.document.uri,l.document.languageId,!0))&&(this._cellUris.set(l.document.uri,this._cells.length),this._cells.push(l),f.push(l.document.getText().length+1),m.push(l.document.lineCount));this._cellLengths=new T.PrefixSumComputer(new Uint32Array(f)),this._cellLines=new T.PrefixSumComputer(new Uint32Array(m))}get version(){return this._versionId}getText(f){var m,l;if(!f){let g="";for(const a of this._cells)g+=a.document.getText()+`
`;return g=g.slice(0,-1),g}if(f.isEmpty)return"";const d=this.locationAt(f.start),E=this.locationAt(f.end),w=this._cells[(m=this._cellUris.get(d.uri))!==null&&m!==void 0?m:-1],S=this._cells[(l=this._cellUris.get(E.uri))!==null&&l!==void 0?l:-1];if(!w||!S)return"";if(w===S)return w.document.getText(new b.Range(d.range.start,E.range.end));{const g=w.document.getText(new b.Range(d.range.start,new b.Position(w.document.lineCount,0))),a=S.document.getText(new b.Range(new b.Position(0,0),E.range.end));return g+`
`+a}}offsetAt(f){const m=this._cellLines.getIndexOf(f.line),l=this._cellLengths.getAccumulatedValue(m.index-1),d=this._cells[m.index].document.offsetAt(f.with(m.remainder));return l+d}positionAt(f){if(typeof f=="number"){const l=this._cellLengths.getIndexOf(f),d=this._cellLines.getAccumulatedValue(l.index-1);return this._cells[l.index].document.positionAt(l.remainder).translate(d)}const m=this._cellUris.get(f.uri);if(m!==void 0){const l=this._cellLines.getAccumulatedValue(m-1);return new b.Position(l+f.range.start.line,f.range.start.character)}return new b.Position(0,0)}locationAt(f){b.Range.isRange(f)||(f=new b.Range(f,f));const m=this._cellLines.getIndexOf(f.start.line);let l=m;f.isEmpty||(l=this._cellLines.getIndexOf(f.end.line));const d=new b.Position(m.remainder,f.start.character),E=new b.Position(l.remainder,f.end.character),w=new b.Range(d,E),S=this._cells[m.index];return new b.Location(S.document.uri,S.document.validateRange(w))}contains(f){return this._cellUris.has(f)}validateRange(f){const m=this.validatePosition(f.start),l=this.validatePosition(f.end);return f.with(m,l)}validatePosition(f){const m=this._cellLines.getIndexOf(f.line),l=new b.Position(m.remainder,f.character),d=this._cells[m.index].document.validatePosition(l),E=this._cellLines.getAccumulatedValue(m.index-1);return new b.Position(E+d.line,d.character)}}e.ExtHostNotebookConcatDocument=i}),define(me[200],ge([0,1,7,15,3]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(P){this._actual=new b.ColorTheme(b.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new T.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(P){let D=P==="light"?b.ColorThemeKind.Light:P==="dark"?b.ColorThemeKind.Dark:b.ColorThemeKind.HighContrast;this._actual=new b.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=qe([He(0,I.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(me[63],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,b.createDecorator)("IURITransformerService");class I{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=I}),define(me[201],ge([0,1,23]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class I{constructor(){this.buffers=[]}add(D){let k=this.buffers.indexOf(D);return k<0&&(k=this.buffers.length,this.buffers.push(D)),k}}function T(P,D){if(D.serializeBuffersForPostMessage){const k=new I,i=(m,l)=>{if(l instanceof ArrayBuffer){const d=k.add(l);return{$$vscode_array_buffer_reference$$:!0,index:d}}else if(ArrayBuffer.isView(l)){const d=A(l);if(d){const E=k.add(l.buffer);return{$$vscode_array_buffer_reference$$:!0,index:E,view:{type:d,byteLength:l.byteLength,byteOffset:l.byteOffset}}}}return l},C=JSON.stringify(P,i),f=k.buffers.map(m=>{const l=new Uint8Array(m);return b.VSBuffer.wrap(l)});return{message:C,buffers:f}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=T;function A(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function y(P,D){const k=D.map(f=>{const m=new ArrayBuffer(f.byteLength);return new Uint8Array(m).set(f.buffer),m}),i=D.length?(f,m)=>{if(typeof m=="object"&&m.$$vscode_array_buffer_reference$$){const l=m,{index:d}=l,E=k[d];if(l.view)switch(l.view.type){case 1:return new Int8Array(E,l.view.byteOffset,l.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(E,l.view.byteOffset,l.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(E,l.view.byteOffset,l.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(E,l.view.byteOffset,l.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(E,l.view.byteOffset,l.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(E,l.view.byteOffset,l.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(E,l.view.byteOffset,l.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(E,l.view.byteOffset,l.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(E,l.view.byteOffset,l.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(E,l.view.byteOffset,l.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(E,l.view.byteOffset,l.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return E}return m}:void 0;return{message:JSON.parse(P,i),arrayBuffers:k}}e.deserializeWebviewMessage=y}),define(me[88],ge([0,1,2]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function I(A,y,P){const D=A.webviewResourceRoot.replace("{{resource}}",P.scheme+T(P)).replace("{{uuid}}",y);return b.URI.parse(D)}e.asWebviewUri=I;function T(A){return A.toString().replace(/^\S+?:/,"")}}),define(me[202],ge([0,1,3,6,88,30]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class y{constructor(D,k,i){this._proxy=D,this._editors=k,this._initData=i,this._handlePool=0,this._disposables=new I.DisposableStore,this._insets=new Map,this._disposables.add(k.onDidChangeVisibleTextEditors(()=>{const C=k.getVisibleTextEditors();for(const f of this._insets.values())C.indexOf(f.editor)<0&&f.inset.dispose()}))}dispose(){this._insets.forEach(D=>D.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(D,k,i,C,f){let m;for(const a of this._editors.getVisibleTextEditors(!0))if(a.value===D){m=a;break}if(!m)throw new Error("not a visible editor");const l=this,d=this._handlePool++,E=new b.Emitter,w=new b.Emitter,S=new class{constructor(){this._uuid=(0,A.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(a){return(0,T.asWebviewUri)(l._initData,this._uuid,a)}get cspSource(){return l._initData.webviewCspSource}set options(a){this._options=a,l._proxy.$setOptions(d,a)}get options(){return this._options}set html(a){this._html=a,l._proxy.$setHtml(d,a)}get html(){return this._html}get onDidReceiveMessage(){return E.event}postMessage(a){return l._proxy.$postMessage(d,a)}},g=new class{constructor(){this.editor=D,this.line=k,this.height=i,this.webview=S,this.onDidDispose=w.event}dispose(){l._insets.has(d)&&(l._insets.delete(d),l._proxy.$disposeEditorInset(d),w.fire(),w.dispose(),E.dispose())}};return this._proxy.$createEditorInset(d,m.id,m.value.document.uri,k+1,i,C||{},f.identifier,f.extensionLocation),this._insets.set(d,{editor:D,inset:g,onDidReceiveMessage:E}),g}$onDidDispose(D){const k=this._insets.get(D);k&&k.inset.dispose()}$onDidReceiveMessage(D,k){const i=this._insets.get(D);i&&i.onDidReceiveMessage.fire(k)}}e.ExtHostEditorInsets=y}),define(me[203],ge([0,1,3,81,169,4,6,22,40,17,53,24,43,195]),function(G,e,b,I,T,A,y,P,D,k,i,C,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,m.registerIcon)("default-view-icon",f.Codicon.window,(0,T.localize)(0,null));var l;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(l=e.Extensions||(e.Extensions={}));var d;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel"})(d=e.ViewContainerLocation||(e.ViewContainerLocation={}));function E(s){switch(s){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=E;function w(s){return`viewContainer.${s}.enabled`}e.getEnabledViewContainerContextKey=w;class S extends y.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new b.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new b.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,k.flatten)([...this.viewContainers.values()])}registerViewContainer(c,h,_){var u;const p=this.get(c.id);if(p)return p;const R=c;return R.openCommandActionDescriptor=(_==null?void 0:_.donotRegisterOpenCommand)?void 0:(u=R.openCommandActionDescriptor)!==null&&u!==void 0?u:{id:R.id},(0,P.getOrSet)(this.viewContainers,h,[]).push(R),(_==null?void 0:_.isDefault)&&this.defaultViewContainers.push(R),this._onDidRegister.fire({viewContainer:R,viewContainerLocation:h}),R}deregisterViewContainer(c){for(const h of this.viewContainers.keys()){const _=this.viewContainers.get(h),u=_==null?void 0:_.indexOf(c);if(u!==-1){_==null||_.splice(u,1),_.length===0&&this.viewContainers.delete(h),this._onDidDeregister.fire({viewContainer:c,viewContainerLocation:h});return}}}get(c){return this.all.filter(h=>h.id===c)[0]}getViewContainers(c){return[...this.viewContainers.get(c)||[]]}getViewContainerLocation(c){return[...this.viewContainers.keys()].filter(h=>this.getViewContainers(h).filter(_=>(_==null?void 0:_.id)===c.id).length>0)[0]}getDefaultViewContainer(c){return this.defaultViewContainers.find(h=>this.getViewContainerLocation(h)===c)}}D.Registry.add(l.ViewContainersRegistry,new S);var g;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(g=e.ViewContentGroups||(e.ViewContentGroups={}));function a(s,c){var h,_,u,p;const R=(h=s.group)!==null&&h!==void 0?h:g.More,O=(_=c.group)!==null&&_!==void 0?_:g.More;return R!==O?R.localeCompare(O):((u=s.order)!==null&&u!==void 0?u:5)-((p=c.order)!==null&&p!==void 0?p:5)}class v extends y.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new b.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new b.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new b.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new b.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new i.SetMap}registerViews(c,h){this.registerViews2([{views:c,viewContainer:h}])}registerViews2(c){c.forEach(({views:h,viewContainer:_})=>this.addViews(h,_)),this._onViewsRegistered.fire(c)}deregisterViews(c,h){const _=this.removeViews(c,h);_.length&&this._onViewsDeregistered.fire({views:_,viewContainer:h})}moveViews(c,h){for(const _ of this._views.keys())if(_!==h){const u=this.removeViews(c,_);u.length&&(this.addViews(u,h),this._onDidChangeContainer.fire({views:u,from:_,to:h}))}}getViews(c){return this._views.get(c)||[]}getView(c){for(const h of this._viewContainers){const _=(this._views.get(h)||[]).filter(u=>u.id===c)[0];if(_)return _}return null}getViewContainer(c){for(const h of this._viewContainers)if((this._views.get(h)||[]).filter(u=>u.id===c)[0])return h;return null}registerViewWelcomeContent(c,h){return this._viewWelcomeContents.add(c,h),this._onDidChangeViewWelcomeContent.fire(c),(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(c,h),this._onDidChangeViewWelcomeContent.fire(c)})}registerViewWelcomeContent2(c,h){const _=new Map;for(const[u,p]of h)this._viewWelcomeContents.add(c,p),_.set(u,(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(c,p),this._onDidChangeViewWelcomeContent.fire(c)}));return this._onDidChangeViewWelcomeContent.fire(c),_}getViewWelcomeContent(c){const h=[];return this._viewWelcomeContents.forEach(c,_=>h.push(_)),h.sort(a)}addViews(c,h){let _=this._views.get(h);_||(_=[],this._views.set(h,_),this._viewContainers.push(h));for(const u of c){if(this.getView(u.id)!==null)throw new Error((0,T.localize)(1,null,u.id));_.push(u)}}removeViews(c,h){const _=this._views.get(h);if(!_)return[];const u=[],p=[];for(const R of _)c.includes(R)?u.push(R):p.push(R);return u.length&&(p.length?this._views.set(h,p):(this._views.delete(h),this._viewContainers.splice(this._viewContainers.indexOf(h),1))),u}}D.Registry.add(l.ViewsRegistry,new v),e.IViewsService=(0,A.createDecorator)("viewsService"),e.FocusedViewContext=new I.RawContextKey("focusedView","",(0,T.localize)(2,null));function t(s){return`view.${s}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,A.createDecorator)("viewDescriptorService");var n;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(n=e.ViewVisibilityState||(e.ViewVisibilityState={}));var o;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(o=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class r{constructor(c,h){this.resolved=!1,this._hasResolve=!1,(0,C.mixin)(this,c),this._hasResolve=!!h,this.resolve=async _=>{var u,p;if(h&&!this.resolved){const R=await h(_);R&&(this.tooltip=(u=this.tooltip)!==null&&u!==void 0?u:R.tooltip,this.command=(p=this.command)!==null&&p!==void 0?p:R.command)}_.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=r}),define(me[204],ge([0,1,2,180,119,14,181,203]),function(G,e,b,I,T,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function D(d){return(E,...w)=>d(E.get(I.ICommandService),...w)}class k{static execute(E,w){const S={forceReuseWindow:w&&w.reuseWindow,remoteAuthority:w&&w.remoteAuthority};return E.executeCommand("_files.newWindow",S)}}e.NewWindowAPICommand=k,k.ID="vscode.newWindow",I.CommandsRegistry.registerCommand({id:k.ID,handler:D(k.execute),description:{description:"Opens an new window",args:[]}}),I.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(d,E){return d.get(T.IWorkspacesService).removeRecentlyOpened([E])});class i{static execute(E,w){return typeof w=="string"?w=w.match(/^[^:/?#]+:\/\//)?b.URI.parse(w):b.URI.file(w):w=b.URI.revive(w),E.executeCommand("_workbench.removeFromRecentlyOpened",w)}}e.RemoveFromRecentlyOpenedAPICommand=i,i.ID="vscode.removeFromRecentlyOpened",I.CommandsRegistry.registerCommand(i.ID,D(i.execute));class C{static execute(E,w){const S=typeof w=="string"?{extensionId:w}:w;return E.executeCommand("workbench.action.openIssueReporter",S)}}e.OpenIssueReporter=C,C.ID="vscode.openIssueReporter",I.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(d,E){const w=d.get(T.IWorkspacesService);let S;const g=E.uri,a=E.label,v=E.remoteAuthority;return E.type==="workspace"?S={workspace:await w.getWorkspaceIdentifier(g),label:a,remoteAuthority:v}:E.type==="folder"?S={folderUri:g,label:a,remoteAuthority:v}:S={fileUri:g,label:a,remoteAuthority:v},w.addRecentlyOpened([S])}),I.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(d){return d.get(T.IWorkspacesService).getRecentlyOpened()}),I.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(d,E){const w=d.get(A.ILogService),S=d.get(y.IEnvironmentService);S.isExtensionDevelopment&&!!S.extensionTestsLocationURI&&w.setLevel(E)}),I.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(d){return d.get(A.ILogService).getLevel()}),I.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(d,E){const w=d.get(P.IViewDescriptorService),S=w.getViewContainerById(E.destinationId);if(!!S){for(const g of E.viewIds){const a=w.getViewDescriptorById(g);(a==null?void 0:a.canMoveView)&&w.moveViewsToContainer([a],S,P.ViewVisibilityState.Default)}await d.get(P.IViewsService).openViewContainer(S.id,!0)}});class f{static execute(E,w){return!Array.isArray(w==null?void 0:w.viewIds)||typeof(w==null?void 0:w.destinationId)!="string"?Promise.reject("Invalid arguments"):E.executeCommand("_workbench.action.moveViews",w)}}e.MoveViewsAPICommand=f,f.ID="vscode.moveViews",I.CommandsRegistry.registerCommand({id:f.ID,handler:D(f.execute),description:{description:"Move Views",args:[]}});class m{static execute(E,w){return E.executeCommand("_workbench.open",w)}}m.ID="vscode.open",I.CommandsRegistry.registerCommand(m.ID,D(m.execute));class l{static execute(E,w,S,g,a){return E.executeCommand("_workbench.diff",[w,S,g])}}l.ID="vscode.diff",I.CommandsRegistry.registerCommand(l.ID,D(l.execute))}),define(me[122],ge([0,1,3,13,170]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new b.Emitter,this._onExit=new b.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(P){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=P}onEvent(P){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=P}onRequest(P){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=P}sendResponse(P){P.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.internalSend("response",P)}sendRequest(P,D,k,i){const C={command:P};if(D&&Object.keys(D).length>0&&(C.arguments=D),this.internalSend("request",C),typeof i=="number"){const f=setTimeout(()=>{clearTimeout(f);const m=this.pendingRequests.get(C.seq);if(m){this.pendingRequests.delete(C.seq);const l={type:"response",seq:0,request_seq:C.seq,success:!1,command:P,message:(0,T.localize)(0,null,i,P)};m(l)}},i)}return k&&this.pendingRequests.set(C.seq,k),C.seq}acceptMessage(P){this.messageCallback?this.messageCallback(P):(this.queue.push(P),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(P,D){return P.type!=="event"||D.type!=="event"}async processQueue(){let P;for(;this.queue.length;){if((!P||this.needsTaskBoundaryBetween(this.queue[0],P))&&await(0,I.timeout)(0),P=this.queue.shift(),!P)return;switch(P.type){case"event":this.eventCallback&&this.eventCallback(P);break;case"request":this.requestCallback&&this.requestCallback(P);break;case"response":const D=P,k=this.pendingRequests.get(D.request_seq);k&&(this.pendingRequests.delete(D.request_seq),k(D));break}}}internalSend(P,D){D.type=P,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const P=new Map;this.pendingRequests.forEach((D,k)=>P.set(k,D)),await(0,I.timeout)(500),P.forEach((D,k)=>{D({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(me[205],ge([0,1,9,2,8,24,12]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const P=/{([^}]+)}/g;function D(n,o,r){return n.replace(P,function(s,c){return o&&c.length>0&&c[0]!=="_"?s:r&&r.hasOwnProperty(c)?r[c]:s})}e.formatPII=D;function k(n){const o={};for(const r of Object.keys(n))r.startsWith("!")||(o[r]=n[r]);return o}e.filterExceptionsFromTelemetry=k;function i(n){return n.configuration.request==="attach"&&!C(n)}e.isSessionAttach=i;function C(n){let o=n.configuration.type;if(!!o)return o==="vslsShare"&&(o=n.configuration.adapterProxy.configuration.type),(0,b.equalsIgnoreCase)(o,"extensionhost")||(0,b.equalsIgnoreCase)(o,"pwa-extensionhost")?n:n.parentSession?C(n.parentSession):void 0}e.getExtensionHostDebugSession=C;function f(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=f;function m(n,o,r){let s,c=0,h=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,_=null;for(;_=h.exec(n);){let u=_.index+1,p=u+_[0].length;if(u<=o&&p>=r){s=_[0],c=u;break}}if(s){let u=/\w+/g,p=null;for(;(p=u.exec(s))&&!(p.index+1+c+p[0].length>=r););p&&(s=s.substring(0,u.lastIndex))}return s?{start:c,end:c+s.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=m;const l=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function d(n){return!!(n&&n.match(l))}e.isUri=d;function E(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(d(n.path))return I.URI.parse(n.path);if((0,T.isAbsolute)(n.path))return I.URI.file(n.path)}return n.path}function w(n){if(typeof n.path=="object"){const o=I.URI.revive(n.path);if(o)return o.scheme===y.Schemas.file?o.fsPath:o.toString()}return n.path}function S(n,o){const r=o?E:w,s=(0,A.deepClone)(n);return a(s,(c,h)=>{c&&h&&(h.path=r(h))}),s}e.convertToDAPaths=S;function g(n,o){const r=o?E:w,s=(0,A.deepClone)(n);return a(s,(c,h)=>{!c&&h&&(h.path=r(h))}),s}e.convertToVSCPaths=g;function a(n,o){switch(n.type){case"event":const r=n;switch(r.event){case"output":o(!1,r.body.source);break;case"loadedSource":o(!1,r.body.source);break;case"breakpoint":o(!1,r.body.breakpoint.source);break;default:break}break;case"request":const s=n;switch(s.command){case"setBreakpoints":o(!0,s.arguments.source);break;case"breakpointLocations":o(!0,s.arguments.source);break;case"source":o(!0,s.arguments.source);break;case"gotoTargets":o(!0,s.arguments.source);break;case"launchVSCode":s.arguments.args.forEach(h=>o(!1,h));break;default:break}break;case"response":const c=n;if(c.success&&c.body)switch(c.command){case"stackTrace":c.body.stackFrames.forEach(h=>o(!1,h.source));break;case"loadedSources":c.body.sources.forEach(h=>o(!1,h));break;case"scopes":c.body.scopes.forEach(h=>o(!1,h.source));break;case"setFunctionBreakpoints":c.body.breakpoints.forEach(h=>o(!1,h.source));break;case"setBreakpoints":c.body.breakpoints.forEach(h=>o(!1,h.source));break;default:break}break}}function v(n){return n.filter(o=>{var r;return!((r=o.presentation)===null||r===void 0?void 0:r.hidden)}).sort((o,r)=>o.presentation?r.presentation?o.presentation.group?r.presentation.group?o.presentation.group!==r.presentation.group?o.presentation.group.localeCompare(r.presentation.group):t(o.presentation.order,r.presentation.order):-1:r.presentation.group?1:t(o.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=v;function t(n,o){return typeof n!="number"?typeof o!="number"?0:1:typeof o!="number"?-1:n-o}}),define(me[206],ge([0,1,26,38,171,123,8,9,24,10,182,122]),function(G,e,b,I,T,A,y,P,D,k,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class f extends C.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(S,g){this.outputStream=g,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,S.on("data",a=>this.handleData(a))}sendMessage(S){if(this.outputStream){const g=JSON.stringify(S);this.outputStream.write(`Content-Length: ${Buffer.byteLength(g,"utf8")}${f.TWO_CRLF}${g}`,"utf8")}}handleData(S){for(this.rawData=Buffer.concat([this.rawData,S]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const g=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,g.length>0)try{this.acceptMessage(JSON.parse(g))}catch(a){this._onError.fire(new Error((a.message||a)+`
`+g))}continue}}else{const g=this.rawData.indexOf(f.TWO_CRLF);if(g!==-1){const v=this.rawData.toString("utf8",0,g).split(f.HEADER_LINESEPARATOR);for(const t of v){const n=t.split(f.HEADER_FIELDSEPARATOR);n[0]==="Content-Length"&&(this.contentLength=Number(n[1]))}this.rawData=this.rawData.slice(g+f.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=f,f.TWO_CRLF=`\r
\r
`,f.HEADER_LINESEPARATOR=/\r?\n/,f.HEADER_FIELDSEPARATOR=/: */;class m extends f{startSession(){return new Promise((S,g)=>{let a=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),S(),a=!0}),this.socket.on("close",()=>{a?this._onError.fire(new Error("connection closed")):g(new Error("connection closed"))}),this.socket.on("error",v=>{a?this._onError.fire(v):g(v)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=m;class l extends m{constructor(S){super();this.adapterServer=S}createConnection(S){return A.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",S)}}e.SocketDebugAdapter=l;class d extends m{constructor(S){super();this.adapterServer=S}createConnection(S){return A.createConnection(this.adapterServer.path,S)}}e.NamedPipeDebugAdapter=d;class E extends f{constructor(S,g,a){super();this.adapterExecutable=S,this.debugType=g,this.outputService=a}async startSession(){const S=this.adapterExecutable.command,g=this.adapterExecutable.args,a=this.adapterExecutable.options||{};try{if(S)if(y.isAbsolute(S)){if(!await(0,b.exists)(S))throw new Error(T.localize(0,null,S))}else S.indexOf("/")<0&&S.indexOf("\\")<0;else throw new Error(T.localize(1,null,this.debugType));let v=process.env;if(a.env&&Object.keys(a.env).length>0&&(v=D.mixin(D.deepClone(process.env),a.env)),S==="node")if(Array.isArray(g)&&g.length>0){const n=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,o={env:v,execArgv:n?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};a.cwd&&(o.cwd=a.cwd);const r=I.fork(g[0],g.slice(1),o);if(!r.pid)throw new Error(T.localize(2,null,g[0]));this.serverProcess=r}else throw new Error(T.localize(3,null));else{const n={env:v};a.cwd&&(n.cwd=a.cwd),this.serverProcess=I.spawn(S,g,n)}this.serverProcess.on("error",n=>{this._onError.fire(n)}),this.serverProcess.on("exit",(n,o)=>{this._onExit.fire(n)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",n=>{this._onError.fire(n)}),this.serverProcess.stdin.on("error",n=>{this._onError.fire(n)});const t=this.outputService;if(t){const n=o=>o.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",o=>{const r=t.getChannel(i.ExtensionsChannelId);r&&r.append(n(o))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(v){this._onError.fire(v)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),k.isWindows?new Promise((S,g)=>{const a=I.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(v,t,n){if(v)return g(v)});a.on("exit",S),a.on("error",g)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(S,g){if(!!S){const a=Object.create(null);S.runtime&&(S.runtime.indexOf("./")===0?a.runtime=y.join(g,S.runtime):a.runtime=S.runtime),S.runtimeArgs&&(a.runtimeArgs=S.runtimeArgs),S.program&&(y.isAbsolute(S.program)?a.program=S.program:a.program=y.join(g,S.program)),S.args&&(a.args=S.args);const v=S;return v.win&&(a.win=E.extract(v.win,g)),v.winx86&&(a.winx86=E.extract(v.winx86,g)),v.windows&&(a.windows=E.extract(v.windows,g)),v.osx&&(a.osx=E.extract(v.osx,g)),v.linux&&(a.linux=E.extract(v.linux,g)),a}}static platformAdapterExecutable(S,g){let a=Object.create(null);g=g.toLowerCase();for(const s of S)if(s.contributes){const c=s.contributes.debuggers;c&&c.length>0&&c.filter(h=>typeof h.type=="string"&&P.equalsIgnoreCase(h.type,g)).forEach(h=>{const _=E.extract(h,s.extensionLocation.fsPath);a=D.mixin(a,_,s.isBuiltin)})}let v;k.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?v=a.winx86||a.win||a.windows:k.isWindows?v=a.win||a.windows:k.isMacintosh?v=a.osx:k.isLinux&&(v=a.linux),v=v||a;let t=v.program||a.program;const n=v.args||a.args;let o=v.runtime||a.runtime;const r=v.runtimeArgs||a.runtimeArgs;if(o)return{type:"executable",command:o,args:(r||[]).concat(typeof t=="string"?[t]:[]).concat(n||[])};if(t)return{type:"executable",command:t,args:n||[]}}}e.ExecutableDebugAdapter=E}),define(me[207],ge([0,1,38,10,29,189]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function y(f,m){return new Promise((l,d)=>{let E="";const w=b.spawn(f,m);w.pid&&w.stdout.on("data",S=>{E+=S.toString()}),w.on("error",S=>{d(S)}),w.on("close",S=>{l(E)})})}let P;function D(f,m){if(!P)if(I.isWindows)P=new A.WindowsExternalTerminalService(void 0);else if(I.isMacintosh)P=new A.MacExternalTerminalService(void 0);else if(I.isLinux)P=new A.LinuxExternalTerminalService(void 0);else throw new Error("external terminals not supported on this platform");const l=m.getConfiguration("terminal");return P.runInTerminal(f.title,f.cwd,f.args,f.env||{},l.external||{})}e.runInExternalTerminal=D;function k(f){return f?I.isWindows?y("wmic",["process","get","ParentProcessId"]).then(m=>m.split(`\r
`).some(d=>parseInt(d)===f),m=>!0):y("/usr/bin/pgrep",["-lP",String(f)]).then(m=>{const l=m.trim();return!(l.length===0||l.indexOf(" tmux")>=0)},m=>!0):Promise.resolve(!0)}e.hasChildProcesses=k;var i;(function(f){f[f.cmd=0]="cmd",f[f.powershell=1]="powershell",f[f.bash=2]="bash"})(i||(i={}));function C(f,m,l,d){f=f.trim().toLowerCase();let E;f.indexOf("powershell")>=0||f.indexOf("pwsh")>=0?E=1:f.indexOf("cmd.exe")>=0?E=0:f.indexOf("bash")>=0?E=2:I.isWindows?E=0:E=2;let w,S=" ";switch(E){case 1:if(w=a=>(a=a.replace(/\'/g,"''"),a.length>0&&a.charAt(a.length-1)==="\\"?`'${a}\\'`:`'${a}'`),l){const a=(0,T.getDriveLetter)(l);a&&(S+=`${a}:; `),S+=`cd ${w(l)}; `}if(d)for(let a in d){const v=d[a];v===null?S+=`Remove-Item env:${a}; `:S+=`\${env:${a}}='${v}'; `}if(m.length>0){const a=w(m.shift());S+=a[0]==="'"?`& ${a} `:`${a} `;for(let v of m)S+=`${w(v)} `}break;case 0:if(w=a=>(a=a.replace(/\"/g,'""'),a.indexOf(" ")>=0||a.indexOf('"')>=0||a.length===0?`"${a}"`:a),l){const a=(0,T.getDriveLetter)(l);a&&(S+=`${a}: && `),S+=`cd ${w(l)} && `}if(d){S+='cmd /C "';for(let a in d){let v=d[a];v===null?S+=`set "${a}=" && `:(v=v.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),S+=`set "${a}=${v}" && `)}}for(let a of m)S+=`${w(a)} `;d&&(S+='"');break;case 2:w=a=>(a=a.replace(/(["'\\\$])/g,"\\$1"),a.indexOf(" ")>=0||a.indexOf(";")>=0||a.length===0?`"${a}"`:a);const g=a=>/[^\w@%\/+=,.:^-]/.test(a)?`'${a.replace(/'/g,"'\\''")}'`:a;if(l&&(S+=`cd ${w(l)} ; `),d){S+="/usr/bin/env";for(let a in d){const v=d[a];v===null?S+=` -u ${g(a)}`:S+=` ${g(`${a}=${v}`)}`}S+=" "}for(let a of m)S+=`${w(a)} `;break}return S}e.prepareCommand=C}),define(me[89],ge([0,1,33,12,8,10,81]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarVisibility=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var P;(function(u){u[u.Markdown=1]="Markdown",u[u.Code=2]="Code"})(P=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var D;(function(u){u[u.Running=1]="Running",u[u.Idle=2]="Idle"})(D=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{}};var k;(function(u){u[u.Idle=1]="Idle",u[u.Pending=2]="Pending",u[u.Executing=3]="Executing"})(k=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var i;(function(u){u[u.WithHardKernelDependency=0]="WithHardKernelDependency",u[u.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",u[u.Pure=2]="Pure",u[u.Never=3]="Never"})(i=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var C;(function(u){u[u.ModelChange=1]="ModelChange",u[u.Move=2]="Move",u[u.CellClearOutput=3]="CellClearOutput",u[u.CellsClearOutput=4]="CellsClearOutput",u[u.ChangeLanguage=5]="ChangeLanguage",u[u.Initialize=6]="Initialize",u[u.ChangeCellMetadata=7]="ChangeCellMetadata",u[u.Output=8]="Output",u[u.OutputItem=9]="OutputItem",u[u.ChangeCellContent=10]="ChangeCellContent",u[u.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",u[u.Unknown=12]="Unknown"})(C=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var f;(function(u){u[u.Handle=0]="Handle",u[u.Index=1]="Index"})(f=e.SelectionStateType||(e.SelectionStateType={}));var m;(function(u){u[u.Replace=1]="Replace",u[u.Output=2]="Output",u[u.Metadata=3]="Metadata",u[u.CellLanguage=4]="CellLanguage",u[u.DocumentMetadata=5]="DocumentMetadata",u[u.Move=6]="Move",u[u.OutputItems=7]="OutputItems",u[u.PartialMetadata=8]="PartialMetadata"})(m=e.CellEditType||(e.CellEditType={}));function l(u){const p=d.parse(u);return p?p.notebook.toString():u.toString()}e.getCellUndoRedoComparisonKey=l;var d;(function(u){u.scheme=I.Schemas.vscodeNotebookCell;const p=/^ch(\d{7,})/;function R(x,$){return x.with({scheme:u.scheme,fragment:`ch${$.toString().padStart(7,"0")}${x.scheme!==I.Schemas.file?x.scheme:""}`})}u.generate=R;function O(x){if(x.scheme===u.scheme){const $=p.exec(x.fragment);if(!!$)return{handle:Number($[1]),notebook:x.with({scheme:x.fragment.substr($[0].length)||I.Schemas.file,fragment:null})}}}u.parse=O;function j(x){if(x.scheme===I.Schemas.vscodeNotebookCellMetadata){const $=p.exec(x.fragment);if(!!$)return{handle:Number($[1]),notebook:x.with({scheme:x.fragment.substr($[0].length)||I.Schemas.file,fragment:null})}}}u.parseCellMetadataUri=j;function ie(x,$,U){return x.with({scheme:U,fragment:`ch${$.toString().padStart(7,"0")}${x.scheme!==I.Schemas.file?x.scheme:""}`})}u.generateCellUri=ie;function K(x,$){if(x.scheme===$){const U=p.exec(x.fragment);if(!!U)return{handle:Number(U[1]),notebook:x.with({scheme:x.fragment.substr(U[0].length)||I.Schemas.file,fragment:null})}}}u.parseCellUri=K})(d=e.CellUri||(e.CellUri={}));const E=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function w(u){var p,R;return(R=(p=E.get(u))===null||p===void 0?void 0:p.alwaysSecure)!==null&&R!==void 0?R:!1}e.mimeTypeIsAlwaysSecure=w;function S(u){var p,R;return(R=(p=E.get(u))===null||p===void 0?void 0:p.supportedByCore)!==null&&R!==void 0?R:!1}e.mimeTypeSupportedByCore=S;function g(u){var p,R;return(R=(p=E.get(u))===null||p===void 0?void 0:p.mergeable)!==null&&R!==void 0?R:!1}e.mimeTypeIsMergeable=g;function a(u,p){return A.isWindows&&(u=u.replace(/\//g,"\\"),p=p.replace(/\//g,"\\")),b.match(u,p)}function v(u,p,R){let O=0;for(let j=0;j<p.length;j++){if(a(p[j],u))return O;O++}for(let j=0;j<R.length;j++){if(a(R[j],u))return O;O++}return O}function t(u,p,R){return u.sort((O,j)=>v(O,p,R)-v(j,p,R))}e.sortMimeTypes=t;function n(u,p,R,O=(j,ie)=>j===ie){const j=[];function ie($,U,L){if(!(U===0&&L.length===0)){const N=j[j.length-1];N&&N.start+N.deleteCount===$?(N.deleteCount+=U,N.toInsert.push(...L)):j.push({start:$,deleteCount:U,toInsert:L})}}let K=0,x=0;for(;;){if(K===u.length){ie(K,0,p.slice(x));break}if(x===p.length){ie(K,u.length-K,[]);break}const $=u[K],U=p[x];if(O($,U)){K+=1,x+=1;continue}R(U)?(ie(K,1,[]),K+=1):(ie(K,0,[U]),x+=1)}return j}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var o;(function(u){u.default="default",u.option="option"})(o=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(u){const p=u;return!!((typeof p.include=="string"||b.isRelativePattern(p.include))&&(typeof p.exclude=="string"||b.isRelativePattern(p.exclude)))}e.isDocumentExcludePattern=r;function s(u,p,R){if(Array.isArray(u.viewType)&&u.viewType.indexOf(p)>=0||u.viewType===p)return!0;if(u.filenamePattern){let O=r(u.filenamePattern)?u.filenamePattern.include:u.filenamePattern,j=r(u.filenamePattern)?u.filenamePattern.exclude:void 0;if(b.match(O,(0,T.basename)(R.fsPath).toLowerCase()))return!(j&&b.match(j,(0,T.basename)(R.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=s;class c{constructor(p){this.textModel=p}getElements(){const p=new Int32Array(this.textModel.cells.length);for(let R=0;R<this.textModel.cells.length;R++)p[R]=this.textModel.cells[R].getHashValue();return p}}e.CellSequence=c,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer";var h;(function(u){u[u.Left=1]="Left",u[u.Right=2]="Right"})(h=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class _{static create(p){return`${_._prefix}/${p}`}static parse(p){if(p.startsWith(_._prefix))return p.substr(_._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=_,_._prefix="notebook/"}),define(me[208],ge([0,1,173,4,81]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new T.RawContextKey("customExecutionSupported",!0,b.localize(0,null)),e.ShellExecutionSupportedContext=new T.RawContextKey("shellExecutionSupported",!1,b.localize(1,null)),e.ProcessExecutionSupportedContext=new T.RawContextKey("processExecutionSupported",!1,b.localize(2,null)),e.ITaskService=(0,I.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(me[209],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function b(T){return[...T.entries()]}e.serializeEnvironmentVariableCollection=b;function I(T){return new Map(T)}e.deserializeEnvironmentVariableCollection=I}),define(me[210],ge([0,1,8,95,10]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function A(a,v){if(!!v)if(T.isWindows)for(const t in v){let n=t;for(const r in a)if(t.toLowerCase()===r.toLowerCase()){n=r;break}const o=v[t];o!==void 0&&y(a,n,o)}else Object.keys(v).forEach(t=>{const n=v[t];n!==void 0&&y(a,t,n)})}e.mergeEnvironments=A;function y(a,v,t){typeof t=="string"?a[v]=t:delete a[v]}function P(a,v,t,n){a.TERM_PROGRAM="vscode",v&&(a.TERM_PROGRAM_VERSION=v),i(a,n)&&(a.LANG=C(t)),a.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=P;function D(a,v){if(!!v)for(const t of Object.keys(v)){const n=v[t];n&&(a[t]=n)}}function k(a,v){return Object.keys(v).forEach(t=>{const n=v[t];if(typeof n=="string")try{v[t]=a(n)}catch(o){v[t]=n}}),v}function i(a,v){if(v==="on")return!0;if(v==="auto"){const t=a.LANG;return!t||t.search(/\.UTF\-8$/)===-1&&t.search(/\.utf8$/)===-1&&t.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=i;function C(a){const v=a?a.split("-"):[],t=v.length;if(t===0)return"en_US.UTF-8";if(t===1){const n={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};v[0]in n&&v.push(n[v[0]])}else v[1]=v[1].toUpperCase();return v.join("_")+".UTF-8"}e.getLangEnvVariable=C;function f(a,v,t,n,o,r){if(a.cwd){const c=typeof a.cwd=="object"?a.cwd.fsPath:a.cwd,h=m(c,t);return l(h||c)}let s;return!a.ignoreConfigurationCwd&&o&&(t&&(o=m(o,t,r)),o&&(b.isAbsolute(o)?s=o:n&&(s=b.join(n.fsPath,o)))),s||(s=n?n.fsPath:v||""),l(s)}e.getCwd=f;function m(a,v,t){if(v)try{return v(a)}catch(n){t==null||t.error("Could not resolve terminal cwd",n);return}return a}function l(a){return T.OS===1&&a&&a[1]===":"?a[0].toUpperCase()+a.substr(1):a}function d(a,v,t){if(!!t)return n=>t.resolveWithEnvironment(v,a,n)}e.createVariableResolver=d;function E(a,v,t,n,o,r,s,c=T.platform){let h;s&&(h=S(a,"automationShell",c)),h||(h=S(a,"shell",c));let _=h||v;if(c===3&&!t&&n){const u=b.join(n,"Sysnative").replace(/\//g,"\\").toLowerCase();_&&_.toLowerCase().indexOf(u)===0&&(_=b.join(n,"System32",_.substr(u.length+1)))}if(_&&c===3&&(_=_.replace(/\//g,"\\")),o)try{_=o(_)}catch(u){r.error("Could not resolve shell",u)}return _}e.getDefaultShell=E;function w(a,v,t,n,o=T.platform){if(v&&S(a,"automationShell",o))return[];const r=o===3?"windows":o===1?"osx":"linux";let s=a(`terminal.integrated.shellArgs.${r}`);if(!s)return[];if(typeof s=="string"&&o===3)return t?t(s):s;if(t){const c=[];for(const h of s)try{c.push(t(h))}catch(_){n.error(`Could not resolve terminal.integrated.shellArgs.${r}`,_),c.push(h)}s=c}return s}e.getDefaultShellArgs=w;function S(a,v,t=T.platform){return a(`terminal.integrated.${v}.${t===3?"windows":t===1?"osx":"linux"}`)}function g(a,v,t,n,o,r){const s={};if(a.strictEnv)D(s,a.env);else{D(s,r);const c=Object.assign({},v);t&&(c&&k(t,c),a.env&&k(t,a.env)),(0,I.sanitizeProcessEnvironment)(s,"VSCODE_IPC_HOOK_CLI"),A(s,c),A(s,a.env),P(s,n,T.locale,o)}return s}e.createTerminalEnvironment=g});var mn=this&&this.__asyncValues||function(G){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=G[Symbol.asyncIterator],b;return e?e.call(G):(G=typeof __values=="function"?__values(G):G[Symbol.iterator](),b={},I("next"),I("throw"),I("return"),b[Symbol.asyncIterator]=function(){return this},b);function I(A){b[A]=G[A]&&function(y){return new Promise(function(P,D){y=G[A](y),T(P,D,y.done,y.value)})}}function T(A,y,P,D){Promise.resolve(D).then(function(k){A({value:k,done:P})},y)}};define(me[211],ge([0,1,37,8,105,192,38,26,43,10]),function(G,e,b,I,T,A,y,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let i;function C(a,v,t,n,o,r,s){return t=t||{existsFile:P.SymlinkSupport.existsFile,readFile:b.promises.readFile},k.isWindows?f(a,t,n,v("terminal.integrated.useWslProfiles")||!0,v("terminal.integrated.profiles.windows"),v("terminal.integrated.defaultProfile.windows"),o,r):w(t,n,a,v(k.isMacintosh?"terminal.integrated.profiles.osx":"terminal.integrated.profiles.linux"),v(k.isMacintosh?"terminal.integrated.defaultProfile.osx":"terminal.integrated.defaultProfile.linux"),s,o,r)}e.detectAvailableProfiles=C;async function f(a,v,t,n,o,r,s,c){const h=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),_=`${process.env.windir}\\${h?"Sysnative":"System32"}`;let u=!1;(0,A.getWindowsBuildNumber)()>=16299&&(u=!0),await l();const p=new Map;a||(p.set("PowerShell",{source:"PowerShell",icon:D.Codicon.terminalPowershell.id,isAutoDetected:!0}),p.set("Windows PowerShell",{path:`${_}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:D.Codicon.terminalPowershell.id,isAutoDetected:!0}),p.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),p.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),p.set("Command Prompt",{path:`${_}\\cmd.exe`,icon:D.Codicon.terminalCmd.id,isAutoDetected:!0})),S(o,p);const R=await m(p.entries(),r,v,t,s,c);if(!a||a&&n)try{const O=await E(`${_}\\${u?"wsl":"bash"}.exe`,r);O&&R.push(...O)}catch(O){t==null||t.info("WSL is not installed, so could not detect WSL profiles")}return R}async function m(a,v,t,n,o,r){const s=[];for(const[c,h]of a)if(h!==null){let _,u,p;if("source"in h){const j=i==null?void 0:i.get(h.source);if(!j)continue;_=j.paths,u=h.args||j.args,p=h.icon||j.icon}else _=Array.isArray(h.path)?h.path:[h.path],u=k.isWindows||Array.isArray(h.args)?h.args:void 0,p=h.icon;const R=_.slice();for(let j=0;j<R.length;j++)R[j]=await(o==null?void 0:o.resolveAsync(r,R[j]))||R[j];const O=await g(c,v,R,t,u,h.env,h.overrideName,h.isAutoDetected,n);O?(O.isAutoDetected=h.isAutoDetected,O.icon=p,s.push(O)):n==null||n.trace("profile not validated",c,_)}return s}async function l(){i||(i=new Map,i.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`],args:["--login"]}),i.set("PowerShell",{profileName:"PowerShell",paths:await d(),icon:"terminal-powershell"}))}async function d(){var a,v;const t=[];try{for(var n=mn((0,T.enumeratePowerShellInstallations)()),o;o=await n.next(),!o.done;){const r=o.value;t.push(r.exePath)}}catch(r){a={error:r}}finally{try{o&&!o.done&&(v=n.return)&&await v.call(n)}finally{if(a)throw a.error}}return t}async function E(a,v){const t=[],n=await new Promise((s,c)=>{y.exec("wsl.exe -l -q",{encoding:"utf16le"},(h,_)=>{if(h)return c("Problem occurred when getting wsl distros");s(_)})});if(!n)return[];const o=new RegExp(/[\r?\n]/),r=n.split(o).filter(s=>s.trim().length>0&&s!=="");for(const s of r)if(s!==""&&!s.startsWith("docker-desktop")){const c=`${s} (WSL)`,h={profileName:c,path:a,args:["-d",`${s}`],isDefault:c===v};s.includes("Ubuntu")?h.icon="terminal-ubuntu":s.includes("Debian")?h.icon="terminal-debian":h.icon="terminal-linux",t.push(h)}return t}async function w(a,v,t,n,o,r,s,c){const h=new Map;if(!t){const _=await a.readFile("/etc/shells","utf8"),u=r||_.split(`
`).filter(R=>R.trim().indexOf("#")!==0&&R.trim().length>0),p=new Map;for(const R of u){let O=(0,I.basename)(R),j=p.get(O)||0;j++,j>1&&(O=`${O} (${j})`),p.set(O,j),h.set(O,{path:R,isAutoDetected:!0})}}return S(n,h),await m(h.entries(),o,a,v,s,c)}function S(a,v){if(!!a)for(const[t,n]of Object.entries(a))n===null||!("path"in n)&&!("source"in n)?v.delete(t):v.set(t,n)}async function g(a,v,t,n,o,r,s,c,h){if(t.length===0)return Promise.resolve(void 0);const _=t.shift();if(_==="")return g(a,v,t,n,o,r,s,c);const u={profileName:a,path:_,args:o,env:r,overrideName:s,isAutoDetected:c,isDefault:a===v};if((0,I.basename)(_)===_){const R=process.env.PATH?process.env.PATH.split(I.delimiter):void 0;return await(0,A.findExecutable)(_,void 0,R,void 0,n.existsFile)?u:g(a,v,t,n,o)}return await n.existsFile((0,I.normalize)(_))?u:g(a,v,t,n,o,r,s,c)}}),define(me[124],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var b;(function(D){D[D.NotExpandable=0]="NotExpandable",D[D.Expandable=1]="Expandable",D[D.BusyExpanding=2]="BusyExpanding",D[D.Expanded=3]="Expanded"})(b=e.TestItemExpandState||(e.TestItemExpandState={}));const I=(D,k)=>{k.expand!==void 0&&(D.expand=k.expand),k.item!==void 0&&(D.item=D.item?Object.assign(D.item,k.item):k.item)};e.applyTestItemUpdate=I;var T;(function(D){D[D.Add=0]="Add",D[D.Update=1]="Update",D[D.Remove=2]="Remove",D[D.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",D[D.Retire=4]="Retire"})(T=e.TestDiffOpType||(e.TestDiffOpType={}));const A=(D,k)=>`${D}:${k.toString()}`;e.getTestSubscriptionKey=A;class y{add(k){}update(k){}remove(k,i){}complete(){}}e.IncrementalChangeCollector=y;class P{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(k){const i=this.createChangeCollector();for(const C of k)switch(C[0]){case 0:{const f=C[1];if(f.parent){if(this.items.has(f.parent)){const m=this.items.get(f.parent);m.children.add(f.item.extId);const l=this.createItem(f,m);this.items.set(f.item.extId,l),i.add(l)}}else{this.roots.add(f.item.extId);const m=this.createItem(f);this.items.set(f.item.extId,m),i.add(m)}f.expand===2&&this.busyControllerCount++;break}case 1:{const f=C[1],m=this.items.get(f.extId);if(!m)break;f.expand!==void 0&&(m.expand===2&&this.busyControllerCount--,f.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(m,f),i.update(m);break}case 2:{const f=this.items.get(C[1]);if(!f)break;f.parent?this.items.get(f.parent).children.delete(f.item.extId):this.roots.delete(f.item.extId);const m=[[C[1]]];for(;m.length;)for(const l of m.pop()){const d=this.items.get(l);d&&(m.push(d.children),this.items.delete(l),i.remove(d,d!==f),d.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(C[1]);break;case 3:this.updatePendingRoots(C[1]);break}i.complete()}retireTest(k){}updatePendingRoots(k){this.pendingRootCount+=k}createChangeCollector(){return new y}}e.AbstractIncrementalTestCollection=P}),define(me[212],ge([0,1,8,36,11,24,10,76,174]),function(G,e,b,I,T,A,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(C,f,m){this._contributedVariables=new Map,this._context=C,this._labelService=f,m&&(this._envVariablesPromise=m.then(l=>this.prepareEnv(l)))}prepareEnv(C){if(y.isWindows){const f=Object.create(null);return Object.keys(C).forEach(m=>{f[m.toLowerCase()]=C[m]}),f}return C}resolveWithEnvironment(C,f,m){return this.recursiveResolve(this.prepareEnv(C),f?f.uri:void 0,m)}async resolveAsync(C,f){return this.recursiveResolve(await this._envVariablesPromise,C?C.uri:void 0,f)}async resolveAnyBase(C,f,m,l){const d=A.deepClone(f);return y.isWindows&&d.windows?Object.keys(d.windows).forEach(E=>d[E]=d.windows[E]):y.isMacintosh&&d.osx?Object.keys(d.osx).forEach(E=>d[E]=d.osx[E]):y.isLinux&&d.linux&&Object.keys(d.linux).forEach(E=>d[E]=d.linux[E]),delete d.windows,delete d.osx,delete d.linux,this.recursiveResolve(await this._envVariablesPromise,C?C.uri:void 0,d,m,l)}async resolveAnyAsync(C,f,m){return this.resolveAnyBase(C,f,m)}async resolveAnyMap(C,f,m){const l=new Map;return{newConfig:await this.resolveAnyBase(C,f,m,l),resolvedVariables:l}}resolveWithInteractionReplace(C,f,m,l){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,f,m,l){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,f){if(this._contributedVariables.has(C))throw new Error("Variable "+C+" is contributed twice.");this._contributedVariables.set(C,f)}recursiveResolve(C,f,m,l,d){if(T.isString(m))return this.resolveString(C,f,m,l,d);if(T.isArray(m))return m.map(E=>this.recursiveResolve(C,f,E,l,d));if(T.isObject(m)){let E=Object.create(null);return Object.keys(m).forEach(w=>{const S=this.resolveString(C,f,w,l,d);E[S]=this.recursiveResolve(C,f,m[w],l,d)}),E}return m}resolveString(C,f,m,l,d){return m.replace(k.VARIABLE_REGEXP,(w,S)=>{if(S.includes(k.VARIABLE_LHS))return w;let g=this.evaluateSingleVariable(C,w,S,f,l);return d&&d.set(S,g),g})}fsPath(C){return this._labelService?this._labelService.getUriLabel(C,{noPrefix:!0}):C.fsPath}evaluateSingleVariable(C,f,m,l,d){let E;const w=m.split(":");w.length>1&&(m=w[0],E=w[1]);const S=()=>{const v=this._context.getFilePath();if(v)return v;throw new Error((0,D.localize)(0,null,f))},g=()=>{const v=S();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,D.localize)(1,null,f,b.basename(v)))},a=()=>{if(E){const v=this._context.getFolderUri(E);if(v)return v;throw new Error((0,D.localize)(2,null,f,E))}if(l)return l;throw this._context.getWorkspaceFolderCount()>1?new Error((0,D.localize)(3,null,f)):new Error((0,D.localize)(4,null,f))};switch(m){case"env":if(E){if(C){const v=C[y.isWindows?E.toLowerCase():E];if(T.isString(v))return v}return""}throw new Error((0,D.localize)(5,null,f));case"config":if(E){const v=this._context.getConfigurationValue(l,E);if(T.isUndefinedOrNull(v))throw new Error((0,D.localize)(6,null,f,E));if(T.isObject(v))throw new Error((0,D.localize)(7,null,f,E));return v}throw new Error((0,D.localize)(8,null,f));case"command":return this.resolveFromMap(f,E,d,"command");case"input":return this.resolveFromMap(f,E,d,"input");default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.fsPath(a()));case"cwd":return l||E?(0,P.normalizeDriveLetter)(this.fsPath(a())):I.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return b.basename(this.fsPath(a()));case"lineNumber":const v=this._context.getLineNumber();if(v)return v;throw new Error((0,D.localize)(9,null,f));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,D.localize)(10,null,f));case"file":return S();case"fileWorkspaceFolder":return g();case"relativeFile":return l||E?b.relative(this.fsPath(a()),S()):S();case"relativeFileDirname":const n=b.dirname(S());if(l||E){const c=b.relative(this.fsPath(a()),n);return c.length===0?".":c}return n;case"fileDirname":return b.dirname(S());case"fileExtname":return b.extname(S());case"fileBasename":return b.basename(S());case"fileBasenameNoExtension":const o=b.basename(S());return o.slice(0,o.length-b.extname(o).length);case"fileDirnameBasename":return b.basename(b.dirname(S()));case"execPath":const r=this._context.getExecPath();return r||f;case"execInstallFolder":const s=this._context.getAppRoot();return s||f;case"pathSeparator":return b.sep;default:try{const c=E?`${m}:${E}`:m;return this.resolveFromMap(f,c,d,void 0)}catch(c){return f}}}}resolveFromMap(C,f,m,l){if(f&&m){const d=l===void 0?m[f]:m[l+":"+f];if(typeof d=="string")return d;throw new Error((0,D.localize)(11,null,C))}return C}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(me[213],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,b.createDecorator)("editorGroupsService");var I;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var T;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(T=e.GroupOrientation||(e.GroupOrientation={}));var A;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(A=e.GroupLocation||(e.GroupLocation={}));var y;(function(f){f[f.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",f[f.EVEN=1]="EVEN",f[f.TOGGLE=2]="TOGGLE"})(y=e.GroupsArrangement||(e.GroupsArrangement={}));var P;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(P=e.MergeGroupMode||(e.MergeGroupMode={}));var D;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(D=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(f){f[f.GROUP_ACTIVE=0]="GROUP_ACTIVE",f[f.GROUP_INDEX=1]="GROUP_INDEX",f[f.EDITOR_OPEN=2]="EDITOR_OPEN",f[f.EDITOR_CLOSE=3]="EDITOR_CLOSE",f[f.EDITOR_MOVE=4]="EDITOR_MOVE",f[f.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",f[f.EDITOR_LABEL=6]="EDITOR_LABEL",f[f.EDITOR_PIN=7]="EDITOR_PIN",f[f.EDITOR_STICKY=8]="EDITOR_STICKY",f[f.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(k=e.GroupChangeKind||(e.GroupChangeKind={}));var i;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(i=e.OpenEditorContext||(e.OpenEditorContext={}));function C(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=C}),define(me[214],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,b.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(me[20],ge([0,1,17,99,285,59,24,11,2,44,80,175,115,89,214,7]),function(G,e,b,I,T,A,y,P,D,k,i,C,f,m,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookKernelPreload=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookCellPreviousExecutionResult=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var E;(function(be){function he(J){const{selectionStartLineNumber:Ne,selectionStartColumn:Fe,positionLineNumber:Ye,positionColumn:et}=J,ut=new d.Position(Ne-1,Fe-1),ht=new d.Position(Ye-1,et-1);return new d.Selection(ut,ht)}be.to=he;function ae(J){const{anchor:Ne,active:Fe}=J;return{selectionStartLineNumber:Ne.line+1,selectionStartColumn:Ne.character+1,positionLineNumber:Fe.line+1,positionColumn:Fe.character+1}}be.from=ae})(E=e.Selection||(e.Selection={}));var w;(function(be){function he(J){if(!!J){const{start:Ne,end:Fe}=J;return{startLineNumber:Ne.line+1,startColumn:Ne.character+1,endLineNumber:Fe.line+1,endColumn:Fe.character+1}}}be.from=he;function ae(J){if(!!J){const{startLineNumber:Ne,startColumn:Fe,endLineNumber:Ye,endColumn:et}=J;return new d.Range(Ne-1,Fe-1,Ye-1,et-1)}}be.to=ae})(w=e.Range||(e.Range={}));var S;(function(be){function he(ae){switch(ae){case 1:return d.StandardTokenType.Comment;case 0:return d.StandardTokenType.Other;case 4:return d.StandardTokenType.RegEx;case 2:return d.StandardTokenType.String}}be.to=he})(S=e.TokenType||(e.TokenType={}));var g;(function(be){function he(J){return new d.Position(J.lineNumber-1,J.column-1)}be.to=he;function ae(J){return{lineNumber:J.line+1,column:J.character+1}}be.from=ae})(g=e.Position||(e.Position={}));var a;(function(be){function he(J){switch(J){case d.DiagnosticTag.Unnecessary:return 1;case d.DiagnosticTag.Deprecated:return 2}}be.from=he;function ae(J){switch(J){case 1:return d.DiagnosticTag.Unnecessary;case 2:return d.DiagnosticTag.Deprecated;default:return}}be.to=ae})(a=e.DiagnosticTag||(e.DiagnosticTag={}));var v;(function(be){function he(J){let Ne;return J.code&&((0,P.isString)(J.code)||(0,P.isNumber)(J.code)?Ne=String(J.code):Ne={value:String(J.code.value),target:J.code.target}),Object.assign(Object.assign({},w.from(J.range)),{message:J.message,source:J.source,code:Ne,severity:n.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(t.from),tags:Array.isArray(J.tags)?(0,b.coalesce)(J.tags.map(a.from)):void 0})}be.from=he;function ae(J){var Ne;const Fe=new d.Diagnostic(w.to(J),J.message,n.to(J.severity));return Fe.source=J.source,Fe.code=(0,P.isString)(J.code)?J.code:(Ne=J.code)===null||Ne===void 0?void 0:Ne.value,Fe.relatedInformation=J.relatedInformation&&J.relatedInformation.map(t.to),Fe.tags=J.tags&&(0,b.coalesce)(J.tags.map(a.to)),Fe}be.to=ae})(v=e.Diagnostic||(e.Diagnostic={}));var t;(function(be){function he(J){return Object.assign(Object.assign({},w.from(J.location.range)),{message:J.message,resource:J.location.uri})}be.from=he;function ae(J){return new d.DiagnosticRelatedInformation(new d.Location(J.resource,w.to(J)),J.message)}be.to=ae})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var n;(function(be){function he(J){switch(J){case d.DiagnosticSeverity.Error:return f.MarkerSeverity.Error;case d.DiagnosticSeverity.Warning:return f.MarkerSeverity.Warning;case d.DiagnosticSeverity.Information:return f.MarkerSeverity.Info;case d.DiagnosticSeverity.Hint:return f.MarkerSeverity.Hint}return f.MarkerSeverity.Error}be.from=he;function ae(J){switch(J){case f.MarkerSeverity.Info:return d.DiagnosticSeverity.Information;case f.MarkerSeverity.Warning:return d.DiagnosticSeverity.Warning;case f.MarkerSeverity.Error:return d.DiagnosticSeverity.Error;case f.MarkerSeverity.Hint:return d.DiagnosticSeverity.Hint;default:return d.DiagnosticSeverity.Error}}be.to=ae})(n=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var o;(function(be){function he(J){return typeof J=="number"&&J>=d.ViewColumn.One?J-1:J===d.ViewColumn.Beside?l.SIDE_GROUP:l.ACTIVE_GROUP}be.from=he;function ae(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}be.to=ae})(o=e.ViewColumn||(e.ViewColumn={}));function r(be){return typeof be.range!="undefined"}function s(be){return be.length===0?!0:!!r(be[0])}e.isDecorationOptionsArr=s;var c;(function(be){function he(et){return et.map(be.from)}be.fromMany=he;function ae(et){return et&&typeof et=="object"&&typeof et.language=="string"&&typeof et.value=="string"}function J(et){let ut;if(ae(et)){const{language:ft,value:lt}=et;ut={value:"```"+ft+`
`+lt+"\n```\n"}}else d.MarkdownString.isMarkdownString(et)?ut={value:et.value,isTrusted:et.isTrusted,supportThemeIcons:et.supportThemeIcons}:typeof et=="string"?ut={value:et}:ut={value:""};const ht=Object.create(null);ut.uris=ht;const Je=ft=>{try{let lt=D.URI.parse(ft,!0);lt=lt.with({query:Ne(lt.query,ht)}),ht[ft]=lt}catch(lt){}return""},at=new T.Renderer;return at.link=Je,at.image=ft=>Je(I.parseHrefAndDimensions(ft).href),T(ut.value,{renderer:at}),ut}be.from=J;function Ne(et,ut){if(!et)return et;let ht;try{ht=(0,A.parse)(et)}catch(at){}if(!ht)return et;let Je=!1;return ht=(0,y.cloneAndChange)(ht,at=>{if(D.URI.isUri(at)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[ft]=at,Je=!0,ft}else return}),Je?JSON.stringify(ht):et}function Fe(et){const ut=new d.MarkdownString(et.value,et.supportThemeIcons);return ut.isTrusted=et.isTrusted,ut}be.to=Fe;function Ye(et){if(!!et)return typeof et=="string"?et:be.from(et)}be.fromStrict=Ye})(c=e.MarkdownString||(e.MarkdownString={}));function h(be){return s(be)?be.map(he=>({range:w.from(he.range),hoverMessage:Array.isArray(he.hoverMessage)?c.fromMany(he.hoverMessage):he.hoverMessage?c.from(he.hoverMessage):void 0,renderOptions:he.renderOptions})):be.map(he=>({range:w.from(he)}))}e.fromRangeOrRangeWithMessage=h;function _(be){return typeof be=="undefined"?be:typeof be=="string"?D.URI.file(be):be}e.pathOrURIToURI=_;var u;(function(be){function he(ae){return typeof ae=="undefined"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?_(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}be.from=he})(u=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var p;(function(be){function he(ae){return typeof ae=="undefined"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?_(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?u.from(ae.before):void 0,after:ae.after?u.from(ae.after):void 0}}be.from=he})(p=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var R;(function(be){function he(ae){if(typeof ae=="undefined")return ae;switch(ae){case d.DecorationRangeBehavior.OpenOpen:return 0;case d.DecorationRangeBehavior.ClosedClosed:return 1;case d.DecorationRangeBehavior.OpenClosed:return 2;case d.DecorationRangeBehavior.ClosedOpen:return 3}}be.from=he})(R=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var O;(function(be){function he(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?R.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?p.from(ae.light):void 0,dark:ae.dark?p.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?_(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?u.from(ae.before):void 0,after:ae.after?u.from(ae.after):void 0}}be.from=he})(O=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var j;(function(be){function he(J){return{text:J.newText,eol:J.newEol&&ne.from(J.newEol),range:w.from(J.range)}}be.from=he;function ae(J){const Ne=new d.TextEdit(w.to(J.range),J.text);return Ne.newEol=typeof J.eol=="undefined"?void 0:ne.to(J.eol),Ne}be.to=ae})(j=e.TextEdit||(e.TextEdit={}));var ie;(function(be){function he(J,Ne,Fe){var Ye,et,ut;const ht={edits:[]};if(J instanceof d.WorkspaceEdit)for(let Je of J._allEntries())if(Je._type===1)ht.edits.push({_type:1,oldUri:Je.from,newUri:Je.to,options:Je.options,metadata:Je.metadata});else if(Je._type===2){const at=Ne==null?void 0:Ne.getDocument(Je.uri);ht.edits.push({_type:2,resource:Je.uri,edit:j.from(Je.edit),modelVersionId:at==null?void 0:at.version,metadata:Je.metadata})}else Je._type===3?ht.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,edit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:(Ye=Fe==null?void 0:Fe.lookupNotebookDocument(Je.uri))===null||Ye===void 0?void 0:Ye.apiNotebook.version}):Je._type===4?(Je.newOutputs&&ht.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,edit:{editType:2,index:Je.index,append:Je.append,outputs:Je.newOutputs.map(Ie.from)}}),Je.newMetadata&&ht.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,edit:{editType:8,index:Je.index,metadata:Je.newMetadata}})):Je._type===5?ht.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,notebookVersionId:(et=Fe==null?void 0:Fe.lookupNotebookDocument(Je.uri))===null||et===void 0?void 0:et.apiNotebook.version,edit:{editType:1,index:Je.index,count:Je.count,cells:Je.cells.map(Z.from)}}):Je._type===6&&ht.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,edit:{editType:7,outputId:Je.outputId,items:((ut=Je.newOutputItems)===null||ut===void 0?void 0:ut.map(ce.from))||[],append:Je.append}});return ht}be.from=he;function ae(J){const Ne=new d.WorkspaceEdit;for(const Fe of J.edits)Fe.edit?Ne.replace(D.URI.revive(Fe.resource),w.to(Fe.edit.range),Fe.edit.text):Ne.renameFile(D.URI.revive(Fe.oldUri),D.URI.revive(Fe.newUri),Fe.options);return Ne}be.to=ae})(ie=e.WorkspaceEdit||(e.WorkspaceEdit={}));var K;(function(be){const he=Object.create(null);he[d.SymbolKind.File]=0,he[d.SymbolKind.Module]=1,he[d.SymbolKind.Namespace]=2,he[d.SymbolKind.Package]=3,he[d.SymbolKind.Class]=4,he[d.SymbolKind.Method]=5,he[d.SymbolKind.Property]=6,he[d.SymbolKind.Field]=7,he[d.SymbolKind.Constructor]=8,he[d.SymbolKind.Enum]=9,he[d.SymbolKind.Interface]=10,he[d.SymbolKind.Function]=11,he[d.SymbolKind.Variable]=12,he[d.SymbolKind.Constant]=13,he[d.SymbolKind.String]=14,he[d.SymbolKind.Number]=15,he[d.SymbolKind.Boolean]=16,he[d.SymbolKind.Array]=17,he[d.SymbolKind.Object]=18,he[d.SymbolKind.Key]=19,he[d.SymbolKind.Null]=20,he[d.SymbolKind.EnumMember]=21,he[d.SymbolKind.Struct]=22,he[d.SymbolKind.Event]=23,he[d.SymbolKind.Operator]=24,he[d.SymbolKind.TypeParameter]=25;function ae(Ne){return typeof he[Ne]=="number"?he[Ne]:6}be.from=ae;function J(Ne){for(const Fe in he)if(he[Fe]===Ne)return Number(Fe);return d.SymbolKind.Property}be.to=J})(K=e.SymbolKind||(e.SymbolKind={}));var x;(function(be){function he(J){switch(J){case d.SymbolTag.Deprecated:return 1}}be.from=he;function ae(J){switch(J){case 1:return d.SymbolTag.Deprecated}}be.to=ae})(x=e.SymbolTag||(e.SymbolTag={}));var $;(function(be){function he(J){return{name:J.name,kind:K.from(J.kind),tags:J.tags&&J.tags.map(x.from),containerName:J.containerName,location:F.from(J.location)}}be.from=he;function ae(J){const Ne=new d.SymbolInformation(J.name,K.to(J.kind),J.containerName,F.to(J.location));return Ne.tags=J.tags&&J.tags.map(x.to),Ne}be.to=ae})($=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var U;(function(be){function he(J){var Ne,Fe;const Ye={name:J.name||"!!MISSING: name!!",detail:J.detail,range:w.from(J.range),selectionRange:w.from(J.selectionRange),kind:K.from(J.kind),tags:(Fe=(Ne=J.tags)===null||Ne===void 0?void 0:Ne.map(x.from))!==null&&Fe!==void 0?Fe:[]};return J.children&&(Ye.children=J.children.map(he)),Ye}be.from=he;function ae(J){const Ne=new d.DocumentSymbol(J.name,J.detail,K.to(J.kind),w.to(J.range),w.to(J.selectionRange));return(0,b.isNonEmptyArray)(J.tags)&&(Ne.tags=J.tags.map(x.to)),J.children&&(Ne.children=J.children.map(ae)),Ne}be.to=ae})(U=e.DocumentSymbol||(e.DocumentSymbol={}));var L;(function(be){function he(ae){const J=new d.CallHierarchyItem(K.to(ae.kind),ae.name,ae.detail||"",D.URI.revive(ae.uri),w.to(ae.range),w.to(ae.selectionRange));return J._sessionId=ae._sessionId,J._itemId=ae._itemId,J}be.to=he})(L=e.CallHierarchyItem||(e.CallHierarchyItem={}));var N;(function(be){function he(ae){return new d.CallHierarchyIncomingCall(L.to(ae.from),ae.fromRanges.map(J=>w.to(J)))}be.to=he})(N=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var M;(function(be){function he(ae){return new d.CallHierarchyOutgoingCall(L.to(ae.to),ae.fromRanges.map(J=>w.to(J)))}be.to=he})(M=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var F;(function(be){function he(J){return{range:J.range&&w.from(J.range),uri:J.uri}}be.from=he;function ae(J){return new d.Location(D.URI.revive(J.uri),w.to(J.range))}be.to=ae})(F=e.location||(e.location={}));var W;(function(be){function he(J){const Ne=J,Fe=J;return{originSelectionRange:Ne.originSelectionRange?w.from(Ne.originSelectionRange):void 0,uri:Ne.targetUri?Ne.targetUri:Fe.uri,range:w.from(Ne.targetRange?Ne.targetRange:Fe.range),targetSelectionRange:Ne.targetSelectionRange?w.from(Ne.targetSelectionRange):void 0}}be.from=he;function ae(J){return{targetUri:D.URI.revive(J.uri),targetRange:w.to(J.range),targetSelectionRange:J.targetSelectionRange?w.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?w.to(J.originSelectionRange):void 0}}be.to=ae})(W=e.DefinitionLink||(e.DefinitionLink={}));var q;(function(be){function he(J){return{range:w.from(J.range),contents:c.fromMany(J.contents)}}be.from=he;function ae(J){return new d.Hover(J.contents.map(c.to),w.to(J.range))}be.to=ae})(q=e.Hover||(e.Hover={}));var Q;(function(be){function he(J){return{range:w.from(J.range),expression:J.expression}}be.from=he;function ae(J){return new d.EvaluatableExpression(w.to(J.range),J.expression)}be.to=ae})(Q=e.EvaluatableExpression||(e.EvaluatableExpression={}));var le;(function(be){function he(J){if(J instanceof d.InlineValueText)return{type:"text",range:w.from(J.range),text:J.text};if(J instanceof d.InlineValueVariableLookup)return{type:"variable",range:w.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof d.InlineValueEvaluatableExpression)return{type:"expression",range:w.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}be.from=he;function ae(J){switch(J.type){case"text":return{range:w.to(J.range),text:J.text};case"variable":return{range:w.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:w.to(J.range),expression:J.expression}}}be.to=ae})(le=e.InlineValue||(e.InlineValue={}));var ve;(function(be){function he(J){return{frameId:J.frameId,stoppedLocation:w.from(J.stoppedLocation)}}be.from=he;function ae(J){return new d.InlineValueContext(J.frameId,w.to(J.stoppedLocation))}be.to=ae})(ve=e.InlineValueContext||(e.InlineValueContext={}));var Re;(function(be){function he(J){return{range:w.from(J.range),kind:J.kind}}be.from=he;function ae(J){return new d.DocumentHighlight(w.to(J.range),J.kind)}be.to=ae})(Re=e.DocumentHighlight||(e.DocumentHighlight={}));var Se;(function(be){function he(ae){switch(ae){case 1:return d.CompletionTriggerKind.TriggerCharacter;case 2:return d.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return d.CompletionTriggerKind.Invoke}}be.to=he})(Se=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Oe;(function(be){function he(ae){return{triggerKind:Se.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}be.to=he})(Oe=e.CompletionContext||(e.CompletionContext={}));var z;(function(be){function he(J){switch(J){case d.CompletionItemTag.Deprecated:return 1}}be.from=he;function ae(J){switch(J){case 1:return d.CompletionItemTag.Deprecated}}be.to=ae})(z=e.CompletionItemTag||(e.CompletionItemTag={}));var Y;(function(be){const he=new Map([[d.CompletionItemKind.Method,0],[d.CompletionItemKind.Function,1],[d.CompletionItemKind.Constructor,2],[d.CompletionItemKind.Field,3],[d.CompletionItemKind.Variable,4],[d.CompletionItemKind.Class,5],[d.CompletionItemKind.Interface,7],[d.CompletionItemKind.Struct,6],[d.CompletionItemKind.Module,8],[d.CompletionItemKind.Property,9],[d.CompletionItemKind.Unit,12],[d.CompletionItemKind.Value,13],[d.CompletionItemKind.Constant,14],[d.CompletionItemKind.Enum,15],[d.CompletionItemKind.EnumMember,16],[d.CompletionItemKind.Keyword,17],[d.CompletionItemKind.Snippet,27],[d.CompletionItemKind.Text,18],[d.CompletionItemKind.Color,19],[d.CompletionItemKind.File,20],[d.CompletionItemKind.Reference,21],[d.CompletionItemKind.Folder,23],[d.CompletionItemKind.Event,10],[d.CompletionItemKind.Operator,11],[d.CompletionItemKind.TypeParameter,24],[d.CompletionItemKind.Issue,26],[d.CompletionItemKind.User,25]]);function ae(Fe){var Ye;return(Ye=he.get(Fe))!==null&&Ye!==void 0?Ye:9}be.from=ae;const J=new Map([[0,d.CompletionItemKind.Method],[1,d.CompletionItemKind.Function],[2,d.CompletionItemKind.Constructor],[3,d.CompletionItemKind.Field],[4,d.CompletionItemKind.Variable],[5,d.CompletionItemKind.Class],[7,d.CompletionItemKind.Interface],[6,d.CompletionItemKind.Struct],[8,d.CompletionItemKind.Module],[9,d.CompletionItemKind.Property],[12,d.CompletionItemKind.Unit],[13,d.CompletionItemKind.Value],[14,d.CompletionItemKind.Constant],[15,d.CompletionItemKind.Enum],[16,d.CompletionItemKind.EnumMember],[17,d.CompletionItemKind.Keyword],[27,d.CompletionItemKind.Snippet],[18,d.CompletionItemKind.Text],[19,d.CompletionItemKind.Color],[20,d.CompletionItemKind.File],[21,d.CompletionItemKind.Reference],[23,d.CompletionItemKind.Folder],[10,d.CompletionItemKind.Event],[11,d.CompletionItemKind.Operator],[24,d.CompletionItemKind.TypeParameter],[25,d.CompletionItemKind.User],[26,d.CompletionItemKind.Issue]]);function Ne(Fe){var Ye;return(Ye=J.get(Fe))!==null&&Ye!==void 0?Ye:d.CompletionItemKind.Property}be.to=Ne})(Y=e.CompletionItemKind||(e.CompletionItemKind={}));var ee;(function(be){function he(ae,J){var Ne;const Fe=new d.CompletionItem(typeof ae.label=="string"?ae.label:ae.label.name);return typeof ae.label!="string"&&(Fe.label2=ae.label),Fe.insertText=ae.insertText,Fe.kind=Y.to(ae.kind),Fe.tags=(Ne=ae.tags)===null||Ne===void 0?void 0:Ne.map(z.to),Fe.detail=ae.detail,Fe.documentation=I.isMarkdownString(ae.documentation)?c.to(ae.documentation):ae.documentation,Fe.sortText=ae.sortText,Fe.filterText=ae.filterText,Fe.preselect=ae.preselect,Fe.commitCharacters=ae.commitCharacters,k.Range.isIRange(ae.range)?Fe.range=w.to(ae.range):typeof ae.range=="object"&&(Fe.range={inserting:w.to(ae.range.insert),replacing:w.to(ae.range.replace)}),Fe.keepWhitespace=typeof ae.insertTextRules=="undefined"?!1:Boolean(ae.insertTextRules&1),typeof ae.insertTextRules!="undefined"&&ae.insertTextRules&4?Fe.insertText=new d.SnippetString(ae.insertText):(Fe.insertText=ae.insertText,Fe.textEdit=Fe.range instanceof d.Range?new d.TextEdit(Fe.range,Fe.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(Fe.additionalTextEdits=ae.additionalTextEdits.map(Ye=>j.to(Ye))),Fe.command=J&&ae.command?J.fromInternal(ae.command):void 0,Fe}be.to=he})(ee=e.CompletionItem||(e.CompletionItem={}));var se;(function(be){function he(J){return{label:J.label,documentation:J.documentation?c.fromStrict(J.documentation):void 0}}be.from=he;function ae(J){return{label:J.label,documentation:I.isMarkdownString(J.documentation)?c.to(J.documentation):J.documentation}}be.to=ae})(se=e.ParameterInformation||(e.ParameterInformation={}));var fe;(function(be){function he(J){return{label:J.label,documentation:J.documentation?c.fromStrict(J.documentation):void 0,parameters:Array.isArray(J.parameters)?J.parameters.map(se.from):[],activeParameter:J.activeParameter}}be.from=he;function ae(J){return{label:J.label,documentation:I.isMarkdownString(J.documentation)?c.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(se.to):[],activeParameter:J.activeParameter}}be.to=ae})(fe=e.SignatureInformation||(e.SignatureInformation={}));var Ee;(function(be){function he(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(fe.from):[]}}be.from=he;function ae(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(fe.to):[]}}be.to=ae})(Ee=e.SignatureHelp||(e.SignatureHelp={}));var Be;(function(be){function he(J){var Ne;return{text:J.text,position:g.from(J.position),kind:pe.from((Ne=J.kind)!==null&&Ne!==void 0?Ne:d.InlayHintKind.Other),whitespaceBefore:J.whitespaceBefore,whitespaceAfter:J.whitespaceAfter}}be.from=he;function ae(J){const Ne=new d.InlayHint(J.text,g.to(J.position),pe.to(J.kind));return Ne.whitespaceAfter=J.whitespaceAfter,Ne.whitespaceBefore=J.whitespaceBefore,Ne}be.to=ae})(Be=e.InlayHint||(e.InlayHint={}));var pe;(function(be){function he(J){return J}be.from=he;function ae(J){return J}be.to=ae})(pe=e.InlayHintKind||(e.InlayHintKind={}));var Ce;(function(be){function he(J){return{range:w.from(J.range),url:J.target,tooltip:J.tooltip}}be.from=he;function ae(J){let Ne;if(J.url)try{Ne=typeof J.url=="string"?D.URI.parse(J.url,!0):D.URI.revive(J.url)}catch(Fe){}return new d.DocumentLink(w.to(J.range),Ne)}be.to=ae})(Ce=e.DocumentLink||(e.DocumentLink={}));var Me;(function(be){function he(J){const Ne=new d.ColorPresentation(J.label);return J.textEdit&&(Ne.textEdit=j.to(J.textEdit)),J.additionalTextEdits&&(Ne.additionalTextEdits=J.additionalTextEdits.map(Fe=>j.to(Fe))),Ne}be.to=he;function ae(J){return{label:J.label,textEdit:J.textEdit?j.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(Ne=>j.from(Ne)):void 0}}be.from=ae})(Me=e.ColorPresentation||(e.ColorPresentation={}));var ze;(function(be){function he(J){return new d.Color(J[0],J[1],J[2],J[3])}be.to=he;function ae(J){return[J.red,J.green,J.blue,J.alpha]}be.from=ae})(ze=e.Color||(e.Color={}));var _e;(function(be){function he(J){return{range:w.from(J.range)}}be.from=he;function ae(J){return new d.SelectionRange(w.to(J.range))}be.to=ae})(_e=e.SelectionRange||(e.SelectionRange={}));var Ke;(function(be){function he(ae){switch(ae){case 2:return d.TextDocumentSaveReason.AfterDelay;case 1:return d.TextDocumentSaveReason.Manual;case 3:case 4:return d.TextDocumentSaveReason.FocusOut}}be.to=he})(Ke=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var X;(function(be){function he(J){switch(J){case d.TextEditorLineNumbersStyle.Off:return 0;case d.TextEditorLineNumbersStyle.Relative:return 2;case d.TextEditorLineNumbersStyle.On:default:return 1}}be.from=he;function ae(J){switch(J){case 0:return d.TextEditorLineNumbersStyle.Off;case 2:return d.TextEditorLineNumbersStyle.Relative;case 1:default:return d.TextEditorLineNumbersStyle.On}}be.to=ae})(X=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ne;(function(be){function he(J){if(J===d.EndOfLine.CRLF)return 1;if(J===d.EndOfLine.LF)return 0}be.from=he;function ae(J){if(J===1)return d.EndOfLine.CRLF;if(J===0)return d.EndOfLine.LF}be.to=ae})(ne=e.EndOfLine||(e.EndOfLine={}));var we;(function(be){function he(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case d.ProgressLocation.SourceControl:return 3;case d.ProgressLocation.Window:return 10;case d.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}be.from=he})(we=e.ProgressLocation||(e.ProgressLocation={}));var xe;(function(be){function he(ae){const J={start:ae.start+1,end:ae.end+1};return ae.kind&&(J.kind=je.from(ae.kind)),J}be.from=he})(xe=e.FoldingRange||(e.FoldingRange={}));var je;(function(be){function he(ae){if(ae)switch(ae){case d.FoldingRangeKind.Comment:return i.FoldingRangeKind.Comment;case d.FoldingRangeKind.Imports:return i.FoldingRangeKind.Imports;case d.FoldingRangeKind.Region:return i.FoldingRangeKind.Region}}be.from=he})(je=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ve;(function(be){function he(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?w.from(ae.selection):void 0,override:typeof ae.override=="boolean"?C.EditorOverride.DISABLED:void 0}}be.from=he})(Ve=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ze;(function(be){function he(J){return J instanceof d.RelativePattern||typeof J=="string"?J:ae(J)?new d.RelativePattern(J.base,J.pattern):J}be.from=he;function ae(J){const Ne=J;return Ne&&typeof Ne.base=="string"&&typeof Ne.pattern=="string"}})(Ze=e.GlobPattern||(e.GlobPattern={}));var De;(function(be){function he(ae){if(ae){if(Array.isArray(ae))return ae.map(he);if(typeof ae=="string")return ae;{const J=ae;return{language:J.language,scheme:J.scheme,pattern:typeof J.pattern=="undefined"?void 0:Ze.from(J.pattern),exclusive:J.exclusive}}}else return}be.from=he})(De=e.LanguageSelector||(e.LanguageSelector={}));var ye;(function(be){function he(J){return{start:J.start,end:J.end}}be.from=he;function ae(J){return new d.NotebookRange(J.start,J.end)}be.to=ae})(ye=e.NotebookRange||(e.NotebookRange={}));var Pe;(function(be){function he(ae){return new d.NotebookCellMetadata().with(Object.assign(Object.assign({},ae),{executionOrder:null,lastRunSuccess:null,runState:null,runStartTime:null,runStartTimeAdjustment:null,runEndTime:null}))}be.to=he})(Pe=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var oe;(function(be){function he(J){return J}be.from=he;function ae(J){return new d.NotebookDocumentMetadata().with(J)}be.to=ae})(oe=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var ue;(function(be){function he(J){return{startTime:J.runStartTime,endTime:J.runEndTime,executionOrder:J.executionOrder,success:J.lastRunSuccess}}be.to=he;function ae(J){return{lastRunSuccess:J.success,runStartTime:J.startTime,runEndTime:J.endTime,executionOrder:J.executionOrder}}be.from=ae})(ue=e.NotebookCellPreviousExecutionResult||(e.NotebookCellPreviousExecutionResult={}));var H;(function(be){function he(J){switch(J){case d.NotebookCellKind.Markdown:return m.CellKind.Markdown;case d.NotebookCellKind.Code:default:return m.CellKind.Code}}be.from=he;function ae(J){switch(J){case m.CellKind.Markdown:return d.NotebookCellKind.Markdown;case m.CellKind.Code:default:return d.NotebookCellKind.Code}}be.to=ae})(H=e.NotebookCellKind||(e.NotebookCellKind={}));var Z;(function(be){function he(J){var Ne;return{cellKind:H.from(J.kind),language:J.language,source:J.source,metadata:Object.assign(Object.assign({},J.metadata),ue.from((Ne=J.latestExecutionSummary)!==null&&Ne!==void 0?Ne:{})),outputs:J.outputs?J.outputs.map(Ie.from):[]}}be.from=he;function ae(J){return new d.NotebookCellData(H.to(J.cellKind),J.source,J.language,J.outputs?J.outputs.map(Ie.to):void 0,J.metadata?Pe.to(J.metadata):void 0)}be.to=ae})(Z=e.NotebookCellData||(e.NotebookCellData={}));var ce;(function(be){function he(J){return{mime:J.mime,value:J.value,metadata:J.metadata}}be.from=he;function ae(J){return new d.NotebookCellOutputItem(J.mime,J.value,J.metadata)}be.to=ae})(ce=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ie;(function(be){function he(J){return{outputId:J.id,outputs:J.outputs.map(ce.from),metadata:J.metadata}}be.from=he;function ae(J){const Ne=J.outputs.map(ce.to);return new d.NotebookCellOutput(Ne,J.outputId,J.metadata)}be.to=ae})(Ie=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ae;(function(be){function he(Fe){if(Fe!=null){if(Fe instanceof d.RelativePattern||typeof Fe=="string")return Fe;if(Ne(Fe))return new d.RelativePattern(Fe.base,Fe.pattern);if(J(Fe))return{include:Ze.from(Fe.include)||void 0,exclude:Ze.from(Fe.exclude)||void 0}}}be.from=he;function ae(Fe){return typeof Fe=="string"?Fe:Ne(Fe)?{base:Fe.base,pattern:Fe.pattern}:{include:Fe.include,exclude:Fe.exclude}}be.to=ae;function J(Fe){const Ye=Fe,et=Ze.from(Ye.include);if(!(et&&et instanceof d.RelativePattern||typeof et=="string"))return!1;const ut=Ze.from(Ye.exclude);return!!(ut&&ut instanceof d.RelativePattern||typeof ut=="string")}function Ne(Fe){const Ye=Fe;return Ye&&typeof Ye.base=="string"&&typeof Ye.pattern=="string"}})(Ae=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Le;(function(be){function he(ae){return{backgroundColor:ae.backgroundColor,borderColor:ae.borderColor,top:ae.top?u.from(ae.top):void 0}}be.from=he})(Le=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var $e;(function(be){function he(ae,J,Ne){const Fe=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===d.NotebookCellStatusBarAlignment.Left?1:2,command:J.toInternal(Fe,Ne),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}be.from=he})($e=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Xe;(function(be){function he(ae){var J,Ne;return{transientOutputs:(J=ae==null?void 0:ae.transientOutputs)!==null&&J!==void 0?J:!1,transientCellMetadata:Object.assign(Object.assign({},ae==null?void 0:ae.transientCellMetadata),{executionOrder:!0,runState:!0,runStartTime:!0,runStartTimeAdjustment:!0,runEndTime:!0,lastRunSuccess:!0}),transientDocumentMetadata:(Ne=ae==null?void 0:ae.transientDocumentMetadata)!==null&&Ne!==void 0?Ne:{}}}be.from=he})(Xe=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var rt;(function(be){function he(J){var Ne;return{uri:J.uri,provides:typeof J.provides=="string"?[J.provides]:(Ne=J.provides)!==null&&Ne!==void 0?Ne:[]}}be.from=he;function ae(J){return new d.NotebookKernelPreload(D.URI.revive(J.uri),J.provides)}be.to=ae})(rt=e.NotebookKernelPreload||(e.NotebookKernelPreload={}));var tt;(function(be){function he(J){return{message:c.fromStrict(J.message)||"",severity:J.severity,expectedOutput:J.expectedOutput,actualOutput:J.actualOutput,location:J.location?F.from(J.location):void 0}}be.from=he;function ae(J){const Ne=new d.TestMessage(typeof J.message=="string"?J.message:c.to(J.message));return Ne.severity=J.severity,Ne.actualOutput=J.actualOutput,Ne.expectedOutput=J.expectedOutput,Ne}be.to=ae})(tt=e.TestMessage||(e.TestMessage={}));var Qe;(function(be){function he(Fe){var Ye,et;return{extId:Fe.id,label:Fe.label,uri:Fe.uri,range:w.from(Fe.range)||null,debuggable:(Ye=Fe.debuggable)!==null&&Ye!==void 0?Ye:!1,description:Fe.description||null,runnable:(et=Fe.runnable)!==null&&et!==void 0?et:!0,error:Fe.error&&c.fromStrict(Fe.error)||null}}be.from=he;function ae(Fe){return{extId:Fe.id,label:Fe.label,uri:Fe.uri,range:w.from(Fe.range)||null,debuggable:!1,description:Fe.description||null,error:null,runnable:!0}}be.fromResultSnapshot=ae;function J(Fe){return{id:Fe.extId,label:Fe.label,uri:D.URI.revive(Fe.uri),range:w.to(Fe.range||void 0),addChild:()=>{},dispose:()=>{},status:d.TestItemStatus.Pending,data:void 0,debuggable:Fe.debuggable,description:Fe.description||void 0,runnable:Fe.runnable}}be.toPlain=J;function Ne(Fe){const Ye=new d.TestItemImpl(Fe.extId,Fe.label,D.URI.revive(Fe.uri),void 0);return Ye.range=w.to(Fe.range||void 0),Ye.debuggable=Fe.debuggable,Ye.description=Fe.description||void 0,Ye.runnable=Fe.runnable,Ye}be.to=Ne})(Qe=e.TestItem||(e.TestItem={}));var mt;(function(be){const he=(J,Ne)=>Object.assign(Object.assign({},Qe.toPlain(J.item)),{taskStates:J.tasks.map(Fe=>({state:Fe.state,duration:Fe.duration,messages:Fe.messages.map(tt.to)})),children:J.children.map(Fe=>Ne.get(Fe)).filter(P.isDefined).map(Fe=>he(Fe,Ne))});function ae(J){const Ne=[],Fe=new Map;for(const Ye of J.items)Fe.set(Ye.item.extId,Ye),Ye.direct&&Ne.push(Ye);return{completedAt:J.completedAt,results:Ne.map(Ye=>he(Ye,Fe))}}be.to=ae})(mt=e.TestResults||(e.TestResults={}));var wt;(function(be){function he(ae){switch(ae){case 1:return d.CodeActionTriggerKind.Invoke;case 2:return d.CodeActionTriggerKind.Automatic}}be.to=he})(wt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(me[215],ge([0,1,2,16,7,20,57]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(k,i,C,f={timeout:1500,errors:3}){this._logService=k,this._documents=i,this._mainThreadBulkEdits=C,this._thresholds=f,this._callbacks=new y.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(i,C,f)=>{const l={dispose:this._callbacks.push([i,C,k])};return Array.isArray(f)&&f.push(l),l}}async $participateInSave(k,i){const C=b.URI.revive(k);let f=!1;const m=setTimeout(()=>f=!0,this._thresholds.timeout),l=[];try{for(let d of[...this._callbacks]){if(f)break;const E=this._documents.getDocument(C),w=await this._deliverEventAsyncAndBlameBadListeners(d,{document:E,reason:A.TextDocumentSaveReason.to(i)});l.push(w)}}finally{clearTimeout(m)}return l}_deliverEventAsyncAndBlameBadListeners([k,i,C],f){const m=this._badListeners.get(k);return typeof m=="number"&&m>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(C,k,i,f).then(()=>!0,l=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this._logService.error(l),!(l instanceof Error)||l.message!=="concurrent_edits"){const d=this._badListeners.get(k);this._badListeners.set(k,d?d+1:1),typeof d=="number"&&d>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,i,C,f){const m=[],l=Date.now(),{document:d,reason:E}=f,{version:w}=d,S=Object.freeze({document:d,reason:E,waitUntil(g){if(Object.isFrozen(m))throw(0,I.illegalState)("waitUntil can not be called async");m.push(Promise.resolve(g))}});try{i.apply(C,[S])}catch(g){return Promise.reject(g)}return Object.freeze(m),new Promise((g,a)=>{const v=setTimeout(()=>a(new Error("timeout")),this._thresholds.timeout);return Promise.all(m).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-l}ms`),clearTimeout(v),g(t)}).catch(t=>{clearTimeout(v),a(t)})}).then(g=>{const a={edits:[]};for(const v of g)if(Array.isArray(v)&&v.every(t=>t instanceof T.TextEdit))for(const{newText:t,newEol:n,range:o}of v)a.edits.push({_type:2,resource:d.uri,edit:{range:o&&A.Range.from(o),text:t,eol:n&&A.EndOfLine.from(n)}});if(a.edits.length!==0)return w===d.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(a):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(me[216],ge([0,1,3,13,33,2,20,7]),function(G,e,b,I,T,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{constructor(C,f,m,l,d){this._onDidCreate=new b.Emitter,this._onDidChange=new b.Emitter,this._onDidDelete=new b.Emitter,this._config=0,m&&(this._config+=1),l&&(this._config+=2),d&&(this._config+=4);const E=(0,T.parse)(f),w=C(S=>{if(!m)for(let g of S.created){const a=A.URI.revive(g);E(a.fsPath)&&this._onDidCreate.fire(a)}if(!l)for(let g of S.changed){const a=A.URI.revive(g);E(a.fsPath)&&this._onDidChange.fire(a)}if(!d)for(let g of S.deleted){const a=A.URI.revive(g);E(a.fsPath)&&this._onDidDelete.fire(a)}});this._disposable=P.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,w)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class k{constructor(C,f,m){this._logService=f,this._extHostDocumentsAndEditors=m,this._onFileSystemEvent=new b.Emitter,this._onDidRenameFile=new b.Emitter,this._onDidCreateFile=new b.Emitter,this._onDidDeleteFile=new b.Emitter,this._onWillRenameFile=new I.AsyncEmitter,this._onWillCreateFile=new I.AsyncEmitter,this._onWillDeleteFile=new I.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(C,f,m,l){return new D(this._onFileSystemEvent.event,C,f,m,l)}$onFileEvent(C){this._onFileSystemEvent.fire(C)}$onDidRunFileOperation(C,f){switch(C){case 2:this._onDidRenameFile.fire(Object.freeze({files:f.map(m=>({oldUri:A.URI.revive(m.source),newUri:A.URI.revive(m.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:f.map(m=>A.URI.revive(m.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:f.map(m=>A.URI.revive(m.target))}));break;default:}}getOnWillRenameFileEvent(C){return this._createWillExecuteEvent(C,this._onWillRenameFile)}getOnWillCreateFileEvent(C){return this._createWillExecuteEvent(C,this._onWillCreateFile)}getOnWillDeleteFileEvent(C){return this._createWillExecuteEvent(C,this._onWillDeleteFile)}_createWillExecuteEvent(C,f){return(m,l,d)=>{const E=function(S){m.call(l,S)};return E.extension=C,f.event(E,void 0,d)}}async $onWillRunFileOperation(C,f,m,l){switch(C){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:f.map(d=>({oldUri:A.URI.revive(d.source),newUri:A.URI.revive(d.target)}))},m,l);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:f.map(d=>A.URI.revive(d.target))},m,l);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:f.map(d=>A.URI.revive(d.target))},m,l)}}async _fireWillEvent(C,f,m,l){const d=new Set,E=[];if(await C.fireAsync(f,l,async(S,g)=>{var a;const v=Date.now(),t=await Promise.resolve(S);t instanceof P.WorkspaceEdit&&(E.push(t),d.add((a=g.extension.displayName)!==null&&a!==void 0?a:g.extension.identifier.value)),Date.now()-v>m&&this._logService.warn("SLOW file-participant",g.extension.identifier)}),!l.isCancellationRequested&&E.length!==0){const w={edits:[]};for(let S of E){let{edits:g}=y.WorkspaceEdit.from(S,this._extHostDocumentsAndEditors);w.edits=w.edits.concat(g)}return{edit:w,extensionNames:Array.from(d)}}}}e.ExtHostFileSystemEventService=k}),define(me[217],ge([0,1,12,24,2,20,7,89]),function(G,e,b,I,T,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(f,m,l,d){this.start=f,this.deletedCount=m,this.deletedItems=l,this.items=d}static asApiEvents(f){return f.map(m=>({start:m.start,deletedCount:m.deletedCount,deletedItems:m.deletedItems,items:m.items.map(l=>l.apiCell)}))}}class k{constructor(f,m,l){var d;this._notebook=f,this._extHostDocument=m,this._cellData=l,this.handle=l.handle,this.uri=T.URI.revive(l.uri),this.cellKind=l.cellKind,this._outputs=l.outputs.map(A.NotebookCellOutput.to),this._internalMetadata=(d=l.metadata)!==null&&d!==void 0?d:{},this._metadata=A.NotebookCellMetadata.to(this._internalMetadata),this._previousResult=A.NotebookCellPreviousExecutionResult.to(this._internalMetadata)}static asModelAddData(f,m){return{EOL:m.eol,lines:m.source,modeId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:f}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._cell){const f=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._cell=Object.freeze({get index(){return f._notebook.getCellIndex(f)},notebook:f._notebook.apiNotebook,kind:A.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get outputs(){return f._outputs.slice(0)},get metadata(){return f._metadata},get latestExecutionSummary(){return f._previousResult}})}return this._cell}setOutputs(f){this._outputs=f.map(A.NotebookCellOutput.to)}setOutputItems(f,m,l){const d=l.map(A.NotebookCellOutputItem.to),E=this._outputs.find(w=>w.id===f);E&&(m||(E.outputs.length=0),E.outputs.push(...d))}setMetadata(f){this._internalMetadata=f,this._metadata=A.NotebookCellMetadata.to(f),this._previousResult=A.NotebookCellPreviousExecutionResult.to(f)}}e.ExtHostCell=k;class i{constructor(f,m,l,d,E,w,S){this._proxy=f,this._textDocumentsAndEditors=m,this._textDocuments=l,this._emitter=d,this._viewType=E,this._metadata=w,this.uri=S,this.handle=i._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const f=this;this._notebook={get uri(){return f.uri},get version(){return f._versionId},get viewType(){return f._viewType},get isDirty(){return f._isDirty},get isUntitled(){return f.uri.scheme===b.Schemas.untitled},get isClosed(){return f._disposed},get metadata(){return f._metadata},get cellCount(){return f._cells.length},cellAt(m){return m=f._validateIndex(m),f._cells[m].apiCell},getCells(m){return(m?f._getCells(m):f._cells).map(d=>d.apiCell)},save(){return f._save()}}}return this._notebook}updateBackup(f){var m;(m=this._backup)===null||m===void 0||m.delete(),this._backup=f}disposeBackup(){var f;(f=this._backup)===null||f===void 0||f.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(f){f.metadata&&(this._metadata=this._metadata.with(f.metadata))}acceptModelChanged(f,m){this._versionId=f.versionId,this._isDirty=m;for(const l of f.rawEvents)l.kind===P.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(l.changes,!0),l.kind===P.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(l.changes,!1):l.kind===P.NotebookCellsChangeType.Move?this._moveCell(l.index,l.newIdx):l.kind===P.NotebookCellsChangeType.Output?this._setCellOutputs(l.index,l.outputs):l.kind===P.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(l.index,l.outputId,l.append,l.outputItems):l.kind===P.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(l.index,l.language):l.kind===P.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(l.index,l.metadata)}_validateIndex(f){return f=f|0,f<0?0:f>=this._cells.length?this._cells.length-1:f}_validateRange(f){let m=f.start|0,l=f.end|0;return m<0&&(m=0),l>this._cells.length&&(l=this._cells.length),f.with({start:m,end:l})}_getCells(f){f=this._validateRange(f);const m=[];for(let l=f.start;l<f.end;l++)m.push(this._cells[l]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(f,m){if(!this._disposed){const l=[],d=[],E=[];f.reverse().forEach(w=>{const g=w[2].map(t=>{const n=new k(this,this._textDocumentsAndEditors,t);return m||d.push(k.asModelAddData(this.apiNotebook,t)),n}),a=new D(w[0],w[1],[],g),v=this._cells.splice(w[0],w[1],...g);for(let t of v)E.push(t.uri),a.deletedItems.push(t.apiCell);l.push(a)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:E}),m||this._emitter.emitModelChange((0,I.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(l)}))}}_moveCell(f,m){const l=this._cells.splice(f,1);this._cells.splice(m,0,...l);const d=[new D(f,1,l.map(E=>E.apiCell),[]),new D(m,0,[],l)];this._emitter.emitModelChange((0,I.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(d)}))}_setCellOutputs(f,m){const l=this._cells[f];l.setOutputs(m),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.apiNotebook,cells:[l.apiCell]}))}_setCellOutputItems(f,m,l,d){const E=this._cells[f];E.setOutputItems(m,l,d),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.apiNotebook,cells:[E.apiCell]}))}_changeCellLanguage(f,m){const l=this._cells[f];l.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelModeChanged(l.uri,m)}_changeCellMetadata(f,m){var l;const d=this._cells[f],E=d.internalMetadata,w=d.apiCell.metadata;d.setMetadata(m);const S=d.apiCell.metadata;if((0,I.equals)(w,S)||this._emitter.emitCellMetadataChange((0,I.deepFreeze)({document:this.apiNotebook,cell:d.apiCell})),E.runState!==m.runState){const g=(l=m.runState)!==null&&l!==void 0?l:y.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,I.deepFreeze)({document:this.apiNotebook,cell:d.apiCell,executionState:g}))}}getCellFromIndex(f){return this._cells[f]}getCell(f){return this._cells.find(m=>m.handle===f)}getCellIndex(f){return this._cells.indexOf(f)}}e.ExtHostNotebookDocument=i,i._handlePool=0}),define(me[218],ge([0,1,7,20]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class T{constructor(P){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=P}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(P){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:P})}replaceCellMetadata(P,D){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:P,metadata:D})}replaceCells(P,D,k){this._throwIfFinalized(),!(P===D&&k.length===0)&&this._collectedEdits.push({editType:1,index:P,count:D-P,cells:k.map(I.NotebookCellData.from)})}}class A{constructor(P,D,k,i,C,f){this.id=P,this._proxy=D,this.notebookData=k,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=C,this._visibleRanges=i,this._viewColumn=f}get apiEditor(){if(!this._editor){const P=this;this._editor={get document(){return P.notebookData.apiNotebook},get selections(){return P._selections},get visibleRanges(){return P._visibleRanges},revealRange(D,k){P._proxy.$tryRevealRange(P.id,I.NotebookRange.from(D),k!=null?k:b.NotebookEditorRevealType.Default)},get viewColumn(){return P._viewColumn},edit(D){const k=new T(this.document.version);return D(k),P._applyEdit(k.finalize())},setDecorations(D,k){return P.setDecorations(D,k)}}}return this._editor}get visible(){return this._visible}_acceptVisibility(P){this._visible=P}_acceptVisibleRanges(P){this._visibleRanges=P}_acceptSelections(P){this._selections=P}_acceptViewColumn(P){this._viewColumn=P}_applyEdit(P){if(P.cellEdits.length===0)return Promise.resolve(!0);const D=[];let k=-1;for(let i=0;i<P.cellEdits.length;i++){if(k<0){D.push(P.cellEdits[i]),k++;continue}const f=D[k],m=P.cellEdits[i];if(f.editType===1&&m.editType===1&&f.index===m.index){f.cells.push(...P.cellEdits[i].cells),f.count+=P.cellEdits[i].count;continue}D.push(P.cellEdits[i]),k++}return this._proxy.$tryApplyEdits(this.id,P.documentVersionId,D)}setDecorations(P,D){if(!(D.isEmpty&&!this._hasDecorationsForKey.has(P.key)))return D.isEmpty?this._hasDecorationsForKey.delete(P.key):this._hasDecorationsForKey.add(P.key),this._proxy.$trySetDecorations(this.id,I.NotebookRange.from(D),P.key)}}e.ExtHostNotebookEditor=A}),define(me[219],ge([0,1,20,116,163,21,54]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class P{constructor(C){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=C}withProgress(C,f,m){const l=this._handles++,{title:d,location:E,cancellable:w}=f,S={label:(0,T.localize)(0,null,C.displayName||C.name),id:C.identifier.value};return this._proxy.$startProgress(l,{location:b.ProgressLocation.from(E),title:d,source:S,cancellable:w},C),this._withProgress(l,m,!!w)}_withProgress(C,f,m){let l;m&&(l=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(C,l));const d=w=>{this._proxy.$progressEnd(w),this._mapHandleToCancellationSource.delete(w),l&&l.dispose()};let E;try{E=f(new k(this._proxy,C),m&&l?l.token:A.CancellationToken.None)}catch(w){throw d(C),w}return E.then(w=>d(C),w=>d(C)),E}$acceptProgressCanceled(C){const f=this._mapHandleToCancellationSource.get(C);f&&(f.cancel(),this._mapHandleToCancellationSource.delete(C))}}e.ExtHostProgress=P;function D(i,C){return i.message=C.message,typeof C.increment=="number"&&(typeof i.increment=="number"?i.increment+=C.increment:i.increment=C.increment),i}class k extends I.Progress{constructor(C,f){super(m=>this.throttledReport(m));this._proxy=C,this._handle=f}throttledReport(C){this._proxy.$progressReport(this._handle,C)}}qe([(0,y.throttle)(100,(i,C)=>D(i,C),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(me[125],ge([0,1,52,16,72,20,7]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class P{constructor(f,m){const l=P._Keys.nextId();f.$registerTextEditorDecorationType(l,A.DecorationRenderOptions.from(m)),this.value=Object.freeze({key:l,dispose(){f.$removeTextEditorDecorationType(l)}})}}e.TextEditorDecorationType=P,P._Keys=new T.IdGenerator("TextEditorDecorationType");class D{constructor(f,m){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=f,this._documentVersionId=f.version,this._undoStopBefore=m.undoStopBefore,this._undoStopAfter=m.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(f,m){this._throwIfFinalized();let l=null;if(f instanceof y.Position)l=new y.Range(f,f);else if(f instanceof y.Range)l=f;else throw new Error("Unrecognized location");this._pushEdit(l,m,!1)}insert(f,m){this._throwIfFinalized(),this._pushEdit(new y.Range(f,f),m,!0)}delete(f){this._throwIfFinalized();let m=null;if(f instanceof y.Range)m=f;else throw new Error("Unrecognized location");this._pushEdit(m,null,!0)}_pushEdit(f,m,l){const d=this._document.validateRange(f);this._collectedEdits.push({range:d,text:m,forceMoveMarkers:l})}setEndOfLine(f){if(this._throwIfFinalized(),f!==y.EndOfLine.LF&&f!==y.EndOfLine.CRLF)throw(0,I.illegalArgument)("endOfLine");this._setEndOfLine=f}}e.TextEditorEdit=D;class k{constructor(f,m,l,d){this._proxy=f,this._id=m,this._accept(l),this._logService=d;const E=this;this.value={get tabSize(){return E._tabSize},set tabSize(w){E._setTabSize(w)},get insertSpaces(){return E._insertSpaces},set insertSpaces(w){E._setInsertSpaces(w)},get cursorStyle(){return E._cursorStyle},set cursorStyle(w){E._setCursorStyle(w)},get lineNumbers(){return E._lineNumbers},set lineNumbers(w){E._setLineNumbers(w)}}}_accept(f){this._tabSize=f.tabSize,this._insertSpaces=f.insertSpaces,this._cursorStyle=f.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(f.lineNumbers)}_validateTabSize(f){if(f==="auto")return"auto";if(typeof f=="number"){const m=Math.floor(f);return m>0?m:null}if(typeof f=="string"){const m=parseInt(f,10);return isNaN(m)?null:m>0?m:null}return null}_setTabSize(f){const m=this._validateTabSize(f);if(m!==null){if(typeof m=="number"){if(this._tabSize===m)return;this._tabSize=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:m}))}}_validateInsertSpaces(f){return f==="auto"?"auto":f==="false"?!1:Boolean(f)}_setInsertSpaces(f){const m=this._validateInsertSpaces(f);if(typeof m=="boolean"){if(this._insertSpaces===m)return;this._insertSpaces=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:m}))}_setCursorStyle(f){this._cursorStyle!==f&&(this._cursorStyle=f,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:f})))}_setLineNumbers(f){this._lineNumbers!==f&&(this._lineNumbers=f,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(f)})))}assign(f){const m={};let l=!1;if(typeof f.tabSize!="undefined"){const d=this._validateTabSize(f.tabSize);d==="auto"?(l=!0,m.tabSize=d):typeof d=="number"&&this._tabSize!==d&&(this._tabSize=d,l=!0,m.tabSize=d)}if(typeof f.insertSpaces!="undefined"){const d=this._validateInsertSpaces(f.insertSpaces);d==="auto"?(l=!0,m.insertSpaces=d):this._insertSpaces!==d&&(this._insertSpaces=d,l=!0,m.insertSpaces=d)}typeof f.cursorStyle!="undefined"&&this._cursorStyle!==f.cursorStyle&&(this._cursorStyle=f.cursorStyle,l=!0,m.cursorStyle=f.cursorStyle),typeof f.lineNumbers!="undefined"&&this._lineNumbers!==f.lineNumbers&&(this._lineNumbers=f.lineNumbers,l=!0,m.lineNumbers=A.TextEditorLineNumbersStyle.from(f.lineNumbers)),l&&this._warnOnError(this._proxy.$trySetOptions(this._id,m))}_warnOnError(f){f.catch(m=>this._logService.warn(m))}}e.ExtHostTextEditorOptions=k;class i{constructor(f,m,l,d,E,w,S,g){this.id=f,this._proxy=m,this._logService=l,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=E,this._options=new k(this._proxy,this.id,w,l),this._visibleRanges=S,this._viewColumn=g;const a=this;this.value=Object.freeze({get document(){return d.getValue()},set document(v){throw(0,I.readonly)("document")},get selection(){return a._selections&&a._selections[0]},set selection(v){if(!(v instanceof y.Selection))throw(0,I.illegalArgument)("selection");a._selections=[v],a._trySetSelection()},get selections(){return a._selections},set selections(v){if(!Array.isArray(v)||v.some(t=>!(t instanceof y.Selection)))throw(0,I.illegalArgument)("selections");a._selections=v,a._trySetSelection()},get visibleRanges(){return a._visibleRanges},set visibleRanges(v){throw(0,I.readonly)("visibleRanges")},get options(){return a._options.value},set options(v){a._disposed||a._options.assign(v)},get viewColumn(){return a._viewColumn},set viewColumn(v){throw(0,I.readonly)("viewColumn")},edit(v,t={undoStopBefore:!0,undoStopAfter:!0}){if(a._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new D(d.getValue(),t);return v(n),a._applyEdit(n)},insertSnippet(v,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(a._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!t||Array.isArray(t)&&t.length===0)o=a._selections.map(r=>A.Range.from(r));else if(t instanceof y.Position){const{lineNumber:r,column:s}=A.Position.from(t);o=[{startLineNumber:r,startColumn:s,endLineNumber:r,endColumn:s}]}else if(t instanceof y.Range)o=[A.Range.from(t)];else{o=[];for(const r of t)if(r instanceof y.Range)o.push(A.Range.from(r));else{const{lineNumber:s,column:c}=A.Position.from(r);o.push({startLineNumber:s,startColumn:c,endLineNumber:s,endColumn:c})}}return m.$tryInsertSnippet(f,v.value,o,n)},setDecorations(v,t){const n=t.length===0;n&&!a._hasDecorationsForKey.has(v.key)||(n?a._hasDecorationsForKey.delete(v.key):a._hasDecorationsForKey.add(v.key),a._runOnProxy(()=>{if(A.isDecorationOptionsArr(t))return m.$trySetDecorations(f,v.key,A.fromRangeOrRangeWithMessage(t));{const o=new Array(4*t.length);for(let r=0,s=t.length;r<s;r++){const c=t[r];o[4*r]=c.start.line+1,o[4*r+1]=c.start.character+1,o[4*r+2]=c.end.line+1,o[4*r+3]=c.end.character+1}return m.$trySetDecorationsFast(f,v.key,o)}}))},revealRange(v,t){a._runOnProxy(()=>m.$tryRevealRange(f,A.Range.from(v),t||y.TextEditorRevealType.Default))},show(v){m.$tryShowEditor(f,A.ViewColumn.from(v))},hide(){m.$tryHideEditor(f)}})}dispose(){(0,b.ok)(!this._disposed),this._disposed=!0}_acceptOptions(f){(0,b.ok)(!this._disposed),this._options._accept(f)}_acceptVisibleRanges(f){(0,b.ok)(!this._disposed),this._visibleRanges=f}_acceptViewColumn(f){(0,b.ok)(!this._disposed),this._viewColumn=f}_acceptSelections(f){(0,b.ok)(!this._disposed),this._selections=f}async _trySetSelection(){const f=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,f)),this.value}_applyEdit(f){const m=f.finalize();if(m.edits.length===0&&!m.setEndOfLine)return Promise.resolve(!0);const l=m.edits.map(E=>E.range);l.sort((E,w)=>E.end.line===w.end.line?E.end.character===w.end.character?E.start.line===w.start.line?E.start.character-w.start.character:E.start.line-w.start.line:E.end.character-w.end.character:E.end.line-w.end.line);for(let E=0,w=l.length-1;E<w;E++){const S=l[E].end;if(l[E+1].start.isBefore(S))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=m.edits.map(E=>({range:A.Range.from(E.range),text:E.text,forceMoveMarkers:E.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,m.documentVersionId,d,{setEndOfLine:typeof m.setEndOfLine=="number"?A.EndOfLine.from(m.setEndOfLine):void 0,undoStopBefore:m.undoStopBefore,undoStopAfter:m.undoStopAfter})}_runOnProxy(f){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):f().then(()=>this,m=>(m instanceof Error&&m.name==="DISPOSED"||this._logService.warn(m),null))}}e.ExtHostTextEditor=i}),define(me[220],ge([0,1,166,25,2,3,6,13,7,11,17,20,21]),function(G,e,b,I,T,A,y,P,D,k,i,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function m(E,w){if((0,k.isString)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let S;return Array.isArray(E.highlights)&&(S=E.highlights.filter(g=>g.length===2&&typeof g[0]=="number"&&typeof g[1]=="number"),S=S.length?S:void 0),{label:E.label,highlights:S}}}class l{constructor(w,S,g){this._proxy=w,this.commands=S,this.logService=g,this.treeViews=new Map;function a(v){return v&&v.$treeViewId&&v.$treeItemHandle}S.registerArgumentProcessor({processArgument:v=>a(v)?this.convertArgument(v):Array.isArray(v)&&v.length>0?v.map(t=>a(t)?this.convertArgument(t):t):v})}registerTreeDataProvider(w,S,g){const a=this.createTreeView(w,{treeDataProvider:S},g);return{dispose:()=>a.dispose()}}createTreeView(w,S,g){if(!S||!S.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=this._proxy.$registerTreeViewDataProvider(w,{showCollapseAll:!!S.showCollapseAll,canSelectMany:!!S.canSelectMany,canDragAndDrop:!!S.canDragAndDrop}),v=this.createExtHostTreeView(w,S,g);return{get onDidCollapseElement(){return v.onDidCollapseElement},get onDidExpandElement(){return v.onDidExpandElement},get selection(){return v.selectedElements},get onDidChangeSelection(){return v.onDidChangeSelection},get visible(){return v.visible},get onDidChangeVisibility(){return v.onDidChangeVisibility},get message(){return v.message},set message(t){v.message=t},get title(){return v.title},set title(t){v.title=t},get description(){return v.description},set description(t){v.description=t},reveal:(t,n)=>v.reveal(t,n),dispose:async()=>{await a,this.treeViews.delete(w),v.dispose()}}}$getChildren(w,S){const g=this.treeViews.get(w);return g?g.getChildren(S):Promise.reject(new Error((0,b.localize)(0,null,w)))}$setParent(w,S,g){const a=this.treeViews.get(w);return a?a.setParent(S,g):Promise.reject(new Error((0,b.localize)(1,null,w)))}async $hasResolve(w){const S=this.treeViews.get(w);if(!S)throw new Error((0,b.localize)(2,null,w));return S.hasResolve}$resolve(w,S,g){const a=this.treeViews.get(w);if(!a)throw new Error((0,b.localize)(3,null,w));return a.resolveTreeItem(S,g)}$setExpanded(w,S,g){const a=this.treeViews.get(w);if(!a)throw new Error((0,b.localize)(4,null,w));a.setExpanded(S,g)}$setSelection(w,S){const g=this.treeViews.get(w);if(!g)throw new Error((0,b.localize)(5,null,w));g.setSelection(S)}$setVisible(w,S){const g=this.treeViews.get(w);if(!g)throw new Error((0,b.localize)(6,null,w));g.setVisible(S)}createExtHostTreeView(w,S,g){const a=new d(w,S,this._proxy,this.commands.converter,this.logService,g);return this.treeViews.set(w,a),a}convertArgument(w){const S=this.treeViews.get(w.$treeViewId);return S?S.getExtensionElement(w.$treeItemHandle):null}}e.ExtHostTreeViews=l;class d extends y.Disposable{constructor(w,S,g,a,v,t){super();if(this.viewId=w,this.proxy=g,this.commands=a,this.logService=v,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new f.CancellationTokenSource,t.contributes&&t.contributes.views)for(const r in t.contributes.views)for(const s of t.contributes.views[r])s.id===w&&(this._title=s.name);this.dataProvider=S.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(r=>this._onDidChangeData.fire({message:!1,element:r})));let n,o;this._register(A.Event.debounce(this._onDidChangeData.event,(r,s)=>(r||(r={message:!1,elements:[]}),s.element!==!1&&(n||(n=new Promise(c=>o=c),this.refreshPromise=this.refreshPromise.then(()=>n)),r.elements.push(s.element)),s.message&&(r.message=!0),r),200,!0)(({message:r,elements:s})=>{s.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const c=o;return n=null,this.refresh(s).then(()=>c())})),r&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(w=>this.getExtensionElement(w)).filter(w=>!(0,k.isUndefinedOrNull)(w))}getChildren(w){const S=w?this.getExtensionElement(w):void 0;if(w&&!S)return this.logService.error(`No tree item with id '${w}' found.`),Promise.resolve([]);const g=this.getChildrenNodes(w);return(g?Promise.resolve(g):this.fetchChildrenNodes(S)).then(a=>a.map(v=>v.item))}getExtensionElement(w){return this.elements.get(w)}reveal(w,S){S=S||{select:!0,focus:!1};const g=(0,k.isUndefinedOrNull)(S.select)?!0:S.select,a=(0,k.isUndefinedOrNull)(S.focus)?!1:S.focus,v=(0,k.isUndefinedOrNull)(S.expand)?!1:S.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):w?this.refreshPromise.then(()=>this.resolveUnknownParentChain(w)).then(t=>this.resolveTreeNode(w,t[t.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:t.map(o=>o.item)},{select:g,focus:a,expand:v})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:g,focus:a,expand:v})}get message(){return this._message}set message(w){this._message=w,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(w){this._title=w,this.proxy.$setTitle(this.viewId,w,this._description)}get description(){return this._description}set description(w){this._description=w,this.proxy.$setTitle(this.viewId,this._title,w)}setExpanded(w,S){const g=this.getExtensionElement(w);g&&(S?this._onDidExpandElement.fire(Object.freeze({element:g})):this._onDidCollapseElement.fire(Object.freeze({element:g})))}setSelection(w){(0,i.equals)(this._selectedHandles,w)||(this._selectedHandles=w,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(w){w!==this._visible&&(this._visible=w,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}setParent(w,S){const g=w.map(v=>this.getExtensionElement(v)).filter(v=>!(0,k.isUndefinedOrNull)(v)),a=this.getExtensionElement(S);return this.dataProvider.setParent&&g&&a?(0,P.asPromise)(()=>this.dataProvider.setParent(g,a)):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(w,S){var g;if(!!this.dataProvider.resolveTreeItem){const a=this.elements.get(w);if(a){const v=this.nodes.get(a);if(v){const t=(g=await this.dataProvider.resolveTreeItem(v.extensionItem,a,S))!==null&&g!==void 0?g:v.extensionItem;return v.item.tooltip=this.getTooltip(t.tooltip),v.item.command=this.getCommand(v.disposableStore,t.command),v.item}}}}resolveUnknownParentChain(w){return this.resolveParent(w).then(S=>S?this.resolveUnknownParentChain(S).then(g=>this.resolveTreeNode(S,g[g.length-1]).then(a=>(g.push(a),g))):Promise.resolve([]))}resolveParent(w){const S=this.nodes.get(w);return S?Promise.resolve(S.parent?this.elements.get(S.parent.item.handle):void 0):(0,P.asPromise)(()=>this.dataProvider.getParent(w))}resolveTreeNode(w,S){const g=this.nodes.get(w);return g?Promise.resolve(g):(0,P.asPromise)(()=>this.dataProvider.getTreeItem(w)).then(a=>this.createHandle(w,a,S,!0)).then(a=>this.getChildren(S?S.item.handle:void 0).then(()=>{const v=this.getExtensionElement(a);if(v){const t=this.nodes.get(v);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${a}`)}))}getChildrenNodes(w){if(w){let S;if(typeof w=="string"){const g=this.getExtensionElement(w);S=g?this.nodes.get(g):void 0}else S=w;return S&&S.children||null}return this.roots}async fetchChildrenNodes(w){this.clearChildren(w);const S=new f.CancellationTokenSource(this._refreshCancellationSource.token);try{const g=w?this.nodes.get(w):void 0,a=await this.dataProvider.getChildren(w);if(S.token.isCancellationRequested)return[];const v=await Promise.all((0,i.coalesce)(a||[]).map(async t=>{const n=await this.dataProvider.getTreeItem(t);return n&&!S.token.isCancellationRequested?this.createAndRegisterTreeNode(t,n,g):null}));return S.token.isCancellationRequested?[]:(0,i.coalesce)(v)}finally{S.dispose()}}refresh(w){if(w.some(g=>!g))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new f.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const g=this.getHandlesToRefresh(w);if(g.length)return this.refreshHandles(g)}return Promise.resolve(void 0)}getHandlesToRefresh(w){const S=new Set,g=w.map(v=>this.nodes.get(v));for(const v of g)if(v&&!S.has(v.item.handle)){let t=v;for(;t&&t.parent&&g.findIndex(n=>t&&t.parent&&n&&n.item.handle===t.parent.item.handle)===-1;){const n=this.elements.get(t.parent.item.handle);t=n?this.nodes.get(n):void 0}t&&!t.parent&&S.add(v.item.handle)}const a=[];return S.forEach(v=>{const t=this.elements.get(v);if(t){const n=this.nodes.get(t);n&&(!n.parent||!S.has(n.parent.item.handle))&&a.push(v)}}),a}refreshHandles(w){const S={};return Promise.all(w.map(g=>this.refreshNode(g).then(a=>{a&&(S[g]=a.item)}))).then(()=>Object.keys(S).length?this.proxy.$refresh(this.viewId,S):void 0)}refreshNode(w){const S=this.getExtensionElement(w);if(S){const g=this.nodes.get(S);if(g)return this.clearChildren(S),(0,P.asPromise)(()=>this.dataProvider.getTreeItem(S)).then(a=>{if(a){const v=this.createTreeNode(S,a,g.parent);return this.updateNodeCache(S,v,g,g.parent),g.dispose(),v}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(w,S,g){const a=this.createTreeNode(w,S,g);if(S.id&&this.elements.has(a.item.handle))throw new Error((0,b.localize)(7,null,S.id));return this.addNodeToCache(w,a),this.addNodeToParentCache(a,g),a}getTooltip(w){return D.MarkdownString.isMarkdownString(w)?C.MarkdownString.from(w):w}getCommand(w,S){return S?this.commands.toInternal(S,w):void 0}createTreeNode(w,S,g){const a=new y.DisposableStore,v=this.createHandle(w,S,g),t=this.getLightIconPath(S);return{item:{handle:v,parentHandle:g?g.item.handle:void 0,label:m(S.label,this.extension),description:S.description,resourceUri:S.resourceUri,tooltip:this.getTooltip(S.tooltip),command:this.getCommand(a,S.command),contextValue:S.contextValue,icon:t,iconDark:this.getDarkIconPath(S)||t,themeIcon:this.getThemeIcon(S),collapsibleState:(0,k.isUndefinedOrNull)(S.collapsibleState)?D.TreeItemCollapsibleState.None:S.collapsibleState,accessibilityInformation:S.accessibilityInformation},extensionItem:S,parent:g,children:void 0,disposableStore:a,dispose(){a.dispose()}}}getThemeIcon(w){return w.iconPath instanceof D.ThemeIcon?w.iconPath:void 0}createHandle(w,{id:S,label:g,resourceUri:a},v,t){if(S)return`${d.ID_HANDLE_PREFIX}/${S}`;const n=m(g,this.extension),o=v?v.item.handle:d.LABEL_HANDLE_PREFIX;let r=n?n.label:a?(0,I.basename)(a):"";r=r.indexOf("/")!==-1?r.replace("/","//"):r;const s=this.nodes.has(w)?this.nodes.get(w).item.handle:void 0,c=this.getChildrenNodes(v)||[];let h,_=0;do{if(h=`${o}/${_}:${r}`,t||!this.elements.has(h)||s===h)break;_++}while(_<=c.length);return h}getLightIconPath(w){if(w.iconPath&&!(w.iconPath instanceof D.ThemeIcon))return typeof w.iconPath=="string"||T.URI.isUri(w.iconPath)?this.getIconPath(w.iconPath):this.getIconPath(w.iconPath.light)}getDarkIconPath(w){if(w.iconPath&&!(w.iconPath instanceof D.ThemeIcon)&&w.iconPath.dark)return this.getIconPath(w.iconPath.dark)}getIconPath(w){return T.URI.isUri(w)?w:T.URI.file(w)}addNodeToCache(w,S){this.elements.set(S.item.handle,w),this.nodes.set(w,S)}updateNodeCache(w,S,g,a){this.elements.delete(S.item.handle),this.nodes.delete(w),S.item.handle!==g.item.handle&&this.elements.delete(g.item.handle),this.addNodeToCache(w,S);const v=this.getChildrenNodes(a)||[],t=v.filter(n=>n.item.handle===g.item.handle)[0];t&&v.splice(v.indexOf(t),1,S)}addNodeToParentCache(w,S){S?(S.children||(S.children=[]),S.children.push(w)):(this.roots||(this.roots=[]),this.roots.push(w))}clearChildren(w){if(w){const S=this.nodes.get(w);if(S){if(S.children)for(const g of S.children){const a=this.elements.get(g.item.handle);a&&this.clear(a)}S.children=void 0}}else this.clearAll()}clear(w){const S=this.nodes.get(w);if(S){if(S.children)for(const g of S.children){const a=this.elements.get(g.item.handle);a&&this.clear(a)}this.nodes.delete(w),this.elements.delete(S.item.handle),S.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(w=>w.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}d.LABEL_HANDLE_PREFIX="0",d.ID_HANDLE_PREFIX="1"}),define(me[221],ge([0,1,17,13,21,11,87,20,7,124]),function(G,e,b,I,T,A,y,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class i{constructor(){this.testIdsToInternal=new Map}getTestById(E,w){if(w!==void 0){const S=this.testIdsToInternal.get(w),g=S==null?void 0:S.get(E);if(g)return[S,g]}return(0,b.mapFind)(this.testIdsToInternal.values(),S=>{const g=S.get(E);return g&&[S,g]})}createForHierarchy(E=()=>{}){return new l(this.createIdMap(f++),E)}createIdMap(E){const w=new m(E);return this.testIdsToInternal.set(w.id,w),{object:w,dispose:()=>this.testIdsToInternal.delete(w.id)}}}e.OwnedTestCollection=i;var C;(function(d){d[d.Disconnected=0]="Disconnected",d[d.IsChild=1]="IsChild",d[d.IsParent=2]="IsParent",d[d.IsSame=3]="IsSame"})(C=e.TestPosition||(e.TestPosition={}));let f=0;class m{constructor(E){this.id=E,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(E){if(this.map.has(E.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${E.item.extId}`);this.map.set(E.item.extId,E),E.parent||this._roots.add(E)}has(E){return this.map.has(E)}delete(E){const w=this.map.get(E);return w?(this.map.delete(E),this._roots.delete(w),!0):!1}get(E){return this.map.get(E)}comparePositions(E,w){const S=typeof E=="string"?this.map.get(E):E,g=typeof w=="string"?this.map.get(w):w;if(!S||!g)return 0;if(S===g)return 3;for(let a=this.map.get(g.parent);a;a=this.map.get(a.parent))if(a===S)return 1;for(let a=this.map.get(S.parent);a;a=this.map.get(a.parent))if(a===g)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=m;class l{constructor(E,w){this.testIdToInternal=E,this.publishDiff=w,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new I.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(E,w){this.addItem(E,w,null)}getTestByReference(E){return this.testItemToInternal.get(E)}collectDiff(){const E=this.diff;return this.diff=[],E}pushDiff(E){const w=this.diff[this.diff.length-1];if(w&&E[0]===1){if(w[0]===1&&w[1].extId===E[1].extId){(0,k.applyTestItemUpdate)(w[1],E[1]);return}if(w[0]===0&&w[1].item.extId===E[1].extId){(0,k.applyTestItemUpdate)(w[1],E[1]);return}}this.diff.push(E),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(E,w){var S;const g=this.testIdToInternal.object.get(E);if(!!g){if((g.expandLevels===void 0||w>g.expandLevels)&&(g.expandLevels=w),g.expand===1){const a=this.refreshChildren(g);return a.isSettled?this.expandChildren(g,w-1):a.p.then(()=>this.expandChildren(g,w-1))}else if(g.expand===3)return((S=g.initialExpand)===null||S===void 0?void 0:S.isSettled)===!1?g.initialExpand.p.then(()=>this.expandChildren(g,w-1)):this.expandChildren(g,w-1)}}dispose(){var E;for(const w of this.testItemToInternal.values())(E=w.discoverCts)===null||E===void 0||E.dispose(!0),(0,y.getPrivateApiFor)(w.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(E,w){const S=E==null?void 0:E.actual.id;switch(w[0]){case 2:this.pushDiff([4,S]);break;case 1:this.removeItem(E);break;case 0:this.addItem(w[1],E.src.controller,E);break;case 3:const[g,a,v]=w;switch(a){case"status":this.updateExpandability(E);break;case"range":this.pushDiff([1,{extId:S,item:{range:P.Range.from(v)}}]);break;case"error":this.pushDiff([1,{extId:S,item:{error:P.MarkdownString.fromStrict(v)||null}}]);break;default:this.pushDiff([1,{extId:S,item:{[a]:v!=null?v:null}}]);break}break;default:(0,A.assertNever)(w[0])}}addItem(E,w,S){if(!(E instanceof D.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${E.id} did not`);if(this.testItemToInternal.has(E))throw new Error(`Attempted to add a single TestItem ${E.id} multiple times to the tree`);if(this.testIdToInternal.object.has(E.id))throw new Error(`Attempted to insert a duplicate test item ID ${E.id}`);const g=S?S.item.extId:null,a=E.resolveHandler?1:0,v=S?S.expandLevels:1,t={controller:w,tree:this.testIdToInternal.object.id},n={actual:E,parent:g,item:P.TestItem.from(E),expandLevels:v?v-1:void 0,expand:0,src:t};this.testIdToInternal.object.add(n),this.testItemToInternal.set(E,n),this.pushDiff([0,{parent:g,src:t,expand:a,item:n.item}]);const o=(0,y.getPrivateApiFor)(E);o.parent=S==null?void 0:S.actual,o.bus.event(this.onTestItemEvent.bind(this,n)),this.updateExpandability(n);for(const r of o.children.values())this.testItemToInternal.has(r)||this.addItem(r,w,n)}updateExpandability(E){var w;let S;E.actual.resolveHandler?E.actual.status===D.TestItemStatus.Pending?S=E.discoverCts?2:1:((w=E.initialExpand)===null||w===void 0||w.complete(),S=3):S=0,S!==E.expand&&(E.expand=S,this.pushDiff([1,{extId:E.actual.id,expand:S}]),S===1&&E.expandLevels!==void 0&&this.refreshChildren(E))}expandChildren(E,w){if(!(w<0)){const S=[...E.actual.children.values()].map(g=>this.expand(g.id,w)).filter(I.isThenable);if(S.length)return Promise.all(S).then(()=>{})}}refreshChildren(E){if(E.discoverCts&&E.discoverCts.dispose(!0),!E.actual.resolveHandler){const w=new I.DeferredPromise;return w.complete(),w}return E.expand=2,E.discoverCts=new T.CancellationTokenSource,this.pushExpandStateUpdate(E),E.initialExpand=new I.DeferredPromise,E.actual.resolveHandler(E.discoverCts.token),E.initialExpand}pushExpandStateUpdate(E){this.pushDiff([1,{extId:E.actual.id,expand:E.expand}])}removeItem(E){var w;this.pushDiff([2,E.actual.id]);const S=[E];for(;S.length;){const g=S.pop();if(!!g){(w=g.discoverCts)===null||w===void 0||w.dispose(!0),this.testIdToInternal.object.delete(g.item.extId),this.testItemToInternal.delete(g.actual);for(const a of g.actual.children.values())S.push(this.testIdToInternal.object.get(a.id))}}}flushDiff(){const E=this.collectDiff();E.length&&this.publishDiff(E)}}e.SingleUseTestCollection=l}),define(me[222],ge([0,1,27,3,8]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(i){this.removedDueToLooping=i}}e.DeltaExtensionsResult=A;class y{constructor(i){this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(b.ExtensionIdentifier.toKey(i.identifier))){console.error("Extension `"+i.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(b.ExtensionIdentifier.toKey(i.identifier),i),this._extensionsArr.push(i),Array.isArray(i.activationEvents))for(let C of i.activationEvents)C==="onUri"&&(C=`onUri:${b.ExtensionIdentifier.toKey(i.identifier)}`),this._activationMap.has(C)||this._activationMap.set(C,[]),this._activationMap.get(C).push(i)}}keepOnly(i){const C=new Set;i.forEach(f=>C.add(b.ExtensionIdentifier.toKey(f))),this._extensionDescriptions=this._extensionDescriptions.filter(f=>C.has(b.ExtensionIdentifier.toKey(f.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(i,C){i.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(i));const f=y._findLoopingExtensions(this._extensionDescriptions);if(C=C.concat(f.map(m=>m.identifier)),C.length>0){const m=new Set;C.forEach(l=>m.add(b.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>!m.has(b.ExtensionIdentifier.toKey(l.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(f)}static _findLoopingExtensions(i){const C=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(E){this._nodesSet.has(E)||(this._nodesSet.add(E),this._nodesArr.push(E))}addArc(E,w){this.addNode(E),this.addNode(w),this._arcs.has(E)?this._arcs.get(E).push(w):this._arcs.set(E,[w])}getArcs(E){return this._arcs.has(E)?this._arcs.get(E):[]}hasOnlyGoodArcs(E,w){const S=C.getArcs(E);for(let g=0;g<S.length;g++)if(!w.has(S[g]))return!1;return!0}getNodes(){return this._nodesArr}};let f=new Map;for(let E of i){const w=b.ExtensionIdentifier.toKey(E.identifier);if(f.set(w,E),E.extensionDependencies)for(let S of E.extensionDependencies){const g=b.ExtensionIdentifier.toKey(S);C.addArc(w,g)}}let m=new Set;C.getNodes().filter(E=>C.getArcs(E).length===0).forEach(E=>m.add(E));let l=C.getNodes().filter(E=>!m.has(E)),d;do{d=!1;for(let E=0;E<l.length;E++){const w=l[E];C.hasOnlyGoodArcs(w,m)&&(l.splice(E,1),E--,m.add(w),d=!0)}}while(d);return l.map(E=>f.get(E))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(b.ExtensionIdentifier.toKey(i))}getExtensionDescriptionsForActivationEvent(i){const C=this._activationMap.get(i);return C?C.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(i){const C=this._extensionsMap.get(b.ExtensionIdentifier.toKey(i));return C||void 0}}e.ExtensionDescriptionRegistry=y;var P;(function(k){k[k.Builtin=0]="Builtin",k[k.User=1]="User",k[k.Dev=2]="Dev"})(P||(P={}));function D(k,i){const C=k.isBuiltin?0:k.isUnderDevelopment?2:1,f=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(C!==f)return C-f;const m=T.posix.basename(k.extensionLocation.path),l=T.posix.basename(i.extensionLocation.path);return m<l?-1:m>l?1:0}}),define(me[223],ge([0,1,23]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var I;(function(P){P[P.VersionMismatch=55]="VersionMismatch",P[P.UnexpectedError=81]="UnexpectedError"})(I=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var T;(function(P){P[P.Initialized=0]="Initialized",P[P.Ready=1]="Ready",P[P.Terminate=2]="Terminate"})(T=e.MessageType||(e.MessageType={}));function A(P){const D=b.VSBuffer.alloc(1);switch(P){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=A;function y(P,D){if(P.byteLength!==1)return!1;switch(P.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=y}),define(me[41],ge([0,1,3,2,4,27,183]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:I.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,T.createDecorator)("extensionService");class P{constructor(S){this.dependency=S}}e.MissingExtensionDependency=P;var D;(function(w){w[w.LocalProcess=0]="LocalProcess",w[w.LocalWebWorker=1]="LocalWebWorker",w[w.Remote=2]="Remote"})(D=e.ExtensionHostKind||(e.ExtensionHostKind={}));class k{constructor(S,g,a,v){this.codeLoadingTime=S,this.activateCallTime=g,this.activateResolvedTime=a,this.activationReason=v}}e.ActivationTimes=k;class i{constructor(S,g){this.description=S,this.value=g}}e.ExtensionPointContribution=i,e.ExtensionHostLogFileName="exthost";var C;(function(w){w[w.Normal=0]="Normal",w[w.Immediate=1]="Immediate"})(C=e.ActivationKind||(e.ActivationKind={}));function f(w){w.enableProposedApi||m(w)}e.checkProposedApiEnabled=f;function m(w){throw new Error(`[${w.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${w.identifier.value}`)}e.throwProposedApiError=m;function l(w){return{type:w.isBuiltin?0:1,isBuiltin:w.isBuiltin||w.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(w.publisher,w.name),uuid:w.uuid},manifest:w,location:w.extensionLocation}}e.toExtension=l;function d(w){return Object.assign(Object.assign({identifier:new A.ExtensionIdentifier(w.identifier.id),isBuiltin:w.type===0,isUserBuiltin:w.type===1&&w.isBuiltin,isUnderDevelopment:!1,extensionLocation:w.location},w.manifest),{uuid:w.identifier.uuid})}e.toExtensionDescription=d;class E{constructor(){this.onDidRegisterExtensions=b.Event.None,this.onDidChangeExtensionsStatus=b.Event.None,this.onDidChangeExtensions=b.Event.None,this.onWillActivateByEvent=b.Event.None,this.onDidChangeResponsiveChange=b.Event.None}activateByEvent(S){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(S){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(S){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(S){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(S,g){return Promise.resolve()}_onWillActivateExtension(S){}_onDidActivateExtension(S,g,a,v,t){}_onDidActivateExtensionError(S,g){}_onExtensionRuntimeError(S,g){}_onExtensionHostExit(S){}}e.NullExtensionService=E}),define(me[224],ge([0,1,27,41,14]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const A=Promise.resolve(void 0);class y{constructor(l,d,E,w){this.startup=l,this.codeLoadingTime=d,this.activateCallTime=E,this.activateResolvedTime=w}}e.ExtensionActivationTimes=y,y.NONE=new y(!1,-1,-1,-1);class P{constructor(l){this._startup=l,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(l,d){return l===-1||d===-1?-1:d-l}build(){return new y(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=P;class D{constructor(l,d,E,w,S,g){this.activationFailed=l,this.activationFailedError=d,this.activationTimes=E,this.module=w,this.exports=S,this.subscriptions=g}}e.ActivatedExtension=D;class k extends D{constructor(l){super(!1,null,l,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=k;class i extends D{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=i;class C extends D{constructor(l){super(!0,l,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=C;let f=class{constructor(l,d,E,w,S){this._logService=S,this._registry=l,this._resolvedExtensionsSet=new Set,d.forEach(g=>this._resolvedExtensionsSet.add(b.ExtensionIdentifier.toKey(g))),this._hostExtensionsMap=new Map,E.forEach(g=>this._hostExtensionsMap.set(b.ExtensionIdentifier.toKey(g),g)),this._host=w,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(l){const d=b.ExtensionIdentifier.toKey(l);return this._activatedExtensions.has(d)}getActivatedExtension(l){const d=b.ExtensionIdentifier.toKey(l),E=this._activatedExtensions.get(d);if(!E)throw new Error("Extension `"+l.value+"` is not known or not activated");return E}activateByEvent(l,d){if(this._alreadyActivatedEvents[l])return A;const E=this._registry.getExtensionDescriptionsForActivationEvent(l);return this._activateExtensions(E.map(w=>({id:w.identifier,reason:{startup:d,extensionId:w.identifier,activationEvent:l}}))).then(()=>{this._alreadyActivatedEvents[l]=!0})}activateById(l,d){const E=this._registry.getExtensionDescription(l);if(!E)throw new Error("Extension `"+l+"` is not known");return this._activateExtensions([{id:E.identifier,reason:d}])}_handleActivateRequest(l,d,E){if(this._hostExtensionsMap.has(b.ExtensionIdentifier.toKey(l.id))){d[b.ExtensionIdentifier.toKey(l.id)]=l;return}const w=this._registry.getExtensionDescription(l.id);if(!w){const a=new Error(`Cannot activate unknown extension '${l.id.value}'`);this._host.onExtensionActivationError(l.id,a,new I.MissingExtensionDependency(l.id.value)),this._activatedExtensions.set(b.ExtensionIdentifier.toKey(l.id),new C(a));return}const S=typeof w.extensionDependencies=="undefined"?[]:w.extensionDependencies;let g=!0;for(let a=0,v=S.length;a<v;a++){const t=S[a];if(!this._resolvedExtensionsSet.has(b.ExtensionIdentifier.toKey(t))){const n=this._activatedExtensions.get(b.ExtensionIdentifier.toKey(t));if(!(n&&!n.activationFailed)){if(n&&n.activationFailed){const c=w.displayName||w.identifier.value,h=this._registry.getExtensionDescription(t),_=h&&h.displayName||t,u=new Error(`Cannot activate the '${c}' extension because its dependency '${_}' failed to activate`);u.detail=n.activationFailedError,this._host.onExtensionActivationError(w.identifier,u,null),this._activatedExtensions.set(b.ExtensionIdentifier.toKey(w.identifier),new C(u));return}if(this._hostExtensionsMap.has(b.ExtensionIdentifier.toKey(t))){g=!1,d[b.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(b.ExtensionIdentifier.toKey(t)),reason:l.reason};continue}const o=this._registry.getExtensionDescription(t);if(o){g=!1,d[b.ExtensionIdentifier.toKey(t)]={id:o.identifier,reason:l.reason};continue}const r=w.displayName||w.identifier.value,s=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(w.identifier,s,new I.MissingExtensionDependency(t)),this._activatedExtensions.set(b.ExtensionIdentifier.toKey(w.identifier),new C(s));return}}}g?d[b.ExtensionIdentifier.toKey(w.identifier)]=l:E.push(l)}_activateExtensions(l){if(l.length===0||(l=l.filter(S=>!this._activatedExtensions.has(b.ExtensionIdentifier.toKey(S.id))),l.length===0))return Promise.resolve(void 0);const d=Object.create(null),E=[];for(let S=0,g=l.length;S<g;S++)this._handleActivateRequest(l[S],d,E);for(let S=0,g=E.length;S<g;S++){const a=b.ExtensionIdentifier.toKey(E[S].id);d[a]&&delete d[a]}const w=Object.keys(d).map(S=>d[S]);return E.length===0?Promise.all(w.map(S=>this._activateExtension(S.id,S.reason))).then(S=>{}):this._activateExtensions(w).then(S=>this._activateExtensions(E))}_activateExtension(l,d){const E=b.ExtensionIdentifier.toKey(l);if(this._activatedExtensions.has(E))return Promise.resolve(void 0);const w=this._activatingExtensions.get(E);if(w)return w;const S=this._host.actualActivateExtension(l,d).then(void 0,g=>{const a=new Error;return g&&g.name&&(a.name=g.name),g&&g.message?a.message=`Activating extension '${l.value}' failed: ${g.message}.`:a.message=`Activating extension '${l.value}' failed: ${g}.`,g&&g.stack&&(a.stack=g.stack),this._host.onExtensionActivationError(l,a,null),this._logService.error(`Activating extension ${l.value} failed due to an error:`),this._logService.error(g),new C(g)}).then(g=>{this._activatedExtensions.set(E,g),this._activatingExtensions.delete(E)});return this._activatingExtensions.set(E,S),S}};f=qe([He(4,T.ILogService)],f),e.ExtensionsActivator=f}),define(me[225],ge([0,1,14,41,28,12,114]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let P=class extends b.LogService{constructor(k){if(k.logFile.scheme!==A.Schemas.file)throw new Error("Only file-logging supported");super(new y.SpdLogLogger(I.ExtensionHostLogFileName,k.logFile.fsPath,!0,k.logLevel))}$setLevel(k){this.setLevel(k)}};P=qe([He(0,T.IExtHostInitDataService)],P),e.ExtHostLogService=P}),define(me[226],ge([0,1,16]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class I{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,y)=>{this._actualOk=A,this._actualErr=y,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,b.onUnexpectedError)(A))}then(A,y){return this._ensureActual().then(A,y)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=I}),define(me[126],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class b{constructor(D,k){this.isMain=D,this.sid=k,this.nid=++b.count}}e.ProxyIdentifier=b,b.count=0;const I=[];function T(P){const D=new b(!0,P);return I[D.nid]=D,D}e.createMainContextProxyIdentifier=T;function A(P){const D=new b(!1,P);return I[D.nid]=D,D}e.createExtHostContextProxyIdentifier=A;function y(P){return I[P].sid}e.getStringIdentifierForProxy=y}),define(me[5],ge([0,1,2,126,59]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var A;(function(a){a[a.Desktop=1]="Desktop",a[a.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var y;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(y=e.TextEditorRevealType||(e.TextEditorRevealType={}));var P;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(P=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var k;(function(a){a[a.Markdown=1]="Markdown",a[a.Code=2]="Code"})(k=e.CellKind||(e.CellKind={}));var i;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(i=e.CellOutputKind||(e.CellOutputKind={}));var C;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(C=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var f;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(f=e.CandidatePortSource||(e.CandidatePortSource={}));var m;(function(a){a.name="$ident";function v(n,o){return Object.defineProperty(n,a.name,{value:o,enumerable:!0}),n}a.mixin=v;function t(n){return n[a.name]}a.of=t})(m=e.ObjectIdentifier||(e.ObjectIdentifier={}));class l{static mixin(v){return v._id=l._n++,v}}e.IdObject=l,l._n=0;var d;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.command="m",a.kindModifier="n",a.label2="o"})(d=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var E;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(E=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var w;(function(a){a[a.File=1]="File",a[a.Text=2]="Text",a[a.Cell=3]="Cell"})(w=e.WorkspaceEditType||(e.WorkspaceEditType={}));function S(a){if(a&&a.edits)for(const v of a.edits)typeof v.resource=="object"?v.resource=b.URI.revive(v.resource):(v.newUri=b.URI.revive(v.newUri),v.oldUri=b.URI.revive(v.oldUri)),v.metadata&&v.metadata.iconPath&&(v.metadata=(0,T.revive)(v.metadata));return a}e.reviveWorkspaceEditDto=S;var g;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(g=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,I.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,I.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,I.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,I.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,I.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,I.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,I.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,I.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,I.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,I.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,I.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,I.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,I.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,I.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,I.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,I.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,I.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,I.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,I.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,I.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,I.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,I.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,I.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,I.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,I.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,I.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,I.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,I.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,I.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,I.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadTheming:(0,I.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,I.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,I.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,I.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,I.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,I.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,I.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,I.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,I.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,I.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,I.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,I.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,I.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,I.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,I.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,I.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,I.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,I.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,I.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,I.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,I.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,I.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,I.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,I.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,I.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookKernels:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostTheming:(0,I.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,I.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,I.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,I.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,I.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,I.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(me[90],ge([0,1,5,3,4]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(P){this._onDidChangePassword=new I.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=P.getProxy(b.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this._onDidChangePassword.fire(P)}get(P,D){return this._proxy.$getPassword(P,D)}store(P,D,k){return this._proxy.$setPassword(P,D,k)}delete(P,D){return this._proxy.$deletePassword(P,D)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,T.createDecorator)("IExtHostSecretState")}),define(me[64],ge([0,1,4,14,5,15]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,b.createDecorator)("IExtHostApiDeprecationService");let y=class{constructor(D,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(T.MainContext.MainThreadTelemetry)}report(D,k,i){const C=this.getUsageKey(D,k);this._reportedUsages.has(C)||(this._reportedUsages.add(C),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${i}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:D}))}getUsageKey(D,k){return`${D}-${k.identifier.value}`}};y=qe([He(0,A.IExtHostRpcService),He(1,I.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(P,D,k){}})}),define(me[227],ge([0,1,3,5,7,27]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new b.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new b.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(I.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(D,k,i,C={}){const f=A.ExtensionIdentifier.toKey(D.identifier),m=this._inFlightRequests.get(f)||[],l=i.sort().join(" ");let d=m.find(E=>E.scopes===l);if(d)return d.result;{const E=this._getSession(D,f,k,i,C);d={scopes:l,result:E},m.push(d),this._inFlightRequests.set(f,m);try{await E}finally{const w=m.findIndex(S=>S.scopes===l);w>-1&&(m.splice(w),this._inFlightRequests.set(f,m))}return E}}async _getSession(D,k,i,C,f={}){await this._proxy.$ensureProvider(i);const m=D.displayName||D.name;return this._proxy.$getSession(i,C,k,m,f)}async removeSession(D,k){const i=this._authenticationProviders.get(D);return i?i.provider.removeSession(k):this._proxy.$removeSession(D,k)}registerAuthenticationProvider(D,k,i,C){var f;if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:k,provider:i,options:C!=null?C:{supportsMultipleAccounts:!1}}),this._providers.find(l=>l.id===D)||this._providers.push({id:D,label:k});const m=i.onDidChangeSessions(l=>{var d,E,w;this._proxy.$sendDidChangeSessions(D,{added:(d=l.added)!==null&&d!==void 0?d:[],changed:(E=l.changed)!==null&&E!==void 0?E:[],removed:(w=l.removed)!==null&&w!==void 0?w:[]})});return this._proxy.$registerAuthenticationProvider(D,k,(f=C==null?void 0:C.supportsMultipleAccounts)!==null&&f!==void 0?f:!1),new T.Disposable(()=>{m.dispose(),this._authenticationProviders.delete(D);const l=this._providers.findIndex(d=>d.id===D);l>-1&&this._providers.splice(l),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,k){const i=this._authenticationProviders.get(D);if(i)return Promise.resolve(i.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,k){const i=this._authenticationProviders.get(D);if(i)return Promise.resolve(i.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,k){const i=this._authenticationProviders.get(D);if(i)return Promise.resolve(i.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,k){return this._onDidChangeSessions.fire({provider:{id:D,label:k}}),Promise.resolve()}$onDidChangeAuthenticationProviders(D,k){return D.forEach(i=>{this._providers.some(C=>C.id===i.id)||this._providers.push(i)}),k.forEach(i=>{const C=this._providers.findIndex(f=>f.id===i.id);C>-1&&this._providers.splice(C)}),this._onDidChangeAuthenticationProviders.fire({added:D,removed:k}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(me[228],ge([0,1,5,15,20]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(P,D){this._extHostDocumentsAndEditors=D,this._proxy=P.getProxy(b.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(P){const D=T.WorkspaceEdit.from(P,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};A=qe([He(0,I.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(me[229],ge([0,1,5]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class I{constructor(A){const y=A.getProxy(b.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(P){return y.$writeText(P)}})}}e.ExtHostClipboard=I}),define(me[51],ge([0,1,11,7,20,24,5,17,14,59,44,49,2,6,4,15]),function(G,e,b,I,T,A,y,P,D,k,i,C,f,m,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let E=class{constructor(t,n){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(y.MainContext.MainThreadCommands),this._logService=n,this.converter=new w(this,o=>{const r=this._apiCommands.get(o);return(r==null?void 0:r.result)===g.Void?r:void 0},n),this._argumentProcessors=[{processArgument(o){return(0,k.revive)(o)}},{processArgument(o){return(0,A.cloneAndChange)(o,function(r){if(i.Range.isIRange(r))return T.Range.to(r);if(C.Position.isIPosition(r))return T.Position.to(r);if(i.Range.isIRange(r.range)&&f.URI.isUri(r.uri))return T.location.to(r);if(!Array.isArray(r))return r})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const n=this.registerCommand(!1,t.id,async(...o)=>{const r=t.args.map((c,h)=>{if(!c.validate(o[h]))throw new Error(`Invalid argument '${c.name}' when running '${t.id}', received: ${o[h]}`);return c.convert(o[h])}),s=await this.executeCommand(t.internalId,...r);return t.result.convert(s,o,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new I.Disposable(()=>{n.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,n,o,r,s){if(this._logService.trace("ExtHostCommands#registerCommand",n),!n.trim().length)throw new Error("invalid id");if(this._commands.has(n))throw new Error(`command '${n}' already exists`);return this._commands.set(n,{callback:o,thisArg:r,description:s}),t&&this._proxy.$registerCommand(n),new I.Disposable(()=>{this._commands.delete(n)&&t&&this._proxy.$unregisterCommand(n)})}executeCommand(t,...n){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,n,!0)}async _doExecuteCommand(t,n,o){if(this._commands.has(t))return this._executeContributedCommand(t,n);{const r=(0,A.cloneAndChange)(n,function(s){if(s instanceof I.Position)return T.Position.from(s);if(s instanceof I.Range)return T.Range.from(s);if(s instanceof I.Location)return T.location.from(s);if(I.NotebookRange.isNotebookRange(s))return T.NotebookRange.from(s);if(!Array.isArray(s))return s});try{const s=await this._proxy.$executeCommand(t,r,o);return(0,k.revive)(s)}catch(s){if(s instanceof Error&&s.message==="$executeCommand:retry")return this._doExecuteCommand(t,n,!1);throw s}}}async _executeContributedCommand(t,n){const o=this._commands.get(t);if(!o)throw new Error("Unknown command");let{callback:r,thisArg:s,description:c}=o;if(c)for(let h=0;h<c.args.length;h++)try{(0,b.validateConstraint)(n[h],c.args[h].constraint)}catch(_){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${c.args[h].name}' - ${c.args[h].description}`)}try{return await r.apply(s,n)}catch(h){if(t===this.converter.delegatingCommandId){const _=this.converter.getActualCommand(...n);_&&(t=_.command)}throw this._logService.error(h,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...n){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(n=n.map(o=>this._argumentProcessors.reduce((r,s)=>s.processArgument(r),o)),this._executeContributedCommand(t,n)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(n=>(t&&(n=n.filter(o=>o[0]!=="_")),n))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[n,o]of this._commands){let{description:r}=o;r&&(t[n]=r)}return Promise.resolve(t)}};E=qe([He(0,d.IExtHostRpcService),He(1,D.ILogService)],E),e.ExtHostCommands=E,e.IExtHostCommands=(0,l.createDecorator)("IExtHostCommands");class w{constructor(t,n,o){this._commands=t,this._lookupApiCommand=n,this._logService=o,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,n){if(!!t){const o={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return o;const r=this._lookupApiCommand(t.command);if(r)o.id=r.internalId,o.arguments=r.args.map((s,c)=>s.convert(t.arguments&&t.arguments[c]));else if((0,P.isNonEmptyArray)(t.arguments)){const s=++this._cachIdPool;this._cache.set(s,t),n.add((0,m.toDisposable)(()=>{this._cache.delete(s),this._logService.trace("CommandsConverter#DISPOSE",s)})),o.$ident=s,o.id=this.delegatingCommandId,o.arguments=[s],this._logService.trace("CommandsConverter#CREATE",t.command,s)}return o}}fromInternal(t){const n=y.ObjectIdentifier.of(t);return typeof n=="number"?this._cache.get(n):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const n=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],n?n.command:"MISSING"),n?this._commands.executeCommand(n.command,...n.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=w;class S{constructor(t,n,o,r){this.name=t,this.description=n,this.validate=o,this.convert=r}optional(){return new S(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,n){return new S(t!=null?t:this.name,n!=null?n:this.description,this.validate,this.convert)}}e.ApiCommandArgument=S,S.Uri=new S("uri","Uri of a text document",v=>f.URI.isUri(v),v=>v),S.Position=new S("position","A position in a text document",v=>I.Position.isPosition(v),T.Position.from),S.Range=new S("range","A range in a text document",v=>I.Range.isRange(v),T.Range.from),S.Selection=new S("selection","A selection in a text document",v=>I.Selection.isSelection(v),T.Selection.from),S.Number=new S("number","",v=>typeof v=="number",v=>v),S.String=new S("string","",v=>typeof v=="string",v=>v),S.CallHierarchyItem=new S("item","A call hierarchy item",v=>v instanceof I.CallHierarchyItem,T.CallHierarchyItem.to);class g{constructor(t,n){this.description=t,this.convert=n}}e.ApiCommandResult=g,g.Void=new g("no result",v=>v);class a{constructor(t,n,o,r,s){this.id=t,this.internalId=n,this.description=o,this.args=r,this.result=s}}e.ApiCommand=a}),define(me[230],ge([0,1,6,20,7,80,51,204,17,111]),function(G,e,b,I,T,A,y,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const i=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",f(I.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,d)=>{if(!(0,D.isFalsyOrEmpty)(l)){class E extends T.SymbolInformation{static to(S){const g=new E(S.name,I.SymbolKind.to(S.kind),S.containerName||"",new T.Location(d[0],I.Range.to(S.range)));return g.detail=S.detail,g.range=g.location.range,g.selectionRange=I.Range.to(S.selectionRange),g.children=S.children?S.children.map(E.to):[],g}}return l.map(E.to)}})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",f(I.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",f(I.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",l=>typeof l=="string",l=>l),new y.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",f(I.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",f(I.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",f(I.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",l=>Array.isArray(l)&&l.every(d=>T.Position.isPosition(d)),l=>l.map(I.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",l=>l.map(d=>{let E;for(const w of d.reverse())E=new T.SelectionRange(I.Range.to(w),E);return E}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",l=>{const d=[];if(Array.isArray(l))for(let E of l)d.push(...E[1].map(I.WorkspaceSymbol.to));return d})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(I.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(I.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(I.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",l=>{if(!!l){if(l.rejectReason)throw new Error(l.rejectReason);return I.WorkspaceEdit.to(l)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(I.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new T.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!!l){const d=(0,k.decodeSemanticTokensDto)(l);if(d.type==="full")return new T.SemanticTokens(d.data,void 0)}})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new T.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!!l){const d=(0,k.decodeSemanticTokensDto)(l);if(d.type==="full")return new T.SemanticTokens(d.data,void 0)}})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(l,d,E)=>{if(!l)return new T.CompletionList([]);const w=l.suggestions.map(S=>I.CompletionItem.to(S,E));return new T.CompletionList(w,l.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",l=>{if(l)return I.SignatureHelp.to(l)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(l,d,E)=>f(w=>new T.CodeLens(I.Range.to(w.range),w.command&&E.fromInternal(w.command)))(l))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>T.Range.isRange(l),l=>T.Selection.isSelection(l)?I.Selection.from(l):I.Range.from(l)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(l,d,E)=>f(w=>{if(w._isSynthetic){if(!w.command)throw new Error("Synthetic code actions must have a command");return E.fromInternal(w.command)}else{const S=new T.CodeAction(w.title,w.kind?new T.CodeActionKind(w.kind):void 0);return w.edit&&(S.edit=I.WorkspaceEdit.to(w.edit)),w.command&&(S.command=E.fromInternal(w.command)),S.isPreferred=w.isPreferred,S}})(l))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(d=>new T.ColorInformation(I.Range.to(d.range),I.Color.to(d.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",l=>l instanceof T.Color,I.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:I.Range.from(l.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(I.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inline hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",l=>l.map(I.InlayHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",f(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(d=>I.NotebookExclusiveDocumentPattern.to(d))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",l=>l.map(I.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[I.ViewColumn.from(l.viewColumn),I.TextEditorOpenOptions.from(l)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[I.ViewColumn.from(l.viewColumn),I.TextEditorOpenOptions.from(l)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[I.ViewColumn.from(l.viewColumn),I.TextEditorOpenOptions.from(l)]).optional()],y.ApiCommandResult.Void)];class C{constructor(d){this._disposables=new b.DisposableStore,this._commands=d}static register(d){return i.forEach(d.registerApiCommand,d),new C(d).registerCommands()}registerCommands(){const d=E=>(...w)=>E(this._commands,...w);this._register(P.RemoveFromRecentlyOpenedAPICommand.ID,d(P.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:E=>typeof E=="string"}]}),this._register(P.OpenIssueReporter.ID,d(P.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:E=>typeof E=="string"||typeof E=="object"&&typeof E.extensionId=="string"}]})}_register(d,E,w){const S=this._commands.registerCommand(!1,d,E,this,w);this._disposables.add(S)}}e.ExtHostApiCommands=C;function f(l){return d=>{if(Array.isArray(d))return d.map(l)}}function m(l){if(!!Array.isArray(l)){const d=[];for(const E of l)A.isLocationLink(E)?d.push(I.DefinitionLink.to(E)):d.push(I.location.to(E));return d}}}),define(me[231],ge([0,1,13,54,3,6,2,80,27,20,7,5]),function(G,e,b,I,T,A,y,P,D,k,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class f{constructor(a,v,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=a.getProxy(C.MainContext.MainThreadComments),v.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const o=this._commentControllers.get(n.handle);return o||n}else if(n&&n.$mid===7){const o=this._commentControllers.get(n.commentControlHandle);if(!o)return n;const r=o.getCommentThread(n.commentThreadHandle);return r||n}else if(n&&n.$mid===8){const o=this._commentControllers.get(n.thread.commentControlHandle);if(!o)return n;const r=o.getCommentThread(n.thread.commentThreadHandle);return r?{thread:r,text:n.text}:n}else if(n&&n.$mid===9){const o=this._commentControllers.get(n.thread.commentControlHandle);if(!o)return n;const r=o.getCommentThread(n.thread.commentThreadHandle);if(!r)return n;let s=n.commentUniqueId,c=r.getCommentByUniqueId(s);return c||n}else if(n&&n.$mid===10){const o=this._commentControllers.get(n.thread.commentControlHandle);if(!o)return n;const r=o.getCommentThread(n.thread.commentThreadHandle);if(!r)return n;let s=n.text,c=n.commentUniqueId,h=r.getCommentByUniqueId(c);return h?(h.body=s,h):n}return n}})}createCommentController(a,v,t){const n=f.handlePool++,o=new l(a,n,this._proxy,v,t);this._commentControllers.set(o.handle,o);const r=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(a.identifier))||[];return r.push(o),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(a.identifier),r),o}$createCommentThreadTemplate(a,v,t){const n=this._commentControllers.get(a);!n||n.$createCommentThreadTemplate(v,t)}async $updateCommentThreadTemplate(a,v,t){const n=this._commentControllers.get(a);!n||n.$updateCommentThreadTemplate(v,t)}$deleteCommentThread(a,v){const t=this._commentControllers.get(a);t&&t.$deleteCommentThread(v)}$provideCommentingRanges(a,v,t){const n=this._commentControllers.get(a);if(!n||!n.commentingRangeProvider)return Promise.resolve(void 0);const o=this._documents.getDocument(y.URI.revive(v));return(0,b.asPromise)(()=>n.commentingRangeProvider.provideCommentingRanges(o,t)).then(r=>r?r.map(s=>k.Range.from(s)):void 0)}$toggleReaction(a,v,t,n,o){const r=this._commentControllers.get(a);return!r||!r.reactionHandler?Promise.resolve(void 0):(0,b.asPromise)(()=>{const s=r.getCommentThread(v);if(s){const c=s.getCommentByUniqueId(n.uniqueIdInThread);if(r!==void 0&&c&&r.reactionHandler)return r.reactionHandler(c,w(o))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=f,f.handlePool=0;class m{constructor(a,v,t,n,o,r,s){this._proxy=a,this._commentController=v,this._id=t,this._uri=n,this._range=o,this._comments=r,this.handle=m._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new T.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${v.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,k.Range.from(this._range),s),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=r}set threadId(a){this._id=a}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(a){a.isEqual(this._range)||(this._range=a,this.modifications.range=a,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(a){this._canReply!==a&&(this._canReply=a,this.modifications.canReply=a,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(a){this._label=a,this.modifications.label=a,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(a){this._contextValue=a,this.modifications.contextValue=a,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(a){this._comments=a,this.modifications.comments=a,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(a){this._collapseState=a,this.modifications.collapsibleState=a,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const a=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),v={};a("range")&&(v.range=k.Range.from(this._range)),a("label")&&(v.label=this.label),a("contextValue")&&(v.contextValue=this.contextValue),a("comments")&&(v.comments=this._comments.map(t=>d(this,this._commentController,t,this._commentsMap))),a("collapsibleState")&&(v.collapseState=S(this._collapseState)),a("canReply")&&(v.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,v)}}getCommentByUniqueId(a){for(let v of this._commentsMap){let t=v[0],n=v[1];if(a===n)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(a=>a.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}m._handlePool=0,qe([(0,I.debounce)(100)],m.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=m;class l{constructor(a,v,t,n,o){this._extension=a,this._handle=v,this._proxy=t,this._id=n,this._label=o,this._threads=new Map,this._proxy.$registerCommentController(this.handle,n,o)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(a){this._reactionHandler=a,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!a})}get options(){return this._options}set options(a){this._options=a,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(a,v,t,n){if(typeof a=="string"){const o=new m(this._proxy,this,a,v,t,n,this._extension.identifier);return this._threads.set(o.handle,o),o}else{const o=new m(this._proxy,this,void 0,a,v,t,this._extension.identifier);return this._threads.set(o.handle,o),o}}$createCommentThreadTemplate(a,v){const t=new m(this._proxy,this,void 0,y.URI.revive(a),k.Range.to(v),[],this._extension.identifier);return t.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(a,v){let t=this._threads.get(a);t&&(t.range=k.Range.to(v))}$deleteCommentThread(a){let v=this._threads.get(a);v&&v.dispose(),this._threads.delete(a)}getCommentThread(a){return this._threads.get(a)}dispose(){this._threads.forEach(a=>{a.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function d(g,a,v,t){let n=t.get(v);n||(n=++g.commentHandle,t.set(v,n));const o=v.author&&v.author.iconPath?v.author.iconPath.toString():void 0;return{mode:v.mode,contextValue:v.contextValue,uniqueIdInThread:n,body:k.MarkdownString.from(v.body),userName:v.author.name,userIconPath:o,label:v.label,commentReactions:v.reactions?v.reactions.map(r=>E(r)):void 0}}function E(g){return{label:g.label,iconPath:g.iconPath?k.pathOrURIToURI(g.iconPath):void 0,count:g.count,hasReacted:g.authorHasReacted}}function w(g){return{label:g.label||"",count:g.count||0,iconPath:g.iconPath?y.URI.revive(g.iconPath):"",authorHasReacted:g.hasReacted||!1}}function S(g){if(g!==void 0)switch(g){case i.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case i.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}}),define(me[127],ge([0,1,2,5,7,4,15,14,17,9,8]),function(G,e,b,I,T,A,y,P,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let C=class yn{constructor(m,l){this._logService=l,this._provider=new Map,this._proxy=m.getProxy(I.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,l){const d=yn._handlePool++;this._provider.set(d,{provider:m,extensionId:l}),this._proxy.$registerDecorationProvider(d,l.value);const E=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(w=>{if(!w){this._proxy.$onDidChange(d,null);return}let S=(0,D.asArray)(w);if(S.length<=yn._maxEventSize){this._proxy.$onDidChange(d,S);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",l.value,S.length);const g=S.map(t=>({uri:t,rank:(0,k.count)(t.path,"/")})),a=(0,D.groupBy)(g,(t,n)=>t.rank-n.rank||(0,k.compare)(t.uri.path,n.uri.path));let v=[];e:for(let t of a){let n;for(let o of t){let r=(0,i.dirname)(o.uri.path);if(n!==r&&(n=r,v.push(o.uri)>=yn._maxEventSize))break e}}this._proxy.$onDidChange(d,v)});return new T.Disposable(()=>{E==null||E.dispose(),this._proxy.$unregisterDecorationProvider(d),this._provider.delete(d)})}async $provideDecorations(m,l,d){if(!this._provider.has(m))return Object.create(null);const E=Object.create(null),{provider:w,extensionId:S}=this._provider.get(m);return await Promise.all(l.map(async g=>{try{const{uri:a,id:v}=g,t=await Promise.resolve(w.provideFileDecoration(b.URI.revive(a),d));if(!t)return;try{T.FileDecoration.validate(t),E[v]=[t.propagate,t.tooltip,t.badge,t.color]}catch(n){this._logService.warn(`INVALID decoration from extension '${S.value}': ${n}`)}}catch(a){this._logService.error(a)}})),E}};C._handlePool=0,C._maxEventSize=250,C=qe([He(0,y.IExtHostRpcService),He(1,P.ILogService)],C),e.ExtHostDecorations=C,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")}),define(me[232],ge([0,1,161,115,2,5,7,20,3,14,22]),function(G,e,b,I,T,A,y,P,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class C{constructor(l,d,E,w,S){this._name=l,this._owner=d,this._maxDiagnosticsPerFile=E,this._proxy=w,this._onDidChangeDiagnostics=S,this._isDisposed=!1,this._data=new i.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(l,d){if(!l){this.clear();return}this._checkDisposed();let E=[];if(T.URI.isUri(l)){if(!d){this.delete(l);return}this._data.set(l,d.slice()),E=[l]}else if(Array.isArray(l)){E=[];let S;l=[...l].sort(C._compareIndexedTuplesByUri);for(const g of l){const[a,v]=g;if((!S||a.toString()!==S.toString())&&(S&&this._data.get(S).length===0&&this._data.delete(S),S=a,E.push(a),this._data.set(a,[])),v){const t=this._data.get(a);t&&t.push(...v)}else{const t=this._data.get(a);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(E),!!this._proxy){const w=[];for(let S of E){let g=[];const a=this._data.get(S);if(a)if(a.length>this._maxDiagnosticsPerFile){g=[];const v=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let n of a)if(n.severity===v[t]&&g.push(P.Diagnostic.from(n))===this._maxDiagnosticsPerFile)break e;g.push({severity:I.MarkerSeverity.Info,message:(0,b.localize)(0,null,a.length-this._maxDiagnosticsPerFile),startLineNumber:g[g.length-1].startLineNumber,startColumn:g[g.length-1].startColumn,endLineNumber:g[g.length-1].endLineNumber,endColumn:g[g.length-1].endColumn})}else g=a.map(v=>P.Diagnostic.from(v));w.push([S,g])}this._proxy.$changeMany(this._owner,w)}}delete(l){this._checkDisposed(),this._onDidChangeDiagnostics.fire([l]),this._data.delete(l),this._proxy&&this._proxy.$changeMany(this._owner,[[l,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(l,d){this._checkDisposed();for(let E of this._data.keys())l.apply(d,[E,this.get(E),this])}get(l){this._checkDisposed();const d=this._data.get(l);return Array.isArray(d)?Object.freeze(d.slice(0)):[]}has(l){return this._checkDisposed(),Array.isArray(this._data.get(l))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(l,d){return l[0].toString()<d[0].toString()?-1:l[0].toString()>d[0].toString()?1:0}}e.DiagnosticCollection=C;let f=class Kt{constructor(l,d){this._logService=d,this._collections=new Map,this._onDidChangeDiagnostics=new D.Emitter,this.onDidChangeDiagnostics=D.Event.map(D.Event.debounce(this._onDidChangeDiagnostics.event,Kt._debouncer,50),Kt._mapper),this._proxy=l.getProxy(A.MainContext.MainThreadDiagnostics)}static _debouncer(l,d){return l?l.concat(d):d}static _mapper(l){const d=[],E=new Set;for(const w of l)typeof w=="string"?E.has(w)||(E.add(w),d.push(T.URI.parse(w))):E.has(w.toString())||(E.add(w.toString()),d.push(w));return Object.freeze(d),{uris:d}}createDiagnosticCollection(l,d){const{_collections:E,_proxy:w,_onDidChangeDiagnostics:S,_logService:g}=this,a=new class{$changeMany(n,o){w.$changeMany(n,o),g.trace("[DiagnosticCollection] change many (extension, owner, uris)",l.value,n,o.length===0?"CLEARING":o)}$clear(n){w.$clear(n),g.trace("[DiagnosticCollection] remove all (extension, owner)",l.value,n)}dispose(){w.dispose()}};let v;if(!d)d="_generated_diagnostic_collection_name_#"+Kt._idPool++,v=d;else if(!E.has(d))v=d;else{this._logService.warn(`DiagnosticCollection with name '${d}' does already exist.`);do v=d+Kt._idPool++;while(E.has(v))}return new class extends C{constructor(){super(d,v,Kt._maxDiagnosticsPerFile,a,S);E.set(v,this)}dispose(){super.dispose(),E.delete(v)}}}getDiagnostics(l){if(l)return this._getDiagnostics(l);{const d=new Map,E=[];for(const w of this._collections.values())w.forEach((S,g)=>{let a=d.get(S.toString());typeof a=="undefined"&&(a=E.length,d.set(S.toString(),a),E.push([S,[]])),E[a][1]=E[a][1].concat(...g)});return E}}_getDiagnostics(l){let d=[];for(let E of this._collections.values())E.has(l)&&(d=d.concat(E.get(l)));return d}$acceptMarkersChange(l){if(!this._mirrorCollection){const d="_generated_mirror",E=new C(d,d,Kt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(d,E),this._mirrorCollection=E}for(const[d,E]of l)this._mirrorCollection.set(T.URI.revive(d),E.map(P.Diagnostic.to))}};f._idPool=0,f._maxDiagnosticsPerFile=1e3,f=qe([He(1,k.ILogService)],f),e.ExtHostDiagnostics=f}),define(me[233],ge([0,1,2,5]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class T{constructor(y){this._proxy=y.getProxy(I.MainContext.MainThreadDialogs)}showOpenDialog(y){return this._proxy.$showOpenDialog(y).then(P=>P?P.map(D=>b.URI.revive(D)):void 0)}showSaveDialog(y){return this._proxy.$showSaveDialog(y).then(P=>P?b.URI.revive(P):void 0)}}e.ExtHostDialogs=T}),define(me[234],ge([0,1,16,2,7,5,12,21,9]),function(G,e,b,I,T,A,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(C,f,m){this._documentsAndEditors=f,this._logService=m,this._documentContentProviders=new Map,this._proxy=C.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,f){if(Object.keys(y.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const m=k._handlePool++;this._documentContentProviders.set(m,f),this._proxy.$registerTextContentProvider(m,C);let l;return typeof f.onDidChange=="function"&&(l=f.onDidChange(d=>{if(d.scheme!==C){this._logService.warn(`Provider for scheme '${C}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(d)&&this.$provideTextDocumentContent(m,d).then(E=>{if(!(!E&&typeof E!="string")){const w=this._documentsAndEditors.getDocument(d);if(!!w){const S=(0,D.splitLines)(E);if(!w.equalLines(S))return this._proxy.$onVirtualDocumentChange(d,E)}}},b.onUnexpectedError)})),new T.Disposable(()=>{this._documentContentProviders.delete(m)&&this._proxy.$unregisterTextContentProvider(m),l&&(l.dispose(),l=void 0)})}$provideTextDocumentContent(C,f){const m=this._documentContentProviders.get(C);return m?Promise.resolve(m.provideTextDocumentContent(I.URI.revive(f),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${f.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(me[235],ge([0,1,3,6,2,5,121,20,11,24]),function(G,e,b,I,T,A,y,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class i{constructor(f,m){this._onDidAddDocument=new b.Emitter,this._onDidRemoveDocument=new b.Emitter,this._onDidChangeDocument=new b.Emitter,this._onDidSaveDocument=new b.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new I.DisposableStore,this._documentLoader=new Map,this._proxy=f.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=m,this._documentsAndEditors.onDidRemoveDocuments(l=>{for(const d of l)this._onDidRemoveDocument.fire(d.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(l=>{for(const d of l)this._onDidAddDocument.fire(d.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(f){if(!!f){const m=this._documentsAndEditors.getDocument(f);if(m)return m}}getDocument(f){const m=this.getDocumentData(f);if(!(m==null?void 0:m.document))throw new Error(`Unable to retrieve document from URI '${f}'`);return m.document}ensureDocumentData(f){const m=this._documentsAndEditors.getDocument(f);if(m)return Promise.resolve(m);let l=this._documentLoader.get(f.toString());return l||(l=this._proxy.$tryOpenDocument(f).then(d=>{this._documentLoader.delete(f.toString());const E=T.URI.revive(d);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(E))},d=>(this._documentLoader.delete(f.toString()),Promise.reject(d))),this._documentLoader.set(f.toString(),l)),l}createDocumentData(f){return this._proxy.$tryCreateDocument(f).then(m=>T.URI.revive(m))}$acceptModelModeChanged(f,m){const l=T.URI.revive(f),d=this._documentsAndEditors.getDocument(l);if(!d)throw new Error("unknown document");this._onDidRemoveDocument.fire(d.document),d._acceptLanguageId(m),this._onDidAddDocument.fire(d.document)}$acceptModelSaved(f){const m=T.URI.revive(f),l=this._documentsAndEditors.getDocument(m);if(!l)throw new Error("unknown document");this.$acceptDirtyStateChanged(f,!1),this._onDidSaveDocument.fire(l.document)}$acceptDirtyStateChanged(f,m){const l=T.URI.revive(f),d=this._documentsAndEditors.getDocument(l);if(!d)throw new Error("unknown document");d._acceptIsDirty(m),this._onDidChangeDocument.fire({document:d.document,contentChanges:[]})}$acceptModelChanged(f,m,l){const d=T.URI.revive(f),E=this._documentsAndEditors.getDocument(d);if(!E)throw new Error("unknown document");E._acceptIsDirty(l),E.onEvents(m),this._onDidChangeDocument.fire((0,k.deepFreeze)({document:E.document,contentChanges:m.changes.map(w=>({range:P.Range.to(w.range),rangeOffset:w.rangeOffset,rangeLength:w.rangeLength,text:w.text}))}))}setWordDefinitionFor(f,m){(0,y.setWordDefinitionFor)(f,m)}}e.ExtHostDocuments=i}),define(me[39],ge([0,1,52,3,6,2,4,5,121,15,125,20,14,22,12,55,135]),function(G,e,b,I,T,A,y,P,D,k,i,C,f,m,l,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class w{constructor(a){this.value=a,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let S=class{constructor(a,v){this._extHostRpc=a,this._logService=v,this._activeEditorId=null,this._editors=new Map,this._documents=new m.ResourceMap,this._onDidAddDocuments=new I.Emitter,this._onDidRemoveDocuments=new I.Emitter,this._onDidChangeVisibleTextEditors=new I.Emitter,this._onDidChangeActiveTextEditor=new I.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const v=[],t=[],n=[];if(a.removedDocuments)for(const o of a.removedDocuments){const r=A.URI.revive(o),s=this._documents.get(r);(s==null?void 0:s.unref())&&(this._documents.delete(r),v.push(s.value))}if(a.addedDocuments)for(const o of a.addedDocuments){const r=A.URI.revive(o.uri);let s=this._documents.get(r);if(s&&r.scheme!==l.Schemas.vscodeNotebookCell)throw new Error(`document '${r} already exists!'`);s||(s=new w(new D.ExtHostDocumentData(this._extHostRpc.getProxy(P.MainContext.MainThreadDocuments),r,o.lines,o.EOL,o.versionId,o.modeId,o.isDirty,o.notebook)),this._documents.set(r,s),t.push(s.value)),s.ref()}if(a.removedEditors)for(const o of a.removedEditors){const r=this._editors.get(o);this._editors.delete(o),r&&n.push(r)}if(a.addedEditors)for(const o of a.addedEditors){const r=A.URI.revive(o.documentUri);b.ok(this._documents.has(r),`document '${r}' does not exist`),b.ok(!this._editors.has(o.id),`editor '${o.id}' already exists!`);const s=this._documents.get(r).value,c=new i.ExtHostTextEditor(o.id,this._extHostRpc.getProxy(P.MainContext.MainThreadTextEditors),this._logService,new E.Lazy(()=>s.document),o.selections.map(C.Selection.to),o.options,o.visibleRanges.map(h=>C.Range.to(h)),typeof o.editorPosition=="number"?C.ViewColumn.to(o.editorPosition):void 0);this._editors.set(o.id,c)}a.newActiveEditor!==void 0&&(b.ok(a.newActiveEditor===null||this._editors.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this._activeEditorId=a.newActiveEditor),(0,T.dispose)(v),(0,T.dispose)(n),a.removedDocuments&&this._onDidRemoveDocuments.fire(v),a.addedDocuments&&this._onDidAddDocuments.fire(t),(a.removedEditors||a.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(o=>o.value)),a.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(a){var v;return(v=this._documents.get(a))===null||v===void 0?void 0:v.value}allDocuments(){return d.Iterable.map(this._documents.values(),a=>a.value)}getEditor(a){return this._editors.get(a)}activeEditor(a){if(!!this._activeEditorId){const v=this._editors.get(this._activeEditorId);return a?v:v==null?void 0:v.value}}allEditors(){return[...this._editors.values()]}};S=qe([He(0,k.IExtHostRpcService),He(1,f.ILogService)],S),e.ExtHostDocumentsAndEditors=S,e.IExtHostDocumentsAndEditors=(0,y.createDecorator)("IExtHostDocumentsAndEditors")}),define(me[236],ge([0,1,2,5,6,7,20,142,9,23]),function(G,e,b,I,T,A,y,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class i{constructor(){this._schemes=[]}add(m){this._stateMachine=void 0,this._schemes.push(m)}delete(m){const l=this._schemes.indexOf(m);l>=0&&(this._schemes.splice(l,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const m=this._schemes.sort(),l=[];let d,E,w=14,S=14;for(const g of m){let a=d?(0,D.commonPrefixLength)(d,g):0;for(a===0?E=1:E=S;a<g.length;a++)a+1===g.length?(w=S,S=9):S+=1,l.push([E,g.toUpperCase().charCodeAt(a),S]),l.push([E,g.toLowerCase().charCodeAt(a),S]),E=S;d=g,S=w}l.push([9,58,10]),l.push([10,47,12]),this._stateMachine=new P.StateMachine(l)}}provideDocumentLinks(m){this._initStateMachine();const l=[],d=P.LinkComputer.computeLinks({getLineContent(E){return m.lineAt(E-1).text},getLineCount(){return m.lineCount}},this._stateMachine);for(const E of d){const w=y.DocumentLink.to(E);w.target&&l.push(w)}return l}}class C{constructor(m,l){this._extHostLanguageFeatures=l,this._linkProvider=new i,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=m.getProxy(I.MainContext.MainThreadFileSystem)}dispose(){var m;(m=this._linkProviderRegistration)===null||m===void 0||m.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(m,l,d,E={}){if(this._registeredSchemes.has(l))throw new Error(`a provider for the scheme '${l}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const w=this._handlePool++;this._linkProvider.add(l),this._registeredSchemes.add(l),this._fsProvider.set(w,d);let S=2;E.isCaseSensitive&&(S+=1024),E.isReadonly&&(S+=2048),typeof d.copy=="function"&&(S+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&(S+=4),this._proxy.$registerFileSystemProvider(w,l,S).catch(a=>{console.error(`FAILED to register filesystem provider of ${m.value}-extension for the scheme ${l}`),console.error(a)});const g=d.onDidChangeFile(a=>{const v=[];for(const t of a){let{uri:n,type:o}=t;if(n.scheme===l){let r;switch(o){case A.FileChangeType.Changed:r=0;break;case A.FileChangeType.Created:r=1;break;case A.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}v.push({resource:n,type:r})}}this._proxy.$onFileSystemChange(w,v)});return(0,T.toDisposable)(()=>{g.dispose(),this._linkProvider.delete(l),this._registeredSchemes.delete(l),this._fsProvider.delete(w),this._proxy.$unregisterProvider(w)})}static _asIStat(m){const{type:l,ctime:d,mtime:E,size:w}=m;return{type:l,ctime:d,mtime:E,size:w}}$stat(m,l){return Promise.resolve(this._getFsProvider(m).stat(b.URI.revive(l))).then(C._asIStat)}$readdir(m,l){return Promise.resolve(this._getFsProvider(m).readDirectory(b.URI.revive(l)))}$readFile(m,l){return Promise.resolve(this._getFsProvider(m).readFile(b.URI.revive(l))).then(d=>k.VSBuffer.wrap(d))}$writeFile(m,l,d,E){return Promise.resolve(this._getFsProvider(m).writeFile(b.URI.revive(l),d.buffer,E))}$delete(m,l,d){return Promise.resolve(this._getFsProvider(m).delete(b.URI.revive(l),d))}$rename(m,l,d,E){return Promise.resolve(this._getFsProvider(m).rename(b.URI.revive(l),b.URI.revive(d),E))}$copy(m,l,d,E){const w=this._getFsProvider(m);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(b.URI.revive(l),b.URI.revive(d),E))}$mkdir(m,l){return Promise.resolve(this._getFsProvider(m).createDirectory(b.URI.revive(l)))}$watch(m,l,d,E){const w=this._getFsProvider(m).watch(b.URI.revive(d),E);this._watches.set(l,w)}$unwatch(m,l){const d=this._watches.get(l);d&&(d.dispose(),this._watches.delete(l))}$open(m,l,d){const E=this._getFsProvider(m);if(!E.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(E.open(b.URI.revive(l),d))}$close(m,l){const d=this._getFsProvider(m);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(l))}$read(m,l,d,E){const w=this._getFsProvider(m);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const S=k.VSBuffer.alloc(E);return Promise.resolve(w.read(l,d,S.buffer,0,E)).then(g=>S.slice(0,g))}$write(m,l,d,E){const w=this._getFsProvider(m);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(l,d,E.buffer,0,E.byteLength))}_getFsProvider(m){const l=this._fsProvider.get(m);if(!l){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return l}}e.ExtHostFileSystem=C}),define(me[91],ge([0,1,5,45,7,23,4,15,62]),function(G,e,b,I,T,A,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let k=class Nt{constructor(C,f){const m=C.getProxy(b.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(l){return m.$stat(l).catch(Nt._handleError)},readDirectory(l){return m.$readdir(l).catch(Nt._handleError)},createDirectory(l){return m.$mkdir(l).catch(Nt._handleError)},async readFile(l){return m.$readFile(l).then(d=>d.buffer).catch(Nt._handleError)},writeFile(l,d){return m.$writeFile(l,A.VSBuffer.wrap(d)).catch(Nt._handleError)},delete(l,d){return m.$delete(l,Object.assign({recursive:!1,useTrash:!1},d)).catch(Nt._handleError)},rename(l,d,E){return m.$rename(l,d,Object.assign({overwrite:!1},E)).catch(Nt._handleError)},copy(l,d,E){return m.$copy(l,d,Object.assign({overwrite:!1},E)).catch(Nt._handleError)},isWritableFileSystem(l){const d=f.getCapabilities(l);if(typeof d=="number")return!(d&2048)}})}static _handleError(C){if(!(C instanceof Error))throw new T.FileSystemError(String(C));if(C.name==="ENOPRO")throw T.FileSystemError.Unavailable(C.message);switch(C.name){case I.FileSystemProviderErrorCode.FileExists:throw T.FileSystemError.FileExists(C.message);case I.FileSystemProviderErrorCode.FileNotFound:throw T.FileSystemError.FileNotFound(C.message);case I.FileSystemProviderErrorCode.FileNotADirectory:throw T.FileSystemError.FileNotADirectory(C.message);case I.FileSystemProviderErrorCode.FileIsADirectory:throw T.FileSystemError.FileIsADirectory(C.message);case I.FileSystemProviderErrorCode.NoPermissions:throw T.FileSystemError.NoPermissions(C.message);case I.FileSystemProviderErrorCode.Unavailable:throw T.FileSystemError.Unavailable(C.message);default:throw new T.FileSystemError(C.message,C.name)}}};k=qe([He(0,P.IExtHostRpcService),He(1,D.IExtHostFileSystemInfo)],k),e.ExtHostConsumerFileSystem=k,e.IExtHostConsumerFileSystem=(0,y.createDecorator)("IExtHostConsumerFileSystem")}),define(me[237],ge([0,1,6,5]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class T{constructor(y){this._handlePool=0,this._proxy=y.getProxy(I.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const P=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(P,y),(0,b.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=T}),define(me[238],ge([0,1,2,24,20,7,13,5,9,44,17,11,139,6,111,72,86,47,16]),function(G,e,b,I,T,A,y,P,D,k,i,C,f,m,l,d,E,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class g{constructor(z,Y){this._documents=z,this._provider=Y}provideDocumentSymbols(z,Y){const ee=this._documents.getDocument(z);return(0,y.asPromise)(()=>this._provider.provideDocumentSymbols(ee,Y)).then(se=>{if(!(0,i.isFalsyOrEmpty)(se))return se[0]instanceof A.DocumentSymbol?se.map(T.DocumentSymbol.from):g._asDocumentSymbolTree(se)})}static _asDocumentSymbolTree(z){var Y;z=z.slice(0).sort((fe,Ee)=>{let Be=fe.location.range.start.compareTo(Ee.location.range.start);return Be===0&&(Be=Ee.location.range.end.compareTo(fe.location.range.end)),Be});const ee=[],se=[];for(const fe of z){const Ee={name:fe.name||"!!MISSING: name!!",kind:T.SymbolKind.from(fe.kind),tags:((Y=fe.tags)===null||Y===void 0?void 0:Y.map(T.SymbolTag.from))||[],detail:"",containerName:fe.containerName,range:T.Range.from(fe.location.range),selectionRange:T.Range.from(fe.location.range),children:[]};for(;;){if(se.length===0){se.push(Ee),ee.push(Ee);break}const Be=se[se.length-1];if(k.Range.containsRange(Be.range,Ee.range)&&!k.Range.equalsRange(Be.range,Ee.range)){Be.children&&Be.children.push(Ee),se.push(Ee);break}se.pop()}}return ee}}class a{constructor(z,Y,ee){this._documents=z,this._commands=Y,this._provider=ee,this._cache=new E.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(z,Y){const ee=this._documents.getDocument(z),se=await this._provider.provideCodeLenses(ee,Y);if(!(!se||Y.isCancellationRequested)){const fe=this._cache.add(se),Ee=new m.DisposableStore;this._disposables.set(fe,Ee);const Be={cacheId:fe,lenses:[]};for(let pe=0;pe<se.length;pe++)Be.lenses.push({cacheId:[fe,pe],range:T.Range.from(se[pe].range),command:this._commands.toInternal(se[pe].command,Ee)});return Be}}async resolveCodeLens(z,Y){var ee;const se=z.cacheId&&this._cache.get(...z.cacheId);if(!!se){let fe;if(typeof this._provider.resolveCodeLens!="function"||se.isResolved?fe=se:fe=await this._provider.resolveCodeLens(se,Y),fe||(fe=se),!Y.isCancellationRequested){const Ee=z.cacheId&&this._disposables.get(z.cacheId[0]);if(!!Ee)return z.command=this._commands.toInternal((ee=fe.command)!==null&&ee!==void 0?ee:a._badCmd,Ee),z}}}releaseCodeLenses(z){var Y;(Y=this._disposables.get(z))===null||Y===void 0||Y.dispose(),this._disposables.delete(z),this._cache.delete(z)}}a._badCmd={command:"missing",title:"!!MISSING: command!!"};function v(Oe){return Array.isArray(Oe)?Oe.map(T.DefinitionLink.from):Oe?[T.DefinitionLink.from(Oe)]:[]}class t{constructor(z,Y){this._documents=z,this._provider=Y}provideDefinition(z,Y,ee){const se=this._documents.getDocument(z),fe=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideDefinition(se,fe,ee)).then(v)}}class n{constructor(z,Y){this._documents=z,this._provider=Y}provideDeclaration(z,Y,ee){const se=this._documents.getDocument(z),fe=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideDeclaration(se,fe,ee)).then(v)}}class o{constructor(z,Y){this._documents=z,this._provider=Y}provideImplementation(z,Y,ee){const se=this._documents.getDocument(z),fe=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideImplementation(se,fe,ee)).then(v)}}class r{constructor(z,Y){this._documents=z,this._provider=Y}provideTypeDefinition(z,Y,ee){const se=this._documents.getDocument(z),fe=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideTypeDefinition(se,fe,ee)).then(v)}}class s{constructor(z,Y){this._documents=z,this._provider=Y}provideHover(z,Y,ee){const se=this._documents.getDocument(z),fe=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideHover(se,fe,ee)).then(Ee=>{if(!(!Ee||(0,i.isFalsyOrEmpty)(Ee.contents)))return Ee.range||(Ee.range=se.getWordRangeAtPosition(fe)),Ee.range||(Ee.range=new A.Range(fe,fe)),T.Hover.from(Ee)})}}class c{constructor(z,Y){this._documents=z,this._provider=Y}provideEvaluatableExpression(z,Y,ee){const se=this._documents.getDocument(z),fe=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideEvaluatableExpression(se,fe,ee)).then(Ee=>{if(Ee)return T.EvaluatableExpression.from(Ee)})}}class h{constructor(z,Y){this._documents=z,this._provider=Y}provideInlineValues(z,Y,ee,se){const fe=this._documents.getDocument(z);return(0,y.asPromise)(()=>this._provider.provideInlineValues(fe,T.Range.to(Y),T.InlineValueContext.to(ee),se)).then(Ee=>{if(Array.isArray(Ee))return Ee.map(Be=>T.InlineValue.from(Be))})}}class _{constructor(z,Y){this._documents=z,this._provider=Y}provideDocumentHighlights(z,Y,ee){const se=this._documents.getDocument(z),fe=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideDocumentHighlights(se,fe,ee)).then(Ee=>{if(Array.isArray(Ee))return Ee.map(T.DocumentHighlight.from)})}}class u{constructor(z,Y){this._documents=z,this._provider=Y}provideLinkedEditingRanges(z,Y,ee){const se=this._documents.getDocument(z),fe=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideLinkedEditingRanges(se,fe,ee)).then(Ee=>{if(Ee&&Array.isArray(Ee.ranges))return{ranges:(0,i.coalesce)(Ee.ranges.map(T.Range.from)),wordPattern:Ee.wordPattern}})}}class p{constructor(z,Y){this._documents=z,this._provider=Y}provideReferences(z,Y,ee,se){const fe=this._documents.getDocument(z),Ee=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideReferences(fe,Ee,ee,se)).then(Be=>{if(Array.isArray(Be))return Be.map(T.location.from)})}}class R{constructor(z,Y,ee,se,fe,Ee,Be){this._documents=z,this._commands=Y,this._diagnostics=ee,this._provider=se,this._logService=fe,this._extension=Ee,this._apiDeprecation=Be,this._cache=new E.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(z,Y,ee,se){const fe=this._documents.getDocument(z),Ee=f.Selection.isISelection(Y)?T.Selection.to(Y):T.Range.to(Y),Be=[];for(const Ce of this._diagnostics.getDiagnostics(z))if(Ee.intersection(Ce.range)&&Be.push(Ce)>R._maxCodeActionsPerFile)break;const pe={diagnostics:Be,only:ee.only?new A.CodeActionKind(ee.only):void 0,triggerKind:T.CodeActionTriggerKind.to(ee.trigger)};return(0,y.asPromise)(()=>this._provider.provideCodeActions(fe,Ee,pe,se)).then(Ce=>{var Me;if(!(!(0,i.isNonEmptyArray)(Ce)||se.isCancellationRequested)){const ze=this._cache.add(Ce),_e=new m.DisposableStore;this._disposables.set(ze,_e);const Ke=[];for(let X=0;X<Ce.length;X++){const ne=Ce[X];!ne||(R._isCommand(ne)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ke.push({_isSynthetic:!0,title:ne.title,command:this._commands.toInternal(ne,_e)})):(pe.only&&(ne.kind?pe.only.contains(ne.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action is of kind '${ne.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ke.push({cacheId:[ze,X],title:ne.title,command:ne.command&&this._commands.toInternal(ne.command,_e),diagnostics:ne.diagnostics&&ne.diagnostics.map(T.Diagnostic.from),edit:ne.edit&&T.WorkspaceEdit.from(ne.edit),kind:ne.kind&&ne.kind.value,isPreferred:ne.isPreferred,disabled:(Me=ne.disabled)===null||Me===void 0?void 0:Me.reason})))}return{cacheId:ze,actions:Ke}}})}async resolveCodeAction(z,Y){var ee;const[se,fe]=z,Ee=this._cache.get(se,fe);if(!(!Ee||R._isCommand(Ee))&&!!this._provider.resolveCodeAction){const Be=(ee=await this._provider.resolveCodeAction(Ee,Y))!==null&&ee!==void 0?ee:Ee;return(Be==null?void 0:Be.edit)?T.WorkspaceEdit.from(Be.edit):void 0}}releaseCodeActions(z){var Y;(Y=this._disposables.get(z))===null||Y===void 0||Y.dispose(),this._disposables.delete(z),this._cache.delete(z)}static _isCommand(z){return typeof z.command=="string"&&typeof z.title=="string"}}R._maxCodeActionsPerFile=1e3;class O{constructor(z,Y){this._documents=z,this._provider=Y}provideDocumentFormattingEdits(z,Y,ee){const se=this._documents.getDocument(z);return(0,y.asPromise)(()=>this._provider.provideDocumentFormattingEdits(se,Y,ee)).then(fe=>{if(Array.isArray(fe))return fe.map(T.TextEdit.from)})}}class j{constructor(z,Y){this._documents=z,this._provider=Y}provideDocumentRangeFormattingEdits(z,Y,ee,se){const fe=this._documents.getDocument(z),Ee=T.Range.to(Y);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(fe,Ee,ee,se)).then(Be=>{if(Array.isArray(Be))return Be.map(T.TextEdit.from)})}}class ie{constructor(z,Y){this._documents=z,this._provider=Y,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(z,Y,ee,se,fe){const Ee=this._documents.getDocument(z),Be=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(Ee,Be,ee,se,fe)).then(pe=>{if(Array.isArray(pe))return pe.map(T.TextEdit.from)})}}class K{constructor(z,Y){this._provider=z,this._logService=Y,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(z,Y){const ee=P.IdObject.mixin({symbols:[]});return(0,y.asPromise)(()=>this._provider.provideWorkspaceSymbols(z,Y)).then(se=>{if((0,i.isNonEmptyArray)(se)){for(const fe of se)if(!!fe){if(!fe.name){this._logService.warn("INVALID SymbolInformation, lacks name",fe);continue}const Ee=P.IdObject.mixin(T.WorkspaceSymbol.from(fe));this._symbolCache.set(Ee._id,fe),ee.symbols.push(Ee)}}}).then(()=>(ee.symbols.length>0&&this._resultCache.set(ee._id,[ee.symbols[0]._id,ee.symbols[ee.symbols.length-1]._id]),ee))}async resolveWorkspaceSymbol(z,Y){if(typeof this._provider.resolveWorkspaceSymbol!="function")return z;const ee=this._symbolCache.get(z._id);if(ee){const se=await(0,y.asPromise)(()=>this._provider.resolveWorkspaceSymbol(ee,Y));return se&&(0,I.mixin)(z,T.WorkspaceSymbol.from(se),!0)}}releaseWorkspaceSymbols(z){const Y=this._resultCache.get(z);if(Y){for(let[ee,se]=Y;ee<=se;ee++)this._symbolCache.delete(ee);this._resultCache.delete(z)}}}class x{constructor(z,Y,ee){this._documents=z,this._provider=Y,this._logService=ee}static supportsResolving(z){return typeof z.prepareRename=="function"}provideRenameEdits(z,Y,ee,se){const fe=this._documents.getDocument(z),Ee=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideRenameEdits(fe,Ee,ee,se)).then(Be=>{if(!!Be)return T.WorkspaceEdit.from(Be)},Be=>{const pe=x._asMessage(Be);return pe?{rejectReason:pe,edits:void 0}:Promise.reject(Be)})}resolveRenameLocation(z,Y,ee){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const se=this._documents.getDocument(z),fe=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.prepareRename(se,fe,ee)).then(Ee=>{let Be,pe;if(A.Range.isRange(Ee)?(Be=Ee,pe=se.getText(Ee)):(0,C.isObject)(Ee)&&(Be=Ee.range,pe=Ee.placeholder),!!Be){if(Be.start.line>fe.line||Be.end.line<fe.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:T.Range.from(Be),text:pe}}},Ee=>{const Be=x._asMessage(Ee);return Be?{rejectReason:Be,range:void 0,text:void 0}:Promise.reject(Ee)})}static _asMessage(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class ${constructor(z,Y){this.resultId=z,this.tokens=Y}}class U{constructor(z,Y){this._documents=z,this._provider=Y,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(z,Y,ee){const se=this._documents.getDocument(z),fe=Y!==0?this._previousResults.get(Y):null;return(0,y.asPromise)(()=>fe&&typeof fe.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(se,fe.resultId,ee):this._provider.provideDocumentSemanticTokens(se,ee)).then(Ee=>(fe&&this._previousResults.delete(Y),Ee?(Ee=U._fixProvidedSemanticTokens(Ee),this._send(U._convertToEdits(fe,Ee),Ee)):null))}async releaseDocumentSemanticColoring(z){this._previousResults.delete(z)}static _fixProvidedSemanticTokens(z){return U._isSemanticTokens(z)?U._isCorrectSemanticTokens(z)?z:new A.SemanticTokens(new Uint32Array(z.data),z.resultId):U._isSemanticTokensEdits(z)?U._isCorrectSemanticTokensEdits(z)?z:new A.SemanticTokensEdits(z.edits.map(Y=>new A.SemanticTokensEdit(Y.start,Y.deleteCount,Y.data?new Uint32Array(Y.data):Y.data)),z.resultId):z}static _isSemanticTokens(z){return z&&!!z.data}static _isCorrectSemanticTokens(z){return z.data instanceof Uint32Array}static _isSemanticTokensEdits(z){return z&&Array.isArray(z.edits)}static _isCorrectSemanticTokensEdits(z){for(const Y of z.edits)if(!(Y.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(z,Y){if(!U._isSemanticTokens(Y)||!z||!z.tokens)return Y;const ee=z.tokens,se=ee.length,fe=Y.data,Ee=fe.length;let Be=0;const pe=Math.min(se,Ee);for(;Be<pe&&ee[Be]===fe[Be];)Be++;if(Be===se&&Be===Ee)return new A.SemanticTokensEdits([],Y.resultId);let Ce=0;const Me=pe-Be;for(;Ce<Me&&ee[se-Ce-1]===fe[Ee-Ce-1];)Ce++;return new A.SemanticTokensEdits([{start:Be,deleteCount:se-Be-Ce,data:fe.subarray(Be,Ee-Ce)}],Y.resultId)}_send(z,Y){if(U._isSemanticTokens(z)){const ee=this._nextResultId++;return this._previousResults.set(ee,new $(z.resultId,z.data)),(0,l.encodeSemanticTokensDto)({id:ee,type:"full",data:z.data})}if(U._isSemanticTokensEdits(z)){const ee=this._nextResultId++;return U._isSemanticTokens(Y)?this._previousResults.set(ee,new $(Y.resultId,Y.data)):this._previousResults.set(ee,new $(z.resultId)),(0,l.encodeSemanticTokensDto)({id:ee,type:"delta",deltas:(z.edits||[]).map(se=>({start:se.start,deleteCount:se.deleteCount,data:se.data}))})}return null}}e.DocumentSemanticTokensAdapter=U;class L{constructor(z,Y){this._documents=z,this._provider=Y}provideDocumentRangeSemanticTokens(z,Y,ee){const se=this._documents.getDocument(z);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(se,T.Range.to(Y),ee)).then(fe=>fe?this._send(fe):null)}_send(z){return(0,l.encodeSemanticTokensDto)({id:0,type:"full",data:z.data})}}e.DocumentRangeSemanticTokensAdapter=L;class N{constructor(z,Y,ee,se,fe){this._documents=z,this._commands=Y,this._provider=ee,this._apiDeprecation=se,this._extension=fe,this._cache=new E.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}async provideCompletionItems(z,Y,ee,se){const fe=this._documents.getDocument(z),Ee=T.Position.to(Y),Be=fe.getWordRangeAtPosition(Ee)||new A.Range(Ee,Ee),pe=Be.with({end:Ee}),Ce=new w.StopWatch(!0),Me=await(0,y.asPromise)(()=>this._provider.provideCompletionItems(fe,Ee,se,T.CompletionContext.to(ee)));if(!!Me&&!se.isCancellationRequested){const ze=Array.isArray(Me)?new A.CompletionList(Me):Me,_e=N.supportsResolving(this._provider)?this._cache.add(ze.items):this._cache.add([]),Ke=new m.DisposableStore;this._disposables.set(_e,Ke);const X=[],ne={x:_e,b:X,a:{replace:T.Range.from(Be),insert:T.Range.from(pe)},c:ze.isIncomplete||void 0,d:Ce.elapsed()};for(let we=0;we<ze.items.length;we++){const xe=ze.items[we],je=this._convertCompletionItem(xe,[_e,we],pe,Be);X.push(je)}return ne}}async resolveCompletionItem(z,Y){if(typeof this._provider.resolveCompletionItem=="function"){const ee=this._cache.get(...z);if(!!ee){const se=await(0,y.asPromise)(()=>this._provider.resolveCompletionItem(ee,Y));if(!!se)return this._convertCompletionItem(se,z)}}}releaseCompletionItems(z){var Y;(Y=this._disposables.get(z))===null||Y===void 0||Y.dispose(),this._disposables.delete(z),this._cache.delete(z)}_convertCompletionItem(z,Y,ee,se){var fe;const Ee=this._disposables.get(Y[0]);if(!Ee)throw Error("DisposableStore is missing...");const Be={x:Y,a:(fe=z.label)!==null&&fe!==void 0?fe:"",o:z.label2,b:z.kind!==void 0?T.CompletionItemKind.from(z.kind):void 0,n:z.tags&&z.tags.map(T.CompletionItemTag.from),c:z.detail,d:typeof z.documentation=="undefined"?void 0:T.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters,l:z.additionalTextEdits&&z.additionalTextEdits.map(T.TextEdit.from),m:this._commands.toInternal(z.command,Ee)};z.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Be.h=z.textEdit.newText):typeof z.insertText=="string"?Be.h=z.insertText:z.insertText instanceof A.SnippetString&&(Be.h=z.insertText.value,Be.i|=4);let pe;return z.textEdit?pe=z.textEdit.range:z.range&&(pe=z.range),A.Range.isRange(pe)?Be.j=T.Range.from(pe):pe&&(!(ee==null?void 0:ee.isEqual(pe.inserting))||!(se==null?void 0:se.isEqual(pe.replacing)))&&(Be.j={insert:T.Range.from(pe.inserting),replace:T.Range.from(pe.replacing)}),Be}}class M{constructor(z,Y){this._documents=z,this._provider=Y,this._cache=new E.Cache("SignatureHelp")}provideSignatureHelp(z,Y,ee,se){const fe=this._documents.getDocument(z),Ee=T.Position.to(Y),Be=this.reviveContext(ee);return(0,y.asPromise)(()=>this._provider.provideSignatureHelp(fe,Ee,se,Be)).then(pe=>{if(pe){const Ce=this._cache.add([pe]);return Object.assign(Object.assign({},T.SignatureHelp.from(pe)),{id:Ce})}})}reviveContext(z){let Y;if(z.activeSignatureHelp){const ee=T.SignatureHelp.to(z.activeSignatureHelp),se=this._cache.get(z.activeSignatureHelp.id,0);se?(Y=se,Y.activeSignature=ee.activeSignature,Y.activeParameter=ee.activeParameter):Y=ee}return Object.assign(Object.assign({},z),{activeSignatureHelp:Y})}releaseSignatureHelp(z){this._cache.delete(z)}}class F{constructor(z,Y){this._documents=z,this._provider=Y}provideInlayHints(z,Y,ee){const se=this._documents.getDocument(z);return(0,y.asPromise)(()=>this._provider.provideInlayHints(se,T.Range.to(Y),ee)).then(fe=>fe?{hints:fe.map(T.InlayHint.from)}:void 0)}}class W{constructor(z,Y){this._documents=z,this._provider=Y,this._cache=new E.Cache("DocumentLink")}provideLinks(z,Y){const ee=this._documents.getDocument(z);return(0,y.asPromise)(()=>this._provider.provideDocumentLinks(ee,Y)).then(se=>{if(!(!Array.isArray(se)||se.length===0)&&!Y.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:se.map(T.DocumentLink.from)};{const fe=this._cache.add(se),Ee={links:[],id:fe};for(let Be=0;Be<se.length;Be++){const pe=T.DocumentLink.from(se[Be]);pe.cacheId=[fe,Be],Ee.links.push(pe)}return Ee}}})}resolveLink(z,Y){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const ee=this._cache.get(...z);return ee?(0,y.asPromise)(()=>this._provider.resolveDocumentLink(ee,Y)).then(se=>se&&T.DocumentLink.from(se)||void 0):Promise.resolve(void 0)}releaseLinks(z){this._cache.delete(z)}}class q{constructor(z,Y){this._documents=z,this._provider=Y}provideColors(z,Y){const ee=this._documents.getDocument(z);return(0,y.asPromise)(()=>this._provider.provideDocumentColors(ee,Y)).then(se=>Array.isArray(se)?se.map(Ee=>({color:T.Color.from(Ee.color),range:T.Range.from(Ee.range)})):[])}provideColorPresentations(z,Y,ee){const se=this._documents.getDocument(z),fe=T.Range.to(Y.range),Ee=T.Color.to(Y.color);return(0,y.asPromise)(()=>this._provider.provideColorPresentations(Ee,{document:se,range:fe},ee)).then(Be=>{if(!!Array.isArray(Be))return Be.map(T.ColorPresentation.from)})}}class Q{constructor(z,Y){this._documents=z,this._provider=Y}provideFoldingRanges(z,Y,ee){const se=this._documents.getDocument(z);return(0,y.asPromise)(()=>this._provider.provideFoldingRanges(se,Y,ee)).then(fe=>{if(!!Array.isArray(fe))return fe.map(T.FoldingRange.from)})}}class le{constructor(z,Y,ee){this._documents=z,this._provider=Y,this._logService=ee}provideSelectionRanges(z,Y,ee){const se=this._documents.getDocument(z),fe=Y.map(T.Position.to);return(0,y.asPromise)(()=>this._provider.provideSelectionRanges(se,fe,ee)).then(Ee=>{if(!(0,i.isNonEmptyArray)(Ee))return[];if(Ee.length!==fe.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Be=[];for(let pe=0;pe<fe.length;pe++){const Ce=[];Be.push(Ce);let Me=fe[pe],ze=Ee[pe];for(;;){if(!ze.range.contains(Me))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(T.SelectionRange.from(ze)),!ze.parent)break;Me=ze.range,ze=ze.parent}}return Be})}}class ve{constructor(z,Y){this._documents=z,this._provider=Y,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(z,Y,ee){const se=this._documents.getDocument(z),fe=T.Position.to(Y),Ee=await this._provider.prepareCallHierarchy(se,fe,ee);if(!!Ee){const Be=this._idPool.nextId();return this._cache.set(Be,new Map),Array.isArray(Ee)?Ee.map(pe=>this._cacheAndConvertItem(Be,pe)):[this._cacheAndConvertItem(Be,Ee)]}}async provideCallsTo(z,Y,ee){const se=this._itemFromCache(z,Y);if(!se)throw new Error("missing call hierarchy item");const fe=await this._provider.provideCallHierarchyIncomingCalls(se,ee);if(!!fe)return fe.map(Ee=>({from:this._cacheAndConvertItem(z,Ee.from),fromRanges:Ee.fromRanges.map(Be=>T.Range.from(Be))}))}async provideCallsFrom(z,Y,ee){const se=this._itemFromCache(z,Y);if(!se)throw new Error("missing call hierarchy item");const fe=await this._provider.provideCallHierarchyOutgoingCalls(se,ee);if(!!fe)return fe.map(Ee=>({to:this._cacheAndConvertItem(z,Ee.to),fromRanges:Ee.fromRanges.map(Be=>T.Range.from(Be))}))}releaseSession(z){this._cache.delete(z)}_cacheAndConvertItem(z,Y){var ee;const se=this._cache.get(z),fe={_sessionId:z,_itemId:se.size.toString(36),name:Y.name,detail:Y.detail,kind:T.SymbolKind.from(Y.kind),uri:Y.uri,range:T.Range.from(Y.range),selectionRange:T.Range.from(Y.selectionRange),tags:(ee=Y.tags)===null||ee===void 0?void 0:ee.map(T.SymbolTag.from)};return se.set(fe._itemId,Y),fe}_itemFromCache(z,Y){const ee=this._cache.get(z);return ee==null?void 0:ee.get(Y)}}class Re{constructor(z,Y){this.adapter=z,this.extension=Y}}class Se{constructor(z,Y,ee,se,fe,Ee,Be){this._adapter=new Map,this._uriTransformer=Y,this._proxy=z.getProxy(P.MainContext.MainThreadLanguageFeatures),this._documents=ee,this._commands=se,this._diagnostics=fe,this._logService=Ee,this._apiDeprecation=Be}_transformDocumentSelector(z){return(0,i.coalesce)((0,i.asArray)(z).map(Y=>this._doTransformDocumentSelector(Y)))}_doTransformDocumentSelector(z){if(typeof z=="string")return{$serialized:!0,language:z};if(z)return{$serialized:!0,language:z.language,scheme:this._transformScheme(z.scheme),pattern:typeof z.pattern=="undefined"?void 0:T.GlobPattern.from(z.pattern),exclusive:z.exclusive}}_transformScheme(z){return this._uriTransformer&&typeof z=="string"?this._uriTransformer.transformOutgoingScheme(z):z}_createDisposable(z){return new A.Disposable(()=>{this._adapter.delete(z),this._proxy.$unregister(z)})}_nextHandle(){return Se._handlePool++}_withAdapter(z,Y,ee,se,fe=!1){const Ee=this._adapter.get(z);if(!Ee)return Promise.resolve(se);if(Ee.adapter instanceof Y){let Be;Ee.extension&&(Be=Date.now(),this._logService.trace(`[${Ee.extension.identifier.value}] INVOKE provider '${Y.name}'`));const pe=ee(Ee.adapter,Ee.extension),Ce=Ee.extension;return Ce&&Promise.resolve(pe).then(()=>this._logService.trace(`[${Ce.identifier.value}] provider DONE after ${Date.now()-Be}ms`),Me=>{fe&&Me instanceof S.CancellationError||(this._logService.error(`[${Ce.identifier.value}] provider FAILED`),this._logService.error(Me))}),pe}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(z,Y){const ee=this._nextHandle();return this._adapter.set(ee,new Re(z,Y)),ee}static _extLabel(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,Y,ee,se){const fe=this._addNewAdapter(new g(this._documents,ee),z),Ee=se&&se.label||Se._extLabel(z);return this._proxy.$registerDocumentSymbolProvider(fe,this._transformDocumentSelector(Y),Ee),this._createDisposable(fe)}$provideDocumentSymbols(z,Y,ee){return this._withAdapter(z,g,se=>se.provideDocumentSymbols(b.URI.revive(Y),ee),void 0)}registerCodeLensProvider(z,Y,ee){const se=this._nextHandle(),fe=typeof ee.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(se,new Re(new a(this._documents,this._commands.converter,ee),z)),this._proxy.$registerCodeLensSupport(se,this._transformDocumentSelector(Y),fe);let Ee=this._createDisposable(se);if(fe!==void 0){const Be=ee.onDidChangeCodeLenses(pe=>this._proxy.$emitCodeLensEvent(fe));Ee=A.Disposable.from(Ee,Be)}return Ee}$provideCodeLenses(z,Y,ee){return this._withAdapter(z,a,se=>se.provideCodeLenses(b.URI.revive(Y),ee),void 0)}$resolveCodeLens(z,Y,ee){return this._withAdapter(z,a,se=>se.resolveCodeLens(Y,ee),void 0)}$releaseCodeLenses(z,Y){this._withAdapter(z,a,ee=>Promise.resolve(ee.releaseCodeLenses(Y)),void 0)}registerDefinitionProvider(z,Y,ee){const se=this._addNewAdapter(new t(this._documents,ee),z);return this._proxy.$registerDefinitionSupport(se,this._transformDocumentSelector(Y)),this._createDisposable(se)}$provideDefinition(z,Y,ee,se){return this._withAdapter(z,t,fe=>fe.provideDefinition(b.URI.revive(Y),ee,se),[])}registerDeclarationProvider(z,Y,ee){const se=this._addNewAdapter(new n(this._documents,ee),z);return this._proxy.$registerDeclarationSupport(se,this._transformDocumentSelector(Y)),this._createDisposable(se)}$provideDeclaration(z,Y,ee,se){return this._withAdapter(z,n,fe=>fe.provideDeclaration(b.URI.revive(Y),ee,se),[])}registerImplementationProvider(z,Y,ee){const se=this._addNewAdapter(new o(this._documents,ee),z);return this._proxy.$registerImplementationSupport(se,this._transformDocumentSelector(Y)),this._createDisposable(se)}$provideImplementation(z,Y,ee,se){return this._withAdapter(z,o,fe=>fe.provideImplementation(b.URI.revive(Y),ee,se),[])}registerTypeDefinitionProvider(z,Y,ee){const se=this._addNewAdapter(new r(this._documents,ee),z);return this._proxy.$registerTypeDefinitionSupport(se,this._transformDocumentSelector(Y)),this._createDisposable(se)}$provideTypeDefinition(z,Y,ee,se){return this._withAdapter(z,r,fe=>fe.provideTypeDefinition(b.URI.revive(Y),ee,se),[])}registerHoverProvider(z,Y,ee,se){const fe=this._addNewAdapter(new s(this._documents,ee),z);return this._proxy.$registerHoverProvider(fe,this._transformDocumentSelector(Y)),this._createDisposable(fe)}$provideHover(z,Y,ee,se){return this._withAdapter(z,s,fe=>fe.provideHover(b.URI.revive(Y),ee,se),void 0)}registerEvaluatableExpressionProvider(z,Y,ee,se){const fe=this._addNewAdapter(new c(this._documents,ee),z);return this._proxy.$registerEvaluatableExpressionProvider(fe,this._transformDocumentSelector(Y)),this._createDisposable(fe)}$provideEvaluatableExpression(z,Y,ee,se){return this._withAdapter(z,c,fe=>fe.provideEvaluatableExpression(b.URI.revive(Y),ee,se),void 0)}registerInlineValuesProvider(z,Y,ee,se){const fe=typeof ee.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Ee=this._addNewAdapter(new h(this._documents,ee),z);this._proxy.$registerInlineValuesProvider(Ee,this._transformDocumentSelector(Y),fe);let Be=this._createDisposable(Ee);if(fe!==void 0){const pe=ee.onDidChangeInlineValues(Ce=>this._proxy.$emitInlineValuesEvent(fe));Be=A.Disposable.from(Be,pe)}return Be}$provideInlineValues(z,Y,ee,se,fe){return this._withAdapter(z,h,Ee=>Ee.provideInlineValues(b.URI.revive(Y),ee,se,fe),void 0)}registerDocumentHighlightProvider(z,Y,ee){const se=this._addNewAdapter(new _(this._documents,ee),z);return this._proxy.$registerDocumentHighlightProvider(se,this._transformDocumentSelector(Y)),this._createDisposable(se)}$provideDocumentHighlights(z,Y,ee,se){return this._withAdapter(z,_,fe=>fe.provideDocumentHighlights(b.URI.revive(Y),ee,se),void 0)}registerLinkedEditingRangeProvider(z,Y,ee){const se=this._addNewAdapter(new u(this._documents,ee),z);return this._proxy.$registerLinkedEditingRangeProvider(se,this._transformDocumentSelector(Y)),this._createDisposable(se)}$provideLinkedEditingRanges(z,Y,ee,se){return this._withAdapter(z,u,async fe=>{const Ee=await fe.provideLinkedEditingRanges(b.URI.revive(Y),ee,se);if(Ee)return{ranges:Ee.ranges,wordPattern:Ee.wordPattern?Se._serializeRegExp(Ee.wordPattern):void 0}},void 0)}registerReferenceProvider(z,Y,ee){const se=this._addNewAdapter(new p(this._documents,ee),z);return this._proxy.$registerReferenceSupport(se,this._transformDocumentSelector(Y)),this._createDisposable(se)}$provideReferences(z,Y,ee,se,fe){return this._withAdapter(z,p,Ee=>Ee.provideReferences(b.URI.revive(Y),ee,se,fe),void 0)}registerCodeActionProvider(z,Y,ee,se){var fe,Ee;const Be=new m.DisposableStore,pe=this._addNewAdapter(new R(this._documents,this._commands.converter,this._diagnostics,ee,this._logService,z,this._apiDeprecation),z);return this._proxy.$registerQuickFixSupport(pe,this._transformDocumentSelector(Y),{providedKinds:(fe=se==null?void 0:se.providedCodeActionKinds)===null||fe===void 0?void 0:fe.map(Ce=>Ce.value),documentation:(Ee=se==null?void 0:se.documentation)===null||Ee===void 0?void 0:Ee.map(Ce=>({kind:Ce.kind.value,command:this._commands.converter.toInternal(Ce.command,Be)}))},Se._extLabel(z),Boolean(ee.resolveCodeAction)),Be.add(this._createDisposable(pe)),Be}$provideCodeActions(z,Y,ee,se,fe){return this._withAdapter(z,R,Ee=>Ee.provideCodeActions(b.URI.revive(Y),ee,se,fe),void 0)}$resolveCodeAction(z,Y,ee){return this._withAdapter(z,R,se=>se.resolveCodeAction(Y,ee),void 0)}$releaseCodeActions(z,Y){this._withAdapter(z,R,ee=>Promise.resolve(ee.releaseCodeActions(Y)),void 0)}registerDocumentFormattingEditProvider(z,Y,ee){const se=this._addNewAdapter(new O(this._documents,ee),z);return this._proxy.$registerDocumentFormattingSupport(se,this._transformDocumentSelector(Y),z.identifier,z.displayName||z.name),this._createDisposable(se)}$provideDocumentFormattingEdits(z,Y,ee,se){return this._withAdapter(z,O,fe=>fe.provideDocumentFormattingEdits(b.URI.revive(Y),ee,se),void 0)}registerDocumentRangeFormattingEditProvider(z,Y,ee){const se=this._addNewAdapter(new j(this._documents,ee),z);return this._proxy.$registerRangeFormattingSupport(se,this._transformDocumentSelector(Y),z.identifier,z.displayName||z.name),this._createDisposable(se)}$provideDocumentRangeFormattingEdits(z,Y,ee,se,fe){return this._withAdapter(z,j,Ee=>Ee.provideDocumentRangeFormattingEdits(b.URI.revive(Y),ee,se,fe),void 0)}registerOnTypeFormattingEditProvider(z,Y,ee,se){const fe=this._addNewAdapter(new ie(this._documents,ee),z);return this._proxy.$registerOnTypeFormattingSupport(fe,this._transformDocumentSelector(Y),se,z.identifier),this._createDisposable(fe)}$provideOnTypeFormattingEdits(z,Y,ee,se,fe,Ee){return this._withAdapter(z,ie,Be=>Be.provideOnTypeFormattingEdits(b.URI.revive(Y),ee,se,fe,Ee),void 0)}registerWorkspaceSymbolProvider(z,Y){const ee=this._addNewAdapter(new K(Y,this._logService),z);return this._proxy.$registerNavigateTypeSupport(ee),this._createDisposable(ee)}$provideWorkspaceSymbols(z,Y,ee){return this._withAdapter(z,K,se=>se.provideWorkspaceSymbols(Y,ee),{symbols:[]})}$resolveWorkspaceSymbol(z,Y,ee){return this._withAdapter(z,K,se=>se.resolveWorkspaceSymbol(Y,ee),void 0)}$releaseWorkspaceSymbols(z,Y){this._withAdapter(z,K,ee=>ee.releaseWorkspaceSymbols(Y),void 0)}registerRenameProvider(z,Y,ee){const se=this._addNewAdapter(new x(this._documents,ee,this._logService),z);return this._proxy.$registerRenameSupport(se,this._transformDocumentSelector(Y),x.supportsResolving(ee)),this._createDisposable(se)}$provideRenameEdits(z,Y,ee,se,fe){return this._withAdapter(z,x,Ee=>Ee.provideRenameEdits(b.URI.revive(Y),ee,se,fe),void 0)}$resolveRenameLocation(z,Y,ee,se){return this._withAdapter(z,x,fe=>fe.resolveRenameLocation(b.URI.revive(Y),ee,se),void 0)}registerDocumentSemanticTokensProvider(z,Y,ee,se){const fe=this._nextHandle(),Ee=typeof ee.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(fe,new Re(new U(this._documents,ee),z)),this._proxy.$registerDocumentSemanticTokensProvider(fe,this._transformDocumentSelector(Y),se,Ee);let Be=this._createDisposable(fe);if(Ee){const pe=ee.onDidChangeSemanticTokens(Ce=>this._proxy.$emitDocumentSemanticTokensEvent(Ee));Be=A.Disposable.from(Be,pe)}return Be}$provideDocumentSemanticTokens(z,Y,ee,se){return this._withAdapter(z,U,fe=>fe.provideDocumentSemanticTokens(b.URI.revive(Y),ee,se),null,!0)}$releaseDocumentSemanticTokens(z,Y){this._withAdapter(z,U,ee=>ee.releaseDocumentSemanticColoring(Y),void 0)}registerDocumentRangeSemanticTokensProvider(z,Y,ee,se){const fe=this._addNewAdapter(new L(this._documents,ee),z);return this._proxy.$registerDocumentRangeSemanticTokensProvider(fe,this._transformDocumentSelector(Y),se),this._createDisposable(fe)}$provideDocumentRangeSemanticTokens(z,Y,ee,se){return this._withAdapter(z,L,fe=>fe.provideDocumentRangeSemanticTokens(b.URI.revive(Y),ee,se),null,!0)}registerCompletionItemProvider(z,Y,ee,se){const fe=this._addNewAdapter(new N(this._documents,this._commands.converter,ee,this._apiDeprecation,z),z);return this._proxy.$registerSuggestSupport(fe,this._transformDocumentSelector(Y),se,N.supportsResolving(ee),`${z.identifier.value}(${se.join("")})`),this._createDisposable(fe)}$provideCompletionItems(z,Y,ee,se,fe){return this._withAdapter(z,N,Ee=>Ee.provideCompletionItems(b.URI.revive(Y),ee,se,fe),void 0)}$resolveCompletionItem(z,Y,ee){return this._withAdapter(z,N,se=>se.resolveCompletionItem(Y,ee),void 0)}$releaseCompletionItems(z,Y){this._withAdapter(z,N,ee=>ee.releaseCompletionItems(Y),void 0)}registerSignatureHelpProvider(z,Y,ee,se){const fe=Array.isArray(se)?{triggerCharacters:se,retriggerCharacters:[]}:se,Ee=this._addNewAdapter(new M(this._documents,ee),z);return this._proxy.$registerSignatureHelpProvider(Ee,this._transformDocumentSelector(Y),fe),this._createDisposable(Ee)}$provideSignatureHelp(z,Y,ee,se,fe){return this._withAdapter(z,M,Ee=>Ee.provideSignatureHelp(b.URI.revive(Y),ee,se,fe),void 0)}$releaseSignatureHelp(z,Y){this._withAdapter(z,M,ee=>ee.releaseSignatureHelp(Y),void 0)}registerInlayHintsProvider(z,Y,ee){const se=typeof ee.onDidChangeInlayHints=="function"?this._nextHandle():void 0,fe=this._addNewAdapter(new F(this._documents,ee),z);this._proxy.$registerInlayHintsProvider(fe,this._transformDocumentSelector(Y),se);let Ee=this._createDisposable(fe);if(se!==void 0){const Be=ee.onDidChangeInlayHints(pe=>this._proxy.$emitInlayHintsEvent(se));Ee=A.Disposable.from(Ee,Be)}return Ee}$provideInlayHints(z,Y,ee,se){return this._withAdapter(z,F,fe=>fe.provideInlayHints(b.URI.revive(Y),ee,se),void 0)}registerDocumentLinkProvider(z,Y,ee){const se=this._addNewAdapter(new W(this._documents,ee),z);return this._proxy.$registerDocumentLinkProvider(se,this._transformDocumentSelector(Y),typeof ee.resolveDocumentLink=="function"),this._createDisposable(se)}$provideDocumentLinks(z,Y,ee){return this._withAdapter(z,W,se=>se.provideLinks(b.URI.revive(Y),ee),void 0)}$resolveDocumentLink(z,Y,ee){return this._withAdapter(z,W,se=>se.resolveLink(Y,ee),void 0)}$releaseDocumentLinks(z,Y){this._withAdapter(z,W,ee=>ee.releaseLinks(Y),void 0)}registerColorProvider(z,Y,ee){const se=this._addNewAdapter(new q(this._documents,ee),z);return this._proxy.$registerDocumentColorProvider(se,this._transformDocumentSelector(Y)),this._createDisposable(se)}$provideDocumentColors(z,Y,ee){return this._withAdapter(z,q,se=>se.provideColors(b.URI.revive(Y),ee),[])}$provideColorPresentations(z,Y,ee,se){return this._withAdapter(z,q,fe=>fe.provideColorPresentations(b.URI.revive(Y),ee,se),void 0)}registerFoldingRangeProvider(z,Y,ee){const se=this._nextHandle(),fe=typeof ee.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(se,new Re(new Q(this._documents,ee),z)),this._proxy.$registerFoldingRangeProvider(se,this._transformDocumentSelector(Y),fe);let Ee=this._createDisposable(se);if(fe!==void 0){const Be=ee.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(fe));Ee=A.Disposable.from(Ee,Be)}return Ee}$provideFoldingRanges(z,Y,ee,se){return this._withAdapter(z,Q,fe=>fe.provideFoldingRanges(b.URI.revive(Y),ee,se),void 0)}registerSelectionRangeProvider(z,Y,ee){const se=this._addNewAdapter(new le(this._documents,ee,this._logService),z);return this._proxy.$registerSelectionRangeProvider(se,this._transformDocumentSelector(Y)),this._createDisposable(se)}$provideSelectionRanges(z,Y,ee,se){return this._withAdapter(z,le,fe=>fe.provideSelectionRanges(b.URI.revive(Y),ee,se),[])}registerCallHierarchyProvider(z,Y,ee){const se=this._addNewAdapter(new ve(this._documents,ee),z);return this._proxy.$registerCallHierarchyProvider(se,this._transformDocumentSelector(Y)),this._createDisposable(se)}$prepareCallHierarchy(z,Y,ee,se){return this._withAdapter(z,ve,fe=>Promise.resolve(fe.prepareSession(b.URI.revive(Y),ee,se)),void 0)}$provideCallHierarchyIncomingCalls(z,Y,ee,se){return this._withAdapter(z,ve,fe=>fe.provideCallsTo(Y,ee,se),void 0)}$provideCallHierarchyOutgoingCalls(z,Y,ee,se){return this._withAdapter(z,ve,fe=>fe.provideCallsFrom(Y,ee,se),void 0)}$releaseCallHierarchy(z,Y){this._withAdapter(z,ve,ee=>Promise.resolve(ee.releaseSession(Y)),void 0)}static _serializeRegExp(z){return{pattern:z.source,flags:(0,D.regExpFlags)(z)}}static _serializeIndentationRule(z){return{decreaseIndentPattern:Se._serializeRegExp(z.decreaseIndentPattern),increaseIndentPattern:Se._serializeRegExp(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?Se._serializeRegExp(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?Se._serializeRegExp(z.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(z){return{beforeText:Se._serializeRegExp(z.beforeText),afterText:z.afterText?Se._serializeRegExp(z.afterText):void 0,previousLineText:z.previousLineText?Se._serializeRegExp(z.previousLineText):void 0,action:z.action}}static _serializeOnEnterRules(z){return z.map(Se._serializeOnEnterRule)}setLanguageConfiguration(z,Y,ee){let{wordPattern:se}=ee;if(se&&(0,D.regExpLeadsToEndlessLoop)(se))throw new Error(`Invalid language configuration: wordPattern '${se}' is not allowed to match the empty string.`);se?this._documents.setWordDefinitionFor(Y,se):this._documents.setWordDefinitionFor(Y,void 0),ee.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),ee.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const fe=this._nextHandle(),Ee={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?Se._serializeRegExp(ee.wordPattern):void 0,indentationRules:ee.indentationRules?Se._serializeIndentationRule(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?Se._serializeOnEnterRules(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport};return this._proxy.$setLanguageConfiguration(fe,Y,Ee),this._createDisposable(fe)}$setWordDefinitions(z){for(const Y of z)this._documents.setWordDefinitionFor(Y.languageId,new RegExp(Y.regexSource,Y.regexFlags))}}e.ExtHostLanguageFeatures=Se,Se._handlePool=0}),define(me[239],ge([0,1,5,20,7]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class A{constructor(P,D){this._proxy=P.getProxy(b.MainContext.MainThreadLanguages),this._documents=D}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(P,D){await this._proxy.$changeLanguage(P,D);const k=this._documents.getDocumentData(P);if(!k)throw new Error(`document '${P.toString}' NOT found`);return k.document}async tokenAtPosition(P,D){var k;const i=P.version,C=I.Position.from(D),f=await this._proxy.$tokensAtPosition(P.uri,C),m={type:T.StandardTokenType.Other,range:(k=P.getWordRangeAtPosition(D))!==null&&k!==void 0?k:new T.Range(D.line,D.character,D.line,D.character)};if(!f)return m;const l={range:I.Range.to(f.range),type:I.TokenType.to(f.type)};return!l.range.contains(D)||i!==P.version?m:l}}e.ExtHostLanguages=A}),define(me[240],ge([0,1,5,14,41]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(P){return P&&P.title}let y=class{constructor(D,k){this._logService=k,this._proxy=D.getProxy(b.MainContext.MainThreadMessageService)}showMessage(D,k,i,C,f){const m={extension:D};let l;typeof C=="string"||A(C)?l=[C,...f]:(m.modal=C&&C.modal,m.useCustom=C&&C.useCustom,l=f),m.useCustom&&(0,T.checkProposedApiEnabled)(D);const d=[];for(let E=0;E<l.length;E++){const w=l[E];if(typeof w=="string")d.push({title:w,handle:E,isCloseAffordance:!1});else if(typeof w=="object"){let{title:S,isCloseAffordance:g}=w;d.push({title:S,isCloseAffordance:!!g,handle:E})}else this._logService.warn("Invalid message item:",w)}return this._proxy.$showMessage(k,i,m,d).then(E=>{if(typeof E=="number")return l[E]})}};y=qe([He(1,I.ILogService)],y),e.ExtHostMessageService=y}),define(me[241],ge([0,1,13,23,21,3,74,72,6,22,9,11,2,86,5,20,7,89,217,218]),function(G,e,b,I,T,A,y,P,D,k,i,C,f,m,l,d,E,w,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=void 0;class a{constructor(s,c){const h=a._Keys.nextId();s.$registerNotebookEditorDecorationType(h,d.NotebookDecorationRenderOptions.from(c)),this.value={key:h,dispose(){s.$removeNotebookEditorDecorationType(h)}}}}e.NotebookEditorDecorationType=a,a._Keys=new P.IdGenerator("NotebookEditorDecorationType");class v{constructor(s,c,h,_,u,p){this._textDocumentsAndEditors=h,this._textDocuments=_,this.logService=u,this._extensionStoragePaths=p,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new k.ResourceMap,this._editors=new Map,this._onDidChangeNotebookEditorSelection=new A.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new A.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new A.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new A.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new A.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new A.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new A.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new A.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new A.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new A.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new A.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new A.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._activeExecutions=new k.ResourceMap,this._statusBarCache=new m.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=s.getProxy(l.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=s.getProxy(l.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=s.getProxy(l.MainContext.MainThreadNotebookEditors),this._commandsConverter=c.converter,c.registerArgumentProcessor({processArgument:R=>{var O;if(R&&R.$mid===12){const j=(O=R.notebookEditor)===null||O===void 0?void 0:O.notebookUri,ie=R.cell.handle,K=this._documents.get(j),x=K==null?void 0:K.getCell(ie);if(x)return x.apiCell}return R}})}get activeNotebookEditor(){var s;return(s=this._activeNotebookEditor)===null||s===void 0?void 0:s.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(s=>s.apiEditor)}getEditorById(s){return this._editors.get(s)}getIdByEditor(s){for(const[c,h]of this._editors)if(h.apiEditor===s)return c}get notebookDocuments(){return[...this._documents.values()]}lookupNotebookDocument(s){return this._documents.get(s)}_getNotebookDocument(s){const c=this._documents.get(s);if(!c)throw new Error(`NO notebook document for '${s}'`);return c}_getProviderData(s){const c=this._notebookContentProviders.get(s);if(!c)throw new Error(`NO provider for '${s}'`);return c}registerNotebookContentProvider(s,c,h,_,u){if((0,i.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(c))throw new Error(`Notebook provider for '${c}' already registered`);this._notebookContentProviders.set(c,{extension:s,provider:h});let p;return h.onDidChangeNotebookContentOptions&&(p=h.onDidChangeNotebookContentOptions(()=>{const R=d.NotebookDocumentContentOptions.from(h.options);this._notebookProxy.$updateNotebookProviderOptions(c,R)})),this._notebookProxy.$registerNotebookProvider({id:s.identifier,location:s.extensionLocation},c,d.NotebookDocumentContentOptions.from(_),v._convertNotebookRegistrationData(s,u)),new E.Disposable(()=>{p==null||p.dispose(),this._notebookContentProviders.delete(c),this._notebookProxy.$unregisterNotebookProvider(c)})}static _convertNotebookRegistrationData(s,c){if(!!c){const h=c.filenamePattern.map(_=>d.NotebookExclusiveDocumentPattern.from(_)).filter(_=>_!==void 0);if(c.filenamePattern&&!h){console.warn(`Notebook content provider view options file name pattern is invalid ${c.filenamePattern}`);return}return{providerDisplayName:s.displayName||s.name,displayName:c.displayName,filenamePattern:h,exclusive:c.exclusive||!1}}}registerNotebookCellStatusBarItemProvider(s,c,h){const _=v._notebookStatusBarItemProviderHandlePool++,u=typeof h.onDidChangeCellStatusBarItems=="function"?v._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(_,h),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(_,u,c);let p;return u!==void 0&&(p=h.onDidChangeCellStatusBarItems(R=>this._notebookProxy.$emitCellStatusBarEvent(u))),new E.Disposable(()=>{this._notebookStatusBarItemProviders.delete(_),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(_,u),p&&p.dispose()})}createNotebookEditorDecorationType(s){return new a(this._notebookEditorsProxy,s).value}async openNotebookDocument(s){const c=this._documents.get(s);if(c)return c.apiNotebook;const h=await this._notebookDocumentsProxy.$tryOpenDocument(s),_=this._documents.get(f.URI.revive(h));return(0,C.assertIsDefined)(_==null?void 0:_.apiNotebook)}async showNotebookDocument(s,c){var h;f.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let _;typeof c=="object"?_={position:d.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selections:c.selections&&c.selections.map(d.NotebookRange.from),pinned:typeof c.preview=="boolean"?!c.preview:void 0}:_={preserveFocus:!1};const u=await this._notebookEditorsProxy.$tryShowNotebookDocument(s.uri,s.viewType,_),p=u&&((h=this._editors.get(u))===null||h===void 0?void 0:h.apiEditor);if(p)return p;throw u?new Error(`Could NOT open editor for "${s.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.toString()}".`)}async $provideNotebookCellStatusBarItems(s,c,h,_){var u;const p=this._notebookStatusBarItemProviders.get(s),R=f.URI.revive(c),O=this._documents.get(R);if(!(!O||!p)){const j=O.getCellFromIndex(h);if(!!j){const ie=await p.provideCellStatusBarItems(j.apiCell,_);if(!!ie){const K=new D.DisposableStore,x=this._statusBarCache.add([K]),$=(u=ie&&ie.map(U=>d.NotebookStatusBarItem.from(U,this._commandsConverter,K)))!==null&&u!==void 0?u:void 0;return{cacheId:x,items:$}}}}}$releaseNotebookCellStatusBarItems(s){this._statusBarCache.delete(s)}registerNotebookSerializer(s,c,h,_,u){if((0,i.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");const p=this._handlePool++;return this._notebookSerializer.set(p,h),this._notebookProxy.$registerNotebookSerializer(p,{id:s.identifier,location:s.extensionLocation},c,d.NotebookDocumentContentOptions.from(_),v._convertNotebookRegistrationData(s,u)),(0,D.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(p)})}async $dataToNotebook(s,c,h){const _=this._notebookSerializer.get(s);if(!_)throw new Error("NO serializer found");const u=await _.deserializeNotebook(c.buffer,h);return{metadata:d.NotebookDocumentMetadata.from(u.metadata),cells:u.cells.map(d.NotebookCellData.from)}}async $notebookToData(s,c,h){const _=this._notebookSerializer.get(s);if(!_)throw new Error("NO serializer found");const u=await _.serializeNotebook({metadata:d.NotebookDocumentMetadata.to(c.metadata),cells:c.cells.map(d.NotebookCellData.to)},h);return I.VSBuffer.wrap(u)}cancelOneNotebookCellExecution(s){const c=this._activeExecutions.get(s.uri);c==null||c.cancel()}async $openNotebook(s,c,h,_,u){const{provider:p}=this._getProviderData(s),R=await p.openNotebook(f.URI.revive(c),{backupId:h,untitledDocumentData:_==null?void 0:_.buffer},u);return{metadata:d.NotebookDocumentMetadata.from(R.metadata),cells:R.cells.map(d.NotebookCellData.from)}}async $saveNotebook(s,c,h){const _=this._getNotebookDocument(f.URI.revive(c)),{provider:u}=this._getProviderData(s);return await u.saveNotebook(_.apiNotebook,h),!0}async $saveNotebookAs(s,c,h,_){const u=this._getNotebookDocument(f.URI.revive(c)),{provider:p}=this._getProviderData(s);return await p.saveNotebookAs(f.URI.revive(h),u.apiNotebook,_),!0}async $backupNotebook(s,c,h){var _;const u=this._getNotebookDocument(f.URI.revive(c)),p=this._getProviderData(s),R=(_=this._extensionStoragePaths.workspaceValue(p.extension))!==null&&_!==void 0?_:this._extensionStoragePaths.globalValue(p.extension),O=String((0,y.hash)([u.uri.toString(),this._backupIdPool++])),j=f.URI.joinPath(R,O),ie=await p.provider.backupNotebook(u.apiNotebook,{destination:j},h);return u.updateBackup(ie),ie.id}$acceptModelChanged(s,c,h){this._getNotebookDocument(f.URI.revive(s)).acceptModelChanged(c,h)}$acceptDirtyStateChanged(s,c){const h=this._getNotebookDocument(f.URI.revive(s));h.acceptModelChanged({rawEvents:[],versionId:h.apiNotebook.version},c)}$acceptModelSaved(s){const c=this._getNotebookDocument(f.URI.revive(s));this._onDidSaveNotebookDocument.fire(c.apiNotebook)}$acceptEditorPropertiesChanged(s,c){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",s,c);const h=this._editors.get(s);if(!h)throw new Error(`unknown text editor: ${s}. known editors: ${[...this._editors.keys()]} `);c.visibleRanges&&h._acceptVisibleRanges(c.visibleRanges.ranges.map(d.NotebookRange.to)),c.selections&&h._acceptSelections(c.selections.selections.map(d.NotebookRange.to)),c.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:h.apiEditor,visibleRanges:h.apiEditor.visibleRanges}),c.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:h.apiEditor,selections:h.apiEditor.selections}))}$acceptEditorViewColumns(s){for(const c in s){const h=this._editors.get(c);if(!h)throw new Error(`unknown text editor: ${c}. known editors: ${[...this._editors.keys()]} `);h._acceptViewColumn(d.ViewColumn.to(s[c]))}}$acceptDocumentPropertiesChanged(s,c){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",s.path,c);const h=this._getNotebookDocument(f.URI.revive(s));h.acceptDocumentPropertiesChanged(c),c.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:h.apiNotebook})}_createExtHostEditor(s,c,h){if(this._editors.has(c))throw new Error(`editor with id ALREADY EXSIST: ${c}`);const _=new g.ExtHostNotebookEditor(c,this._notebookEditorsProxy,s,h.visibleRanges.map(d.NotebookRange.to),h.selections.map(d.NotebookRange.to),typeof h.viewColumn=="number"?d.ViewColumn.to(h.viewColumn):void 0);this._editors.set(c,_)}$acceptDocumentAndEditorsDelta(s){var c,h,_;if(s.removedDocuments)for(const p of s.removedDocuments){const R=f.URI.revive(p),O=this._documents.get(R);O&&(O.dispose(),this._documents.delete(R),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:O.apiNotebook.getCells().map(j=>j.document.uri)}),this._onDidCloseNotebookDocument.fire(O.apiNotebook));for(const j of this._editors.values())j.notebookData.uri.toString()===R.toString()&&this._editors.delete(j.id)}if(s.addedDocuments){const p=[];for(const R of s.addedDocuments){const O=f.URI.revive(R.uri),j=R.viewType;if(this._documents.has(O))throw new Error(`adding EXISTING notebook ${O} `);const ie=this,K=new S.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(x){ie._onDidChangeNotebookCells.fire(x)},emitCellOutputsChange(x){ie._onDidChangeCellOutputs.fire(x)},emitCellMetadataChange(x){ie._onDidChangeCellMetadata.fire(x)},emitCellExecutionStateChange(x){ie._onDidChangeCellExecutionState.fire(x)}},j,R.metadata?d.NotebookDocumentMetadata.to(R.metadata):new E.NotebookDocumentMetadata,O);K.acceptModelChanged({versionId:R.versionId,rawEvents:[{kind:w.NotebookCellsChangeType.Initialize,changes:[[0,0,R.cells]]}]},!1),p.push(...R.cells.map(x=>S.ExtHostCell.asModelAddData(K.apiNotebook,x))),(c=this._documents.get(O))===null||c===void 0||c.dispose(),this._documents.set(O,K),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:p}),this._onDidOpenNotebookDocument.fire(K.apiNotebook)}}if(s.addedEditors)for(const p of s.addedEditors){if(this._editors.has(p.id))return;const R=f.URI.revive(p.documentUri),O=this._documents.get(R);O&&this._createExtHostEditor(O,p.id,p)}const u=[];if(s.removedEditors)for(const p of s.removedEditors){const R=this._editors.get(p);R&&(this._editors.delete(p),((h=this._activeNotebookEditor)===null||h===void 0?void 0:h.id)===R.id&&(this._activeNotebookEditor=void 0),u.push(R))}if(s.visibleEditors){this._visibleNotebookEditors=s.visibleEditors.map(R=>this._editors.get(R)).filter(R=>!!R);const p=new Set;this._visibleNotebookEditors.forEach(R=>p.add(R.id));for(const R of this._editors.values()){const O=p.has(R.id);R._acceptVisibility(O)}this._visibleNotebookEditors=[...this._editors.values()].map(R=>R).filter(R=>R.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}s.newActiveEditor===null?this._activeNotebookEditor=void 0:s.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(s.newActiveEditor)),s.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((_=this._activeNotebookEditor)===null||_===void 0?void 0:_.apiEditor)}createNotebookCellExecution(s,c,h){const _=this.lookupNotebookDocument(s);if(!_)throw new Error(`Invalid uri: ${s} `);const u=_.getCellFromIndex(c);if(!u)throw new Error(`Invalid cell index: ${s}, ${c} `);if(this._activeExecutions.has(u.uri))throw new Error(`duplicate execution for ${u.uri}`);const p=new n(s,_,u,this._notebookDocumentsProxy);this._activeExecutions.set(u.uri,p);const R=p.onDidChangeState(()=>{p.state===t.Resolved&&(p.dispose(),R.dispose(),this._activeExecutions.delete(u.uri))});return p.asApiObject()}}e.ExtHostNotebookController=v,v._notebookStatusBarItemProviderHandlePool=0;var t;(function(r){r[r.Init=0]="Init",r[r.Started=1]="Started",r[r.Resolved=2]="Resolved"})(t||(t={}));class n extends D.Disposable{constructor(s,c,h,_){super();this._uri=s,this._document=c,this._cell=h,this._proxy=_,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=t.Init,this._tokenSource=this._register(new T.CancellationTokenSource),this._collector=new o(10,u=>this.applyEdits(u)),this._executionOrder=h.internalMetadata.executionOrder,this.mixinMetadata({runState:E.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(s){await this._collector.addItem(s)}async applyEdits(s){return this._proxy.$applyEdits(this._uri,s,!1)}verifyStateForOutput(){if(this._state===t.Init)throw new Error("Must call start before modifying cell output");if(this._state===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(s){const c={editType:8,handle:this._cell.handle,metadata:s};this.applyEdits([c])}cellIndexToHandle(s){const c=typeof s=="number"?this._document.getCellFromIndex(s):this._cell;if(!!c)return c.handle}asApiObject(){const s=this;return Object.freeze({get document(){return s._document.apiNotebook},get cell(){return s._cell.apiCell},get executionOrder(){return s._executionOrder},set executionOrder(c){s._executionOrder=c,s.mixinMetadata({executionOrder:c})},start(c){var h;if(s._state===t.Resolved||s._state===t.Started)throw new Error("Cannot call start again");s._state=t.Started,s._onDidChangeState.fire(),s.mixinMetadata({runState:E.NotebookCellExecutionState.Executing,runStartTime:(h=c==null?void 0:c.startTime)!==null&&h!==void 0?h:null})},end(c){var h,_;if(s._state===t.Resolved)throw new Error("Cannot call resolve twice");s._state=t.Resolved,s._onDidChangeState.fire(),s.mixinMetadata({runState:E.NotebookCellExecutionState.Idle,lastRunSuccess:(h=c==null?void 0:c.success)!==null&&h!==void 0?h:null,runEndTime:(_=c==null?void 0:c.endTime)!==null&&_!==void 0?_:null})},clearOutput(c){return s.verifyStateForOutput(),this.replaceOutput([],c)},async appendOutput(c,h){s.verifyStateForOutput();const _=s.cellIndexToHandle(h);if(typeof _=="number")return c=Array.isArray(c)?c:[c],s.applyEditSoon({editType:2,handle:_,append:!0,outputs:c.map(d.NotebookCellOutput.from)})},async replaceOutput(c,h){s.verifyStateForOutput();const _=s.cellIndexToHandle(h);if(typeof _=="number")return c=Array.isArray(c)?c:[c],s.applyEditSoon({editType:2,handle:_,outputs:c.map(d.NotebookCellOutput.from)})},async appendOutputItems(c,h){return s.verifyStateForOutput(),c=Array.isArray(c)?c:[c],s.applyEditSoon({editType:7,append:!0,items:c.map(d.NotebookCellOutputItem.from),outputId:h})},async replaceOutputItems(c,h){return s.verifyStateForOutput(),c=Array.isArray(c)?c:[c],s.applyEditSoon({editType:7,items:c.map(d.NotebookCellOutputItem.from),outputId:h})},token:s._tokenSource.token})}}class o{constructor(s,c){this.delay=s,this.callback=c,this.batch=[]}addItem(s){return this.batch.push(s),this.waitPromise||(this.waitPromise=(0,b.timeout)(this.delay).then(()=>{this.waitPromise=void 0;const c=this.batch;return this.batch=[],this.callback(c)})),this.waitPromise}}}),define(me[242],ge([0,1,3,6,5,27,2,20,88,22]),function(G,e,b,I,T,A,y,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;class i{constructor(f,m,l){this._initData=m,this._extHostNotebook=l,this._kernelData=new Map,this._handlePool=0,this._proxy=f.getProxy(T.MainContext.MainThreadNotebookKernels)}createNotebookController(f,m,l,d,E,w){for(let R of this._kernelData.values())if(R.controller.id===m&&A.ExtensionIdentifier.equals(f.identifier,R.extensionId))throw new Error(`notebook controller with id '${m}' ALREADY exist`);const S=this._handlePool++,g=this,a=()=>console.warn(`NO execute handler from notebook controller '${r.id}' of extension: '${f.identifier}'`);let v=!1;const t=new I.DisposableStore,n=new b.Emitter,o=new b.Emitter,r={id:`${f.identifier.value}/${m}`,viewType:l,extensionId:f.identifier,extensionLocation:f.extensionLocation,label:d||f.identifier.value,preloads:w?w.map(P.NotebookKernelPreload.from):[]};let s=E!=null?E:a,c;this._proxy.$addKernel(S,r).catch(R=>{console.log(R),v=!0});let h=0;const _=()=>{if(!v){const R=++h;Promise.resolve().then(()=>{R===h&&this._proxy.$updateKernel(S,r)})}},u=new k.ResourceMap,p={get id(){return m},get viewType(){return r.viewType},onDidChangeNotebookAssociation:n.event,get label(){return r.label},set label(R){var O;r.label=(O=R!=null?R:f.displayName)!==null&&O!==void 0?O:f.name,_()},get detail(){var R;return(R=r.detail)!==null&&R!==void 0?R:""},set detail(R){r.detail=R,_()},get description(){var R;return(R=r.description)!==null&&R!==void 0?R:""},set description(R){r.description=R,_()},get supportedLanguages(){return r.supportedLanguages},set supportedLanguages(R){r.supportedLanguages=R,_()},get hasExecutionOrder(){var R;return(R=r.hasExecutionOrder)!==null&&R!==void 0?R:!1},set hasExecutionOrder(R){r.hasExecutionOrder=R,_()},get preloads(){return r.preloads?r.preloads.map(P.NotebookKernelPreload.to):[]},get executeHandler(){return s},set executeHandler(R){s=R!=null?R:a},get interruptHandler(){return c},set interruptHandler(R){c=R,r.supportsInterrupt=Boolean(R),_()},createNotebookCellExecutionTask(R){if(v)throw new Error("notebook controller is DISPOSED");if(!u.has(R.notebook.uri))throw new Error(`notebook controller is NOT associated to notebook: ${R.notebook.uri.toString()}`);return g._extHostNotebook.createNotebookCellExecution(R.notebook.uri,R.index,r.id)},dispose:()=>{v||(v=!0,this._kernelData.delete(S),t.dispose(),n.dispose(),o.dispose(),this._proxy.$removeKernel(S))},onDidReceiveMessage:o.event,postMessage(R,O){return g._proxy.$postMessage(S,O&&g._extHostNotebook.getIdByEditor(O),R)},asWebviewUri(R){return(0,D.asWebviewUri)(g._initData.environment,String(S),R)},updateNotebookAffinity(R,O){g._proxy.$updateNotebookPriority(S,R.uri,O)}};return this._kernelData.set(S,{extensionId:f.identifier,controller:p,onDidReceiveMessage:o,onDidChangeSelection:n,associatedNotebooks:u}),p}$acceptSelection(f,m,l){const d=this._kernelData.get(f);if(d){const E=this._extHostNotebook.lookupNotebookDocument(y.URI.revive(m));l?d.associatedNotebooks.set(E.uri,!0):d.associatedNotebooks.delete(E.uri),d.onDidChangeSelection.fire({selected:l,notebook:E.apiNotebook})}}async $executeCells(f,m,l){const d=this._kernelData.get(f);if(!!d){const E=this._extHostNotebook.lookupNotebookDocument(y.URI.revive(m));if(!E)throw new Error("MISSING notebook");const w=[];for(let S of l){const g=E.getCell(S);g&&w.push(g.apiCell)}try{await d.controller.executeHandler.call(d.controller,w,E.apiNotebook,d.controller)}catch(S){console.error(S)}}}async $cancelCells(f,m,l){const d=this._kernelData.get(f);if(!!d){const E=this._extHostNotebook.lookupNotebookDocument(y.URI.revive(m));if(!E)throw new Error("MISSING notebook");d.controller.interruptHandler&&await d.controller.interruptHandler.call(d.controller,E.apiNotebook);for(let w of l){const S=E.getCell(w);S&&this._extHostNotebook.cancelOneNotebookCellExecution(S)}}}$acceptKernelMessageFromRenderer(f,m,l){const d=this._kernelData.get(f);if(!!d){const E=this._extHostNotebook.getEditorById(m);if(!E)throw new Error(`send message for UNKNOWN editor: ${m}`);d.onDidReceiveMessage.fire(Object.freeze({editor:E.apiEditor,message:l}))}}}e.ExtHostNotebookKernels=i}),define(me[65],ge([0,1,5,3,6,23,4,15]),function(G,e,b,I,T,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class D extends T.Disposable{constructor(l,d,E,w){super();this._onDidAppend=this._register(new I.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=l,this._proxy=w,this._id=w.$register(this.name,d,E),this._disposed=!1,this._offset=0}get name(){return this._name}append(l){this.validate(),this._offset+=l?A.VSBuffer.fromString(l).byteLength:0}update(){this._id.then(l=>this._proxy.$update(l))}appendLine(l){this.validate(),this.append(l+`
`)}clear(){this.validate();const l=this._offset;this._id.then(d=>this._proxy.$clear(d,l))}show(l,d){this.validate(),this._id.then(E=>this._proxy.$reveal(E,!!(typeof l=="boolean"?l:d)))}hide(){this.validate(),this._id.then(l=>this._proxy.$close(l))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(l=>this._proxy.$dispose(l)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=D;class k extends D{constructor(l,d){super(l,!1,void 0,d)}append(l){super.append(l),this._id.then(d=>this._proxy.$append(d,l)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=k;class i extends D{constructor(l,d,E){super(l,!0,d,E)}append(l){throw new Error("Not supported")}}class C{constructor(l,d){this.name=l,this._channel=d}append(l){this._channel.then(d=>d.append(l))}appendLine(l){this._channel.then(d=>d.appendLine(l))}clear(){this._channel.then(l=>l.clear())}show(l,d){this._channel.then(E=>E.show(l,d))}hide(){this._channel.then(l=>l.hide())}dispose(){this._channel.then(l=>l.dispose())}}e.LazyOutputChannel=C;let f=class{constructor(l){this._proxy=l.getProxy(b.MainContext.MainThreadOutputService)}$setVisibleChannel(l){}createOutputChannel(l){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");return new k(l,this._proxy)}createOutputChannelFromLogFile(l,d){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");if(!d)throw new Error("illegal argument `file`. must not be falsy");return new i(l,d,this._proxy)}};f=qe([He(0,P.IExtHostRpcService)],f),e.ExtHostOutputService=f,e.IExtHostOutputService=(0,y.createDecorator)("IExtHostOutputService")}),define(me[243],ge([0,1,13,21,3,6,5,2,7,16,17,58]),function(G,e,b,I,T,A,y,P,D,k,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function f(m,l,d){const E=m.getProxy(y.MainContext.MainThreadQuickOpen);class w{constructor(r,s){this._sessions=new Map,this._instances=0,this._workspace=r,this._commands=s}showQuickPick(r,s,c,h=I.CancellationToken.None){this._onDidSelectItem=void 0;const _=Promise.resolve(r),u=++this._instances,p=E.$show(u,{title:c==null?void 0:c.title,placeHolder:c==null?void 0:c.placeHolder,matchOnDescription:c==null?void 0:c.matchOnDescription,matchOnDetail:c==null?void 0:c.matchOnDetail,ignoreFocusLost:c==null?void 0:c.ignoreFocusOut,canPickMany:c==null?void 0:c.canPickMany},h),R={},O=p.then(()=>R);return Promise.race([O,_]).then(j=>{if(j!==R)return _.then(ie=>{const K=[];for(let x=0;x<ie.length;x++){const $=ie[x];let U,L,N,M,F;typeof $=="string"?U=$:(U=$.label,L=$.description,N=$.detail,M=$.picked,F=$.alwaysShow),K.push({label:U,description:L,handle:x,detail:N,picked:M,alwaysShow:F})}return c&&typeof c.onDidSelectItem=="function"&&(this._onDidSelectItem=x=>{c.onDidSelectItem(ie[x])}),E.$setItems(u,K),p.then(x=>{if(typeof x=="number")return ie[x];if(Array.isArray(x))return x.map($=>ie[$])})})}).then(void 0,j=>{if(!(0,k.isPromiseCanceledError)(j))return E.$setError(u,j),Promise.reject(j)})}$onItemSelected(r){this._onDidSelectItem&&this._onDidSelectItem(r)}showInput(r,s=I.CancellationToken.None){return this._validateInput=r?r.validateInput:void 0,E.$input(r,typeof this._validateInput=="function",s).then(void 0,c=>{if(!(0,k.isPromiseCanceledError)(c))return Promise.reject(c)})}$validateInput(r){return this._validateInput?(0,b.asPromise)(()=>this._validateInput(r)):Promise.resolve(void 0)}async showWorkspaceFolderPick(r,s=I.CancellationToken.None){const c=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!!c){const h=await this._workspace.getWorkspaceFolders2();if(!!h)return h.find(_=>_.uri.toString()===c.uri.toString())}}createQuickPick(r,s){const c=new t(r,s,()=>this._sessions.delete(c._id));return this._sessions.set(c._id,c),c}createInputBox(r){const s=new n(r,()=>this._sessions.delete(s._id));return this._sessions.set(s._id,s),s}$onDidChangeValue(r,s){const c=this._sessions.get(r);c&&c._fireDidChangeValue(s)}$onDidAccept(r){const s=this._sessions.get(r);s&&s._fireDidAccept()}$onDidChangeActive(r,s){const c=this._sessions.get(r);c instanceof t&&c._fireDidChangeActive(s)}$onDidChangeSelection(r,s){const c=this._sessions.get(r);c instanceof t&&c._fireDidChangeSelection(s)}$onDidTriggerButton(r,s){const c=this._sessions.get(r);c&&c._fireDidTriggerButton(s)}$onDidHide(r){const s=this._sessions.get(r);s&&s._fireDidHide()}}class S{constructor(r,s){this._extensionId=r,this._onDidDispose=s,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new T.Emitter,this._onDidChangeValueEmitter=new T.Emitter,this._onDidTriggerButtonEmitter=new T.Emitter,this._onDidHideEmitter=new T.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(r){this._title=r,this.update({title:r})}get step(){return this._steps}set step(r){this._steps=r,this.update({step:r})}get totalSteps(){return this._totalSteps}set totalSteps(r){this._totalSteps=r,this.update({totalSteps:r})}get enabled(){return this._enabled}set enabled(r){this._enabled=r,this.update({enabled:r})}get busy(){return this._busy}set busy(r){this._busy=r,this.update({busy:r})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(r){this._ignoreFocusOut=r,this.update({ignoreFocusOut:r})}get value(){return this._value}set value(r){this._value=r,this.update({value:r})}get placeholder(){return this._placeholder}set placeholder(r){this._placeholder=r,this.update({placeholder:r})}get buttons(){return this._buttons}set buttons(r){this._buttons=r.slice(),this._handlesToButtons.clear(),r.forEach((s,c)=>{const h=s===D.QuickInputButtons.Back?-1:c;this._handlesToButtons.set(h,s)}),this.update({buttons:r.map((s,c)=>({iconPath:g(s.iconPath),tooltip:s.tooltip,handle:s===D.QuickInputButtons.Back?-1:c}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(r){this._value=r,this._onDidChangeValueEmitter.fire(r)}_fireDidTriggerButton(r){const s=this._handlesToButtons.get(r);s&&this._onDidTriggerButtonEmitter.fire(s)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,A.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),E.$dispose(this._id))}update(r){if(!this._disposed){for(const s of Object.keys(r)){const c=r[s];this._pendingUpdate[s]=c===void 0?null:c}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){E.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}S._nextId=1;function g(o){if(o instanceof D.ThemeIcon)return{id:o.id};const r=v(o),s=a(o);return{dark:typeof r=="string"?P.URI.file(r):r,light:typeof s=="string"?P.URI.file(s):s}}function a(o){return typeof o=="object"&&"light"in o?o.light:o}function v(o){return typeof o=="object"&&"dark"in o?o.dark:o}class t extends S{constructor(r,s,c){super(r,c);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new T.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new T.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(r){this._items=r.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),r.forEach((s,c)=>{this._handlesToItems.set(c,s),this._itemsToHandles.set(s,c)}),this.update({items:r.map((s,c)=>({label:s.label,description:s.description,handle:c,detail:s.detail,picked:s.picked,alwaysShow:s.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(r){this._canSelectMany=r,this.update({canSelectMany:r})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(r){this._matchOnDescription=r,this.update({matchOnDescription:r})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(r){this._matchOnDetail=r,this.update({matchOnDetail:r})}get sortByLabel(){return this._sortByLabel}set sortByLabel(r){this._sortByLabel=r,this.update({sortByLabel:r})}get activeItems(){return this._activeItems}set activeItems(r){this._activeItems=r.filter(s=>this._itemsToHandles.has(s)),this.update({activeItems:this._activeItems.map(s=>this._itemsToHandles.get(s))})}get selectedItems(){return this._selectedItems}set selectedItems(r){this._selectedItems=r.filter(s=>this._itemsToHandles.has(s)),this.update({selectedItems:this._selectedItems.map(s=>this._itemsToHandles.get(s))})}_fireDidChangeActive(r){const s=(0,i.coalesce)(r.map(c=>this._handlesToItems.get(c)));this._activeItems=s,this._onDidChangeActiveEmitter.fire(s)}_fireDidChangeSelection(r){const s=(0,i.coalesce)(r.map(c=>this._handlesToItems.get(c)));this._selectedItems=s,this._onDidChangeSelectionEmitter.fire(s)}}class n extends S{constructor(r,s){super(r,s);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(r){this._password=r,this.update({password:r})}get prompt(){return this._prompt}set prompt(r){this._prompt=r,this.update({prompt:r})}get validationMessage(){return this._validationMessage}set validationMessage(r){this._validationMessage=r,this.update({validationMessage:r,severity:r?C.default.Error:C.default.Ignore})}}return new w(l,d)}e.createExtHostQuickOpen=f}),define(me[244],ge([0,1,2,3,54,6,13,5,17,100,14,27,41]),function(G,e,b,I,T,A,y,P,D,k,i,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function m(r){if(r)return typeof r.iconPath=="string"?b.URI.file(r.iconPath):r.iconPath}function l(r,s){if(!r.iconPath&&!s.iconPath)return 0;if(r.iconPath){if(!s.iconPath)return 1}else return-1;const c=typeof r.iconPath=="string"?r.iconPath:r.iconPath.fsPath,h=typeof s.iconPath=="string"?s.iconPath:s.iconPath.fsPath;return(0,k.comparePaths)(c,h)}function d(r,s){let c=0;if(r.strikeThrough!==s.strikeThrough)return r.strikeThrough?1:-1;if(r.faded!==s.faded)return r.faded?1:-1;if(r.tooltip!==s.tooltip)return(r.tooltip||"").localeCompare(s.tooltip||"");if(c=l(r,s),c!==0)return c;if(r.light&&s.light)c=l(r.light,s.light);else{if(r.light)return 1;if(s.light)return-1}if(c!==0)return c;if(r.dark&&s.dark)c=l(r.dark,s.dark);else{if(r.dark)return 1;if(s.dark)return-1}return c}function E(r,s){if(r.command!==s.command)return r.command<s.command?-1:1;if(r.title!==s.title)return r.title<s.title?-1:1;if(r.tooltip!==s.tooltip){if(r.tooltip!==void 0&&s.tooltip!==void 0)return r.tooltip<s.tooltip?-1:1;if(r.tooltip!==void 0)return 1;if(s.tooltip!==void 0)return-1}if(r.arguments===s.arguments)return 0;if(r.arguments)if(s.arguments){if(r.arguments.length!==s.arguments.length)return r.arguments.length-s.arguments.length}else return 1;else return-1;for(let c=0;c<r.arguments.length;c++){const h=r.arguments[c],_=s.arguments[c];if(h!==_)return h<_?-1:1}return 0}function w(r,s){let c=(0,k.comparePaths)(r.resourceUri.fsPath,s.resourceUri.fsPath,!0);if(c!==0)return c;if(r.command&&s.command)c=E(r.command,s.command);else{if(r.command)return 1;if(s.command)return-1}if(c!==0)return c;if(r.decorations&&s.decorations)c=d(r.decorations,s.decorations);else{if(r.decorations)return 1;if(s.decorations)return-1}return c}function S(r,s){for(let c=0;c<r.length;c++)if(r[c]!==s[c])return!1;return!0}function g(r,s){return r.command===s.command&&r.title===s.title&&r.tooltip===s.tooltip&&(r.arguments&&s.arguments?S(r.arguments,s.arguments):r.arguments===s.arguments)}function a(r,s){return(0,D.equals)(r,s,g)}class v{constructor(s,c,h){this._extension=s,this._proxy=c,this._sourceControlHandle=h,this._value="",this._onDidChange=new I.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(s){this._proxy.$setInputBoxValue(this._sourceControlHandle,s),this.updateValue(s)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(s){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,s),this._placeholder=s}get validateInput(){return(0,f.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(s){if((0,f.checkProposedApiEnabled)(this._extension),s&&typeof s!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=s,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!s)}get visible(){return this._visible}set visible(s){s=!!s,this._visible!==s&&(this._visible=s,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,s))}focus(){(0,f.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(s,c){(0,f.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,s,c)}$onInputBoxValueChange(s){this.updateValue(s)}updateValue(s){this._value=s,this._onDidChange.fire(s)}}e.ExtHostSCMInputBox=v;class t{constructor(s,c,h,_,u){this._proxy=s,this._commands=c,this._sourceControlHandle=h,this._id=_,this._label=u,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new I.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new I.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(s){this._label=s,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,s)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(s){this._hideWhenEmpty=s,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(s){this._resourceStates=[...s],this._onDidUpdateResourceStates.fire()}getResourceState(s){return this._resourceStatesMap.get(s)}$executeResourceCommand(s,c){const h=this._resourceStatesCommandsMap.get(s);return h?(0,y.asPromise)(()=>this._commands.executeCommand(h.command,...h.arguments||[],c)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var s;const c=[...this._resourceStates].sort(w),_=(0,D.sortedDiff)(this._resourceSnapshot,c,w).map(R=>{const O=R.toInsert.map(j=>{const ie=this._resourceHandlePool++;this._resourceStatesMap.set(ie,j);const K=j.resourceUri,x=m(j.decorations),$=j.decorations&&m(j.decorations.light)||x,U=j.decorations&&m(j.decorations.dark)||x,L=[];let N;if(j.command)if(j.command.command==="vscode.open"||j.command.command==="vscode.diff"){const le=new A.DisposableStore;N=this._commands.converter.toInternal(j.command,le),this._resourceStatesDisposablesMap.set(ie,le)}else this._resourceStatesCommandsMap.set(ie,j.command);$&&L.push($),U&&U.toString()!==($==null?void 0:$.toString())&&L.push(U);const M=j.decorations&&j.decorations.tooltip||"",F=j.decorations&&!!j.decorations.strikeThrough,W=j.decorations&&!!j.decorations.faded,q=j.contextValue||"";return{rawResource:[ie,K,L,M,F,W,q,N],handle:ie}});return{start:R.start,deleteCount:R.deleteCount,toInsert:O}}),u=_.map(({start:R,deleteCount:O,toInsert:j})=>[R,O,j.map(ie=>ie.rawResource)]),p=_.reverse();for(const{start:R,deleteCount:O,toInsert:j}of p){const ie=j.map(x=>x.handle),K=this._handlesSnapshot.splice(R,O,...ie);for(const x of K)this._resourceStatesMap.delete(x),this._resourceStatesCommandsMap.delete(x),(s=this._resourceStatesDisposablesMap.get(x))===null||s===void 0||s.dispose(),this._resourceStatesDisposablesMap.delete(x)}return this._resourceSnapshot=c,u}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class n{constructor(s,c,h,_,u,p){this._proxy=c,this._commands=h,this._id=_,this._label=u,this._rootUri=p,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new I.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new v(s,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,_,u,p)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(s){this._count!==s&&(this._count=s,this._proxy.$updateSourceControl(this.handle,{count:s}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(s){this._quickDiffProvider=s,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!s})}get commitTemplate(){return this._commitTemplate}set commitTemplate(s){s!==this._commitTemplate&&(this._commitTemplate=s,this._proxy.$updateSourceControl(this.handle,{commitTemplate:s}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(s){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=s;const c=this._commands.converter.toInternal(s,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:c})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(s){if(!(this._statusBarCommands&&s&&a(this._statusBarCommands,s))){this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=s;const c=(s||[]).map(h=>this._commands.converter.toInternal(h,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:c})}}get selected(){return this._selected}createResourceGroup(s,c){const h=new t(this._proxy,this._commands,this.handle,s,c),_=I.Event.once(h.onDidDispose)(()=>this.createdResourceGroups.delete(h));return this.createdResourceGroups.set(h,_),this.eventuallyAddResourceGroups(),h}eventuallyAddResourceGroups(){const s=[],c=[];for(const[h,_]of this.createdResourceGroups){_.dispose();const u=h.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(h),this.eventuallyUpdateResourceStates()});I.Event.once(h.onDidDispose)(()=>{this.updatedResourceGroups.delete(h),u.dispose(),this._groups.delete(h.handle),this._proxy.$unregisterGroup(this.handle,h.handle)}),s.push([h.handle,h.id,h.label,h.features]);const p=h._takeResourceStateSnapshot();p.length>0&&c.push([h.handle,p]),this._groups.set(h.handle,h)}this._proxy.$registerGroups(this.handle,s,c),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const s=[];this.updatedResourceGroups.forEach(c=>{const h=c._takeResourceStateSnapshot();h.length!==0&&s.push([c.handle,h])}),s.length>0&&this._proxy.$spliceResourceStates(this.handle,s),this.updatedResourceGroups.clear()}getResourceGroup(s){return this._groups.get(s)}setSelectionState(s){this._selected=s,this._onDidChangeSelection.fire(s)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(s=>s.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}n._handlePool=0,qe([(0,T.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),qe([(0,T.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let o=class Un{constructor(s,c,h){this._commands=c,this.logService=h,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new I.Emitter,this._proxy=s.getProxy(P.MainContext.MainThreadSCM),this._telemetry=s.getProxy(P.MainContext.MainThreadTelemetry),c.registerArgumentProcessor({processArgument:_=>{if(_&&_.$mid===3){const u=this._sourceControls.get(_.sourceControlHandle);if(!u)return _;const p=u.getResourceGroup(_.groupHandle);return p?p.getResourceState(_.handle):_}else if(_&&_.$mid===4){const u=this._sourceControls.get(_.sourceControlHandle);return u?u.getResourceGroup(_.groupHandle):_}else if(_&&_.$mid===5){const u=this._sourceControls.get(_.handle);return u||_}return _}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(s,c,h,_){this.logService.trace("ExtHostSCM#createSourceControl",s.identifier.value,c,h,_),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:s.identifier.value});const u=Un._handlePool++,p=new n(s,this._proxy,this._commands,c,h,_);this._sourceControls.set(u,p);const R=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(s.identifier))||[];return R.push(p),this._sourceControlsByExtension.set(C.ExtensionIdentifier.toKey(s.identifier),R),p}getLastInputBox(s){this.logService.trace("ExtHostSCM#getLastInputBox",s.identifier.value);const c=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(s.identifier)),h=c&&c[c.length-1];return h&&h.inputBox}$provideOriginalResource(s,c,h){const _=b.URI.revive(c);this.logService.trace("ExtHostSCM#$provideOriginalResource",s,_.toString());const u=this._sourceControls.get(s);return!u||!u.quickDiffProvider||!u.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,y.asPromise)(()=>u.quickDiffProvider.provideOriginalResource(_,h)).then(p=>p||null)}$onInputBoxValueChange(s,c){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",s);const h=this._sourceControls.get(s);return h&&h.inputBox.$onInputBoxValueChange(c),Promise.resolve(void 0)}$executeResourceCommand(s,c,h,_){this.logService.trace("ExtHostSCM#$executeResourceCommand",s,c,h);const u=this._sourceControls.get(s);if(!u)return Promise.resolve(void 0);const p=u.getResourceGroup(c);return p?p.$executeResourceCommand(h,_):Promise.resolve(void 0)}$validateInput(s,c,h){this.logService.trace("ExtHostSCM#$validateInput",s);const _=this._sourceControls.get(s);return!_||!_.inputBox.validateInput?Promise.resolve(void 0):(0,y.asPromise)(()=>_.inputBox.validateInput(c,h)).then(u=>u?Promise.resolve([u.message,u.type]):Promise.resolve(void 0))}$setSelectedSourceControl(s){var c,h;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",s),s!==void 0&&((c=this._sourceControls.get(s))===null||c===void 0||c.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((h=this._sourceControls.get(this._selectedSourceControlHandle))===null||h===void 0||h.setSelectionState(!1)),this._selectedSourceControlHandle=s,Promise.resolve(void 0)}};o._handlePool=0,o=qe([He(2,i.ILogService)],o),e.ExtHostSCM=o});var it=this&&this.__classPrivateFieldSet||function(G,e,b,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,b):T?T.value=b:e.set(G,b),b},We=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)};define(me[245],ge([0,1,7,5,164,6]),function(G,e,b,I,T,A){"use strict";var y,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class D{constructor(f,m,l,d,E=b.StatusBarAlignment.Left,w,S){y.set(this,void 0),P.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,it(this,y,f,"f"),it(this,P,m,"f"),this._id=D.ID_GEN++,this._statusId=l,this._statusName=d,this._alignment=E,this._priority=w,this._accessibilityInformation=S}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var f;return(f=this._command)===null||f===void 0?void 0:f.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!D.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){var m;((m=this._command)===null||m===void 0?void 0:m.fromApi)!==f&&(this._internalCommandRegistration.clear(),typeof f=="string"?this._command={fromApi:f,internal:We(this,P,"f").toInternal({title:"",command:f},this._internalCommandRegistration)}:f?this._command={fromApi:f,internal:We(this,P,"f").toInternal(f,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,We(this,y,"f").$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var f;this._timeoutHandle=void 0;let m=this._color;this._backgroundColor&&(m=D.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),We(this,y,"f").$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(f=this._command)===null||f===void 0?void 0:f.internal,m,this._backgroundColor,this._alignment===b.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=D,y=new WeakMap,P=new WeakMap,D.ID_GEN=0,D.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new b.ThemeColor("statusBarItem.errorForeground")]]);class k{constructor(f){this._messages=[],this._item=f.createStatusBarEntry("status.extensionMessage",(0,T.localize)(0,null),b.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const m={message:f};return this._messages.unshift(m),this._update(),new b.Disposable(()=>{const l=this._messages.indexOf(m);l>=0&&(this._messages.splice(l,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class i{constructor(f,m){this._proxy=f.getProxy(I.MainContext.MainThreadStatusBar),this._commands=m,this._statusMessage=new k(this)}createStatusBarEntry(f,m,l,d,E){return new D(this._proxy,this._commands,f,m,l,d,E)}setStatusBarMessage(f,m){const l=this._statusMessage.setMessage(f);let d;return typeof m=="number"?d=setTimeout(()=>l.dispose(),m):typeof m!="undefined"&&m.then(()=>l.dispose(),()=>l.dispose()),new b.Disposable(()=>{l.dispose(),clearTimeout(d)})}}e.ExtHostStatusBar=i}),define(me[92],ge([0,1,5,3,4]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(P){this._onDidChangeStorage=new I.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=P.getProxy(b.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,D){this._proxy.$registerExtensionStorageKeysToSync(P,D)}getValue(P,D,k){return this._proxy.$getValue(P,D).then(i=>i||k)}setValue(P,D,k){return this._proxy.$setValue(P,D,k)}$acceptValue(P,D,k){this._onDidChangeStorage.fire({shared:P,key:D,value:k})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,T.createDecorator)("IExtHostStorage")}),define(me[93],ge([0,1,4,28,14,91,2]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,b.createDecorator)("IExtensionStoragePaths");let P=class{constructor(k,i,C){var f;this._logService=i,this._extHostFileSystem=C,this._workspace=(f=k.workspace)!==null&&f!==void 0?f:void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(m=>this._value=m)}async _getOrCreateWorkspaceStoragePath(){var k;if(!this._workspace)return Promise.resolve(void 0);const i=this._workspace.id,C=y.URI.joinPath(this._environment.workspaceStorageHome,i);try{return await this._extHostFileSystem.value.stat(C),this._logService.trace("[ExtHostStorage] storage dir already exists",C),C}catch(f){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",C),await this._extHostFileSystem.value.createDirectory(C),await this._extHostFileSystem.value.writeFile(y.URI.joinPath(C,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(k=y.URI.revive(this._workspace.configuration))===null||k===void 0?void 0:k.toString(),name:this._workspace.name},void 0,2))),C}catch(f){this._logService.error("[ExtHostStorage]",f);return}}workspaceValue(k){if(this._value)return y.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return y.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}};P=qe([He(0,I.IExtHostInitDataService),He(1,T.ILogService),He(2,A.IExtHostConsumerFileSystem)],P),e.ExtensionStoragePaths=P}),define(me[34],ge([0,1,3,5,4,2,15,6,7,165,16,209,21,30,191]),function(G,e,b,I,T,A,y,P,D,k,i,C,f,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,T.createDecorator)("IExtHostTerminalService");class d{constructor(t,n,o,r){this._proxy=t,this._id=n,this._creationOptions=o,this._name=r,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(c=>this._pidPromiseComplete=c);const s=this;this.value={get name(){return s._name||""},get processId(){return s._pidPromise},get creationOptions(){return s._creationOptions},get exitStatus(){return s._exitStatus},sendText(c,h=!0){s._checkDisposed(),s._proxy.$sendText(s._id,c,h)},show(c){s._checkDisposed(),s._proxy.$show(s._id,c)},hide(){s._checkDisposed(),s._proxy.$hide(s._id)},dispose(){s._disposed||(s._disposed=!0,s._proxy.$dispose(s._id))},get dimensions(){if(!(s._cols===void 0||s._rows===void 0))return{columns:s._cols,rows:s._rows}}}}async create(t,n,o,r,s,c,h,_,u,p,R){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:n,cwd:o,env:r,icon:s,initialText:c,waitOnExit:h,strictEnv:_,hideFromUser:u,isFeatureTerminal:p,isExtensionOwnedTerminal:R})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,n){return t===this._cols&&n===this._rows||t===0||n===0?!1:(this._cols=t,this._rows=n,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(n=>{n!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=d;class E{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new b.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new b.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new b.Emitter,this._onProcessTitleChanged=new b.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new b.Emitter,this._onProcessShellTypeChanged=new b.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,n){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:n})}async processBinary(t){}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(n=>this._onProcessData.fire(n)),this._pty.onDidClose&&this._pty.onDidClose((n=void 0)=>{this._onProcessExit.fire(n===void 0?void 0:n)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(n=>this._onProcessOverrideDimensions.fire(n&&{cols:n.columns,rows:n.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(n=>this._onProcessTitleChanged.fire(n)),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=E;let w=1,S=class extends P.Disposable{constructor(t,n){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new b.Emitter,this._onDidOpenTerminal=new b.Emitter,this._onDidChangeActiveTerminal=new b.Emitter,this._onDidChangeTerminalDimensions=new b.Emitter,this._proxy=n.getProxy(I.MainContext.MainThreadTerminalService),this._bufferer=new l.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new b.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[o,r]of this._terminalProcesses)r.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const n=new d(this._proxy,(0,m.generateUuid)(),t,t.name),o=new E(t.pty);return n.createExtensionTerminal().then(r=>{const s=this._setupExtHostProcessListeners(r,o);this._terminalProcessDisposables[r]=s}),this._terminals.push(n),n.value}attachPtyToTerminal(t,n){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const r=new E(n),s=this._setupExtHostProcessListeners(t,r);this._terminalProcessDisposables[t]=s}async $acceptActiveTerminalChanged(t){const n=this._activeTerminal;if(t===null){this._activeTerminal=void 0,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const o=this._getTerminalById(t);o&&(this._activeTerminal=o,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,n){const o=this._getTerminalById(t);o&&this._onDidWriteTerminalData.fire({terminal:o.value,data:n})}async $acceptTerminalDimensions(t,n,o){const r=this._getTerminalById(t);r&&r.setDimensions(n,o)&&this._onDidChangeTerminalDimensions.fire({terminal:r.value,dimensions:r.value.dimensions})}async $acceptTerminalMaximumDimensions(t,n,o){var r;(r=this._terminalProcesses.get(t))===null||r===void 0||r.resize(n,o)}async $acceptTerminalTitleChange(t,n){const o=this._getTerminalById(t);o&&(o.name=n)}async $acceptTerminalClosed(t,n){const o=this._getTerminalObjectIndexById(this._terminals,t);if(o!==null){const r=this._terminals.splice(o,1)[0];r.setExitCode(n),this._onDidCloseTerminal.fire(r.value)}}$acceptTerminalOpened(t,n,o,r){if(n){const h=this._getTerminalObjectIndexById(this._terminals,n);if(h!==null){this._terminals[h]._id=t,this._onDidOpenTerminal.fire(this.terminals[h]),this._terminals[h].isOpen=!0;return}}const s={name:r.name,shellPath:r.executable,shellArgs:r.args,cwd:typeof r.cwd=="string"?r.cwd:A.URI.revive(r.cwd),env:r.env,hideFromUser:r.hideFromUser},c=new d(this._proxy,t,s,o);this._terminals.push(c),this._onDidOpenTerminal.fire(c.value),c.isOpen=!0}async $acceptTerminalProcessId(t,n){const o=this._getTerminalById(t);o&&o._setProcessId(n)}async $startExtensionTerminal(t,n){const o=this._getTerminalById(t);if(!o)return{message:(0,k.localize)(0,null,t)};o.isOpen||await new Promise(s=>{const c=this.onDidOpenTerminal(async h=>{h===o.value&&(c.dispose(),s())})});const r=this._terminalProcesses.get(t);r?r.startSendingEvents(n):this._extensionTerminalAwaitingStart[t]={initialDimensions:n}}_setupExtHostProcessListeners(t,n){const o=new P.DisposableStore;o.add(n.onProcessReady(s=>this._proxy.$sendProcessReady(t,s.pid,s.cwd))),o.add(n.onProcessTitleChanged(s=>this._proxy.$sendProcessTitle(t,s))),this._bufferer.startBuffering(t,n.onProcessData),o.add(n.onProcessExit(s=>this._onProcessExit(t,s))),n.onProcessOverrideDimensions&&o.add(n.onProcessOverrideDimensions(s=>this._proxy.$sendOverrideDimensions(t,s))),this._terminalProcesses.set(t,n);const r=this._extensionTerminalAwaitingStart[t];return r&&n instanceof E&&(n.startSendingEvents(r.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),o}$acceptProcessAckDataEvent(t,n){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.acknowledgeDataEvent(n)}$acceptProcessInput(t,n){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.input(n)}$acceptProcessResize(t,n,o){var r;try{(r=this._terminalProcesses.get(t))===null||r===void 0||r.resize(n,o)}catch(s){if(s.code!=="EPIPE"&&s.code!=="ERR_IPC_CHANNEL_CLOSED")throw s}}$acceptProcessShutdown(t,n){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.shutdown(n)}$acceptProcessRequestInitialCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getInitialCwd().then(o=>this._proxy.$sendProcessInitialCwd(t,o))}$acceptProcessRequestCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getCwd().then(o=>this._proxy.$sendProcessCwd(t,o))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,n){const o=this._getTerminalById(t);if(!o)return[];this._terminalLinkCache.delete(t);const r=this._terminalLinkCancellationSource.get(t);r&&r.dispose(!0);const s=new f.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,s);const c=[],h={terminal:o.value,line:n},_=[];for(const R of this._linkProviders)_.push(new Promise(async O=>{s.token.onCancellationRequested(()=>O({provider:R,links:[]}));const j=await R.provideTerminalLinks(h,s.token)||[];s.token.isCancellationRequested||O({provider:R,links:j})}));const u=await Promise.all(_);if(s.token.isCancellationRequested)return[];const p=new Map;for(const R of u)R&&R.links.length>0&&c.push(...R.links.map(O=>{const j={id:w++,startIndex:O.startIndex,length:O.length,label:O.tooltip};return p.set(j.id,{provider:R.provider,link:O}),j}));return this._terminalLinkCache.set(t,p),c}$activateLink(t,n){var o;const r=(o=this._terminalLinkCache.get(t))===null||o===void 0?void 0:o.get(n);!r||r.provider.handleTerminalLink(r.link)}_onProcessExit(t,n){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const o=this._terminalProcessDisposables[t];o&&(o.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,n)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,n){const o=this._getTerminalObjectIndexById(t,n);return o!==null?t[o]:null}_getTerminalObjectIndexById(t,n){let o=null;return t.some((r,s)=>r._id===n?(o=s,!0):!1),o}getEnvironmentVariableCollection(t){let n=this._environmentVariableCollections.get(t.identifier.value);return n||(n=new g,this._setEnvironmentVariableCollection(t.identifier.value,n)),n}_syncEnvironmentVariableCollection(t,n){const o=(0,C.serializeEnvironmentVariableCollection)(n.map);this._proxy.$setEnvironmentVariableCollection(t,n.persistent,o.length===0?void 0:o)}$initEnvironmentVariableCollections(t){t.forEach(n=>{const o=n[0],r=new g(n[1]);this._setEnvironmentVariableCollection(o,r)})}_setEnvironmentVariableCollection(t,n){this._environmentVariableCollections.set(t,n),n.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,n)})}};S=qe([He(1,y.IExtHostRpcService)],S),e.BaseExtHostTerminalService=S;class g{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new b.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Replace})}append(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Append})}prepend(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,n){const o=this.map.get(t);(!o||o.value!==n.value||o.type!==n.type)&&(this.map.set(t,n),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,n){this.map.forEach((o,r)=>t.call(n,r,o,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=g;let a=class extends S{constructor(t){super(!1,t)}createTerminal(t,n,o){throw new i.NotSupportedError}createTerminalFromOptions(t){throw new i.NotSupportedError}getDefaultShell(t,n){throw new i.NotSupportedError}getDefaultShellArgs(t,n){throw new i.NotSupportedError}async getDefaultShellAndArgs(t){throw new i.NotSupportedError}$getAvailableProfiles(t){throw new i.NotSupportedError}};a=qe([He(0,y.IExtHostRpcService)],a),e.WorkerExtHostTerminalService=a}),define(me[246],ge([0,1,3,17,5,125,20,7]),function(G,e,b,I,T,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(i,C){this._extHostDocumentsAndEditors=C,this._onDidChangeTextEditorSelection=new b.Emitter,this._onDidChangeTextEditorOptions=new b.Emitter,this._onDidChangeTextEditorVisibleRanges=new b.Emitter,this._onDidChangeTextEditorViewColumn=new b.Emitter,this._onDidChangeActiveTextEditor=new b.Emitter,this._onDidChangeVisibleTextEditors=new b.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=i.getProxy(T.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(f=>this._onDidChangeVisibleTextEditors.fire(f)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(f=>this._onDidChangeActiveTextEditor.fire(f))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(i){const C=this._extHostDocumentsAndEditors.allEditors();return i?C:C.map(f=>f.value)}async showTextDocument(i,C,f){let m;typeof C=="number"?m={position:y.ViewColumn.from(C),preserveFocus:f}:typeof C=="object"?m={position:y.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?y.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:m={preserveFocus:!1};const l=await this._proxy.$tryShowTextDocument(i.uri,m),d=l&&this._extHostDocumentsAndEditors.getEditor(l);if(d)return d.value;throw l?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}createTextEditorDecorationType(i){return new A.TextEditorDecorationType(this._proxy,i).value}$acceptEditorPropertiesChanged(i,C){const f=this._extHostDocumentsAndEditors.getEditor(i);if(!f)throw new Error("unknown text editor");if(C.options&&f._acceptOptions(C.options),C.selections){const m=C.selections.selections.map(y.Selection.to);f._acceptSelections(m)}if(C.visibleRanges){const m=I.coalesce(C.visibleRanges.map(y.Range.to));f._acceptVisibleRanges(m)}if(C.options&&this._onDidChangeTextEditorOptions.fire({textEditor:f.value,options:Object.assign(Object.assign({},C.options),{lineNumbers:y.TextEditorLineNumbersStyle.to(C.options.lineNumbers)})}),C.selections){const m=P.TextEditorSelectionChangeKind.fromValue(C.selections.source),l=C.selections.selections.map(y.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:f.value,selections:l,kind:m})}if(C.visibleRanges){const m=I.coalesce(C.visibleRanges.map(y.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:f.value,visibleRanges:m})}}$acceptEditorPositionData(i){for(const C in i){const f=this._extHostDocumentsAndEditors.getEditor(C);if(!f)throw new Error("Unknown text editor");const m=y.ViewColumn.to(i[C]);f.value.viewColumn!==m&&(f._acceptViewColumn(m),this._onDidChangeTextEditorViewColumn.fire({textEditor:f.value,viewColumn:m}))}}getDiffInformation(i){return Promise.resolve(this._proxy.$getDiffInformation(i))}}e.ExtHostEditors=D});var Jt=this&&this.__rest||function(G,e){var b={};for(var I in G)Object.prototype.hasOwnProperty.call(G,I)&&e.indexOf(I)<0&&(b[I]=G[I]);if(G!=null&&typeof Object.getOwnPropertySymbols=="function")for(var T=0,I=Object.getOwnPropertySymbols(G);T<I.length;T++)e.indexOf(I[T])<0&&Object.prototype.propertyIsEnumerable.call(G,I[T])&&(b[I[T]]=G[I[T]]);return b};define(me[247],ge([0,1,2,4,5,6,7]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,I.createDecorator)("IExtHostTimeline");class P{constructor(i,C){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=i.getProxy(T.MainContext.MainThreadTimeline),C.registerArgumentProcessor({processArgument:f=>{var m,l;if(f&&f.$mid===11){const d=f.uri===void 0?void 0:b.URI.revive(f.uri);return(l=(m=this._itemsBySourceAndUriMap.get(f.source))===null||m===void 0?void 0:m.get(D(d)))===null||l===void 0?void 0:l.get(f.handle)}return f}})}async $getTimeline(i,C,f,m,l){const d=this._providers.get(i);return d==null?void 0:d.provideTimeline(b.URI.revive(C),f,m,l)}registerTimelineProvider(i,C,f,m){const l=new A.DisposableStore,d=this.convertTimelineItem(C.id,m,l).bind(this);let E;C.onDidChange&&(E=C.onDidChange(S=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},S),{id:C.id})),this));const w=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},C),{scheme:i,onDidChange:void 0,async provideTimeline(S,g,a,v){var t;(v==null?void 0:v.resetCache)&&(l.clear(),(t=w.get(C.id))===null||t===void 0||t.clear());const n=await C.provideTimeline(S,g,a);if(n!=null){const o=d(S,v);return Object.assign(Object.assign({},n),{source:C.id,items:n.items.map(o)})}},dispose(){var S;for(const g of w.values())(S=g.get(C.id))===null||S===void 0||S.clear();E==null||E.dispose(),l.dispose()}}))}convertTimelineItem(i,C,f){return(m,l)=>{let d;if(l==null?void 0:l.cacheResults){let E=this._itemsBySourceAndUriMap.get(i);E===void 0&&(E=new Map,this._itemsBySourceAndUriMap.set(i,E));const w=D(m);d=E.get(w),d===void 0&&(d=new Map,E.set(w,d))}return E=>{var w,S;const{iconPath:g}=E,a=Jt(E,["iconPath"]),v=`${i}|${(w=E.id)!==null&&w!==void 0?w:E.timestamp}`;d==null||d.set(v,E);let t,n,o;return E.iconPath&&(g instanceof y.ThemeIcon?o={id:g.id}:b.URI.isUri(g)?(t=g,n=g):{light:t,dark:n}=g),Object.assign(Object.assign({},a),{id:(S=a.id)!==null&&S!==void 0?S:void 0,handle:v,source:i,command:E.command?C.toInternal(E.command,f):void 0,icon:t,iconDark:n,themeIcon:o,accessibilityInformation:E.accessibilityInformation})}}}registerTimelineProviderCore(i){if(this._providers.get(i.id))throw new Error(`Timeline Provider ${i.id} already exists.`);return this._proxy.$registerTimelineProvider({id:i.id,label:i.label,scheme:i.scheme}),this._providers.set(i.id,i),(0,A.toDisposable)(()=>{var f;for(const m of this._itemsBySourceAndUriMap.values())(f=m.get(i.id))===null||f===void 0||f.clear();this._providers.delete(i.id),this._proxy.$unregisterTimelineProvider(i.id),i.dispose()})}}e.ExtHostTimeline=P;function D(k){return k==null?void 0:k.toString()}}),define(me[248],ge([0,1,6,12,2,5]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(D){this._openers=new Map,this._proxy=D.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,k,i,C){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const f=C.schemes.find(m=>!y.supportedSchemes.has(m));if(f)throw new Error(`Scheme '${f}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,i),this._proxy.$registerUriOpener(k,C.schemes,D,C.label),(0,b.toDisposable)(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(D,k,i){const C=this._openers.get(D);if(!C)throw new Error(`Unknown opener with id: ${D}`);const f=T.URI.revive(k);return C.canOpenExternalUri(f,i)}async $openUri(D,k,i){const C=this._openers.get(D);if(!C)throw new Error(`Unknown opener id: '${D}'`);return C.openExternalUri(T.URI.revive(k.resolvedUri),{sourceUri:T.URI.revive(k.sourceUri)},i)}}e.ExtHostUriOpeners=y,y.supportedSchemes=new Set([I.Schemas.http,I.Schemas.https])}),define(me[249],ge([0,1,5,2,6,16,27]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(b.MainContext.MainThreadUrls)}registerUriHandler(k,i){if(this.handles.has(y.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const C=P.HandlePool++;return this.handles.add(y.ExtensionIdentifier.toKey(k)),this.handlers.set(C,i),this._proxy.$registerUriHandler(C,k),(0,T.toDisposable)(()=>{this.handles.delete(y.ExtensionIdentifier.toKey(k)),this.handlers.delete(C),this._proxy.$unregisterUriHandler(C)})}$handleExternalUri(k,i){const C=this.handlers.get(k);if(!C)return Promise.resolve(void 0);try{C.handleUri(I.URI.revive(i))}catch(f){(0,A.onUnexpectedError)(f)}return Promise.resolve(void 0)}async createAppUri(k){return I.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=P,P.HandlePool=0});var it=this&&this.__classPrivateFieldSet||function(G,e,b,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,b):T?T.value=b:e.set(G,b),b},We=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)};define(me[66],ge([0,1,3,2,176,201,88,5]),function(G,e,b,I,T,A,y,P){"use strict";var D,k,i,C,f,m,l,d,E,w,S,g;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class a{constructor(h,_,u,p,R,O,j){D.set(this,void 0),k.set(this,void 0),i.set(this,void 0),C.set(this,void 0),f.set(this,void 0),m.set(this,void 0),l.set(this,""),d.set(this,void 0),E.set(this,!1),w.set(this,!1),S.set(this,!1),this._onMessageEmitter=new b.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,g.set(this,new b.Emitter),this._onDidDispose=We(this,g,"f").event,it(this,D,h,"f"),it(this,k,_,"f"),it(this,d,u,"f"),it(this,C,p,"f"),it(this,f,R,"f"),it(this,m,O,"f"),it(this,S,v(O),"f"),it(this,i,j,"f")}dispose(){it(this,E,!0,"f"),We(this,g,"f").fire(),We(this,g,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(h){return it(this,w,!0,"f"),(0,y.asWebviewUri)(We(this,C,"f"),We(this,D,"f"),h)}get cspSource(){return We(this,C,"f").webviewCspSource.replace("{{uuid}}",We(this,D,"f"))}get html(){return this.assertNotDisposed(),We(this,l,"f")}set html(h){this.assertNotDisposed(),We(this,l,"f")!==h&&(it(this,l,h,"f"),!We(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(h)&&(it(this,w,!0,"f"),We(this,i,"f").report("Webview vscode-resource: uris",We(this,m,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),We(this,k,"f").$setHtml(We(this,D,"f"),h))}get options(){return this.assertNotDisposed(),We(this,d,"f")}set options(h){this.assertNotDisposed(),We(this,k,"f").$setOptions(We(this,D,"f"),o(We(this,m,"f"),We(this,f,"f"),h)),it(this,d,h,"f")}async postMessage(h){if(We(this,E,"f"))return!1;const _=(0,A.serializeWebviewMessage)(h,{serializeBuffersForPostMessage:We(this,S,"f")});return We(this,k,"f").$postMessage(We(this,D,"f"),_.message,..._.buffers)}assertNotDisposed(){if(We(this,E,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=a,D=new WeakMap,k=new WeakMap,i=new WeakMap,C=new WeakMap,f=new WeakMap,m=new WeakMap,l=new WeakMap,d=new WeakMap,E=new WeakMap,w=new WeakMap,S=new WeakMap,g=new WeakMap;function v(c){try{const h=(0,T.normalizeVersion)((0,T.parseVersion)(c.engines.vscode));return!!h&&h.majorBase>=1&&h.minorBase>=57}catch(h){return!1}}e.shouldSerializeBuffersForPostMessage=v;class t{constructor(h,_,u,p,R){this.initData=_,this.workspace=u,this._logService=p,this._deprecationService=R,this._webviews=new Map,this._webviewProxy=h.getProxy(P.MainContext.MainThreadWebviews)}$onMessage(h,_,...u){const p=this.getWebview(h);if(p){const{message:R}=(0,A.deserializeWebviewMessage)(_,u);p._onMessageEmitter.fire(R)}}$onMissingCsp(h,_){this._logService.warn(`${_} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(h,_,u){const p=new a(h,this._webviewProxy,r(_),this.initData,this.workspace,u,this._deprecationService);return this._webviews.set(h,p),p._onDidDispose(()=>{this._webviews.delete(h)}),p}deleteWebview(h){this._webviews.delete(h)}getWebview(h){return this._webviews.get(h)}}e.ExtHostWebviews=t;function n(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=n;function o(c,h,_){return{enableCommandUris:_.enableCommandUris,enableScripts:_.enableScripts,portMapping:_.portMapping,localResourceRoots:_.localResourceRoots||s(c,h)}}e.serializeWebviewOptions=o;function r(c){var h;return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,portMapping:c.portMapping,localResourceRoots:(h=c.localResourceRoots)===null||h===void 0?void 0:h.map(_=>I.URI.from(_))}}e.reviveOptions=r;function s(c,h){return[...((h==null?void 0:h.getWorkspaceFolders())||[]).map(_=>_.uri),c.extensionLocation]}}),define(me[250],ge([0,1,21,74,6,12,25,2,20,66,86,5,7]),function(G,e,b,I,T,A,y,P,D,k,i,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class m{constructor(t,n){this.document=t,this._storagePath=n,this._backupCounter=1,this._edits=new i.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,n){await this.getEdit(t).undo(),n||this.disposeBackup()}async redo(t,n){await this.getEdit(t).redo(),n||this.disposeBackup()}disposeEdits(t){for(const n of t)this._edits.delete(n)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=a(this.document.uri)+this._backupCounter++;return(0,y.joinPath)(this._storagePath,t)}updateBackup(t){var n;(n=this._backup)===null||n===void 0||n.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const n=this._edits.get(t,0);if(!n)throw new Error("No edit found");return n}}class l{constructor(){this._documents=new Map}get(t,n){return this._documents.get(this.key(t,n))}add(t,n,o){const r=this.key(t,n.uri);if(this._documents.has(r))throw new Error(`Document already exists for viewType:${t} resource:${n.uri}`);const s=new m(n,o);return this._documents.set(r,s),s}delete(t,n){const o=this.key(t,n.uri);this._documents.delete(o)}key(t,n){return`${t}@@@${n}`}}var d;(function(v){v[v.Text=0]="Text",v[v.Custom=1]="Custom"})(d||(d={}));class E{constructor(){this._providers=new Map}addTextProvider(t,n,o){return this.add(0,t,n,o)}addCustomProvider(t,n,o){return this.add(1,t,n,o)}get(t){return this._providers.get(t)}add(t,n,o,r){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,{type:t,extension:o,provider:r}),new f.Disposable(()=>this._providers.delete(n))}}class w{constructor(t,n,o,r,s){this._extHostDocuments=n,this._extensionStoragePaths=o,this._extHostWebview=r,this._extHostWebviewPanels=s,this._editorProviders=new E,this._documents=new l,this._proxy=t.getProxy(C.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,n,o,r){const s=new T.DisposableStore;return S(o)?(s.add(this._editorProviders.addTextProvider(n,t,o)),this._proxy.$registerTextEditorProvider((0,k.toExtensionData)(t),n,r.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(t))):(s.add(this._editorProviders.addCustomProvider(n,t,o)),this.supportEditing(o)&&s.add(o.onDidChangeCustomDocument(c=>{const h=this.getCustomDocumentEntry(n,c.document.uri);if(g(c)){const _=h.addEdit(c);this._proxy.$onDidEdit(c.document.uri,n,_,c.label)}else this._proxy.$onContentChange(c.document.uri,n)})),this._proxy.$registerCustomEditorProvider((0,k.toExtensionData)(t),n,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(t))),f.Disposable.from(s,new f.Disposable(()=>{this._proxy.$unregisterEditorProvider(n)}))}async $createCustomDocument(t,n,o,r,s){var c;const h=this._editorProviders.get(n);if(!h)throw new Error(`No provider found for '${n}'`);if(h.type!==1)throw new Error(`Invalid provide type for '${n}'`);const _=P.URI.revive(t),u=await h.provider.openCustomDocument(_,{backupId:o,untitledDocumentData:r==null?void 0:r.buffer},s);let p;return this.supportEditing(h.provider)&&this._extensionStoragePaths&&(p=(c=this._extensionStoragePaths.workspaceValue(h.extension))!==null&&c!==void 0?c:this._extensionStoragePaths.globalValue(h.extension)),this._documents.add(n,u,p),{editable:this.supportEditing(h.provider)}}async $disposeCustomDocument(t,n){const o=this._editorProviders.get(n);if(!o)throw new Error(`No provider found for '${n}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${n}'`);const r=P.URI.revive(t),{document:s}=this.getCustomDocumentEntry(n,r);this._documents.delete(n,s),s.dispose()}async $resolveWebviewEditor(t,n,o,r,s,c){const h=this._editorProviders.get(o);if(!h)throw new Error(`No provider found for '${o}'`);const _=D.ViewColumn.to(s),u=this._extHostWebview.createNewWebview(n,r.webviewOptions,h.extension),p=this._extHostWebviewPanels.createNewWebviewPanel(n,o,r.title,_,r.panelOptions,u),R=P.URI.revive(t);switch(h.type){case 1:{const{document:O}=this.getCustomDocumentEntry(o,R);return h.provider.resolveCustomEditor(O,p,c)}case 0:{const O=this._extHostDocuments.getDocument(R);return h.provider.resolveCustomTextEditor(O,p,c)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,n,o){this.getCustomDocumentEntry(n,t).disposeEdits(o)}async $onMoveCustomEditor(t,n,o){const r=this._editorProviders.get(o);if(!r)throw new Error(`No provider found for '${o}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const s=this._extHostWebviewPanels.getWebviewPanel(t);if(!s)throw new Error("No webview found");const c=P.URI.revive(n),h=this._extHostDocuments.getDocument(c);await r.provider.moveCustomTextEditor(h,s,b.CancellationToken.None)}async $undo(t,n,o,r){return this.getCustomDocumentEntry(n,t).undo(o,r)}async $redo(t,n,o,r){return this.getCustomDocumentEntry(n,t).redo(o,r)}async $revert(t,n,o){const r=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).revertCustomDocument(r.document,o),r.disposeBackup()}async $onSave(t,n,o){const r=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).saveCustomDocument(r.document,o),r.disposeBackup()}async $onSaveAs(t,n,o,r){const s=this.getCustomDocumentEntry(n,t);return this.getCustomEditorProvider(n).saveCustomDocumentAs(s.document,P.URI.revive(o),r)}async $backup(t,n,o){const r=this.getCustomDocumentEntry(n,t),c=await this.getCustomEditorProvider(n).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},o);return r.updateBackup(c),c.id}getCustomDocumentEntry(t,n){const o=this._documents.get(t,P.URI.revive(n));if(!o)throw new Error("No custom document found");return o}getCustomEditorProvider(t){const n=this._editorProviders.get(t),o=n==null?void 0:n.provider;if(!o||!this.supportEditing(o))throw new Error("Custom document is not editable");return o}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=w;function S(v){return typeof v.resolveCustomTextEditor=="function"}function g(v){return typeof v.undo=="function"&&typeof v.redo=="function"}function a(v){const t=v.scheme===A.Schemas.file||v.scheme===A.Schemas.untitled?v.fsPath:v.toString();return(0,I.hash)(t)+""}});var it=this&&this.__classPrivateFieldSet||function(G,e,b,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,b):T?T.value=b:e.set(G,b),b},We=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)};define(me[251],ge([0,1,3,6,2,30,20,66,5,7]),function(G,e,b,I,T,A,y,P,D,k){"use strict";var i,C,f,m,l,d,E,w,S,g,a,v,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class n extends I.Disposable{constructor(c,h,_,u,p,R,O){super();i.set(this,void 0),C.set(this,void 0),f.set(this,void 0),m.set(this,void 0),l.set(this,void 0),d.set(this,void 0),E.set(this,void 0),w.set(this,void 0),S.set(this,!0),g.set(this,!0),a.set(this,!1),v.set(this,this._register(new b.Emitter)),this.onDidDispose=We(this,v,"f").event,t.set(this,this._register(new b.Emitter)),this.onDidChangeViewState=We(this,t,"f").event,it(this,i,c,"f"),it(this,C,h,"f"),it(this,f,_,"f"),it(this,l,R,"f"),it(this,w,p,"f"),it(this,d,u,"f"),it(this,m,O,"f")}dispose(){We(this,a,"f")||(it(this,a,!0,"f"),We(this,v,"f").fire(),We(this,C,"f").$disposeWebview(We(this,i,"f")),We(this,m,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),We(this,m,"f")}get viewType(){return this.assertNotDisposed(),We(this,f,"f")}get title(){return this.assertNotDisposed(),We(this,d,"f")}set title(c){this.assertNotDisposed(),We(this,d,"f")!==c&&(it(this,d,c,"f"),We(this,C,"f").$setTitle(We(this,i,"f"),c))}get iconPath(){return this.assertNotDisposed(),We(this,E,"f")}set iconPath(c){this.assertNotDisposed(),We(this,E,"f")!==c&&(it(this,E,c,"f"),We(this,C,"f").$setIconPath(We(this,i,"f"),T.URI.isUri(c)?{light:c,dark:c}:c))}get options(){return We(this,l,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof We(this,w,"f")=="number"&&We(this,w,"f")<0))return We(this,w,"f")}get active(){return this.assertNotDisposed(),We(this,g,"f")}get visible(){return this.assertNotDisposed(),We(this,S,"f")}_updateViewState(c){We(this,a,"f")||(this.active!==c.active||this.visible!==c.visible||this.viewColumn!==c.viewColumn)&&(it(this,g,c.active,"f"),it(this,S,c.visible,"f"),it(this,w,c.viewColumn,"f"),We(this,t,"f").fire({webviewPanel:this}))}reveal(c,h){this.assertNotDisposed(),We(this,C,"f").$reveal(We(this,i,"f"),{viewColumn:c?y.ViewColumn.from(c):void 0,preserveFocus:!!h})}assertNotDisposed(){if(We(this,a,"f"))throw new Error("Webview is disposed")}}i=new WeakMap,C=new WeakMap,f=new WeakMap,m=new WeakMap,l=new WeakMap,d=new WeakMap,E=new WeakMap,w=new WeakMap,S=new WeakMap,g=new WeakMap,a=new WeakMap,v=new WeakMap,t=new WeakMap;class o{constructor(c,h,_){this.webviews=h,this.workspace=_,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=c.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(c,h,_,u,p={}){const R=typeof u=="object"?u.viewColumn:u,O={viewColumn:y.ViewColumn.from(R),preserveFocus:typeof u=="object"&&!!u.preserveFocus},j=(0,P.shouldSerializeBuffersForPostMessage)(c),ie=o.newHandle();this._proxy.$createWebviewPanel((0,P.toExtensionData)(c),ie,h,{title:_,panelOptions:r(p),webviewOptions:(0,P.serializeWebviewOptions)(c,this.workspace,p),serializeBuffersForPostMessage:j},O);const K=this.webviews.createNewWebview(ie,p,c);return this.createNewWebviewPanel(ie,h,_,R,p,K)}$onDidChangeWebviewPanelViewStates(c){const h=Object.keys(c);h.sort((_,u)=>{const p=c[_],R=c[u];return p.active?1:R.active?-1:+p.visible-+R.visible});for(const _ of h){const u=this.getWebviewPanel(_);if(!!u){const p=c[_];u._updateViewState({active:p.active,visible:p.visible,viewColumn:y.ViewColumn.to(p.position)})}}}async $onDidDisposeWebviewPanel(c){const h=this.getWebviewPanel(c);h==null||h.dispose(),this._webviewPanels.delete(c),this.webviews.deleteWebview(c)}registerWebviewPanelSerializer(c,h,_){if(this._serializers.has(h))throw new Error(`Serializer for '${h}' already registered`);return this._serializers.set(h,{serializer:_,extension:c}),this._proxy.$registerSerializer(h,{serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(c)}),new k.Disposable(()=>{this._serializers.delete(h),this._proxy.$unregisterSerializer(h)})}async $deserializeWebviewPanel(c,h,_,u){const p=this._serializers.get(h);if(!p)throw new Error(`No serializer found for '${h}'`);const{serializer:R,extension:O}=p,j=this.webviews.createNewWebview(c,_.webviewOptions,O),ie=this.createNewWebviewPanel(c,h,_.title,u,_.panelOptions,j);await R.deserializeWebviewPanel(ie,_.state)}createNewWebviewPanel(c,h,_,u,p,R){const O=new n(c,this._proxy,h,_,u,p,R);return this._webviewPanels.set(c,O),O}getWebviewPanel(c){return this._webviewPanels.get(c)}}e.ExtHostWebviewPanels=o;function r(s){return{enableFindWidget:s.enableFindWidget,retainContextWhenHidden:s.retainContextWhenHidden}}});var it=this&&this.__classPrivateFieldSet||function(G,e,b,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,b):T?T.value=b:e.set(G,b),b},We=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)};define(me[252],ge([0,1,3,6,66,5,7]),function(G,e,b,I,T,A,y){"use strict";var P,D,k,i,C,f,m,l,d,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends I.Disposable{constructor(a,v,t,n,o,r){super();P.set(this,void 0),D.set(this,void 0),k.set(this,void 0),i.set(this,void 0),C.set(this,!1),f.set(this,void 0),m.set(this,void 0),l.set(this,void 0),d.set(this,this._register(new b.Emitter)),this.onDidChangeVisibility=We(this,d,"f").event,E.set(this,this._register(new b.Emitter)),this.onDidDispose=We(this,E,"f").event,it(this,k,t,"f"),it(this,m,n,"f"),it(this,P,a,"f"),it(this,D,v,"f"),it(this,i,o,"f"),it(this,f,r,"f")}dispose(){We(this,C,"f")||(it(this,C,!0,"f"),We(this,E,"f").fire(),We(this,i,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),We(this,m,"f")}set title(a){this.assertNotDisposed(),We(this,m,"f")!==a&&(it(this,m,a,"f"),We(this,D,"f").$setWebviewViewTitle(We(this,P,"f"),a))}get description(){return this.assertNotDisposed(),We(this,l,"f")}set description(a){this.assertNotDisposed(),We(this,l,"f")!==a&&(it(this,l,a,"f"),We(this,D,"f").$setWebviewViewDescription(We(this,P,"f"),a))}get visible(){return We(this,f,"f")}get webview(){return We(this,i,"f")}get viewType(){return We(this,k,"f")}_setVisible(a){a===We(this,f,"f")||We(this,C,"f")||(it(this,f,a,"f"),We(this,d,"f").fire())}show(a){this.assertNotDisposed(),We(this,D,"f").$show(We(this,P,"f"),!!a)}assertNotDisposed(){if(We(this,C,"f"))throw new Error("Webview is disposed")}}P=new WeakMap,D=new WeakMap,k=new WeakMap,i=new WeakMap,C=new WeakMap,f=new WeakMap,m=new WeakMap,l=new WeakMap,d=new WeakMap,E=new WeakMap;class S{constructor(a,v){this._extHostWebview=v,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=a.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(a,v,t,n){if(this._viewProviders.has(v))throw new Error(`View provider for '${v}' already registered`);return this._viewProviders.set(v,{provider:t,extension:a}),this._proxy.$registerWebviewViewProvider((0,T.toExtensionData)(a),v,{retainContextWhenHidden:n==null?void 0:n.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new y.Disposable(()=>{this._viewProviders.delete(v),this._proxy.$unregisterWebviewViewProvider(v)})}async $resolveWebviewView(a,v,t,n,o){const r=this._viewProviders.get(v);if(!r)throw new Error(`No view provider found for '${v}'`);const{provider:s,extension:c}=r,h=this._extHostWebview.createNewWebview(a,{},c),_=new w(a,this._proxy,v,t,h,!0);this._webviewViews.set(a,_),await s.resolveWebviewView(_,{state:n},o)}async $onDidChangeWebviewViewVisibility(a,v){this.getWebviewView(a)._setVisible(v)}async $disposeWebviewView(a){const v=this.getWebviewView(a);this._webviewViews.delete(a),v.dispose(),this._extHostWebview.deleteWebview(a)}getWebviewView(a){const v=this._webviewViews.get(a);if(!v)throw new Error("No webview found");return v}}e.ExtHostWebviewViews=S}),define(me[128],ge([0,1,3,5,2,12,9,4,15]),function(G,e,b,I,T,A,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class xn{constructor(C){this._onDidChangeWindowState=new b.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=xn.InitialState,this._proxy=C.getProxy(I.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(f=>this.$onDidChangeWindowFocus(f))}get state(){return this._state}$onDidChangeWindowFocus(C){C!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:C}),this._onDidChangeWindowState.fire(this._state))}openUri(C,f){let m;if(typeof C=="string"){m=C;try{C=T.URI.parse(C)}catch(l){return Promise.reject(`Invalid uri - '${C}'`)}}return(0,y.isFalsyOrWhitespace)(C.scheme)?Promise.reject("Invalid scheme - cannot be empty"):C.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${C.scheme}'`):this._proxy.$openUri(C,m,f)}async asExternalUri(C,f){if((0,y.isFalsyOrWhitespace)(C.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([A.Schemas.http,A.Schemas.https]).has(C.scheme))return Promise.reject(`Invalid scheme '${C.scheme}'`);const m=await this._proxy.$asExternalUri(C,f);return T.URI.from(m)}};k.InitialState={focused:!0},k=qe([He(0,D.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(me[253],ge([0,1,8,48,30,51,6,5,2,15]),function(G,e,b,I,T,A,y,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let i=class extends y.Disposable{constructor(f,m){super();const l=f.getProxy(P.MainContext.MainThreadDownloadService);m.registerCommand(!1,"_workbench.downloadResource",async d=>{const E=D.URI.file((0,b.join)((0,I.tmpdir)(),(0,T.generateUuid)()));return await l.$download(d,E),E})}};i=qe([He(0,k.IExtHostRpcService),He(1,A.IExtHostCommands)],i),e.ExtHostDownloadService=i}),define(me[254],ge([0,1,2,8,146,26,37,65,28,15,6,14,114,45]),function(G,e,b,I,T,A,y,P,D,k,i,C,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=e.ExtHostOutputChannelBackedByFile=void 0;class l{constructor(S,g){this.file=g,this.appender=(0,f.createRotatingLogger)(S,g,30*m.ByteSize.MB,1),this.appender.clearFormatters()}append(S){this.appender.critical(S)}flush(){this.appender.flush()}}class d extends P.AbstractExtHostOutputChannel{constructor(S,g,a){super(S,!1,b.URI.file(g.file),a);this._appender=g}append(S){super.append(S),this._appender.append(S),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(S,g){this._appender.flush(),super.show(S,g)}clear(){this._appender.flush(),super.clear()}}e.ExtHostOutputChannelBackedByFile=d;let E=class extends P.ExtHostOutputService{constructor(S,g,a){super(S);this.logService=g,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new i.MutableDisposable,this._logsLocation=a.logsLocation}$setVisibleChannel(S){if(S){const g=this._channels.get(S);g&&(this._visibleChannelDisposable.value=g.onDidAppend(()=>g.update()))}}createOutputChannel(S){if(S=S.trim(),!S)throw new Error("illegal argument `name`. must not be falsy");const g=this._doCreateOutChannel(S);return g.then(a=>a._id.then(v=>this._channels.set(v,a))),new P.LazyOutputChannel(S,g)}async _doCreateOutChannel(S){try{const g=(0,I.join)(this._logsLocation.fsPath,`output_logging_${(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await A.SymlinkSupport.existsDirectory(g)||await y.promises.mkdir(g,{recursive:!0});const v=`${this._namePool++}-${S.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=b.URI.file((0,I.join)(g,`${v}.log`)),n=new l(v,t.fsPath);return new d(S,n,this._proxy)}catch(g){return this.logService.error(g),new P.ExtHostPushOutputChannel(S,this._proxy)}}};E=qe([He(0,k.IExtHostRpcService),He(1,C.ILogService),He(2,D.IExtHostInitDataService)],E),e.ExtHostOutputService2=E}),define(me[255],ge([0,1,5,15,6,28,2,38,25,37,26,7,10,50,3,73,14]),function(G,e,b,I,T,A,y,P,D,k,i,C,f,m,l,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class w{constructor(h,_,u){this.remoteAddress=h,this.localAddress=_,this._dispose=u,this._onDispose=new l.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function S(c){const h=c.trim().split(`
`),_=[];return h.forEach(p=>{const R=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(p);R&&R.length>=3&&_.push({pid:parseInt(R[1],10),socket:parseInt(R[2],10)})}),_.reduce((p,R)=>(p[R.socket]=R,p),{})}e.getSockets=S;function g(...c){const h=[].concat(...c.map(v));return[...new Map(h.filter(_=>_.st==="0A").map(_=>{const u=_.local_address.split(":");return{socket:parseInt(_.inode,10),ip:a(u[0]),port:parseInt(u[1],16)}}).map(_=>[_.ip+":"+_.port,_])).values()]}e.loadListeningPorts=g;function a(c){let h="";if(c.length===8)for(let _=c.length-2;_>=0;_-=2)h+=parseInt(c.substr(_,2),16),_!==0&&(h+=".");else for(let _=c.length-4;_>=0;_-=4)h+=parseInt(c.substr(_,4),16).toString(16),_!==0&&(h+=":");return h}e.parseIpAddress=a;function v(c){const h=c.trim().split(`
`),_=h.shift().trim().split(/\s+/).filter(p=>p!=="rx_queue"&&p!=="tm->when");return h.map(p=>p.trim().split(/\s+/).reduce((R,O,j)=>(R[_[j]||j]=O,R),{}))}e.loadConnectionTable=v;function t(c){return!!c.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||c.indexOf("out/vs/server/main.js")!==-1||c.indexOf("_productName=VSCode")!==-1}function n(c){const h=c.trim().split(`
`),_=[];return h.forEach(u=>{const p=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(u);p&&p.length>=4&&_.push({pid:parseInt(p[1],10),ppid:parseInt(p[2]),cmd:p[3]})}),_}e.getRootProcesses=n;async function o(c,h,_){const u=_.reduce((R,O)=>(R[O.pid]=O,R),{}),p=[];return c.forEach(({socket:R,ip:O,port:j})=>{var ie;const K=h[R]?h[R].pid:void 0,x=K?(ie=u[K])===null||ie===void 0?void 0:ie.cmd:void 0;K&&x&&!t(x)&&p.push({host:O,port:j,detail:x,pid:K})}),p}e.findPorts=o;function r(c,h,_){const u=new Map,p=n(h);for(const R of c){const O=_.get(R.port);if(O){u.set(R.port,O);continue}const j=p.find(ie=>ie.cmd.includes(`${R.port}`));if(j){let ie=j,K;do K=p.find(x=>x.ppid===ie.pid),K&&(ie=K);while(K);u.set(R.port,{host:R.ip,port:R.port,pid:ie.pid,detail:ie.cmd,ppid:ie.ppid})}else u.set(R.port,{host:R.ip,port:R.port,ppid:Number.MAX_VALUE})}return u}e.tryFindRootPorts=r;let s=class extends T.Disposable{constructor(h,_,u){super();this.logService=u,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new l.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=h.getProxy(b.MainContext.MainThreadTunnelService),f.isLinux&&_.remote.isRemote&&_.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(h,_){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${h.identifier.value} called openTunnel API for ${_.remoteAddress.host}:${_.remoteAddress.port}.`);const u=await this._proxy.$openTunnel(_,h.displayName);if(u){const p=new w(u.remoteAddress,u.localAddress,()=>this._proxy.$closeTunnel(u.remoteAddress));return this._register(p),p}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(h){return Math.max(h*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(h,_){const u=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(u,{selector:h,provider:_}),this._proxy.$registerPortsAttributesProvider(h,u),new C.Disposable(()=>{this._portAttributesProviders.delete(u),this._proxy.$unregisterPortsAttributesProvider(u)})}async $providePortAttributes(h,_,u,p,R){const O=[];for(const ie of h){const K=this._portAttributesProviders.get(ie);if(!K)return[];O.push(...await Promise.all(_.map(async x=>K.provider.providePortAttributes(x,u,p,R))))}const j=O.filter(ie=>!!ie);return j.length>0?j.map(ie=>({autoForwardAction:ie.autoForwardAction,port:ie.port})):[]}async $registerCandidateFinder(h){if(!(h&&this._candidateFindingEnabled)){this._candidateFindingEnabled=h;let _=new d.MovingAverage,u;for(;this._candidateFindingEnabled;){const p=new Date().getTime(),R=await this.findCandidatePorts();this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${R.map(j=>j.port).join(", ")}`);const O=new Date().getTime()-p;_.update(O),(!u||JSON.stringify(u)!==JSON.stringify(R))&&(u=R,await this._proxy.$onFoundNewCandidates(u)),await new Promise(j=>setTimeout(()=>j(),this.calculateDelay(_.value)))}}}async setTunnelExtensionFunctions(h){var _;return h?(h.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(h.candidatePortSource),h.showCandidatePort&&(this._showCandidatePort=h.showCandidatePort,this._proxy.$setCandidateFilter()),h.tunnelFactory&&(this._forwardPortProvider=h.tunnelFactory,this._proxy.$setTunnelProvider((_=h.tunnelFeatures)!==null&&_!==void 0?_:{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,T.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(h,_){if(this._extensionTunnels.has(h.host)){const u=this._extensionTunnels.get(h.host);u.has(h.port)&&(_&&u.get(h.port).disposeListener.dispose(),await u.get(h.port).tunnel.dispose(),u.delete(h.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(h,_){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const u=this._forwardPortProvider(h,_);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),u!==void 0){const p=await u;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(h.remoteAddress.host)||this._extensionTunnels.set(h.remoteAddress.host,new Map);const R=this._register(p.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(p.remoteAddress))));return this._extensionTunnels.get(h.remoteAddress.host).set(h.remoteAddress.port,{tunnel:p,disposeListener:R}),m.TunnelDto.fromApiTunnel(p)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(u){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(h){const _=await Promise.all(h.map(p=>{var R;return this._showCandidatePort(p.host,p.port,(R=p.detail)!==null&&R!==void 0?R:"")})),u=h.filter((p,R)=>_[R]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${h.map(p=>p.port).join(", ")} to ${u.map(p=>p.port).join(", ")}`),u}async findCandidatePorts(){let h="",_="";try{h=await k.promises.readFile("/proc/net/tcp","utf8"),_=await k.promises.readFile("/proc/net/tcp6","utf8")}catch(U){}const u=g(h,_),p=await new Promise(U=>{(0,P.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(L,N,M)=>{U(N)})}),R=S(p),O=await i.readdir("/proc"),j=[];for(let U of O)try{const L=Number(U),N=D.joinPath(y.URI.file("/proc"),U);if((await k.promises.stat(N.fsPath)).isDirectory()&&!isNaN(L)){const F=await k.promises.readlink(D.joinPath(N,"cwd").fsPath),W=await k.promises.readFile(D.joinPath(N,"cmdline").fsPath,"utf8");j.push({pid:L,cwd:F,cmd:W})}}catch(L){}const ie=[],K=u.filter(U=>{const L=R[U.socket];return L||ie.push(U),L}),x=o(K,R,j);let $;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${ie.length}`),ie.length>0){const U=await new Promise(L=>{(0,P.exec)("ps -F -A -l | grep root",(N,M,F)=>{L(M)})});this._foundRootPorts=r(ie,U,this._foundRootPorts),$=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${$.join(", ")}`)}return x.then(U=>$?U.concat($):U)}};s=qe([He(0,I.IExtHostRpcService),He(1,A.IExtHostInitDataService),He(2,E.ILogService)],s),e.ExtHostTunnelService=s}),define(me[256],ge([0,1,13,21,16,3,6,102,226,126,23]),function(G,e,b,I,T,A,y,P,D,k,i){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function f(r,s){try{return JSON.stringify(r,s)}catch(c){return"null"}}function m(r,s){return JSON.stringify(r,s)}function l(r){return r?(s,c)=>c&&c.$mid===1?r.transformOutgoing(c):c:null}var d;(function(r){r[r.LocalSide=0]="LocalSide",r[r.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));var E;(function(r){r[r.Responsive=0]="Responsive",r[r.Unresponsive=1]="Unresponsive"})(E=e.ResponsiveState||(e.ResponsiveState={}));const w=()=>{},S=Symbol.for("rpcProtocol"),g=Symbol.for("rpcProxy");class a extends y.Disposable{constructor(s,c=null,h=null){super();this[C]=!0,this._onDidChangeResponsiveState=this._register(new A.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=s,this._logger=c,this._uriTransformer=h,this._uriReplacer=l(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let _=0,u=k.ProxyIdentifier.count;_<u;_++)this._locals[_]=null,this._proxies[_]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new b.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(_=>this._receiveOneMessage(_))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(s=>{this._pendingRPCReplies[s].resolveErr(T.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(s){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+a.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(s){this._unresponsiveTime=Date.now()+a.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(s){this._responsiveState!==s&&(this._responsiveState=s,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(s){return this._uriTransformer?(0,P.transformIncomingURIs)(s,this._uriTransformer):s}getProxy(s){const{nid:c,sid:h}=s;return this._proxies[c]||(this._proxies[c]=this._createProxy(c,h)),this._proxies[c]}_createProxy(s,c){let h={get:(_,u)=>(typeof u=="string"&&!_[u]&&u.charCodeAt(0)===36&&(_[u]=(...p)=>this._remoteCall(s,u,p)),u===g?c:_[u])};return new Proxy(Object.create(null),h)}set(s,c){return this._locals[s.nid]=c,c}assertRegistered(s){for(let c=0,h=s.length;c<h;c++){const _=s[c];if(!this._locals[_.nid])throw new Error(`Missing actor ${_.sid} (isMain: ${_.isMain})`)}}_receiveOneMessage(s){if(!this._isDisposed){const c=s.byteLength,h=v.read(s,0),_=h.readUInt8(),u=h.readUInt32();switch(_){case 1:case 2:{let{rpcId:p,method:R,args:O}=t.deserializeRequestJSONArgs(h);this._uriTransformer&&(O=(0,P.transformIncomingURIs)(O,this._uriTransformer)),this._receiveRequest(c,u,p,R,O,_===2);break}case 3:case 4:{let{rpcId:p,method:R,args:O}=t.deserializeRequestMixedArgs(h);this._uriTransformer&&(O=(0,P.transformIncomingURIs)(O,this._uriTransformer)),this._receiveRequest(c,u,p,R,O,_===4);break}case 5:{this._logger&&this._logger.logIncoming(c,u,0,"ack"),this._onDidReceiveAcknowledge(u);break}case 6:{this._receiveCancel(c,u);break}case 7:{this._receiveReply(c,u,void 0);break}case 9:{let p=t.deserializeReplyOKJSON(h);this._uriTransformer&&(p=(0,P.transformIncomingURIs)(p,this._uriTransformer)),this._receiveReply(c,u,p);break}case 8:{let p=t.deserializeReplyOKVSBuffer(h);this._receiveReply(c,u,p);break}case 10:{let p=t.deserializeReplyErrError(h);this._uriTransformer&&(p=(0,P.transformIncomingURIs)(p,this._uriTransformer)),this._receiveReplyErr(c,u,p);break}case 11:{this._receiveReplyErr(c,u,void 0);break}default:console.error("received unexpected message"),console.error(s)}}}_receiveRequest(s,c,h,_,u,p){this._logger&&this._logger.logIncoming(s,c,1,`receiveRequest ${(0,k.getStringIdentifierForProxy)(h)}.${_}(`,u);const R=String(c);let O,j;if(p){const K=new I.CancellationTokenSource;u.push(K.token),O=this._invokeHandler(h,_,u),j=()=>K.cancel()}else O=this._invokeHandler(h,_,u),j=w;this._cancelInvokedHandlers[R]=j;const ie=t.serializeAcknowledged(c);this._logger&&this._logger.logOutgoing(ie.byteLength,c,1,"ack"),this._protocol.send(ie),O.then(K=>{delete this._cancelInvokedHandlers[R];const x=t.serializeReplyOK(c,K,this._uriReplacer);this._logger&&this._logger.logOutgoing(x.byteLength,c,1,"reply:",K),this._protocol.send(x)},K=>{delete this._cancelInvokedHandlers[R];const x=t.serializeReplyErr(c,K);this._logger&&this._logger.logOutgoing(x.byteLength,c,1,"replyErr:",K),this._protocol.send(x)})}_receiveCancel(s,c){this._logger&&this._logger.logIncoming(s,c,1,"receiveCancel");const h=String(c);this._cancelInvokedHandlers[h]&&this._cancelInvokedHandlers[h]()}_receiveReply(s,c,h){this._logger&&this._logger.logIncoming(s,c,0,"receiveReply:",h);const _=String(c);if(!!this._pendingRPCReplies.hasOwnProperty(_)){const u=this._pendingRPCReplies[_];delete this._pendingRPCReplies[_],u.resolveOk(h)}}_receiveReplyErr(s,c,h){this._logger&&this._logger.logIncoming(s,c,0,"receiveReplyErr:",h);const _=String(c);if(!!this._pendingRPCReplies.hasOwnProperty(_)){const u=this._pendingRPCReplies[_];delete this._pendingRPCReplies[_];let p;h&&(h.$isError?(p=new Error,p.name=h.name,p.message=h.message,p.stack=h.stack):p=h),u.resolveErr(p)}}_invokeHandler(s,c,h){try{return Promise.resolve(this._doInvokeHandler(s,c,h))}catch(_){return Promise.reject(_)}}_doInvokeHandler(s,c,h){const _=this._locals[s];if(!_)throw new Error("Unknown actor "+(0,k.getStringIdentifierForProxy)(s));let u=_[c];if(typeof u!="function")throw new Error("Unknown method "+c+" on actor "+(0,k.getStringIdentifierForProxy)(s));return u.apply(_,h)}_remoteCall(s,c,h){if(this._isDisposed)return Promise.reject(T.canceled());let _=null;if(h.length>0&&I.CancellationToken.isCancellationToken(h[h.length-1])&&(_=h.pop()),_&&_.isCancellationRequested)return Promise.reject(T.canceled());const u=t.serializeRequestArguments(h,this._uriReplacer),p=++this._lastMessageId,R=String(p),O=new D.LazyPromise;_&&_.onCancellationRequested(()=>{const ie=t.serializeCancel(p);this._logger&&this._logger.logOutgoing(ie.byteLength,p,0,"cancel"),this._protocol.send(t.serializeCancel(p))}),this._pendingRPCReplies[R]=O,this._onWillSendRequest(p);const j=t.serializeRequest(p,s,c,u,!!_);return this._logger&&this._logger.logOutgoing(j.byteLength,p,0,`request: ${(0,k.getStringIdentifierForProxy)(s)}.${c}(`,h),this._protocol.send(j),O}}e.RPCProtocol=a,C=S,a.UNRESPONSIVE_TIME=3*1e3;class v{constructor(s,c){this._buff=s,this._offset=c}static alloc(s,c,h){let _=new v(i.VSBuffer.alloc(h+1+4),0);return _.writeUInt8(s),_.writeUInt32(c),_}static read(s,c){return new v(s,c)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(s){this._buff.writeUInt8(s,this._offset),this._offset+=1}readUInt8(){const s=this._buff.readUInt8(this._offset);return this._offset+=1,s}writeUInt32(s){this._buff.writeUInt32BE(s,this._offset),this._offset+=4}readUInt32(){const s=this._buff.readUInt32BE(this._offset);return this._offset+=4,s}static sizeShortString(s){return 1+s.byteLength}writeShortString(s){this._buff.writeUInt8(s.byteLength,this._offset),this._offset+=1,this._buff.set(s,this._offset),this._offset+=s.byteLength}readShortString(){const s=this._buff.readUInt8(this._offset);this._offset+=1;const h=this._buff.slice(this._offset,this._offset+s).toString();return this._offset+=s,h}static sizeLongString(s){return 4+s.byteLength}writeLongString(s){this._buff.writeUInt32BE(s.byteLength,this._offset),this._offset+=4,this._buff.set(s,this._offset),this._offset+=s.byteLength}readLongString(){const s=this._buff.readUInt32BE(this._offset);this._offset+=4;const h=this._buff.slice(this._offset,this._offset+s).toString();return this._offset+=s,h}writeBuffer(s){this._buff.writeUInt32BE(s.byteLength,this._offset),this._offset+=4,this._buff.set(s,this._offset),this._offset+=s.byteLength}static sizeVSBuffer(s){return 4+s.byteLength}writeVSBuffer(s){this._buff.writeUInt32BE(s.byteLength,this._offset),this._offset+=4,this._buff.set(s,this._offset),this._offset+=s.byteLength}readVSBuffer(){const s=this._buff.readUInt32BE(this._offset);this._offset+=4;const c=this._buff.slice(this._offset,this._offset+s);return this._offset+=s,c}static sizeMixedArray(s,c){let h=0;h+=1;for(let _=0,u=s.length;_<u;_++){const p=s[_],R=c[_];switch(h+=1,R){case 1:h+=this.sizeLongString(p);break;case 2:h+=this.sizeVSBuffer(p);break;case 3:break}}return h}writeMixedArray(s,c){this._buff.writeUInt8(s.length,this._offset),this._offset+=1;for(let h=0,_=s.length;h<_;h++){const u=s[h];switch(c[h]){case 1:this.writeUInt8(1),this.writeLongString(u);break;case 2:this.writeUInt8(2),this.writeVSBuffer(u);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const s=this._buff.readUInt8(this._offset);this._offset+=1;let c=new Array(s);for(let h=0;h<s;h++)switch(this.readUInt8()){case 1:c[h]=this.readLongString();break;case 2:c[h]=this.readVSBuffer();break;case 3:c[h]=void 0;break}return c}}class t{static _arrayContainsBufferOrUndefined(s){for(let c=0,h=s.length;c<h;c++)if(s[c]instanceof i.VSBuffer||typeof s[c]=="undefined")return!0;return!1}static serializeRequestArguments(s,c){if(this._arrayContainsBufferOrUndefined(s)){let h=[],_=[];for(let u=0,p=s.length;u<p;u++){const R=s[u];R instanceof i.VSBuffer?(h[u]=R,_[u]=2):typeof R=="undefined"?(h[u]=i.VSBuffer.alloc(0),_[u]=3):(h[u]=i.VSBuffer.fromString(m(R,c)),_[u]=1)}return{type:"mixed",args:h,argsType:_}}return{type:"simple",args:m(s,c)}}static serializeRequest(s,c,h,_,u){return _.type==="mixed"?this._requestMixedArgs(s,c,h,_.args,_.argsType,u):this._requestJSONArgs(s,c,h,_.args,u)}static _requestJSONArgs(s,c,h,_,u){const p=i.VSBuffer.fromString(h),R=i.VSBuffer.fromString(_);let O=0;O+=v.sizeUInt8(),O+=v.sizeShortString(p),O+=v.sizeLongString(R);let j=v.alloc(u?2:1,s,O);return j.writeUInt8(c),j.writeShortString(p),j.writeLongString(R),j.buffer}static deserializeRequestJSONArgs(s){const c=s.readUInt8(),h=s.readShortString(),_=s.readLongString();return{rpcId:c,method:h,args:JSON.parse(_)}}static _requestMixedArgs(s,c,h,_,u,p){const R=i.VSBuffer.fromString(h);let O=0;O+=v.sizeUInt8(),O+=v.sizeShortString(R),O+=v.sizeMixedArray(_,u);let j=v.alloc(p?4:3,s,O);return j.writeUInt8(c),j.writeShortString(R),j.writeMixedArray(_,u),j.buffer}static deserializeRequestMixedArgs(s){const c=s.readUInt8(),h=s.readShortString(),_=s.readMixedArray(),u=new Array(_.length);for(let p=0,R=_.length;p<R;p++){const O=_[p];typeof O=="string"?u[p]=JSON.parse(O):u[p]=O}return{rpcId:c,method:h,args:u}}static serializeAcknowledged(s){return v.alloc(5,s,0).buffer}static serializeCancel(s){return v.alloc(6,s,0).buffer}static serializeReplyOK(s,c,h){return typeof c=="undefined"?this._serializeReplyOKEmpty(s):c instanceof i.VSBuffer?this._serializeReplyOKVSBuffer(s,c):this._serializeReplyOKJSON(s,f(c,h))}static _serializeReplyOKEmpty(s){return v.alloc(7,s,0).buffer}static _serializeReplyOKVSBuffer(s,c){let h=0;h+=v.sizeVSBuffer(c);let _=v.alloc(8,s,h);return _.writeVSBuffer(c),_.buffer}static deserializeReplyOKVSBuffer(s){return s.readVSBuffer()}static _serializeReplyOKJSON(s,c){const h=i.VSBuffer.fromString(c);let _=0;_+=v.sizeLongString(h);let u=v.alloc(9,s,_);return u.writeLongString(h),u.buffer}static deserializeReplyOKJSON(s){const c=s.readLongString();return JSON.parse(c)}static serializeReplyErr(s,c){return c?this._serializeReplyErrEror(s,c):this._serializeReplyErrEmpty(s)}static _serializeReplyErrEror(s,c){const h=i.VSBuffer.fromString(f(T.transformErrorForSerialization(c),null));let _=0;_+=v.sizeLongString(h);let u=v.alloc(10,s,_);return u.writeLongString(h),u.buffer}static deserializeReplyErrError(s){const c=s.readLongString();return JSON.parse(c)}static _serializeReplyErrEmpty(s){return v.alloc(11,s,0).buffer}}var n;(function(r){r[r.RequestJSONArgs=1]="RequestJSONArgs",r[r.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",r[r.RequestMixedArgs=3]="RequestMixedArgs",r[r.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",r[r.Acknowledged=5]="Acknowledged",r[r.Cancel=6]="Cancel",r[r.ReplyOKEmpty=7]="ReplyOKEmpty",r[r.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",r[r.ReplyOKJSON=9]="ReplyOKJSON",r[r.ReplyErrError=10]="ReplyErrError",r[r.ReplyErrEmpty=11]="ReplyErrEmpty"})(n||(n={}));var o;(function(r){r[r.String=1]="String",r[r.VSBuffer=2]="VSBuffer",r[r.Undefined=3]="Undefined"})(o||(o={}))}),define(me[257],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,b.createDecorator)("remoteAgentService")}),define(me[258],ge([0,1,12,8,10,2,4,257]),function(G,e,b,I,T,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let D=class{constructor(i,C){this.localUserHome=i,this.remoteAgentService=C,this.resolveOS=(async()=>{const f=await this.remoteAgentService.getEnvironment();return(f==null?void 0:f.os)||T.OS})(),this.resolveUserHome=(async()=>{const f=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(f==null?void 0:f.userHome)||i})()}async userHome(i){return(i==null?void 0:i.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(i=>i===1?I.win32:I.posix)}async fileURI(i){let C="";if(await this.resolveOS===1&&(i=i.replace(/\\/g,"/")),i[0]==="/"&&i[1]==="/"){const m=i.indexOf("/",2);m===-1?(C=i.substring(2),i="/"):(C=i.substring(2,m),i=i.substring(m)||"/")}return A.URI.from({scheme:b.Schemas.file,authority:C,path:i,query:"",fragment:""})}};D=qe([He(1,P.IRemoteAgentService)],D),e.AbstractPathService=D}),define(me[67],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class b{constructor(y,P){this.line=y,this.character=P}isBefore(y){return!1}isBeforeOrEqual(y){return!1}isAfter(y){return!1}isAfterOrEqual(y){return!1}isEqual(y){return!1}compareTo(y){return 0}translate(y,P){return new b(0,0)}with(y){return new b(0,0)}}e.Position=b;class I{constructor(y,P,D,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new b(y,P),this.end=new b(D,k)}contains(y){return!1}isEqual(y){return!1}intersection(y){}union(y){return new I(0,0,0,0)}with(y){return new I(0,0,0,0)}}e.Range=I;var T;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(T=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(me[31],ge([0,1,17,33,24,29,9,4,8,16,67]),function(G,e,b,I,T,A,y,P,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return i.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const C="\u27EA ",f=" characters skipped \u27EB",m=(C.length+f.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var l;(function(L){L[L.file=0]="file",L[L.text=1]="text"})(l=e.SearchProviderType||(e.SearchProviderType={}));var d;(function(L){L[L.File=1]="File",L[L.Text=2]="Text"})(d=e.QueryType||(e.QueryType={}));function E(L){return!!L.preview}e.resultIsMatch=E;function w(L){return!!L.resource}e.isFileMatch=w;function S(L){return!!L.message}e.isProgressMessage=S;var g;(function(L){L[L.Normal=0]="Normal",L[L.NewSearchStarted=1]="NewSearchStarted"})(g=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class a{constructor(N){this.resource=N,this.results=[]}}e.FileMatch=a;class v{constructor(N,M,F){this.ranges=M;const W=Array.isArray(M)?M:[M];if(F&&F.matchLines===1&&t(W)){N=(0,y.getNLines)(N,F.matchLines);let q="",Q=0,le=0;const ve=Math.floor(F.charsPerLine/5),Re=[];for(const Se of W){const Oe=Math.max(Se.startColumn-ve,0),z=Se.startColumn+F.charsPerLine;if(Oe>le+ve+m){const Y=C+(Oe-le)+f;q+=Y+N.slice(Oe,z),Q+=Oe-(le+Y.length)}else q+=N.slice(le,z);Re.push(new o(0,Se.startColumn-Q,Se.endColumn-Q)),le=z}this.preview={text:q,matches:Array.isArray(this.ranges)?Re:Re[0]}}else{const q=Array.isArray(M)?M[0].startLineNumber:M.startLineNumber;this.preview={text:N,matches:(0,b.mapArrayOrNot)(M,Q=>new n(Q.startLineNumber-q,Q.startColumn,Q.endLineNumber-q,Q.endColumn))}}}}e.TextSearchMatch=v;function t(L){const N=L[0].startLineNumber;for(const M of L)if(M.startLineNumber!==N||M.endLineNumber!==N)return!1;return!0}class n{constructor(N,M,F,W){this.startLineNumber=N,this.startColumn=M,this.endLineNumber=F,this.endColumn=W}}e.SearchRange=n;class o extends n{constructor(N,M,F){super(N,M,N,F)}}e.OneLineRange=o;var r;(function(L){L.Default="default",L.FileNames="fileNames",L.Type="type",L.Modified="modified",L.CountDescending="countDescending",L.CountAscending="countAscending"})(r=e.SearchSortOrder||(e.SearchSortOrder={}));function s(L,N=!0){const M=L&&L.files&&L.files.exclude,F=N&&L&&L.search&&L.search.exclude;if(!(!M&&!F)){if(!M||!F)return M||F;let W=Object.create(null);return W=T.mixin(W,T.deepClone(M)),W=T.mixin(W,T.deepClone(F),!0),W}}e.getExcludes=s;function c(L,N){return L.excludePattern&&I.match(L.excludePattern,N)?!1:L.includePattern||L.usingSearchPaths?L.includePattern&&I.match(L.includePattern,N)?!0:L.usingSearchPaths?!!L.folderQueries&&L.folderQueries.some(M=>{const F=M.folder.fsPath;if(A.isEqualOrParent(N,F)){const W=D.relative(F,N);return!M.includePattern||!!I.match(M.includePattern,W)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var h;(function(L){L[L.unknownEncoding=1]="unknownEncoding",L[L.regexParseError=2]="regexParseError",L[L.globParseError=3]="globParseError",L[L.invalidLiteral=4]="invalidLiteral",L[L.rgProcessError=5]="rgProcessError",L[L.other=6]="other",L[L.canceled=7]="canceled"})(h=e.SearchErrorCode||(e.SearchErrorCode={}));class _ extends Error{constructor(N,M){super(N);this.code=M}}e.SearchError=_;function u(L){const N=L.message;if((0,k.isPromiseCanceledError)(L))return new _(N,h.canceled);try{const M=JSON.parse(N);return new _(M.message,M.code)}catch(M){return new _(N,h.other)}}e.deserializeSearchError=u;function p(L){const N={message:L.message,code:L.code};return new Error(JSON.stringify(N))}e.serializeSearchError=p;function R(L){return L.type==="error"?!0:L.type==="success"}e.isSerializedSearchComplete=R;function O(L){return L.type==="success"}e.isSerializedSearchSuccess=O;function j(L){return!!L.path}e.isSerializedFileMatch=j;function ie(L,N){const M=L.searchPath?L.searchPath:L.relativePath;return(0,y.fuzzyContains)(M,N)}e.isFilePatternMatch=ie;class K{constructor(N){this.path=N,this.results=[]}addMatch(N){this.results.push(N)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=K;function x(L,N){const M=Object.assign(Object.assign({},L||{}),N||{});return Object.keys(M).filter(F=>{const W=M[F];return typeof W=="boolean"&&W})}e.resolvePatternsForProvider=x;class ${constructor(N,M){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},N.excludePattern||{}),M.excludePattern||{}),this._parsedExcludeExpression=I.parse(this._excludeExpression);let F=N.includePattern;M.includePattern&&(F?F=Object.assign(Object.assign({},F),M.includePattern):F=M.includePattern),F&&(this._parsedIncludeExpression=I.parse(F))}includedInQuerySync(N,M,F){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(N,M,F)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(N,M,F))}includedInQuery(N,M,F){return Promise.resolve(this._parsedExcludeExpression(N,M,F)).then(q=>!!q).then(q=>q?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(N,M,F)).then(Q=>!!Q):Promise.resolve(!0)).then(q=>q)}hasSiblingExcludeClauses(){return U(this._excludeExpression)}}e.QueryGlobTester=$;function U(L){for(const N in L)if(typeof L[N]!="boolean")return!0;return!1}}),define(me[32],ge([0,1,17,13,21,3,22,12,73,25,9,11,2,167,4,14,186,61,62,28,15,7,31,5]),function(G,e,b,I,T,A,y,P,D,k,i,C,f,m,l,d,E,w,S,g,a,v,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function o(R,O,j){return new k.ExtUri(ie=>h(ie,j)).isEqual(R,O)}function r(R,O,j){return o(R.uri,O.uri,j)?0:(0,i.compare)(R.uri.toString(),O.uri.toString())}function s(R,O,j){return R.index!==O.index?R.index<O.index?-1:1:o(R.uri,O.uri,j)?(0,i.compare)(R.name,O.name):(0,i.compare)(R.uri.toString(),O.uri.toString())}function c(R,O,j,ie){const K=R.slice(0).sort(($,U)=>j($,U,ie)),x=O.slice(0).sort(($,U)=>j($,U,ie));return(0,b.delta)(K,x,($,U)=>j($,U,ie))}function h(R,O){const j=O.getCapabilities(R.scheme);return!(j&&j&1024)}class _ extends w.Workspace{constructor(O,j,ie,K,x,$){super(O,ie.map(U=>new w.WorkspaceFolder(U)),K,$);this._name=j,this._isUntitled=x,this._workspaceFolders=[],this._structure=y.TernarySearchTree.forUris($),ie.forEach(U=>{this._workspaceFolders.push(U),this._structure.set(U.uri,U)})}static toExtHostWorkspace(O,j,ie,K){if(!O)return{workspace:null,added:[],removed:[]};const{id:x,name:$,folders:U,configuration:L,isUntitled:N}=O,M=[],F=j;j?U.forEach((le,ve)=>{const Re=f.URI.revive(le.uri),Se=_._findFolder(ie||j,Re,K);Se?(Se.name=le.name,Se.index=le.index,M.push(Se)):M.push({uri:Re,name:le.name,index:ve})}):M.push(...U.map(({uri:le,name:ve,index:Re})=>({uri:f.URI.revive(le),name:ve,index:Re}))),M.sort((le,ve)=>le.index<ve.index?-1:1);const W=new _(x,$,M,L?f.URI.revive(L):null,!!N,le=>h(le,K)),{added:q,removed:Q}=c(F?F.workspaceFolders:[],W.workspaceFolders,r,K);return{workspace:W,added:q,removed:Q}}static _findFolder(O,j,ie){for(let K=0;K<O.folders.length;K++){const x=O.workspaceFolders[K];if(o(x.uri,j,ie))return x}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(O,j){return j&&this._structure.get(O)&&(O=(0,k.dirname)(O)),this._structure.findSubstr(O)}resolveWorkspaceFolder(O){return this._structure.get(O)}}let u=class{constructor(O,j,ie,K){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=K,this._extHostFileSystemInfo=ie,this._requestIdProvider=new D.Counter,this._barrier=new I.Barrier,this._proxy=O.getProxy(n.MainContext.MainThreadWorkspace),this._messageService=O.getProxy(n.MainContext.MainThreadMessageService);const x=j.workspace;this._confirmedWorkspace=x?new _(x.id,x.name,[],x.configuration?f.URI.revive(x.configuration):null,!!x.isUntitled,$=>h($,ie)):void 0}$initializeWorkspace(O,j){this._trusted=j,this.$acceptWorkspaceData(O),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?f.URI.from({scheme:P.Schemas.untitled,path:(0,k.basename)((0,k.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(O,j,ie,...K){const x=[];if(Array.isArray(K)&&K.forEach(M=>{f.URI.isUri(M.uri)&&!x.some(F=>o(F.uri,M.uri,this._extHostFileSystemInfo))&&x.push({uri:M.uri,name:M.name||(0,k.basenameOrAuthority)(M.uri)})}),this._unconfirmedWorkspace||[j,ie].some(M=>typeof M!="number"||M<0)||ie===0&&x.length===0)return!1;const $=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(j+ie>$.length)return!1;const U=$.slice(0);U.splice(j,ie,...x.map(M=>({uri:M.uri,name:M.name||(0,k.basenameOrAuthority)(M.uri),index:void 0})));for(let M=0;M<U.length;M++){const F=U[M];if(U.some((W,q)=>q!==M&&o(F.uri,W.uri,this._extHostFileSystemInfo)))return!1}U.forEach((M,F)=>M.index=F);const{added:L,removed:N}=c($,U,s,this._extHostFileSystemInfo);if(L.length===0&&N.length===0)return!1;if(this._proxy){const M=O.displayName||O.name;this._proxy.$updateWorkspaceFolders(M,j,ie,x).then(void 0,F=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(E.Severity.Error,(0,m.localize)(0,null,M,F.toString()),{extension:O},[])})}return this.trySetWorkspaceFolders(U),!0}getWorkspaceFolder(O,j){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,j)}async getWorkspaceFolder2(O,j){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,j)}async resolveWorkspaceFolder(O){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(O)}getPath(){if(!!this._actualWorkspace){const{folders:O}=this._actualWorkspace;if(O.length!==0)return O[0].uri.fsPath}}getRelativePath(O,j){let ie,K="";if(typeof O=="string"?(ie=f.URI.file(O),K=O):typeof O!="undefined"&&(ie=O,K=O.fsPath),!ie)return K;const x=this.getWorkspaceFolder(ie,!0);if(!x)return K;typeof j=="undefined"&&this._actualWorkspace&&(j=this._actualWorkspace.folders.length>1);let $=(0,k.relativePath)(x.uri,ie);return j&&x.name&&($=`${x.name}/${$}`),$}trySetWorkspaceFolders(O){this._actualWorkspace&&(this._unconfirmedWorkspace=_.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:O,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(O){const{workspace:j,added:ie,removed:K}=_.toExtHostWorkspace(O,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=j||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:ie,removed:K}))}findFiles(O,j,ie,K,x=T.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${K.value}, entryPoint: findFiles`);let $;if(j===null?$=!1:j&&(typeof j=="string"?$=j:$=j.pattern),x&&x.isCancellationRequested)return Promise.resolve([]);const{includePattern:U,folder:L}=p(O);return this._proxy.$startFileSearch((0,C.withUndefinedAsNull)(U),(0,C.withUndefinedAsNull)(L),(0,C.withUndefinedAsNull)($),(0,C.withUndefinedAsNull)(ie),x).then(N=>Array.isArray(N)?N.map(M=>f.URI.revive(M)):[])}async findTextInFiles(O,j,ie,K,x=T.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${K.value}, entryPoint: findTextInFiles`);const $=this._requestIdProvider.getNext(),U=typeof j.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:j.previewOptions,{includePattern:L,folder:N}=p(j.include),M=typeof j.exclude=="string"?j.exclude:j.exclude?j.exclude.pattern:void 0,F={ignoreSymlinks:typeof j.followSymlinks=="boolean"?!j.followSymlinks:void 0,disregardIgnoreFiles:typeof j.useIgnoreFiles=="boolean"?!j.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof j.useGlobalIgnoreFiles=="boolean"?!j.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof j.useDefaultExcludes=="boolean"?!j.useDefaultExcludes:!0,fileEncoding:j.encoding,maxResults:j.maxResults,previewOptions:U,afterContext:j.afterContext,beforeContext:j.beforeContext,includePattern:L,excludePattern:M},W=!1;if(this._activeSearchCallbacks[$]=q=>{if(!W){const Q=f.URI.revive(q.resource);q.results.forEach(le=>{(0,t.resultIsMatch)(le)?ie({uri:Q,preview:{text:le.preview.text,matches:(0,b.mapArrayOrNot)(le.preview.matches,ve=>new v.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))},ranges:(0,b.mapArrayOrNot)(le.ranges,ve=>new v.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))}):ie({uri:Q,text:le.text,lineNumber:le.lineNumber})})}},x.isCancellationRequested)return{};try{const q=await this._proxy.$startTextSearch(O,(0,C.withUndefinedAsNull)(N),F,$,x);return delete this._activeSearchCallbacks[$],q||{}}catch(q){throw delete this._activeSearchCallbacks[$],q}}$handleTextSearchResult(O,j){this._activeSearchCallbacks[j]&&this._activeSearchCallbacks[j](O)}saveAll(O){return this._proxy.$saveAll(O)}resolveProxy(O){return this._proxy.$resolveProxy(O)}get trusted(){return this._trusted}requestWorkspaceTrust(O){return this._proxy.$requestWorkspaceTrust(O)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};u=qe([He(0,a.IExtHostRpcService),He(1,g.IExtHostInitDataService),He(2,S.IExtHostFileSystemInfo),He(3,d.ILogService)],u),e.ExtHostWorkspace=u,e.IExtHostWorkspace=(0,l.createDecorator)("IExtHostWorkspace");function p(R){let O,j;return R&&(typeof R=="string"?O=R:(O=R.pattern,j=R.baseFolder||f.URI.file(R.base))),{includePattern:O,folder:j}}}),define(me[35],ge([0,1,24,3,32,5,7,188,83,11,13,4,15,14,2]),function(G,e,b,I,T,A,y,P,D,k,i,C,f,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function d(n,o){if(o){const r=o.split(".");let s=n;for(let c=0;s&&c<r.length;c++)s=s[r[c]];return s}}function E(n){return n instanceof l.URI}function w(n){return n&&n.uri instanceof l.URI&&n.languageId&&typeof n.languageId=="string"}function S(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function g(n){return n&&n.uri instanceof l.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function a(n){if(E(n))return{resource:n};if(w(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(S(n))return{overrideIdentifier:n.languageId};if(g(n))return{resource:n.uri};if(n===null)return{resource:null}}let v=class{constructor(o,r,s){this._proxy=o.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=r,this._logService=s,this._barrier=new i.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(o=>this._actual)}$initializeConfiguration(o){this._actual=new t(this._proxy,this._extHostWorkspace,o,this._logService),this._barrier.open()}$acceptConfigurationChanged(o,r){this.getConfigProvider().then(s=>s.$acceptConfigurationChanged(o,r))}};v=qe([He(0,f.IExtHostRpcService),He(1,T.IExtHostWorkspace),He(2,m.ILogService)],v),e.ExtHostConfiguration=v;class t{constructor(o,r,s,c){this._onDidChangeConfiguration=new I.Emitter,this._proxy=o,this._logService=c,this._extHostWorkspace=r,this._configuration=P.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(o,r){const s={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=P.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(r,s))}getConfiguration(o,r,s){const c=a(r)||{},h=this._toReadonlyValue(o?d(this._configuration.getValue(void 0,c,this._extHostWorkspace.workspace),o):this._configuration.getValue(void 0,c,this._extHostWorkspace.workspace));o&&this._validateConfigurationAccess(o,c,s==null?void 0:s.identifier);function _(p){if(p==null)return null;if(typeof p=="boolean")return p?1:4;switch(p){case y.ConfigurationTarget.Global:return 1;case y.ConfigurationTarget.Workspace:return 4;case y.ConfigurationTarget.WorkspaceFolder:return 5}}const u={has(p){return typeof d(h,p)!="undefined"},get:(p,R)=>{this._validateConfigurationAccess(o?`${o}.${p}`:p,c,s==null?void 0:s.identifier);let O=d(h,p);if(typeof O=="undefined")O=R;else{let j;const ie=(K,x)=>{let $;const U=()=>{j=j||(0,b.deepClone)(h),$=$||d(j,x)};return(0,k.isObject)(K)?new Proxy(K,{get:(L,N)=>{if(typeof N=="string"&&N.toLowerCase()==="tojson")return U(),()=>$;if(j)return $=$||d(j,x),$[N];const M=L[N];return typeof N=="string"?ie(M,`${x}.${N}`):M},set:(L,N,M)=>(U(),$&&($[N]=M),!0),deleteProperty:(L,N)=>(U(),$&&delete $[N],!0),defineProperty:(L,N,M)=>(U(),$&&Object.defineProperty($,N,M),!0)}):K};O=ie(O,p)}return O},update:(p,R,O,j)=>{p=o?`${o}.${p}`:p;const ie=_(O);return R!==void 0?this._proxy.$updateConfigurationOption(ie,p,R,c,j):this._proxy.$removeConfigurationOption(ie,p,c,j)},inspect:p=>{var R,O,j,ie,K,x,$,U;p=o?`${o}.${p}`:p;const L=(0,b.deepClone)(this._configuration.inspect(p,c,this._extHostWorkspace.workspace));if(L)return{key:p,defaultValue:(R=L.default)===null||R===void 0?void 0:R.value,globalValue:(O=L.user)===null||O===void 0?void 0:O.value,workspaceValue:(j=L.workspace)===null||j===void 0?void 0:j.value,workspaceFolderValue:(ie=L.workspaceFolder)===null||ie===void 0?void 0:ie.value,defaultLanguageValue:(K=L.default)===null||K===void 0?void 0:K.override,globalLanguageValue:(x=L.user)===null||x===void 0?void 0:x.override,workspaceLanguageValue:($=L.workspace)===null||$===void 0?void 0:$.override,workspaceFolderLanguageValue:(U=L.workspaceFolder)===null||U===void 0?void 0:U.override,languageIds:L.overrideIdentifiers}}};return typeof h=="object"&&(0,b.mixin)(u,h,!1),Object.freeze(u)}_toReadonlyValue(o){const r=s=>(0,k.isObject)(s)?new Proxy(s,{get:(c,h)=>r(c[h]),set:(c,h,_)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(h)}' of object`)},deleteProperty:(c,h)=>{throw new Error(`TypeError: Cannot delete read only property '${String(h)}' of object`)},defineProperty:(c,h)=>{throw new Error(`TypeError: Cannot define property '${String(h)}' for a readonly object`)},setPrototypeOf:c=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):s;return r(o)}_validateConfigurationAccess(o,r,s){const c=D.OVERRIDE_PROPERTY_PATTERN.test(o)?4:this._configurationScopes.get(o),h=s?`[${s.value}] `:"";if(c===4){typeof(r==null?void 0:r.resource)=="undefined"&&this._logService.warn(`${h}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(c===3){(r==null?void 0:r.resource)&&this._logService.warn(`${h}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(o,r){const s=new P.ConfigurationChangeEvent(o,r,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(c,h)=>s.affectsConfiguration(c,a(h))})}_toMap(o){return o.reduce((r,s)=>(r.set(s[0],s[1]),r),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,C.createDecorator)("IExtHostConfiguration")});var it=this&&this.__classPrivateFieldSet||function(G,e,b,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,b):T?T.value=b:e.set(G,b),b},We=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)};define(me[68],ge([0,1,2,13,3,5,7,32,39,35,21,34,15,28,4,12,10,14,64,208,16]),function(G,e,b,I,T,A,y,P,D,k,i,C,f,m,l,d,E,w,S,g,a){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(K){function x(U){if(U!=null)return U}K.from=x;function $(U){if(U!=null)return U}K.to=$})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var n;(function(K){function x(U){if(U!=null)return U}K.from=x;function $(U){if(U!=null)return U}K.to=$})(n=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var o;(function(K){function x(U){if(U!=null)return U}K.from=x;function $(U){if(U!=null)return U}K.to=$})(o=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var r;(function(K){function x(L){if(L){const N=L;return N&&!!N.process}else return!1}K.is=x;function $(L){if(L!=null){const N={process:L.process,args:L.args};return L.options&&(N.options=o.from(L.options)),N}}K.from=$;function U(L){if(L!=null)return new y.ProcessExecution(L.process,L.args,L.options)}K.to=U})(r=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var s;(function(K){function x(U){if(U!=null)return U}K.from=x;function $(U){if(U!=null)return U}K.to=$})(s=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var c;(function(K){function x(L){if(L){const N=L;return N&&(!!N.commandLine||!!N.command)}else return!1}K.is=x;function $(L){if(L!=null){const N={};return L.commandLine!==void 0?N.commandLine=L.commandLine:(N.command=L.command,N.args=L.args),L.options&&(N.options=s.from(L.options)),N}}K.from=$;function U(L){if(!(L==null||L.command===void 0&&L.commandLine===void 0))return L.commandLine?new y.ShellExecution(L.commandLine,L.options):new y.ShellExecution(L.command,L.args?L.args:[],L.options)}K.to=U})(c=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var h;(function(K){function x(L){if(L){let N=L;return N&&N.customExecution==="customExecution"}else return!1}K.is=x;function $(L){return{customExecution:"customExecution"}}K.from=$;function U(L,N){return N.get(L)}K.to=U})(h=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var _;(function(K){function x($,U){let L;return $.scope!==void 0&&typeof $.scope!="number"?L=$.scope.uri:$.scope!==void 0&&typeof $.scope=="number"&&($.scope===y.TaskScope.Workspace&&U&&U.workspaceFile?L=U.workspaceFile:L=g.USER_TASKS_GROUP_KEY),{id:$._id,workspaceFolder:L}}K.from=x})(_=e.TaskHandleDTO||(e.TaskHandleDTO={}));var u;(function(K){function x(L,N){if(L==null)return[];const M=[];for(let F of L){const W=$(F,N);W&&M.push(W)}return M}K.fromMany=x;function $(L,N){if(L!=null){let M;L.execution instanceof y.ProcessExecution?M=r.from(L.execution):L.execution instanceof y.ShellExecution?M=c.from(L.execution):L.execution&&L.execution instanceof y.CustomExecution&&(M=h.from(L.execution));const F=t.from(L.definition);let W;if(L.scope?typeof L.scope=="number"?W=L.scope:W=L.scope.uri:W=y.TaskScope.Workspace,!(!F||!W)){const q=L.group?L.group.id:void 0;return{_id:L._id,definition:F,name:L.name,source:{extensionId:N.identifier.value,label:L.source,scope:W},execution:M,isBackground:L.isBackground,group:q,presentationOptions:n.from(L.presentationOptions),problemMatchers:L.problemMatchers,hasDefinedMatchers:L.hasDefinedMatchers,runOptions:L.runOptions?L.runOptions:{reevaluateOnRerun:!0},detail:L.detail}}}}K.from=$;async function U(L,N,M){if(L!=null){let F;r.is(L.execution)?F=r.to(L.execution):c.is(L.execution)?F=c.to(L.execution):h.is(L.execution)&&(F=h.to(L._id,M));const W=t.to(L.definition);let q;if(L.source&&(L.source.scope!==void 0?typeof L.source.scope=="number"?q=L.source.scope:q=await N.resolveWorkspaceFolder(b.URI.revive(L.source.scope)):q=y.TaskScope.Workspace),!(!W||!q)){const Q=new y.Task(W,q,L.name,L.source.label,F,L.problemMatchers);return L.isBackground!==void 0&&(Q.isBackground=L.isBackground),L.group!==void 0&&(Q.group=y.TaskGroup.from(L.group)),L.presentationOptions&&(Q.presentationOptions=n.to(L.presentationOptions)),L._id&&(Q._id=L._id),L.detail&&(Q.detail=L.detail),Q}}}K.to=U})(u=e.TaskDTO||(e.TaskDTO={}));var p;(function(K){function x(U){return U}K.from=x;function $(U){if(!!U)return Object.assign(Object.create(null),U)}K.to=$})(p=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(x,$,U){this._id=$,this._task=U,v.set(this,void 0),it(this,v,x,"f")}get task(){return this._task}terminate(){We(this,v,"f").terminateTask(this)}fireDidStartProcess(x){}fireDidEndProcess(x){}}v=new WeakMap;var O;(function(K){function x($){return{id:$._id,task:void 0}}K.from=x})(O=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let j=class{constructor(x,$,U,L,N,M,F,W){this._onDidExecuteTask=new T.Emitter,this._onDidTerminateTask=new T.Emitter,this._onDidTaskProcessStarted=new T.Emitter,this._onDidTaskProcessEnded=new T.Emitter,this._proxy=x.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=U,this._editorService=L,this._configurationService=N,this._terminalService=M,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=F,this._deprecationService=W,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(x,$,U){if(!U)return new y.Disposable(()=>{});const L=this.nextHandle();return this._handlers.set(L,{type:$,provider:U,extension:x}),this._proxy.$registerTaskProvider(L,$),new y.Disposable(()=>{this._handlers.delete(L),this._proxy.$unregisterTaskProvider(L)})}registerTaskSystem(x,$){this._proxy.$registerTaskSystem(x,$)}fetchTasks(x){return this._proxy.$fetchTasks(p.from(x)).then(async $=>{const U=[];for(let L of $){const N=await u.to(L,this._workspaceProvider,this._providedCustomExecutions2);N&&U.push(N)}return U})}get taskExecutions(){const x=[];return this._taskExecutions.forEach($=>x.push($)),x}terminateTask(x){if(!(x instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(x._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(x,$,U){const L=this._providedCustomExecutions2.get(x.id);if(L){if(this._activeCustomExecutions2.get(x.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(x.id,L),this._terminalService.attachPtyToTerminal($,await L.callback(U))}this._lastStartedTask=x.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(x)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(x){const $=await this.getTaskExecution(x);this._taskExecutionPromises.delete(x.id),this._taskExecutions.delete(x.id),this.customExecutionComplete(x),this._onDidTerminateTask.fire({execution:$})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(x){const $=await this.getTaskExecution(x.id);this._onDidTaskProcessStarted.fire({execution:$,processId:x.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(x){const $=await this.getTaskExecution(x.id);this._onDidTaskProcessEnded.fire({execution:$,exitCode:x.exitCode})}$provideTasks(x,$){const U=this._handlers.get(x);if(!U)return Promise.reject(new Error("no handler found"));const L=[],N=(0,I.asPromise)(()=>U.provider.provideTasks(i.CancellationToken.None)).then(M=>this.provideTasksInternal($,L,U,M));return new Promise(M=>{N.then(F=>{Promise.all(L).then(()=>{M(F)})})})}async $resolveTask(x,$){const U=this._handlers.get(x);if(!U)return Promise.reject(new Error("no handler found"));if($.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${$.definition.type}] cannot be resolved by provider of type [${U.type}].`);const L=await u.to($,this._workspaceProvider,this._providedCustomExecutions2);if(!L)throw new Error("Unexpected: Task cannot be resolved.");const N=await U.provider.resolveTask(L,i.CancellationToken.None);if(!!N){this.checkDeprecation(N,U);const M=u.from(N,U.extension);if(!M)throw new Error("Unexpected: Task cannot be resolved.");if(N.definition!==L.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return h.is(M.execution)&&await this.addCustomExecution(M,N,!0),await this.resolveTaskInternal(M)}}nextHandle(){return this._handleCounter++}async addCustomExecution(x,$,U){const L=await this._proxy.$createTaskId(x);!U&&!this._providedCustomExecutions2.has(L)&&this._notProvidedCustomExecutions.add(L),this._providedCustomExecutions2.set(L,$.execution)}async getTaskExecution(x,$){if(typeof x=="string"){const N=this._taskExecutionPromises.get(x);if(!N)throw new Error("Unexpected: The specified task is missing an execution");return N}let U=this._taskExecutionPromises.get(x.id);if(U)return U;const L=new Promise(async(N,M)=>{const F=$||await u.to(x.task,this._workspaceProvider,this._providedCustomExecutions2);F?N(new R(this,x.id,F)):M("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(x.id,L),L.then(N=>(this._taskExecutions.set(x.id,N),N),N=>Promise.reject(N))}checkDeprecation(x,$){x._deprecated&&this._deprecationService.report("Task.constructor",$.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(x){this._activeCustomExecutions2.get(x.id)&&this._activeCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.has(x.id)&&this._lastStartedTask!==x.id&&(this._providedCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.delete(x.id));let U=this._notProvidedCustomExecutions.values(),L=U.next();for(;!L.done;)!this._activeCustomExecutions2.has(L.value)&&this._lastStartedTask!==L.value&&(this._providedCustomExecutions2.delete(L.value),this._notProvidedCustomExecutions.delete(L.value)),L=U.next()}};j=qe([He(0,f.IExtHostRpcService),He(1,m.IExtHostInitDataService),He(2,P.IExtHostWorkspace),He(3,D.IExtHostDocumentsAndEditors),He(4,k.IExtHostConfiguration),He(5,C.IExtHostTerminalService),He(6,w.ILogService),He(7,S.IExtHostApiDeprecationService)],j),e.ExtHostTaskBase=j;let ie=class extends j{constructor(x,$,U,L,N,M,F,W){super(x,$,U,L,N,M,F,W);this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:E.PlatformToString(0)})}async executeTask(x,$){if(!$.execution)throw new Error("Tasks to execute must include an execution");const U=u.from($,x);if(U===void 0)throw new Error("Task is not valid");if(h.is(U.execution))await this.addCustomExecution(U,$,!1);else throw new a.NotSupportedError;const L=await this.getTaskExecution(await this._proxy.$getTaskExecution(U),$);return this._proxy.$executeTask(U).catch(N=>{throw new Error(N)}),L}provideTasksInternal(x,$,U,L){const N=[];if(L)for(let M of L){this.checkDeprecation(M,U),(!M.definition||!x[M.definition.type])&&this._logService.warn(`The task [${M.source}, ${M.name}] uses an undefined task type. The task will be ignored in the future.`);const F=u.from(M,U.extension);F&&h.is(F.execution)?(N.push(F),$.push(this.addCustomExecution(F,M,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:N,extension:U.extension}}async resolveTaskInternal(x){if(h.is(x.execution))return x;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(x,$){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(x,$,U){}};ie=qe([He(0,f.IExtHostRpcService),He(1,m.IExtHostInitDataService),He(2,P.IExtHostWorkspace),He(3,D.IExtHostDocumentsAndEditors),He(4,k.IExtHostConfiguration),He(5,C.IExtHostTerminalService),He(6,w.ILogService),He(7,S.IExtHostApiDeprecationService)],ie),e.WorkerExtHostTask=ie,e.IExtHostTask=(0,l.createDecorator)("IExtHostTask")});var it=this&&this.__classPrivateFieldSet||function(G,e,b,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,b):T?T.value=b:e.set(G,b),b},We=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)},Jt=this&&this.__rest||function(G,e){var b={};for(var I in G)Object.prototype.hasOwnProperty.call(G,I)&&e.indexOf(I)<0&&(b[I]=G[I]);if(G!=null&&typeof Object.getOwnPropertySymbols=="function")for(var T=0,I=Object.getOwnPropertySymbols(G);T<I.length;T++)e.indexOf(I[T])<0&&Object.prototype.propertyIsEnumerable.call(G,I[T])&&(b[I[T]]=G[I[T]]);return b};define(me[259],ge([0,1,17,13,23,21,3,71,55,6,24,11,2,30,5,39,15,87,20,7,32,221,124]),function(G,e,b,I,T,A,y,P,D,k,i,C,f,m,l,d,E,w,S,g,a,v,t){"use strict";var n,o,r,s;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const c=(U,L)=>`${U}:${L.toString()}`;let h=class{constructor(L,N,M){this.documents=N,this.workspace=M,this.resultsChangedEmitter=new y.Emitter,this.controllers=new Map,this.ownedTests=new v.OwnedTestCollection,this.testControllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=L.getProxy(l.MainContext.MainThreadTesting),this.runQueue=new _(this.proxy),this.workspaceObservers=new x(this.proxy),this.textDocumentObservers=new $(this.proxy,N)}registerTestController(L,N){const M=(0,m.generateUuid)();this.controllers.set(M,{instance:N,extensionId:L}),this.proxy.$registerTestController(M);const F=[...this.testControllers.keys()];return setTimeout(()=>{var W;for(const q of F)(W=this.testControllers.get(q))===null||W===void 0||W.subscribeFn(M,N)},0),new g.Disposable(()=>{this.controllers.delete(M),this.proxy.$unregisterTestController(M)})}createTextDocumentTestObserver(L){return this.textDocumentObservers.checkout(L.uri)}createWorkspaceTestObserver(L){return this.workspaceObservers.checkout(L.uri)}async runTests(L,N=A.CancellationToken.None){const M=F=>F.map(this.getInternalTestForReference,this).filter(C.isDefined).map(W=>({src:W.src,testId:W.item.extId}));await this.proxy.$runTests({exclude:L.exclude?M(L.exclude).map(F=>F.testId):void 0,tests:M(L.tests),debug:L.debug},N)}createTestRun(L,N,M,F=!0){return this.runQueue.createTestRun(L,N,M,F)}$publishTestResults(L){this.results=Object.freeze(L.map(N=>(0,i.deepFreeze)(S.TestResults.to(N))).concat(this.results).sort((N,M)=>M.completedAt-N.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(L,N){const M=f.URI.revive(N),F=c(L,M);if(!this.testControllers.has(F)){const W=new A.CancellationTokenSource;let q;if(L===1){let Se=this.documents.getDocument(M);if(!Se){const Oe=new k.DisposableStore;Se=await new Promise(z=>{Oe.add((0,I.disposableTimeout)(()=>z(void 0),5e3)),Oe.add(this.documents.onDidAddDocuments(Y=>{const ee=Y.find(se=>se.document.uri.toString()===M.toString());ee&&z(ee)}))}).finally(()=>Oe.dispose())}if(Se){const Oe=await this.workspace.getWorkspaceFolder2(M,!1);q=z=>z.createDocumentTestRoot?z.createDocumentTestRoot(Se.document,W.token):(0,e.createDefaultDocumentTestRoot)(z,Se.document,Oe,W.token)}}else{const Se=await this.workspace.getWorkspaceFolder2(M,!1);Se&&(q=Oe=>Oe.createWorkspaceTestRoot(Se,W.token))}if(!!q){const Q=async(Se,Oe)=>{try{const z=await q(Oe);z&&ve.addRoot(z,Se)}catch(z){console.error(z)}},le=new k.DisposableStore,ve=le.add(this.ownedTests.createForHierarchy(Se=>this.proxy.$publishDiff(L,N,Se)));le.add((0,k.toDisposable)(()=>W.dispose(!0)));const Re=[];for(const[Se,Oe]of this.controllers)Re.push(Q(Se,Oe.instance));Promise.all(Re).then(()=>ve.pushDiff([3,-1])),this.testControllers.set(F,{store:le,collection:ve,subscribeFn:Q})}}}async $expandTest(L,N){const M=(0,b.mapFind)(this.testControllers.values(),F=>F.collection.treeId===L.src.tree?F:void 0);await(M==null?void 0:M.collection.expand(L.testId,N<0?Infinity:N)),this.flushCollectionDiffs()}$unsubscribeFromTests(L,N){var M;const F=f.URI.revive(N),W=c(L,F);(M=this.testControllers.get(W))===null||M===void 0||M.store.dispose(),this.testControllers.delete(W)}$acceptDiff(L,N,M){L===1?this.textDocumentObservers.acceptDiff(f.URI.revive(N),M):this.workspaceObservers.acceptDiff(f.URI.revive(N),M)}async $runTestsForProvider(L,N){const M=this.controllers.get(L.tests[0].src.controller);if(!!M){const F=L.tests.map(({testId:Q,src:le})=>this.ownedTests.getTestById(Q,le==null?void 0:le.tree)).filter(C.isDefined).map(([Q,le])=>le),W=L.excludeExtIds.map(Q=>this.ownedTests.getTestById(Q)).filter(C.isDefined).filter(([Q,le])=>F.some(ve=>Q.comparePositions(ve,le)===1));if(!!F.length){const q={tests:F.map(Q=>O.unwrap(Q.actual)),exclude:W.map(([,Q])=>O.unwrap(Q.actual)),debug:L.debug};await this.runQueue.enqueueRun({dto:u.fromInternal(L),token:N,extensionId:M.extensionId,req:q,doRun:()=>M.instance.runTests(q,N)})}}}$lookupTest(L){const N=this.ownedTests.getTestById(L.testId);if(!N)return Promise.resolve(void 0);const M=N[1],{actual:F,discoverCts:W,expandLevels:q}=M,Q=Jt(M,["actual","discoverCts","expandLevels"]);return Promise.resolve(Q)}flushCollectionDiffs(){for(const{collection:L}of this.testControllers.values())L.flushDiff()}getInternalTestForReference(L){var N,M;return(M=(N=this.workspaceObservers.getMirroredTestDataByReference(L))!==null&&N!==void 0?N:(0,b.mapFind)(this.testControllers.values(),F=>F.collection.getTestByReference(L)))!==null&&M!==void 0?M:this.textDocumentObservers.getMirroredTestDataByReference(L)}};h=qe([He(0,E.IExtHostRpcService),He(1,d.IExtHostDocumentsAndEditors),He(2,a.IExtHostWorkspace)],h),e.ExtHostTesting=h;class _{constructor(L){this.proxy=L,this.state=new Map}enqueueRun(L){let N=this.state.get(L.extensionId);N||(N={queue:[],current:void 0},this.state.set(L.extensionId,N));const M=new I.DeferredPromise,F=()=>{const W=[],q=new Set;N.current={publicReq:L.req,factory:Q=>{const le=new p(Q,L.dto,q,this.proxy);return W.push(le),L.token.onCancellationRequested(()=>le.end()),le}},this.invokeRunner(L.extensionId,L.dto.id,L.doRun,W).finally(()=>M.complete())};return N.queue.push(F),N.queue.length===1&&F(),M.p}createTestRun(L,N,M,F){var W,q;const Q=this.state.get(L);if((Q==null?void 0:Q.current.publicReq)===N)return Q.current.factory(M);const le=u.fromPublic(N),ve=new p(M,le,new Set,this.proxy);return this.proxy.$startedExtensionTestRun({debug:N.debug,exclude:(q=(W=N.exclude)===null||W===void 0?void 0:W.map(Re=>Re.id))!==null&&q!==void 0?q:[],id:le.id,tests:N.tests.map(Re=>Re.id),persist:F}),ve.onEnd.wait().then(()=>this.proxy.$finishedExtensionTestRun(le.id)),ve}invokeRunner(L,N,M,F){try{const W=M();return(0,I.isThenable)(W)?W.then(()=>this.handleInvokeResult(L,N,F,void 0)).catch(q=>this.handleInvokeResult(L,N,F,q)):this.handleInvokeResult(L,N,F,void 0)}catch(W){return this.handleInvokeResult(L,N,F,W)}}async handleInvokeResult(L,N,M,F){const W=this.state.get(L);!W||(W.queue.shift(),W.queue.length>0?W.queue[0]():this.state.delete(L),await Promise.all(M.map(q=>q.onEnd.wait())))}}class u{constructor(L,N,M){this.id=L,this.include=N,this.exclude=M}static fromPublic(L){var N,M;return new u((0,m.generateUuid)(),new Set(L.tests.map(F=>F.id)),new Set((M=(N=L.exclude)===null||N===void 0?void 0:N.map(F=>F.id))!==null&&M!==void 0?M:D.Iterable.empty()))}static fromInternal(L){return new u(L.runId,new Set(L.tests.map(N=>N.testId)),new Set(L.excludeExtIds))}isIncluded(L){for(let N=L;N;N=N.parent){if(this.include.has(N.id))return!0;if(this.exclude.has(N.id))return!1}return!0}}class p{constructor(L,N,M,F){this.name=L,n.set(this,void 0),o.set(this,void 0),r.set(this,(0,m.generateUuid)()),s.set(this,void 0),this.onEnd=new I.Barrier,it(this,n,F,"f"),it(this,o,N,"f"),it(this,s,M,"f"),F.$startedTestRunTask(N.id,{id:We(this,r,"f"),name:L,running:!0})}setState(L,N,M){We(this,o,"f").isIncluded(L)&&(this.ensureTestIsKnown(L),We(this,n,"f").$updateTestStateInRun(We(this,o,"f").id,We(this,r,"f"),L.id,N,M))}appendMessage(L,N){We(this,o,"f").isIncluded(L)&&(this.ensureTestIsKnown(L),We(this,n,"f").$appendTestMessageInRun(We(this,o,"f").id,We(this,r,"f"),L.id,S.TestMessage.from(N)))}appendOutput(L){We(this,n,"f").$appendOutputToRun(We(this,o,"f").id,We(this,r,"f"),T.VSBuffer.fromString(L))}end(){We(this,n,"f").$finishedTestRunTask(We(this,o,"f").id,We(this,r,"f")),this.onEnd.open()}ensureTestIsKnown(L){const N=We(this,s,"f");if(!N.has(L.id)){const M=[];for(;M.unshift(S.TestItem.from(L)),!(N.has(L.id)||(N.add(L.id),!L.parent));)L=L.parent;We(this,n,"f").$addTestsToRun(We(this,o,"f").id,M)}}}n=new WeakMap,o=new WeakMap,r=new WeakMap,s=new WeakMap;const R=async(U,L,N,M)=>{if(!!N){const F=await U.createWorkspaceTestRoot(N,M);if(!!F){M.onCancellationRequested(()=>{O.removeFilter(L)});const W=O.getWrapperForTestItem(F,L);return W.refreshMatch(),W}}};e.createDefaultDocumentTestRoot=R;class O extends g.TestItemImpl{constructor(L,N,M){super(L.id,L.label,L.uri,void 0);if(this.actual=L,this.filterDocument=N,this.actualParent=M,!(L instanceof g.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${L.id} did not`);this.debuggable=L.debuggable,this.runnable=L.runnable,this.description=L.description,this.error=L.error,this.status=L.status,this.range=L.range,this.resolveHandler=L.resolveHandler;const F=(0,w.getPrivateApiFor)(this);(0,w.getPrivateApiFor)(L).bus.event(q=>{switch(q[0]){case 3:this[q[1]]=q[2];break;case 0:const Q=O.getWrapperForTestItem(q[1],this.filterDocument,this);(0,w.getPrivateApiFor)(Q).parent=L,Q.refreshMatch();break;default:F.bus.fire(q)}})}static removeFilter(L){this.wrapperMap.delete(L)}static getWrapperForTestItem(L,N,M){let F=this.wrapperMap.get(N);if(F==null?void 0:F.has(L))return F.get(L);F||(F=new WeakMap,this.wrapperMap.set(N,F));const W=new O(L,N,M);return F.set(L,W),W}static unwrap(L){return L instanceof O?L.actual:L}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var L,N;const M=this._cachedMatchesFilter;for(const W of this.actual.children.values()){const q=O.getWrapperForTestItem(W,this.filterDocument,this);q.hasNodeMatchingFilter?this.children.has(q.id)||this.addChild(q):q.dispose()}const F=this.children.size>0||((L=this.actual.uri)===null||L===void 0?void 0:L.toString())===this.filterDocument.uri.toString();return this._cachedMatchesFilter=F,F!==M&&((N=this.actualParent)===null||N===void 0||N.refreshMatch()),this._cachedMatchesFilter}dispose(){this.actualParent&&(0,w.getPrivateApiFor)(this.actualParent).children.delete(this.id),(0,w.getPrivateApiFor)(this).bus.fire([1])}}e.TestItemFilteredWrapper=O,O.wrapperMap=new WeakMap;class j extends t.IncrementalChangeCollector{constructor(L){super();this.emitter=L,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(L){this.added.add(L)}update(L){Object.assign(L.revived,S.TestItem.toPlain(L.item)),this.added.has(L)||this.updated.add(L)}remove(L){if(this.added.has(L)){this.added.delete(L);return}if(this.updated.delete(L),L.parent&&this.alreadyRemoved.has(L.parent)){this.alreadyRemoved.add(L.item.extId);return}this.removed.add(L)}getChangeEvent(){const{added:L,updated:N,removed:M}=this;return{get added(){return[...L].map(F=>F.revived)},get updated(){return[...N].map(F=>F.revived)},get removed(){return[...M].map(F=>F.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class ie extends t.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new y.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(L){let N=[];for(const M of L){const F=this.items.get(M);F&&N.push(F.revived)}return N}getMirroredTestDataById(L){return this.items.get(L)}getMirroredTestDataByReference(L){return this.items.get(L.id)}createItem(L,N){return Object.assign(Object.assign({},L),{revived:S.TestItem.toPlain(L.item),depth:N?N.depth+1:0,children:new Set})}createChangeCollector(){return new j(this.changeEmitter)}}e.MirroredTestCollection=ie;class K{constructor(){this.resources=new Map}checkout(L){var N,M;const F=L.toString(),W=(N=this.resources.get(F))!==null&&N!==void 0?N:this.createObserverData(L);return(M=W.pendingDeletion)===null||M===void 0||M.dispose(),W.observers++,{onDidChangeTest:W.tests.onDidChangeTests,onDidDiscoverInitialTests:new y.Emitter().event,get tests(){return W.tests.rootTestItems},dispose:(0,P.once)(()=>{--W.observers||(W.pendingDeletion=this.eventuallyDispose(L))})}}getMirroredTestDataByReference(L){for(const{tests:N}of this.resources.values()){const M=N.getMirroredTestDataByReference(L);if(M)return M}}eventuallyDispose(L){return(0,I.disposableTimeout)(()=>this.unlisten(L),10*1e3)}createObserverData(L){const N=new ie,M=this.listen(L,W=>N.apply(W)),F={observers:0,tests:N,listener:M};return this.resources.set(L.toString(),F),F}unlisten(L){var N;const M=L.toString(),F=this.resources.get(M);F&&(F.observers=-1,(N=F.pendingDeletion)===null||N===void 0||N.dispose(),F.listener.dispose(),this.resources.delete(M))}}class x extends K{constructor(L){super();this.proxy=L,this.diffListeners=new Map}acceptDiff(L,N){var M;(M=this.diffListeners.get(L.toString()))===null||M===void 0||M(N)}listen(L,N){this.proxy.$subscribeToDiffs(0,L);const M=L.toString();return this.diffListeners.set(M,N),new g.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,L),this.diffListeners.delete(M)})}}class $ extends K{constructor(L,N){super();this.proxy=L,this.documents=N,this.diffListeners=new Map}acceptDiff(L,N){var M;(M=this.diffListeners.get(L.toString()))===null||M===void 0||M(N)}listen(L,N){if(!this.documents.getDocument(L))return new g.Disposable(()=>{});const F=L.toString();return this.diffListeners.set(F,N),this.proxy.$subscribeToDiffs(1,L),new g.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,L),this.diffListeners.delete(F)})}}}),define(me[260],ge([0,1,17,53,33,76,22,12,8,25,9,11,2,140,172,84,61,213,258,31]),function(G,e,b,I,T,A,y,P,D,k,i,C,f,m,l,d,E,w,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let a=class{constructor(_,u,p,R){this.configurationService=_,this.workspaceContextService=u,this.editorGroupsService=p,this.pathService=R}text(_,u,p={}){_=this.getContentPattern(_,p);const R=this.configurationService.getValue(),O=u&&u.some(ie=>!this.configurationService.getValue({resource:ie}).search.useRipgrep),j=this.commonQuery(u==null?void 0:u.map(E.toWorkspaceFolder),p);return Object.assign(Object.assign({},j),{type:2,contentPattern:_,previewOptions:p.previewOptions,maxFileSize:p.maxFileSize,usePCRE2:R.search.usePCRE2||O||!1,beforeContext:p.beforeContext,afterContext:p.afterContext,userDisabledExcludesAndIgnoreFiles:p.disregardExcludeSettings&&p.disregardIgnoreFiles})}getContentPattern(_,u){const p=this.configurationService.getValue();_.isRegExp&&(_.pattern=_.pattern.replace(/\r?\n/g,"\\n"));const R=Object.assign(Object.assign({},_),{wordSeparators:p.editor.wordSeparators});return this.isCaseSensitive(_,u)&&(R.isCaseSensitive=!0),this.isMultiline(_)&&(R.isMultiline=!0),R}file(_,u={}){const p=this.commonQuery(_,u);return Object.assign(Object.assign({},p),{type:1,filePattern:u.filePattern?u.filePattern.trim():u.filePattern,exists:u.exists,sortByScore:u.sortByScore,cacheKey:u.cacheKey})}handleIncludeExclude(_,u){return _?(_=Array.isArray(_)?_.map(r):r(_),u?this.parseSearchPaths(_):{pattern:t(...Array.isArray(_)?_:[_])}):{}}commonQuery(_=[],u={}){const p=this.handleIncludeExclude(u.includePattern,u.expandPatterns),R=this.handleIncludeExclude(u.excludePattern,u.expandPatterns),O=_.length>1,j=(p.searchPaths&&p.searchPaths.length?p.searchPaths.map(x=>this.getFolderQueryForSearchPath(x,u,R)):_.map(x=>this.getFolderQueryForRoot(x,u,R,O))).filter(x=>!!x),ie={_reason:u._reason,folderQueries:j,usingSearchPaths:!!(p.searchPaths&&p.searchPaths.length),extraFileResources:u.extraFileResources,excludePattern:R.pattern,includePattern:p.pattern,onlyOpenEditors:u.onlyOpenEditors,maxResults:u.maxResults};if(u.onlyOpenEditors){const $=b.coalesce(b.flatten(this.editorGroupsService.groups.map(L=>L.editors.map(N=>N.resource)))).filter(L=>(0,g.pathIncludedInQuery)(ie,L.fsPath)),U=this.commonQueryFromFileList($);return Object.assign(Object.assign({},ie),U)}const K=u.extraFileResources&&u.extraFileResources.filter(x=>(0,g.pathIncludedInQuery)(ie,x.fsPath));return ie.extraFileResources=K&&K.length?K:void 0,ie}commonQueryFromFileList(_){const u=[],p=new y.ResourceMap,R={};let O=!1;return _.forEach(j=>{var ie,K;if(j.scheme!==P.Schemas.walkThrough)if((0,k.isAbsolutePath)(j)){const $=(K=(ie=this.workspaceContextService.getWorkspaceFolder(j))===null||ie===void 0?void 0:ie.uri)!==null&&K!==void 0?K:j.with({path:D.dirname(j.fsPath)});let U=p.get($);U||(O=!0,U={folder:$,includePattern:{}},u.push(U),p.set($,U));const L=D.relative($.fsPath,j.fsPath);(0,C.assertIsDefined)(U.includePattern)[L.replace(/\\/g,"/")]=!0}else j.fsPath&&(O=!0,R[j.fsPath]=!0)}),{folderQueries:u,includePattern:R,usingSearchPaths:!0,excludePattern:O?void 0:{"**/*":!0}}}isCaseSensitive(_,u){if(u.isSmartCase){if(_.isRegExp){if(i.containsUppercaseCharacter(_.pattern,!0))return!0}else if(i.containsUppercaseCharacter(_.pattern))return!0}return!!_.isCaseSensitive}isMultiline(_){return _.isMultiline||_.isRegExp&&(0,m.isMultilineRegexSource)(_.pattern)||_.pattern.indexOf(`
`)>=0?!0:!!_.isMultiline}parseSearchPaths(_){const u=U=>D.isAbsolute(U)||/^\.\.?([\/\\]|$)/.test(U),R=(Array.isArray(_)?_:n(_)).map(U=>{const L=this.pathService.resolvedUserHome;return L?(0,A.untildify)(U,L.scheme===P.Schemas.file?L.fsPath:L.path):U}),O=I.groupBy(R,U=>u(U)?"searchPaths":"exprSegments"),j=(O.exprSegments||[]).map(U=>i.rtrim(U,"/")).map(U=>i.rtrim(U,"\\")).map(U=>(U[0]==="."&&(U="*"+U),o(U))),ie={},K=this.expandSearchPathPatterns(O.searchPaths||[]);K&&K.length&&(ie.searchPaths=K);const x=b.flatten(j),$=t(...x);return $&&(ie.pattern=$),ie}getExcludesForFolder(_,u){return u.disregardExcludeSettings?void 0:(0,g.getExcludes)(_,!u.disregardSearchExcludeSettings)}expandSearchPathPatterns(_){if(!_||!_.length)return[];const u=b.flatten(_.map(R=>{let{pathPortion:O,globPortion:j}=v(R);j&&(j=s(j));const ie=this.expandOneSearchPath(O);return b.flatten(ie.map(K=>this.resolveOneSearchPathPattern(K,j)))})),p=new Map;return u.forEach(R=>{const O=R.searchPath.toString(),j=p.get(O);j?R.pattern&&(j.pattern=j.pattern||{},j.pattern[R.pattern]=!0):p.set(O,{searchPath:R.searchPath,pattern:R.pattern?t(R.pattern):void 0})}),Array.from(p.values())}expandOneSearchPath(_){if(D.isAbsolute(_)){const u=this.workspaceContextService.getWorkspace().folders;return u[0]&&u[0].uri.scheme!==P.Schemas.file?[{searchPath:u[0].uri.with({path:_})}]:[{searchPath:f.URI.file(D.normalize(_))}]}if(this.workspaceContextService.getWorkbenchState()===2){const u=this.workspaceContextService.getWorkspace().folders[0].uri;if(_=r(_),_.startsWith("../")||_===".."){const R=D.posix.resolve(u.path,_);return[{searchPath:u.with({path:R})}]}const p=s(_);return[{searchPath:u,pattern:p}]}else{if(_==="./"||_===".\\")return[];{const u=_.replace(/^\.[\/\\]/,""),R=this.workspaceContextService.getWorkspace().folders.map(O=>{const j=u.match(new RegExp(`^${O.name}(?:/(.*))?`));return j?{match:j,folder:O}:null}).filter(C.isDefined);if(R.length)return R.map(O=>{const j=O.match[1];return{searchPath:O.folder.uri,pattern:j&&s(j)}});{const O=_.match(/\.[\/\\](.+)[\/\\]?/),j=O?O[1]:_,ie=l.localize(0,null,j);throw new Error(ie)}}}}resolveOneSearchPathPattern(_,u){const p=_.pattern&&u?`${_.pattern}/${u}`:_.pattern||u,R=[{searchPath:_.searchPath,pattern:p}];return p&&!p.endsWith("**")&&R.push({searchPath:_.searchPath,pattern:p+"/**"}),R}getFolderQueryForSearchPath(_,u,p){const R=this.getFolderQueryForRoot((0,E.toWorkspaceFolder)(_.searchPath),u,p,!1);return R?Object.assign(Object.assign({},R),{includePattern:_.pattern}):null}getFolderQueryForRoot(_,u,p,R){let O;const j=f.URI.isUri(_)?_:_.uri;if(p.searchPaths){const U=p.searchPaths.filter(L=>(0,k.isEqual)(L.searchPath,j))[0];if(U&&!U.pattern)return null;U&&(O=U.pattern)}const ie=this.configurationService.getValue({resource:j}),K=this.getExcludesForFolder(ie,u),x=Object.assign(Object.assign({},K||{}),O||{}),$=f.URI.isUri(_)?(0,k.basename)(_):_.name;return{folder:j,folderName:R?$:void 0,excludePattern:Object.keys(x).length>0?x:void 0,fileEncoding:ie.files&&ie.files.encoding,disregardIgnoreFiles:typeof u.disregardIgnoreFiles=="boolean"?u.disregardIgnoreFiles:!ie.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof u.disregardGlobalIgnoreFiles=="boolean"?u.disregardGlobalIgnoreFiles:!ie.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof u.ignoreSymlinks=="boolean"?u.ignoreSymlinks:!ie.search.followSymlinks}}};a=qe([He(0,d.IConfigurationService),He(1,E.IWorkspaceContextService),He(2,w.IEditorGroupsService),He(3,S.IPathService)],a),e.QueryBuilder=a;function v(h){const _=h.match(/[\*\{\}\(\)\[\]\?]/);if(_){const u=_.index,p=h.substr(0,u).match(/[/|\\][^/\\]*$/);if(p){let R=h.substr(0,p.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:h.substr((p.index||0)+1)}}}return{pathPortion:h}}function t(...h){return h.length?h.reduce((_,u)=>(_[u]=!0,_),Object.create(null)):void 0}function n(h){return T.splitGlobAware(h,",").map(_=>_.trim()).filter(_=>!!_.length)}function o(h){return[`**/${h}/**`,`**/${h}`].map(u=>u.replace(/\*\*\/\*\*/g,"**"))}function r(h){return h.replace(/\\/g,"/")}function s(h){return r(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function c(h,_){h=b.distinct(h,R=>R.toString());const u=[],p=_.getWorkspace();return h&&h.forEach(R=>{let O;if(_.getWorkbenchState()===2)O=(0,k.relativePath)(p.folders[0].uri,R),O&&O!=="."&&(O="./"+O);else{const j=_.getWorkspaceFolder(R);if(j){const ie=j.name;if(p.folders.filter(x=>x.name===ie).length===1){const x=(0,k.relativePath)(j.uri,R);x===""?O=`./${j.name}`:O=`./${j.name}/${x}`}else O=R.fsPath}}O&&u.push(O)}),u}e.resolveResourcesForSearchIncludes=c}),define(me[261],ge([0,1,25,2,21,16,4,260,31,61]),function(G,e,b,I,T,A,y,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const i=7e3;function C(d,E){const w=E.activationEvents;if(!w)return Promise.resolve(void 0);const S=[],g=[];for(const r of w)if(/^workspaceContains:/.test(r)){const s=r.substr("workspaceContains:".length);s.indexOf("*")>=0||s.indexOf("?")>=0||d.forceUsingSearch?g.push(s):S.push(s)}if(S.length===0&&g.length===0)return Promise.resolve(void 0);let a;const v=new Promise((r,s)=>{a=r}),t=r=>a({activationEvent:r}),n=Promise.all(S.map(r=>f(d,r,t))).then(()=>{}),o=m(d,E.identifier,g,t);return Promise.all([n,o]).then(()=>{a(void 0)}),v}e.checkActivateWorkspaceContainsExtension=C;async function f(d,E,w){for(const S of d.folders)if(await d.exists(b.joinPath(I.URI.revive(S),E))){w(`workspaceContains:${E}`);return}}async function m(d,E,w,S){if(w.length===0)return Promise.resolve(void 0);const g=new T.CancellationTokenSource,a=d.checkExists(d.folders,w,g.token),v=setTimeout(async()=>{g.cancel(),S(`workspaceContainsTimeout:${w.join(",")}`)},i);let t=!1;try{t=await a}catch(n){A.isPromiseCanceledError(n)||A.onUnexpectedError(n)}g.dispose(),clearTimeout(v),t&&S(`workspaceContains:${w.join(",")}`)}function l(d,E,w,S){const g=d.get(y.IInstantiationService),a=d.get(D.ISearchService),t=g.createInstance(P.QueryBuilder).file(E.map(n=>(0,k.toWorkspaceFolder)(I.URI.revive(n))),{_reason:"checkExists",includePattern:w,exists:!0});return a.fileSearch(t,S).then(n=>!!n.limitHit,n=>A.isPromiseCanceledError(n)?!1:Promise.reject(n))}e.checkGlobFileExists=l});var it=this&&this.__classPrivateFieldSet||function(G,e,b,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,b):T?T.value=b:e.set(G,b),b},We=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)};define(me[42],ge([0,1,162,8,69,25,13,6,22,2,14,5,35,224,92,32,41,222,16,27,23,197,7,85,4,28,93,15,82,50,34,3,261,90,198]),function(G,e,b,I,T,A,y,P,D,k,i,C,f,m,l,d,E,w,S,g,a,v,t,n,o,r,s,c,h,_,u,p,R,O,j){"use strict";var ie,K,x;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,o.createDecorator)("IHostUtils");let $=class Bn extends P.Disposable{constructor(M,F,W,q,Q,le,ve,Re,Se,Oe){super();this._onDidChangeRemoteConnectionData=this._register(new p.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=F,this._extHostContext=W,this._initData=ve,this._extHostWorkspace=q,this._extHostConfiguration=Q,this._logService=le,this._extHostTunnelService=Se,this._extHostTerminalService=Oe,this._disposables=new P.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(C.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(C.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(C.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new y.Barrier,this._readyToStartExtensionHost=new y.Barrier,this._readyToRunExtensions=new y.Barrier,this._eagerExtensionsActivated=new y.Barrier,this._registry=new w.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new l.ExtHostStorage(this._extHostContext),this._secretState=new O.ExtHostSecretState(this._extHostContext),this._storagePath=Re,this._instaService=M.createChild(new h.ServiceCollection([l.IExtHostStorage,this._storage],[O.IExtHostSecretState,this._secretState]));const z=new Set;this._initData.hostExtensions.forEach(Y=>z.add(g.ExtensionIdentifier.toKey(Y))),this._activator=new m.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Y,ee,se)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Y,S.transformErrorForSerialization(ee),se)},actualActivateExtension:async(Y,ee)=>{if(z.has(g.ExtensionIdentifier.toKey(Y)))return await this._mainThreadExtensionsProxy.$activateExtension(Y,ee),new m.HostExtension;const se=this._registry.getExtensionDescription(Y);return this._activateExtension(se,ee)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),T.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(M){S.onUnexpectedError(M)}}async deactivateAll(){let M=[];try{M=this._registry.getAllExtensionDescriptions().map(Q=>Q.identifier).filter(Q=>this.isActivated(Q)).map(Q=>this._deactivate(Q))}catch(F){}await Promise.all(M)}isActivated(M){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(M):!1}_activateByEvent(M,F){return this._activator.activateByEvent(M,F)}_activateById(M,F){return this._activator.activateById(M,F)}activateByIdWithErrors(M,F){return this._activateById(M,F).then(()=>{const W=this._activator.getActivatedExtension(M);if(W.activationFailed)return Promise.reject(W.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(M=>this._registry)}getExtensionExports(M){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(M).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const M=D.TernarySearchTree.forPaths(),F=this._registry.getAllExtensionDescriptions().map(W=>{if(!!this._getEntryPoint(W))return this._hostUtils.realpath(W.extensionLocation.fsPath).then(q=>M.set(k.URI.file(q).fsPath,W))});this._extensionPathIndex=Promise.all(F).then(()=>M)}return this._extensionPathIndex}_deactivate(M){let F=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(M))return F;const W=this._activator.getActivatedExtension(M);if(!W)return F;try{typeof W.module.deactivate=="function"&&(F=Promise.resolve(W.module.deactivate()).then(void 0,q=>Promise.resolve(void 0)))}catch(q){}try{(0,P.dispose)(W.subscriptions)}catch(q){}return F}async _activateExtension(M,F){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier),this._doActivateExtension(M,F).then(W=>{const q=W.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(M.identifier,q.codeLoadingTime,q.activateCallTime,q.activateResolvedTime,F),this._logExtensionActivationTimes(M,F,"success",q),W},W=>{throw this._logExtensionActivationTimes(M,F,"failure"),W})}_logExtensionActivationTimes(M,F,W,q){const Q=U(M,F);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},Q),q||{}),{outcome:W}))}_doActivateExtension(M,F){const W=U(M,F);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",W);const q=this._getEntryPoint(M);if(!q)return Promise.resolve(new m.EmptyExtension(m.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${M.identifier.value} ${JSON.stringify(F)}`),this._logService.flush();const Q=new m.ExtensionActivationTimesBuilder(F.startup);return Promise.all([this._loadCommonJSModule(M.identifier,(0,A.joinPath)(M.extensionLocation,q),Q),this._loadExtensionContext(M)]).then(le=>(T.mark(`code/extHost/willActivateExtension/${M.identifier.value}`),Bn._callActivate(this._logService,M.identifier,le[0],le[1],Q))).then(le=>(T.mark(`code/extHost/didActivateExtension/${M.identifier.value}`),le))}_loadExtensionContext(M){const F=new v.ExtensionGlobalMemento(M,this._storage),W=new v.ExtensionMemento(M.identifier.value,!1,this._storage),q=new j.ExtensionSecrets(M,this._secretState),Q=M.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,le=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${M.identifier.value}`),Promise.all([F.whenReady,W.whenReady,this._storagePath.whenReady]).then(()=>{const ve=this;let Re;return Object.freeze({globalState:F,workspaceState:W,secrets:q,subscriptions:[],get extensionUri(){return M.extensionLocation},get extensionPath(){return M.extensionLocation.fsPath},asAbsolutePath(Se){return I.join(M.extensionLocation.fsPath,Se)},get storagePath(){var Se;return(Se=ve._storagePath.workspaceValue(M))===null||Se===void 0?void 0:Se.fsPath},get globalStoragePath(){return ve._storagePath.globalValue(M).fsPath},get logPath(){return I.join(ve._initData.logsLocation.fsPath,M.identifier.value)},get logUri(){return k.URI.joinPath(ve._initData.logsLocation,M.identifier.value)},get storageUri(){return ve._storagePath.workspaceValue(M)},get globalStorageUri(){return ve._storagePath.globalValue(M)},get extensionMode(){return Q},get extension(){return Re===void 0&&(Re=new L(ve,M.identifier,M,le)),Re},get extensionRuntime(){return(0,E.checkProposedApiEnabled)(M),ve.extensionRuntime},get environmentVariableCollection(){return ve._extHostTerminalService.getEnvironmentVariableCollection(M)}})})}static _callActivate(M,F,W,q,Q){return W=W||{activate:void 0,deactivate:void 0},this._callActivateOptional(M,F,W,q,Q).then(le=>new m.ActivatedExtension(!1,null,Q.build(),W,le,q.subscriptions))}static _callActivateOptional(M,F,W,q,Q){if(typeof W.activate=="function")try{Q.activateCallStart(),M.trace(`ExtensionService#_callActivateOptional ${F.value}`);const le=typeof global=="object"?global:self,ve=W.activate.apply(le,[q]);return Q.activateCallStop(),Q.activateResolveStart(),Promise.resolve(ve).then(Re=>(Q.activateResolveStop(),Re))}catch(le){return Promise.reject(le)}else return Promise.resolve(W)}_activateOneStartupFinished(M,F){this._activateById(M.identifier,{startup:!1,extensionId:M.identifier,activationEvent:F}).then(void 0,W=>{this._logService.error(W)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(T.getMarks());for(const M of this._registry.getAllExtensionDescriptions())if(M.activationEvents)for(const F of M.activationEvents)F==="onStartupFinished"&&this._activateOneStartupFinished(M,F)}_handleEagerExtensions(){const M=this._activateByEvent("*",!0).then(void 0,Q=>{this._logService.error(Q)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(Q=>this._handleWorkspaceContainsEagerExtensions(Q.added)));const F=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],W=this._handleWorkspaceContainsEagerExtensions(F),q=Promise.all([M,W]).then(()=>{});return Promise.race([q,(0,y.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),q}_handleWorkspaceContainsEagerExtensions(M){return M.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(F=>this._handleWorkspaceContainsEagerExtension(M,F))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(M,F){if(!this.isActivated(F.identifier)){const W=!this._initData.remote.isRemote&&!!this._initData.remote.authority,q={folders:M.map(le=>le.uri),forceUsingSearch:W,exists:le=>this._hostUtils.exists(le.fsPath),checkExists:(le,ve,Re)=>this._mainThreadWorkspaceProxy.$checkExists(le,ve,Re)},Q=await(0,R.checkActivateWorkspaceContainsExtension)(q,F);if(!!Q)return this._activateById(F.identifier,{startup:!0,extensionId:F.identifier,activationEvent:Q.activationEvent}).then(void 0,le=>this._logService.error(le))}}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(M){throw console.error(M),M}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:M,extensionTestsLocationURI:F}=this._initData.environment;if(!M||!F)throw new Error(b.localize(0,null));const W=await this._loadCommonJSModule(null,F,new m.ExtensionActivationTimesBuilder(!1));if(!W||typeof W.run!="function")throw new Error(b.localize(1,null,F.toString()));return new Promise((q,Q)=>{const le=(Se,Oe)=>{Se?Q(Se):q(typeof Oe=="number"&&Oe>0?1:0)},ve=(0,A.originalFSPath)(F),Re=W.run(ve,le);Re&&Re.then&&Re.then(()=>{q(0)}).catch(Se=>{Q(Se.toString())})})}async $extensionTestsExit(M){this._logService.info(`extension host terminating: test runner requested exit with code ${M}`),this._logService.info(`exiting with code ${M}`),this._logService.flush(),this._hostUtils.exit(M)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(M,F){return this._resolvers[M]=F,(0,P.toDisposable)(()=>{delete this._resolvers[M]})}async $resolveAuthority(M,F){const W=M.indexOf("+");if(W===-1)throw new Error("Not an authority that can be resolved!");const q=M.substr(0,W);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${q}`,!1);const Q=this._resolvers[q];if(!Q)return{type:"error",error:{code:n.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${q}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(Q)),T.mark(`code/extHost/willResolveAuthority/${q}`);const le=await Q.resolve(M,{resolveAttempt:F});T.mark(`code/extHost/didResolveAuthorityOK/${q}`);const ve={authority:M,host:le.host,port:le.port,connectionToken:le.connectionToken},Re={extensionHostEnv:le.extensionHostEnv,trust:le.trust};return{type:"ok",value:{authority:ve,options:Re,tunnelInformation:{environmentTunnels:le.environmentTunnels}}}}catch(le){if(T.mark(`code/extHost/didResolveAuthorityError/${q}`),le instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:le._code,message:le._message,detail:le._detail}};throw le}}$startExtensionHost(M){return this._registry.keepOnly(M),this._startExtensionHost()}$activateByEvent(M,F){return F===1?this._activateByEvent(M,!1):this._readyToRunExtensions.wait().then(W=>this._activateByEvent(M,!1))}async $activate(M,F){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(M)?(await this._activateById(M,F),!0):!1}async $deltaExtensions(M,F){M.forEach(q=>q.extensionLocation=k.URI.revive(q.extensionLocation));const W=await this.getExtensionPathIndex();return await Promise.all(F.map(async q=>{const Q=this._registry.getExtensionDescription(q);if(!!Q){const le=await this._hostUtils.realpath(Q.extensionLocation.fsPath);W.delete(k.URI.file(le).fsPath)}})),await Promise.all(M.map(async q=>{const Q=await this._hostUtils.realpath(q.extensionLocation.fsPath);W.set(k.URI.file(Q).fsPath,q)})),this._registry.deltaExtensions(M,F),Promise.resolve(void 0)}async $test_latency(M){return M}async $test_up(M){return M.byteLength}async $test_down(M){let F=a.VSBuffer.alloc(M),W=Math.random()%256;for(let q=0;q<M;q++)F.writeUInt8(W,q);return F}async $updateRemoteConnectionData(M){this._remoteConnectionData=M,this._onDidChangeRemoteConnectionData.fire()}};$=qe([He(0,o.IInstantiationService),He(1,e.IHostUtils),He(2,c.IExtHostRpcService),He(3,d.IExtHostWorkspace),He(4,f.IExtHostConfiguration),He(5,i.ILogService),He(6,r.IExtHostInitDataService),He(7,s.IExtensionStoragePaths),He(8,_.IExtHostTunnelService),He(9,u.IExtHostTerminalService)],$),e.AbstractExtHostExtensionService=$;function U(N,M){return{id:N.identifier.value,name:N.name,extensionVersion:N.version,publisherDisplayName:N.publisher,activationEvents:N.activationEvents?N.activationEvents.join(","):null,isBuiltin:N.isBuiltin,reason:M.activationEvent,reasonId:M.extensionId.value}}e.IExtHostExtensionService=(0,o.createDecorator)("IExtHostExtensionService");class L{constructor(M,F,W,q){ie.set(this,void 0),K.set(this,void 0),x.set(this,void 0),it(this,ie,M,"f"),it(this,K,F,"f"),it(this,x,W.identifier,"f"),this.id=W.identifier.value,this.extensionUri=W.extensionLocation,this.extensionPath=I.normalize((0,A.originalFSPath)(W.extensionLocation)),this.packageJSON=W,this.extensionKind=q}get isActive(){return We(this,ie,"f").isActivated(We(this,x,"f"))}get exports(){if(this.packageJSON.api!=="none")return We(this,ie,"f").getExtensionExports(We(this,x,"f"))}activate(){return We(this,ie,"f").activateByIdWithErrors(We(this,x,"f"),{startup:!1,extensionId:We(this,K,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=L,ie=new WeakMap,K=new WeakMap,x=new WeakMap}),define(me[46],ge([0,1,8,2,3,13,5,7,122,32,42,39,212,35,205,15,4,11,36]),function(G,e,b,I,T,A,y,P,D,k,i,C,f,m,l,d,E,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,E.createDecorator)("IExtHostDebugService");let g=class{constructor(c,h,_,u,p){this._workspaceService=h,this._extensionService=_,this._editorsService=u,this._configurationService=p,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new T.Emitter,this._onDidTerminateDebugSession=new T.Emitter,this._onDidChangeActiveDebugSession=new T.Emitter,this._onDidReceiveDebugSessionCustomEvent=new T.Emitter,this._debugServiceProxy=c.getProxy(y.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new T.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new v(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(R=>{R.onDidChange(O=>{this.registerAllDebugTypes(R)}),this.registerAllDebugTypes(R)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(c,h){const _=c;if(typeof _.sourceReference=="number"&&_.sourceReference>0){let u=`debug:${encodeURIComponent(_.path||"")}`,p="?";return h&&(u+=`${p}session=${encodeURIComponent(h.id)}`,p="&"),u+=`${p}ref=${_.sourceReference}`,I.URI.parse(u)}else{if(_.path)return I.URI.file(_.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(c){const h=[];for(const _ of c.getAllExtensionDescriptions())if(_.contributes){const u=_.contributes.debuggers;if(u&&u.length>0)for(const p of u)(0,l.isDebuggerMainContribution)(p)&&h.push(p.type)}this._debugServiceProxy.$registerDebugTypes(h)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const c=[];return this._breakpoints.forEach(h=>c.push(h)),c}addBreakpoints(c){this.startBreakpoints();const h=c.filter(p=>{const R=p.id;return this._breakpoints.has(R)?!1:(this._breakpoints.set(R,p),!0)});this.fireBreakpointChanges(h,[],[]);const _=[],u=new Map;for(const p of h)if(p instanceof P.SourceBreakpoint){let R=u.get(p.location.uri.toString());R||(R={type:"sourceMulti",uri:p.location.uri,lines:[]},u.set(p.location.uri.toString(),R),_.push(R)),R.lines.push({id:p.id,enabled:p.enabled,condition:p.condition,hitCondition:p.hitCondition,logMessage:p.logMessage,line:p.location.range.start.line,character:p.location.range.start.character})}else p instanceof P.FunctionBreakpoint&&_.push({type:"function",id:p.id,enabled:p.enabled,hitCondition:p.hitCondition,logMessage:p.logMessage,condition:p.condition,functionName:p.functionName});return this._debugServiceProxy.$registerBreakpoints(_)}removeBreakpoints(c){this.startBreakpoints();const h=c.filter(R=>this._breakpoints.delete(R.id));this.fireBreakpointChanges([],h,[]);const _=h.filter(R=>R instanceof P.SourceBreakpoint).map(R=>R.id),u=h.filter(R=>R instanceof P.FunctionBreakpoint).map(R=>R.id),p=h.filter(R=>R instanceof P.DataBreakpoint).map(R=>R.id);return this._debugServiceProxy.$unregisterBreakpoints(_,u,p)}startDebugging(c,h,_){return this._debugServiceProxy.$startDebugging(c?c.uri:void 0,h,{parentSessionID:_.parentSession?_.parentSession.id:void 0,repl:_.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:_.noDebug,compact:_.compact})}stopDebugging(c){return this._debugServiceProxy.$stopDebugging(c?c.id:void 0)}registerDebugConfigurationProvider(c,h,_){if(!h)return new P.Disposable(()=>{});const u=this._configProviderHandleCounter++;return this._configProviders.push({type:c,handle:u,provider:h}),this._debugServiceProxy.$registerDebugConfigurationProvider(c,_,!!h.provideDebugConfigurations,!!h.resolveDebugConfiguration,!!h.resolveDebugConfigurationWithSubstitutedVariables,u),new P.Disposable(()=>{this._configProviders=this._configProviders.filter(p=>p.provider!==h),this._debugServiceProxy.$unregisterDebugConfigurationProvider(u)})}registerDebugAdapterDescriptorFactory(c,h,_){if(!_)return new P.Disposable(()=>{});if(!this.definesDebugType(c,h))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${h}' debugger.`);if(this.getAdapterDescriptorFactoryByType(h))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const u=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:h,handle:u,factory:_}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(h,u),new P.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(p=>p.factory!==_),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(u)})}registerDebugAdapterTrackerFactory(c,h){if(!h)return new P.Disposable(()=>{});const _=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:c,handle:_,factory:h}),new P.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(u=>u.factory!==h)})}async $runInTerminal(c,h){return Promise.resolve(void 0)}async $substituteVariables(c,h){if(!this._variableResolver){const[p,R]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(p||[],this._editorsService,R)}let _;const u=await this.getFolder(c);return u&&(_={uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(_,h)}createDebugAdapter(c,h){if(c.type==="implementation")return new o(c.implementation)}createSignService(){}async $startDASession(c,h){const _=this,u=await this.getSession(h);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(u.type),u).then(p=>{if(!p)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}' (extension might have failed to activate)`);const R=this.convertToDto(p),O=this.createDebugAdapter(R,u);if(!O)throw new Error(`Couldn't create a debug adapter for type '${u.type}'.`);const j=O;return this._debugAdapters.set(c,j),this.getDebugAdapterTrackers(u).then(ie=>(ie&&this._debugAdaptersTrackers.set(c,ie),j.onMessage(async K=>{if(K.type==="request"&&K.command==="handshake"){const x=K,$={type:"response",seq:0,command:x.command,request_seq:x.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const U=await this._signService.sign(x.arguments.value);$.body={signature:U},j.sendResponse($)}else throw new Error("no signer")}catch(U){$.success=!1,$.message=U.message,j.sendResponse($)}}else ie&&ie.onDidSendMessage&&ie.onDidSendMessage(K),K=(0,l.convertToVSCPaths)(K,!0),_._debugServiceProxy.$acceptDAMessage(c,K)}),j.onError(K=>{ie&&ie.onError&&ie.onError(K),this._debugServiceProxy.$acceptDAError(c,K.name,K.message,K.stack)}),j.onExit(K=>{ie&&ie.onExit&&ie.onExit((0,w.withNullAsUndefined)(K),void 0),this._debugServiceProxy.$acceptDAExit(c,(0,w.withNullAsUndefined)(K),void 0)}),ie&&ie.onWillStartSession&&ie.onWillStartSession(),j.startSession()))})}$sendDAMessage(c,h){h=(0,l.convertToDAPaths)(h,!1);const _=this._debugAdaptersTrackers.get(c);_&&_.onWillReceiveMessage&&_.onWillReceiveMessage(h);const u=this._debugAdapters.get(c);u&&u.sendMessage(h)}$stopDASession(c){const h=this._debugAdaptersTrackers.get(c);this._debugAdaptersTrackers.delete(c),h&&h.onWillStopSession&&h.onWillStopSession();const _=this._debugAdapters.get(c);return this._debugAdapters.delete(c),_?_.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(c){const h=[],_=[],u=[];if(c.added)for(const p of c.added){const R=p.id;if(R&&!this._breakpoints.has(R)){let O;if(p.type==="function")O=new P.FunctionBreakpoint(p.functionName,p.enabled,p.condition,p.hitCondition,p.logMessage);else if(p.type==="data")O=new P.DataBreakpoint(p.label,p.dataId,p.canPersist,p.enabled,p.hitCondition,p.condition,p.logMessage);else{const j=I.URI.revive(p.uri);O=new P.SourceBreakpoint(new P.Location(j,new P.Position(p.line,p.character)),p.enabled,p.condition,p.hitCondition,p.logMessage)}O._id=R,this._breakpoints.set(R,O),h.push(O)}}if(c.removed)for(const p of c.removed){const R=this._breakpoints.get(p);R&&(this._breakpoints.delete(p),_.push(R))}if(c.changed){for(const p of c.changed)if(p.id){const R=this._breakpoints.get(p.id);if(R){if(R instanceof P.FunctionBreakpoint&&p.type==="function"){const O=R;O.enabled=p.enabled,O.condition=p.condition,O.hitCondition=p.hitCondition,O.logMessage=p.logMessage,O.functionName=p.functionName}else if(R instanceof P.SourceBreakpoint&&p.type==="source"){const O=R;O.enabled=p.enabled,O.condition=p.condition,O.hitCondition=p.hitCondition,O.logMessage=p.logMessage,O.location=new P.Location(I.URI.revive(p.uri),new P.Position(p.line,p.character))}u.push(R)}}}this.fireBreakpointChanges(h,_,u)}$provideDebugConfigurations(c,h,_){return(0,A.asPromise)(async()=>{const u=this.getConfigProviderByHandle(c);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const p=await this.getFolder(h);return u.provideDebugConfigurations(p,_)}).then(u=>{if(!u)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return u})}$resolveDebugConfiguration(c,h,_,u){return(0,A.asPromise)(async()=>{const p=this.getConfigProviderByHandle(c);if(!p)throw new Error("no DebugConfigurationProvider found");if(!p.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const R=await this.getFolder(h);return p.resolveDebugConfiguration(R,_,u)})}$resolveDebugConfigurationWithSubstitutedVariables(c,h,_,u){return(0,A.asPromise)(async()=>{const p=this.getConfigProviderByHandle(c);if(!p)throw new Error("no DebugConfigurationProvider found");if(!p.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const R=await this.getFolder(h);return p.resolveDebugConfigurationWithSubstitutedVariables(R,_,u)})}async $provideDebugAdapter(c,h){const _=this.getAdapterDescriptorFactoryByHandle(c);if(!_)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const u=await this.getSession(h);return this.getAdapterDescriptor(_,u).then(p=>{if(!p)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}'`);return this.convertToDto(p)})}async $acceptDebugSessionStarted(c){const h=await this.getSession(c);this._onDidStartDebugSession.fire(h)}async $acceptDebugSessionTerminated(c){const h=await this.getSession(c);h&&(this._onDidTerminateDebugSession.fire(h),this._debugSessions.delete(h.id))}async $acceptDebugSessionActiveChanged(c){this._activeDebugSession=c?await this.getSession(c):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(c,h){const _=await this.getSession(c);_&&_._acceptNameChanged(h)}async $acceptDebugSessionCustomEvent(c,h){const u={session:await this.getSession(c),event:h.event,body:h.body};this._onDidReceiveDebugSessionCustomEvent.fire(u)}convertToDto(c){if(c instanceof P.DebugAdapterExecutable)return{type:"executable",command:c.command,args:c.args,options:c.options};if(c instanceof P.DebugAdapterServer)return{type:"server",port:c.port,host:c.host};if(c instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:c.path};if(c instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:c.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(c){const h=this._adapterFactories.filter(_=>_.type===c);if(h.length>0)return h[0].factory}getAdapterDescriptorFactoryByHandle(c){const h=this._adapterFactories.filter(_=>_.handle===c);if(h.length>0)return h[0].factory}getConfigProviderByHandle(c){const h=this._configProviders.filter(_=>_.handle===c);if(h.length>0)return h[0].provider}definesDebugType(c,h){if(c.contributes){const _=c.contributes.debuggers;if(_&&_.length>0){for(const u of _)if(u.label&&u.type&&u.type===h)return!0}}return!1}getDebugAdapterTrackers(c){const _=c.configuration.type,u=this._trackerFactories.filter(p=>p.type===_||p.type==="*").map(p=>(0,A.asPromise)(()=>p.factory.createDebugAdapterTracker(c)).then(R=>R,R=>null));return Promise.race([Promise.all(u).then(p=>{const R=p.filter(O=>!!O);if(R.length>0)return new n(R)}),new Promise((p,R)=>{const O=setTimeout(()=>{clearTimeout(O),R(new Error("timeout"))},1e3)})]).catch(p=>{})}async getAdapterDescriptor(c,h){const _=h.configuration.debugServer;if(typeof _=="number")return Promise.resolve(new P.DebugAdapterServer(_));if(c){const p=await this._extensionService.getExtensionRegistry();return(0,A.asPromise)(()=>c.createDebugAdapterDescriptor(h,this.daExecutableFromPackage(h,p))).then(R=>{if(R)return R})}const u=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(h,u))}daExecutableFromPackage(c,h){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(c,h,_){(c.length>0||h.length>0||_.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:c,removed:h,changed:_}))}async getSession(c){if(c)if(typeof c=="string"){const h=this._debugSessions.get(c);if(h)return h}else{let h=this._debugSessions.get(c.id);if(!h){const _=await this.getFolder(c.folderUri);h=new a(this._debugServiceProxy,c.id,c.type,c.name,_,c.configuration),this._debugSessions.set(h.id,h),this._debugServiceProxy.$sessionCached(h.id)}return h}throw new Error("cannot find session")}getFolder(c){if(c){const h=I.URI.revive(c);return this._workspaceService.resolveWorkspaceFolder(h)}return Promise.resolve(void 0)}};g=qe([He(0,d.IExtHostRpcService),He(1,k.IExtHostWorkspace),He(2,i.IExtHostExtensionService),He(3,C.IExtHostDocumentsAndEditors),He(4,m.IExtHostConfiguration)],g),e.ExtHostDebugServiceBase=g;class a{constructor(c,h,_,u,p,R){this._debugServiceProxy=c,this._id=h,this._type=_,this._name=u,this._workspaceFolder=p,this._configuration=R}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(c){this._name=c,this._debugServiceProxy.$setDebugSessionName(this._id,c)}_acceptNameChanged(c){this._name=c}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(c,h){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,c,h)}getDebugProtocolBreakpoint(c){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,c.id)}}e.ExtHostDebugSession=a;class v{constructor(c){this.value=Object.freeze({append(h){c.$appendDebugConsole(h)},appendLine(h){this.append(h+`
`)}})}}e.ExtHostDebugConsole=v;class t extends f.AbstractVariableResolverService{constructor(c,h,_,u){super({getFolderUri:p=>{const R=c.filter(O=>O.name===p);if(R&&R.length>0)return R[0].uri},getWorkspaceFolderCount:()=>c.length,getConfigurationValue:(p,R)=>_.getConfiguration(void 0,p).get(R),getAppRoot:()=>S.cwd(),getExecPath:()=>S.env.VSCODE_EXEC_PATH,getFilePath:()=>{if(h){const p=h.activeEditor();if(p)return b.normalize(p.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(h&&u){const p=h.activeEditor();if(p){const R=u.getWorkspaceFolder(p.document.uri);if(R)return b.normalize(R.uri.fsPath)}}},getSelectedText:()=>{if(h){const p=h.activeEditor();if(p&&!p.selection.isEmpty)return p.document.getText(p.selection)}},getLineNumber:()=>{if(h){const p=h.activeEditor();if(p)return String(p.selection.end.line+1)}}},void 0,Promise.resolve(S.env))}}e.ExtHostVariableResolverService=t;class n{constructor(c){this.trackers=c}onWillStartSession(){this.trackers.forEach(c=>c.onWillStartSession?c.onWillStartSession():void 0)}onWillReceiveMessage(c){this.trackers.forEach(h=>h.onWillReceiveMessage?h.onWillReceiveMessage(c):void 0)}onDidSendMessage(c){this.trackers.forEach(h=>h.onDidSendMessage?h.onDidSendMessage(c):void 0)}onWillStopSession(){this.trackers.forEach(c=>c.onWillStopSession?c.onWillStopSession():void 0)}onError(c){this.trackers.forEach(h=>h.onError?h.onError(c):void 0)}onExit(c,h){this.trackers.forEach(_=>_.onExit?_.onExit(c,h):void 0)}}class o extends D.AbstractDebugAdapter{constructor(c){super();this.implementation=c,c.onDidSendMessage(h=>{this.acceptMessage(h)})}startSession(){return Promise.resolve(void 0)}sendMessage(c){this.implementation.handleMessage(c)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let r=class extends g{constructor(c,h,_,u,p){super(c,h,_,u,p)}createVariableResolver(c,h,_){return new t(c,h,_)}};r=qe([He(0,d.IExtHostRpcService),He(1,k.IExtHostWorkspace),He(2,i.IExtHostExtensionService),He(3,C.IExtHostDocumentsAndEditors),He(4,m.IExtHostConfiguration)],r),e.WorkerExtHostDebugService=r}),define(me[262],ge([0,1,69,2,5,35,41,27,15,28,4,42,36,14]),function(G,e,b,I,T,A,y,P,D,k,i,C,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let l=class{constructor(g,a,v,t,n,o,r){this._apiFactory=g,this._extensionRegistry=a,this._instaService=v,this._extHostConfiguration=t,this._extHostExtensionService=n,this._initData=o,this._logService=r,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),b.mark("code/extHost/willWaitForConfig");const g=await this._extHostConfiguration.getConfigProvider();b.mark("code/extHost/didWaitForConfig");const a=await this._extHostExtensionService.getExtensionPathIndex();this.register(new d(this._apiFactory,a,this._extensionRegistry,g,this._logService)),this.register(this._instaService.createInstance(E)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(w,a,this._initData.environment.appUriScheme))}register(g){if(Array.isArray(g.nodeModuleName))for(let a of g.nodeModuleName)this._factories.set(a,g);else this._factories.set(g.nodeModuleName,g);typeof g.alternativeModuleName=="function"&&this._alternatives.push(a=>g.alternativeModuleName(a))}};l=qe([He(2,i.IInstantiationService),He(3,A.IExtHostConfiguration),He(4,C.IExtHostExtensionService),He(5,k.IExtHostInitDataService),He(6,m.ILogService)],l),e.RequireInterceptor=l;class d{constructor(g,a,v,t,n){this._apiFactory=g,this._extensionPaths=a,this._extensionRegistry=v,this._configProvider=t,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(g,a){const v=this._extensionPaths.findSubstr(a.fsPath);if(v){let t=this._extApiImpl.get(P.ExtensionIdentifier.toKey(v.identifier));return t||(t=this._apiFactory(v,this._extensionRegistry,this._configProvider),this._extApiImpl.set(P.ExtensionIdentifier.toKey(v.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((n,o)=>t+=`	${o} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${a.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(y.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let E=class{constructor(g,a){this.nodeModuleName="keytar";const{environment:v}=a,t=g.getProxy(T.MainContext.MainThreadKeytar);if(v.appRoot){let n=v.appRoot.fsPath;f.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,o)=>t.$getPassword(n,o),setPassword:(n,o,r)=>t.$setPassword(n,o,r),deletePassword:(n,o)=>t.$deletePassword(n,o),findPassword:n=>t.$findPassword(n),findCredentials(n){return t.$findCredentials(n)}}}load(g,a){return this._impl}alternativeModuleName(g){const a=g.length;if(!(a<=7||!this.alternativeNames)){const v=a-7;if((g.charAt(v)==="/"||g.charAt(v)==="\\")&&g.endsWith("keytar")&&(g=g.replace(/\\/g,"/"),this.alternativeNames.has(g)))return"keytar"}}};E=qe([He(0,D.IExtHostRpcService),He(1,k.IExtHostInitDataService)],E);let w=class{constructor(g,a,v){this._extensionPaths=g,this._appUriScheme=a,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=v.getProxy(T.MainContext.MainThreadTelemetry);const t=v.getProxy(T.MainContext.MainThreadWindow);this._impl=(n,o)=>{const r=I.URI.parse(n);return o?this.callOriginal(n,o):r.scheme==="http"||r.scheme==="https"?t.$openUri(r,n,{allowTunneling:!0}):r.scheme==="mailto"||r.scheme===this._appUriScheme?t.$openUri(r,n,{}):this.callOriginal(n,o)}}load(g,a,v){const t=this._extensionPaths.findSubstr(a.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=v(g),this._impl}callOriginal(g,a){return this.sendNoForwardTelemetry(),this._original(g,a)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};w=qe([He(2,D.IExtHostRpcService)],w)}),define(me[263],ge([0,1,168,10,7,206,32,42,39,35,34,15,46,190,13,207]),function(G,e,b,I,T,A,y,P,D,k,i,C,f,m,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let E=class extends f.ExtHostDebugServiceBase{constructor(g,a,v,t,n,o){super(g,a,v,t,n);this._terminalService=o,this._integratedTerminalInstances=new w}createDebugAdapter(g,a){switch(g.type){case"server":return new A.SocketDebugAdapter(g);case"pipeServer":return new A.NamedPipeDebugAdapter(g);case"executable":return new A.ExecutableDebugAdapter(g,a.type)}return super.createDebugAdapter(g,a)}daExecutableFromPackage(g,a){const v=A.ExecutableDebugAdapter.platformAdapterExecutable(a.getAllExtensionDescriptions(),g.type);if(v)return new T.DebugAdapterExecutable(v.command,v.args,v.options)}createSignService(){return new m.SignService}async $runInTerminal(g,a){if(g.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(p=>{this._integratedTerminalInstances.onTerminalClosed(p)}));const v=await this._configurationService.getConfigProvider(),t=this._terminalService.getDefaultShell(!0,v),n=this._terminalService.getDefaultShellArgs(!0,v),o=JSON.stringify({shell:t,shellArgs:n});let r=await this._integratedTerminalInstances.checkout(o),s,c=!1;if(r)s=g.cwd;else{const p={shellPath:t,shellArgs:n,cwd:g.cwd,name:g.title||b.localize(0,null)};c=!0,r=this._terminalService.createTerminalFromOptions(p,!0),this._integratedTerminalInstances.insert(r,o)}r.show(!0);const h=await r.processId;c?await new Promise(p=>setTimeout(p,1e3)):v.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(t.indexOf("powershell")>=0||t.indexOf("pwsh")>=0||t.indexOf("cmd.exe")>=0?r.sendText("cls"):t.indexOf("bash")>=0?r.sendText("clear"):I.isWindows?r.sendText("cls"):r.sendText("clear"));const _=(0,d.prepareCommand)(t,g.args,s,g.env);r.sendText(_);const u=this.onDidTerminateDebugSession(p=>{p.id===a&&(this._integratedTerminalInstances.free(r),u.dispose())});return h}else if(g.kind==="external")return(0,d.runInExternalTerminal)(g,await this._configurationService.getConfigProvider());return super.$runInTerminal(g,a)}createVariableResolver(g,a,v){return new f.ExtHostVariableResolverService(g,a,v,this._workspaceService)}};E=qe([He(0,C.IExtHostRpcService),He(1,y.IExtHostWorkspace),He(2,P.IExtHostExtensionService),He(3,D.IExtHostDocumentsAndEditors),He(4,k.IExtHostConfiguration),He(5,i.IExtHostTerminalService)],E),e.ExtHostDebugService=E;class w{constructor(){this._terminalInstances=new Map}async checkout(g){const v=[...this._terminalInstances.entries()].map(([t,n])=>(0,l.createCancelablePromise)(async o=>{if(n.lastUsedAt!==-1&&await(0,d.hasChildProcesses)(await t.processId))return null;const r=Date.now();return n.lastUsedAt+w.minUseDelay>r||o.isCancellationRequested||n.config!==g?null:(n.lastUsedAt=r,t)}));return await(0,l.firstParallel)(v,t=>!!t)}insert(g,a){this._terminalInstances.set(g,{lastUsedAt:Date.now(),config:a})}free(g){const a=this._terminalInstances.get(g);a&&(a.lastUsedAt=-1)}onTerminalClosed(g){this._terminalInstances.delete(g)}}w.minUseDelay=1e3}),define(me[264],ge([0,1,8,2,78,32,46,39,35,34,15,28,68,12,14,64]),function(G,e,b,I,T,A,y,P,D,k,i,C,f,m,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let E=class extends f.ExtHostTaskBase{constructor(S,g,a,v,t,n,o,r){super(S,g,a,v,t,n,o,r);this.workspaceService=a,g.remote.isRemote&&g.remote.authority?this.registerTaskSystem(m.Schemas.vscodeRemote,{scheme:m.Schemas.vscodeRemote,authority:g.remote.authority,platform:process.platform}):this.registerTaskSystem(m.Schemas.file,{scheme:m.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(S,g){const a=g;if(!g.execution&&a._id===void 0)throw new Error("Tasks to execute must include an execution");if(a._id!==void 0){const v=f.TaskHandleDTO.from(a,this.workspaceService),t=await this._proxy.$getTaskExecution(v);if(t.task===void 0)throw new Error("Task from execution DTO is undefined");const n=await this.getTaskExecution(t,g);return this._proxy.$executeTask(v).catch(()=>{}),n}else{const v=f.TaskDTO.from(g,S);if(v===void 0)return Promise.reject(new Error("Task is not valid"));f.CustomExecutionDTO.is(v.execution)&&await this.addCustomExecution(v,g,!1);const t=await this.getTaskExecution(await this._proxy.$getTaskExecution(v),g);return this._proxy.$executeTask(v).catch(()=>{}),t}}provideTasksInternal(S,g,a,v){const t=[];if(v)for(let n of v){this.checkDeprecation(n,a),(!n.definition||!S[n.definition.type])&&this._logService.warn(`The task [${n.source}, ${n.name}] uses an undefined task type. The task will be ignored in the future.`);const o=f.TaskDTO.from(n,a.extension);o&&(t.push(o),f.CustomExecutionDTO.is(o.execution)&&g.push(this.addCustomExecution(o,n,!0)))}return{tasks:t,extension:a.extension}}async resolveTaskInternal(S){return S}async getVariableResolver(S){if(this._variableResolver===void 0){const g=await this._configurationService.getConfigProvider();this._variableResolver=new y.ExtHostVariableResolverService(S,this._editorService,g,this.workspaceService)}return this._variableResolver}async $resolveVariables(S,g){const a=I.URI.revive(S),v={process:void 0,variables:Object.create(null)},t=await this._workspaceProvider.resolveWorkspaceFolder(a),n=await this._workspaceProvider.getWorkspaceFolders2();if(!n||!t)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const o=await this.getVariableResolver(n),r={uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}};for(let s of g.variables)v.variables[s]=await o.resolveAsync(r,s);if(g.process!==void 0){let s;if(g.process.path!==void 0){s=g.process.path.split(b.delimiter);for(let c=0;c<s.length;c++)s[c]=await o.resolveAsync(r,s[c])}v.process=await T.win32.findExecutable(await o.resolveAsync(r,g.process.name),g.process.cwd!==void 0?await o.resolveAsync(r,g.process.cwd):void 0,s)}return v}$getDefaultShellAndArgs(){return this._terminalService.getDefaultShellAndArgs(!0)}async $jsonTasksSupported(){return!0}async $findExecutable(S,g,a){return T.win32.findExecutable(S,g,a)}};E=qe([He(0,i.IExtHostRpcService),He(1,C.IExtHostInitDataService),He(2,A.IExtHostWorkspace),He(3,P.IExtHostDocumentsAndEditors),He(4,D.IExtHostConfiguration),He(5,k.IExtHostTerminalService),He(6,l.ILogService),He(7,d.IExtHostApiDeprecationService)],E),e.ExtHostTask=E}),define(me[265],ge([0,1,10,11,30,149,14,35,46,39,15,34,32,210,211]),function(G,e,b,I,T,A,y,P,D,k,i,C,f,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let d=class extends C.BaseExtHostTerminalService{constructor(w,S,g,a,v){super(!0,w);this._extHostConfiguration=S,this._extHostWorkspace=g,this._extHostDocumentsAndEditors=a,this._logService=v,(0,A.getSystemShell)(b.OS,process.env).then(t=>this._defaultShell=t),this._updateLastActiveWorkspace(),this._variableResolverPromise=this._updateVariableResolver(),this._registerListeners()}createTerminal(w,S,g){const a=new C.ExtHostTerminal(this._proxy,(0,T.generateUuid)(),{name:w,shellPath:S,shellArgs:g},w);return this._terminals.push(a),a.create(S,g),a.value}createTerminalFromOptions(w,S){const g=new C.ExtHostTerminal(this._proxy,(0,T.generateUuid)(),w,w.name);return this._terminals.push(g),g.create((0,I.withNullAsUndefined)(w.shellPath),(0,I.withNullAsUndefined)(w.shellArgs),(0,I.withNullAsUndefined)(w.cwd),(0,I.withNullAsUndefined)(w.env),(0,I.withNullAsUndefined)(w.icon),(0,I.withNullAsUndefined)(w.message),void 0,(0,I.withNullAsUndefined)(w.strictEnv),(0,I.withNullAsUndefined)(w.hideFromUser),(0,I.withNullAsUndefined)(S),!0),g.value}getDefaultShell(w,S){var g;return m.getDefaultShell(this._buildSafeConfigProvider(S),(g=this._defaultShell)!==null&&g!==void 0?g:(0,A.getSystemShellSync)(b.OS,process.env),process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),process.env.windir,m.createVariableResolver(this._lastActiveWorkspace,process.env,this._variableResolver),this._logService,w)}getDefaultShellArgs(w,S){return m.getDefaultShellArgs(this._buildSafeConfigProvider(S),w,m.createVariableResolver(this._lastActiveWorkspace,process.env,this._variableResolver),this._logService)}_registerListeners(){this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(()=>this._updateLastActiveWorkspace()),this._extHostWorkspace.onDidChangeWorkspace(()=>{this._variableResolverPromise=this._updateVariableResolver()})}_updateLastActiveWorkspace(){const w=this._extHostDocumentsAndEditors.activeEditor();w&&(this._lastActiveWorkspace=this._extHostWorkspace.getWorkspaceFolder(w.document.uri))}async _updateVariableResolver(){const w=await this._extHostConfiguration.getConfigProvider(),S=await this._extHostWorkspace.getWorkspaceFolders2();return this._variableResolver=new D.ExtHostVariableResolverService(S||[],this._extHostDocumentsAndEditors,w),this._variableResolver}async $getAvailableProfiles(w){const S=this._buildSafeConfigProvider(await this._extHostConfiguration.getConfigProvider());return(0,l.detectAvailableProfiles)(w,S,void 0,this._logService,await this._variableResolverPromise,this._lastActiveWorkspace)}async getDefaultShellAndArgs(w){const S=await this._extHostConfiguration.getConfigProvider();return{shell:this.getDefaultShell(w,S),args:this.getDefaultShellArgs(w,S)}}_buildSafeConfigProvider(w){const S=w.getConfiguration();return g=>{if(S.get("terminal.integrated.allowWorkspaceConfiguration"))return S.get(g);const v=S.inspect(g);return(v==null?void 0:v.globalValue)||(v==null?void 0:v.defaultValue)}}};d=qe([He(0,i.IExtHostRpcService),He(1,P.IExtHostConfiguration),He(2,f.IExtHostWorkspace),He(3,k.IExtHostDocumentsAndEditors),He(4,y.ILogService)],d),e.ExtHostTerminalService=d}),define(me[266],ge([0,1,13,16,69,6,2,5,256,14,79,82,28,185,15,63,42,34]),function(G,e,b,I,T,A,y,P,D,k,i,C,f,m,l,d,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class S{constructor(a,v,t,n){this._disposables=new A.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const o=new D.RPCProtocol(a,null,n);v=S._transform(v,o);const r=new C.ServiceCollection(...(0,i.getSingletonServiceDescriptors)());r.set(f.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},v)),r.set(l.IExtHostRpcService,new l.ExtHostRpcService(o)),r.set(d.IURITransformerService,new d.URITransformerService(n)),r.set(E.IHostUtils,t);const s=new m.InstantiationService(r,!0),c=s.invokeFunction(p=>p.get(w.IExtHostTerminalService));this._disposables.add(c),this._logService=s.invokeFunction(p=>p.get(k.ILogService)),T.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",v),this._extensionService=s.invokeFunction(p=>p.get(E.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const h=new WeakMap;this._extensionService.getExtensionPathIndex().then(p=>{Error.prepareStackTrace=(R,O)=>{let j="",ie,K;for(const x of O)j+=`
	at ${x.toString()}`,K=x.getFileName(),!ie&&K&&(ie=p.findSubstr(K));return h.set(R,ie),`${R.name||"Error"}: ${R.message||""}${j}`}});const _=o.getProxy(P.MainContext.MainThreadExtensionService),u=o.getProxy(P.MainContext.MainThreadErrors);I.setUnexpectedErrorHandler(p=>{const R=I.transformErrorForSerialization(p),O=h.get(p);O?_.$onExtensionRuntimeError(O.identifier,R):u.$onUnexpectedError(R)})}terminate(a){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${a}`),this._logService.flush(),this._disposables.dispose(),I.setUnexpectedErrorHandler(t=>{});const v=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,b.timeout)(4e3),v]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(a,v){a.extensions.forEach(n=>n.extensionLocation=y.URI.revive(v.transformIncomingURIs(n.extensionLocation))),a.environment.appRoot=y.URI.revive(v.transformIncomingURIs(a.environment.appRoot));const t=a.environment.extensionDevelopmentLocationURI;return t&&(a.environment.extensionDevelopmentLocationURI=t.map(n=>y.URI.revive(v.transformIncomingURIs(n)))),a.environment.extensionTestsLocationURI=y.URI.revive(v.transformIncomingURIs(a.environment.extensionTestsLocationURI)),a.environment.globalStorageHome=y.URI.revive(v.transformIncomingURIs(a.environment.globalStorageHome)),a.environment.workspaceStorageHome=y.URI.revive(v.transformIncomingURIs(a.environment.workspaceStorageHome)),a.logsLocation=y.URI.revive(v.transformIncomingURIs(a.logsLocation)),a.logFile=y.URI.revive(v.transformIncomingURIs(a.logFile)),a.workspace=v.transformIncomingURIs(a.workspace),a}}e.ExtensionHostMain=S}),define(me[267],ge([0,1,8,21,60,33,25,47,31]),function(G,e,b,I,T,A,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(f,m,l){this.config=f,this.provider=m,this.sessionToken=l,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=f.filePattern,this.includePattern=f.includePattern&&A.parse(f.includePattern),this.maxResults=f.maxResults||void 0,this.exists=f.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=f.excludePattern&&A.parse(f.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(f=>f.cancel()),this.activeCancellationTokens=new Set}search(f){const m=this.config.folderQueries||[];return new Promise((l,d)=>{const E=w=>{this.resultCount++,f(w)};if(this.isCanceled)return l({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(w=>{const S=w.toString(),g=b.basename(S);this.globalExcludePattern&&this.globalExcludePattern(S,g)||this.matchFile(E,{base:w,basename:g})}),Promise.all(m.map(w=>this.searchInFolder(w,E))).then(w=>{l({limitHit:this.isLimitHit,stats:w[0]||void 0})},w=>{d(new Error((0,T.toErrorMessage)(w)))})})}async searchInFolder(f,m){const l=new I.CancellationTokenSource,d=this.getSearchOptionsForFolder(f),E=this.initDirectoryTree(),w=new D.QueryGlobTester(this.config,f),S=!w.hasSiblingExcludeClauses();let g;try{this.activeCancellationTokens.add(l),g=P.StopWatch.create();const a=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},d,l.token),v=g.elapsed(),t=P.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(a&&a.forEach(n=>{const o=b.posix.relative(f.folder.path,n.path);if(S){const r=b.basename(n.path);this.matchFile(m,{base:f.folder,relativePath:o,basename:r});return}this.addDirectoryEntries(E,f.folder,o,m)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(E,w,m),{providerTime:v,postProcessTime:t.elapsed()})}finally{l.dispose(),this.activeCancellationTokens.delete(l)}}getSearchOptionsForFolder(f){const m=(0,D.resolvePatternsForProvider)(this.config.includePattern,f.includePattern),l=(0,D.resolvePatternsForProvider)(this.config.excludePattern,f.excludePattern);return{folder:f.folder,excludes:l,includes:m,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,followSymlinks:!f.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const f={rootEntries:[],pathToEntries:Object.create(null)};return f.pathToEntries["."]=f.rootEntries,f}addDirectoryEntries({pathToEntries:f},m,l,d){if(l===this.filePattern){const w=b.basename(this.filePattern);this.matchFile(d,{base:m,relativePath:this.filePattern,basename:w})}function E(w){const S=b.basename(w),g=b.dirname(w);let a=f[g];a||(a=f[g]=[],E(g)),a.push({base:m,relativePath:w,basename:S})}E(l)}matchDirectoryTree({rootEntries:f,pathToEntries:m},l,d){const E=this,w=this.filePattern;function S(g){const a=A.hasSiblingFn(()=>g.map(v=>v.basename));for(let v=0,t=g.length;v<t;v++){const n=g[v],{relativePath:o,basename:r}=n;if(!!l.includedInQuerySync(o,r,w!==r?a:void 0)){const s=m[o];if(s)S(s);else{if(o===w)continue;E.matchFile(d,n)}if(E.isLimitHit)break}}}S(f)}matchFile(f,m){(!this.includePattern||m.relativePath&&this.includePattern(m.relativePath,m.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||f(m))}}class i{constructor(){this.sessions=new Map}fileSearch(f,m,l,d){const E=this.getSessionTokenSource(f.cacheKey),w=new k(f,m,E&&E.token);let S=0;const g=a=>{S+=a.length,l(a.map(v=>this.rawMatchToSearchItem(v)))};return this.doSearch(w,i.BATCH_SIZE,g,d).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:S,detailStats:a.stats}}))}clearCache(f){const m=this.getSessionTokenSource(f);m&&m.cancel()}getSessionTokenSource(f){if(!!f)return this.sessions.has(f)||this.sessions.set(f,new I.CancellationTokenSource),this.sessions.get(f)}rawMatchToSearchItem(f){return f.relativePath?{resource:y.joinPath(f.base,f.relativePath)}:{resource:f.base}}doSearch(f,m,l,d){d.onCancellationRequested(()=>{f.cancel()});const E=S=>{S&&(w.push(S),m>0&&w.length>=m&&(l(w),w=[]))};let w=[];return f.search(E).then(S=>(w.length&&l(w),S),S=>(w.length&&l(w),Promise.reject(S)))}}e.FileSearchManager=i,i.BATCH_SIZE=512}),define(me[129],ge([0,1,8,17,21,60,25,33,2,31,12,11]),function(G,e,b,I,T,A,y,P,D,k,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class f{constructor(g,a,v){this.query=g,this.provider=a,this.fileUtils=v,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(g,a){const v=this.query.folderQueries||[],t=new T.CancellationTokenSource;return a.onCancellationRequested(()=>t.cancel()),new Promise((n,o)=>{this.collector=new l(g);let r=!1;const s=(c,h)=>{if(!r&&!this.isLimitHit){const _=this.resultSize(c);E(c)&&typeof this.query.maxResults=="number"&&this.resultCount+_>this.query.maxResults&&(this.isLimitHit=!0,r=!0,t.cancel(),c=this.trimResultToSize(c,this.query.maxResults-this.resultCount));const u=this.resultSize(c);this.resultCount+=u,(u>0||!E(c))&&this.collector.add(c,h)}};Promise.all(v.map((c,h)=>this.searchInFolder(c,_=>s(_,h),t.token))).then(c=>{t.dispose(),this.collector.flush();const h=c.some(_=>!!_&&!!_.limitHit);n({limitHit:this.isLimitHit||h,messages:(0,I.flatten)(c.map(_=>(_==null?void 0:_.message)?(0,C.isArray)(_.message)?_.message:[_.message]:[])),stats:{type:"textSearchProvider"}})},c=>{t.dispose();const h=(0,A.toErrorMessage)(c);o(new Error(h))})})}resultSize(g){return E(g)?Array.isArray(g.ranges)?g.ranges.length:1:0}trimResultToSize(g,a){const v=Array.isArray(g.ranges)?g.ranges:[g.ranges],t=Array.isArray(g.preview.matches)?g.preview.matches:[g.preview.matches];return{ranges:v.slice(0,a),preview:{matches:t.slice(0,a),text:g.preview.text},uri:g.uri}}async searchInFolder(g,a,v){const t=new k.QueryGlobTester(this.query,g),n=[],o={report:c=>{if(!!this.validateProviderResult(c)){const h=g.folder.scheme===i.Schemas.file?P.hasSiblingPromiseFn(()=>this.fileUtils.readdir(y.dirname(c.uri))):void 0,_=y.relativePath(g.folder,c.uri);_&&n.push(t.includedInQuery(_,b.basename(_),h).then(u=>{u&&a(c)}))}}},r=this.getSearchOptionsForFolder(g),s=await this.provider.provideTextSearchResults(m(this.query.contentPattern),r,o,v);return await Promise.all(n),s}validateProviderResult(g){if(E(g)){if(Array.isArray(g.ranges)){if(!Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(g.preview.matches.length!==g.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(g){const a=(0,k.resolvePatternsForProvider)(this.query.includePattern,g.includePattern),v=(0,k.resolvePatternsForProvider)(this.query.excludePattern,g.excludePattern),t={folder:D.URI.from(g.folder),excludes:v,includes:a,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,followSymlinks:!g.ignoreSymlinks,encoding:g.fileEncoding&&this.fileUtils.toCanonicalName(g.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=f;function m(S){return{isCaseSensitive:S.isCaseSensitive||!1,isRegExp:S.isRegExp||!1,isWordMatch:S.isWordMatch||!1,isMultiline:S.isMultiline||!1,pattern:S.pattern}}class l{constructor(g){this._onResult=g,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new w(512,a=>this.sendItems(a))}add(g,a){this._currentFileMatch&&(this._currentFolderIdx!==a||!y.isEqual(this._currentUri,g.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=a,this._currentFileMatch={resource:g.uri,results:[]}),this._currentFileMatch.results.push(d(g))}pushToCollector(){const g=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,g)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(g){this._onResult(g)}}e.TextSearchResultsCollector=l;function d(S){return E(S)?{preview:{matches:(0,I.mapArrayOrNot)(S.preview.matches,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character})),text:S.preview.text},ranges:(0,I.mapArrayOrNot)(S.ranges,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character}))}:{text:S.text,lineNumber:S.lineNumber}}function E(S){return!!S.preview}e.extensionResultIsMatch=E;class w{constructor(g,a){this.maxBatchSize=g,this.cb=a,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(g,a){!g||this.addItemToBatch(g,a)}addItems(g,a){!g||this.addItemsToBatch(g,a)}addItemToBatch(g,a){this.batch.push(g),this.batchSize+=a,this.onUpdate()}addItemsToBatch(g,a){this.batch=this.batch.concat(g),this.batchSize+=a,this.onUpdate()}onUpdate(){this.totalNumberCompleted<w.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},w.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=w,w.TIMEOUT=4e3,w.START_BATCH_AFTER_COUNT=50}),define(me[70],ge([0,1,6,5,4,267,15,63,14,2,129]),function(G,e,b,I,T,A,y,P,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,T.createDecorator)("IExtHostSearch");let C=class{constructor(d,E,w){this.extHostRpc=d,this._uriTransformer=E,this._logService=w,this._proxy=this.extHostRpc.getProxy(I.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(d){return this._uriTransformer.transformOutgoingScheme(d)}registerTextSearchProvider(d,E){if(this._textSearchUsedSchemes.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this._textSearchUsedSchemes.add(d);const w=this._handlePool++;return this._textSearchProvider.set(w,E),this._proxy.$registerTextSearchProvider(w,this._transformScheme(d)),(0,b.toDisposable)(()=>{this._textSearchUsedSchemes.delete(d),this._textSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}registerFileSearchProvider(d,E){if(this._fileSearchUsedSchemes.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this._fileSearchUsedSchemes.add(d);const w=this._handlePool++;return this._fileSearchProvider.set(w,E),this._proxy.$registerFileSearchProvider(w,this._transformScheme(d)),(0,b.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(d),this._fileSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}$provideFileSearchResults(d,E,w,S){const g=f(w),a=this._fileSearchProvider.get(d);if(a)return this._fileSearchManager.fileSearch(g,a,v=>{this._proxy.$handleFileMatch(d,E,v.map(t=>t.resource))},S);throw new Error("unknown provider: "+d)}$clearCache(d){return this._fileSearchManager.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,E,w,S){const g=this._textSearchProvider.get(d);if(!g||!g.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const a=f(w);return this.createTextSearchManager(a,g).search(t=>this._proxy.$handleTextMatch(d,E,t),S)}createTextSearchManager(d,E){return new i.TextSearchManager(d,E,{readdir:w=>Promise.resolve([]),toCanonicalName:w=>w})}};C=qe([He(0,y.IExtHostRpcService),He(1,P.IURITransformerService),He(2,D.ILogService)],C),e.ExtHostSearch=C;function f(l){return Object.assign(Object.assign({},l),{folderQueries:l.folderQueries&&l.folderQueries.map(m),extraFileResources:l.extraFileResources&&l.extraFileResources.map(d=>k.URI.revive(d))})}e.reviveQuery=f;function m(l){return Object.assign(Object.assign({},l),{folder:k.URI.revive(l.folder)})}}),define(me[268],ge([0,1,160,21,16,3,58,2,151,109,141,77,45,5,230,229,51,231,35,232,233,234,215,235,39,42,236,216,238,239,240,65,219,243,244,245,92,34,246,220,20,7,249,66,128,32,41,53,202,237,118,127,68,46,70,14,63,15,28,241,200,50,64,227,247,199,93,91,252,250,251,228,62,259,248,90,196,120,242,85,67]),function(G,e,b,I,T,A,y,P,D,k,i,C,f,m,l,d,E,w,S,g,a,v,t,n,o,r,s,c,h,_,u,p,R,O,j,ie,K,x,$,U,L,N,M,F,W,q,Q,le,ve,Re,Se,Oe,z,Y,ee,se,fe,Ee,Be,pe,Ce,Me,ze,_e,Ke,X,ne,we,xe,je,Ve,Ze,De,ye,Pe,oe,ue,H,Z,ce,Ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ae(Le){const $e=Le.get(Be.IExtHostInitDataService),Xe=Le.get(De.IExtHostFileSystemInfo),rt=Le.get(we.IExtHostConsumerFileSystem),tt=Le.get(r.IExtHostExtensionService),Qe=Le.get(q.IExtHostWorkspace),mt=Le.get(H.IExtHostTelemetry),wt=Le.get(S.IExtHostConfiguration),be=Le.get(fe.IURITransformerService),he=Le.get(Ee.IExtHostRpcService),ae=Le.get(K.IExtHostStorage),J=Le.get(ne.IExtensionStoragePaths),Ne=Le.get(se.ILogService),Fe=Le.get(Me.IExtHostTunnelService),Ye=Le.get(ze.IExtHostApiDeprecationService),et=Le.get(W.IExtHostWindow),ut=Le.get(oe.IExtHostSecretState);he.set(m.ExtHostContext.ExtHostFileSystemInfo,Xe),he.set(m.ExtHostContext.ExtHostLogService,Ne),he.set(m.ExtHostContext.ExtHostWorkspace,Qe),he.set(m.ExtHostContext.ExtHostConfiguration,wt),he.set(m.ExtHostContext.ExtHostExtensionService,tt),he.set(m.ExtHostContext.ExtHostStorage,ae),he.set(m.ExtHostContext.ExtHostTunnelService,Fe),he.set(m.ExtHostContext.ExtHostWindow,et),he.set(m.ExtHostContext.ExtHostSecretState,ut),he.set(m.ExtHostContext.ExtHostTelemetry,mt);const ht=he.set(m.ExtHostContext.ExtHostDecorations,Le.get(Oe.IExtHostDecorations)),Je=he.set(m.ExtHostContext.ExtHostDocumentsAndEditors,Le.get(o.IExtHostDocumentsAndEditors)),at=he.set(m.ExtHostContext.ExtHostCommands,Le.get(E.IExtHostCommands)),ft=he.set(m.ExtHostContext.ExtHostTerminalService,Le.get(x.IExtHostTerminalService)),lt=he.set(m.ExtHostContext.ExtHostDebugService,Le.get(Y.IExtHostDebugService)),St=he.set(m.ExtHostContext.ExtHostSearch,Le.get(ee.IExtHostSearch)),vt=he.set(m.ExtHostContext.ExtHostTask,Le.get(z.IExtHostTask)),Pt=he.set(m.ExtHostContext.ExtHostOutputService,Le.get(p.IExtHostOutputService)),Tt=he.set(m.ExtHostContext.ExtHostEditorTabs,new ue.ExtHostEditorTabs),Rt=he.set(m.ExtHostContext.ExtHostUrls,new M.ExtHostUrls(he)),_t=he.set(m.ExtHostContext.ExtHostDocuments,new n.ExtHostDocuments(he,Je)),Zt=he.set(m.ExtHostContext.ExtHostDocumentContentProviders,new v.ExtHostDocumentContentProvider(he,Je,Ne)),en=he.set(m.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(Ne,_t,he.getProxy(m.MainContext.MainThreadBulkEdits))),gt=he.set(m.ExtHostContext.ExtHostNotebook,new pe.ExtHostNotebookController(he,at,Je,_t,Ne,J)),tn=he.set(m.ExtHostContext.ExtHostNotebookKernels,new Z.ExtHostNotebookKernels(he,$e,gt)),Dt=he.set(m.ExtHostContext.ExtHostEditors,new $.ExtHostEditors(he,Je)),Gt=he.set(m.ExtHostContext.ExtHostTreeViews,new U.ExtHostTreeViews(he.getProxy(m.MainContext.MainThreadTreeViews),at,Ne)),nn=he.set(m.ExtHostContext.ExtHostEditorInsets,new ve.ExtHostEditorInsets(he.getProxy(m.MainContext.MainThreadEditorInsets),Dt,$e.environment)),Qt=he.set(m.ExtHostContext.ExtHostDiagnostics,new g.ExtHostDiagnostics(he,Ne)),ct=he.set(m.ExtHostContext.ExtHostLanguageFeatures,new h.ExtHostLanguageFeatures(he,be,_t,at,Qt,Ne,Ye)),rn=he.set(m.ExtHostContext.ExtHostFileSystem,new s.ExtHostFileSystem(he,ct)),Lt=he.set(m.ExtHostContext.ExtHostFileSystemEventService,new c.ExtHostFileSystemEventService(he,Ne,Je)),Wt=he.set(m.ExtHostContext.ExtHostQuickOpen,(0,O.createExtHostQuickOpen)(he,Qe,at)),gn=he.set(m.ExtHostContext.ExtHostSCM,new j.ExtHostSCM(he,at,Ne)),Dn=he.set(m.ExtHostContext.ExtHostComments,new w.ExtHostComments(he,at,_t)),pn=he.set(m.ExtHostContext.ExtHostProgress,new R.ExtHostProgress(he.getProxy(m.MainContext.MainThreadProgress))),sn=he.set(m.ExtHostContext.ExtHosLabelService,new Re.ExtHostLabelService(he)),Xt=he.set(m.ExtHostContext.ExtHostTheming,new Ce.ExtHostTheming(he)),Ut=he.set(m.ExtHostContext.ExtHostAuthentication,new _e.ExtHostAuthentication(he)),Cn=he.set(m.ExtHostContext.ExtHostTimeline,new Ke.ExtHostTimeline(he,at)),on=he.set(m.ExtHostContext.ExtHostWebviews,new F.ExtHostWebviews(he,$e.environment,Qe,Ne,Ye)),an=he.set(m.ExtHostContext.ExtHostWebviewPanels,new Ve.ExtHostWebviewPanels(he,on,Qe)),Yt=he.set(m.ExtHostContext.ExtHostCustomEditors,new je.ExtHostCustomEditors(he,_t,J,on,an)),kn=he.set(m.ExtHostContext.ExtHostWebviewViews,new xe.ExtHostWebviewViews(he,on)),Ft=he.set(m.ExtHostContext.ExtHostTesting,new ye.ExtHostTesting(he,Je,Qe)),ln=he.set(m.ExtHostContext.ExtHostUriOpeners,new Pe.ExtHostUriOpeners(he)),Pn=(0,le.values)(m.ExtHostContext);he.assertRegistered(Pn);const $t=new Ze.ExtHostBulkEdits(he,Je),cn=new d.ExtHostClipboard(he),xt=new u.ExtHostMessageService(he,Ne),Mt=new a.ExtHostDialogs(he),vn=new ie.ExtHostStatusBar(he,at.converter),Ht=new _.ExtHostLanguages(he,_t);return l.ExtHostApiCommands.register(at),function(Ue,un,dn){const pt=function(){let te=!Ue.isUnderDevelopment;function de(Te){te||(Ne.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Te(st){if(Array.isArray(st))st.forEach(Te);else if(typeof st=="string")de(st);else{const bt=st;typeof bt.scheme=="undefined"&&de(st),!Ue.enableProposedApi&&typeof bt.exclusive=="boolean"&&(0,Q.throwProposedApiError)(Ue)}return st}}(),In={getSession(te,de,Te){return Ut.getSession(Ue,te,de,Te)},get onDidChangeSessions(){return Ut.onDidChangeSessions},registerAuthenticationProvider(te,de,Te,st){return Ut.registerAuthenticationProvider(te,de,Te,st)},get onDidChangeAuthenticationProviders(){return(0,Q.checkProposedApiEnabled)(Ue),Ut.onDidChangeAuthenticationProviders},get providers(){return(0,Q.checkProposedApiEnabled)(Ue),Ut.providers},logout(te,de){return(0,Q.checkProposedApiEnabled)(Ue),Ut.removeSession(te,de)}},An={registerCommand(te,de,Te){return at.registerCommand(!0,te,de,Te)},registerTextEditorCommand(te,de,Te){return at.registerCommand(!0,te,(...st)=>{const bt=Dt.getActiveTextEditor();if(!bt){Ne.warn("Cannot execute "+te+" because there is no active text editor.");return}return bt.edit(Ct=>{de.apply(Te,[bt,Ct,...st])}).then(Ct=>{Ct||Ne.warn("Edits from command "+te+" were not applied.")},Ct=>{Ne.warn("An error occurred while running command "+te,Ct)})})},registerDiffInformationCommand:(te,de,Te)=>((0,Q.checkProposedApiEnabled)(Ue),at.registerCommand(!0,te,async(...st)=>{const bt=Je.activeEditor(!0);if(!bt){Ne.warn("Cannot execute "+te+" because there is no active text editor.");return}const Ct=await Dt.getDiffInformation(bt.id);de.apply(Te,[Ct,...st])})),executeCommand(te,...de){return at.executeCommand(te,...de)},getCommands(te=!1){return at.getCommands(te)}},wn={get machineId(){return $e.telemetryInfo.machineId},get sessionId(){return $e.telemetryInfo.sessionId},get language(){return $e.environment.appLanguage},get appName(){return $e.environment.appName},get appRoot(){var te,de;return(de=(te=$e.environment.appRoot)===null||te===void 0?void 0:te.fsPath)!==null&&de!==void 0?de:""},get uriScheme(){return $e.environment.appUriScheme},get clipboard(){return cn.value},get shell(){return ft.getDefaultShell(!1,dn)},get isTelemetryEnabled(){return mt.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return mt.onDidChangeTelemetryEnabled},get isNewAppInstall(){const te=Date.now()-new Date($e.telemetryInfo.firstSessionDate).getTime();return isNaN(te)?!1:te<1e3*60*60*24},openExternal(te,de){return et.openUri(te,{allowTunneling:!!$e.remote.authority,allowContributedOpeners:de==null?void 0:de.allowContributedOpeners})},asExternalUri(te){return te.scheme===$e.environment.appUriScheme?Rt.createAppUri(te):et.asExternalUri(te,{allowTunneling:!!$e.remote.authority})},get remoteName(){return(0,Se.getRemoteName)($e.remote.authority)},get uiKind(){return $e.uiKind}};$e.environment.extensionTestsLocationURI||Object.freeze(wn);const bn=$e.remote.isRemote?N.ExtensionKind.Workspace:N.ExtensionKind.UI,zt={registerTestController(te){return(0,Q.checkProposedApiEnabled)(Ue),Ft.registerTestController(Ue.identifier.value,te)},createDocumentTestObserver(te){return(0,Q.checkProposedApiEnabled)(Ue),Ft.createTextDocumentTestObserver(te)},createWorkspaceTestObserver(te){return(0,Q.checkProposedApiEnabled)(Ue),Ft.createWorkspaceTestObserver(te)},runTests(te){return(0,Q.checkProposedApiEnabled)(Ue),Ft.runTests(te)},createTestItem(te,de){return new N.TestItemImpl(te.id,te.label,te.uri,de)},createTestRun(te,de,Te){return(0,Q.checkProposedApiEnabled)(Ue),Ft.createTestRun(Ue.identifier.value,te,de,Te)},get onDidChangeTestResults(){return(0,Q.checkProposedApiEnabled)(Ue),Ft.onResultsChanged},get testResults(){return(0,Q.checkProposedApiEnabled)(Ue),Ft.results}};zt.createTestRunTask=zt.createTestRun;const Tn={getExtension(te){const de=un.getExtensionDescription(te);if(de)return new r.Extension(tt,Ue.identifier,de,bn)},get all(){return un.getAllExtensionDescriptions().map(te=>new r.Extension(tt,Ue.identifier,te,bn))},get onDidChange(){return un.onDidChange}},Rn={createDiagnosticCollection(te){return Qt.createDiagnosticCollection(Ue.identifier,te)},get onDidChangeDiagnostics(){return Qt.onDidChangeDiagnostics},getDiagnostics:te=>Qt.getDiagnostics(te),getLanguages(){return Ht.getLanguages()},setTextDocumentLanguage(te,de){return Ht.changeLanguage(te.uri,de)},match(te,de){return(0,C.score)(L.LanguageSelector.from(te),de.uri,de.languageId,!0)},registerCodeActionsProvider(te,de,Te){return ct.registerCodeActionProvider(Ue,pt(te),de,Te)},registerCodeLensProvider(te,de){return ct.registerCodeLensProvider(Ue,pt(te),de)},registerDefinitionProvider(te,de){return ct.registerDefinitionProvider(Ue,pt(te),de)},registerDeclarationProvider(te,de){return ct.registerDeclarationProvider(Ue,pt(te),de)},registerImplementationProvider(te,de){return ct.registerImplementationProvider(Ue,pt(te),de)},registerTypeDefinitionProvider(te,de){return ct.registerTypeDefinitionProvider(Ue,pt(te),de)},registerHoverProvider(te,de){return ct.registerHoverProvider(Ue,pt(te),de,Ue.identifier)},registerEvaluatableExpressionProvider(te,de){return ct.registerEvaluatableExpressionProvider(Ue,pt(te),de,Ue.identifier)},registerInlineValuesProvider(te,de){return ct.registerInlineValuesProvider(Ue,pt(te),de,Ue.identifier)},registerDocumentHighlightProvider(te,de){return ct.registerDocumentHighlightProvider(Ue,pt(te),de)},registerLinkedEditingRangeProvider(te,de){return ct.registerLinkedEditingRangeProvider(Ue,pt(te),de)},registerReferenceProvider(te,de){return ct.registerReferenceProvider(Ue,pt(te),de)},registerRenameProvider(te,de){return ct.registerRenameProvider(Ue,pt(te),de)},registerDocumentSymbolProvider(te,de,Te){return ct.registerDocumentSymbolProvider(Ue,pt(te),de,Te)},registerWorkspaceSymbolProvider(te){return ct.registerWorkspaceSymbolProvider(Ue,te)},registerDocumentFormattingEditProvider(te,de){return ct.registerDocumentFormattingEditProvider(Ue,pt(te),de)},registerDocumentRangeFormattingEditProvider(te,de){return ct.registerDocumentRangeFormattingEditProvider(Ue,pt(te),de)},registerOnTypeFormattingEditProvider(te,de,Te,...st){return ct.registerOnTypeFormattingEditProvider(Ue,pt(te),de,[Te].concat(st))},registerDocumentSemanticTokensProvider(te,de,Te){return ct.registerDocumentSemanticTokensProvider(Ue,pt(te),de,Te)},registerDocumentRangeSemanticTokensProvider(te,de,Te){return ct.registerDocumentRangeSemanticTokensProvider(Ue,pt(te),de,Te)},registerSignatureHelpProvider(te,de,Te,...st){return typeof Te=="object"?ct.registerSignatureHelpProvider(Ue,pt(te),de,Te):ct.registerSignatureHelpProvider(Ue,pt(te),de,typeof Te=="undefined"?[]:[Te,...st])},registerCompletionItemProvider(te,de,...Te){return ct.registerCompletionItemProvider(Ue,pt(te),de,Te)},registerDocumentLinkProvider(te,de){return ct.registerDocumentLinkProvider(Ue,pt(te),de)},registerColorProvider(te,de){return ct.registerColorProvider(Ue,pt(te),de)},registerFoldingRangeProvider(te,de){return ct.registerFoldingRangeProvider(Ue,pt(te),de)},registerSelectionRangeProvider(te,de){return ct.registerSelectionRangeProvider(Ue,te,de)},registerCallHierarchyProvider(te,de){return ct.registerCallHierarchyProvider(Ue,te,de)},setLanguageConfiguration:(te,de)=>ct.setLanguageConfiguration(Ue,te,de),getTokenInformationAtPosition(te,de){return(0,Q.checkProposedApiEnabled)(Ue),Ht.tokenAtPosition(te,de)},registerInlayHintsProvider(te,de){return(0,Q.checkProposedApiEnabled)(Ue),ct.registerInlayHintsProvider(Ue,te,de)}},Ln={get activeTextEditor(){return Dt.getActiveTextEditor()},get visibleTextEditors(){return Dt.getVisibleTextEditors()},get activeTerminal(){return ft.activeTerminal},get terminals(){return ft.terminals},async showTextDocument(te,de,Te){const st=await(P.URI.isUri(te)?Promise.resolve(_n.openTextDocument(te)):Promise.resolve(te));return Dt.showTextDocument(st,de,Te)},createTextEditorDecorationType(te){return Dt.createTextEditorDecorationType(te)},onDidChangeActiveTextEditor(te,de,Te){return Dt.onDidChangeActiveTextEditor(te,de,Te)},onDidChangeVisibleTextEditors(te,de,Te){return Dt.onDidChangeVisibleTextEditors(te,de,Te)},onDidChangeTextEditorSelection(te,de,Te){return Dt.onDidChangeTextEditorSelection(te,de,Te)},onDidChangeTextEditorOptions(te,de,Te){return Dt.onDidChangeTextEditorOptions(te,de,Te)},onDidChangeTextEditorVisibleRanges(te,de,Te){return Dt.onDidChangeTextEditorVisibleRanges(te,de,Te)},onDidChangeTextEditorViewColumn(te,de,Te){return Dt.onDidChangeTextEditorViewColumn(te,de,Te)},onDidCloseTerminal(te,de,Te){return ft.onDidCloseTerminal(te,de,Te)},onDidOpenTerminal(te,de,Te){return ft.onDidOpenTerminal(te,de,Te)},onDidChangeActiveTerminal(te,de,Te){return ft.onDidChangeActiveTerminal(te,de,Te)},onDidChangeTerminalDimensions(te,de,Te){return(0,Q.checkProposedApiEnabled)(Ue),ft.onDidChangeTerminalDimensions(te,de,Te)},onDidWriteTerminalData(te,de,Te){return(0,Q.checkProposedApiEnabled)(Ue),ft.onDidWriteTerminalData(te,de,Te)},get state(){return et.state},onDidChangeWindowState(te,de,Te){return et.onDidChangeWindowState(te,de,Te)},showInformationMessage(te,...de){return xt.showMessage(Ue,y.default.Info,te,de[0],de.slice(1))},showWarningMessage(te,...de){return xt.showMessage(Ue,y.default.Warning,te,de[0],de.slice(1))},showErrorMessage(te,...de){return xt.showMessage(Ue,y.default.Error,te,de[0],de.slice(1))},showQuickPick(te,de,Te){return Wt.showQuickPick(te,!!Ue.enableProposedApi,de,Te)},showWorkspaceFolderPick(te){return Wt.showWorkspaceFolderPick(te)},showInputBox(te,de){return Wt.showInput(te,de)},showOpenDialog(te){return Mt.showOpenDialog(te)},showSaveDialog(te){return Mt.showSaveDialog(te)},createStatusBarItem(te,de){let Te,st,bt,Ct;return te&&typeof te!="number"?(Te=te.id,st=te.name,bt=te.alignment,de=te.priority,Ct=te.accessibilityInformation):(Te=Ue.identifier.value,st=b.localize(0,null,Ue.displayName||Ue.name),bt=te),vn.createStatusBarEntry(Te,st,bt,de,Ct)},setStatusBarMessage(te,de){return vn.setStatusBarMessage(te,de)},withScmProgress(te){return Ye.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),pn.withProgress(Ue,{location:N.ProgressLocation.SourceControl},(de,Te)=>te({report(st){}}))},withProgress(te,de){return pn.withProgress(Ue,te,de)},createOutputChannel(te){return Pt.createOutputChannel(te)},createWebviewPanel(te,de,Te,st){return an.createWebviewPanel(Ue,te,de,Te,st)},createWebviewTextEditorInset(te,de,Te,st){return(0,Q.checkProposedApiEnabled)(Ue),nn.createWebviewEditorInset(te,de,Te,st,Ue)},createTerminal(te,de,Te){return typeof te=="object"?"pty"in te?ft.createExtensionTerminal(te):(te.icon&&(0,Q.checkProposedApiEnabled)(Ue),ft.createTerminalFromOptions(te)):ft.createTerminal(te,de,Te)},registerTerminalLinkProvider(te){return ft.registerLinkProvider(te)},registerTreeDataProvider(te,de){return Gt.registerTreeDataProvider(te,de,Ue)},createTreeView(te,de){return Gt.createTreeView(te,de,Ue)},registerWebviewPanelSerializer:(te,de)=>an.registerWebviewPanelSerializer(Ue,te,de),registerCustomEditorProvider:(te,de,Te={})=>Yt.registerCustomEditorProvider(Ue,te,de,Te),registerFileDecorationProvider(te){return ht.registerFileDecorationProvider(te,Ue.identifier)},registerUriHandler(te){return Rt.registerUriHandler(Ue.identifier,te)},createQuickPick(){return Wt.createQuickPick(Ue.identifier,!!Ue.enableProposedApi)},createInputBox(){return Wt.createInputBox(Ue.identifier)},get activeColorTheme(){return Xt.activeColorTheme},onDidChangeActiveColorTheme(te,de,Te){return Xt.onDidChangeActiveColorTheme(te,de,Te)},registerWebviewViewProvider(te,de,Te){return kn.registerWebviewViewProvider(Ue,te,de,Te==null?void 0:Te.webviewOptions)},get activeNotebookEditor(){return(0,Q.checkProposedApiEnabled)(Ue),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,de,Te){return(0,Q.checkProposedApiEnabled)(Ue),gt.onDidChangeActiveNotebookEditor(te,de,Te)},get visibleNotebookEditors(){return(0,Q.checkProposedApiEnabled)(Ue),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,Q.checkProposedApiEnabled)(Ue),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,de,Te){return(0,Q.checkProposedApiEnabled)(Ue),gt.onDidChangeNotebookEditorSelection(te,de,Te)},onDidChangeNotebookEditorVisibleRanges(te,de,Te){return(0,Q.checkProposedApiEnabled)(Ue),gt.onDidChangeNotebookEditorVisibleRanges(te,de,Te)},showNotebookDocument(te,de){return(0,Q.checkProposedApiEnabled)(Ue),gt.showNotebookDocument(te,de)},registerExternalUriOpener(te,de,Te){return(0,Q.checkProposedApiEnabled)(Ue),ln.registerExternalUriOpener(Ue.identifier,te,de,Te)},get openEditors(){return(0,Q.checkProposedApiEnabled)(Ue),Tt.tabs},get onDidChangeOpenEditors(){return(0,Q.checkProposedApiEnabled)(Ue),Tt.onDidChangeTabs}},_n={get rootPath(){return Ye.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Qe.getPath()},set rootPath(te){throw T.readonly()},getWorkspaceFolder(te){return Qe.getWorkspaceFolder(te)},get workspaceFolders(){return Qe.getWorkspaceFolders()},get name(){return Qe.name},set name(te){throw T.readonly()},get workspaceFile(){return Qe.workspaceFile},set workspaceFile(te){throw T.readonly()},updateWorkspaceFolders:(te,de,...Te)=>Qe.updateWorkspaceFolders(Ue,te,de||0,...Te),onDidChangeWorkspaceFolders:function(te,de,Te){return Qe.onDidChangeWorkspace(te,de,Te)},asRelativePath:(te,de)=>Qe.getRelativePath(te,de),findFiles:(te,de,Te,st)=>Qe.findFiles(L.GlobPattern.from(te),L.GlobPattern.from(de),Te,Ue.identifier,st),findTextInFiles:(te,de,Te,st)=>{let bt,Ct;return typeof de=="object"?(bt=de,Ct=Te):(bt={},Ct=de,st=Te),Qe.findTextInFiles(te,bt||{},Ct,Ue.identifier,st)},saveAll:te=>Qe.saveAll(te),applyEdit(te){return $t.applyWorkspaceEdit(te)},createFileSystemWatcher:(te,de,Te,st)=>Lt.createFileSystemWatcher(L.GlobPattern.from(te),de,Te,st),get textDocuments(){return _t.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw T.readonly()},openTextDocument(te){let de;const Te=te;if(typeof te=="string")de=Promise.resolve(P.URI.file(te));else if(P.URI.isUri(te))de=Promise.resolve(te);else if(!Te||typeof Te=="object")de=_t.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(st=>_t.ensureDocumentData(st).then(bt=>bt.document))},onDidOpenTextDocument:(te,de,Te)=>_t.onDidAddDocument(te,de,Te),onDidCloseTextDocument:(te,de,Te)=>_t.onDidRemoveDocument(te,de,Te),onDidChangeTextDocument:(te,de,Te)=>_t.onDidChangeDocument(te,de,Te),onDidSaveTextDocument:(te,de,Te)=>_t.onDidSaveDocument(te,de,Te),onWillSaveTextDocument:(te,de,Te)=>en.getOnWillSaveTextDocumentEvent(Ue)(te,de,Te),onDidChangeConfiguration:(te,de,Te)=>dn.onDidChangeConfiguration(te,de,Te),getConfiguration(te,de){return de=arguments.length===1?void 0:de,dn.getConfiguration(te,de,Ue)},registerTextDocumentContentProvider(te,de){return Zt.registerTextDocumentContentProvider(te,de)},registerTaskProvider:(te,de)=>(Ye.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),vt.registerTaskProvider(Ue,te,de)),registerFileSystemProvider(te,de,Te){return rn.registerFileSystemProvider(Ue.identifier,te,de,Te)},get fs(){return rt.value},registerFileSearchProvider:(te,de)=>((0,Q.checkProposedApiEnabled)(Ue),St.registerFileSearchProvider(te,de)),registerTextSearchProvider:(te,de)=>((0,Q.checkProposedApiEnabled)(Ue),St.registerTextSearchProvider(te,de)),registerRemoteAuthorityResolver:(te,de)=>((0,Q.checkProposedApiEnabled)(Ue),tt.registerRemoteAuthorityResolver(te,de)),registerResourceLabelFormatter:te=>((0,Q.checkProposedApiEnabled)(Ue),sn.$registerResourceLabelFormatter(te)),onDidCreateFiles:(te,de,Te)=>Lt.onDidCreateFile(te,de,Te),onDidDeleteFiles:(te,de,Te)=>Lt.onDidDeleteFile(te,de,Te),onDidRenameFiles:(te,de,Te)=>Lt.onDidRenameFile(te,de,Te),onWillCreateFiles:(te,de,Te)=>Lt.getOnWillCreateFileEvent(Ue)(te,de,Te),onWillDeleteFiles:(te,de,Te)=>Lt.getOnWillDeleteFileEvent(Ue)(te,de,Te),onWillRenameFiles:(te,de,Te)=>Lt.getOnWillRenameFileEvent(Ue)(te,de,Te),openTunnel:te=>((0,Q.checkProposedApiEnabled)(Ue),Fe.openTunnel(Ue,te).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,Q.checkProposedApiEnabled)(Ue),Fe.getTunnels()},onDidChangeTunnels:(te,de,Te)=>((0,Q.checkProposedApiEnabled)(Ue),Fe.onDidChangeTunnels(te,de,Te)),registerPortAttributesProvider:(te,de)=>((0,Q.checkProposedApiEnabled)(Ue),Fe.registerPortsAttributesProvider(te,de)),registerTimelineProvider:(te,de)=>((0,Q.checkProposedApiEnabled)(Ue),Cn.registerTimelineProvider(te,de,Ue.identifier,at.converter)),get isTrusted(){return Qe.trusted},requestWorkspaceTrust:te=>((0,Q.checkProposedApiEnabled)(Ue),Qe.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,de,Te)=>Qe.onDidGrantWorkspaceTrust(te,de,Te)},Fn={get inputBox(){return Ye.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),gn.getLastInputBox(Ue)},createSourceControl(te,de,Te){return gn.createSourceControl(Ue,te,de,Te)}},En={createCommentController(te,de){return Dn.createCommentController(Ue,te,de)}},Sn={get activeDebugSession(){return lt.activeDebugSession},get activeDebugConsole(){return lt.activeDebugConsole},get breakpoints(){return lt.breakpoints},onDidStartDebugSession(te,de,Te){return lt.onDidStartDebugSession(te,de,Te)},onDidTerminateDebugSession(te,de,Te){return lt.onDidTerminateDebugSession(te,de,Te)},onDidChangeActiveDebugSession(te,de,Te){return lt.onDidChangeActiveDebugSession(te,de,Te)},onDidReceiveDebugSessionCustomEvent(te,de,Te){return lt.onDidReceiveDebugSessionCustomEvent(te,de,Te)},onDidChangeBreakpoints(te,de,Te){return lt.onDidChangeBreakpoints(te,de,Te)},registerDebugConfigurationProvider(te,de,Te){return lt.registerDebugConfigurationProvider(te,de,Te||N.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,de){return lt.registerDebugAdapterDescriptorFactory(Ue,te,de)},registerDebugAdapterTrackerFactory(te,de){return lt.registerDebugAdapterTrackerFactory(te,de)},startDebugging(te,de,Te){return!Te||typeof Te=="object"&&"configuration"in Te?lt.startDebugging(te,de,{parentSession:Te}):lt.startDebugging(te,de,Te||{})},stopDebugging(te){return lt.stopDebugging(te)},addBreakpoints(te){return lt.addBreakpoints(te)},removeBreakpoints(te){return lt.removeBreakpoints(te)},asDebugSourceUri(te,de){return lt.asDebugSourceUri(te,de)}},Bt={registerTaskProvider:(te,de)=>vt.registerTaskProvider(Ue,te,de),fetchTasks:te=>vt.fetchTasks(te),executeTask:te=>vt.executeTask(Ue,te),get taskExecutions(){return vt.taskExecutions},onDidStartTask:(te,de,Te)=>vt.onDidStartTask(te,de,Te),onDidEndTask:(te,de,Te)=>vt.onDidEndTask(te,de,Te),onDidStartTaskProcess:(te,de,Te)=>vt.onDidStartTaskProcess(te,de,Te),onDidEndTaskProcess:(te,de,Te)=>vt.onDidEndTaskProcess(te,de,Te)},Vt={openNotebookDocument:te=>((0,Q.checkProposedApiEnabled)(Ue),gt.openNotebookDocument(te)),get onDidOpenNotebookDocument(){return(0,Q.checkProposedApiEnabled)(Ue),gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,Q.checkProposedApiEnabled)(Ue),gt.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,Q.checkProposedApiEnabled)(Ue),gt.onDidSaveNotebookDocument},get notebookDocuments(){return(0,Q.checkProposedApiEnabled)(Ue),gt.notebookDocuments.map(te=>te.apiNotebook)},registerNotebookSerializer(te,de,Te,st){return(0,Q.checkProposedApiEnabled)(Ue),gt.registerNotebookSerializer(Ue,te,de,Te,Ue.enableProposedApi?st:void 0)},registerNotebookContentProvider:(te,de,Te,st)=>((0,Q.checkProposedApiEnabled)(Ue),gt.registerNotebookContentProvider(Ue,te,de,Te,Ue.enableProposedApi?st:void 0)),registerNotebookCellStatusBarItemProvider:(te,de)=>((0,Q.checkProposedApiEnabled)(Ue),gt.registerNotebookCellStatusBarItemProvider(Ue,te,de)),createNotebookEditorDecorationType(te){return(0,Q.checkProposedApiEnabled)(Ue),gt.createNotebookEditorDecorationType(te)},onDidChangeNotebookDocumentMetadata(te,de,Te){return(0,Q.checkProposedApiEnabled)(Ue),gt.onDidChangeNotebookDocumentMetadata(te,de,Te)},onDidChangeNotebookCells(te,de,Te){return(0,Q.checkProposedApiEnabled)(Ue),gt.onDidChangeNotebookCells(te,de,Te)},onDidChangeCellExecutionState(te,de,Te){return(0,Q.checkProposedApiEnabled)(Ue),gt.onDidChangeNotebookCellExecutionState(te,de,Te)},onDidChangeCellOutputs(te,de,Te){return(0,Q.checkProposedApiEnabled)(Ue),gt.onDidChangeCellOutputs(te,de,Te)},onDidChangeCellMetadata(te,de,Te){return(0,Q.checkProposedApiEnabled)(Ue),gt.onDidChangeCellMetadata(te,de,Te)},createConcatTextDocument(te,de){return(0,Q.checkProposedApiEnabled)(Ue),new X.ExtHostNotebookConcatDocument(gt,_t,te,de)},createNotebookController(te,de,Te,st,bt){return(0,Q.checkProposedApiEnabled)(Ue),tn.createNotebookController(Ue,te,de,Te,st,bt)}};return{version:$e.version,authentication:In,commands:An,comments:En,debug:Sn,env:wn,extensions:Tn,languages:Rn,notebook:Vt,scm:Fn,tasks:Bt,test:zt,window:Ln,workspace:_n,Breakpoint:N.Breakpoint,CallHierarchyIncomingCall:N.CallHierarchyIncomingCall,CallHierarchyItem:N.CallHierarchyItem,CallHierarchyOutgoingCall:N.CallHierarchyOutgoingCall,CancellationError:T.CancellationError,CancellationTokenSource:I.CancellationTokenSource,CandidatePortSource:m.CandidatePortSource,CodeAction:N.CodeAction,CodeActionKind:N.CodeActionKind,CodeActionTriggerKind:N.CodeActionTriggerKind,CodeLens:N.CodeLens,Color:N.Color,ColorInformation:N.ColorInformation,ColorPresentation:N.ColorPresentation,ColorThemeKind:N.ColorThemeKind,CommentMode:N.CommentMode,CommentThreadCollapsibleState:N.CommentThreadCollapsibleState,CompletionItem:N.CompletionItem,CompletionItemKind:N.CompletionItemKind,CompletionItemTag:N.CompletionItemTag,CompletionList:N.CompletionList,CompletionTriggerKind:N.CompletionTriggerKind,ConfigurationTarget:N.ConfigurationTarget,CustomExecution:N.CustomExecution,DebugAdapterExecutable:N.DebugAdapterExecutable,DebugAdapterInlineImplementation:N.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:N.DebugAdapterNamedPipeServer,DebugAdapterServer:N.DebugAdapterServer,DebugConfigurationProviderTriggerKind:N.DebugConfigurationProviderTriggerKind,DebugConsoleMode:N.DebugConsoleMode,DecorationRangeBehavior:N.DecorationRangeBehavior,Diagnostic:N.Diagnostic,DiagnosticRelatedInformation:N.DiagnosticRelatedInformation,DiagnosticSeverity:N.DiagnosticSeverity,DiagnosticTag:N.DiagnosticTag,Disposable:N.Disposable,DocumentHighlight:N.DocumentHighlight,DocumentHighlightKind:N.DocumentHighlightKind,DocumentLink:N.DocumentLink,DocumentSymbol:N.DocumentSymbol,EndOfLine:N.EndOfLine,EnvironmentVariableMutatorType:N.EnvironmentVariableMutatorType,EvaluatableExpression:N.EvaluatableExpression,InlineValueText:N.InlineValueText,InlineValueVariableLookup:N.InlineValueVariableLookup,InlineValueEvaluatableExpression:N.InlineValueEvaluatableExpression,EventEmitter:A.Emitter,ExtensionKind:N.ExtensionKind,ExtensionMode:N.ExtensionMode,ExternalUriOpenerPriority:N.ExternalUriOpenerPriority,FileChangeType:N.FileChangeType,FileDecoration:N.FileDecoration,FileSystemError:N.FileSystemError,FileType:f.FileType,FoldingRange:N.FoldingRange,FoldingRangeKind:N.FoldingRangeKind,FunctionBreakpoint:N.FunctionBreakpoint,Hover:N.Hover,IndentAction:i.IndentAction,Location:N.Location,MarkdownString:N.MarkdownString,OverviewRulerLane:k.OverviewRulerLane,ParameterInformation:N.ParameterInformation,PortAutoForwardAction:N.PortAutoForwardAction,Position:N.Position,ProcessExecution:N.ProcessExecution,ProgressLocation:N.ProgressLocation,QuickInputButtons:N.QuickInputButtons,Range:N.Range,RelativePattern:N.RelativePattern,Selection:N.Selection,SelectionRange:N.SelectionRange,SemanticTokens:N.SemanticTokens,SemanticTokensBuilder:N.SemanticTokensBuilder,SemanticTokensEdit:N.SemanticTokensEdit,SemanticTokensEdits:N.SemanticTokensEdits,SemanticTokensLegend:N.SemanticTokensLegend,ShellExecution:N.ShellExecution,ShellQuoting:N.ShellQuoting,SignatureHelp:N.SignatureHelp,SignatureHelpTriggerKind:N.SignatureHelpTriggerKind,SignatureInformation:N.SignatureInformation,SnippetString:N.SnippetString,SourceBreakpoint:N.SourceBreakpoint,StandardTokenType:N.StandardTokenType,StatusBarAlignment:N.StatusBarAlignment,SymbolInformation:N.SymbolInformation,SymbolKind:N.SymbolKind,SymbolTag:N.SymbolTag,Task:N.Task,TaskGroup:N.TaskGroup,TaskPanelKind:N.TaskPanelKind,TaskRevealKind:N.TaskRevealKind,TaskScope:N.TaskScope,TextDocumentSaveReason:N.TextDocumentSaveReason,TextEdit:N.TextEdit,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:N.TextEditorLineNumbersStyle,TextEditorRevealType:N.TextEditorRevealType,TextEditorSelectionChangeKind:N.TextEditorSelectionChangeKind,ThemeColor:N.ThemeColor,ThemeIcon:N.ThemeIcon,TreeItem:N.TreeItem,TreeItemCollapsibleState:N.TreeItemCollapsibleState,UIKind:m.UIKind,Uri:P.URI,ViewColumn:N.ViewColumn,WorkspaceEdit:N.WorkspaceEdit,InlayHint:N.InlayHint,InlayHintKind:N.InlayHintKind,RemoteAuthorityResolverError:N.RemoteAuthorityResolverError,RemoteTrustOption:ce.RemoteTrustOption,ResolvedAuthority:N.ResolvedAuthority,SourceControlInputBoxValidationType:N.SourceControlInputBoxValidationType,ExtensionRuntime:N.ExtensionRuntime,TimelineItem:N.TimelineItem,NotebookRange:N.NotebookRange,NotebookCellKind:N.NotebookCellKind,NotebookCellExecutionState:N.NotebookCellExecutionState,NotebookDocumentMetadata:N.NotebookDocumentMetadata,NotebookCellMetadata:N.NotebookCellMetadata,NotebookCellData:N.NotebookCellData,NotebookData:N.NotebookData,NotebookKernelPreload:N.NotebookKernelPreload,NotebookCellStatusBarAlignment:N.NotebookCellStatusBarAlignment,NotebookEditorRevealType:N.NotebookEditorRevealType,NotebookCellOutput:N.NotebookCellOutput,NotebookCellOutputItem:N.NotebookCellOutputItem,NotebookCellStatusBarItem:N.NotebookCellStatusBarItem,NotebookControllerAffinity:N.NotebookControllerAffinity,LinkedEditingRanges:N.LinkedEditingRanges,TestItemStatus:N.TestItemStatus,TestResultState:N.TestResultState,TestMessage:N.TestMessage,TextSearchCompleteMessageType:Ie.TextSearchCompleteMessageType,TestMessageSeverity:N.TestMessageSeverity,WorkspaceTrustState:N.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=Ae}),define(me[269],ge([0,1,79,65,32,127,35,51,39,34,68,46,70,93,92,50,64,128,91,62,90,120]),function(G,e,b,I,T,A,y,P,D,k,i,C,f,m,l,d,E,w,S,g,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,b.registerSingleton)(m.IExtensionStoragePaths,m.ExtensionStoragePaths),(0,b.registerSingleton)(E.IExtHostApiDeprecationService,E.ExtHostApiDeprecationService),(0,b.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands),(0,b.registerSingleton)(y.IExtHostConfiguration,y.ExtHostConfiguration),(0,b.registerSingleton)(S.IExtHostConsumerFileSystem,S.ExtHostConsumerFileSystem),(0,b.registerSingleton)(C.IExtHostDebugService,C.WorkerExtHostDebugService),(0,b.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,b.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),(0,b.registerSingleton)(g.IExtHostFileSystemInfo,g.ExtHostFileSystemInfo),(0,b.registerSingleton)(I.IExtHostOutputService,I.ExtHostOutputService),(0,b.registerSingleton)(f.IExtHostSearch,f.ExtHostSearch),(0,b.registerSingleton)(l.IExtHostStorage,l.ExtHostStorage),(0,b.registerSingleton)(i.IExtHostTask,i.WorkerExtHostTask),(0,b.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService),(0,b.registerSingleton)(d.IExtHostTunnelService,d.ExtHostTunnelService),(0,b.registerSingleton)(w.IExtHostWindow,w.ExtHostWindow),(0,b.registerSingleton)(T.IExtHostWorkspace,T.ExtHostWorkspace),(0,b.registerSingleton)(a.IExtHostSecretState,a.ExtHostSecretState),(0,b.registerSingleton)(v.IExtHostTelemetry,v.ExtHostTelemetry)}),define(me[94],ge([0,1,17,14,31,67]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function y(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}e.anchorGlob=y;function P(C,f,m,l){const d=(0,b.mapArrayOrNot)(m,D),E=new T.TextSearchMatch(f,d,l),w=E.preview.matches;return{ranges:(0,b.mapArrayOrNot)(d,k),uri:C,preview:{text:E.preview.text,matches:(0,b.mapArrayOrNot)(w,k)}}}e.createTextSearchResult=P;function D(C){return new T.SearchRange(C.start.line,C.start.character,C.end.line,C.end.character)}function k(C){return new A.Range(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let i=class{constructor(f,m){this.prefix=f,this.logService=m}appendLine(f){this.logService.debug(`${this.prefix}#search`,f)}};i=qe([He(1,I.ILogService)],i),e.OutputChannel=i}),define(me[270],ge([0,1,96,23]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function T(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(n=>n===t)}e.isUTFEncoding=T,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const A=512,y=512,P=512*8,D=512*128;class k{constructor(n){this.iconvLiteDecoder=n}static async create(n){let o;if(n!==e.UTF8)o=(await new Promise((s,c)=>{G(["iconv-lite-umd"],s,c)})).getDecoder(m(n));else{const r=new TextDecoder;o={write(s){return r.decode(s,{stream:!0})},end(){return r.decode()}}}return new k(o)}write(n){return this.iconvLiteDecoder.write(n)}end(){return this.iconvLiteDecoder.end()}}function i(t,n){var o;const r=((o=n.minBytesRequiredForDetection)!==null&&o!==void 0?o:n.guessEncoding)?P:y;return new Promise((s,c)=>{const h=(0,b.newWriteableStream)(O=>O.join("")),_=[];let u=0,p;const R=async()=>{try{const O=await v({buffer:I.VSBuffer.concat(_),bytesRead:u},n.guessEncoding);O.encoding=await n.overwriteEncoding(O.encoding),p=await k.create(O.encoding);const j=p.write(I.VSBuffer.concat(_).buffer);h.write(j),_.length=0,u=0,s({stream:h,detected:O})}catch(O){c(O)}};(0,b.listenStream)(t,{onData:async O=>{p?h.write(p.write(O.buffer)):(_.push(O),u+=O.byteLength,u>=r&&(t.pause(),await R(),setTimeout(()=>t.resume())))},onError:O=>h.error(O),onEnd:async()=>{p||await R(),h.end(p==null?void 0:p.end())}})})}e.toDecodeStream=i;async function C(t,n,o){const s=(await new Promise((_,u)=>{G(["iconv-lite-umd"],_,u)})).getEncoder(m(n),o);let c=!1,h=!1;return{read(){if(h)return null;const _=t.read();if(typeof _!="string"){if(h=!0,!c&&(o==null?void 0:o.addBOM))switch(n){case e.UTF8:case e.UTF8_with_bom:return I.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return I.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return I.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const u=s.end();return u&&u.length>0?(c=!0,I.VSBuffer.wrap(u)):null}return c=!0,I.VSBuffer.wrap(s.write(_))}}}e.toEncodeReadable=C;async function f(t){return(await new Promise((o,r)=>{G(["iconv-lite-umd"],o,r)})).encodingExists(m(t))}e.encodingExists=f;function m(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=m;function l(t,n){if(!t||n<e.UTF16be_BOM.length)return null;const o=t.readUInt8(0),r=t.readUInt8(1);if(o===e.UTF16be_BOM[0]&&r===e.UTF16be_BOM[1])return e.UTF16be;if(o===e.UTF16le_BOM[0]&&r===e.UTF16le_BOM[1])return e.UTF16le;if(n<e.UTF8_BOM.length)return null;const s=t.readUInt8(2);return o===e.UTF8_BOM[0]&&r===e.UTF8_BOM[1]&&s===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=l;const d=["ascii","utf-16","utf-32"];async function E(t){const n=await new Promise((h,_)=>{G(["jschardet"],h,_)}),o=t.slice(0,D),r=g(o.buffer),s=n.detect(r);if(!s||!s.encoding)return null;const c=s.encoding.toLowerCase();return 0<=d.indexOf(c)?null:S(s.encoding)}const w={ibm866:"cp866",big5:"cp950"};function S(t){const n=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return w[n]||n}function g(t){let n="";for(let o=0;o<t.length;o++)n+=String.fromCharCode(t[o]);return n}function a(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const n=t.match(/windows(\d+)/);return n?"windows-"+n[1]:t}}e.toCanonicalName=a;function v({buffer:t,bytesRead:n},o){let r=l(t,n),s=!1;if(r!==e.UTF16be&&r!==e.UTF16le&&t){let c=!0,h=!0,_=!1;for(let u=0;u<n&&u<A;u++){const p=u%2==1,R=t.readUInt8(u)===0;if(R&&(_=!0),c&&(p&&!R||!p&&R)&&(c=!1),h&&(p&&R||!p&&!R)&&(h=!1),R&&!c&&!h)break}_&&(c?r=e.UTF16le:h?r=e.UTF16be:s=!0)}return o&&!s&&!r&&t?E(t.slice(0,n)).then(c=>({seemsBinary:!1,encoding:c})):{seemsBinary:s,encoding:r}}e.detectEncodingFromBuffer=v,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(me[130],ge([0,1,270,26,129]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class A extends T.TextSearchManager{constructor(P,D,k=I){super(P,D,{readdir:i=>k.readdir(i.fsPath),toCanonicalName:i=>(0,b.toCanonicalName)(i)})}}e.NativeTextSearchManager=A}),define(me[271],ge([0,1,272,286,287,2,288]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function P(C,f,m,l,d,E){const w=E.environment.useHostProxy,S=typeof w=="boolean"?w:!E.remote.isRemote,g=(0,y.createProxyResolver)({resolveProxy:v=>C.resolveProxy(v),getHttpProxySetting:()=>f.getConfiguration("http").get("proxy"),log:(v,t,...n)=>{switch(v){case y.LogLevel.Trace:l.trace(t,...n);break;case y.LogLevel.Debug:l.debug(t,...n);break;case y.LogLevel.Info:l.info(t,...n);break;case y.LogLevel.Warning:l.warn(t,...n);break;case y.LogLevel.Error:l.error(t,...n);break;case y.LogLevel.Critical:l.critical(t,...n);break;case y.LogLevel.Off:break;default:o(v,t,n);break}function o(r,s,...c){l.error("Unknown log level",r),l.error(s,...c)}},getLogLevel:()=>l.getLevel(),proxyResolveTelemetry:v=>{d.$publicLog2("resolveProxy",v)},useHostProxy:S,env:process.env}),a=D(f,g);return i(m,a)}e.connectProxyResolver=P;function D(C,f){const m={config:C.getConfiguration("http").get("proxySupport")||"off"};C.onDidChangeConfiguration(d=>{m.config=C.getConfiguration("http").get("proxySupport")||"off"});const l={config:!!C.getConfiguration("http").get("systemCertificates")};return C.onDidChangeConfiguration(d=>{l.config=!!C.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},b,(0,y.createHttpPatch)(b,f,{config:"off"},l,!0)),on:Object.assign({},b,(0,y.createHttpPatch)(b,f,{config:"on"},l,!0)),override:Object.assign({},b,(0,y.createHttpPatch)(b,f,{config:"override"},l,!0)),onRequest:Object.assign({},b,(0,y.createHttpPatch)(b,f,m,l,!0)),default:Object.assign(b,(0,y.createHttpPatch)(b,f,m,l,!1))},https:{off:Object.assign({},I,(0,y.createHttpPatch)(I,f,{config:"off"},l,!0)),on:Object.assign({},I,(0,y.createHttpPatch)(I,f,{config:"on"},l,!0)),override:Object.assign({},I,(0,y.createHttpPatch)(I,f,{config:"override"},l,!0)),onRequest:Object.assign({},I,(0,y.createHttpPatch)(I,f,m,l,!0)),default:Object.assign(I,(0,y.createHttpPatch)(I,f,m,l,!1))},tls:Object.assign(T,(0,y.createTlsPatch)(T))}}const k=new Map;function i(C,f){return C.getExtensionPathIndex().then(m=>{const l=G.__$__nodeRequire("module"),d=l._load;l._load=function(w,S,g){if(w==="tls")return f.tls;if(w!=="http"&&w!=="https")return d.apply(this,arguments);const a=f[w],v=m.findSubstr(A.URI.file(S.filename).fsPath);let t=k.get(v);if(t||k.set(v,t={}),!t[w]){let n=a.default;v&&v.enableProposedApi&&(n=a[v.proxySupport]||a.onRequest),t[w]=Object.assign({},n)}return t[w]}})}}),define(me[273],ge([0,1,38,8,75,29,10,9,94,274]),function(G,e,b,I,T,A,y,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const i=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(g,a,v,t){const n=f(g,a,v,t),o=a.folder.fsPath;return{cmd:b.spawn(i,n.args,{cwd:o}),rgDiskPath:i,siblingClauses:n.siblingClauses,rgArgs:n,cwd:o}}e.spawnRipgrepCmd=C;function f(g,a,v,t){const n=["--files","--hidden","--case-sensitive"];l([a],v,!1).forEach(r=>{const s=(0,D.anchorGlob)(r);if(n.push("-g",s),y.isMacintosh){const c=(0,T.normalizeNFD)(s);c!==s&&n.push("-g",c)}});const o=m([a],t,void 0,!1);return o.globArgs.forEach(r=>{const s=`!${(0,D.anchorGlob)(r)}`;if(n.push("-g",s),y.isMacintosh){const c=(0,T.normalizeNFD)(s);c!==s&&n.push("-g",c)}}),a.disregardIgnoreFiles!==!1?n.push("--no-ignore"):n.push("--no-ignore-parent"),a.ignoreSymlinks||n.push("--follow"),g.exists&&n.push("--quiet"),n.push("--no-config"),a.disregardGlobalIgnoreFiles&&n.push("--no-ignore-global"),{args:n,siblingClauses:o.siblingClauses}}function m(g,a,v,t=!0){const n=[];let o={};return g.forEach(r=>{const s=Object.assign({},r.excludePattern||{},a||{}),c=d(s,t?r.folder.fsPath:void 0,v);n.push(...c.globArgs),c.siblingClauses&&(o=Object.assign(o,c.siblingClauses))}),{globArgs:n,siblingClauses:o}}e.foldersToRgExcludeGlobs=m;function l(g,a,v=!0){const t=[];return g.forEach(n=>{const o=Object.assign({},a||{},n.includePattern||{}),r=d(o,v?n.folder.fsPath:void 0);t.push(...r.globArgs)}),t}e.foldersToIncludeGlobs=l;function d(g,a,v){const t=[],n={};return Object.keys(g).forEach(o=>{if(!(v&&v.has(o))&&!!o){const r=g[o];o=w(a?E(a,o):o),o.startsWith("\\\\")?o="\\\\"+o.substr(2).replace(/\\/g,"/"):o=o.replace(/\\/g,"/"),typeof r=="boolean"&&r?(o.startsWith("\\\\")&&(o+="**"),t.push(S(o))):r&&r.when&&(n[o]=r)}}),{globArgs:t,siblingClauses:n}}function E(g,a){return I.isAbsolute(a)?a:I.join(g,a)}e.getAbsoluteGlob=E;function w(g){return g=P.rtrim(g,"\\"),P.rtrim(g,"/")}function S(g){return A.getRoot(g).toLowerCase()==="c:/"?g.replace(/^c:[/\\]/i,"/"):g}e.fixDriveC=S}),define(me[275],ge([0,1,38,37,8,103,17,60,33,75,29,10,47,9,11,26,31,273,101]),function(G,e,b,I,T,A,y,P,D,k,i,C,f,m,l,d,E,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const g=new Set;process.on("exit",()=>{g.forEach(o=>o())});class a{constructor(r){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=r,this.filePattern=r.filePattern||"",this.includePattern=r.includePattern&&D.parse(r.includePattern),this.maxResults=r.maxResults||null,this.exists=!!r.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,S.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=r.excludePattern&&D.parse(r.excludePattern),this.folderExcludePatterns=new Map,r.folderQueries.forEach(s=>{const c=Object.assign({},s.excludePattern||{},this.config.excludePattern||{}),h=s.folder.fsPath;r.folderQueries.map(_=>_.folder.fsPath).filter(_=>_!==h).forEach(_=>{(0,i.isEqualOrParent)(_,h)&&(c[T.relative(h,_)]=!0)}),this.folderExcludePatterns.set(h,new t(c,h))})}cancel(){this.isCanceled=!0}walk(r,s,c,h,_){if(this.fileWalkSW=f.StopWatch.create(!1),this.isCanceled)return _(null,this.isLimitHit);s.forEach(u=>{const p=T.basename(u.fsPath);this.globalExcludePattern&&this.globalExcludePattern(u.fsPath,p)||this.matchFile(c,{relativePath:u.fsPath,searchPath:void 0})}),this.cmdSW=f.StopWatch.create(!1),this.parallel(r,(u,p)=>{this.call(this.cmdTraversal,this,u,c,h,R=>{if(R){const O=(0,P.toErrorMessage)(R);console.error(O),this.errors.push(O),p(R,void 0)}else p(null,void 0)})},(u,p)=>{this.fileWalkSW.stop();const R=u?y.coalesce(u)[0]:null;_(R,this.isLimitHit)})}parallel(r,s,c){const h=new Array(r.length),_=new Array(r.length);let u=!1,p=0;if(r.length===0)return c(null,[]);r.forEach((R,O)=>{s(R,(j,ie)=>{if(j?(u=!0,h[O]=null,_[O]=j):(h[O]=ie,_[O]=null),++p===r.length)return c(u?_:null,h)})})}call(r,s,...c){try{r.apply(s,c)}catch(h){c[c.length-1](h)}}cmdTraversal(r,s,c,h){const _=r.folder.fsPath,u=C.isMacintosh;let p;const R=()=>p&&p.kill();g.add(R);let O=L=>{g.delete(R),O=()=>{},h(L)},j="";const ie=this.initDirectoryTree();let K;const x=(0,w.spawnRipgrepCmd)(this.config,r,this.config.includePattern,this.folderExcludePatterns.get(r.folder.fsPath).expression);p=x.cmd,K=!Object.keys(x.siblingClauses).length;const $=x.rgArgs.args.map(L=>L.match(/^-/)?L:`'${L}'`).join(" ");let U=`${x.rgDiskPath} ${$}
 - cwd: ${x.cwd}`;x.rgArgs.siblingClauses&&(U+=`
 - Sibling clauses: ${JSON.stringify(x.rgArgs.siblingClauses)}`),c({message:U}),this.cmdResultCount=0,this.collectStdout(p,"utf8",c,(L,N,M)=>{if(L){O(L);return}if(this.isLimitHit){O();return}const W=(j+(u?k.normalizeNFC(N||""):N)).split(`
`);if(M){const q=W.length;W[q-1]=W[q-1].trim(),W[q-1]||W.pop()}else j=W.pop()||"";if(W.length&&W[0].indexOf(`
`)!==-1){O(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=W.length,K){for(const q of W)if(this.matchFile(s,{base:_,relativePath:q,searchPath:this.getSearchPath(r,q)}),this.isLimitHit){R();break}(M||this.isLimitHit)&&O();return}this.addDirectoryEntries(r,ie,_,W,s),M&&(this.matchDirectoryTree(ie,_,s),O())})}spawnFindCmd(r){const s=this.folderExcludePatterns.get(r.folder.fsPath),c=s.getBasenameTerms(),h=s.getPathTerms(),_=["-L","."];if(c.length||h.length){_.push("-not","(","(");for(const u of c)_.push("-name",u),_.push("-o");for(const u of h)_.push("-path",u),_.push("-o");_.pop(),_.push(")","-prune",")")}return _.push("-type","f"),b.spawn("find",_,{cwd:r.folder.fsPath})}readStdout(r,s,c){let h="";this.collectStdout(r,s,()=>{},(_,u,p)=>{if(_){c(_);return}h+=u,p&&c(null,h)})}collectStdout(r,s,c,h){let _=(R,O,j)=>{(R||j)&&(_=()=>{},this.cmdSW&&this.cmdSW.stop()),h(R,O,j)},u=!1;r.stdout?(this.forwardData(r.stdout,s,_),r.stdout.once("data",()=>u=!0)):c({message:"stdout is null"});let p;r.stderr?p=this.collectData(r.stderr):c({message:"stderr is null"}),r.on("error",R=>{_(R)}),r.on("close",R=>{let O;!u&&(O=this.decodeData(p,s))&&n(O)?_(new Error(`command failed with error code ${R}: ${this.decodeData(p,s)}`)):(this.exists&&R===0&&(this.isLimitHit=!0),_(null,"",!0))})}forwardData(r,s,c){const h=new A.StringDecoder(s);return r.on("data",_=>{c(null,h.write(_))}),h}collectData(r){const s=[];return r.on("data",c=>{s.push(c)}),s}decodeData(r,s){const c=new A.StringDecoder(s);return r.map(h=>c.write(h)).join("")}initDirectoryTree(){const r={rootEntries:[],pathToEntries:Object.create(null)};return r.pathToEntries["."]=r.rootEntries,r}addDirectoryEntries(r,{pathToEntries:s},c,h,_){h.indexOf(this.filePattern)!==-1&&this.matchFile(_,{base:c,relativePath:this.filePattern,searchPath:this.getSearchPath(r,this.filePattern)});const u=p=>{const R=T.basename(p),O=T.dirname(p);let j=s[O];j||(j=s[O]=[],u(O)),j.push({base:c,relativePath:p,basename:R,searchPath:this.getSearchPath(r,p)})};h.forEach(u)}matchDirectoryTree({rootEntries:r,pathToEntries:s},c,h){const _=this,u=this.folderExcludePatterns.get(c),p=this.filePattern;function R(O){_.directoriesWalked++;const j=D.hasSiblingFn(()=>O.map(ie=>ie.basename));for(let ie=0,K=O.length;ie<K;ie++){const x=O[ie],{relativePath:$,basename:U}=x;if(!u.test($,U,p!==U?j:void 0)){const L=s[$];if(L)R(L);else{if(_.filesWalked++,$===p)continue;_.matchFile(h,x)}if(_.isLimitHit)break}}}R(r)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(r,s,c,h,_){const u=r.folder,p=D.hasSiblingFn(()=>c);this.parallel(c,(R,O)=>{if(this.isCanceled||this.isLimitHit)return O(null);const j=s?[s,R].join(T.sep):R;if(this.folderExcludePatterns.get(r.folder.fsPath).test(j,R,this.config.filePattern!==R?p:void 0))return O(null);const ie=[u.fsPath,j].join(T.sep);I.lstat(ie,(K,x)=>{if(K||this.isCanceled||this.isLimitHit)return O(null);this.statLinkIfNeeded(ie,x,($,U)=>$||this.isCanceled||this.isLimitHit?O(null):U.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(ie,x,(L,N)=>L||this.isCanceled||this.isLimitHit||(N=N||"",this.walkedPaths[N])?O(null):(this.walkedPaths[N]=!0,(0,d.readdir)(ie).then(M=>{if(this.isCanceled||this.isLimitHit)return O(null);this.doWalk(r,j,M,h,F=>O(F||null))},M=>{O(null)})))):(this.filesWalked++,j===this.filePattern||this.maxFilesize&&l.isNumber(U.size)&&U.size>this.maxFilesize||this.matchFile(h,{base:u.fsPath,relativePath:j,searchPath:this.getSearchPath(r,j)}),O(null,void 0)))})},R=>{const O=R&&y.coalesce(R);return _(O&&O.length>0?O[0]:void 0)})}matchFile(r,s){this.isFileMatch(s)&&(!this.includePattern||this.includePattern(s.relativePath,T.basename(s.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||r(s))}isFileMatch(r){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,E.isFilePatternMatch)(r,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(r,s,c){return s.isSymbolicLink()?I.stat(r,c):c(null,s)}realPathIfNeeded(r,s,c){return s.isSymbolicLink()?I.realpath(r,(h,_)=>h?c(h):c(null,_)):c(null,r)}getSearchPath(r,s){return r.folderName?T.join(r.folderName,s):s}}e.FileWalker=a;class v{constructor(r){this.folderQueries=r.folderQueries,this.extraFiles=r.extraFileResources||[],this.walker=new a(r)}search(r,s,c){this.walker.walk(this.folderQueries,this.extraFiles,r,s,(h,_)=>{c(h,{limitHit:_,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=v;class t{constructor(r,s){this.expression=r,this.root=s,this.init(r)}init(r){let s,c;Object.keys(r).filter(h=>r[h]).forEach(h=>{T.isAbsolute(h)?(s=s||D.getEmptyExpression(),s[h]=r[h]):(c=c||D.getEmptyExpression(),c[h]=r[h])}),this.absoluteParsedExpr=s&&D.parse(s,{trimForExclusions:!0}),this.relativeParsedExpr=c&&D.parse(c,{trimForExclusions:!0})}test(r,s,c){return this.relativeParsedExpr&&this.relativeParsedExpr(r,s,c)||this.absoluteParsedExpr&&this.absoluteParsedExpr(T.join(this.root,r),s,c)}getBasenameTerms(){const r=[];return this.absoluteParsedExpr&&r.push(...D.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&r.push(...D.getBasenameTerms(this.relativeParsedExpr)),r}getPathTerms(){const r=[];return this.absoluteParsedExpr&&r.push(...D.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&r.push(...D.getPathTerms(this.relativeParsedExpr)),r}}function n(o){const r=o.trim().split(`
`),s=r[0].trim();if(s.startsWith("Error parsing regex"))return s;if(s.startsWith("regex parse error"))return m.uppercaseFirstLetter(r[r.length-1].trim());if(s.startsWith("error parsing glob")||s.startsWith("unsupported encoding"))return s.charAt(0).toUpperCase()+s.substr(1);if(s==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(s.startsWith("Literal "))return s}e.rgErrorMsgForDisplay=n}),define(me[131],ge([0,1,38,289,103,17,53,33,8,9,2,31,67,290,274,94]),function(G,e,b,I,T,A,y,P,D,k,i,C,f,m,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const E=l.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class w{constructor(u){this.outputChannel=u}provideTextSearchResults(u,p,R,O){return this.outputChannel.appendLine(`provideTextSearchResults ${u.pattern}, ${JSON.stringify(Object.assign(Object.assign({},p),{folder:p.folder.toString()}))}`),new Promise((j,ie)=>{O.onCancellationRequested(()=>F());const K=n(u,p),x=p.folder.fsPath,$=K.map(ve=>ve.match(/^-/)?ve:`'${ve}'`).join(" ");this.outputChannel.appendLine(`${E} ${$}
 - cwd: ${x}`);let U=b.spawn(E,K,{cwd:x});U.on("error",ve=>{console.error(ve),this.outputChannel.appendLine("Error: "+(ve&&ve.message)),ie((0,C.serializeSearchError)(new C.SearchError(ve&&ve.message,C.SearchErrorCode.rgProcessError)))});let L=!1;const N=new a(p.maxResults,x,p.previewOptions);N.on("result",ve=>{L=!0,q="",R.report(ve)});let M=!1;const F=()=>{M=!0,U&&U.kill(),N&&N.cancel()};let W=!1;N.on("hitLimit",()=>{W=!0,F()});let q="";U.stdout.on("data",ve=>{N.handleData(ve),L||(q+=ve)});let Q=!1;U.stdout.once("data",()=>Q=!0);let le="";U.stderr.on("data",ve=>{const Re=ve.toString();this.outputChannel.appendLine(Re),le+=Re}),U.on("close",()=>{if(this.outputChannel.appendLine(Q?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(L?"Got result from parser":"No result from parser"),q&&this.outputChannel.appendLine(`Got data without result: ${q}`),this.outputChannel.appendLine(""),M)j({limitHit:W});else{N.flush(),U=null;let ve;le&&!Q&&(ve=S(le))?ie((0,C.serializeSearchError)(new C.SearchError(ve.message,ve.code))):j({limitHit:W})}})})}}e.RipgrepTextSearchEngine=w;function S(_){const u=_.split(`
`),p=u[0].trim();if(u.some(O=>O.startsWith("regex parse error")))return new C.SearchError(g(u),C.SearchErrorCode.regexParseError);const R=p.match(/grep config error: unknown encoding: (.*)/);if(R)return new C.SearchError(`Unknown encoding: ${R[1]}`,C.SearchErrorCode.unknownEncoding);if(p.startsWith("error parsing glob"))return new C.SearchError(p.charAt(0).toUpperCase()+p.substr(1),C.SearchErrorCode.globParseError);if(p.startsWith("the literal"))return new C.SearchError(p.charAt(0).toUpperCase()+p.substr(1),C.SearchErrorCode.invalidLiteral);if(p.startsWith("PCRE2: error compiling pattern"))return new C.SearchError(p,C.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=S;function g(_){const u=["Regex parse error"],p=_.filter(R=>R.startsWith("PCRE2:"));if(p.length>=1){const R=p[0].replace("PCRE2:","");if(R.indexOf(":")!==-1&&R.split(":").length>=2){const O=R.split(":")[1];u.push(":"+O)}}return u.join("")}e.buildRegexParseError=g;class a extends I.EventEmitter{constructor(u,p,R){super();this.maxResults=u,this.rootFolder=p,this.previewOptions=R,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new T.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(u,p){return super.on(u,p),this}handleData(u){if(!this.isDone){const p=typeof u=="string"?u:this.stringDecoder.write(u);this.handleDecodedData(p)}}handleDecodedData(u){let p=u.indexOf(`
`);const R=this.remainder+u;if(p>=0)p+=this.remainder.length;else{this.remainder=R;return}let O=0;for(;p>=0;)this.handleLine(R.substring(O,p).trim()),O=p+1,p=R.indexOf(`
`,O);this.remainder=R.substring(O)}handleLine(u){if(!(this.isDone||!u)){let p;try{p=JSON.parse(u)}catch(R){throw new Error(`malformed line from rg: ${u}`)}if(p.type==="match"){const R=v(p.data.path),O=i.URI.file(D.join(this.rootFolder,R)),j=this.createTextSearchMatch(p.data,O);this.onResult(j),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(p.type==="context"){const R=v(p.data.path),O=i.URI.file(D.join(this.rootFolder,R));this.createTextSearchContext(p.data,O).forEach(ie=>this.onResult(ie))}}}createTextSearchMatch(u,p){const R=u.line_number-1;let O=!1,j=v(u.lines);R===0&&(0,k.startsWithUTF8BOM)(j)&&(O=!0,j=(0,k.stripUTF8BOM)(j));const ie=Buffer.from(j);let K=0,x=0,$=R;u.submatches.length===0&&u.submatches.push(j.length?{start:0,end:1,match:{text:j[0]}}:{start:0,end:0,match:{text:""}});const U=(0,A.coalesce)(u.submatches.map((L,N)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);let M=v(L.match);R===0&&N===0&&O&&(M=(0,k.stripUTF8BOM)(M),L.start=L.start<=3?0:L.start-3,L.end=L.end<=3?0:L.end-3);const F=ie.slice(K,L.start).toString().length,W=x+F,q=t(M),Q=$,le=q.numLines+Q,ve=q.numLines>0?q.lastLineLength:q.lastLineLength+W;return K=L.end,x=ve,$=le,new f.Range(Q,W,le,ve)}));return(0,d.createTextSearchResult)(p,j,U,this.previewOptions)}createTextSearchContext(u,p){const R=v(u.lines),O=u.line_number;return R.replace(/\r?\n$/,"").split(`
`).map((j,ie)=>({text:j,uri:p,lineNumber:O+ie}))}onResult(u){this.emit("result",u)}}e.RipgrepParser=a;function v(_){return _.bytes?Buffer.from(_.bytes,"base64").toString():_.text}function t(_){const u=/\n/g;let p=0,R=-1,O;for(;O=u.exec(_);)p++,R=O.index;const j=R>=0?_.length-R-1:_.length;return{numLines:p,lastLineLength:j}}function n(_,u){const p=["--hidden"];p.push(_.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:R,otherIncludes:O}=(0,y.groupBy)(u.includes,ie=>ie.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(O&&O.length){const ie=new Set;O.forEach(K=>{ie.add(K)}),p.push("-g","!*"),ie.forEach(K=>{o(K).map(d.anchorGlob).forEach(x=>{p.push("-g",x)})})}R&&R.length&&R.forEach(ie=>{p.push("-g",ie)}),u.excludes.map(d.anchorGlob).forEach(ie=>p.push("-g",`!${ie}`)),u.maxFileSize&&p.push("--max-filesize",u.maxFileSize+""),u.useIgnoreFiles?p.push("--no-ignore-parent"):p.push("--no-ignore"),u.followSymlinks&&p.push("--follow"),u.encoding&&u.encoding!=="utf8"&&p.push("--encoding",u.encoding),_.pattern==="--"&&(_.isRegExp=!0,_.pattern="\\-\\-"),_.isMultiline&&!_.isRegExp&&(_.pattern=(0,k.escapeRegExpCharacters)(_.pattern),_.isRegExp=!0),u.usePCRE2&&p.push("--pcre2"),p.push("--crlf"),_.isRegExp&&(_.pattern=r(_.pattern),p.push("--auto-hybrid-regex"));let j;if(_.isWordMatch){const K=(0,k.createRegExp)(_.pattern,!!_.isRegExp,{wholeWord:_.isWordMatch}).source.replace(/\\\//g,"/");p.push("--regexp",K)}else if(_.isRegExp){let ie=c(_.pattern);ie=h(ie),p.push("--regexp",ie)}else j=_.pattern,p.push("--fixed-strings");return p.push("--no-config"),u.useGlobalIgnoreFiles||p.push("--no-ignore-global"),p.push("--json"),_.isMultiline&&p.push("--multiline"),u.beforeContext&&p.push("--before-context",u.beforeContext+""),u.afterContext&&p.push("--after-context",u.afterContext+""),p.push("--"),j&&p.push(j),p.push("."),p}function o(_){const u=(0,P.splitGlobAware)(_,"/");return u.map((p,R)=>u.slice(0,R+1).join("/"))}e.spreadGlobComponents=o;function r(_){const u=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;_.match(u);)_=_.replace(u,"$1\\x{$2}");const p=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;_.match(p);)_=_.replace(p,"$1\\x{$2}");return _}e.unicodeEscapesToPCRE2=r;const s=_=>_.type==="Assertion"&&_.kind==="lookbehind";function c(_){let u;try{u=new m.RegExpParser().parsePattern(_)}catch(K){return _}let p="",R=0;const O=(K,x,$)=>{p+=_.slice(R,K)+$,R=x},j=[];return new m.RegExpVisitor({onCharacterEnter(K){if(K.raw==="\\n"){const x=j[0];if(!x)O(K.start,K.end,"\\r?\\n");else if(!j.some(s))if(x.type==="CharacterClass")if(x.negate){const $=_.slice(x.start+2,K.start)+_.slice(K.end,x.end-1);O(x.start,x.end,"(?!\\r?\\n"+($?`|[${$}]`:"")+")")}else{const $=_.slice(x.start+1,K.start)+_.slice(K.end,x.end-1);O(x.start,x.end,$===""?"\\r?\\n":`(?:[${$}]|\\r?\\n)`)}else x.type==="Quantifier"&&O(K.start,K.end,"(?:\\r?\\n)")}},onQuantifierEnter(K){j.unshift(K)},onQuantifierLeave(){j.shift()},onCharacterClassRangeEnter(K){j.unshift(K)},onCharacterClassRangeLeave(){j.shift()},onCharacterClassEnter(K){j.unshift(K)},onCharacterClassLeave(){j.shift()},onAssertionEnter(K){s(K)&&j.push(K)},onAssertionLeave(K){j[0]===K&&j.shift()}}).visit(u),p+=_.slice(R),p}e.fixRegexNewline=c;function h(_){return _.replace(/\n/g,"\\r?\\n")}e.fixNewline=h}),define(me[276],ge([0,1,21,131,116,12]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class y{constructor(k){this.outputChannel=k,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(k,i,C,f){const m=new I.RipgrepTextSearchEngine(this.outputChannel);if(i.folder.scheme===A.Schemas.userData){const l=Object.assign(Object.assign({},i),{folder:i.folder.with({scheme:A.Schemas.file})}),d=new T.Progress(E=>C.report(Object.assign(Object.assign({},E),{uri:E.uri.with({scheme:i.folder.scheme})})));return this.withToken(f,E=>m.provideTextSearchResults(k,l,d,E))}else return this.withToken(f,l=>m.provideTextSearchResults(k,i,C,l))}async withToken(k,i){const C=P(k);this.inProgress.add(C);const f=await i(C.token);return this.inProgress.delete(C),f}dispose(){this.inProgress.forEach(k=>k.cancel())}}e.RipgrepSearchProvider=y;function P(D){const k=new b.CancellationTokenSource;return D.onCancellationRequested(()=>k.cancel()),k}}),define(me[277],ge([0,1,26,131,130]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class A{constructor(D){this.query=D}search(D,k,i){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(m){i({message:m})}},f=new T.NativeTextSearchManager(this.query,new I.RipgrepTextSearchEngine(C),b);return new Promise((m,l)=>f.search(d=>{k(d.map(y))},D).then(d=>m({limitHit:d.limitHit,type:"success"}),l))}}e.TextSearchEngineAdapter=A;function y(P){return{path:P.resource&&P.resource.fsPath,results:P.results,numMatches:(P.results||[]).reduce((D,k)=>{if(k.ranges){const i=k;return D+(Array.isArray(i.ranges)?i.ranges.length:1)}else return D+1},0)}}}),define(me[278],ge([0,1,37,291,17,13,16,3,101,8,47,2,45,31,275,277]),function(G,e,b,I,T,A,y,P,D,k,i,C,f,m,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,I.gracefulify(b);class E{constructor(){this.caches=Object.create(null)}fileSearch(t){let n;const o=g(t),r=new P.Emitter({onFirstListenerDidAdd:()=>{n=(0,A.createCancelablePromise)(s=>this.doFileSearchWithEngine(l.Engine,o,c=>r.fire(c),s)),n.then(s=>r.fire(s),s=>r.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onLastListenerRemove:()=>{n.cancel()}});return r.event}textSearch(t){let n;const o=g(t),r=new P.Emitter({onFirstListenerDidAdd:()=>{n=(0,A.createCancelablePromise)(s=>this.ripgrepTextSearch(o,c=>r.fire(c),s)),n.then(s=>r.fire(s),s=>r.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onLastListenerRemove:()=>{n.cancel()}});return r.event}ripgrepTextSearch(t,n,o){return t.maxFileSize=(0,f.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new d.TextSearchEngineAdapter(t).search(o,n,n)}doFileSearch(t,n,o){return this.doFileSearchWithEngine(l.Engine,t,n,o)}doFileSearchWithEngine(t,n,o,r,s=E.BATCH_SIZE){let c=0;const h=u=>{Array.isArray(u)?(c+=u.length,o(u.map(p=>this.rawMatchToSearchItem(p)))):u.relativePath?(c++,o(this.rawMatchToSearchItem(u))):o(u)};if(n.sortByScore){let u=this.trySortedSearchFromCache(n,h,r);if(!u){const p=n.maxResults?Object.assign({},n,{maxResults:null}):n,R=new t(p);u=this.doSortedSearch(R,n,o,h,r)}return new Promise((p,R)=>{u.then(([O,j])=>{const ie=j.map(K=>this.rawMatchToSearchItem(K));this.sendProgress(ie,o,s),p(O)},R)})}const _=new t(n);return this.doSearch(_,h,s,r).then(u=>({limitHit:u.limitHit,type:"success",stats:{detailStats:u.stats,type:"searchProcess",fromCache:!1,resultCount:c,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,k.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,n,o,r,s){const c=new P.Emitter;let h=(0,A.createCancelablePromise)(u=>{let p=[];const R=O=>{Array.isArray(O)?p=O:(r(O),c.fire(O))};return this.doSearch(t,R,-1,u).then(O=>[O,p])}),_;if(n.cacheKey){_=this.getOrCreateCache(n.cacheKey);const u={promise:h,event:c.event,resolved:!1};_.resultsToSearchCache[n.filePattern||""]=u,h.then(()=>{u.resolved=!0},p=>{delete _.resultsToSearchCache[n.filePattern||""]}),h=this.preventCancellation(h)}return h.then(([u,p])=>{const R=_?_.scorerCache:Object.create(null),O=(typeof n.maxResults!="number"||n.maxResults>0)&&i.StopWatch.create(!1);return this.sortResults(n,p,R,s).then(j=>{const ie=O?O.elapsed():-1;return[{type:"success",stats:{detailStats:u.stats,sortingTime:ie,fromCache:!1,type:"searchProcess",workspaceFolderCount:n.folderQueries.length,resultCount:j.length},messages:u.messages,limitHit:u.limitHit||typeof n.maxResults=="number"&&p.length>n.maxResults},j]})})}getOrCreateCache(t){const n=this.caches[t];return n||(this.caches[t]=new w)}trySortedSearchFromCache(t,n,o){const r=t.cacheKey&&this.caches[t.cacheKey];if(!!r){const s=this.getResultsFromCache(r,t.filePattern||"",n,o);if(s)return s.then(([c,h,_])=>{const u=i.StopWatch.create(!1);return this.sortResults(t,h,r.scorerCache,o).then(p=>{const R=u.elapsed(),O={fromCache:!0,detailStats:_,type:"searchProcess",resultCount:h.length,sortingTime:R};return[{type:"success",limitHit:c.limitHit||typeof t.maxResults=="number"&&h.length>t.maxResults,stats:O},p]})})}}sortResults(t,n,o,r){const s=(0,D.prepareQuery)(t.filePattern||""),c=(_,u)=>(0,D.compareItemsByFuzzyScore)(_,u,s,!0,S,o),h=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return T.topAsync(n,c,h,1e4,r)}sendProgress(t,n,o){if(o&&o>0)for(let r=0;r<t.length;r+=o)n(t.slice(r,r+o));else n(t)}getResultsFromCache(t,n,o,r){const s=i.StopWatch.create(!1),c=n.indexOf(k.sep)>=0;let h;for(const R in t.resultsToSearchCache)if(n.startsWith(R)){if(c&&R.indexOf(k.sep)<0&&R!=="")continue;const O=t.resultsToSearchCache[R];h={promise:this.preventCancellation(O.promise),event:O.event,resolved:O.resolved};break}if(!h)return null;const _=s.elapsed(),u=i.StopWatch.create(!1),p=h.event(o);return r&&r.onCancellationRequested(()=>{p.dispose()}),h.promise.then(([R,O])=>{if(r&&r.isCancellationRequested)throw(0,y.canceled)();const j=[],ie=(0,D.prepareQuery)(n).normalizedLowercase;for(const K of O)!(0,m.isFilePatternMatch)(K,ie)||j.push(K);return[R,j,{cacheWasResolved:h.resolved,cacheLookupTime:_,cacheFilterTime:u.elapsed(),cacheEntryCount:O.length}]})}doSearch(t,n,o,r){return new Promise((s,c)=>{let h=[];r&&r.onCancellationRequested(()=>t.cancel()),t.search(_=>{_&&(o?(h.push(_),o>0&&h.length>=o&&(n(h),h=[])):n(_))},_=>{n(_)},(_,u)=>{h.length&&n(h),_?c(_):s(u)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(n,o){return t.then(n,o)}catch(n){return this.then(void 0,n)}finally(n){return t.finally(n)}}}}e.SearchService=E,E.BATCH_SIZE=512;class w{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const S=new class{getItemLabel(v){return(0,k.basename)(v.relativePath)}getItemDescription(v){return(0,k.dirname)(v.relativePath)}getItemPath(v){return v.relativePath}};function g(v){return Object.assign(Object.assign({},v),{folderQueries:v.folderQueries&&v.folderQueries.map(a),extraFileResources:v.extraFileResources&&v.extraFileResources.map(t=>C.URI.revive(t))})}function a(v){return Object.assign(Object.assign({},v),{folder:C.URI.revive(v.folder)})}}),define(me[279],ge([0,1,6,2,26,14,31,278,276,94,15,63,28,70,12,130]),function(G,e,b,I,T,A,y,P,D,k,i,C,f,m,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let E=class extends m.ExtHostSearch{constructor(S,g,a,v){super(S,a,v);this._pfs=T,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new k.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(l.Schemas.userData,new D.RipgrepSearchProvider(t)),g.remote.isRemote&&g.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const S=new k.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(l.Schemas.file,new D.RipgrepSearchProvider(S)),this.registerInternalFileSearchProvider(l.Schemas.file,new P.SearchService)}registerInternalFileSearchProvider(S,g){const a=this._handlePool++;return this._internalFileSearchProvider=g,this._internalFileSearchHandle=a,this._proxy.$registerFileSearchProvider(a,this._transformScheme(S)),(0,b.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(a)})}$provideFileSearchResults(S,g,a,v){const t=(0,m.reviveQuery)(a);return S===this._internalFileSearchHandle?this.doInternalFileSearch(S,g,t,v):super.$provideFileSearchResults(S,g,a,v)}doInternalFileSearch(S,g,a,v){const t=n=>{if((0,y.isSerializedFileMatch)(n)&&(n=[n]),Array.isArray(n)){this._proxy.$handleFileMatch(S,g,n.map(o=>I.URI.file(o.path)));return}n.message&&this._logService.debug("ExtHostSearch",n.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(a,t,v)}$clearCache(S){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(S),super.$clearCache(S)}createTextSearchManager(S,g){return new d.NativeTextSearchManager(S,g)}};E=qe([He(0,i.IExtHostRpcService),He(1,f.IExtHostInitDataService),He(2,C.IURITransformerService),He(3,A.ILogService)],E),e.NativeExtHostSearch=E}),define(me[132],ge([0,1,292,123,293,3,106,8,48,30,6,23,107,16,10]),function(G,e,b,I,T,A,y,P,D,k,i,C,f,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class d{constructor(h){this.socket=h,this._errorListener=_=>{if(_){if(_.code==="EPIPE")return;(0,m.onUnexpectedError)(_)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(h){const _=u=>h(C.VSBuffer.wrap(u));return this.socket.on("data",_),{dispose:()=>this.socket.off("data",_)}}onClose(h){return this.socket.on("close",h),{dispose:()=>this.socket.off("close",h)}}onEnd(h){return this.socket.on("end",h),{dispose:()=>this.socket.off("end",h)}}write(h){if(!this.socket.destroyed)try{this.socket.write(h.buffer,_=>{if(_){if(_.code==="EPIPE")return;(0,m.onUnexpectedError)(_)}})}catch(_){if(_.code==="EPIPE")return;(0,m.onUnexpectedError)(_)}}end(){this.socket.end()}drain(){return new Promise((h,_)=>{if(this.socket.bufferSize===0){h();return}const u=()=>{this.socket.off("close",u),this.socket.off("end",u),this.socket.off("error",u),this.socket.off("timeout",u),this.socket.off("drain",u),h()};this.socket.on("close",u),this.socket.on("end",u),this.socket.on("error",u),this.socket.on("timeout",u),this.socket.on("drain",u)})}}e.NodeSocket=d;var E;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(E||(E={}));var w;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(w||(w={}));class S extends i.Disposable{constructor(h,_,u,p){super();this._onDidZlibFlush=this._register(new A.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new A.Emitter),this._onClose=this._register(new A.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=h,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=_,this._recordInflateBytes=p,_?(this._zlibInflate=T.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",R=>{console.error(R),(0,m.onUnexpectedError)(R),this._onClose.fire()}),this._zlibInflate.on("data",R=>{this._pendingInflateData.push(R)}),u&&(this._zlibInflate.write(u.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=T.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",R=>{console.error(R),(0,m.onUnexpectedError)(R),this._onClose.fire()}),this._zlibDeflate.on("data",R=>{this._pendingDeflateData.push(R)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new f.ChunkStream,this._register(this.socket.onData(R=>this._acceptChunk(R))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):C.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(h){return this._onData.event(h)}onClose(h){return this._onClose.event(h)}onEnd(h){return this.socket.onEnd(h)}write(h){this._totalOutgoingDataBytes+=h.byteLength,this._zlibDeflate?(this._zlibDeflate.write(h.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let _=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,_=_.slice(0,_.length-4),this._isEnded||this._write(C.VSBuffer.wrap(_),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(h,!1)}_write(h,_){let u=2;h.byteLength<126?u+=0:h.byteLength<2**16?u+=2:u+=8;const p=C.VSBuffer.alloc(u);if(_?p.writeUInt8(194,0):p.writeUInt8(130,0),h.byteLength<126)p.writeUInt8(h.byteLength,1);else if(h.byteLength<2**16){p.writeUInt8(126,1);let R=1;p.writeUInt8(h.byteLength>>>8&255,++R),p.writeUInt8(h.byteLength>>>0&255,++R)}else{p.writeUInt8(127,1);let R=1;p.writeUInt8(0,++R),p.writeUInt8(0,++R),p.writeUInt8(0,++R),p.writeUInt8(0,++R),p.writeUInt8(h.byteLength>>>24&255,++R),p.writeUInt8(h.byteLength>>>16&255,++R),p.writeUInt8(h.byteLength>>>8&255,++R),p.writeUInt8(h.byteLength>>>0&255,++R)}this._totalOutgoingWireBytes+=p.byteLength+h.byteLength,this.socket.write(C.VSBuffer.concat([p,h]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(h){if(h.byteLength!==0){for(this._totalIncomingWireBytes+=h.byteLength,this._incomingData.acceptChunk(h);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const _=this._incomingData.peek(this._state.readLen),p=(_.readUInt8(0)&128)>>>7,R=_.readUInt8(1),O=(R&128)>>>7,j=R&127;this._state.state=2,this._state.readLen=2+(O?4:0)+(j===126?2:0)+(j===127?8:0),this._state.fin=p,this._state.mask=0}else if(this._state.state===2){const _=this._incomingData.read(this._state.readLen),u=_.readUInt8(1),p=(u&128)>>>7;let R=u&127,O=1;R===126?R=_.readUInt8(++O)*2**8+_.readUInt8(++O):R===127&&(R=_.readUInt8(++O)*0+_.readUInt8(++O)*0+_.readUInt8(++O)*0+_.readUInt8(++O)*0+_.readUInt8(++O)*2**24+_.readUInt8(++O)*2**16+_.readUInt8(++O)*2**8+_.readUInt8(++O));let j=0;p&&(j=_.readUInt8(++O)*2**24+_.readUInt8(++O)*2**16+_.readUInt8(++O)*2**8+_.readUInt8(++O)),this._state.state=3,this._state.readLen=R,this._state.mask=j}else if(this._state.state===3){const _=this._incomingData.read(this._state.readLen);g(_,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(_.buffer)),this._zlibInflate.write(_.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const u=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=u.length,this._onData.fire(C.VSBuffer.wrap(u))})):(this._totalIncomingDataBytes+=_.byteLength,this._onData.fire(_))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await A.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=S;function g(c,h){if(h!==0){let _=c.byteLength>>>2;for(let ie=0;ie<_;ie++){const K=c.readUInt32BE(ie*4);c.writeUInt32BE(K^h,ie*4)}let u=_*4,p=c.byteLength-u;const R=h>>>24&255,O=h>>>16&255,j=h>>>8&255;p>=1&&c.writeUInt8(c.readUInt8(u)^R,u),p>=2&&c.writeUInt8(c.readUInt8(u+1)^O,u+1),p>=3&&c.writeUInt8(c.readUInt8(u+2)^j,u+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function v(){const c=(0,k.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let h;return e.XDG_RUNTIME_DIR?h=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):h=(0,P.join)((0,D.tmpdir)(),`vscode-ipc-${c}.sock`),n(h),h}e.createRandomIPCHandle=v;function t(c,h,_){const u=(0,b.createHash)("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${u}-${_}-${h}-sock`;let p;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?p=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${u.substr(0,8)}-${_}-${h}.sock`):p=(0,P.join)(c,`${_}-${h}.sock`),n(p),p}e.createStaticIPCHandle=t;function n(c){const h=a[l.platform];typeof h=="number"&&c.length>=h&&console.warn(`WARNING: IPC handle "${c}" is longer than ${h} chars, try a shorter --user-data-dir`)}class o extends y.IPCServer{constructor(h){super(o.toClientConnectionEvent(h));this.server=h}static toClientConnectionEvent(h){const _=A.Event.fromNodeEventEmitter(h,"connection");return A.Event.map(_,u=>({protocol:new f.Protocol(new d(u)),onDidClientDisconnect:A.Event.once(A.Event.fromNodeEventEmitter(u,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function r(c){return new Promise((h,_)=>{const u=(0,I.createServer)();u.on("error",_),u.listen(c,()=>{u.removeListener("error",_),h(new o(u))})})}e.serve=r;function s(c,h){return new Promise((_,u)=>{const p=(0,I.createConnection)(c,()=>{p.removeListener("error",u),_(f.Client.fromSocket(new d(p),h))});p.once("error",u)})}e.connect=s}),define(me[280],ge([0,1,132,272,37,51,2,119,14]),function(G,e,b,I,T,A,y,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class k{constructor(f,m,l){this._commands=f,this.logService=m,this._ipcHandlePath=l,this._server=I.createServer((d,E)=>this.onRequest(d,E)),this.setup().catch(d=>(m.error(d),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",f=>this.logService.error(f))}catch(f){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(f,m){const l=[];f.setEncoding("utf8"),f.on("data",d=>l.push(d)),f.on("end",()=>{const d=JSON.parse(l.join(""));switch(d.type){case"open":this.open(d,m);break;case"openExternal":this.openExternal(d,m);break;case"status":this.getStatus(d,m);break;case"extensionManagement":this.manageExtensions(d,m).catch(this.logService.error);break;default:m.writeHead(404),m.write(`Unknown message type: ${d.type}`,E=>{E&&this.logService.error(E)}),m.end();break}})}open(f,m){let{fileURIs:l,folderURIs:d,forceNewWindow:E,diffMode:w,addMode:S,forceReuseWindow:g,gotoLineMode:a,waitMarkerFilePath:v}=f;const t=[];if(Array.isArray(d))for(const n of d)try{t.push({folderUri:y.URI.parse(n)})}catch(o){}if(Array.isArray(l))for(const n of l)try{(0,P.hasWorkspaceFileExtension)(n)?t.push({workspaceUri:y.URI.parse(n)}):t.push({fileUri:y.URI.parse(n)})}catch(o){}if(t.length){const n=v?y.URI.file(v):void 0,r={forceNewWindow:E,diffMode:w,addMode:S,gotoLineMode:a,forceReuseWindow:g,preferNewWindow:!g&&!n&&!S,waitMarkerFileURI:n};this._commands.executeCommand("_remoteCLI.windowOpen",t,r)}m.writeHead(200),m.end()}async openExternal(f,m){for(const l of f.uris){const d=y.URI.parse(l),E=d.scheme==="file"?d:l;await this._commands.executeCommand("_remoteCLI.openExternal",E)}m.writeHead(200),m.end()}async manageExtensions(f,m){try{const l=w=>w==null?void 0:w.map(S=>/\.vsix$/i.test(S)?y.URI.parse(S):S),d={list:f.list,install:l(f.install),uninstall:l(f.uninstall),force:f.force},E=await this._commands.executeCommand("_remoteCLI.manageExtensions",d);m.writeHead(200),m.write(E)}catch(l){m.writeHead(500),m.write(String(l),d=>{d&&this.logService.error(d)})}m.end()}async getStatus(f,m){try{const l=await this._commands.executeCommand("_remoteCLI.getSystemStatus");m.writeHead(200),m.write(l),m.end()}catch(l){m.writeHead(500),m.write(String(l),d=>{d&&this.logService.error(d)}),m.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&T.existsSync(this._ipcHandlePath)&&T.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=k;let i=class extends k{constructor(f,m){super(f,m,(0,b.createRandomIPCHandle)())}};i=qe([He(0,A.IExtHostCommands),He(1,D.ILogService)],i),e.CLIServer=i}),define(me[281],ge([0,1,69,268,262,5,271,42,253,2,12,7,280,104]),function(G,e,b,I,T,A,y,P,D,k,i,C,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class l extends T.RequireInterceptor{_installInterceptor(){const w=this,S=G.__$__nodeRequire("module"),g=S._load;S._load=function(v,t,n){for(let o of w._alternatives){let r=o(v);if(r){v=r;break}}return w._factories.has(v)?w._factories.get(v).load(v,k.URI.file((0,m.realpathSync)(t.filename)),o=>g.apply(this,[o,t,n])):g.apply(this,arguments)}}}class d extends P.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=C.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const w=this._instaService.invokeFunction(I.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(D.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(f.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(l,w,this._registry).install(),b.mark("code/extHost/didInitAPI");const g=await this._extHostConfiguration.getConfigProvider();await(0,y.connectProxyResolver)(this._extHostWorkspace,g,this,this._logService,this._mainThreadTelemetryProxy,this._initData),b.mark("code/extHost/didInitProxyResolver");const a=process.send,v=this._extHostContext.getProxy(A.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?a.apply(process,t):(v.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(w){return w.main}_loadCommonJSModule(w,S,g){if(S.scheme!==i.Schemas.file)throw new Error(`Cannot load URI: '${S}', must be of file-scheme`);let a=null;g.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${S.toString(!0)}`),this._logService.flush();try{w&&b.mark(`code/extHost/willLoadExtensionCode/${w.value}`),a=G.__$__nodeRequire(S.fsPath)}catch(v){return Promise.reject(v)}finally{w&&b.mark(`code/extHost/didLoadExtensionCode/${w.value}`),g.codeLoadingStop()}return Promise.resolve(a)}async $setRemoteEnvironment(w){if(!!this._initData.remote.isRemote)for(const S in w){const g=w[S];g===null?delete process.env[S]:process.env[S]=g}}}e.ExtHostExtensionService=d}),define(me[282],ge([0,1,79,254,265,264,263,279,281,225,255,46,42,65,70,68,34,50,14]),function(G,e,b,I,T,A,y,P,D,k,i,C,f,m,l,d,E,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,b.registerSingleton)(f.IExtHostExtensionService,D.ExtHostExtensionService),(0,b.registerSingleton)(S.ILogService,k.ExtHostLogService),(0,b.registerSingleton)(C.IExtHostDebugService,y.ExtHostDebugService),(0,b.registerSingleton)(m.IExtHostOutputService,I.ExtHostOutputService2),(0,b.registerSingleton)(l.IExtHostSearch,P.NativeExtHostSearch),(0,b.registerSingleton)(d.IExtHostTask,A.ExtHostTask),(0,b.registerSingleton)(E.IExtHostTerminalService,T.ExtHostTerminalService),(0,b.registerSingleton)(w.IExtHostTunnelService,i.ExtHostTunnelService)}),define(me[283],ge([0,1,123,294,69,16,107,132,187,223,266,23,102,26,104,13,269,282]),function(G,e,b,I,T,A,y,P,D,k,i,C,f,m,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let r=0;r<process.execArgv.length;r++)process.execArgv[r]==="--inspect-port=0"&&(process.execArgv.splice(r,1),r--)}();const E=I(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"]});(function(){const o=G.__$__nodeRequire("module"),r=o._load;o._load=function(s){if(s==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return r.apply(this,arguments)}})();const w=process.exit.bind(process);function S(o){process.exit=function(r){if(o)w(r);else{const s=new Error("An extension called process.exit() and this was prevented.");console.warn(s.stack)}},process.crash=function(){const r=new Error("An extension called process.crash() and this was prevented.");console.warn(r.stack)}}let g=function(o){w()};function a(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((o,r)=>{let s=null,c=setTimeout(()=>{g("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const h=108e5,_=3e5,u=new d.RunOnceScheduler(()=>g("renderer disconnected for too long (1)"),h),p=new d.RunOnceScheduler(()=>g("renderer disconnected for too long (2)"),_);process.on("message",(O,j)=>{if(O&&O.type==="VSCODE_EXTHOST_IPC_SOCKET"){const ie=C.VSBuffer.wrap(Buffer.from(O.initialDataChunk,"base64"));let K;if(O.skipWebSocketFrames)K=new P.NodeSocket(j);else{const x=C.VSBuffer.wrap(Buffer.from(O.inflateBytes,"base64"));K=new P.WebSocketNodeSocket(new P.NodeSocket(j),O.permessageDeflate,x,!1)}s?(u.cancel(),p.cancel(),s.beginAcceptReconnection(K,ie),s.endAcceptReconnection()):(clearTimeout(c),s=new y.PersistentProtocol(K,ie),s.onDidDispose(()=>g("renderer disconnected")),o(s),s.onSocketClose(()=>{u.schedule()}))}if(O&&O.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(p.isScheduled())return;u.isScheduled()&&p.schedule()}});const R={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(R)});{const o=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((r,s)=>{const c=b.createConnection(o,()=>{c.removeListener("error",s),r(new y.PersistentProtocol(new P.NodeSocket(c)))});c.once("error",s)})}}async function v(){const o=await a();return new class{constructor(){this._onMessage=new y.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,o.onMessage(r=>{(0,k.isMessageOfType)(r,2)?(this._terminating=!0,g("received terminate message from renderer")):this._onMessage.fire(r)})}send(r){this._terminating||o.send(r)}drain(){return o.drain()}}}function t(o){return new Promise(r=>{const s=o.onMessage(c=>{s.dispose();const h=JSON.parse(c.toString()),_=h.commit,u=D.default.commit;_&&u&&_!==u&&w(55);const p=[];process.on("unhandledRejection",(j,ie)=>{p.push(ie),setTimeout(()=>{const K=p.indexOf(ie);K>=0&&ie.catch(x=>{p.splice(K,1),console.warn(`rejected promise not handled within 1 second: ${x}`),x&&x.stack&&console.warn(`stack trace: ${x.stack}`),(0,A.onUnexpectedError)(j)})},1e3)}),process.on("rejectionHandled",j=>{const ie=p.indexOf(j);ie>=0&&p.splice(ie,1)}),process.on("uncaughtException",function(j){(0,A.onUnexpectedError)(j)});let R=0;setInterval(function(){try{process.kill(h.parentPid,0),R=0}catch(j){j&&j.code==="EPERM"?(R++,R>=3&&g(`parent process ${h.parentPid} does not exist anymore (3 x EPERM): ${j.message} (code: ${j.code}) (errno: ${j.errno})`)):g(`parent process ${h.parentPid} does not exist anymore: ${j.message} (code: ${j.code}) (errno: ${j.errno})`)}},1e3);let O;try{O=G.__$__nodeRequire("native-watchdog"),O.start(h.parentPid)}catch(j){(0,A.onUnexpectedError)(j)}o.send((0,k.createMessageOfType)(0)),r({protocol:o,initData:h})});o.send((0,k.createMessageOfType)(1))})}async function n(){T.mark("code/extHost/willConnectToRenderer");const o=await v();T.mark("code/extHost/didConnectToRenderer");const r=await t(o);T.mark("code/extHost/didWaitForInitData");const{initData:s}=r;S(!!s.environment.extensionTestsLocationURI),s.environment.useHostProxy=E.useHostProxy!==void 0?E.useHostProxy!=="false":void 0;const c=new class{exit(p){w(p)}exists(p){return(0,m.exists)(p)}realpath(p){return(0,l.realpath)(p)}};let h=null;if(s.remote.authority&&E.uriTransformerPath)try{const p=G.__$__nodeRequire(E.uriTransformerPath)(s.remote.authority);h=new f.URITransformer(p)}catch(u){console.error(u)}const _=new i.ExtensionHostMain(r.protocol,s,c,h);g=u=>_.terminate(u)}e.startExtensionHostProcess=n}),define(me[295],ge([0,1,283]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,b.startExtensionHostProcess)().catch(I=>console.log(I))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a19565da7dfc739fa26e36aae96113e19fe3806f/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
