/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ve=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/async","vs/base/common/errors","vs/base/common/path","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/platform/log/common/log","vs/base/common/network","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/map","vs/base/common/objects","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/base/common/uuid","vs/editor/common/core/range","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/extpath","vs/editor/common/core/position","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/iterator","vs/base/common/json","vs/base/common/linkedList","vs/base/common/process","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/uint","vs/base/common/htmlContent","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],be=function(J){for(var e=[],_=0,k=J.length;_<k;_++)e[_]=ve[J[_]];return e};define(ve[42],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function _(k,A){if(!k)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}e.ok=_}),define(ve[51],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupByNumber=e.groupBy=e.forEach=e.values=void 0;const _=Object.prototype.hasOwnProperty;function k(I){const d=[];for(let f in I)_.call(I,f)&&d.push(I[f]);return d}e.values=k;function A(I,d){for(let f in I)if(_.call(I,f)&&d({key:f,value:I[f]},function(){delete I[f]})===!1)return}e.forEach=A;function T(I,d){const f=Object.create(null);for(const r of I){const o=d(r);let p=f[o];p||(p=f[o]=[]),p.push(r)}return f}e.groupBy=T;function y(I,d){const f=new Map;for(const r of I){const o=d(r);let p=f.get(o);p||(p=[],f.set(o,p)),p.push(r)}return f}e.groupByNumber=y;function D(I){const d=Object.create(null);return I&&I.forEach((f,r)=>{d[r]=f}),d}e.fromMap=D;function S(I,d){const f=[],r=[];for(let o of I)d.has(o)||f.push(o);for(let o of d)I.has(o)||r.push(o);return{removed:f,added:r}}e.diffSets=S;function C(I,d){const f=[],r=[];for(let[o,p]of I)d.has(o)||f.push(p);for(let[o,p]of d)I.has(o)||r.push(p);return{removed:f,added:r}}e.diffMaps=C;class i{constructor(){this.map=new Map}add(d,f){let r=this.map.get(d);r||(r=new Set,this.map.set(d,r)),r.add(f)}delete(d,f){const r=this.map.get(d);!r||(r.delete(f),r.size===0&&this.map.delete(d))}forEach(d,f){const r=this.map.get(d);!r||r.forEach(f)}}e.SetMap=i}),define(ve[52],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function _(y){return(D,S,C)=>{let i=null,I=null;if(typeof C.value=="function"?(i="value",I=C.value):typeof C.get=="function"&&(i="get",I=C.get),!I)throw new Error("not supported");C[i]=y(I,S)}}e.createDecorator=_;function k(y,D,S){let C=null,i=null;if(typeof S.value=="function"?(C="value",i=S.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(C="get",i=S.get),!i)throw new Error("not supported");const I=`$memoize$${D}`;S[C]=function(...d){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,d)}),this[I]}}e.memoize=k;function A(y,D,S){return _((C,i)=>{const I=`$debounce$${i}`,d=`$debounce$result$${i}`;return function(...f){this[d]||(this[d]=S?S():void 0),clearTimeout(this[I]),D&&(this[d]=D(this[d],...f),f=[this[d]]),this[I]=setTimeout(()=>{C.apply(this,f),this[d]=S?S():void 0},y)}})}e.debounce=A;function T(y,D,S){return _((C,i)=>{const I=`$throttle$timer$${i}`,d=`$throttle$result$${i}`,f=`$throttle$lastRun$${i}`,r=`$throttle$pending$${i}`;return function(...o){if(this[d]||(this[d]=S?S():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),D&&(this[d]=D(this[d],...o)),!this[r]){const p=this[f]+y;p<=Date.now()?(this[f]=Date.now(),C.apply(this,[this[d]]),this[d]=S?S():void 0):(this[r]=!0,this[I]=setTimeout(()=>{this[r]=!1,this[f]=Date.now(),C.apply(this,[this[d]]),this[d]=S?S():void 0},p-Date.now()))}}})}e.throttle=T}),define(ve[12],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class _{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=_,e.errorHandler=new _;function k(w){e.errorHandler.setUnexpectedErrorHandler(w)}e.setUnexpectedErrorHandler=k;function A(w){S(w)||e.errorHandler.onUnexpectedError(w)}e.onUnexpectedError=A;function T(w){S(w)||e.errorHandler.onUnexpectedExternalError(w)}e.onUnexpectedExternalError=T;function y(w){if(w instanceof Error){let{name:t,message:n}=w;const l=w.stacktrace||w.stack;return{$isError:!0,name:t,message:n,stack:l}}return w}e.transformErrorForSerialization=y;const D="Canceled";function S(w){return w instanceof Error&&w.name===D&&w.message===D}e.isPromiseCanceledError=S;class C extends Error{constructor(){super(D);this.name=this.message}}e.CancellationError=C;function i(){const w=new Error(D);return w.name=w.message,w}e.canceled=i;function I(w){return w?new Error(`Illegal argument: ${w}`):new Error("Illegal argument")}e.illegalArgument=I;function d(w){return w?new Error(`Illegal state: ${w}`):new Error("Illegal state")}e.illegalState=d;function f(w){return w?new Error(`readonly property '${w} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function r(w){const t=new Error(`${w} has been disposed`);return t.name="DISPOSED",t}e.disposed=r;function o(w){return w?w.message?w.message:w.stack?w.stack.split(`
`)[0]:String(w):"Error"}e.getErrorMessage=o;class p extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=p;class g extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=g;class E extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=E;function m(w){const t=w;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=m;function u(w,t=Object.create(null)){const n=new Error(w);return t.actions&&(n.actions=t.actions),n}e.createErrorWithActions=u}),define(ve[15],be([0,1,12]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function k(W,F=0){return W[W.length-(1+F)]}e.tail=k;function A(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.tail2=A;function T(W,F,L=(M,x)=>M===x){if(W===F)return!0;if(!W||!F||W.length!==F.length)return!1;for(let M=0,x=W.length;M<x;M++)if(!L(W[M],F[M]))return!1;return!0}e.equals=T;function y(W,F,L){let M=0,x=W.length-1;for(;M<=x;){const G=(M+x)/2|0,X=L(W[G],F);if(X<0)M=G+1;else if(X>0)x=G-1;else return G}return-(M+1)}e.binarySearch=y;function D(W,F){let L=0,M=W.length;if(M===0)return 0;for(;L<M;){const x=Math.floor((L+M)/2);F(W[x])?M=x:L=x+1}return L}e.findFirstInSorted=D;function S(W,F,L){if(W=W|0,W>=F.length)throw new TypeError("invalid index");let M=F[Math.floor(F.length*Math.random())],x=[],G=[],X=[];for(let ne of F){const me=L(ne,M);me<0?x.push(ne):me>0?G.push(ne):X.push(ne)}return W<x.length?S(W,x,L):W<x.length+X.length?X[0]:S(W-(x.length+X.length),G,L)}e.quickSelect=S;function C(W,F){const L=[];let M;for(const x of W.slice(0).sort(F))!M||F(M[0],x)!==0?(M=[x],L.push(M)):M.push(x);return L}e.groupBy=C;function i(W,F,L){const M=[];function x(ne,me,Le){if(!(me===0&&Le.length===0)){const We=M[M.length-1];We&&We.start+We.deleteCount===ne?(We.deleteCount+=me,We.toInsert.push(...Le)):M.push({start:ne,deleteCount:me,toInsert:Le})}}let G=0,X=0;for(;;){if(G===W.length){x(G,0,F.slice(X));break}if(X===F.length){x(G,W.length-G,[]);break}const ne=W[G],me=F[X],Le=L(ne,me);Le===0?(G+=1,X+=1):Le<0?(x(G,1,[]),G+=1):Le>0&&(x(G,0,[me]),X+=1)}return M}e.sortedDiff=i;function I(W,F,L){const M=i(W,F,L),x=[],G=[];for(const X of M)x.push(...W.slice(X.start,X.start+X.deleteCount)),G.push(...X.toInsert);return{removed:x,added:G}}e.delta=I;function d(W,F,L){if(L===0)return[];const M=W.slice(0,L).sort(F);return r(W,F,M,L,W.length),M}e.top=d;function f(W,F,L,M,x){return L===0?Promise.resolve([]):new Promise((G,X)=>{(async()=>{const ne=W.length,me=W.slice(0,L).sort(F);for(let Le=L,We=Math.min(L+M,ne);Le<ne;Le=We,We=Math.min(We+M,ne)){if(Le>L&&await new Promise(Fe=>setTimeout(Fe)),x&&x.isCancellationRequested)throw(0,_.canceled)();r(W,F,me,Le,We)}return me})().then(G,X)})}e.topAsync=f;function r(W,F,L,M,x){for(const G=L.length;M<x;M++){const X=W[M];if(F(X,L[G-1])<0){L.pop();const ne=D(L,me=>F(X,me)<0);L.splice(ne,0,X)}}}function o(W){return W.filter(F=>!!F)}e.coalesce=o;function p(W){let F=0;for(let L=0;L<W.length;L++)W[L]&&(W[F]=W[L],F+=1);W.length=F}e.coalesceInPlace=p;function g(W,F,L){W.splice(L,0,W.splice(F,1)[0])}e.move=g;function E(W){return!Array.isArray(W)||W.length===0}e.isFalsyOrEmpty=E;function m(W){return Array.isArray(W)&&W.length>0}e.isNonEmptyArray=m;function u(W,F){if(!F)return W.filter((M,x)=>W.indexOf(M)===x);const L=Object.create(null);return W.filter(M=>{const x=F(M);return L[x]?!1:(L[x]=!0,!0)})}e.distinct=u;function w(W){const F=new Set;return W.filter(L=>F.has(L)?!1:(F.add(L),!0))}e.distinctES6=w;function t(W){const F=Object.create(null);return L=>{const M=W(L);return F[M]?!1:(F[M]=!0,!0)}}e.uniqueFilter=t;function n(W,F){for(let L=W.length-1;L>=0;L--){const M=W[L];if(F(M))return L}return-1}e.lastIndex=n;function l(W,F){return W.length>0?W[0]:F}e.firstOrDefault=l;function a(W,F,L=(M,x)=>M===x){let M=0;for(let x=0,G=Math.min(W.length,F.length);x<G&&L(W[x],F[x]);x++)M++;return M}e.commonPrefixLength=a;function s(W){return[].concat(...W)}e.flatten=s;function c(W,F){let L=typeof F=="number"?W:0;typeof F=="number"?L=W:(L=0,F=W);const M=[];if(L<=F)for(let x=L;x<F;x++)M.push(x);else for(let x=L;x>F;x--)M.push(x);return M}e.range=c;function v(W,F,L){return W.reduce((M,x)=>(M[F(x)]=L?L(x):x,M),Object.create(null))}e.index=v;function P(W,F){return W.push(F),()=>h(W,F)}e.insert=P;function h(W,F){const L=W.indexOf(F);if(L>-1)return W.splice(L,1),F}e.remove=h;function b(W,F,L){const M=W.slice(0,F),x=W.slice(F);return M.concat(L,x)}e.arrayInsert=b;function R(W,F){let L;if(typeof F=="number"){let M=F;L=()=>{const x=Math.sin(M++)*179426549;return x-Math.floor(x)}}else L=Math.random;for(let M=W.length-1;M>0;M-=1){const x=Math.floor(L()*(M+1)),G=W[M];W[M]=W[x],W[x]=G}}e.shuffle=R;function U(W,F){const L=W.indexOf(F);L>-1&&(W.splice(L,1),W.unshift(F))}e.pushToStart=U;function K(W,F){const L=W.indexOf(F);L>-1&&(W.splice(L,1),W.push(F))}e.pushToEnd=K;function he(W,F){return Array.isArray(W)?W.map(F):F(W)}e.mapArrayOrNot=he;function V(W){return Array.isArray(W)?W:[W]}e.asArray=V;function H(W){return W[Math.floor(Math.random()*W.length)]}e.getRandomElement=H;function Y(W,F){for(const L of W){const M=F(L);if(M!==void 0)return M}}e.mapFind=Y}),define(ve[53],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function _(k){const A=this;let T=!1,y;return function(){return T||(T=!0,y=k.apply(A,arguments)),y}}e.once=_}),define(ve[54],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class _{constructor(A){this._prefix=A,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=_,e.defaultGenerator=new _("id#")}),define(ve[43],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var _;(function(k){function A(w){return w&&typeof w=="object"&&typeof w[Symbol.iterator]=="function"}k.is=A;const T=Object.freeze([]);function y(){return T}k.empty=y;function*D(w){yield w}k.single=D;function S(w){return w||T}k.from=S;function C(w){return!w||w[Symbol.iterator]().next().done===!0}k.isEmpty=C;function i(w){return w[Symbol.iterator]().next().value}k.first=i;function I(w,t){for(const n of w)if(t(n))return!0;return!1}k.some=I;function d(w,t){for(const n of w)if(t(n))return n}k.find=d;function*f(w,t){for(const n of w)t(n)&&(yield n)}k.filter=f;function*r(w,t){for(const n of w)yield t(n)}k.map=r;function*o(...w){for(const t of w)for(const n of t)yield n}k.concat=o;function*p(w){for(const t of w)for(const n of t)yield n}k.concatNested=p;function g(w,t,n){let l=n;for(const a of w)l=t(l,a);return l}k.reduce=g;function*E(w,t,n=w.length){for(t<0&&(t+=w.length),n<0?n+=w.length:n>w.length&&(n=w.length);t<n;t++)yield w[t]}k.slice=E;function m(w,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,w];const l=w[Symbol.iterator]();for(let a=0;a<t;a++){const s=l.next();if(s.done)return[n,k.empty()];n.push(s.value)}return[n,{[Symbol.iterator](){return l}}]}k.consume=m;function u(w,t,n=(l,a)=>l===a){const l=w[Symbol.iterator](),a=t[Symbol.iterator]();for(;;){const s=l.next(),c=a.next();if(s.done!==c.done)return!1;if(s.done)return!0;if(!n(s.value,c.value))return!1}}k.equals=u})(_=e.Iterable||(e.Iterable={}))}),define(ve[44],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var _;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(_=e.ScanError||(e.ScanError={}));var k;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(k=e.SyntaxKind||(e.SyntaxKind={}));var A;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(A=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function y(t,n=!1){let l=0,a=t.length,s="",c=0,v=16,P=0;function h(H){let Y=0,W=0;for(;Y<H;){const F=t.charCodeAt(l);if(F>=48&&F<=57)W=W*16+F-48;else if(F>=65&&F<=70)W=W*16+F-65+10;else if(F>=97&&F<=102)W=W*16+F-97+10;else break;l++,Y++}return Y<H&&(W=-1),W}function b(H){l=H,s="",c=0,v=16,P=0}function R(){const H=l;if(t.charCodeAt(l)===48)l++;else for(l++;l<t.length&&C(t.charCodeAt(l));)l++;if(l<t.length&&t.charCodeAt(l)===46)if(l++,l<t.length&&C(t.charCodeAt(l)))for(l++;l<t.length&&C(t.charCodeAt(l));)l++;else return P=3,t.substring(H,l);let Y=l;if(l<t.length&&(t.charCodeAt(l)===69||t.charCodeAt(l)===101))if(l++,(l<t.length&&t.charCodeAt(l)===43||t.charCodeAt(l)===45)&&l++,l<t.length&&C(t.charCodeAt(l))){for(l++;l<t.length&&C(t.charCodeAt(l));)l++;Y=l}else P=3;return t.substring(H,Y)}function U(){let H="",Y=l;for(;;){if(l>=a){H+=t.substring(Y,l),P=2;break}const W=t.charCodeAt(l);if(W===34){H+=t.substring(Y,l),l++;break}if(W===92){if(H+=t.substring(Y,l),l++,l>=a){P=2;break}switch(t.charCodeAt(l++)){case 34:H+='"';break;case 92:H+="\\";break;case 47:H+="/";break;case 98:H+="\b";break;case 102:H+="\f";break;case 110:H+=`
`;break;case 114:H+="\r";break;case 116:H+="	";break;case 117:const L=h(4);L>=0?H+=String.fromCharCode(L):P=4;break;default:P=5}Y=l;continue}if(W>=0&&W<=31)if(S(W)){H+=t.substring(Y,l),P=2;break}else P=6;l++}return H}function K(){if(s="",P=0,c=l,l>=a)return c=a,v=17;let H=t.charCodeAt(l);if(D(H)){do l++,s+=String.fromCharCode(H),H=t.charCodeAt(l);while(D(H));return v=15}if(S(H))return l++,s+=String.fromCharCode(H),H===13&&t.charCodeAt(l)===10&&(l++,s+=`
`),v=14;switch(H){case 123:return l++,v=1;case 125:return l++,v=2;case 91:return l++,v=3;case 93:return l++,v=4;case 58:return l++,v=6;case 44:return l++,v=5;case 34:return l++,s=U(),v=10;case 47:const Y=l-1;if(t.charCodeAt(l+1)===47){for(l+=2;l<a&&!S(t.charCodeAt(l));)l++;return s=t.substring(Y,l),v=12}if(t.charCodeAt(l+1)===42){l+=2;const W=a-1;let F=!1;for(;l<W;){if(t.charCodeAt(l)===42&&t.charCodeAt(l+1)===47){l+=2,F=!0;break}l++}return F||(l++,P=1),s=t.substring(Y,l),v=13}return s+=String.fromCharCode(H),l++,v=16;case 45:if(s+=String.fromCharCode(H),l++,l===a||!C(t.charCodeAt(l)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=R(),v=11;default:for(;l<a&&he(H);)l++,H=t.charCodeAt(l);if(c!==l){switch(s=t.substring(c,l),s){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return s+=String.fromCharCode(H),l++,v=16}}function he(H){if(D(H)||S(H))return!1;switch(H){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let H;do H=K();while(H>=12&&H<=15);return H}return{setPosition:b,getPosition:()=>l,scan:n?V:K,getToken:()=>v,getTokenValue:()=>s,getTokenOffset:()=>c,getTokenLength:()=>l-c,getTokenError:()=>P}}e.createScanner=y;function D(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function S(t){return t===10||t===13||t===8232||t===8233}function C(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function I(t,n){const l=[],a=new Object;let s;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function P(h,b,R,U){c.value=h,c.offset=b,c.length=R,c.type=U,c.colonOffset=void 0,s=c}try{m(t,{onObjectBegin:(h,b)=>{if(n<=h)throw a;s=void 0,v=n>h,l.push("")},onObjectProperty:(h,b,R)=>{if(n<b||(P(h,b,R,"property"),l[l.length-1]=h,n<=b+R))throw a},onObjectEnd:(h,b)=>{if(n<=h)throw a;s=void 0,l.pop()},onArrayBegin:(h,b)=>{if(n<=h)throw a;s=void 0,l.push(0)},onArrayEnd:(h,b)=>{if(n<=h)throw a;s=void 0,l.pop()},onLiteralValue:(h,b,R)=>{if(n<b||(P(h,b,R,w(h)),n<=b+R))throw a},onSeparator:(h,b,R)=>{if(n<=b)throw a;if(h===":"&&s&&s.type==="property")s.colonOffset=b,v=!1,s=void 0;else if(h===","){const U=l[l.length-1];typeof U=="number"?l[l.length-1]=U+1:(v=!0,l[l.length-1]=""),s=void 0}}})}catch(h){if(h!==a)throw h}return{path:l,previousNode:s,isAtPropertyKey:v,matches:h=>{let b=0;for(let R=0;b<h.length&&R<l.length;R++)if(h[b]===l[R]||h[b]==="*")b++;else if(h[b]!=="**")return!1;return b===h.length}}}e.getLocation=I;function d(t,n=[],l=T.DEFAULT){let a=null,s=[];const c=[];function v(h){Array.isArray(s)?s.push(h):a!==null&&(s[a]=h)}return m(t,{onObjectBegin:()=>{const h={};v(h),c.push(s),s=h,a=null},onObjectProperty:h=>{a=h},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{const h=[];v(h),c.push(s),s=h,a=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:v,onError:(h,b,R)=>{n.push({error:h,offset:b,length:R})}},l),s[0]}e.parse=d;function f(t,n=[],l=T.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(h){a.type==="property"&&(a.length=h-a.offset,a=a.parent)}function c(h){return a.children.push(h),h}m(t,{onObjectBegin:h=>{a=c({type:"object",offset:h,length:-1,parent:a,children:[]})},onObjectProperty:(h,b,R)=>{a=c({type:"property",offset:b,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:h,offset:b,length:R,parent:a})},onObjectEnd:(h,b)=>{a.length=h+b-a.offset,a=a.parent,s(h+b)},onArrayBegin:(h,b)=>{a=c({type:"array",offset:h,length:-1,parent:a,children:[]})},onArrayEnd:(h,b)=>{a.length=h+b-a.offset,a=a.parent,s(h+b)},onLiteralValue:(h,b,R)=>{c({type:w(h),offset:b,length:R,parent:a,value:h}),s(b+R)},onSeparator:(h,b,R)=>{a.type==="property"&&(h===":"?a.colonOffset=b:h===","&&s(b))},onError:(h,b,R)=>{n.push({error:h,offset:b,length:R})}},l);const P=a.children[0];return P&&delete P.parent,P}e.parseTree=f;function r(t,n){if(!!t){let l=t;for(let a of n)if(typeof a=="string"){if(l.type!=="object"||!Array.isArray(l.children))return;let s=!1;for(const c of l.children)if(Array.isArray(c.children)&&c.children[0].value===a){l=c.children[1],s=!0;break}if(!s)return}else{const s=a;if(l.type!=="array"||s<0||!Array.isArray(l.children)||s>=l.children.length)return;l=l.children[s]}return l}}e.findNodeAtLocation=r;function o(t){if(!t.parent||!t.parent.children)return[];const n=o(t.parent);if(t.parent.type==="property"){const l=t.parent.children[0].value;n.push(l)}else if(t.parent.type==="array"){const l=t.parent.children.indexOf(t);l!==-1&&n.push(l)}return n}e.getNodePath=o;function p(t){switch(t.type){case"array":return t.children.map(p);case"object":const n=Object.create(null);for(let l of t.children){const a=l.children[1];a&&(n[l.children[0].value]=p(a))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=p;function g(t,n,l=!1){return n>=t.offset&&n<t.offset+t.length||l&&n===t.offset+t.length}e.contains=g;function E(t,n,l=!1){if(g(t,n,l)){const a=t.children;if(Array.isArray(a))for(let s=0;s<a.length&&a[s].offset<=n;s++){const c=E(a[s],n,l);if(c)return c}return t}}e.findNodeAtOffset=E;function m(t,n,l=T.DEFAULT){const a=y(t,!1);function s(me){return me?()=>me(a.getTokenOffset(),a.getTokenLength()):()=>!0}function c(me){return me?Le=>me(Le,a.getTokenOffset(),a.getTokenLength()):()=>!0}const v=s(n.onObjectBegin),P=c(n.onObjectProperty),h=s(n.onObjectEnd),b=s(n.onArrayBegin),R=s(n.onArrayEnd),U=c(n.onLiteralValue),K=c(n.onSeparator),he=s(n.onComment),V=c(n.onError),H=l&&l.disallowComments,Y=l&&l.allowTrailingComma;function W(){for(;;){const me=a.scan();switch(a.getTokenError()){case 4:F(14);break;case 5:F(15);break;case 3:F(13);break;case 1:H||F(11);break;case 2:F(12);break;case 6:F(16);break}switch(me){case 12:case 13:H?F(10):he();break;case 16:F(1);break;case 15:case 14:break;default:return me}}}function F(me,Le=[],We=[]){if(V(me),Le.length+We.length>0){let Fe=a.getToken();for(;Fe!==17;){if(Le.indexOf(Fe)!==-1){W();break}else if(We.indexOf(Fe)!==-1)break;Fe=W()}}}function L(me){const Le=a.getTokenValue();return me?U(Le):P(Le),W(),!0}function M(){switch(a.getToken()){case 11:let me=0;try{me=JSON.parse(a.getTokenValue()),typeof me!="number"&&(F(2),me=0)}catch(Le){F(2)}U(me);break;case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return W(),!0}function x(){return a.getToken()!==10?(F(3,[],[2,5]),!1):(L(!1),a.getToken()===6?(K(":"),W(),ne()||F(4,[],[2,5])):F(5,[],[2,5]),!0)}function G(){v(),W();let me=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(me||F(4,[],[]),K(","),W(),a.getToken()===2&&Y)break}else me&&F(6,[],[]);x()||F(4,[],[2,5]),me=!0}return h(),a.getToken()!==2?F(7,[2],[]):W(),!0}function X(){b(),W();let me=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(me||F(4,[],[]),K(","),W(),a.getToken()===4&&Y)break}else me&&F(6,[],[]);ne()||F(4,[],[4,5]),me=!0}return R(),a.getToken()!==4?F(8,[4],[]):W(),!0}function ne(){switch(a.getToken()){case 3:return X();case 1:return G();case 10:return L(!0);default:return M()}}return W(),a.getToken()===17?l.allowEmptyContent?!0:(F(4,[],[]),!1):ne()?(a.getToken()!==17&&F(9,[],[]),!0):(F(4,[],[]),!1)}e.visit=m;function u(t,n){let l=y(t),a=[],s,c=0,v;do switch(v=l.getPosition(),s=l.scan(),s){case 12:case 13:case 17:c!==v&&a.push(t.substring(c,v)),n!==void 0&&a.push(l.getTokenValue().replace(/[^\r\n]/g,n)),c=l.getPosition();break}while(s!==17);return a.join("")}e.stripComments=u;function w(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=w}),define(ve[106],be([0,1,44]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function k(S,C,i){let I,d,f,r,o;if(C){for(r=C.offset,o=r+C.length,f=r;f>0&&!D(S,f-1);)f--;let c=o;for(;c<S.length&&!D(S,c);)c++;d=S.substring(f,c),I=T(d,i)}else d=S,I=0,f=0,r=0,o=S.length;const p=y(i,S);let g=!1,E=0,m;i.insertSpaces?m=A(" ",i.tabSize||4):m="	";const u=(0,_.createScanner)(d,!1);let w=!1;function t(){return p+A(m,I+E)}function n(){let c=u.scan();for(g=!1;c===15||c===14;)g=g||c===14,c=u.scan();return w=c===16||u.getTokenError()!==0,c}const l=[];function a(c,v,P){!w&&v<o&&P>r&&S.substring(v,P)!==c&&l.push({offset:v,length:P-v,content:c})}let s=n();if(s!==17){const c=u.getTokenOffset()+f,v=A(m,I);a(v,f,c)}for(;s!==17;){let c=u.getTokenOffset()+u.getTokenLength()+f,v=n(),P="";for(;!g&&(v===12||v===13);){const b=u.getTokenOffset()+f;a(" ",c,b),c=u.getTokenOffset()+u.getTokenLength()+f,P=v===12?t():"",v=n()}if(v===2)s!==1&&(E--,P=t());else if(v===4)s!==3&&(E--,P=t());else{switch(s){case 3:case 1:E++,P=t();break;case 5:case 12:P=t();break;case 13:g?P=t():P=" ";break;case 6:P=" ";break;case 10:if(v===6){P="";break}case 7:case 8:case 9:case 11:case 2:case 4:v===12||v===13?P=" ":v!==5&&v!==17&&(w=!0);break;case 16:w=!0;break}g&&(v===12||v===13)&&(P=t())}const h=u.getTokenOffset()+f;a(P,c,h),s=v}return l}e.format=k;function A(S,C){let i="";for(let I=0;I<C;I++)i+=S;return i}function T(S,C){let i=0,I=0;const d=C.tabSize||4;for(;i<S.length;){const f=S.charAt(i);if(f===" ")I++;else if(f==="	")I+=d;else break;i++}return Math.floor(I/d)}function y(S,C){for(let i=0;i<C.length;i++){const I=C.charAt(i);if(I==="\r")return i+1<C.length&&C.charAt(i+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=y;function D(S,C){return`\r
`.indexOf(S.charAt(C))!==-1}e.isEOL=D}),define(ve[107],be([0,1,44,106]),function(J,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function A(C,i,I){return T(C,i,void 0,I)}e.removeProperty=A;function T(C,i,I,d,f){const r=i.slice(),o=[],p=(0,_.parseTree)(C,o);let g,E;for(;r.length>0&&(E=r.pop(),g=(0,_.findNodeAtLocation)(p,r),g===void 0&&I!==void 0);)typeof E=="string"?I={[E]:I}:I=[I];if(g)if(g.type==="object"&&typeof E=="string"&&Array.isArray(g.children)){const m=(0,_.findNodeAtLocation)(g,[E]);if(m!==void 0)if(I===void 0){if(!m.parent)throw new Error("Malformed AST");const u=g.children.indexOf(m.parent);let w,t=m.parent.offset+m.parent.length;if(u>0){const n=g.children[u-1];w=n.offset+n.length}else w=g.offset+1,g.children.length>1&&(t=g.children[1].offset);return y(C,{offset:w,length:t-w,content:""},d)}else return y(C,{offset:m.offset,length:m.length,content:JSON.stringify(I)},d);else{if(I===void 0)return[];const u=`${JSON.stringify(E)}: ${JSON.stringify(I)}`,w=f?f(g.children.map(n=>n.children[0].value)):g.children.length;let t;if(w>0){const n=g.children[w-1];t={offset:n.offset+n.length,length:0,content:","+u}}else g.children.length===0?t={offset:g.offset+1,length:0,content:u}:t={offset:g.offset+1,length:0,content:u+","};return y(C,t,d)}}else if(g.type==="array"&&typeof E=="number"&&Array.isArray(g.children))if(I!==void 0){const m=`${JSON.stringify(I)}`;let u;if(g.children.length===0||E===0)u={offset:g.offset+1,length:0,content:g.children.length===0?m:m+","};else{const w=E===-1||E>g.children.length?g.children.length:E,t=g.children[w-1];u={offset:t.offset+t.length,length:0,content:","+m}}return y(C,u,d)}else{const m=E,u=g.children[m];let w;if(g.children.length===1)w={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===m){const t=g.children[m-1],n=t.offset+t.length,l=g.offset+g.length;w={offset:n,length:l-2-n,content:""}}else w={offset:u.offset,length:g.children[m+1].offset-u.offset,content:""};return y(C,w,d)}else throw new Error(`Can not add ${typeof E!="number"?"index":"property"} to parent of type ${g.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return y(C,{offset:p?p.offset:0,length:p?p.length:0,content:JSON.stringify(I)},d)}}e.setProperty=T;function y(C,i,I){let d=D(C,i),f=i.offset,r=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;f>0&&!(0,k.isEOL)(d,f-1);)f--;for(;r<d.length&&!(0,k.isEOL)(d,r);)r++}const o=(0,k.format)(d,{offset:f,length:r-f},I);for(let g=o.length-1;g>=0;g--){const E=o[g];d=D(d,E),f=Math.min(f,E.offset),r=Math.max(r,E.offset+E.length),r+=E.content.length-E.length}const p=C.length-(d.length-r)-f;return[{offset:f,length:p,content:d.substring(f,r)}]}e.withFormatting=y;function D(C,i){return C.substring(0,i.offset)+i.content+C.substring(i.offset+i.length)}e.applyEdit=D;function S(C,i){let I=i.slice(0).sort((f,r)=>{const o=f.offset-r.offset;return o===0?f.length-r.length:o}),d=C.length;for(let f=I.length-1;f>=0;f--){let r=I[f];if(r.offset+r.length<=d)C=D(C,r);else throw new Error("Overlapping edit");d=r.offset}return C}e.applyEdits=S}),define(ve[108],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class _{constructor(A){this.executor=A,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(A){this._error=A}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(A){return new _(()=>A(this.getValue()))}}e.Lazy=_}),define(ve[6],be([0,1,53,43]),function(J,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const A=!1;let T=null;function y(m){T=m}if(e.setDisposableTracker=y,A){const m="__is_disposable_tracked__";T=new class{trackDisposable(u){const w=new Error("Potentially leaked disposable").stack;setTimeout(()=>{u[m]||console.log(w)},3e3)}markTracked(u){if(u&&u!==o.None)try{u[m]=!0}catch(w){}}}}function D(m){!T||T.markTracked(m)}function S(m){return T&&T.trackDisposable(m),m}e.trackDisposable=S;class C extends Error{constructor(u){super(`Encountered errors while disposing of store. Errors: [${u.join(", ")}]`);this.errors=u}}e.MultiDisposeError=C;function i(m){return typeof m.dispose=="function"&&m.dispose.length===0}e.isDisposable=i;function I(m){if(k.Iterable.is(m)){let u=[];for(const w of m)if(w){D(w);try{w.dispose()}catch(t){u.push(t)}}if(u.length===1)throw u[0];if(u.length>1)throw new C(u);return Array.isArray(m)?[]:m}else if(m)return D(m),m.dispose(),m}e.dispose=I;function d(...m){return m.forEach(D),f(()=>I(m))}e.combinedDisposable=d;function f(m){const u=S({dispose:()=>{D(u),m()}});return u}e.toDisposable=f;class r{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(D(this),this._isDisposed=!0,this.clear())}clear(){try{I(this._toDispose.values())}finally{this._toDispose.clear()}}add(u){if(!u)return u;if(u===this)throw new Error("Cannot register a disposable on itself!");return D(u),this._isDisposed?r.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(u),u}}e.DisposableStore=r,r.DISABLE_DISPOSED_WARNING=!1;class o{constructor(){this._store=new r,S(this)}dispose(){D(this),this._store.dispose()}_register(u){if(u===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(u)}}e.Disposable=o,o.None=Object.freeze({dispose(){}});class p{constructor(){this._isDisposed=!1,S(this)}get value(){return this._isDisposed?void 0:this._value}set value(u){var w;this._isDisposed||u===this._value||((w=this._value)===null||w===void 0||w.dispose(),u&&D(u),this._value=u)}clear(){this.value=void 0}dispose(){var u;this._isDisposed=!0,D(this),(u=this._value)===null||u===void 0||u.dispose(),this._value=void 0}}e.MutableDisposable=p;class g{constructor(){this.references=new Map}acquire(u,...w){let t=this.references.get(u);t||(t={counter:0,object:this.createReferencedObject(u,...w)},this.references.set(u,t));const{object:n}=t,l=(0,_.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(u,t.object),this.references.delete(u))});return t.counter++,{object:n,dispose:l}}}e.ReferenceCollection=g;class E{constructor(u){this.object=u}dispose(){}}e.ImmortalReference=E}),define(ve[45],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class _{constructor(T){this.element=T,this.next=_.Undefined,this.prev=_.Undefined}}_.Undefined=new _(void 0);class k{constructor(){this._first=_.Undefined,this._last=_.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===_.Undefined}clear(){let T=this._first;for(;T!==_.Undefined;){const y=T.next;T.prev=_.Undefined,T.next=_.Undefined,T=y}this._first=_.Undefined,this._last=_.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,y){const D=new _(T);if(this._first===_.Undefined)this._first=D,this._last=D;else if(y){const C=this._last;this._last=D,D.prev=C,C.next=D}else{const C=this._first;this._first=D,D.next=C,C.prev=D}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(D))}}shift(){if(this._first!==_.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==_.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==_.Undefined&&T.next!==_.Undefined){const y=T.prev;y.next=T.next,T.next.prev=y}else T.prev===_.Undefined&&T.next===_.Undefined?(this._first=_.Undefined,this._last=_.Undefined):T.next===_.Undefined?(this._last=this._last.prev,this._last.next=_.Undefined):T.prev===_.Undefined&&(this._first=this._first.next,this._first.prev=_.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==_.Undefined;)yield T.element,T=T.next}}e.LinkedList=k}),function(J,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(J=typeof globalThis!="undefined"?globalThis:J||self,J.marked=e())}(this,function(){"use strict";function J(ye,Ee){for(var Ce=0;Ce<Ee.length;Ce++){var re=Ee[Ce];re.enumerable=re.enumerable||!1,re.configurable=!0,"value"in re&&(re.writable=!0),Object.defineProperty(ye,re.key,re)}}function e(ye,Ee,Ce){return Ee&&J(ye.prototype,Ee),Ce&&J(ye,Ce),ye}function _(ye,Ee){if(!!ye){if(typeof ye=="string")return k(ye,Ee);var Ce=Object.prototype.toString.call(ye).slice(8,-1);if(Ce==="Object"&&ye.constructor&&(Ce=ye.constructor.name),Ce==="Map"||Ce==="Set")return Array.from(ye);if(Ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ce))return k(ye,Ee)}}function k(ye,Ee){(Ee==null||Ee>ye.length)&&(Ee=ye.length);for(var Ce=0,re=new Array(Ee);Ce<Ee;Ce++)re[Ce]=ye[Ce];return re}function A(ye,Ee){var Ce;if(typeof Symbol=="undefined"||ye[Symbol.iterator]==null){if(Array.isArray(ye)||(Ce=_(ye))||Ee&&ye&&typeof ye.length=="number"){Ce&&(ye=Ce);var re=0;return function(){return re>=ye.length?{done:!0}:{done:!1,value:ye[re++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Ce=ye[Symbol.iterator](),Ce.next.bind(Ce)}function T(ye){var Ee={exports:{}};return ye(Ee,Ee.exports),Ee.exports}var y=T(function(ye){function Ee(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Ce(re){ye.exports.defaults=re}ye.exports={defaults:Ee(),getDefaults:Ee,changeDefaults:Ce}}),D=/[&<>"']/,S=/[&<>"']/g,C=/[<>"']|&(?!#?\w+;)/,i=/[<>"']|&(?!#?\w+;)/g,I={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},d=function(Ee){return I[Ee]};function f(ye,Ee){if(Ee){if(D.test(ye))return ye.replace(S,d)}else if(C.test(ye))return ye.replace(i,d);return ye}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(ye){return ye.replace(r,function(Ee,Ce){return Ce=Ce.toLowerCase(),Ce==="colon"?":":Ce.charAt(0)==="#"?Ce.charAt(1)==="x"?String.fromCharCode(parseInt(Ce.substring(2),16)):String.fromCharCode(+Ce.substring(1)):""})}var p=/(^|[^\[])\^/g;function g(ye,Ee){ye=ye.source||ye,Ee=Ee||"";var Ce={replace:function(le,N){return N=N.source||N,N=N.replace(p,"$1"),ye=ye.replace(le,N),Ce},getRegex:function(){return new RegExp(ye,Ee)}};return Ce}var E=/[^\w:]/g,m=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(ye,Ee,Ce){if(ye){var re;try{re=decodeURIComponent(o(Ce)).replace(E,"").toLowerCase()}catch(le){return null}if(re.indexOf("javascript:")===0||re.indexOf("vbscript:")===0||re.indexOf("data:")===0)return null}Ee&&!m.test(Ce)&&(Ce=a(Ee,Ce));try{Ce=encodeURI(Ce).replace(/%25/g,"%")}catch(le){return null}return Ce}var w={},t=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(ye,Ee){w[" "+ye]||(t.test(ye)?w[" "+ye]=ye+"/":w[" "+ye]=P(ye,"/",!0)),ye=w[" "+ye];var Ce=ye.indexOf(":")===-1;return Ee.substring(0,2)==="//"?Ce?Ee:ye.replace(n,"$1")+Ee:Ee.charAt(0)==="/"?Ce?Ee:ye.replace(l,"$1")+Ee:ye+Ee}var s={exec:function(){}};function c(ye){for(var Ee=1,Ce,re;Ee<arguments.length;Ee++){Ce=arguments[Ee];for(re in Ce)Object.prototype.hasOwnProperty.call(Ce,re)&&(ye[re]=Ce[re])}return ye}function v(ye,Ee){var Ce=ye.replace(/\|/g,function(N,Q,ae){for(var ke=!1,Ie=Q;--Ie>=0&&ae[Ie]==="\\";)ke=!ke;return ke?"|":" |"}),re=Ce.split(/ \|/),le=0;if(re.length>Ee)re.splice(Ee);else for(;re.length<Ee;)re.push("");for(;le<re.length;le++)re[le]=re[le].trim().replace(/\\\|/g,"|");return re}function P(ye,Ee,Ce){var re=ye.length;if(re===0)return"";for(var le=0;le<re;){var N=ye.charAt(re-le-1);if(N===Ee&&!Ce)le++;else if(N!==Ee&&Ce)le++;else break}return ye.substr(0,re-le)}function h(ye,Ee){if(ye.indexOf(Ee[1])===-1)return-1;for(var Ce=ye.length,re=0,le=0;le<Ce;le++)if(ye[le]==="\\")le++;else if(ye[le]===Ee[0])re++;else if(ye[le]===Ee[1]&&(re--,re<0))return le;return-1}function b(ye){ye&&ye.sanitize&&!ye.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(ye,Ee){if(Ee<1)return"";for(var Ce="";Ee>1;)Ee&1&&(Ce+=ye),Ee>>=1,ye+=ye;return Ce+ye}var U={escape:f,unescape:o,edit:g,cleanUrl:u,resolveUrl:a,noopTest:s,merge:c,splitCells:v,rtrim:P,findClosingBracket:h,checkSanitizeDeprecation:b,repeatString:R},K=y.defaults,he=U.rtrim,V=U.splitCells,H=U.escape,Y=U.findClosingBracket;function W(ye,Ee,Ce){var re=Ee.href,le=Ee.title?H(Ee.title):null,N=ye[1].replace(/\\([\[\]])/g,"$1");return ye[0].charAt(0)!=="!"?{type:"link",raw:Ce,href:re,title:le,text:N}:{type:"image",raw:Ce,href:re,title:le,text:H(N)}}function F(ye,Ee){var Ce=ye.match(/^(\s+)(?:```)/);if(Ce===null)return Ee;var re=Ce[1];return Ee.split(`
`).map(function(le){var N=le.match(/^\s+/);if(N===null)return le;var Q=N[0];return Q.length>=re.length?le.slice(re.length):le}).join(`
`)}var L=function(){function ye(Ce){this.options=Ce||K}var Ee=ye.prototype;return Ee.space=function(re){var le=this.rules.block.newline.exec(re);if(le)return le[0].length>1?{type:"space",raw:le[0]}:{raw:`
`}},Ee.code=function(re){var le=this.rules.block.code.exec(re);if(le){var N=le[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:le[0],codeBlockStyle:"indented",text:this.options.pedantic?N:he(N,`
`)}}},Ee.fences=function(re){var le=this.rules.block.fences.exec(re);if(le){var N=le[0],Q=F(N,le[3]||"");return{type:"code",raw:N,lang:le[2]?le[2].trim():le[2],text:Q}}},Ee.heading=function(re){var le=this.rules.block.heading.exec(re);if(le){var N=le[2].trim();if(/#$/.test(N)){var Q=he(N,"#");(this.options.pedantic||!Q||/ $/.test(Q))&&(N=Q.trim())}return{type:"heading",raw:le[0],depth:le[1].length,text:N}}},Ee.nptable=function(re){var le=this.rules.block.nptable.exec(re);if(le){var N={type:"table",header:V(le[1].replace(/^ *| *\| *$/g,"")),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:le[3]?le[3].replace(/\n$/,"").split(`
`):[],raw:le[0]};if(N.header.length===N.align.length){var Q=N.align.length,ae;for(ae=0;ae<Q;ae++)/^ *-+: *$/.test(N.align[ae])?N.align[ae]="right":/^ *:-+: *$/.test(N.align[ae])?N.align[ae]="center":/^ *:-+ *$/.test(N.align[ae])?N.align[ae]="left":N.align[ae]=null;for(Q=N.cells.length,ae=0;ae<Q;ae++)N.cells[ae]=V(N.cells[ae],N.header.length);return N}}},Ee.hr=function(re){var le=this.rules.block.hr.exec(re);if(le)return{type:"hr",raw:le[0]}},Ee.blockquote=function(re){var le=this.rules.block.blockquote.exec(re);if(le){var N=le[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:le[0],text:N}}},Ee.list=function(re){var le=this.rules.block.list.exec(re);if(le){var N=le[0],Q=le[2],ae=Q.length>1,ke={type:"list",raw:N,ordered:ae,start:ae?+Q.slice(0,-1):"",loose:!1,items:[]},Ie=le[0].match(this.rules.block.item),Ae=!1,xe,Ye,rt,tt,Qe,mt,bt,pe,ce=Ie.length;rt=this.rules.block.listItemStart.exec(Ie[0]);for(var se=0;se<ce;se++){if(xe=Ie[se],N=xe,se!==ce-1){if(tt=this.rules.block.listItemStart.exec(Ie[se+1]),this.options.pedantic?tt[1].length>rt[1].length:tt[1].length>rt[0].length||tt[1].length>3){Ie.splice(se,2,Ie[se]+`
`+Ie[se+1]),se--,ce--;continue}else(!this.options.pedantic||this.options.smartLists?tt[2][tt[2].length-1]!==Q[Q.length-1]:ae===(tt[2].length===1))&&(Qe=Ie.slice(se+1).join(`
`),ke.raw=ke.raw.substring(0,ke.raw.length-Qe.length),se=ce-1);rt=tt}Ye=xe.length,xe=xe.replace(/^ *([*+-]|\d+[.)]) ?/,""),~xe.indexOf(`
 `)&&(Ye-=xe.length,xe=this.options.pedantic?xe.replace(/^ {1,4}/gm,""):xe.replace(new RegExp("^ {1,"+Ye+"}","gm"),"")),mt=Ae||/\n\n(?!\s*$)/.test(xe),se!==ce-1&&(Ae=xe.charAt(xe.length-1)===`
`,mt||(mt=Ae)),mt&&(ke.loose=!0),this.options.gfm&&(bt=/^\[[ xX]\] /.test(xe),pe=void 0,bt&&(pe=xe[1]!==" ",xe=xe.replace(/^\[[ xX]\] +/,""))),ke.items.push({type:"list_item",raw:N,task:bt,checked:pe,loose:mt,text:xe})}return ke}},Ee.html=function(re){var le=this.rules.block.html.exec(re);if(le)return{type:this.options.sanitize?"paragraph":"html",raw:le[0],pre:!this.options.sanitizer&&(le[1]==="pre"||le[1]==="script"||le[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):H(le[0]):le[0]}},Ee.def=function(re){var le=this.rules.block.def.exec(re);if(le){le[3]&&(le[3]=le[3].substring(1,le[3].length-1));var N=le[1].toLowerCase().replace(/\s+/g," ");return{tag:N,raw:le[0],href:le[2],title:le[3]}}},Ee.table=function(re){var le=this.rules.block.table.exec(re);if(le){var N={type:"table",header:V(le[1].replace(/^ *| *\| *$/g,"")),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:le[3]?le[3].replace(/\n$/,"").split(`
`):[]};if(N.header.length===N.align.length){N.raw=le[0];var Q=N.align.length,ae;for(ae=0;ae<Q;ae++)/^ *-+: *$/.test(N.align[ae])?N.align[ae]="right":/^ *:-+: *$/.test(N.align[ae])?N.align[ae]="center":/^ *:-+ *$/.test(N.align[ae])?N.align[ae]="left":N.align[ae]=null;for(Q=N.cells.length,ae=0;ae<Q;ae++)N.cells[ae]=V(N.cells[ae].replace(/^ *\| *| *\| *$/g,""),N.header.length);return N}}},Ee.lheading=function(re){var le=this.rules.block.lheading.exec(re);if(le)return{type:"heading",raw:le[0],depth:le[2].charAt(0)==="="?1:2,text:le[1]}},Ee.paragraph=function(re){var le=this.rules.block.paragraph.exec(re);if(le)return{type:"paragraph",raw:le[0],text:le[1].charAt(le[1].length-1)===`
`?le[1].slice(0,-1):le[1]}},Ee.text=function(re){var le=this.rules.block.text.exec(re);if(le)return{type:"text",raw:le[0],text:le[0]}},Ee.escape=function(re){var le=this.rules.inline.escape.exec(re);if(le)return{type:"escape",raw:le[0],text:H(le[1])}},Ee.tag=function(re,le,N){var Q=this.rules.inline.tag.exec(re);if(Q)return!le&&/^<a /i.test(Q[0])?le=!0:le&&/^<\/a>/i.test(Q[0])&&(le=!1),!N&&/^<(pre|code|kbd|script)(\s|>)/i.test(Q[0])?N=!0:N&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Q[0])&&(N=!1),{type:this.options.sanitize?"text":"html",raw:Q[0],inLink:le,inRawBlock:N,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Q[0]):H(Q[0]):Q[0]}},Ee.link=function(re){var le=this.rules.inline.link.exec(re);if(le){var N=le[2].trim();if(!this.options.pedantic&&/^</.test(N)){if(!/>$/.test(N))return;var Q=he(N.slice(0,-1),"\\");if((N.length-Q.length)%2==0)return}else{var ae=Y(le[2],"()");if(ae>-1){var ke=le[0].indexOf("!")===0?5:4,Ie=ke+le[1].length+ae;le[2]=le[2].substring(0,ae),le[0]=le[0].substring(0,Ie).trim(),le[3]=""}}var Ae=le[2],xe="";if(this.options.pedantic){var Ye=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);Ye&&(Ae=Ye[1],xe=Ye[3])}else xe=le[3]?le[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(N)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),W(le,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:xe&&xe.replace(this.rules.inline._escapes,"$1")},le[0])}},Ee.reflink=function(re,le){var N;if((N=this.rules.inline.reflink.exec(re))||(N=this.rules.inline.nolink.exec(re))){var Q=(N[2]||N[1]).replace(/\s+/g," ");if(Q=le[Q.toLowerCase()],!Q||!Q.href){var ae=N[0].charAt(0);return{type:"text",raw:ae,text:ae}}return W(N,Q,N[0])}},Ee.emStrong=function(re,le,N){N===void 0&&(N="");var Q=this.rules.inline.emStrong.lDelim.exec(re);if(!!Q&&!(Q[3]&&N.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ae=Q[1]||Q[2]||"";if(!ae||ae&&(N===""||this.rules.inline.punctuation.exec(N))){var ke=Q[0].length-1,Ie,Ae,xe=ke,Ye=0,rt=Q[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(rt.lastIndex=0,le=le.slice(-1*re.length+ke);(Q=rt.exec(le))!=null;)if(Ie=Q[1]||Q[2]||Q[3]||Q[4]||Q[5]||Q[6],!!Ie){if(Ae=Ie.length,Q[3]||Q[4]){xe+=Ae;continue}else if((Q[5]||Q[6])&&ke%3&&!((ke+Ae)%3)){Ye+=Ae;continue}if(xe-=Ae,!(xe>0)){if(xe+Ye-Ae<=0&&!le.slice(rt.lastIndex).match(rt)&&(Ae=Math.min(Ae,Ae+xe+Ye)),Math.min(ke,Ae)%2)return{type:"em",raw:re.slice(0,ke+Q.index+Ae+1),text:re.slice(1,ke+Q.index+Ae)};if(Math.min(ke,Ae)%2==0)return{type:"strong",raw:re.slice(0,ke+Q.index+Ae+1),text:re.slice(2,ke+Q.index+Ae-1)}}}}}},Ee.codespan=function(re){var le=this.rules.inline.code.exec(re);if(le){var N=le[2].replace(/\n/g," "),Q=/[^ ]/.test(N),ae=/^ /.test(N)&&/ $/.test(N);return Q&&ae&&(N=N.substring(1,N.length-1)),N=H(N,!0),{type:"codespan",raw:le[0],text:N}}},Ee.br=function(re){var le=this.rules.inline.br.exec(re);if(le)return{type:"br",raw:le[0]}},Ee.del=function(re){var le=this.rules.inline.del.exec(re);if(le)return{type:"del",raw:le[0],text:le[2]}},Ee.autolink=function(re,le){var N=this.rules.inline.autolink.exec(re);if(N){var Q,ae;return N[2]==="@"?(Q=H(this.options.mangle?le(N[1]):N[1]),ae="mailto:"+Q):(Q=H(N[1]),ae=Q),{type:"link",raw:N[0],text:Q,href:ae,tokens:[{type:"text",raw:Q,text:Q}]}}},Ee.url=function(re,le){var N;if(N=this.rules.inline.url.exec(re)){var Q,ae;if(N[2]==="@")Q=H(this.options.mangle?le(N[0]):N[0]),ae="mailto:"+Q;else{var ke;do ke=N[0],N[0]=this.rules.inline._backpedal.exec(N[0])[0];while(ke!==N[0]);Q=H(N[0]),N[1]==="www."?ae="http://"+Q:ae=Q}return{type:"link",raw:N[0],text:Q,href:ae,tokens:[{type:"text",raw:Q,text:Q}]}}},Ee.inlineText=function(re,le,N){var Q=this.rules.inline.text.exec(re);if(Q){var ae;return le?ae=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Q[0]):H(Q[0]):Q[0]:ae=H(this.options.smartypants?N(Q[0]):Q[0]),{type:"text",raw:Q[0],text:ae}}},ye}(),M=U.noopTest,x=U.edit,G=U.merge,X={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:M,table:M,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};X._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,X._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,X.def=x(X.def).replace("label",X._label).replace("title",X._title).getRegex(),X.bullet=/(?:[*+-]|\d{1,9}[.)])/,X.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,X.item=x(X.item,"gm").replace(/bull/g,X.bullet).getRegex(),X.listItemStart=x(/^( *)(bull)/).replace("bull",X.bullet).getRegex(),X.list=x(X.list).replace(/bull/g,X.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+X.def.source+")").getRegex(),X._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",X._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,X.html=x(X.html,"i").replace("comment",X._comment).replace("tag",X._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),X.paragraph=x(X._paragraph).replace("hr",X.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",X._tag).getRegex(),X.blockquote=x(X.blockquote).replace("paragraph",X.paragraph).getRegex(),X.normal=G({},X),X.gfm=G({},X.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),X.gfm.nptable=x(X.gfm.nptable).replace("hr",X.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",X._tag).getRegex(),X.gfm.table=x(X.gfm.table).replace("hr",X.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",X._tag).getRegex(),X.pedantic=G({},X.normal,{html:x(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",X._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:M,paragraph:x(X.normal._paragraph).replace("hr",X.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",X.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ne={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:M,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:M,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ne._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ne.punctuation=x(ne.punctuation).replace(/punctuation/g,ne._punctuation).getRegex(),ne.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ne.escapedEmSt=/\\\*|\\_/g,ne._comment=x(X._comment).replace("(?:-->|$)","-->").getRegex(),ne.emStrong.lDelim=x(ne.emStrong.lDelim).replace(/punct/g,ne._punctuation).getRegex(),ne.emStrong.rDelimAst=x(ne.emStrong.rDelimAst,"g").replace(/punct/g,ne._punctuation).getRegex(),ne.emStrong.rDelimUnd=x(ne.emStrong.rDelimUnd,"g").replace(/punct/g,ne._punctuation).getRegex(),ne._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ne._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ne._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ne.autolink=x(ne.autolink).replace("scheme",ne._scheme).replace("email",ne._email).getRegex(),ne._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ne.tag=x(ne.tag).replace("comment",ne._comment).replace("attribute",ne._attribute).getRegex(),ne._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ne._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ne._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ne.link=x(ne.link).replace("label",ne._label).replace("href",ne._href).replace("title",ne._title).getRegex(),ne.reflink=x(ne.reflink).replace("label",ne._label).getRegex(),ne.reflinkSearch=x(ne.reflinkSearch,"g").replace("reflink",ne.reflink).replace("nolink",ne.nolink).getRegex(),ne.normal=G({},ne),ne.pedantic=G({},ne.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:x(/^!?\[(label)\]\((.*?)\)/).replace("label",ne._label).getRegex(),reflink:x(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ne._label).getRegex()}),ne.gfm=G({},ne.normal,{escape:x(ne.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),ne.gfm.url=x(ne.gfm.url,"i").replace("email",ne.gfm._extended_email).getRegex(),ne.breaks=G({},ne.gfm,{br:x(ne.br).replace("{2,}","*").getRegex(),text:x(ne.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var me={block:X,inline:ne},Le=y.defaults,We=me.block,Fe=me.inline,ze=U.repeatString;function $(ye){return ye.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function j(ye){var Ee="",Ce,re,le=ye.length;for(Ce=0;Ce<le;Ce++)re=ye.charCodeAt(Ce),Math.random()>.5&&(re="x"+re.toString(16)),Ee+="&#"+re+";";return Ee}var te=function(){function ye(Ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ce||Le,this.options.tokenizer=this.options.tokenizer||new L,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var re={block:We.normal,inline:Fe.normal};this.options.pedantic?(re.block=We.pedantic,re.inline=Fe.pedantic):this.options.gfm&&(re.block=We.gfm,this.options.breaks?re.inline=Fe.breaks:re.inline=Fe.gfm),this.tokenizer.rules=re}ye.lex=function(re,le){var N=new ye(le);return N.lex(re)},ye.lexInline=function(re,le){var N=new ye(le);return N.inlineTokens(re)};var Ee=ye.prototype;return Ee.lex=function(re){return re=re.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(re,this.tokens,!0),this.inline(this.tokens),this.tokens},Ee.blockTokens=function(re,le,N){le===void 0&&(le=[]),N===void 0&&(N=!0),this.options.pedantic&&(re=re.replace(/^ +$/gm,""));for(var Q,ae,ke,Ie;re;){if(Q=this.tokenizer.space(re)){re=re.substring(Q.raw.length),Q.type&&le.push(Q);continue}if(Q=this.tokenizer.code(re)){re=re.substring(Q.raw.length),Ie=le[le.length-1],Ie&&Ie.type==="paragraph"?(Ie.raw+=`
`+Q.raw,Ie.text+=`
`+Q.text):le.push(Q);continue}if(Q=this.tokenizer.fences(re)){re=re.substring(Q.raw.length),le.push(Q);continue}if(Q=this.tokenizer.heading(re)){re=re.substring(Q.raw.length),le.push(Q);continue}if(Q=this.tokenizer.nptable(re)){re=re.substring(Q.raw.length),le.push(Q);continue}if(Q=this.tokenizer.hr(re)){re=re.substring(Q.raw.length),le.push(Q);continue}if(Q=this.tokenizer.blockquote(re)){re=re.substring(Q.raw.length),Q.tokens=this.blockTokens(Q.text,[],N),le.push(Q);continue}if(Q=this.tokenizer.list(re)){for(re=re.substring(Q.raw.length),ke=Q.items.length,ae=0;ae<ke;ae++)Q.items[ae].tokens=this.blockTokens(Q.items[ae].text,[],!1);le.push(Q);continue}if(Q=this.tokenizer.html(re)){re=re.substring(Q.raw.length),le.push(Q);continue}if(N&&(Q=this.tokenizer.def(re))){re=re.substring(Q.raw.length),this.tokens.links[Q.tag]||(this.tokens.links[Q.tag]={href:Q.href,title:Q.title});continue}if(Q=this.tokenizer.table(re)){re=re.substring(Q.raw.length),le.push(Q);continue}if(Q=this.tokenizer.lheading(re)){re=re.substring(Q.raw.length),le.push(Q);continue}if(N&&(Q=this.tokenizer.paragraph(re))){re=re.substring(Q.raw.length),le.push(Q);continue}if(Q=this.tokenizer.text(re)){re=re.substring(Q.raw.length),Ie=le[le.length-1],Ie&&Ie.type==="text"?(Ie.raw+=`
`+Q.raw,Ie.text+=`
`+Q.text):le.push(Q);continue}if(re){var Ae="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return le},Ee.inline=function(re){var le,N,Q,ae,ke,Ie,Ae=re.length;for(le=0;le<Ae;le++)switch(Ie=re[le],Ie.type){case"paragraph":case"text":case"heading":{Ie.tokens=[],this.inlineTokens(Ie.text,Ie.tokens);break}case"table":{for(Ie.tokens={header:[],cells:[]},ae=Ie.header.length,N=0;N<ae;N++)Ie.tokens.header[N]=[],this.inlineTokens(Ie.header[N],Ie.tokens.header[N]);for(ae=Ie.cells.length,N=0;N<ae;N++)for(ke=Ie.cells[N],Ie.tokens.cells[N]=[],Q=0;Q<ke.length;Q++)Ie.tokens.cells[N][Q]=[],this.inlineTokens(ke[Q],Ie.tokens.cells[N][Q]);break}case"blockquote":{this.inline(Ie.tokens);break}case"list":{for(ae=Ie.items.length,N=0;N<ae;N++)this.inline(Ie.items[N].tokens);break}}return re},Ee.inlineTokens=function(re,le,N,Q){le===void 0&&(le=[]),N===void 0&&(N=!1),Q===void 0&&(Q=!1);var ae,ke,Ie=re,Ae,xe,Ye;if(this.tokens.links){var rt=Object.keys(this.tokens.links);if(rt.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(Ie))!=null;)rt.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(Ie=Ie.slice(0,Ae.index)+"["+ze("a",Ae[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(Ie))!=null;)Ie=Ie.slice(0,Ae.index)+"["+ze("a",Ae[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(Ie))!=null;)Ie=Ie.slice(0,Ae.index)+"++"+Ie.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;re;){if(xe||(Ye=""),xe=!1,ae=this.tokenizer.escape(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.tag(re,N,Q)){re=re.substring(ae.raw.length),N=ae.inLink,Q=ae.inRawBlock;var tt=le[le.length-1];tt&&ae.type==="text"&&tt.type==="text"?(tt.raw+=ae.raw,tt.text+=ae.text):le.push(ae);continue}if(ae=this.tokenizer.link(re)){re=re.substring(ae.raw.length),ae.type==="link"&&(ae.tokens=this.inlineTokens(ae.text,[],!0,Q)),le.push(ae);continue}if(ae=this.tokenizer.reflink(re,this.tokens.links)){re=re.substring(ae.raw.length);var Qe=le[le.length-1];ae.type==="link"?(ae.tokens=this.inlineTokens(ae.text,[],!0,Q),le.push(ae)):Qe&&ae.type==="text"&&Qe.type==="text"?(Qe.raw+=ae.raw,Qe.text+=ae.text):le.push(ae);continue}if(ae=this.tokenizer.emStrong(re,Ie,Ye)){re=re.substring(ae.raw.length),ae.tokens=this.inlineTokens(ae.text,[],N,Q),le.push(ae);continue}if(ae=this.tokenizer.codespan(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.br(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.del(re)){re=re.substring(ae.raw.length),ae.tokens=this.inlineTokens(ae.text,[],N,Q),le.push(ae);continue}if(ae=this.tokenizer.autolink(re,j)){re=re.substring(ae.raw.length),le.push(ae);continue}if(!N&&(ae=this.tokenizer.url(re,j))){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.inlineText(re,Q,$)){re=re.substring(ae.raw.length),ae.raw.slice(-1)!=="_"&&(Ye=ae.raw.slice(-1)),xe=!0,ke=le[le.length-1],ke&&ke.type==="text"?(ke.raw+=ae.raw,ke.text+=ae.text):le.push(ae);continue}if(re){var mt="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(mt);break}else throw new Error(mt)}}return le},e(ye,null,[{key:"rules",get:function(){return{block:We,inline:Fe}}}]),ye}(),oe=y.defaults,de=U.cleanUrl,_e=U.escape,Be=function(){function ye(Ce){this.options=Ce||oe}var Ee=ye.prototype;return Ee.code=function(re,le,N){var Q=(le||"").match(/\S*/)[0];if(this.options.highlight){var ae=this.options.highlight(re,Q);ae!=null&&ae!==re&&(N=!0,re=ae)}return re=re.replace(/\n$/,"")+`
`,Q?'<pre><code class="'+this.options.langPrefix+_e(Q,!0)+'">'+(N?re:_e(re,!0))+`</code></pre>
`:"<pre><code>"+(N?re:_e(re,!0))+`</code></pre>
`},Ee.blockquote=function(re){return`<blockquote>
`+re+`</blockquote>
`},Ee.html=function(re){return re},Ee.heading=function(re,le,N,Q){return this.options.headerIds?"<h"+le+' id="'+this.options.headerPrefix+Q.slug(N)+'">'+re+"</h"+le+`>
`:"<h"+le+">"+re+"</h"+le+`>
`},Ee.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Ee.list=function(re,le,N){var Q=le?"ol":"ul",ae=le&&N!==1?' start="'+N+'"':"";return"<"+Q+ae+`>
`+re+"</"+Q+`>
`},Ee.listitem=function(re){return"<li>"+re+`</li>
`},Ee.checkbox=function(re){return"<input "+(re?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Ee.paragraph=function(re){return"<p>"+re+`</p>
`},Ee.table=function(re,le){return le&&(le="<tbody>"+le+"</tbody>"),`<table>
<thead>
`+re+`</thead>
`+le+`</table>
`},Ee.tablerow=function(re){return`<tr>
`+re+`</tr>
`},Ee.tablecell=function(re,le){var N=le.header?"th":"td",Q=le.align?"<"+N+' align="'+le.align+'">':"<"+N+">";return Q+re+"</"+N+`>
`},Ee.strong=function(re){return"<strong>"+re+"</strong>"},Ee.em=function(re){return"<em>"+re+"</em>"},Ee.codespan=function(re){return"<code>"+re+"</code>"},Ee.br=function(){return this.options.xhtml?"<br/>":"<br>"},Ee.del=function(re){return"<del>"+re+"</del>"},Ee.link=function(re,le,N){if(re=de(this.options.sanitize,this.options.baseUrl,re),re===null)return N;var Q='<a href="'+_e(re)+'"';return le&&(Q+=' title="'+le+'"'),Q+=">"+N+"</a>",Q},Ee.image=function(re,le,N){if(re=de(this.options.sanitize,this.options.baseUrl,re),re===null)return N;var Q='<img src="'+re+'" alt="'+N+'"';return le&&(Q+=' title="'+le+'"'),Q+=this.options.xhtml?"/>":">",Q},Ee.text=function(re){return re},ye}(),fe=function(){function ye(){}var Ee=ye.prototype;return Ee.strong=function(re){return re},Ee.em=function(re){return re},Ee.codespan=function(re){return re},Ee.del=function(re){return re},Ee.html=function(re){return re},Ee.text=function(re){return re},Ee.link=function(re,le,N){return""+N},Ee.image=function(re,le,N){return""+N},Ee.br=function(){return""},ye}(),De=function(){function ye(){this.seen={}}var Ee=ye.prototype;return Ee.serialize=function(re){return re.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Ee.getNextSafeSlug=function(re,le){var N=re,Q=0;if(this.seen.hasOwnProperty(N)){Q=this.seen[re];do Q++,N=re+"-"+Q;while(this.seen.hasOwnProperty(N))}return le||(this.seen[re]=Q,this.seen[N]=0),N},Ee.slug=function(re,le){le===void 0&&(le={});var N=this.serialize(re);return this.getNextSafeSlug(N,le.dryrun)},ye}(),Re=y.defaults,He=U.unescape,we=function(){function ye(Ce){this.options=Ce||Re,this.options.renderer=this.options.renderer||new Be,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new fe,this.slugger=new De}ye.parse=function(re,le){var N=new ye(le);return N.parse(re)},ye.parseInline=function(re,le){var N=new ye(le);return N.parseInline(re)};var Ee=ye.prototype;return Ee.parse=function(re,le){le===void 0&&(le=!0);var N="",Q,ae,ke,Ie,Ae,xe,Ye,rt,tt,Qe,mt,bt,pe,ce,se,q,Me,Te,Je=re.length;for(Q=0;Q<Je;Q++)switch(Qe=re[Q],Qe.type){case"space":continue;case"hr":{N+=this.renderer.hr();continue}case"heading":{N+=this.renderer.heading(this.parseInline(Qe.tokens),Qe.depth,He(this.parseInline(Qe.tokens,this.textRenderer)),this.slugger);continue}case"code":{N+=this.renderer.code(Qe.text,Qe.lang,Qe.escaped);continue}case"table":{for(rt="",Ye="",Ie=Qe.header.length,ae=0;ae<Ie;ae++)Ye+=this.renderer.tablecell(this.parseInline(Qe.tokens.header[ae]),{header:!0,align:Qe.align[ae]});for(rt+=this.renderer.tablerow(Ye),tt="",Ie=Qe.cells.length,ae=0;ae<Ie;ae++){for(xe=Qe.tokens.cells[ae],Ye="",Ae=xe.length,ke=0;ke<Ae;ke++)Ye+=this.renderer.tablecell(this.parseInline(xe[ke]),{header:!1,align:Qe.align[ke]});tt+=this.renderer.tablerow(Ye)}N+=this.renderer.table(rt,tt);continue}case"blockquote":{tt=this.parse(Qe.tokens),N+=this.renderer.blockquote(tt);continue}case"list":{for(mt=Qe.ordered,bt=Qe.start,pe=Qe.loose,Ie=Qe.items.length,tt="",ae=0;ae<Ie;ae++)se=Qe.items[ae],q=se.checked,Me=se.task,ce="",se.task&&(Te=this.renderer.checkbox(q),pe?se.tokens.length>0&&se.tokens[0].type==="text"?(se.tokens[0].text=Te+" "+se.tokens[0].text,se.tokens[0].tokens&&se.tokens[0].tokens.length>0&&se.tokens[0].tokens[0].type==="text"&&(se.tokens[0].tokens[0].text=Te+" "+se.tokens[0].tokens[0].text)):se.tokens.unshift({type:"text",text:Te}):ce+=Te),ce+=this.parse(se.tokens,pe),tt+=this.renderer.listitem(ce,Me,q);N+=this.renderer.list(tt,mt,bt);continue}case"html":{N+=this.renderer.html(Qe.text);continue}case"paragraph":{N+=this.renderer.paragraph(this.parseInline(Qe.tokens));continue}case"text":{for(tt=Qe.tokens?this.parseInline(Qe.tokens):Qe.text;Q+1<Je&&re[Q+1].type==="text";)Qe=re[++Q],tt+=`
`+(Qe.tokens?this.parseInline(Qe.tokens):Qe.text);N+=le?this.renderer.paragraph(tt):tt;continue}default:{var et='Token with "'+Qe.type+'" type was not found.';if(this.options.silent){console.error(et);return}else throw new Error(et)}}return N},Ee.parseInline=function(re,le){le=le||this.renderer;var N="",Q,ae,ke=re.length;for(Q=0;Q<ke;Q++)switch(ae=re[Q],ae.type){case"escape":{N+=le.text(ae.text);break}case"html":{N+=le.html(ae.text);break}case"link":{N+=le.link(ae.href,ae.title,this.parseInline(ae.tokens,le));break}case"image":{N+=le.image(ae.href,ae.title,ae.text);break}case"strong":{N+=le.strong(this.parseInline(ae.tokens,le));break}case"em":{N+=le.em(this.parseInline(ae.tokens,le));break}case"codespan":{N+=le.codespan(ae.text);break}case"br":{N+=le.br();break}case"del":{N+=le.del(this.parseInline(ae.tokens,le));break}case"text":{N+=le.text(ae.text);break}default:{var Ie='Token with "'+ae.type+'" type was not found.';if(this.options.silent){console.error(Ie);return}else throw new Error(Ie)}}return N},ye}(),qe=U.merge,z=U.checkSanitizeDeprecation,ee=U.escape,ge=y.getDefaults,Ne=y.changeDefaults,Ve=y.defaults;function $e(ye,Ee,Ce){if(typeof ye=="undefined"||ye===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ye!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ye)+", string expected");if(typeof Ee=="function"&&(Ce=Ee,Ee=null),Ee=qe({},$e.defaults,Ee||{}),z(Ee),Ce){var re=Ee.highlight,le;try{le=te.lex(ye,Ee)}catch(ke){return Ce(ke)}var N=function(Ie){var Ae;if(!Ie)try{Ae=we.parse(le,Ee)}catch(xe){Ie=xe}return Ee.highlight=re,Ie?Ce(Ie):Ce(null,Ae)};if(!re||re.length<3||(delete Ee.highlight,!le.length))return N();var Q=0;$e.walkTokens(le,function(ke){ke.type==="code"&&(Q++,setTimeout(function(){re(ke.text,ke.lang,function(Ie,Ae){if(Ie)return N(Ie);Ae!=null&&Ae!==ke.text&&(ke.text=Ae,ke.escaped=!0),Q--,Q===0&&N()})},0))}),Q===0&&N();return}try{var ae=te.lex(ye,Ee);return Ee.walkTokens&&$e.walkTokens(ae,Ee.walkTokens),we.parse(ae,Ee)}catch(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,Ee.silent)return"<p>An error occurred:</p><pre>"+ee(ke.message+"",!0)+"</pre>";throw ke}}$e.options=$e.setOptions=function(ye){return qe($e.defaults,ye),Ne($e.defaults),$e},$e.getDefaults=ge,$e.defaults=Ve,$e.use=function(ye){var Ee=qe({},ye);if(ye.renderer&&function(){var re=$e.defaults.renderer||new Be,le=function(ae){var ke=re[ae];re[ae]=function(){for(var Ie=arguments.length,Ae=new Array(Ie),xe=0;xe<Ie;xe++)Ae[xe]=arguments[xe];var Ye=ye.renderer[ae].apply(re,Ae);return Ye===!1&&(Ye=ke.apply(re,Ae)),Ye}};for(var N in ye.renderer)le(N);Ee.renderer=re}(),ye.tokenizer&&function(){var re=$e.defaults.tokenizer||new L,le=function(ae){var ke=re[ae];re[ae]=function(){for(var Ie=arguments.length,Ae=new Array(Ie),xe=0;xe<Ie;xe++)Ae[xe]=arguments[xe];var Ye=ye.tokenizer[ae].apply(re,Ae);return Ye===!1&&(Ye=ke.apply(re,Ae)),Ye}};for(var N in ye.tokenizer)le(N);Ee.tokenizer=re}(),ye.walkTokens){var Ce=$e.defaults.walkTokens;Ee.walkTokens=function(re){ye.walkTokens(re),Ce&&Ce(re)}}$e.setOptions(Ee)},$e.walkTokens=function(ye,Ee){for(var Ce=A(ye),re;!(re=Ce()).done;){var le=re.value;switch(Ee(le),le.type){case"table":{for(var N=A(le.tokens.header),Q;!(Q=N()).done;){var ae=Q.value;$e.walkTokens(ae,Ee)}for(var ke=A(le.tokens.cells),Ie;!(Ie=ke()).done;)for(var Ae=Ie.value,xe=A(Ae),Ye;!(Ye=xe()).done;){var rt=Ye.value;$e.walkTokens(rt,Ee)}break}case"list":{$e.walkTokens(le.items,Ee);break}default:le.tokens&&$e.walkTokens(le.tokens,Ee)}}},$e.parseInline=function(ye,Ee){if(typeof ye=="undefined"||ye===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ye!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ye)+", string expected");Ee=qe({},$e.defaults,Ee||{}),z(Ee);try{var Ce=te.lexInline(ye,Ee);return Ee.walkTokens&&$e.walkTokens(Ce,Ee.walkTokens),we.parseInline(Ce,Ee)}catch(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,Ee.silent)return"<p>An error occurred:</p><pre>"+ee(re.message+"",!0)+"</pre>";throw re}},$e.Parser=we,$e.parser=we.parse,$e.Renderer=Be,$e.TextRenderer=fe,$e.Lexer=te,$e.lexer=te.lex,$e.Tokenizer=L,$e.Slugger=De,$e.parse=$e;var Ze=$e;return Ze}),define(ve[81],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function _(y,D,S){return Math.min(Math.max(y,D),S)}e.clamp=_;function k(y,D){return(D+y%D)%D}e.rot=k;class A{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=A;class T{constructor(){this._n=1,this._val=0}update(D){return this._val=this._val+(D-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=T});"use strict";(function(){function J(A){const T=[];typeof A=="number"&&T.push("code/timeOrigin",A);function y(S){T.push(S,Date.now())}function D(){const S=[];for(let C=0;C<T.length;C+=2)S.push({name:T[C],startTime:T[C+1]});return S}return{mark:y,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const y of performance.getEntriesByType("mark"))T.push({name:y.name,startTime:Math.round(A+y.startTime)});return T}};if(typeof process=="object"){const A=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function _(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var k;typeof global=="object"?k=global:typeof self=="object"?k=self:k={},typeof define=="function"?define("vs/base/common/performance",[],function(){return _(k)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=_(k):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),k.perf=_(k))})(),define(ve[21],be([0,1]),function(J,e){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const k="en";let A=!1,T=!1,y=!1,D=!1,S=!1,C=!1,i=!1,I,d=k,f,r;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let o;typeof e.globals.vscode!="undefined"?o=e.globals.vscode.process:typeof process!="undefined"&&(o=process);const p=typeof((_=o==null?void 0:o.versions)===null||_===void 0?void 0:_.electron)=="string"&&o.type==="renderer";if(e.isElectronSandboxed=p&&(o==null?void 0:o.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const a=o==null?void 0:o.env.VSCODE_BROWSER_CODE_LOADING;if(typeof a=="string")return a==="none"||a==="code"||a==="bypassHeatCheck"||a==="bypassHeatCheckAndEagerCompile"?a:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!p)r=navigator.userAgent,A=r.indexOf("Windows")>=0,T=r.indexOf("Macintosh")>=0,i=(r.indexOf("Macintosh")>=0||r.indexOf("iPad")>=0||r.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=r.indexOf("Linux")>=0,C=!0,I=navigator.language,d=I;else if(typeof o=="object"){A=o.platform==="win32",T=o.platform==="darwin",y=o.platform==="linux",D=y&&!!o.env.SNAP&&!!o.env.SNAP_REVISION,I=k,d=k;const a=o.env.VSCODE_NLS_CONFIG;if(a)try{const s=JSON.parse(a),c=s.availableLanguages["*"];I=s.locale,d=c||k,f=s._translationsConfigFile}catch(s){}S=!0}else console.error("Unable to resolve platform.");var g;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(g=e.Platform||(e.Platform={}));function E(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=E;let m=0;T?m=1:A?m=3:y&&(m=2),e.isWindows=A,e.isMacintosh=T,e.isLinux=y,e.isLinuxSnap=D,e.isNative=S,e.isWeb=C,e.isIOS=i,e.platform=m,e.userAgent=r,e.language=d;var u;(function(a){function s(){return e.language}a.value=s;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=c;function v(){return e.language==="en"}a.isDefault=v})(u=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=f,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let c=[];e.globals.addEventListener("message",P=>{if(P.data&&P.data.vscodeSetImmediateId)for(let h=0,b=c.length;h<b;h++){const R=c[h];if(R.id===P.data.vscodeSetImmediateId){c.splice(h,1),R.callback();return}}});let v=0;return P=>{const h=++v;c.push({id:h,callback:P}),e.globals.postMessage({vscodeSetImmediateId:h},"*")}}if(typeof(o==null?void 0:o.nextTick)=="function")return o.nextTick.bind(o);const s=Promise.resolve();return c=>s.then(c)}();var w;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(w=e.OperatingSystem||(e.OperatingSystem={})),e.OS=T||i?2:A?1:3;let t=!0,n=!1;function l(){if(!n){n=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,t=new Uint16Array(a.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=l}),define(ve[46],be([0,1,21]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let k;if(typeof _.globals.vscode!="undefined"){const A=_.globals.vscode.process;k={get platform(){return A.platform},get env(){return A.env},cwd(){return A.cwd()},nextTick(T){return(0,_.setImmediate)(T)}}}else typeof process!="undefined"?k={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(A){return process.nextTick(A)}}:k={get platform(){return _.isWindows?"win32":_.isMacintosh?"darwin":"linux"},nextTick(A){return(0,_.setImmediate)(A)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=k.cwd,e.env=k.env,e.platform=k.platform,e.nextTick=k.nextTick}),define(ve[13],be([0,1,46]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const k=65,A=97,T=90,y=122,D=46,S=47,C=92,i=58,I=63;class d extends Error{constructor(u,w,t){let n;typeof w=="string"&&w.indexOf("not ")===0?(n="must not be",w=w.replace(/^not /,"")):n="must be";const l=u.indexOf(".")!==-1?"property":"argument";let a=`The "${u}" ${l} ${n} of type ${w}`;a+=`. Received type ${typeof t}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function f(m,u){if(typeof m!="string")throw new d(u,"string",m)}function r(m){return m===S||m===C}function o(m){return m===S}function p(m){return m>=k&&m<=T||m>=A&&m<=y}function g(m,u,w,t){let n="",l=0,a=-1,s=0,c=0;for(let v=0;v<=m.length;++v){if(v<m.length)c=m.charCodeAt(v);else{if(t(c))break;c=S}if(t(c)){if(!(a===v-1||s===1))if(s===2){if(n.length<2||l!==2||n.charCodeAt(n.length-1)!==D||n.charCodeAt(n.length-2)!==D){if(n.length>2){const P=n.lastIndexOf(w);P===-1?(n="",l=0):(n=n.slice(0,P),l=n.length-1-n.lastIndexOf(w)),a=v,s=0;continue}else if(n.length!==0){n="",l=0,a=v,s=0;continue}}u&&(n+=n.length>0?`${w}..`:"..",l=2)}else n.length>0?n+=`${w}${m.slice(a+1,v)}`:n=m.slice(a+1,v),l=v-a-1;a=v,s=0}else c===D&&s!==-1?++s:s=-1}return n}function E(m,u){if(u===null||typeof u!="object")throw new d("pathObject","Object",u);const w=u.dir||u.root,t=u.base||`${u.name||""}${u.ext||""}`;return w?w===u.root?`${w}${t}`:`${w}${m}${t}`:t}e.win32={resolve(...m){let u="",w="",t=!1;for(let n=m.length-1;n>=-1;n--){let l;if(n>=0){if(l=m[n],f(l,"path"),l.length===0)continue}else u.length===0?l=_.cwd():(l=_.env[`=${u}`]||_.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==u.toLowerCase()&&l.charCodeAt(2)===C)&&(l=`${u}\\`));const a=l.length;let s=0,c="",v=!1;const P=l.charCodeAt(0);if(a===1)r(P)&&(s=1,v=!0);else if(r(P))if(v=!0,r(l.charCodeAt(1))){let h=2,b=h;for(;h<a&&!r(l.charCodeAt(h));)h++;if(h<a&&h!==b){const R=l.slice(b,h);for(b=h;h<a&&r(l.charCodeAt(h));)h++;if(h<a&&h!==b){for(b=h;h<a&&!r(l.charCodeAt(h));)h++;(h===a||h!==b)&&(c=`\\\\${R}\\${l.slice(b,h)}`,s=h)}}}else s=1;else p(P)&&l.charCodeAt(1)===i&&(c=l.slice(0,2),s=2,a>2&&r(l.charCodeAt(2))&&(v=!0,s=3));if(c.length>0)if(u.length>0){if(c.toLowerCase()!==u.toLowerCase())continue}else u=c;if(t){if(u.length>0)break}else if(w=`${l.slice(s)}\\${w}`,t=v,v&&u.length>0)break}return w=g(w,!t,"\\",r),t?`${u}\\${w}`:`${u}${w}`||"."},normalize(m){f(m,"path");const u=m.length;if(u===0)return".";let w=0,t,n=!1;const l=m.charCodeAt(0);if(u===1)return o(l)?"\\":m;if(r(l))if(n=!0,r(m.charCodeAt(1))){let s=2,c=s;for(;s<u&&!r(m.charCodeAt(s));)s++;if(s<u&&s!==c){const v=m.slice(c,s);for(c=s;s<u&&r(m.charCodeAt(s));)s++;if(s<u&&s!==c){for(c=s;s<u&&!r(m.charCodeAt(s));)s++;if(s===u)return`\\\\${v}\\${m.slice(c)}\\`;s!==c&&(t=`\\\\${v}\\${m.slice(c,s)}`,w=s)}}}else w=1;else p(l)&&m.charCodeAt(1)===i&&(t=m.slice(0,2),w=2,u>2&&r(m.charCodeAt(2))&&(n=!0,w=3));let a=w<u?g(m.slice(w),!n,"\\",r):"";return a.length===0&&!n&&(a="."),a.length>0&&r(m.charCodeAt(u-1))&&(a+="\\"),t===void 0?n?`\\${a}`:a:n?`${t}\\${a}`:`${t}${a}`},isAbsolute(m){f(m,"path");const u=m.length;if(u===0)return!1;const w=m.charCodeAt(0);return r(w)||u>2&&p(w)&&m.charCodeAt(1)===i&&r(m.charCodeAt(2))},join(...m){if(m.length===0)return".";let u,w;for(let l=0;l<m.length;++l){const a=m[l];f(a,"path"),a.length>0&&(u===void 0?u=w=a:u+=`\\${a}`)}if(u===void 0)return".";let t=!0,n=0;if(typeof w=="string"&&r(w.charCodeAt(0))){++n;const l=w.length;l>1&&r(w.charCodeAt(1))&&(++n,l>2&&(r(w.charCodeAt(2))?++n:t=!1))}if(t){for(;n<u.length&&r(u.charCodeAt(n));)n++;n>=2&&(u=`\\${u.slice(n)}`)}return e.win32.normalize(u)},relative(m,u){if(f(m,"from"),f(u,"to"),m===u)return"";const w=e.win32.resolve(m),t=e.win32.resolve(u);if(w===t||(m=w.toLowerCase(),u=t.toLowerCase(),m===u))return"";let n=0;for(;n<m.length&&m.charCodeAt(n)===C;)n++;let l=m.length;for(;l-1>n&&m.charCodeAt(l-1)===C;)l--;const a=l-n;let s=0;for(;s<u.length&&u.charCodeAt(s)===C;)s++;let c=u.length;for(;c-1>s&&u.charCodeAt(c-1)===C;)c--;const v=c-s,P=a<v?a:v;let h=-1,b=0;for(;b<P;b++){const U=m.charCodeAt(n+b);if(U!==u.charCodeAt(s+b))break;U===C&&(h=b)}if(b!==P){if(h===-1)return t}else{if(v>P){if(u.charCodeAt(s+b)===C)return t.slice(s+b+1);if(b===2)return t.slice(s+b)}a>P&&(m.charCodeAt(n+b)===C?h=b:b===2&&(h=3)),h===-1&&(h=0)}let R="";for(b=n+h+1;b<=l;++b)(b===l||m.charCodeAt(b)===C)&&(R+=R.length===0?"..":"\\..");return s+=h,R.length>0?`${R}${t.slice(s,c)}`:(t.charCodeAt(s)===C&&++s,t.slice(s,c))},toNamespacedPath(m){if(typeof m!="string")return m;if(m.length===0)return"";const u=e.win32.resolve(m);if(u.length<=2)return m;if(u.charCodeAt(0)===C){if(u.charCodeAt(1)===C){const w=u.charCodeAt(2);if(w!==I&&w!==D)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(p(u.charCodeAt(0))&&u.charCodeAt(1)===i&&u.charCodeAt(2)===C)return`\\\\?\\${u}`;return m},dirname(m){f(m,"path");const u=m.length;if(u===0)return".";let w=-1,t=0;const n=m.charCodeAt(0);if(u===1)return r(n)?m:".";if(r(n)){if(w=t=1,r(m.charCodeAt(1))){let s=2,c=s;for(;s<u&&!r(m.charCodeAt(s));)s++;if(s<u&&s!==c){for(c=s;s<u&&r(m.charCodeAt(s));)s++;if(s<u&&s!==c){for(c=s;s<u&&!r(m.charCodeAt(s));)s++;if(s===u)return m;s!==c&&(w=t=s+1)}}}}else p(n)&&m.charCodeAt(1)===i&&(w=u>2&&r(m.charCodeAt(2))?3:2,t=w);let l=-1,a=!0;for(let s=u-1;s>=t;--s)if(r(m.charCodeAt(s))){if(!a){l=s;break}}else a=!1;if(l===-1){if(w===-1)return".";l=w}return m.slice(0,l)},basename(m,u){u!==void 0&&f(u,"ext"),f(m,"path");let w=0,t=-1,n=!0,l;if(m.length>=2&&p(m.charCodeAt(0))&&m.charCodeAt(1)===i&&(w=2),u!==void 0&&u.length>0&&u.length<=m.length){if(u===m)return"";let a=u.length-1,s=-1;for(l=m.length-1;l>=w;--l){const c=m.charCodeAt(l);if(r(c)){if(!n){w=l+1;break}}else s===-1&&(n=!1,s=l+1),a>=0&&(c===u.charCodeAt(a)?--a==-1&&(t=l):(a=-1,t=s))}return w===t?t=s:t===-1&&(t=m.length),m.slice(w,t)}for(l=m.length-1;l>=w;--l)if(r(m.charCodeAt(l))){if(!n){w=l+1;break}}else t===-1&&(n=!1,t=l+1);return t===-1?"":m.slice(w,t)},extname(m){f(m,"path");let u=0,w=-1,t=0,n=-1,l=!0,a=0;m.length>=2&&m.charCodeAt(1)===i&&p(m.charCodeAt(0))&&(u=t=2);for(let s=m.length-1;s>=u;--s){const c=m.charCodeAt(s);if(r(c)){if(!l){t=s+1;break}continue}n===-1&&(l=!1,n=s+1),c===D?w===-1?w=s:a!==1&&(a=1):w!==-1&&(a=-1)}return w===-1||n===-1||a===0||a===1&&w===n-1&&w===t+1?"":m.slice(w,n)},format:E.bind(null,"\\"),parse(m){f(m,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return u;const w=m.length;let t=0,n=m.charCodeAt(0);if(w===1)return r(n)?(u.root=u.dir=m,u):(u.base=u.name=m,u);if(r(n)){if(t=1,r(m.charCodeAt(1))){let h=2,b=h;for(;h<w&&!r(m.charCodeAt(h));)h++;if(h<w&&h!==b){for(b=h;h<w&&r(m.charCodeAt(h));)h++;if(h<w&&h!==b){for(b=h;h<w&&!r(m.charCodeAt(h));)h++;h===w?t=h:h!==b&&(t=h+1)}}}}else if(p(n)&&m.charCodeAt(1)===i){if(w<=2)return u.root=u.dir=m,u;if(t=2,r(m.charCodeAt(2))){if(w===3)return u.root=u.dir=m,u;t=3}}t>0&&(u.root=m.slice(0,t));let l=-1,a=t,s=-1,c=!0,v=m.length-1,P=0;for(;v>=t;--v){if(n=m.charCodeAt(v),r(n)){if(!c){a=v+1;break}continue}s===-1&&(c=!1,s=v+1),n===D?l===-1?l=v:P!==1&&(P=1):l!==-1&&(P=-1)}return s!==-1&&(l===-1||P===0||P===1&&l===s-1&&l===a+1?u.base=u.name=m.slice(a,s):(u.name=m.slice(a,l),u.base=m.slice(a,s),u.ext=m.slice(l,s))),a>0&&a!==t?u.dir=m.slice(0,a-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...m){let u="",w=!1;for(let t=m.length-1;t>=-1&&!w;t--){const n=t>=0?m[t]:_.cwd();f(n,"path"),n.length!==0&&(u=`${n}/${u}`,w=n.charCodeAt(0)===S)}return u=g(u,!w,"/",o),w?`/${u}`:u.length>0?u:"."},normalize(m){if(f(m,"path"),m.length===0)return".";const u=m.charCodeAt(0)===S,w=m.charCodeAt(m.length-1)===S;return m=g(m,!u,"/",o),m.length===0?u?"/":w?"./":".":(w&&(m+="/"),u?`/${m}`:m)},isAbsolute(m){return f(m,"path"),m.length>0&&m.charCodeAt(0)===S},join(...m){if(m.length===0)return".";let u;for(let w=0;w<m.length;++w){const t=m[w];f(t,"path"),t.length>0&&(u===void 0?u=t:u+=`/${t}`)}return u===void 0?".":e.posix.normalize(u)},relative(m,u){if(f(m,"from"),f(u,"to"),m===u||(m=e.posix.resolve(m),u=e.posix.resolve(u),m===u))return"";const w=1,t=m.length,n=t-w,l=1,a=u.length-l,s=n<a?n:a;let c=-1,v=0;for(;v<s;v++){const h=m.charCodeAt(w+v);if(h!==u.charCodeAt(l+v))break;h===S&&(c=v)}if(v===s)if(a>s){if(u.charCodeAt(l+v)===S)return u.slice(l+v+1);if(v===0)return u.slice(l+v)}else n>s&&(m.charCodeAt(w+v)===S?c=v:v===0&&(c=0));let P="";for(v=w+c+1;v<=t;++v)(v===t||m.charCodeAt(v)===S)&&(P+=P.length===0?"..":"/..");return`${P}${u.slice(l+c)}`},toNamespacedPath(m){return m},dirname(m){if(f(m,"path"),m.length===0)return".";const u=m.charCodeAt(0)===S;let w=-1,t=!0;for(let n=m.length-1;n>=1;--n)if(m.charCodeAt(n)===S){if(!t){w=n;break}}else t=!1;return w===-1?u?"/":".":u&&w===1?"//":m.slice(0,w)},basename(m,u){u!==void 0&&f(u,"ext"),f(m,"path");let w=0,t=-1,n=!0,l;if(u!==void 0&&u.length>0&&u.length<=m.length){if(u===m)return"";let a=u.length-1,s=-1;for(l=m.length-1;l>=0;--l){const c=m.charCodeAt(l);if(c===S){if(!n){w=l+1;break}}else s===-1&&(n=!1,s=l+1),a>=0&&(c===u.charCodeAt(a)?--a==-1&&(t=l):(a=-1,t=s))}return w===t?t=s:t===-1&&(t=m.length),m.slice(w,t)}for(l=m.length-1;l>=0;--l)if(m.charCodeAt(l)===S){if(!n){w=l+1;break}}else t===-1&&(n=!1,t=l+1);return t===-1?"":m.slice(w,t)},extname(m){f(m,"path");let u=-1,w=0,t=-1,n=!0,l=0;for(let a=m.length-1;a>=0;--a){const s=m.charCodeAt(a);if(s===S){if(!n){w=a+1;break}continue}t===-1&&(n=!1,t=a+1),s===D?u===-1?u=a:l!==1&&(l=1):u!==-1&&(l=-1)}return u===-1||t===-1||l===0||l===1&&u===t-1&&u===w+1?"":m.slice(u,t)},format:E.bind(null,"/"),parse(m){f(m,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return u;const w=m.charCodeAt(0)===S;let t;w?(u.root="/",t=1):t=0;let n=-1,l=0,a=-1,s=!0,c=m.length-1,v=0;for(;c>=t;--c){const P=m.charCodeAt(c);if(P===S){if(!s){l=c+1;break}continue}a===-1&&(s=!1,a=c+1),P===D?n===-1?n=c:v!==1&&(v=1):n!==-1&&(v=-1)}if(a!==-1){const P=l===0&&w?1:l;n===-1||v===0||v===1&&n===a-1&&n===l+1?u.base=u.name=m.slice(P,a):(u.name=m.slice(P,n),u.base=m.slice(P,a),u.ext=m.slice(n,a))}return l>0?u.dir=m.slice(0,l-1):w&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=_.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=_.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=_.platform==="win32"?e.win32.join:e.posix.join,e.resolve=_.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=_.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=_.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=_.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=_.platform==="win32"?e.win32.extname:e.posix.extname,e.format=_.platform==="win32"?e.win32.format:e.posix.format,e.parse=_.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=_.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=_.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=_.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ve[55],be([0,1,21]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const k=_.globals.performance&&typeof _.globals.performance.now=="function";class A{constructor(y){this._highResolution=k&&y,this._startTime=this._now(),this._stopTime=-1}static create(y=!0){return new A(y)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?_.globals.performance.now():Date.now()}}e.StopWatch=A}),define(ve[3],be([0,1,12,53,6,45,55]),function(J,e,_,k,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var D;(function(g){g.None=()=>A.Disposable.None;function E(V){return(H,Y=null,W)=>{let F=!1,L;return L=V(M=>{if(!F)return L?L.dispose():F=!0,H.call(Y,M)},null,W),F&&L.dispose(),L}}g.once=E;function m(V,H){return a((Y,W=null,F)=>V(L=>Y.call(W,H(L)),null,F))}g.map=m;function u(V,H){return a((Y,W=null,F)=>V(L=>{H(L),Y.call(W,L)},null,F))}g.forEach=u;function w(V,H){return a((Y,W=null,F)=>V(L=>H(L)&&Y.call(W,L),null,F))}g.filter=w;function t(V){return V}g.signal=t;function n(...V){return(H,Y=null,W)=>(0,A.combinedDisposable)(...V.map(F=>F(L=>H.call(Y,L),null,W)))}g.any=n;function l(V,H,Y){let W=Y;return m(V,F=>(W=H(W,F),W))}g.reduce=l;function a(V){let H;const Y=new d({onFirstListenerAdd(){H=V(Y.fire,Y)},onLastListenerRemove(){H.dispose()}});return Y.event}g.snapshot=a;function s(V,H,Y=100,W=!1,F){let L,M,x,G=0;const X=new d({leakWarningThreshold:F,onFirstListenerAdd(){L=V(ne=>{G++,M=H(M,ne),W&&!x&&(X.fire(M),M=void 0),clearTimeout(x),x=setTimeout(()=>{const me=M;M=void 0,x=void 0,(!W||G>1)&&X.fire(me),G=0},Y)})},onLastListenerRemove(){L.dispose()}});return X.event}g.debounce=s;function c(V){const H=new Date().getTime();return m(E(V),Y=>new Date().getTime()-H)}g.stopwatch=c;function v(V){let H=!0,Y;return w(V,W=>{const F=H||W!==Y;return H=!1,Y=W,F})}g.latch=v;function P(V,H=!1,Y=[]){let W=Y.slice(),F=V(x=>{W?W.push(x):M.fire(x)});const L=()=>{W&&W.forEach(x=>M.fire(x)),W=null},M=new d({onFirstListenerAdd(){F||(F=V(x=>M.fire(x)))},onFirstListenerDidAdd(){W&&(H?setTimeout(L):L())},onLastListenerRemove(){F&&F.dispose(),F=null}});return M.event}g.buffer=P;class h{constructor(H){this.event=H}map(H){return new h(m(this.event,H))}forEach(H){return new h(u(this.event,H))}filter(H){return new h(w(this.event,H))}reduce(H,Y){return new h(l(this.event,H,Y))}latch(){return new h(v(this.event))}debounce(H,Y=100,W=!1,F){return new h(s(this.event,H,Y,W,F))}on(H,Y,W){return this.event(H,Y,W)}once(H,Y,W){return E(this.event)(H,Y,W)}}function b(V){return new h(V)}g.chain=b;function R(V,H,Y=W=>W){const W=(...x)=>M.fire(Y(...x)),F=()=>V.on(H,W),L=()=>V.removeListener(H,W),M=new d({onFirstListenerAdd:F,onLastListenerRemove:L});return M.event}g.fromNodeEventEmitter=R;function U(V,H,Y=W=>W){const W=(...x)=>M.fire(Y(...x)),F=()=>V.addEventListener(H,W),L=()=>V.removeEventListener(H,W),M=new d({onFirstListenerAdd:F,onLastListenerRemove:L});return M.event}g.fromDOMEventEmitter=U;function K(V){const H=new d;let Y=!1;return V.then(void 0,()=>null).then(()=>{Y?H.fire(void 0):setTimeout(()=>H.fire(void 0),0)}),Y=!0,H.event}g.fromPromise=K;function he(V){return new Promise(H=>E(V)(H))}g.toPromise=he})(D=e.Event||(e.Event={}));class S{constructor(E){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${E}_${S._idPool++}`}start(E){this._stopWatch=new y.StopWatch(!0),this._listenerCount=E}stop(){if(this._stopWatch){const E=this._stopWatch.elapsed();this._elapsedOverall+=E,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${E.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}S._idPool=0;let C=-1;function i(g){const E=C;return C=g,{dispose(){C=E}}}e.setGlobalLeakWarningThreshold=i;class I{constructor(E,m=Math.random().toString(18).slice(2,5)){this.customThreshold=E,this.name=m,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(E){let m=C;if(typeof this.customThreshold=="number"&&(m=this.customThreshold),!(m<=0||E<m)){this._stacks||(this._stacks=new Map);const u=new Error().stack.split(`
`).slice(3).join(`
`),w=this._stacks.get(u)||0;if(this._stacks.set(u,w+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=m*.5;let t,n=0;for(const[l,a]of this._stacks)(!t||n<a)&&(t=l,n=a);console.warn(`[${this.name}] potential listener LEAK detected, having ${E} listeners already. MOST frequent listener (${n}):`),console.warn(t)}return()=>{const t=this._stacks.get(u)||0;this._stacks.set(u,t-1)}}}}class d{constructor(E){var m;this._disposed=!1,this._options=E,this._leakageMon=C>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((m=this._options)===null||m===void 0?void 0:m._profName)?new S(this._options._profName):void 0}get event(){return this._event||(this._event=(E,m,u)=>{var w;this._listeners||(this._listeners=new T.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(m?[E,m]:E);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,E,m);const l=(w=this._leakageMon)===null||w===void 0?void 0:w.check(this._listeners.size);let a;return a={dispose:()=>{l&&l(),a.dispose=d._noop,this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},u instanceof A.DisposableStore?u.add(a):Array.isArray(u)&&u.push(a),a}),this._event}fire(E){var m,u;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let w of this._listeners)this._deliveryQueue.push([w,E]);for((m=this._perfMon)===null||m===void 0||m.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[w,t]=this._deliveryQueue.shift();try{typeof w=="function"?w.call(void 0,t):w[0].call(w[1],t)}catch(n){(0,_.onUnexpectedError)(n)}}(u=this._perfMon)===null||u===void 0||u.stop()}}dispose(){var E,m,u;(E=this._listeners)===null||E===void 0||E.clear(),(m=this._deliveryQueue)===null||m===void 0||m.clear(),(u=this._leakageMon)===null||u===void 0||u.dispose(),this._disposed=!0}}e.Emitter=d,d._noop=function(){};class f extends d{constructor(E){super(E);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=E==null?void 0:E.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const E=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(E))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(E){this._listeners&&(this._isPaused!==0?this._eventQueue.push(E):super.fire(E))}}e.PauseableEmitter=f;class r{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new d({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(E){const m={event:E,listener:null};this.events.push(m),this.hasListeners&&this.hook(m);const u=()=>{this.hasListeners&&this.unhook(m);const w=this.events.indexOf(m);this.events.splice(w,1)};return(0,A.toDisposable)((0,k.once)(u))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(E=>this.hook(E))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(E=>this.unhook(E))}hook(E){E.listener=E.event(m=>this.emitter.fire(m))}unhook(E){E.listener&&E.listener.dispose(),E.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=r;class o{constructor(){this.buffers=[]}wrapEvent(E){return(m,u,w)=>E(t=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>m.call(u,t)):m.call(u,t)},void 0,w)}bufferEvents(E){const m=[];this.buffers.push(m);const u=E();return this.buffers.pop(),m.forEach(w=>w()),u}}e.EventBufferer=o;class p{constructor(){this.listening=!1,this.inputEvent=D.None,this.inputEventListener=A.Disposable.None,this.emitter=new d({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(E){this.inputEvent=E,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=E(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=p}),define(ve[20],be([0,1,3]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const k=Object.freeze(function(D,S){const C=setTimeout(D.bind(S),0);return{dispose(){clearTimeout(C)}}});var A;(function(D){function S(C){return C===D.None||C===D.Cancelled||C instanceof T?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}D.isCancellationToken=S,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:_.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:k})})(A=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?k:(this._emitter||(this._emitter=new _.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=A.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=A.None}}e.CancellationTokenSource=y}),define(ve[36],be([0,1,3]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class k{constructor(){this._icons=new Map,this._onDidRegister=new _.Emitter}add(I){const d=this._icons.get(I.id);d?I.description?d.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const A=new k;e.iconRegistry=A;function T(i,I){return new D(i,I)}e.registerCodicon=T;function y(i){return i?i.replace(/\$\((.*?)\)/g,(I,d)=>` ${d} `).trim():""}e.getCodiconAriaLabel=y;class D{constructor(I,d,f){this.id=I,this.definition=d,this.description=f,A.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=D;function S(i,I){const d=["codicon","codicon-"+i];return I&&d.push("codicon-modifier-"+I),d}e.getClassNamesArray=S;var C;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function d(o){if(o instanceof D)return["codicon","codicon-"+o.id];const p=I.exec(o.id);if(!p)return d(D.error);let[,g,E]=p;const m=["codicon","codicon-"+g];return E&&m.push("codicon-modifier-"+E.substr(1)),m}i.asClassNameArray=d;function f(o){return d(o).join(" ")}i.asClassName=f;function r(o){return"."+d(o).join(".")}i.asCSSSelector=r})(C=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(D=e.Codicon||(e.Codicon={}))}),define(ve[109],be([0,1,12,6]),function(J,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function A(m){const u=m;return u?[u.on,u.pause,u.resume,u.destroy].every(w=>typeof w=="function"):!1}e.isReadableStream=A;function T(m){const u=m;return u?A(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.isReadableBufferedStream=T;function y(m,u){return new D(m,u)}e.newWriteableStream=y;class D{constructor(u,w){this.reducer=u,this.options=w,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(u){var w;if(!this.state.destroyed){if(this.state.flowing)this.emitData(u);else if(this.buffer.data.push(u),typeof((w=this.options)===null||w===void 0?void 0:w.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(u){this.state.destroyed||(this.state.flowing?this.emitError(u):this.buffer.error.push(u))}end(u){this.state.destroyed||(typeof u!="undefined"&&this.write(u),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(u){this.listeners.data.slice(0).forEach(w=>w(u))}emitError(u){this.listeners.error.length===0?(0,_.onUnexpectedError)(u):this.listeners.error.slice(0).forEach(w=>w(u))}emitEnd(){this.listeners.end.slice(0).forEach(u=>u())}on(u,w){if(!this.state.destroyed)switch(u){case"data":this.listeners.data.push(w),this.resume();break;case"end":this.listeners.end.push(w),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(w),this.state.flowing&&this.flowErrors();break}}removeListener(u,w){if(!this.state.destroyed){let t;switch(u){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const n=t.indexOf(w);n>=0&&t.splice(n,1)}}}flowData(){if(this.buffer.data.length>0){const u=this.reducer(this.buffer.data);this.emitData(u),this.buffer.data.length=0;const w=[...this.pendingWritePromises];this.pendingWritePromises.length=0,w.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const u of this.buffer.error)this.emitError(u);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(m,u){const w=[];let t;for(;(t=m.read())!==null;)w.push(t);return u(w)}e.consumeReadable=S;function C(m,u,w){const t=[];let n;for(;(n=m.read())!==null&&t.length<w;)t.push(n);return n===null&&t.length>0?u(t):{read:()=>{if(t.length>0)return t.shift();if(typeof n!="undefined"){const l=n;return n=void 0,l}return m.read()}}}e.peekReadable=C;function i(m,u){return new Promise((w,t)=>{const n=[];I(m,{onData:l=>{u&&n.push(l)},onError:l=>{u?t(l):w(void 0)},onEnd:()=>{w(u?u(n):void 0)}})})}e.consumeStream=i;function I(m,u){m.on("error",w=>u.onError(w)),m.on("end",()=>u.onEnd()),m.on("data",w=>u.onData(w))}e.listenStream=I;function d(m,u){return new Promise((w,t)=>{const n=new k.DisposableStore,l=[],a=v=>{if(l.push(v),l.length>u)return n.dispose(),m.pause(),w({stream:m,buffer:l,ended:!1})},s=v=>t(v),c=()=>w({stream:m,buffer:l,ended:!0});n.add((0,k.toDisposable)(()=>m.removeListener("error",s))),m.on("error",s),n.add((0,k.toDisposable)(()=>m.removeListener("end",c))),m.on("end",c),n.add((0,k.toDisposable)(()=>m.removeListener("data",a))),m.on("data",a)})}e.peekStream=d;function f(m,u){const w=y(u);return w.end(m),w}e.toStream=f;function r(){const m=y(()=>{throw new Error("not supported")});return m.end(),m}e.emptyStream=r;function o(m){let u=!1;return{read:()=>u?null:(u=!0,m)}}e.toReadable=o;function p(m,u,w){const t=y(w);return I(m,{onData:n=>t.write(u.data(n)),onError:n=>t.error(u.error?u.error(n):n),onEnd:()=>t.end()}),t}e.transform=p;function g(m,u,w){let t=!1;return{read:()=>{const n=u.read();return t?n:(t=!0,n!==null?w([m,n]):m)}}}e.prefixedReadable=g;function E(m,u,w){let t=!1;const n=y(w);return I(u,{onData:l=>t?n.write(l):(t=!0,n.write(w([m,l]))),onError:l=>n.error(l),onEnd:()=>{t||(t=!0,n.write(m)),n.end()}}),n}e.prefixedStream=E}),define(ve[8],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function _(N){return!N||typeof N!="string"?!0:N.trim().length===0}e.isFalsyOrWhitespace=_;const k=/{(\d+)}/g;function A(N,...Q){return Q.length===0?N:N.replace(k,function(ae,ke){const Ie=parseInt(ke,10);return isNaN(Ie)||Ie<0||Ie>=Q.length?ae:Q[Ie]})}e.format=A;function T(N){return N.replace(/[<>&]/g,function(Q){switch(Q){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Q}})}e.escape=T;function y(N){return N.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function D(N,Q){let ae=0;const ke=Q.charCodeAt(0);for(let Ie=N.length-1;Ie>=0;Ie--)N.charCodeAt(Ie)===ke&&ae++;return ae}e.count=D;function S(N,Q,ae="\u2026"){return N.length<=Q?N:`${N.substr(0,Q)}${ae}`}e.truncate=S;function C(N,Q=" "){const ae=i(N,Q);return I(ae,Q)}e.trim=C;function i(N,Q){if(!N||!Q)return N;const ae=Q.length;if(ae===0||N.length===0)return N;let ke=0;for(;N.indexOf(Q,ke)===ke;)ke=ke+ae;return N.substring(ke)}e.ltrim=i;function I(N,Q){if(!N||!Q)return N;const ae=Q.length,ke=N.length;if(ae===0||ke===0)return N;let Ie=ke,Ae=-1;for(;Ae=N.lastIndexOf(Q,Ie-1),!(Ae===-1||Ae+ae!==Ie);){if(Ae===0)return"";Ie=Ae}return N.substring(0,Ie)}e.rtrim=I;function d(N){return N.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function f(N){return N.replace(/\*/g,"")}e.stripWildcards=f;function r(N,Q,ae={}){if(!N)throw new Error("Cannot create regex from empty string");Q||(N=y(N)),ae.wholeWord&&(/\B/.test(N.charAt(0))||(N="\\b"+N),/\B/.test(N.charAt(N.length-1))||(N=N+"\\b"));let ke="";return ae.global&&(ke+="g"),ae.matchCase||(ke+="i"),ae.multiline&&(ke+="m"),ae.unicode&&(ke+="u"),new RegExp(N,ke)}e.createRegExp=r;function o(N){return N.source==="^"||N.source==="^$"||N.source==="$"||N.source==="^\\s*$"?!1:!!(N.exec("")&&N.lastIndex===0)}e.regExpLeadsToEndlessLoop=o;function p(N){return!!N.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=p;function g(N){return(N.global?"g":"")+(N.ignoreCase?"i":"")+(N.multiline?"m":"")+(N.unicode?"u":"")}e.regExpFlags=g;function E(N){return N.split(/\r\n|\r|\n/)}e.splitLines=E;function m(N){for(let Q=0,ae=N.length;Q<ae;Q++){const ke=N.charCodeAt(Q);if(ke!==32&&ke!==9)return Q}return-1}e.firstNonWhitespaceIndex=m;function u(N,Q=0,ae=N.length){for(let ke=Q;ke<ae;ke++){const Ie=N.charCodeAt(ke);if(Ie!==32&&Ie!==9)return N.substring(Q,ke)}return N.substring(Q,ae)}e.getLeadingWhitespace=u;function w(N,Q=N.length-1){for(let ae=Q;ae>=0;ae--){const ke=N.charCodeAt(ae);if(ke!==32&&ke!==9)return ae}return-1}e.lastNonWhitespaceIndex=w;function t(N,Q){return N<Q?-1:N>Q?1:0}e.compare=t;function n(N,Q,ae=0,ke=N.length,Ie=0,Ae=Q.length){for(;ae<ke&&Ie<Ae;ae++,Ie++){let rt=N.charCodeAt(ae),tt=Q.charCodeAt(Ie);if(rt<tt)return-1;if(rt>tt)return 1}const xe=ke-ae,Ye=Ae-Ie;return xe<Ye?-1:xe>Ye?1:0}e.compareSubstring=n;function l(N,Q){return a(N,Q,0,N.length,0,Q.length)}e.compareIgnoreCase=l;function a(N,Q,ae=0,ke=N.length,Ie=0,Ae=Q.length){for(;ae<ke&&Ie<Ae;ae++,Ie++){let rt=N.charCodeAt(ae),tt=Q.charCodeAt(Ie);if(rt!==tt){const Qe=rt-tt;if(!(Qe===32&&c(tt))&&!(Qe===-32&&c(rt)))return s(rt)&&s(tt)?Qe:n(N.toLowerCase(),Q.toLowerCase(),ae,ke,Ie,Ae)}}const xe=ke-ae,Ye=Ae-Ie;return xe<Ye?-1:xe>Ye?1:0}e.compareSubstringIgnoreCase=a;function s(N){return N>=97&&N<=122}e.isLowerAsciiLetter=s;function c(N){return N>=65&&N<=90}e.isUpperAsciiLetter=c;function v(N){return s(N)||c(N)}function P(N,Q){return N.length===Q.length&&h(N,Q)}e.equalsIgnoreCase=P;function h(N,Q,ae=N.length){for(let ke=0;ke<ae;ke++){const Ie=N.charCodeAt(ke),Ae=Q.charCodeAt(ke);if(Ie!==Ae){if(v(Ie)&&v(Ae)){const xe=Math.abs(Ie-Ae);if(xe!==0&&xe!==32)return!1}else if(String.fromCharCode(Ie).toLowerCase()!==String.fromCharCode(Ae).toLowerCase())return!1}}return!0}function b(N,Q){const ae=Q.length;return Q.length>N.length?!1:h(N,Q,ae)}e.startsWithIgnoreCase=b;function R(N,Q){let ae,ke=Math.min(N.length,Q.length);for(ae=0;ae<ke;ae++)if(N.charCodeAt(ae)!==Q.charCodeAt(ae))return ae;return ke}e.commonPrefixLength=R;function U(N,Q){let ae,ke=Math.min(N.length,Q.length);const Ie=N.length-1,Ae=Q.length-1;for(ae=0;ae<ke;ae++)if(N.charCodeAt(Ie-ae)!==Q.charCodeAt(Ae-ae))return ae;return ke}e.commonSuffixLength=U;function K(N){return 55296<=N&&N<=56319}e.isHighSurrogate=K;function he(N){return 56320<=N&&N<=57343}e.isLowSurrogate=he;function V(N,Q){return(N-55296<<10)+(Q-56320)+65536}e.computeCodePoint=V;function H(N,Q,ae){const ke=N.charCodeAt(ae);if(K(ke)&&ae+1<Q){const Ie=N.charCodeAt(ae+1);if(he(Ie))return V(ke,Ie)}return ke}e.getNextCodePoint=H;function Y(N,Q){const ae=N.charCodeAt(Q-1);if(he(ae)&&Q>1){const ke=N.charCodeAt(Q-2);if(K(ke))return V(ke,ae)}return ae}function W(N,Q){const ae=$e.getInstance(),ke=Q,Ie=N.length,Ae=H(N,Ie,Q);Q+=Ae>=65536?2:1;let xe=ae.getGraphemeBreakType(Ae);for(;Q<Ie;){const Ye=H(N,Ie,Q),rt=ae.getGraphemeBreakType(Ye);if(Ne(xe,rt))break;Q+=Ye>=65536?2:1,xe=rt}return Q-ke}e.nextCharLength=W;function F(N,Q){const ae=$e.getInstance(),ke=Q,Ie=Y(N,Q);Q-=Ie>=65536?2:1;let Ae=ae.getGraphemeBreakType(Ie);for(;Q>0;){const xe=Y(N,Q),Ye=ae.getGraphemeBreakType(xe);if(Ne(Ye,Ae))break;Q-=xe>=65536?2:1,Ae=Ye}return ke-Q}e.prevCharLength=F;function L(N,Q){const ae=$e.getInstance(),ke=N.length,Ie=Q,Ae=H(N,ke,Q),xe=ae.getGraphemeBreakType(Ae);Q+=Ae>=65536?2:1;let Ye=xe;for(;Q<ke;){const tt=H(N,ke,Q),Qe=ae.getGraphemeBreakType(tt);if(Ne(Ye,Qe))break;Q+=tt>=65536?2:1,Ye=Qe}const rt=Q;for(Q=Ie,Ye=xe;Q>0;){const tt=Y(N,Q),Qe=ae.getGraphemeBreakType(tt);if(Ne(Qe,Ye))break;Q-=tt>=65536?2:1,Ye=Qe}return[Q,rt]}function M(N,Q){return Q>0&&he(N.charCodeAt(Q))?L(N,Q-1):L(N,Q)}e.getCharContainingOffset=M;function x(N){const Q=N.length;let ae=0,ke=0;for(;ke<Q;){const xe=H(N,Q,ke);ke+=xe>=65536?2:1,xe<128?ae+=1:xe<2048?ae+=2:xe<65536?ae+=3:ae+=4}const Ie=new Uint8Array(ae);ke=0;let Ae=0;for(;ke<Q;){const xe=H(N,Q,ke);ke+=xe>=65536?2:1,xe<128?Ie[Ae++]=xe:xe<2048?(Ie[Ae++]=192|(xe&1984)>>>6,Ie[Ae++]=128|(xe&63)>>>0):xe<65536?(Ie[Ae++]=224|(xe&61440)>>>12,Ie[Ae++]=128|(xe&4032)>>>6,Ie[Ae++]=128|(xe&63)>>>0):(Ie[Ae++]=240|(xe&1835008)>>>18,Ie[Ae++]=128|(xe&258048)>>>12,Ie[Ae++]=128|(xe&4032)>>>6,Ie[Ae++]=128|(xe&63)>>>0)}return Ie}e.encodeUTF8=x;function G(N){const Q=N.byteLength,ae=[];let ke=0;for(;ke<Q;){const Ie=N[ke];let Ae;if(Ie>=240&&ke+3<Q?Ae=(N[ke++]&7)<<18>>>0|(N[ke++]&63)<<12>>>0|(N[ke++]&63)<<6>>>0|(N[ke++]&63)<<0>>>0:Ie>=224&&ke+2<Q?Ae=(N[ke++]&15)<<12>>>0|(N[ke++]&63)<<6>>>0|(N[ke++]&63)<<0>>>0:Ie>=192&&ke+1<Q?Ae=(N[ke++]&31)<<6>>>0|(N[ke++]&63)<<0>>>0:Ae=N[ke++],Ae>=0&&Ae<=55295||Ae>=57344&&Ae<=65535)ae.push(String.fromCharCode(Ae));else if(Ae>=65536&&Ae<=1114111){const xe=Ae-65536,Ye=55296+((xe&1047552)>>>10),rt=56320+((xe&1023)>>>0);ae.push(String.fromCharCode(Ye)),ae.push(String.fromCharCode(rt))}else ae.push(String.fromCharCode(65533))}return ae.join("")}e.decodeUTF8=G;const X=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function ne(N){return X.test(N)}e.containsRTL=ne;const me=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Le(N){return me.test(N)}e.containsEmoji=Le;const We=/^[\t\n\r\x20-\x7E]*$/;function Fe(N){return We.test(N)}e.isBasicASCII=Fe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ze(N){return e.UNUSUAL_LINE_TERMINATORS.test(N)}e.containsUnusualLineTerminators=ze;function $(N){for(let Q=0,ae=N.length;Q<ae;Q++)if(j(N.charCodeAt(Q)))return!0;return!1}e.containsFullWidthCharacter=$;function j(N){return N=+N,N>=11904&&N<=55215||N>=63744&&N<=64255||N>=65281&&N<=65374}e.isFullWidthCharacter=j;function te(N){return N>=127462&&N<=127487||N===8986||N===8987||N===9200||N===9203||N>=9728&&N<=10175||N===11088||N===11093||N>=127744&&N<=128591||N>=128640&&N<=128764||N>=128992&&N<=129003||N>=129280&&N<=129535||N>=129648&&N<=129750}e.isEmojiImprecise=te;function oe(N,Q){if(N.length<Q)return N;const ae=/\b/g;let ke=0;for(;ae.test(N)&&!(N.length-ae.lastIndex<Q);)ke=ae.lastIndex,ae.lastIndex+=1;return N.substring(ke).replace(/^\s/,"")}e.lcut=oe;const de=/\x1B\x5B[12]?K/g,_e=/\x1b\[\d+m/g,Be=/\x1b\[0?m/g;function fe(N){return N&&(N=N.replace(de,""),N=N.replace(_e,""),N=N.replace(Be,"")),N}e.removeAnsiEscapeCodes=fe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function De(N){return!!(N&&N.length>0&&N.charCodeAt(0)===65279)}e.startsWithUTF8BOM=De;function Re(N){return De(N)?N.substr(1):N}e.stripUTF8BOM=Re;function He(N,Q){if(!N||!Q||N.length<Q.length)return!1;const ae=Q.length,ke=N.toLowerCase();let Ie=0,Ae=-1;for(;Ie<ae;){const xe=ke.indexOf(Q[Ie],Ae+1);if(xe<0)return!1;Ae=xe,Ie++}return!0}e.fuzzyContains=He;function we(N,Q=!1){return N?(Q&&(N=N.replace(/\\./g,"")),N.toLowerCase()!==N):!1}e.containsUppercaseCharacter=we;function qe(N){return N.charAt(0).toUpperCase()+N.slice(1)}e.uppercaseFirstLetter=qe;function z(N,Q=1){if(Q===0)return"";let ae=-1;do ae=N.indexOf(`
`,ae+1),Q--;while(Q>0&&ae>=0);return ae===-1?N:(N[ae-1]==="\r"&&ae--,N.substr(0,ae))}e.getNLines=z;function ee(N){const Q=90-65+1;return N=N%(2*Q),N<Q?String.fromCharCode(97+N):String.fromCharCode(65+N-Q)}e.singleLetterHash=ee;function ge(N){return $e.getInstance().getGraphemeBreakType(N)}e.getGraphemeBreakType=ge;function Ne(N,Q){return N===0?Q!==5&&Q!==7:N===2&&Q===3?!1:N===4||N===2||N===3||Q===4||Q===2||Q===3?!0:!(N===8&&(Q===8||Q===9||Q===11||Q===12)||(N===11||N===9)&&(Q===9||Q===10)||(N===12||N===10)&&Q===10||Q===5||Q===13||Q===7||N===1||N===13&&Q===14||N===6&&Q===6)}e.breakBetweenGraphemeBreakType=Ne;var Ve;(function(N){N[N.Other=0]="Other",N[N.Prepend=1]="Prepend",N[N.CR=2]="CR",N[N.LF=3]="LF",N[N.Control=4]="Control",N[N.Extend=5]="Extend",N[N.Regional_Indicator=6]="Regional_Indicator",N[N.SpacingMark=7]="SpacingMark",N[N.L=8]="L",N[N.V=9]="V",N[N.T=10]="T",N[N.LV=11]="LV",N[N.LVT=12]="LVT",N[N.ZWJ=13]="ZWJ",N[N.Extended_Pictographic=14]="Extended_Pictographic"})(Ve=e.GraphemeBreakType||(e.GraphemeBreakType={}));class $e{constructor(){this._data=Ze()}static getInstance(){return $e._INSTANCE||($e._INSTANCE=new $e),$e._INSTANCE}getGraphemeBreakType(Q){if(Q<32)return Q===10?3:Q===13?2:4;if(Q<127)return 0;const ae=this._data,ke=ae.length/3;let Ie=1;for(;Ie<=ke;)if(Q<ae[3*Ie])Ie=2*Ie;else if(Q>ae[3*Ie+1])Ie=2*Ie+1;else return ae[3*Ie+2];return 0}}$e._INSTANCE=null;function Ze(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function ye(N,Q){if(N===0)return 0;const ae=Ee(N,Q);if(ae!==void 0)return ae;const ke=Y(Q,N);return N-=Ce(ke),N}e.getLeftDeleteOffset=ye;function Ee(N,Q){let ae=Y(Q,N);for(N-=Ce(ae);re(ae)||ae===65039||ae===8419;){if(N===0)return;ae=Y(Q,N),N-=Ce(ae)}if(!!te(ae)){if(N>=0){const ke=Y(Q,N);ke===8205&&(N-=Ce(ke))}return N}}function Ce(N){return N>=65536?2:1}function re(N){return 127995<=N&&N<=127999}var le;(function(N){N[N.zwj=8205]="zwj",N[N.emojiVariantSelector=65039]="emojiVariantSelector",N[N.enclosingKeyCap=8419]="enclosingKeyCap"})(le||(le={}))}),define(ve[24],be([0,1,8,109]),function(J,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer!="undefined",T=typeof TextEncoder!="undefined",y=typeof TextDecoder!="undefined";let D,S;class C{constructor(v){this.buffer=v,this.byteLength=this.buffer.byteLength}static alloc(v){return A?new C(Buffer.allocUnsafe(v)):new C(new Uint8Array(v))}static wrap(v){return A&&!Buffer.isBuffer(v)&&(v=Buffer.from(v.buffer,v.byteOffset,v.byteLength)),new C(v)}static fromString(v,P){return!((P==null?void 0:P.dontUseNodeBuffer)||!1)&&A?new C(Buffer.from(v)):T?(D||(D=new TextEncoder),new C(D.encode(v))):new C(_.encodeUTF8(v))}static concat(v,P){if(typeof P=="undefined"){P=0;for(let R=0,U=v.length;R<U;R++)P+=v[R].byteLength}const h=C.alloc(P);let b=0;for(let R=0,U=v.length;R<U;R++){const K=v[R];h.set(K,b),b+=K.byteLength}return h}toString(){return A?this.buffer.toString():y?(S||(S=new TextDecoder),S.decode(this.buffer)):_.decodeUTF8(this.buffer)}slice(v,P){return new C(this.buffer.subarray(v,P))}set(v,P){v instanceof C?this.buffer.set(v.buffer,P):this.buffer.set(v,P)}readUInt32BE(v){return d(this.buffer,v)}writeUInt32BE(v,P){f(this.buffer,v,P)}readUInt32LE(v){return r(this.buffer,v)}writeUInt32LE(v,P){o(this.buffer,v,P)}readUInt8(v){return p(this.buffer,v)}writeUInt8(v,P){g(this.buffer,v,P)}}e.VSBuffer=C;function i(c,v){return c[v+0]<<0>>>0|c[v+1]<<8>>>0}e.readUInt16LE=i;function I(c,v,P){c[P+0]=v&255,v=v>>>8,c[P+1]=v&255}e.writeUInt16LE=I;function d(c,v){return c[v]*2**24+c[v+1]*2**16+c[v+2]*2**8+c[v+3]}e.readUInt32BE=d;function f(c,v,P){c[P+3]=v,v=v>>>8,c[P+2]=v,v=v>>>8,c[P+1]=v,v=v>>>8,c[P]=v}e.writeUInt32BE=f;function r(c,v){return c[v+0]<<0>>>0|c[v+1]<<8>>>0|c[v+2]<<16>>>0|c[v+3]<<24>>>0}e.readUInt32LE=r;function o(c,v,P){c[P+0]=v&255,v=v>>>8,c[P+1]=v&255,v=v>>>8,c[P+2]=v&255,v=v>>>8,c[P+3]=v&255}e.writeUInt32LE=o;function p(c,v){return c[v]}e.readUInt8=p;function g(c,v,P){c[P]=v}e.writeUInt8=g;function E(c){return k.consumeReadable(c,v=>C.concat(v))}e.readableToBuffer=E;function m(c){return k.toReadable(c)}e.bufferToReadable=m;function u(c){return k.consumeStream(c,v=>C.concat(v))}e.streamToBuffer=u;async function w(c){return c.ended?C.concat(c.buffer):C.concat([...c.buffer,await u(c.stream)])}e.bufferedStreamToBuffer=w;function t(c){return k.toStream(c,v=>C.concat(v))}e.bufferToStream=t;function n(c){return k.transform(c,{data:v=>typeof v=="string"?C.fromString(v):C.wrap(v)},v=>C.concat(v))}e.streamToBufferReadableStream=n;function l(c){return k.newWriteableStream(v=>C.concat(v),c)}e.newWriteableBufferStream=l;function a(c,v){return k.prefixedReadable(c,v,P=>C.concat(P))}e.prefixedBufferReadable=a;function s(c,v){return k.prefixedStream(c,v,P=>C.concat(P))}e.prefixedBufferStream=s}),define(ve[56],be([0,1,8]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function k(g){return A(g,0)}e.hash=k;function A(g,E){switch(typeof g){case"object":return g===null?T(349,E):Array.isArray(g)?S(g,E):C(g,E);case"string":return D(g,E);case"boolean":return y(g,E);case"number":return T(g,E);case"undefined":return T(937,E);default:return T(617,E)}}e.doHash=A;function T(g,E){return(E<<5)-E+g|0}function y(g,E){return T(g?433:863,E)}function D(g,E){E=T(149417,E);for(let m=0,u=g.length;m<u;m++)E=T(g.charCodeAt(m),E);return E}e.stringHash=D;function S(g,E){return E=T(104579,E),g.reduce((m,u)=>A(u,m),E)}function C(g,E){return E=T(181387,E),Object.keys(g).sort().reduce((m,u)=>(m=D(u,m),A(g[u],m)),E)}class i{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=A(E,this._value),this._value}}e.Hasher=i;var I;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function d(g,E,m=32){const u=m-E,w=~((1<<u)-1);return(g<<E|(w&g)>>>u)>>>0}function f(g,E=0,m=g.byteLength,u=0){for(let w=0;w<m;w++)g[E+w]=u}function r(g,E,m="0"){for(;g.length<E;)g=m+g;return g}function o(g,E=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(m=>m.toString(16).padStart(2,"0")).join(""):r((g>>>0).toString(16),E/4)}e.toHexString=o;class p{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const m=E.length;if(m!==0){const u=this._buff;let w=this._buffLen,t=this._leftoverHighSurrogate,n,l;for(t!==0?(n=t,l=-1,t=0):(n=E.charCodeAt(0),l=0);;){let a=n;if(_.isHighSurrogate(n))if(l+1<m){const s=E.charCodeAt(l+1);_.isLowSurrogate(s)?(l++,a=_.computeCodePoint(n,s)):a=65533}else{t=n;break}else _.isLowSurrogate(n)&&(a=65533);if(w=this._push(u,w,a),l++,l<m)n=E.charCodeAt(l);else break}this._buffLen=w,this._leftoverHighSurrogate=t}}_push(E,m,u){return u<128?E[m++]=u:u<2048?(E[m++]=192|(u&1984)>>>6,E[m++]=128|(u&63)>>>0):u<65536?(E[m++]=224|(u&61440)>>>12,E[m++]=128|(u&4032)>>>6,E[m++]=128|(u&63)>>>0):(E[m++]=240|(u&1835008)>>>18,E[m++]=128|(u&258048)>>>12,E[m++]=128|(u&4032)>>>6,E[m++]=128|(u&63)>>>0),m>=64&&(this._step(),m-=64,this._totalLen+=64,E[0]=E[64+0],E[1]=E[64+1],E[2]=E[64+2]),m}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),o(this._h0)+o(this._h1)+o(this._h2)+o(this._h3)+o(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=p._bigBlock32,m=this._buffDV;for(let v=0;v<64;v+=4)E.setUint32(v,m.getUint32(v,!1),!1);for(let v=64;v<320;v+=4)E.setUint32(v,d(E.getUint32(v-12,!1)^E.getUint32(v-32,!1)^E.getUint32(v-56,!1)^E.getUint32(v-64,!1),1),!1);let u=this._h0,w=this._h1,t=this._h2,n=this._h3,l=this._h4,a,s,c;for(let v=0;v<80;v++)v<20?(a=w&t|~w&n,s=1518500249):v<40?(a=w^t^n,s=1859775393):v<60?(a=w&t|w&n|t&n,s=2400959708):(a=w^t^n,s=3395469782),c=d(u,5)+a+l+s+E.getUint32(v*4,!1)&4294967295,l=n,n=t,t=d(w,30),w=u,u=c;this._h0=this._h0+u&4294967295,this._h1=this._h1+w&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+l&4294967295}}e.StringSHA1=p,p._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ve[47],be([0,1,8]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var k;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(k||(k={})),function(A){const T="error",y="warning",D="warn",S="info",C="ignore";function i(d){return d?_.equalsIgnoreCase(T,d)?A.Error:_.equalsIgnoreCase(y,d)||_.equalsIgnoreCase(D,d)?A.Warning:_.equalsIgnoreCase(S,d)?A.Info:A.Ignore:A.Ignore}A.fromValue=i;function I(d){switch(d){case A.Error:return T;case A.Warning:return y;case A.Info:return S;default:return C}}A.toString=I}(k||(k={})),e.default=k}),define(ve[10],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function _(v){return Array.isArray(v)}e.isArray=_;function k(v){return typeof v=="string"}e.isString=k;function A(v){return Array.isArray(v)&&v.every(P=>k(P))}e.isStringArray=A;function T(v){return typeof v=="object"&&v!==null&&!Array.isArray(v)&&!(v instanceof RegExp)&&!(v instanceof Date)}e.isObject=T;function y(v){return typeof v=="number"&&!isNaN(v)}e.isNumber=y;function D(v){return!!v&&typeof v[Symbol.iterator]=="function"}e.isIterable=D;function S(v){return v===!0||v===!1}e.isBoolean=S;function C(v){return typeof v=="undefined"}e.isUndefined=C;function i(v){return!I(v)}e.isDefined=i;function I(v){return C(v)||v===null}e.isUndefinedOrNull=I;function d(v,P){if(!v)throw new Error(P?`Unexpected type, expected '${P}'`:"Unexpected type")}e.assertType=d;function f(v){if(I(v))throw new Error("Assertion Failed: argument is undefined or null");return v}e.assertIsDefined=f;function r(...v){const P=[];for(let h=0;h<v.length;h++){const b=v[h];if(I(b))throw new Error(`Assertion Failed: argument at index ${h} is undefined or null`);P.push(b)}return P}e.assertAllDefined=r;const o=Object.prototype.hasOwnProperty;function p(v){if(!T(v))return!1;for(let P in v)if(o.call(v,P))return!1;return!0}e.isEmptyObject=p;function g(v){return typeof v=="function"}e.isFunction=g;function E(...v){return v.length>0&&v.every(g)}e.areFunctions=E;function m(v,P){const h=Math.min(v.length,P.length);for(let b=0;b<h;b++)u(v[b],P[b])}e.validateConstraints=m;function u(v,P){if(k(P)){if(typeof v!==P)throw new Error(`argument does not match constraint: typeof ${P}`)}else if(g(P)){try{if(v instanceof P)return}catch(h){}if(!I(v)&&v.constructor===P||P.length===1&&P.call(void 0,v)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=u;function w(v){let P=[],h=Object.getPrototypeOf(v);for(;Object.prototype!==h;)P=P.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return P}e.getAllPropertyNames=w;function t(v){const P=[];for(const h of w(v))typeof v[h]=="function"&&P.push(h);return P}e.getAllMethodNames=t;function n(v,P){const h=R=>function(){const U=Array.prototype.slice.call(arguments,0);return P(R,U)};let b={};for(const R of v)b[R]=h(R);return b}e.createProxyObject=n;function l(v){return v===null?void 0:v}e.withNullAsUndefined=l;function a(v){return typeof v=="undefined"?null:v}e.withUndefinedAsNull=a;function s(v){return class{constructor(){return new Proxy({},{get(P,h){if(P[h])return P[h];throw new Error(`Not Implemented: ${v}->${String(h)}`)}})}}}e.NotImplementedProxy=s;function c(v){throw new Error("Unreachable")}e.assertNever=c}),define(ve[37],be([0,1,21,8,13,10]),function(J,e,_,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function y(n){return n===47||n===92}e.isPathSeparator=y;function D(n){return n.replace(/[\\/]/g,A.posix.sep)}e.toSlashes=D;function S(n,l=A.posix.sep){if(!n)return"";const a=n.length,s=n.charCodeAt(0);if(y(s)){if(y(n.charCodeAt(1))&&!y(n.charCodeAt(2))){let v=3;const P=v;for(;v<a&&!y(n.charCodeAt(v));v++);if(P!==v&&!y(n.charCodeAt(v+1))){for(v+=1;v<a;v++)if(y(n.charCodeAt(v)))return n.slice(0,v+1).replace(/[\\/]/g,l)}}return l}else if(p(s)&&n.charCodeAt(1)===58)return y(n.charCodeAt(2))?n.slice(0,2)+l:n.slice(0,2);let c=n.indexOf("://");if(c!==-1){for(c+=3;c<a;c++)if(y(n.charCodeAt(c)))return n.slice(0,c+1)}return""}e.getRoot=S;function C(n){if(!_.isWindows||!n||n.length<5)return!1;let l=n.charCodeAt(0);if(l!==92||(l=n.charCodeAt(1),l!==92))return!1;let a=2;const s=a;for(;a<n.length&&(l=n.charCodeAt(a),l!==92);a++);return!(s===a||(l=n.charCodeAt(a+1),isNaN(l)||l===92))}e.isUNC=C;const i=/[\\/:\*\?"<>\|]/g,I=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(n,l=_.isWindows){const a=l?i:I;return!(!n||n.length===0||/^\s+$/.test(n)||(a.lastIndex=0,a.test(n))||l&&d.test(n)||n==="."||n===".."||l&&n[n.length-1]==="."||l&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=f;function r(n,l,a){const s=n===l;return!a||s?s:!n||!l?!1:(0,k.equalsIgnoreCase)(n,l)}e.isEqual=r;function o(n,l,a,s=A.sep){if(n===l)return!0;if(!n||!l||l.length>n.length)return!1;if(a){if(!(0,k.startsWithIgnoreCase)(n,l))return!1;if(l.length===n.length)return!0;let v=l.length;return l.charAt(l.length-1)===s&&v--,n.charAt(v)===s}return l.charAt(l.length-1)!==s&&(l+=s),n.indexOf(l)===0}e.isEqualOrParent=o;function p(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=p;function g(n,l){return _.isWindows&&n.endsWith(":")&&(n+=A.sep),(0,A.isAbsolute)(n)||(n=(0,A.join)(l,n)),n=(0,A.normalize)(n),_.isWindows?(n=(0,k.rtrim)(n,A.sep),n.endsWith(":")&&(n+=A.sep)):(n=(0,k.rtrim)(n,A.sep),n||(n=A.sep)),n}e.sanitizeFilePath=g;function E(n){const l=(0,A.normalize)(n);return _.isWindows?n.length>3?!1:m(l)&&(n.length===2||l.charCodeAt(2)===92):l===A.posix.sep}e.isRootOrDriveLetter=E;function m(n){return _.isWindows?p(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=m;function u(n){return m(n)?n[0]:void 0}e.getDriveLetter=u;function w(n,l,a){return l.length>n.length?-1:n===l?0:(a&&(n=n.toLowerCase(),l=l.toLowerCase()),n.indexOf(l))}e.indexOfPath=w;function t(n){const l=n.split(":");let a,s,c;if(l.forEach(v=>{const P=Number(v);(0,T.isNumber)(P)?s===void 0?s=P:c===void 0&&(c=P):a=a?[a,v].join(":"):v}),!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:s!==void 0?s:void 0,column:c!==void 0?c:s!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(ve[23],be([0,1,10]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function k(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const p=Array.isArray(o)?[]:{};return Object.keys(o).forEach(g=>{o[g]&&typeof o[g]=="object"?p[g]=k(o[g]):p[g]=o[g]}),p}e.deepClone=k;function A(o){if(!o||typeof o!="object")return o;const p=[o];for(;p.length>0;){const g=p.shift();Object.freeze(g);for(const E in g)if(T.call(g,E)){const m=g[E];typeof m=="object"&&!Object.isFrozen(m)&&p.push(m)}}return o}e.deepFreeze=A;const T=Object.prototype.hasOwnProperty;function y(o,p){return D(o,p,new Set)}e.cloneAndChange=y;function D(o,p,g){if((0,_.isUndefinedOrNull)(o))return o;const E=p(o);if(typeof E!="undefined")return E;if((0,_.isArray)(o)){const m=[];for(const u of o)m.push(D(u,p,g));return m}if((0,_.isObject)(o)){if(g.has(o))throw new Error("Cannot clone recursive data-structure");g.add(o);const m={};for(let u in o)T.call(o,u)&&(m[u]=D(o[u],p,g));return g.delete(o),m}return o}function S(o,p,g=!0){return(0,_.isObject)(o)?((0,_.isObject)(p)&&Object.keys(p).forEach(E=>{E in o?g&&((0,_.isObject)(o[E])&&(0,_.isObject)(p[E])?S(o[E],p[E],g):o[E]=p[E]):o[E]=p[E]}),o):p}e.mixin=S;function C(o,p){if(o===p)return!0;if(o==null||p===null||p===void 0||typeof o!=typeof p||typeof o!="object"||Array.isArray(o)!==Array.isArray(p))return!1;let g,E;if(Array.isArray(o)){if(o.length!==p.length)return!1;for(g=0;g<o.length;g++)if(!C(o[g],p[g]))return!1}else{const m=[];for(E in o)m.push(E);m.sort();const u=[];for(E in p)u.push(E);if(u.sort(),!C(m,u))return!1;for(g=0;g<m.length;g++)if(!C(o[m[g]],p[m[g]]))return!1}return!0}e.equals=C;function i(o){const p=new Set;return JSON.stringify(o,(g,E)=>{if((0,_.isObject)(E)||Array.isArray(E)){if(p.has(E))return"[Circular]";p.add(E)}return E})}e.safeStringify=i;function I(o,p,g){const E=p(o);return typeof E=="undefined"?g:E}e.getOrDefault=I;function d(o,p){const g=Object.create(null);return!o||!p||Object.keys(p).forEach(m=>{const u=o[m],w=p[m];C(u,w)||(g[m]=w)}),g}e.distinct=d;function f(o,p){const g=p.toLowerCase(),E=Object.keys(o).find(m=>m.toLowerCase()===g);return E?o[E]:o[p]}e.getCaseInsensitive=f;function r(o,p){const g=Object.create(null);for(const E of Object.keys(o))p(E,o[E])&&(g[E]=o[E]);return g}e.filter=r}),define(ve[82],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var _;(function(T){T[T.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",T[T.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",T[T.MAX_UINT_8=255]="MAX_UINT_8",T[T.MAX_UINT_16=65535]="MAX_UINT_16",T[T.MAX_UINT_32=4294967295]="MAX_UINT_32",T[T.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(_=e.Constants||(e.Constants={}));function k(T){return T<0?0:T>255?255:T|0}e.toUint8=k;function A(T){return T<0?0:T>4294967295?4294967295:T|0}e.toUint32=A}),define(ve[2],be([0,1,21,13]),function(J,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const A=/^\w[\w\d+.-]*$/,T=/^\//,y=/^\/\//;function D(l,a){if(!l.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!A.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!T.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(l,a){return!l&&!a?"file":l}function C(l,a){switch(l){case"https":case"http":case"file":a?a[0]!==I&&(a=I+a):a=I;break}return a}const i="",I="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{constructor(a,s,c,v,P,h=!1){typeof a=="object"?(this.scheme=a.scheme||i,this.authority=a.authority||i,this.path=a.path||i,this.query=a.query||i,this.fragment=a.fragment||i):(this.scheme=S(a,h),this.authority=s||i,this.path=C(this.scheme,c||i),this.query=v||i,this.fragment=P||i,D(this,h))}static isUri(a){return a instanceof f?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}get fsPath(){return m(this,!1)}with(a){if(!a)return this;let{scheme:s,authority:c,path:v,query:P,fragment:h}=a;return s===void 0?s=this.scheme:s===null&&(s=i),c===void 0?c=this.authority:c===null&&(c=i),v===void 0?v=this.path:v===null&&(v=i),P===void 0?P=this.query:P===null&&(P=i),h===void 0?h=this.fragment:h===null&&(h=i),s===this.scheme&&c===this.authority&&v===this.path&&P===this.query&&h===this.fragment?this:new o(s,c,v,P,h)}static parse(a,s=!1){const c=d.exec(a);return c?new o(c[2]||i,n(c[4]||i),n(c[5]||i),n(c[7]||i),n(c[9]||i),s):new o(i,i,i,i,i)}static file(a){let s=i;if(_.isWindows&&(a=a.replace(/\\/g,I)),a[0]===I&&a[1]===I){const c=a.indexOf(I,2);c===-1?(s=a.substring(2),a=I):(s=a.substring(2,c),a=a.substring(c)||I)}return new o("file",s,a,i,i)}static from(a){return new o(a.scheme,a.authority,a.path,a.query,a.fragment)}static joinPath(a,...s){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return _.isWindows&&a.scheme==="file"?c=f.file(k.win32.join(m(a,!0),...s)).path:c=k.posix.join(a.path,...s),a.with({path:c})}toString(a=!1){return u(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof f)return a;{const s=new o(a);return s._formatted=a.external,s._fsPath=a._sep===r?a.fsPath:null,s}}else return a}}e.URI=f;const r=_.isWindows?1:void 0;class o extends f{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(a=!1){return a?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=r),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const p={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function g(l,a){let s,c=-1;for(let v=0;v<l.length;v++){const P=l.charCodeAt(v);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||a&&P===47)c!==-1&&(s+=encodeURIComponent(l.substring(c,v)),c=-1),s!==void 0&&(s+=l.charAt(v));else{s===void 0&&(s=l.substr(0,v));const h=p[P];h!==void 0?(c!==-1&&(s+=encodeURIComponent(l.substring(c,v)),c=-1),s+=h):c===-1&&(c=v)}}return c!==-1&&(s+=encodeURIComponent(l.substring(c))),s!==void 0?s:l}function E(l){let a;for(let s=0;s<l.length;s++){const c=l.charCodeAt(s);c===35||c===63?(a===void 0&&(a=l.substr(0,s)),a+=p[c]):a!==void 0&&(a+=l[s])}return a!==void 0?a:l}function m(l,a){let s;return l.authority&&l.path.length>1&&l.scheme==="file"?s=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===47&&(l.path.charCodeAt(1)>=65&&l.path.charCodeAt(1)<=90||l.path.charCodeAt(1)>=97&&l.path.charCodeAt(1)<=122)&&l.path.charCodeAt(2)===58?a?s=l.path.substr(1):s=l.path[1].toLowerCase()+l.path.substr(2):s=l.path,_.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=m;function u(l,a){const s=a?E:g;let c="",{scheme:v,authority:P,path:h,query:b,fragment:R}=l;if(v&&(c+=v,c+=":"),(P||v==="file")&&(c+=I,c+=I),P){let U=P.indexOf("@");if(U!==-1){const K=P.substr(0,U);P=P.substr(U+1),U=K.indexOf(":"),U===-1?c+=s(K,!1):(c+=s(K.substr(0,U),!1),c+=":",c+=s(K.substr(U+1),!1)),c+="@"}P=P.toLowerCase(),U=P.indexOf(":"),U===-1?c+=s(P,!1):(c+=s(P.substr(0,U),!1),c+=P.substr(U))}if(h){if(h.length>=3&&h.charCodeAt(0)===47&&h.charCodeAt(2)===58){const U=h.charCodeAt(1);U>=65&&U<=90&&(h=`/${String.fromCharCode(U+32)}:${h.substr(3)}`)}else if(h.length>=2&&h.charCodeAt(1)===58){const U=h.charCodeAt(0);U>=65&&U<=90&&(h=`${String.fromCharCode(U+32)}:${h.substr(2)}`)}c+=s(h,!0)}return b&&(c+="?",c+=s(b,!1)),R&&(c+="#",c+=a?R:g(R,!1)),c}function w(l){try{return decodeURIComponent(l)}catch(a){return l.length>3?l.substr(0,3)+w(l.substr(3)):l}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(l){return l.match(t)?l.replace(t,a=>w(a)):l}});var it=this&&this.__classPrivateFieldSet||function(J,e,_,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!A:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(J,_):A?A.value=_:e.set(J,_),_},Ue=this&&this.__classPrivateFieldGet||function(J,e,_,k){if(_==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?k:_==="a"?k.call(J):k?k.value:e.get(J)};define(ve[22],be([0,1,2,8]),function(J,e,_,k){"use strict";var A,T,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(t,n,l){let a=t.get(n);return a===void 0&&(a=l,t.set(n,a)),a}e.getOrSet=D;function S(t){const n=[];return t.forEach((l,a)=>{n.push(`${a} => ${l}`)}),`Map(${t.size}) {${n.join(", ")}}`}e.mapToString=S;function C(t){const n=[];return t.forEach(l=>{n.push(l)}),`Set(${t.size}) {${n.join(", ")}}`}e.setToString=C;class i{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const l=n.charCodeAt(0),a=this._value.charCodeAt(this._pos);return l-a}value(){return this._value[this._pos]}}e.StringIterator=i;class I{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,k.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class d{constructor(n=!0,l=!0){this._splitOnBackslash=n,this._caseSensitive=l}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const l=this._value.charCodeAt(this._to);if(l===47||this._splitOnBackslash&&l===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,k.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=d;var f;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(f||(f={}));class r{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new d(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,k.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,k.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,k.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,k.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=r;class o{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class p{constructor(n){this._iter=n}static forUris(n=()=>!1){return new p(new r(n))}static forPaths(){return new p(new d)}static forStrings(){return new p(new i)}static forConfigKeys(){return new p(new I)}clear(){this._root=void 0}set(n,l){const a=this._iter.reset(n);let s;for(this._root||(this._root=new o,this._root.segment=a.value()),s=this._root;;){const v=a.cmp(s.segment);if(v>0)s.left||(s.left=new o,s.left.segment=a.value()),s=s.left;else if(v<0)s.right||(s.right=new o,s.right.segment=a.value()),s=s.right;else if(a.hasNext())a.next(),s.mid||(s.mid=new o,s.mid.segment=a.value()),s=s.mid;else break}const c=s.value;return s.value=l,s.key=n,c}get(n){var l;return(l=this._getNode(n))===null||l===void 0?void 0:l.value}_getNode(n){const l=this._iter.reset(n);let a=this._root;for(;a;){const s=l.cmp(a.segment);if(s>0)a=a.left;else if(s<0)a=a.right;else if(l.hasNext())l.next(),a=a.mid;else break}return a}has(n){const l=this._getNode(n);return!((l==null?void 0:l.value)===void 0&&(l==null?void 0:l.mid)===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,l){const a=this._iter.reset(n),s=[];let c=this._root;for(;c;){const v=a.cmp(c.segment);if(v>0)s.push([1,c]),c=c.left;else if(v<0)s.push([-1,c]),c=c.right;else if(a.hasNext())a.next(),s.push([0,c]),c=c.mid;else{for(l?(c.left=void 0,c.mid=void 0,c.right=void 0):c.value=void 0;s.length>0&&c.isEmpty();){let[P,h]=s.pop();switch(P){case 1:h.left=void 0;break;case 0:h.mid=void 0;break;case-1:h.right=void 0;break}c=h}break}}}findSubstr(n){const l=this._iter.reset(n);let a=this._root,s;for(;a;){const c=l.cmp(a.segment);if(c>0)a=a.left;else if(c<0)a=a.right;else if(l.hasNext())l.next(),s=a.value||s,a=a.mid;else break}return a&&a.value||s}findSuperstr(n){const l=this._iter.reset(n);let a=this._root;for(;a;){const s=l.cmp(a.segment);if(s>0)a=a.left;else if(s<0)a=a.right;else if(l.hasNext())l.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(n){for(const[l,a]of this)n(a,l)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){n&&(yield*this._entries(n.left),n.value&&(yield[n.key,n.value]),yield*this._entries(n.mid),yield*this._entries(n.right))}}e.TernarySearchTree=p;class g{constructor(n,l){this[A]="ResourceMap",n instanceof g?(this.map=new Map(n.map),this.toKey=l!=null?l:g.defaultToKey):(this.map=new Map,this.toKey=n!=null?n:g.defaultToKey)}set(n,l){return this.map.set(this.toKey(n),l),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,l){typeof l!="undefined"&&(n=n.bind(l));for(let[a,s]of this.map)n(s,_.URI.parse(a),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield _.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[_.URI.parse(n[0]),n[1]]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[_.URI.parse(n[0]),n[1]]}}e.ResourceMap=g,g.defaultToKey=t=>t.toString();var E;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(E=e.Touch||(e.Touch={}));class m{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var n;return(n=this._head)===null||n===void 0?void 0:n.value}get last(){var n;return(n=this._tail)===null||n===void 0?void 0:n.value}has(n){return this._map.has(n)}get(n,l=0){const a=this._map.get(n);if(!!a)return l!==0&&this.touch(a,l),a.value}set(n,l,a=0){let s=this._map.get(n);if(s)s.value=l,a!==0&&this.touch(s,a);else{switch(s={key:n,value:l,next:void 0,previous:void 0},a){case 0:this.addItemLast(s);break;case 1:this.addItemFirst(s);break;case 2:this.addItemLast(s);break;default:this.addItemLast(s);break}this._map.set(n,s),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const l=this._map.get(n);if(!!l)return this._map.delete(n),this.removeItem(l),this._size--,l.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}}forEach(n,l){const a=this._state;let s=this._head;for(;s;){if(l?n.bind(l)(s.value,s.key,this):n(s.value,s.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const n=this,l=this._state;let a=this._head;const s={[Symbol.iterator](){return s},next(){if(n._state!==l)throw new Error("LinkedMap got modified during iteration.");if(a){const c={value:a.key,done:!1};return a=a.next,c}else return{value:void 0,done:!0}}};return s}values(){const n=this,l=this._state;let a=this._head;const s={[Symbol.iterator](){return s},next(){if(n._state!==l)throw new Error("LinkedMap got modified during iteration.");if(a){const c={value:a.value,done:!1};return a=a.next,c}else return{value:void 0,done:!0}}};return s}entries(){const n=this,l=this._state;let a=this._head;const s={[Symbol.iterator](){return s},next(){if(n._state!==l)throw new Error("LinkedMap got modified during iteration.");if(a){const c={value:[a.key,a.value],done:!1};return a=a.next,c}else return{value:void 0,done:!0}}};return s}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(!(n>=this.size)){if(n===0){this.clear();return}let l=this._head,a=this.size;for(;l&&a>n;)this._map.delete(l.key),l=l.next,a--;this._head=l,this._size=a,l&&(l.previous=void 0),this._state++}}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const l=n.next,a=n.previous;if(!l||!a)throw new Error("Invalid list");l.previous=a,a.next=l}n.next=void 0,n.previous=void 0,this._state++}touch(n,l){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(l!==1&&l!==2)){if(l===1){if(n===this._head)return;const a=n.next,s=n.previous;n===this._tail?(s.next=void 0,this._tail=s):(a.previous=s,s.next=a),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(l===2){if(n===this._tail)return;const a=n.next,s=n.previous;n===this._head?(a.previous=void 0,this._head=a):(a.previous=s,s.next=a),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((l,a)=>{n.push([a,l])}),n}fromJSON(n){this.clear();for(const[l,a]of n)this.set(l,a)}}e.LinkedMap=m;class u extends m{constructor(n,l=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,l),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,l=2){return super.get(n,l)}peek(n){return super.get(n,0)}set(n,l){return super.set(n,l,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=u;class w{constructor(n){y.set(this,void 0),it(this,y,n,"f")}get size(){return Ue(this,y,"f").size}forEach(n,l){Ue(this,y,"f").forEach(n,l)}get(n){return Ue(this,y,"f").get(n)}has(n){return Ue(this,y,"f").has(n)}entries(){return Ue(this,y,"f").entries()}keys(){return Ue(this,y,"f").keys()}values(){return Ue(this,y,"f").values()}[(y=new WeakMap,Symbol.iterator)](){return Ue(this,y,"f").entries()}}e.ReadonlyMapView=w}),define(ve[110],be([0,1,22,8]),function(J,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function A(...fe){return function(De,Re){for(let He=0,we=fe.length;He<we;He++){const qe=fe[He](De,Re);if(qe)return qe}return null}}e.or=A,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(fe,De,Re){if(!Re||Re.length<De.length)return null;let He;return fe?He=k.startsWithIgnoreCase(Re,De):He=Re.indexOf(De)===0,He?De.length>0?[{start:0,end:De.length}]:[]:null}function y(fe,De){const Re=De.toLowerCase().indexOf(fe.toLowerCase());return Re===-1?null:[{start:Re,end:Re+fe.length}]}e.matchesContiguousSubString=y;function D(fe,De){return S(fe.toLowerCase(),De.toLowerCase(),0,0)}e.matchesSubString=D;function S(fe,De,Re,He){if(Re===fe.length)return[];if(He===De.length)return null;if(fe[Re]===De[He]){let we=null;return(we=S(fe,De,Re+1,He+1))?g({start:He,end:He+1},we):null}return S(fe,De,Re,He+1)}function C(fe){return 97<=fe&&fe<=122}function i(fe){return 65<=fe&&fe<=90}e.isUpper=i;function I(fe){return 48<=fe&&fe<=57}function d(fe){return fe===32||fe===9||fe===10||fe===13}const f=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(fe=>f.add(fe.charCodeAt(0)));function r(fe){return d(fe)||f.has(fe)}function o(fe,De){return fe===De||r(fe)&&r(De)}function p(fe){return C(fe)||i(fe)||I(fe)}function g(fe,De){return De.length===0?De=[fe]:fe.end===De[0].start?De[0].start=fe.start:De.unshift(fe),De}function E(fe,De){for(let Re=De;Re<fe.length;Re++){const He=fe.charCodeAt(Re);if(i(He)||I(He)||Re>0&&!p(fe.charCodeAt(Re-1)))return Re}return fe.length}function m(fe,De,Re,He){if(Re===fe.length)return[];if(He===De.length)return null;if(fe[Re]!==De[He].toLowerCase())return null;{let we=null,qe=He+1;for(we=m(fe,De,Re+1,He+1);!we&&(qe=E(De,qe))<De.length;)we=m(fe,De,Re+1,qe),qe++;return we===null?null:g({start:He,end:He+1},we)}}function u(fe){let De=0,Re=0,He=0,we=0,qe=0;for(let Ve=0;Ve<fe.length;Ve++)qe=fe.charCodeAt(Ve),i(qe)&&De++,C(qe)&&Re++,p(qe)&&He++,I(qe)&&we++;const z=De/fe.length,ee=Re/fe.length,ge=He/fe.length,Ne=we/fe.length;return{upperPercent:z,lowerPercent:ee,alphaPercent:ge,numericPercent:Ne}}function w(fe){const{upperPercent:De,lowerPercent:Re}=fe;return Re===0&&De>.6}function t(fe){const{upperPercent:De,lowerPercent:Re,alphaPercent:He,numericPercent:we}=fe;return Re>.2&&De<.8&&He>.6&&we<.2}function n(fe){let De=0,Re=0,He=0,we=0;for(let qe=0;qe<fe.length;qe++)He=fe.charCodeAt(qe),i(He)&&De++,C(He)&&Re++,d(He)&&we++;return(De===0||Re===0)&&we===0?fe.length<=30:De<=5}function l(fe,De){if(!De||(De=De.trim(),De.length===0)||!n(fe)||De.length>60)return null;const Re=u(De);if(!t(Re)){if(!w(Re))return null;De=De.toLowerCase()}let He=null,we=0;for(fe=fe.toLowerCase();we<De.length&&(He=m(fe,De,0,we))===null;)we=E(De,we+1);return He}e.matchesCamelCase=l;function a(fe,De,Re=!1){if(!De||De.length===0)return null;let He=null,we=0;for(fe=fe.toLowerCase(),De=De.toLowerCase();we<De.length&&(He=s(fe,De,0,we,Re))===null;)we=c(De,we+1);return He}e.matchesWords=a;function s(fe,De,Re,He,we){if(Re===fe.length)return[];if(He===De.length)return null;if(o(fe.charCodeAt(Re),De.charCodeAt(He))){let qe=null,z=He+1;if(qe=s(fe,De,Re+1,He+1,we),!we)for(;!qe&&(z=c(De,z))<De.length;)qe=s(fe,De,Re+1,z,we),z++;return qe===null?null:g({start:He,end:He+1},qe)}else return null}function c(fe,De){for(let Re=De;Re<fe.length;Re++)if(r(fe.charCodeAt(Re))||Re>0&&r(fe.charCodeAt(Re-1)))return Re;return fe.length}const v=A(e.matchesPrefix,l,y),P=A(e.matchesPrefix,l,D),h=new _.LRUCache(1e4);function b(fe,De,Re=!1){if(typeof fe!="string"||typeof De!="string")return null;let He=h.get(fe);He||(He=new RegExp(k.convertSimple2RegExpPattern(fe),"i"),h.set(fe,He));const we=He.exec(De);return we?[{start:we.index,end:we.index+we[0].length}]:Re?P(fe,De):v(fe,De)}e.matchesFuzzy=b;function R(fe,De){const Re=$(fe,fe.toLowerCase(),0,De,De.toLowerCase(),0,!0);return Re?K(Re):null}e.matchesFuzzy2=R;function U(fe,De,Re,He,we,qe){const z=Math.min(13,fe.length);for(;Re<z;Re++){const ee=$(fe,De,Re,He,we,qe,!1);if(ee)return ee}return[0,qe]}e.anyScore=U;function K(fe){if(typeof fe=="undefined")return[];const De=[],Re=fe[1];for(let He=fe.length-1;He>1;He--){const we=fe[He]+Re,qe=De[De.length-1];qe&&qe.end===we?qe.end=we+1:De.push({start:we,end:we+1})}return De}e.createMatches=K;const he=128;function V(){const fe=[],De=[];for(let Re=0;Re<=he;Re++)De[Re]=0;for(let Re=0;Re<=he;Re++)fe.push(De.slice(0));return fe}function H(fe){const De=[];for(let Re=0;Re<=fe;Re++)De[Re]=0;return De}const Y=H(2*he),W=H(2*he),F=V(),L=V(),M=V(),x=!1;function G(fe,De,Re,He,we){function qe(ee,ge,Ne=" "){for(;ee.length<ge;)ee=Ne+ee;return ee}let z=` |   |${He.split("").map(ee=>qe(ee,3)).join("|")}
`;for(let ee=0;ee<=Re;ee++)ee===0?z+=" |":z+=`${De[ee-1]}|`,z+=fe[ee].slice(0,we+1).map(ge=>qe(ge.toString(),3)).join("|")+`
`;return z}function X(fe,De,Re,He){fe=fe.substr(De),Re=Re.substr(He),console.log(G(L,fe,fe.length,Re,Re.length)),console.log(G(M,fe,fe.length,Re,Re.length)),console.log(G(F,fe,fe.length,Re,Re.length))}function ne(fe,De){if(De<0||De>=fe.length)return!1;const Re=fe.codePointAt(De);switch(Re){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!k.isEmojiImprecise(Re)}}function me(fe,De){if(De<0||De>=fe.length)return!1;switch(fe.charCodeAt(De)){case 32:case 9:return!0;default:return!1}}function Le(fe,De,Re){return De[fe]!==Re[fe]}function We(fe,De,Re,He,we,qe,z=!1){for(;De<Re&&we<qe;)fe[De]===He[we]&&(z&&(Y[De]=we),De+=1),we+=1;return De===Re}e.isPatternInWord=We;var Fe;(function(fe){fe[fe.Diag=1]="Diag",fe[fe.Left=2]="Left",fe[fe.LeftLeft=3]="LeftLeft"})(Fe||(Fe={}));var ze;(function(fe){fe.Default=[-100,0];function De(Re){return!Re||Re.length===2&&Re[0]===-100&&Re[1]===0}fe.isDefault=De})(ze=e.FuzzyScore||(e.FuzzyScore={}));function $(fe,De,Re,He,we,qe,z){const ee=fe.length>he?he:fe.length,ge=He.length>he?he:He.length;if(!(Re>=ee||qe>=ge||ee-Re>ge-qe)&&!!We(De,Re,ee,we,qe,ge,!0)){j(ee,ge,Re,qe,De,we);let Ne=1,Ve=1,$e=Re,Ze=qe;const ye=[!1];for(Ne=1,$e=Re;$e<ee;Ne++,$e++){const N=Y[$e],Q=W[$e],ae=$e+1<ee?W[$e+1]:ge;for(Ve=N-qe+1,Ze=N;Ze<ae;Ve++,Ze++){let ke=Number.MIN_SAFE_INTEGER,Ie=!1;Ze<=Q&&(ke=te(fe,De,$e,Re,He,we,Ze,ge,qe,F[Ne-1][Ve-1]===0,ye));let Ae=0;ke!==Number.MAX_SAFE_INTEGER&&(Ie=!0,Ae=ke+L[Ne-1][Ve-1]);const xe=Ze>N,Ye=xe?L[Ne][Ve-1]+(F[Ne][Ve-1]>0?-5:0):0,rt=Ze>N+1&&F[Ne][Ve-1]>0,tt=rt?L[Ne][Ve-2]+(F[Ne][Ve-2]>0?-5:0):0;if(rt&&(!xe||tt>=Ye)&&(!Ie||tt>=Ae))L[Ne][Ve]=tt,M[Ne][Ve]=3,F[Ne][Ve]=0;else if(xe&&(!Ie||Ye>=Ae))L[Ne][Ve]=Ye,M[Ne][Ve]=2,F[Ne][Ve]=0;else if(Ie)L[Ne][Ve]=Ae,M[Ne][Ve]=1,F[Ne][Ve]=F[Ne-1][Ve-1]+1;else throw new Error("not possible")}}if(x&&X(fe,Re,He,qe),!(!ye[0]&&!z)){Ne--,Ve--;const Ee=[L[Ne][Ve],qe];let Ce=0,re=0;for(;Ne>=1;){let N=Ve;do{const Q=M[Ne][N];if(Q===3)N=N-2;else if(Q===2)N=N-1;else break}while(N>=1);Ce>1&&De[Re+Ne-1]===we[qe+Ve-1]&&!Le(N+qe-1,He,we)&&Ce+1>F[Ne][N]&&(N=Ve),N===Ve?Ce++:Ce=1,re||(re=N),Ne--,Ve=N-1,Ee.push(Ve)}ge===ee&&(Ee[0]+=2);const le=re-ee;return Ee[0]-=le,Ee}}}e.fuzzyScore=$;function j(fe,De,Re,He,we,qe){let z=fe-1,ee=De-1;for(;z>=Re&&ee>=He;)we[z]===qe[ee]&&(W[z]=ee,z--),ee--}function te(fe,De,Re,He,we,qe,z,ee,ge,Ne,Ve){if(De[Re]!==qe[z])return Number.MIN_SAFE_INTEGER;let $e=1,Ze=!1;return z===Re-He?$e=fe[Re]===we[z]?7:5:Le(z,we,qe)&&(z===0||!Le(z-1,we,qe))?($e=fe[Re]===we[z]?7:5,Ze=!0):ne(qe,z)&&(z===0||!ne(qe,z-1))?$e=5:(ne(qe,z-1)||me(qe,z-1))&&($e=5,Ze=!0),$e>1&&Re===He&&(Ve[0]=!0),Ze||(Ze=Le(z,we,qe)||ne(qe,z-1)||me(qe,z-1)),Re===He?z>ge&&($e-=Ze?3:5):Ne?$e+=Ze?2:0:$e+=Ze?0:1,z+1===ee&&($e-=Ze?3:5),$e}function oe(fe,De,Re,He,we,qe,z){return _e(fe,De,Re,He,we,qe,!0,z)}e.fuzzyScoreGracefulAggressive=oe;function de(fe,De,Re,He,we,qe,z){return _e(fe,De,Re,He,we,qe,!1,z)}e.fuzzyScoreGraceful=de;function _e(fe,De,Re,He,we,qe,z,ee){let ge=$(fe,De,Re,He,we,qe,ee);if(ge&&!z)return ge;if(fe.length>=3){const Ne=Math.min(7,fe.length-1);for(let Ve=Re+1;Ve<Ne;Ve++){const $e=Be(fe,Ve);if($e){const Ze=$($e,$e.toLowerCase(),Re,He,we,qe,ee);Ze&&(Ze[0]-=3,(!ge||Ze[0]>ge[0])&&(ge=Ze))}}}return ge}function Be(fe,De){if(!(De+1>=fe.length)){const Re=fe[De],He=fe[De+1];if(Re!==He)return fe.slice(0,De)+He+Re+fe.slice(De+2)}}}),define(ve[111],be([0,1,36,110,8]),function(J,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const T=new RegExp(`\\$\\(${_.CSSIcon.iconNameExpression}(?:${_.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(`(\\\\)?${T.source}`,"g");function D(o){return o.replace(y,(p,g)=>g?p:`\\${p}`)}e.escapeIcons=D;const S=new RegExp(`\\\\${T.source}`,"g");function C(o){return o.replace(S,p=>`\\${p}`)}e.markdownEscapeEscapedIcons=C;const i=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function I(o){return o.indexOf(e.iconStartMarker)===-1?o:o.replace(i,(p,g,E,m)=>E?p:g||m||"")}e.stripIcons=I;function d(o){const p=o.indexOf(e.iconStartMarker);return p===-1?{text:o}:f(o,p)}e.parseLabelWithIcons=d;function f(o,p){const g=[];let E="";function m(c){if(c){E+=c;for(const v of c)g.push(t)}}let u=-1,w="",t=0,n,l,a=p;const s=o.length;for(m(o.substr(0,p));a<s;)n=o[a],l=o[a+1],n===e.iconStartMarker[0]&&l===e.iconStartMarker[1]?(u=a,m(w),w=e.iconStartMarker,a++):n===")"&&u!==-1?(t+=a-u+1,u=-1,w=""):u!==-1?/^[a-z0-9\-]$/i.test(n)?w+=n:(m(w),u=-1,w=""):m(n),a++;return m(w),{text:E,iconOffsets:g}}function r(o,p,g=!1){const{text:E,iconOffsets:m}=p;if(!m||m.length===0)return(0,k.matchesFuzzy)(o,E,g);const u=(0,A.ltrim)(E," "),w=E.length-u.length,t=(0,k.matchesFuzzy)(o,u,g);if(t)for(const n of t){const l=m[n.start+w]+w;n.start+=l,n.end+=l}return t}e.matchesFuzzyIconAware=r}),define(ve[83],be([0,1,15,111,12]),function(J,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var T;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(T=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(o="",p=!1){var g,E;if(this.value=o,typeof this.value!="string")throw(0,A.illegalArgument)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1):(this.isTrusted=(g=p.isTrusted)!==null&&g!==void 0?g:void 0,this.supportThemeIcons=(E=p.supportThemeIcons)!==null&&E!==void 0?E:!1)}appendText(o,p=0){return this.value+=I(this.supportThemeIcons?(0,k.escapeIcons)(o):o).replace(/([ \t]+)/g,(g,E)=>"&nbsp;".repeat(E.length)).replace(/^>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(o){return this.value+=o,this}appendCodeblock(o,p){return this.value+="\n```",this.value+=o,this.value+=`
`,this.value+=p,this.value+="\n```\n",this}}e.MarkdownString=y;function D(r){return S(r)?!r.value:Array.isArray(r)?r.every(D):!0}e.isEmptyMarkdownString=D;function S(r){return r instanceof y?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.isMarkdownString=S;function C(r,o){return!r&&!o?!0:!r||!o?!1:Array.isArray(r)&&Array.isArray(o)?(0,_.equals)(r,o,i):S(r)&&S(o)?i(r,o):!1}e.markedStringsEquals=C;function i(r,o){return r===o?!0:!r||!o?!1:r.value===o.value&&r.isTrusted===o.isTrusted&&r.supportThemeIcons===o.supportThemeIcons}function I(r){return r.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=I;function d(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=d;function f(r){const o=[],p=r.split("|").map(E=>E.trim());r=p[0];const g=p[1];if(g){const E=/height=(\d+)/.exec(g),m=/width=(\d+)/.exec(g),u=E?E[1]:"",w=m?m[1]:"",t=isFinite(parseInt(w)),n=isFinite(parseInt(u));t&&o.push(`width="${w}"`),n&&o.push(`height="${u}"`)}return{href:r,dimensions:o}}e.parseHrefAndDimensions=f}),define(ve[57],be([0,1,24,8,2]),function(J,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(C){return JSON.stringify(C,D)}e.stringify=T;function y(C){let i=JSON.parse(C);return i=S(i),i}e.parse=y;function D(C,i){return i instanceof RegExp?{$mid:2,source:i.source,flags:(0,k.regExpFlags)(i)}:i}function S(C,i=0){if(!C||i>200)return C;if(typeof C=="object"){switch(C.$mid){case 1:return A.URI.revive(C);case 2:return new RegExp(C.source,C.flags)}if(C instanceof _.VSBuffer||C instanceof Uint8Array)return C;if(Array.isArray(C))for(let I=0;I<C.length;++I)C[I]=S(C[I],i+1);else for(const I in C)Object.hasOwnProperty.call(C,I)&&(C[I]=S(C[I],i+1))}return C}e.revive=S}),define(ve[19],be([0,1,2,21]),function(J,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var A;(function(D){D.inMemory="inmemory",D.vscode="vscode",D.internal="private",D.walkThrough="walkThrough",D.walkThroughSnippet="walkThroughSnippet",D.http="http",D.https="https",D.file="file",D.mailto="mailto",D.untitled="untitled",D.data="data",D.command="command",D.vscodeRemote="vscode-remote",D.vscodeRemoteResource="vscode-remote-resource",D.userData="vscode-userdata",D.vscodeCustomEditor="vscode-custom-editor",D.vscodeNotebook="vscode-notebook",D.vscodeNotebookCell="vscode-notebook-cell",D.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",D.vscodeNotebookCellOutput="vscode-notebook-cell-output",D.vscodeSettings="vscode-settings",D.vscodeWorkspaceTrust="vscode-workspace-trust",D.vscodeTerminal="vscode-terminal",D.webviewPanel="webview-panel",D.vscodeWebview="vscode-webview",D.extension="extension",D.vscodeFileResource="vscode-file",D.tmp="tmp"})(A=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,C,i){this._hosts[S]=C,this._ports[S]=i}setConnectionToken(S,C){this._connectionTokens[S]=C}rewrite(S){if(this._delegate)return this._delegate(S);const C=S.authority;let i=this._hosts[C];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const I=this._ports[C],d=this._connectionTokens[C];let f=`path=${encodeURIComponent(S.path)}`;return typeof d=="string"&&(f+=`&tkn=${encodeURIComponent(d)}`),_.URI.from({scheme:k.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${i}:${I}`,path:"/vscode-remote-resource",query:f})}}e.RemoteAuthorities=new T;class y{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(S,C,i){const I=this.toUri(S,C);return I.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(I):k.isNative&&(i||k.isPreferringBrowserCodeLoad)&&I.scheme===A.file?I.with({scheme:A.vscodeFileResource,authority:I.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(S,C){const i=this.toUri(S,C);return i.scheme===A.vscodeFileResource?i.with({scheme:A.file,authority:i.authority!==this.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(S,C){return _.URI.isUri(S)?S:_.URI.parse(C.toUrl(S))}}e.FileAccess=new y}),define(ve[25],be([0,1,37,13,2,8,19,21]),function(J,e,_,k,A,T,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(f){return(0,A.uriToFsPath)(f,!0)}e.originalFSPath=S;class C{constructor(r){this._ignorePathCasing=r}compare(r,o,p=!1){return r===o?0:(0,T.compare)(this.getComparisonKey(r,p),this.getComparisonKey(o,p))}isEqual(r,o,p=!1){return r===o?!0:!r||!o?!1:this.getComparisonKey(r,p)===this.getComparisonKey(o,p)}getComparisonKey(r,o=!1){return r.with({path:this._ignorePathCasing(r)?r.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(r){return this._ignorePathCasing(r)}isEqualOrParent(r,o,p=!1){if(r.scheme===o.scheme){if(r.scheme===y.Schemas.file)return _.isEqualOrParent(S(r),S(o),this._ignorePathCasing(r))&&r.query===o.query&&(p||r.fragment===o.fragment);if((0,e.isEqualAuthority)(r.authority,o.authority))return _.isEqualOrParent(r.path,o.path,this._ignorePathCasing(r),"/")&&r.query===o.query&&(p||r.fragment===o.fragment)}return!1}joinPath(r,...o){return A.URI.joinPath(r,...o)}basenameOrAuthority(r){return(0,e.basename)(r)||r.authority}basename(r){return k.posix.basename(r.path)}extname(r){return k.posix.extname(r.path)}dirname(r){if(r.path.length===0)return r;let o;return r.scheme===y.Schemas.file?o=A.URI.file(k.dirname(S(r))).path:(o=k.posix.dirname(r.path),r.authority&&o.length&&o.charCodeAt(0)!==47&&(console.error(`dirname("${r.toString})) resulted in a relative path`),o="/")),r.with({path:o})}normalizePath(r){if(!r.path.length)return r;let o;return r.scheme===y.Schemas.file?o=A.URI.file(k.normalize(S(r))).path:o=k.posix.normalize(r.path),r.with({path:o})}relativePath(r,o){if(!(r.scheme!==o.scheme||!(0,e.isEqualAuthority)(r.authority,o.authority))){if(r.scheme===y.Schemas.file){const E=k.relative(S(r),S(o));return D.isWindows?_.toSlashes(E):E}let p=r.path||"/",g=o.path||"/";if(this._ignorePathCasing(r)){let E=0;for(const m=Math.min(p.length,g.length);E<m&&!(p.charCodeAt(E)!==g.charCodeAt(E)&&p.charAt(E).toLowerCase()!==g.charAt(E).toLowerCase());E++);p=g.substr(0,E)+p.substr(E)}return k.posix.relative(p,g)}}resolvePath(r,o){if(r.scheme===y.Schemas.file){const p=A.URI.file(k.resolve(S(r),o));return r.with({authority:p.authority,path:p.path})}return o.indexOf("/")===-1&&(o=_.toSlashes(o),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o)),r.with({path:k.posix.resolve(r.path,o)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,o){return r===o||(0,T.equalsIgnoreCase)(r,o)}hasTrailingPathSeparator(r,o=k.sep){if(r.scheme===y.Schemas.file){const p=S(r);return p.length>_.getRoot(p).length&&p[p.length-1]===o}else{const p=r.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,o=k.sep){return(0,e.hasTrailingPathSeparator)(r,o)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,o=k.sep){let p=!1;if(r.scheme===y.Schemas.file){const g=S(r);p=g!==void 0&&g.length===_.getRoot(g).length&&g[g.length-1]===o}else{o="/";const g=r.path;p=g.length===1&&g.charCodeAt(g.length-1)===47}return!p&&!(0,e.hasTrailingPathSeparator)(r,o)?r.with({path:r.path+"/"}):r}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(f=>f.scheme===y.Schemas.file?!D.isLinux:!0),e.extUriIgnorePathCase=new C(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(f,r){const o=[];for(let p=0;p<f.length;p++){const g=r(f[p]);f.some((E,m)=>m===p?!1:(0,e.isEqualOrParent)(g,r(E)))||o.push(f[p])}return o}e.distinctParents=i;var I;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function r(o){const p=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(m=>{const[u,w]=m.split(":");u&&w&&p.set(u,w)});const E=o.path.substring(0,o.path.indexOf(";"));return E&&p.set(f.META_DATA_MIME,E),p}f.parseMetaData=r})(I=e.DataUri||(e.DataUri={}));function d(f,r,o){if(r){let p=f.path;return p&&p[0]!==k.posix.sep&&(p=k.posix.sep+p),f.with({scheme:o,authority:r,path:p})}return f.with({scheme:o})}e.toLocalResource=d}),define(ve[11],be([0,1,20,12,3,6,45,25]),function(J,e,_,k,A,T,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(L){return!!L&&typeof L.then=="function"}e.isThenable=S;function C(L){const M=new _.CancellationTokenSource,x=L(M.token),G=new Promise((X,ne)=>{M.token.onCancellationRequested(()=>{ne((0,k.canceled)())}),Promise.resolve(x).then(me=>{M.dispose(),X(me)},me=>{M.dispose(),ne(me)})});return new class{cancel(){M.cancel()}then(X,ne){return G.then(X,ne)}catch(X){return this.then(void 0,X)}finally(X){return G.finally(X)}}}e.createCancelablePromise=C;function i(L,M,x){return Promise.race([L,new Promise(G=>M.onCancellationRequested(()=>G(x)))])}e.raceCancellation=i;async function I(L){let M=-1;const x=L.map((X,ne)=>X.then(me=>(M=ne,me))),G=await Promise.race(x);return L.forEach((X,ne)=>{ne!==M&&X.cancel()}),G}e.raceCancellablePromises=I;function d(L,M,x){let G;const X=setTimeout(()=>{G==null||G(void 0),x==null||x()},M);return Promise.race([L.finally(()=>clearTimeout(X)),new Promise(ne=>G=ne)])}e.raceTimeout=d;function f(L){return new Promise((M,x)=>{const G=L();S(G)?G.then(M,x):M(G)})}e.asPromise=f;class r{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(M){if(this.activePromise){if(this.queuedPromiseFactory=M,!this.queuedPromise){const x=()=>{this.queuedPromise=null;const G=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,G};this.queuedPromise=new Promise(G=>{this.activePromise.then(x,x).then(G)})}return new Promise((x,G)=>{this.queuedPromise.then(x,G)})}return this.activePromise=M(),new Promise((x,G)=>{this.activePromise.then(X=>{this.activePromise=null,x(X)},X=>{this.activePromise=null,G(X)})})}}e.Throttler=r;class o{constructor(){this.current=Promise.resolve(null)}queue(M){return this.current=this.current.then(()=>M(),()=>M())}}e.Sequencer=o;class p{constructor(){this.promiseMap=new Map}queue(M,x){var G;const ne=((G=this.promiseMap.get(M))!==null&&G!==void 0?G:Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.promiseMap.get(M)===ne&&this.promiseMap.delete(M)});return this.promiseMap.set(M,ne),ne}}e.SequencerByKey=p;class g{constructor(M){this.defaultDelay=M,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(M,x=this.defaultDelay){return this.task=M,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((G,X)=>{this.doResolve=G,this.doReject=X}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const G=this.task;return this.task=null,G()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},x),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,k.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=g;class E{constructor(M){this.delayer=new g(M),this.throttler=new r}trigger(M,x){return this.delayer.trigger(()=>this.throttler.queue(M),x)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=E;class m{constructor(){this._isOpen=!1,this._promise=new Promise((M,x)=>{this._completePromise=M})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=m;class u extends m{constructor(M){super();this._timeout=setTimeout(()=>this.open(),M)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function w(L,M){return M?new Promise((x,G)=>{const X=setTimeout(x,L);M.onCancellationRequested(()=>{clearTimeout(X),G((0,k.canceled)())})}):C(x=>w(L,x))}e.timeout=w;function t(L,M=0){const x=setTimeout(L,M);return(0,T.toDisposable)(()=>clearTimeout(x))}e.disposableTimeout=t;function n(L){return L.then(void 0,M=>{})}e.ignoreErrors=n;function l(L){const M=[];let x=0;const G=L.length;function X(){return x<G?L[x++]():null}function ne(me){me!=null&&M.push(me);const Le=X();return Le?Le.then(ne):Promise.resolve(M)}return Promise.resolve(null).then(ne)}e.sequence=l;function a(L,M=G=>!!G,x=null){let G=0;const X=L.length,ne=()=>{if(G>=X)return Promise.resolve(x);const me=L[G++];return Promise.resolve(me()).then(We=>M(We)?Promise.resolve(We):ne())};return ne()}e.first=a;function s(L,M=G=>!!G,x=null){if(L.length===0)return Promise.resolve(x);let G=L.length;const X=()=>{var ne,me;G=-1;for(const Le of L)(me=(ne=Le).cancel)===null||me===void 0||me.call(ne)};return new Promise((ne,me)=>{for(const Le of L)Le.then(We=>{--G>=0&&M(We)?(X(),ne(We)):G===0&&ne(x)}).catch(We=>{--G>=0&&(X(),me(We))})})}e.firstParallel=s;class c{constructor(M){this._size=0,this.maxDegreeOfParalellism=M,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new A.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(M){return this._size++,new Promise((x,G)=>{this.outstandingPromises.push({factory:M,c:x,e:G}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const M=this.outstandingPromises.shift();this.runningPromises++;const x=M.factory();x.then(M.c,M.e),x.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=c;class v extends c{constructor(){super(1)}}e.Queue=v;class P{constructor(){this.queues=new Map}queueFor(M,x=D.extUri){const G=x.getComparisonKey(M);let X=this.queues.get(G);return X||(X=new v,A.Event.once(X.onFinished)(()=>{X==null||X.dispose(),this.queues.delete(G)}),this.queues.set(G,X)),X}dispose(){this.queues.forEach(M=>M.dispose()),this.queues.clear()}}e.ResourceQueue=P;class h{constructor(M,x){this._token=-1,typeof M=="function"&&typeof x=="number"&&this.setIfNotSet(M,x)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(M,x){this.cancel(),this._token=setTimeout(()=>{this._token=-1,M()},x)}setIfNotSet(M,x){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,M()},x))}}e.TimeoutTimer=h;class b{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(M,x){this.cancel(),this._token=setInterval(()=>{M()},x)}}e.IntervalTimer=b;class R{constructor(M,x){this.timeoutToken=-1,this.runner=M,this.timeout=x,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(M=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,M)}get delay(){return this.timeout}set delay(M){this.timeout=M}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class U extends R{constructor(M,x){super(M,x);this.units=[]}work(M){this.units.push(M),this.isScheduled()||this.schedule()}doRun(){const M=this.units;this.units=[],this.runner&&this.runner(M)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=U,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const L=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=M=>{const x=setTimeout(()=>M(L));let G=!1;return{dispose(){G||(G=!0,clearTimeout(x))}}}}else e.runWhenIdle=(L,M)=>{const x=requestIdleCallback(L,typeof M=="number"?{timeout:M}:void 0);let G=!1;return{dispose(){G||(G=!0,cancelIdleCallback(x))}}}}();class K{constructor(M){this._didRun=!1,this._executor=()=>{try{this._value=M()}catch(x){this._error=x}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=K;async function he(L,M,x){let G;for(let X=0;X<x;X++)try{return await L()}catch(ne){G=ne,await w(M)}throw G}e.retry=he;class V{hasPending(M){return this._pending?typeof M=="number"?this._pending.taskId===M:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var M;(M=this._pending)===null||M===void 0||M.cancel()}setPending(M,x,G){return this._pending={taskId:M,cancel:()=>G==null?void 0:G(),promise:x},x.then(()=>this.donePending(M),()=>this.donePending(M)),x}donePending(M){this._pending&&M===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const M=this._next;this._next=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}setNext(M){if(this._next)this._next.run=M;else{let x,G;const X=new Promise((ne,me)=>{x=ne,G=me});this._next={run:M,promise:X,promiseResolve:x,promiseReject:G}}return this._next.promise}}e.TaskSequentializer=V;class H{constructor(M){this.interval=M,this.lastIncrementTime=0,this.value=0}increment(){const M=Date.now();return M-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=M,this.value=0),this.value++,this.value}}e.IntervalCounter=H;class Y{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((M,x)=>{this.completeCallback=M,this.errorCallback=x})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(M){return new Promise(x=>{this.completeCallback(M),this.resolved=!0,x()})}error(M){return new Promise(x=>{this.errorCallback(M),this.rejected=!0,x()})}cancel(){new Promise(M=>{this.errorCallback((0,k.canceled)()),this.rejected=!0,M()})}}e.DeferredPromise=Y;class W extends A.Emitter{async fireAsync(M,x,G){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new y.LinkedList);for(const X of this._listeners)this._asyncDeliveryQueue.push([X,M]);for(;this._asyncDeliveryQueue.size>0&&!x.isCancellationRequested;){const[X,ne]=this._asyncDeliveryQueue.shift(),me=[],Le=Object.assign(Object.assign({},ne),{waitUntil:We=>{if(Object.isFrozen(me))throw new Error("waitUntil can NOT be called asynchronous");G&&(We=G(We,typeof X=="function"?X:X[0])),me.push(We)}});try{typeof X=="function"?X.call(void 0,Le):X[0].call(X[1],Le)}catch(We){(0,k.onUnexpectedError)(We);continue}Object.freeze(me),await F.settled(me).catch(We=>(0,k.onUnexpectedError)(We))}}}}e.AsyncEmitter=W;var F;(function(L){async function M(ne){return typeof Promise.allSettled=="function"?x(ne):G(ne)}L.allSettled=M;async function x(ne){return Promise.allSettled(ne)}async function G(ne){return Promise.all(ne.map(me=>me.then(Le=>({status:"fulfilled",value:Le}),Le=>({status:"rejected",reason:Le}))))}async function X(ne){let me;const Le=await Promise.all(ne.map(We=>We.then(Fe=>Fe,Fe=>{me||(me=Fe)})));if(typeof me!="undefined")throw me;return Le}L.settled=X})(F=e.Promises||(e.Promises={}))}),define(ve[112],be([0,1,13,11]),function(J,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const A=new k.IdleValue(()=>{const h=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:h,collatorIsNumeric:h.resolvedOptions().numeric}}),T=new k.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new k.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function D(h,b,R=!1){const U=h||"",K=b||"",he=A.value.collator.compare(U,K);return A.value.collatorIsNumeric&&he===0&&U!==K?U<K?-1:1:he}e.compareFileNames=D;function S(h,b){const R=T.value.collator;return h=h||"",b=b||"",w(R,h,b)}e.compareFileNamesDefault=S;function C(h,b){const R=T.value.collator;return h=h||"",b=b||"",a(h,b)||w(R,h,b)}e.compareFileNamesUpper=C;function i(h,b){const R=T.value.collator;return h=h||"",b=b||"",l(h,b)||w(R,h,b)}e.compareFileNamesLower=i;function I(h,b){return h=h||"",b=b||"",h===b?0:h<b?-1:1}e.compareFileNamesUnicode=I;function d(h,b,R=!1){R||(h=h&&h.toLowerCase(),b=b&&b.toLowerCase());const[U,K]=m(h),[he,V]=m(b);return U!==he?U<he?-1:1:K===V?0:K<V?-1:1}e.noIntlCompareFileNames=d;function f(h,b){const[R,U]=m(h),[K,he]=m(b);let V=A.value.collator.compare(U,he);if(V===0){if(A.value.collatorIsNumeric&&U!==he)return U<he?-1:1;if(V=A.value.collator.compare(R,K),A.value.collatorIsNumeric&&V===0&&R!==K)return R<K?-1:1}return V}e.compareFileExtensions=f;function r(h,b){h=h||"",b=b||"";const R=u(h),U=u(b),K=T.value.collator,he=y.value.collator;return w(he,R,U)||w(K,h,b)}e.compareFileExtensionsDefault=r;function o(h,b){h=h||"",b=b||"";const R=u(h),U=u(b),K=T.value.collator,he=y.value.collator;return w(he,R,U)||a(h,b)||w(K,h,b)}e.compareFileExtensionsUpper=o;function p(h,b){h=h||"",b=b||"";const R=u(h),U=u(b),K=T.value.collator,he=y.value.collator;return w(he,R,U)||l(h,b)||w(K,h,b)}e.compareFileExtensionsLower=p;function g(h,b){h=h||"",b=b||"";const R=u(h).toLowerCase(),U=u(b).toLowerCase();return R!==U?R<U?-1:1:h!==b?h<b?-1:1:0}e.compareFileExtensionsUnicode=g;const E=/^(.*?)(\.([^.]*))?$/;function m(h,b=!1){const R=h?E.exec(h):[];let U=[R&&R[1]||"",R&&R[3]||""];return b&&(!U[0]&&U[1]||U[0]&&U[0].charAt(0)===".")&&(U=[U[0]+"."+U[1],""]),U}function u(h){const b=h?E.exec(h):[];return b&&b[1]&&b[1].charAt(0)!=="."&&b[3]||""}function w(h,b,R){let U=h.compare(b,R);return U!==0?U:b.length!==R.length?b.length<R.length?-1:1:0}function t(h){const b=h.charAt(0);return b.toLocaleUpperCase()!==b}function n(h){const b=h.charAt(0);return b.toLocaleLowerCase()!==b}function l(h,b){return t(h)&&n(b)?-1:n(h)&&t(b)?1:0}function a(h,b){return n(h)&&t(b)?-1:t(h)&&n(b)?1:0}function s(h,b,R=!1){return R||(h=h&&h.toLowerCase(),b=b&&b.toLowerCase()),h===b?0:h<b?-1:1}function c(h,b,R=!1){const U=h.split(_.sep),K=b.split(_.sep),he=U.length-1,V=K.length-1;let H,Y;for(let W=0;;W++){if(H=he===W,Y=V===W,H&&Y)return D(U[W],K[W],R);if(H)return-1;if(Y)return 1;const F=s(U[W],K[W],R);if(F!==0)return F}}e.comparePaths=c;function v(h,b,R){const U=h.toLowerCase(),K=b.toLowerCase(),he=P(h,b,R);if(he)return he;const V=U.endsWith(R),H=K.endsWith(R);if(V!==H)return V?-1:1;const Y=D(U,K);return Y!==0?Y:U.localeCompare(K)}e.compareAnything=v;function P(h,b,R){const U=h.toLowerCase(),K=b.toLowerCase(),he=U.startsWith(R),V=K.startsWith(R);if(he!==V)return he?-1:1;if(he&&V){if(U.length<K.length)return-1;if(U.length>K.length)return 1}return 0}e.compareByPrefix=P}),define(ve[28],be([0,1,8,37,13,22,11]),function(J,e,_,k,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D;const S="**",C="/",i="[/\\\\]",I="[^/\\\\]",d=/\//g;function f(x){switch(x){case 0:return"";case 1:return`${I}*?`;default:return`(?:${i}|${I}+${i}|${i}${I}+)*?`}}function r(x,G){if(!x)return[];const X=[];let ne=!1,me=!1,Le="";for(const We of x){switch(We){case G:if(!ne&&!me){X.push(Le),Le="";continue}break;case"{":ne=!0;break;case"}":ne=!1;break;case"[":me=!0;break;case"]":me=!1;break}Le+=We}return Le&&X.push(Le),X}e.splitGlobAware=r;function o(x){if(!x)return"";let G="";const X=r(x,C);if(X.every(ne=>ne===S))G=".*";else{let ne=!1;X.forEach((me,Le)=>{if(me===S){ne||(G+=f(2),ne=!0);return}let We=!1,Fe="",ze=!1,$="";for(const j of me){if(j!=="}"&&We){Fe+=j;continue}if(ze&&(j!=="]"||!$)){let te;j==="-"?te=j:(j==="^"||j==="!")&&!$?te="^":j===C?te="":te=_.escapeRegExpCharacters(j),$+=te;continue}switch(j){case"{":We=!0;continue;case"[":ze=!0;continue;case"}":G+=`(?:${r(Fe,",").map(de=>o(de)).join("|")})`,We=!1,Fe="";break;case"]":G+="["+$+"]",ze=!1,$="";break;case"?":G+=I;continue;case"*":G+=f(1);continue;default:G+=_.escapeRegExpCharacters(j)}}Le<X.length-1&&(X[Le+1]!==S||Le+2<X.length)&&(G+=i),ne=!1})}return G}const p=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,m=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,w=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new T.LRUCache(1e4),n=function(){return!1},l=function(){return null};function a(x,G){if(!x)return l;let X;typeof x!="string"?X=x.pattern:X=x,X=X.trim();const ne=`${X}_${!!G.trimForExclusions}`;let me=t.get(ne);if(me)return s(me,x);let Le;if(p.test(X)){const We=X.substr(4);me=function(Fe,ze){return typeof Fe=="string"&&Fe.endsWith(We)?X:null}}else(Le=g.exec(c(X,G)))?me=v(Le[1],X):(G.trimForExclusions?m:E).test(X)?me=P(X,G):(Le=u.exec(c(X,G)))?me=h(Le[1].substr(1),X,!0):(Le=w.exec(c(X,G)))?me=h(Le[1],X,!1):me=b(X);return t.set(ne,me),s(me,x)}function s(x,G){return typeof G=="string"?x:function(X,ne){return k.isEqualOrParent(X,G.base)?x(A.relative(G.base,X),ne):null}}function c(x,G){return G.trimForExclusions&&x.endsWith("/**")?x.substr(0,x.length-2):x}function v(x,G){const X=`/${x}`,ne=`\\${x}`,me=function(We,Fe){return typeof We!="string"?null:Fe?Fe===x?G:null:We===x||We.endsWith(X)||We.endsWith(ne)?G:null},Le=[x];return me.basenames=Le,me.patterns=[G],me.allBasenames=Le,me}function P(x,G){const X=M(x.slice(1,-1).split(",").map(Fe=>a(Fe,G)).filter(Fe=>Fe!==l),x),ne=X.length;if(!ne)return l;if(ne===1)return X[0];const me=function(Fe,ze){for(let $=0,j=X.length;$<j;$++)if(X[$](Fe,ze))return x;return null},Le=X.find(Fe=>!!Fe.allBasenames);Le&&(me.allBasenames=Le.allBasenames);const We=X.reduce((Fe,ze)=>ze.allPaths?Fe.concat(ze.allPaths):Fe,[]);return We.length&&(me.allPaths=We),me}function h(x,G,X){const ne=A.sep===A.posix.sep,me=ne?x:x.replace(d,A.sep),Le=A.sep+me,We=A.posix.sep+x,Fe=X?function(ze,$){return typeof ze=="string"&&(ze===me||ze.endsWith(Le)||!ne&&(ze===x||ze.endsWith(We)))?G:null}:function(ze,$){return typeof ze=="string"&&(ze===me||!ne&&ze===x)?G:null};return Fe.allPaths=[(X?"*/":"./")+x],Fe}function b(x){try{const G=new RegExp(`^${o(x)}$`);return function(X){return G.lastIndex=0,typeof X=="string"&&G.test(X)?x:null}}catch(G){return l}}function R(x,G,X){return!x||typeof G!="string"?!1:U(x)(G,void 0,X)}e.match=R;function U(x,G={}){if(!x)return n;if(typeof x=="string"||H(x)){const X=a(x,G);if(X===l)return n;const ne=function(me,Le){return!!X(me,Le)};return X.allBasenames&&(ne.allBasenames=X.allBasenames),X.allPaths&&(ne.allPaths=X.allPaths),ne}return F(x,G)}e.parse=U;function K(x){if(!!x){let G;return X=>(G||(G=(x()||Promise.resolve([])).then(ne=>ne?V(ne):{})),G.then(ne=>!!ne[X]))}}e.hasSiblingPromiseFn=K;function he(x){if(!!x){let G;return X=>{if(!G){const ne=x();G=ne?V(ne):{}}return!!G[X]}}}e.hasSiblingFn=he;function V(x){const G={};for(const X of x)G[X]=!0;return G}function H(x){const G=x;return G&&typeof G.base=="string"&&typeof G.pattern=="string"}e.isRelativePattern=H;function Y(x){return x.allBasenames||[]}e.getBasenameTerms=Y;function W(x){return x.allPaths||[]}e.getPathTerms=W;function F(x,G){const X=M(Object.getOwnPropertyNames(x).map(Fe=>L(Fe,x[Fe],G)).filter(Fe=>Fe!==l)),ne=X.length;if(!ne)return l;if(!X.some(Fe=>!!Fe.requiresSiblings)){if(ne===1)return X[0];const Fe=function(j,te){for(let oe=0,de=X.length;oe<de;oe++){const _e=X[oe](j,te);if(_e)return _e}return null},ze=X.find(j=>!!j.allBasenames);ze&&(Fe.allBasenames=ze.allBasenames);const $=X.reduce((j,te)=>te.allPaths?j.concat(te.allPaths):j,[]);return $.length&&(Fe.allPaths=$),Fe}const me=function(Fe,ze,$){let j;for(let te=0,oe=X.length;te<oe;te++){const de=X[te];de.requiresSiblings&&$&&(ze||(ze=A.basename(Fe)),j||(j=ze.substr(0,ze.length-A.extname(Fe).length)));const _e=de(Fe,ze,j,$);if(_e)return _e}return null},Le=X.find(Fe=>!!Fe.allBasenames);Le&&(me.allBasenames=Le.allBasenames);const We=X.reduce((Fe,ze)=>ze.allPaths?Fe.concat(ze.allPaths):Fe,[]);return We.length&&(me.allPaths=We),me}function L(x,G,X){if(G===!1)return l;const ne=a(x,X);if(ne===l)return l;if(typeof G=="boolean")return ne;if(G){const me=G.when;if(typeof me=="string"){const Le=(We,Fe,ze,$)=>{if(!$||!ne(We,Fe))return null;const j=me.replace("$(basename)",ze),te=$(j);return(0,y.isThenable)(te)?te.then(oe=>oe?x:null):te?x:null};return Le.requiresSiblings=!0,Le}}return ne}function M(x,G){const X=x.filter(Fe=>!!Fe.basenames);if(X.length<2)return x;const ne=X.reduce((Fe,ze)=>{const $=ze.basenames;return $?Fe.concat($):Fe},[]);let me;if(G){me=[];for(let Fe=0,ze=ne.length;Fe<ze;Fe++)me.push(G)}else me=X.reduce((Fe,ze)=>{const $=ze.patterns;return $?Fe.concat($):Fe},[]);const Le=function(Fe,ze){if(typeof Fe!="string")return null;if(!ze){let j;for(j=Fe.length;j>0;j--){const te=Fe.charCodeAt(j-1);if(te===47||te===92)break}ze=Fe.substr(j)}const $=ne.indexOf(ze);return $!==-1?me[$]:null};Le.basenames=ne,Le.patterns=me,Le.allBasenames=ne;const We=x.filter(Fe=>!Fe.basenames);return We.push(Le),We}}),define(ve[58],be([0,1,2,13,8,19,21,25,37]),function(J,e,_,k,A,T,y,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function C(a,s,c){if(typeof a=="string"&&(a=_.URI.file(a)),c){const P=c.getWorkspaceFolder(a);if(P){const h=c.getWorkspace().folders.length>1;let b;if((0,D.isEqual)(P.uri,a)?b="":b=(0,D.relativePath)(P.uri,a),h){const R=P.name?P.name:(0,D.basename)(P.uri);b=b?R+" \u2022 "+b:R}return b}}if(a.scheme!==T.Schemas.file&&a.scheme!==T.Schemas.untitled)return a.with({query:null,fragment:null}).toString(!0);if((0,S.hasDriveLetter)(a.fsPath))return(0,k.normalize)(I(a.fsPath));let v=(0,k.normalize)(a.fsPath);return!y.isWindows&&(s==null?void 0:s.userHome)&&(v=f(v,s.userHome.fsPath)),v}e.getPathLabel=C;function i(a){if(!!a){typeof a=="string"&&(a=_.URI.file(a));const s=(0,D.basename)(a)||(a.scheme===T.Schemas.file?a.fsPath:a.path);return y.isWindows&&(0,S.isRootOrDriveLetter)(s)?I(s):s}}e.getBaseLabel=i;function I(a){return(0,S.hasDriveLetter)(a)?a.charAt(0).toUpperCase()+a.slice(1):a}e.normalizeDriveLetter=I;let d=Object.create(null);function f(a,s){if(y.isWindows||!a||!s)return a;let c=d.original===s?d.normalized:void 0;return c||(c=`${(0,A.rtrim)(s,k.posix.sep)}${k.posix.sep}`,d={original:s,normalized:c}),(y.isLinux?a.startsWith(c):(0,A.startsWithIgnoreCase)(a,c))&&(a=`~/${a.substr(c.length)}`),a}e.tildify=f;function r(a,s){return a.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=r;const o="\u2026",p="\\\\",g="~";function E(a,s=k.sep){const c=new Array(a.length);let v=!1;for(let P=0;P<a.length;P++){let h=a[P];if(h===""){c[P]=`.${s}`;continue}if(!h){c[P]=h;continue}v=!0;let b="";h.indexOf(p)===0?(b=h.substr(0,h.indexOf(p)+p.length),h=h.substr(h.indexOf(p)+p.length)):h.indexOf(s)===0?(b=h.substr(0,h.indexOf(s)+s.length),h=h.substr(h.indexOf(s)+s.length)):h.indexOf(g)===0&&(b=h.substr(0,h.indexOf(g)+g.length),h=h.substr(h.indexOf(g)+g.length));const R=h.split(s);for(let U=1;v&&U<=R.length;U++)for(let K=R.length-U;v&&K>=0;K--){v=!1;let he=R.slice(K,K+U).join(s);for(let V=0;!v&&V<a.length;V++)if(V!==P&&a[V]&&a[V].indexOf(he)>-1){const H=K+U===R.length,Y=K>0&&a[V].indexOf(s)>-1?s+he:he,W=a[V].endsWith(Y);v=!H||W}if(!v){let V="";(R[0].endsWith(":")||b!=="")&&(K===1&&(K=0,U++,he=R[0]+s+he),K>0&&(V=R[0]+s),V=b+V),K>0&&(V=V+o+s),V=V+he,K+U<R.length&&(V=V+s+o),c[P]=V}}v&&(c[P]=h)}return c}e.shorten=E;var m;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function u(a,s=Object.create(null)){const c=[];let v=!1,P="";for(const h of a)if(h==="$"||v&&h==="{")P&&c.push({value:P,type:m.TEXT}),P="",v=!0;else if(h==="}"&&v){const b=s[P];if(typeof b=="string")b.length&&c.push({value:b,type:m.VARIABLE});else if(b){const R=c[c.length-1];(!R||R.type!==m.SEPARATOR)&&c.push({value:b.label,type:m.SEPARATOR})}P="",v=!1}else P+=h;return P&&!v&&c.push({value:P,type:m.TEXT}),c.filter((h,b)=>{if(h.type===m.SEPARATOR){const R=c[b-1],U=c[b+1];return[R,U].every(K=>K&&(K.type===m.VARIABLE||K.type===m.TEXT)&&K.value.length>0)}return!0}).map(h=>h.value).join("")}e.template=u;function w(a,s){return y.isMacintosh||s?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,y.isMacintosh?"&":"&&"):a.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.mnemonicMenuLabel=w;function t(a,s){return y.isMacintosh||s?a.replace(/\(&&\w\)|&&/g,""):y.isWindows?a.replace(/&&|&/g,c=>c==="&"?"&&":"&"):a.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function n(a){return a.replace(/&/g,"&&")}e.unmnemonicLabel=n;function l(a){const s=a.indexOf("/")!==-1?k.posix:k.win32,c=s.basename(a),v=s.dirname(a);return c.length?{name:c,parentPath:v}:{name:v,parentPath:""}}e.splitName=l}),define(ve[113],be([0,1,2]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function k(i){return i.toJSON()}class A{constructor(I){this._uriTransformer=I}transformIncoming(I){const d=this._uriTransformer.transformIncoming(I);return d===I?I:k(_.URI.from(d))}transformOutgoing(I){const d=this._uriTransformer.transformOutgoing(I);return d===I?I:k(_.URI.from(d))}transformOutgoingURI(I){const d=this._uriTransformer.transformOutgoing(I);return d===I?I:_.URI.from(d)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function T(i,I,d){if(!i||d>200)return null;if(typeof i=="object"){if(i instanceof _.URI)return I.transformOutgoing(i);for(let f in i)if(Object.hasOwnProperty.call(i,f)){const r=T(i[f],I,d+1);r!==null&&(i[f]=r)}}return null}function y(i,I){const d=T(i,I,0);return d===null?i:d}e.transformOutgoingURIs=y;function D(i,I,d,f){if(!i||f>200)return null;if(typeof i=="object"){if(i.$mid===1)return d?_.URI.revive(I.transformIncoming(i)):I.transformIncoming(i);for(let r in i)if(Object.hasOwnProperty.call(i,r)){const o=D(i[r],I,d,f+1);o!==null&&(i[r]=o)}}return null}function S(i,I){const d=D(i,I,!1,0);return d===null?i:d}e.transformIncomingURIs=S;function C(i,I){const d=D(i,I,!0,0);return d===null?i:d}e.transformAndReviveIncomingURIs=C}),define(ve[31],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const _=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function k(S){return _.test(S)}e.isUUID=k;const A=new Uint8Array(16),T=[];for(let S=0;S<256;S++)T.push(S.toString(16).padStart(2,"0"));let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(S){for(let C=0;C<S.length;C++)S[C]=Math.floor(Math.random()*256);return S};function D(){y(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let S=0,C="";return C+=T[A[S++]],C+=T[A[S++]],C+=T[A[S++]],C+=T[A[S++]],C+="-",C+=T[A[S++]],C+=T[A[S++]],C+="-",C+=T[A[S++]],C+=T[A[S++]],C+="-",C+=T[A[S++]],C+=T[A[S++]],C+="-",C+=T[A[S++]],C+=T[A[S++]],C+=T[A[S++]],C+=T[A[S++]],C+=T[A[S++]],C+=T[A[S++]],C}e.generateUuid=D}),define(ve[84],be([0,1,82]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class k{constructor(D){let S=(0,_.toUint8)(D);this._defaultValue=S,this._asciiMap=k._createAsciiMap(S),this._map=new Map}static _createAsciiMap(D){let S=new Uint8Array(256);for(let C=0;C<256;C++)S[C]=D;return S}set(D,S){let C=(0,_.toUint8)(S);D>=0&&D<256?this._asciiMap[D]=C:this._map.set(D,C)}get(D){return D>=0&&D<256?this._asciiMap[D]:this._map.get(D)||this._defaultValue}}e.CharacterClassifier=k;var A;(function(y){y[y.False=0]="False",y[y.True=1]="True"})(A||(A={}));class T{constructor(){this._actual=new k(0)}add(D){this._actual.set(D,1)}has(D){return this._actual.get(D)===1}}e.CharacterSet=T}),define(ve[114],be([0,1,84]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var k;(function(y){y[y.Regular=0]="Regular",y[y.Whitespace=1]="Whitespace",y[y.WordSeparator=2]="WordSeparator"})(k=e.WordCharacterClass||(e.WordCharacterClass={}));class A extends _.CharacterClassifier{constructor(D){super(0);for(let S=0,C=D.length;S<C;S++)this.set(D.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=A;function T(y){let D={};return S=>(D.hasOwnProperty(S)||(D[S]=y(S)),D[S])}e.getMapForWordSeparators=T(y=>new A(y))}),define(ve[38],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class _{constructor(A,T){this.lineNumber=A,this.column=T}with(A=this.lineNumber,T=this.column){return A===this.lineNumber&&T===this.column?this:new _(A,T)}delta(A=0,T=0){return this.with(this.lineNumber+A,this.column+T)}equals(A){return _.equals(this,A)}static equals(A,T){return!A&&!T?!0:!!A&&!!T&&A.lineNumber===T.lineNumber&&A.column===T.column}isBefore(A){return _.isBefore(this,A)}static isBefore(A,T){return A.lineNumber<T.lineNumber?!0:T.lineNumber<A.lineNumber?!1:A.column<T.column}isBeforeOrEqual(A){return _.isBeforeOrEqual(this,A)}static isBeforeOrEqual(A,T){return A.lineNumber<T.lineNumber?!0:T.lineNumber<A.lineNumber?!1:A.column<=T.column}static compare(A,T){let y=A.lineNumber|0,D=T.lineNumber|0;if(y===D){let S=A.column|0,C=T.column|0;return S-C}return y-D}clone(){return new _(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(A){return new _(A.lineNumber,A.column)}static isIPosition(A){return A&&typeof A.lineNumber=="number"&&typeof A.column=="number"}}e.Position=_}),define(ve[32],be([0,1,38]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class k{constructor(T,y,D,S){T>D||T===D&&y>S?(this.startLineNumber=D,this.startColumn=S,this.endLineNumber=T,this.endColumn=y):(this.startLineNumber=T,this.startColumn=y,this.endLineNumber=D,this.endColumn=S)}isEmpty(){return k.isEmpty(this)}static isEmpty(T){return T.startLineNumber===T.endLineNumber&&T.startColumn===T.endColumn}containsPosition(T){return k.containsPosition(this,T)}static containsPosition(T,y){return!(y.lineNumber<T.startLineNumber||y.lineNumber>T.endLineNumber||y.lineNumber===T.startLineNumber&&y.column<T.startColumn||y.lineNumber===T.endLineNumber&&y.column>T.endColumn)}containsRange(T){return k.containsRange(this,T)}static containsRange(T,y){return!(y.startLineNumber<T.startLineNumber||y.endLineNumber<T.startLineNumber||y.startLineNumber>T.endLineNumber||y.endLineNumber>T.endLineNumber||y.startLineNumber===T.startLineNumber&&y.startColumn<T.startColumn||y.endLineNumber===T.endLineNumber&&y.endColumn>T.endColumn)}strictContainsRange(T){return k.strictContainsRange(this,T)}static strictContainsRange(T,y){return!(y.startLineNumber<T.startLineNumber||y.endLineNumber<T.startLineNumber||y.startLineNumber>T.endLineNumber||y.endLineNumber>T.endLineNumber||y.startLineNumber===T.startLineNumber&&y.startColumn<=T.startColumn||y.endLineNumber===T.endLineNumber&&y.endColumn>=T.endColumn)}plusRange(T){return k.plusRange(this,T)}static plusRange(T,y){let D,S,C,i;return y.startLineNumber<T.startLineNumber?(D=y.startLineNumber,S=y.startColumn):y.startLineNumber===T.startLineNumber?(D=y.startLineNumber,S=Math.min(y.startColumn,T.startColumn)):(D=T.startLineNumber,S=T.startColumn),y.endLineNumber>T.endLineNumber?(C=y.endLineNumber,i=y.endColumn):y.endLineNumber===T.endLineNumber?(C=y.endLineNumber,i=Math.max(y.endColumn,T.endColumn)):(C=T.endLineNumber,i=T.endColumn),new k(D,S,C,i)}intersectRanges(T){return k.intersectRanges(this,T)}static intersectRanges(T,y){let D=T.startLineNumber,S=T.startColumn,C=T.endLineNumber,i=T.endColumn,I=y.startLineNumber,d=y.startColumn,f=y.endLineNumber,r=y.endColumn;return D<I?(D=I,S=d):D===I&&(S=Math.max(S,d)),C>f?(C=f,i=r):C===f&&(i=Math.min(i,r)),D>C||D===C&&S>i?null:new k(D,S,C,i)}equalsRange(T){return k.equalsRange(this,T)}static equalsRange(T,y){return!!T&&!!y&&T.startLineNumber===y.startLineNumber&&T.startColumn===y.startColumn&&T.endLineNumber===y.endLineNumber&&T.endColumn===y.endColumn}getEndPosition(){return k.getEndPosition(this)}static getEndPosition(T){return new _.Position(T.endLineNumber,T.endColumn)}getStartPosition(){return k.getStartPosition(this)}static getStartPosition(T){return new _.Position(T.startLineNumber,T.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(T,y){return new k(this.startLineNumber,this.startColumn,T,y)}setStartPosition(T,y){return new k(T,y,this.endLineNumber,this.endColumn)}collapseToStart(){return k.collapseToStart(this)}static collapseToStart(T){return new k(T.startLineNumber,T.startColumn,T.startLineNumber,T.startColumn)}static fromPositions(T,y=T){return new k(T.lineNumber,T.column,y.lineNumber,y.column)}static lift(T){return T?new k(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):null}static isIRange(T){return T&&typeof T.startLineNumber=="number"&&typeof T.startColumn=="number"&&typeof T.endLineNumber=="number"&&typeof T.endColumn=="number"}static areIntersectingOrTouching(T,y){return!(T.endLineNumber<y.startLineNumber||T.endLineNumber===y.startLineNumber&&T.endColumn<y.startColumn||y.endLineNumber<T.startLineNumber||y.endLineNumber===T.startLineNumber&&y.endColumn<T.startColumn)}static areIntersecting(T,y){return!(T.endLineNumber<y.startLineNumber||T.endLineNumber===y.startLineNumber&&T.endColumn<=y.startColumn||y.endLineNumber<T.startLineNumber||y.endLineNumber===T.startLineNumber&&y.endColumn<=T.startColumn)}static compareRangesUsingStarts(T,y){if(T&&y){const C=T.startLineNumber|0,i=y.startLineNumber|0;if(C===i){const I=T.startColumn|0,d=y.startColumn|0;if(I===d){const f=T.endLineNumber|0,r=y.endLineNumber|0;if(f===r){const o=T.endColumn|0,p=y.endColumn|0;return o-p}return f-r}return I-d}return C-i}return(T?1:0)-(y?1:0)}static compareRangesUsingEnds(T,y){return T.endLineNumber===y.endLineNumber?T.endColumn===y.endColumn?T.startLineNumber===y.startLineNumber?T.startColumn-y.startColumn:T.startLineNumber-y.startLineNumber:T.endColumn-y.endColumn:T.endLineNumber-y.endLineNumber}static spansMultipleLines(T){return T.endLineNumber>T.startLineNumber}}e.Range=k}),define(ve[115],be([0,1,38,32]),function(J,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var A;(function(y){y[y.LTR=0]="LTR",y[y.RTL=1]="RTL"})(A=e.SelectionDirection||(e.SelectionDirection={}));class T extends k.Range{constructor(D,S,C,i){super(D,S,C,i);this.selectionStartLineNumber=D,this.selectionStartColumn=S,this.positionLineNumber=C,this.positionColumn=i}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(D){return T.selectionsEqual(this,D)}static selectionsEqual(D,S){return D.selectionStartLineNumber===S.selectionStartLineNumber&&D.selectionStartColumn===S.selectionStartColumn&&D.positionLineNumber===S.positionLineNumber&&D.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(D,S){return this.getDirection()===0?new T(this.startLineNumber,this.startColumn,D,S):new T(D,S,this.startLineNumber,this.startColumn)}getPosition(){return new _.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(D,S){return this.getDirection()===0?new T(D,S,this.endLineNumber,this.endColumn):new T(this.endLineNumber,this.endColumn,D,S)}static fromPositions(D,S=D){return new T(D.lineNumber,D.column,S.lineNumber,S.column)}static liftSelection(D){return new T(D.selectionStartLineNumber,D.selectionStartColumn,D.positionLineNumber,D.positionColumn)}static selectionsArrEqual(D,S){if(D&&!S||!D&&S)return!1;if(!D&&!S)return!0;if(D.length!==S.length)return!1;for(let C=0,i=D.length;C<i;C++)if(!this.selectionsEqual(D[C],S[C]))return!1;return!0}static isISelection(D){return D&&typeof D.selectionStartLineNumber=="number"&&typeof D.selectionStartColumn=="number"&&typeof D.positionLineNumber=="number"&&typeof D.positionColumn=="number"}static createWithDirection(D,S,C,i,I){return I===0?new T(D,S,C,i):new T(C,i,D,S)}}e.Selection=T}),define(ve[85],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var _;(function(f){f[f.Left=1]="Left",f[f.Center=2]="Center",f[f.Right=4]="Right",f[f.Full=7]="Full"})(_=e.OverviewRulerLane||(e.OverviewRulerLane={}));var k;(function(f){f[f.Inline=1]="Inline",f[f.Gutter=2]="Gutter"})(k=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(f){f[f.TextDefined=0]="TextDefined",f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(A=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(f){f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(f){f[f.LF=0]="LF",f[f.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class D{constructor(r){this.tabSize=Math.max(1,r.tabSize|0),this.indentSize=r.tabSize|0,this.insertSpaces=Boolean(r.insertSpaces),this.defaultEOL=r.defaultEOL|0,this.trimAutoWhitespace=Boolean(r.trimAutoWhitespace)}equals(r){return this.tabSize===r.tabSize&&this.indentSize===r.indentSize&&this.insertSpaces===r.insertSpaces&&this.defaultEOL===r.defaultEOL&&this.trimAutoWhitespace===r.trimAutoWhitespace}createChangeEvent(r){return{tabSize:this.tabSize!==r.tabSize,indentSize:this.indentSize!==r.indentSize,insertSpaces:this.insertSpaces!==r.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==r.trimAutoWhitespace}}}e.TextModelResolvedOptions=D;class S{constructor(r,o){this.range=r,this.matches=o}}e.FindMatch=S;var C;(function(f){f[f.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",f[f.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",f[f.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",f[f.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(C=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var i;(function(f){f[f.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(i=e.ModelConstants||(e.ModelConstants={}));class I{constructor(r,o,p,g,E,m){this.identifier=r,this.range=o,this.text=p,this.forceMoveMarkers=g,this.isAutoWhitespaceEdit=E,this._isTracked=m}}e.ValidAnnotatedEditOperation=I;class d{constructor(r,o,p){this.reverseEdits=r,this.changes=o,this.trimAutoWhitespaceLineNumbers=p}}e.ApplyEditsResult=d}),define(ve[116],be([0,1,8,114,38,32,85]),function(J,e,_,k,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const D=999;class S{constructor(m,u,w,t){this.searchString=m,this.isRegex=u,this.matchCase=w,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let m;this.isRegex?m=C(this.searchString):m=this.searchString.indexOf(`
`)>=0;let u=null;try{u=_.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:m,global:!0,unicode:!0})}catch(t){return null}if(!u)return null;let w=!this.isRegex&&!m;return w&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(w=this.matchCase),new i(u,this.wordSeparators?(0,k.getMapForWordSeparators)(this.wordSeparators):null,w?this.searchString:null)}}e.SearchParams=S;function C(E){if(!E||E.length===0)return!1;for(let m=0,u=E.length;m<u;m++)if(E.charCodeAt(m)===92){if(m++,m>=u)break;const t=E.charCodeAt(m);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=C;class i{constructor(m,u,w){this.regex=m,this.wordSeparators=u,this.simpleSearch=w}}e.SearchData=i;function I(E,m,u){if(!u)return new y.FindMatch(E,null);let w=[];for(let t=0,n=m.length;t<n;t++)w[t]=m[t];return new y.FindMatch(E,w)}e.createFindMatch=I;class d{constructor(m){let u=[],w=0;for(let t=0,n=m.length;t<n;t++)m.charCodeAt(t)===10&&(u[w++]=t);this._lineFeedsOffsets=u}findLineFeedCountBeforeOffset(m){const u=this._lineFeedsOffsets;let w=0,t=u.length-1;if(t===-1||m<=u[0])return 0;for(;w<t;){const n=w+((t-w)/2>>0);u[n]>=m?t=n-1:u[n+1]>=m?(w=n,t=n):w=n+1}return w+1}}class f{static findMatches(m,u,w,t,n){const l=u.parseSearchRequest();return l?l.regex.multiline?this._doFindMatchesMultiline(m,w,new g(l.wordSeparators,l.regex),t,n):this._doFindMatchesLineByLine(m,w,l,t,n):[]}static _getMultilineMatchRange(m,u,w,t,n,l){let a,s=0;t?(s=t.findLineFeedCountBeforeOffset(n),a=u+n+s):a=u+n;let c;if(t){let b=t.findLineFeedCountBeforeOffset(n+l.length)-s;c=a+l.length+b}else c=a+l.length;const v=m.getPositionAt(a),P=m.getPositionAt(c);return new T.Range(v.lineNumber,v.column,P.lineNumber,P.column)}static _doFindMatchesMultiline(m,u,w,t,n){const l=m.getOffsetAt(u.getStartPosition()),a=m.getValueInRange(u,1),s=m.getEOL()===`\r
`?new d(a):null,c=[];let v=0,P;for(w.reset(0);P=w.next(a);)if(c[v++]=I(this._getMultilineMatchRange(m,l,a,s,P.index,P[0]),P,t),v>=n)return c;return c}static _doFindMatchesLineByLine(m,u,w,t,n){const l=[];let a=0;if(u.startLineNumber===u.endLineNumber){const c=m.getLineContent(u.startLineNumber).substring(u.startColumn-1,u.endColumn-1);return a=this._findMatchesInLine(w,c,u.startLineNumber,u.startColumn-1,a,l,t,n),l}const s=m.getLineContent(u.startLineNumber).substring(u.startColumn-1);a=this._findMatchesInLine(w,s,u.startLineNumber,u.startColumn-1,a,l,t,n);for(let c=u.startLineNumber+1;c<u.endLineNumber&&a<n;c++)a=this._findMatchesInLine(w,m.getLineContent(c),c,0,a,l,t,n);if(a<n){const c=m.getLineContent(u.endLineNumber).substring(0,u.endColumn-1);a=this._findMatchesInLine(w,c,u.endLineNumber,0,a,l,t,n)}return l}static _findMatchesInLine(m,u,w,t,n,l,a,s){const c=m.wordSeparators;if(!a&&m.simpleSearch){const h=m.simpleSearch,b=h.length,R=u.length;let U=-b;for(;(U=u.indexOf(h,U+b))!==-1;)if((!c||p(c,u,R,U,b))&&(l[n++]=new y.FindMatch(new T.Range(w,U+1+t,w,U+1+b+t),null),n>=s))return n;return n}const v=new g(m.wordSeparators,m.regex);let P;v.reset(0);do if(P=v.next(u),P&&(l[n++]=I(new T.Range(w,P.index+1+t,w,P.index+1+P[0].length+t),P,a),n>=s))return n;while(P);return n}static findNextMatch(m,u,w,t){const n=u.parseSearchRequest();if(!n)return null;const l=new g(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindNextMatchMultiline(m,w,l,t):this._doFindNextMatchLineByLine(m,w,l,t)}static _doFindNextMatchMultiline(m,u,w,t){const n=new A.Position(u.lineNumber,1),l=m.getOffsetAt(n),a=m.getLineCount(),s=m.getValueInRange(new T.Range(n.lineNumber,n.column,a,m.getLineMaxColumn(a)),1),c=m.getEOL()===`\r
`?new d(s):null;w.reset(u.column-1);let v=w.next(s);return v?I(this._getMultilineMatchRange(m,l,s,c,v.index,v[0]),v,t):u.lineNumber!==1||u.column!==1?this._doFindNextMatchMultiline(m,new A.Position(1,1),w,t):null}static _doFindNextMatchLineByLine(m,u,w,t){const n=m.getLineCount(),l=u.lineNumber,a=m.getLineContent(l),s=this._findFirstMatchInLine(w,a,l,u.column,t);if(s)return s;for(let c=1;c<=n;c++){const v=(l+c-1)%n,P=m.getLineContent(v+1),h=this._findFirstMatchInLine(w,P,v+1,1,t);if(h)return h}return null}static _findFirstMatchInLine(m,u,w,t,n){m.reset(t-1);const l=m.next(u);return l?I(new T.Range(w,l.index+1,w,l.index+1+l[0].length),l,n):null}static findPreviousMatch(m,u,w,t){const n=u.parseSearchRequest();if(!n)return null;const l=new g(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindPreviousMatchMultiline(m,w,l,t):this._doFindPreviousMatchLineByLine(m,w,l,t)}static _doFindPreviousMatchMultiline(m,u,w,t){const n=this._doFindMatchesMultiline(m,new T.Range(1,1,u.lineNumber,u.column),w,t,10*D);if(n.length>0)return n[n.length-1];const l=m.getLineCount();return u.lineNumber!==l||u.column!==m.getLineMaxColumn(l)?this._doFindPreviousMatchMultiline(m,new A.Position(l,m.getLineMaxColumn(l)),w,t):null}static _doFindPreviousMatchLineByLine(m,u,w,t){const n=m.getLineCount(),l=u.lineNumber,a=m.getLineContent(l).substring(0,u.column-1),s=this._findLastMatchInLine(w,a,l,t);if(s)return s;for(let c=1;c<=n;c++){const v=(n+l-c-1)%n,P=m.getLineContent(v+1),h=this._findLastMatchInLine(w,P,v+1,t);if(h)return h}return null}static _findLastMatchInLine(m,u,w,t){let n=null,l;for(m.reset(0);l=m.next(u);)n=I(new T.Range(w,l.index+1,w,l.index+1+l[0].length),l,t);return n}}e.TextModelSearch=f;function r(E,m,u,w,t){if(w===0)return!0;const n=m.charCodeAt(w-1);if(E.get(n)!==0||n===13||n===10)return!0;if(t>0){const l=m.charCodeAt(w);if(E.get(l)!==0)return!0}return!1}function o(E,m,u,w,t){if(w+t===u)return!0;const n=m.charCodeAt(w+t);if(E.get(n)!==0||n===13||n===10)return!0;if(t>0){const l=m.charCodeAt(w+t-1);if(E.get(l)!==0)return!0}return!1}function p(E,m,u,w,t){return r(E,m,u,w,t)&&o(E,m,u,w,t)}e.isValidMatch=p;class g{constructor(m,u){this._wordSeparators=m,this._searchRegex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(m){this._searchRegex.lastIndex=m,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(m){const u=m.length;let w;do{if(this._prevMatchStartIndex+this._prevMatchLength===u||(w=this._searchRegex.exec(m),!w))return null;const t=w.index,n=w[0].length;if(t===this._prevMatchStartIndex&&n===this._prevMatchLength){if(n===0){_.getNextCodePoint(m,u,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=n,!this._wordSeparators||p(this._wordSeparators,m,u,t,n))return w}while(w);return null}}e.Searcher=g}),define(ve[86],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function _(D=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const C of e.USUAL_WORD_SEPARATORS)D.indexOf(C)>=0||(S+="\\"+C);return S+="\\s]+)",new RegExp(S,"g")}e.DEFAULT_WORD_REGEXP=_();function k(D){let S=e.DEFAULT_WORD_REGEXP;if(D&&D instanceof RegExp)if(D.global)S=D;else{let C="g";D.ignoreCase&&(C+="i"),D.multiline&&(C+="m"),D.unicode&&(C+="u"),S=new RegExp(D.source,C)}return S.lastIndex=0,S}e.ensureValidWordDefinition=k;const A={maxLen:1e3,windowSize:15,timeBudget:150};function T(D,S,C,i,I=A){if(C.length>I.maxLen){let p=D-I.maxLen/2;return p<0?p=0:i+=p,C=C.substring(p,D+I.maxLen/2),T(D,S,C,i,I)}const d=Date.now(),f=D-1-i;let r=-1,o=null;for(let p=1;!(Date.now()-d>=I.timeBudget);p++){const g=f-I.windowSize*p;S.lastIndex=Math.max(0,g);const E=y(S,C,f,r);if(!E&&o||(o=E,g<=0))break;r=g}if(o){let p={word:o[0],startColumn:i+1+o.index,endColumn:i+1+o.index+o[0].length};return S.lastIndex=0,p}return null}e.getWordAtText=T;function y(D,S,C,i){let I;for(;I=D.exec(S);){const d=I.index||0;if(d<=C&&D.lastIndex>=C)return I;if(i>0&&d>i)return null}return null}}),define(ve[117],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var _;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(_=e.IndentAction||(e.IndentAction={}));class k{constructor(D){if(this.open=D.open,this.close=D.close,this._standardTokenMask=0,Array.isArray(D.notIn))for(let S=0,C=D.notIn.length;S<C;S++)switch(D.notIn[S]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(D){return(this._standardTokenMask&D)==0}}e.StandardAutoClosingPairConditional=k;class A{constructor(D){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of D)T(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),T(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),T(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),T(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&T(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=A;function T(y,D,S){y.has(D)?y.get(D).push(S):y.set(D,[S])}}),define(ve[59],be([0,1,28,13]),function(J,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function A(T,y,D,S){if(Array.isArray(T)){let C=0;for(const i of T){const I=A(i,y,D,S);if(I===10)return I;I>C&&(C=I)}return C}else{if(typeof T=="string")return S?T==="*"?5:T===D?10:0:0;if(T){const{language:C,pattern:i,scheme:I,hasAccessToAllModels:d}=T;if(!S&&!d)return 0;let f=0;if(I)if(I===y.scheme)f=10;else if(I==="*")f=5;else return 0;if(C)if(C===D)f=10;else if(C==="*")f=Math.max(f,5);else return 0;if(i){let r;if(typeof i=="string"?r=i:r=Object.assign(Object.assign({},i),{base:(0,k.normalize)(i.base)}),r===y.fsPath||(0,_.match)(r,y.fsPath))f=10;else return 0}return f}else return 0}}e.score=A}),define(ve[118],be([0,1,84]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var k;(function(f){f[f.Invalid=0]="Invalid",f[f.Start=1]="Start",f[f.H=2]="H",f[f.HT=3]="HT",f[f.HTT=4]="HTT",f[f.HTTP=5]="HTTP",f[f.F=6]="F",f[f.FI=7]="FI",f[f.FIL=8]="FIL",f[f.BeforeColon=9]="BeforeColon",f[f.AfterColon=10]="AfterColon",f[f.AlmostThere=11]="AlmostThere",f[f.End=12]="End",f[f.Accept=13]="Accept",f[f.LastKnownState=14]="LastKnownState"})(k=e.State||(e.State={}));class A{constructor(r,o,p){const g=new Uint8Array(r*o);for(let E=0,m=r*o;E<m;E++)g[E]=p;this._data=g,this.rows=r,this.cols=o}get(r,o){return this._data[r*this.cols+o]}set(r,o,p){this._data[r*this.cols+o]=p}}e.Uint8Matrix=A;class T{constructor(r){let o=0,p=0;for(let E=0,m=r.length;E<m;E++){let[u,w,t]=r[E];w>o&&(o=w),u>p&&(p=u),t>p&&(p=t)}o++,p++;let g=new A(p,o,0);for(let E=0,m=r.length;E<m;E++){let[u,w,t]=r[E];g.set(u,w,t)}this._states=g,this._maxCharCode=o}nextState(r,o){return o<0||o>=this._maxCharCode?0:this._states.get(r,o)}}e.StateMachine=T;let y=null;function D(){return y===null&&(y=new T([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),y}var S;(function(f){f[f.None=0]="None",f[f.ForceTermination=1]="ForceTermination",f[f.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let C=null;function i(){if(C===null){C=new _.CharacterClassifier(0);const f=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let o=0;o<f.length;o++)C.set(f.charCodeAt(o),1);const r=".,;";for(let o=0;o<r.length;o++)C.set(r.charCodeAt(o),2)}return C}class I{static _createLink(r,o,p,g,E){let m=E-1;do{const u=o.charCodeAt(m);if(r.get(u)!==2)break;m--}while(m>g);if(g>0){const u=o.charCodeAt(g-1),w=o.charCodeAt(m);(u===40&&w===41||u===91&&w===93||u===123&&w===125)&&m--}return{range:{startLineNumber:p,startColumn:g+1,endLineNumber:p,endColumn:m+2},url:o.substring(g,m+1)}}static computeLinks(r,o=D()){const p=i();let g=[];for(let E=1,m=r.getLineCount();E<=m;E++){const u=r.getLineContent(E),w=u.length;let t=0,n=0,l=0,a=1,s=!1,c=!1,v=!1,P=!1;for(;t<w;){let h=!1;const b=u.charCodeAt(t);if(a===13){let R;switch(b){case 40:s=!0,R=0;break;case 41:R=s?0:1;break;case 91:v=!0,c=!0,R=0;break;case 93:v=!1,R=c?0:1;break;case 123:P=!0,R=0;break;case 125:R=P?0:1;break;case 39:R=l===34||l===96?0:1;break;case 34:R=l===39||l===96?0:1;break;case 96:R=l===39||l===34?0:1;break;case 42:R=l===42?1:0;break;case 124:R=l===124?1:0;break;case 32:R=v?0:1;break;default:R=p.get(b)}R===1&&(g.push(I._createLink(p,u,E,n,t)),h=!0)}else if(a===12){let R;b===91?(c=!0,R=0):R=p.get(b),R===1?h=!0:a=13}else a=o.nextState(a,b),a===0&&(h=!0);h&&(a=1,s=!1,c=!1,P=!1,n=t+1,l=b),t++}a===13&&g.push(I._createLink(p,u,E,n,w))}return g}}e.LinkComputer=I;function d(f){return!f||typeof f.getLineCount!="function"||typeof f.getLineContent!="function"?[]:I.computeLinks(f)}e.computeLinks=d}),define(ve[119],be([0,1,3,6]),function(J,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class A{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new _.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(y){this._onDidChange.fire({changedLanguages:y,changedColorMap:!1})}register(y,D){return this._map.set(y,D),this.fire([y]),(0,k.toDisposable)(()=>{this._map.get(y)===D&&(this._map.delete(y),this.fire([y]))})}registerPromise(y,D){let S=null,C=!1;return this._promises.set(y,D.then(i=>{this._promises.delete(y),!(C||!i)&&(S=this.register(y,i))})),(0,k.toDisposable)(()=>{C=!0,S&&S.dispose()})}getPromise(y){const D=this.get(y);if(D)return Promise.resolve(D);const S=this._promises.get(y);return S?S.then(C=>this.get(y)):null}get(y){return this._map.get(y)||null}setColorMap(y){this._colorMap=y,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=A}),define(ve[87],be([0,1,24,21]),function(J,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var A;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(A||(A={}));function T(I){for(let d=0,f=I.length;d<f;d+=4){const r=I[d+0],o=I[d+1],p=I[d+2],g=I[d+3];I[d+0]=g,I[d+1]=p,I[d+2]=o,I[d+3]=r}}function y(I){const d=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return k.isLittleEndian()||T(d),_.VSBuffer.wrap(d)}function D(I){const d=I.buffer;if(k.isLittleEndian()||T(d),d.byteOffset%4==0)return new Uint32Array(d.buffer,d.byteOffset,d.length/4);{const f=new Uint8Array(d.byteLength);return f.set(d),new Uint32Array(f.buffer,f.byteOffset,f.length/4)}}function S(I){const d=new Uint32Array(C(I));let f=0;if(d[f++]=I.id,I.type==="full")d[f++]=1,d[f++]=I.data.length,d.set(I.data,f),f+=I.data.length;else{d[f++]=2,d[f++]=I.deltas.length;for(const r of I.deltas)d[f++]=r.start,d[f++]=r.deleteCount,r.data?(d[f++]=r.data.length,d.set(r.data,f),f+=r.data.length):d[f++]=0}return y(d)}e.encodeSemanticTokensDto=S;function C(I){let d=0;if(d+=1+1,I.type==="full")d+=1+I.data.length;else{d+=1,d+=(1+1+1)*I.deltas.length;for(const f of I.deltas)f.data&&(d+=f.data.length)}return d}function i(I){const d=D(I);let f=0;const r=d[f++];if(d[f++]===1){const E=d[f++],m=d.subarray(f,f+E);return f+=E,{id:r,type:"full",data:m}}const p=d[f++];let g=[];for(let E=0;E<p;E++){const m=d[f++],u=d[f++],w=d[f++];let t;w>0&&(t=d.subarray(f,f+w),f+=w),g[E]={start:m,deleteCount:u,data:t}}return{id:r,type:"delta",deltas:g}}e.decodeSemanticTokensDto=i}),define(ve[88],be([0,1,82]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class k{constructor(y,D){this.index=y,this.remainder=D}}e.PrefixSumIndexOfResult=k;class A{constructor(y){this.values=y,this.prefixSum=new Uint32Array(y.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(y,D){y=(0,_.toUint32)(y);const S=this.values,C=this.prefixSum,i=D.length;return i===0?!1:(this.values=new Uint32Array(S.length+i),this.values.set(S.subarray(0,y),0),this.values.set(S.subarray(y),y+i),this.values.set(D,y),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(y,D){return y=(0,_.toUint32)(y),D=(0,_.toUint32)(D),this.values[y]===D?!1:(this.values[y]=D,y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),!0)}removeValues(y,D){y=(0,_.toUint32)(y),D=(0,_.toUint32)(D);const S=this.values,C=this.prefixSum;if(y>=S.length)return!1;let i=S.length-y;return D>=i&&(D=i),D===0?!1:(this.values=new Uint32Array(S.length-D),this.values.set(S.subarray(0,y),0),this.values.set(S.subarray(y+D),y),this.prefixSum=new Uint32Array(this.values.length),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(y){return y<0?0:(y=(0,_.toUint32)(y),this._getAccumulatedValue(y))}_getAccumulatedValue(y){if(y<=this.prefixSumValidIndex[0])return this.prefixSum[y];let D=this.prefixSumValidIndex[0]+1;D===0&&(this.prefixSum[0]=this.values[0],D++),y>=this.values.length&&(y=this.values.length-1);for(let S=D;S<=y;S++)this.prefixSum[S]=this.prefixSum[S-1]+this.values[S];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],y),this.prefixSum[y]}getIndexOf(y){y=Math.floor(y),this.getTotalValue();let D=0,S=this.values.length-1,C=0,i=0,I=0;for(;D<=S;)if(C=D+(S-D)/2|0,i=this.prefixSum[C],I=i-this.values[C],y<I)S=C-1;else if(y>=i)D=C+1;else break;return new k(C,y-I)}}e.PrefixSumComputer=A}),define(ve[120],be([0,1,8,38,88]),function(J,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class T{constructor(D,S,C,i){this._uri=D,this._lines=S,this._eol=C,this._versionId=i,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(D){D.eol&&D.eol!==this._eol&&(this._eol=D.eol,this._lineStarts=null);const S=D.changes;for(const C of S)this._acceptDeleteRange(C.range),this._acceptInsertText(new k.Position(C.range.startLineNumber,C.range.startColumn),C.text);this._versionId=D.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const D=this._eol.length,S=this._lines.length,C=new Uint32Array(S);for(let i=0;i<S;i++)C[i]=this._lines[i].length+D;this._lineStarts=new A.PrefixSumComputer(C)}}_setLineText(D,S){this._lines[D]=S,this._lineStarts&&this._lineStarts.changeValue(D,this._lines[D].length+this._eol.length)}_acceptDeleteRange(D){if(D.startLineNumber===D.endLineNumber){if(D.startColumn===D.endColumn)return;this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.startLineNumber-1].substring(D.endColumn-1));return}this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.endLineNumber-1].substring(D.endColumn-1)),this._lines.splice(D.startLineNumber,D.endLineNumber-D.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(D.startLineNumber,D.endLineNumber-D.startLineNumber)}_acceptInsertText(D,S){if(S.length!==0){let C=(0,_.splitLines)(S);if(C.length===1){this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+C[0]+this._lines[D.lineNumber-1].substring(D.column-1));return}C[C.length-1]+=this._lines[D.lineNumber-1].substring(D.column-1),this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+C[0]);let i=new Uint32Array(C.length-1);for(let I=1;I<C.length;I++)this._lines.splice(D.lineNumber+I-1,0,C[I]),i[I-1]=C[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(D.lineNumber,i)}}}e.MirrorTextModel=T}),define(ve[121],be([16,17]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ve[60],be([0,1,121,10,15]),function(J,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(C,i){return i&&(C.stack||C.stacktrace)?_.localize(0,null,D(C),y(C.stack)||y(C.stacktrace)):D(C)}function y(C){return Array.isArray(C)?C.join(`
`):C}function D(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?_.localize(1,null,C.message):C.message||_.localize(2,null)}function S(C=null,i=!1){if(!C)return _.localize(3,null);if(Array.isArray(C)){const I=A.coalesce(C),d=S(I[0],i);return I.length>1?_.localize(4,null,d,I.length):d}if(k.isString(C))return C;if(C.detail){const I=C.detail;if(I.error)return T(I.error,i);if(I.exception)return T(I.exception,i)}return C.stack?T(C,i):C.message?C.message:_.localize(5,null)}e.toErrorMessage=S}),define(ve[122],be([16,17]),function(J,e){return J.create("vs/editor/common/config/editorOptions",e)}),define(ve[123],be([0,1,122,21,86]),function(J,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var T;(function(z){z[z.None=0]="None",z[z.Keep=1]="Keep",z[z.Brackets=2]="Brackets",z[z.Advanced=3]="Advanced",z[z.Full=4]="Full"})(T=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(ee){this._values=ee}hasChanged(ee){return this._values[ee]}}e.ConfigurationChangedEvent=y;class D{constructor(){this._values=[]}_read(ee){return this._values[ee]}get(ee){return this._values[ee]}_write(ee,ge){this._values[ee]=ge}}e.ValidatedEditorOptions=D;class S{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=S;class C{constructor(ee,ge,Ne,Ve){this.id=ee,this.name=ge,this.defaultValue=Ne,this.schema=Ve}compute(ee,ge,Ne){return Ne}}class i{constructor(ee,ge=null){this.schema=void 0,this.id=ee,this.name="_never_",this.defaultValue=void 0,this.deps=ge}validate(ee){return this.defaultValue}}class I{constructor(ee,ge,Ne,Ve){this.id=ee,this.name=ge,this.defaultValue=Ne,this.schema=Ve}validate(ee){return typeof ee=="undefined"?this.defaultValue:ee}compute(ee,ge,Ne){return Ne}}function d(z,ee){return typeof z=="undefined"?ee:z==="false"?!1:Boolean(z)}e.boolean=d;class f extends I{constructor(ee,ge,Ne,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="boolean",Ve.default=Ne),super(ee,ge,Ne,Ve)}validate(ee){return d(ee,this.defaultValue)}}class r extends I{constructor(ee,ge,Ne,Ve,$e,Ze=void 0){typeof Ze!="undefined"&&(Ze.type="integer",Ze.default=Ne,Ze.minimum=Ve,Ze.maximum=$e),super(ee,ge,Ne,Ze),this.minimum=Ve,this.maximum=$e}static clampedInt(ee,ge,Ne,Ve){if(typeof ee=="undefined")return ge;let $e=parseInt(ee,10);return isNaN($e)?ge:($e=Math.max(Ne,$e),$e=Math.min(Ve,$e),$e|0)}validate(ee){return r.clampedInt(ee,this.defaultValue,this.minimum,this.maximum)}}class o extends I{constructor(ee,ge,Ne,Ve,$e){typeof $e!="undefined"&&($e.type="number",$e.default=Ne),super(ee,ge,Ne,$e),this.validationFn=Ve}static clamp(ee,ge,Ne){return ee<ge?ge:ee>Ne?Ne:ee}static float(ee,ge){if(typeof ee=="number")return ee;if(typeof ee=="undefined")return ge;const Ne=parseFloat(ee);return isNaN(Ne)?ge:Ne}validate(ee){return this.validationFn(o.float(ee,this.defaultValue))}}class p extends I{static string(ee,ge){return typeof ee!="string"?ge:ee}constructor(ee,ge,Ne,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="string",Ve.default=Ne),super(ee,ge,Ne,Ve)}validate(ee){return p.string(ee,this.defaultValue)}}function g(z,ee,ge){return typeof z!="string"||ge.indexOf(z)===-1?ee:z}e.stringSet=g;class E extends I{constructor(ee,ge,Ne,Ve,$e=void 0){typeof $e!="undefined"&&($e.type="string",$e.enum=Ve,$e.default=Ne),super(ee,ge,Ne,$e),this._allowedValues=Ve}validate(ee){return g(ee,this.defaultValue,this._allowedValues)}}class m extends C{constructor(ee,ge,Ne,Ve,$e,Ze,ye=void 0){typeof ye!="undefined"&&(ye.type="string",ye.enum=$e,ye.default=Ve),super(ee,ge,Ne,ye),this._allowedValues=$e,this._convert=Ze}validate(ee){return typeof ee!="string"?this.defaultValue:this._allowedValues.indexOf(ee)===-1?this.defaultValue:this._convert(ee)}}function u(z){switch(z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class w extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[_.localize(0,null),_.localize(1,null),_.localize(2,null)],default:"auto",description:_.localize(3,null)})}validate(ee){switch(ee){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ee,ge,Ne){return Ne===0?ee.accessibilitySupport:Ne}}class t extends C{constructor(){const ee={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",ee,{"editor.comments.insertSpace":{type:"boolean",default:ee.insertSpace,description:_.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ee.ignoreEmptyLines,description:_.localize(5,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ge=ee;return{insertSpace:d(ge.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(ge.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(z){z[z.Hidden=0]="Hidden",z[z.Blink=1]="Blink",z[z.Smooth=2]="Smooth",z[z.Phase=3]="Phase",z[z.Expand=4]="Expand",z[z.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function l(z){switch(z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var a;(function(z){z[z.Line=1]="Line",z[z.Block=2]="Block",z[z.Underline=3]="Underline",z[z.LineThin=4]="LineThin",z[z.BlockOutline=5]="BlockOutline",z[z.UnderlineThin=6]="UnderlineThin"})(a=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function s(z){switch(z){case a.Line:return"line";case a.Block:return"block";case a.Underline:return"underline";case a.LineThin:return"line-thin";case a.BlockOutline:return"block-outline";case a.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=s;function c(z){switch(z){case"line":return a.Line;case"block":return a.Block;case"underline":return a.Underline;case"line-thin":return a.LineThin;case"block-outline":return a.BlockOutline;case"underline-thin":return a.UnderlineThin}}class v extends i{constructor(){super(123,[62,31])}compute(ee,ge,Ne){const Ve=["monaco-editor"];return ge.get(31)&&Ve.push(ge.get(31)),ee.extraEditorClassName&&Ve.push(ee.extraEditorClassName),ge.get(62)==="default"?Ve.push("mouse-default"):ge.get(62)==="copy"&&Ve.push("mouse-copy"),ge.get(97)&&Ve.push("showUnused"),ge.get(121)&&Ve.push("showDeprecated"),Ve.join(" ")}}class P extends f{constructor(){super(30,"emptySelectionClipboard",!0,{description:_.localize(6,null)})}compute(ee,ge,Ne){return Ne&&ee.emptySelectionClipboard}}class h extends C{constructor(){const ee={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",ee,{"editor.find.cursorMoveOnType":{type:"boolean",default:ee.cursorMoveOnType,description:_.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:ee.seedSearchStringFromSelection,description:_.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ee.autoFindInSelection,enumDescriptions:[_.localize(9,null),_.localize(10,null),_.localize(11,null)],description:_.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ee.globalFindClipboard,description:_.localize(13,null),included:k.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ee.addExtraSpaceOnTop,description:_.localize(14,null)},"editor.find.loop":{type:"boolean",default:ee.loop,description:_.localize(15,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ge=ee;return{cursorMoveOnType:d(ge.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:d(ge.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof ee.autoFindInSelection=="boolean"?ee.autoFindInSelection?"always":"never":g(ge.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(ge.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(ge.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(ge.loop,this.defaultValue.loop)}}}class b extends C{constructor(){super(41,"fontLigatures",b.OFF,{anyOf:[{type:"boolean",description:_.localize(16,null)},{type:"string",description:_.localize(17,null)}],description:_.localize(18,null),default:!1})}validate(ee){return typeof ee=="undefined"?this.defaultValue:typeof ee=="string"?ee==="false"?b.OFF:ee==="true"?b.ON:ee:Boolean(ee)?b.ON:b.OFF}}e.EditorFontLigatures=b,b.OFF='"liga" off, "calt" off',b.ON='"liga" on, "calt" on';class R extends i{constructor(){super(40)}compute(ee,ge,Ne){return ee.fontInfo}}class U extends I{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:_.localize(19,null)})}validate(ee){let ge=o.float(ee,this.defaultValue);return ge===0?e.EDITOR_FONT_DEFAULTS.fontSize:o.clamp(ge,6,100)}compute(ee,ge,Ne){return ee.fontInfo.fontSize}}class K extends C{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:K.MINIMUM_VALUE,maximum:K.MAXIMUM_VALUE,errorMessage:_.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:K.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:_.localize(21,null)})}validate(ee){return ee==="normal"||ee==="bold"?ee:String(r.clampedInt(ee,e.EDITOR_FONT_DEFAULTS.fontWeight,K.MINIMUM_VALUE,K.MAXIMUM_VALUE))}}K.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],K.MINIMUM_VALUE=1,K.MAXIMUM_VALUE=1e3;class he extends C{constructor(){const ee={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ge={type:"string",enum:["peek","gotoAndPeek","goto"],default:ee.multiple,enumDescriptions:[_.localize(22,null),_.localize(23,null),_.localize(24,null)]},Ne=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",ee,{"editor.gotoLocation.multiple":{deprecationMessage:_.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:_.localize(26,null)},ge),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:_.localize(27,null)},ge),"editor.gotoLocation.multipleDeclarations":Object.assign({description:_.localize(28,null)},ge),"editor.gotoLocation.multipleImplementations":Object.assign({description:_.localize(29,null)},ge),"editor.gotoLocation.multipleReferences":Object.assign({description:_.localize(30,null)},ge),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ee.alternativeDefinitionCommand,enum:Ne,description:_.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ee.alternativeTypeDefinitionCommand,enum:Ne,description:_.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ee.alternativeDeclarationCommand,enum:Ne,description:_.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ee.alternativeImplementationCommand,enum:Ne,description:_.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ee.alternativeReferenceCommand,enum:Ne,description:_.localize(35,null)}})}validate(ee){var ge,Ne,Ve,$e,Ze;if(!ee||typeof ee!="object")return this.defaultValue;const ye=ee;return{multiple:g(ye.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(ge=ye.multipleDefinitions)!==null&&ge!==void 0?ge:g(ye.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Ne=ye.multipleTypeDefinitions)!==null&&Ne!==void 0?Ne:g(ye.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(Ve=ye.multipleDeclarations)!==null&&Ve!==void 0?Ve:g(ye.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:($e=ye.multipleImplementations)!==null&&$e!==void 0?$e:g(ye.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Ze=ye.multipleReferences)!==null&&Ze!==void 0?Ze:g(ye.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:p.string(ye.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:p.string(ye.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:p.string(ye.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:p.string(ye.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:p.string(ye.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class V extends C{constructor(){const ee={enabled:!0,delay:300,sticky:!0};super(50,"hover",ee,{"editor.hover.enabled":{type:"boolean",default:ee.enabled,description:_.localize(36,null)},"editor.hover.delay":{type:"number",default:ee.delay,description:_.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:ee.sticky,description:_.localize(38,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ge=ee;return{enabled:d(ge.enabled,this.defaultValue.enabled),delay:r.clampedInt(ge.delay,this.defaultValue.delay,0,1e4),sticky:d(ge.sticky,this.defaultValue.sticky)}}}var H;(function(z){z[z.None=0]="None",z[z.Text=1]="Text",z[z.Blocks=2]="Blocks"})(H=e.RenderMinimap||(e.RenderMinimap={}));class Y extends i{constructor(){super(126,[46,54,35,61,89,56,57,91,113,116,117,118,2])}compute(ee,ge,Ne){return Y.computeLayout(ge,{memory:ee.memory,outerWidth:ee.outerWidth,outerHeight:ee.outerHeight,isDominatedByLongLines:ee.isDominatedByLongLines,lineHeight:ee.fontInfo.lineHeight,viewLineCount:ee.viewLineCount,lineNumbersDigitCount:ee.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ee.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ee.fontInfo.maxDigitWidth,pixelRatio:ee.pixelRatio})}static computeContainedMinimapLineCount(ee){const ge=ee.height/ee.lineHeight,Ne=ee.scrollBeyondLastLine?ge-1:0,Ve=(ee.viewLineCount+Ne)/(ee.pixelRatio*ee.height),$e=Math.floor(ee.viewLineCount/Ve);return{typicalViewportLineCount:ge,extraLinesBeyondLastLine:Ne,desiredRatio:Ve,minimapLineCount:$e}}static _computeMinimapLayout(ee,ge){const Ne=ee.outerWidth,Ve=ee.outerHeight,$e=ee.pixelRatio;if(!ee.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor($e*Ve),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ve};const Ze=ge.stableMinimapLayoutInput,ye=Ze&&ee.outerHeight===Ze.outerHeight&&ee.lineHeight===Ze.lineHeight&&ee.typicalHalfwidthCharacterWidth===Ze.typicalHalfwidthCharacterWidth&&ee.pixelRatio===Ze.pixelRatio&&ee.scrollBeyondLastLine===Ze.scrollBeyondLastLine&&ee.minimap.enabled===Ze.minimap.enabled&&ee.minimap.side===Ze.minimap.side&&ee.minimap.size===Ze.minimap.size&&ee.minimap.showSlider===Ze.minimap.showSlider&&ee.minimap.renderCharacters===Ze.minimap.renderCharacters&&ee.minimap.maxColumn===Ze.minimap.maxColumn&&ee.minimap.scale===Ze.minimap.scale&&ee.verticalScrollbarWidth===Ze.verticalScrollbarWidth&&ee.isViewportWrapping===Ze.isViewportWrapping,Ee=ee.lineHeight,Ce=ee.typicalHalfwidthCharacterWidth,re=ee.scrollBeyondLastLine,le=ee.minimap.renderCharacters;let N=$e>=2?Math.round(ee.minimap.scale*2):ee.minimap.scale;const Q=ee.minimap.maxColumn,ae=ee.minimap.size,ke=ee.minimap.side,Ie=ee.verticalScrollbarWidth,Ae=ee.viewLineCount,xe=ee.remainingWidth,Ye=ee.isViewportWrapping,rt=le?2:3;let tt=Math.floor($e*Ve);const Qe=tt/$e;let mt=!1,bt=!1,pe=rt*N,ce=N/$e,se=1;if(ae==="fill"||ae==="fit"){const{typicalViewportLineCount:ht,extraLinesBeyondLastLine:Xe,desiredRatio:at,minimapLineCount:ft}=Y.computeContainedMinimapLineCount({viewLineCount:Ae,scrollBeyondLastLine:re,height:Ve,lineHeight:Ee,pixelRatio:$e});if(Ae/ft>1)mt=!0,bt=!0,N=1,pe=1,ce=N/$e;else{let Et=!1,vt=N+1;if(ae==="fit"){const kt=Math.ceil((Ae+Xe)*pe);Ye&&ye&&xe<=ge.stableFitRemainingWidth?(Et=!0,vt=ge.stableFitMaxMinimapScale):(Et=kt>tt,Ye&&Et?(ge.stableMinimapLayoutInput=ee,ge.stableFitRemainingWidth=xe):(ge.stableMinimapLayoutInput=null,ge.stableFitRemainingWidth=0))}if(ae==="fill"||Et){mt=!0;const kt=N;pe=Math.min(Ee*$e,Math.max(1,Math.floor(1/at))),N=Math.min(vt,Math.max(1,Math.floor(pe/rt))),N>kt&&(se=Math.min(2,N/kt)),ce=N/$e/se,tt=Math.ceil(Math.max(ht,Ae+Xe)*pe),Ye&&Et&&(ge.stableFitMaxMinimapScale=N)}}}const q=Math.floor(Q*ce),Me=Math.min(q,Math.max(0,Math.floor((xe-Ie-2)*ce/(Ce+ce)))+e.MINIMAP_GUTTER_WIDTH);let Te=Math.floor($e*Me);const Je=Te/$e;Te=Math.floor(Te*se);const et=le?1:2,ct=ke==="left"?0:Ne-Me-Ie;return{renderMinimap:et,minimapLeft:ct,minimapWidth:Me,minimapHeightIsEditorHeight:mt,minimapIsSampling:bt,minimapScale:N,minimapLineHeight:pe,minimapCanvasInnerWidth:Te,minimapCanvasInnerHeight:tt,minimapCanvasOuterWidth:Je,minimapCanvasOuterHeight:Qe}}static computeLayout(ee,ge){const Ne=ge.outerWidth|0,Ve=ge.outerHeight|0,$e=ge.lineHeight|0,Ze=ge.lineNumbersDigitCount|0,ye=ge.typicalHalfwidthCharacterWidth,Ee=ge.maxDigitWidth,Ce=ge.pixelRatio,re=ge.viewLineCount,le=ee.get(118),N=le==="inherit"?ee.get(117):le,Q=N==="inherit"?ee.get(113):N,ae=ee.get(116),ke=ee.get(2),Ie=ge.isDominatedByLongLines,Ae=ee.get(46),xe=ee.get(56).renderType!==0,Ye=ee.get(57),rt=ee.get(91),tt=ee.get(61),Qe=ee.get(89),mt=Qe.verticalScrollbarSize,bt=Qe.verticalHasArrows,pe=Qe.arrowSize,ce=Qe.horizontalScrollbarSize,se=ee.get(54),q=ee.get(35);let Me;if(typeof se=="string"&&/^\d+(\.\d+)?ch$/.test(se)){const _t=parseFloat(se.substr(0,se.length-2));Me=r.clampedInt(_t*ye,0,0,1e3)}else Me=r.clampedInt(se,0,0,1e3);q&&(Me+=16);let Te=0;if(xe){const _t=Math.max(Ze,Ye);Te=Math.round(_t*Ee)}let Je=0;Ae&&(Je=$e);let et=0,ct=et+Je,ht=ct+Te,Xe=ht+Me;const at=Ne-Je-Te-Me;let ft=!1,lt=!1,Et=-1;ke!==2&&(N==="inherit"&&Ie?(ft=!0,lt=!0):Q==="on"||Q==="bounded"?lt=!0:Q==="wordWrapColumn"&&(Et=ae));const vt=Y._computeMinimapLayout({outerWidth:Ne,outerHeight:Ve,lineHeight:$e,typicalHalfwidthCharacterWidth:ye,pixelRatio:Ce,scrollBeyondLastLine:rt,minimap:tt,verticalScrollbarWidth:mt,viewLineCount:re,remainingWidth:at,isViewportWrapping:lt},ge.memory||new S);vt.renderMinimap!==0&&vt.minimapLeft===0&&(et+=vt.minimapWidth,ct+=vt.minimapWidth,ht+=vt.minimapWidth,Xe+=vt.minimapWidth);const kt=at-vt.minimapWidth,At=Math.max(1,Math.floor((kt-mt-2)/ye)),Tt=bt?pe:0;return lt&&(Et=Math.max(1,At),Q==="bounded"&&(Et=Math.min(Et,ae))),{width:Ne,height:Ve,glyphMarginLeft:et,glyphMarginWidth:Je,lineNumbersLeft:ct,lineNumbersWidth:Te,decorationsLeft:ht,decorationsWidth:Me,contentLeft:Xe,contentWidth:kt,minimap:vt,viewportColumn:At,isWordWrapMinified:ft,isViewportWrapping:lt,wrappingColumn:Et,verticalScrollbarWidth:mt,horizontalScrollbarHeight:ce,overviewRuler:{top:Tt,width:mt,height:Ve-2*Tt,right:0}}}}e.EditorLayoutInfoComputer=Y;class W extends C{constructor(){const ee={enabled:!0};super(53,"lightbulb",ee,{"editor.lightbulb.enabled":{type:"boolean",default:ee.enabled,description:_.localize(39,null)}})}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:{enabled:d(ee.enabled,this.defaultValue.enabled)}}}class F extends C{constructor(){const ee={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(122,"inlayHints",ee,{"editor.inlayHints.enabled":{type:"boolean",default:ee.enabled,description:_.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:ee.fontSize,description:_.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:ee.fontFamily,description:_.localize(42,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ge=ee;return{enabled:d(ge.enabled,this.defaultValue.enabled),fontSize:r.clampedInt(ge.fontSize,this.defaultValue.fontSize,0,100),fontFamily:p.string(ge.fontFamily,this.defaultValue.fontFamily)}}}class L extends r{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:_.localize(43,null)})}compute(ee,ge,Ne){return ee.fontInfo.lineHeight}}class M extends C{constructor(){const ee={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",ee,{"editor.minimap.enabled":{type:"boolean",default:ee.enabled,description:_.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[_.localize(45,null),_.localize(46,null),_.localize(47,null)],default:ee.size,description:_.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ee.side,description:_.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ee.showSlider,description:_.localize(50,null)},"editor.minimap.scale":{type:"number",default:ee.scale,minimum:1,maximum:3,enum:[1,2,3],description:_.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ee.renderCharacters,description:_.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:ee.maxColumn,description:_.localize(53,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ge=ee;return{enabled:d(ge.enabled,this.defaultValue.enabled),size:g(ge.size,this.defaultValue.size,["proportional","fill","fit"]),side:g(ge.side,this.defaultValue.side,["right","left"]),showSlider:g(ge.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(ge.renderCharacters,this.defaultValue.renderCharacters),scale:r.clampedInt(ge.scale,1,1,3),maxColumn:r.clampedInt(ge.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function x(z){return z==="ctrlCmd"?k.isMacintosh?"metaKey":"ctrlKey":"altKey"}class G extends C{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:_.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:_.localize(55,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ge=ee;return{top:r.clampedInt(ge.top,0,0,1e3),bottom:r.clampedInt(ge.bottom,0,0,1e3)}}}class X extends C{constructor(){const ee={enabled:!0,cycle:!1};super(72,"parameterHints",ee,{"editor.parameterHints.enabled":{type:"boolean",default:ee.enabled,description:_.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:ee.cycle,description:_.localize(57,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ge=ee;return{enabled:d(ge.enabled,this.defaultValue.enabled),cycle:d(ge.cycle,this.defaultValue.cycle)}}}class ne extends i{constructor(){super(124)}compute(ee,ge,Ne){return ee.pixelRatio}}class me extends C{constructor(){const ee={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",ee,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ee.strings,description:_.localize(58,null)},comments:{type:"boolean",default:ee.comments,description:_.localize(59,null)},other:{type:"boolean",default:ee.other,description:_.localize(60,null)}}}],default:ee,description:_.localize(61,null)});this.defaultValue=ee}validate(ee){if(typeof ee=="boolean")return ee;if(ee&&typeof ee=="object"){const ge=ee,Ne={other:d(ge.other,this.defaultValue.other),comments:d(ge.comments,this.defaultValue.comments),strings:d(ge.strings,this.defaultValue.strings)};return Ne.other&&Ne.comments&&Ne.strings?!0:!Ne.other&&!Ne.comments&&!Ne.strings?!1:Ne}return this.defaultValue}}var Le;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative",z[z.Interval=3]="Interval",z[z.Custom=4]="Custom"})(Le=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class We extends C{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[_.localize(62,null),_.localize(63,null),_.localize(64,null),_.localize(65,null)],default:"on",description:_.localize(66,null)})}validate(ee){let ge=this.defaultValue.renderType,Ne=this.defaultValue.renderFn;return typeof ee!="undefined"&&(typeof ee=="function"?(ge=4,Ne=ee):ee==="interval"?ge=3:ee==="relative"?ge=2:ee==="on"?ge=1:ge=0),{renderType:ge,renderFn:Ne}}}function Fe(z){const ee=z.get(84);return ee==="editable"?z.get(77):ee!=="on"}e.filterValidationDecorations=Fe;class ze extends C{constructor(){const ee=[],ge={type:"number",description:_.localize(67,null)};super(88,"rulers",ee,{type:"array",items:{anyOf:[ge,{type:["object"],properties:{column:ge,color:{type:"string",description:_.localize(68,null),format:"color-hex"}}}]},default:ee,description:_.localize(69,null)})}validate(ee){if(Array.isArray(ee)){let ge=[];for(let Ne of ee)if(typeof Ne=="number")ge.push({column:r.clampedInt(Ne,0,0,1e4),color:null});else if(Ne&&typeof Ne=="object"){const Ve=Ne;ge.push({column:r.clampedInt(Ve.column,0,0,1e4),color:Ve.color})}return ge.sort((Ne,Ve)=>Ne.column-Ve.column),ge}return this.defaultValue}}function $(z,ee){if(typeof z!="string")return ee;switch(z){case"hidden":return 2;case"visible":return 3;default:return 1}}class j extends C{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ge=ee,Ne=r.clampedInt(ge.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ve=r.clampedInt(ge.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:r.clampedInt(ge.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:$(ge.vertical,this.defaultValue.vertical),horizontal:$(ge.horizontal,this.defaultValue.horizontal),useShadows:d(ge.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(ge.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(ge.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(ge.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(ge.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ne,horizontalSliderSize:r.clampedInt(ge.horizontalSliderSize,Ne,0,1e3),verticalScrollbarSize:Ve,verticalSliderSize:r.clampedInt(ge.verticalSliderSize,Ve,0,1e3),scrollByPage:d(ge.scrollByPage,this.defaultValue.scrollByPage)}}}class te extends C{constructor(){const ee={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",ee,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[_.localize(70,null),_.localize(71,null)],default:ee.insertMode,description:_.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ee.filterGraceful,description:_.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:ee.localityBonus,description:_.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ee.shareSuggestSelections,markdownDescription:_.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ee.snippetsPreventQuickSuggestions,description:_.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:ee.showIcons,description:_.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ee.showStatusBar,description:_.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ee.showInlineDetails,description:_.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:_.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:_.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:_.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:_.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:_.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:_.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:_.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:_.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:_.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:_.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:_.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:_.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:_.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:_.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:_.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:_.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:_.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:_.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:_.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:_.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:_.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:_.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:_.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:_.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:_.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:_.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:_.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:_.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:_.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:_.localize(109,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ge=ee;return{insertMode:g(ge.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(ge.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(ge.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(ge.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(ge.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:d(ge.showIcons,this.defaultValue.showIcons),showStatusBar:d(ge.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:d(ge.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(ge.showMethods,this.defaultValue.showMethods),showFunctions:d(ge.showFunctions,this.defaultValue.showFunctions),showConstructors:d(ge.showConstructors,this.defaultValue.showConstructors),showFields:d(ge.showFields,this.defaultValue.showFields),showVariables:d(ge.showVariables,this.defaultValue.showVariables),showClasses:d(ge.showClasses,this.defaultValue.showClasses),showStructs:d(ge.showStructs,this.defaultValue.showStructs),showInterfaces:d(ge.showInterfaces,this.defaultValue.showInterfaces),showModules:d(ge.showModules,this.defaultValue.showModules),showProperties:d(ge.showProperties,this.defaultValue.showProperties),showEvents:d(ge.showEvents,this.defaultValue.showEvents),showOperators:d(ge.showOperators,this.defaultValue.showOperators),showUnits:d(ge.showUnits,this.defaultValue.showUnits),showValues:d(ge.showValues,this.defaultValue.showValues),showConstants:d(ge.showConstants,this.defaultValue.showConstants),showEnums:d(ge.showEnums,this.defaultValue.showEnums),showEnumMembers:d(ge.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(ge.showKeywords,this.defaultValue.showKeywords),showWords:d(ge.showWords,this.defaultValue.showWords),showColors:d(ge.showColors,this.defaultValue.showColors),showFiles:d(ge.showFiles,this.defaultValue.showFiles),showReferences:d(ge.showReferences,this.defaultValue.showReferences),showFolders:d(ge.showFolders,this.defaultValue.showFolders),showTypeParameters:d(ge.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(ge.showSnippets,this.defaultValue.showSnippets),showUsers:d(ge.showUsers,this.defaultValue.showUsers),showIssues:d(ge.showIssues,this.defaultValue.showIssues)}}}class oe extends C{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:_.localize(110,null),default:!0,type:"boolean"}})}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d(ee.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class de extends i{constructor(){super(125,[77])}compute(ee,ge,Ne){return ge.get(77)?!0:ee.tabFocusMode}}var _e;(function(z){z[z.None=0]="None",z[z.Same=1]="Same",z[z.Indent=2]="Indent",z[z.DeepIndent=3]="DeepIndent"})(_e=e.WrappingIndent||(e.WrappingIndent={}));function Be(z){switch(z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class fe extends i{constructor(){super(127,[126])}compute(ee,ge,Ne){const Ve=ge.get(126);return{isDominatedByLongLines:ee.isDominatedByLongLines,isWordWrapMinified:Ve.isWordWrapMinified,isViewportWrapping:Ve.isViewportWrapping,wrappingColumn:Ve.wrappingColumn}}}const De="Consolas, 'Courier New', monospace",Re="Menlo, Monaco, 'Courier New', monospace",He="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:k.isMacintosh?Re:k.isLinux?He:De,fontWeight:"normal",fontSize:k.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function we(z){return e.editorOptionsRegistry[z.id]=z,z}var qe;(function(z){z[z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",z[z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",z[z.accessibilitySupport=2]="accessibilitySupport",z[z.accessibilityPageSize=3]="accessibilityPageSize",z[z.ariaLabel=4]="ariaLabel",z[z.autoClosingBrackets=5]="autoClosingBrackets",z[z.autoClosingDelete=6]="autoClosingDelete",z[z.autoClosingOvertype=7]="autoClosingOvertype",z[z.autoClosingQuotes=8]="autoClosingQuotes",z[z.autoIndent=9]="autoIndent",z[z.automaticLayout=10]="automaticLayout",z[z.autoSurround=11]="autoSurround",z[z.codeLens=12]="codeLens",z[z.codeLensFontFamily=13]="codeLensFontFamily",z[z.codeLensFontSize=14]="codeLensFontSize",z[z.colorDecorators=15]="colorDecorators",z[z.columnSelection=16]="columnSelection",z[z.comments=17]="comments",z[z.contextmenu=18]="contextmenu",z[z.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",z[z.cursorBlinking=20]="cursorBlinking",z[z.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",z[z.cursorStyle=22]="cursorStyle",z[z.cursorSurroundingLines=23]="cursorSurroundingLines",z[z.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",z[z.cursorWidth=25]="cursorWidth",z[z.disableLayerHinting=26]="disableLayerHinting",z[z.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",z[z.domReadOnly=28]="domReadOnly",z[z.dragAndDrop=29]="dragAndDrop",z[z.emptySelectionClipboard=30]="emptySelectionClipboard",z[z.extraEditorClassName=31]="extraEditorClassName",z[z.fastScrollSensitivity=32]="fastScrollSensitivity",z[z.find=33]="find",z[z.fixedOverflowWidgets=34]="fixedOverflowWidgets",z[z.folding=35]="folding",z[z.foldingStrategy=36]="foldingStrategy",z[z.foldingHighlight=37]="foldingHighlight",z[z.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",z[z.fontFamily=39]="fontFamily",z[z.fontInfo=40]="fontInfo",z[z.fontLigatures=41]="fontLigatures",z[z.fontSize=42]="fontSize",z[z.fontWeight=43]="fontWeight",z[z.formatOnPaste=44]="formatOnPaste",z[z.formatOnType=45]="formatOnType",z[z.glyphMargin=46]="glyphMargin",z[z.gotoLocation=47]="gotoLocation",z[z.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",z[z.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",z[z.hover=50]="hover",z[z.inDiffEditor=51]="inDiffEditor",z[z.letterSpacing=52]="letterSpacing",z[z.lightbulb=53]="lightbulb",z[z.lineDecorationsWidth=54]="lineDecorationsWidth",z[z.lineHeight=55]="lineHeight",z[z.lineNumbers=56]="lineNumbers",z[z.lineNumbersMinChars=57]="lineNumbersMinChars",z[z.linkedEditing=58]="linkedEditing",z[z.links=59]="links",z[z.matchBrackets=60]="matchBrackets",z[z.minimap=61]="minimap",z[z.mouseStyle=62]="mouseStyle",z[z.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",z[z.mouseWheelZoom=64]="mouseWheelZoom",z[z.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",z[z.multiCursorModifier=66]="multiCursorModifier",z[z.multiCursorPaste=67]="multiCursorPaste",z[z.occurrencesHighlight=68]="occurrencesHighlight",z[z.overviewRulerBorder=69]="overviewRulerBorder",z[z.overviewRulerLanes=70]="overviewRulerLanes",z[z.padding=71]="padding",z[z.parameterHints=72]="parameterHints",z[z.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",z[z.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",z[z.quickSuggestions=75]="quickSuggestions",z[z.quickSuggestionsDelay=76]="quickSuggestionsDelay",z[z.readOnly=77]="readOnly",z[z.renameOnType=78]="renameOnType",z[z.renderControlCharacters=79]="renderControlCharacters",z[z.renderIndentGuides=80]="renderIndentGuides",z[z.renderFinalNewline=81]="renderFinalNewline",z[z.renderLineHighlight=82]="renderLineHighlight",z[z.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",z[z.renderValidationDecorations=84]="renderValidationDecorations",z[z.renderWhitespace=85]="renderWhitespace",z[z.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",z[z.roundedSelection=87]="roundedSelection",z[z.rulers=88]="rulers",z[z.scrollbar=89]="scrollbar",z[z.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",z[z.scrollBeyondLastLine=91]="scrollBeyondLastLine",z[z.scrollPredominantAxis=92]="scrollPredominantAxis",z[z.selectionClipboard=93]="selectionClipboard",z[z.selectionHighlight=94]="selectionHighlight",z[z.selectOnLineNumbers=95]="selectOnLineNumbers",z[z.showFoldingControls=96]="showFoldingControls",z[z.showUnused=97]="showUnused",z[z.snippetSuggestions=98]="snippetSuggestions",z[z.smartSelect=99]="smartSelect",z[z.smoothScrolling=100]="smoothScrolling",z[z.stickyTabStops=101]="stickyTabStops",z[z.stopRenderingLineAfter=102]="stopRenderingLineAfter",z[z.suggest=103]="suggest",z[z.suggestFontSize=104]="suggestFontSize",z[z.suggestLineHeight=105]="suggestLineHeight",z[z.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",z[z.suggestSelection=107]="suggestSelection",z[z.tabCompletion=108]="tabCompletion",z[z.tabIndex=109]="tabIndex",z[z.unusualLineTerminators=110]="unusualLineTerminators",z[z.useTabStops=111]="useTabStops",z[z.wordSeparators=112]="wordSeparators",z[z.wordWrap=113]="wordWrap",z[z.wordWrapBreakAfterCharacters=114]="wordWrapBreakAfterCharacters",z[z.wordWrapBreakBeforeCharacters=115]="wordWrapBreakBeforeCharacters",z[z.wordWrapColumn=116]="wordWrapColumn",z[z.wordWrapOverride1=117]="wordWrapOverride1",z[z.wordWrapOverride2=118]="wordWrapOverride2",z[z.wrappingIndent=119]="wrappingIndent",z[z.wrappingStrategy=120]="wrappingStrategy",z[z.showDeprecated=121]="showDeprecated",z[z.inlayHints=122]="inlayHints",z[z.editorClassName=123]="editorClassName",z[z.pixelRatio=124]="pixelRatio",z[z.tabFocusMode=125]="tabFocusMode",z[z.layoutInfo=126]="layoutInfo",z[z.wrappingInfo=127]="wrappingInfo"})(qe=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:we(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:_.localize(111,null)})),acceptSuggestionOnEnter:we(new E(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",_.localize(112,null),""],markdownDescription:_.localize(113,null)})),accessibilitySupport:we(new w),accessibilityPageSize:we(new r(3,"accessibilityPageSize",10,1,1073741824,{description:_.localize(114,null)})),ariaLabel:we(new p(4,"ariaLabel",_.localize(115,null))),autoClosingBrackets:we(new E(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",_.localize(116,null),_.localize(117,null),""],description:_.localize(118,null)})),autoClosingDelete:we(new E(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",_.localize(119,null),""],description:_.localize(120,null)})),autoClosingOvertype:we(new E(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",_.localize(121,null),""],description:_.localize(122,null)})),autoClosingQuotes:we(new E(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",_.localize(123,null),_.localize(124,null),""],description:_.localize(125,null)})),autoIndent:we(new m(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[_.localize(126,null),_.localize(127,null),_.localize(128,null),_.localize(129,null),_.localize(130,null)],description:_.localize(131,null)})),automaticLayout:we(new f(10,"automaticLayout",!1)),autoSurround:we(new E(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[_.localize(132,null),_.localize(133,null),_.localize(134,null),""],description:_.localize(135,null)})),stickyTabStops:we(new f(101,"stickyTabStops",!1,{description:_.localize(136,null)})),codeLens:we(new f(12,"codeLens",!0,{description:_.localize(137,null)})),codeLensFontFamily:we(new p(13,"codeLensFontFamily","",{description:_.localize(138,null)})),codeLensFontSize:we(new r(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:_.localize(139,null)})),colorDecorators:we(new f(15,"colorDecorators",!0,{description:_.localize(140,null)})),columnSelection:we(new f(16,"columnSelection",!1,{description:_.localize(141,null)})),comments:we(new t),contextmenu:we(new f(18,"contextmenu",!0)),copyWithSyntaxHighlighting:we(new f(19,"copyWithSyntaxHighlighting",!0,{description:_.localize(142,null)})),cursorBlinking:we(new m(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],l,{description:_.localize(143,null)})),cursorSmoothCaretAnimation:we(new f(21,"cursorSmoothCaretAnimation",!1,{description:_.localize(144,null)})),cursorStyle:we(new m(22,"cursorStyle",a.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],c,{description:_.localize(145,null)})),cursorSurroundingLines:we(new r(23,"cursorSurroundingLines",0,0,1073741824,{description:_.localize(146,null)})),cursorSurroundingLinesStyle:we(new E(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[_.localize(147,null),_.localize(148,null)],description:_.localize(149,null)})),cursorWidth:we(new r(25,"cursorWidth",0,0,1073741824,{markdownDescription:_.localize(150,null)})),disableLayerHinting:we(new f(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:we(new f(27,"disableMonospaceOptimizations",!1)),domReadOnly:we(new f(28,"domReadOnly",!1)),dragAndDrop:we(new f(29,"dragAndDrop",!0,{description:_.localize(151,null)})),emptySelectionClipboard:we(new P),extraEditorClassName:we(new p(31,"extraEditorClassName","")),fastScrollSensitivity:we(new o(32,"fastScrollSensitivity",5,z=>z<=0?5:z,{markdownDescription:_.localize(152,null)})),find:we(new h),fixedOverflowWidgets:we(new f(34,"fixedOverflowWidgets",!1)),folding:we(new f(35,"folding",!0,{description:_.localize(153,null)})),foldingStrategy:we(new E(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[_.localize(154,null),_.localize(155,null)],description:_.localize(156,null)})),foldingHighlight:we(new f(37,"foldingHighlight",!0,{description:_.localize(157,null)})),unfoldOnClickAfterEndOfLine:we(new f(38,"unfoldOnClickAfterEndOfLine",!1,{description:_.localize(158,null)})),fontFamily:we(new p(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:_.localize(159,null)})),fontInfo:we(new R),fontLigatures2:we(new b),fontSize:we(new U),fontWeight:we(new K),formatOnPaste:we(new f(44,"formatOnPaste",!1,{description:_.localize(160,null)})),formatOnType:we(new f(45,"formatOnType",!1,{description:_.localize(161,null)})),glyphMargin:we(new f(46,"glyphMargin",!0,{description:_.localize(162,null)})),gotoLocation:we(new he),hideCursorInOverviewRuler:we(new f(48,"hideCursorInOverviewRuler",!1,{description:_.localize(163,null)})),highlightActiveIndentGuide:we(new f(49,"highlightActiveIndentGuide",!0,{description:_.localize(164,null)})),hover:we(new V),inDiffEditor:we(new f(51,"inDiffEditor",!1)),letterSpacing:we(new o(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,z=>o.clamp(z,-5,20),{description:_.localize(165,null)})),lightbulb:we(new W),lineDecorationsWidth:we(new I(54,"lineDecorationsWidth",10)),lineHeight:we(new L),lineNumbers:we(new We),lineNumbersMinChars:we(new r(57,"lineNumbersMinChars",5,1,300)),linkedEditing:we(new f(58,"linkedEditing",!1,{description:_.localize(166,null)})),links:we(new f(59,"links",!0,{description:_.localize(167,null)})),matchBrackets:we(new E(60,"matchBrackets","always",["always","near","never"],{description:_.localize(168,null)})),minimap:we(new M),mouseStyle:we(new E(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:we(new o(63,"mouseWheelScrollSensitivity",1,z=>z===0?1:z,{markdownDescription:_.localize(169,null)})),mouseWheelZoom:we(new f(64,"mouseWheelZoom",!1,{markdownDescription:_.localize(170,null)})),multiCursorMergeOverlapping:we(new f(65,"multiCursorMergeOverlapping",!0,{description:_.localize(171,null)})),multiCursorModifier:we(new m(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],x,{markdownEnumDescriptions:[_.localize(172,null),_.localize(173,null)],markdownDescription:_.localize(174,null)})),multiCursorPaste:we(new E(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[_.localize(175,null),_.localize(176,null)],markdownDescription:_.localize(177,null)})),occurrencesHighlight:we(new f(68,"occurrencesHighlight",!0,{description:_.localize(178,null)})),overviewRulerBorder:we(new f(69,"overviewRulerBorder",!0,{description:_.localize(179,null)})),overviewRulerLanes:we(new r(70,"overviewRulerLanes",3,0,3)),padding:we(new G),parameterHints:we(new X),peekWidgetDefaultFocus:we(new E(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[_.localize(180,null),_.localize(181,null)],description:_.localize(182,null)})),definitionLinkOpensInPeek:we(new f(74,"definitionLinkOpensInPeek",!1,{description:_.localize(183,null)})),quickSuggestions:we(new me),quickSuggestionsDelay:we(new r(76,"quickSuggestionsDelay",10,0,1073741824,{description:_.localize(184,null)})),readOnly:we(new f(77,"readOnly",!1)),renameOnType:we(new f(78,"renameOnType",!1,{description:_.localize(185,null),markdownDeprecationMessage:_.localize(186,null)})),renderControlCharacters:we(new f(79,"renderControlCharacters",!1,{description:_.localize(187,null)})),renderIndentGuides:we(new f(80,"renderIndentGuides",!0,{description:_.localize(188,null)})),renderFinalNewline:we(new f(81,"renderFinalNewline",!0,{description:_.localize(189,null)})),renderLineHighlight:we(new E(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",_.localize(190,null)],description:_.localize(191,null)})),renderLineHighlightOnlyWhenFocus:we(new f(83,"renderLineHighlightOnlyWhenFocus",!1,{description:_.localize(192,null)})),renderValidationDecorations:we(new E(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:we(new E(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",_.localize(193,null),_.localize(194,null),_.localize(195,null),""],description:_.localize(196,null)})),revealHorizontalRightPadding:we(new r(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:we(new f(87,"roundedSelection",!0,{description:_.localize(197,null)})),rulers:we(new ze),scrollbar:we(new j),scrollBeyondLastColumn:we(new r(90,"scrollBeyondLastColumn",5,0,1073741824,{description:_.localize(198,null)})),scrollBeyondLastLine:we(new f(91,"scrollBeyondLastLine",!0,{description:_.localize(199,null)})),scrollPredominantAxis:we(new f(92,"scrollPredominantAxis",!0,{description:_.localize(200,null)})),selectionClipboard:we(new f(93,"selectionClipboard",!0,{description:_.localize(201,null),included:k.isLinux})),selectionHighlight:we(new f(94,"selectionHighlight",!0,{description:_.localize(202,null)})),selectOnLineNumbers:we(new f(95,"selectOnLineNumbers",!0)),showFoldingControls:we(new E(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[_.localize(203,null),_.localize(204,null)],description:_.localize(205,null)})),showUnused:we(new f(97,"showUnused",!0,{description:_.localize(206,null)})),showDeprecated:we(new f(121,"showDeprecated",!0,{description:_.localize(207,null)})),inlayHints:we(new F),snippetSuggestions:we(new E(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[_.localize(208,null),_.localize(209,null),_.localize(210,null),_.localize(211,null)],description:_.localize(212,null)})),smartSelect:we(new oe),smoothScrolling:we(new f(100,"smoothScrolling",!1,{description:_.localize(213,null)})),stopRenderingLineAfter:we(new r(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:we(new te),suggestFontSize:we(new r(104,"suggestFontSize",0,0,1e3,{markdownDescription:_.localize(214,null)})),suggestLineHeight:we(new r(105,"suggestLineHeight",0,0,1e3,{markdownDescription:_.localize(215,null)})),suggestOnTriggerCharacters:we(new f(106,"suggestOnTriggerCharacters",!0,{description:_.localize(216,null)})),suggestSelection:we(new E(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[_.localize(217,null),_.localize(218,null),_.localize(219,null)],description:_.localize(220,null)})),tabCompletion:we(new E(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[_.localize(221,null),_.localize(222,null),_.localize(223,null)],description:_.localize(224,null)})),tabIndex:we(new r(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:we(new E(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[_.localize(225,null),_.localize(226,null),_.localize(227,null)],description:_.localize(228,null)})),useTabStops:we(new f(111,"useTabStops",!0,{description:_.localize(229,null)})),wordSeparators:we(new p(112,"wordSeparators",A.USUAL_WORD_SEPARATORS,{description:_.localize(230,null)})),wordWrap:we(new E(113,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[_.localize(231,null),_.localize(232,null),_.localize(233,null),_.localize(234,null)],description:_.localize(235,null)})),wordWrapBreakAfterCharacters:we(new p(114,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:we(new p(115,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:we(new r(116,"wordWrapColumn",80,1,1073741824,{markdownDescription:_.localize(236,null)})),wordWrapOverride1:we(new E(117,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:we(new E(118,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:we(new m(119,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Be,{enumDescriptions:[_.localize(237,null),_.localize(238,null),_.localize(239,null),_.localize(240,null)],description:_.localize(241,null)})),wrappingStrategy:we(new E(120,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[_.localize(242,null),_.localize(243,null)],description:_.localize(244,null)})),editorClassName:we(new v),pixelRatio:we(new ne),tabFocusMode:we(new de),layoutInfo:we(new Y),wrappingInfo:we(new fe)}}),define(ve[124],be([16,17]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ve[125],be([16,17]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ve[126],be([16,17]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(ve[127],be([16,17]),function(J,e){return J.create("vs/platform/markers/common/markers",e)}),define(ve[128],be([16,17]),function(J,e){return J.create("vs/platform/theme/common/iconRegistry",e)}),define(ve[129],be([16,17]),function(J,e){return J.create("vs/platform/workspaces/common/workspaces",e)}),define(ve[130],be([16,17]),function(J,e){return J.create("vs/workbench/api/common/extHost.api.impl",e)}),define(ve[131],be([16,17]),function(J,e){return J.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ve[132],be([16,17]),function(J,e){return J.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ve[133],be([16,17]),function(J,e){return J.create("vs/workbench/api/common/extHostProgress",e)}),define(ve[134],be([16,17]),function(J,e){return J.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ve[135],be([16,17]),function(J,e){return J.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ve[136],be([16,17]),function(J,e){return J.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ve[137],be([16,17]),function(J,e){return J.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ve[138],be([16,17]),function(J,e){return J.create("vs/workbench/common/views",e)}),define(ve[139],be([16,17]),function(J,e){return J.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ve[140],be([16,17]),function(J,e){return J.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ve[141],be([16,17]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ve[142],be([16,17]),function(J,e){return J.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ve[143],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var _;(function(y){y[y.ACTIVATE=0]="ACTIVATE",y[y.RESTORE=1]="RESTORE",y[y.PRESERVE=2]="PRESERVE"})(_=e.EditorActivation||(e.EditorActivation={}));var k;(function(y){y[y.PICK=1]="PICK",y[y.DISABLED=2]="DISABLED"})(k=e.EditorOverride||(e.EditorOverride={}));var A;(function(y){y[y.API=0]="API",y[y.USER=1]="USER"})(A=e.EditorOpenContext||(e.EditorOpenContext={}));var T;(function(y){y[y.Center=0]="Center",y[y.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",y[y.NearTop=2]="NearTop",y[y.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(T=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ve[144],be([0,1,125]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function A(I){return I=I.trim(),I==="*"||k.test(I)}e.isValidVersionStr=A;function T(I){if(!A(I))return null;if(I=I.trim(),I==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let d=I.match(k);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=T;function y(I){if(!I)return null;let d=I.majorBase,f=I.majorMustEqual,r=I.minorBase,o=I.minorMustEqual,p=I.patchBase,g=I.patchMustEqual;return I.hasCaret&&(d===0||(o=!1),g=!1),{majorBase:d,majorMustEqual:f,minorBase:r,minorMustEqual:o,patchBase:p,patchMustEqual:g,isMinimum:I.hasGreaterEquals}}e.normalizeVersion=y;function D(I,d){let f;typeof I=="string"?f=y(T(I)):f=I;let r;if(typeof d=="string"?r=y(T(d)):r=d,!f||!r)return!1;let o=f.majorBase,p=f.minorBase,g=f.patchBase,E=r.majorBase,m=r.minorBase,u=r.patchBase,w=r.majorMustEqual,t=r.minorMustEqual,n=r.patchMustEqual;return r.isMinimum?o>E?!0:o<E?!1:p>m?!0:p<m?!1:g>=u:(o===1&&E===0&&(!w||!t||!n)&&(E=1,m=0,u=0,w=!0,t=!1,n=!1),o<E?!1:o>E?!w:p<m?!1:p>m?!t:g<u?!1:g>u?!n:!0)}e.isValidVersion=D;function S(I,d,f){return d.isBuiltin||typeof d.main=="undefined"?!0:i(I,d.engines.vscode,f)}e.isValidExtensionVersion=S;function C(I,d){return I==="*"||i(d,I)}e.isEngineValid=C;function i(I,d,f=[]){let r=y(T(d));if(!r)return f.push(_.localize(0,null,d)),!1;if(r.majorBase===0){if(!r.majorMustEqual||!r.minorMustEqual)return f.push(_.localize(1,null,d)),!1}else if(!r.majorMustEqual)return f.push(_.localize(2,null,d)),!1;return D(I,r)?!0:(f.push(_.localize(3,null,I,d)),!1)}e.isVersionValid=i}),define(ve[89],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class _{constructor(T,y=[],D=!1){this.ctor=T,this.staticArguments=y,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=_;const k=(A,...T)=>new _(A,T);e.createSyncDescriptor=k}),define(ve[61],be([0,1,89]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const k=[];function A(y,D,S){D instanceof _.SyncDescriptor||(D=new _.SyncDescriptor(D,[],S)),k.push([y,D])}e.registerSingleton=A;function T(){return k}e.getSingletonServiceDescriptors=T}),define(ve[145],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class _{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=_;class k{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let y of this._nodes.values())y.outgoing.size===0&&T.push(y);return T}insertEdge(T,y){const D=this.lookupOrInsertNode(T),S=this.lookupOrInsertNode(y);D.outgoing.set(this._hashFn(y),S),S.incoming.set(this._hashFn(T),D)}removeNode(T){const y=this._hashFn(T);this._nodes.delete(y);for(let D of this._nodes.values())D.outgoing.delete(y),D.incoming.delete(y)}lookupOrInsertNode(T){const y=this._hashFn(T);let D=this._nodes.get(y);return D||(D=new _(T),this._nodes.set(y,D)),D}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[y,D]of this._nodes)T.push(`${y}, (incoming)[${[...D.incoming.keys()].join(", ")}], (outgoing)[${[...D.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,y]of this._nodes){const D=new Set([T]),S=this._findCycle(y,D);if(S)return S}}_findCycle(T,y){for(let[D,S]of T.outgoing){if(y.has(D))return[...y,D].join(" -> ");y.add(D);const C=this._findCycle(S,y);if(C)return C;y.delete(D)}}}e.Graph=k}),define(ve[4],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var _;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function S(C){return C[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=S})(_=e._util||(e._util={})),e.IInstantiationService=A("instantiationService");function k(D,S,C,i){S[_.DI_TARGET]===S?S[_.DI_DEPENDENCIES].push({id:D,index:C,optional:i}):(S[_.DI_DEPENDENCIES]=[{id:D,index:C,optional:i}],S[_.DI_TARGET]=S)}function A(D){if(_.serviceIds.has(D))return _.serviceIds.get(D);const S=function(C,i,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");k(S,C,I,!1)};return S.toString=()=>D,_.serviceIds.set(D,S),S}e.createDecorator=A;function T(D){return D}e.refineServiceDecorator=T;function y(D){return function(S,C,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");k(D,S,i,!0)}}e.optional=y}),define(ve[146],be([0,1,4]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,_.createDecorator)("modelService");function k(A){return!A.isTooLargeForSyncing()&&!A.isForSimpleWidget}e.shouldSynchronizeModel=k}),define(ve[147],be([0,1,3,56,6,22,81,59,146]),function(J,e,_,k,A,T,y,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function C(d){return typeof d=="string"?!1:Array.isArray(d)?d.every(C):!!d.exclusive}class i{constructor(){this._clock=0,this._entries=[],this._onDidChange=new _.Emitter}get onDidChange(){return this._onDidChange.event}register(f,r){let o={selector:f,provider:r,_score:-1,_time:this._clock++};return this._entries.push(o),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,A.toDisposable)(()=>{if(o){let p=this._entries.indexOf(o);p>=0&&(this._entries.splice(p,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),o=void 0)}})}has(f){return this.all(f).length>0}all(f){if(!f)return[];this._updateScores(f);const r=[];for(let o of this._entries)o._score>0&&r.push(o.provider);return r}ordered(f){const r=[];return this._orderedForEach(f,o=>r.push(o.provider)),r}orderedGroups(f){const r=[];let o,p;return this._orderedForEach(f,g=>{o&&p===g._score?o.push(g.provider):(p=g._score,o=[g.provider],r.push(o))}),r}_orderedForEach(f,r){if(!!f){this._updateScores(f);for(const o of this._entries)o._score>0&&r(o)}}_updateScores(f){let r={uri:f.uri.toString(),language:f.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===r.language&&this._lastCandidate.uri===r.uri)){this._lastCandidate=r;for(let o of this._entries)if(o._score=(0,D.score)(o.selector,f.uri,f.getLanguageIdentifier().language,(0,S.shouldSynchronizeModel)(f)),C(o.selector)&&o._score>0){for(let p of this._entries)p._score=0;o._score=1e3;break}this._entries.sort(i._compareByScoreAndTime)}}static _compareByScoreAndTime(f,r){return f._score<r._score?1:f._score>r._score?-1:f._time<r._time?1:f._time>r._time?-1:0}}e.LanguageFeatureRegistry=i;class I{constructor(f,r,o=Number.MAX_SAFE_INTEGER){this._registry=f,this.min=r,this.max=o,this._cache=new T.LRUCache(50,.7)}_key(f){return f.id+(0,k.hash)(this._registry.all(f))}_clamp(f){return f===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(f*1.3)))}get(f){const r=this._key(f),o=this._cache.get(r);return this._clamp(o==null?void 0:o.value)}update(f,r){const o=this._key(f);let p=this._cache.get(o);return p||(p=new y.MovingAverage,this._cache.set(o,p)),p.update(r),this.get(f)}}e.LanguageFeatureRequestDelays=I}),define(ve[62],be([0,1,2,32,147,119,36]),function(J,e,_,k,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var D;(function(h){h[h.Null=0]="Null",h[h.PlainText=1]="PlainText"})(D=e.LanguageId||(e.LanguageId={}));class S{constructor(b,R){this.language=b,this.id=R}}e.LanguageIdentifier=S;var C;(function(h){h[h.NotSet=-1]="NotSet",h[h.None=0]="None",h[h.Italic=1]="Italic",h[h.Bold=2]="Bold",h[h.Underline=4]="Underline"})(C=e.FontStyle||(e.FontStyle={}));var i;(function(h){h[h.None=0]="None",h[h.DefaultForeground=1]="DefaultForeground",h[h.DefaultBackground=2]="DefaultBackground"})(i=e.ColorId||(e.ColorId={}));var I;(function(h){h[h.Other=0]="Other",h[h.Comment=1]="Comment",h[h.String=2]="String",h[h.RegEx=4]="RegEx"})(I=e.StandardTokenType||(e.StandardTokenType={}));var d;(function(h){h[h.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",h[h.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",h[h.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",h[h.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",h[h.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",h[h.ITALIC_MASK=2048]="ITALIC_MASK",h[h.BOLD_MASK=4096]="BOLD_MASK",h[h.UNDERLINE_MASK=8192]="UNDERLINE_MASK",h[h.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",h[h.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",h[h.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",h[h.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",h[h.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",h[h.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",h[h.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",h[h.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",h[h.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",h[h.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(d=e.MetadataConsts||(e.MetadataConsts={}));class f{static getLanguageId(b){return(b&255)>>>0}static getTokenType(b){return(b&1792)>>>8}static getFontStyle(b){return(b&14336)>>>11}static getForeground(b){return(b&8372224)>>>14}static getBackground(b){return(b&4286578688)>>>23}static getClassNameFromMetadata(b){let R=this.getForeground(b),U="mtk"+R,K=this.getFontStyle(b);return K&1&&(U+=" mtki"),K&2&&(U+=" mtkb"),K&4&&(U+=" mtku"),U}static getInlineStyleFromMetadata(b,R){const U=this.getForeground(b),K=this.getFontStyle(b);let he=`color: ${R[U]};`;return K&1&&(he+="font-style: italic;"),K&2&&(he+="font-weight: bold;"),K&4&&(he+="text-decoration: underline;"),he}}e.TokenMetadata=f;var r;(function(h){h[h.Method=0]="Method",h[h.Function=1]="Function",h[h.Constructor=2]="Constructor",h[h.Field=3]="Field",h[h.Variable=4]="Variable",h[h.Class=5]="Class",h[h.Struct=6]="Struct",h[h.Interface=7]="Interface",h[h.Module=8]="Module",h[h.Property=9]="Property",h[h.Event=10]="Event",h[h.Operator=11]="Operator",h[h.Unit=12]="Unit",h[h.Value=13]="Value",h[h.Constant=14]="Constant",h[h.Enum=15]="Enum",h[h.EnumMember=16]="EnumMember",h[h.Keyword=17]="Keyword",h[h.Text=18]="Text",h[h.Color=19]="Color",h[h.File=20]="File",h[h.Reference=21]="Reference",h[h.Customcolor=22]="Customcolor",h[h.Folder=23]="Folder",h[h.TypeParameter=24]="TypeParameter",h[h.User=25]="User",h[h.Issue=26]="Issue",h[h.Snippet=27]="Snippet"})(r=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let h=Object.create(null);return h[0]="symbol-method",h[1]="symbol-function",h[2]="symbol-constructor",h[3]="symbol-field",h[4]="symbol-variable",h[5]="symbol-class",h[6]="symbol-struct",h[7]="symbol-interface",h[8]="symbol-module",h[9]="symbol-property",h[10]="symbol-event",h[11]="symbol-operator",h[12]="symbol-unit",h[13]="symbol-value",h[14]="symbol-constant",h[15]="symbol-enum",h[16]="symbol-enum-member",h[17]="symbol-keyword",h[27]="symbol-snippet",h[18]="symbol-text",h[19]="symbol-color",h[20]="symbol-file",h[21]="symbol-reference",h[22]="symbol-customcolor",h[23]="symbol-folder",h[24]="symbol-type-parameter",h[25]="account",h[26]="issues",function(b){const R=h[b];let U=R&&y.iconRegistry.get(R);return U||(console.info("No codicon found for CompletionItemKind "+b),U=y.Codicon.symbolProperty),U.classNames}}(),e.completionKindFromString=function(){let h=Object.create(null);return h.method=0,h.function=1,h.constructor=2,h.field=3,h.variable=4,h.class=5,h.struct=6,h.interface=7,h.module=8,h.property=9,h.event=10,h.operator=11,h.unit=12,h.value=13,h.constant=14,h.enum=15,h["enum-member"]=16,h.enumMember=16,h.keyword=17,h.snippet=27,h.text=18,h.color=19,h.file=20,h.reference=21,h.customcolor=22,h.folder=23,h["type-parameter"]=24,h.typeParameter=24,h.account=25,h.issue=26,function(b,R){let U=h[b];return typeof U=="undefined"&&!R&&(U=9),U}}();var o;(function(h){h[h.Deprecated=1]="Deprecated"})(o=e.CompletionItemTag||(e.CompletionItemTag={}));var p;(function(h){h[h.KeepWhitespace=1]="KeepWhitespace",h[h.InsertAsSnippet=4]="InsertAsSnippet"})(p=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var g;(function(h){h[h.Invoke=0]="Invoke",h[h.TriggerCharacter=1]="TriggerCharacter",h[h.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(g=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var E;(function(h){h[h.Invoke=1]="Invoke",h[h.Auto=2]="Auto"})(E=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var m;(function(h){h[h.Invoke=1]="Invoke",h[h.TriggerCharacter=2]="TriggerCharacter",h[h.ContentChange=3]="ContentChange"})(m=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var u;(function(h){h[h.Text=0]="Text",h[h.Read=1]="Read",h[h.Write=2]="Write"})(u=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function w(h){return h&&_.URI.isUri(h.uri)&&k.Range.isIRange(h.range)&&(k.Range.isIRange(h.originSelectionRange)||k.Range.isIRange(h.targetSelectionRange))}e.isLocationLink=w;var t;(function(h){h[h.File=0]="File",h[h.Module=1]="Module",h[h.Namespace=2]="Namespace",h[h.Package=3]="Package",h[h.Class=4]="Class",h[h.Method=5]="Method",h[h.Property=6]="Property",h[h.Field=7]="Field",h[h.Constructor=8]="Constructor",h[h.Enum=9]="Enum",h[h.Interface=10]="Interface",h[h.Function=11]="Function",h[h.Variable=12]="Variable",h[h.Constant=13]="Constant",h[h.String=14]="String",h[h.Number=15]="Number",h[h.Boolean=16]="Boolean",h[h.Array=17]="Array",h[h.Object=18]="Object",h[h.Key=19]="Key",h[h.Null=20]="Null",h[h.EnumMember=21]="EnumMember",h[h.Struct=22]="Struct",h[h.Event=23]="Event",h[h.Operator=24]="Operator",h[h.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var n;(function(h){h[h.Deprecated=1]="Deprecated"})(n=e.SymbolTag||(e.SymbolTag={}));var l;(function(h){const b=new Map;b.set("file",0),b.set("module",1),b.set("namespace",2),b.set("package",3),b.set("class",4),b.set("method",5),b.set("property",6),b.set("field",7),b.set("constructor",8),b.set("enum",9),b.set("interface",10),b.set("function",11),b.set("variable",12),b.set("constant",13),b.set("string",14),b.set("number",15),b.set("boolean",16),b.set("array",17),b.set("object",18),b.set("key",19),b.set("null",20),b.set("enum-member",21),b.set("struct",22),b.set("event",23),b.set("operator",24),b.set("type-parameter",25);const R=new Map;R.set(0,"file"),R.set(1,"module"),R.set(2,"namespace"),R.set(3,"package"),R.set(4,"class"),R.set(5,"method"),R.set(6,"property"),R.set(7,"field"),R.set(8,"constructor"),R.set(9,"enum"),R.set(10,"interface"),R.set(11,"function"),R.set(12,"variable"),R.set(13,"constant"),R.set(14,"string"),R.set(15,"number"),R.set(16,"boolean"),R.set(17,"array"),R.set(18,"object"),R.set(19,"key"),R.set(20,"null"),R.set(21,"enum-member"),R.set(22,"struct"),R.set(23,"event"),R.set(24,"operator"),R.set(25,"type-parameter");function U(V){return b.get(V)}h.fromString=U;function K(V){return R.get(V)}h.toString=K;function he(V,H){const Y=R.get(V);let W=Y&&y.iconRegistry.get("symbol-"+Y);return W||(console.info("No codicon found for SymbolKind "+V),W=y.Codicon.symbolProperty),`${H?"inline":"block"} ${W.classNames}`}h.toCssClassName=he})(l=e.SymbolKinds||(e.SymbolKinds={}));class a{constructor(b){this.value=b}}e.FoldingRangeKind=a,a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region");var s;(function(h){h[h.Collapsed=0]="Collapsed",h[h.Expanded=1]="Expanded"})(s=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var c;(function(h){h[h.Editing=0]="Editing",h[h.Preview=1]="Preview"})(c=e.CommentMode||(e.CommentMode={}));var v;(function(h){h[h.Other=0]="Other",h[h.Type=1]="Type",h[h.Parameter=2]="Parameter"})(v=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new A.LanguageFeatureRegistry,e.RenameProviderRegistry=new A.LanguageFeatureRegistry,e.CompletionProviderRegistry=new A.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new A.LanguageFeatureRegistry,e.HoverProviderRegistry=new A.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new A.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new A.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new A.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new A.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new A.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new A.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new A.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new A.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new A.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.LinkProviderRegistry=new A.LanguageFeatureRegistry,e.ColorProviderRegistry=new A.LanguageFeatureRegistry,e.SelectionRangeRegistry=new A.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new A.LanguageFeatureRegistry,e.TokenizationRegistry=new T.TokenizationRegistryImpl;var P;(function(h){h[h.None=0]="None",h[h.Option=1]="Option",h[h.Default=2]="Default",h[h.Preferred=3]="Preferred"})(P=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ve[148],be([0,1,6,10,4,3,45,43]),function(J,e,_,k,A,T,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,A.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new T.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(S,C){if(!S)throw new Error("invalid command");if(typeof S=="string"){if(!C)throw new Error("invalid command");return this.registerCommand({id:S,handler:C})}if(S.description){const r=[];for(let p of S.description.args)r.push(p.constraint);const o=S.handler;S.handler=function(p,...g){return(0,k.validateConstraints)(g,r),o(p,...g)}}const{id:i}=S;let I=this._commands.get(i);I||(I=new y.LinkedList,this._commands.set(i,I));let d=I.unshift(S),f=(0,_.toDisposable)(()=>{d();const r=this._commands.get(i);(r==null?void 0:r.isEmpty())&&this._commands.delete(i)});return this._onDidRegisterCommand.fire(i),f}registerCommandAlias(S,C){return e.CommandsRegistry.registerCommand(S,(i,...I)=>i.get(e.ICommandService).executeCommand(C,...I))}getCommand(S){const C=this._commands.get(S);if(!(!C||C.isEmpty()))return D.Iterable.first(C)}getCommands(){const S=new Map;for(const C of this._commands.keys()){const i=this.getCommand(C);i&&S.set(C,i)}return S}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>_.Disposable.None,onDidExecuteCommand:()=>_.Disposable.None,executeCommand(){return Promise.resolve(void 0)}},e.CommandsRegistry.registerCommand("noop",()=>{})}),define(ve[63],be([0,1,8,4,21]),function(J,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=A.userAgent||"";const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",A.isMacintosh),y.set("isLinux",A.isLinux),y.set("isWindows",A.isWindows),y.set("isWeb",A.isWeb),y.set("isMacNative",A.isMacintosh&&!A.isWeb),y.set("isEdge",T.indexOf("Edg/")>=0),y.set("isFirefox",T.indexOf("Firefox")>=0),y.set("isChrome",T.indexOf("Chrome")>=0),y.set("isSafari",T.indexOf("Safari")>=0);const D=Object.prototype.hasOwnProperty;var S;(function(h){h[h.False=0]="False",h[h.True=1]="True",h[h.Defined=2]="Defined",h[h.Not=3]="Not",h[h.Equals=4]="Equals",h[h.NotEquals=5]="NotEquals",h[h.And=6]="And",h[h.Regex=7]="Regex",h[h.NotRegex=8]="NotRegex",h[h.Or=9]="Or",h[h.In=10]="In",h[h.NotIn=11]="NotIn",h[h.Greater=12]="Greater",h[h.GreaterEquals=13]="GreaterEquals",h[h.Smaller=14]="Smaller",h[h.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class C{static false(){return I.INSTANCE}static true(){return d.INSTANCE}static has(b){return f.create(b)}static equals(b,R){return r.create(b,R)}static notEquals(b,R){return g.create(b,R)}static regex(b,R){return n.create(b,R)}static in(b,R){return o.create(b,R)}static not(b){return E.create(b)}static and(...b){return a.create(b)}static or(...b){return s.create(b)}static greater(b,R){return m.create(b,R)}static less(b,R){return w.create(b,R)}static deserialize(b,R=!1){if(!!b)return this._deserializeOrExpression(b,R)}static _deserializeOrExpression(b,R){let U=b.split("||");return s.create(U.map(K=>this._deserializeAndExpression(K,R)))}static _deserializeAndExpression(b,R){let U=b.split("&&");return a.create(U.map(K=>this._deserializeOne(K,R)))}static _deserializeOne(b,R){if(b=b.trim(),b.indexOf("!=")>=0){let U=b.split("!=");return g.create(U[0].trim(),this._deserializeValue(U[1],R))}if(b.indexOf("==")>=0){let U=b.split("==");return r.create(U[0].trim(),this._deserializeValue(U[1],R))}if(b.indexOf("=~")>=0){let U=b.split("=~");return n.create(U[0].trim(),this._deserializeRegexValue(U[1],R))}if(b.indexOf(" in ")>=0){let U=b.split(" in ");return o.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(b)){const U=b.split(">=");return u.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(b)){const U=b.split(">");return m.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(b)){const U=b.split("<=");return t.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(b)){const U=b.split("<");return w.create(U[0].trim(),U[1].trim())}return/^\!\s*/.test(b)?E.create(b.substr(1).trim()):f.create(b)}static _deserializeValue(b,R){if(b=b.trim(),b==="true")return!0;if(b==="false")return!1;let U=/^'([^']*)'$/.exec(b);return U?U[1].trim():b}static _deserializeRegexValue(b,R){if((0,_.isFalsyOrWhitespace)(b)){if(R)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let U=b.indexOf("/"),K=b.lastIndexOf("/");if(U===K||U<0){if(R)throw new Error(`bad regexp-value '${b}', missing /-enclosure`);return console.warn(`bad regexp-value '${b}', missing /-enclosure`),null}let he=b.slice(U+1,K),V=b[K+1]==="i"?"i":"";try{return new RegExp(he,V)}catch(H){if(R)throw new Error(`bad regexp-value '${b}', parse error: ${H}`);return console.warn(`bad regexp-value '${b}', parse error: ${H}`),null}}}e.ContextKeyExpr=C;function i(h,b){return h.cmp(b)}class I{constructor(){this.type=0}cmp(b){return this.type-b.type}equals(b){return b.type===this.type}evaluate(b){return!1}serialize(){return"false"}keys(){return[]}map(b){return this}negate(){return d.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class d{constructor(){this.type=1}cmp(b){return this.type-b.type}equals(b){return b.type===this.type}evaluate(b){return!0}serialize(){return"true"}keys(){return[]}map(b){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=d,d.INSTANCE=new d;class f{constructor(b){this.key=b,this.type=2}static create(b){const R=y.get(b);return typeof R=="boolean"?R?d.INSTANCE:I.INSTANCE:new f(b)}cmp(b){return b.type!==this.type?this.type-b.type:v(this.key,b.key)}equals(b){return b.type===this.type?this.key===b.key:!1}evaluate(b){return!!b.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(b){return b.mapDefined(this.key)}negate(){return E.create(this.key)}}e.ContextKeyDefinedExpr=f;class r{constructor(b,R){this.key=b,this.value=R,this.type=4}static create(b,R){if(typeof R=="boolean")return R?f.create(b):E.create(b);const U=y.get(b);return typeof U=="boolean"?R===(U?"true":"false")?d.INSTANCE:I.INSTANCE:new r(b,R)}cmp(b){return b.type!==this.type?this.type-b.type:P(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return b.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(b){return b.mapEquals(this.key,this.value)}negate(){return g.create(this.key,this.value)}}e.ContextKeyEqualsExpr=r;class o{constructor(b,R){this.key=b,this.valueKey=R,this.type=10}static create(b,R){return new o(b,R)}cmp(b){return b.type!==this.type?this.type-b.type:P(this.key,this.valueKey,b.key,b.valueKey)}equals(b){return b.type===this.type?this.key===b.key&&this.valueKey===b.valueKey:!1}evaluate(b){const R=b.getValue(this.valueKey),U=b.getValue(this.key);return Array.isArray(R)?R.indexOf(U)>=0:typeof U=="string"&&typeof R=="object"&&R!==null?D.call(R,U):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(b){return b.mapIn(this.key,this.valueKey)}negate(){return p.create(this)}}e.ContextKeyInExpr=o;class p{constructor(b){this._actual=b,this.type=11}static create(b){return new p(b)}cmp(b){return b.type!==this.type?this.type-b.type:this._actual.cmp(b._actual)}equals(b){return b.type===this.type?this._actual.equals(b._actual):!1}evaluate(b){return!this._actual.evaluate(b)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(b){return new p(this._actual.map(b))}negate(){return this._actual}}e.ContextKeyNotInExpr=p;class g{constructor(b,R){this.key=b,this.value=R,this.type=5}static create(b,R){if(typeof R=="boolean")return R?E.create(b):f.create(b);const U=y.get(b);return typeof U=="boolean"?R===(U?"true":"false")?I.INSTANCE:d.INSTANCE:new g(b,R)}cmp(b){return b.type!==this.type?this.type-b.type:P(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return b.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(b){return b.mapNotEquals(this.key,this.value)}negate(){return r.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=g;class E{constructor(b){this.key=b,this.type=3}static create(b){const R=y.get(b);return typeof R=="boolean"?R?I.INSTANCE:d.INSTANCE:new E(b)}cmp(b){return b.type!==this.type?this.type-b.type:v(this.key,b.key)}equals(b){return b.type===this.type?this.key===b.key:!1}evaluate(b){return!b.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(b){return b.mapNot(this.key)}negate(){return f.create(this.key)}}e.ContextKeyNotExpr=E;class m{constructor(b,R){this.key=b,this.value=R,this.type=12}static create(b,R){return new m(b,R)}cmp(b){return b.type!==this.type?this.type-b.type:P(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return parseFloat(b.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(b){return b.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=m;class u{constructor(b,R){this.key=b,this.value=R,this.type=13}static create(b,R){return new u(b,R)}cmp(b){return b.type!==this.type?this.type-b.type:P(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return parseFloat(b.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(b){return b.mapGreaterEquals(this.key,this.value)}negate(){return w.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=u;class w{constructor(b,R){this.key=b,this.value=R,this.type=14}static create(b,R){return new w(b,R)}cmp(b){return b.type!==this.type?this.type-b.type:P(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return parseFloat(b.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(b){return b.mapSmaller(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeySmallerExpr=w;class t{constructor(b,R){this.key=b,this.value=R,this.type=15}static create(b,R){return new t(b,R)}cmp(b){return b.type!==this.type?this.type-b.type:P(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return parseFloat(b.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(b){return b.mapSmallerEquals(this.key,this.value)}negate(){return m.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class n{constructor(b,R){this.key=b,this.regexp=R,this.type=7}static create(b,R){return new n(b,R)}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.key<b.key)return-1;if(this.key>b.key)return 1;const R=this.regexp?this.regexp.source:"",U=b.regexp?b.regexp.source:"";return R<U?-1:R>U?1:0}equals(b){if(b.type===this.type){const R=this.regexp?this.regexp.source:"",U=b.regexp?b.regexp.source:"";return this.key===b.key&&R===U}return!1}evaluate(b){let R=b.getValue(this.key);return this.regexp?this.regexp.test(R):!1}serialize(){const b=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${b}`}keys(){return[this.key]}map(b){return b.mapRegex(this.key,this.regexp)}negate(){return l.create(this)}}e.ContextKeyRegexExpr=n;class l{constructor(b){this._actual=b,this.type=8}static create(b){return new l(b)}cmp(b){return b.type!==this.type?this.type-b.type:this._actual.cmp(b._actual)}equals(b){return b.type===this.type?this._actual.equals(b._actual):!1}evaluate(b){return!this._actual.evaluate(b)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(b){return new l(this._actual.map(b))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=l;class a{constructor(b){this.expr=b,this.type=6}static create(b){return a._normalizeArr(b)}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.expr.length<b.expr.length)return-1;if(this.expr.length>b.expr.length)return 1;for(let R=0,U=this.expr.length;R<U;R++){const K=i(this.expr[R],b.expr[R]);if(K!==0)return K}return 0}equals(b){if(b.type===this.type){if(this.expr.length!==b.expr.length)return!1;for(let R=0,U=this.expr.length;R<U;R++)if(!this.expr[R].equals(b.expr[R]))return!1;return!0}return!1}evaluate(b){for(let R=0,U=this.expr.length;R<U;R++)if(!this.expr[R].evaluate(b))return!1;return!0}static _normalizeArr(b){const R=[];let U=!1;for(const K of b)if(!!K){if(K.type===1){U=!0;continue}if(K.type===0)return I.INSTANCE;if(K.type===6){R.push(...K.expr);continue}R.push(K)}if(R.length===0&&U)return d.INSTANCE;if(R.length!==0){if(R.length===1)return R[0];for(R.sort(i);R.length>1;){const K=R[R.length-1];if(K.type!==9)break;R.pop();const he=R.pop(),V=s.create(K.expr.map(H=>a.create([H,he])));V&&(R.push(V),R.sort(i))}return R.length===1?R[0]:new a(R)}}serialize(){return this.expr.map(b=>b.serialize()).join(" && ")}keys(){const b=[];for(let R of this.expr)b.push(...R.keys());return b}map(b){return new a(this.expr.map(R=>R.map(b)))}negate(){let b=[];for(let R of this.expr)b.push(R.negate());return s.create(b)}}e.ContextKeyAndExpr=a;class s{constructor(b){this.expr=b,this.type=9}static create(b){const R=s._normalizeArr(b);if(R.length!==0)return R.length===1?R[0]:new s(R)}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.expr.length<b.expr.length)return-1;if(this.expr.length>b.expr.length)return 1;for(let R=0,U=this.expr.length;R<U;R++){const K=i(this.expr[R],b.expr[R]);if(K!==0)return K}return 0}equals(b){if(b.type===this.type){if(this.expr.length!==b.expr.length)return!1;for(let R=0,U=this.expr.length;R<U;R++)if(!this.expr[R].equals(b.expr[R]))return!1;return!0}return!1}evaluate(b){for(let R=0,U=this.expr.length;R<U;R++)if(this.expr[R].evaluate(b))return!0;return!1}static _normalizeArr(b){let R=[],U=!1;if(b){for(let K=0,he=b.length;K<he;K++){const V=b[K];if(!!V){if(V.type===0){U=!0;continue}if(V.type===1)return[d.INSTANCE];if(V.type===9){R=R.concat(V.expr);continue}R.push(V)}}if(R.length===0&&U)return[I.INSTANCE];R.sort(i)}return R}serialize(){return this.expr.map(b=>b.serialize()).join(" || ")}keys(){const b=[];for(let R of this.expr)b.push(...R.keys());return b}map(b){return new s(this.expr.map(R=>R.map(b)))}negate(){let b=[];for(let U of this.expr)b.push(U.negate());const R=U=>U.type===9?U.expr:[U];for(;b.length>1;){const U=b.shift(),K=b.shift(),he=[];for(const V of R(U))for(const H of R(K))he.push(C.and(V,H));b.unshift(C.or(...he))}return b[0]}}e.ContextKeyOrExpr=s;class c extends f{constructor(b,R,U){super(b);this._defaultValue=R,typeof U=="object"?c._info.push(Object.assign(Object.assign({},U),{key:b})):U!==!0&&c._info.push({key:b,description:U,type:R!=null?typeof R:void 0})}static all(){return c._info.values()}bindTo(b){return b.createKey(this.key,this._defaultValue)}getValue(b){return b.getContextKeyValue(this.key)}toNegated(){return C.not(this.key)}isEqualTo(b){return C.equals(this.key,b)}notEqualsTo(b){return C.notEquals(this.key,b)}}e.RawContextKey=c,c._info=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function v(h,b){return h<b?-1:h>b?1:0}function P(h,b,R,U){return h<R?-1:h>R?1:b<U?-1:b>U?1:0}}),define(ve[149],be([0,1,4]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,_.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,_.refineServiceDecorator)(e.IEnvironmentService)}),define(ve[26],be([0,1,8,4]),function(J,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function A(C){return C&&typeof C=="object"&&typeof C.id=="string"&&(!C.uuid||typeof C.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(C){C[C.System=0]="System",C[C.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));class y{constructor(i){this.value=i,this._lower=i.toLowerCase()}static equals(i,I){if(typeof i=="undefined"||i===null)return typeof I=="undefined"||I===null;if(typeof I=="undefined"||I===null)return!1;if(typeof i=="string"||typeof I=="string"){let d=typeof i=="string"?i:i.value,f=typeof I=="string"?I:I.value;return _.equalsIgnoreCase(d,f)}return i._lower===I._lower}static toKey(i){return typeof i=="string"?i.toLowerCase():i._lower}}e.ExtensionIdentifier=y;function D(C){return C.contributes&&C.contributes.localizations?C.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function S(C){return C.contributes&&C.contributes.authentication?C.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=S,e.IBuiltinExtensionsScannerService=(0,k.createDecorator)("IBuiltinExtensionsScannerService")}),define(ve[150],be([0,1,8,26]),function(J,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function A(f,r){return f.uuid&&r.uuid?f.uuid===r.uuid:f.id===r.id?!0:(0,_.compareIgnoreCase)(f.id,r.id)===0}e.areSameExtensions=A;class T{constructor(r,o){this.version=o,this.id=r.id,this.uuid=r.uuid}key(){return`${this.id}-${this.version}`}equals(r){return r instanceof T?A(this,r)&&this.version===r.version:!1}}e.ExtensionIdentifierWithVersion=T;function y(f,r){return`${f}.${r}`}e.getExtensionId=y;function D(f){return f.toLocaleLowerCase()}e.adoptToGalleryExtensionId=D;function S(f,r){return D(y(f,r))}e.getGalleryExtensionId=S;function C(f,r){const o=[],p=g=>{for(const E of o)if(E.some(m=>A(r(m),r(g))))return E;return null};for(const g of f){const E=p(g);E?E.push(g):o.push([g])}return o}e.groupByExtension=C;function i(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function I(f){return Object.assign({id:f.identifier.id,name:f.name,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0)},f.telemetryData)}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function d(f){const r=new Set;for(const o of f)o.malicious&&r.add(o.id.id);return r}e.getMaliciousExtensionsSet=d}),define(ve[64],be([0,1,126,13,2,4,8,10,22]),function(J,e,_,k,A,T,y,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,T.createDecorator)("fileService");function C(V){return V.create===!0}e.isFileOpenForWriteOptions=C;var i;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var I;(function(V){V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock"})(I=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function d(V){return!!(V.capabilities&2)}e.hasReadWriteCapability=d;function f(V){return!!(V.capabilities&8)}e.hasFileFolderCopyCapability=f;function r(V){return!!(V.capabilities&4)}e.hasOpenReadWriteCloseCapability=r;function o(V){return!!(V.capabilities&16)}e.hasFileReadStreamCapability=o;var p;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(p=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class g extends Error{constructor(H,Y){super(H);this.code=Y}}e.FileSystemProviderError=g;function E(V,H){const Y=new g(V.toString(),H);return u(Y,H),Y}e.createFileSystemProviderError=E;function m(V){return V||E((0,_.localize)(0,null),p.Unknown)}e.ensureFileSystemProviderError=m;function u(V,H){return V.name=H?`${H} (FileSystemError)`:"FileSystemError",V}e.markAsFileSystemProviderError=u;function w(V){if(!V)return p.Unknown;if(V instanceof g)return V.code;const H=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!H)return p.Unknown;switch(H[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileExceedsMemoryLimit:return p.FileExceedsMemoryLimit;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.toFileSystemProviderErrorCode=w;function t(V){if(V instanceof v)return V.fileOperationResult;switch(w(V)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 10;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileExceedsMemoryLimit:return 9;case p.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var n;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class l{constructor(H,Y,W){this.resource=H,this.operation=Y,this.target=W}isOperation(H){return this.operation===H}}e.FileOperationEvent=l;var a;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class s{constructor(H,Y){this.ignorePathCasing=Y,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=H;for(const W of H)switch(W.type){case 1:this.added||(this.added=S.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(W.resource,W);break;case 0:this.updated||(this.updated=S.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(W.resource,W);break;case 2:this.deleted||(this.deleted=S.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(W.resource,W);break}}contains(H,...Y){return this.doContains(H,{includeChildren:!1},...Y)}affects(H,...Y){return this.doContains(H,{includeChildren:!0},...Y)}doContains(H,Y,...W){var F,L,M,x,G,X;if(!H)return!1;const ne=W.length>0;return!!((!ne||W.includes(1))&&(((F=this.added)===null||F===void 0?void 0:F.get(H))||Y.includeChildren&&((L=this.added)===null||L===void 0?void 0:L.findSuperstr(H)))||(!ne||W.includes(0))&&(((M=this.updated)===null||M===void 0?void 0:M.get(H))||Y.includeChildren&&((x=this.updated)===null||x===void 0?void 0:x.findSuperstr(H)))||(!ne||W.includes(2))&&(((G=this.deleted)===null||G===void 0?void 0:G.findSubstr(H))||Y.includeChildren&&((X=this.deleted)===null||X===void 0?void 0:X.findSuperstr(H))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(H){const Y=[],W=H===1?this.added:H===0?this.updated:this.deleted;if(W)for(const[,F]of W)Y.push(F);return Y}filter(H){return new s(this.changes.filter(Y=>H(Y)),this.ignorePathCasing)}}e.FileChangesEvent=s;function c(V,H,Y){return!V||!H||V===H||H.length>V.length?!1:(H.charAt(H.length-1)!==k.sep&&(H+=k.sep),Y?(0,y.startsWithIgnoreCase)(V,H):V.indexOf(H)===0)}e.isParent=c;class v extends Error{constructor(H,Y,W){super(H);this.fileOperationResult=Y,this.options=W}static isFileOperationError(H){return H instanceof Error&&!(0,D.isUndefinedOrNull)(H.fileOperationResult)}}e.FileOperationError=v;var P;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",V[V.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(P=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var h;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(h=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function b(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.etag=b;async function R(V,H){if(!H.canHandleResource(A.URI.from({scheme:V.scheme})))return new Promise(Y=>{const W=H.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===V.scheme&&F.added&&(W.dispose(),Y())})})}e.whenProviderRegistered=R,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class U{static formatSize(H){return(0,D.isNumber)(H)||(H=0),H<U.KB?(0,_.localize)(1,null,H.toFixed(0)):H<U.MB?(0,_.localize)(2,null,(H/U.KB).toFixed(2)):H<U.GB?(0,_.localize)(3,null,(H/U.MB).toFixed(2)):H<U.TB?(0,_.localize)(4,null,(H/U.GB).toFixed(2)):(0,_.localize)(5,null,(H/U.TB).toFixed(2))}}e.ByteSize=U,U.KB=1024,U.MB=U.KB*U.KB,U.GB=U.MB*U.KB,U.TB=U.GB*U.KB;var K;(function(V){V[V.IA32=0]="IA32",V[V.OTHER=1]="OTHER"})(K=e.Arch||(e.Arch={}));function he(V){return{maxFileSize:V===0?300*U.MB:16*U.GB,maxHeapSize:V===0?700*U.MB:2*700*U.MB}}e.getPlatformLimits=he}),define(ve[65],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class _{constructor(...A){this._entries=new Map;for(let[T,y]of A)this.set(T,y)}set(A,T){const y=this._entries.get(A);return this._entries.set(A,T),y}has(A){return this._entries.has(A)}get(A){return this._entries.get(A)}}e.ServiceCollection=_}),define(ve[151],be([0,1,12,145,89,4,65,11]),function(J,e,_,k,A,T,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class C extends Error{constructor(r){var o;super("cyclic dependency between services");this.message=(o=r.findCycleSlow())!==null&&o!==void 0?o:`UNABLE to detect cycle, dumping graph: 
${r.toString()}`}}class i{constructor(r=new y.ServiceCollection,o=!1,p){this._activeInstantiations=new Set,this._services=r,this._strict=o,this._parent=p,this._services.set(T.IInstantiationService,this)}createChild(r){return new i(r,this._strict,this)}invokeFunction(r,...o){let p=d.traceInvocation(r),g=!1;try{return r({get:(m,u)=>{if(g)throw(0,_.illegalState)("service accessor is only valid during the invocation of its target method");const w=this._getOrCreateServiceInstance(m,p);if(!w&&u!==T.optional)throw new Error(`[invokeFunction] unknown service '${m}'`);return w}},...o)}finally{g=!0,p.stop()}}createInstance(r,...o){let p,g;return r instanceof A.SyncDescriptor?(p=d.traceCreation(r.ctor),g=this._createInstance(r.ctor,r.staticArguments.concat(o),p)):(p=d.traceCreation(r),g=this._createInstance(r,o,p)),p.stop(),g}_createInstance(r,o=[],p){let g=T._util.getServiceDependencies(r).sort((u,w)=>u.index-w.index),E=[];for(const u of g){let w=this._getOrCreateServiceInstance(u.id,p);if(!w&&this._strict&&!u.optional)throw new Error(`[createInstance] ${r.name} depends on UNKNOWN service ${u.id}.`);E.push(w)}let m=g.length>0?g[0].index:o.length;if(o.length!==m){console.warn(`[createInstance] First service dependency of ${r.name} at position ${m+1} conflicts with ${o.length} static arguments`);let u=m-o.length;u>0?o=o.concat(new Array(u)):o=o.slice(0,m)}return new r(...[...o,...E])}_setServiceInstance(r,o){if(this._services.get(r)instanceof A.SyncDescriptor)this._services.set(r,o);else if(this._parent)this._parent._setServiceInstance(r,o);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(r){let o=this._services.get(r);return!o&&this._parent?this._parent._getServiceInstanceOrDescriptor(r):o}_getOrCreateServiceInstance(r,o){let p=this._getServiceInstanceOrDescriptor(r);return p instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(r,p,o.branch(r,!0)):(o.branch(r,!1),p)}_safeCreateAndCacheServiceInstance(r,o,p){if(this._activeInstantiations.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this._activeInstantiations.add(r);try{return this._createAndCacheServiceInstance(r,o,p)}finally{this._activeInstantiations.delete(r)}}_createAndCacheServiceInstance(r,o,p){const g=new k.Graph(u=>u.id.toString());let E=0;const m=[{id:r,desc:o,_trace:p}];for(;m.length;){const u=m.pop();if(g.lookupOrInsertNode(u),E++>1e3)throw new C(g);for(let w of T._util.getServiceDependencies(u.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(w.id);if(!t&&!w.optional&&console.warn(`[createInstance] ${r} depends on ${w.id} which is NOT registered.`),t instanceof A.SyncDescriptor){const n={id:w.id,desc:t,_trace:u._trace.branch(w.id,!0)};g.insertEdge(u,n),m.push(n)}}}for(;;){const u=g.roots();if(u.length===0){if(!g.isEmpty())throw new C(g);break}for(const{data:w}of u){if(this._getServiceInstanceOrDescriptor(w.id)instanceof A.SyncDescriptor){const n=this._createServiceInstanceWithOwner(w.id,w.desc.ctor,w.desc.staticArguments,w.desc.supportsDelayedInstantiation,w._trace);this._setServiceInstance(w.id,n)}g.removeNode(w)}}return this._getServiceInstanceOrDescriptor(r)}_createServiceInstanceWithOwner(r,o,p=[],g,E){if(this._services.get(r)instanceof A.SyncDescriptor)return this._createServiceInstance(o,p,g,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(r,o,p,g,E);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}_createServiceInstance(r,o=[],p,g){if(p){const E=new D.IdleValue(()=>this._createInstance(r,o,g));return new Proxy(Object.create(null),{get(m,u){if(u in m)return m[u];let w=E.value,t=w[u];return typeof t!="function"||(t=t.bind(w),m[u]=t),t},set(m,u,w){return E.value[u]=w,!0}})}else return this._createInstance(r,o,g)}}e.InstantiationService=i;var I;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(I||(I={}));class d{constructor(r,o){this.type=r,this.name=o,this._start=Date.now(),this._dep=[]}static traceInvocation(r){return S?new d(1,r.name||r.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(r){return S?new d(0,r.name):d._None}branch(r,o){let p=new d(2,r.toString());return this._dep.push([r,o,p]),p}stop(){let r=Date.now()-this._start;d._totals+=r;let o=!1;function p(E,m){let u=[],w=new Array(E+1).join("	");for(const[t,n,l]of m._dep)if(n&&l){o=!0,u.push(`${w}CREATES -> ${t}`);let a=p(E+1,l);a&&u.push(a)}else u.push(`${w}uses -> ${t}`);return u.join(`
`)}let g=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(r>2||o)&&console.log(g.join(`
`))}}d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(ve[18],be([0,1,4,6,21,3,60]),function(J,e,_,k,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,_.createDecorator)("logService"),e.ILoggerService=(0,_.createDecorator)("loggerService");function D(){return new Date().toISOString()}var S;(function(w){w[w.Trace=0]="Trace",w[w.Debug=1]="Debug",w[w.Info=2]="Info",w[w.Warning=3]="Warning",w[w.Error=4]="Error",w[w.Critical=5]="Critical",w[w.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;class C extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class i extends C{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(S.Trace)&&this.log(S.Trace,this.format([t,...n]))}debug(t,...n){this.checkLogLevel(S.Debug)&&this.log(S.Debug,this.format([t,...n]))}info(t,...n){this.checkLogLevel(S.Info)&&this.log(S.Info,this.format([t,...n]))}warn(t,...n){this.checkLogLevel(S.Warning)&&this.log(S.Warning,this.format([t,...n]))}error(t,...n){if(this.checkLogLevel(S.Error))if(t instanceof Error){const l=Array.prototype.slice.call(arguments);l[0]=t.stack,this.log(S.Error,this.format(l))}else this.log(S.Error,this.format([t,...n]))}critical(t,...n){this.checkLogLevel(S.Critical)&&this.log(S.Critical,this.format([t,...n]))}flush(){}format(t){let n="";for(let l=0;l<t.length;l++){let a=t[l];if(typeof a=="object")try{a=JSON.stringify(a)}catch(s){}n+=(l>0?" ":"")+a}return n}}e.AbstractMessageLogger=i;class I extends C{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!A.isWindows}trace(t,...n){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...n):console.log(`[main ${D()}]`,t,...n))}debug(t,...n){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...n):console.log(`[main ${D()}]`,t,...n))}info(t,...n){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...n):console.log(`[main ${D()}]`,t,...n))}warn(t,...n){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${D()}][0m`,t,...n):console.warn(`[main ${D()}]`,t,...n))}error(t,...n){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${D()}][0m`,t,...n):console.error(`[main ${D()}]`,t,...n))}critical(t,...n){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${D()}][0m`,t,...n):console.error(`[main ${D()}]`,t,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class d extends C{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...n){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}e.ConsoleLogger=d;class f extends C{constructor(t,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:(0,y.toErrorMessage)(t,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=f;class r extends C{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const l of this.logServices)l.trace(t,...n)}debug(t,...n){for(const l of this.logServices)l.debug(t,...n)}info(t,...n){for(const l of this.logServices)l.info(t,...n)}warn(t,...n){for(const l of this.logServices)l.warn(t,...n)}error(t,...n){for(const l of this.logServices)l.error(t,...n)}critical(t,...n){for(const l of this.logServices)l.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=r;class o extends k.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}e.LogService=o;class p extends k.Disposable{constructor(t,n){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(l=>{this.logLevel=l,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(l))}))}createLogger(t,n){let l=this.loggers.get(t.toString());return l||(l=this.doCreateLogger(t,(n==null?void 0:n.always)?S.Trace:this.logLevel,n),this.loggers.set(t.toString(),l),(n==null?void 0:n.always)||this.logLevelChangeableLoggers.push(l)),l}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=p;class g{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(t){}getLevel(){return S.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}e.NullLogService=g;function E(w){if(w.verbose)return S.Trace;if(typeof w.logLevel=="string"){const t=m(w.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=E;function m(w){switch(w){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=m;function u(w){switch(w){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=u}),define(ve[90],be([0,1,4,127,47]),function(J,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(T=e.MarkerTag||(e.MarkerTag={}));var y;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function C(r,o){return o-r}S.compare=C;const i=Object.create(null);i[S.Error]=(0,k.localize)(0,null),i[S.Warning]=(0,k.localize)(1,null),i[S.Info]=(0,k.localize)(2,null);function I(r){return i[r]||""}S.toString=I;function d(r){switch(r){case A.default.Error:return S.Error;case A.default.Warning:return S.Warning;case A.default.Info:return S.Info;case A.default.Ignore:return S.Hint}}S.fromSeverity=d;function f(r){switch(r){case S.Error:return A.default.Error;case S.Warning:return A.default.Warning;case S.Info:return A.default.Info;case S.Hint:return A.default.Ignore}}S.toSeverity=f}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var D;(function(S){const C="";function i(d){return I(d,!0)}S.makeKey=i;function I(d,f){let r=[C];return d.source?r.push(d.source.replace("\xA6","\\\xA6")):r.push(C),d.code?typeof d.code=="string"?r.push(d.code.replace("\xA6","\\\xA6")):r.push(d.code.value.replace("\xA6","\\\xA6")):r.push(C),d.severity!==void 0&&d.severity!==null?r.push(y.toString(d.severity)):r.push(C),d.message&&f?r.push(d.message.replace("\xA6","\\\xA6")):r.push(C),d.startLineNumber!==void 0&&d.startLineNumber!==null?r.push(d.startLineNumber.toString()):r.push(C),d.startColumn!==void 0&&d.startColumn!==null?r.push(d.startColumn.toString()):r.push(C),d.endLineNumber!==void 0&&d.endLineNumber!==null?r.push(d.endLineNumber.toString()):r.push(C),d.endColumn!==void 0&&d.endColumn!==null?r.push(d.endColumn.toString()):r.push(C),r.push(C),r.join("\xA6")}S.makeKeyOptionalMessage=I})(D=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,_.createDecorator)("markerService")}),define(ve[152],be([0,1,47,4,3]),function(J,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=_.default,e.INotificationService=(0,k.createDecorator)("notificationService");var T;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.GLOBAL=1]="GLOBAL"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(C){C[C.OFF=0]="OFF",C[C.SILENT=1]="SILENT",C[C.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class D{constructor(){this.progress=new S,this.onDidClose=A.Event.None,this.onDidChangeVisibility=A.Event.None}updateSeverity(i){}updateMessage(i){}updateActions(i){}close(){}}e.NoOpNotification=D;class S{infinite(){}done(){}total(i){}worked(i){}}e.NoOpProgress=S});var je=this&&this.__decorate||function(J,e,_,k){var A=arguments.length,T=A<3?e:k===null?k=Object.getOwnPropertyDescriptor(e,_):k,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(J,e,_,k);else for(var D=J.length-1;D>=0;D--)(y=J[D])&&(T=(A<3?y(T):A>3?y(e,_,T):y(e,_))||T);return A>3&&T&&Object.defineProperty(e,_,T),T},Ke=this&&this.__param||function(J,e){return function(_,k){e(_,k,J)}};define(ve[153],be([0,1,4,20,6,11]),function(J,e,_,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,_.createDecorator)("progressService");var y;(function(i){i[i.Explorer=1]="Explorer",i[i.Scm=3]="Scm",i[i.Extensions=5]="Extensions",i[i.Window=10]="Window",i[i.Notification=15]="Notification",i[i.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class D{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=D,D.None=Object.freeze({report(){}});let S=class extends A.Disposable{constructor(I,d){super();this.deferred=new T.DeferredPromise,d.withProgress(I,f=>(this.reporter=f,this.lastStep&&f.report(this.lastStep),this.deferred.p)),this._register((0,A.toDisposable)(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};S=je([Ke(1,e.IProgressService)],S),e.UnmanagedProgress=S;class C extends A.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new A.DisposableStore)}start(I){this.stop();const d=++this.currentOperationId,f=new k.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{d===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add((0,A.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,A.toDisposable)(()=>f.cancel())),this.currentOperationDisposables.add((0,A.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:d,token:f.token,stop:()=>this.doStop(d),isCurrent:()=>this.currentOperationId===d}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=C,e.IEditorProgressService=(0,_.createDecorator)("editorProgressService")}),define(ve[29],be([0,1,10,42]),function(J,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class A{constructor(){this.data=new Map}add(y,D){k.ok(_.isString(y)),k.ok(_.isObject(D)),k.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,D)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}e.Registry=new A}),define(ve[91],be([0,1,29,3]),function(J,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function A(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class T{constructor(){this._onDidChangeSchema=new k.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,C){this.schemasById[A(S)]=C,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new T;_.Registry.add(e.Extensions.JSONContribution,y)}),define(ve[66],be([0,1,124,3,29,10,91]),function(J,e,_,k,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const S=A.Registry.as(y.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new k.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new k.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:_.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(g,E=!0){this.registerConfigurations([g],E)}registerConfigurations(g,E=!0){const m=[];g.forEach(u=>{m.push(...this.validateAndRegisterProperties(u,E,u.extensionInfo)),this.configurationContributors.push(u),this.registerJSONConfiguration(u)}),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(m)}deregisterConfigurations(g){const E=[],m=u=>{if(u.properties)for(const w in u.properties)E.push(w),delete this.configurationProperties[w],this.removeFromSchema(w,u.properties[w]);u.allOf&&u.allOf.forEach(w=>m(w))};for(const u of g){m(u);const w=this.configurationContributors.indexOf(u);w!==-1&&this.configurationContributors.splice(w,1)}S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}registerDefaultConfigurations(g){const E=[],m=[];for(const u of g)for(const w in u)if(E.push(w),e.OVERRIDE_PROPERTY_PATTERN.test(w)){this.defaultValues[w]=Object.assign(Object.assign({},this.defaultValues[w]||{}),u[w]);const t={type:"object",default:this.defaultValues[w],description:_.localize(1,null,w),$ref:e.resourceLanguageSettingsSchemaId};m.push(I(w)),this.configurationProperties[w]=t,this.defaultLanguageConfigurationOverridesNode.properties[w]=t}else{this.defaultValues[w]=u[w];const t=this.configurationProperties[w];t&&(this.updatePropertyDefaultValue(w,t),this.updateSchema(w,t))}this.registerOverrideIdentifiers(m),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}deregisterDefaultConfigurations(g){const E=[];for(const m of g)for(const u in m)if(E.push(u),delete this.defaultValues[u],e.OVERRIDE_PROPERTY_PATTERN.test(u))delete this.configurationProperties[u],delete this.defaultLanguageConfigurationOverridesNode.properties[u];else{const w=this.configurationProperties[u];w&&(this.updatePropertyDefaultValue(u,w),this.updateSchema(u,w))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}notifyConfigurationSchemaUpdated(...g){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(g){for(const E of g)this.overrideIdentifiers.add(E);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(g,E=!0,m,u=3){var w;u=T.isUndefinedOrNull(g.scope)?u:g.scope;let t=[],n=g.properties;if(n)for(let a in n){if(E&&r(a)){delete n[a];continue}const s=n[a];if(this.updatePropertyDefaultValue(a,s),e.OVERRIDE_PROPERTY_PATTERN.test(a)?s.scope=void 0:(s.scope=T.isUndefinedOrNull(s.scope)?u:s.scope,s.restricted=T.isUndefinedOrNull(s.restricted)?!!((w=m==null?void 0:m.restrictedConfigurations)===null||w===void 0?void 0:w.includes(a)):s.restricted),n[a].hasOwnProperty("included")&&!n[a].included){this.excludedConfigurationProperties[a]=n[a],delete n[a];continue}else this.configurationProperties[a]=n[a];!n[a].deprecationMessage&&n[a].markdownDeprecationMessage&&(n[a].deprecationMessage=n[a].markdownDeprecationMessage),t.push(a)}let l=g.allOf;if(l)for(let a of l)t.push(...this.validateAndRegisterProperties(a,E,m,u));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(g){const E=m=>{let u=m.properties;if(u)for(const t in u)this.updateSchema(t,u[t]);let w=m.allOf;w&&w.forEach(E)};E(g)}updateSchema(g,E){switch(e.allSettings.properties[g]=E,E.scope){case 1:e.applicationSettings.properties[g]=E;break;case 2:e.machineSettings.properties[g]=E;break;case 6:e.machineOverridableSettings.properties[g]=E;break;case 3:e.windowSettings.properties[g]=E;break;case 4:e.resourceSettings.properties[g]=E;break;case 5:e.resourceSettings.properties[g]=E,this.resourceLanguageSettingsSchema.properties[g]=E;break}}removeFromSchema(g,E){switch(delete e.allSettings.properties[g],E.scope){case 1:delete e.applicationSettings.properties[g];break;case 2:delete e.machineSettings.properties[g];break;case 6:delete e.machineOverridableSettings.properties[g];break;case 3:delete e.windowSettings.properties[g];break;case 4:case 5:delete e.resourceSettings.properties[g];break}}updateOverridePropertyPatternKey(){for(const g of this.overrideIdentifiers.values()){const E=`[${g}]`,m={type:"object",description:_.localize(2,null),errorMessage:_.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(E,m),e.allSettings.properties[E]=m,e.applicationSettings.properties[E]=m,e.machineSettings.properties[E]=m,e.machineOverridableSettings.properties[E]=m,e.windowSettings.properties[E]=m,e.resourceSettings.properties[E]=m}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(g,E){let m=this.defaultValues[g];T.isUndefined(m)&&(m=E.default),T.isUndefined(m)&&(m=d(E.type)),E.default=m}}const i="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(i);function I(p){return p.substring(1,p.length-1)}e.overrideIdentifierFromKey=I;function d(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const f=new C;A.Registry.add(e.Extensions.Configuration,f);function r(p){return p.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(p)?_.localize(5,null,p):f.getConfigurationProperties()[p]!==void 0?_.localize(6,null,p):null:_.localize(4,null)}e.validateProperty=r;function o(){const p=[],g=f.getConfigurationProperties();for(const E of Object.keys(g))p.push([E,g[E].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=o}),define(ve[92],be([0,1,23,10,2,29,4,66]),function(J,e,_,k,A,T,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function S(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof A.URI)}e.isConfigurationOverrides=S;var C;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(C=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function I(n,l){const a=l?n?l.keys.filter(R=>n.keys.indexOf(R)===-1):[...l.keys]:[],s=n?l?n.keys.filter(R=>l.keys.indexOf(R)===-1):[...n.keys]:[],c=[];if(l&&n){for(const R of n.keys)if(l.keys.indexOf(R)!==-1){const U=g(n.contents,R),K=g(l.contents,R);_.equals(U,K)||c.push(R)}}const v=[],P=R=>{const U={};for(const K of R)for(const he of K.identifiers)U[w(he)]=K;return U},h=l?P(l.overrides):{},b=n?P(n.overrides):{};if(Object.keys(h).length)for(const R of a){const U=h[R];U&&v.push([(0,D.overrideIdentifierFromKey)(R),U.keys])}if(Object.keys(b).length)for(const R of s){const U=b[R];U&&v.push([(0,D.overrideIdentifierFromKey)(R),U.keys])}if(Object.keys(h).length&&Object.keys(b).length)for(const R of c){const U=b[R],K=h[R];if(U&&K){const he=I({contents:U.contents,keys:U.keys,overrides:[]},{contents:K.contents,keys:K.keys,overrides:[]});v.push([(0,D.overrideIdentifierFromKey)(R),[...he.added,...he.removed,...he.updated]])}}return{added:a,removed:s,updated:c,overrides:v}}e.compare=I;function d(n,l){const a=[];for(const s of Object.keys(n))if(D.OVERRIDE_PROPERTY_PATTERN.test(s)){const c={};for(const v in n[s])c[v]=n[s][v];a.push({identifiers:[(0,D.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(c),contents:f(c,l)})}return a}e.toOverrides=d;function f(n,l){const a=Object.create(null);for(let s in n)r(a,s,n[s],l);return a}e.toValuesTree=f;function r(n,l,a,s){const c=l.split("."),v=c.pop();let P=n;for(let h=0;h<c.length;h++){let b=c[h],R=P[b];switch(typeof R){case"undefined":R=P[b]=Object.create(null);break;case"object":break;default:s(`Ignoring ${l} as ${c.slice(0,h+1).join(".")} is ${JSON.stringify(R)}`);return}P=R}if(typeof P=="object"&&P!==null)try{P[v]=a}catch(h){s(`Ignoring ${l} as ${c.join(".")} is ${JSON.stringify(P)}`)}else s(`Ignoring ${l} as ${c.join(".")} is ${JSON.stringify(P)}`)}e.addToValueTree=r;function o(n,l){const a=l.split(".");p(n,a)}e.removeFromValueTree=o;function p(n,l){const a=l.shift();if(l.length===0){delete n[a];return}if(Object.keys(n).indexOf(a)!==-1){const s=n[a];typeof s=="object"&&!Array.isArray(s)&&(p(s,l),Object.keys(s).length===0&&delete n[a])}}function g(n,l,a){function s(P,h){let b=P;for(const R of h){if(typeof b!="object"||b===null)return;b=b[R]}return b}const c=l.split("."),v=s(n,c);return typeof v=="undefined"?a:v}e.getConfigurationValue=g;function E(n,l,a){Object.keys(l).forEach(s=>{s!=="__proto__"&&(s in n?k.isObject(n[s])&&k.isObject(l[s])?E(n[s],l[s],a):a&&(n[s]=l[s]):n[s]=l[s])})}e.merge=E;function m(){const n=T.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}e.getConfigurationKeys=m;function u(){const n=Object.create(null),l=T.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(let a in l){let s=l[a].default;r(n,a,s,c=>console.error(`Conflict in default settings: ${c}`))}return n}e.getDefaultValues=u;function w(n){return`[${n}]`}e.keyFromOverrideIdentifier=w;function t(n,l,a){const s=n.inspect(l),c=n.inspect(a);return typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:s.defaultValue}e.getMigratedSettingValue=t}),define(ve[154],be([0,1,44,22,15,10,23,2,66,92,29,6,3]),function(J,e,_,k,A,T,y,D,S,C,i,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class f{constructor(t={},n=[],l=[]){this._contents=t,this._keys=n,this._overrides=l,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,C.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,n){const l=this.getContentsForOverrideIdentifer(n);return l?t?(0,C.getConfigurationValue)(l,t):l:void 0}getKeysForOverrideIdentifier(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.keys;return[]}override(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let l={};for(const a of A.distinct([...Object.keys(this.contents),...Object.keys(n)])){let s=this.contents[a],c=n[a];c&&(typeof s=="object"&&typeof c=="object"?(s=y.deepClone(s),this.mergeContents(s,c)):s=c),l[a]=s}return new f(l,this.keys,this.overrides)}merge(...t){const n=y.deepClone(this.contents),l=y.deepClone(this.overrides),a=[...this.keys];for(const s of t){this.mergeContents(n,s.contents);for(const c of s.overrides){const[v]=l.filter(P=>A.equals(P.identifiers,c.identifiers));v?this.mergeContents(v.contents,c.contents):l.push(y.deepClone(c))}for(const c of s.keys)a.indexOf(c)===-1&&a.push(c)}return new f(n,a,l)}freeze(){return this.isFrozen=!0,this}mergeContents(t,n){for(const l of Object.keys(n)){if(l in t&&T.isObject(t[l])&&T.isObject(n[l])){this.mergeContents(t[l],n[l]);continue}t[l]=y.deepClone(n[l])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?y.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),(0,C.addToValueTree)(this.contents,t,n,l=>{throw new Error(l)})}removeValue(t){this.removeKey(t)&&(0,C.removeFromValueTree)(this.contents,t)}addKey(t){let n=this.keys.length;for(let l=0;l<n;l++)t.indexOf(this.keys[l])===0&&(n=l);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=f;class r extends f{constructor(){const t=(0,C.getDefaultValues)(),n=(0,C.getConfigurationKeys)(),l=[];for(const a of Object.keys(t))S.OVERRIDE_PROPERTY_PATTERN.test(a)&&l.push({identifiers:[(0,S.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(t[a]),contents:(0,C.toValuesTree)(t[a],s=>console.error(`Conflict in default settings file: ${s}`))});super(t,n,l)}}e.DefaultConfigurationModel=r;class o{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,n){if(!T.isUndefinedOrNull(t)){const l=this.doParseContent(t);this.parseRaw(l,n)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,n){this._raw=t;const{contents:l,keys:a,overrides:s,restricted:c}=this.doParseRaw(t,n);this._configurationModel=new f(l,a,s),this._restrictedConfigurations=c||[]}doParseContent(t){let n={},l=null,a=[],s=[],c=[];function v(h){Array.isArray(a)?a.push(h):l&&(a[l]=h)}let P={onObjectBegin:()=>{let h={};v(h),s.push(a),a=h,l=null},onObjectProperty:h=>{l=h},onObjectEnd:()=>{a=s.pop()},onArrayBegin:()=>{let h=[];v(h),s.push(a),a=h,l=null},onArrayEnd:()=>{a=s.pop()},onLiteralValue:v,onError:(h,b,R)=>{c.push({error:h,offset:b,length:R})}};if(t)try{_.visit(t,P),n=a[0]||{}}catch(h){console.error(`Error while parsing settings file ${this._name}: ${h}`),this._parseErrors=[h]}return n}doParseRaw(t,n){const l=i.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),a=this.filter(t,l,!0,n);t=a.raw;const s=(0,C.toValuesTree)(t,P=>console.error(`Conflict in settings file ${this._name}: ${P}`)),c=Object.keys(t),v=(0,C.toOverrides)(t,P=>console.error(`Conflict in settings file ${this._name}: ${P}`));return{contents:s,keys:c,overrides:v,restricted:a.restricted}}filter(t,n,l,a){if(!(a==null?void 0:a.scopes)&&!(a==null?void 0:a.skipRestricted))return{raw:t,restricted:[]};const s={},c=[];for(let v in t)if(S.OVERRIDE_PROPERTY_PATTERN.test(v)&&l){const P=this.filter(t[v],n,!1,a);s[v]=P.raw,c.push(...P.restricted)}else{const P=n[v],h=P?typeof P.scope!="undefined"?P.scope:3:void 0;(P==null?void 0:P.restricted)&&c.push(v),(h===void 0||a.scopes===void 0||a.scopes.includes(h))&&(a.skipRestricted&&(P==null?void 0:P.restricted)||(s[v]=t[v]))}return{raw:s,restricted:c}}}e.ConfigurationModelParser=o;class p extends I.Disposable{constructor(t,n,l,a){super();this.userSettingsResource=t,this.scopes=n,this.fileService=a,this._onDidChange=this._register(new d.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new o(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(l.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(d.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new f}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class g{constructor(t,n,l=new f,a=new f,s=new k.ResourceMap,c=new f,v=new k.ResourceMap,P=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=l,this._workspaceConfiguration=a,this._folderConfigurations=s,this._memoryConfiguration=c,this._memoryConfigurationByResource=v,this._freeze=P,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(t,n,l){return this.getConsolidateConfigurationModel(n,l).getValue(t)}updateValue(t,n,l={}){let a;l.resource?(a=this._memoryConfigurationByResource.get(l.resource),a||(a=new f,this._memoryConfigurationByResource.set(l.resource,a))):a=this._memoryConfiguration,n===void 0?a.removeValue(t):a.setValue(t,n),l.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,l){const a=this.getConsolidateConfigurationModel(n,l),s=this.getFolderConfigurationModelForResource(n.resource,l),c=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,v=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),P=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),h=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),b=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),R=l?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,U=s?n.overrideIdentifier?s.freeze().override(n.overrideIdentifier).getValue(t):s.freeze().getValue(t):void 0,K=n.overrideIdentifier?c.override(n.overrideIdentifier).getValue(t):c.getValue(t),he=a.getValue(t),V=A.distinct(A.flatten(a.overrides.map(H=>H.identifiers))).filter(H=>a.getOverrideValue(t,H)!==void 0);return{defaultValue:v,userValue:P,userLocalValue:h,userRemoteValue:b,workspaceValue:R,workspaceFolderValue:U,memoryValue:K,value:he,default:v!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:P!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:h!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:b!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:U!==void 0?{value:s==null?void 0:s.freeze().getValue(t),override:n.overrideIdentifier?s==null?void 0:s.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:K!==void 0?{value:c.getValue(t),override:n.overrideIdentifier?c.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:V.length?V:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const l=n.filter(a=>S.OVERRIDE_PROPERTY_PATTERN.test(a)).map(a=>{const s=(0,S.overrideIdentifierFromKey)(a),c=this._defaultConfiguration.getKeysForOverrideIdentifier(s),v=t.getKeysForOverrideIdentifier(s),P=[...v.filter(h=>c.indexOf(h)===-1),...c.filter(h=>v.indexOf(h)===-1),...c.filter(h=>!y.equals(this._defaultConfiguration.override(s).getValue(h),t.override(s).getValue(h)))];return[s,P]});return this.updateDefaultConfiguration(t),{keys:n,overrides:l}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:l,removed:a,overrides:s}=(0,C.compare)(this.localUserConfiguration,t),c=[...n,...l,...a];return c.length&&this.updateLocalUserConfiguration(t),{keys:c,overrides:s}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:l,removed:a,overrides:s}=(0,C.compare)(this.remoteUserConfiguration,t);let c=[...n,...l,...a];return c.length&&this.updateRemoteUserConfiguration(t),{keys:c,overrides:s}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:l,removed:a,overrides:s}=(0,C.compare)(this.workspaceConfiguration,t);let c=[...n,...l,...a];return c.length&&this.updateWorkspaceConfiguration(t),{keys:c,overrides:s}}compareAndUpdateFolderConfiguration(t,n){const l=this.folderConfigurations.get(t),{added:a,updated:s,removed:c,overrides:v}=(0,C.compare)(l,n);let P=[...a,...s,...c];return(P.length||!l)&&this.updateFolderConfiguration(t,n),{keys:P,overrides:v}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:l,updated:a,removed:s,overrides:c}=(0,C.compare)(n,void 0);return{keys:[...l,...a,...s],overrides:c}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let l=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?l.override(t.overrideIdentifier):l}getConsolidatedConfigurationModelForResource({resource:t},n){let l=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const a=n.getFolder(t);a&&(l=this.getFolderConsolidatedConfiguration(a.uri)||l);const s=this._memoryConfigurationByResource.get(t);s&&(l=l.merge(s))}return l}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const l=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(t);a?(n=l.merge(a),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=l}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const l=n.getFolder(t);if(l)return this._folderConfigurations.get(l.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:l,overrides:a,keys:s}=this._folderConfigurations.get(n);return t.push([n,{contents:l,overrides:a,keys:s}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(l=>t.add(l))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(l=>n.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(l=>n.add(l)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(l=>n.add(l)),this._folderConfigurations.forEach(l=>l.getKeysForOverrideIdentifier(t).forEach(a=>n.add(a))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),l=this.parseConfigurationModel(t.user),a=this.parseConfigurationModel(t.workspace),s=t.folders.reduce((c,v)=>(c.set(D.URI.revive(v[0]),this.parseConfigurationModel(v[1])),c),new k.ResourceMap);return new g(n,l,new f,a,s,new f,new k.ResourceMap,!1)}static parseConfigurationModel(t){return new f(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=g;function E(...w){if(w.length===0)return{keys:[],overrides:[]};if(w.length===1)return w[0];const t=new Set,n=new Map;for(const a of w)a.keys.forEach(s=>t.add(s)),a.overrides.forEach(([s,c])=>{const v=(0,k.getOrSet)(n,s,new Set);c.forEach(P=>v.add(P))});const l=[];return n.forEach((a,s)=>l.push([s,[...a.values()]])),{keys:[...t.values()],overrides:l}}e.mergeChanges=E;class m{constructor(t,n,l,a){this.change=t,this.previous=n,this.currentConfiguraiton=l,this.currentWorkspace=a,this._previousConfiguration=void 0;const s=new Set;t.keys.forEach(v=>s.add(v)),t.overrides.forEach(([,v])=>v.forEach(P=>s.add(P))),this.affectedKeys=[...s.values()];const c=new f;this.affectedKeys.forEach(v=>c.setValue(v,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=g.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){var l;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const a=this.previousConfiguration?this.previousConfiguration.getValue(t,n,(l=this.previous)===null||l===void 0?void 0:l.workspace):void 0,s=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!y.equals(a,s)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let l=(0,C.toValuesTree)({[n]:!0},()=>{}),a;for(;typeof l=="object"&&(a=Object.keys(l)[0]);){if(t=t[a],!t)return!1;l=l[a]}return!0}}e.ConfigurationChangeEvent=m;class u extends m{constructor(t,n,l,a){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=l,this.sourceConfig=a}}e.AllKeysConfigurationChangeEvent=u}),define(ve[67],be([0,1,4]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.RemoteTrustOption=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,_.createDecorator)("remoteAuthorityResolverService");var k;(function(y){y[y.Unknown=0]="Unknown",y[y.DisableTrust=1]="DisableTrust",y[y.MachineTrusted=2]="MachineTrusted"})(k=e.RemoteTrustOption||(e.RemoteTrustOption={}));var A;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(A=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class T extends Error{constructor(D,S=A.Unknown,C){super(D);this._message=D,this._code=S,this._detail=C,this.isHandled=S===A.NotAvailable&&C===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,T.prototype)}static isTemporarilyNotAvailable(D){return D instanceof T&&D._code===A.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof T&&D._code===A.NoResolverFound}static isHandled(D){return D instanceof T&&D.isHandled}}e.RemoteAuthorityResolverError=T}),define(ve[93],be([0,1,19]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function k(S){return S.scheme===_.Schemas.vscodeRemote?S.authority:void 0}e.getRemoteAuthority=k;function A(S){if(!!S){const C=S.indexOf("+");return C<0?S:S.substr(0,C)}}e.getRemoteName=A;function T(S){return S.scheme!==_.Schemas.file&&S.scheme!==_.Schemas.vscodeRemote}function y(S){if(S.folders.length)return S.folders.every(C=>T(C.uri))?S.folders[0].uri:void 0;if(S.configuration&&T(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=y;function D(S){var C;return(C=y(S))===null||C===void 0?void 0:C.scheme}e.getVirtualWorkspaceScheme=D}),define(ve[155],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class _{constructor(A){this._callback=A,this._terminalBufferMap=new Map}dispose(){for(const A of this._terminalBufferMap.values())A.dispose()}startBuffering(A,T,y=5){let D;return D=T(S=>{const C=typeof S=="string"?S:S.data;let i=this._terminalBufferMap.get(A);if(i){i.data.push(C);return}const I=setTimeout(()=>this.flushBuffer(A),y);i={data:[C],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(A),D.dispose()}},this._terminalBufferMap.set(A,i)}),D}stopBuffering(A){const T=this._terminalBufferMap.get(A);T&&T.dispose()}flushBuffer(A){const T=this._terminalBufferMap.get(A);T&&(this._terminalBufferMap.delete(A),this._callback(A,T.data.join("")))}}e.TerminalDataBufferer=_}),define(ve[156],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var _;(function(k){k.DARK="dark",k.LIGHT="light",k.HIGH_CONTRAST="hc"})(_=e.ColorScheme||(e.ColorScheme={}))}),define(ve[157],be([0,1,4,6,29,3,156,36]),function(J,e,_,k,A,T,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,_.createDecorator)("themeService");var S;(function(p){function g(E){return E&&typeof E=="object"&&typeof E.id=="string"}p.isThemeColor=g})(S=e.ThemeColor||(e.ThemeColor={}));function C(p){return{id:p}}e.themeColorFromId=C;var i;(function(p){function g(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||S.isThemeColor(t.color))}p.isThemeIcon=g;const E=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function m(t){const n=E.exec(t);if(!!n){let[,l]=n;return{id:l}}}p.fromString=m;function u(t,n){let l=t.id;const a=l.lastIndexOf("~");return a!==-1&&(l=l.substring(0,a)),n&&(l=`${l}~${n}`),{id:l}}p.modify=u;function w(t,n){var l,a;return t.id===n.id&&((l=t.color)===null||l===void 0?void 0:l.id)===((a=n.color)===null||a===void 0?void 0:a.id)}p.isEqual=w,p.asClassNameArray=D.CSSIcon.asClassNameArray,p.asClassName=D.CSSIcon.asClassName,p.asCSSSelector=D.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function I(p){switch(p){case y.ColorScheme.DARK:return"vs-dark";case y.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class d{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new T.Emitter}onColorThemeChange(g){return this.themingParticipants.push(g),this.onThemingParticipantAddedEmitter.fire(g),(0,k.toDisposable)(()=>{const E=this.themingParticipants.indexOf(g);this.themingParticipants.splice(E,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let f=new d;A.Registry.add(e.Extensions.ThemingContribution,f);function r(p){return f.onColorThemeChange(p)}e.registerThemingParticipant=r;class o extends k.Disposable{constructor(g){super();this.themeService=g,this.theme=g.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(E=>this.onThemeChange(E)))}onThemeChange(g){this.theme=g,this.updateStyles()}updateStyles(){}getColor(g,E){let m=this.theme.getColor(g);return m&&E&&(m=E(m,this.theme)),m?m.toString():null}}e.Themable=o}),define(ve[158],be([0,1,29,157,3,128,91,11,36]),function(J,e,_,k,A,T,y,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class C{constructor(){this._onDidChange=new A.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,T.localize)(0,null)},fontCharacter:{type:"string",description:(0,T.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${S.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(g,E,m,u){const w=this.iconsById[g];if(w){if(m&&!w.description){w.description=m,this.iconSchema.properties[g].markdownDescription=`${m} $(${g})`;const l=this.iconReferenceSchema.enum.indexOf(g);l!==-1&&(this.iconReferenceSchema.enumDescriptions[l]=m),this._onDidChange.fire()}return w}let t={id:g,description:m,defaults:E,deprecationMessage:u};this.iconsById[g]=t;let n={$ref:"#/definitions/icons"};return u&&(n.deprecationMessage=u),m&&(n.markdownDescription=`${m}: $(${g})`),this.iconSchema.properties[g]=n,this.iconReferenceSchema.enum.push(g),this.iconReferenceSchema.enumDescriptions.push(m||""),this._onDidChange.fire(),{id:g}}deregisterIcon(g){delete this.iconsById[g],delete this.iconSchema.properties[g];const E=this.iconReferenceSchema.enum.indexOf(g);E!==-1&&(this.iconReferenceSchema.enum.splice(E,1),this.iconReferenceSchema.enumDescriptions.splice(E,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(g=>this.iconsById[g])}getIcon(g){return this.iconsById[g]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(g,E){const m=this.iconFontsById[g];if(m)return m;let u={id:g,definition:E};return this.iconFontsById[g]=u,this._onDidChange.fire(),u}deregisterIconFont(g){delete this.iconFontsById[g]}getIconFonts(){return Object.keys(this.iconFontsById).map(g=>this.iconFontsById[g])}getIconFont(g){return this.iconFontsById[g]}toString(){const g=(w,t)=>w.id.localeCompare(t.id),E=w=>{for(;k.ThemeIcon.isThemeIcon(w.defaults);)w=this.iconsById[w.defaults.id];return`codicon codicon-${w?w.id:""}`};let m=[];m.push("| preview     | identifier                        | default codicon ID                | description"),m.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const u=Object.keys(this.iconsById).map(w=>this.iconsById[w]);for(const w of u.filter(t=>!!t.description).sort(g))m.push(`|<i class="${E(w)}"></i>|${w.id}|${k.ThemeIcon.isThemeIcon(w.defaults)?w.defaults.id:w.id}|${w.description||""}|`);m.push("| preview     | identifier                        "),m.push("| ----------- | --------------------------------- |");for(const w of u.filter(t=>!k.ThemeIcon.isThemeIcon(t.defaults)).sort(g))m.push(`|<i class="${E(w)}"></i>|${w.id}|`);return m.join(`
`)}}const i=new C;_.Registry.add(e.Extensions.IconContribution,i);function I(p,g,E,m){return i.registerIcon(p,g,E,m)}e.registerIcon=I;function d(){return i}e.getIconRegistry=d;function f(){for(const p of S.iconRegistry.all)i.registerIcon(p.id,p.definition,p.description);S.iconRegistry.onDidRegister(p=>i.registerIcon(p.id,p.definition,p.description))}f(),e.iconsSchemaId="vscode://schemas/icons";let r=_.Registry.as(y.Extensions.JSONContribution);r.registerSchema(e.iconsSchemaId,i.getIconSchema());const o=new D.RunOnceScheduler(()=>r.notifySchemaChanged(e.iconsSchemaId),200);i.onDidChange(()=>{o.isScheduled()||o.schedule()}),e.widgetClose=I("widget-close",S.Codicon.close,(0,T.localize)(2,null)),e.gotoPreviousLocation=I("goto-previous-location",S.Codicon.arrowUp,(0,T.localize)(3,null)),e.gotoNextLocation=I("goto-next-location",S.Codicon.arrowDown,(0,T.localize)(4,null)),e.syncing=k.ThemeIcon.modify(S.Codicon.sync,"spin")}),define(ve[48],be([0,1,2,25,4,22]),function(J,e,_,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");var y;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function D(d){const f=d;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=D;function S(d){const f=d;return!!(f&&typeof f=="object"&&_.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=S;class C{constructor(f,r,o,p){this._id=f,this._configuration=o,this._ignorePathCasing=p,this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=r}update(f){this._id=f.id,this._configuration=f.configuration,this._ignorePathCasing=f._ignorePathCasing,this.folders=f.folders}get folders(){return this._folders}set folders(f){this._folders=f,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(f){this._configuration=f}getFolder(f){return f&&this._foldersMap.findSubstr(f.with({scheme:f.scheme,authority:f.authority,path:f.path}))||null}updateFoldersMap(){this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing);for(const f of this.folders)this._foldersMap.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=C;class i{constructor(f,r){this.raw=r,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return(0,k.joinPath)(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function I(d){return new i({uri:d,index:0,name:(0,k.basenameOrAuthority)(d)},{uri:d.toString()})}e.toWorkspaceFolder=I}),define(ve[159],be([0,1,4,129,48,2,21,13,25,107,44,19,58,37,93]),function(J,e,_,k,A,T,y,D,S,C,i,I,d,f,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const o=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,k.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function p(Y){return(typeof Y=="string"?(0,D.extname)(Y):(0,S.extname)(Y))===o}e.hasWorkspaceFileExtension=p,e.IWorkspacesService=(0,_.createDecorator)("workspacesService");function g(Y){return Y.hasOwnProperty("workspace")}e.isRecentWorkspace=g;function E(Y){return Y.hasOwnProperty("folderUri")}e.isRecentFolder=E;function m(Y){return Y.hasOwnProperty("fileUri")}e.isRecentFile=m;function u(Y){const W=Y;return typeof(W==null?void 0:W.id)=="string"&&T.URI.isUri(W.uri)}e.isSingleFolderWorkspaceIdentifier=u;function w(Y){if(Y.configuration)return{id:Y.id,configPath:Y.configuration};if(Y.folders.length===1)return{id:Y.id,uri:Y.folders[0].uri}}e.toWorkspaceIdentifier=w;function t(Y){const W=Y;return typeof(W==null?void 0:W.id)=="string"&&T.URI.isUri(W.configPath)}e.isWorkspaceIdentifier=t;function n(Y){const W=Y;if(W==null?void 0:W.uri)return{id:W.id,uri:T.URI.revive(W.uri)};const F=Y;if(F==null?void 0:F.configPath)return{id:F.id,configPath:T.URI.revive(F.configPath)};if(Y==null?void 0:Y.id)return{id:Y.id}}e.reviveIdentifier=n;function l(Y,W){return S.extUriBiasedIgnorePathCase.isEqualOrParent(Y,W.untitledWorkspacesHome)}e.isUntitledWorkspace=l;function a(Y){return s(Y)||c(Y)}e.isStoredWorkspaceFolder=a;function s(Y){const W=Y;return typeof(W==null?void 0:W.path)=="string"&&(!W.name||typeof W.name=="string")}e.isRawFileWorkspaceFolder=s;function c(Y){const W=Y;return typeof(W==null?void 0:W.uri)=="string"&&(!W.name||typeof W.name=="string")}e.isRawUriWorkspaceFolder=c;function v(Y,W,F,L,M=!y.isWindows,x){if(Y.scheme!==L.scheme)return{name:F,uri:Y.toString(!0)};let G=W?void 0:x.relativePath(L,Y);if(G!==void 0)G.length===0?G=".":y.isWindows&&Y.scheme===I.Schemas.file&&!M&&(G=G.replace(/\//g,"\\"));else if(Y.scheme===I.Schemas.file)G=Y.fsPath,y.isWindows&&(G=(0,d.normalizeDriveLetter)(G),M&&(G=(0,f.toSlashes)(G)));else{if(!x.isEqualAuthority(Y.authority,L.authority))return{name:F,uri:Y.toString(!0)};G=Y.path}return{name:F,path:G}}e.getStoredWorkspaceFolder=v;function P(Y,W,F){let L=[],M=new Set;const x=F.dirname(W);for(let G of Y){let X;if(s(G))G.path&&(X=F.resolvePath(x,G.path));else if(c(G))try{X=T.URI.parse(G.uri),X.path[0]!=="/"&&(X=X.with({path:"/"+X.path}))}catch(ne){console.warn(ne)}if(X){let ne=F.getComparisonKey(X);if(!M.has(ne)){M.add(ne);const me=G.name||F.basenameOrAuthority(X);L.push(new A.WorkspaceFolder({uri:X,name:me,index:L.length},G))}}}return L}e.toWorkspaceFolders=P;function h(Y,W,F,L,M){let x=b(W,Y);const G=M.dirname(W),X=M.dirname(L),ne=[],me=R(x.folders);for(const ze of x.folders){const $=s(ze)?M.resolvePath(G,ze.path):T.URI.parse(ze.uri);let j;F?j=!1:j=!s(ze)||(0,D.isAbsolute)(ze.path),ne.push(v($,j,ze.name,X,me,M))}const Le={insertSpaces:!1,tabSize:4,eol:y.isLinux||y.isMacintosh?`
`:`\r
`},We=C.setProperty(Y,["folders"],ne,Le);let Fe=C.applyEdits(Y,We);return x.remoteAuthority===(0,r.getRemoteAuthority)(L)&&(Fe=C.applyEdits(Fe,C.removeProperty(Fe,["remoteAuthority"],Le))),Fe}e.rewriteWorkspaceFileForNewLocation=h;function b(Y,W){let F=i.parse(W);if(F&&Array.isArray(F.folders))F.folders=F.folders.filter(L=>a(L));else throw new Error(`${Y} looks like an invalid workspace file.`);return F}function R(Y){return y.isWindows?Y.some(W=>s(W)&&W.path.indexOf("/")>=0):!0}e.useSlashForPath=R;function U(Y){return Y.workspace&&typeof Y.workspace=="object"&&typeof Y.workspace.id=="string"&&typeof Y.workspace.configPath=="string"}function K(Y){return typeof Y.folderUri=="string"}function he(Y){return typeof Y.fileUri=="string"}function V(Y,W){const F={workspaces:[],files:[]};if(Y){const L=function(x,G){for(let X=0;X<x.length;X++)try{G(x[X],X)}catch(ne){W.warn(`Error restoring recent entry ${JSON.stringify(x[X])}: ${ne.toString()}. Skip entry.`)}},M=Y;if(Array.isArray(M.entries))L(M.entries,x=>{const G=x.label,X=x.remoteAuthority;U(x)?F.workspaces.push({label:G,remoteAuthority:X,workspace:{id:x.workspace.id,configPath:T.URI.parse(x.workspace.configPath)}}):K(x)?F.workspaces.push({label:G,remoteAuthority:X,folderUri:T.URI.parse(x.folderUri)}):he(x)&&F.files.push({label:G,remoteAuthority:X,fileUri:T.URI.parse(x.fileUri)})});else{const x=Y;Array.isArray(x.workspaces3)&&L(x.workspaces3,(G,X)=>{const ne=Array.isArray(x.workspaceLabels)&&x.workspaceLabels[X]||void 0;typeof G=="object"&&typeof G.id=="string"&&typeof G.configURIPath=="string"?F.workspaces.push({label:ne,workspace:{id:G.id,configPath:T.URI.parse(G.configURIPath)}}):typeof G=="string"&&F.workspaces.push({label:ne,folderUri:T.URI.parse(G)})}),Array.isArray(x.files2)&&L(x.files2,(G,X)=>{const ne=Array.isArray(x.fileLabels)&&x.fileLabels[X]||void 0;typeof G=="string"&&F.files.push({label:ne,fileUri:T.URI.parse(G)})})}}return F}e.restoreRecentlyOpened=V;function H(Y){const W={entries:[]};for(const F of Y.workspaces)E(F)?W.entries.push({folderUri:F.folderUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority}):W.entries.push({workspace:{id:F.workspace.id,configPath:F.workspace.configPath.toString()},label:F.label,remoteAuthority:F.remoteAuthority});for(const F of Y.files)W.entries.push({fileUri:F.fileUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority});return W}e.toStoreData=H}),define(ve[68],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class _{constructor(A){this.id=A,this._data=new Map,this._idPool=1}add(A){const T=this._idPool++;return this._data.set(T,A),this.logDebugInfo(),T}get(A,T){return this._data.has(A)?this._data.get(A)[T]:void 0}delete(A){this._data.delete(A),this.logDebugInfo()}logDebugInfo(){!_.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=_,_.enableDebugLogging=!1}),define(ve[160],be([0,1,2,3]),function(J,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class A{constructor(){this._onDidChangeTabs=new k.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(y){this._tabs=y.map(D=>({name:D.name,group:D.group,resource:_.URI.revive(D.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=A}),define(ve[49],be([0,1,19,4]),function(J,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(_.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(y,D){D===null?this._providerInfo.delete(y):this._providerInfo.set(y,D)}isFreeScheme(y){return!this._providerInfo.has(y)&&!this._systemSchemes.has(y)}getCapabilities(y){return this._providerInfo.get(y)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,k.createDecorator)("IExtHostFileSystemInfo")}),define(ve[27],be([0,1,4]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,_.createDecorator)("IExtHostInitDataService")}),define(ve[161],be([0,1,11]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class k{constructor(y,D,S){this._deferredPromises=new Map,this._id=y,this._shared=D,this._storage=S,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(C=>(this._value=C,this)),this._storageListener=this._storage.onDidChangeStorage(C=>{C.shared===this._shared&&C.key===this._id&&(this._value=C.value)}),this._scheduler=new _.RunOnceScheduler(()=>{const C=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const i of C.values())i.complete()}catch(i){for(const I of C.values())I.error(i)}})()},0)}get whenReady(){return this._init}get(y,D){let S=this._value[y];return typeof S=="undefined"&&(S=D),S}update(y,D){this._value[y]=D;let S=this._deferredPromises.get(y);if(S!==void 0)return S.p;const C=new _.DeferredPromise;return this._deferredPromises.set(y,C),this._scheduler.isScheduled()||this._scheduler.schedule(),C.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=k;class A extends k{constructor(y,D){super(y.identifier.value,!0,D);this._extension=y}setKeysForSync(y){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},y)}}e.ExtensionGlobalMemento=A}),define(ve[14],be([0,1,4]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,_.createDecorator)("IExtHostRpcService");class k{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=k});var it=this&&this.__classPrivateFieldSet||function(J,e,_,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!A:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(J,_):A?A.value=_:e.set(J,_),_},Ue=this&&this.__classPrivateFieldGet||function(J,e,_,k){if(_==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?k:_==="a"?k.call(J):k?k.value:e.get(J)};define(ve[162],be([0,1,26,3]),function(J,e,_,k){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{constructor(D,S){A.set(this,void 0),this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this._id=_.ExtensionIdentifier.toKey(D.identifier),it(this,A,S,"f"),Ue(this,A,"f").onDidChangePassword(C=>{C.extensionId===this._id&&this._onDidChange.fire({key:C.key})})}get(D){return Ue(this,A,"f").get(this._id,D)}store(D,S){return Ue(this,A,"f").store(this._id,D,S)}delete(D){return Ue(this,A,"f").delete(this._id,D)}}e.ExtensionSecrets=T,A=new WeakMap}),define(ve[94],be([0,1,4,3]),function(J,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class A{constructor(){this._onDidChangeTelemetryEnabled=new k.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(y){this._enabled=y}$onDidChangeTelemetryEnabled(y){this._enabled=y,this._onDidChangeTelemetryEnabled.fire(y)}}e.ExtHostTelemetry=A,e.IExtHostTelemetry=(0,_.createDecorator)("IExtHostTelemetry")}),define(ve[69],be([0,1,3]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var k;(function(y){y[y.NewChild=0]="NewChild",y[y.Disposed=1]="Disposed",y[y.Invalidated=2]="Invalidated",y[y.SetProp=3]="SetProp"})(k=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const A=new WeakMap,T=y=>{let D=A.get(y);return D||(D={children:new Map,bus:new _.Emitter},A.set(y,D)),D};e.getPrivateApiFor=T}),define(ve[70],be([0,1,4,3,14]),function(J,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var T;(function(D){function S(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public}}D.fromApiTunnel=S;function C(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.public}}D.fromServiceTunnel=C})(T=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,_.createDecorator)("IExtHostTunnelService");let y=class{constructor(S){this.onDidChangeTunnels=new k.Emitter().event}async $applyCandidateFilter(S){return S}async openTunnel(S,C){}async getTunnels(){return[]}async setTunnelExtensionFunctions(S){return{dispose:()=>{}}}registerPortsAttributesProvider(S,C){return{dispose:()=>{}}}async $providePortAttributes(S,C,i,I,d){return[]}async $forwardPort(S,C){}async $closeTunnel(S){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};y=je([Ke(0,A.IExtHostRpcService)],y),e.ExtHostTunnelService=y});var it=this&&this.__classPrivateFieldSet||function(J,e,_,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!A:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(J,_):A?A.value=_:e.set(J,_),_},Ue=this&&this.__classPrivateFieldGet||function(J,e,_,k){if(_==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?k:_==="a"?k.call(J):k?k.value:e.get(J)},Qt=this&&this.__rest||function(J,e){var _={};for(var k in J)Object.prototype.hasOwnProperty.call(J,k)&&e.indexOf(k)<0&&(_[k]=J[k]);if(J!=null&&typeof Object.getOwnPropertySymbols=="function")for(var A=0,k=Object.getOwnPropertySymbols(J);A<k.length;A++)e.indexOf(k[A])<0&&Object.prototype.propertyIsEnumerable.call(J,k[A])&&(_[k[A]]=J[k[A]]);return _};define(ve[7],be([0,1,15,12,83,22,8,10,2,31,64,67,69]),function(J,e,_,k,A,T,y,D,S,C,i,I,d){"use strict";var f,r,o,p,g,E,m,u,w,t,n,l,a,s,c,v;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelPreload=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function P(B){function O(){return Reflect.construct(B,arguments,this.constructor)}return Object.defineProperty(O,"name",Object.getOwnPropertyDescriptor(B,"name")),Object.setPrototypeOf(O,B),Object.setPrototypeOf(O.prototype,B.prototype),O}let h=o=class{constructor(O){f.set(this,void 0),it(this,f,O,"f")}static from(...O){let ie=O;return new o(function(){if(ie){for(const Se of ie)Se&&typeof Se.dispose=="function"&&Se.dispose();ie=void 0}})}dispose(){typeof Ue(this,f,"f")=="function"&&(Ue(this,f,"f").call(this),it(this,f,void 0,"f"))}};f=new WeakMap,h=o=je([P],h),e.Disposable=h;let b=p=class{constructor(O,ie){if(O<0)throw(0,k.illegalArgument)("line must be non-negative");if(ie<0)throw(0,k.illegalArgument)("character must be non-negative");this._line=O,this._character=ie}static Min(...O){if(O.length===0)throw new TypeError;let ie=O[0];for(let Se=1;Se<O.length;Se++){const Ge=O[Se];Ge.isBefore(ie)&&(ie=Ge)}return ie}static Max(...O){if(O.length===0)throw new TypeError;let ie=O[0];for(let Se=1;Se<O.length;Se++){const Ge=O[Se];Ge.isAfter(ie)&&(ie=Ge)}return ie}static isPosition(O){if(!O)return!1;if(O instanceof p)return!0;let{line:ie,character:Se}=O;return typeof ie=="number"&&typeof Se=="number"}get line(){return this._line}get character(){return this._character}isBefore(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<O._character}isBeforeOrEqual(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<=O._character}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this._line===O._line&&this._character===O._character}compareTo(O){return this._line<O._line?-1:this._line>O.line?1:this._character<O._character?-1:this._character>O._character?1:0}translate(O,ie=0){if(O===null||ie===null)throw(0,k.illegalArgument)();let Se;return typeof O=="undefined"?Se=0:typeof O=="number"?Se=O:(Se=typeof O.lineDelta=="number"?O.lineDelta:0,ie=typeof O.characterDelta=="number"?O.characterDelta:0),Se===0&&ie===0?this:new p(this.line+Se,this.character+ie)}with(O,ie=this.character){if(O===null||ie===null)throw(0,k.illegalArgument)();let Se;return typeof O=="undefined"?Se=this.line:typeof O=="number"?Se=O:(Se=typeof O.line=="number"?O.line:this.line,ie=typeof O.character=="number"?O.character:this.character),Se===this.line&&ie===this.character?this:new p(Se,ie)}toJSON(){return{line:this.line,character:this.character}}};b=p=je([P],b),e.Position=b;let R=g=class{constructor(O,ie,Se,Ge){let nt,ot;if(typeof O=="number"&&typeof ie=="number"&&typeof Se=="number"&&typeof Ge=="number"?(nt=new b(O,ie),ot=new b(Se,Ge)):O instanceof b&&ie instanceof b&&(nt=O,ot=ie),!nt||!ot)throw new Error("Invalid arguments");nt.isBefore(ot)?(this._start=nt,this._end=ot):(this._start=ot,this._end=nt)}static isRange(O){return O instanceof g?!0:O?b.isPosition(O.start)&&b.isPosition(O.end):!1}get start(){return this._start}get end(){return this._end}contains(O){return O instanceof g?this.contains(O._start)&&this.contains(O._end):O instanceof b?!(O.isBefore(this._start)||this._end.isBefore(O)):!1}isEqual(O){return this._start.isEqual(O._start)&&this._end.isEqual(O._end)}intersection(O){const ie=b.Max(O.start,this._start),Se=b.Min(O.end,this._end);if(!ie.isAfter(Se))return new g(ie,Se)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const ie=b.Min(O.start,this._start),Se=b.Max(O.end,this.end);return new g(ie,Se)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(O,ie=this.end){if(O===null||ie===null)throw(0,k.illegalArgument)();let Se;return O?b.isPosition(O)?Se=O:(Se=O.start||this.start,ie=O.end||this.end):Se=this.start,Se.isEqual(this._start)&&ie.isEqual(this.end)?this:new g(Se,ie)}toJSON(){return[this.start,this.end]}};R=g=je([P],R),e.Range=R;let U=E=class extends R{constructor(O,ie,Se,Ge){let nt,ot;if(typeof O=="number"&&typeof ie=="number"&&typeof Se=="number"&&typeof Ge=="number"?(nt=new b(O,ie),ot=new b(Se,Ge)):O instanceof b&&ie instanceof b&&(nt=O,ot=ie),!nt||!ot)throw new Error("Invalid arguments");super(nt,ot);this._anchor=nt,this._active=ot}static isSelection(O){return O instanceof E?!0:O?R.isRange(O)&&b.isPosition(O.anchor)&&b.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};U=E=je([P],U),e.Selection=U;class K{constructor(O,ie,Se){if(typeof O!="string"||O.length===0)throw(0,k.illegalArgument)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,k.illegalArgument)("port");if(typeof Se!="undefined"&&(typeof Se!="string"||Se.length===0||!/^[0-9A-Za-z\-]+$/.test(Se)))throw(0,k.illegalArgument)("connectionToken");this.host=O,this.port=Math.round(ie),this.connectionToken=Se}}e.ResolvedAuthority=K;class he extends Error{constructor(O,ie=I.RemoteAuthorityResolverErrorCode.Unknown,Se){super(O);this._message=O,this._code=ie,this._detail=Se,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,he.prototype)}static NotAvailable(O,ie){return new he(O,I.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(O){return new he(O,I.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=he;var V;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(V=e.EndOfLine||(e.EndOfLine={}));var H;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(H=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let Y=m=class{constructor(O,ie){this._range=O,this._newText=ie}static isTextEdit(O){return O instanceof m?!0:O?R.isRange(O)&&typeof O.newText=="string":!1}static replace(O,ie){return new m(O,ie)}static insert(O,ie){return m.replace(new R(O,O),ie)}static delete(O){return m.replace(O,"")}static setEndOfLine(O){const ie=new m(new R(new b(0,0),new b(0,0)),"");return ie.newEol=O,ie}get range(){return this._range}set range(O){if(O&&!R.isRange(O))throw(0,k.illegalArgument)("range");this._range=O}get newText(){return this._newText||""}set newText(O){if(O&&typeof O!="string")throw(0,k.illegalArgument)("newText");this._newText=O}get newEol(){return this._newEol}set newEol(O){if(O&&typeof O!="number")throw(0,k.illegalArgument)("newEol");this._newEol=O}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};Y=m=je([P],Y),e.TextEdit=Y;var W;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellOutput=4]="CellOutput",B[B.CellReplace=5]="CellReplace",B[B.CellOutputItem=6]="CellOutputItem"})(W=e.FileEditType||(e.FileEditType={}));let F=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(O,ie,Se,Ge){this._edits.push({_type:1,from:O,to:ie,options:Se,metadata:Ge})}createFile(O,ie,Se){this._edits.push({_type:1,from:void 0,to:O,options:ie,metadata:Se})}deleteFile(O,ie,Se){this._edits.push({_type:1,from:O,to:void 0,options:ie,metadata:Se})}replaceNotebookMetadata(O,ie,Se){this._edits.push({_type:3,metadata:Se,uri:O,edit:{editType:5,metadata:ie},notebookMetadata:ie})}replaceNotebookCells(O,ie,Se,Ge,nt){let ot,dt,yt=[],Ct;if($t.isNotebookRange(ie)&&Lt.isNotebookCellDataArray(Se)&&!Lt.isNotebookCellDataArray(Ge)?(ot=ie.start,dt=ie.end,yt=Se,Ct=Ge):typeof ie=="number"&&typeof Se=="number"&&Lt.isNotebookCellDataArray(Ge)&&(ot=ie,dt=Se,yt=Ge,Ct=nt),ot===void 0||dt===void 0)throw new Error("Invalid arguments");(ot!==dt||yt.length>0)&&this._edits.push({_type:5,uri:O,index:ot,count:dt-ot,cells:yt,metadata:Ct})}replaceNotebookCellMetadata(O,ie,Se,Ge){this._edits.push({_type:3,metadata:Ge,uri:O,edit:{editType:8,index:ie,metadata:Se}})}replace(O,ie,Se,Ge){this._edits.push({_type:2,uri:O,edit:new Y(ie,Se),metadata:Ge})}insert(O,ie,Se,Ge){this.replace(O,new R(ie,ie),Se,Ge)}delete(O,ie,Se){this.replace(O,ie,"",Se)}has(O){return this._edits.some(ie=>ie._type===2&&ie.uri.toString()===O.toString())}set(O,ie){if(ie)for(const Se of ie)Se&&this._edits.push({_type:2,uri:O,edit:Se});else{for(let Se=0;Se<this._edits.length;Se++){const Ge=this._edits[Se];Ge._type===2&&Ge.uri.toString()===O.toString()&&(this._edits[Se]=void 0)}(0,_.coalesceInPlace)(this._edits)}}get(O){const ie=[];for(let Se of this._edits)Se._type===2&&Se.uri.toString()===O.toString()&&ie.push(Se.edit);return ie}entries(){const O=new T.ResourceMap;for(let ie of this._edits)if(ie._type===2){let Se=O.get(ie.uri);Se||(Se=[ie.uri,[]],O.set(ie.uri,Se)),Se[1].push(ie.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};F=je([P],F),e.WorkspaceEdit=F;let L=u=class{constructor(O){this._tabstop=1,this.value=O||""}static isSnippetString(O){return O instanceof u?!0:O?typeof O.value=="string":!1}static _escape(O){return O.replace(/\$|}|\\/g,"\\$&")}appendText(O){return this.value+=u._escape(O),this}appendTabstop(O=this._tabstop++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,ie=this._tabstop++){if(typeof O=="function"){const Se=new u;Se._tabstop=this._tabstop,O(Se),this._tabstop=Se._tabstop,O=Se.value}else O=u._escape(O);return this.value+="${",this.value+=ie,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,ie=this._tabstop++){const Se=O.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(O,ie){if(typeof ie=="function"){const Se=new u;Se._tabstop=this._tabstop,ie(Se),this._tabstop=Se._tabstop,ie=Se.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};L=u=je([P],L),e.SnippetString=L;var M;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(M=e.DiagnosticTag||(e.DiagnosticTag={}));var x;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(x=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let G=w=class{constructor(O,ie){if(this.uri=O,ie)if(ie instanceof R)this.range=ie;else if(ie instanceof b)this.range=new R(ie,ie);else throw new Error("Illegal argument")}static isLocation(O){return O instanceof w?!0:O?R.isRange(O.range)&&S.URI.isUri(O.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};G=w=je([P],G),e.Location=G;let X=class{constructor(O,ie){this.location=O,this.message=ie}static is(O){return O?typeof O.message=="string"&&O.location&&R.isRange(O.location.range)&&S.URI.isUri(O.location.uri):!1}static isEqual(O,ie){return O===ie?!0:!O||!ie?!1:O.message===ie.message&&O.location.range.isEqual(ie.location.range)&&O.location.uri.toString()===ie.location.uri.toString()}};X=je([P],X),e.DiagnosticRelatedInformation=X;let ne=class{constructor(O,ie,Se=x.Error){if(!R.isRange(O))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=O,this.message=ie,this.severity=Se}toJSON(){return{severity:x[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,ie){return O===ie?!0:!O||!ie?!1:O.message===ie.message&&O.severity===ie.severity&&O.code===ie.code&&O.severity===ie.severity&&O.source===ie.source&&O.range.isEqual(ie.range)&&(0,_.equals)(O.tags,ie.tags)&&(0,_.equals)(O.relatedInformation,ie.relatedInformation,X.isEqual)}};ne=je([P],ne),e.Diagnostic=ne;let me=class{constructor(O,ie){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:(0,A.isMarkdownString)(O)?this.contents=[O]:this.contents=[O],this.range=ie}};me=je([P],me),e.Hover=me;var Le;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(Le=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let We=class{constructor(O,ie=Le.Text){this.range=O,this.kind=ie}toJSON(){return{range:this.range,kind:Le[this.kind]}}};We=je([P],We),e.DocumentHighlight=We;var Fe;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(Fe=e.SymbolKind||(e.SymbolKind={}));var ze;(function(B){B[B.Deprecated=1]="Deprecated"})(ze=e.SymbolTag||(e.SymbolTag={}));let $=t=class{constructor(O,ie,Se,Ge,nt){this.name=O,this.kind=ie,this.containerName=nt,typeof Se=="string"&&(this.containerName=Se),Ge instanceof G?this.location=Ge:Se instanceof R&&(this.location=new G(Ge,Se)),t.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Fe[this.kind],location:this.location,containerName:this.containerName}}};$=t=je([P],$),e.SymbolInformation=$;let j=n=class{constructor(O,ie,Se,Ge,nt){this.name=O,this.detail=ie,this.kind=Se,this.range=Ge,this.selectionRange=nt,this.children=[],n.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children&&O.children.forEach(n.validate)}};j=n=je([P],j),e.DocumentSymbol=j;var te;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(te=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let oe=class{constructor(O,ie){this.title=O,this.kind=ie}};oe=je([P],oe),e.CodeAction=oe;let de=l=class{constructor(O){this.value=O}append(O){return new l(this.value?this.value+l.sep+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+l.sep)}};de.sep=".",de=l=je([P],de),e.CodeActionKind=de,de.Empty=new de(""),de.QuickFix=de.Empty.append("quickfix"),de.Refactor=de.Empty.append("refactor"),de.RefactorExtract=de.Refactor.append("extract"),de.RefactorInline=de.Refactor.append("inline"),de.RefactorRewrite=de.Refactor.append("rewrite"),de.Source=de.Empty.append("source"),de.SourceOrganizeImports=de.Source.append("organizeImports"),de.SourceFixAll=de.Source.append("fixAll");let _e=class{constructor(O,ie){if(this.range=O,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};_e=je([P],_e),e.SelectionRange=_e;class Be{constructor(O,ie,Se,Ge,nt,ot){this.kind=O,this.name=ie,this.detail=Se,this.uri=Ge,this.range=nt,this.selectionRange=ot}}e.CallHierarchyItem=Be;class fe{constructor(O,ie){this.fromRanges=ie,this.from=O}}e.CallHierarchyIncomingCall=fe;class De{constructor(O,ie){this.fromRanges=ie,this.to=O}}e.CallHierarchyOutgoingCall=De;let Re=class{constructor(O,ie){this.range=O,this.command=ie}get isResolved(){return!!this.command}};Re=je([P],Re),e.CodeLens=Re;let He=a=class{constructor(O,ie=!1){r.set(this,void 0),it(this,r,new A.MarkdownString(O,{supportThemeIcons:ie}),"f")}static isMarkdownString(O){return O instanceof a?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}get value(){return Ue(this,r,"f").value}set value(O){Ue(this,r,"f").value=O}get isTrusted(){return Ue(this,r,"f").isTrusted}set isTrusted(O){Ue(this,r,"f").isTrusted=O}get supportThemeIcons(){return Ue(this,r,"f").supportThemeIcons}appendText(O){return Ue(this,r,"f").appendText(O),this}appendMarkdown(O){return Ue(this,r,"f").appendMarkdown(O),this}appendCodeblock(O,ie){return Ue(this,r,"f").appendCodeblock(ie!=null?ie:"",O),this}};r=new WeakMap,He=a=je([P],He),e.MarkdownString=He;let we=class{constructor(O,ie){this.label=O,this.documentation=ie}};we=je([P],we),e.ParameterInformation=we;let qe=class{constructor(O,ie){this.label=O,this.documentation=ie,this.parameters=[]}};qe=je([P],qe),e.SignatureInformation=qe;let z=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};z=je([P],z),e.SignatureHelp=z;var ee;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(ee=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var ge;(function(B){B[B.Other=0]="Other",B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(ge=e.InlayHintKind||(e.InlayHintKind={}));let Ne=class{constructor(O,ie,Se){this.text=O,this.position=ie,this.kind=Se}};Ne=je([P],Ne),e.InlayHint=Ne;var Ve;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ve=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var $e;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})($e=e.CompletionItemKind||(e.CompletionItemKind={}));var Ze;(function(B){B[B.Deprecated=1]="Deprecated"})(Ze=e.CompletionItemTag||(e.CompletionItemTag={}));let ye=class{constructor(O,ie){this.label=O,this.kind=ie}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&$e[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ye=je([P],ye),e.CompletionItem=ye;let Ee=class{constructor(O=[],ie=!1){this.items=O,this.isIncomplete=ie}};Ee=je([P],Ee),e.CompletionList=Ee;var Ce;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(Ce=e.ViewColumn||(e.ViewColumn={}));var re;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(re=e.StatusBarAlignment||(e.StatusBarAlignment={}));var le;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative"})(le=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var N;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(N=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Q;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Q=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ae;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(ae=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ke;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(ke=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(B){function O(ie){switch(ie){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=O}(ae=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ie=class{constructor(O,ie){if(ie&&!S.URI.isUri(ie))throw(0,k.illegalArgument)("target");if(!R.isRange(O)||O.isEmpty)throw(0,k.illegalArgument)("range");this.range=O,this.target=ie}};Ie=je([P],Ie),e.DocumentLink=Ie;let Ae=class{constructor(O,ie,Se,Ge){this.red=O,this.green=ie,this.blue=Se,this.alpha=Ge}};Ae=je([P],Ae),e.Color=Ae;let xe=class{constructor(O,ie){if(ie&&!(ie instanceof Ae))throw(0,k.illegalArgument)("color");if(!R.isRange(O)||O.isEmpty)throw(0,k.illegalArgument)("range");this.range=O,this.color=ie}};xe=je([P],xe),e.ColorInformation=xe;let Ye=class{constructor(O){if(!O||typeof O!="string")throw(0,k.illegalArgument)("label");this.label=O}};Ye=je([P],Ye),e.ColorPresentation=Ye;var rt;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(rt=e.ColorFormat||(e.ColorFormat={}));var tt;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(tt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Qe;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(Qe=e.TaskRevealKind||(e.TaskRevealKind={}));var mt;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(mt=e.TaskPanelKind||(e.TaskPanelKind={}));let bt=s=class{constructor(O,ie){if(typeof O!="string"||typeof ie!="string")throw(0,k.illegalArgument)("name");this._id=O}static from(O){switch(O){case"clean":return s.Clean;case"build":return s.Build;case"rebuild":return s.Rebuild;case"test":return s.Test;default:return}}get id(){return this._id}};bt.Clean=new s("clean","Clean"),bt.Build=new s("build","Build"),bt.Rebuild=new s("rebuild","Rebuild"),bt.Test=new s("test","Test"),bt=s=je([P],bt),e.TaskGroup=bt;function pe(B){let O="";for(let ie=0;ie<B.length;ie++)O+=B[ie].replace(/,/g,",,")+",";return O}let ce=class{constructor(O,ie,Se){if(typeof O!="string")throw(0,k.illegalArgument)("process");this._args=[],this._process=O,ie!==void 0&&(Array.isArray(ie)?(this._args=ie,this._options=Se):this._options=ie)}get process(){return this._process}set process(O){if(typeof O!="string")throw(0,k.illegalArgument)("process");this._process=O}get args(){return this._args}set args(O){Array.isArray(O)||(O=[]),this._args=O}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("process"),this._process!==void 0&&O.push(this._process),this._args&&this._args.length>0)for(let ie of this._args)O.push(ie);return pe(O)}};ce=je([P],ce),e.ProcessExecution=ce;let se=class{constructor(O,ie,Se){if(this._args=[],Array.isArray(ie)){if(!O)throw(0,k.illegalArgument)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,k.illegalArgument)("command");this._command=O,this._args=ie,this._options=Se}else{if(typeof O!="string")throw(0,k.illegalArgument)("commandLine");this._commandLine=O,this._options=ie}}get commandLine(){return this._commandLine}set commandLine(O){if(typeof O!="string")throw(0,k.illegalArgument)("commandLine");this._commandLine=O}get command(){return this._command?this._command:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,k.illegalArgument)("command");this._command=O}get args(){return this._args}set args(O){this._args=O||[]}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("shell"),this._commandLine!==void 0&&O.push(this._commandLine),this._command!==void 0&&O.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ie of this._args)O.push(typeof ie=="string"?ie:ie.value);return pe(O)}};se=je([P],se),e.ShellExecution=se;var q;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(q=e.ShellQuoting||(e.ShellQuoting={}));var Me;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(Me=e.TaskScope||(e.TaskScope={}));class Te{constructor(O){this._callback=O}computeId(){return"customExecution"+(0,C.generateUuid)()}set callback(O){this._callback=O}get callback(){return this._callback}}e.CustomExecution=Te;let Je=c=class{constructor(O,ie,Se,Ge,nt,ot){this.__deprecated=!1,this._definition=this.definition=O;let dt;typeof ie=="string"?(this._name=this.name=ie,this._source=this.source=Se,this.execution=Ge,dt=nt,this.__deprecated=!0):ie===Me.Global||ie===Me.Workspace?(this.target=ie,this._name=this.name=Se,this._source=this.source=Ge,this.execution=nt,dt=ot):(this.target=ie,this._name=this.name=Se,this._source=this.source=Ge,this.execution=nt,dt=ot),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(O){this.__id=O}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof ce?this._definition={type:c.ProcessType,id:this._execution.computeId()}:this._execution instanceof se?this._definition={type:c.ShellType,id:this._execution.computeId()}:this._execution instanceof Te?this._definition={type:c.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:c.EmptyType,id:(0,C.generateUuid)()}}get definition(){return this._definition}set definition(O){if(O==null)throw(0,k.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=O}get scope(){return this._scope}set target(O){this.clear(),this._scope=O}get name(){return this._name}set name(O){if(typeof O!="string")throw(0,k.illegalArgument)("name");this.clear(),this._name=O}get execution(){return this._execution}set execution(O){O===null&&(O=void 0),this.clear(),this._execution=O;const ie=this._definition.type;(c.EmptyType===ie||c.ProcessType===ie||c.ShellType===ie||c.ExtensionCallbackType===ie)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(O){if(Array.isArray(O))this.clear(),this._problemMatchers=O,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.clear(),this._isBackground=O}get source(){return this._source}set source(O){if(typeof O!="string"||O.length===0)throw(0,k.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=O}get group(){return this._group}set group(O){O===null&&(O=void 0),this.clear(),this._group=O}get detail(){return this._detail}set detail(O){O===null&&(O=void 0),this._detail=O}get presentationOptions(){return this._presentationOptions}set presentationOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._presentationOptions=O}get runOptions(){return this._runOptions}set runOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._runOptions=O}};Je.ExtensionCallbackType="customExecution",Je.ProcessType="process",Je.ShellType="shell",Je.EmptyType="$empty",Je=c=je([P],Je),e.Task=Je;var et;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(et=e.ProgressLocation||(e.ProgressLocation={}));let ct=class{constructor(O,ie=ht.None){this.collapsibleState=ie,S.URI.isUri(O)?this.resourceUri=O:this.label=O}};ct=je([P],ct),e.TreeItem=ct;var ht;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(ht=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Xe=class{constructor(O,ie){this.id=O,this.color=ie}};Xe=je([P],Xe),e.ThemeIcon=Xe,Xe.File=new Xe("file"),Xe.Folder=new Xe("folder");let at=class{constructor(O){this.id=O}};at=je([P],at),e.ThemeColor=at;var ft;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(ft=e.ConfigurationTarget||(e.ConfigurationTarget={}));let lt=class{constructor(O,ie){if(typeof O!="string"&&(!O||!S.URI.isUri(O)&&!S.URI.isUri(O.uri)))throw(0,k.illegalArgument)("base");if(typeof ie!="string")throw(0,k.illegalArgument)("pattern");typeof O=="string"?(this.baseFolder=S.URI.file(O),this.base=O):S.URI.isUri(O)?(this.baseFolder=O,this.base=O.fsPath):(this.baseFolder=O.uri,this.base=O.uri.fsPath),this.pattern=ie}};lt=je([P],lt),e.RelativePattern=lt;let Et=class{constructor(O,ie,Se,Ge){this.enabled=typeof O=="boolean"?O:!0,typeof ie=="string"&&(this.condition=ie),typeof Se=="string"&&(this.hitCondition=Se),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=(0,C.generateUuid)()),this._id}};Et=je([P],Et),e.Breakpoint=Et;let vt=class extends Et{constructor(O,ie,Se,Ge,nt){super(ie,Se,Ge,nt);if(O===null)throw(0,k.illegalArgument)("location");this.location=O}};vt=je([P],vt),e.SourceBreakpoint=vt;let kt=class extends Et{constructor(O,ie,Se,Ge,nt){super(ie,Se,Ge,nt);this.functionName=O}};kt=je([P],kt),e.FunctionBreakpoint=kt;let At=class extends Et{constructor(O,ie,Se,Ge,nt,ot,dt){super(Ge,nt,ot,dt);if(!ie)throw(0,k.illegalArgument)("dataId");this.label=O,this.dataId=ie,this.canPersist=Se}};At=je([P],At),e.DataBreakpoint=At;let Tt=class{constructor(O,ie,Se){this.command=O,this.args=ie||[],this.options=Se}};Tt=je([P],Tt),e.DebugAdapterExecutable=Tt;let _t=class{constructor(O,ie){this.port=O,this.host=ie}};_t=je([P],_t),e.DebugAdapterServer=_t;let Yt=class{constructor(O){this.path=O}};Yt=je([P],Yt),e.DebugAdapterNamedPipeServer=Yt;let Jt=class{constructor(O){this.implementation=O}};Jt=je([P],Jt),e.DebugAdapterInlineImplementation=Jt;let gt=class{constructor(O,ie){this.range=O,this.expression=ie}};gt=je([P],gt),e.EvaluatableExpression=gt;let Xt=class{constructor(O,ie){this.range=O,this.text=ie}};Xt=je([P],Xt),e.InlineValueText=Xt;let St=class{constructor(O,ie,Se=!0){this.range=O,this.variableName=ie,this.caseSensitiveLookup=Se}};St=je([P],St),e.InlineValueVariableLookup=St;let jt=class{constructor(O,ie){this.range=O,this.expression=ie}};jt=je([P],jt),e.InlineValueEvaluatableExpression=jt;let Zt=class{constructor(O,ie){this.frameId=O,this.stoppedLocation=ie}};Zt=je([P],Zt),e.InlineValueContext=Zt;var qt;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(qt=e.FileChangeType||(e.FileChangeType={}));let ut=v=class extends Error{constructor(O,ie=i.FileSystemProviderErrorCode.Unknown,Se){var Ge;super(S.URI.isUri(O)?O.toString(!0):O);this.code=(Ge=Se==null?void 0:Se.name)!==null&&Ge!==void 0?Ge:"Unknown",(0,i.markAsFileSystemProviderError)(this,ie),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,v.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}static FileExists(O){return new v(O,i.FileSystemProviderErrorCode.FileExists,v.FileExists)}static FileNotFound(O){return new v(O,i.FileSystemProviderErrorCode.FileNotFound,v.FileNotFound)}static FileNotADirectory(O){return new v(O,i.FileSystemProviderErrorCode.FileNotADirectory,v.FileNotADirectory)}static FileIsADirectory(O){return new v(O,i.FileSystemProviderErrorCode.FileIsADirectory,v.FileIsADirectory)}static NoPermissions(O){return new v(O,i.FileSystemProviderErrorCode.NoPermissions,v.NoPermissions)}static Unavailable(O){return new v(O,i.FileSystemProviderErrorCode.Unavailable,v.Unavailable)}};ut=v=je([P],ut),e.FileSystemError=ut;let en=class{constructor(O,ie,Se){this.start=O,this.end=ie,this.kind=Se}};en=je([P],en),e.FoldingRange=en;var Rt;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Rt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var xt;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(xt=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var dn;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(dn=e.CommentMode||(e.CommentMode={}));class _n{constructor(O,ie=[]){this.tokenTypes=O,this.tokenModifiers=ie}}e.SemanticTokensLegend=_n;function hn(B){return typeof B=="undefined"||(0,D.isStringArray)(B)}class tn{constructor(O){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,O){this._hasLegend=!0;for(let ie=0,Se=O.tokenTypes.length;ie<Se;ie++)this._tokenTypeStrToInt.set(O.tokenTypes[ie],ie);for(let ie=0,Se=O.tokenModifiers.length;ie<Se;ie++)this._tokenModifierStrToInt.set(O.tokenModifiers[ie],ie)}}push(O,ie,Se,Ge,nt){if(typeof O=="number"&&typeof ie=="number"&&typeof Se=="number"&&typeof Ge=="number"&&(typeof nt=="number"||typeof nt=="undefined"))return typeof nt=="undefined"&&(nt=0),this._pushEncoded(O,ie,Se,Ge,nt);if(R.isRange(O)&&typeof ie=="string"&&hn(Se))return this._push(O,ie,Se);throw(0,k.illegalArgument)()}_push(O,ie,Se){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ie))throw new Error("`tokenType` is not in the provided legend");const Ge=O.start.line,nt=O.start.character,ot=O.end.character-O.start.character,dt=this._tokenTypeStrToInt.get(ie);let yt=0;if(Se)for(const Ct of Se){if(!this._tokenModifierStrToInt.has(Ct))throw new Error("`tokenModifier` is not in the provided legend");const It=this._tokenModifierStrToInt.get(Ct);yt|=1<<It>>>0}this._pushEncoded(Ge,nt,ot,dt,yt)}_pushEncoded(O,ie,Se,Ge,nt){if(this._dataIsSortedAndDeltaEncoded&&(O<this._prevLine||O===this._prevLine&&ie<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let Ct=0,It=0;for(let Pt=0;Pt<yt;Pt++){let Mt=this._data[5*Pt],un=this._data[5*Pt+1];Mt===0?(Mt=Ct,un+=It):Mt+=Ct,this._data[5*Pt]=Mt,this._data[5*Pt+1]=un,Ct=Mt,It=un}}let ot=O,dt=ie;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ot-=this._prevLine,ot===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=ot,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=Se,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=nt,this._prevLine=O,this._prevChar=ie}static _sortAndDeltaEncode(O){let ie=[];const Se=O.length/5|0;for(let dt=0;dt<Se;dt++)ie[dt]=dt;ie.sort((dt,yt)=>{const Ct=O[5*dt],It=O[5*yt];if(Ct===It){const Pt=O[5*dt+1],Mt=O[5*yt+1];return Pt-Mt}return Ct-It});const Ge=new Uint32Array(O.length);let nt=0,ot=0;for(let dt=0;dt<Se;dt++){const yt=5*ie[dt],Ct=O[yt+0],It=O[yt+1],Pt=O[yt+2],Mt=O[yt+3],un=O[yt+4],Tn=Ct-nt,Mn=Tn===0?It-ot:It,cn=5*dt;Ge[cn+0]=Tn,Ge[cn+1]=Mn,Ge[cn+2]=Pt,Ge[cn+3]=Mt,Ge[cn+4]=un,nt=Ct,ot=It}return Ge}build(O){return this._dataIsSortedAndDeltaEncoded?new Kt(new Uint32Array(this._data),O):new Kt(tn._sortAndDeltaEncode(this._data),O)}}e.SemanticTokensBuilder=tn;class Kt{constructor(O,ie){this.resultId=ie,this.data=O}}e.SemanticTokens=Kt;class Nt{constructor(O,ie,Se){this.start=O,this.deleteCount=ie,this.data=Se}}e.SemanticTokensEdit=Nt;class En{constructor(O,ie){this.resultId=ie,this.edits=O}}e.SemanticTokensEdits=En;var nn;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(nn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var rn;(function(B){B[B.Initial=1]="Initial",B[B.Dynamic=2]="Dynamic"})(rn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Gt=class{constructor(){}};Gt.Back={iconPath:new Xe("arrow-left")},Gt=je([P],Gt),e.QuickInputButtons=Gt;var yn;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(yn=e.ExtensionKind||(e.ExtensionKind={}));class Ft{constructor(O,ie,Se){this.badge=O,this.tooltip=ie,this.color=Se}static validate(O){if(O.badge&&O.badge.length!==1&&O.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Ft;let sn=class{constructor(O){this.kind=O}};sn=je([P],sn),e.ColorTheme=sn;var Sn;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast"})(Sn=e.ColorThemeKind||(e.ColorThemeKind={}));class $t{constructor(O,ie){if(O<0)throw(0,k.illegalArgument)("start must be positive");if(ie<0)throw(0,k.illegalArgument)("end must be positive");O<=ie?(this._start=O,this._end=ie):(this._start=ie,this._end=O)}static isNotebookRange(O){return O instanceof $t?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(O){let ie=this._start,Se=this._end;return O.start!==void 0&&(ie=O.start),O.end!==void 0&&(Se=O.end),ie===this._start&&Se===this._end?this:new $t(ie,Se)}}e.NotebookRange=$t;class on{constructor(O,ie){typeof O=="object"?Object.assign(this,O):(this.inputCollapsed=O,this.outputCollapsed=ie)}with(O){let{inputCollapsed:ie,outputCollapsed:Se}=O,Ge=Qt(O,["inputCollapsed","outputCollapsed"]);return ie===void 0?ie=this.inputCollapsed:ie===null&&(ie=void 0),Se===void 0?Se=this.outputCollapsed:Se===null&&(Se=void 0),ie===this.inputCollapsed&&Se===this.outputCollapsed&&Object.keys(Ge).length===0?this:new on(Object.assign({inputCollapsed:ie,outputCollapsed:Se},Ge))}}e.NotebookCellMetadata=on;class Ut{constructor(O={}){Object.assign(this,O)}with(O){return new Ut(O)}}e.NotebookDocumentMetadata=Ut;class Lt{constructor(O,ie,Se,Ge,nt,ot){this.kind=O,this.source=ie,this.language=Se,this.outputs=Ge!=null?Ge:[],this.metadata=nt,this.latestExecutionSummary=ot}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(ie=>Lt.isNotebookCellData(ie))}static isNotebookCellData(O){return!0}}e.NotebookCellData=Lt;class fn{constructor(O,ie){this.cells=O,this.metadata=ie!=null?ie:new Ut}}e.NotebookData=fn;class Wt{constructor(O,ie,Se){if(this.mime=O,this.value=ie,this.metadata=Se,(0,y.isFalsyOrWhitespace)(this.mime))throw new Error("INVALID mime type, must not be empty or falsy")}static isNotebookCellOutputItem(O){return O instanceof Wt}}e.NotebookCellOutputItem=Wt;class Oe{constructor(O,ie,Se){this.outputs=O,typeof ie=="string"?(this.id=ie,this.metadata=Se):(this.id=(0,C.generateUuid)(),this.metadata=ie!=null?ie:Se)}}e.NotebookCellOutput=Oe;var an;(function(B){B[B.Markdown=1]="Markdown",B[B.Code=2]="Code"})(an=e.NotebookCellKind||(e.NotebookCellKind={}));var ln;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(ln=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var pt;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(pt=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Dn;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Dn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Cn{constructor(O,ie,Se,Ge,nt,ot){this.text=O,this.alignment=ie,this.command=Se,this.tooltip=Ge,this.priority=nt,this.accessibilityInformation=ot}}e.NotebookCellStatusBarItem=Cn;var mn;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(mn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class gn{constructor(O,ie=[]){this.uri=O,this.provides=typeof ie=="string"?[ie]:ie}}e.NotebookKernelPreload=gn;let Ht=class{constructor(O,ie){this.label=O,this.timestamp=ie}};Ht=je([P],Ht),e.TimelineItem=Ht;var kn;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(kn=e.ExtensionMode||(e.ExtensionMode={}));var In;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(In=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Pn;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=4]="RegEx"})(Pn=e.StandardTokenType||(e.StandardTokenType={}));class pn{constructor(O,ie){this.ranges=O,this.wordPattern=ie}}e.LinkedEditingRanges=pn;var An;(function(B){B[B.Unset=0]="Unset",B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(An=e.TestResultState||(e.TestResultState={}));var vn;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information",B[B.Hint=3]="Hint"})(vn=e.TestMessageSeverity||(e.TestMessageSeverity={}));var bn;(function(B){B[B.Pending=0]="Pending",B[B.Resolved=1]="Resolved"})(bn=e.TestItemStatus||(e.TestItemStatus={}));const Bt=(B,O,ie,Se)=>{let Ge=ie;return{enumerable:!0,configurable:!1,get(){return Ge},set(nt){Se(Ge,nt)||(Ge=nt,B.bus.fire([3,O,nt]))}}},zt=(B,O)=>B===O,Z=(B,O)=>B===O?!0:!B||!O?!1:B.isEqual(O);class ue{constructor(O,ie,Se,Ge){this.label=ie,this.data=Ge;const nt=(0,d.getPrivateApiFor)(this);Object.defineProperties(this,{id:{value:O,enumerable:!0,writable:!1},uri:{value:Se,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>nt.parent},children:{value:new T.ReadonlyMapView(nt.children),enumerable:!0,writable:!1},range:Bt(nt,"range",void 0,Z),description:Bt(nt,"description",void 0,zt),runnable:Bt(nt,"runnable",!0,zt),debuggable:Bt(nt,"debuggable",!1,zt),status:Bt(nt,"status",bn.Resolved,zt),error:Bt(nt,"error",void 0,zt)})}invalidate(){(0,d.getPrivateApiFor)(this).bus.fire([2])}dispose(){const O=(0,d.getPrivateApiFor)(this);O.parent&&(0,d.getPrivateApiFor)(O.parent).children.delete(this.id),O.bus.fire([1])}addChild(O){if(!(O instanceof ue))throw new Error("Test child must be created through vscode.test.createTestItem()");const ie=(0,d.getPrivateApiFor)(this);if(ie.children.has(O.id))throw new Error(`Attempted to insert a duplicate test item ID ${O.id}`);ie.children.set(O.id,O),ie.bus.fire([0,O])}}e.TestItemImpl=ue;class Pe{constructor(O){this.message=O,this.severity=vn.Error}static diff(O,ie,Se){const Ge=new Pe(O);return Ge.expectedOutput=ie,Ge.actualOutput=Se,Ge}}e.TestMessage=Pe;var st;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(st=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var wt;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(wt=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Dt;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore"})(Dt=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(ve[95],be([0,1,42,19,8,120,86,7,15]),function(J,e,_,k,A,T,y,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const C=new Map;function i(r,o){o?C.set(r,o):C.delete(r)}e.setWordDefinitionFor=i;function I(r){return C.get(r)}e.getWordDefinitionFor=I;class d extends T.MirrorTextModel{constructor(o,p,g,E,m,u,w,t){super(p,g,E,m);this._proxy=o,this._languageId=u,this._isDirty=w,this._notebook=t,this._isDisposed=!1}dispose(){(0,_.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(o){return(0,S.equals)(this._lines,o)}get document(){if(!this._document){const o=this;this._document={get uri(){return o._uri},get fileName(){return o._uri.fsPath},get isUntitled(){return o._uri.scheme===k.Schemas.untitled},get languageId(){return o._languageId},get version(){return o._versionId},get isClosed(){return o._isDisposed},get isDirty(){return o._isDirty},get notebook(){return o._notebook},save(){return o._save()},getText(p){return p?o._getTextInRange(p):o.getText()},get eol(){return o._eol===`
`?D.EndOfLine.LF:D.EndOfLine.CRLF},get lineCount(){return o._lines.length},lineAt(p){return o._lineAt(p)},offsetAt(p){return o._offsetAt(p)},positionAt(p){return o._positionAt(p)},validateRange(p){return o._validateRange(p)},validatePosition(p){return o._validatePosition(p)},getWordRangeAtPosition(p,g){return o._getWordRangeAtPosition(p,g)}}}return Object.freeze(this._document)}_acceptLanguageId(o){(0,_.ok)(!this._isDisposed),this._languageId=o}_acceptIsDirty(o){(0,_.ok)(!this._isDisposed),this._isDirty=o}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(o){const p=this._validateRange(o);if(p.isEmpty)return"";if(p.isSingleLine)return this._lines[p.start.line].substring(p.start.character,p.end.character);const g=this._eol,E=p.start.line,m=p.end.line,u=[];u.push(this._lines[E].substring(p.start.character));for(let w=E+1;w<m;w++)u.push(this._lines[w]);return u.push(this._lines[m].substring(0,p.end.character)),u.join(g)}_lineAt(o){let p;if(o instanceof D.Position?p=o.line:typeof o=="number"&&(p=o),typeof p!="number"||p<0||p>=this._lines.length||Math.floor(p)!==p)throw new Error("Illegal value for `line`");return new f(p,this._lines[p],p===this._lines.length-1)}_offsetAt(o){return o=this._validatePosition(o),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(o.line-1)+o.character}_positionAt(o){o=Math.floor(o),o=Math.max(0,o),this._ensureLineStarts();const p=this._lineStarts.getIndexOf(o),g=this._lines[p.index].length;return new D.Position(p.index,Math.min(p.remainder,g))}_validateRange(o){if(!(o instanceof D.Range))throw new Error("Invalid argument");const p=this._validatePosition(o.start),g=this._validatePosition(o.end);return p===o.start&&g===o.end?o:new D.Range(p.line,p.character,g.line,g.character)}_validatePosition(o){if(!(o instanceof D.Position))throw new Error("Invalid argument");if(this._lines.length===0)return o.with(0,0);let{line:p,character:g}=o,E=!1;if(p<0)p=0,g=0,E=!0;else if(p>=this._lines.length)p=this._lines.length-1,g=this._lines[p].length,E=!0;else{const m=this._lines[p].length;g<0?(g=0,E=!0):g>m&&(g=m,E=!0)}return E?new D.Position(p,g):o}_getWordRangeAtPosition(o,p){const g=this._validatePosition(o);if(!p)p=I(this._languageId);else if((0,A.regExpLeadsToEndlessLoop)(p))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${p.source}' because it matches the empty string.`);const E=(0,y.getWordAtText)(g.character+1,(0,y.ensureValidWordDefinition)(p),this._lines[g.line],0);if(E)return new D.Range(g.line,E.startColumn-1,g.line,E.endColumn-1)}}e.ExtHostDocumentData=d;class f{constructor(o,p,g){this._line=o,this._text=p,this._isLastLine=g}get lineNumber(){return this._line}get text(){return this._text}get range(){return new D.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new D.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=f}),define(ve[163],be([0,1,7,3,88,6,59,22,2,31]),function(J,e,_,k,A,T,y,D,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class i{constructor(d,f,r,o){this._notebook=r,this._selector=o,this._disposables=new T.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this.uri=S.URI.from({scheme:"vscode-concat-doc",path:(0,C.generateUuid)()}),this._init(),this._disposables.add(f.onDidChangeDocument(g=>{const E=this._cellUris.get(g.document.uri);E!==void 0&&(this._cellLengths.changeValue(E,this._cells[E].document.getText().length+1),this._cellLines.changeValue(E,this._cells[E].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const p=g=>{g===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(d.onDidChangeNotebookCells(g=>p(g.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new D.ResourceMap;const d=[],f=[];for(const r of this._notebook.getCells())r.kind===_.NotebookCellKind.Code&&(!this._selector||(0,y.score)(this._selector,r.document.uri,r.document.languageId,!0))&&(this._cellUris.set(r.document.uri,this._cells.length),this._cells.push(r),d.push(r.document.getText().length+1),f.push(r.document.lineCount));this._cellLengths=new A.PrefixSumComputer(new Uint32Array(d)),this._cellLines=new A.PrefixSumComputer(new Uint32Array(f))}get version(){return this._versionId}getText(d){var f,r;if(!d){let m="";for(const u of this._cells)m+=u.document.getText()+`
`;return m=m.slice(0,-1),m}if(d.isEmpty)return"";const o=this.locationAt(d.start),p=this.locationAt(d.end),g=this._cells[(f=this._cellUris.get(o.uri))!==null&&f!==void 0?f:-1],E=this._cells[(r=this._cellUris.get(p.uri))!==null&&r!==void 0?r:-1];if(!g||!E)return"";if(g===E)return g.document.getText(new _.Range(o.range.start,p.range.end));{const m=g.document.getText(new _.Range(o.range.start,new _.Position(g.document.lineCount,0))),u=E.document.getText(new _.Range(new _.Position(0,0),p.range.end));return m+`
`+u}}offsetAt(d){const f=this._cellLines.getIndexOf(d.line),r=this._cellLengths.getAccumulatedValue(f.index-1),o=this._cells[f.index].document.offsetAt(d.with(f.remainder));return r+o}positionAt(d){if(typeof d=="number"){const r=this._cellLengths.getIndexOf(d),o=this._cellLines.getAccumulatedValue(r.index-1);return this._cells[r.index].document.positionAt(r.remainder).translate(o)}const f=this._cellUris.get(d.uri);if(f!==void 0){const r=this._cellLines.getAccumulatedValue(f-1);return new _.Position(r+d.range.start.line,d.range.start.character)}return new _.Position(0,0)}locationAt(d){_.Range.isRange(d)||(d=new _.Range(d,d));const f=this._cellLines.getIndexOf(d.start.line);let r=f;d.isEmpty||(r=this._cellLines.getIndexOf(d.end.line));const o=new _.Position(f.remainder,d.start.character),p=new _.Position(r.remainder,d.end.character),g=new _.Range(o,p),E=this._cells[f.index];return new _.Location(E.document.uri,E.document.validateRange(g))}contains(d){return this._cellUris.has(d)}validateRange(d){const f=this.validatePosition(d.start),r=this.validatePosition(d.end);return d.with(f,r)}validatePosition(d){const f=this._cellLines.getIndexOf(d.line),r=new _.Position(f.remainder,d.character),o=this._cells[f.index].document.validatePosition(r),p=this._cellLines.getAccumulatedValue(f.index-1);return new _.Position(p+o.line,o.character)}}e.ExtHostNotebookConcatDocument=i}),define(ve[164],be([0,1,7,14,3]),function(J,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(D){this._actual=new _.ColorTheme(_.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new A.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(D){let S=D==="light"?_.ColorThemeKind.Light:D==="dark"?_.ColorThemeKind.Dark:_.ColorThemeKind.HighContrast;this._actual=new _.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};T=je([Ke(0,k.IExtHostRpcService)],T),e.ExtHostTheming=T}),define(ve[71],be([0,1,4]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,_.createDecorator)("IURITransformerService");class k{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=k}),define(ve[165],be([0,1,24]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class k{constructor(){this.buffers=[]}add(S){let C=this.buffers.indexOf(S);return C<0&&(C=this.buffers.length,this.buffers.push(S)),C}}function A(D,S){if(S.serializeBuffersForPostMessage){const C=new k,i=(f,r)=>{if(r instanceof ArrayBuffer){const o=C.add(r);return{$$vscode_array_buffer_reference$$:!0,index:o}}else if(ArrayBuffer.isView(r)){const o=T(r);if(o){const p=C.add(r.buffer);return{$$vscode_array_buffer_reference$$:!0,index:p,view:{type:o,byteLength:r.byteLength,byteOffset:r.byteOffset}}}}return r},I=JSON.stringify(D,i),d=C.buffers.map(f=>{const r=new Uint8Array(f);return _.VSBuffer.wrap(r)});return{message:I,buffers:d}}else return{message:JSON.stringify(D),buffers:[]}}e.serializeWebviewMessage=A;function T(D){switch(D.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function y(D,S){const C=S.map(d=>{const f=new ArrayBuffer(d.byteLength);return new Uint8Array(f).set(d.buffer),f}),i=S.length?(d,f)=>{if(typeof f=="object"&&f.$$vscode_array_buffer_reference$$){const r=f,{index:o}=r,p=C[o];if(r.view)switch(r.view.type){case 1:return new Int8Array(p,r.view.byteOffset,r.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(p,r.view.byteOffset,r.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(p,r.view.byteOffset,r.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(p,r.view.byteOffset,r.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(p,r.view.byteOffset,r.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(p,r.view.byteOffset,r.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(p,r.view.byteOffset,r.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(p,r.view.byteOffset,r.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(p,r.view.byteOffset,r.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(p,r.view.byteOffset,r.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(p,r.view.byteOffset,r.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return p}return f}:void 0;return{message:JSON.parse(D,i),arrayBuffers:C}}e.deserializeWebviewMessage=y}),define(ve[72],be([0,1,2]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function k(T,y,D){const S=T.webviewResourceRoot.replace("{{resource}}",D.scheme+A(D)).replace("{{uuid}}",y);return _.URI.parse(S)}e.asWebviewUri=k;function A(T){return T.toString().replace(/^\S+?:/,"")}}),define(ve[166],be([0,1,3,6,72,31]),function(J,e,_,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class y{constructor(S,C,i){this._proxy=S,this._editors=C,this._initData=i,this._handlePool=0,this._disposables=new k.DisposableStore,this._insets=new Map,this._disposables.add(C.onDidChangeVisibleTextEditors(()=>{const I=C.getVisibleTextEditors();for(const d of this._insets.values())I.indexOf(d.editor)<0&&d.inset.dispose()}))}dispose(){this._insets.forEach(S=>S.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(S,C,i,I,d){let f;for(const u of this._editors.getVisibleTextEditors(!0))if(u.value===S){f=u;break}if(!f)throw new Error("not a visible editor");const r=this,o=this._handlePool++,p=new _.Emitter,g=new _.Emitter,E=new class{constructor(){this._uuid=(0,T.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(u){return(0,A.asWebviewUri)(r._initData,this._uuid,u)}get cspSource(){return r._initData.webviewCspSource}set options(u){this._options=u,r._proxy.$setOptions(o,u)}get options(){return this._options}set html(u){this._html=u,r._proxy.$setHtml(o,u)}get html(){return this._html}get onDidReceiveMessage(){return p.event}postMessage(u){return r._proxy.$postMessage(o,u)}},m=new class{constructor(){this.editor=S,this.line=C,this.height=i,this.webview=E,this.onDidDispose=g.event}dispose(){r._insets.has(o)&&(r._insets.delete(o),r._proxy.$disposeEditorInset(o),g.fire(),g.dispose(),p.dispose())}};return this._proxy.$createEditorInset(o,f.id,f.value.document.uri,C+1,i,I||{},d.identifier,d.extensionLocation),this._insets.set(o,{editor:S,inset:m,onDidReceiveMessage:p}),m}$onDidDispose(S){const C=this._insets.get(S);C&&C.inset.dispose()}$onDidReceiveMessage(S,C){const i=this._insets.get(S);i&&i.onDidReceiveMessage.fire(C)}}e.ExtHostEditorInsets=y}),define(ve[167],be([0,1,3,63,138,4,6,22,29,15,51,23,36,158]),function(J,e,_,k,A,T,y,D,S,C,i,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,f.registerIcon)("default-view-icon",d.Codicon.window,(0,A.localize)(0,null));var r;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(r=e.Extensions||(e.Extensions={}));var o;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel"})(o=e.ViewContainerLocation||(e.ViewContainerLocation={}));function p(s){switch(s){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=p;function g(s){return`viewContainer.${s}.enabled`}e.getEnabledViewContainerContextKey=g;class E extends y.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new _.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new _.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,C.flatten)([...this.viewContainers.values()])}registerViewContainer(c,v,P){var h;const b=this.get(c.id);if(b)return b;const R=c;return R.openCommandActionDescriptor=(P==null?void 0:P.donotRegisterOpenCommand)?void 0:(h=R.openCommandActionDescriptor)!==null&&h!==void 0?h:{id:R.id},(0,D.getOrSet)(this.viewContainers,v,[]).push(R),(P==null?void 0:P.isDefault)&&this.defaultViewContainers.push(R),this._onDidRegister.fire({viewContainer:R,viewContainerLocation:v}),R}deregisterViewContainer(c){for(const v of this.viewContainers.keys()){const P=this.viewContainers.get(v),h=P==null?void 0:P.indexOf(c);if(h!==-1){P==null||P.splice(h,1),P.length===0&&this.viewContainers.delete(v),this._onDidDeregister.fire({viewContainer:c,viewContainerLocation:v});return}}}get(c){return this.all.filter(v=>v.id===c)[0]}getViewContainers(c){return[...this.viewContainers.get(c)||[]]}getViewContainerLocation(c){return[...this.viewContainers.keys()].filter(v=>this.getViewContainers(v).filter(P=>(P==null?void 0:P.id)===c.id).length>0)[0]}getDefaultViewContainer(c){return this.defaultViewContainers.find(v=>this.getViewContainerLocation(v)===c)}}S.Registry.add(r.ViewContainersRegistry,new E);var m;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(m=e.ViewContentGroups||(e.ViewContentGroups={}));function u(s,c){var v,P,h,b;const R=(v=s.group)!==null&&v!==void 0?v:m.More,U=(P=c.group)!==null&&P!==void 0?P:m.More;return R!==U?R.localeCompare(U):((h=s.order)!==null&&h!==void 0?h:5)-((b=c.order)!==null&&b!==void 0?b:5)}class w extends y.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new _.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new _.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new _.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new _.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new i.SetMap}registerViews(c,v){this.registerViews2([{views:c,viewContainer:v}])}registerViews2(c){c.forEach(({views:v,viewContainer:P})=>this.addViews(v,P)),this._onViewsRegistered.fire(c)}deregisterViews(c,v){const P=this.removeViews(c,v);P.length&&this._onViewsDeregistered.fire({views:P,viewContainer:v})}moveViews(c,v){for(const P of this._views.keys())if(P!==v){const h=this.removeViews(c,P);h.length&&(this.addViews(h,v),this._onDidChangeContainer.fire({views:h,from:P,to:v}))}}getViews(c){return this._views.get(c)||[]}getView(c){for(const v of this._viewContainers){const P=(this._views.get(v)||[]).filter(h=>h.id===c)[0];if(P)return P}return null}getViewContainer(c){for(const v of this._viewContainers)if((this._views.get(v)||[]).filter(h=>h.id===c)[0])return v;return null}registerViewWelcomeContent(c,v){return this._viewWelcomeContents.add(c,v),this._onDidChangeViewWelcomeContent.fire(c),(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(c,v),this._onDidChangeViewWelcomeContent.fire(c)})}registerViewWelcomeContent2(c,v){const P=new Map;for(const[h,b]of v)this._viewWelcomeContents.add(c,b),P.set(h,(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(c,b),this._onDidChangeViewWelcomeContent.fire(c)}));return this._onDidChangeViewWelcomeContent.fire(c),P}getViewWelcomeContent(c){const v=[];return this._viewWelcomeContents.forEach(c,P=>v.push(P)),v.sort(u)}addViews(c,v){let P=this._views.get(v);P||(P=[],this._views.set(v,P),this._viewContainers.push(v));for(const h of c){if(this.getView(h.id)!==null)throw new Error((0,A.localize)(1,null,h.id));P.push(h)}}removeViews(c,v){const P=this._views.get(v);if(!P)return[];const h=[],b=[];for(const R of P)c.includes(R)?h.push(R):b.push(R);return h.length&&(b.length?this._views.set(v,b):(this._views.delete(v),this._viewContainers.splice(this._viewContainers.indexOf(v),1))),h}}S.Registry.add(r.ViewsRegistry,new w),e.IViewsService=(0,T.createDecorator)("viewsService"),e.FocusedViewContext=new k.RawContextKey("focusedView","",(0,A.localize)(2,null));function t(s){return`view.${s}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,T.createDecorator)("viewDescriptorService");var n;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(n=e.ViewVisibilityState||(e.ViewVisibilityState={}));var l;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(l=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class a{constructor(c,v){this.resolved=!1,this._hasResolve=!1,(0,I.mixin)(this,c),this._hasResolve=!!v,this.resolve=async P=>{var h,b;if(v&&!this.resolved){const R=await v(P);R&&(this.tooltip=(h=this.tooltip)!==null&&h!==void 0?h:R.tooltip,this.command=(b=this.command)!==null&&b!==void 0?b:R.command)}P.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=a}),define(ve[168],be([0,1,2,148,159,18,149,167]),function(J,e,_,k,A,T,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function S(o){return(p,...g)=>o(p.get(k.ICommandService),...g)}class C{static execute(p,g){const E={forceReuseWindow:g&&g.reuseWindow,remoteAuthority:g&&g.remoteAuthority};return p.executeCommand("_files.newWindow",E)}}e.NewWindowAPICommand=C,C.ID="vscode.newWindow",k.CommandsRegistry.registerCommand({id:C.ID,handler:S(C.execute),description:{description:"Opens an new window",args:[]}}),k.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(o,p){return o.get(A.IWorkspacesService).removeRecentlyOpened([p])});class i{static execute(p,g){return typeof g=="string"?g=g.match(/^[^:/?#]+:\/\//)?_.URI.parse(g):_.URI.file(g):g=_.URI.revive(g),p.executeCommand("_workbench.removeFromRecentlyOpened",g)}}e.RemoveFromRecentlyOpenedAPICommand=i,i.ID="vscode.removeFromRecentlyOpened",k.CommandsRegistry.registerCommand(i.ID,S(i.execute));class I{static execute(p,g){const E=typeof g=="string"?{extensionId:g}:g;return p.executeCommand("workbench.action.openIssueReporter",E)}}e.OpenIssueReporter=I,I.ID="vscode.openIssueReporter",k.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(o,p){const g=o.get(A.IWorkspacesService);let E;const m=p.uri,u=p.label,w=p.remoteAuthority;return p.type==="workspace"?E={workspace:await g.getWorkspaceIdentifier(m),label:u,remoteAuthority:w}:p.type==="folder"?E={folderUri:m,label:u,remoteAuthority:w}:E={fileUri:m,label:u,remoteAuthority:w},g.addRecentlyOpened([E])}),k.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(o){return o.get(A.IWorkspacesService).getRecentlyOpened()}),k.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(o,p){const g=o.get(T.ILogService),E=o.get(y.IEnvironmentService);E.isExtensionDevelopment&&!!E.extensionTestsLocationURI&&g.setLevel(p)}),k.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(o){return o.get(T.ILogService).getLevel()}),k.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(o,p){const g=o.get(D.IViewDescriptorService),E=g.getViewContainerById(p.destinationId);if(!!E){for(const m of p.viewIds){const u=g.getViewDescriptorById(m);(u==null?void 0:u.canMoveView)&&g.moveViewsToContainer([u],E,D.ViewVisibilityState.Default)}await o.get(D.IViewsService).openViewContainer(E.id,!0)}});class d{static execute(p,g){return!Array.isArray(g==null?void 0:g.viewIds)||typeof(g==null?void 0:g.destinationId)!="string"?Promise.reject("Invalid arguments"):p.executeCommand("_workbench.action.moveViews",g)}}e.MoveViewsAPICommand=d,d.ID="vscode.moveViews",k.CommandsRegistry.registerCommand({id:d.ID,handler:S(d.execute),description:{description:"Move Views",args:[]}});class f{static execute(p,g){return p.executeCommand("_workbench.open",g)}}f.ID="vscode.open",k.CommandsRegistry.registerCommand(f.ID,S(f.execute));class r{static execute(p,g,E,m,u){return p.executeCommand("_workbench.diff",[g,E,m])}}r.ID="vscode.diff",k.CommandsRegistry.registerCommand(r.ID,S(r.execute))}),define(ve[169],be([0,1,3,11,139]),function(J,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new _.Emitter,this._onExit=new _.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(D){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=D}onEvent(D){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=D}onRequest(D){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=D}sendResponse(D){D.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${D.command}`)):this.internalSend("response",D)}sendRequest(D,S,C,i){const I={command:D};if(S&&Object.keys(S).length>0&&(I.arguments=S),this.internalSend("request",I),typeof i=="number"){const d=setTimeout(()=>{clearTimeout(d);const f=this.pendingRequests.get(I.seq);if(f){this.pendingRequests.delete(I.seq);const r={type:"response",seq:0,request_seq:I.seq,success:!1,command:D,message:(0,A.localize)(0,null,i,D)};f(r)}},i)}return C&&this.pendingRequests.set(I.seq,C),I.seq}acceptMessage(D){this.messageCallback?this.messageCallback(D):(this.queue.push(D),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(D,S){return D.type!=="event"||S.type!=="event"}async processQueue(){let D;for(;this.queue.length;){if((!D||this.needsTaskBoundaryBetween(this.queue[0],D))&&await(0,k.timeout)(0),D=this.queue.shift(),!D)return;switch(D.type){case"event":this.eventCallback&&this.eventCallback(D);break;case"request":this.requestCallback&&this.requestCallback(D);break;case"response":const S=D,C=this.pendingRequests.get(S.request_seq);C&&(this.pendingRequests.delete(S.request_seq),C(S));break}}}internalSend(D,S){S.type=D,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const D=new Map;this.pendingRequests.forEach((S,C)=>D.set(C,S)),await(0,k.timeout)(500),D.forEach((S,C)=>{S({type:"response",seq:0,request_seq:C,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(C)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(ve[170],be([0,1,8,2,13,23,19]),function(J,e,_,k,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const D=/{([^}]+)}/g;function S(n,l,a){return n.replace(D,function(s,c){return l&&c.length>0&&c[0]!=="_"?s:a&&a.hasOwnProperty(c)?a[c]:s})}e.formatPII=S;function C(n){const l={};for(const a of Object.keys(n))a.startsWith("!")||(l[a]=n[a]);return l}e.filterExceptionsFromTelemetry=C;function i(n){return n.configuration.request==="attach"&&!I(n)}e.isSessionAttach=i;function I(n){let l=n.configuration.type;if(!!l)return l==="vslsShare"&&(l=n.configuration.adapterProxy.configuration.type),(0,_.equalsIgnoreCase)(l,"extensionhost")||(0,_.equalsIgnoreCase)(l,"pwa-extensionhost")?n:n.parentSession?I(n.parentSession):void 0}e.getExtensionHostDebugSession=I;function d(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=d;function f(n,l,a){let s,c=0,v=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,P=null;for(;P=v.exec(n);){let h=P.index+1,b=h+P[0].length;if(h<=l&&b>=a){s=P[0],c=h;break}}if(s){let h=/\w+/g,b=null;for(;(b=h.exec(s))&&!(b.index+1+c+b[0].length>=a););b&&(s=s.substring(0,h.lastIndex))}return s?{start:c,end:c+s.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=f;const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function o(n){return!!(n&&n.match(r))}e.isUri=o;function p(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(o(n.path))return k.URI.parse(n.path);if((0,A.isAbsolute)(n.path))return k.URI.file(n.path)}return n.path}function g(n){if(typeof n.path=="object"){const l=k.URI.revive(n.path);if(l)return l.scheme===y.Schemas.file?l.fsPath:l.toString()}return n.path}function E(n,l){const a=l?p:g,s=(0,T.deepClone)(n);return u(s,(c,v)=>{c&&v&&(v.path=a(v))}),s}e.convertToDAPaths=E;function m(n,l){const a=l?p:g,s=(0,T.deepClone)(n);return u(s,(c,v)=>{!c&&v&&(v.path=a(v))}),s}e.convertToVSCPaths=m;function u(n,l){switch(n.type){case"event":const a=n;switch(a.event){case"output":l(!1,a.body.source);break;case"loadedSource":l(!1,a.body.source);break;case"breakpoint":l(!1,a.body.breakpoint.source);break;default:break}break;case"request":const s=n;switch(s.command){case"setBreakpoints":l(!0,s.arguments.source);break;case"breakpointLocations":l(!0,s.arguments.source);break;case"source":l(!0,s.arguments.source);break;case"gotoTargets":l(!0,s.arguments.source);break;case"launchVSCode":s.arguments.args.forEach(v=>l(!1,v));break;default:break}break;case"response":const c=n;if(c.success&&c.body)switch(c.command){case"stackTrace":c.body.stackFrames.forEach(v=>l(!1,v.source));break;case"loadedSources":c.body.sources.forEach(v=>l(!1,v));break;case"scopes":c.body.scopes.forEach(v=>l(!1,v.source));break;case"setFunctionBreakpoints":c.body.breakpoints.forEach(v=>l(!1,v.source));break;case"setBreakpoints":c.body.breakpoints.forEach(v=>l(!1,v.source));break;default:break}break}}function w(n){return n.filter(l=>{var a;return!((a=l.presentation)===null||a===void 0?void 0:a.hidden)}).sort((l,a)=>l.presentation?a.presentation?l.presentation.group?a.presentation.group?l.presentation.group!==a.presentation.group?l.presentation.group.localeCompare(a.presentation.group):t(l.presentation.order,a.presentation.order):-1:a.presentation.group?1:t(l.presentation.order,a.presentation.order):-1:a.presentation?1:0)}e.getVisibleAndSorted=w;function t(n,l){return typeof n!="number"?typeof l!="number"?0:1:typeof l!="number"?-1:n-l}}),define(ve[73],be([0,1,28,19,13,21,63]),function(J,e,_,k,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarVisibility=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var D;(function(h){h[h.Markdown=1]="Markdown",h[h.Code=2]="Code"})(D=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var S;(function(h){h[h.Running=1]="Running",h[h.Idle=2]="Idle"})(S=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{}};var C;(function(h){h[h.Idle=1]="Idle",h[h.Pending=2]="Pending",h[h.Executing=3]="Executing"})(C=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var i;(function(h){h[h.WithHardKernelDependency=0]="WithHardKernelDependency",h[h.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",h[h.Pure=2]="Pure",h[h.Never=3]="Never"})(i=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var I;(function(h){h[h.ModelChange=1]="ModelChange",h[h.Move=2]="Move",h[h.CellClearOutput=3]="CellClearOutput",h[h.CellsClearOutput=4]="CellsClearOutput",h[h.ChangeLanguage=5]="ChangeLanguage",h[h.Initialize=6]="Initialize",h[h.ChangeCellMetadata=7]="ChangeCellMetadata",h[h.Output=8]="Output",h[h.OutputItem=9]="OutputItem",h[h.ChangeCellContent=10]="ChangeCellContent",h[h.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",h[h.Unknown=12]="Unknown"})(I=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(h){h[h.Handle=0]="Handle",h[h.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var f;(function(h){h[h.Replace=1]="Replace",h[h.Output=2]="Output",h[h.Metadata=3]="Metadata",h[h.CellLanguage=4]="CellLanguage",h[h.DocumentMetadata=5]="DocumentMetadata",h[h.Move=6]="Move",h[h.OutputItems=7]="OutputItems",h[h.PartialMetadata=8]="PartialMetadata"})(f=e.CellEditType||(e.CellEditType={}));function r(h){const b=o.parse(h);return b?b.notebook.toString():h.toString()}e.getCellUndoRedoComparisonKey=r;var o;(function(h){h.scheme=k.Schemas.vscodeNotebookCell;const b=/^ch(\d{7,})/;function R(H,Y){return H.with({scheme:h.scheme,fragment:`ch${Y.toString().padStart(7,"0")}${H.scheme!==k.Schemas.file?H.scheme:""}`})}h.generate=R;function U(H){if(H.scheme===h.scheme){const Y=b.exec(H.fragment);if(!!Y)return{handle:Number(Y[1]),notebook:H.with({scheme:H.fragment.substr(Y[0].length)||k.Schemas.file,fragment:null})}}}h.parse=U;function K(H){if(H.scheme===k.Schemas.vscodeNotebookCellMetadata){const Y=b.exec(H.fragment);if(!!Y)return{handle:Number(Y[1]),notebook:H.with({scheme:H.fragment.substr(Y[0].length)||k.Schemas.file,fragment:null})}}}h.parseCellMetadataUri=K;function he(H,Y,W){return H.with({scheme:W,fragment:`ch${Y.toString().padStart(7,"0")}${H.scheme!==k.Schemas.file?H.scheme:""}`})}h.generateCellUri=he;function V(H,Y){if(H.scheme===Y){const W=b.exec(H.fragment);if(!!W)return{handle:Number(W[1]),notebook:H.with({scheme:H.fragment.substr(W[0].length)||k.Schemas.file,fragment:null})}}}h.parseCellUri=V})(o=e.CellUri||(e.CellUri={}));const p=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function g(h){var b,R;return(R=(b=p.get(h))===null||b===void 0?void 0:b.alwaysSecure)!==null&&R!==void 0?R:!1}e.mimeTypeIsAlwaysSecure=g;function E(h){var b,R;return(R=(b=p.get(h))===null||b===void 0?void 0:b.supportedByCore)!==null&&R!==void 0?R:!1}e.mimeTypeSupportedByCore=E;function m(h){var b,R;return(R=(b=p.get(h))===null||b===void 0?void 0:b.mergeable)!==null&&R!==void 0?R:!1}e.mimeTypeIsMergeable=m;function u(h,b){return T.isWindows&&(h=h.replace(/\//g,"\\"),b=b.replace(/\//g,"\\")),_.match(h,b)}function w(h,b,R){let U=0;for(let K=0;K<b.length;K++){if(u(b[K],h))return U;U++}for(let K=0;K<R.length;K++){if(u(R[K],h))return U;U++}return U}function t(h,b,R){return h.sort((U,K)=>w(U,b,R)-w(K,b,R))}e.sortMimeTypes=t;function n(h,b,R,U=(K,he)=>K===he){const K=[];function he(Y,W,F){if(!(W===0&&F.length===0)){const L=K[K.length-1];L&&L.start+L.deleteCount===Y?(L.deleteCount+=W,L.toInsert.push(...F)):K.push({start:Y,deleteCount:W,toInsert:F})}}let V=0,H=0;for(;;){if(V===h.length){he(V,0,b.slice(H));break}if(H===b.length){he(V,h.length-V,[]);break}const Y=h[V],W=b[H];if(U(Y,W)){V+=1,H+=1;continue}R(W)?(he(V,1,[]),V+=1):(he(V,0,[W]),H+=1)}return K}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var l;(function(h){h.default="default",h.option="option"})(l=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function a(h){const b=h;return!!((typeof b.include=="string"||_.isRelativePattern(b.include))&&(typeof b.exclude=="string"||_.isRelativePattern(b.exclude)))}e.isDocumentExcludePattern=a;function s(h,b,R){if(Array.isArray(h.viewType)&&h.viewType.indexOf(b)>=0||h.viewType===b)return!0;if(h.filenamePattern){let U=a(h.filenamePattern)?h.filenamePattern.include:h.filenamePattern,K=a(h.filenamePattern)?h.filenamePattern.exclude:void 0;if(_.match(U,(0,A.basename)(R.fsPath).toLowerCase()))return!(K&&_.match(K,(0,A.basename)(R.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=s;class c{constructor(b){this.textModel=b}getElements(){const b=new Int32Array(this.textModel.cells.length);for(let R=0;R<this.textModel.cells.length;R++)b[R]=this.textModel.cells[R].getHashValue();return b}}e.CellSequence=c,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer";var v;(function(h){h[h.Left=1]="Left",h[h.Right=2]="Right"})(v=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class P{static create(b){return`${P._prefix}/${b}`}static parse(b){if(b.startsWith(P._prefix))return b.substr(P._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=P,P._prefix="notebook/"}),define(ve[171],be([0,1,141,4,63]),function(J,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new A.RawContextKey("customExecutionSupported",!0,_.localize(0,null)),e.ShellExecutionSupportedContext=new A.RawContextKey("shellExecutionSupported",!1,_.localize(1,null)),e.ProcessExecutionSupportedContext=new A.RawContextKey("processExecutionSupported",!1,_.localize(2,null)),e.ITaskService=(0,k.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ve[172],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function _(A){return[...A.entries()]}e.serializeEnvironmentVariableCollection=_;function k(A){return new Map(A)}e.deserializeEnvironmentVariableCollection=k}),define(ve[96],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var _;(function(S){S[S.NotExpandable=0]="NotExpandable",S[S.Expandable=1]="Expandable",S[S.BusyExpanding=2]="BusyExpanding",S[S.Expanded=3]="Expanded"})(_=e.TestItemExpandState||(e.TestItemExpandState={}));const k=(S,C)=>{C.expand!==void 0&&(S.expand=C.expand),C.item!==void 0&&(S.item=S.item?Object.assign(S.item,C.item):C.item)};e.applyTestItemUpdate=k;var A;(function(S){S[S.Add=0]="Add",S[S.Update=1]="Update",S[S.Remove=2]="Remove",S[S.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",S[S.Retire=4]="Retire"})(A=e.TestDiffOpType||(e.TestDiffOpType={}));const T=(S,C)=>`${S}:${C.toString()}`;e.getTestSubscriptionKey=T;class y{add(C){}update(C){}remove(C,i){}complete(){}}e.IncrementalChangeCollector=y;class D{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(C){const i=this.createChangeCollector();for(const I of C)switch(I[0]){case 0:{const d=I[1];if(d.parent){if(this.items.has(d.parent)){const f=this.items.get(d.parent);f.children.add(d.item.extId);const r=this.createItem(d,f);this.items.set(d.item.extId,r),i.add(r)}}else{this.roots.add(d.item.extId);const f=this.createItem(d);this.items.set(d.item.extId,f),i.add(f)}d.expand===2&&this.busyControllerCount++;break}case 1:{const d=I[1],f=this.items.get(d.extId);if(!f)break;d.expand!==void 0&&(f.expand===2&&this.busyControllerCount--,d.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(f,d),i.update(f);break}case 2:{const d=this.items.get(I[1]);if(!d)break;d.parent?this.items.get(d.parent).children.delete(d.item.extId):this.roots.delete(d.item.extId);const f=[[I[1]]];for(;f.length;)for(const r of f.pop()){const o=this.items.get(r);o&&(f.push(o.children),this.items.delete(r),i.remove(o,o!==d),o.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(I[1]);break;case 3:this.updatePendingRoots(I[1]);break}i.complete()}retireTest(C){}updatePendingRoots(C){this.pendingRootCount+=C}createChangeCollector(){return new y}}e.AbstractIncrementalTestCollection=D}),define(ve[173],be([0,1,13,46,10,23,21,58,142]),function(J,e,_,k,A,T,y,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class C{constructor(I,d,f){this._contributedVariables=new Map,this._context=I,this._labelService=d,f&&(this._envVariablesPromise=f.then(r=>this.prepareEnv(r)))}prepareEnv(I){if(y.isWindows){const d=Object.create(null);return Object.keys(I).forEach(f=>{d[f.toLowerCase()]=I[f]}),d}return I}resolveWithEnvironment(I,d,f){return this.recursiveResolve(this.prepareEnv(I),d?d.uri:void 0,f)}async resolveAsync(I,d){return this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,d)}async resolveAnyBase(I,d,f,r){const o=T.deepClone(d);return y.isWindows&&o.windows?Object.keys(o.windows).forEach(p=>o[p]=o.windows[p]):y.isMacintosh&&o.osx?Object.keys(o.osx).forEach(p=>o[p]=o.osx[p]):y.isLinux&&o.linux&&Object.keys(o.linux).forEach(p=>o[p]=o.linux[p]),delete o.windows,delete o.osx,delete o.linux,this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,o,f,r)}async resolveAnyAsync(I,d,f){return this.resolveAnyBase(I,d,f)}async resolveAnyMap(I,d,f){const r=new Map;return{newConfig:await this.resolveAnyBase(I,d,f,r),resolvedVariables:r}}resolveWithInteractionReplace(I,d,f,r){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,d,f,r){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,d){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,d)}recursiveResolve(I,d,f,r,o){if(A.isString(f))return this.resolveString(I,d,f,r,o);if(A.isArray(f))return f.map(p=>this.recursiveResolve(I,d,p,r,o));if(A.isObject(f)){let p=Object.create(null);return Object.keys(f).forEach(g=>{const E=this.resolveString(I,d,g,r,o);p[E]=this.recursiveResolve(I,d,f[g],r,o)}),p}return f}resolveString(I,d,f,r,o){return f.replace(C.VARIABLE_REGEXP,(g,E)=>{if(E.includes(C.VARIABLE_LHS))return g;let m=this.evaluateSingleVariable(I,g,E,d,r);return o&&o.set(E,m),m})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,d,f,r,o){let p;const g=f.split(":");g.length>1&&(f=g[0],p=g[1]);const E=()=>{const w=this._context.getFilePath();if(w)return w;throw new Error((0,S.localize)(0,null,d))},m=()=>{const w=E();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,S.localize)(1,null,d,_.basename(w)))},u=()=>{if(p){const w=this._context.getFolderUri(p);if(w)return w;throw new Error((0,S.localize)(2,null,d,p))}if(r)return r;throw this._context.getWorkspaceFolderCount()>1?new Error((0,S.localize)(3,null,d)):new Error((0,S.localize)(4,null,d))};switch(f){case"env":if(p){if(I){const w=I[y.isWindows?p.toLowerCase():p];if(A.isString(w))return w}return""}throw new Error((0,S.localize)(5,null,d));case"config":if(p){const w=this._context.getConfigurationValue(r,p);if(A.isUndefinedOrNull(w))throw new Error((0,S.localize)(6,null,d,p));if(A.isObject(w))throw new Error((0,S.localize)(7,null,d,p));return w}throw new Error((0,S.localize)(8,null,d));case"command":return this.resolveFromMap(d,p,o,"command");case"input":return this.resolveFromMap(d,p,o,"input");default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,D.normalizeDriveLetter)(this.fsPath(u()));case"cwd":return r||p?(0,D.normalizeDriveLetter)(this.fsPath(u())):k.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return _.basename(this.fsPath(u()));case"lineNumber":const w=this._context.getLineNumber();if(w)return w;throw new Error((0,S.localize)(9,null,d));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,S.localize)(10,null,d));case"file":return E();case"fileWorkspaceFolder":return m();case"relativeFile":return r||p?_.relative(this.fsPath(u()),E()):E();case"relativeFileDirname":const n=_.dirname(E());if(r||p){const c=_.relative(this.fsPath(u()),n);return c.length===0?".":c}return n;case"fileDirname":return _.dirname(E());case"fileExtname":return _.extname(E());case"fileBasename":return _.basename(E());case"fileBasenameNoExtension":const l=_.basename(E());return l.slice(0,l.length-_.extname(l).length);case"fileDirnameBasename":return _.basename(_.dirname(E()));case"execPath":const a=this._context.getExecPath();return a||d;case"execInstallFolder":const s=this._context.getAppRoot();return s||d;case"pathSeparator":return _.sep;default:try{const c=p?`${f}:${p}`:f;return this.resolveFromMap(d,c,o,void 0)}catch(c){return d}}}}resolveFromMap(I,d,f,r){if(d&&f){const o=r===void 0?f[d]:f[r+":"+d];if(typeof o=="string")return o;throw new Error((0,S.localize)(11,null,I))}return I}}e.AbstractVariableResolverService=C,C.VARIABLE_LHS="${",C.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ve[174],be([0,1,4]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,_.createDecorator)("editorGroupsService");var k;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(k=e.GroupDirection||(e.GroupDirection={}));var A;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var y;(function(d){d[d.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",d[d.EVEN=1]="EVEN",d[d.TOGGLE=2]="TOGGLE"})(y=e.GroupsArrangement||(e.GroupsArrangement={}));var D;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(D=e.MergeGroupMode||(e.MergeGroupMode={}));var S;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(S=e.GroupsOrder||(e.GroupsOrder={}));var C;(function(d){d[d.GROUP_ACTIVE=0]="GROUP_ACTIVE",d[d.GROUP_INDEX=1]="GROUP_INDEX",d[d.EDITOR_OPEN=2]="EDITOR_OPEN",d[d.EDITOR_CLOSE=3]="EDITOR_CLOSE",d[d.EDITOR_MOVE=4]="EDITOR_MOVE",d[d.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",d[d.EDITOR_LABEL=6]="EDITOR_LABEL",d[d.EDITOR_PIN=7]="EDITOR_PIN",d[d.EDITOR_STICKY=8]="EDITOR_STICKY",d[d.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(C=e.GroupChangeKind||(e.GroupChangeKind={}));var i;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(i=e.OpenEditorContext||(e.OpenEditorContext={}));function I(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=I}),define(ve[175],be([0,1,4]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,_.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(ve[9],be([0,1,15,83,229,57,23,10,2,32,62,143,90,73,175,7]),function(J,e,_,k,A,T,y,D,S,C,i,I,d,f,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookKernelPreload=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookCellPreviousExecutionResult=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var p;(function(pe){function ce(q){const{selectionStartLineNumber:Me,selectionStartColumn:Te,positionLineNumber:Je,positionColumn:et}=q,ct=new o.Position(Me-1,Te-1),ht=new o.Position(Je-1,et-1);return new o.Selection(ct,ht)}pe.to=ce;function se(q){const{anchor:Me,active:Te}=q;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:Te.line+1,positionColumn:Te.character+1}}pe.from=se})(p=e.Selection||(e.Selection={}));var g;(function(pe){function ce(q){if(!!q){const{start:Me,end:Te}=q;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:Te.line+1,endColumn:Te.character+1}}}pe.from=ce;function se(q){if(!!q){const{startLineNumber:Me,startColumn:Te,endLineNumber:Je,endColumn:et}=q;return new o.Range(Me-1,Te-1,Je-1,et-1)}}pe.to=se})(g=e.Range||(e.Range={}));var E;(function(pe){function ce(se){switch(se){case 1:return o.StandardTokenType.Comment;case 0:return o.StandardTokenType.Other;case 4:return o.StandardTokenType.RegEx;case 2:return o.StandardTokenType.String}}pe.to=ce})(E=e.TokenType||(e.TokenType={}));var m;(function(pe){function ce(q){return new o.Position(q.lineNumber-1,q.column-1)}pe.to=ce;function se(q){return{lineNumber:q.line+1,column:q.character+1}}pe.from=se})(m=e.Position||(e.Position={}));var u;(function(pe){function ce(q){switch(q){case o.DiagnosticTag.Unnecessary:return 1;case o.DiagnosticTag.Deprecated:return 2}}pe.from=ce;function se(q){switch(q){case 1:return o.DiagnosticTag.Unnecessary;case 2:return o.DiagnosticTag.Deprecated;default:return}}pe.to=se})(u=e.DiagnosticTag||(e.DiagnosticTag={}));var w;(function(pe){function ce(q){let Me;return q.code&&((0,D.isString)(q.code)||(0,D.isNumber)(q.code)?Me=String(q.code):Me={value:String(q.code.value),target:q.code.target}),Object.assign(Object.assign({},g.from(q.range)),{message:q.message,source:q.source,code:Me,severity:n.from(q.severity),relatedInformation:q.relatedInformation&&q.relatedInformation.map(t.from),tags:Array.isArray(q.tags)?(0,_.coalesce)(q.tags.map(u.from)):void 0})}pe.from=ce;function se(q){var Me;const Te=new o.Diagnostic(g.to(q),q.message,n.to(q.severity));return Te.source=q.source,Te.code=(0,D.isString)(q.code)?q.code:(Me=q.code)===null||Me===void 0?void 0:Me.value,Te.relatedInformation=q.relatedInformation&&q.relatedInformation.map(t.to),Te.tags=q.tags&&(0,_.coalesce)(q.tags.map(u.to)),Te}pe.to=se})(w=e.Diagnostic||(e.Diagnostic={}));var t;(function(pe){function ce(q){return Object.assign(Object.assign({},g.from(q.location.range)),{message:q.message,resource:q.location.uri})}pe.from=ce;function se(q){return new o.DiagnosticRelatedInformation(new o.Location(q.resource,g.to(q)),q.message)}pe.to=se})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var n;(function(pe){function ce(q){switch(q){case o.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case o.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case o.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case o.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}pe.from=ce;function se(q){switch(q){case d.MarkerSeverity.Info:return o.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return o.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return o.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return o.DiagnosticSeverity.Hint;default:return o.DiagnosticSeverity.Error}}pe.to=se})(n=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var l;(function(pe){function ce(q){return typeof q=="number"&&q>=o.ViewColumn.One?q-1:q===o.ViewColumn.Beside?r.SIDE_GROUP:r.ACTIVE_GROUP}pe.from=ce;function se(q){if(typeof q=="number"&&q>=0)return q+1;throw new Error("invalid 'EditorGroupColumn'")}pe.to=se})(l=e.ViewColumn||(e.ViewColumn={}));function a(pe){return typeof pe.range!="undefined"}function s(pe){return pe.length===0?!0:!!a(pe[0])}e.isDecorationOptionsArr=s;var c;(function(pe){function ce(et){return et.map(pe.from)}pe.fromMany=ce;function se(et){return et&&typeof et=="object"&&typeof et.language=="string"&&typeof et.value=="string"}function q(et){let ct;if(se(et)){const{language:ft,value:lt}=et;ct={value:"```"+ft+`
`+lt+"\n```\n"}}else o.MarkdownString.isMarkdownString(et)?ct={value:et.value,isTrusted:et.isTrusted,supportThemeIcons:et.supportThemeIcons}:typeof et=="string"?ct={value:et}:ct={value:""};const ht=Object.create(null);ct.uris=ht;const Xe=ft=>{try{let lt=S.URI.parse(ft,!0);lt=lt.with({query:Me(lt.query,ht)}),ht[ft]=lt}catch(lt){}return""},at=new A.Renderer;return at.link=Xe,at.image=ft=>Xe(k.parseHrefAndDimensions(ft).href),A(ct.value,{renderer:at}),ct}pe.from=q;function Me(et,ct){if(!et)return et;let ht;try{ht=(0,T.parse)(et)}catch(at){}if(!ht)return et;let Xe=!1;return ht=(0,y.cloneAndChange)(ht,at=>{if(S.URI.isUri(at)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[ft]=at,Xe=!0,ft}else return}),Xe?JSON.stringify(ht):et}function Te(et){const ct=new o.MarkdownString(et.value,et.supportThemeIcons);return ct.isTrusted=et.isTrusted,ct}pe.to=Te;function Je(et){if(!!et)return typeof et=="string"?et:pe.from(et)}pe.fromStrict=Je})(c=e.MarkdownString||(e.MarkdownString={}));function v(pe){return s(pe)?pe.map(ce=>({range:g.from(ce.range),hoverMessage:Array.isArray(ce.hoverMessage)?c.fromMany(ce.hoverMessage):ce.hoverMessage?c.from(ce.hoverMessage):void 0,renderOptions:ce.renderOptions})):pe.map(ce=>({range:g.from(ce)}))}e.fromRangeOrRangeWithMessage=v;function P(pe){return typeof pe=="undefined"?pe:typeof pe=="string"?S.URI.file(pe):pe}e.pathOrURIToURI=P;var h;(function(pe){function ce(se){return typeof se=="undefined"?se:{contentText:se.contentText,contentIconPath:se.contentIconPath?P(se.contentIconPath):void 0,border:se.border,borderColor:se.borderColor,fontStyle:se.fontStyle,fontWeight:se.fontWeight,textDecoration:se.textDecoration,color:se.color,backgroundColor:se.backgroundColor,margin:se.margin,width:se.width,height:se.height}}pe.from=ce})(h=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var b;(function(pe){function ce(se){return typeof se=="undefined"?se:{backgroundColor:se.backgroundColor,outline:se.outline,outlineColor:se.outlineColor,outlineStyle:se.outlineStyle,outlineWidth:se.outlineWidth,border:se.border,borderColor:se.borderColor,borderRadius:se.borderRadius,borderSpacing:se.borderSpacing,borderStyle:se.borderStyle,borderWidth:se.borderWidth,fontStyle:se.fontStyle,fontWeight:se.fontWeight,textDecoration:se.textDecoration,cursor:se.cursor,color:se.color,opacity:se.opacity,letterSpacing:se.letterSpacing,gutterIconPath:se.gutterIconPath?P(se.gutterIconPath):void 0,gutterIconSize:se.gutterIconSize,overviewRulerColor:se.overviewRulerColor,before:se.before?h.from(se.before):void 0,after:se.after?h.from(se.after):void 0}}pe.from=ce})(b=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var R;(function(pe){function ce(se){if(typeof se=="undefined")return se;switch(se){case o.DecorationRangeBehavior.OpenOpen:return 0;case o.DecorationRangeBehavior.ClosedClosed:return 1;case o.DecorationRangeBehavior.OpenClosed:return 2;case o.DecorationRangeBehavior.ClosedOpen:return 3}}pe.from=ce})(R=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var U;(function(pe){function ce(se){return{isWholeLine:se.isWholeLine,rangeBehavior:se.rangeBehavior?R.from(se.rangeBehavior):void 0,overviewRulerLane:se.overviewRulerLane,light:se.light?b.from(se.light):void 0,dark:se.dark?b.from(se.dark):void 0,backgroundColor:se.backgroundColor,outline:se.outline,outlineColor:se.outlineColor,outlineStyle:se.outlineStyle,outlineWidth:se.outlineWidth,border:se.border,borderColor:se.borderColor,borderRadius:se.borderRadius,borderSpacing:se.borderSpacing,borderStyle:se.borderStyle,borderWidth:se.borderWidth,fontStyle:se.fontStyle,fontWeight:se.fontWeight,textDecoration:se.textDecoration,cursor:se.cursor,color:se.color,opacity:se.opacity,letterSpacing:se.letterSpacing,gutterIconPath:se.gutterIconPath?P(se.gutterIconPath):void 0,gutterIconSize:se.gutterIconSize,overviewRulerColor:se.overviewRulerColor,before:se.before?h.from(se.before):void 0,after:se.after?h.from(se.after):void 0}}pe.from=ce})(U=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var K;(function(pe){function ce(q){return{text:q.newText,eol:q.newEol&&ee.from(q.newEol),range:g.from(q.range)}}pe.from=ce;function se(q){const Me=new o.TextEdit(g.to(q.range),q.text);return Me.newEol=typeof q.eol=="undefined"?void 0:ee.to(q.eol),Me}pe.to=se})(K=e.TextEdit||(e.TextEdit={}));var he;(function(pe){function ce(q,Me,Te){var Je,et,ct;const ht={edits:[]};if(q instanceof o.WorkspaceEdit)for(let Xe of q._allEntries())if(Xe._type===1)ht.edits.push({_type:1,oldUri:Xe.from,newUri:Xe.to,options:Xe.options,metadata:Xe.metadata});else if(Xe._type===2){const at=Me==null?void 0:Me.getDocument(Xe.uri);ht.edits.push({_type:2,resource:Xe.uri,edit:K.from(Xe.edit),modelVersionId:at==null?void 0:at.version,metadata:Xe.metadata})}else Xe._type===3?ht.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:Xe.edit,notebookMetadata:Xe.notebookMetadata,notebookVersionId:(Je=Te==null?void 0:Te.lookupNotebookDocument(Xe.uri))===null||Je===void 0?void 0:Je.apiNotebook.version}):Xe._type===4?(Xe.newOutputs&&ht.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:{editType:2,index:Xe.index,append:Xe.append,outputs:Xe.newOutputs.map(ke.from)}}),Xe.newMetadata&&ht.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:{editType:8,index:Xe.index,metadata:Xe.newMetadata}})):Xe._type===5?ht.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,notebookVersionId:(et=Te==null?void 0:Te.lookupNotebookDocument(Xe.uri))===null||et===void 0?void 0:et.apiNotebook.version,edit:{editType:1,index:Xe.index,count:Xe.count,cells:Xe.cells.map(Q.from)}}):Xe._type===6&&ht.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:{editType:7,outputId:Xe.outputId,items:((ct=Xe.newOutputItems)===null||ct===void 0?void 0:ct.map(ae.from))||[],append:Xe.append}});return ht}pe.from=ce;function se(q){const Me=new o.WorkspaceEdit;for(const Te of q.edits)Te.edit?Me.replace(S.URI.revive(Te.resource),g.to(Te.edit.range),Te.edit.text):Me.renameFile(S.URI.revive(Te.oldUri),S.URI.revive(Te.newUri),Te.options);return Me}pe.to=se})(he=e.WorkspaceEdit||(e.WorkspaceEdit={}));var V;(function(pe){const ce=Object.create(null);ce[o.SymbolKind.File]=0,ce[o.SymbolKind.Module]=1,ce[o.SymbolKind.Namespace]=2,ce[o.SymbolKind.Package]=3,ce[o.SymbolKind.Class]=4,ce[o.SymbolKind.Method]=5,ce[o.SymbolKind.Property]=6,ce[o.SymbolKind.Field]=7,ce[o.SymbolKind.Constructor]=8,ce[o.SymbolKind.Enum]=9,ce[o.SymbolKind.Interface]=10,ce[o.SymbolKind.Function]=11,ce[o.SymbolKind.Variable]=12,ce[o.SymbolKind.Constant]=13,ce[o.SymbolKind.String]=14,ce[o.SymbolKind.Number]=15,ce[o.SymbolKind.Boolean]=16,ce[o.SymbolKind.Array]=17,ce[o.SymbolKind.Object]=18,ce[o.SymbolKind.Key]=19,ce[o.SymbolKind.Null]=20,ce[o.SymbolKind.EnumMember]=21,ce[o.SymbolKind.Struct]=22,ce[o.SymbolKind.Event]=23,ce[o.SymbolKind.Operator]=24,ce[o.SymbolKind.TypeParameter]=25;function se(Me){return typeof ce[Me]=="number"?ce[Me]:6}pe.from=se;function q(Me){for(const Te in ce)if(ce[Te]===Me)return Number(Te);return o.SymbolKind.Property}pe.to=q})(V=e.SymbolKind||(e.SymbolKind={}));var H;(function(pe){function ce(q){switch(q){case o.SymbolTag.Deprecated:return 1}}pe.from=ce;function se(q){switch(q){case 1:return o.SymbolTag.Deprecated}}pe.to=se})(H=e.SymbolTag||(e.SymbolTag={}));var Y;(function(pe){function ce(q){return{name:q.name,kind:V.from(q.kind),tags:q.tags&&q.tags.map(H.from),containerName:q.containerName,location:x.from(q.location)}}pe.from=ce;function se(q){const Me=new o.SymbolInformation(q.name,V.to(q.kind),q.containerName,x.to(q.location));return Me.tags=q.tags&&q.tags.map(H.to),Me}pe.to=se})(Y=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var W;(function(pe){function ce(q){var Me,Te;const Je={name:q.name||"!!MISSING: name!!",detail:q.detail,range:g.from(q.range),selectionRange:g.from(q.selectionRange),kind:V.from(q.kind),tags:(Te=(Me=q.tags)===null||Me===void 0?void 0:Me.map(H.from))!==null&&Te!==void 0?Te:[]};return q.children&&(Je.children=q.children.map(ce)),Je}pe.from=ce;function se(q){const Me=new o.DocumentSymbol(q.name,q.detail,V.to(q.kind),g.to(q.range),g.to(q.selectionRange));return(0,_.isNonEmptyArray)(q.tags)&&(Me.tags=q.tags.map(H.to)),q.children&&(Me.children=q.children.map(se)),Me}pe.to=se})(W=e.DocumentSymbol||(e.DocumentSymbol={}));var F;(function(pe){function ce(se){const q=new o.CallHierarchyItem(V.to(se.kind),se.name,se.detail||"",S.URI.revive(se.uri),g.to(se.range),g.to(se.selectionRange));return q._sessionId=se._sessionId,q._itemId=se._itemId,q}pe.to=ce})(F=e.CallHierarchyItem||(e.CallHierarchyItem={}));var L;(function(pe){function ce(se){return new o.CallHierarchyIncomingCall(F.to(se.from),se.fromRanges.map(q=>g.to(q)))}pe.to=ce})(L=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var M;(function(pe){function ce(se){return new o.CallHierarchyOutgoingCall(F.to(se.to),se.fromRanges.map(q=>g.to(q)))}pe.to=ce})(M=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var x;(function(pe){function ce(q){return{range:q.range&&g.from(q.range),uri:q.uri}}pe.from=ce;function se(q){return new o.Location(S.URI.revive(q.uri),g.to(q.range))}pe.to=se})(x=e.location||(e.location={}));var G;(function(pe){function ce(q){const Me=q,Te=q;return{originSelectionRange:Me.originSelectionRange?g.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:Te.uri,range:g.from(Me.targetRange?Me.targetRange:Te.range),targetSelectionRange:Me.targetSelectionRange?g.from(Me.targetSelectionRange):void 0}}pe.from=ce;function se(q){return{targetUri:S.URI.revive(q.uri),targetRange:g.to(q.range),targetSelectionRange:q.targetSelectionRange?g.to(q.targetSelectionRange):void 0,originSelectionRange:q.originSelectionRange?g.to(q.originSelectionRange):void 0}}pe.to=se})(G=e.DefinitionLink||(e.DefinitionLink={}));var X;(function(pe){function ce(q){return{range:g.from(q.range),contents:c.fromMany(q.contents)}}pe.from=ce;function se(q){return new o.Hover(q.contents.map(c.to),g.to(q.range))}pe.to=se})(X=e.Hover||(e.Hover={}));var ne;(function(pe){function ce(q){return{range:g.from(q.range),expression:q.expression}}pe.from=ce;function se(q){return new o.EvaluatableExpression(g.to(q.range),q.expression)}pe.to=se})(ne=e.EvaluatableExpression||(e.EvaluatableExpression={}));var me;(function(pe){function ce(q){if(q instanceof o.InlineValueText)return{type:"text",range:g.from(q.range),text:q.text};if(q instanceof o.InlineValueVariableLookup)return{type:"variable",range:g.from(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};if(q instanceof o.InlineValueEvaluatableExpression)return{type:"expression",range:g.from(q.range),expression:q.expression};throw new Error("Unknown 'InlineValue' type")}pe.from=ce;function se(q){switch(q.type){case"text":return{range:g.to(q.range),text:q.text};case"variable":return{range:g.to(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};case"expression":return{range:g.to(q.range),expression:q.expression}}}pe.to=se})(me=e.InlineValue||(e.InlineValue={}));var Le;(function(pe){function ce(q){return{frameId:q.frameId,stoppedLocation:g.from(q.stoppedLocation)}}pe.from=ce;function se(q){return new o.InlineValueContext(q.frameId,g.to(q.stoppedLocation))}pe.to=se})(Le=e.InlineValueContext||(e.InlineValueContext={}));var We;(function(pe){function ce(q){return{range:g.from(q.range),kind:q.kind}}pe.from=ce;function se(q){return new o.DocumentHighlight(g.to(q.range),q.kind)}pe.to=se})(We=e.DocumentHighlight||(e.DocumentHighlight={}));var Fe;(function(pe){function ce(se){switch(se){case 1:return o.CompletionTriggerKind.TriggerCharacter;case 2:return o.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return o.CompletionTriggerKind.Invoke}}pe.to=ce})(Fe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ze;(function(pe){function ce(se){return{triggerKind:Fe.to(se.triggerKind),triggerCharacter:se.triggerCharacter}}pe.to=ce})(ze=e.CompletionContext||(e.CompletionContext={}));var $;(function(pe){function ce(q){switch(q){case o.CompletionItemTag.Deprecated:return 1}}pe.from=ce;function se(q){switch(q){case 1:return o.CompletionItemTag.Deprecated}}pe.to=se})($=e.CompletionItemTag||(e.CompletionItemTag={}));var j;(function(pe){const ce=new Map([[o.CompletionItemKind.Method,0],[o.CompletionItemKind.Function,1],[o.CompletionItemKind.Constructor,2],[o.CompletionItemKind.Field,3],[o.CompletionItemKind.Variable,4],[o.CompletionItemKind.Class,5],[o.CompletionItemKind.Interface,7],[o.CompletionItemKind.Struct,6],[o.CompletionItemKind.Module,8],[o.CompletionItemKind.Property,9],[o.CompletionItemKind.Unit,12],[o.CompletionItemKind.Value,13],[o.CompletionItemKind.Constant,14],[o.CompletionItemKind.Enum,15],[o.CompletionItemKind.EnumMember,16],[o.CompletionItemKind.Keyword,17],[o.CompletionItemKind.Snippet,27],[o.CompletionItemKind.Text,18],[o.CompletionItemKind.Color,19],[o.CompletionItemKind.File,20],[o.CompletionItemKind.Reference,21],[o.CompletionItemKind.Folder,23],[o.CompletionItemKind.Event,10],[o.CompletionItemKind.Operator,11],[o.CompletionItemKind.TypeParameter,24],[o.CompletionItemKind.Issue,26],[o.CompletionItemKind.User,25]]);function se(Te){var Je;return(Je=ce.get(Te))!==null&&Je!==void 0?Je:9}pe.from=se;const q=new Map([[0,o.CompletionItemKind.Method],[1,o.CompletionItemKind.Function],[2,o.CompletionItemKind.Constructor],[3,o.CompletionItemKind.Field],[4,o.CompletionItemKind.Variable],[5,o.CompletionItemKind.Class],[7,o.CompletionItemKind.Interface],[6,o.CompletionItemKind.Struct],[8,o.CompletionItemKind.Module],[9,o.CompletionItemKind.Property],[12,o.CompletionItemKind.Unit],[13,o.CompletionItemKind.Value],[14,o.CompletionItemKind.Constant],[15,o.CompletionItemKind.Enum],[16,o.CompletionItemKind.EnumMember],[17,o.CompletionItemKind.Keyword],[27,o.CompletionItemKind.Snippet],[18,o.CompletionItemKind.Text],[19,o.CompletionItemKind.Color],[20,o.CompletionItemKind.File],[21,o.CompletionItemKind.Reference],[23,o.CompletionItemKind.Folder],[10,o.CompletionItemKind.Event],[11,o.CompletionItemKind.Operator],[24,o.CompletionItemKind.TypeParameter],[25,o.CompletionItemKind.User],[26,o.CompletionItemKind.Issue]]);function Me(Te){var Je;return(Je=q.get(Te))!==null&&Je!==void 0?Je:o.CompletionItemKind.Property}pe.to=Me})(j=e.CompletionItemKind||(e.CompletionItemKind={}));var te;(function(pe){function ce(se,q){var Me;const Te=new o.CompletionItem(typeof se.label=="string"?se.label:se.label.name);return typeof se.label!="string"&&(Te.label2=se.label),Te.insertText=se.insertText,Te.kind=j.to(se.kind),Te.tags=(Me=se.tags)===null||Me===void 0?void 0:Me.map($.to),Te.detail=se.detail,Te.documentation=k.isMarkdownString(se.documentation)?c.to(se.documentation):se.documentation,Te.sortText=se.sortText,Te.filterText=se.filterText,Te.preselect=se.preselect,Te.commitCharacters=se.commitCharacters,C.Range.isIRange(se.range)?Te.range=g.to(se.range):typeof se.range=="object"&&(Te.range={inserting:g.to(se.range.insert),replacing:g.to(se.range.replace)}),Te.keepWhitespace=typeof se.insertTextRules=="undefined"?!1:Boolean(se.insertTextRules&1),typeof se.insertTextRules!="undefined"&&se.insertTextRules&4?Te.insertText=new o.SnippetString(se.insertText):(Te.insertText=se.insertText,Te.textEdit=Te.range instanceof o.Range?new o.TextEdit(Te.range,Te.insertText):void 0),se.additionalTextEdits&&se.additionalTextEdits.length>0&&(Te.additionalTextEdits=se.additionalTextEdits.map(Je=>K.to(Je))),Te.command=q&&se.command?q.fromInternal(se.command):void 0,Te}pe.to=ce})(te=e.CompletionItem||(e.CompletionItem={}));var oe;(function(pe){function ce(q){return{label:q.label,documentation:q.documentation?c.fromStrict(q.documentation):void 0}}pe.from=ce;function se(q){return{label:q.label,documentation:k.isMarkdownString(q.documentation)?c.to(q.documentation):q.documentation}}pe.to=se})(oe=e.ParameterInformation||(e.ParameterInformation={}));var de;(function(pe){function ce(q){return{label:q.label,documentation:q.documentation?c.fromStrict(q.documentation):void 0,parameters:Array.isArray(q.parameters)?q.parameters.map(oe.from):[],activeParameter:q.activeParameter}}pe.from=ce;function se(q){return{label:q.label,documentation:k.isMarkdownString(q.documentation)?c.to(q.documentation):q.documentation,parameters:Array.isArray(q.parameters)?q.parameters.map(oe.to):[],activeParameter:q.activeParameter}}pe.to=se})(de=e.SignatureInformation||(e.SignatureInformation={}));var _e;(function(pe){function ce(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(de.from):[]}}pe.from=ce;function se(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(de.to):[]}}pe.to=se})(_e=e.SignatureHelp||(e.SignatureHelp={}));var Be;(function(pe){function ce(q){var Me;return{text:q.text,position:m.from(q.position),kind:fe.from((Me=q.kind)!==null&&Me!==void 0?Me:o.InlayHintKind.Other),whitespaceBefore:q.whitespaceBefore,whitespaceAfter:q.whitespaceAfter}}pe.from=ce;function se(q){const Me=new o.InlayHint(q.text,m.to(q.position),fe.to(q.kind));return Me.whitespaceAfter=q.whitespaceAfter,Me.whitespaceBefore=q.whitespaceBefore,Me}pe.to=se})(Be=e.InlayHint||(e.InlayHint={}));var fe;(function(pe){function ce(q){return q}pe.from=ce;function se(q){return q}pe.to=se})(fe=e.InlayHintKind||(e.InlayHintKind={}));var De;(function(pe){function ce(q){return{range:g.from(q.range),url:q.target,tooltip:q.tooltip}}pe.from=ce;function se(q){let Me;if(q.url)try{Me=typeof q.url=="string"?S.URI.parse(q.url,!0):S.URI.revive(q.url)}catch(Te){}return new o.DocumentLink(g.to(q.range),Me)}pe.to=se})(De=e.DocumentLink||(e.DocumentLink={}));var Re;(function(pe){function ce(q){const Me=new o.ColorPresentation(q.label);return q.textEdit&&(Me.textEdit=K.to(q.textEdit)),q.additionalTextEdits&&(Me.additionalTextEdits=q.additionalTextEdits.map(Te=>K.to(Te))),Me}pe.to=ce;function se(q){return{label:q.label,textEdit:q.textEdit?K.from(q.textEdit):void 0,additionalTextEdits:q.additionalTextEdits?q.additionalTextEdits.map(Me=>K.from(Me)):void 0}}pe.from=se})(Re=e.ColorPresentation||(e.ColorPresentation={}));var He;(function(pe){function ce(q){return new o.Color(q[0],q[1],q[2],q[3])}pe.to=ce;function se(q){return[q.red,q.green,q.blue,q.alpha]}pe.from=se})(He=e.Color||(e.Color={}));var we;(function(pe){function ce(q){return{range:g.from(q.range)}}pe.from=ce;function se(q){return new o.SelectionRange(g.to(q.range))}pe.to=se})(we=e.SelectionRange||(e.SelectionRange={}));var qe;(function(pe){function ce(se){switch(se){case 2:return o.TextDocumentSaveReason.AfterDelay;case 1:return o.TextDocumentSaveReason.Manual;case 3:case 4:return o.TextDocumentSaveReason.FocusOut}}pe.to=ce})(qe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var z;(function(pe){function ce(q){switch(q){case o.TextEditorLineNumbersStyle.Off:return 0;case o.TextEditorLineNumbersStyle.Relative:return 2;case o.TextEditorLineNumbersStyle.On:default:return 1}}pe.from=ce;function se(q){switch(q){case 0:return o.TextEditorLineNumbersStyle.Off;case 2:return o.TextEditorLineNumbersStyle.Relative;case 1:default:return o.TextEditorLineNumbersStyle.On}}pe.to=se})(z=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ee;(function(pe){function ce(q){if(q===o.EndOfLine.CRLF)return 1;if(q===o.EndOfLine.LF)return 0}pe.from=ce;function se(q){if(q===1)return o.EndOfLine.CRLF;if(q===0)return o.EndOfLine.LF}pe.to=se})(ee=e.EndOfLine||(e.EndOfLine={}));var ge;(function(pe){function ce(se){if(typeof se=="object")return se.viewId;switch(se){case o.ProgressLocation.SourceControl:return 3;case o.ProgressLocation.Window:return 10;case o.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}pe.from=ce})(ge=e.ProgressLocation||(e.ProgressLocation={}));var Ne;(function(pe){function ce(se){const q={start:se.start+1,end:se.end+1};return se.kind&&(q.kind=Ve.from(se.kind)),q}pe.from=ce})(Ne=e.FoldingRange||(e.FoldingRange={}));var Ve;(function(pe){function ce(se){if(se)switch(se){case o.FoldingRangeKind.Comment:return i.FoldingRangeKind.Comment;case o.FoldingRangeKind.Imports:return i.FoldingRangeKind.Imports;case o.FoldingRangeKind.Region:return i.FoldingRangeKind.Region}}pe.from=ce})(Ve=e.FoldingRangeKind||(e.FoldingRangeKind={}));var $e;(function(pe){function ce(se){if(se)return{pinned:typeof se.preview=="boolean"?!se.preview:void 0,inactive:se.background,preserveFocus:se.preserveFocus,selection:typeof se.selection=="object"?g.from(se.selection):void 0,override:typeof se.override=="boolean"?I.EditorOverride.DISABLED:void 0}}pe.from=ce})($e=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ze;(function(pe){function ce(q){return q instanceof o.RelativePattern||typeof q=="string"?q:se(q)?new o.RelativePattern(q.base,q.pattern):q}pe.from=ce;function se(q){const Me=q;return Me&&typeof Me.base=="string"&&typeof Me.pattern=="string"}})(Ze=e.GlobPattern||(e.GlobPattern={}));var ye;(function(pe){function ce(se){if(se){if(Array.isArray(se))return se.map(ce);if(typeof se=="string")return se;{const q=se;return{language:q.language,scheme:q.scheme,pattern:typeof q.pattern=="undefined"?void 0:Ze.from(q.pattern),exclusive:q.exclusive}}}else return}pe.from=ce})(ye=e.LanguageSelector||(e.LanguageSelector={}));var Ee;(function(pe){function ce(q){return{start:q.start,end:q.end}}pe.from=ce;function se(q){return new o.NotebookRange(q.start,q.end)}pe.to=se})(Ee=e.NotebookRange||(e.NotebookRange={}));var Ce;(function(pe){function ce(se){return new o.NotebookCellMetadata().with(Object.assign(Object.assign({},se),{executionOrder:null,lastRunSuccess:null,runState:null,runStartTime:null,runStartTimeAdjustment:null,runEndTime:null}))}pe.to=ce})(Ce=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var re;(function(pe){function ce(q){return q}pe.from=ce;function se(q){return new o.NotebookDocumentMetadata().with(q)}pe.to=se})(re=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var le;(function(pe){function ce(q){return{startTime:q.runStartTime,endTime:q.runEndTime,executionOrder:q.executionOrder,success:q.lastRunSuccess}}pe.to=ce;function se(q){return{lastRunSuccess:q.success,runStartTime:q.startTime,runEndTime:q.endTime,executionOrder:q.executionOrder}}pe.from=se})(le=e.NotebookCellPreviousExecutionResult||(e.NotebookCellPreviousExecutionResult={}));var N;(function(pe){function ce(q){switch(q){case o.NotebookCellKind.Markdown:return f.CellKind.Markdown;case o.NotebookCellKind.Code:default:return f.CellKind.Code}}pe.from=ce;function se(q){switch(q){case f.CellKind.Markdown:return o.NotebookCellKind.Markdown;case f.CellKind.Code:default:return o.NotebookCellKind.Code}}pe.to=se})(N=e.NotebookCellKind||(e.NotebookCellKind={}));var Q;(function(pe){function ce(q){var Me;return{cellKind:N.from(q.kind),language:q.language,source:q.source,metadata:Object.assign(Object.assign({},q.metadata),le.from((Me=q.latestExecutionSummary)!==null&&Me!==void 0?Me:{})),outputs:q.outputs?q.outputs.map(ke.from):[]}}pe.from=ce;function se(q){return new o.NotebookCellData(N.to(q.cellKind),q.source,q.language,q.outputs?q.outputs.map(ke.to):void 0,q.metadata?Ce.to(q.metadata):void 0)}pe.to=se})(Q=e.NotebookCellData||(e.NotebookCellData={}));var ae;(function(pe){function ce(q){return{mime:q.mime,value:q.value,metadata:q.metadata}}pe.from=ce;function se(q){return new o.NotebookCellOutputItem(q.mime,q.value,q.metadata)}pe.to=se})(ae=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ke;(function(pe){function ce(q){return{outputId:q.id,outputs:q.outputs.map(ae.from),metadata:q.metadata}}pe.from=ce;function se(q){const Me=q.outputs.map(ae.to);return new o.NotebookCellOutput(Me,q.outputId,q.metadata)}pe.to=se})(ke=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ie;(function(pe){function ce(Te){if(Te!=null){if(Te instanceof o.RelativePattern||typeof Te=="string")return Te;if(Me(Te))return new o.RelativePattern(Te.base,Te.pattern);if(q(Te))return{include:Ze.from(Te.include)||void 0,exclude:Ze.from(Te.exclude)||void 0}}}pe.from=ce;function se(Te){return typeof Te=="string"?Te:Me(Te)?{base:Te.base,pattern:Te.pattern}:{include:Te.include,exclude:Te.exclude}}pe.to=se;function q(Te){const Je=Te,et=Ze.from(Je.include);if(!(et&&et instanceof o.RelativePattern||typeof et=="string"))return!1;const ct=Ze.from(Je.exclude);return!!(ct&&ct instanceof o.RelativePattern||typeof ct=="string")}function Me(Te){const Je=Te;return Je&&typeof Je.base=="string"&&typeof Je.pattern=="string"}})(Ie=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ae;(function(pe){function ce(se){return{backgroundColor:se.backgroundColor,borderColor:se.borderColor,top:se.top?h.from(se.top):void 0}}pe.from=ce})(Ae=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var xe;(function(pe){function ce(se,q,Me){const Te=typeof se.command=="string"?{title:"",command:se.command}:se.command;return{alignment:se.alignment===o.NotebookCellStatusBarAlignment.Left?1:2,command:q.toInternal(Te,Me),text:se.text,tooltip:se.tooltip,accessibilityInformation:se.accessibilityInformation,priority:se.priority}}pe.from=ce})(xe=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Ye;(function(pe){function ce(se){var q,Me;return{transientOutputs:(q=se==null?void 0:se.transientOutputs)!==null&&q!==void 0?q:!1,transientCellMetadata:Object.assign(Object.assign({},se==null?void 0:se.transientCellMetadata),{executionOrder:!0,runState:!0,runStartTime:!0,runStartTimeAdjustment:!0,runEndTime:!0,lastRunSuccess:!0}),transientDocumentMetadata:(Me=se==null?void 0:se.transientDocumentMetadata)!==null&&Me!==void 0?Me:{}}}pe.from=ce})(Ye=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var rt;(function(pe){function ce(q){var Me;return{uri:q.uri,provides:typeof q.provides=="string"?[q.provides]:(Me=q.provides)!==null&&Me!==void 0?Me:[]}}pe.from=ce;function se(q){return new o.NotebookKernelPreload(S.URI.revive(q.uri),q.provides)}pe.to=se})(rt=e.NotebookKernelPreload||(e.NotebookKernelPreload={}));var tt;(function(pe){function ce(q){return{message:c.fromStrict(q.message)||"",severity:q.severity,expectedOutput:q.expectedOutput,actualOutput:q.actualOutput,location:q.location?x.from(q.location):void 0}}pe.from=ce;function se(q){const Me=new o.TestMessage(typeof q.message=="string"?q.message:c.to(q.message));return Me.severity=q.severity,Me.actualOutput=q.actualOutput,Me.expectedOutput=q.expectedOutput,Me}pe.to=se})(tt=e.TestMessage||(e.TestMessage={}));var Qe;(function(pe){function ce(Te){var Je,et;return{extId:Te.id,label:Te.label,uri:Te.uri,range:g.from(Te.range)||null,debuggable:(Je=Te.debuggable)!==null&&Je!==void 0?Je:!1,description:Te.description||null,runnable:(et=Te.runnable)!==null&&et!==void 0?et:!0,error:Te.error&&c.fromStrict(Te.error)||null}}pe.from=ce;function se(Te){return{extId:Te.id,label:Te.label,uri:Te.uri,range:g.from(Te.range)||null,debuggable:!1,description:Te.description||null,error:null,runnable:!0}}pe.fromResultSnapshot=se;function q(Te){return{id:Te.extId,label:Te.label,uri:S.URI.revive(Te.uri),range:g.to(Te.range||void 0),addChild:()=>{},dispose:()=>{},status:o.TestItemStatus.Pending,data:void 0,debuggable:Te.debuggable,description:Te.description||void 0,runnable:Te.runnable}}pe.toPlain=q;function Me(Te){const Je=new o.TestItemImpl(Te.extId,Te.label,S.URI.revive(Te.uri),void 0);return Je.range=g.to(Te.range||void 0),Je.debuggable=Te.debuggable,Je.description=Te.description||void 0,Je.runnable=Te.runnable,Je}pe.to=Me})(Qe=e.TestItem||(e.TestItem={}));var mt;(function(pe){const ce=(q,Me)=>Object.assign(Object.assign({},Qe.toPlain(q.item)),{taskStates:q.tasks.map(Te=>({state:Te.state,duration:Te.duration,messages:Te.messages.map(tt.to)})),children:q.children.map(Te=>Me.get(Te)).filter(D.isDefined).map(Te=>ce(Te,Me))});function se(q){const Me=[],Te=new Map;for(const Je of q.items)Te.set(Je.item.extId,Je),Je.direct&&Me.push(Je);return{completedAt:q.completedAt,results:Me.map(Je=>ce(Je,Te))}}pe.to=se})(mt=e.TestResults||(e.TestResults={}));var bt;(function(pe){function ce(se){switch(se){case 1:return o.CodeActionTriggerKind.Invoke;case 2:return o.CodeActionTriggerKind.Automatic}}pe.to=ce})(bt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(ve[176],be([0,1,2,12,7,9,45]),function(J,e,_,k,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class D{constructor(C,i,I,d={timeout:1500,errors:3}){this._logService=C,this._documents=i,this._mainThreadBulkEdits=I,this._thresholds=d,this._callbacks=new y.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(C){return(i,I,d)=>{const r={dispose:this._callbacks.push([i,I,C])};return Array.isArray(d)&&d.push(r),r}}async $participateInSave(C,i){const I=_.URI.revive(C);let d=!1;const f=setTimeout(()=>d=!0,this._thresholds.timeout),r=[];try{for(let o of[...this._callbacks]){if(d)break;const p=this._documents.getDocument(I),g=await this._deliverEventAsyncAndBlameBadListeners(o,{document:p,reason:T.TextDocumentSaveReason.to(i)});r.push(g)}}finally{clearTimeout(f)}return r}_deliverEventAsyncAndBlameBadListeners([C,i,I],d){const f=this._badListeners.get(C);return typeof f=="number"&&f>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,C,i,d).then(()=>!0,r=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const o=this._badListeners.get(C);this._badListeners.set(C,o?o+1:1),typeof o=="number"&&o>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(C,i,I,d){const f=[],r=Date.now(),{document:o,reason:p}=d,{version:g}=o,E=Object.freeze({document:o,reason:p,waitUntil(m){if(Object.isFrozen(f))throw(0,k.illegalState)("waitUntil can not be called async");f.push(Promise.resolve(m))}});try{i.apply(I,[E])}catch(m){return Promise.reject(m)}return Object.freeze(f),new Promise((m,u)=>{const w=setTimeout(()=>u(new Error("timeout")),this._thresholds.timeout);return Promise.all(f).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(w),m(t)}).catch(t=>{clearTimeout(w),u(t)})}).then(m=>{const u={edits:[]};for(const w of m)if(Array.isArray(w)&&w.every(t=>t instanceof A.TextEdit))for(const{newText:t,newEol:n,range:l}of w)u.edits.push({_type:2,resource:o.uri,edit:{range:l&&T.Range.from(l),text:t,eol:n&&T.EndOfLine.from(n)}});if(u.edits.length!==0)return g===o.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(u):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=D}),define(ve[177],be([0,1,3,11,28,2,9,7]),function(J,e,_,k,A,T,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{constructor(I,d,f,r,o){this._onDidCreate=new _.Emitter,this._onDidChange=new _.Emitter,this._onDidDelete=new _.Emitter,this._config=0,f&&(this._config+=1),r&&(this._config+=2),o&&(this._config+=4);const p=(0,A.parse)(d),g=I(E=>{if(!f)for(let m of E.created){const u=T.URI.revive(m);p(u.fsPath)&&this._onDidCreate.fire(u)}if(!r)for(let m of E.changed){const u=T.URI.revive(m);p(u.fsPath)&&this._onDidChange.fire(u)}if(!o)for(let m of E.deleted){const u=T.URI.revive(m);p(u.fsPath)&&this._onDidDelete.fire(u)}});this._disposable=D.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,g)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class C{constructor(I,d,f){this._logService=d,this._extHostDocumentsAndEditors=f,this._onFileSystemEvent=new _.Emitter,this._onDidRenameFile=new _.Emitter,this._onDidCreateFile=new _.Emitter,this._onDidDeleteFile=new _.Emitter,this._onWillRenameFile=new k.AsyncEmitter,this._onWillCreateFile=new k.AsyncEmitter,this._onWillDeleteFile=new k.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(I,d,f,r){return new S(this._onFileSystemEvent.event,I,d,f,r)}$onFileEvent(I){this._onFileSystemEvent.fire(I)}$onDidRunFileOperation(I,d){switch(I){case 2:this._onDidRenameFile.fire(Object.freeze({files:d.map(f=>({oldUri:T.URI.revive(f.source),newUri:T.URI.revive(f.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:d.map(f=>T.URI.revive(f.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:d.map(f=>T.URI.revive(f.target))}));break;default:}}getOnWillRenameFileEvent(I){return this._createWillExecuteEvent(I,this._onWillRenameFile)}getOnWillCreateFileEvent(I){return this._createWillExecuteEvent(I,this._onWillCreateFile)}getOnWillDeleteFileEvent(I){return this._createWillExecuteEvent(I,this._onWillDeleteFile)}_createWillExecuteEvent(I,d){return(f,r,o)=>{const p=function(E){f.call(r,E)};return p.extension=I,d.event(p,void 0,o)}}async $onWillRunFileOperation(I,d,f,r){switch(I){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:d.map(o=>({oldUri:T.URI.revive(o.source),newUri:T.URI.revive(o.target)}))},f,r);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:d.map(o=>T.URI.revive(o.target))},f,r);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:d.map(o=>T.URI.revive(o.target))},f,r)}}async _fireWillEvent(I,d,f,r){const o=new Set,p=[];if(await I.fireAsync(d,r,async(E,m)=>{var u;const w=Date.now(),t=await Promise.resolve(E);t instanceof D.WorkspaceEdit&&(p.push(t),o.add((u=m.extension.displayName)!==null&&u!==void 0?u:m.extension.identifier.value)),Date.now()-w>f&&this._logService.warn("SLOW file-participant",m.extension.identifier)}),!r.isCancellationRequested&&p.length!==0){const g={edits:[]};for(let E of p){let{edits:m}=y.WorkspaceEdit.from(E,this._extHostDocumentsAndEditors);g.edits=g.edits.concat(m)}return{edit:g,extensionNames:Array.from(o)}}}}e.ExtHostFileSystemEventService=C}),define(ve[178],be([0,1,19,23,2,9,7,73]),function(J,e,_,k,A,T,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class S{constructor(d,f,r,o){this.start=d,this.deletedCount=f,this.deletedItems=r,this.items=o}static asApiEvents(d){return d.map(f=>({start:f.start,deletedCount:f.deletedCount,deletedItems:f.deletedItems,items:f.items.map(r=>r.apiCell)}))}}class C{constructor(d,f,r){var o;this._notebook=d,this._extHostDocument=f,this._cellData=r,this.handle=r.handle,this.uri=A.URI.revive(r.uri),this.cellKind=r.cellKind,this._outputs=r.outputs.map(T.NotebookCellOutput.to),this._internalMetadata=(o=r.metadata)!==null&&o!==void 0?o:{},this._metadata=T.NotebookCellMetadata.to(this._internalMetadata),this._previousResult=T.NotebookCellPreviousExecutionResult.to(this._internalMetadata)}static asModelAddData(d,f){return{EOL:f.eol,lines:f.source,modeId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:d}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._cell){const d=this,f=this._extHostDocument.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._cell=Object.freeze({get index(){return d._notebook.getCellIndex(d)},notebook:d._notebook.apiNotebook,kind:T.NotebookCellKind.to(this._cellData.cellKind),document:f.document,get outputs(){return d._outputs.slice(0)},get metadata(){return d._metadata},get latestExecutionSummary(){return d._previousResult}})}return this._cell}setOutputs(d){this._outputs=d.map(T.NotebookCellOutput.to)}setOutputItems(d,f,r){const o=r.map(T.NotebookCellOutputItem.to),p=this._outputs.find(g=>g.id===d);p&&(f||(p.outputs.length=0),p.outputs.push(...o))}setMetadata(d){this._internalMetadata=d,this._metadata=T.NotebookCellMetadata.to(d),this._previousResult=T.NotebookCellPreviousExecutionResult.to(d)}}e.ExtHostCell=C;class i{constructor(d,f,r,o,p,g,E){this._proxy=d,this._textDocumentsAndEditors=f,this._textDocuments=r,this._emitter=o,this._viewType=p,this._metadata=g,this.uri=E,this.handle=i._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const d=this;this._notebook={get uri(){return d.uri},get version(){return d._versionId},get viewType(){return d._viewType},get isDirty(){return d._isDirty},get isUntitled(){return d.uri.scheme===_.Schemas.untitled},get isClosed(){return d._disposed},get metadata(){return d._metadata},get cellCount(){return d._cells.length},cellAt(f){return f=d._validateIndex(f),d._cells[f].apiCell},getCells(f){return(f?d._getCells(f):d._cells).map(o=>o.apiCell)},save(){return d._save()}}}return this._notebook}updateBackup(d){var f;(f=this._backup)===null||f===void 0||f.delete(),this._backup=d}disposeBackup(){var d;(d=this._backup)===null||d===void 0||d.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(d){d.metadata&&(this._metadata=this._metadata.with(d.metadata))}acceptModelChanged(d,f){this._versionId=d.versionId,this._isDirty=f;for(const r of d.rawEvents)r.kind===D.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(r.changes,!0),r.kind===D.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(r.changes,!1):r.kind===D.NotebookCellsChangeType.Move?this._moveCell(r.index,r.newIdx):r.kind===D.NotebookCellsChangeType.Output?this._setCellOutputs(r.index,r.outputs):r.kind===D.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(r.index,r.outputId,r.append,r.outputItems):r.kind===D.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(r.index,r.language):r.kind===D.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(r.index,r.metadata)}_validateIndex(d){return d=d|0,d<0?0:d>=this._cells.length?this._cells.length-1:d}_validateRange(d){let f=d.start|0,r=d.end|0;return f<0&&(f=0),r>this._cells.length&&(r=this._cells.length),d.with({start:f,end:r})}_getCells(d){d=this._validateRange(d);const f=[];for(let r=d.start;r<d.end;r++)f.push(this._cells[r]);return f}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(d,f){if(!this._disposed){const r=[],o=[],p=[];d.reverse().forEach(g=>{const m=g[2].map(t=>{const n=new C(this,this._textDocumentsAndEditors,t);return f||o.push(C.asModelAddData(this.apiNotebook,t)),n}),u=new S(g[0],g[1],[],m),w=this._cells.splice(g[0],g[1],...m);for(let t of w)p.push(t.uri),u.deletedItems.push(t.apiCell);r.push(u)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:o,removedDocuments:p}),f||this._emitter.emitModelChange((0,k.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(r)}))}}_moveCell(d,f){const r=this._cells.splice(d,1);this._cells.splice(f,0,...r);const o=[new S(d,1,r.map(p=>p.apiCell),[]),new S(f,0,[],r)];this._emitter.emitModelChange((0,k.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(o)}))}_setCellOutputs(d,f){const r=this._cells[d];r.setOutputs(f),this._emitter.emitCellOutputsChange((0,k.deepFreeze)({document:this.apiNotebook,cells:[r.apiCell]}))}_setCellOutputItems(d,f,r,o){const p=this._cells[d];p.setOutputItems(f,r,o),this._emitter.emitCellOutputsChange((0,k.deepFreeze)({document:this.apiNotebook,cells:[p.apiCell]}))}_changeCellLanguage(d,f){const r=this._cells[d];r.apiCell.document.languageId!==f&&this._textDocuments.$acceptModelModeChanged(r.uri,f)}_changeCellMetadata(d,f){var r;const o=this._cells[d],p=o.internalMetadata,g=o.apiCell.metadata;o.setMetadata(f);const E=o.apiCell.metadata;if((0,k.equals)(g,E)||this._emitter.emitCellMetadataChange((0,k.deepFreeze)({document:this.apiNotebook,cell:o.apiCell})),p.runState!==f.runState){const m=(r=f.runState)!==null&&r!==void 0?r:y.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,k.deepFreeze)({document:this.apiNotebook,cell:o.apiCell,executionState:m}))}}getCellFromIndex(d){return this._cells[d]}getCell(d){return this._cells.find(f=>f.handle===d)}getCellIndex(d){return this._cells.indexOf(d)}}e.ExtHostNotebookDocument=i,i._handlePool=0}),define(ve[179],be([0,1,7,9]),function(J,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(D){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=D}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(D){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:D})}replaceCellMetadata(D,S){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:D,metadata:S})}replaceCells(D,S,C){this._throwIfFinalized(),!(D===S&&C.length===0)&&this._collectedEdits.push({editType:1,index:D,count:S-D,cells:C.map(k.NotebookCellData.from)})}}class T{constructor(D,S,C,i,I,d){this.id=D,this._proxy=S,this.notebookData=C,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=I,this._visibleRanges=i,this._viewColumn=d}get apiEditor(){if(!this._editor){const D=this;this._editor={get document(){return D.notebookData.apiNotebook},get selections(){return D._selections},get visibleRanges(){return D._visibleRanges},revealRange(S,C){D._proxy.$tryRevealRange(D.id,k.NotebookRange.from(S),C!=null?C:_.NotebookEditorRevealType.Default)},get viewColumn(){return D._viewColumn},edit(S){const C=new A(this.document.version);return S(C),D._applyEdit(C.finalize())},setDecorations(S,C){return D.setDecorations(S,C)}}}return this._editor}get visible(){return this._visible}_acceptVisibility(D){this._visible=D}_acceptVisibleRanges(D){this._visibleRanges=D}_acceptSelections(D){this._selections=D}_acceptViewColumn(D){this._viewColumn=D}_applyEdit(D){if(D.cellEdits.length===0)return Promise.resolve(!0);const S=[];let C=-1;for(let i=0;i<D.cellEdits.length;i++){if(C<0){S.push(D.cellEdits[i]),C++;continue}const d=S[C],f=D.cellEdits[i];if(d.editType===1&&f.editType===1&&d.index===f.index){d.cells.push(...D.cellEdits[i].cells),d.count+=D.cellEdits[i].count;continue}S.push(D.cellEdits[i]),C++}return this._proxy.$tryApplyEdits(this.id,D.documentVersionId,S)}setDecorations(D,S){if(!(S.isEmpty&&!this._hasDecorationsForKey.has(D.key)))return S.isEmpty?this._hasDecorationsForKey.delete(D.key):this._hasDecorationsForKey.add(D.key),this._proxy.$trySetDecorations(this.id,k.NotebookRange.from(S),D.key)}}e.ExtHostNotebookEditor=T}),define(ve[180],be([0,1,9,153,133,20,52]),function(J,e,_,k,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class D{constructor(I){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=I}withProgress(I,d,f){const r=this._handles++,{title:o,location:p,cancellable:g}=d,E={label:(0,A.localize)(0,null,I.displayName||I.name),id:I.identifier.value};return this._proxy.$startProgress(r,{location:_.ProgressLocation.from(p),title:o,source:E,cancellable:g},I),this._withProgress(r,f,!!g)}_withProgress(I,d,f){let r;f&&(r=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(I,r));const o=g=>{this._proxy.$progressEnd(g),this._mapHandleToCancellationSource.delete(g),r&&r.dispose()};let p;try{p=d(new C(this._proxy,I),f&&r?r.token:T.CancellationToken.None)}catch(g){throw o(I),g}return p.then(g=>o(I),g=>o(I)),p}$acceptProgressCanceled(I){const d=this._mapHandleToCancellationSource.get(I);d&&(d.cancel(),this._mapHandleToCancellationSource.delete(I))}}e.ExtHostProgress=D;function S(i,I){return i.message=I.message,typeof I.increment=="number"&&(typeof i.increment=="number"?i.increment+=I.increment:i.increment=I.increment),i}class C extends k.Progress{constructor(I,d){super(f=>this.throttledReport(f));this._proxy=I,this._handle=d}throttledReport(I){this._proxy.$progressReport(this._handle,I)}}je([(0,y.throttle)(100,(i,I)=>S(i,I),()=>Object.create(null))],C.prototype,"throttledReport",null)}),define(ve[97],be([0,1,42,12,54,9,7]),function(J,e,_,k,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class D{constructor(d,f){const r=D._Keys.nextId();d.$registerTextEditorDecorationType(r,T.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:r,dispose(){d.$removeTextEditorDecorationType(r)}})}}e.TextEditorDecorationType=D,D._Keys=new A.IdGenerator("TextEditorDecorationType");class S{constructor(d,f){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=d,this._documentVersionId=d.version,this._undoStopBefore=f.undoStopBefore,this._undoStopAfter=f.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(d,f){this._throwIfFinalized();let r=null;if(d instanceof y.Position)r=new y.Range(d,d);else if(d instanceof y.Range)r=d;else throw new Error("Unrecognized location");this._pushEdit(r,f,!1)}insert(d,f){this._throwIfFinalized(),this._pushEdit(new y.Range(d,d),f,!0)}delete(d){this._throwIfFinalized();let f=null;if(d instanceof y.Range)f=d;else throw new Error("Unrecognized location");this._pushEdit(f,null,!0)}_pushEdit(d,f,r){const o=this._document.validateRange(d);this._collectedEdits.push({range:o,text:f,forceMoveMarkers:r})}setEndOfLine(d){if(this._throwIfFinalized(),d!==y.EndOfLine.LF&&d!==y.EndOfLine.CRLF)throw(0,k.illegalArgument)("endOfLine");this._setEndOfLine=d}}e.TextEditorEdit=S;class C{constructor(d,f,r,o){this._proxy=d,this._id=f,this._accept(r),this._logService=o;const p=this;this.value={get tabSize(){return p._tabSize},set tabSize(g){p._setTabSize(g)},get insertSpaces(){return p._insertSpaces},set insertSpaces(g){p._setInsertSpaces(g)},get cursorStyle(){return p._cursorStyle},set cursorStyle(g){p._setCursorStyle(g)},get lineNumbers(){return p._lineNumbers},set lineNumbers(g){p._setLineNumbers(g)}}}_accept(d){this._tabSize=d.tabSize,this._insertSpaces=d.insertSpaces,this._cursorStyle=d.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(d.lineNumbers)}_validateTabSize(d){if(d==="auto")return"auto";if(typeof d=="number"){const f=Math.floor(d);return f>0?f:null}if(typeof d=="string"){const f=parseInt(d,10);return isNaN(f)?null:f>0?f:null}return null}_setTabSize(d){const f=this._validateTabSize(d);if(f!==null){if(typeof f=="number"){if(this._tabSize===f)return;this._tabSize=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:f}))}}_validateInsertSpaces(d){return d==="auto"?"auto":d==="false"?!1:Boolean(d)}_setInsertSpaces(d){const f=this._validateInsertSpaces(d);if(typeof f=="boolean"){if(this._insertSpaces===f)return;this._insertSpaces=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:f}))}_setCursorStyle(d){this._cursorStyle!==d&&(this._cursorStyle=d,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:d})))}_setLineNumbers(d){this._lineNumbers!==d&&(this._lineNumbers=d,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(d)})))}assign(d){const f={};let r=!1;if(typeof d.tabSize!="undefined"){const o=this._validateTabSize(d.tabSize);o==="auto"?(r=!0,f.tabSize=o):typeof o=="number"&&this._tabSize!==o&&(this._tabSize=o,r=!0,f.tabSize=o)}if(typeof d.insertSpaces!="undefined"){const o=this._validateInsertSpaces(d.insertSpaces);o==="auto"?(r=!0,f.insertSpaces=o):this._insertSpaces!==o&&(this._insertSpaces=o,r=!0,f.insertSpaces=o)}typeof d.cursorStyle!="undefined"&&this._cursorStyle!==d.cursorStyle&&(this._cursorStyle=d.cursorStyle,r=!0,f.cursorStyle=d.cursorStyle),typeof d.lineNumbers!="undefined"&&this._lineNumbers!==d.lineNumbers&&(this._lineNumbers=d.lineNumbers,r=!0,f.lineNumbers=T.TextEditorLineNumbersStyle.from(d.lineNumbers)),r&&this._warnOnError(this._proxy.$trySetOptions(this._id,f))}_warnOnError(d){d.catch(f=>this._logService.warn(f))}}e.ExtHostTextEditorOptions=C;class i{constructor(d,f,r,o,p,g,E,m){this.id=d,this._proxy=f,this._logService=r,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=p,this._options=new C(this._proxy,this.id,g,r),this._visibleRanges=E,this._viewColumn=m;const u=this;this.value=Object.freeze({get document(){return o.getValue()},set document(w){throw(0,k.readonly)("document")},get selection(){return u._selections&&u._selections[0]},set selection(w){if(!(w instanceof y.Selection))throw(0,k.illegalArgument)("selection");u._selections=[w],u._trySetSelection()},get selections(){return u._selections},set selections(w){if(!Array.isArray(w)||w.some(t=>!(t instanceof y.Selection)))throw(0,k.illegalArgument)("selections");u._selections=w,u._trySetSelection()},get visibleRanges(){return u._visibleRanges},set visibleRanges(w){throw(0,k.readonly)("visibleRanges")},get options(){return u._options.value},set options(w){u._disposed||u._options.assign(w)},get viewColumn(){return u._viewColumn},set viewColumn(w){throw(0,k.readonly)("viewColumn")},edit(w,t={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new S(o.getValue(),t);return w(n),u._applyEdit(n)},insertSnippet(w,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let l;if(!t||Array.isArray(t)&&t.length===0)l=u._selections.map(a=>T.Range.from(a));else if(t instanceof y.Position){const{lineNumber:a,column:s}=T.Position.from(t);l=[{startLineNumber:a,startColumn:s,endLineNumber:a,endColumn:s}]}else if(t instanceof y.Range)l=[T.Range.from(t)];else{l=[];for(const a of t)if(a instanceof y.Range)l.push(T.Range.from(a));else{const{lineNumber:s,column:c}=T.Position.from(a);l.push({startLineNumber:s,startColumn:c,endLineNumber:s,endColumn:c})}}return f.$tryInsertSnippet(d,w.value,l,n)},setDecorations(w,t){const n=t.length===0;n&&!u._hasDecorationsForKey.has(w.key)||(n?u._hasDecorationsForKey.delete(w.key):u._hasDecorationsForKey.add(w.key),u._runOnProxy(()=>{if(T.isDecorationOptionsArr(t))return f.$trySetDecorations(d,w.key,T.fromRangeOrRangeWithMessage(t));{const l=new Array(4*t.length);for(let a=0,s=t.length;a<s;a++){const c=t[a];l[4*a]=c.start.line+1,l[4*a+1]=c.start.character+1,l[4*a+2]=c.end.line+1,l[4*a+3]=c.end.character+1}return f.$trySetDecorationsFast(d,w.key,l)}}))},revealRange(w,t){u._runOnProxy(()=>f.$tryRevealRange(d,T.Range.from(w),t||y.TextEditorRevealType.Default))},show(w){f.$tryShowEditor(d,T.ViewColumn.from(w))},hide(){f.$tryHideEditor(d)}})}dispose(){(0,_.ok)(!this._disposed),this._disposed=!0}_acceptOptions(d){(0,_.ok)(!this._disposed),this._options._accept(d)}_acceptVisibleRanges(d){(0,_.ok)(!this._disposed),this._visibleRanges=d}_acceptViewColumn(d){(0,_.ok)(!this._disposed),this._viewColumn=d}_acceptSelections(d){(0,_.ok)(!this._disposed),this._selections=d}async _trySetSelection(){const d=this._selections.map(T.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,d)),this.value}_applyEdit(d){const f=d.finalize();if(f.edits.length===0&&!f.setEndOfLine)return Promise.resolve(!0);const r=f.edits.map(p=>p.range);r.sort((p,g)=>p.end.line===g.end.line?p.end.character===g.end.character?p.start.line===g.start.line?p.start.character-g.start.character:p.start.line-g.start.line:p.end.character-g.end.character:p.end.line-g.end.line);for(let p=0,g=r.length-1;p<g;p++){const E=r[p].end;if(r[p+1].start.isBefore(E))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const o=f.edits.map(p=>({range:T.Range.from(p.range),text:p.text,forceMoveMarkers:p.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,f.documentVersionId,o,{setEndOfLine:typeof f.setEndOfLine=="number"?T.EndOfLine.from(f.setEndOfLine):void 0,undoStopBefore:f.undoStopBefore,undoStopAfter:f.undoStopAfter})}_runOnProxy(d){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):d().then(()=>this,f=>(f instanceof Error&&f.name==="DISPOSED"||this._logService.warn(f),null))}}e.ExtHostTextEditor=i}),define(ve[181],be([0,1,136,25,2,3,6,11,7,10,15,9,20]),function(J,e,_,k,A,T,y,D,S,C,i,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function f(p,g){if((0,C.isString)(p))return{label:p};if(p&&typeof p=="object"&&typeof p.label=="string"){let E;return Array.isArray(p.highlights)&&(E=p.highlights.filter(m=>m.length===2&&typeof m[0]=="number"&&typeof m[1]=="number"),E=E.length?E:void 0),{label:p.label,highlights:E}}}class r{constructor(g,E,m){this._proxy=g,this.commands=E,this.logService=m,this.treeViews=new Map;function u(w){return w&&w.$treeViewId&&w.$treeItemHandle}E.registerArgumentProcessor({processArgument:w=>u(w)?this.convertArgument(w):Array.isArray(w)&&w.length>0?w.map(t=>u(t)?this.convertArgument(t):t):w})}registerTreeDataProvider(g,E,m){const u=this.createTreeView(g,{treeDataProvider:E},m);return{dispose:()=>u.dispose()}}createTreeView(g,E,m){if(!E||!E.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=this._proxy.$registerTreeViewDataProvider(g,{showCollapseAll:!!E.showCollapseAll,canSelectMany:!!E.canSelectMany,canDragAndDrop:!!E.canDragAndDrop}),w=this.createExtHostTreeView(g,E,m);return{get onDidCollapseElement(){return w.onDidCollapseElement},get onDidExpandElement(){return w.onDidExpandElement},get selection(){return w.selectedElements},get onDidChangeSelection(){return w.onDidChangeSelection},get visible(){return w.visible},get onDidChangeVisibility(){return w.onDidChangeVisibility},get message(){return w.message},set message(t){w.message=t},get title(){return w.title},set title(t){w.title=t},get description(){return w.description},set description(t){w.description=t},reveal:(t,n)=>w.reveal(t,n),dispose:async()=>{await u,this.treeViews.delete(g),w.dispose()}}}$getChildren(g,E){const m=this.treeViews.get(g);return m?m.getChildren(E):Promise.reject(new Error((0,_.localize)(0,null,g)))}$setParent(g,E,m){const u=this.treeViews.get(g);return u?u.setParent(E,m):Promise.reject(new Error((0,_.localize)(1,null,g)))}async $hasResolve(g){const E=this.treeViews.get(g);if(!E)throw new Error((0,_.localize)(2,null,g));return E.hasResolve}$resolve(g,E,m){const u=this.treeViews.get(g);if(!u)throw new Error((0,_.localize)(3,null,g));return u.resolveTreeItem(E,m)}$setExpanded(g,E,m){const u=this.treeViews.get(g);if(!u)throw new Error((0,_.localize)(4,null,g));u.setExpanded(E,m)}$setSelection(g,E){const m=this.treeViews.get(g);if(!m)throw new Error((0,_.localize)(5,null,g));m.setSelection(E)}$setVisible(g,E){const m=this.treeViews.get(g);if(!m)throw new Error((0,_.localize)(6,null,g));m.setVisible(E)}createExtHostTreeView(g,E,m){const u=new o(g,E,this._proxy,this.commands.converter,this.logService,m);return this.treeViews.set(g,u),u}convertArgument(g){const E=this.treeViews.get(g.$treeViewId);return E?E.getExtensionElement(g.$treeItemHandle):null}}e.ExtHostTreeViews=r;class o extends y.Disposable{constructor(g,E,m,u,w,t){super();if(this.viewId=g,this.proxy=m,this.commands=u,this.logService=w,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new d.CancellationTokenSource,t.contributes&&t.contributes.views)for(const a in t.contributes.views)for(const s of t.contributes.views[a])s.id===g&&(this._title=s.name);this.dataProvider=E.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(a=>this._onDidChangeData.fire({message:!1,element:a})));let n,l;this._register(T.Event.debounce(this._onDidChangeData.event,(a,s)=>(a||(a={message:!1,elements:[]}),s.element!==!1&&(n||(n=new Promise(c=>l=c),this.refreshPromise=this.refreshPromise.then(()=>n)),a.elements.push(s.element)),s.message&&(a.message=!0),a),200,!0)(({message:a,elements:s})=>{s.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const c=l;return n=null,this.refresh(s).then(()=>c())})),a&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(g=>this.getExtensionElement(g)).filter(g=>!(0,C.isUndefinedOrNull)(g))}getChildren(g){const E=g?this.getExtensionElement(g):void 0;if(g&&!E)return this.logService.error(`No tree item with id '${g}' found.`),Promise.resolve([]);const m=this.getChildrenNodes(g);return(m?Promise.resolve(m):this.fetchChildrenNodes(E)).then(u=>u.map(w=>w.item))}getExtensionElement(g){return this.elements.get(g)}reveal(g,E){E=E||{select:!0,focus:!1};const m=(0,C.isUndefinedOrNull)(E.select)?!0:E.select,u=(0,C.isUndefinedOrNull)(E.focus)?!1:E.focus,w=(0,C.isUndefinedOrNull)(E.expand)?!1:E.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):g?this.refreshPromise.then(()=>this.resolveUnknownParentChain(g)).then(t=>this.resolveTreeNode(g,t[t.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:t.map(l=>l.item)},{select:m,focus:u,expand:w})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:m,focus:u,expand:w})}get message(){return this._message}set message(g){this._message=g,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(g){this._title=g,this.proxy.$setTitle(this.viewId,g,this._description)}get description(){return this._description}set description(g){this._description=g,this.proxy.$setTitle(this.viewId,this._title,g)}setExpanded(g,E){const m=this.getExtensionElement(g);m&&(E?this._onDidExpandElement.fire(Object.freeze({element:m})):this._onDidCollapseElement.fire(Object.freeze({element:m})))}setSelection(g){(0,i.equals)(this._selectedHandles,g)||(this._selectedHandles=g,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(g){g!==this._visible&&(this._visible=g,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}setParent(g,E){const m=g.map(w=>this.getExtensionElement(w)).filter(w=>!(0,C.isUndefinedOrNull)(w)),u=this.getExtensionElement(E);return this.dataProvider.setParent&&m&&u?(0,D.asPromise)(()=>this.dataProvider.setParent(m,u)):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(g,E){var m;if(!!this.dataProvider.resolveTreeItem){const u=this.elements.get(g);if(u){const w=this.nodes.get(u);if(w){const t=(m=await this.dataProvider.resolveTreeItem(w.extensionItem,u,E))!==null&&m!==void 0?m:w.extensionItem;return w.item.tooltip=this.getTooltip(t.tooltip),w.item.command=this.getCommand(w.disposableStore,t.command),w.item}}}}resolveUnknownParentChain(g){return this.resolveParent(g).then(E=>E?this.resolveUnknownParentChain(E).then(m=>this.resolveTreeNode(E,m[m.length-1]).then(u=>(m.push(u),m))):Promise.resolve([]))}resolveParent(g){const E=this.nodes.get(g);return E?Promise.resolve(E.parent?this.elements.get(E.parent.item.handle):void 0):(0,D.asPromise)(()=>this.dataProvider.getParent(g))}resolveTreeNode(g,E){const m=this.nodes.get(g);return m?Promise.resolve(m):(0,D.asPromise)(()=>this.dataProvider.getTreeItem(g)).then(u=>this.createHandle(g,u,E,!0)).then(u=>this.getChildren(E?E.item.handle:void 0).then(()=>{const w=this.getExtensionElement(u);if(w){const t=this.nodes.get(w);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${u}`)}))}getChildrenNodes(g){if(g){let E;if(typeof g=="string"){const m=this.getExtensionElement(g);E=m?this.nodes.get(m):void 0}else E=g;return E&&E.children||null}return this.roots}async fetchChildrenNodes(g){this.clearChildren(g);const E=new d.CancellationTokenSource(this._refreshCancellationSource.token);try{const m=g?this.nodes.get(g):void 0,u=await this.dataProvider.getChildren(g);if(E.token.isCancellationRequested)return[];const w=await Promise.all((0,i.coalesce)(u||[]).map(async t=>{const n=await this.dataProvider.getTreeItem(t);return n&&!E.token.isCancellationRequested?this.createAndRegisterTreeNode(t,n,m):null}));return E.token.isCancellationRequested?[]:(0,i.coalesce)(w)}finally{E.dispose()}}refresh(g){if(g.some(m=>!m))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new d.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const m=this.getHandlesToRefresh(g);if(m.length)return this.refreshHandles(m)}return Promise.resolve(void 0)}getHandlesToRefresh(g){const E=new Set,m=g.map(w=>this.nodes.get(w));for(const w of m)if(w&&!E.has(w.item.handle)){let t=w;for(;t&&t.parent&&m.findIndex(n=>t&&t.parent&&n&&n.item.handle===t.parent.item.handle)===-1;){const n=this.elements.get(t.parent.item.handle);t=n?this.nodes.get(n):void 0}t&&!t.parent&&E.add(w.item.handle)}const u=[];return E.forEach(w=>{const t=this.elements.get(w);if(t){const n=this.nodes.get(t);n&&(!n.parent||!E.has(n.parent.item.handle))&&u.push(w)}}),u}refreshHandles(g){const E={};return Promise.all(g.map(m=>this.refreshNode(m).then(u=>{u&&(E[m]=u.item)}))).then(()=>Object.keys(E).length?this.proxy.$refresh(this.viewId,E):void 0)}refreshNode(g){const E=this.getExtensionElement(g);if(E){const m=this.nodes.get(E);if(m)return this.clearChildren(E),(0,D.asPromise)(()=>this.dataProvider.getTreeItem(E)).then(u=>{if(u){const w=this.createTreeNode(E,u,m.parent);return this.updateNodeCache(E,w,m,m.parent),m.dispose(),w}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(g,E,m){const u=this.createTreeNode(g,E,m);if(E.id&&this.elements.has(u.item.handle))throw new Error((0,_.localize)(7,null,E.id));return this.addNodeToCache(g,u),this.addNodeToParentCache(u,m),u}getTooltip(g){return S.MarkdownString.isMarkdownString(g)?I.MarkdownString.from(g):g}getCommand(g,E){return E?this.commands.toInternal(E,g):void 0}createTreeNode(g,E,m){const u=new y.DisposableStore,w=this.createHandle(g,E,m),t=this.getLightIconPath(E);return{item:{handle:w,parentHandle:m?m.item.handle:void 0,label:f(E.label,this.extension),description:E.description,resourceUri:E.resourceUri,tooltip:this.getTooltip(E.tooltip),command:this.getCommand(u,E.command),contextValue:E.contextValue,icon:t,iconDark:this.getDarkIconPath(E)||t,themeIcon:this.getThemeIcon(E),collapsibleState:(0,C.isUndefinedOrNull)(E.collapsibleState)?S.TreeItemCollapsibleState.None:E.collapsibleState,accessibilityInformation:E.accessibilityInformation},extensionItem:E,parent:m,children:void 0,disposableStore:u,dispose(){u.dispose()}}}getThemeIcon(g){return g.iconPath instanceof S.ThemeIcon?g.iconPath:void 0}createHandle(g,{id:E,label:m,resourceUri:u},w,t){if(E)return`${o.ID_HANDLE_PREFIX}/${E}`;const n=f(m,this.extension),l=w?w.item.handle:o.LABEL_HANDLE_PREFIX;let a=n?n.label:u?(0,k.basename)(u):"";a=a.indexOf("/")!==-1?a.replace("/","//"):a;const s=this.nodes.has(g)?this.nodes.get(g).item.handle:void 0,c=this.getChildrenNodes(w)||[];let v,P=0;do{if(v=`${l}/${P}:${a}`,t||!this.elements.has(v)||s===v)break;P++}while(P<=c.length);return v}getLightIconPath(g){if(g.iconPath&&!(g.iconPath instanceof S.ThemeIcon))return typeof g.iconPath=="string"||A.URI.isUri(g.iconPath)?this.getIconPath(g.iconPath):this.getIconPath(g.iconPath.light)}getDarkIconPath(g){if(g.iconPath&&!(g.iconPath instanceof S.ThemeIcon)&&g.iconPath.dark)return this.getIconPath(g.iconPath.dark)}getIconPath(g){return A.URI.isUri(g)?g:A.URI.file(g)}addNodeToCache(g,E){this.elements.set(E.item.handle,g),this.nodes.set(g,E)}updateNodeCache(g,E,m,u){this.elements.delete(E.item.handle),this.nodes.delete(g),E.item.handle!==m.item.handle&&this.elements.delete(m.item.handle),this.addNodeToCache(g,E);const w=this.getChildrenNodes(u)||[],t=w.filter(n=>n.item.handle===m.item.handle)[0];t&&w.splice(w.indexOf(t),1,E)}addNodeToParentCache(g,E){E?(E.children||(E.children=[]),E.children.push(g)):(this.roots||(this.roots=[]),this.roots.push(g))}clearChildren(g){if(g){const E=this.nodes.get(g);if(E){if(E.children)for(const m of E.children){const u=this.elements.get(m.item.handle);u&&this.clear(u)}E.children=void 0}}else this.clearAll()}clear(g){const E=this.nodes.get(g);if(E){if(E.children)for(const m of E.children){const u=this.elements.get(m.item.handle);u&&this.clear(u)}this.nodes.delete(g),this.elements.delete(E.item.handle),E.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(g=>g.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}o.LABEL_HANDLE_PREFIX="0",o.ID_HANDLE_PREFIX="1"}),define(ve[182],be([0,1,15,11,20,10,69,9,7,96]),function(J,e,_,k,A,T,y,D,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class i{constructor(){this.testIdsToInternal=new Map}getTestById(p,g){if(g!==void 0){const E=this.testIdsToInternal.get(g),m=E==null?void 0:E.get(p);if(m)return[E,m]}return(0,_.mapFind)(this.testIdsToInternal.values(),E=>{const m=E.get(p);return m&&[E,m]})}createForHierarchy(p=()=>{}){return new r(this.createIdMap(d++),p)}createIdMap(p){const g=new f(p);return this.testIdsToInternal.set(g.id,g),{object:g,dispose:()=>this.testIdsToInternal.delete(g.id)}}}e.OwnedTestCollection=i;var I;(function(o){o[o.Disconnected=0]="Disconnected",o[o.IsChild=1]="IsChild",o[o.IsParent=2]="IsParent",o[o.IsSame=3]="IsSame"})(I=e.TestPosition||(e.TestPosition={}));let d=0;class f{constructor(p){this.id=p,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(p){if(this.map.has(p.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${p.item.extId}`);this.map.set(p.item.extId,p),p.parent||this._roots.add(p)}has(p){return this.map.has(p)}delete(p){const g=this.map.get(p);return g?(this.map.delete(p),this._roots.delete(g),!0):!1}get(p){return this.map.get(p)}comparePositions(p,g){const E=typeof p=="string"?this.map.get(p):p,m=typeof g=="string"?this.map.get(g):g;if(!E||!m)return 0;if(E===m)return 3;for(let u=this.map.get(m.parent);u;u=this.map.get(u.parent))if(u===E)return 1;for(let u=this.map.get(E.parent);u;u=this.map.get(u.parent))if(u===m)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=f;class r{constructor(p,g){this.testIdToInternal=p,this.publishDiff=g,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new k.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(p,g){this.addItem(p,g,null)}getTestByReference(p){return this.testItemToInternal.get(p)}collectDiff(){const p=this.diff;return this.diff=[],p}pushDiff(p){const g=this.diff[this.diff.length-1];if(g&&p[0]===1){if(g[0]===1&&g[1].extId===p[1].extId){(0,C.applyTestItemUpdate)(g[1],p[1]);return}if(g[0]===0&&g[1].item.extId===p[1].extId){(0,C.applyTestItemUpdate)(g[1],p[1]);return}}this.diff.push(p),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(p,g){var E;const m=this.testIdToInternal.object.get(p);if(!!m){if((m.expandLevels===void 0||g>m.expandLevels)&&(m.expandLevels=g),m.expand===1){const u=this.refreshChildren(m);return u.isSettled?this.expandChildren(m,g-1):u.p.then(()=>this.expandChildren(m,g-1))}else if(m.expand===3)return((E=m.initialExpand)===null||E===void 0?void 0:E.isSettled)===!1?m.initialExpand.p.then(()=>this.expandChildren(m,g-1)):this.expandChildren(m,g-1)}}dispose(){var p;for(const g of this.testItemToInternal.values())(p=g.discoverCts)===null||p===void 0||p.dispose(!0),(0,y.getPrivateApiFor)(g.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(p,g){const E=p==null?void 0:p.actual.id;switch(g[0]){case 2:this.pushDiff([4,E]);break;case 1:this.removeItem(p);break;case 0:this.addItem(g[1],p.src.controller,p);break;case 3:const[m,u,w]=g;switch(u){case"status":this.updateExpandability(p);break;case"range":this.pushDiff([1,{extId:E,item:{range:D.Range.from(w)}}]);break;case"error":this.pushDiff([1,{extId:E,item:{error:D.MarkdownString.fromStrict(w)||null}}]);break;default:this.pushDiff([1,{extId:E,item:{[u]:w!=null?w:null}}]);break}break;default:(0,T.assertNever)(g[0])}}addItem(p,g,E){if(!(p instanceof S.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${p.id} did not`);if(this.testItemToInternal.has(p))throw new Error(`Attempted to add a single TestItem ${p.id} multiple times to the tree`);if(this.testIdToInternal.object.has(p.id))throw new Error(`Attempted to insert a duplicate test item ID ${p.id}`);const m=E?E.item.extId:null,u=p.resolveHandler?1:0,w=E?E.expandLevels:1,t={controller:g,tree:this.testIdToInternal.object.id},n={actual:p,parent:m,item:D.TestItem.from(p),expandLevels:w?w-1:void 0,expand:0,src:t};this.testIdToInternal.object.add(n),this.testItemToInternal.set(p,n),this.pushDiff([0,{parent:m,src:t,expand:u,item:n.item}]);const l=(0,y.getPrivateApiFor)(p);l.parent=E==null?void 0:E.actual,l.bus.event(this.onTestItemEvent.bind(this,n)),this.updateExpandability(n);for(const a of l.children.values())this.testItemToInternal.has(a)||this.addItem(a,g,n)}updateExpandability(p){var g;let E;p.actual.resolveHandler?p.actual.status===S.TestItemStatus.Pending?E=p.discoverCts?2:1:((g=p.initialExpand)===null||g===void 0||g.complete(),E=3):E=0,E!==p.expand&&(p.expand=E,this.pushDiff([1,{extId:p.actual.id,expand:E}]),E===1&&p.expandLevels!==void 0&&this.refreshChildren(p))}expandChildren(p,g){if(!(g<0)){const E=[...p.actual.children.values()].map(m=>this.expand(m.id,g)).filter(k.isThenable);if(E.length)return Promise.all(E).then(()=>{})}}refreshChildren(p){if(p.discoverCts&&p.discoverCts.dispose(!0),!p.actual.resolveHandler){const g=new k.DeferredPromise;return g.complete(),g}return p.expand=2,p.discoverCts=new A.CancellationTokenSource,this.pushExpandStateUpdate(p),p.initialExpand=new k.DeferredPromise,p.actual.resolveHandler(p.discoverCts.token),p.initialExpand}pushExpandStateUpdate(p){this.pushDiff([1,{extId:p.actual.id,expand:p.expand}])}removeItem(p){var g;this.pushDiff([2,p.actual.id]);const E=[p];for(;E.length;){const m=E.pop();if(!!m){(g=m.discoverCts)===null||g===void 0||g.dispose(!0),this.testIdToInternal.object.delete(m.item.extId),this.testItemToInternal.delete(m.actual);for(const u of m.actual.children.values())E.push(this.testIdToInternal.object.get(u.id))}}}flushDiff(){const p=this.collectDiff();p.length&&this.publishDiff(p)}}e.SingleUseTestCollection=r}),define(ve[183],be([0,1,26,3,13]),function(J,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(i){this.removedDueToLooping=i}}e.DeltaExtensionsResult=T;class y{constructor(i){this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(_.ExtensionIdentifier.toKey(i.identifier))){console.error("Extension `"+i.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(_.ExtensionIdentifier.toKey(i.identifier),i),this._extensionsArr.push(i),Array.isArray(i.activationEvents))for(let I of i.activationEvents)I==="onUri"&&(I=`onUri:${_.ExtensionIdentifier.toKey(i.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(i)}}keepOnly(i){const I=new Set;i.forEach(d=>I.add(_.ExtensionIdentifier.toKey(d))),this._extensionDescriptions=this._extensionDescriptions.filter(d=>I.has(_.ExtensionIdentifier.toKey(d.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(i,I){i.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(i));const d=y._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(d.map(f=>f.identifier)),I.length>0){const f=new Set;I.forEach(r=>f.add(_.ExtensionIdentifier.toKey(r))),this._extensionDescriptions=this._extensionDescriptions.filter(r=>!f.has(_.ExtensionIdentifier.toKey(r.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new T(d)}static _findLoopingExtensions(i){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(p){this._nodesSet.has(p)||(this._nodesSet.add(p),this._nodesArr.push(p))}addArc(p,g){this.addNode(p),this.addNode(g),this._arcs.has(p)?this._arcs.get(p).push(g):this._arcs.set(p,[g])}getArcs(p){return this._arcs.has(p)?this._arcs.get(p):[]}hasOnlyGoodArcs(p,g){const E=I.getArcs(p);for(let m=0;m<E.length;m++)if(!g.has(E[m]))return!1;return!0}getNodes(){return this._nodesArr}};let d=new Map;for(let p of i){const g=_.ExtensionIdentifier.toKey(p.identifier);if(d.set(g,p),p.extensionDependencies)for(let E of p.extensionDependencies){const m=_.ExtensionIdentifier.toKey(E);I.addArc(g,m)}}let f=new Set;I.getNodes().filter(p=>I.getArcs(p).length===0).forEach(p=>f.add(p));let r=I.getNodes().filter(p=>!f.has(p)),o;do{o=!1;for(let p=0;p<r.length;p++){const g=r[p];I.hasOnlyGoodArcs(g,f)&&(r.splice(p,1),p--,f.add(g),o=!0)}}while(o);return r.map(p=>d.get(p))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(_.ExtensionIdentifier.toKey(i))}getExtensionDescriptionsForActivationEvent(i){const I=this._activationMap.get(i);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(i){const I=this._extensionsMap.get(_.ExtensionIdentifier.toKey(i));return I||void 0}}e.ExtensionDescriptionRegistry=y;var D;(function(C){C[C.Builtin=0]="Builtin",C[C.User=1]="User",C[C.Dev=2]="Dev"})(D||(D={}));function S(C,i){const I=C.isBuiltin?0:C.isUnderDevelopment?2:1,d=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(I!==d)return I-d;const f=A.posix.basename(C.extensionLocation.path),r=A.posix.basename(i.extensionLocation.path);return f<r?-1:f>r?1:0}}),define(ve[184],be([0,1,24]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var k;(function(D){D[D.VersionMismatch=55]="VersionMismatch",D[D.UnexpectedError=81]="UnexpectedError"})(k=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var A;(function(D){D[D.Initialized=0]="Initialized",D[D.Ready=1]="Ready",D[D.Terminate=2]="Terminate"})(A=e.MessageType||(e.MessageType={}));function T(D){const S=_.VSBuffer.alloc(1);switch(D){case 0:S.writeUInt8(1,0);break;case 1:S.writeUInt8(2,0);break;case 2:S.writeUInt8(3,0);break}return S}e.createMessageOfType=T;function y(D,S){if(D.byteLength!==1)return!1;switch(D.readUInt8(0)){case 1:return S===0;case 2:return S===1;case 3:return S===2;default:return!1}}e.isMessageOfType=y}),define(ve[33],be([0,1,3,2,4,26,150]),function(J,e,_,k,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:k.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,A.createDecorator)("extensionService");class D{constructor(E){this.dependency=E}}e.MissingExtensionDependency=D;var S;(function(g){g[g.LocalProcess=0]="LocalProcess",g[g.LocalWebWorker=1]="LocalWebWorker",g[g.Remote=2]="Remote"})(S=e.ExtensionHostKind||(e.ExtensionHostKind={}));class C{constructor(E,m,u,w){this.codeLoadingTime=E,this.activateCallTime=m,this.activateResolvedTime=u,this.activationReason=w}}e.ActivationTimes=C;class i{constructor(E,m){this.description=E,this.value=m}}e.ExtensionPointContribution=i,e.ExtensionHostLogFileName="exthost";var I;(function(g){g[g.Normal=0]="Normal",g[g.Immediate=1]="Immediate"})(I=e.ActivationKind||(e.ActivationKind={}));function d(g){g.enableProposedApi||f(g)}e.checkProposedApiEnabled=d;function f(g){throw new Error(`[${g.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${g.identifier.value}`)}e.throwProposedApiError=f;function r(g){return{type:g.isBuiltin?0:1,isBuiltin:g.isBuiltin||g.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(g.publisher,g.name),uuid:g.uuid},manifest:g,location:g.extensionLocation}}e.toExtension=r;function o(g){return Object.assign(Object.assign({identifier:new T.ExtensionIdentifier(g.identifier.id),isBuiltin:g.type===0,isUserBuiltin:g.type===1&&g.isBuiltin,isUnderDevelopment:!1,extensionLocation:g.location},g.manifest),{uuid:g.identifier.uuid})}e.toExtensionDescription=o;class p{constructor(){this.onDidRegisterExtensions=_.Event.None,this.onDidChangeExtensionsStatus=_.Event.None,this.onDidChangeExtensions=_.Event.None,this.onWillActivateByEvent=_.Event.None,this.onDidChangeResponsiveChange=_.Event.None}activateByEvent(E){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(E){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(E){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(E){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(E,m){return Promise.resolve()}_onWillActivateExtension(E){}_onDidActivateExtension(E,m,u,w,t){}_onDidActivateExtensionError(E,m){}_onExtensionRuntimeError(E,m){}_onExtensionHostExit(E){}}e.NullExtensionService=p}),define(ve[185],be([0,1,26,33,18]),function(J,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const T=Promise.resolve(void 0);class y{constructor(r,o,p,g){this.startup=r,this.codeLoadingTime=o,this.activateCallTime=p,this.activateResolvedTime=g}}e.ExtensionActivationTimes=y,y.NONE=new y(!1,-1,-1,-1);class D{constructor(r){this._startup=r,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(r,o){return r===-1||o===-1?-1:o-r}build(){return new y(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=D;class S{constructor(r,o,p,g,E,m){this.activationFailed=r,this.activationFailedError=o,this.activationTimes=p,this.module=g,this.exports=E,this.subscriptions=m}}e.ActivatedExtension=S;class C extends S{constructor(r){super(!1,null,r,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=C;class i extends S{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=i;class I extends S{constructor(r){super(!0,r,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=I;let d=class{constructor(r,o,p,g,E){this._logService=E,this._registry=r,this._resolvedExtensionsSet=new Set,o.forEach(m=>this._resolvedExtensionsSet.add(_.ExtensionIdentifier.toKey(m))),this._hostExtensionsMap=new Map,p.forEach(m=>this._hostExtensionsMap.set(_.ExtensionIdentifier.toKey(m),m)),this._host=g,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(r){const o=_.ExtensionIdentifier.toKey(r);return this._activatedExtensions.has(o)}getActivatedExtension(r){const o=_.ExtensionIdentifier.toKey(r),p=this._activatedExtensions.get(o);if(!p)throw new Error("Extension `"+r.value+"` is not known or not activated");return p}activateByEvent(r,o){if(this._alreadyActivatedEvents[r])return T;const p=this._registry.getExtensionDescriptionsForActivationEvent(r);return this._activateExtensions(p.map(g=>({id:g.identifier,reason:{startup:o,extensionId:g.identifier,activationEvent:r}}))).then(()=>{this._alreadyActivatedEvents[r]=!0})}activateById(r,o){const p=this._registry.getExtensionDescription(r);if(!p)throw new Error("Extension `"+r+"` is not known");return this._activateExtensions([{id:p.identifier,reason:o}])}_handleActivateRequest(r,o,p){if(this._hostExtensionsMap.has(_.ExtensionIdentifier.toKey(r.id))){o[_.ExtensionIdentifier.toKey(r.id)]=r;return}const g=this._registry.getExtensionDescription(r.id);if(!g){const u=new Error(`Cannot activate unknown extension '${r.id.value}'`);this._host.onExtensionActivationError(r.id,u,new k.MissingExtensionDependency(r.id.value)),this._activatedExtensions.set(_.ExtensionIdentifier.toKey(r.id),new I(u));return}const E=typeof g.extensionDependencies=="undefined"?[]:g.extensionDependencies;let m=!0;for(let u=0,w=E.length;u<w;u++){const t=E[u];if(!this._resolvedExtensionsSet.has(_.ExtensionIdentifier.toKey(t))){const n=this._activatedExtensions.get(_.ExtensionIdentifier.toKey(t));if(!(n&&!n.activationFailed)){if(n&&n.activationFailed){const c=g.displayName||g.identifier.value,v=this._registry.getExtensionDescription(t),P=v&&v.displayName||t,h=new Error(`Cannot activate the '${c}' extension because its dependency '${P}' failed to activate`);h.detail=n.activationFailedError,this._host.onExtensionActivationError(g.identifier,h,null),this._activatedExtensions.set(_.ExtensionIdentifier.toKey(g.identifier),new I(h));return}if(this._hostExtensionsMap.has(_.ExtensionIdentifier.toKey(t))){m=!1,o[_.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(_.ExtensionIdentifier.toKey(t)),reason:r.reason};continue}const l=this._registry.getExtensionDescription(t);if(l){m=!1,o[_.ExtensionIdentifier.toKey(t)]={id:l.identifier,reason:r.reason};continue}const a=g.displayName||g.identifier.value,s=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(g.identifier,s,new k.MissingExtensionDependency(t)),this._activatedExtensions.set(_.ExtensionIdentifier.toKey(g.identifier),new I(s));return}}}m?o[_.ExtensionIdentifier.toKey(g.identifier)]=r:p.push(r)}_activateExtensions(r){if(r.length===0||(r=r.filter(E=>!this._activatedExtensions.has(_.ExtensionIdentifier.toKey(E.id))),r.length===0))return Promise.resolve(void 0);const o=Object.create(null),p=[];for(let E=0,m=r.length;E<m;E++)this._handleActivateRequest(r[E],o,p);for(let E=0,m=p.length;E<m;E++){const u=_.ExtensionIdentifier.toKey(p[E].id);o[u]&&delete o[u]}const g=Object.keys(o).map(E=>o[E]);return p.length===0?Promise.all(g.map(E=>this._activateExtension(E.id,E.reason))).then(E=>{}):this._activateExtensions(g).then(E=>this._activateExtensions(p))}_activateExtension(r,o){const p=_.ExtensionIdentifier.toKey(r);if(this._activatedExtensions.has(p))return Promise.resolve(void 0);const g=this._activatingExtensions.get(p);if(g)return g;const E=this._host.actualActivateExtension(r,o).then(void 0,m=>{const u=new Error;return m&&m.name&&(u.name=m.name),m&&m.message?u.message=`Activating extension '${r.value}' failed: ${m.message}.`:u.message=`Activating extension '${r.value}' failed: ${m}.`,m&&m.stack&&(u.stack=m.stack),this._host.onExtensionActivationError(r,u,null),this._logService.error(`Activating extension ${r.value} failed due to an error:`),this._logService.error(m),new I(m)}).then(m=>{this._activatedExtensions.set(p,m),this._activatingExtensions.delete(p)});return this._activatingExtensions.set(p,E),E}};d=je([Ke(4,A.ILogService)],d),e.ExtensionsActivator=d}),define(ve[186],be([0,1,12]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class k{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,y)=>{this._actualOk=T,this._actualErr=y,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,_.onUnexpectedError)(T))}then(T,y){return this._ensureActual().then(T,y)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=k}),define(ve[98],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class _{constructor(S,C){this.isMain=S,this.sid=C,this.nid=++_.count}}e.ProxyIdentifier=_,_.count=0;const k=[];function A(D){const S=new _(!0,D);return k[S.nid]=S,S}e.createMainContextProxyIdentifier=A;function T(D){const S=new _(!1,D);return k[S.nid]=S,S}e.createExtHostContextProxyIdentifier=T;function y(D){return k[D].sid}e.getStringIdentifierForProxy=y}),define(ve[5],be([0,1,2,98,57]),function(J,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var T;(function(u){u[u.Desktop=1]="Desktop",u[u.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var y;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(y=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(D=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var S;(function(u){u[u.Int8Array=1]="Int8Array",u[u.Uint8Array=2]="Uint8Array",u[u.Uint8ClampedArray=3]="Uint8ClampedArray",u[u.Int16Array=4]="Int16Array",u[u.Uint16Array=5]="Uint16Array",u[u.Int32Array=6]="Int32Array",u[u.Uint32Array=7]="Uint32Array",u[u.Float32Array=8]="Float32Array",u[u.Float64Array=9]="Float64Array",u[u.BigInt64Array=10]="BigInt64Array",u[u.BigUint64Array=11]="BigUint64Array"})(S=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var C;(function(u){u[u.Markdown=1]="Markdown",u[u.Code=2]="Code"})(C=e.CellKind||(e.CellKind={}));var i;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})(i=e.CellOutputKind||(e.CellOutputKind={}));var I;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(I=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var d;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output"})(d=e.CandidatePortSource||(e.CandidatePortSource={}));var f;(function(u){u.name="$ident";function w(n,l){return Object.defineProperty(n,u.name,{value:l,enumerable:!0}),n}u.mixin=w;function t(n){return n[u.name]}u.of=t})(f=e.ObjectIdentifier||(e.ObjectIdentifier={}));class r{static mixin(w){return w._id=r._n++,w}}e.IdObject=r,r._n=0;var o;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.command="m",u.kindModifier="n",u.label2="o"})(o=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var p;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})(p=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var g;(function(u){u[u.File=1]="File",u[u.Text=2]="Text",u[u.Cell=3]="Cell"})(g=e.WorkspaceEditType||(e.WorkspaceEditType={}));function E(u){if(u&&u.edits)for(const w of u.edits)typeof w.resource=="object"?w.resource=_.URI.revive(w.resource):(w.newUri=_.URI.revive(w.newUri),w.oldUri=_.URI.revive(w.oldUri)),w.metadata&&w.metadata.iconPath&&(w.metadata=(0,A.revive)(w.metadata));return u}e.reviveWorkspaceEditDto=E;var m;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})(m=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,k.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,k.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,k.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,k.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,k.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,k.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,k.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,k.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,k.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,k.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,k.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,k.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,k.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,k.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,k.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,k.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,k.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,k.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,k.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,k.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,k.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,k.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,k.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,k.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,k.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,k.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,k.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,k.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,k.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,k.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,k.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,k.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,k.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,k.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,k.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,k.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,k.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,k.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,k.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,k.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,k.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,k.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,k.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,k.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,k.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,k.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,k.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadTheming:(0,k.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,k.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,k.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,k.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,k.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,k.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,k.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,k.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,k.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,k.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,k.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,k.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,k.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,k.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,k.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,k.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,k.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,k.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,k.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,k.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,k.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,k.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,k.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,k.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,k.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,k.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,k.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,k.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,k.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookKernels:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostTheming:(0,k.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,k.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,k.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,k.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,k.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,k.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(ve[74],be([0,1,5,3,4]),function(J,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(D){this._onDidChangePassword=new k.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=D.getProxy(_.MainContext.MainThreadSecretState)}async $onDidChangePassword(D){this._onDidChangePassword.fire(D)}get(D,S){return this._proxy.$getPassword(D,S)}store(D,S,C){return this._proxy.$setPassword(D,S,C)}delete(D,S){return this._proxy.$deletePassword(D,S)}}e.ExtHostSecretState=T,e.IExtHostSecretState=(0,A.createDecorator)("IExtHostSecretState")}),define(ve[75],be([0,1,4,18,5,14]),function(J,e,_,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,_.createDecorator)("IExtHostApiDeprecationService");let y=class{constructor(S,C){this._extHostLogService=C,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(A.MainContext.MainThreadTelemetry)}report(S,C,i){const I=this.getUsageKey(S,C);this._reportedUsages.has(I)||(this._reportedUsages.add(I),C.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${i}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:C.identifier.value,apiId:S}))}getUsageKey(S,C){return`${S}-${C.identifier.value}`}};y=je([Ke(0,T.IExtHostRpcService),Ke(1,k.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(D,S,C){}})}),define(ve[187],be([0,1,3,5,7,26]),function(J,e,_,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new _.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new _.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(k.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(S,C,i,I={}){const d=T.ExtensionIdentifier.toKey(S.identifier),f=this._inFlightRequests.get(d)||[],r=i.sort().join(" ");let o=f.find(p=>p.scopes===r);if(o)return o.result;{const p=this._getSession(S,d,C,i,I);o={scopes:r,result:p},f.push(o),this._inFlightRequests.set(d,f);try{await p}finally{const g=f.findIndex(E=>E.scopes===r);g>-1&&(f.splice(g),this._inFlightRequests.set(d,f))}return p}}async _getSession(S,C,i,I,d={}){await this._proxy.$ensureProvider(i);const f=S.displayName||S.name;return this._proxy.$getSession(i,I,C,f,d)}async removeSession(S,C){const i=this._authenticationProviders.get(S);return i?i.provider.removeSession(C):this._proxy.$removeSession(S,C)}registerAuthenticationProvider(S,C,i,I){var d;if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:C,provider:i,options:I!=null?I:{supportsMultipleAccounts:!1}}),this._providers.find(r=>r.id===S)||this._providers.push({id:S,label:C});const f=i.onDidChangeSessions(r=>{var o,p,g;this._proxy.$sendDidChangeSessions(S,{added:(o=r.added)!==null&&o!==void 0?o:[],changed:(p=r.changed)!==null&&p!==void 0?p:[],removed:(g=r.removed)!==null&&g!==void 0?g:[]})});return this._proxy.$registerAuthenticationProvider(S,C,(d=I==null?void 0:I.supportsMultipleAccounts)!==null&&d!==void 0?d:!1),new A.Disposable(()=>{f.dispose(),this._authenticationProviders.delete(S);const r=this._providers.findIndex(o=>o.id===S);r>-1&&this._providers.splice(r),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,C){const i=this._authenticationProviders.get(S);if(i)return Promise.resolve(i.provider.createSession(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,C){const i=this._authenticationProviders.get(S);if(i)return Promise.resolve(i.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,C){const i=this._authenticationProviders.get(S);if(i)return Promise.resolve(i.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,C){return this._onDidChangeSessions.fire({provider:{id:S,label:C}}),Promise.resolve()}$onDidChangeAuthenticationProviders(S,C){return S.forEach(i=>{this._providers.some(I=>I.id===i.id)||this._providers.push(i)}),C.forEach(i=>{const I=this._providers.findIndex(d=>d.id===i.id);I>-1&&this._providers.splice(I)}),this._onDidChangeAuthenticationProviders.fire({added:S,removed:C}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(ve[188],be([0,1,5,14,9]),function(J,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let T=class{constructor(D,S){this._extHostDocumentsAndEditors=S,this._proxy=D.getProxy(_.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(D){const S=A.WorkspaceEdit.from(D,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(S)}};T=je([Ke(0,k.IExtHostRpcService)],T),e.ExtHostBulkEdits=T}),define(ve[189],be([0,1,5]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class k{constructor(T){const y=T.getProxy(_.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(D){return y.$writeText(D)}})}}e.ExtHostClipboard=k}),define(ve[76],be([0,1,10,7,9,23,5,15,18,57,32,38,2,6,4,14]),function(J,e,_,k,A,T,y,D,S,C,i,I,d,f,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let p=class{constructor(t,n){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(y.MainContext.MainThreadCommands),this._logService=n,this.converter=new g(this,l=>{const a=this._apiCommands.get(l);return(a==null?void 0:a.result)===m.Void?a:void 0},n),this._argumentProcessors=[{processArgument(l){return(0,C.revive)(l)}},{processArgument(l){return(0,T.cloneAndChange)(l,function(a){if(i.Range.isIRange(a))return A.Range.to(a);if(I.Position.isIPosition(a))return A.Position.to(a);if(i.Range.isIRange(a.range)&&d.URI.isUri(a.uri))return A.location.to(a);if(!Array.isArray(a))return a})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const n=this.registerCommand(!1,t.id,async(...l)=>{const a=t.args.map((c,v)=>{if(!c.validate(l[v]))throw new Error(`Invalid argument '${c.name}' when running '${t.id}', received: ${l[v]}`);return c.convert(l[v])}),s=await this.executeCommand(t.internalId,...a);return t.result.convert(s,l,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new k.Disposable(()=>{n.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,n,l,a,s){if(this._logService.trace("ExtHostCommands#registerCommand",n),!n.trim().length)throw new Error("invalid id");if(this._commands.has(n))throw new Error(`command '${n}' already exists`);return this._commands.set(n,{callback:l,thisArg:a,description:s}),t&&this._proxy.$registerCommand(n),new k.Disposable(()=>{this._commands.delete(n)&&t&&this._proxy.$unregisterCommand(n)})}executeCommand(t,...n){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,n,!0)}async _doExecuteCommand(t,n,l){if(this._commands.has(t))return this._executeContributedCommand(t,n);{const a=(0,T.cloneAndChange)(n,function(s){if(s instanceof k.Position)return A.Position.from(s);if(s instanceof k.Range)return A.Range.from(s);if(s instanceof k.Location)return A.location.from(s);if(k.NotebookRange.isNotebookRange(s))return A.NotebookRange.from(s);if(!Array.isArray(s))return s});try{const s=await this._proxy.$executeCommand(t,a,l);return(0,C.revive)(s)}catch(s){if(s instanceof Error&&s.message==="$executeCommand:retry")return this._doExecuteCommand(t,n,!1);throw s}}}async _executeContributedCommand(t,n){const l=this._commands.get(t);if(!l)throw new Error("Unknown command");let{callback:a,thisArg:s,description:c}=l;if(c)for(let v=0;v<c.args.length;v++)try{(0,_.validateConstraint)(n[v],c.args[v].constraint)}catch(P){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${c.args[v].name}' - ${c.args[v].description}`)}try{return await a.apply(s,n)}catch(v){if(t===this.converter.delegatingCommandId){const P=this.converter.getActualCommand(...n);P&&(t=P.command)}throw this._logService.error(v,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...n){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(n=n.map(l=>this._argumentProcessors.reduce((a,s)=>s.processArgument(a),l)),this._executeContributedCommand(t,n)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(n=>(t&&(n=n.filter(l=>l[0]!=="_")),n))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[n,l]of this._commands){let{description:a}=l;a&&(t[n]=a)}return Promise.resolve(t)}};p=je([Ke(0,o.IExtHostRpcService),Ke(1,S.ILogService)],p),e.ExtHostCommands=p,e.IExtHostCommands=(0,r.createDecorator)("IExtHostCommands");class g{constructor(t,n,l){this._commands=t,this._lookupApiCommand=n,this._logService=l,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,n){if(!!t){const l={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return l;const a=this._lookupApiCommand(t.command);if(a)l.id=a.internalId,l.arguments=a.args.map((s,c)=>s.convert(t.arguments&&t.arguments[c]));else if((0,D.isNonEmptyArray)(t.arguments)){const s=++this._cachIdPool;this._cache.set(s,t),n.add((0,f.toDisposable)(()=>{this._cache.delete(s),this._logService.trace("CommandsConverter#DISPOSE",s)})),l.$ident=s,l.id=this.delegatingCommandId,l.arguments=[s],this._logService.trace("CommandsConverter#CREATE",t.command,s)}return l}}fromInternal(t){const n=y.ObjectIdentifier.of(t);return typeof n=="number"?this._cache.get(n):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const n=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],n?n.command:"MISSING"),n?this._commands.executeCommand(n.command,...n.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=g;class E{constructor(t,n,l,a){this.name=t,this.description=n,this.validate=l,this.convert=a}optional(){return new E(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,n){return new E(t!=null?t:this.name,n!=null?n:this.description,this.validate,this.convert)}}e.ApiCommandArgument=E,E.Uri=new E("uri","Uri of a text document",w=>d.URI.isUri(w),w=>w),E.Position=new E("position","A position in a text document",w=>k.Position.isPosition(w),A.Position.from),E.Range=new E("range","A range in a text document",w=>k.Range.isRange(w),A.Range.from),E.Selection=new E("selection","A selection in a text document",w=>k.Selection.isSelection(w),A.Selection.from),E.Number=new E("number","",w=>typeof w=="number",w=>w),E.String=new E("string","",w=>typeof w=="string",w=>w),E.CallHierarchyItem=new E("item","A call hierarchy item",w=>w instanceof k.CallHierarchyItem,A.CallHierarchyItem.to);class m{constructor(t,n){this.description=t,this.convert=n}}e.ApiCommandResult=m,m.Void=new m("no result",w=>w);class u{constructor(t,n,l,a,s){this.id=t,this.internalId=n,this.description=l,this.args=a,this.result=s}}e.ApiCommand=u}),define(ve[190],be([0,1,6,9,7,62,76,168,15,87]),function(J,e,_,k,A,T,y,D,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const i=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",d(k.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,o)=>{if(!(0,S.isFalsyOrEmpty)(r)){class p extends A.SymbolInformation{static to(E){const m=new p(E.name,k.SymbolKind.to(E.kind),E.containerName||"",new A.Location(o[0],k.Range.to(E.range)));return m.detail=E.detail,m.range=m.location.range,m.selectionRange=k.Range.to(E.selectionRange),m.children=E.children?E.children.map(p.to):[],m}}return r.map(p.to)}})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",d(k.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",d(k.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",r=>typeof r=="string",r=>r),new y.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",d(k.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",d(k.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",d(k.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",r=>Array.isArray(r)&&r.every(o=>A.Position.isPosition(o)),r=>r.map(k.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",r=>r.map(o=>{let p;for(const g of o.reverse())p=new A.SelectionRange(k.Range.to(g),p);return p}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",r=>{const o=[];if(Array.isArray(r))for(let p of r)o.push(...p[1].map(k.WorkspaceSymbol.to));return o})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(k.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(k.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(k.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",r=>{if(!!r){if(r.rejectReason)throw new Error(r.rejectReason);return k.WorkspaceEdit.to(r)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(k.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new A.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!!r){const o=(0,C.decodeSemanticTokensDto)(r);if(o.type==="full")return new A.SemanticTokens(o.data,void 0)}})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new A.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!!r){const o=(0,C.decodeSemanticTokensDto)(r);if(o.type==="full")return new A.SemanticTokens(o.data,void 0)}})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(r,o,p)=>{if(!r)return new A.CompletionList([]);const g=r.suggestions.map(E=>k.CompletionItem.to(E,p));return new A.CompletionList(g,r.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",r=>{if(r)return k.SignatureHelp.to(r)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(r,o,p)=>d(g=>new A.CodeLens(k.Range.to(g.range),g.command&&p.fromInternal(g.command)))(r))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>A.Range.isRange(r),r=>A.Selection.isSelection(r)?k.Selection.from(r):k.Range.from(r)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(r,o,p)=>d(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return p.fromInternal(g.command)}else{const E=new A.CodeAction(g.title,g.kind?new A.CodeActionKind(g.kind):void 0);return g.edit&&(E.edit=k.WorkspaceEdit.to(g.edit)),g.command&&(E.command=p.fromInternal(g.command)),E.isPreferred=g.isPreferred,E}})(r))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(o=>new A.ColorInformation(k.Range.to(o.range),k.Color.to(o.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",r=>r instanceof A.Color,k.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:k.Range.from(r.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(k.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inline hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",r=>r.map(k.InlayHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",d(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(o=>k.NotebookExclusiveDocumentPattern.to(o))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",r=>r.map(k.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[k.ViewColumn.from(r.viewColumn),k.TextEditorOpenOptions.from(r)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[k.ViewColumn.from(r.viewColumn),k.TextEditorOpenOptions.from(r)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[k.ViewColumn.from(r.viewColumn),k.TextEditorOpenOptions.from(r)]).optional()],y.ApiCommandResult.Void)];class I{constructor(o){this._disposables=new _.DisposableStore,this._commands=o}static register(o){return i.forEach(o.registerApiCommand,o),new I(o).registerCommands()}registerCommands(){const o=p=>(...g)=>p(this._commands,...g);this._register(D.RemoveFromRecentlyOpenedAPICommand.ID,o(D.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:p=>typeof p=="string"}]}),this._register(D.OpenIssueReporter.ID,o(D.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:p=>typeof p=="string"||typeof p=="object"&&typeof p.extensionId=="string"}]})}_register(o,p,g){const E=this._commands.registerCommand(!1,o,p,this,g);this._disposables.add(E)}}e.ExtHostApiCommands=I;function d(r){return o=>{if(Array.isArray(o))return o.map(r)}}function f(r){if(!!Array.isArray(r)){const o=[];for(const p of r)T.isLocationLink(p)?o.push(k.DefinitionLink.to(p)):o.push(k.location.to(p));return o}}}),define(ve[191],be([0,1,11,52,3,6,2,62,26,9,7,5]),function(J,e,_,k,A,T,y,D,S,C,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class d{constructor(u,w,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=u.getProxy(I.MainContext.MainThreadComments),w.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const l=this._commentControllers.get(n.handle);return l||n}else if(n&&n.$mid===7){const l=this._commentControllers.get(n.commentControlHandle);if(!l)return n;const a=l.getCommentThread(n.commentThreadHandle);return a||n}else if(n&&n.$mid===8){const l=this._commentControllers.get(n.thread.commentControlHandle);if(!l)return n;const a=l.getCommentThread(n.thread.commentThreadHandle);return a?{thread:a,text:n.text}:n}else if(n&&n.$mid===9){const l=this._commentControllers.get(n.thread.commentControlHandle);if(!l)return n;const a=l.getCommentThread(n.thread.commentThreadHandle);if(!a)return n;let s=n.commentUniqueId,c=a.getCommentByUniqueId(s);return c||n}else if(n&&n.$mid===10){const l=this._commentControllers.get(n.thread.commentControlHandle);if(!l)return n;const a=l.getCommentThread(n.thread.commentThreadHandle);if(!a)return n;let s=n.text,c=n.commentUniqueId,v=a.getCommentByUniqueId(c);return v?(v.body=s,v):n}return n}})}createCommentController(u,w,t){const n=d.handlePool++,l=new r(u,n,this._proxy,w,t);this._commentControllers.set(l.handle,l);const a=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(u.identifier))||[];return a.push(l),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(u.identifier),a),l}$createCommentThreadTemplate(u,w,t){const n=this._commentControllers.get(u);!n||n.$createCommentThreadTemplate(w,t)}async $updateCommentThreadTemplate(u,w,t){const n=this._commentControllers.get(u);!n||n.$updateCommentThreadTemplate(w,t)}$deleteCommentThread(u,w){const t=this._commentControllers.get(u);t&&t.$deleteCommentThread(w)}$provideCommentingRanges(u,w,t){const n=this._commentControllers.get(u);if(!n||!n.commentingRangeProvider)return Promise.resolve(void 0);const l=this._documents.getDocument(y.URI.revive(w));return(0,_.asPromise)(()=>n.commentingRangeProvider.provideCommentingRanges(l,t)).then(a=>a?a.map(s=>C.Range.from(s)):void 0)}$toggleReaction(u,w,t,n,l){const a=this._commentControllers.get(u);return!a||!a.reactionHandler?Promise.resolve(void 0):(0,_.asPromise)(()=>{const s=a.getCommentThread(w);if(s){const c=s.getCommentByUniqueId(n.uniqueIdInThread);if(a!==void 0&&c&&a.reactionHandler)return a.reactionHandler(c,g(l))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=d,d.handlePool=0;class f{constructor(u,w,t,n,l,a,s){this._proxy=u,this._commentController=w,this._id=t,this._uri=n,this._range=l,this._comments=a,this.handle=f._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new A.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${w.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,C.Range.from(this._range),s),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=a}set threadId(u){this._id=u}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(u){u.isEqual(this._range)||(this._range=u,this.modifications.range=u,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(u){this._canReply!==u&&(this._canReply=u,this.modifications.canReply=u,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(u){this._label=u,this.modifications.label=u,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(u){this._contextValue=u,this.modifications.contextValue=u,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(u){this._comments=u,this.modifications.comments=u,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(u){this._collapseState=u,this.modifications.collapsibleState=u,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const u=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),w={};u("range")&&(w.range=C.Range.from(this._range)),u("label")&&(w.label=this.label),u("contextValue")&&(w.contextValue=this.contextValue),u("comments")&&(w.comments=this._comments.map(t=>o(this,this._commentController,t,this._commentsMap))),u("collapsibleState")&&(w.collapseState=E(this._collapseState)),u("canReply")&&(w.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,w)}}getCommentByUniqueId(u){for(let w of this._commentsMap){let t=w[0],n=w[1];if(u===n)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(u=>u.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}f._handlePool=0,je([(0,k.debounce)(100)],f.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=f;class r{constructor(u,w,t,n,l){this._extension=u,this._handle=w,this._proxy=t,this._id=n,this._label=l,this._threads=new Map,this._proxy.$registerCommentController(this.handle,n,l)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(u){this._reactionHandler=u,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this._options}set options(u){this._options=u,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(u,w,t,n){if(typeof u=="string"){const l=new f(this._proxy,this,u,w,t,n,this._extension.identifier);return this._threads.set(l.handle,l),l}else{const l=new f(this._proxy,this,void 0,u,w,t,this._extension.identifier);return this._threads.set(l.handle,l),l}}$createCommentThreadTemplate(u,w){const t=new f(this._proxy,this,void 0,y.URI.revive(u),C.Range.to(w),[],this._extension.identifier);return t.collapsibleState=D.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(u,w){let t=this._threads.get(u);t&&(t.range=C.Range.to(w))}$deleteCommentThread(u){let w=this._threads.get(u);w&&w.dispose(),this._threads.delete(u)}getCommentThread(u){return this._threads.get(u)}dispose(){this._threads.forEach(u=>{u.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function o(m,u,w,t){let n=t.get(w);n||(n=++m.commentHandle,t.set(w,n));const l=w.author&&w.author.iconPath?w.author.iconPath.toString():void 0;return{mode:w.mode,contextValue:w.contextValue,uniqueIdInThread:n,body:C.MarkdownString.from(w.body),userName:w.author.name,userIconPath:l,label:w.label,commentReactions:w.reactions?w.reactions.map(a=>p(a)):void 0}}function p(m){return{label:m.label,iconPath:m.iconPath?C.pathOrURIToURI(m.iconPath):void 0,count:m.count,hasReacted:m.authorHasReacted}}function g(m){return{label:m.label||"",count:m.count||0,iconPath:m.iconPath?y.URI.revive(m.iconPath):"",authorHasReacted:m.hasReacted||!1}}function E(m){if(m!==void 0)switch(m){case i.CommentThreadCollapsibleState.Expanded:return D.CommentThreadCollapsibleState.Expanded;case i.CommentThreadCollapsibleState.Collapsed:return D.CommentThreadCollapsibleState.Collapsed}return D.CommentThreadCollapsibleState.Collapsed}}),define(ve[99],be([0,1,2,5,7,4,14,18,15,8,13]),function(J,e,_,k,A,T,y,D,S,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class wn{constructor(f,r){this._logService=r,this._provider=new Map,this._proxy=f.getProxy(k.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,r){const o=wn._handlePool++;this._provider.set(o,{provider:f,extensionId:r}),this._proxy.$registerDecorationProvider(o,r.value);const p=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(g=>{if(!g){this._proxy.$onDidChange(o,null);return}let E=(0,S.asArray)(g);if(E.length<=wn._maxEventSize){this._proxy.$onDidChange(o,E);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",r.value,E.length);const m=E.map(t=>({uri:t,rank:(0,C.count)(t.path,"/")})),u=(0,S.groupBy)(m,(t,n)=>t.rank-n.rank||(0,C.compare)(t.uri.path,n.uri.path));let w=[];e:for(let t of u){let n;for(let l of t){let a=(0,i.dirname)(l.uri.path);if(n!==a&&(n=a,w.push(l.uri)>=wn._maxEventSize))break e}}this._proxy.$onDidChange(o,w)});return new A.Disposable(()=>{p==null||p.dispose(),this._proxy.$unregisterDecorationProvider(o),this._provider.delete(o)})}async $provideDecorations(f,r,o){if(!this._provider.has(f))return Object.create(null);const p=Object.create(null),{provider:g,extensionId:E}=this._provider.get(f);return await Promise.all(r.map(async m=>{try{const{uri:u,id:w}=m,t=await Promise.resolve(g.provideFileDecoration(_.URI.revive(u),o));if(!t)return;try{A.FileDecoration.validate(t),p[w]=[t.propagate,t.tooltip,t.badge,t.color]}catch(n){this._logService.warn(`INVALID decoration from extension '${E.value}': ${n}`)}}catch(u){this._logService.error(u)}})),p}};I._handlePool=0,I._maxEventSize=250,I=je([Ke(0,y.IExtHostRpcService),Ke(1,D.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=(0,T.createDecorator)("IExtHostDecorations")}),define(ve[192],be([0,1,131,90,2,5,7,9,3,18,22]),function(J,e,_,k,A,T,y,D,S,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class I{constructor(r,o,p,g,E){this._name=r,this._owner=o,this._maxDiagnosticsPerFile=p,this._proxy=g,this._onDidChangeDiagnostics=E,this._isDisposed=!1,this._data=new i.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(r,o){if(!r){this.clear();return}this._checkDisposed();let p=[];if(A.URI.isUri(r)){if(!o){this.delete(r);return}this._data.set(r,o.slice()),p=[r]}else if(Array.isArray(r)){p=[];let E;r=[...r].sort(I._compareIndexedTuplesByUri);for(const m of r){const[u,w]=m;if((!E||u.toString()!==E.toString())&&(E&&this._data.get(E).length===0&&this._data.delete(E),E=u,p.push(u),this._data.set(u,[])),w){const t=this._data.get(u);t&&t.push(...w)}else{const t=this._data.get(u);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(p),!!this._proxy){const g=[];for(let E of p){let m=[];const u=this._data.get(E);if(u)if(u.length>this._maxDiagnosticsPerFile){m=[];const w=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let n of u)if(n.severity===w[t]&&m.push(D.Diagnostic.from(n))===this._maxDiagnosticsPerFile)break e;m.push({severity:k.MarkerSeverity.Info,message:(0,_.localize)(0,null,u.length-this._maxDiagnosticsPerFile),startLineNumber:m[m.length-1].startLineNumber,startColumn:m[m.length-1].startColumn,endLineNumber:m[m.length-1].endLineNumber,endColumn:m[m.length-1].endColumn})}else m=u.map(w=>D.Diagnostic.from(w));g.push([E,m])}this._proxy.$changeMany(this._owner,g)}}delete(r){this._checkDisposed(),this._onDidChangeDiagnostics.fire([r]),this._data.delete(r),this._proxy&&this._proxy.$changeMany(this._owner,[[r,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(r,o){this._checkDisposed();for(let p of this._data.keys())r.apply(o,[p,this.get(p),this])}get(r){this._checkDisposed();const o=this._data.get(r);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(r){return this._checkDisposed(),Array.isArray(this._data.get(r))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(r,o){return r[0].toString()<o[0].toString()?-1:r[0].toString()>o[0].toString()?1:0}}e.DiagnosticCollection=I;let d=class Vt{constructor(r,o){this._logService=o,this._collections=new Map,this._onDidChangeDiagnostics=new S.Emitter,this.onDidChangeDiagnostics=S.Event.map(S.Event.debounce(this._onDidChangeDiagnostics.event,Vt._debouncer,50),Vt._mapper),this._proxy=r.getProxy(T.MainContext.MainThreadDiagnostics)}static _debouncer(r,o){return r?r.concat(o):o}static _mapper(r){const o=[],p=new Set;for(const g of r)typeof g=="string"?p.has(g)||(p.add(g),o.push(A.URI.parse(g))):p.has(g.toString())||(p.add(g.toString()),o.push(g));return Object.freeze(o),{uris:o}}createDiagnosticCollection(r,o){const{_collections:p,_proxy:g,_onDidChangeDiagnostics:E,_logService:m}=this,u=new class{$changeMany(n,l){g.$changeMany(n,l),m.trace("[DiagnosticCollection] change many (extension, owner, uris)",r.value,n,l.length===0?"CLEARING":l)}$clear(n){g.$clear(n),m.trace("[DiagnosticCollection] remove all (extension, owner)",r.value,n)}dispose(){g.dispose()}};let w;if(!o)o="_generated_diagnostic_collection_name_#"+Vt._idPool++,w=o;else if(!p.has(o))w=o;else{this._logService.warn(`DiagnosticCollection with name '${o}' does already exist.`);do w=o+Vt._idPool++;while(p.has(w))}return new class extends I{constructor(){super(o,w,Vt._maxDiagnosticsPerFile,u,E);p.set(w,this)}dispose(){super.dispose(),p.delete(w)}}}getDiagnostics(r){if(r)return this._getDiagnostics(r);{const o=new Map,p=[];for(const g of this._collections.values())g.forEach((E,m)=>{let u=o.get(E.toString());typeof u=="undefined"&&(u=p.length,o.set(E.toString(),u),p.push([E,[]])),p[u][1]=p[u][1].concat(...m)});return p}}_getDiagnostics(r){let o=[];for(let p of this._collections.values())p.has(r)&&(o=o.concat(p.get(r)));return o}$acceptMarkersChange(r){if(!this._mirrorCollection){const o="_generated_mirror",p=new I(o,o,Vt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(o,p),this._mirrorCollection=p}for(const[o,p]of r)this._mirrorCollection.set(A.URI.revive(o),p.map(D.Diagnostic.to))}};d._idPool=0,d._maxDiagnosticsPerFile=1e3,d=je([Ke(1,C.ILogService)],d),e.ExtHostDiagnostics=d}),define(ve[193],be([0,1,2,5]),function(J,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class A{constructor(y){this._proxy=y.getProxy(k.MainContext.MainThreadDialogs)}showOpenDialog(y){return this._proxy.$showOpenDialog(y).then(D=>D?D.map(S=>_.URI.revive(S)):void 0)}showSaveDialog(y){return this._proxy.$showSaveDialog(y).then(D=>D?_.URI.revive(D):void 0)}}e.ExtHostDialogs=A}),define(ve[194],be([0,1,12,2,7,5,19,20,8]),function(J,e,_,k,A,T,y,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class C{constructor(I,d,f){this._documentsAndEditors=d,this._logService=f,this._documentContentProviders=new Map,this._proxy=I.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,d){if(Object.keys(y.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const f=C._handlePool++;this._documentContentProviders.set(f,d),this._proxy.$registerTextContentProvider(f,I);let r;return typeof d.onDidChange=="function"&&(r=d.onDidChange(o=>{if(o.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(o)&&this.$provideTextDocumentContent(f,o).then(p=>{if(!(!p&&typeof p!="string")){const g=this._documentsAndEditors.getDocument(o);if(!!g){const E=(0,S.splitLines)(p);if(!g.equalLines(E))return this._proxy.$onVirtualDocumentChange(o,p)}}},_.onUnexpectedError)})),new A.Disposable(()=>{this._documentContentProviders.delete(f)&&this._proxy.$unregisterTextContentProvider(f),r&&(r.dispose(),r=void 0)})}$provideTextDocumentContent(I,d){const f=this._documentContentProviders.get(I);return f?Promise.resolve(f.provideTextDocumentContent(k.URI.revive(d),D.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${d.scheme}`))}}e.ExtHostDocumentContentProvider=C,C._handlePool=0}),define(ve[195],be([0,1,3,6,2,5,95,9,10,23]),function(J,e,_,k,A,T,y,D,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class i{constructor(d,f){this._onDidAddDocument=new _.Emitter,this._onDidRemoveDocument=new _.Emitter,this._onDidChangeDocument=new _.Emitter,this._onDidSaveDocument=new _.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new k.DisposableStore,this._documentLoader=new Map,this._proxy=d.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=f,this._documentsAndEditors.onDidRemoveDocuments(r=>{for(const o of r)this._onDidRemoveDocument.fire(o.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(r=>{for(const o of r)this._onDidAddDocument.fire(o.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(d){if(!!d){const f=this._documentsAndEditors.getDocument(d);if(f)return f}}getDocument(d){const f=this.getDocumentData(d);if(!(f==null?void 0:f.document))throw new Error(`Unable to retrieve document from URI '${d}'`);return f.document}ensureDocumentData(d){const f=this._documentsAndEditors.getDocument(d);if(f)return Promise.resolve(f);let r=this._documentLoader.get(d.toString());return r||(r=this._proxy.$tryOpenDocument(d).then(o=>{this._documentLoader.delete(d.toString());const p=A.URI.revive(o);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(p))},o=>(this._documentLoader.delete(d.toString()),Promise.reject(o))),this._documentLoader.set(d.toString(),r)),r}createDocumentData(d){return this._proxy.$tryCreateDocument(d).then(f=>A.URI.revive(f))}$acceptModelModeChanged(d,f){const r=A.URI.revive(d),o=this._documentsAndEditors.getDocument(r);if(!o)throw new Error("unknown document");this._onDidRemoveDocument.fire(o.document),o._acceptLanguageId(f),this._onDidAddDocument.fire(o.document)}$acceptModelSaved(d){const f=A.URI.revive(d),r=this._documentsAndEditors.getDocument(f);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(d,!1),this._onDidSaveDocument.fire(r.document)}$acceptDirtyStateChanged(d,f){const r=A.URI.revive(d),o=this._documentsAndEditors.getDocument(r);if(!o)throw new Error("unknown document");o._acceptIsDirty(f),this._onDidChangeDocument.fire({document:o.document,contentChanges:[]})}$acceptModelChanged(d,f,r){const o=A.URI.revive(d),p=this._documentsAndEditors.getDocument(o);if(!p)throw new Error("unknown document");p._acceptIsDirty(r),p.onEvents(f),this._onDidChangeDocument.fire((0,C.deepFreeze)({document:p.document,contentChanges:f.changes.map(g=>({range:D.Range.to(g.range),rangeOffset:g.rangeOffset,rangeLength:g.rangeLength,text:g.text}))}))}setWordDefinitionFor(d,f){(0,y.setWordDefinitionFor)(d,f)}}e.ExtHostDocuments=i}),define(ve[39],be([0,1,42,3,6,2,4,5,95,14,97,9,18,22,19,43,108]),function(J,e,_,k,A,T,y,D,S,C,i,I,d,f,r,o,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class g{constructor(u){this.value=u,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let E=class{constructor(u,w){this._extHostRpc=u,this._logService=w,this._activeEditorId=null,this._editors=new Map,this._documents=new f.ResourceMap,this._onDidAddDocuments=new k.Emitter,this._onDidRemoveDocuments=new k.Emitter,this._onDidChangeVisibleTextEditors=new k.Emitter,this._onDidChangeActiveTextEditor=new k.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(u){this.acceptDocumentsAndEditorsDelta(u)}acceptDocumentsAndEditorsDelta(u){const w=[],t=[],n=[];if(u.removedDocuments)for(const l of u.removedDocuments){const a=T.URI.revive(l),s=this._documents.get(a);(s==null?void 0:s.unref())&&(this._documents.delete(a),w.push(s.value))}if(u.addedDocuments)for(const l of u.addedDocuments){const a=T.URI.revive(l.uri);let s=this._documents.get(a);if(s&&a.scheme!==r.Schemas.vscodeNotebookCell)throw new Error(`document '${a} already exists!'`);s||(s=new g(new S.ExtHostDocumentData(this._extHostRpc.getProxy(D.MainContext.MainThreadDocuments),a,l.lines,l.EOL,l.versionId,l.modeId,l.isDirty,l.notebook)),this._documents.set(a,s),t.push(s.value)),s.ref()}if(u.removedEditors)for(const l of u.removedEditors){const a=this._editors.get(l);this._editors.delete(l),a&&n.push(a)}if(u.addedEditors)for(const l of u.addedEditors){const a=T.URI.revive(l.documentUri);_.ok(this._documents.has(a),`document '${a}' does not exist`),_.ok(!this._editors.has(l.id),`editor '${l.id}' already exists!`);const s=this._documents.get(a).value,c=new i.ExtHostTextEditor(l.id,this._extHostRpc.getProxy(D.MainContext.MainThreadTextEditors),this._logService,new p.Lazy(()=>s.document),l.selections.map(I.Selection.to),l.options,l.visibleRanges.map(v=>I.Range.to(v)),typeof l.editorPosition=="number"?I.ViewColumn.to(l.editorPosition):void 0);this._editors.set(l.id,c)}u.newActiveEditor!==void 0&&(_.ok(u.newActiveEditor===null||this._editors.has(u.newActiveEditor),`active editor '${u.newActiveEditor}' does not exist`),this._activeEditorId=u.newActiveEditor),(0,A.dispose)(w),(0,A.dispose)(n),u.removedDocuments&&this._onDidRemoveDocuments.fire(w),u.addedDocuments&&this._onDidAddDocuments.fire(t),(u.removedEditors||u.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(l=>l.value)),u.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(u){var w;return(w=this._documents.get(u))===null||w===void 0?void 0:w.value}allDocuments(){return o.Iterable.map(this._documents.values(),u=>u.value)}getEditor(u){return this._editors.get(u)}activeEditor(u){if(!!this._activeEditorId){const w=this._editors.get(this._activeEditorId);return u?w:w==null?void 0:w.value}}allEditors(){return[...this._editors.values()]}};E=je([Ke(0,C.IExtHostRpcService),Ke(1,d.ILogService)],E),e.ExtHostDocumentsAndEditors=E,e.IExtHostDocumentsAndEditors=(0,y.createDecorator)("IExtHostDocumentsAndEditors")}),define(ve[196],be([0,1,2,5,6,7,9,118,8,24]),function(J,e,_,k,A,T,y,D,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class i{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const r=this._schemes.indexOf(f);r>=0&&(this._schemes.splice(r,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),r=[];let o,p,g=14,E=14;for(const m of f){let u=o?(0,S.commonPrefixLength)(o,m):0;for(u===0?p=1:p=E;u<m.length;u++)u+1===m.length?(g=E,E=9):E+=1,r.push([p,m.toUpperCase().charCodeAt(u),E]),r.push([p,m.toLowerCase().charCodeAt(u),E]),p=E;o=m,E=g}r.push([9,58,10]),r.push([10,47,12]),this._stateMachine=new D.StateMachine(r)}}provideDocumentLinks(f){this._initStateMachine();const r=[],o=D.LinkComputer.computeLinks({getLineContent(p){return f.lineAt(p-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const p of o){const g=y.DocumentLink.to(p);g.target&&r.push(g)}return r}}class I{constructor(f,r){this._extHostLanguageFeatures=r,this._linkProvider=new i,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(k.MainContext.MainThreadFileSystem)}dispose(){var f;(f=this._linkProviderRegistration)===null||f===void 0||f.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(f,r,o,p={}){if(this._registeredSchemes.has(r))throw new Error(`a provider for the scheme '${r}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const g=this._handlePool++;this._linkProvider.add(r),this._registeredSchemes.add(r),this._fsProvider.set(g,o);let E=2;p.isCaseSensitive&&(E+=1024),p.isReadonly&&(E+=2048),typeof o.copy=="function"&&(E+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&(E+=4),this._proxy.$registerFileSystemProvider(g,r,E).catch(u=>{console.error(`FAILED to register filesystem provider of ${f.value}-extension for the scheme ${r}`),console.error(u)});const m=o.onDidChangeFile(u=>{const w=[];for(const t of u){let{uri:n,type:l}=t;if(n.scheme===r){let a;switch(l){case T.FileChangeType.Changed:a=0;break;case T.FileChangeType.Created:a=1;break;case T.FileChangeType.Deleted:a=2;break;default:throw new Error("Unknown FileChangeType")}w.push({resource:n,type:a})}}this._proxy.$onFileSystemChange(g,w)});return(0,A.toDisposable)(()=>{m.dispose(),this._linkProvider.delete(r),this._registeredSchemes.delete(r),this._fsProvider.delete(g),this._proxy.$unregisterProvider(g)})}static _asIStat(f){const{type:r,ctime:o,mtime:p,size:g}=f;return{type:r,ctime:o,mtime:p,size:g}}$stat(f,r){return Promise.resolve(this._getFsProvider(f).stat(_.URI.revive(r))).then(I._asIStat)}$readdir(f,r){return Promise.resolve(this._getFsProvider(f).readDirectory(_.URI.revive(r)))}$readFile(f,r){return Promise.resolve(this._getFsProvider(f).readFile(_.URI.revive(r))).then(o=>C.VSBuffer.wrap(o))}$writeFile(f,r,o,p){return Promise.resolve(this._getFsProvider(f).writeFile(_.URI.revive(r),o.buffer,p))}$delete(f,r,o){return Promise.resolve(this._getFsProvider(f).delete(_.URI.revive(r),o))}$rename(f,r,o,p){return Promise.resolve(this._getFsProvider(f).rename(_.URI.revive(r),_.URI.revive(o),p))}$copy(f,r,o,p){const g=this._getFsProvider(f);if(!g.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(g.copy(_.URI.revive(r),_.URI.revive(o),p))}$mkdir(f,r){return Promise.resolve(this._getFsProvider(f).createDirectory(_.URI.revive(r)))}$watch(f,r,o,p){const g=this._getFsProvider(f).watch(_.URI.revive(o),p);this._watches.set(r,g)}$unwatch(f,r){const o=this._watches.get(r);o&&(o.dispose(),this._watches.delete(r))}$open(f,r,o){const p=this._getFsProvider(f);if(!p.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(p.open(_.URI.revive(r),o))}$close(f,r){const o=this._getFsProvider(f);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(r))}$read(f,r,o,p){const g=this._getFsProvider(f);if(!g.read)throw new Error('FileSystemProvider does not implement "read"');const E=C.VSBuffer.alloc(p);return Promise.resolve(g.read(r,o,E.buffer,0,p)).then(m=>E.slice(0,m))}$write(f,r,o,p){const g=this._getFsProvider(f);if(!g.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(g.write(r,o,p.buffer,0,p.byteLength))}_getFsProvider(f){const r=this._fsProvider.get(f);if(!r){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return r}}e.ExtHostFileSystem=I}),define(ve[77],be([0,1,5,64,7,24,4,14,49]),function(J,e,_,k,A,T,y,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let C=class Ot{constructor(I,d){const f=I.getProxy(_.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(r){return f.$stat(r).catch(Ot._handleError)},readDirectory(r){return f.$readdir(r).catch(Ot._handleError)},createDirectory(r){return f.$mkdir(r).catch(Ot._handleError)},async readFile(r){return f.$readFile(r).then(o=>o.buffer).catch(Ot._handleError)},writeFile(r,o){return f.$writeFile(r,T.VSBuffer.wrap(o)).catch(Ot._handleError)},delete(r,o){return f.$delete(r,Object.assign({recursive:!1,useTrash:!1},o)).catch(Ot._handleError)},rename(r,o,p){return f.$rename(r,o,Object.assign({overwrite:!1},p)).catch(Ot._handleError)},copy(r,o,p){return f.$copy(r,o,Object.assign({overwrite:!1},p)).catch(Ot._handleError)},isWritableFileSystem(r){const o=d.getCapabilities(r);if(typeof o=="number")return!(o&2048)}})}static _handleError(I){if(!(I instanceof Error))throw new A.FileSystemError(String(I));if(I.name==="ENOPRO")throw A.FileSystemError.Unavailable(I.message);switch(I.name){case k.FileSystemProviderErrorCode.FileExists:throw A.FileSystemError.FileExists(I.message);case k.FileSystemProviderErrorCode.FileNotFound:throw A.FileSystemError.FileNotFound(I.message);case k.FileSystemProviderErrorCode.FileNotADirectory:throw A.FileSystemError.FileNotADirectory(I.message);case k.FileSystemProviderErrorCode.FileIsADirectory:throw A.FileSystemError.FileIsADirectory(I.message);case k.FileSystemProviderErrorCode.NoPermissions:throw A.FileSystemError.NoPermissions(I.message);case k.FileSystemProviderErrorCode.Unavailable:throw A.FileSystemError.Unavailable(I.message);default:throw new A.FileSystemError(I.message,I.name)}}};C=je([Ke(0,D.IExtHostRpcService),Ke(1,S.IExtHostFileSystemInfo)],C),e.ExtHostConsumerFileSystem=C,e.IExtHostConsumerFileSystem=(0,y.createDecorator)("IExtHostConsumerFileSystem")}),define(ve[197],be([0,1,6,5]),function(J,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class A{constructor(y){this._handlePool=0,this._proxy=y.getProxy(k.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const D=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(D,y),(0,_.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(D)})}}e.ExtHostLabelService=A}),define(ve[198],be([0,1,2,23,9,7,11,5,8,32,15,10,115,6,87,54,68,55,12]),function(J,e,_,k,A,T,y,D,S,C,i,I,d,f,r,o,p,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class m{constructor($,j){this._documents=$,this._provider=j}provideDocumentSymbols($,j){const te=this._documents.getDocument($);return(0,y.asPromise)(()=>this._provider.provideDocumentSymbols(te,j)).then(oe=>{if(!(0,i.isFalsyOrEmpty)(oe))return oe[0]instanceof T.DocumentSymbol?oe.map(A.DocumentSymbol.from):m._asDocumentSymbolTree(oe)})}static _asDocumentSymbolTree($){var j;$=$.slice(0).sort((de,_e)=>{let Be=de.location.range.start.compareTo(_e.location.range.start);return Be===0&&(Be=_e.location.range.end.compareTo(de.location.range.end)),Be});const te=[],oe=[];for(const de of $){const _e={name:de.name||"!!MISSING: name!!",kind:A.SymbolKind.from(de.kind),tags:((j=de.tags)===null||j===void 0?void 0:j.map(A.SymbolTag.from))||[],detail:"",containerName:de.containerName,range:A.Range.from(de.location.range),selectionRange:A.Range.from(de.location.range),children:[]};for(;;){if(oe.length===0){oe.push(_e),te.push(_e);break}const Be=oe[oe.length-1];if(C.Range.containsRange(Be.range,_e.range)&&!C.Range.equalsRange(Be.range,_e.range)){Be.children&&Be.children.push(_e),oe.push(_e);break}oe.pop()}}return te}}class u{constructor($,j,te){this._documents=$,this._commands=j,this._provider=te,this._cache=new p.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses($,j){const te=this._documents.getDocument($),oe=await this._provider.provideCodeLenses(te,j);if(!(!oe||j.isCancellationRequested)){const de=this._cache.add(oe),_e=new f.DisposableStore;this._disposables.set(de,_e);const Be={cacheId:de,lenses:[]};for(let fe=0;fe<oe.length;fe++)Be.lenses.push({cacheId:[de,fe],range:A.Range.from(oe[fe].range),command:this._commands.toInternal(oe[fe].command,_e)});return Be}}async resolveCodeLens($,j){var te;const oe=$.cacheId&&this._cache.get(...$.cacheId);if(!!oe){let de;if(typeof this._provider.resolveCodeLens!="function"||oe.isResolved?de=oe:de=await this._provider.resolveCodeLens(oe,j),de||(de=oe),!j.isCancellationRequested){const _e=$.cacheId&&this._disposables.get($.cacheId[0]);if(!!_e)return $.command=this._commands.toInternal((te=de.command)!==null&&te!==void 0?te:u._badCmd,_e),$}}}releaseCodeLenses($){var j;(j=this._disposables.get($))===null||j===void 0||j.dispose(),this._disposables.delete($),this._cache.delete($)}}u._badCmd={command:"missing",title:"!!MISSING: command!!"};function w(ze){return Array.isArray(ze)?ze.map(A.DefinitionLink.from):ze?[A.DefinitionLink.from(ze)]:[]}class t{constructor($,j){this._documents=$,this._provider=j}provideDefinition($,j,te){const oe=this._documents.getDocument($),de=A.Position.to(j);return(0,y.asPromise)(()=>this._provider.provideDefinition(oe,de,te)).then(w)}}class n{constructor($,j){this._documents=$,this._provider=j}provideDeclaration($,j,te){const oe=this._documents.getDocument($),de=A.Position.to(j);return(0,y.asPromise)(()=>this._provider.provideDeclaration(oe,de,te)).then(w)}}class l{constructor($,j){this._documents=$,this._provider=j}provideImplementation($,j,te){const oe=this._documents.getDocument($),de=A.Position.to(j);return(0,y.asPromise)(()=>this._provider.provideImplementation(oe,de,te)).then(w)}}class a{constructor($,j){this._documents=$,this._provider=j}provideTypeDefinition($,j,te){const oe=this._documents.getDocument($),de=A.Position.to(j);return(0,y.asPromise)(()=>this._provider.provideTypeDefinition(oe,de,te)).then(w)}}class s{constructor($,j){this._documents=$,this._provider=j}provideHover($,j,te){const oe=this._documents.getDocument($),de=A.Position.to(j);return(0,y.asPromise)(()=>this._provider.provideHover(oe,de,te)).then(_e=>{if(!(!_e||(0,i.isFalsyOrEmpty)(_e.contents)))return _e.range||(_e.range=oe.getWordRangeAtPosition(de)),_e.range||(_e.range=new T.Range(de,de)),A.Hover.from(_e)})}}class c{constructor($,j){this._documents=$,this._provider=j}provideEvaluatableExpression($,j,te){const oe=this._documents.getDocument($),de=A.Position.to(j);return(0,y.asPromise)(()=>this._provider.provideEvaluatableExpression(oe,de,te)).then(_e=>{if(_e)return A.EvaluatableExpression.from(_e)})}}class v{constructor($,j){this._documents=$,this._provider=j}provideInlineValues($,j,te,oe){const de=this._documents.getDocument($);return(0,y.asPromise)(()=>this._provider.provideInlineValues(de,A.Range.to(j),A.InlineValueContext.to(te),oe)).then(_e=>{if(Array.isArray(_e))return _e.map(Be=>A.InlineValue.from(Be))})}}class P{constructor($,j){this._documents=$,this._provider=j}provideDocumentHighlights($,j,te){const oe=this._documents.getDocument($),de=A.Position.to(j);return(0,y.asPromise)(()=>this._provider.provideDocumentHighlights(oe,de,te)).then(_e=>{if(Array.isArray(_e))return _e.map(A.DocumentHighlight.from)})}}class h{constructor($,j){this._documents=$,this._provider=j}provideLinkedEditingRanges($,j,te){const oe=this._documents.getDocument($),de=A.Position.to(j);return(0,y.asPromise)(()=>this._provider.provideLinkedEditingRanges(oe,de,te)).then(_e=>{if(_e&&Array.isArray(_e.ranges))return{ranges:(0,i.coalesce)(_e.ranges.map(A.Range.from)),wordPattern:_e.wordPattern}})}}class b{constructor($,j){this._documents=$,this._provider=j}provideReferences($,j,te,oe){const de=this._documents.getDocument($),_e=A.Position.to(j);return(0,y.asPromise)(()=>this._provider.provideReferences(de,_e,te,oe)).then(Be=>{if(Array.isArray(Be))return Be.map(A.location.from)})}}class R{constructor($,j,te,oe,de,_e,Be){this._documents=$,this._commands=j,this._diagnostics=te,this._provider=oe,this._logService=de,this._extension=_e,this._apiDeprecation=Be,this._cache=new p.Cache("CodeAction"),this._disposables=new Map}provideCodeActions($,j,te,oe){const de=this._documents.getDocument($),_e=d.Selection.isISelection(j)?A.Selection.to(j):A.Range.to(j),Be=[];for(const De of this._diagnostics.getDiagnostics($))if(_e.intersection(De.range)&&Be.push(De)>R._maxCodeActionsPerFile)break;const fe={diagnostics:Be,only:te.only?new T.CodeActionKind(te.only):void 0,triggerKind:A.CodeActionTriggerKind.to(te.trigger)};return(0,y.asPromise)(()=>this._provider.provideCodeActions(de,_e,fe,oe)).then(De=>{var Re;if(!(!(0,i.isNonEmptyArray)(De)||oe.isCancellationRequested)){const He=this._cache.add(De),we=new f.DisposableStore;this._disposables.set(He,we);const qe=[];for(let z=0;z<De.length;z++){const ee=De[z];!ee||(R._isCommand(ee)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),qe.push({_isSynthetic:!0,title:ee.title,command:this._commands.toInternal(ee,we)})):(fe.only&&(ee.kind?fe.only.contains(ee.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${fe.only.value} 'requested but returned code action is of kind '${ee.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${fe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),qe.push({cacheId:[He,z],title:ee.title,command:ee.command&&this._commands.toInternal(ee.command,we),diagnostics:ee.diagnostics&&ee.diagnostics.map(A.Diagnostic.from),edit:ee.edit&&A.WorkspaceEdit.from(ee.edit),kind:ee.kind&&ee.kind.value,isPreferred:ee.isPreferred,disabled:(Re=ee.disabled)===null||Re===void 0?void 0:Re.reason})))}return{cacheId:He,actions:qe}}})}async resolveCodeAction($,j){var te;const[oe,de]=$,_e=this._cache.get(oe,de);if(!(!_e||R._isCommand(_e))&&!!this._provider.resolveCodeAction){const Be=(te=await this._provider.resolveCodeAction(_e,j))!==null&&te!==void 0?te:_e;return(Be==null?void 0:Be.edit)?A.WorkspaceEdit.from(Be.edit):void 0}}releaseCodeActions($){var j;(j=this._disposables.get($))===null||j===void 0||j.dispose(),this._disposables.delete($),this._cache.delete($)}static _isCommand($){return typeof $.command=="string"&&typeof $.title=="string"}}R._maxCodeActionsPerFile=1e3;class U{constructor($,j){this._documents=$,this._provider=j}provideDocumentFormattingEdits($,j,te){const oe=this._documents.getDocument($);return(0,y.asPromise)(()=>this._provider.provideDocumentFormattingEdits(oe,j,te)).then(de=>{if(Array.isArray(de))return de.map(A.TextEdit.from)})}}class K{constructor($,j){this._documents=$,this._provider=j}provideDocumentRangeFormattingEdits($,j,te,oe){const de=this._documents.getDocument($),_e=A.Range.to(j);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(de,_e,te,oe)).then(Be=>{if(Array.isArray(Be))return Be.map(A.TextEdit.from)})}}class he{constructor($,j){this._documents=$,this._provider=j,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits($,j,te,oe,de){const _e=this._documents.getDocument($),Be=A.Position.to(j);return(0,y.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(_e,Be,te,oe,de)).then(fe=>{if(Array.isArray(fe))return fe.map(A.TextEdit.from)})}}class V{constructor($,j){this._provider=$,this._logService=j,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols($,j){const te=D.IdObject.mixin({symbols:[]});return(0,y.asPromise)(()=>this._provider.provideWorkspaceSymbols($,j)).then(oe=>{if((0,i.isNonEmptyArray)(oe)){for(const de of oe)if(!!de){if(!de.name){this._logService.warn("INVALID SymbolInformation, lacks name",de);continue}const _e=D.IdObject.mixin(A.WorkspaceSymbol.from(de));this._symbolCache.set(_e._id,de),te.symbols.push(_e)}}}).then(()=>(te.symbols.length>0&&this._resultCache.set(te._id,[te.symbols[0]._id,te.symbols[te.symbols.length-1]._id]),te))}async resolveWorkspaceSymbol($,j){if(typeof this._provider.resolveWorkspaceSymbol!="function")return $;const te=this._symbolCache.get($._id);if(te){const oe=await(0,y.asPromise)(()=>this._provider.resolveWorkspaceSymbol(te,j));return oe&&(0,k.mixin)($,A.WorkspaceSymbol.from(oe),!0)}}releaseWorkspaceSymbols($){const j=this._resultCache.get($);if(j){for(let[te,oe]=j;te<=oe;te++)this._symbolCache.delete(te);this._resultCache.delete($)}}}class H{constructor($,j,te){this._documents=$,this._provider=j,this._logService=te}static supportsResolving($){return typeof $.prepareRename=="function"}provideRenameEdits($,j,te,oe){const de=this._documents.getDocument($),_e=A.Position.to(j);return(0,y.asPromise)(()=>this._provider.provideRenameEdits(de,_e,te,oe)).then(Be=>{if(!!Be)return A.WorkspaceEdit.from(Be)},Be=>{const fe=H._asMessage(Be);return fe?{rejectReason:fe,edits:void 0}:Promise.reject(Be)})}resolveRenameLocation($,j,te){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const oe=this._documents.getDocument($),de=A.Position.to(j);return(0,y.asPromise)(()=>this._provider.prepareRename(oe,de,te)).then(_e=>{let Be,fe;if(T.Range.isRange(_e)?(Be=_e,fe=oe.getText(_e)):(0,I.isObject)(_e)&&(Be=_e.range,fe=_e.placeholder),!!Be){if(Be.start.line>de.line||Be.end.line<de.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:A.Range.from(Be),text:fe}}},_e=>{const Be=H._asMessage(_e);return Be?{rejectReason:Be,range:void 0,text:void 0}:Promise.reject(_e)})}static _asMessage($){return typeof $=="string"?$:$ instanceof Error&&typeof $.message=="string"?$.message:void 0}}class Y{constructor($,j){this.resultId=$,this.tokens=j}}class W{constructor($,j){this._documents=$,this._provider=j,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens($,j,te){const oe=this._documents.getDocument($),de=j!==0?this._previousResults.get(j):null;return(0,y.asPromise)(()=>de&&typeof de.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(oe,de.resultId,te):this._provider.provideDocumentSemanticTokens(oe,te)).then(_e=>(de&&this._previousResults.delete(j),_e?(_e=W._fixProvidedSemanticTokens(_e),this._send(W._convertToEdits(de,_e),_e)):null))}async releaseDocumentSemanticColoring($){this._previousResults.delete($)}static _fixProvidedSemanticTokens($){return W._isSemanticTokens($)?W._isCorrectSemanticTokens($)?$:new T.SemanticTokens(new Uint32Array($.data),$.resultId):W._isSemanticTokensEdits($)?W._isCorrectSemanticTokensEdits($)?$:new T.SemanticTokensEdits($.edits.map(j=>new T.SemanticTokensEdit(j.start,j.deleteCount,j.data?new Uint32Array(j.data):j.data)),$.resultId):$}static _isSemanticTokens($){return $&&!!$.data}static _isCorrectSemanticTokens($){return $.data instanceof Uint32Array}static _isSemanticTokensEdits($){return $&&Array.isArray($.edits)}static _isCorrectSemanticTokensEdits($){for(const j of $.edits)if(!(j.data instanceof Uint32Array))return!1;return!0}static _convertToEdits($,j){if(!W._isSemanticTokens(j)||!$||!$.tokens)return j;const te=$.tokens,oe=te.length,de=j.data,_e=de.length;let Be=0;const fe=Math.min(oe,_e);for(;Be<fe&&te[Be]===de[Be];)Be++;if(Be===oe&&Be===_e)return new T.SemanticTokensEdits([],j.resultId);let De=0;const Re=fe-Be;for(;De<Re&&te[oe-De-1]===de[_e-De-1];)De++;return new T.SemanticTokensEdits([{start:Be,deleteCount:oe-Be-De,data:de.subarray(Be,_e-De)}],j.resultId)}_send($,j){if(W._isSemanticTokens($)){const te=this._nextResultId++;return this._previousResults.set(te,new Y($.resultId,$.data)),(0,r.encodeSemanticTokensDto)({id:te,type:"full",data:$.data})}if(W._isSemanticTokensEdits($)){const te=this._nextResultId++;return W._isSemanticTokens(j)?this._previousResults.set(te,new Y(j.resultId,j.data)):this._previousResults.set(te,new Y($.resultId)),(0,r.encodeSemanticTokensDto)({id:te,type:"delta",deltas:($.edits||[]).map(oe=>({start:oe.start,deleteCount:oe.deleteCount,data:oe.data}))})}return null}}e.DocumentSemanticTokensAdapter=W;class F{constructor($,j){this._documents=$,this._provider=j}provideDocumentRangeSemanticTokens($,j,te){const oe=this._documents.getDocument($);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(oe,A.Range.to(j),te)).then(de=>de?this._send(de):null)}_send($){return(0,r.encodeSemanticTokensDto)({id:0,type:"full",data:$.data})}}e.DocumentRangeSemanticTokensAdapter=F;class L{constructor($,j,te,oe,de){this._documents=$,this._commands=j,this._provider=te,this._apiDeprecation=oe,this._extension=de,this._cache=new p.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving($){return typeof $.resolveCompletionItem=="function"}async provideCompletionItems($,j,te,oe){const de=this._documents.getDocument($),_e=A.Position.to(j),Be=de.getWordRangeAtPosition(_e)||new T.Range(_e,_e),fe=Be.with({end:_e}),De=new g.StopWatch(!0),Re=await(0,y.asPromise)(()=>this._provider.provideCompletionItems(de,_e,oe,A.CompletionContext.to(te)));if(!!Re&&!oe.isCancellationRequested){const He=Array.isArray(Re)?new T.CompletionList(Re):Re,we=L.supportsResolving(this._provider)?this._cache.add(He.items):this._cache.add([]),qe=new f.DisposableStore;this._disposables.set(we,qe);const z=[],ee={x:we,b:z,a:{replace:A.Range.from(Be),insert:A.Range.from(fe)},c:He.isIncomplete||void 0,d:De.elapsed()};for(let ge=0;ge<He.items.length;ge++){const Ne=He.items[ge],Ve=this._convertCompletionItem(Ne,[we,ge],fe,Be);z.push(Ve)}return ee}}async resolveCompletionItem($,j){if(typeof this._provider.resolveCompletionItem=="function"){const te=this._cache.get(...$);if(!!te){const oe=await(0,y.asPromise)(()=>this._provider.resolveCompletionItem(te,j));if(!!oe)return this._convertCompletionItem(oe,$)}}}releaseCompletionItems($){var j;(j=this._disposables.get($))===null||j===void 0||j.dispose(),this._disposables.delete($),this._cache.delete($)}_convertCompletionItem($,j,te,oe){var de;const _e=this._disposables.get(j[0]);if(!_e)throw Error("DisposableStore is missing...");const Be={x:j,a:(de=$.label)!==null&&de!==void 0?de:"",o:$.label2,b:$.kind!==void 0?A.CompletionItemKind.from($.kind):void 0,n:$.tags&&$.tags.map(A.CompletionItemTag.from),c:$.detail,d:typeof $.documentation=="undefined"?void 0:A.MarkdownString.fromStrict($.documentation),e:$.sortText!==$.label?$.sortText:void 0,f:$.filterText!==$.label?$.filterText:void 0,g:$.preselect||void 0,i:$.keepWhitespace?1:0,k:$.commitCharacters,l:$.additionalTextEdits&&$.additionalTextEdits.map(A.TextEdit.from),m:this._commands.toInternal($.command,_e)};$.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Be.h=$.textEdit.newText):typeof $.insertText=="string"?Be.h=$.insertText:$.insertText instanceof T.SnippetString&&(Be.h=$.insertText.value,Be.i|=4);let fe;return $.textEdit?fe=$.textEdit.range:$.range&&(fe=$.range),T.Range.isRange(fe)?Be.j=A.Range.from(fe):fe&&(!(te==null?void 0:te.isEqual(fe.inserting))||!(oe==null?void 0:oe.isEqual(fe.replacing)))&&(Be.j={insert:A.Range.from(fe.inserting),replace:A.Range.from(fe.replacing)}),Be}}class M{constructor($,j){this._documents=$,this._provider=j,this._cache=new p.Cache("SignatureHelp")}provideSignatureHelp($,j,te,oe){const de=this._documents.getDocument($),_e=A.Position.to(j),Be=this.reviveContext(te);return(0,y.asPromise)(()=>this._provider.provideSignatureHelp(de,_e,oe,Be)).then(fe=>{if(fe){const De=this._cache.add([fe]);return Object.assign(Object.assign({},A.SignatureHelp.from(fe)),{id:De})}})}reviveContext($){let j;if($.activeSignatureHelp){const te=A.SignatureHelp.to($.activeSignatureHelp),oe=this._cache.get($.activeSignatureHelp.id,0);oe?(j=oe,j.activeSignature=te.activeSignature,j.activeParameter=te.activeParameter):j=te}return Object.assign(Object.assign({},$),{activeSignatureHelp:j})}releaseSignatureHelp($){this._cache.delete($)}}class x{constructor($,j){this._documents=$,this._provider=j}provideInlayHints($,j,te){const oe=this._documents.getDocument($);return(0,y.asPromise)(()=>this._provider.provideInlayHints(oe,A.Range.to(j),te)).then(de=>de?{hints:de.map(A.InlayHint.from)}:void 0)}}class G{constructor($,j){this._documents=$,this._provider=j,this._cache=new p.Cache("DocumentLink")}provideLinks($,j){const te=this._documents.getDocument($);return(0,y.asPromise)(()=>this._provider.provideDocumentLinks(te,j)).then(oe=>{if(!(!Array.isArray(oe)||oe.length===0)&&!j.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:oe.map(A.DocumentLink.from)};{const de=this._cache.add(oe),_e={links:[],id:de};for(let Be=0;Be<oe.length;Be++){const fe=A.DocumentLink.from(oe[Be]);fe.cacheId=[de,Be],_e.links.push(fe)}return _e}}})}resolveLink($,j){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const te=this._cache.get(...$);return te?(0,y.asPromise)(()=>this._provider.resolveDocumentLink(te,j)).then(oe=>oe&&A.DocumentLink.from(oe)||void 0):Promise.resolve(void 0)}releaseLinks($){this._cache.delete($)}}class X{constructor($,j){this._documents=$,this._provider=j}provideColors($,j){const te=this._documents.getDocument($);return(0,y.asPromise)(()=>this._provider.provideDocumentColors(te,j)).then(oe=>Array.isArray(oe)?oe.map(_e=>({color:A.Color.from(_e.color),range:A.Range.from(_e.range)})):[])}provideColorPresentations($,j,te){const oe=this._documents.getDocument($),de=A.Range.to(j.range),_e=A.Color.to(j.color);return(0,y.asPromise)(()=>this._provider.provideColorPresentations(_e,{document:oe,range:de},te)).then(Be=>{if(!!Array.isArray(Be))return Be.map(A.ColorPresentation.from)})}}class ne{constructor($,j){this._documents=$,this._provider=j}provideFoldingRanges($,j,te){const oe=this._documents.getDocument($);return(0,y.asPromise)(()=>this._provider.provideFoldingRanges(oe,j,te)).then(de=>{if(!!Array.isArray(de))return de.map(A.FoldingRange.from)})}}class me{constructor($,j,te){this._documents=$,this._provider=j,this._logService=te}provideSelectionRanges($,j,te){const oe=this._documents.getDocument($),de=j.map(A.Position.to);return(0,y.asPromise)(()=>this._provider.provideSelectionRanges(oe,de,te)).then(_e=>{if(!(0,i.isNonEmptyArray)(_e))return[];if(_e.length!==de.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Be=[];for(let fe=0;fe<de.length;fe++){const De=[];Be.push(De);let Re=de[fe],He=_e[fe];for(;;){if(!He.range.contains(Re))throw new Error("INVALID selection range, must contain the previous range");if(De.push(A.SelectionRange.from(He)),!He.parent)break;Re=He.range,He=He.parent}}return Be})}}class Le{constructor($,j){this._documents=$,this._provider=j,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession($,j,te){const oe=this._documents.getDocument($),de=A.Position.to(j),_e=await this._provider.prepareCallHierarchy(oe,de,te);if(!!_e){const Be=this._idPool.nextId();return this._cache.set(Be,new Map),Array.isArray(_e)?_e.map(fe=>this._cacheAndConvertItem(Be,fe)):[this._cacheAndConvertItem(Be,_e)]}}async provideCallsTo($,j,te){const oe=this._itemFromCache($,j);if(!oe)throw new Error("missing call hierarchy item");const de=await this._provider.provideCallHierarchyIncomingCalls(oe,te);if(!!de)return de.map(_e=>({from:this._cacheAndConvertItem($,_e.from),fromRanges:_e.fromRanges.map(Be=>A.Range.from(Be))}))}async provideCallsFrom($,j,te){const oe=this._itemFromCache($,j);if(!oe)throw new Error("missing call hierarchy item");const de=await this._provider.provideCallHierarchyOutgoingCalls(oe,te);if(!!de)return de.map(_e=>({to:this._cacheAndConvertItem($,_e.to),fromRanges:_e.fromRanges.map(Be=>A.Range.from(Be))}))}releaseSession($){this._cache.delete($)}_cacheAndConvertItem($,j){var te;const oe=this._cache.get($),de={_sessionId:$,_itemId:oe.size.toString(36),name:j.name,detail:j.detail,kind:A.SymbolKind.from(j.kind),uri:j.uri,range:A.Range.from(j.range),selectionRange:A.Range.from(j.selectionRange),tags:(te=j.tags)===null||te===void 0?void 0:te.map(A.SymbolTag.from)};return oe.set(de._itemId,j),de}_itemFromCache($,j){const te=this._cache.get($);return te==null?void 0:te.get(j)}}class We{constructor($,j){this.adapter=$,this.extension=j}}class Fe{constructor($,j,te,oe,de,_e,Be){this._adapter=new Map,this._uriTransformer=j,this._proxy=$.getProxy(D.MainContext.MainThreadLanguageFeatures),this._documents=te,this._commands=oe,this._diagnostics=de,this._logService=_e,this._apiDeprecation=Be}_transformDocumentSelector($){return(0,i.coalesce)((0,i.asArray)($).map(j=>this._doTransformDocumentSelector(j)))}_doTransformDocumentSelector($){if(typeof $=="string")return{$serialized:!0,language:$};if($)return{$serialized:!0,language:$.language,scheme:this._transformScheme($.scheme),pattern:typeof $.pattern=="undefined"?void 0:A.GlobPattern.from($.pattern),exclusive:$.exclusive}}_transformScheme($){return this._uriTransformer&&typeof $=="string"?this._uriTransformer.transformOutgoingScheme($):$}_createDisposable($){return new T.Disposable(()=>{this._adapter.delete($),this._proxy.$unregister($)})}_nextHandle(){return Fe._handlePool++}_withAdapter($,j,te,oe,de=!1){const _e=this._adapter.get($);if(!_e)return Promise.resolve(oe);if(_e.adapter instanceof j){let Be;_e.extension&&(Be=Date.now(),this._logService.trace(`[${_e.extension.identifier.value}] INVOKE provider '${j.name}'`));const fe=te(_e.adapter,_e.extension),De=_e.extension;return De&&Promise.resolve(fe).then(()=>this._logService.trace(`[${De.identifier.value}] provider DONE after ${Date.now()-Be}ms`),Re=>{de&&Re instanceof E.CancellationError||(this._logService.error(`[${De.identifier.value}] provider FAILED`),this._logService.error(Re))}),fe}return Promise.reject(new Error("no adapter found"))}_addNewAdapter($,j){const te=this._nextHandle();return this._adapter.set(te,new We($,j)),te}static _extLabel($){return $.displayName||$.name}registerDocumentSymbolProvider($,j,te,oe){const de=this._addNewAdapter(new m(this._documents,te),$),_e=oe&&oe.label||Fe._extLabel($);return this._proxy.$registerDocumentSymbolProvider(de,this._transformDocumentSelector(j),_e),this._createDisposable(de)}$provideDocumentSymbols($,j,te){return this._withAdapter($,m,oe=>oe.provideDocumentSymbols(_.URI.revive(j),te),void 0)}registerCodeLensProvider($,j,te){const oe=this._nextHandle(),de=typeof te.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(oe,new We(new u(this._documents,this._commands.converter,te),$)),this._proxy.$registerCodeLensSupport(oe,this._transformDocumentSelector(j),de);let _e=this._createDisposable(oe);if(de!==void 0){const Be=te.onDidChangeCodeLenses(fe=>this._proxy.$emitCodeLensEvent(de));_e=T.Disposable.from(_e,Be)}return _e}$provideCodeLenses($,j,te){return this._withAdapter($,u,oe=>oe.provideCodeLenses(_.URI.revive(j),te),void 0)}$resolveCodeLens($,j,te){return this._withAdapter($,u,oe=>oe.resolveCodeLens(j,te),void 0)}$releaseCodeLenses($,j){this._withAdapter($,u,te=>Promise.resolve(te.releaseCodeLenses(j)),void 0)}registerDefinitionProvider($,j,te){const oe=this._addNewAdapter(new t(this._documents,te),$);return this._proxy.$registerDefinitionSupport(oe,this._transformDocumentSelector(j)),this._createDisposable(oe)}$provideDefinition($,j,te,oe){return this._withAdapter($,t,de=>de.provideDefinition(_.URI.revive(j),te,oe),[])}registerDeclarationProvider($,j,te){const oe=this._addNewAdapter(new n(this._documents,te),$);return this._proxy.$registerDeclarationSupport(oe,this._transformDocumentSelector(j)),this._createDisposable(oe)}$provideDeclaration($,j,te,oe){return this._withAdapter($,n,de=>de.provideDeclaration(_.URI.revive(j),te,oe),[])}registerImplementationProvider($,j,te){const oe=this._addNewAdapter(new l(this._documents,te),$);return this._proxy.$registerImplementationSupport(oe,this._transformDocumentSelector(j)),this._createDisposable(oe)}$provideImplementation($,j,te,oe){return this._withAdapter($,l,de=>de.provideImplementation(_.URI.revive(j),te,oe),[])}registerTypeDefinitionProvider($,j,te){const oe=this._addNewAdapter(new a(this._documents,te),$);return this._proxy.$registerTypeDefinitionSupport(oe,this._transformDocumentSelector(j)),this._createDisposable(oe)}$provideTypeDefinition($,j,te,oe){return this._withAdapter($,a,de=>de.provideTypeDefinition(_.URI.revive(j),te,oe),[])}registerHoverProvider($,j,te,oe){const de=this._addNewAdapter(new s(this._documents,te),$);return this._proxy.$registerHoverProvider(de,this._transformDocumentSelector(j)),this._createDisposable(de)}$provideHover($,j,te,oe){return this._withAdapter($,s,de=>de.provideHover(_.URI.revive(j),te,oe),void 0)}registerEvaluatableExpressionProvider($,j,te,oe){const de=this._addNewAdapter(new c(this._documents,te),$);return this._proxy.$registerEvaluatableExpressionProvider(de,this._transformDocumentSelector(j)),this._createDisposable(de)}$provideEvaluatableExpression($,j,te,oe){return this._withAdapter($,c,de=>de.provideEvaluatableExpression(_.URI.revive(j),te,oe),void 0)}registerInlineValuesProvider($,j,te,oe){const de=typeof te.onDidChangeInlineValues=="function"?this._nextHandle():void 0,_e=this._addNewAdapter(new v(this._documents,te),$);this._proxy.$registerInlineValuesProvider(_e,this._transformDocumentSelector(j),de);let Be=this._createDisposable(_e);if(de!==void 0){const fe=te.onDidChangeInlineValues(De=>this._proxy.$emitInlineValuesEvent(de));Be=T.Disposable.from(Be,fe)}return Be}$provideInlineValues($,j,te,oe,de){return this._withAdapter($,v,_e=>_e.provideInlineValues(_.URI.revive(j),te,oe,de),void 0)}registerDocumentHighlightProvider($,j,te){const oe=this._addNewAdapter(new P(this._documents,te),$);return this._proxy.$registerDocumentHighlightProvider(oe,this._transformDocumentSelector(j)),this._createDisposable(oe)}$provideDocumentHighlights($,j,te,oe){return this._withAdapter($,P,de=>de.provideDocumentHighlights(_.URI.revive(j),te,oe),void 0)}registerLinkedEditingRangeProvider($,j,te){const oe=this._addNewAdapter(new h(this._documents,te),$);return this._proxy.$registerLinkedEditingRangeProvider(oe,this._transformDocumentSelector(j)),this._createDisposable(oe)}$provideLinkedEditingRanges($,j,te,oe){return this._withAdapter($,h,async de=>{const _e=await de.provideLinkedEditingRanges(_.URI.revive(j),te,oe);if(_e)return{ranges:_e.ranges,wordPattern:_e.wordPattern?Fe._serializeRegExp(_e.wordPattern):void 0}},void 0)}registerReferenceProvider($,j,te){const oe=this._addNewAdapter(new b(this._documents,te),$);return this._proxy.$registerReferenceSupport(oe,this._transformDocumentSelector(j)),this._createDisposable(oe)}$provideReferences($,j,te,oe,de){return this._withAdapter($,b,_e=>_e.provideReferences(_.URI.revive(j),te,oe,de),void 0)}registerCodeActionProvider($,j,te,oe){var de,_e;const Be=new f.DisposableStore,fe=this._addNewAdapter(new R(this._documents,this._commands.converter,this._diagnostics,te,this._logService,$,this._apiDeprecation),$);return this._proxy.$registerQuickFixSupport(fe,this._transformDocumentSelector(j),{providedKinds:(de=oe==null?void 0:oe.providedCodeActionKinds)===null||de===void 0?void 0:de.map(De=>De.value),documentation:(_e=oe==null?void 0:oe.documentation)===null||_e===void 0?void 0:_e.map(De=>({kind:De.kind.value,command:this._commands.converter.toInternal(De.command,Be)}))},Fe._extLabel($),Boolean(te.resolveCodeAction)),Be.add(this._createDisposable(fe)),Be}$provideCodeActions($,j,te,oe,de){return this._withAdapter($,R,_e=>_e.provideCodeActions(_.URI.revive(j),te,oe,de),void 0)}$resolveCodeAction($,j,te){return this._withAdapter($,R,oe=>oe.resolveCodeAction(j,te),void 0)}$releaseCodeActions($,j){this._withAdapter($,R,te=>Promise.resolve(te.releaseCodeActions(j)),void 0)}registerDocumentFormattingEditProvider($,j,te){const oe=this._addNewAdapter(new U(this._documents,te),$);return this._proxy.$registerDocumentFormattingSupport(oe,this._transformDocumentSelector(j),$.identifier,$.displayName||$.name),this._createDisposable(oe)}$provideDocumentFormattingEdits($,j,te,oe){return this._withAdapter($,U,de=>de.provideDocumentFormattingEdits(_.URI.revive(j),te,oe),void 0)}registerDocumentRangeFormattingEditProvider($,j,te){const oe=this._addNewAdapter(new K(this._documents,te),$);return this._proxy.$registerRangeFormattingSupport(oe,this._transformDocumentSelector(j),$.identifier,$.displayName||$.name),this._createDisposable(oe)}$provideDocumentRangeFormattingEdits($,j,te,oe,de){return this._withAdapter($,K,_e=>_e.provideDocumentRangeFormattingEdits(_.URI.revive(j),te,oe,de),void 0)}registerOnTypeFormattingEditProvider($,j,te,oe){const de=this._addNewAdapter(new he(this._documents,te),$);return this._proxy.$registerOnTypeFormattingSupport(de,this._transformDocumentSelector(j),oe,$.identifier),this._createDisposable(de)}$provideOnTypeFormattingEdits($,j,te,oe,de,_e){return this._withAdapter($,he,Be=>Be.provideOnTypeFormattingEdits(_.URI.revive(j),te,oe,de,_e),void 0)}registerWorkspaceSymbolProvider($,j){const te=this._addNewAdapter(new V(j,this._logService),$);return this._proxy.$registerNavigateTypeSupport(te),this._createDisposable(te)}$provideWorkspaceSymbols($,j,te){return this._withAdapter($,V,oe=>oe.provideWorkspaceSymbols(j,te),{symbols:[]})}$resolveWorkspaceSymbol($,j,te){return this._withAdapter($,V,oe=>oe.resolveWorkspaceSymbol(j,te),void 0)}$releaseWorkspaceSymbols($,j){this._withAdapter($,V,te=>te.releaseWorkspaceSymbols(j),void 0)}registerRenameProvider($,j,te){const oe=this._addNewAdapter(new H(this._documents,te,this._logService),$);return this._proxy.$registerRenameSupport(oe,this._transformDocumentSelector(j),H.supportsResolving(te)),this._createDisposable(oe)}$provideRenameEdits($,j,te,oe,de){return this._withAdapter($,H,_e=>_e.provideRenameEdits(_.URI.revive(j),te,oe,de),void 0)}$resolveRenameLocation($,j,te,oe){return this._withAdapter($,H,de=>de.resolveRenameLocation(_.URI.revive(j),te,oe),void 0)}registerDocumentSemanticTokensProvider($,j,te,oe){const de=this._nextHandle(),_e=typeof te.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(de,new We(new W(this._documents,te),$)),this._proxy.$registerDocumentSemanticTokensProvider(de,this._transformDocumentSelector(j),oe,_e);let Be=this._createDisposable(de);if(_e){const fe=te.onDidChangeSemanticTokens(De=>this._proxy.$emitDocumentSemanticTokensEvent(_e));Be=T.Disposable.from(Be,fe)}return Be}$provideDocumentSemanticTokens($,j,te,oe){return this._withAdapter($,W,de=>de.provideDocumentSemanticTokens(_.URI.revive(j),te,oe),null,!0)}$releaseDocumentSemanticTokens($,j){this._withAdapter($,W,te=>te.releaseDocumentSemanticColoring(j),void 0)}registerDocumentRangeSemanticTokensProvider($,j,te,oe){const de=this._addNewAdapter(new F(this._documents,te),$);return this._proxy.$registerDocumentRangeSemanticTokensProvider(de,this._transformDocumentSelector(j),oe),this._createDisposable(de)}$provideDocumentRangeSemanticTokens($,j,te,oe){return this._withAdapter($,F,de=>de.provideDocumentRangeSemanticTokens(_.URI.revive(j),te,oe),null,!0)}registerCompletionItemProvider($,j,te,oe){const de=this._addNewAdapter(new L(this._documents,this._commands.converter,te,this._apiDeprecation,$),$);return this._proxy.$registerSuggestSupport(de,this._transformDocumentSelector(j),oe,L.supportsResolving(te),`${$.identifier.value}(${oe.join("")})`),this._createDisposable(de)}$provideCompletionItems($,j,te,oe,de){return this._withAdapter($,L,_e=>_e.provideCompletionItems(_.URI.revive(j),te,oe,de),void 0)}$resolveCompletionItem($,j,te){return this._withAdapter($,L,oe=>oe.resolveCompletionItem(j,te),void 0)}$releaseCompletionItems($,j){this._withAdapter($,L,te=>te.releaseCompletionItems(j),void 0)}registerSignatureHelpProvider($,j,te,oe){const de=Array.isArray(oe)?{triggerCharacters:oe,retriggerCharacters:[]}:oe,_e=this._addNewAdapter(new M(this._documents,te),$);return this._proxy.$registerSignatureHelpProvider(_e,this._transformDocumentSelector(j),de),this._createDisposable(_e)}$provideSignatureHelp($,j,te,oe,de){return this._withAdapter($,M,_e=>_e.provideSignatureHelp(_.URI.revive(j),te,oe,de),void 0)}$releaseSignatureHelp($,j){this._withAdapter($,M,te=>te.releaseSignatureHelp(j),void 0)}registerInlayHintsProvider($,j,te){const oe=typeof te.onDidChangeInlayHints=="function"?this._nextHandle():void 0,de=this._addNewAdapter(new x(this._documents,te),$);this._proxy.$registerInlayHintsProvider(de,this._transformDocumentSelector(j),oe);let _e=this._createDisposable(de);if(oe!==void 0){const Be=te.onDidChangeInlayHints(fe=>this._proxy.$emitInlayHintsEvent(oe));_e=T.Disposable.from(_e,Be)}return _e}$provideInlayHints($,j,te,oe){return this._withAdapter($,x,de=>de.provideInlayHints(_.URI.revive(j),te,oe),void 0)}registerDocumentLinkProvider($,j,te){const oe=this._addNewAdapter(new G(this._documents,te),$);return this._proxy.$registerDocumentLinkProvider(oe,this._transformDocumentSelector(j),typeof te.resolveDocumentLink=="function"),this._createDisposable(oe)}$provideDocumentLinks($,j,te){return this._withAdapter($,G,oe=>oe.provideLinks(_.URI.revive(j),te),void 0)}$resolveDocumentLink($,j,te){return this._withAdapter($,G,oe=>oe.resolveLink(j,te),void 0)}$releaseDocumentLinks($,j){this._withAdapter($,G,te=>te.releaseLinks(j),void 0)}registerColorProvider($,j,te){const oe=this._addNewAdapter(new X(this._documents,te),$);return this._proxy.$registerDocumentColorProvider(oe,this._transformDocumentSelector(j)),this._createDisposable(oe)}$provideDocumentColors($,j,te){return this._withAdapter($,X,oe=>oe.provideColors(_.URI.revive(j),te),[])}$provideColorPresentations($,j,te,oe){return this._withAdapter($,X,de=>de.provideColorPresentations(_.URI.revive(j),te,oe),void 0)}registerFoldingRangeProvider($,j,te){const oe=this._nextHandle(),de=typeof te.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(oe,new We(new ne(this._documents,te),$)),this._proxy.$registerFoldingRangeProvider(oe,this._transformDocumentSelector(j),de);let _e=this._createDisposable(oe);if(de!==void 0){const Be=te.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(de));_e=T.Disposable.from(_e,Be)}return _e}$provideFoldingRanges($,j,te,oe){return this._withAdapter($,ne,de=>de.provideFoldingRanges(_.URI.revive(j),te,oe),void 0)}registerSelectionRangeProvider($,j,te){const oe=this._addNewAdapter(new me(this._documents,te,this._logService),$);return this._proxy.$registerSelectionRangeProvider(oe,this._transformDocumentSelector(j)),this._createDisposable(oe)}$provideSelectionRanges($,j,te,oe){return this._withAdapter($,me,de=>de.provideSelectionRanges(_.URI.revive(j),te,oe),[])}registerCallHierarchyProvider($,j,te){const oe=this._addNewAdapter(new Le(this._documents,te),$);return this._proxy.$registerCallHierarchyProvider(oe,this._transformDocumentSelector(j)),this._createDisposable(oe)}$prepareCallHierarchy($,j,te,oe){return this._withAdapter($,Le,de=>Promise.resolve(de.prepareSession(_.URI.revive(j),te,oe)),void 0)}$provideCallHierarchyIncomingCalls($,j,te,oe){return this._withAdapter($,Le,de=>de.provideCallsTo(j,te,oe),void 0)}$provideCallHierarchyOutgoingCalls($,j,te,oe){return this._withAdapter($,Le,de=>de.provideCallsFrom(j,te,oe),void 0)}$releaseCallHierarchy($,j){this._withAdapter($,Le,te=>Promise.resolve(te.releaseSession(j)),void 0)}static _serializeRegExp($){return{pattern:$.source,flags:(0,S.regExpFlags)($)}}static _serializeIndentationRule($){return{decreaseIndentPattern:Fe._serializeRegExp($.decreaseIndentPattern),increaseIndentPattern:Fe._serializeRegExp($.increaseIndentPattern),indentNextLinePattern:$.indentNextLinePattern?Fe._serializeRegExp($.indentNextLinePattern):void 0,unIndentedLinePattern:$.unIndentedLinePattern?Fe._serializeRegExp($.unIndentedLinePattern):void 0}}static _serializeOnEnterRule($){return{beforeText:Fe._serializeRegExp($.beforeText),afterText:$.afterText?Fe._serializeRegExp($.afterText):void 0,previousLineText:$.previousLineText?Fe._serializeRegExp($.previousLineText):void 0,action:$.action}}static _serializeOnEnterRules($){return $.map(Fe._serializeOnEnterRule)}setLanguageConfiguration($,j,te){let{wordPattern:oe}=te;if(oe&&(0,S.regExpLeadsToEndlessLoop)(oe))throw new Error(`Invalid language configuration: wordPattern '${oe}' is not allowed to match the empty string.`);oe?this._documents.setWordDefinitionFor(j,oe):this._documents.setWordDefinitionFor(j,void 0),te.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",$,"Do not use."),te.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",$,"Do not use.");const de=this._nextHandle(),_e={comments:te.comments,brackets:te.brackets,wordPattern:te.wordPattern?Fe._serializeRegExp(te.wordPattern):void 0,indentationRules:te.indentationRules?Fe._serializeIndentationRule(te.indentationRules):void 0,onEnterRules:te.onEnterRules?Fe._serializeOnEnterRules(te.onEnterRules):void 0,__electricCharacterSupport:te.__electricCharacterSupport,__characterPairSupport:te.__characterPairSupport};return this._proxy.$setLanguageConfiguration(de,j,_e),this._createDisposable(de)}$setWordDefinitions($){for(const j of $)this._documents.setWordDefinitionFor(j.languageId,new RegExp(j.regexSource,j.regexFlags))}}e.ExtHostLanguageFeatures=Fe,Fe._handlePool=0}),define(ve[199],be([0,1,5,9,7]),function(J,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class T{constructor(D,S){this._proxy=D.getProxy(_.MainContext.MainThreadLanguages),this._documents=S}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(D,S){await this._proxy.$changeLanguage(D,S);const C=this._documents.getDocumentData(D);if(!C)throw new Error(`document '${D.toString}' NOT found`);return C.document}async tokenAtPosition(D,S){var C;const i=D.version,I=k.Position.from(S),d=await this._proxy.$tokensAtPosition(D.uri,I),f={type:A.StandardTokenType.Other,range:(C=D.getWordRangeAtPosition(S))!==null&&C!==void 0?C:new A.Range(S.line,S.character,S.line,S.character)};if(!d)return f;const r={range:k.Range.to(d.range),type:k.TokenType.to(d.type)};return!r.range.contains(S)||i!==D.version?f:r}}e.ExtHostLanguages=T}),define(ve[200],be([0,1,5,18,33]),function(J,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(D){return D&&D.title}let y=class{constructor(S,C){this._logService=C,this._proxy=S.getProxy(_.MainContext.MainThreadMessageService)}showMessage(S,C,i,I,d){const f={extension:S};let r;typeof I=="string"||T(I)?r=[I,...d]:(f.modal=I&&I.modal,f.useCustom=I&&I.useCustom,r=d),f.useCustom&&(0,A.checkProposedApiEnabled)(S);const o=[];for(let p=0;p<r.length;p++){const g=r[p];if(typeof g=="string")o.push({title:g,handle:p,isCloseAffordance:!1});else if(typeof g=="object"){let{title:E,isCloseAffordance:m}=g;o.push({title:E,isCloseAffordance:!!m,handle:p})}else this._logService.warn("Invalid message item:",g)}return this._proxy.$showMessage(C,i,f,o).then(p=>{if(typeof p=="number")return r[p]})}};y=je([Ke(1,k.ILogService)],y),e.ExtHostMessageService=y}),define(ve[201],be([0,1,11,24,20,3,56,54,6,22,8,10,2,68,5,9,7,73,178,179]),function(J,e,_,k,A,T,y,D,S,C,i,I,d,f,r,o,p,g,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=void 0;class u{constructor(s,c){const v=u._Keys.nextId();s.$registerNotebookEditorDecorationType(v,o.NotebookDecorationRenderOptions.from(c)),this.value={key:v,dispose(){s.$removeNotebookEditorDecorationType(v)}}}}e.NotebookEditorDecorationType=u,u._Keys=new D.IdGenerator("NotebookEditorDecorationType");class w{constructor(s,c,v,P,h,b){this._textDocumentsAndEditors=v,this._textDocuments=P,this.logService=h,this._extensionStoragePaths=b,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new C.ResourceMap,this._editors=new Map,this._onDidChangeNotebookEditorSelection=new T.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new T.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new T.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new T.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new T.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new T.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new T.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new T.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new T.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new T.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new T.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new T.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._activeExecutions=new C.ResourceMap,this._statusBarCache=new f.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=s.getProxy(r.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=s.getProxy(r.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=s.getProxy(r.MainContext.MainThreadNotebookEditors),this._commandsConverter=c.converter,c.registerArgumentProcessor({processArgument:R=>{var U;if(R&&R.$mid===12){const K=(U=R.notebookEditor)===null||U===void 0?void 0:U.notebookUri,he=R.cell.handle,V=this._documents.get(K),H=V==null?void 0:V.getCell(he);if(H)return H.apiCell}return R}})}get activeNotebookEditor(){var s;return(s=this._activeNotebookEditor)===null||s===void 0?void 0:s.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(s=>s.apiEditor)}getEditorById(s){return this._editors.get(s)}getIdByEditor(s){for(const[c,v]of this._editors)if(v.apiEditor===s)return c}get notebookDocuments(){return[...this._documents.values()]}lookupNotebookDocument(s){return this._documents.get(s)}_getNotebookDocument(s){const c=this._documents.get(s);if(!c)throw new Error(`NO notebook document for '${s}'`);return c}_getProviderData(s){const c=this._notebookContentProviders.get(s);if(!c)throw new Error(`NO provider for '${s}'`);return c}registerNotebookContentProvider(s,c,v,P,h){if((0,i.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(c))throw new Error(`Notebook provider for '${c}' already registered`);this._notebookContentProviders.set(c,{extension:s,provider:v});let b;return v.onDidChangeNotebookContentOptions&&(b=v.onDidChangeNotebookContentOptions(()=>{const R=o.NotebookDocumentContentOptions.from(v.options);this._notebookProxy.$updateNotebookProviderOptions(c,R)})),this._notebookProxy.$registerNotebookProvider({id:s.identifier,location:s.extensionLocation},c,o.NotebookDocumentContentOptions.from(P),w._convertNotebookRegistrationData(s,h)),new p.Disposable(()=>{b==null||b.dispose(),this._notebookContentProviders.delete(c),this._notebookProxy.$unregisterNotebookProvider(c)})}static _convertNotebookRegistrationData(s,c){if(!!c){const v=c.filenamePattern.map(P=>o.NotebookExclusiveDocumentPattern.from(P)).filter(P=>P!==void 0);if(c.filenamePattern&&!v){console.warn(`Notebook content provider view options file name pattern is invalid ${c.filenamePattern}`);return}return{providerDisplayName:s.displayName||s.name,displayName:c.displayName,filenamePattern:v,exclusive:c.exclusive||!1}}}registerNotebookCellStatusBarItemProvider(s,c,v){const P=w._notebookStatusBarItemProviderHandlePool++,h=typeof v.onDidChangeCellStatusBarItems=="function"?w._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(P,v),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(P,h,c);let b;return h!==void 0&&(b=v.onDidChangeCellStatusBarItems(R=>this._notebookProxy.$emitCellStatusBarEvent(h))),new p.Disposable(()=>{this._notebookStatusBarItemProviders.delete(P),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(P,h),b&&b.dispose()})}createNotebookEditorDecorationType(s){return new u(this._notebookEditorsProxy,s).value}async openNotebookDocument(s){const c=this._documents.get(s);if(c)return c.apiNotebook;const v=await this._notebookDocumentsProxy.$tryOpenDocument(s),P=this._documents.get(d.URI.revive(v));return(0,I.assertIsDefined)(P==null?void 0:P.apiNotebook)}async showNotebookDocument(s,c){var v;d.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let P;typeof c=="object"?P={position:o.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selections:c.selections&&c.selections.map(o.NotebookRange.from),pinned:typeof c.preview=="boolean"?!c.preview:void 0}:P={preserveFocus:!1};const h=await this._notebookEditorsProxy.$tryShowNotebookDocument(s.uri,s.viewType,P),b=h&&((v=this._editors.get(h))===null||v===void 0?void 0:v.apiEditor);if(b)return b;throw h?new Error(`Could NOT open editor for "${s.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.toString()}".`)}async $provideNotebookCellStatusBarItems(s,c,v,P){var h;const b=this._notebookStatusBarItemProviders.get(s),R=d.URI.revive(c),U=this._documents.get(R);if(!(!U||!b)){const K=U.getCellFromIndex(v);if(!!K){const he=await b.provideCellStatusBarItems(K.apiCell,P);if(!!he){const V=new S.DisposableStore,H=this._statusBarCache.add([V]),Y=(h=he&&he.map(W=>o.NotebookStatusBarItem.from(W,this._commandsConverter,V)))!==null&&h!==void 0?h:void 0;return{cacheId:H,items:Y}}}}}$releaseNotebookCellStatusBarItems(s){this._statusBarCache.delete(s)}registerNotebookSerializer(s,c,v,P,h){if((0,i.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");const b=this._handlePool++;return this._notebookSerializer.set(b,v),this._notebookProxy.$registerNotebookSerializer(b,{id:s.identifier,location:s.extensionLocation},c,o.NotebookDocumentContentOptions.from(P),w._convertNotebookRegistrationData(s,h)),(0,S.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(b)})}async $dataToNotebook(s,c,v){const P=this._notebookSerializer.get(s);if(!P)throw new Error("NO serializer found");const h=await P.deserializeNotebook(c.buffer,v);return{metadata:o.NotebookDocumentMetadata.from(h.metadata),cells:h.cells.map(o.NotebookCellData.from)}}async $notebookToData(s,c,v){const P=this._notebookSerializer.get(s);if(!P)throw new Error("NO serializer found");const h=await P.serializeNotebook({metadata:o.NotebookDocumentMetadata.to(c.metadata),cells:c.cells.map(o.NotebookCellData.to)},v);return k.VSBuffer.wrap(h)}cancelOneNotebookCellExecution(s){const c=this._activeExecutions.get(s.uri);c==null||c.cancel()}async $openNotebook(s,c,v,P,h){const{provider:b}=this._getProviderData(s),R=await b.openNotebook(d.URI.revive(c),{backupId:v,untitledDocumentData:P==null?void 0:P.buffer},h);return{metadata:o.NotebookDocumentMetadata.from(R.metadata),cells:R.cells.map(o.NotebookCellData.from)}}async $saveNotebook(s,c,v){const P=this._getNotebookDocument(d.URI.revive(c)),{provider:h}=this._getProviderData(s);return await h.saveNotebook(P.apiNotebook,v),!0}async $saveNotebookAs(s,c,v,P){const h=this._getNotebookDocument(d.URI.revive(c)),{provider:b}=this._getProviderData(s);return await b.saveNotebookAs(d.URI.revive(v),h.apiNotebook,P),!0}async $backupNotebook(s,c,v){var P;const h=this._getNotebookDocument(d.URI.revive(c)),b=this._getProviderData(s),R=(P=this._extensionStoragePaths.workspaceValue(b.extension))!==null&&P!==void 0?P:this._extensionStoragePaths.globalValue(b.extension),U=String((0,y.hash)([h.uri.toString(),this._backupIdPool++])),K=d.URI.joinPath(R,U),he=await b.provider.backupNotebook(h.apiNotebook,{destination:K},v);return h.updateBackup(he),he.id}$acceptModelChanged(s,c,v){this._getNotebookDocument(d.URI.revive(s)).acceptModelChanged(c,v)}$acceptDirtyStateChanged(s,c){const v=this._getNotebookDocument(d.URI.revive(s));v.acceptModelChanged({rawEvents:[],versionId:v.apiNotebook.version},c)}$acceptModelSaved(s){const c=this._getNotebookDocument(d.URI.revive(s));this._onDidSaveNotebookDocument.fire(c.apiNotebook)}$acceptEditorPropertiesChanged(s,c){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",s,c);const v=this._editors.get(s);if(!v)throw new Error(`unknown text editor: ${s}. known editors: ${[...this._editors.keys()]} `);c.visibleRanges&&v._acceptVisibleRanges(c.visibleRanges.ranges.map(o.NotebookRange.to)),c.selections&&v._acceptSelections(c.selections.selections.map(o.NotebookRange.to)),c.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:v.apiEditor,visibleRanges:v.apiEditor.visibleRanges}),c.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:v.apiEditor,selections:v.apiEditor.selections}))}$acceptEditorViewColumns(s){for(const c in s){const v=this._editors.get(c);if(!v)throw new Error(`unknown text editor: ${c}. known editors: ${[...this._editors.keys()]} `);v._acceptViewColumn(o.ViewColumn.to(s[c]))}}$acceptDocumentPropertiesChanged(s,c){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",s.path,c);const v=this._getNotebookDocument(d.URI.revive(s));v.acceptDocumentPropertiesChanged(c),c.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:v.apiNotebook})}_createExtHostEditor(s,c,v){if(this._editors.has(c))throw new Error(`editor with id ALREADY EXSIST: ${c}`);const P=new m.ExtHostNotebookEditor(c,this._notebookEditorsProxy,s,v.visibleRanges.map(o.NotebookRange.to),v.selections.map(o.NotebookRange.to),typeof v.viewColumn=="number"?o.ViewColumn.to(v.viewColumn):void 0);this._editors.set(c,P)}$acceptDocumentAndEditorsDelta(s){var c,v,P;if(s.removedDocuments)for(const b of s.removedDocuments){const R=d.URI.revive(b),U=this._documents.get(R);U&&(U.dispose(),this._documents.delete(R),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:U.apiNotebook.getCells().map(K=>K.document.uri)}),this._onDidCloseNotebookDocument.fire(U.apiNotebook));for(const K of this._editors.values())K.notebookData.uri.toString()===R.toString()&&this._editors.delete(K.id)}if(s.addedDocuments){const b=[];for(const R of s.addedDocuments){const U=d.URI.revive(R.uri),K=R.viewType;if(this._documents.has(U))throw new Error(`adding EXISTING notebook ${U} `);const he=this,V=new E.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(H){he._onDidChangeNotebookCells.fire(H)},emitCellOutputsChange(H){he._onDidChangeCellOutputs.fire(H)},emitCellMetadataChange(H){he._onDidChangeCellMetadata.fire(H)},emitCellExecutionStateChange(H){he._onDidChangeCellExecutionState.fire(H)}},K,R.metadata?o.NotebookDocumentMetadata.to(R.metadata):new p.NotebookDocumentMetadata,U);V.acceptModelChanged({versionId:R.versionId,rawEvents:[{kind:g.NotebookCellsChangeType.Initialize,changes:[[0,0,R.cells]]}]},!1),b.push(...R.cells.map(H=>E.ExtHostCell.asModelAddData(V.apiNotebook,H))),(c=this._documents.get(U))===null||c===void 0||c.dispose(),this._documents.set(U,V),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:b}),this._onDidOpenNotebookDocument.fire(V.apiNotebook)}}if(s.addedEditors)for(const b of s.addedEditors){if(this._editors.has(b.id))return;const R=d.URI.revive(b.documentUri),U=this._documents.get(R);U&&this._createExtHostEditor(U,b.id,b)}const h=[];if(s.removedEditors)for(const b of s.removedEditors){const R=this._editors.get(b);R&&(this._editors.delete(b),((v=this._activeNotebookEditor)===null||v===void 0?void 0:v.id)===R.id&&(this._activeNotebookEditor=void 0),h.push(R))}if(s.visibleEditors){this._visibleNotebookEditors=s.visibleEditors.map(R=>this._editors.get(R)).filter(R=>!!R);const b=new Set;this._visibleNotebookEditors.forEach(R=>b.add(R.id));for(const R of this._editors.values()){const U=b.has(R.id);R._acceptVisibility(U)}this._visibleNotebookEditors=[...this._editors.values()].map(R=>R).filter(R=>R.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}s.newActiveEditor===null?this._activeNotebookEditor=void 0:s.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(s.newActiveEditor)),s.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((P=this._activeNotebookEditor)===null||P===void 0?void 0:P.apiEditor)}createNotebookCellExecution(s,c,v){const P=this.lookupNotebookDocument(s);if(!P)throw new Error(`Invalid uri: ${s} `);const h=P.getCellFromIndex(c);if(!h)throw new Error(`Invalid cell index: ${s}, ${c} `);if(this._activeExecutions.has(h.uri))throw new Error(`duplicate execution for ${h.uri}`);const b=new n(s,P,h,this._notebookDocumentsProxy);this._activeExecutions.set(h.uri,b);const R=b.onDidChangeState(()=>{b.state===t.Resolved&&(b.dispose(),R.dispose(),this._activeExecutions.delete(h.uri))});return b.asApiObject()}}e.ExtHostNotebookController=w,w._notebookStatusBarItemProviderHandlePool=0;var t;(function(a){a[a.Init=0]="Init",a[a.Started=1]="Started",a[a.Resolved=2]="Resolved"})(t||(t={}));class n extends S.Disposable{constructor(s,c,v,P){super();this._uri=s,this._document=c,this._cell=v,this._proxy=P,this._onDidChangeState=new T.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=t.Init,this._tokenSource=this._register(new A.CancellationTokenSource),this._collector=new l(10,h=>this.applyEdits(h)),this._executionOrder=v.internalMetadata.executionOrder,this.mixinMetadata({runState:p.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(s){await this._collector.addItem(s)}async applyEdits(s){return this._proxy.$applyEdits(this._uri,s,!1)}verifyStateForOutput(){if(this._state===t.Init)throw new Error("Must call start before modifying cell output");if(this._state===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(s){const c={editType:8,handle:this._cell.handle,metadata:s};this.applyEdits([c])}cellIndexToHandle(s){const c=typeof s=="number"?this._document.getCellFromIndex(s):this._cell;if(!!c)return c.handle}asApiObject(){const s=this;return Object.freeze({get document(){return s._document.apiNotebook},get cell(){return s._cell.apiCell},get executionOrder(){return s._executionOrder},set executionOrder(c){s._executionOrder=c,s.mixinMetadata({executionOrder:c})},start(c){var v;if(s._state===t.Resolved||s._state===t.Started)throw new Error("Cannot call start again");s._state=t.Started,s._onDidChangeState.fire(),s.mixinMetadata({runState:p.NotebookCellExecutionState.Executing,runStartTime:(v=c==null?void 0:c.startTime)!==null&&v!==void 0?v:null})},end(c){var v,P;if(s._state===t.Resolved)throw new Error("Cannot call resolve twice");s._state=t.Resolved,s._onDidChangeState.fire(),s.mixinMetadata({runState:p.NotebookCellExecutionState.Idle,lastRunSuccess:(v=c==null?void 0:c.success)!==null&&v!==void 0?v:null,runEndTime:(P=c==null?void 0:c.endTime)!==null&&P!==void 0?P:null})},clearOutput(c){return s.verifyStateForOutput(),this.replaceOutput([],c)},async appendOutput(c,v){s.verifyStateForOutput();const P=s.cellIndexToHandle(v);if(typeof P=="number")return c=Array.isArray(c)?c:[c],s.applyEditSoon({editType:2,handle:P,append:!0,outputs:c.map(o.NotebookCellOutput.from)})},async replaceOutput(c,v){s.verifyStateForOutput();const P=s.cellIndexToHandle(v);if(typeof P=="number")return c=Array.isArray(c)?c:[c],s.applyEditSoon({editType:2,handle:P,outputs:c.map(o.NotebookCellOutput.from)})},async appendOutputItems(c,v){return s.verifyStateForOutput(),c=Array.isArray(c)?c:[c],s.applyEditSoon({editType:7,append:!0,items:c.map(o.NotebookCellOutputItem.from),outputId:v})},async replaceOutputItems(c,v){return s.verifyStateForOutput(),c=Array.isArray(c)?c:[c],s.applyEditSoon({editType:7,items:c.map(o.NotebookCellOutputItem.from),outputId:v})},token:s._tokenSource.token})}}class l{constructor(s,c){this.delay=s,this.callback=c,this.batch=[]}addItem(s){return this.batch.push(s),this.waitPromise||(this.waitPromise=(0,_.timeout)(this.delay).then(()=>{this.waitPromise=void 0;const c=this.batch;return this.batch=[],this.callback(c)})),this.waitPromise}}}),define(ve[202],be([0,1,3,6,5,26,2,9,72,22]),function(J,e,_,k,A,T,y,D,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;class i{constructor(d,f,r){this._initData=f,this._extHostNotebook=r,this._kernelData=new Map,this._handlePool=0,this._proxy=d.getProxy(A.MainContext.MainThreadNotebookKernels)}createNotebookController(d,f,r,o,p,g){for(let R of this._kernelData.values())if(R.controller.id===f&&T.ExtensionIdentifier.equals(d.identifier,R.extensionId))throw new Error(`notebook controller with id '${f}' ALREADY exist`);const E=this._handlePool++,m=this,u=()=>console.warn(`NO execute handler from notebook controller '${a.id}' of extension: '${d.identifier}'`);let w=!1;const t=new k.DisposableStore,n=new _.Emitter,l=new _.Emitter,a={id:`${d.identifier.value}/${f}`,viewType:r,extensionId:d.identifier,extensionLocation:d.extensionLocation,label:o||d.identifier.value,preloads:g?g.map(D.NotebookKernelPreload.from):[]};let s=p!=null?p:u,c;this._proxy.$addKernel(E,a).catch(R=>{console.log(R),w=!0});let v=0;const P=()=>{if(!w){const R=++v;Promise.resolve().then(()=>{R===v&&this._proxy.$updateKernel(E,a)})}},h=new C.ResourceMap,b={get id(){return f},get viewType(){return a.viewType},onDidChangeNotebookAssociation:n.event,get label(){return a.label},set label(R){var U;a.label=(U=R!=null?R:d.displayName)!==null&&U!==void 0?U:d.name,P()},get detail(){var R;return(R=a.detail)!==null&&R!==void 0?R:""},set detail(R){a.detail=R,P()},get description(){var R;return(R=a.description)!==null&&R!==void 0?R:""},set description(R){a.description=R,P()},get supportedLanguages(){return a.supportedLanguages},set supportedLanguages(R){a.supportedLanguages=R,P()},get hasExecutionOrder(){var R;return(R=a.hasExecutionOrder)!==null&&R!==void 0?R:!1},set hasExecutionOrder(R){a.hasExecutionOrder=R,P()},get preloads(){return a.preloads?a.preloads.map(D.NotebookKernelPreload.to):[]},get executeHandler(){return s},set executeHandler(R){s=R!=null?R:u},get interruptHandler(){return c},set interruptHandler(R){c=R,a.supportsInterrupt=Boolean(R),P()},createNotebookCellExecutionTask(R){if(w)throw new Error("notebook controller is DISPOSED");if(!h.has(R.notebook.uri))throw new Error(`notebook controller is NOT associated to notebook: ${R.notebook.uri.toString()}`);return m._extHostNotebook.createNotebookCellExecution(R.notebook.uri,R.index,a.id)},dispose:()=>{w||(w=!0,this._kernelData.delete(E),t.dispose(),n.dispose(),l.dispose(),this._proxy.$removeKernel(E))},onDidReceiveMessage:l.event,postMessage(R,U){return m._proxy.$postMessage(E,U&&m._extHostNotebook.getIdByEditor(U),R)},asWebviewUri(R){return(0,S.asWebviewUri)(m._initData.environment,String(E),R)},updateNotebookAffinity(R,U){m._proxy.$updateNotebookPriority(E,R.uri,U)}};return this._kernelData.set(E,{extensionId:d.identifier,controller:b,onDidReceiveMessage:l,onDidChangeSelection:n,associatedNotebooks:h}),b}$acceptSelection(d,f,r){const o=this._kernelData.get(d);if(o){const p=this._extHostNotebook.lookupNotebookDocument(y.URI.revive(f));r?o.associatedNotebooks.set(p.uri,!0):o.associatedNotebooks.delete(p.uri),o.onDidChangeSelection.fire({selected:r,notebook:p.apiNotebook})}}async $executeCells(d,f,r){const o=this._kernelData.get(d);if(!!o){const p=this._extHostNotebook.lookupNotebookDocument(y.URI.revive(f));if(!p)throw new Error("MISSING notebook");const g=[];for(let E of r){const m=p.getCell(E);m&&g.push(m.apiCell)}try{await o.controller.executeHandler.call(o.controller,g,p.apiNotebook,o.controller)}catch(E){console.error(E)}}}async $cancelCells(d,f,r){const o=this._kernelData.get(d);if(!!o){const p=this._extHostNotebook.lookupNotebookDocument(y.URI.revive(f));if(!p)throw new Error("MISSING notebook");o.controller.interruptHandler&&await o.controller.interruptHandler.call(o.controller,p.apiNotebook);for(let g of r){const E=p.getCell(g);E&&this._extHostNotebook.cancelOneNotebookCellExecution(E)}}}$acceptKernelMessageFromRenderer(d,f,r){const o=this._kernelData.get(d);if(!!o){const p=this._extHostNotebook.getEditorById(f);if(!p)throw new Error(`send message for UNKNOWN editor: ${f}`);o.onDidReceiveMessage.fire(Object.freeze({editor:p.apiEditor,message:r}))}}}e.ExtHostNotebookKernels=i}),define(ve[100],be([0,1,5,3,6,24,4,14]),function(J,e,_,k,A,T,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class S extends A.Disposable{constructor(r,o,p,g){super();this._onDidAppend=this._register(new k.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=r,this._proxy=g,this._id=g.$register(this.name,o,p),this._disposed=!1,this._offset=0}get name(){return this._name}append(r){this.validate(),this._offset+=r?T.VSBuffer.fromString(r).byteLength:0}update(){this._id.then(r=>this._proxy.$update(r))}appendLine(r){this.validate(),this.append(r+`
`)}clear(){this.validate();const r=this._offset;this._id.then(o=>this._proxy.$clear(o,r))}show(r,o){this.validate(),this._id.then(p=>this._proxy.$reveal(p,!!(typeof r=="boolean"?r:o)))}hide(){this.validate(),this._id.then(r=>this._proxy.$close(r))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(r=>this._proxy.$dispose(r)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=S;class C extends S{constructor(r,o){super(r,!1,void 0,o)}append(r){super.append(r),this._id.then(o=>this._proxy.$append(o,r)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=C;class i extends S{constructor(r,o,p){super(r,!0,o,p)}append(r){throw new Error("Not supported")}}class I{constructor(r,o){this.name=r,this._channel=o}append(r){this._channel.then(o=>o.append(r))}appendLine(r){this._channel.then(o=>o.appendLine(r))}clear(){this._channel.then(r=>r.clear())}show(r,o){this._channel.then(p=>p.show(r,o))}hide(){this._channel.then(r=>r.hide())}dispose(){this._channel.then(r=>r.dispose())}}e.LazyOutputChannel=I;let d=class{constructor(r){this._proxy=r.getProxy(_.MainContext.MainThreadOutputService)}$setVisibleChannel(r){}createOutputChannel(r){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");return new C(r,this._proxy)}createOutputChannelFromLogFile(r,o){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");if(!o)throw new Error("illegal argument `file`. must not be falsy");return new i(r,o,this._proxy)}};d=je([Ke(0,D.IExtHostRpcService)],d),e.ExtHostOutputService=d,e.IExtHostOutputService=(0,y.createDecorator)("IExtHostOutputService")}),define(ve[203],be([0,1,11,20,3,6,5,2,7,12,15,47]),function(J,e,_,k,A,T,y,D,S,C,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function d(f,r,o){const p=f.getProxy(y.MainContext.MainThreadQuickOpen);class g{constructor(a,s){this._sessions=new Map,this._instances=0,this._workspace=a,this._commands=s}showQuickPick(a,s,c,v=k.CancellationToken.None){this._onDidSelectItem=void 0;const P=Promise.resolve(a),h=++this._instances,b=p.$show(h,{title:c==null?void 0:c.title,placeHolder:c==null?void 0:c.placeHolder,matchOnDescription:c==null?void 0:c.matchOnDescription,matchOnDetail:c==null?void 0:c.matchOnDetail,ignoreFocusLost:c==null?void 0:c.ignoreFocusOut,canPickMany:c==null?void 0:c.canPickMany},v),R={},U=b.then(()=>R);return Promise.race([U,P]).then(K=>{if(K!==R)return P.then(he=>{const V=[];for(let H=0;H<he.length;H++){const Y=he[H];let W,F,L,M,x;typeof Y=="string"?W=Y:(W=Y.label,F=Y.description,L=Y.detail,M=Y.picked,x=Y.alwaysShow),V.push({label:W,description:F,handle:H,detail:L,picked:M,alwaysShow:x})}return c&&typeof c.onDidSelectItem=="function"&&(this._onDidSelectItem=H=>{c.onDidSelectItem(he[H])}),p.$setItems(h,V),b.then(H=>{if(typeof H=="number")return he[H];if(Array.isArray(H))return H.map(Y=>he[Y])})})}).then(void 0,K=>{if(!(0,C.isPromiseCanceledError)(K))return p.$setError(h,K),Promise.reject(K)})}$onItemSelected(a){this._onDidSelectItem&&this._onDidSelectItem(a)}showInput(a,s=k.CancellationToken.None){return this._validateInput=a?a.validateInput:void 0,p.$input(a,typeof this._validateInput=="function",s).then(void 0,c=>{if(!(0,C.isPromiseCanceledError)(c))return Promise.reject(c)})}$validateInput(a){return this._validateInput?(0,_.asPromise)(()=>this._validateInput(a)):Promise.resolve(void 0)}async showWorkspaceFolderPick(a,s=k.CancellationToken.None){const c=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[a]);if(!!c){const v=await this._workspace.getWorkspaceFolders2();if(!!v)return v.find(P=>P.uri.toString()===c.uri.toString())}}createQuickPick(a,s){const c=new t(a,s,()=>this._sessions.delete(c._id));return this._sessions.set(c._id,c),c}createInputBox(a){const s=new n(a,()=>this._sessions.delete(s._id));return this._sessions.set(s._id,s),s}$onDidChangeValue(a,s){const c=this._sessions.get(a);c&&c._fireDidChangeValue(s)}$onDidAccept(a){const s=this._sessions.get(a);s&&s._fireDidAccept()}$onDidChangeActive(a,s){const c=this._sessions.get(a);c instanceof t&&c._fireDidChangeActive(s)}$onDidChangeSelection(a,s){const c=this._sessions.get(a);c instanceof t&&c._fireDidChangeSelection(s)}$onDidTriggerButton(a,s){const c=this._sessions.get(a);c&&c._fireDidTriggerButton(s)}$onDidHide(a){const s=this._sessions.get(a);s&&s._fireDidHide()}}class E{constructor(a,s){this._extensionId=a,this._onDidDispose=s,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new A.Emitter,this._onDidChangeValueEmitter=new A.Emitter,this._onDidTriggerButtonEmitter=new A.Emitter,this._onDidHideEmitter=new A.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(a){this._title=a,this.update({title:a})}get step(){return this._steps}set step(a){this._steps=a,this.update({step:a})}get totalSteps(){return this._totalSteps}set totalSteps(a){this._totalSteps=a,this.update({totalSteps:a})}get enabled(){return this._enabled}set enabled(a){this._enabled=a,this.update({enabled:a})}get busy(){return this._busy}set busy(a){this._busy=a,this.update({busy:a})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(a){this._ignoreFocusOut=a,this.update({ignoreFocusOut:a})}get value(){return this._value}set value(a){this._value=a,this.update({value:a})}get placeholder(){return this._placeholder}set placeholder(a){this._placeholder=a,this.update({placeholder:a})}get buttons(){return this._buttons}set buttons(a){this._buttons=a.slice(),this._handlesToButtons.clear(),a.forEach((s,c)=>{const v=s===S.QuickInputButtons.Back?-1:c;this._handlesToButtons.set(v,s)}),this.update({buttons:a.map((s,c)=>({iconPath:m(s.iconPath),tooltip:s.tooltip,handle:s===S.QuickInputButtons.Back?-1:c}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(a){this._value=a,this._onDidChangeValueEmitter.fire(a)}_fireDidTriggerButton(a){const s=this._handlesToButtons.get(a);s&&this._onDidTriggerButtonEmitter.fire(s)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,T.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),p.$dispose(this._id))}update(a){if(!this._disposed){for(const s of Object.keys(a)){const c=a[s];this._pendingUpdate[s]=c===void 0?null:c}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){p.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}E._nextId=1;function m(l){if(l instanceof S.ThemeIcon)return{id:l.id};const a=w(l),s=u(l);return{dark:typeof a=="string"?D.URI.file(a):a,light:typeof s=="string"?D.URI.file(s):s}}function u(l){return typeof l=="object"&&"light"in l?l.light:l}function w(l){return typeof l=="object"&&"dark"in l?l.dark:l}class t extends E{constructor(a,s,c){super(a,c);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new A.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new A.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(a){this._items=a.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),a.forEach((s,c)=>{this._handlesToItems.set(c,s),this._itemsToHandles.set(s,c)}),this.update({items:a.map((s,c)=>({label:s.label,description:s.description,handle:c,detail:s.detail,picked:s.picked,alwaysShow:s.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(a){this._canSelectMany=a,this.update({canSelectMany:a})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(a){this._matchOnDescription=a,this.update({matchOnDescription:a})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(a){this._matchOnDetail=a,this.update({matchOnDetail:a})}get sortByLabel(){return this._sortByLabel}set sortByLabel(a){this._sortByLabel=a,this.update({sortByLabel:a})}get activeItems(){return this._activeItems}set activeItems(a){this._activeItems=a.filter(s=>this._itemsToHandles.has(s)),this.update({activeItems:this._activeItems.map(s=>this._itemsToHandles.get(s))})}get selectedItems(){return this._selectedItems}set selectedItems(a){this._selectedItems=a.filter(s=>this._itemsToHandles.has(s)),this.update({selectedItems:this._selectedItems.map(s=>this._itemsToHandles.get(s))})}_fireDidChangeActive(a){const s=(0,i.coalesce)(a.map(c=>this._handlesToItems.get(c)));this._activeItems=s,this._onDidChangeActiveEmitter.fire(s)}_fireDidChangeSelection(a){const s=(0,i.coalesce)(a.map(c=>this._handlesToItems.get(c)));this._selectedItems=s,this._onDidChangeSelectionEmitter.fire(s)}}class n extends E{constructor(a,s){super(a,s);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(a){this._password=a,this.update({password:a})}get prompt(){return this._prompt}set prompt(a){this._prompt=a,this.update({prompt:a})}get validationMessage(){return this._validationMessage}set validationMessage(a){this._validationMessage=a,this.update({validationMessage:a,severity:a?I.default.Error:I.default.Ignore})}}return new g(r,o)}e.createExtHostQuickOpen=d}),define(ve[204],be([0,1,2,3,52,6,11,5,15,112,18,26,33]),function(J,e,_,k,A,T,y,D,S,C,i,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function f(a){if(a)return typeof a.iconPath=="string"?_.URI.file(a.iconPath):a.iconPath}function r(a,s){if(!a.iconPath&&!s.iconPath)return 0;if(a.iconPath){if(!s.iconPath)return 1}else return-1;const c=typeof a.iconPath=="string"?a.iconPath:a.iconPath.fsPath,v=typeof s.iconPath=="string"?s.iconPath:s.iconPath.fsPath;return(0,C.comparePaths)(c,v)}function o(a,s){let c=0;if(a.strikeThrough!==s.strikeThrough)return a.strikeThrough?1:-1;if(a.faded!==s.faded)return a.faded?1:-1;if(a.tooltip!==s.tooltip)return(a.tooltip||"").localeCompare(s.tooltip||"");if(c=r(a,s),c!==0)return c;if(a.light&&s.light)c=r(a.light,s.light);else{if(a.light)return 1;if(s.light)return-1}if(c!==0)return c;if(a.dark&&s.dark)c=r(a.dark,s.dark);else{if(a.dark)return 1;if(s.dark)return-1}return c}function p(a,s){if(a.command!==s.command)return a.command<s.command?-1:1;if(a.title!==s.title)return a.title<s.title?-1:1;if(a.tooltip!==s.tooltip){if(a.tooltip!==void 0&&s.tooltip!==void 0)return a.tooltip<s.tooltip?-1:1;if(a.tooltip!==void 0)return 1;if(s.tooltip!==void 0)return-1}if(a.arguments===s.arguments)return 0;if(a.arguments)if(s.arguments){if(a.arguments.length!==s.arguments.length)return a.arguments.length-s.arguments.length}else return 1;else return-1;for(let c=0;c<a.arguments.length;c++){const v=a.arguments[c],P=s.arguments[c];if(v!==P)return v<P?-1:1}return 0}function g(a,s){let c=(0,C.comparePaths)(a.resourceUri.fsPath,s.resourceUri.fsPath,!0);if(c!==0)return c;if(a.command&&s.command)c=p(a.command,s.command);else{if(a.command)return 1;if(s.command)return-1}if(c!==0)return c;if(a.decorations&&s.decorations)c=o(a.decorations,s.decorations);else{if(a.decorations)return 1;if(s.decorations)return-1}return c}function E(a,s){for(let c=0;c<a.length;c++)if(a[c]!==s[c])return!1;return!0}function m(a,s){return a.command===s.command&&a.title===s.title&&a.tooltip===s.tooltip&&(a.arguments&&s.arguments?E(a.arguments,s.arguments):a.arguments===s.arguments)}function u(a,s){return(0,S.equals)(a,s,m)}class w{constructor(s,c,v){this._extension=s,this._proxy=c,this._sourceControlHandle=v,this._value="",this._onDidChange=new k.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(s){this._proxy.$setInputBoxValue(this._sourceControlHandle,s),this.updateValue(s)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(s){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,s),this._placeholder=s}get validateInput(){return(0,d.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(s){if((0,d.checkProposedApiEnabled)(this._extension),s&&typeof s!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=s,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!s)}get visible(){return this._visible}set visible(s){s=!!s,this._visible!==s&&(this._visible=s,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,s))}focus(){(0,d.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(s,c){(0,d.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,s,c)}$onInputBoxValueChange(s){this.updateValue(s)}updateValue(s){this._value=s,this._onDidChange.fire(s)}}e.ExtHostSCMInputBox=w;class t{constructor(s,c,v,P,h){this._proxy=s,this._commands=c,this._sourceControlHandle=v,this._id=P,this._label=h,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new k.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new k.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(s){this._label=s,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,s)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(s){this._hideWhenEmpty=s,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(s){this._resourceStates=[...s],this._onDidUpdateResourceStates.fire()}getResourceState(s){return this._resourceStatesMap.get(s)}$executeResourceCommand(s,c){const v=this._resourceStatesCommandsMap.get(s);return v?(0,y.asPromise)(()=>this._commands.executeCommand(v.command,...v.arguments||[],c)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var s;const c=[...this._resourceStates].sort(g),P=(0,S.sortedDiff)(this._resourceSnapshot,c,g).map(R=>{const U=R.toInsert.map(K=>{const he=this._resourceHandlePool++;this._resourceStatesMap.set(he,K);const V=K.resourceUri,H=f(K.decorations),Y=K.decorations&&f(K.decorations.light)||H,W=K.decorations&&f(K.decorations.dark)||H,F=[];let L;if(K.command)if(K.command.command==="vscode.open"||K.command.command==="vscode.diff"){const me=new T.DisposableStore;L=this._commands.converter.toInternal(K.command,me),this._resourceStatesDisposablesMap.set(he,me)}else this._resourceStatesCommandsMap.set(he,K.command);Y&&F.push(Y),W&&W.toString()!==(Y==null?void 0:Y.toString())&&F.push(W);const M=K.decorations&&K.decorations.tooltip||"",x=K.decorations&&!!K.decorations.strikeThrough,G=K.decorations&&!!K.decorations.faded,X=K.contextValue||"";return{rawResource:[he,V,F,M,x,G,X,L],handle:he}});return{start:R.start,deleteCount:R.deleteCount,toInsert:U}}),h=P.map(({start:R,deleteCount:U,toInsert:K})=>[R,U,K.map(he=>he.rawResource)]),b=P.reverse();for(const{start:R,deleteCount:U,toInsert:K}of b){const he=K.map(H=>H.handle),V=this._handlesSnapshot.splice(R,U,...he);for(const H of V)this._resourceStatesMap.delete(H),this._resourceStatesCommandsMap.delete(H),(s=this._resourceStatesDisposablesMap.get(H))===null||s===void 0||s.dispose(),this._resourceStatesDisposablesMap.delete(H)}return this._resourceSnapshot=c,h}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class n{constructor(s,c,v,P,h,b){this._proxy=c,this._commands=v,this._id=P,this._label=h,this._rootUri=b,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new k.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new w(s,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,P,h,b)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(s){this._count!==s&&(this._count=s,this._proxy.$updateSourceControl(this.handle,{count:s}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(s){this._quickDiffProvider=s,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!s})}get commitTemplate(){return this._commitTemplate}set commitTemplate(s){s!==this._commitTemplate&&(this._commitTemplate=s,this._proxy.$updateSourceControl(this.handle,{commitTemplate:s}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(s){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=s;const c=this._commands.converter.toInternal(s,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:c})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(s){if(!(this._statusBarCommands&&s&&u(this._statusBarCommands,s))){this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=s;const c=(s||[]).map(v=>this._commands.converter.toInternal(v,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:c})}}get selected(){return this._selected}createResourceGroup(s,c){const v=new t(this._proxy,this._commands,this.handle,s,c),P=k.Event.once(v.onDidDispose)(()=>this.createdResourceGroups.delete(v));return this.createdResourceGroups.set(v,P),this.eventuallyAddResourceGroups(),v}eventuallyAddResourceGroups(){const s=[],c=[];for(const[v,P]of this.createdResourceGroups){P.dispose();const h=v.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(v),this.eventuallyUpdateResourceStates()});k.Event.once(v.onDidDispose)(()=>{this.updatedResourceGroups.delete(v),h.dispose(),this._groups.delete(v.handle),this._proxy.$unregisterGroup(this.handle,v.handle)}),s.push([v.handle,v.id,v.label,v.features]);const b=v._takeResourceStateSnapshot();b.length>0&&c.push([v.handle,b]),this._groups.set(v.handle,v)}this._proxy.$registerGroups(this.handle,s,c),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const s=[];this.updatedResourceGroups.forEach(c=>{const v=c._takeResourceStateSnapshot();v.length!==0&&s.push([c.handle,v])}),s.length>0&&this._proxy.$spliceResourceStates(this.handle,s),this.updatedResourceGroups.clear()}getResourceGroup(s){return this._groups.get(s)}setSelectionState(s){this._selected=s,this._onDidChangeSelection.fire(s)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(s=>s.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}n._handlePool=0,je([(0,A.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),je([(0,A.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let l=class Rn{constructor(s,c,v){this._commands=c,this.logService=v,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new k.Emitter,this._proxy=s.getProxy(D.MainContext.MainThreadSCM),this._telemetry=s.getProxy(D.MainContext.MainThreadTelemetry),c.registerArgumentProcessor({processArgument:P=>{if(P&&P.$mid===3){const h=this._sourceControls.get(P.sourceControlHandle);if(!h)return P;const b=h.getResourceGroup(P.groupHandle);return b?b.getResourceState(P.handle):P}else if(P&&P.$mid===4){const h=this._sourceControls.get(P.sourceControlHandle);return h?h.getResourceGroup(P.groupHandle):P}else if(P&&P.$mid===5){const h=this._sourceControls.get(P.handle);return h||P}return P}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(s,c,v,P){this.logService.trace("ExtHostSCM#createSourceControl",s.identifier.value,c,v,P),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:s.identifier.value});const h=Rn._handlePool++,b=new n(s,this._proxy,this._commands,c,v,P);this._sourceControls.set(h,b);const R=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(s.identifier))||[];return R.push(b),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(s.identifier),R),b}getLastInputBox(s){this.logService.trace("ExtHostSCM#getLastInputBox",s.identifier.value);const c=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(s.identifier)),v=c&&c[c.length-1];return v&&v.inputBox}$provideOriginalResource(s,c,v){const P=_.URI.revive(c);this.logService.trace("ExtHostSCM#$provideOriginalResource",s,P.toString());const h=this._sourceControls.get(s);return!h||!h.quickDiffProvider||!h.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,y.asPromise)(()=>h.quickDiffProvider.provideOriginalResource(P,v)).then(b=>b||null)}$onInputBoxValueChange(s,c){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",s);const v=this._sourceControls.get(s);return v&&v.inputBox.$onInputBoxValueChange(c),Promise.resolve(void 0)}$executeResourceCommand(s,c,v,P){this.logService.trace("ExtHostSCM#$executeResourceCommand",s,c,v);const h=this._sourceControls.get(s);if(!h)return Promise.resolve(void 0);const b=h.getResourceGroup(c);return b?b.$executeResourceCommand(v,P):Promise.resolve(void 0)}$validateInput(s,c,v){this.logService.trace("ExtHostSCM#$validateInput",s);const P=this._sourceControls.get(s);return!P||!P.inputBox.validateInput?Promise.resolve(void 0):(0,y.asPromise)(()=>P.inputBox.validateInput(c,v)).then(h=>h?Promise.resolve([h.message,h.type]):Promise.resolve(void 0))}$setSelectedSourceControl(s){var c,v;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",s),s!==void 0&&((c=this._sourceControls.get(s))===null||c===void 0||c.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((v=this._sourceControls.get(this._selectedSourceControlHandle))===null||v===void 0||v.setSelectionState(!1)),this._selectedSourceControlHandle=s,Promise.resolve(void 0)}};l._handlePool=0,l=je([Ke(2,i.ILogService)],l),e.ExtHostSCM=l});var it=this&&this.__classPrivateFieldSet||function(J,e,_,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!A:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(J,_):A?A.value=_:e.set(J,_),_},Ue=this&&this.__classPrivateFieldGet||function(J,e,_,k){if(_==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?k:_==="a"?k.call(J):k?k.value:e.get(J)};define(ve[205],be([0,1,7,5,134,6]),function(J,e,_,k,A,T){"use strict";var y,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class S{constructor(d,f,r,o,p=_.StatusBarAlignment.Left,g,E){y.set(this,void 0),D.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new T.DisposableStore,it(this,y,d,"f"),it(this,D,f,"f"),this._id=S.ID_GEN++,this._statusId=r,this._statusName=o,this._alignment=p,this._priority=g,this._accessibilityInformation=E}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var d;return(d=this._command)===null||d===void 0?void 0:d.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(d){this._text=d,this.update()}set tooltip(d){this._tooltip=d,this.update()}set color(d){this._color=d,this.update()}set backgroundColor(d){d&&!S.ALLOWED_BACKGROUND_COLORS.has(d.id)&&(d=void 0),this._backgroundColor=d,this.update()}set command(d){var f;((f=this._command)===null||f===void 0?void 0:f.fromApi)!==d&&(this._internalCommandRegistration.clear(),typeof d=="string"?this._command={fromApi:d,internal:Ue(this,D,"f").toInternal({title:"",command:d},this._internalCommandRegistration)}:d?this._command={fromApi:d,internal:Ue(this,D,"f").toInternal(d,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(d){this._accessibilityInformation=d,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ue(this,y,"f").$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var d;this._timeoutHandle=void 0;let f=this._color;this._backgroundColor&&(f=S.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),Ue(this,y,"f").$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(d=this._command)===null||d===void 0?void 0:d.internal,f,this._backgroundColor,this._alignment===_.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=S,y=new WeakMap,D=new WeakMap,S.ID_GEN=0,S.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new _.ThemeColor("statusBarItem.errorForeground")]]);class C{constructor(d){this._messages=[],this._item=d.createStatusBarEntry("status.extensionMessage",(0,A.localize)(0,null),_.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(d){const f={message:d};return this._messages.unshift(f),this._update(),new _.Disposable(()=>{const r=this._messages.indexOf(f);r>=0&&(this._messages.splice(r,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class i{constructor(d,f){this._proxy=d.getProxy(k.MainContext.MainThreadStatusBar),this._commands=f,this._statusMessage=new C(this)}createStatusBarEntry(d,f,r,o,p){return new S(this._proxy,this._commands,d,f,r,o,p)}setStatusBarMessage(d,f){const r=this._statusMessage.setMessage(d);let o;return typeof f=="number"?o=setTimeout(()=>r.dispose(),f):typeof f!="undefined"&&f.then(()=>r.dispose(),()=>r.dispose()),new _.Disposable(()=>{r.dispose(),clearTimeout(o)})}}e.ExtHostStatusBar=i}),define(ve[78],be([0,1,5,3,4]),function(J,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(D){this._onDidChangeStorage=new k.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=D.getProxy(_.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(D,S){this._proxy.$registerExtensionStorageKeysToSync(D,S)}getValue(D,S,C){return this._proxy.$getValue(D,S).then(i=>i||C)}setValue(D,S,C){return this._proxy.$setValue(D,S,C)}$acceptValue(D,S,C){this._onDidChangeStorage.fire({shared:D,key:S,value:C})}}e.ExtHostStorage=T,e.IExtHostStorage=(0,A.createDecorator)("IExtHostStorage")}),define(ve[79],be([0,1,4,27,18,77,2]),function(J,e,_,k,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,_.createDecorator)("IExtensionStoragePaths");let D=class{constructor(C,i,I){var d;this._logService=i,this._extHostFileSystem=I,this._workspace=(d=C.workspace)!==null&&d!==void 0?d:void 0,this._environment=C.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(f=>this._value=f)}async _getOrCreateWorkspaceStoragePath(){var C;if(!this._workspace)return Promise.resolve(void 0);const i=this._workspace.id,I=y.URI.joinPath(this._environment.workspaceStorageHome,i);try{return await this._extHostFileSystem.value.stat(I),this._logService.trace("[ExtHostStorage] storage dir already exists",I),I}catch(d){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",I),await this._extHostFileSystem.value.createDirectory(I),await this._extHostFileSystem.value.writeFile(y.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(C=y.URI.revive(this._workspace.configuration))===null||C===void 0?void 0:C.toString(),name:this._workspace.name},void 0,2))),I}catch(d){this._logService.error("[ExtHostStorage]",d);return}}workspaceValue(C){if(this._value)return y.URI.joinPath(this._value,C.identifier.value)}globalValue(C){return y.URI.joinPath(this._environment.globalStorageHome,C.identifier.value.toLowerCase())}};D=je([Ke(0,k.IExtHostInitDataService),Ke(1,A.ILogService),Ke(2,T.IExtHostConsumerFileSystem)],D),e.ExtensionStoragePaths=D}),define(ve[40],be([0,1,3,5,4,2,14,6,7,135,12,172,20,31,155]),function(J,e,_,k,A,T,y,D,S,C,i,I,d,f,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,A.createDecorator)("IExtHostTerminalService");class o{constructor(t,n,l,a){this._proxy=t,this._id=n,this._creationOptions=l,this._name=a,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(c=>this._pidPromiseComplete=c);const s=this;this.value={get name(){return s._name||""},get processId(){return s._pidPromise},get creationOptions(){return s._creationOptions},get exitStatus(){return s._exitStatus},sendText(c,v=!0){s._checkDisposed(),s._proxy.$sendText(s._id,c,v)},show(c){s._checkDisposed(),s._proxy.$show(s._id,c)},hide(){s._checkDisposed(),s._proxy.$hide(s._id)},dispose(){s._disposed||(s._disposed=!0,s._proxy.$dispose(s._id))},get dimensions(){if(!(s._cols===void 0||s._rows===void 0))return{columns:s._cols,rows:s._rows}}}}async create(t,n,l,a,s,c,v,P,h,b,R){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:n,cwd:l,env:a,icon:s,initialText:c,waitOnExit:v,strictEnv:P,hideFromUser:h,isFeatureTerminal:b,isExtensionOwnedTerminal:R})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,n){return t===this._cols&&n===this._rows||t===0||n===0?!1:(this._cols=t,this._rows=n,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(n=>{n!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=o;class p{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new _.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new _.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new _.Emitter,this._onProcessTitleChanged=new _.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new _.Emitter,this._onProcessShellTypeChanged=new _.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,n){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:n})}async processBinary(t){}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(n=>this._onProcessData.fire(n)),this._pty.onDidClose&&this._pty.onDidClose((n=void 0)=>{this._onProcessExit.fire(n===void 0?void 0:n)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(n=>this._onProcessOverrideDimensions.fire(n&&{cols:n.columns,rows:n.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(n=>this._onProcessTitleChanged.fire(n)),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=p;let g=1,E=class extends D.Disposable{constructor(t,n){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new _.Emitter,this._onDidOpenTerminal=new _.Emitter,this._onDidChangeActiveTerminal=new _.Emitter,this._onDidChangeTerminalDimensions=new _.Emitter,this._proxy=n.getProxy(k.MainContext.MainThreadTerminalService),this._bufferer=new r.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new _.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[l,a]of this._terminalProcesses)a.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const n=new o(this._proxy,(0,f.generateUuid)(),t,t.name),l=new p(t.pty);return n.createExtensionTerminal().then(a=>{const s=this._setupExtHostProcessListeners(a,l);this._terminalProcessDisposables[a]=s}),this._terminals.push(n),n.value}attachPtyToTerminal(t,n){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const a=new p(n),s=this._setupExtHostProcessListeners(t,a);this._terminalProcessDisposables[t]=s}async $acceptActiveTerminalChanged(t){const n=this._activeTerminal;if(t===null){this._activeTerminal=void 0,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const l=this._getTerminalById(t);l&&(this._activeTerminal=l,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,n){const l=this._getTerminalById(t);l&&this._onDidWriteTerminalData.fire({terminal:l.value,data:n})}async $acceptTerminalDimensions(t,n,l){const a=this._getTerminalById(t);a&&a.setDimensions(n,l)&&this._onDidChangeTerminalDimensions.fire({terminal:a.value,dimensions:a.value.dimensions})}async $acceptTerminalMaximumDimensions(t,n,l){var a;(a=this._terminalProcesses.get(t))===null||a===void 0||a.resize(n,l)}async $acceptTerminalTitleChange(t,n){const l=this._getTerminalById(t);l&&(l.name=n)}async $acceptTerminalClosed(t,n){const l=this._getTerminalObjectIndexById(this._terminals,t);if(l!==null){const a=this._terminals.splice(l,1)[0];a.setExitCode(n),this._onDidCloseTerminal.fire(a.value)}}$acceptTerminalOpened(t,n,l,a){if(n){const v=this._getTerminalObjectIndexById(this._terminals,n);if(v!==null){this._terminals[v]._id=t,this._onDidOpenTerminal.fire(this.terminals[v]),this._terminals[v].isOpen=!0;return}}const s={name:a.name,shellPath:a.executable,shellArgs:a.args,cwd:typeof a.cwd=="string"?a.cwd:T.URI.revive(a.cwd),env:a.env,hideFromUser:a.hideFromUser},c=new o(this._proxy,t,s,l);this._terminals.push(c),this._onDidOpenTerminal.fire(c.value),c.isOpen=!0}async $acceptTerminalProcessId(t,n){const l=this._getTerminalById(t);l&&l._setProcessId(n)}async $startExtensionTerminal(t,n){const l=this._getTerminalById(t);if(!l)return{message:(0,C.localize)(0,null,t)};l.isOpen||await new Promise(s=>{const c=this.onDidOpenTerminal(async v=>{v===l.value&&(c.dispose(),s())})});const a=this._terminalProcesses.get(t);a?a.startSendingEvents(n):this._extensionTerminalAwaitingStart[t]={initialDimensions:n}}_setupExtHostProcessListeners(t,n){const l=new D.DisposableStore;l.add(n.onProcessReady(s=>this._proxy.$sendProcessReady(t,s.pid,s.cwd))),l.add(n.onProcessTitleChanged(s=>this._proxy.$sendProcessTitle(t,s))),this._bufferer.startBuffering(t,n.onProcessData),l.add(n.onProcessExit(s=>this._onProcessExit(t,s))),n.onProcessOverrideDimensions&&l.add(n.onProcessOverrideDimensions(s=>this._proxy.$sendOverrideDimensions(t,s))),this._terminalProcesses.set(t,n);const a=this._extensionTerminalAwaitingStart[t];return a&&n instanceof p&&(n.startSendingEvents(a.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),l}$acceptProcessAckDataEvent(t,n){var l;(l=this._terminalProcesses.get(t))===null||l===void 0||l.acknowledgeDataEvent(n)}$acceptProcessInput(t,n){var l;(l=this._terminalProcesses.get(t))===null||l===void 0||l.input(n)}$acceptProcessResize(t,n,l){var a;try{(a=this._terminalProcesses.get(t))===null||a===void 0||a.resize(n,l)}catch(s){if(s.code!=="EPIPE"&&s.code!=="ERR_IPC_CHANNEL_CLOSED")throw s}}$acceptProcessShutdown(t,n){var l;(l=this._terminalProcesses.get(t))===null||l===void 0||l.shutdown(n)}$acceptProcessRequestInitialCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getInitialCwd().then(l=>this._proxy.$sendProcessInitialCwd(t,l))}$acceptProcessRequestCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getCwd().then(l=>this._proxy.$sendProcessCwd(t,l))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,n){const l=this._getTerminalById(t);if(!l)return[];this._terminalLinkCache.delete(t);const a=this._terminalLinkCancellationSource.get(t);a&&a.dispose(!0);const s=new d.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,s);const c=[],v={terminal:l.value,line:n},P=[];for(const R of this._linkProviders)P.push(new Promise(async U=>{s.token.onCancellationRequested(()=>U({provider:R,links:[]}));const K=await R.provideTerminalLinks(v,s.token)||[];s.token.isCancellationRequested||U({provider:R,links:K})}));const h=await Promise.all(P);if(s.token.isCancellationRequested)return[];const b=new Map;for(const R of h)R&&R.links.length>0&&c.push(...R.links.map(U=>{const K={id:g++,startIndex:U.startIndex,length:U.length,label:U.tooltip};return b.set(K.id,{provider:R.provider,link:U}),K}));return this._terminalLinkCache.set(t,b),c}$activateLink(t,n){var l;const a=(l=this._terminalLinkCache.get(t))===null||l===void 0?void 0:l.get(n);!a||a.provider.handleTerminalLink(a.link)}_onProcessExit(t,n){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const l=this._terminalProcessDisposables[t];l&&(l.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,n)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,n){const l=this._getTerminalObjectIndexById(t,n);return l!==null?t[l]:null}_getTerminalObjectIndexById(t,n){let l=null;return t.some((a,s)=>a._id===n?(l=s,!0):!1),l}getEnvironmentVariableCollection(t){let n=this._environmentVariableCollections.get(t.identifier.value);return n||(n=new m,this._setEnvironmentVariableCollection(t.identifier.value,n)),n}_syncEnvironmentVariableCollection(t,n){const l=(0,I.serializeEnvironmentVariableCollection)(n.map);this._proxy.$setEnvironmentVariableCollection(t,n.persistent,l.length===0?void 0:l)}$initEnvironmentVariableCollections(t){t.forEach(n=>{const l=n[0],a=new m(n[1]);this._setEnvironmentVariableCollection(l,a)})}_setEnvironmentVariableCollection(t,n){this._environmentVariableCollections.set(t,n),n.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,n)})}};E=je([Ke(1,y.IExtHostRpcService)],E),e.BaseExtHostTerminalService=E;class m{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new _.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,n){this._setIfDiffers(t,{value:n,type:S.EnvironmentVariableMutatorType.Replace})}append(t,n){this._setIfDiffers(t,{value:n,type:S.EnvironmentVariableMutatorType.Append})}prepend(t,n){this._setIfDiffers(t,{value:n,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,n){const l=this.map.get(t);(!l||l.value!==n.value||l.type!==n.type)&&(this.map.set(t,n),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,n){this.map.forEach((l,a)=>t.call(n,a,l,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=m;let u=class extends E{constructor(t){super(!1,t)}createTerminal(t,n,l){throw new i.NotSupportedError}createTerminalFromOptions(t){throw new i.NotSupportedError}getDefaultShell(t,n){throw new i.NotSupportedError}getDefaultShellArgs(t,n){throw new i.NotSupportedError}async getDefaultShellAndArgs(t){throw new i.NotSupportedError}$getAvailableProfiles(t){throw new i.NotSupportedError}};u=je([Ke(0,y.IExtHostRpcService)],u),e.WorkerExtHostTerminalService=u}),define(ve[206],be([0,1,3,15,5,97,9,7]),function(J,e,_,k,A,T,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(i,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new _.Emitter,this._onDidChangeTextEditorOptions=new _.Emitter,this._onDidChangeTextEditorVisibleRanges=new _.Emitter,this._onDidChangeTextEditorViewColumn=new _.Emitter,this._onDidChangeActiveTextEditor=new _.Emitter,this._onDidChangeVisibleTextEditors=new _.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=i.getProxy(A.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(d=>this._onDidChangeVisibleTextEditors.fire(d)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(d=>this._onDidChangeActiveTextEditor.fire(d))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(i){const I=this._extHostDocumentsAndEditors.allEditors();return i?I:I.map(d=>d.value)}async showTextDocument(i,I,d){let f;typeof I=="number"?f={position:y.ViewColumn.from(I),preserveFocus:d}:typeof I=="object"?f={position:y.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?y.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:f={preserveFocus:!1};const r=await this._proxy.$tryShowTextDocument(i.uri,f),o=r&&this._extHostDocumentsAndEditors.getEditor(r);if(o)return o.value;throw r?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}createTextEditorDecorationType(i){return new T.TextEditorDecorationType(this._proxy,i).value}$acceptEditorPropertiesChanged(i,I){const d=this._extHostDocumentsAndEditors.getEditor(i);if(!d)throw new Error("unknown text editor");if(I.options&&d._acceptOptions(I.options),I.selections){const f=I.selections.selections.map(y.Selection.to);d._acceptSelections(f)}if(I.visibleRanges){const f=k.coalesce(I.visibleRanges.map(y.Range.to));d._acceptVisibleRanges(f)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:d.value,options:Object.assign(Object.assign({},I.options),{lineNumbers:y.TextEditorLineNumbersStyle.to(I.options.lineNumbers)})}),I.selections){const f=D.TextEditorSelectionChangeKind.fromValue(I.selections.source),r=I.selections.selections.map(y.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:d.value,selections:r,kind:f})}if(I.visibleRanges){const f=k.coalesce(I.visibleRanges.map(y.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:d.value,visibleRanges:f})}}$acceptEditorPositionData(i){for(const I in i){const d=this._extHostDocumentsAndEditors.getEditor(I);if(!d)throw new Error("Unknown text editor");const f=y.ViewColumn.to(i[I]);d.value.viewColumn!==f&&(d._acceptViewColumn(f),this._onDidChangeTextEditorViewColumn.fire({textEditor:d.value,viewColumn:f}))}}getDiffInformation(i){return Promise.resolve(this._proxy.$getDiffInformation(i))}}e.ExtHostEditors=S});var Qt=this&&this.__rest||function(J,e){var _={};for(var k in J)Object.prototype.hasOwnProperty.call(J,k)&&e.indexOf(k)<0&&(_[k]=J[k]);if(J!=null&&typeof Object.getOwnPropertySymbols=="function")for(var A=0,k=Object.getOwnPropertySymbols(J);A<k.length;A++)e.indexOf(k[A])<0&&Object.prototype.propertyIsEnumerable.call(J,k[A])&&(_[k[A]]=J[k[A]]);return _};define(ve[207],be([0,1,2,4,5,6,7]),function(J,e,_,k,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,k.createDecorator)("IExtHostTimeline");class D{constructor(i,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=i.getProxy(A.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:d=>{var f,r;if(d&&d.$mid===11){const o=d.uri===void 0?void 0:_.URI.revive(d.uri);return(r=(f=this._itemsBySourceAndUriMap.get(d.source))===null||f===void 0?void 0:f.get(S(o)))===null||r===void 0?void 0:r.get(d.handle)}return d}})}async $getTimeline(i,I,d,f,r){const o=this._providers.get(i);return o==null?void 0:o.provideTimeline(_.URI.revive(I),d,f,r)}registerTimelineProvider(i,I,d,f){const r=new T.DisposableStore,o=this.convertTimelineItem(I.id,f,r).bind(this);let p;I.onDidChange&&(p=I.onDidChange(E=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},E),{id:I.id})),this));const g=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},I),{scheme:i,onDidChange:void 0,async provideTimeline(E,m,u,w){var t;(w==null?void 0:w.resetCache)&&(r.clear(),(t=g.get(I.id))===null||t===void 0||t.clear());const n=await I.provideTimeline(E,m,u);if(n!=null){const l=o(E,w);return Object.assign(Object.assign({},n),{source:I.id,items:n.items.map(l)})}},dispose(){var E;for(const m of g.values())(E=m.get(I.id))===null||E===void 0||E.clear();p==null||p.dispose(),r.dispose()}}))}convertTimelineItem(i,I,d){return(f,r)=>{let o;if(r==null?void 0:r.cacheResults){let p=this._itemsBySourceAndUriMap.get(i);p===void 0&&(p=new Map,this._itemsBySourceAndUriMap.set(i,p));const g=S(f);o=p.get(g),o===void 0&&(o=new Map,p.set(g,o))}return p=>{var g,E;const{iconPath:m}=p,u=Qt(p,["iconPath"]),w=`${i}|${(g=p.id)!==null&&g!==void 0?g:p.timestamp}`;o==null||o.set(w,p);let t,n,l;return p.iconPath&&(m instanceof y.ThemeIcon?l={id:m.id}:_.URI.isUri(m)?(t=m,n=m):{light:t,dark:n}=m),Object.assign(Object.assign({},u),{id:(E=u.id)!==null&&E!==void 0?E:void 0,handle:w,source:i,command:p.command?I.toInternal(p.command,d):void 0,icon:t,iconDark:n,themeIcon:l,accessibilityInformation:p.accessibilityInformation})}}}registerTimelineProviderCore(i){if(this._providers.get(i.id))throw new Error(`Timeline Provider ${i.id} already exists.`);return this._proxy.$registerTimelineProvider({id:i.id,label:i.label,scheme:i.scheme}),this._providers.set(i.id,i),(0,T.toDisposable)(()=>{var d;for(const f of this._itemsBySourceAndUriMap.values())(d=f.get(i.id))===null||d===void 0||d.clear();this._providers.delete(i.id),this._proxy.$unregisterTimelineProvider(i.id),i.dispose()})}}e.ExtHostTimeline=D;function S(C){return C==null?void 0:C.toString()}}),define(ve[208],be([0,1,6,19,2,5]),function(J,e,_,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(S){this._openers=new Map,this._proxy=S.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,C,i,I){if(this._openers.has(C))throw new Error(`Opener with id '${C}' already registered`);const d=I.schemes.find(f=>!y.supportedSchemes.has(f));if(d)throw new Error(`Scheme '${d}' is not supported. Only http and https are currently supported.`);return this._openers.set(C,i),this._proxy.$registerUriOpener(C,I.schemes,S,I.label),(0,_.toDisposable)(()=>{this._openers.delete(C),this._proxy.$unregisterUriOpener(C)})}async $canOpenUri(S,C,i){const I=this._openers.get(S);if(!I)throw new Error(`Unknown opener with id: ${S}`);const d=A.URI.revive(C);return I.canOpenExternalUri(d,i)}async $openUri(S,C,i){const I=this._openers.get(S);if(!I)throw new Error(`Unknown opener id: '${S}'`);return I.openExternalUri(A.URI.revive(C.resolvedUri),{sourceUri:A.URI.revive(C.sourceUri)},i)}}e.ExtHostUriOpeners=y,y.supportedSchemes=new Set([k.Schemas.http,k.Schemas.https])}),define(ve[209],be([0,1,5,2,6,12,26]),function(J,e,_,k,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class D{constructor(C){this.handles=new Set,this.handlers=new Map,this._proxy=C.getProxy(_.MainContext.MainThreadUrls)}registerUriHandler(C,i){if(this.handles.has(y.ExtensionIdentifier.toKey(C)))throw new Error(`Protocol handler already registered for extension ${C}`);const I=D.HandlePool++;return this.handles.add(y.ExtensionIdentifier.toKey(C)),this.handlers.set(I,i),this._proxy.$registerUriHandler(I,C),(0,A.toDisposable)(()=>{this.handles.delete(y.ExtensionIdentifier.toKey(C)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(C,i){const I=this.handlers.get(C);if(!I)return Promise.resolve(void 0);try{I.handleUri(k.URI.revive(i))}catch(d){(0,T.onUnexpectedError)(d)}return Promise.resolve(void 0)}async createAppUri(C){return k.URI.revive(await this._proxy.$createAppUri(C))}}e.ExtHostUrls=D,D.HandlePool=0});var it=this&&this.__classPrivateFieldSet||function(J,e,_,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!A:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(J,_):A?A.value=_:e.set(J,_),_},Ue=this&&this.__classPrivateFieldGet||function(J,e,_,k){if(_==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?k:_==="a"?k.call(J):k?k.value:e.get(J)};define(ve[50],be([0,1,3,2,144,165,72,5]),function(J,e,_,k,A,T,y,D){"use strict";var S,C,i,I,d,f,r,o,p,g,E,m;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class u{constructor(v,P,h,b,R,U,K){S.set(this,void 0),C.set(this,void 0),i.set(this,void 0),I.set(this,void 0),d.set(this,void 0),f.set(this,void 0),r.set(this,""),o.set(this,void 0),p.set(this,!1),g.set(this,!1),E.set(this,!1),this._onMessageEmitter=new _.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,m.set(this,new _.Emitter),this._onDidDispose=Ue(this,m,"f").event,it(this,S,v,"f"),it(this,C,P,"f"),it(this,o,h,"f"),it(this,I,b,"f"),it(this,d,R,"f"),it(this,f,U,"f"),it(this,E,w(U),"f"),it(this,i,K,"f")}dispose(){it(this,p,!0,"f"),Ue(this,m,"f").fire(),Ue(this,m,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(v){return it(this,g,!0,"f"),(0,y.asWebviewUri)(Ue(this,I,"f"),Ue(this,S,"f"),v)}get cspSource(){return Ue(this,I,"f").webviewCspSource.replace("{{uuid}}",Ue(this,S,"f"))}get html(){return this.assertNotDisposed(),Ue(this,r,"f")}set html(v){this.assertNotDisposed(),Ue(this,r,"f")!==v&&(it(this,r,v,"f"),!Ue(this,g,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(v)&&(it(this,g,!0,"f"),Ue(this,i,"f").report("Webview vscode-resource: uris",Ue(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,C,"f").$setHtml(Ue(this,S,"f"),v))}get options(){return this.assertNotDisposed(),Ue(this,o,"f")}set options(v){this.assertNotDisposed(),Ue(this,C,"f").$setOptions(Ue(this,S,"f"),l(Ue(this,f,"f"),Ue(this,d,"f"),v)),it(this,o,v,"f")}async postMessage(v){if(Ue(this,p,"f"))return!1;const P=(0,T.serializeWebviewMessage)(v,{serializeBuffersForPostMessage:Ue(this,E,"f")});return Ue(this,C,"f").$postMessage(Ue(this,S,"f"),P.message,...P.buffers)}assertNotDisposed(){if(Ue(this,p,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=u,S=new WeakMap,C=new WeakMap,i=new WeakMap,I=new WeakMap,d=new WeakMap,f=new WeakMap,r=new WeakMap,o=new WeakMap,p=new WeakMap,g=new WeakMap,E=new WeakMap,m=new WeakMap;function w(c){try{const v=(0,A.normalizeVersion)((0,A.parseVersion)(c.engines.vscode));return!!v&&v.majorBase>=1&&v.minorBase>=57}catch(v){return!1}}e.shouldSerializeBuffersForPostMessage=w;class t{constructor(v,P,h,b,R){this.initData=P,this.workspace=h,this._logService=b,this._deprecationService=R,this._webviews=new Map,this._webviewProxy=v.getProxy(D.MainContext.MainThreadWebviews)}$onMessage(v,P,...h){const b=this.getWebview(v);if(b){const{message:R}=(0,T.deserializeWebviewMessage)(P,h);b._onMessageEmitter.fire(R)}}$onMissingCsp(v,P){this._logService.warn(`${P} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(v,P,h){const b=new u(v,this._webviewProxy,a(P),this.initData,this.workspace,h,this._deprecationService);return this._webviews.set(v,b),b._onDidDispose(()=>{this._webviews.delete(v)}),b}deleteWebview(v){this._webviews.delete(v)}getWebview(v){return this._webviews.get(v)}}e.ExtHostWebviews=t;function n(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=n;function l(c,v,P){return{enableCommandUris:P.enableCommandUris,enableScripts:P.enableScripts,portMapping:P.portMapping,localResourceRoots:P.localResourceRoots||s(c,v)}}e.serializeWebviewOptions=l;function a(c){var v;return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,portMapping:c.portMapping,localResourceRoots:(v=c.localResourceRoots)===null||v===void 0?void 0:v.map(P=>k.URI.from(P))}}e.reviveOptions=a;function s(c,v){return[...((v==null?void 0:v.getWorkspaceFolders())||[]).map(P=>P.uri),c.extensionLocation]}}),define(ve[210],be([0,1,20,56,6,19,25,2,9,50,68,5,7]),function(J,e,_,k,A,T,y,D,S,C,i,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class f{constructor(t,n){this.document=t,this._storagePath=n,this._backupCounter=1,this._edits=new i.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,n){await this.getEdit(t).undo(),n||this.disposeBackup()}async redo(t,n){await this.getEdit(t).redo(),n||this.disposeBackup()}disposeEdits(t){for(const n of t)this._edits.delete(n)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=u(this.document.uri)+this._backupCounter++;return(0,y.joinPath)(this._storagePath,t)}updateBackup(t){var n;(n=this._backup)===null||n===void 0||n.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const n=this._edits.get(t,0);if(!n)throw new Error("No edit found");return n}}class r{constructor(){this._documents=new Map}get(t,n){return this._documents.get(this.key(t,n))}add(t,n,l){const a=this.key(t,n.uri);if(this._documents.has(a))throw new Error(`Document already exists for viewType:${t} resource:${n.uri}`);const s=new f(n,l);return this._documents.set(a,s),s}delete(t,n){const l=this.key(t,n.uri);this._documents.delete(l)}key(t,n){return`${t}@@@${n}`}}var o;(function(w){w[w.Text=0]="Text",w[w.Custom=1]="Custom"})(o||(o={}));class p{constructor(){this._providers=new Map}addTextProvider(t,n,l){return this.add(0,t,n,l)}addCustomProvider(t,n,l){return this.add(1,t,n,l)}get(t){return this._providers.get(t)}add(t,n,l,a){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,{type:t,extension:l,provider:a}),new d.Disposable(()=>this._providers.delete(n))}}class g{constructor(t,n,l,a,s){this._extHostDocuments=n,this._extensionStoragePaths=l,this._extHostWebview=a,this._extHostWebviewPanels=s,this._editorProviders=new p,this._documents=new r,this._proxy=t.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,n,l,a){const s=new A.DisposableStore;return E(l)?(s.add(this._editorProviders.addTextProvider(n,t,l)),this._proxy.$registerTextEditorProvider((0,C.toExtensionData)(t),n,a.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,C.shouldSerializeBuffersForPostMessage)(t))):(s.add(this._editorProviders.addCustomProvider(n,t,l)),this.supportEditing(l)&&s.add(l.onDidChangeCustomDocument(c=>{const v=this.getCustomDocumentEntry(n,c.document.uri);if(m(c)){const P=v.addEdit(c);this._proxy.$onDidEdit(c.document.uri,n,P,c.label)}else this._proxy.$onContentChange(c.document.uri,n)})),this._proxy.$registerCustomEditorProvider((0,C.toExtensionData)(t),n,a.webviewOptions||{},!!a.supportsMultipleEditorsPerDocument,(0,C.shouldSerializeBuffersForPostMessage)(t))),d.Disposable.from(s,new d.Disposable(()=>{this._proxy.$unregisterEditorProvider(n)}))}async $createCustomDocument(t,n,l,a,s){var c;const v=this._editorProviders.get(n);if(!v)throw new Error(`No provider found for '${n}'`);if(v.type!==1)throw new Error(`Invalid provide type for '${n}'`);const P=D.URI.revive(t),h=await v.provider.openCustomDocument(P,{backupId:l,untitledDocumentData:a==null?void 0:a.buffer},s);let b;return this.supportEditing(v.provider)&&this._extensionStoragePaths&&(b=(c=this._extensionStoragePaths.workspaceValue(v.extension))!==null&&c!==void 0?c:this._extensionStoragePaths.globalValue(v.extension)),this._documents.add(n,h,b),{editable:this.supportEditing(v.provider)}}async $disposeCustomDocument(t,n){const l=this._editorProviders.get(n);if(!l)throw new Error(`No provider found for '${n}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${n}'`);const a=D.URI.revive(t),{document:s}=this.getCustomDocumentEntry(n,a);this._documents.delete(n,s),s.dispose()}async $resolveWebviewEditor(t,n,l,a,s,c){const v=this._editorProviders.get(l);if(!v)throw new Error(`No provider found for '${l}'`);const P=S.ViewColumn.to(s),h=this._extHostWebview.createNewWebview(n,a.webviewOptions,v.extension),b=this._extHostWebviewPanels.createNewWebviewPanel(n,l,a.title,P,a.panelOptions,h),R=D.URI.revive(t);switch(v.type){case 1:{const{document:U}=this.getCustomDocumentEntry(l,R);return v.provider.resolveCustomEditor(U,b,c)}case 0:{const U=this._extHostDocuments.getDocument(R);return v.provider.resolveCustomTextEditor(U,b,c)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,n,l){this.getCustomDocumentEntry(n,t).disposeEdits(l)}async $onMoveCustomEditor(t,n,l){const a=this._editorProviders.get(l);if(!a)throw new Error(`No provider found for '${l}'`);if(!a.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const s=this._extHostWebviewPanels.getWebviewPanel(t);if(!s)throw new Error("No webview found");const c=D.URI.revive(n),v=this._extHostDocuments.getDocument(c);await a.provider.moveCustomTextEditor(v,s,_.CancellationToken.None)}async $undo(t,n,l,a){return this.getCustomDocumentEntry(n,t).undo(l,a)}async $redo(t,n,l,a){return this.getCustomDocumentEntry(n,t).redo(l,a)}async $revert(t,n,l){const a=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).revertCustomDocument(a.document,l),a.disposeBackup()}async $onSave(t,n,l){const a=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).saveCustomDocument(a.document,l),a.disposeBackup()}async $onSaveAs(t,n,l,a){const s=this.getCustomDocumentEntry(n,t);return this.getCustomEditorProvider(n).saveCustomDocumentAs(s.document,D.URI.revive(l),a)}async $backup(t,n,l){const a=this.getCustomDocumentEntry(n,t),c=await this.getCustomEditorProvider(n).backupCustomDocument(a.document,{destination:a.getNewBackupUri()},l);return a.updateBackup(c),c.id}getCustomDocumentEntry(t,n){const l=this._documents.get(t,D.URI.revive(n));if(!l)throw new Error("No custom document found");return l}getCustomEditorProvider(t){const n=this._editorProviders.get(t),l=n==null?void 0:n.provider;if(!l||!this.supportEditing(l))throw new Error("Custom document is not editable");return l}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=g;function E(w){return typeof w.resolveCustomTextEditor=="function"}function m(w){return typeof w.undo=="function"&&typeof w.redo=="function"}function u(w){const t=w.scheme===T.Schemas.file||w.scheme===T.Schemas.untitled?w.fsPath:w.toString();return(0,k.hash)(t)+""}});var it=this&&this.__classPrivateFieldSet||function(J,e,_,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!A:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(J,_):A?A.value=_:e.set(J,_),_},Ue=this&&this.__classPrivateFieldGet||function(J,e,_,k){if(_==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?k:_==="a"?k.call(J):k?k.value:e.get(J)};define(ve[211],be([0,1,3,6,2,31,9,50,5,7]),function(J,e,_,k,A,T,y,D,S,C){"use strict";var i,I,d,f,r,o,p,g,E,m,u,w,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class n extends k.Disposable{constructor(c,v,P,h,b,R,U){super();i.set(this,void 0),I.set(this,void 0),d.set(this,void 0),f.set(this,void 0),r.set(this,void 0),o.set(this,void 0),p.set(this,void 0),g.set(this,void 0),E.set(this,!0),m.set(this,!0),u.set(this,!1),w.set(this,this._register(new _.Emitter)),this.onDidDispose=Ue(this,w,"f").event,t.set(this,this._register(new _.Emitter)),this.onDidChangeViewState=Ue(this,t,"f").event,it(this,i,c,"f"),it(this,I,v,"f"),it(this,d,P,"f"),it(this,r,R,"f"),it(this,g,b,"f"),it(this,o,h,"f"),it(this,f,U,"f")}dispose(){Ue(this,u,"f")||(it(this,u,!0,"f"),Ue(this,w,"f").fire(),Ue(this,I,"f").$disposeWebview(Ue(this,i,"f")),Ue(this,f,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ue(this,f,"f")}get viewType(){return this.assertNotDisposed(),Ue(this,d,"f")}get title(){return this.assertNotDisposed(),Ue(this,o,"f")}set title(c){this.assertNotDisposed(),Ue(this,o,"f")!==c&&(it(this,o,c,"f"),Ue(this,I,"f").$setTitle(Ue(this,i,"f"),c))}get iconPath(){return this.assertNotDisposed(),Ue(this,p,"f")}set iconPath(c){this.assertNotDisposed(),Ue(this,p,"f")!==c&&(it(this,p,c,"f"),Ue(this,I,"f").$setIconPath(Ue(this,i,"f"),A.URI.isUri(c)?{light:c,dark:c}:c))}get options(){return Ue(this,r,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ue(this,g,"f")=="number"&&Ue(this,g,"f")<0))return Ue(this,g,"f")}get active(){return this.assertNotDisposed(),Ue(this,m,"f")}get visible(){return this.assertNotDisposed(),Ue(this,E,"f")}_updateViewState(c){Ue(this,u,"f")||(this.active!==c.active||this.visible!==c.visible||this.viewColumn!==c.viewColumn)&&(it(this,m,c.active,"f"),it(this,E,c.visible,"f"),it(this,g,c.viewColumn,"f"),Ue(this,t,"f").fire({webviewPanel:this}))}reveal(c,v){this.assertNotDisposed(),Ue(this,I,"f").$reveal(Ue(this,i,"f"),{viewColumn:c?y.ViewColumn.from(c):void 0,preserveFocus:!!v})}assertNotDisposed(){if(Ue(this,u,"f"))throw new Error("Webview is disposed")}}i=new WeakMap,I=new WeakMap,d=new WeakMap,f=new WeakMap,r=new WeakMap,o=new WeakMap,p=new WeakMap,g=new WeakMap,E=new WeakMap,m=new WeakMap,u=new WeakMap,w=new WeakMap,t=new WeakMap;class l{constructor(c,v,P){this.webviews=v,this.workspace=P,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=c.getProxy(S.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,T.generateUuid)()}createWebviewPanel(c,v,P,h,b={}){const R=typeof h=="object"?h.viewColumn:h,U={viewColumn:y.ViewColumn.from(R),preserveFocus:typeof h=="object"&&!!h.preserveFocus},K=(0,D.shouldSerializeBuffersForPostMessage)(c),he=l.newHandle();this._proxy.$createWebviewPanel((0,D.toExtensionData)(c),he,v,{title:P,panelOptions:a(b),webviewOptions:(0,D.serializeWebviewOptions)(c,this.workspace,b),serializeBuffersForPostMessage:K},U);const V=this.webviews.createNewWebview(he,b,c);return this.createNewWebviewPanel(he,v,P,R,b,V)}$onDidChangeWebviewPanelViewStates(c){const v=Object.keys(c);v.sort((P,h)=>{const b=c[P],R=c[h];return b.active?1:R.active?-1:+b.visible-+R.visible});for(const P of v){const h=this.getWebviewPanel(P);if(!!h){const b=c[P];h._updateViewState({active:b.active,visible:b.visible,viewColumn:y.ViewColumn.to(b.position)})}}}async $onDidDisposeWebviewPanel(c){const v=this.getWebviewPanel(c);v==null||v.dispose(),this._webviewPanels.delete(c),this.webviews.deleteWebview(c)}registerWebviewPanelSerializer(c,v,P){if(this._serializers.has(v))throw new Error(`Serializer for '${v}' already registered`);return this._serializers.set(v,{serializer:P,extension:c}),this._proxy.$registerSerializer(v,{serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(c)}),new C.Disposable(()=>{this._serializers.delete(v),this._proxy.$unregisterSerializer(v)})}async $deserializeWebviewPanel(c,v,P,h){const b=this._serializers.get(v);if(!b)throw new Error(`No serializer found for '${v}'`);const{serializer:R,extension:U}=b,K=this.webviews.createNewWebview(c,P.webviewOptions,U),he=this.createNewWebviewPanel(c,v,P.title,h,P.panelOptions,K);await R.deserializeWebviewPanel(he,P.state)}createNewWebviewPanel(c,v,P,h,b,R){const U=new n(c,this._proxy,v,P,h,b,R);return this._webviewPanels.set(c,U),U}getWebviewPanel(c){return this._webviewPanels.get(c)}}e.ExtHostWebviewPanels=l;function a(s){return{enableFindWidget:s.enableFindWidget,retainContextWhenHidden:s.retainContextWhenHidden}}});var it=this&&this.__classPrivateFieldSet||function(J,e,_,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!A:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(J,_):A?A.value=_:e.set(J,_),_},Ue=this&&this.__classPrivateFieldGet||function(J,e,_,k){if(_==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?k:_==="a"?k.call(J):k?k.value:e.get(J)};define(ve[212],be([0,1,3,6,50,5,7]),function(J,e,_,k,A,T,y){"use strict";var D,S,C,i,I,d,f,r,o,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class g extends k.Disposable{constructor(u,w,t,n,l,a){super();D.set(this,void 0),S.set(this,void 0),C.set(this,void 0),i.set(this,void 0),I.set(this,!1),d.set(this,void 0),f.set(this,void 0),r.set(this,void 0),o.set(this,this._register(new _.Emitter)),this.onDidChangeVisibility=Ue(this,o,"f").event,p.set(this,this._register(new _.Emitter)),this.onDidDispose=Ue(this,p,"f").event,it(this,C,t,"f"),it(this,f,n,"f"),it(this,D,u,"f"),it(this,S,w,"f"),it(this,i,l,"f"),it(this,d,a,"f")}dispose(){Ue(this,I,"f")||(it(this,I,!0,"f"),Ue(this,p,"f").fire(),Ue(this,i,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ue(this,f,"f")}set title(u){this.assertNotDisposed(),Ue(this,f,"f")!==u&&(it(this,f,u,"f"),Ue(this,S,"f").$setWebviewViewTitle(Ue(this,D,"f"),u))}get description(){return this.assertNotDisposed(),Ue(this,r,"f")}set description(u){this.assertNotDisposed(),Ue(this,r,"f")!==u&&(it(this,r,u,"f"),Ue(this,S,"f").$setWebviewViewDescription(Ue(this,D,"f"),u))}get visible(){return Ue(this,d,"f")}get webview(){return Ue(this,i,"f")}get viewType(){return Ue(this,C,"f")}_setVisible(u){u===Ue(this,d,"f")||Ue(this,I,"f")||(it(this,d,u,"f"),Ue(this,o,"f").fire())}show(u){this.assertNotDisposed(),Ue(this,S,"f").$show(Ue(this,D,"f"),!!u)}assertNotDisposed(){if(Ue(this,I,"f"))throw new Error("Webview is disposed")}}D=new WeakMap,S=new WeakMap,C=new WeakMap,i=new WeakMap,I=new WeakMap,d=new WeakMap,f=new WeakMap,r=new WeakMap,o=new WeakMap,p=new WeakMap;class E{constructor(u,w){this._extHostWebview=w,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=u.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(u,w,t,n){if(this._viewProviders.has(w))throw new Error(`View provider for '${w}' already registered`);return this._viewProviders.set(w,{provider:t,extension:u}),this._proxy.$registerWebviewViewProvider((0,A.toExtensionData)(u),w,{retainContextWhenHidden:n==null?void 0:n.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new y.Disposable(()=>{this._viewProviders.delete(w),this._proxy.$unregisterWebviewViewProvider(w)})}async $resolveWebviewView(u,w,t,n,l){const a=this._viewProviders.get(w);if(!a)throw new Error(`No view provider found for '${w}'`);const{provider:s,extension:c}=a,v=this._extHostWebview.createNewWebview(u,{},c),P=new g(u,this._proxy,w,t,v,!0);this._webviewViews.set(u,P),await s.resolveWebviewView(P,{state:n},l)}async $onDidChangeWebviewViewVisibility(u,w){this.getWebviewView(u)._setVisible(w)}async $disposeWebviewView(u){const w=this.getWebviewView(u);this._webviewViews.delete(u),w.dispose(),this._extHostWebview.deleteWebview(u)}getWebviewView(u){const w=this._webviewViews.get(u);if(!w)throw new Error("No webview found");return w}}e.ExtHostWebviewViews=E}),define(ve[101],be([0,1,3,5,2,19,8,4,14]),function(J,e,_,k,A,T,y,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let C=class Fn{constructor(I){this._onDidChangeWindowState=new _.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Fn.InitialState,this._proxy=I.getProxy(k.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(d=>this.$onDidChangeWindowFocus(d))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:I}),this._onDidChangeWindowState.fire(this._state))}openUri(I,d){let f;if(typeof I=="string"){f=I;try{I=A.URI.parse(I)}catch(r){return Promise.reject(`Invalid uri - '${I}'`)}}return(0,y.isFalsyOrWhitespace)(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,f,d)}async asExternalUri(I,d){if((0,y.isFalsyOrWhitespace)(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([T.Schemas.http,T.Schemas.https]).has(I.scheme))return Promise.reject(`Invalid scheme '${I.scheme}'`);const f=await this._proxy.$asExternalUri(I,d);return A.URI.from(f)}};C.InitialState={focused:!0},C=je([Ke(0,S.IExtHostRpcService)],C),e.ExtHostWindow=C,e.IExtHostWindow=(0,D.createDecorator)("IExtHostWindow")}),define(ve[213],be([0,1,18,5,27,14]),function(J,e,_,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let y=class extends _.AbstractLogger{constructor(S,C){super();this._proxy=S.getProxy(k.MainContext.MainThreadLog),this._logFile=C.logFile.toJSON(),this.setLevel(C.logLevel)}$setLevel(S){this.setLevel(S)}trace(S,...C){this.getLevel()<=_.LogLevel.Trace&&this._proxy.$log(this._logFile,_.LogLevel.Trace,Array.from(arguments))}debug(S,...C){this.getLevel()<=_.LogLevel.Debug&&this._proxy.$log(this._logFile,_.LogLevel.Debug,Array.from(arguments))}info(S,...C){this.getLevel()<=_.LogLevel.Info&&this._proxy.$log(this._logFile,_.LogLevel.Info,Array.from(arguments))}warn(S,...C){this.getLevel()<=_.LogLevel.Warning&&this._proxy.$log(this._logFile,_.LogLevel.Warning,Array.from(arguments))}error(S,...C){this.getLevel()<=_.LogLevel.Error&&this._proxy.$log(this._logFile,_.LogLevel.Error,Array.from(arguments))}critical(S,...C){this.getLevel()<=_.LogLevel.Critical&&this._proxy.$log(this._logFile,_.LogLevel.Critical,Array.from(arguments))}flush(){}};y=je([Ke(0,T.IExtHostRpcService),Ke(1,A.IExtHostInitDataService)],y),e.ExtHostLogService=y}),define(ve[214],be([0,1,11,20,12,3,6,113,186,98,24]),function(J,e,_,k,A,T,y,D,S,C,i){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function d(a,s){try{return JSON.stringify(a,s)}catch(c){return"null"}}function f(a,s){return JSON.stringify(a,s)}function r(a){return a?(s,c)=>c&&c.$mid===1?a.transformOutgoing(c):c:null}var o;(function(a){a[a.LocalSide=0]="LocalSide",a[a.OtherSide=1]="OtherSide"})(o=e.RequestInitiator||(e.RequestInitiator={}));var p;(function(a){a[a.Responsive=0]="Responsive",a[a.Unresponsive=1]="Unresponsive"})(p=e.ResponsiveState||(e.ResponsiveState={}));const g=()=>{},E=Symbol.for("rpcProtocol"),m=Symbol.for("rpcProxy");class u extends y.Disposable{constructor(s,c=null,v=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=s,this._logger=c,this._uriTransformer=v,this._uriReplacer=r(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let P=0,h=C.ProxyIdentifier.count;P<h;P++)this._locals[P]=null,this._proxies[P]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new _.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(P=>this._receiveOneMessage(P))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(s=>{this._pendingRPCReplies[s].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(s){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+u.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(s){this._unresponsiveTime=Date.now()+u.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(s){this._responsiveState!==s&&(this._responsiveState=s,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(s){return this._uriTransformer?(0,D.transformIncomingURIs)(s,this._uriTransformer):s}getProxy(s){const{nid:c,sid:v}=s;return this._proxies[c]||(this._proxies[c]=this._createProxy(c,v)),this._proxies[c]}_createProxy(s,c){let v={get:(P,h)=>(typeof h=="string"&&!P[h]&&h.charCodeAt(0)===36&&(P[h]=(...b)=>this._remoteCall(s,h,b)),h===m?c:P[h])};return new Proxy(Object.create(null),v)}set(s,c){return this._locals[s.nid]=c,c}assertRegistered(s){for(let c=0,v=s.length;c<v;c++){const P=s[c];if(!this._locals[P.nid])throw new Error(`Missing actor ${P.sid} (isMain: ${P.isMain})`)}}_receiveOneMessage(s){if(!this._isDisposed){const c=s.byteLength,v=w.read(s,0),P=v.readUInt8(),h=v.readUInt32();switch(P){case 1:case 2:{let{rpcId:b,method:R,args:U}=t.deserializeRequestJSONArgs(v);this._uriTransformer&&(U=(0,D.transformIncomingURIs)(U,this._uriTransformer)),this._receiveRequest(c,h,b,R,U,P===2);break}case 3:case 4:{let{rpcId:b,method:R,args:U}=t.deserializeRequestMixedArgs(v);this._uriTransformer&&(U=(0,D.transformIncomingURIs)(U,this._uriTransformer)),this._receiveRequest(c,h,b,R,U,P===4);break}case 5:{this._logger&&this._logger.logIncoming(c,h,0,"ack"),this._onDidReceiveAcknowledge(h);break}case 6:{this._receiveCancel(c,h);break}case 7:{this._receiveReply(c,h,void 0);break}case 9:{let b=t.deserializeReplyOKJSON(v);this._uriTransformer&&(b=(0,D.transformIncomingURIs)(b,this._uriTransformer)),this._receiveReply(c,h,b);break}case 8:{let b=t.deserializeReplyOKVSBuffer(v);this._receiveReply(c,h,b);break}case 10:{let b=t.deserializeReplyErrError(v);this._uriTransformer&&(b=(0,D.transformIncomingURIs)(b,this._uriTransformer)),this._receiveReplyErr(c,h,b);break}case 11:{this._receiveReplyErr(c,h,void 0);break}default:console.error("received unexpected message"),console.error(s)}}}_receiveRequest(s,c,v,P,h,b){this._logger&&this._logger.logIncoming(s,c,1,`receiveRequest ${(0,C.getStringIdentifierForProxy)(v)}.${P}(`,h);const R=String(c);let U,K;if(b){const V=new k.CancellationTokenSource;h.push(V.token),U=this._invokeHandler(v,P,h),K=()=>V.cancel()}else U=this._invokeHandler(v,P,h),K=g;this._cancelInvokedHandlers[R]=K;const he=t.serializeAcknowledged(c);this._logger&&this._logger.logOutgoing(he.byteLength,c,1,"ack"),this._protocol.send(he),U.then(V=>{delete this._cancelInvokedHandlers[R];const H=t.serializeReplyOK(c,V,this._uriReplacer);this._logger&&this._logger.logOutgoing(H.byteLength,c,1,"reply:",V),this._protocol.send(H)},V=>{delete this._cancelInvokedHandlers[R];const H=t.serializeReplyErr(c,V);this._logger&&this._logger.logOutgoing(H.byteLength,c,1,"replyErr:",V),this._protocol.send(H)})}_receiveCancel(s,c){this._logger&&this._logger.logIncoming(s,c,1,"receiveCancel");const v=String(c);this._cancelInvokedHandlers[v]&&this._cancelInvokedHandlers[v]()}_receiveReply(s,c,v){this._logger&&this._logger.logIncoming(s,c,0,"receiveReply:",v);const P=String(c);if(!!this._pendingRPCReplies.hasOwnProperty(P)){const h=this._pendingRPCReplies[P];delete this._pendingRPCReplies[P],h.resolveOk(v)}}_receiveReplyErr(s,c,v){this._logger&&this._logger.logIncoming(s,c,0,"receiveReplyErr:",v);const P=String(c);if(!!this._pendingRPCReplies.hasOwnProperty(P)){const h=this._pendingRPCReplies[P];delete this._pendingRPCReplies[P];let b;v&&(v.$isError?(b=new Error,b.name=v.name,b.message=v.message,b.stack=v.stack):b=v),h.resolveErr(b)}}_invokeHandler(s,c,v){try{return Promise.resolve(this._doInvokeHandler(s,c,v))}catch(P){return Promise.reject(P)}}_doInvokeHandler(s,c,v){const P=this._locals[s];if(!P)throw new Error("Unknown actor "+(0,C.getStringIdentifierForProxy)(s));let h=P[c];if(typeof h!="function")throw new Error("Unknown method "+c+" on actor "+(0,C.getStringIdentifierForProxy)(s));return h.apply(P,v)}_remoteCall(s,c,v){if(this._isDisposed)return Promise.reject(A.canceled());let P=null;if(v.length>0&&k.CancellationToken.isCancellationToken(v[v.length-1])&&(P=v.pop()),P&&P.isCancellationRequested)return Promise.reject(A.canceled());const h=t.serializeRequestArguments(v,this._uriReplacer),b=++this._lastMessageId,R=String(b),U=new S.LazyPromise;P&&P.onCancellationRequested(()=>{const he=t.serializeCancel(b);this._logger&&this._logger.logOutgoing(he.byteLength,b,0,"cancel"),this._protocol.send(t.serializeCancel(b))}),this._pendingRPCReplies[R]=U,this._onWillSendRequest(b);const K=t.serializeRequest(b,s,c,h,!!P);return this._logger&&this._logger.logOutgoing(K.byteLength,b,0,`request: ${(0,C.getStringIdentifierForProxy)(s)}.${c}(`,v),this._protocol.send(K),U}}e.RPCProtocol=u,I=E,u.UNRESPONSIVE_TIME=3*1e3;class w{constructor(s,c){this._buff=s,this._offset=c}static alloc(s,c,v){let P=new w(i.VSBuffer.alloc(v+1+4),0);return P.writeUInt8(s),P.writeUInt32(c),P}static read(s,c){return new w(s,c)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(s){this._buff.writeUInt8(s,this._offset),this._offset+=1}readUInt8(){const s=this._buff.readUInt8(this._offset);return this._offset+=1,s}writeUInt32(s){this._buff.writeUInt32BE(s,this._offset),this._offset+=4}readUInt32(){const s=this._buff.readUInt32BE(this._offset);return this._offset+=4,s}static sizeShortString(s){return 1+s.byteLength}writeShortString(s){this._buff.writeUInt8(s.byteLength,this._offset),this._offset+=1,this._buff.set(s,this._offset),this._offset+=s.byteLength}readShortString(){const s=this._buff.readUInt8(this._offset);this._offset+=1;const v=this._buff.slice(this._offset,this._offset+s).toString();return this._offset+=s,v}static sizeLongString(s){return 4+s.byteLength}writeLongString(s){this._buff.writeUInt32BE(s.byteLength,this._offset),this._offset+=4,this._buff.set(s,this._offset),this._offset+=s.byteLength}readLongString(){const s=this._buff.readUInt32BE(this._offset);this._offset+=4;const v=this._buff.slice(this._offset,this._offset+s).toString();return this._offset+=s,v}writeBuffer(s){this._buff.writeUInt32BE(s.byteLength,this._offset),this._offset+=4,this._buff.set(s,this._offset),this._offset+=s.byteLength}static sizeVSBuffer(s){return 4+s.byteLength}writeVSBuffer(s){this._buff.writeUInt32BE(s.byteLength,this._offset),this._offset+=4,this._buff.set(s,this._offset),this._offset+=s.byteLength}readVSBuffer(){const s=this._buff.readUInt32BE(this._offset);this._offset+=4;const c=this._buff.slice(this._offset,this._offset+s);return this._offset+=s,c}static sizeMixedArray(s,c){let v=0;v+=1;for(let P=0,h=s.length;P<h;P++){const b=s[P],R=c[P];switch(v+=1,R){case 1:v+=this.sizeLongString(b);break;case 2:v+=this.sizeVSBuffer(b);break;case 3:break}}return v}writeMixedArray(s,c){this._buff.writeUInt8(s.length,this._offset),this._offset+=1;for(let v=0,P=s.length;v<P;v++){const h=s[v];switch(c[v]){case 1:this.writeUInt8(1),this.writeLongString(h);break;case 2:this.writeUInt8(2),this.writeVSBuffer(h);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const s=this._buff.readUInt8(this._offset);this._offset+=1;let c=new Array(s);for(let v=0;v<s;v++)switch(this.readUInt8()){case 1:c[v]=this.readLongString();break;case 2:c[v]=this.readVSBuffer();break;case 3:c[v]=void 0;break}return c}}class t{static _arrayContainsBufferOrUndefined(s){for(let c=0,v=s.length;c<v;c++)if(s[c]instanceof i.VSBuffer||typeof s[c]=="undefined")return!0;return!1}static serializeRequestArguments(s,c){if(this._arrayContainsBufferOrUndefined(s)){let v=[],P=[];for(let h=0,b=s.length;h<b;h++){const R=s[h];R instanceof i.VSBuffer?(v[h]=R,P[h]=2):typeof R=="undefined"?(v[h]=i.VSBuffer.alloc(0),P[h]=3):(v[h]=i.VSBuffer.fromString(f(R,c)),P[h]=1)}return{type:"mixed",args:v,argsType:P}}return{type:"simple",args:f(s,c)}}static serializeRequest(s,c,v,P,h){return P.type==="mixed"?this._requestMixedArgs(s,c,v,P.args,P.argsType,h):this._requestJSONArgs(s,c,v,P.args,h)}static _requestJSONArgs(s,c,v,P,h){const b=i.VSBuffer.fromString(v),R=i.VSBuffer.fromString(P);let U=0;U+=w.sizeUInt8(),U+=w.sizeShortString(b),U+=w.sizeLongString(R);let K=w.alloc(h?2:1,s,U);return K.writeUInt8(c),K.writeShortString(b),K.writeLongString(R),K.buffer}static deserializeRequestJSONArgs(s){const c=s.readUInt8(),v=s.readShortString(),P=s.readLongString();return{rpcId:c,method:v,args:JSON.parse(P)}}static _requestMixedArgs(s,c,v,P,h,b){const R=i.VSBuffer.fromString(v);let U=0;U+=w.sizeUInt8(),U+=w.sizeShortString(R),U+=w.sizeMixedArray(P,h);let K=w.alloc(b?4:3,s,U);return K.writeUInt8(c),K.writeShortString(R),K.writeMixedArray(P,h),K.buffer}static deserializeRequestMixedArgs(s){const c=s.readUInt8(),v=s.readShortString(),P=s.readMixedArray(),h=new Array(P.length);for(let b=0,R=P.length;b<R;b++){const U=P[b];typeof U=="string"?h[b]=JSON.parse(U):h[b]=U}return{rpcId:c,method:v,args:h}}static serializeAcknowledged(s){return w.alloc(5,s,0).buffer}static serializeCancel(s){return w.alloc(6,s,0).buffer}static serializeReplyOK(s,c,v){return typeof c=="undefined"?this._serializeReplyOKEmpty(s):c instanceof i.VSBuffer?this._serializeReplyOKVSBuffer(s,c):this._serializeReplyOKJSON(s,d(c,v))}static _serializeReplyOKEmpty(s){return w.alloc(7,s,0).buffer}static _serializeReplyOKVSBuffer(s,c){let v=0;v+=w.sizeVSBuffer(c);let P=w.alloc(8,s,v);return P.writeVSBuffer(c),P.buffer}static deserializeReplyOKVSBuffer(s){return s.readVSBuffer()}static _serializeReplyOKJSON(s,c){const v=i.VSBuffer.fromString(c);let P=0;P+=w.sizeLongString(v);let h=w.alloc(9,s,P);return h.writeLongString(v),h.buffer}static deserializeReplyOKJSON(s){const c=s.readLongString();return JSON.parse(c)}static serializeReplyErr(s,c){return c?this._serializeReplyErrEror(s,c):this._serializeReplyErrEmpty(s)}static _serializeReplyErrEror(s,c){const v=i.VSBuffer.fromString(d(A.transformErrorForSerialization(c),null));let P=0;P+=w.sizeLongString(v);let h=w.alloc(10,s,P);return h.writeLongString(v),h.buffer}static deserializeReplyErrError(s){const c=s.readLongString();return JSON.parse(c)}static _serializeReplyErrEmpty(s){return w.alloc(11,s,0).buffer}}var n;(function(a){a[a.RequestJSONArgs=1]="RequestJSONArgs",a[a.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",a[a.RequestMixedArgs=3]="RequestMixedArgs",a[a.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",a[a.Acknowledged=5]="Acknowledged",a[a.Cancel=6]="Cancel",a[a.ReplyOKEmpty=7]="ReplyOKEmpty",a[a.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",a[a.ReplyOKJSON=9]="ReplyOKJSON",a[a.ReplyErrError=10]="ReplyErrError",a[a.ReplyErrEmpty=11]="ReplyErrEmpty"})(n||(n={}));var l;(function(a){a[a.String=1]="String",a[a.VSBuffer=2]="VSBuffer",a[a.Undefined=3]="Undefined"})(l||(l={}))}),define(ve[215],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const _=function(T){const y=D=>{self.removeEventListener("message",y);const S=D.data;Object.defineProperties(self,{postMessage:{value(C,i){S.postMessage(C,i)}},onmessage:{get(){return S.onmessage},set(C){S.onmessage=C}}}),S.addEventListener("message",C=>{self.dispatchEvent(new MessageEvent("message",{data:C.data}))}),S.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};self.addEventListener("message",y)}.toString();class k extends EventTarget{constructor(T,y,D){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const S=`((${_})('${y}'))`,C=new Blob([S],{type:"application/javascript"}),i=URL.createObjectURL(C),I=new MessageChannel,d=i,f={type:"_newWorker",id:d,port:I.port2,url:i,options:D};T(f,[I.port2]),this.postMessage=I.port1.postMessage.bind(I.port1),this.terminate=()=>{const r={type:"_terminateWorker",id:d};I.port1.postMessage(r),URL.revokeObjectURL(i),I.port1.close(),I.port2.close()},Object.defineProperties(this,{onmessage:{get(){return I.port1.onmessage},set(r){I.port1.onmessage=r}},onmessageerror:{get(){return I.port1.onmessageerror},set(r){I.port1.onmessageerror=r}}}),I.port1.addEventListener("messageerror",r=>{const o=new MessageEvent("messageerror",{data:r.data});this.dispatchEvent(o)}),I.port1.addEventListener("message",r=>{const o=new MessageEvent("message",{data:r.data});this.dispatchEvent(o)}),I.port1.start()}}e.NestedWorker=k}),define(ve[216],be([0,1,4]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,_.createDecorator)("remoteAgentService")}),define(ve[217],be([0,1,19,13,21,2,4,216]),function(J,e,_,k,A,T,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let S=class{constructor(i,I){this.localUserHome=i,this.remoteAgentService=I,this.resolveOS=(async()=>{const d=await this.remoteAgentService.getEnvironment();return(d==null?void 0:d.os)||A.OS})(),this.resolveUserHome=(async()=>{const d=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(d==null?void 0:d.userHome)||i})()}async userHome(i){return(i==null?void 0:i.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(i=>i===1?k.win32:k.posix)}async fileURI(i){let I="";if(await this.resolveOS===1&&(i=i.replace(/\\/g,"/")),i[0]==="/"&&i[1]==="/"){const f=i.indexOf("/",2);f===-1?(I=i.substring(2),i="/"):(I=i.substring(2,f),i=i.substring(f)||"/")}return T.URI.from({scheme:_.Schemas.file,authority:I,path:i,query:"",fragment:""})}};S=je([Ke(1,D.IRemoteAgentService)],S),e.AbstractPathService=S}),define(ve[102],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class _{constructor(y,D){this.line=y,this.character=D}isBefore(y){return!1}isBeforeOrEqual(y){return!1}isAfter(y){return!1}isAfterOrEqual(y){return!1}isEqual(y){return!1}compareTo(y){return 0}translate(y,D){return new _(0,0)}with(y){return new _(0,0)}}e.Position=_;class k{constructor(y,D,S,C){this.isEmpty=!1,this.isSingleLine=!1,this.start=new _(y,D),this.end=new _(S,C)}contains(y){return!1}isEqual(y){return!1}intersection(y){}union(y){return new k(0,0,0,0)}with(y){return new k(0,0,0,0)}}e.Range=k;var A;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(A=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ve[41],be([0,1,15,28,23,37,8,4,13,12,102]),function(J,e,_,k,A,T,y,D,S,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return i.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const I="\u27EA ",d=" characters skipped \u27EB",f=(I.length+d.length+5)*2;e.ISearchService=(0,D.createDecorator)("searchService");var r;(function(F){F[F.file=0]="file",F[F.text=1]="text"})(r=e.SearchProviderType||(e.SearchProviderType={}));var o;(function(F){F[F.File=1]="File",F[F.Text=2]="Text"})(o=e.QueryType||(e.QueryType={}));function p(F){return!!F.preview}e.resultIsMatch=p;function g(F){return!!F.resource}e.isFileMatch=g;function E(F){return!!F.message}e.isProgressMessage=E;var m;(function(F){F[F.Normal=0]="Normal",F[F.NewSearchStarted=1]="NewSearchStarted"})(m=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class u{constructor(L){this.resource=L,this.results=[]}}e.FileMatch=u;class w{constructor(L,M,x){this.ranges=M;const G=Array.isArray(M)?M:[M];if(x&&x.matchLines===1&&t(G)){L=(0,y.getNLines)(L,x.matchLines);let X="",ne=0,me=0;const Le=Math.floor(x.charsPerLine/5),We=[];for(const Fe of G){const ze=Math.max(Fe.startColumn-Le,0),$=Fe.startColumn+x.charsPerLine;if(ze>me+Le+f){const j=I+(ze-me)+d;X+=j+L.slice(ze,$),ne+=ze-(me+j.length)}else X+=L.slice(me,$);We.push(new l(0,Fe.startColumn-ne,Fe.endColumn-ne)),me=$}this.preview={text:X,matches:Array.isArray(this.ranges)?We:We[0]}}else{const X=Array.isArray(M)?M[0].startLineNumber:M.startLineNumber;this.preview={text:L,matches:(0,_.mapArrayOrNot)(M,ne=>new n(ne.startLineNumber-X,ne.startColumn,ne.endLineNumber-X,ne.endColumn))}}}}e.TextSearchMatch=w;function t(F){const L=F[0].startLineNumber;for(const M of F)if(M.startLineNumber!==L||M.endLineNumber!==L)return!1;return!0}class n{constructor(L,M,x,G){this.startLineNumber=L,this.startColumn=M,this.endLineNumber=x,this.endColumn=G}}e.SearchRange=n;class l extends n{constructor(L,M,x){super(L,M,L,x)}}e.OneLineRange=l;var a;(function(F){F.Default="default",F.FileNames="fileNames",F.Type="type",F.Modified="modified",F.CountDescending="countDescending",F.CountAscending="countAscending"})(a=e.SearchSortOrder||(e.SearchSortOrder={}));function s(F,L=!0){const M=F&&F.files&&F.files.exclude,x=L&&F&&F.search&&F.search.exclude;if(!(!M&&!x)){if(!M||!x)return M||x;let G=Object.create(null);return G=A.mixin(G,A.deepClone(M)),G=A.mixin(G,A.deepClone(x),!0),G}}e.getExcludes=s;function c(F,L){return F.excludePattern&&k.match(F.excludePattern,L)?!1:F.includePattern||F.usingSearchPaths?F.includePattern&&k.match(F.includePattern,L)?!0:F.usingSearchPaths?!!F.folderQueries&&F.folderQueries.some(M=>{const x=M.folder.fsPath;if(T.isEqualOrParent(L,x)){const G=S.relative(x,L);return!M.includePattern||!!k.match(M.includePattern,G)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var v;(function(F){F[F.unknownEncoding=1]="unknownEncoding",F[F.regexParseError=2]="regexParseError",F[F.globParseError=3]="globParseError",F[F.invalidLiteral=4]="invalidLiteral",F[F.rgProcessError=5]="rgProcessError",F[F.other=6]="other",F[F.canceled=7]="canceled"})(v=e.SearchErrorCode||(e.SearchErrorCode={}));class P extends Error{constructor(L,M){super(L);this.code=M}}e.SearchError=P;function h(F){const L=F.message;if((0,C.isPromiseCanceledError)(F))return new P(L,v.canceled);try{const M=JSON.parse(L);return new P(M.message,M.code)}catch(M){return new P(L,v.other)}}e.deserializeSearchError=h;function b(F){const L={message:F.message,code:F.code};return new Error(JSON.stringify(L))}e.serializeSearchError=b;function R(F){return F.type==="error"?!0:F.type==="success"}e.isSerializedSearchComplete=R;function U(F){return F.type==="success"}e.isSerializedSearchSuccess=U;function K(F){return!!F.path}e.isSerializedFileMatch=K;function he(F,L){const M=F.searchPath?F.searchPath:F.relativePath;return(0,y.fuzzyContains)(M,L)}e.isFilePatternMatch=he;class V{constructor(L){this.path=L,this.results=[]}addMatch(L){this.results.push(L)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=V;function H(F,L){const M=Object.assign(Object.assign({},F||{}),L||{});return Object.keys(M).filter(x=>{const G=M[x];return typeof G=="boolean"&&G})}e.resolvePatternsForProvider=H;class Y{constructor(L,M){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},L.excludePattern||{}),M.excludePattern||{}),this._parsedExcludeExpression=k.parse(this._excludeExpression);let x=L.includePattern;M.includePattern&&(x?x=Object.assign(Object.assign({},x),M.includePattern):x=M.includePattern),x&&(this._parsedIncludeExpression=k.parse(x))}includedInQuerySync(L,M,x){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(L,M,x)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(L,M,x))}includedInQuery(L,M,x){return Promise.resolve(this._parsedExcludeExpression(L,M,x)).then(X=>!!X).then(X=>X?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(L,M,x)).then(ne=>!!ne):Promise.resolve(!0)).then(X=>X)}hasSiblingExcludeClauses(){return W(this._excludeExpression)}}e.QueryGlobTester=Y;function W(F){for(const L in F)if(typeof F[L]!="boolean")return!0;return!1}}),define(ve[30],be([0,1,15,11,20,3,22,19,81,25,8,10,2,137,4,18,152,48,49,27,14,7,41,5]),function(J,e,_,k,A,T,y,D,S,C,i,I,d,f,r,o,p,g,E,m,u,w,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function l(R,U,K){return new C.ExtUri(he=>v(he,K)).isEqual(R,U)}function a(R,U,K){return l(R.uri,U.uri,K)?0:(0,i.compare)(R.uri.toString(),U.uri.toString())}function s(R,U,K){return R.index!==U.index?R.index<U.index?-1:1:l(R.uri,U.uri,K)?(0,i.compare)(R.name,U.name):(0,i.compare)(R.uri.toString(),U.uri.toString())}function c(R,U,K,he){const V=R.slice(0).sort((Y,W)=>K(Y,W,he)),H=U.slice(0).sort((Y,W)=>K(Y,W,he));return(0,_.delta)(V,H,(Y,W)=>K(Y,W,he))}function v(R,U){const K=U.getCapabilities(R.scheme);return!(K&&K&1024)}class P extends g.Workspace{constructor(U,K,he,V,H,Y){super(U,he.map(W=>new g.WorkspaceFolder(W)),V,Y);this._name=K,this._isUntitled=H,this._workspaceFolders=[],this._structure=y.TernarySearchTree.forUris(Y),he.forEach(W=>{this._workspaceFolders.push(W),this._structure.set(W.uri,W)})}static toExtHostWorkspace(U,K,he,V){if(!U)return{workspace:null,added:[],removed:[]};const{id:H,name:Y,folders:W,configuration:F,isUntitled:L}=U,M=[],x=K;K?W.forEach((me,Le)=>{const We=d.URI.revive(me.uri),Fe=P._findFolder(he||K,We,V);Fe?(Fe.name=me.name,Fe.index=me.index,M.push(Fe)):M.push({uri:We,name:me.name,index:Le})}):M.push(...W.map(({uri:me,name:Le,index:We})=>({uri:d.URI.revive(me),name:Le,index:We}))),M.sort((me,Le)=>me.index<Le.index?-1:1);const G=new P(H,Y,M,F?d.URI.revive(F):null,!!L,me=>v(me,V)),{added:X,removed:ne}=c(x?x.workspaceFolders:[],G.workspaceFolders,a,V);return{workspace:G,added:X,removed:ne}}static _findFolder(U,K,he){for(let V=0;V<U.folders.length;V++){const H=U.workspaceFolders[V];if(l(H.uri,K,he))return H}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(U,K){return K&&this._structure.get(U)&&(U=(0,C.dirname)(U)),this._structure.findSubstr(U)}resolveWorkspaceFolder(U){return this._structure.get(U)}}let h=class{constructor(U,K,he,V){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new T.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=V,this._extHostFileSystemInfo=he,this._requestIdProvider=new S.Counter,this._barrier=new k.Barrier,this._proxy=U.getProxy(n.MainContext.MainThreadWorkspace),this._messageService=U.getProxy(n.MainContext.MainThreadMessageService);const H=K.workspace;this._confirmedWorkspace=H?new P(H.id,H.name,[],H.configuration?d.URI.revive(H.configuration):null,!!H.isUntitled,Y=>v(Y,he)):void 0}$initializeWorkspace(U,K){this._trusted=K,this.$acceptWorkspaceData(U),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?d.URI.from({scheme:D.Schemas.untitled,path:(0,C.basename)((0,C.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(U,K,he,...V){const H=[];if(Array.isArray(V)&&V.forEach(M=>{d.URI.isUri(M.uri)&&!H.some(x=>l(x.uri,M.uri,this._extHostFileSystemInfo))&&H.push({uri:M.uri,name:M.name||(0,C.basenameOrAuthority)(M.uri)})}),this._unconfirmedWorkspace||[K,he].some(M=>typeof M!="number"||M<0)||he===0&&H.length===0)return!1;const Y=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(K+he>Y.length)return!1;const W=Y.slice(0);W.splice(K,he,...H.map(M=>({uri:M.uri,name:M.name||(0,C.basenameOrAuthority)(M.uri),index:void 0})));for(let M=0;M<W.length;M++){const x=W[M];if(W.some((G,X)=>X!==M&&l(x.uri,G.uri,this._extHostFileSystemInfo)))return!1}W.forEach((M,x)=>M.index=x);const{added:F,removed:L}=c(Y,W,s,this._extHostFileSystemInfo);if(F.length===0&&L.length===0)return!1;if(this._proxy){const M=U.displayName||U.name;this._proxy.$updateWorkspaceFolders(M,K,he,H).then(void 0,x=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(p.Severity.Error,(0,f.localize)(0,null,M,x.toString()),{extension:U},[])})}return this.trySetWorkspaceFolders(W),!0}getWorkspaceFolder(U,K){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(U,K)}async getWorkspaceFolder2(U,K){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(U,K)}async resolveWorkspaceFolder(U){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(U)}getPath(){if(!!this._actualWorkspace){const{folders:U}=this._actualWorkspace;if(U.length!==0)return U[0].uri.fsPath}}getRelativePath(U,K){let he,V="";if(typeof U=="string"?(he=d.URI.file(U),V=U):typeof U!="undefined"&&(he=U,V=U.fsPath),!he)return V;const H=this.getWorkspaceFolder(he,!0);if(!H)return V;typeof K=="undefined"&&this._actualWorkspace&&(K=this._actualWorkspace.folders.length>1);let Y=(0,C.relativePath)(H.uri,he);return K&&H.name&&(Y=`${H.name}/${Y}`),Y}trySetWorkspaceFolders(U){this._actualWorkspace&&(this._unconfirmedWorkspace=P.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:U,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(U){const{workspace:K,added:he,removed:V}=P.toExtHostWorkspace(U,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=K||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:he,removed:V}))}findFiles(U,K,he,V,H=A.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${V.value}, entryPoint: findFiles`);let Y;if(K===null?Y=!1:K&&(typeof K=="string"?Y=K:Y=K.pattern),H&&H.isCancellationRequested)return Promise.resolve([]);const{includePattern:W,folder:F}=b(U);return this._proxy.$startFileSearch((0,I.withUndefinedAsNull)(W),(0,I.withUndefinedAsNull)(F),(0,I.withUndefinedAsNull)(Y),(0,I.withUndefinedAsNull)(he),H).then(L=>Array.isArray(L)?L.map(M=>d.URI.revive(M)):[])}async findTextInFiles(U,K,he,V,H=A.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${V.value}, entryPoint: findTextInFiles`);const Y=this._requestIdProvider.getNext(),W=typeof K.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:K.previewOptions,{includePattern:F,folder:L}=b(K.include),M=typeof K.exclude=="string"?K.exclude:K.exclude?K.exclude.pattern:void 0,x={ignoreSymlinks:typeof K.followSymlinks=="boolean"?!K.followSymlinks:void 0,disregardIgnoreFiles:typeof K.useIgnoreFiles=="boolean"?!K.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof K.useGlobalIgnoreFiles=="boolean"?!K.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof K.useDefaultExcludes=="boolean"?!K.useDefaultExcludes:!0,fileEncoding:K.encoding,maxResults:K.maxResults,previewOptions:W,afterContext:K.afterContext,beforeContext:K.beforeContext,includePattern:F,excludePattern:M},G=!1;if(this._activeSearchCallbacks[Y]=X=>{if(!G){const ne=d.URI.revive(X.resource);X.results.forEach(me=>{(0,t.resultIsMatch)(me)?he({uri:ne,preview:{text:me.preview.text,matches:(0,_.mapArrayOrNot)(me.preview.matches,Le=>new w.Range(Le.startLineNumber,Le.startColumn,Le.endLineNumber,Le.endColumn))},ranges:(0,_.mapArrayOrNot)(me.ranges,Le=>new w.Range(Le.startLineNumber,Le.startColumn,Le.endLineNumber,Le.endColumn))}):he({uri:ne,text:me.text,lineNumber:me.lineNumber})})}},H.isCancellationRequested)return{};try{const X=await this._proxy.$startTextSearch(U,(0,I.withUndefinedAsNull)(L),x,Y,H);return delete this._activeSearchCallbacks[Y],X||{}}catch(X){throw delete this._activeSearchCallbacks[Y],X}}$handleTextSearchResult(U,K){this._activeSearchCallbacks[K]&&this._activeSearchCallbacks[K](U)}saveAll(U){return this._proxy.$saveAll(U)}resolveProxy(U){return this._proxy.$resolveProxy(U)}get trusted(){return this._trusted}requestWorkspaceTrust(U){return this._proxy.$requestWorkspaceTrust(U)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};h=je([Ke(0,u.IExtHostRpcService),Ke(1,m.IExtHostInitDataService),Ke(2,E.IExtHostFileSystemInfo),Ke(3,o.ILogService)],h),e.ExtHostWorkspace=h,e.IExtHostWorkspace=(0,r.createDecorator)("IExtHostWorkspace");function b(R){let U,K;return R&&(typeof R=="string"?U=R:(U=R.pattern,K=R.baseFolder||d.URI.file(R.base))),{includePattern:U,folder:K}}}),define(ve[34],be([0,1,23,3,30,5,7,154,66,10,11,4,14,18,2]),function(J,e,_,k,A,T,y,D,S,C,i,I,d,f,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function o(n,l){if(l){const a=l.split(".");let s=n;for(let c=0;s&&c<a.length;c++)s=s[a[c]];return s}}function p(n){return n instanceof r.URI}function g(n){return n&&n.uri instanceof r.URI&&n.languageId&&typeof n.languageId=="string"}function E(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function m(n){return n&&n.uri instanceof r.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function u(n){if(p(n))return{resource:n};if(g(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(E(n))return{overrideIdentifier:n.languageId};if(m(n))return{resource:n.uri};if(n===null)return{resource:null}}let w=class{constructor(l,a,s){this._proxy=l.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=a,this._logService=s,this._barrier=new i.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(l=>this._actual)}$initializeConfiguration(l){this._actual=new t(this._proxy,this._extHostWorkspace,l,this._logService),this._barrier.open()}$acceptConfigurationChanged(l,a){this.getConfigProvider().then(s=>s.$acceptConfigurationChanged(l,a))}};w=je([Ke(0,d.IExtHostRpcService),Ke(1,A.IExtHostWorkspace),Ke(2,f.ILogService)],w),e.ExtHostConfiguration=w;class t{constructor(l,a,s,c){this._onDidChangeConfiguration=new k.Emitter,this._proxy=l,this._logService=c,this._extHostWorkspace=a,this._configuration=D.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(l,a){const s={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=D.Configuration.parse(l),this._configurationScopes=this._toMap(l.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(a,s))}getConfiguration(l,a,s){const c=u(a)||{},v=this._toReadonlyValue(l?o(this._configuration.getValue(void 0,c,this._extHostWorkspace.workspace),l):this._configuration.getValue(void 0,c,this._extHostWorkspace.workspace));l&&this._validateConfigurationAccess(l,c,s==null?void 0:s.identifier);function P(b){if(b==null)return null;if(typeof b=="boolean")return b?1:4;switch(b){case y.ConfigurationTarget.Global:return 1;case y.ConfigurationTarget.Workspace:return 4;case y.ConfigurationTarget.WorkspaceFolder:return 5}}const h={has(b){return typeof o(v,b)!="undefined"},get:(b,R)=>{this._validateConfigurationAccess(l?`${l}.${b}`:b,c,s==null?void 0:s.identifier);let U=o(v,b);if(typeof U=="undefined")U=R;else{let K;const he=(V,H)=>{let Y;const W=()=>{K=K||(0,_.deepClone)(v),Y=Y||o(K,H)};return(0,C.isObject)(V)?new Proxy(V,{get:(F,L)=>{if(typeof L=="string"&&L.toLowerCase()==="tojson")return W(),()=>Y;if(K)return Y=Y||o(K,H),Y[L];const M=F[L];return typeof L=="string"?he(M,`${H}.${L}`):M},set:(F,L,M)=>(W(),Y&&(Y[L]=M),!0),deleteProperty:(F,L)=>(W(),Y&&delete Y[L],!0),defineProperty:(F,L,M)=>(W(),Y&&Object.defineProperty(Y,L,M),!0)}):V};U=he(U,b)}return U},update:(b,R,U,K)=>{b=l?`${l}.${b}`:b;const he=P(U);return R!==void 0?this._proxy.$updateConfigurationOption(he,b,R,c,K):this._proxy.$removeConfigurationOption(he,b,c,K)},inspect:b=>{var R,U,K,he,V,H,Y,W;b=l?`${l}.${b}`:b;const F=(0,_.deepClone)(this._configuration.inspect(b,c,this._extHostWorkspace.workspace));if(F)return{key:b,defaultValue:(R=F.default)===null||R===void 0?void 0:R.value,globalValue:(U=F.user)===null||U===void 0?void 0:U.value,workspaceValue:(K=F.workspace)===null||K===void 0?void 0:K.value,workspaceFolderValue:(he=F.workspaceFolder)===null||he===void 0?void 0:he.value,defaultLanguageValue:(V=F.default)===null||V===void 0?void 0:V.override,globalLanguageValue:(H=F.user)===null||H===void 0?void 0:H.override,workspaceLanguageValue:(Y=F.workspace)===null||Y===void 0?void 0:Y.override,workspaceFolderLanguageValue:(W=F.workspaceFolder)===null||W===void 0?void 0:W.override,languageIds:F.overrideIdentifiers}}};return typeof v=="object"&&(0,_.mixin)(h,v,!1),Object.freeze(h)}_toReadonlyValue(l){const a=s=>(0,C.isObject)(s)?new Proxy(s,{get:(c,v)=>a(c[v]),set:(c,v,P)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(v)}' of object`)},deleteProperty:(c,v)=>{throw new Error(`TypeError: Cannot delete read only property '${String(v)}' of object`)},defineProperty:(c,v)=>{throw new Error(`TypeError: Cannot define property '${String(v)}' for a readonly object`)},setPrototypeOf:c=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):s;return a(l)}_validateConfigurationAccess(l,a,s){const c=S.OVERRIDE_PROPERTY_PATTERN.test(l)?4:this._configurationScopes.get(l),v=s?`[${s.value}] `:"";if(c===4){typeof(a==null?void 0:a.resource)=="undefined"&&this._logService.warn(`${v}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${l}', provide the URI of a resource or 'null' for any resource.`);return}if(c===3){(a==null?void 0:a.resource)&&this._logService.warn(`${v}Accessing a window scoped configuration for a resource is not expected. To associate '${l}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(l,a){const s=new D.ConfigurationChangeEvent(l,a,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(c,v)=>s.affectsConfiguration(c,u(v))})}_toMap(l){return l.reduce((a,s)=>(a.set(s[0],s[1]),a),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")});var it=this&&this.__classPrivateFieldSet||function(J,e,_,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!A:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(J,_):A?A.value=_:e.set(J,_),_},Ue=this&&this.__classPrivateFieldGet||function(J,e,_,k){if(_==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?k:_==="a"?k.call(J):k?k.value:e.get(J)};define(ve[103],be([0,1,2,11,3,5,7,30,39,34,20,40,14,27,4,19,21,18,75,171,12]),function(J,e,_,k,A,T,y,D,S,C,i,I,d,f,r,o,p,g,E,m,u){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(V){function H(W){if(W!=null)return W}V.from=H;function Y(W){if(W!=null)return W}V.to=Y})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var n;(function(V){function H(W){if(W!=null)return W}V.from=H;function Y(W){if(W!=null)return W}V.to=Y})(n=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var l;(function(V){function H(W){if(W!=null)return W}V.from=H;function Y(W){if(W!=null)return W}V.to=Y})(l=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var a;(function(V){function H(F){if(F){const L=F;return L&&!!L.process}else return!1}V.is=H;function Y(F){if(F!=null){const L={process:F.process,args:F.args};return F.options&&(L.options=l.from(F.options)),L}}V.from=Y;function W(F){if(F!=null)return new y.ProcessExecution(F.process,F.args,F.options)}V.to=W})(a=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var s;(function(V){function H(W){if(W!=null)return W}V.from=H;function Y(W){if(W!=null)return W}V.to=Y})(s=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var c;(function(V){function H(F){if(F){const L=F;return L&&(!!L.commandLine||!!L.command)}else return!1}V.is=H;function Y(F){if(F!=null){const L={};return F.commandLine!==void 0?L.commandLine=F.commandLine:(L.command=F.command,L.args=F.args),F.options&&(L.options=s.from(F.options)),L}}V.from=Y;function W(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new y.ShellExecution(F.commandLine,F.options):new y.ShellExecution(F.command,F.args?F.args:[],F.options)}V.to=W})(c=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var v;(function(V){function H(F){if(F){let L=F;return L&&L.customExecution==="customExecution"}else return!1}V.is=H;function Y(F){return{customExecution:"customExecution"}}V.from=Y;function W(F,L){return L.get(F)}V.to=W})(v=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var P;(function(V){function H(Y,W){let F;return Y.scope!==void 0&&typeof Y.scope!="number"?F=Y.scope.uri:Y.scope!==void 0&&typeof Y.scope=="number"&&(Y.scope===y.TaskScope.Workspace&&W&&W.workspaceFile?F=W.workspaceFile:F=m.USER_TASKS_GROUP_KEY),{id:Y._id,workspaceFolder:F}}V.from=H})(P=e.TaskHandleDTO||(e.TaskHandleDTO={}));var h;(function(V){function H(F,L){if(F==null)return[];const M=[];for(let x of F){const G=Y(x,L);G&&M.push(G)}return M}V.fromMany=H;function Y(F,L){if(F!=null){let M;F.execution instanceof y.ProcessExecution?M=a.from(F.execution):F.execution instanceof y.ShellExecution?M=c.from(F.execution):F.execution&&F.execution instanceof y.CustomExecution&&(M=v.from(F.execution));const x=t.from(F.definition);let G;if(F.scope?typeof F.scope=="number"?G=F.scope:G=F.scope.uri:G=y.TaskScope.Workspace,!(!x||!G)){const X=F.group?F.group.id:void 0;return{_id:F._id,definition:x,name:F.name,source:{extensionId:L.identifier.value,label:F.source,scope:G},execution:M,isBackground:F.isBackground,group:X,presentationOptions:n.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}}}V.from=Y;async function W(F,L,M){if(F!=null){let x;a.is(F.execution)?x=a.to(F.execution):c.is(F.execution)?x=c.to(F.execution):v.is(F.execution)&&(x=v.to(F._id,M));const G=t.to(F.definition);let X;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?X=F.source.scope:X=await L.resolveWorkspaceFolder(_.URI.revive(F.source.scope)):X=y.TaskScope.Workspace),!(!G||!X)){const ne=new y.Task(G,X,F.name,F.source.label,x,F.problemMatchers);return F.isBackground!==void 0&&(ne.isBackground=F.isBackground),F.group!==void 0&&(ne.group=y.TaskGroup.from(F.group)),F.presentationOptions&&(ne.presentationOptions=n.to(F.presentationOptions)),F._id&&(ne._id=F._id),F.detail&&(ne.detail=F.detail),ne}}}V.to=W})(h=e.TaskDTO||(e.TaskDTO={}));var b;(function(V){function H(W){return W}V.from=H;function Y(W){if(!!W)return Object.assign(Object.create(null),W)}V.to=Y})(b=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(H,Y,W){this._id=Y,this._task=W,w.set(this,void 0),it(this,w,H,"f")}get task(){return this._task}terminate(){Ue(this,w,"f").terminateTask(this)}fireDidStartProcess(H){}fireDidEndProcess(H){}}w=new WeakMap;var U;(function(V){function H(Y){return{id:Y._id,task:void 0}}V.from=H})(U=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let K=class{constructor(H,Y,W,F,L,M,x,G){this._onDidExecuteTask=new A.Emitter,this._onDidTerminateTask=new A.Emitter,this._onDidTaskProcessStarted=new A.Emitter,this._onDidTaskProcessEnded=new A.Emitter,this._proxy=H.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=W,this._editorService=F,this._configurationService=L,this._terminalService=M,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=x,this._deprecationService=G,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(H,Y,W){if(!W)return new y.Disposable(()=>{});const F=this.nextHandle();return this._handlers.set(F,{type:Y,provider:W,extension:H}),this._proxy.$registerTaskProvider(F,Y),new y.Disposable(()=>{this._handlers.delete(F),this._proxy.$unregisterTaskProvider(F)})}registerTaskSystem(H,Y){this._proxy.$registerTaskSystem(H,Y)}fetchTasks(H){return this._proxy.$fetchTasks(b.from(H)).then(async Y=>{const W=[];for(let F of Y){const L=await h.to(F,this._workspaceProvider,this._providedCustomExecutions2);L&&W.push(L)}return W})}get taskExecutions(){const H=[];return this._taskExecutions.forEach(Y=>H.push(Y)),H}terminateTask(H){if(!(H instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(H._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(H,Y,W){const F=this._providedCustomExecutions2.get(H.id);if(F){if(this._activeCustomExecutions2.get(H.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(H.id,F),this._terminalService.attachPtyToTerminal(Y,await F.callback(W))}this._lastStartedTask=H.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(H)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(H){const Y=await this.getTaskExecution(H);this._taskExecutionPromises.delete(H.id),this._taskExecutions.delete(H.id),this.customExecutionComplete(H),this._onDidTerminateTask.fire({execution:Y})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(H){const Y=await this.getTaskExecution(H.id);this._onDidTaskProcessStarted.fire({execution:Y,processId:H.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(H){const Y=await this.getTaskExecution(H.id);this._onDidTaskProcessEnded.fire({execution:Y,exitCode:H.exitCode})}$provideTasks(H,Y){const W=this._handlers.get(H);if(!W)return Promise.reject(new Error("no handler found"));const F=[],L=(0,k.asPromise)(()=>W.provider.provideTasks(i.CancellationToken.None)).then(M=>this.provideTasksInternal(Y,F,W,M));return new Promise(M=>{L.then(x=>{Promise.all(F).then(()=>{M(x)})})})}async $resolveTask(H,Y){const W=this._handlers.get(H);if(!W)return Promise.reject(new Error("no handler found"));if(Y.definition.type!==W.type)throw new Error(`Unexpected: Task of type [${Y.definition.type}] cannot be resolved by provider of type [${W.type}].`);const F=await h.to(Y,this._workspaceProvider,this._providedCustomExecutions2);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const L=await W.provider.resolveTask(F,i.CancellationToken.None);if(!!L){this.checkDeprecation(L,W);const M=h.from(L,W.extension);if(!M)throw new Error("Unexpected: Task cannot be resolved.");if(L.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return v.is(M.execution)&&await this.addCustomExecution(M,L,!0),await this.resolveTaskInternal(M)}}nextHandle(){return this._handleCounter++}async addCustomExecution(H,Y,W){const F=await this._proxy.$createTaskId(H);!W&&!this._providedCustomExecutions2.has(F)&&this._notProvidedCustomExecutions.add(F),this._providedCustomExecutions2.set(F,Y.execution)}async getTaskExecution(H,Y){if(typeof H=="string"){const L=this._taskExecutionPromises.get(H);if(!L)throw new Error("Unexpected: The specified task is missing an execution");return L}let W=this._taskExecutionPromises.get(H.id);if(W)return W;const F=new Promise(async(L,M)=>{const x=Y||await h.to(H.task,this._workspaceProvider,this._providedCustomExecutions2);x?L(new R(this,H.id,x)):M("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(H.id,F),F.then(L=>(this._taskExecutions.set(H.id,L),L),L=>Promise.reject(L))}checkDeprecation(H,Y){H._deprecated&&this._deprecationService.report("Task.constructor",Y.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(H){this._activeCustomExecutions2.get(H.id)&&this._activeCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.has(H.id)&&this._lastStartedTask!==H.id&&(this._providedCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.delete(H.id));let W=this._notProvidedCustomExecutions.values(),F=W.next();for(;!F.done;)!this._activeCustomExecutions2.has(F.value)&&this._lastStartedTask!==F.value&&(this._providedCustomExecutions2.delete(F.value),this._notProvidedCustomExecutions.delete(F.value)),F=W.next()}};K=je([Ke(0,d.IExtHostRpcService),Ke(1,f.IExtHostInitDataService),Ke(2,D.IExtHostWorkspace),Ke(3,S.IExtHostDocumentsAndEditors),Ke(4,C.IExtHostConfiguration),Ke(5,I.IExtHostTerminalService),Ke(6,g.ILogService),Ke(7,E.IExtHostApiDeprecationService)],K),e.ExtHostTaskBase=K;let he=class extends K{constructor(H,Y,W,F,L,M,x,G){super(H,Y,W,F,L,M,x,G);this.registerTaskSystem(o.Schemas.vscodeRemote,{scheme:o.Schemas.vscodeRemote,authority:"",platform:p.PlatformToString(0)})}async executeTask(H,Y){if(!Y.execution)throw new Error("Tasks to execute must include an execution");const W=h.from(Y,H);if(W===void 0)throw new Error("Task is not valid");if(v.is(W.execution))await this.addCustomExecution(W,Y,!1);else throw new u.NotSupportedError;const F=await this.getTaskExecution(await this._proxy.$getTaskExecution(W),Y);return this._proxy.$executeTask(W).catch(L=>{throw new Error(L)}),F}provideTasksInternal(H,Y,W,F){const L=[];if(F)for(let M of F){this.checkDeprecation(M,W),(!M.definition||!H[M.definition.type])&&this._logService.warn(`The task [${M.source}, ${M.name}] uses an undefined task type. The task will be ignored in the future.`);const x=h.from(M,W.extension);x&&v.is(x.execution)?(L.push(x),Y.push(this.addCustomExecution(x,M,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:L,extension:W.extension}}async resolveTaskInternal(H){if(v.is(H.execution))return H;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(H,Y){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(H,Y,W){}};he=je([Ke(0,d.IExtHostRpcService),Ke(1,f.IExtHostInitDataService),Ke(2,D.IExtHostWorkspace),Ke(3,S.IExtHostDocumentsAndEditors),Ke(4,C.IExtHostConfiguration),Ke(5,I.IExtHostTerminalService),Ke(6,g.ILogService),Ke(7,E.IExtHostApiDeprecationService)],he),e.WorkerExtHostTask=he,e.IExtHostTask=(0,r.createDecorator)("IExtHostTask")});var it=this&&this.__classPrivateFieldSet||function(J,e,_,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!A:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(J,_):A?A.value=_:e.set(J,_),_},Ue=this&&this.__classPrivateFieldGet||function(J,e,_,k){if(_==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?k:_==="a"?k.call(J):k?k.value:e.get(J)},Qt=this&&this.__rest||function(J,e){var _={};for(var k in J)Object.prototype.hasOwnProperty.call(J,k)&&e.indexOf(k)<0&&(_[k]=J[k]);if(J!=null&&typeof Object.getOwnPropertySymbols=="function")for(var A=0,k=Object.getOwnPropertySymbols(J);A<k.length;A++)e.indexOf(k[A])<0&&Object.prototype.propertyIsEnumerable.call(J,k[A])&&(_[k[A]]=J[k[A]]);return _};define(ve[218],be([0,1,15,11,24,20,3,53,43,6,23,10,2,31,5,39,14,69,9,7,30,182,96]),function(J,e,_,k,A,T,y,D,S,C,i,I,d,f,r,o,p,g,E,m,u,w,t){"use strict";var n,l,a,s;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const c=(W,F)=>`${W}:${F.toString()}`;let v=class{constructor(F,L,M){this.documents=L,this.workspace=M,this.resultsChangedEmitter=new y.Emitter,this.controllers=new Map,this.ownedTests=new w.OwnedTestCollection,this.testControllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=F.getProxy(r.MainContext.MainThreadTesting),this.runQueue=new P(this.proxy),this.workspaceObservers=new H(this.proxy),this.textDocumentObservers=new Y(this.proxy,L)}registerTestController(F,L){const M=(0,f.generateUuid)();this.controllers.set(M,{instance:L,extensionId:F}),this.proxy.$registerTestController(M);const x=[...this.testControllers.keys()];return setTimeout(()=>{var G;for(const X of x)(G=this.testControllers.get(X))===null||G===void 0||G.subscribeFn(M,L)},0),new m.Disposable(()=>{this.controllers.delete(M),this.proxy.$unregisterTestController(M)})}createTextDocumentTestObserver(F){return this.textDocumentObservers.checkout(F.uri)}createWorkspaceTestObserver(F){return this.workspaceObservers.checkout(F.uri)}async runTests(F,L=T.CancellationToken.None){const M=x=>x.map(this.getInternalTestForReference,this).filter(I.isDefined).map(G=>({src:G.src,testId:G.item.extId}));await this.proxy.$runTests({exclude:F.exclude?M(F.exclude).map(x=>x.testId):void 0,tests:M(F.tests),debug:F.debug},L)}createTestRun(F,L,M,x=!0){return this.runQueue.createTestRun(F,L,M,x)}$publishTestResults(F){this.results=Object.freeze(F.map(L=>(0,i.deepFreeze)(E.TestResults.to(L))).concat(this.results).sort((L,M)=>M.completedAt-L.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(F,L){const M=d.URI.revive(L),x=c(F,M);if(!this.testControllers.has(x)){const G=new T.CancellationTokenSource;let X;if(F===1){let Fe=this.documents.getDocument(M);if(!Fe){const ze=new C.DisposableStore;Fe=await new Promise($=>{ze.add((0,k.disposableTimeout)(()=>$(void 0),5e3)),ze.add(this.documents.onDidAddDocuments(j=>{const te=j.find(oe=>oe.document.uri.toString()===M.toString());te&&$(te)}))}).finally(()=>ze.dispose())}if(Fe){const ze=await this.workspace.getWorkspaceFolder2(M,!1);X=$=>$.createDocumentTestRoot?$.createDocumentTestRoot(Fe.document,G.token):(0,e.createDefaultDocumentTestRoot)($,Fe.document,ze,G.token)}}else{const Fe=await this.workspace.getWorkspaceFolder2(M,!1);Fe&&(X=ze=>ze.createWorkspaceTestRoot(Fe,G.token))}if(!!X){const ne=async(Fe,ze)=>{try{const $=await X(ze);$&&Le.addRoot($,Fe)}catch($){console.error($)}},me=new C.DisposableStore,Le=me.add(this.ownedTests.createForHierarchy(Fe=>this.proxy.$publishDiff(F,L,Fe)));me.add((0,C.toDisposable)(()=>G.dispose(!0)));const We=[];for(const[Fe,ze]of this.controllers)We.push(ne(Fe,ze.instance));Promise.all(We).then(()=>Le.pushDiff([3,-1])),this.testControllers.set(x,{store:me,collection:Le,subscribeFn:ne})}}}async $expandTest(F,L){const M=(0,_.mapFind)(this.testControllers.values(),x=>x.collection.treeId===F.src.tree?x:void 0);await(M==null?void 0:M.collection.expand(F.testId,L<0?Infinity:L)),this.flushCollectionDiffs()}$unsubscribeFromTests(F,L){var M;const x=d.URI.revive(L),G=c(F,x);(M=this.testControllers.get(G))===null||M===void 0||M.store.dispose(),this.testControllers.delete(G)}$acceptDiff(F,L,M){F===1?this.textDocumentObservers.acceptDiff(d.URI.revive(L),M):this.workspaceObservers.acceptDiff(d.URI.revive(L),M)}async $runTestsForProvider(F,L){const M=this.controllers.get(F.tests[0].src.controller);if(!!M){const x=F.tests.map(({testId:ne,src:me})=>this.ownedTests.getTestById(ne,me==null?void 0:me.tree)).filter(I.isDefined).map(([ne,me])=>me),G=F.excludeExtIds.map(ne=>this.ownedTests.getTestById(ne)).filter(I.isDefined).filter(([ne,me])=>x.some(Le=>ne.comparePositions(Le,me)===1));if(!!x.length){const X={tests:x.map(ne=>U.unwrap(ne.actual)),exclude:G.map(([,ne])=>U.unwrap(ne.actual)),debug:F.debug};await this.runQueue.enqueueRun({dto:h.fromInternal(F),token:L,extensionId:M.extensionId,req:X,doRun:()=>M.instance.runTests(X,L)})}}}$lookupTest(F){const L=this.ownedTests.getTestById(F.testId);if(!L)return Promise.resolve(void 0);const M=L[1],{actual:x,discoverCts:G,expandLevels:X}=M,ne=Qt(M,["actual","discoverCts","expandLevels"]);return Promise.resolve(ne)}flushCollectionDiffs(){for(const{collection:F}of this.testControllers.values())F.flushDiff()}getInternalTestForReference(F){var L,M;return(M=(L=this.workspaceObservers.getMirroredTestDataByReference(F))!==null&&L!==void 0?L:(0,_.mapFind)(this.testControllers.values(),x=>x.collection.getTestByReference(F)))!==null&&M!==void 0?M:this.textDocumentObservers.getMirroredTestDataByReference(F)}};v=je([Ke(0,p.IExtHostRpcService),Ke(1,o.IExtHostDocumentsAndEditors),Ke(2,u.IExtHostWorkspace)],v),e.ExtHostTesting=v;class P{constructor(F){this.proxy=F,this.state=new Map}enqueueRun(F){let L=this.state.get(F.extensionId);L||(L={queue:[],current:void 0},this.state.set(F.extensionId,L));const M=new k.DeferredPromise,x=()=>{const G=[],X=new Set;L.current={publicReq:F.req,factory:ne=>{const me=new b(ne,F.dto,X,this.proxy);return G.push(me),F.token.onCancellationRequested(()=>me.end()),me}},this.invokeRunner(F.extensionId,F.dto.id,F.doRun,G).finally(()=>M.complete())};return L.queue.push(x),L.queue.length===1&&x(),M.p}createTestRun(F,L,M,x){var G,X;const ne=this.state.get(F);if((ne==null?void 0:ne.current.publicReq)===L)return ne.current.factory(M);const me=h.fromPublic(L),Le=new b(M,me,new Set,this.proxy);return this.proxy.$startedExtensionTestRun({debug:L.debug,exclude:(X=(G=L.exclude)===null||G===void 0?void 0:G.map(We=>We.id))!==null&&X!==void 0?X:[],id:me.id,tests:L.tests.map(We=>We.id),persist:x}),Le.onEnd.wait().then(()=>this.proxy.$finishedExtensionTestRun(me.id)),Le}invokeRunner(F,L,M,x){try{const G=M();return(0,k.isThenable)(G)?G.then(()=>this.handleInvokeResult(F,L,x,void 0)).catch(X=>this.handleInvokeResult(F,L,x,X)):this.handleInvokeResult(F,L,x,void 0)}catch(G){return this.handleInvokeResult(F,L,x,G)}}async handleInvokeResult(F,L,M,x){const G=this.state.get(F);!G||(G.queue.shift(),G.queue.length>0?G.queue[0]():this.state.delete(F),await Promise.all(M.map(X=>X.onEnd.wait())))}}class h{constructor(F,L,M){this.id=F,this.include=L,this.exclude=M}static fromPublic(F){var L,M;return new h((0,f.generateUuid)(),new Set(F.tests.map(x=>x.id)),new Set((M=(L=F.exclude)===null||L===void 0?void 0:L.map(x=>x.id))!==null&&M!==void 0?M:S.Iterable.empty()))}static fromInternal(F){return new h(F.runId,new Set(F.tests.map(L=>L.testId)),new Set(F.excludeExtIds))}isIncluded(F){for(let L=F;L;L=L.parent){if(this.include.has(L.id))return!0;if(this.exclude.has(L.id))return!1}return!0}}class b{constructor(F,L,M,x){this.name=F,n.set(this,void 0),l.set(this,void 0),a.set(this,(0,f.generateUuid)()),s.set(this,void 0),this.onEnd=new k.Barrier,it(this,n,x,"f"),it(this,l,L,"f"),it(this,s,M,"f"),x.$startedTestRunTask(L.id,{id:Ue(this,a,"f"),name:F,running:!0})}setState(F,L,M){Ue(this,l,"f").isIncluded(F)&&(this.ensureTestIsKnown(F),Ue(this,n,"f").$updateTestStateInRun(Ue(this,l,"f").id,Ue(this,a,"f"),F.id,L,M))}appendMessage(F,L){Ue(this,l,"f").isIncluded(F)&&(this.ensureTestIsKnown(F),Ue(this,n,"f").$appendTestMessageInRun(Ue(this,l,"f").id,Ue(this,a,"f"),F.id,E.TestMessage.from(L)))}appendOutput(F){Ue(this,n,"f").$appendOutputToRun(Ue(this,l,"f").id,Ue(this,a,"f"),A.VSBuffer.fromString(F))}end(){Ue(this,n,"f").$finishedTestRunTask(Ue(this,l,"f").id,Ue(this,a,"f")),this.onEnd.open()}ensureTestIsKnown(F){const L=Ue(this,s,"f");if(!L.has(F.id)){const M=[];for(;M.unshift(E.TestItem.from(F)),!(L.has(F.id)||(L.add(F.id),!F.parent));)F=F.parent;Ue(this,n,"f").$addTestsToRun(Ue(this,l,"f").id,M)}}}n=new WeakMap,l=new WeakMap,a=new WeakMap,s=new WeakMap;const R=async(W,F,L,M)=>{if(!!L){const x=await W.createWorkspaceTestRoot(L,M);if(!!x){M.onCancellationRequested(()=>{U.removeFilter(F)});const G=U.getWrapperForTestItem(x,F);return G.refreshMatch(),G}}};e.createDefaultDocumentTestRoot=R;class U extends m.TestItemImpl{constructor(F,L,M){super(F.id,F.label,F.uri,void 0);if(this.actual=F,this.filterDocument=L,this.actualParent=M,!(F instanceof m.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${F.id} did not`);this.debuggable=F.debuggable,this.runnable=F.runnable,this.description=F.description,this.error=F.error,this.status=F.status,this.range=F.range,this.resolveHandler=F.resolveHandler;const x=(0,g.getPrivateApiFor)(this);(0,g.getPrivateApiFor)(F).bus.event(X=>{switch(X[0]){case 3:this[X[1]]=X[2];break;case 0:const ne=U.getWrapperForTestItem(X[1],this.filterDocument,this);(0,g.getPrivateApiFor)(ne).parent=F,ne.refreshMatch();break;default:x.bus.fire(X)}})}static removeFilter(F){this.wrapperMap.delete(F)}static getWrapperForTestItem(F,L,M){let x=this.wrapperMap.get(L);if(x==null?void 0:x.has(F))return x.get(F);x||(x=new WeakMap,this.wrapperMap.set(L,x));const G=new U(F,L,M);return x.set(F,G),G}static unwrap(F){return F instanceof U?F.actual:F}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var F,L;const M=this._cachedMatchesFilter;for(const G of this.actual.children.values()){const X=U.getWrapperForTestItem(G,this.filterDocument,this);X.hasNodeMatchingFilter?this.children.has(X.id)||this.addChild(X):X.dispose()}const x=this.children.size>0||((F=this.actual.uri)===null||F===void 0?void 0:F.toString())===this.filterDocument.uri.toString();return this._cachedMatchesFilter=x,x!==M&&((L=this.actualParent)===null||L===void 0||L.refreshMatch()),this._cachedMatchesFilter}dispose(){this.actualParent&&(0,g.getPrivateApiFor)(this.actualParent).children.delete(this.id),(0,g.getPrivateApiFor)(this).bus.fire([1])}}e.TestItemFilteredWrapper=U,U.wrapperMap=new WeakMap;class K extends t.IncrementalChangeCollector{constructor(F){super();this.emitter=F,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(F){this.added.add(F)}update(F){Object.assign(F.revived,E.TestItem.toPlain(F.item)),this.added.has(F)||this.updated.add(F)}remove(F){if(this.added.has(F)){this.added.delete(F);return}if(this.updated.delete(F),F.parent&&this.alreadyRemoved.has(F.parent)){this.alreadyRemoved.add(F.item.extId);return}this.removed.add(F)}getChangeEvent(){const{added:F,updated:L,removed:M}=this;return{get added(){return[...F].map(x=>x.revived)},get updated(){return[...L].map(x=>x.revived)},get removed(){return[...M].map(x=>x.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class he extends t.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new y.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(F){let L=[];for(const M of F){const x=this.items.get(M);x&&L.push(x.revived)}return L}getMirroredTestDataById(F){return this.items.get(F)}getMirroredTestDataByReference(F){return this.items.get(F.id)}createItem(F,L){return Object.assign(Object.assign({},F),{revived:E.TestItem.toPlain(F.item),depth:L?L.depth+1:0,children:new Set})}createChangeCollector(){return new K(this.changeEmitter)}}e.MirroredTestCollection=he;class V{constructor(){this.resources=new Map}checkout(F){var L,M;const x=F.toString(),G=(L=this.resources.get(x))!==null&&L!==void 0?L:this.createObserverData(F);return(M=G.pendingDeletion)===null||M===void 0||M.dispose(),G.observers++,{onDidChangeTest:G.tests.onDidChangeTests,onDidDiscoverInitialTests:new y.Emitter().event,get tests(){return G.tests.rootTestItems},dispose:(0,D.once)(()=>{--G.observers||(G.pendingDeletion=this.eventuallyDispose(F))})}}getMirroredTestDataByReference(F){for(const{tests:L}of this.resources.values()){const M=L.getMirroredTestDataByReference(F);if(M)return M}}eventuallyDispose(F){return(0,k.disposableTimeout)(()=>this.unlisten(F),10*1e3)}createObserverData(F){const L=new he,M=this.listen(F,G=>L.apply(G)),x={observers:0,tests:L,listener:M};return this.resources.set(F.toString(),x),x}unlisten(F){var L;const M=F.toString(),x=this.resources.get(M);x&&(x.observers=-1,(L=x.pendingDeletion)===null||L===void 0||L.dispose(),x.listener.dispose(),this.resources.delete(M))}}class H extends V{constructor(F){super();this.proxy=F,this.diffListeners=new Map}acceptDiff(F,L){var M;(M=this.diffListeners.get(F.toString()))===null||M===void 0||M(L)}listen(F,L){this.proxy.$subscribeToDiffs(0,F);const M=F.toString();return this.diffListeners.set(M,L),new m.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,F),this.diffListeners.delete(M)})}}class Y extends V{constructor(F,L){super();this.proxy=F,this.documents=L,this.diffListeners=new Map}acceptDiff(F,L){var M;(M=this.diffListeners.get(F.toString()))===null||M===void 0||M(L)}listen(F,L){if(!this.documents.getDocument(F))return new m.Disposable(()=>{});const x=F.toString();return this.diffListeners.set(x,L),this.proxy.$subscribeToDiffs(1,F),new m.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,F),this.diffListeners.delete(x)})}}}),define(ve[219],be([0,1,15,51,28,58,22,19,13,25,8,10,2,116,140,92,48,174,217,41]),function(J,e,_,k,A,T,y,D,S,C,i,I,d,f,r,o,p,g,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let u=class{constructor(P,h,b,R){this.configurationService=P,this.workspaceContextService=h,this.editorGroupsService=b,this.pathService=R}text(P,h,b={}){P=this.getContentPattern(P,b);const R=this.configurationService.getValue(),U=h&&h.some(he=>!this.configurationService.getValue({resource:he}).search.useRipgrep),K=this.commonQuery(h==null?void 0:h.map(p.toWorkspaceFolder),b);return Object.assign(Object.assign({},K),{type:2,contentPattern:P,previewOptions:b.previewOptions,maxFileSize:b.maxFileSize,usePCRE2:R.search.usePCRE2||U||!1,beforeContext:b.beforeContext,afterContext:b.afterContext,userDisabledExcludesAndIgnoreFiles:b.disregardExcludeSettings&&b.disregardIgnoreFiles})}getContentPattern(P,h){const b=this.configurationService.getValue();P.isRegExp&&(P.pattern=P.pattern.replace(/\r?\n/g,"\\n"));const R=Object.assign(Object.assign({},P),{wordSeparators:b.editor.wordSeparators});return this.isCaseSensitive(P,h)&&(R.isCaseSensitive=!0),this.isMultiline(P)&&(R.isMultiline=!0),R}file(P,h={}){const b=this.commonQuery(P,h);return Object.assign(Object.assign({},b),{type:1,filePattern:h.filePattern?h.filePattern.trim():h.filePattern,exists:h.exists,sortByScore:h.sortByScore,cacheKey:h.cacheKey})}handleIncludeExclude(P,h){return P?(P=Array.isArray(P)?P.map(a):a(P),h?this.parseSearchPaths(P):{pattern:t(...Array.isArray(P)?P:[P])}):{}}commonQuery(P=[],h={}){const b=this.handleIncludeExclude(h.includePattern,h.expandPatterns),R=this.handleIncludeExclude(h.excludePattern,h.expandPatterns),U=P.length>1,K=(b.searchPaths&&b.searchPaths.length?b.searchPaths.map(H=>this.getFolderQueryForSearchPath(H,h,R)):P.map(H=>this.getFolderQueryForRoot(H,h,R,U))).filter(H=>!!H),he={_reason:h._reason,folderQueries:K,usingSearchPaths:!!(b.searchPaths&&b.searchPaths.length),extraFileResources:h.extraFileResources,excludePattern:R.pattern,includePattern:b.pattern,onlyOpenEditors:h.onlyOpenEditors,maxResults:h.maxResults};if(h.onlyOpenEditors){const Y=_.coalesce(_.flatten(this.editorGroupsService.groups.map(F=>F.editors.map(L=>L.resource)))).filter(F=>(0,m.pathIncludedInQuery)(he,F.fsPath)),W=this.commonQueryFromFileList(Y);return Object.assign(Object.assign({},he),W)}const V=h.extraFileResources&&h.extraFileResources.filter(H=>(0,m.pathIncludedInQuery)(he,H.fsPath));return he.extraFileResources=V&&V.length?V:void 0,he}commonQueryFromFileList(P){const h=[],b=new y.ResourceMap,R={};let U=!1;return P.forEach(K=>{var he,V;if(K.scheme!==D.Schemas.walkThrough)if((0,C.isAbsolutePath)(K)){const Y=(V=(he=this.workspaceContextService.getWorkspaceFolder(K))===null||he===void 0?void 0:he.uri)!==null&&V!==void 0?V:K.with({path:S.dirname(K.fsPath)});let W=b.get(Y);W||(U=!0,W={folder:Y,includePattern:{}},h.push(W),b.set(Y,W));const F=S.relative(Y.fsPath,K.fsPath);(0,I.assertIsDefined)(W.includePattern)[F.replace(/\\/g,"/")]=!0}else K.fsPath&&(U=!0,R[K.fsPath]=!0)}),{folderQueries:h,includePattern:R,usingSearchPaths:!0,excludePattern:U?void 0:{"**/*":!0}}}isCaseSensitive(P,h){if(h.isSmartCase){if(P.isRegExp){if(i.containsUppercaseCharacter(P.pattern,!0))return!0}else if(i.containsUppercaseCharacter(P.pattern))return!0}return!!P.isCaseSensitive}isMultiline(P){return P.isMultiline||P.isRegExp&&(0,f.isMultilineRegexSource)(P.pattern)||P.pattern.indexOf(`
`)>=0?!0:!!P.isMultiline}parseSearchPaths(P){const h=W=>S.isAbsolute(W)||/^\.\.?([\/\\]|$)/.test(W),R=(Array.isArray(P)?P:n(P)).map(W=>{const F=this.pathService.resolvedUserHome;return F?(0,T.untildify)(W,F.scheme===D.Schemas.file?F.fsPath:F.path):W}),U=k.groupBy(R,W=>h(W)?"searchPaths":"exprSegments"),K=(U.exprSegments||[]).map(W=>i.rtrim(W,"/")).map(W=>i.rtrim(W,"\\")).map(W=>(W[0]==="."&&(W="*"+W),l(W))),he={},V=this.expandSearchPathPatterns(U.searchPaths||[]);V&&V.length&&(he.searchPaths=V);const H=_.flatten(K),Y=t(...H);return Y&&(he.pattern=Y),he}getExcludesForFolder(P,h){return h.disregardExcludeSettings?void 0:(0,m.getExcludes)(P,!h.disregardSearchExcludeSettings)}expandSearchPathPatterns(P){if(!P||!P.length)return[];const h=_.flatten(P.map(R=>{let{pathPortion:U,globPortion:K}=w(R);K&&(K=s(K));const he=this.expandOneSearchPath(U);return _.flatten(he.map(V=>this.resolveOneSearchPathPattern(V,K)))})),b=new Map;return h.forEach(R=>{const U=R.searchPath.toString(),K=b.get(U);K?R.pattern&&(K.pattern=K.pattern||{},K.pattern[R.pattern]=!0):b.set(U,{searchPath:R.searchPath,pattern:R.pattern?t(R.pattern):void 0})}),Array.from(b.values())}expandOneSearchPath(P){if(S.isAbsolute(P)){const h=this.workspaceContextService.getWorkspace().folders;return h[0]&&h[0].uri.scheme!==D.Schemas.file?[{searchPath:h[0].uri.with({path:P})}]:[{searchPath:d.URI.file(S.normalize(P))}]}if(this.workspaceContextService.getWorkbenchState()===2){const h=this.workspaceContextService.getWorkspace().folders[0].uri;if(P=a(P),P.startsWith("../")||P===".."){const R=S.posix.resolve(h.path,P);return[{searchPath:h.with({path:R})}]}const b=s(P);return[{searchPath:h,pattern:b}]}else{if(P==="./"||P===".\\")return[];{const h=P.replace(/^\.[\/\\]/,""),R=this.workspaceContextService.getWorkspace().folders.map(U=>{const K=h.match(new RegExp(`^${U.name}(?:/(.*))?`));return K?{match:K,folder:U}:null}).filter(I.isDefined);if(R.length)return R.map(U=>{const K=U.match[1];return{searchPath:U.folder.uri,pattern:K&&s(K)}});{const U=P.match(/\.[\/\\](.+)[\/\\]?/),K=U?U[1]:P,he=r.localize(0,null,K);throw new Error(he)}}}}resolveOneSearchPathPattern(P,h){const b=P.pattern&&h?`${P.pattern}/${h}`:P.pattern||h,R=[{searchPath:P.searchPath,pattern:b}];return b&&!b.endsWith("**")&&R.push({searchPath:P.searchPath,pattern:b+"/**"}),R}getFolderQueryForSearchPath(P,h,b){const R=this.getFolderQueryForRoot((0,p.toWorkspaceFolder)(P.searchPath),h,b,!1);return R?Object.assign(Object.assign({},R),{includePattern:P.pattern}):null}getFolderQueryForRoot(P,h,b,R){let U;const K=d.URI.isUri(P)?P:P.uri;if(b.searchPaths){const W=b.searchPaths.filter(F=>(0,C.isEqual)(F.searchPath,K))[0];if(W&&!W.pattern)return null;W&&(U=W.pattern)}const he=this.configurationService.getValue({resource:K}),V=this.getExcludesForFolder(he,h),H=Object.assign(Object.assign({},V||{}),U||{}),Y=d.URI.isUri(P)?(0,C.basename)(P):P.name;return{folder:K,folderName:R?Y:void 0,excludePattern:Object.keys(H).length>0?H:void 0,fileEncoding:he.files&&he.files.encoding,disregardIgnoreFiles:typeof h.disregardIgnoreFiles=="boolean"?h.disregardIgnoreFiles:!he.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof h.disregardGlobalIgnoreFiles=="boolean"?h.disregardGlobalIgnoreFiles:!he.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof h.ignoreSymlinks=="boolean"?h.ignoreSymlinks:!he.search.followSymlinks}}};u=je([Ke(0,o.IConfigurationService),Ke(1,p.IWorkspaceContextService),Ke(2,g.IEditorGroupsService),Ke(3,E.IPathService)],u),e.QueryBuilder=u;function w(v){const P=v.match(/[\*\{\}\(\)\[\]\?]/);if(P){const h=P.index,b=v.substr(0,h).match(/[/|\\][^/\\]*$/);if(b){let R=v.substr(0,b.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:v.substr((b.index||0)+1)}}}return{pathPortion:v}}function t(...v){return v.length?v.reduce((P,h)=>(P[h]=!0,P),Object.create(null)):void 0}function n(v){return A.splitGlobAware(v,",").map(P=>P.trim()).filter(P=>!!P.length)}function l(v){return[`**/${v}/**`,`**/${v}`].map(h=>h.replace(/\*\*\/\*\*/g,"**"))}function a(v){return v.replace(/\\/g,"/")}function s(v){return a(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function c(v,P){v=_.distinct(v,R=>R.toString());const h=[],b=P.getWorkspace();return v&&v.forEach(R=>{let U;if(P.getWorkbenchState()===2)U=(0,C.relativePath)(b.folders[0].uri,R),U&&U!=="."&&(U="./"+U);else{const K=P.getWorkspaceFolder(R);if(K){const he=K.name;if(b.folders.filter(H=>H.name===he).length===1){const H=(0,C.relativePath)(K.uri,R);H===""?U=`./${K.name}`:U=`./${K.name}/${H}`}else U=R.fsPath}}U&&h.push(U)}),h}e.resolveResourcesForSearchIncludes=c}),define(ve[220],be([0,1,25,2,20,12,4,219,41,48]),function(J,e,_,k,A,T,y,D,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const i=7e3;function I(o,p){const g=p.activationEvents;if(!g)return Promise.resolve(void 0);const E=[],m=[];for(const a of g)if(/^workspaceContains:/.test(a)){const s=a.substr("workspaceContains:".length);s.indexOf("*")>=0||s.indexOf("?")>=0||o.forceUsingSearch?m.push(s):E.push(s)}if(E.length===0&&m.length===0)return Promise.resolve(void 0);let u;const w=new Promise((a,s)=>{u=a}),t=a=>u({activationEvent:a}),n=Promise.all(E.map(a=>d(o,a,t))).then(()=>{}),l=f(o,p.identifier,m,t);return Promise.all([n,l]).then(()=>{u(void 0)}),w}e.checkActivateWorkspaceContainsExtension=I;async function d(o,p,g){for(const E of o.folders)if(await o.exists(_.joinPath(k.URI.revive(E),p))){g(`workspaceContains:${p}`);return}}async function f(o,p,g,E){if(g.length===0)return Promise.resolve(void 0);const m=new A.CancellationTokenSource,u=o.checkExists(o.folders,g,m.token),w=setTimeout(async()=>{m.cancel(),E(`workspaceContainsTimeout:${g.join(",")}`)},i);let t=!1;try{t=await u}catch(n){T.isPromiseCanceledError(n)||T.onUnexpectedError(n)}m.dispose(),clearTimeout(w),t&&E(`workspaceContains:${g.join(",")}`)}function r(o,p,g,E){const m=o.get(y.IInstantiationService),u=o.get(S.ISearchService),t=m.createInstance(D.QueryBuilder).file(p.map(n=>(0,C.toWorkspaceFolder)(k.URI.revive(n))),{_reason:"checkExists",includePattern:g,exists:!0});return u.fileSearch(t,E).then(n=>!!n.limitHit,n=>T.isPromiseCanceledError(n)?!1:Promise.reject(n))}e.checkGlobFileExists=r});var it=this&&this.__classPrivateFieldSet||function(J,e,_,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!A:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(J,_):A?A.value=_:e.set(J,_),_},Ue=this&&this.__classPrivateFieldGet||function(J,e,_,k){if(_==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?k:_==="a"?k.call(J):k?k.value:e.get(J)};define(ve[35],be([0,1,132,13,80,25,11,6,22,2,18,5,34,185,78,30,33,183,12,26,24,161,7,67,4,27,79,14,65,70,40,3,220,74,162]),function(J,e,_,k,A,T,y,D,S,C,i,I,d,f,r,o,p,g,E,m,u,w,t,n,l,a,s,c,v,P,h,b,R,U,K){"use strict";var he,V,H;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,l.createDecorator)("IHostUtils");let Y=class Ln extends D.Disposable{constructor(M,x,G,X,ne,me,Le,We,Fe,ze){super();this._onDidChangeRemoteConnectionData=this._register(new b.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=x,this._extHostContext=G,this._initData=Le,this._extHostWorkspace=X,this._extHostConfiguration=ne,this._logService=me,this._extHostTunnelService=Fe,this._extHostTerminalService=ze,this._disposables=new D.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new y.Barrier,this._readyToStartExtensionHost=new y.Barrier,this._readyToRunExtensions=new y.Barrier,this._eagerExtensionsActivated=new y.Barrier,this._registry=new g.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new r.ExtHostStorage(this._extHostContext),this._secretState=new U.ExtHostSecretState(this._extHostContext),this._storagePath=We,this._instaService=M.createChild(new v.ServiceCollection([r.IExtHostStorage,this._storage],[U.IExtHostSecretState,this._secretState]));const $=new Set;this._initData.hostExtensions.forEach(j=>$.add(m.ExtensionIdentifier.toKey(j))),this._activator=new f.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(j,te,oe)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(j,E.transformErrorForSerialization(te),oe)},actualActivateExtension:async(j,te)=>{if($.has(m.ExtensionIdentifier.toKey(j)))return await this._mainThreadExtensionsProxy.$activateExtension(j,te),new f.HostExtension;const oe=this._registry.getExtensionDescription(j);return this._activateExtension(oe,te)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),A.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(M){E.onUnexpectedError(M)}}async deactivateAll(){let M=[];try{M=this._registry.getAllExtensionDescriptions().map(ne=>ne.identifier).filter(ne=>this.isActivated(ne)).map(ne=>this._deactivate(ne))}catch(x){}await Promise.all(M)}isActivated(M){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(M):!1}_activateByEvent(M,x){return this._activator.activateByEvent(M,x)}_activateById(M,x){return this._activator.activateById(M,x)}activateByIdWithErrors(M,x){return this._activateById(M,x).then(()=>{const G=this._activator.getActivatedExtension(M);if(G.activationFailed)return Promise.reject(G.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(M=>this._registry)}getExtensionExports(M){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(M).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const M=S.TernarySearchTree.forPaths(),x=this._registry.getAllExtensionDescriptions().map(G=>{if(!!this._getEntryPoint(G))return this._hostUtils.realpath(G.extensionLocation.fsPath).then(X=>M.set(C.URI.file(X).fsPath,G))});this._extensionPathIndex=Promise.all(x).then(()=>M)}return this._extensionPathIndex}_deactivate(M){let x=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(M))return x;const G=this._activator.getActivatedExtension(M);if(!G)return x;try{typeof G.module.deactivate=="function"&&(x=Promise.resolve(G.module.deactivate()).then(void 0,X=>Promise.resolve(void 0)))}catch(X){}try{(0,D.dispose)(G.subscriptions)}catch(X){}return x}async _activateExtension(M,x){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier),this._doActivateExtension(M,x).then(G=>{const X=G.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(M.identifier,X.codeLoadingTime,X.activateCallTime,X.activateResolvedTime,x),this._logExtensionActivationTimes(M,x,"success",X),G},G=>{throw this._logExtensionActivationTimes(M,x,"failure"),G})}_logExtensionActivationTimes(M,x,G,X){const ne=W(M,x);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},ne),X||{}),{outcome:G}))}_doActivateExtension(M,x){const G=W(M,x);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",G);const X=this._getEntryPoint(M);if(!X)return Promise.resolve(new f.EmptyExtension(f.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${M.identifier.value} ${JSON.stringify(x)}`),this._logService.flush();const ne=new f.ExtensionActivationTimesBuilder(x.startup);return Promise.all([this._loadCommonJSModule(M.identifier,(0,T.joinPath)(M.extensionLocation,X),ne),this._loadExtensionContext(M)]).then(me=>(A.mark(`code/extHost/willActivateExtension/${M.identifier.value}`),Ln._callActivate(this._logService,M.identifier,me[0],me[1],ne))).then(me=>(A.mark(`code/extHost/didActivateExtension/${M.identifier.value}`),me))}_loadExtensionContext(M){const x=new w.ExtensionGlobalMemento(M,this._storage),G=new w.ExtensionMemento(M.identifier.value,!1,this._storage),X=new K.ExtensionSecrets(M,this._secretState),ne=M.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,me=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${M.identifier.value}`),Promise.all([x.whenReady,G.whenReady,this._storagePath.whenReady]).then(()=>{const Le=this;let We;return Object.freeze({globalState:x,workspaceState:G,secrets:X,subscriptions:[],get extensionUri(){return M.extensionLocation},get extensionPath(){return M.extensionLocation.fsPath},asAbsolutePath(Fe){return k.join(M.extensionLocation.fsPath,Fe)},get storagePath(){var Fe;return(Fe=Le._storagePath.workspaceValue(M))===null||Fe===void 0?void 0:Fe.fsPath},get globalStoragePath(){return Le._storagePath.globalValue(M).fsPath},get logPath(){return k.join(Le._initData.logsLocation.fsPath,M.identifier.value)},get logUri(){return C.URI.joinPath(Le._initData.logsLocation,M.identifier.value)},get storageUri(){return Le._storagePath.workspaceValue(M)},get globalStorageUri(){return Le._storagePath.globalValue(M)},get extensionMode(){return ne},get extension(){return We===void 0&&(We=new F(Le,M.identifier,M,me)),We},get extensionRuntime(){return(0,p.checkProposedApiEnabled)(M),Le.extensionRuntime},get environmentVariableCollection(){return Le._extHostTerminalService.getEnvironmentVariableCollection(M)}})})}static _callActivate(M,x,G,X,ne){return G=G||{activate:void 0,deactivate:void 0},this._callActivateOptional(M,x,G,X,ne).then(me=>new f.ActivatedExtension(!1,null,ne.build(),G,me,X.subscriptions))}static _callActivateOptional(M,x,G,X,ne){if(typeof G.activate=="function")try{ne.activateCallStart(),M.trace(`ExtensionService#_callActivateOptional ${x.value}`);const me=typeof global=="object"?global:self,Le=G.activate.apply(me,[X]);return ne.activateCallStop(),ne.activateResolveStart(),Promise.resolve(Le).then(We=>(ne.activateResolveStop(),We))}catch(me){return Promise.reject(me)}else return Promise.resolve(G)}_activateOneStartupFinished(M,x){this._activateById(M.identifier,{startup:!1,extensionId:M.identifier,activationEvent:x}).then(void 0,G=>{this._logService.error(G)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(A.getMarks());for(const M of this._registry.getAllExtensionDescriptions())if(M.activationEvents)for(const x of M.activationEvents)x==="onStartupFinished"&&this._activateOneStartupFinished(M,x)}_handleEagerExtensions(){const M=this._activateByEvent("*",!0).then(void 0,ne=>{this._logService.error(ne)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(ne=>this._handleWorkspaceContainsEagerExtensions(ne.added)));const x=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],G=this._handleWorkspaceContainsEagerExtensions(x),X=Promise.all([M,G]).then(()=>{});return Promise.race([X,(0,y.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),X}_handleWorkspaceContainsEagerExtensions(M){return M.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(x=>this._handleWorkspaceContainsEagerExtension(M,x))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(M,x){if(!this.isActivated(x.identifier)){const G=!this._initData.remote.isRemote&&!!this._initData.remote.authority,X={folders:M.map(me=>me.uri),forceUsingSearch:G,exists:me=>this._hostUtils.exists(me.fsPath),checkExists:(me,Le,We)=>this._mainThreadWorkspaceProxy.$checkExists(me,Le,We)},ne=await(0,R.checkActivateWorkspaceContainsExtension)(X,x);if(!!ne)return this._activateById(x.identifier,{startup:!0,extensionId:x.identifier,activationEvent:ne.activationEvent}).then(void 0,me=>this._logService.error(me))}}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(M){throw console.error(M),M}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:M,extensionTestsLocationURI:x}=this._initData.environment;if(!M||!x)throw new Error(_.localize(0,null));const G=await this._loadCommonJSModule(null,x,new f.ExtensionActivationTimesBuilder(!1));if(!G||typeof G.run!="function")throw new Error(_.localize(1,null,x.toString()));return new Promise((X,ne)=>{const me=(Fe,ze)=>{Fe?ne(Fe):X(typeof ze=="number"&&ze>0?1:0)},Le=(0,T.originalFSPath)(x),We=G.run(Le,me);We&&We.then&&We.then(()=>{X(0)}).catch(Fe=>{ne(Fe.toString())})})}async $extensionTestsExit(M){this._logService.info(`extension host terminating: test runner requested exit with code ${M}`),this._logService.info(`exiting with code ${M}`),this._logService.flush(),this._hostUtils.exit(M)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(M,x){return this._resolvers[M]=x,(0,D.toDisposable)(()=>{delete this._resolvers[M]})}async $resolveAuthority(M,x){const G=M.indexOf("+");if(G===-1)throw new Error("Not an authority that can be resolved!");const X=M.substr(0,G);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${X}`,!1);const ne=this._resolvers[X];if(!ne)return{type:"error",error:{code:n.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${X}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(ne)),A.mark(`code/extHost/willResolveAuthority/${X}`);const me=await ne.resolve(M,{resolveAttempt:x});A.mark(`code/extHost/didResolveAuthorityOK/${X}`);const Le={authority:M,host:me.host,port:me.port,connectionToken:me.connectionToken},We={extensionHostEnv:me.extensionHostEnv,trust:me.trust};return{type:"ok",value:{authority:Le,options:We,tunnelInformation:{environmentTunnels:me.environmentTunnels}}}}catch(me){if(A.mark(`code/extHost/didResolveAuthorityError/${X}`),me instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:me._code,message:me._message,detail:me._detail}};throw me}}$startExtensionHost(M){return this._registry.keepOnly(M),this._startExtensionHost()}$activateByEvent(M,x){return x===1?this._activateByEvent(M,!1):this._readyToRunExtensions.wait().then(G=>this._activateByEvent(M,!1))}async $activate(M,x){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(M)?(await this._activateById(M,x),!0):!1}async $deltaExtensions(M,x){M.forEach(X=>X.extensionLocation=C.URI.revive(X.extensionLocation));const G=await this.getExtensionPathIndex();return await Promise.all(x.map(async X=>{const ne=this._registry.getExtensionDescription(X);if(!!ne){const me=await this._hostUtils.realpath(ne.extensionLocation.fsPath);G.delete(C.URI.file(me).fsPath)}})),await Promise.all(M.map(async X=>{const ne=await this._hostUtils.realpath(X.extensionLocation.fsPath);G.set(C.URI.file(ne).fsPath,X)})),this._registry.deltaExtensions(M,x),Promise.resolve(void 0)}async $test_latency(M){return M}async $test_up(M){return M.byteLength}async $test_down(M){let x=u.VSBuffer.alloc(M),G=Math.random()%256;for(let X=0;X<M;X++)x.writeUInt8(G,X);return x}async $updateRemoteConnectionData(M){this._remoteConnectionData=M,this._onDidChangeRemoteConnectionData.fire()}};Y=je([Ke(0,l.IInstantiationService),Ke(1,e.IHostUtils),Ke(2,c.IExtHostRpcService),Ke(3,o.IExtHostWorkspace),Ke(4,d.IExtHostConfiguration),Ke(5,i.ILogService),Ke(6,a.IExtHostInitDataService),Ke(7,s.IExtensionStoragePaths),Ke(8,P.IExtHostTunnelService),Ke(9,h.IExtHostTerminalService)],Y),e.AbstractExtHostExtensionService=Y;function W(L,M){return{id:L.identifier.value,name:L.name,extensionVersion:L.version,publisherDisplayName:L.publisher,activationEvents:L.activationEvents?L.activationEvents.join(","):null,isBuiltin:L.isBuiltin,reason:M.activationEvent,reasonId:M.extensionId.value}}e.IExtHostExtensionService=(0,l.createDecorator)("IExtHostExtensionService");class F{constructor(M,x,G,X){he.set(this,void 0),V.set(this,void 0),H.set(this,void 0),it(this,he,M,"f"),it(this,V,x,"f"),it(this,H,G.identifier,"f"),this.id=G.identifier.value,this.extensionUri=G.extensionLocation,this.extensionPath=k.normalize((0,T.originalFSPath)(G.extensionLocation)),this.packageJSON=G,this.extensionKind=X}get isActive(){return Ue(this,he,"f").isActivated(Ue(this,H,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ue(this,he,"f").getExtensionExports(Ue(this,H,"f"))}activate(){return Ue(this,he,"f").activateByIdWithErrors(Ue(this,H,"f"),{startup:!1,extensionId:Ue(this,V,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=F,he=new WeakMap,V=new WeakMap,H=new WeakMap}),define(ve[104],be([0,1,13,2,3,11,5,7,169,30,35,39,173,34,170,14,4,10,46]),function(J,e,_,k,A,T,y,D,S,C,i,I,d,f,r,o,p,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,p.createDecorator)("IExtHostDebugService");let m=class{constructor(c,v,P,h,b){this._workspaceService=v,this._extensionService=P,this._editorsService=h,this._configurationService=b,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new A.Emitter,this._onDidTerminateDebugSession=new A.Emitter,this._onDidChangeActiveDebugSession=new A.Emitter,this._onDidReceiveDebugSessionCustomEvent=new A.Emitter,this._debugServiceProxy=c.getProxy(y.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new A.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new w(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(R=>{R.onDidChange(U=>{this.registerAllDebugTypes(R)}),this.registerAllDebugTypes(R)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(c,v){const P=c;if(typeof P.sourceReference=="number"&&P.sourceReference>0){let h=`debug:${encodeURIComponent(P.path||"")}`,b="?";return v&&(h+=`${b}session=${encodeURIComponent(v.id)}`,b="&"),h+=`${b}ref=${P.sourceReference}`,k.URI.parse(h)}else{if(P.path)return k.URI.file(P.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(c){const v=[];for(const P of c.getAllExtensionDescriptions())if(P.contributes){const h=P.contributes.debuggers;if(h&&h.length>0)for(const b of h)(0,r.isDebuggerMainContribution)(b)&&v.push(b.type)}this._debugServiceProxy.$registerDebugTypes(v)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const c=[];return this._breakpoints.forEach(v=>c.push(v)),c}addBreakpoints(c){this.startBreakpoints();const v=c.filter(b=>{const R=b.id;return this._breakpoints.has(R)?!1:(this._breakpoints.set(R,b),!0)});this.fireBreakpointChanges(v,[],[]);const P=[],h=new Map;for(const b of v)if(b instanceof D.SourceBreakpoint){let R=h.get(b.location.uri.toString());R||(R={type:"sourceMulti",uri:b.location.uri,lines:[]},h.set(b.location.uri.toString(),R),P.push(R)),R.lines.push({id:b.id,enabled:b.enabled,condition:b.condition,hitCondition:b.hitCondition,logMessage:b.logMessage,line:b.location.range.start.line,character:b.location.range.start.character})}else b instanceof D.FunctionBreakpoint&&P.push({type:"function",id:b.id,enabled:b.enabled,hitCondition:b.hitCondition,logMessage:b.logMessage,condition:b.condition,functionName:b.functionName});return this._debugServiceProxy.$registerBreakpoints(P)}removeBreakpoints(c){this.startBreakpoints();const v=c.filter(R=>this._breakpoints.delete(R.id));this.fireBreakpointChanges([],v,[]);const P=v.filter(R=>R instanceof D.SourceBreakpoint).map(R=>R.id),h=v.filter(R=>R instanceof D.FunctionBreakpoint).map(R=>R.id),b=v.filter(R=>R instanceof D.DataBreakpoint).map(R=>R.id);return this._debugServiceProxy.$unregisterBreakpoints(P,h,b)}startDebugging(c,v,P){return this._debugServiceProxy.$startDebugging(c?c.uri:void 0,v,{parentSessionID:P.parentSession?P.parentSession.id:void 0,repl:P.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:P.noDebug,compact:P.compact})}stopDebugging(c){return this._debugServiceProxy.$stopDebugging(c?c.id:void 0)}registerDebugConfigurationProvider(c,v,P){if(!v)return new D.Disposable(()=>{});const h=this._configProviderHandleCounter++;return this._configProviders.push({type:c,handle:h,provider:v}),this._debugServiceProxy.$registerDebugConfigurationProvider(c,P,!!v.provideDebugConfigurations,!!v.resolveDebugConfiguration,!!v.resolveDebugConfigurationWithSubstitutedVariables,h),new D.Disposable(()=>{this._configProviders=this._configProviders.filter(b=>b.provider!==v),this._debugServiceProxy.$unregisterDebugConfigurationProvider(h)})}registerDebugAdapterDescriptorFactory(c,v,P){if(!P)return new D.Disposable(()=>{});if(!this.definesDebugType(c,v))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${v}' debugger.`);if(this.getAdapterDescriptorFactoryByType(v))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const h=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:v,handle:h,factory:P}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(v,h),new D.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(b=>b.factory!==P),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(h)})}registerDebugAdapterTrackerFactory(c,v){if(!v)return new D.Disposable(()=>{});const P=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:c,handle:P,factory:v}),new D.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(h=>h.factory!==v)})}async $runInTerminal(c,v){return Promise.resolve(void 0)}async $substituteVariables(c,v){if(!this._variableResolver){const[b,R]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(b||[],this._editorsService,R)}let P;const h=await this.getFolder(c);return h&&(P={uri:h.uri,name:h.name,index:h.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(P,v)}createDebugAdapter(c,v){if(c.type==="implementation")return new l(c.implementation)}createSignService(){}async $startDASession(c,v){const P=this,h=await this.getSession(v);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(h.type),h).then(b=>{if(!b)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${h.type}' (extension might have failed to activate)`);const R=this.convertToDto(b),U=this.createDebugAdapter(R,h);if(!U)throw new Error(`Couldn't create a debug adapter for type '${h.type}'.`);const K=U;return this._debugAdapters.set(c,K),this.getDebugAdapterTrackers(h).then(he=>(he&&this._debugAdaptersTrackers.set(c,he),K.onMessage(async V=>{if(V.type==="request"&&V.command==="handshake"){const H=V,Y={type:"response",seq:0,command:H.command,request_seq:H.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const W=await this._signService.sign(H.arguments.value);Y.body={signature:W},K.sendResponse(Y)}else throw new Error("no signer")}catch(W){Y.success=!1,Y.message=W.message,K.sendResponse(Y)}}else he&&he.onDidSendMessage&&he.onDidSendMessage(V),V=(0,r.convertToVSCPaths)(V,!0),P._debugServiceProxy.$acceptDAMessage(c,V)}),K.onError(V=>{he&&he.onError&&he.onError(V),this._debugServiceProxy.$acceptDAError(c,V.name,V.message,V.stack)}),K.onExit(V=>{he&&he.onExit&&he.onExit((0,g.withNullAsUndefined)(V),void 0),this._debugServiceProxy.$acceptDAExit(c,(0,g.withNullAsUndefined)(V),void 0)}),he&&he.onWillStartSession&&he.onWillStartSession(),K.startSession()))})}$sendDAMessage(c,v){v=(0,r.convertToDAPaths)(v,!1);const P=this._debugAdaptersTrackers.get(c);P&&P.onWillReceiveMessage&&P.onWillReceiveMessage(v);const h=this._debugAdapters.get(c);h&&h.sendMessage(v)}$stopDASession(c){const v=this._debugAdaptersTrackers.get(c);this._debugAdaptersTrackers.delete(c),v&&v.onWillStopSession&&v.onWillStopSession();const P=this._debugAdapters.get(c);return this._debugAdapters.delete(c),P?P.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(c){const v=[],P=[],h=[];if(c.added)for(const b of c.added){const R=b.id;if(R&&!this._breakpoints.has(R)){let U;if(b.type==="function")U=new D.FunctionBreakpoint(b.functionName,b.enabled,b.condition,b.hitCondition,b.logMessage);else if(b.type==="data")U=new D.DataBreakpoint(b.label,b.dataId,b.canPersist,b.enabled,b.hitCondition,b.condition,b.logMessage);else{const K=k.URI.revive(b.uri);U=new D.SourceBreakpoint(new D.Location(K,new D.Position(b.line,b.character)),b.enabled,b.condition,b.hitCondition,b.logMessage)}U._id=R,this._breakpoints.set(R,U),v.push(U)}}if(c.removed)for(const b of c.removed){const R=this._breakpoints.get(b);R&&(this._breakpoints.delete(b),P.push(R))}if(c.changed){for(const b of c.changed)if(b.id){const R=this._breakpoints.get(b.id);if(R){if(R instanceof D.FunctionBreakpoint&&b.type==="function"){const U=R;U.enabled=b.enabled,U.condition=b.condition,U.hitCondition=b.hitCondition,U.logMessage=b.logMessage,U.functionName=b.functionName}else if(R instanceof D.SourceBreakpoint&&b.type==="source"){const U=R;U.enabled=b.enabled,U.condition=b.condition,U.hitCondition=b.hitCondition,U.logMessage=b.logMessage,U.location=new D.Location(k.URI.revive(b.uri),new D.Position(b.line,b.character))}h.push(R)}}}this.fireBreakpointChanges(v,P,h)}$provideDebugConfigurations(c,v,P){return(0,T.asPromise)(async()=>{const h=this.getConfigProviderByHandle(c);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const b=await this.getFolder(v);return h.provideDebugConfigurations(b,P)}).then(h=>{if(!h)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return h})}$resolveDebugConfiguration(c,v,P,h){return(0,T.asPromise)(async()=>{const b=this.getConfigProviderByHandle(c);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const R=await this.getFolder(v);return b.resolveDebugConfiguration(R,P,h)})}$resolveDebugConfigurationWithSubstitutedVariables(c,v,P,h){return(0,T.asPromise)(async()=>{const b=this.getConfigProviderByHandle(c);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const R=await this.getFolder(v);return b.resolveDebugConfigurationWithSubstitutedVariables(R,P,h)})}async $provideDebugAdapter(c,v){const P=this.getAdapterDescriptorFactoryByHandle(c);if(!P)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const h=await this.getSession(v);return this.getAdapterDescriptor(P,h).then(b=>{if(!b)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${h.type}'`);return this.convertToDto(b)})}async $acceptDebugSessionStarted(c){const v=await this.getSession(c);this._onDidStartDebugSession.fire(v)}async $acceptDebugSessionTerminated(c){const v=await this.getSession(c);v&&(this._onDidTerminateDebugSession.fire(v),this._debugSessions.delete(v.id))}async $acceptDebugSessionActiveChanged(c){this._activeDebugSession=c?await this.getSession(c):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(c,v){const P=await this.getSession(c);P&&P._acceptNameChanged(v)}async $acceptDebugSessionCustomEvent(c,v){const h={session:await this.getSession(c),event:v.event,body:v.body};this._onDidReceiveDebugSessionCustomEvent.fire(h)}convertToDto(c){if(c instanceof D.DebugAdapterExecutable)return{type:"executable",command:c.command,args:c.args,options:c.options};if(c instanceof D.DebugAdapterServer)return{type:"server",port:c.port,host:c.host};if(c instanceof D.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:c.path};if(c instanceof D.DebugAdapterInlineImplementation)return{type:"implementation",implementation:c.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(c){const v=this._adapterFactories.filter(P=>P.type===c);if(v.length>0)return v[0].factory}getAdapterDescriptorFactoryByHandle(c){const v=this._adapterFactories.filter(P=>P.handle===c);if(v.length>0)return v[0].factory}getConfigProviderByHandle(c){const v=this._configProviders.filter(P=>P.handle===c);if(v.length>0)return v[0].provider}definesDebugType(c,v){if(c.contributes){const P=c.contributes.debuggers;if(P&&P.length>0){for(const h of P)if(h.label&&h.type&&h.type===v)return!0}}return!1}getDebugAdapterTrackers(c){const P=c.configuration.type,h=this._trackerFactories.filter(b=>b.type===P||b.type==="*").map(b=>(0,T.asPromise)(()=>b.factory.createDebugAdapterTracker(c)).then(R=>R,R=>null));return Promise.race([Promise.all(h).then(b=>{const R=b.filter(U=>!!U);if(R.length>0)return new n(R)}),new Promise((b,R)=>{const U=setTimeout(()=>{clearTimeout(U),R(new Error("timeout"))},1e3)})]).catch(b=>{})}async getAdapterDescriptor(c,v){const P=v.configuration.debugServer;if(typeof P=="number")return Promise.resolve(new D.DebugAdapterServer(P));if(c){const b=await this._extensionService.getExtensionRegistry();return(0,T.asPromise)(()=>c.createDebugAdapterDescriptor(v,this.daExecutableFromPackage(v,b))).then(R=>{if(R)return R})}const h=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(v,h))}daExecutableFromPackage(c,v){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(c,v,P){(c.length>0||v.length>0||P.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:c,removed:v,changed:P}))}async getSession(c){if(c)if(typeof c=="string"){const v=this._debugSessions.get(c);if(v)return v}else{let v=this._debugSessions.get(c.id);if(!v){const P=await this.getFolder(c.folderUri);v=new u(this._debugServiceProxy,c.id,c.type,c.name,P,c.configuration),this._debugSessions.set(v.id,v),this._debugServiceProxy.$sessionCached(v.id)}return v}throw new Error("cannot find session")}getFolder(c){if(c){const v=k.URI.revive(c);return this._workspaceService.resolveWorkspaceFolder(v)}return Promise.resolve(void 0)}};m=je([Ke(0,o.IExtHostRpcService),Ke(1,C.IExtHostWorkspace),Ke(2,i.IExtHostExtensionService),Ke(3,I.IExtHostDocumentsAndEditors),Ke(4,f.IExtHostConfiguration)],m),e.ExtHostDebugServiceBase=m;class u{constructor(c,v,P,h,b,R){this._debugServiceProxy=c,this._id=v,this._type=P,this._name=h,this._workspaceFolder=b,this._configuration=R}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(c){this._name=c,this._debugServiceProxy.$setDebugSessionName(this._id,c)}_acceptNameChanged(c){this._name=c}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(c,v){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,c,v)}getDebugProtocolBreakpoint(c){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,c.id)}}e.ExtHostDebugSession=u;class w{constructor(c){this.value=Object.freeze({append(v){c.$appendDebugConsole(v)},appendLine(v){this.append(v+`
`)}})}}e.ExtHostDebugConsole=w;class t extends d.AbstractVariableResolverService{constructor(c,v,P,h){super({getFolderUri:b=>{const R=c.filter(U=>U.name===b);if(R&&R.length>0)return R[0].uri},getWorkspaceFolderCount:()=>c.length,getConfigurationValue:(b,R)=>P.getConfiguration(void 0,b).get(R),getAppRoot:()=>E.cwd(),getExecPath:()=>E.env.VSCODE_EXEC_PATH,getFilePath:()=>{if(v){const b=v.activeEditor();if(b)return _.normalize(b.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(v&&h){const b=v.activeEditor();if(b){const R=h.getWorkspaceFolder(b.document.uri);if(R)return _.normalize(R.uri.fsPath)}}},getSelectedText:()=>{if(v){const b=v.activeEditor();if(b&&!b.selection.isEmpty)return b.document.getText(b.selection)}},getLineNumber:()=>{if(v){const b=v.activeEditor();if(b)return String(b.selection.end.line+1)}}},void 0,Promise.resolve(E.env))}}e.ExtHostVariableResolverService=t;class n{constructor(c){this.trackers=c}onWillStartSession(){this.trackers.forEach(c=>c.onWillStartSession?c.onWillStartSession():void 0)}onWillReceiveMessage(c){this.trackers.forEach(v=>v.onWillReceiveMessage?v.onWillReceiveMessage(c):void 0)}onDidSendMessage(c){this.trackers.forEach(v=>v.onDidSendMessage?v.onDidSendMessage(c):void 0)}onWillStopSession(){this.trackers.forEach(c=>c.onWillStopSession?c.onWillStopSession():void 0)}onError(c){this.trackers.forEach(v=>v.onError?v.onError(c):void 0)}onExit(c,v){this.trackers.forEach(P=>P.onExit?P.onExit(c,v):void 0)}}class l extends S.AbstractDebugAdapter{constructor(c){super();this.implementation=c,c.onDidSendMessage(v=>{this.acceptMessage(v)})}startSession(){return Promise.resolve(void 0)}sendMessage(c){this.implementation.handleMessage(c)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let a=class extends m{constructor(c,v,P,h,b){super(c,v,P,h,b)}createVariableResolver(c,v,P){return new t(c,v,P)}};a=je([Ke(0,o.IExtHostRpcService),Ke(1,C.IExtHostWorkspace),Ke(2,i.IExtHostExtensionService),Ke(3,I.IExtHostDocumentsAndEditors),Ke(4,f.IExtHostConfiguration)],a),e.WorkerExtHostDebugService=a}),define(ve[221],be([0,1,80,2,5,34,33,26,14,27,4,35,46,18]),function(J,e,_,k,A,T,y,D,S,C,i,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let r=class{constructor(m,u,w,t,n,l,a){this._apiFactory=m,this._extensionRegistry=u,this._instaService=w,this._extHostConfiguration=t,this._extHostExtensionService=n,this._initData=l,this._logService=a,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),_.mark("code/extHost/willWaitForConfig");const m=await this._extHostConfiguration.getConfigProvider();_.mark("code/extHost/didWaitForConfig");const u=await this._extHostExtensionService.getExtensionPathIndex();this.register(new o(this._apiFactory,u,this._extensionRegistry,m,this._logService)),this.register(this._instaService.createInstance(p)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(g,u,this._initData.environment.appUriScheme))}register(m){if(Array.isArray(m.nodeModuleName))for(let u of m.nodeModuleName)this._factories.set(u,m);else this._factories.set(m.nodeModuleName,m);typeof m.alternativeModuleName=="function"&&this._alternatives.push(u=>m.alternativeModuleName(u))}};r=je([Ke(2,i.IInstantiationService),Ke(3,T.IExtHostConfiguration),Ke(4,I.IExtHostExtensionService),Ke(5,C.IExtHostInitDataService),Ke(6,f.ILogService)],r),e.RequireInterceptor=r;class o{constructor(m,u,w,t,n){this._apiFactory=m,this._extensionPaths=u,this._extensionRegistry=w,this._configProvider=t,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(m,u){const w=this._extensionPaths.findSubstr(u.fsPath);if(w){let t=this._extApiImpl.get(D.ExtensionIdentifier.toKey(w.identifier));return t||(t=this._apiFactory(w,this._extensionRegistry,this._configProvider),this._extApiImpl.set(D.ExtensionIdentifier.toKey(w.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((n,l)=>t+=`	${l} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${u.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(y.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let p=class{constructor(m,u){this.nodeModuleName="keytar";const{environment:w}=u,t=m.getProxy(A.MainContext.MainThreadKeytar);if(w.appRoot){let n=w.appRoot.fsPath;d.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,l)=>t.$getPassword(n,l),setPassword:(n,l,a)=>t.$setPassword(n,l,a),deletePassword:(n,l)=>t.$deletePassword(n,l),findPassword:n=>t.$findPassword(n),findCredentials(n){return t.$findCredentials(n)}}}load(m,u){return this._impl}alternativeModuleName(m){const u=m.length;if(!(u<=7||!this.alternativeNames)){const w=u-7;if((m.charAt(w)==="/"||m.charAt(w)==="\\")&&m.endsWith("keytar")&&(m=m.replace(/\\/g,"/"),this.alternativeNames.has(m)))return"keytar"}}};p=je([Ke(0,S.IExtHostRpcService),Ke(1,C.IExtHostInitDataService)],p);let g=class{constructor(m,u,w){this._extensionPaths=m,this._appUriScheme=u,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=w.getProxy(A.MainContext.MainThreadTelemetry);const t=w.getProxy(A.MainContext.MainThreadWindow);this._impl=(n,l)=>{const a=k.URI.parse(n);return l?this.callOriginal(n,l):a.scheme==="http"||a.scheme==="https"?t.$openUri(a,n,{allowTunneling:!0}):a.scheme==="mailto"||a.scheme===this._appUriScheme?t.$openUri(a,n,{}):this.callOriginal(n,l)}}load(m,u,w){const t=this._extensionPaths.findSubstr(u.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=w(m),this._impl}callOriginal(m,u){return this.sendNoForwardTelemetry(),this._original(m,u)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};g=je([Ke(2,S.IExtHostRpcService)],g)}),define(ve[222],be([0,1,11,12,80,6,2,5,214,18,61,65,27,151,14,71,35,40]),function(J,e,_,k,A,T,y,D,S,C,i,I,d,f,r,o,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class E{constructor(u,w,t,n){this._disposables=new T.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const l=new S.RPCProtocol(u,null,n);w=E._transform(w,l);const a=new I.ServiceCollection(...(0,i.getSingletonServiceDescriptors)());a.set(d.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},w)),a.set(r.IExtHostRpcService,new r.ExtHostRpcService(l)),a.set(o.IURITransformerService,new o.URITransformerService(n)),a.set(p.IHostUtils,t);const s=new f.InstantiationService(a,!0),c=s.invokeFunction(b=>b.get(g.IExtHostTerminalService));this._disposables.add(c),this._logService=s.invokeFunction(b=>b.get(C.ILogService)),A.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",w),this._extensionService=s.invokeFunction(b=>b.get(p.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const v=new WeakMap;this._extensionService.getExtensionPathIndex().then(b=>{Error.prepareStackTrace=(R,U)=>{let K="",he,V;for(const H of U)K+=`
	at ${H.toString()}`,V=H.getFileName(),!he&&V&&(he=b.findSubstr(V));return v.set(R,he),`${R.name||"Error"}: ${R.message||""}${K}`}});const P=l.getProxy(D.MainContext.MainThreadExtensionService),h=l.getProxy(D.MainContext.MainThreadErrors);k.setUnexpectedErrorHandler(b=>{const R=k.transformErrorForSerialization(b),U=v.get(b);U?P.$onExtensionRuntimeError(U.identifier,R):h.$onUnexpectedError(R)})}terminate(u){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${u}`),this._logService.flush(),this._disposables.dispose(),k.setUnexpectedErrorHandler(t=>{});const w=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,_.timeout)(4e3),w]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(u,w){u.extensions.forEach(n=>n.extensionLocation=y.URI.revive(w.transformIncomingURIs(n.extensionLocation))),u.environment.appRoot=y.URI.revive(w.transformIncomingURIs(u.environment.appRoot));const t=u.environment.extensionDevelopmentLocationURI;return t&&(u.environment.extensionDevelopmentLocationURI=t.map(n=>y.URI.revive(w.transformIncomingURIs(n)))),u.environment.extensionTestsLocationURI=y.URI.revive(w.transformIncomingURIs(u.environment.extensionTestsLocationURI)),u.environment.globalStorageHome=y.URI.revive(w.transformIncomingURIs(u.environment.globalStorageHome)),u.environment.workspaceStorageHome=y.URI.revive(w.transformIncomingURIs(u.environment.workspaceStorageHome)),u.logsLocation=y.URI.revive(w.transformIncomingURIs(u.logsLocation)),u.logFile=y.URI.revive(w.transformIncomingURIs(u.logFile)),u.workspace=w.transformIncomingURIs(u.workspace),u}}e.ExtensionHostMain=E}),define(ve[223],be([0,1,13,20,60,28,25,55,41]),function(J,e,_,k,A,T,y,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class C{constructor(d,f,r){this.config=d,this.provider=f,this.sessionToken=r,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=d.filePattern,this.includePattern=d.includePattern&&T.parse(d.includePattern),this.maxResults=d.maxResults||void 0,this.exists=d.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=d.excludePattern&&T.parse(d.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(d=>d.cancel()),this.activeCancellationTokens=new Set}search(d){const f=this.config.folderQueries||[];return new Promise((r,o)=>{const p=g=>{this.resultCount++,d(g)};if(this.isCanceled)return r({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(g=>{const E=g.toString(),m=_.basename(E);this.globalExcludePattern&&this.globalExcludePattern(E,m)||this.matchFile(p,{base:g,basename:m})}),Promise.all(f.map(g=>this.searchInFolder(g,p))).then(g=>{r({limitHit:this.isLimitHit,stats:g[0]||void 0})},g=>{o(new Error((0,A.toErrorMessage)(g)))})})}async searchInFolder(d,f){const r=new k.CancellationTokenSource,o=this.getSearchOptionsForFolder(d),p=this.initDirectoryTree(),g=new S.QueryGlobTester(this.config,d),E=!g.hasSiblingExcludeClauses();let m;try{this.activeCancellationTokens.add(r),m=D.StopWatch.create();const u=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},o,r.token),w=m.elapsed(),t=D.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(u&&u.forEach(n=>{const l=_.posix.relative(d.folder.path,n.path);if(E){const a=_.basename(n.path);this.matchFile(f,{base:d.folder,relativePath:l,basename:a});return}this.addDirectoryEntries(p,d.folder,l,f)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(p,g,f),{providerTime:w,postProcessTime:t.elapsed()})}finally{r.dispose(),this.activeCancellationTokens.delete(r)}}getSearchOptionsForFolder(d){const f=(0,S.resolvePatternsForProvider)(this.config.includePattern,d.includePattern),r=(0,S.resolvePatternsForProvider)(this.config.excludePattern,d.excludePattern);return{folder:d.folder,excludes:r,includes:f,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,followSymlinks:!d.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const d={rootEntries:[],pathToEntries:Object.create(null)};return d.pathToEntries["."]=d.rootEntries,d}addDirectoryEntries({pathToEntries:d},f,r,o){if(r===this.filePattern){const g=_.basename(this.filePattern);this.matchFile(o,{base:f,relativePath:this.filePattern,basename:g})}function p(g){const E=_.basename(g),m=_.dirname(g);let u=d[m];u||(u=d[m]=[],p(m)),u.push({base:f,relativePath:g,basename:E})}p(r)}matchDirectoryTree({rootEntries:d,pathToEntries:f},r,o){const p=this,g=this.filePattern;function E(m){const u=T.hasSiblingFn(()=>m.map(w=>w.basename));for(let w=0,t=m.length;w<t;w++){const n=m[w],{relativePath:l,basename:a}=n;if(!!r.includedInQuerySync(l,a,g!==a?u:void 0)){const s=f[l];if(s)E(s);else{if(l===g)continue;p.matchFile(o,n)}if(p.isLimitHit)break}}}E(d)}matchFile(d,f){(!this.includePattern||f.relativePath&&this.includePattern(f.relativePath,f.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||d(f))}}class i{constructor(){this.sessions=new Map}fileSearch(d,f,r,o){const p=this.getSessionTokenSource(d.cacheKey),g=new C(d,f,p&&p.token);let E=0;const m=u=>{E+=u.length,r(u.map(w=>this.rawMatchToSearchItem(w)))};return this.doSearch(g,i.BATCH_SIZE,m,o).then(u=>({limitHit:u.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:E,detailStats:u.stats}}))}clearCache(d){const f=this.getSessionTokenSource(d);f&&f.cancel()}getSessionTokenSource(d){if(!!d)return this.sessions.has(d)||this.sessions.set(d,new k.CancellationTokenSource),this.sessions.get(d)}rawMatchToSearchItem(d){return d.relativePath?{resource:y.joinPath(d.base,d.relativePath)}:{resource:d.base}}doSearch(d,f,r,o){o.onCancellationRequested(()=>{d.cancel()});const p=E=>{E&&(g.push(E),f>0&&g.length>=f&&(r(g),g=[]))};let g=[];return d.search(p).then(E=>(g.length&&r(g),E),E=>(g.length&&r(g),Promise.reject(E)))}}e.FileSearchManager=i,i.BATCH_SIZE=512}),define(ve[224],be([0,1,13,15,20,60,25,28,2,41,19,10]),function(J,e,_,k,A,T,y,D,S,C,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class d{constructor(m,u,w){this.query=m,this.provider=u,this.fileUtils=w,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(m,u){const w=this.query.folderQueries||[],t=new A.CancellationTokenSource;return u.onCancellationRequested(()=>t.cancel()),new Promise((n,l)=>{this.collector=new r(m);let a=!1;const s=(c,v)=>{if(!a&&!this.isLimitHit){const P=this.resultSize(c);p(c)&&typeof this.query.maxResults=="number"&&this.resultCount+P>this.query.maxResults&&(this.isLimitHit=!0,a=!0,t.cancel(),c=this.trimResultToSize(c,this.query.maxResults-this.resultCount));const h=this.resultSize(c);this.resultCount+=h,(h>0||!p(c))&&this.collector.add(c,v)}};Promise.all(w.map((c,v)=>this.searchInFolder(c,P=>s(P,v),t.token))).then(c=>{t.dispose(),this.collector.flush();const v=c.some(P=>!!P&&!!P.limitHit);n({limitHit:this.isLimitHit||v,messages:(0,k.flatten)(c.map(P=>(P==null?void 0:P.message)?(0,I.isArray)(P.message)?P.message:[P.message]:[])),stats:{type:"textSearchProvider"}})},c=>{t.dispose();const v=(0,T.toErrorMessage)(c);l(new Error(v))})})}resultSize(m){return p(m)?Array.isArray(m.ranges)?m.ranges.length:1:0}trimResultToSize(m,u){const w=Array.isArray(m.ranges)?m.ranges:[m.ranges],t=Array.isArray(m.preview.matches)?m.preview.matches:[m.preview.matches];return{ranges:w.slice(0,u),preview:{matches:t.slice(0,u),text:m.preview.text},uri:m.uri}}async searchInFolder(m,u,w){const t=new C.QueryGlobTester(this.query,m),n=[],l={report:c=>{if(!!this.validateProviderResult(c)){const v=m.folder.scheme===i.Schemas.file?D.hasSiblingPromiseFn(()=>this.fileUtils.readdir(y.dirname(c.uri))):void 0,P=y.relativePath(m.folder,c.uri);P&&n.push(t.includedInQuery(P,_.basename(P),v).then(h=>{h&&u(c)}))}}},a=this.getSearchOptionsForFolder(m),s=await this.provider.provideTextSearchResults(f(this.query.contentPattern),a,l,w);return await Promise.all(n),s}validateProviderResult(m){if(p(m)){if(Array.isArray(m.ranges)){if(!Array.isArray(m.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(m.preview.matches.length!==m.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(m.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(m){const u=(0,C.resolvePatternsForProvider)(this.query.includePattern,m.includePattern),w=(0,C.resolvePatternsForProvider)(this.query.excludePattern,m.excludePattern),t={folder:S.URI.from(m.folder),excludes:w,includes:u,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,followSymlinks:!m.ignoreSymlinks,encoding:m.fileEncoding&&this.fileUtils.toCanonicalName(m.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=d;function f(E){return{isCaseSensitive:E.isCaseSensitive||!1,isRegExp:E.isRegExp||!1,isWordMatch:E.isWordMatch||!1,isMultiline:E.isMultiline||!1,pattern:E.pattern}}class r{constructor(m){this._onResult=m,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new g(512,u=>this.sendItems(u))}add(m,u){this._currentFileMatch&&(this._currentFolderIdx!==u||!y.isEqual(this._currentUri,m.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=u,this._currentFileMatch={resource:m.uri,results:[]}),this._currentFileMatch.results.push(o(m))}pushToCollector(){const m=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,m)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(m){this._onResult(m)}}e.TextSearchResultsCollector=r;function o(E){return p(E)?{preview:{matches:(0,k.mapArrayOrNot)(E.preview.matches,m=>({startLineNumber:m.start.line,startColumn:m.start.character,endLineNumber:m.end.line,endColumn:m.end.character})),text:E.preview.text},ranges:(0,k.mapArrayOrNot)(E.ranges,m=>({startLineNumber:m.start.line,startColumn:m.start.character,endLineNumber:m.end.line,endColumn:m.end.character}))}:{text:E.text,lineNumber:E.lineNumber}}function p(E){return!!E.preview}e.extensionResultIsMatch=p;class g{constructor(m,u){this.maxBatchSize=m,this.cb=u,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(m,u){!m||this.addItemToBatch(m,u)}addItems(m,u){!m||this.addItemsToBatch(m,u)}addItemToBatch(m,u){this.batch.push(m),this.batchSize+=u,this.onUpdate()}addItemsToBatch(m,u){this.batch=this.batch.concat(m),this.batchSize+=u,this.onUpdate()}onUpdate(){this.totalNumberCompleted<g.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},g.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=g,g.TIMEOUT=4e3,g.START_BATCH_AFTER_COUNT=50}),define(ve[105],be([0,1,6,5,4,223,14,71,18,2,224]),function(J,e,_,k,A,T,y,D,S,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,A.createDecorator)("IExtHostSearch");let I=class{constructor(o,p,g){this.extHostRpc=o,this._uriTransformer=p,this._logService=g,this._proxy=this.extHostRpc.getProxy(k.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(o){return this._uriTransformer.transformOutgoingScheme(o)}registerTextSearchProvider(o,p){if(this._textSearchUsedSchemes.has(o))throw new Error(`a text search provider for the scheme '${o}' is already registered`);this._textSearchUsedSchemes.add(o);const g=this._handlePool++;return this._textSearchProvider.set(g,p),this._proxy.$registerTextSearchProvider(g,this._transformScheme(o)),(0,_.toDisposable)(()=>{this._textSearchUsedSchemes.delete(o),this._textSearchProvider.delete(g),this._proxy.$unregisterProvider(g)})}registerFileSearchProvider(o,p){if(this._fileSearchUsedSchemes.has(o))throw new Error(`a file search provider for the scheme '${o}' is already registered`);this._fileSearchUsedSchemes.add(o);const g=this._handlePool++;return this._fileSearchProvider.set(g,p),this._proxy.$registerFileSearchProvider(g,this._transformScheme(o)),(0,_.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(o),this._fileSearchProvider.delete(g),this._proxy.$unregisterProvider(g)})}$provideFileSearchResults(o,p,g,E){const m=d(g),u=this._fileSearchProvider.get(o);if(u)return this._fileSearchManager.fileSearch(m,u,w=>{this._proxy.$handleFileMatch(o,p,w.map(t=>t.resource))},E);throw new Error("unknown provider: "+o)}$clearCache(o){return this._fileSearchManager.clearCache(o),Promise.resolve(void 0)}$provideTextSearchResults(o,p,g,E){const m=this._textSearchProvider.get(o);if(!m||!m.provideTextSearchResults)throw new Error(`Unknown provider ${o}`);const u=d(g);return this.createTextSearchManager(u,m).search(t=>this._proxy.$handleTextMatch(o,p,t),E)}createTextSearchManager(o,p){return new i.TextSearchManager(o,p,{readdir:g=>Promise.resolve([]),toCanonicalName:g=>g})}};I=je([Ke(0,y.IExtHostRpcService),Ke(1,D.IURITransformerService),Ke(2,S.ILogService)],I),e.ExtHostSearch=I;function d(r){return Object.assign(Object.assign({},r),{folderQueries:r.folderQueries&&r.folderQueries.map(f),extraFileResources:r.extraFileResources&&r.extraFileResources.map(o=>C.URI.revive(o))})}e.reviveQuery=d;function f(r){return Object.assign(Object.assign({},r),{folder:C.URI.revive(r.folder)})}}),define(ve[225],be([0,1,130,20,12,3,47,2,123,85,117,59,64,5,190,189,76,191,34,192,193,194,176,195,39,35,196,177,198,199,200,100,180,203,204,205,78,40,206,181,9,7,209,50,101,30,33,51,166,197,93,99,103,104,105,18,71,14,27,201,164,70,75,187,207,163,79,77,212,210,211,188,49,218,208,74,160,94,202,67,102]),function(J,e,_,k,A,T,y,D,S,C,i,I,d,f,r,o,p,g,E,m,u,w,t,n,l,a,s,c,v,P,h,b,R,U,K,he,V,H,Y,W,F,L,M,x,G,X,ne,me,Le,We,Fe,ze,$,j,te,oe,de,_e,Be,fe,De,Re,He,we,qe,z,ee,ge,Ne,Ve,$e,Ze,ye,Ee,Ce,re,le,N,Q,ae,ke){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ie(Ae){const xe=Ae.get(Be.IExtHostInitDataService),Ye=Ae.get(ye.IExtHostFileSystemInfo),rt=Ae.get(ge.IExtHostConsumerFileSystem),tt=Ae.get(a.IExtHostExtensionService),Qe=Ae.get(X.IExtHostWorkspace),mt=Ae.get(N.IExtHostTelemetry),bt=Ae.get(E.IExtHostConfiguration),pe=Ae.get(de.IURITransformerService),ce=Ae.get(_e.IExtHostRpcService),se=Ae.get(V.IExtHostStorage),q=Ae.get(ee.IExtensionStoragePaths),Me=Ae.get(oe.ILogService),Te=Ae.get(Re.IExtHostTunnelService),Je=Ae.get(He.IExtHostApiDeprecationService),et=Ae.get(G.IExtHostWindow),ct=Ae.get(re.IExtHostSecretState);ce.set(f.ExtHostContext.ExtHostFileSystemInfo,Ye),ce.set(f.ExtHostContext.ExtHostLogService,Me),ce.set(f.ExtHostContext.ExtHostWorkspace,Qe),ce.set(f.ExtHostContext.ExtHostConfiguration,bt),ce.set(f.ExtHostContext.ExtHostExtensionService,tt),ce.set(f.ExtHostContext.ExtHostStorage,se),ce.set(f.ExtHostContext.ExtHostTunnelService,Te),ce.set(f.ExtHostContext.ExtHostWindow,et),ce.set(f.ExtHostContext.ExtHostSecretState,ct),ce.set(f.ExtHostContext.ExtHostTelemetry,mt);const ht=ce.set(f.ExtHostContext.ExtHostDecorations,Ae.get(ze.IExtHostDecorations)),Xe=ce.set(f.ExtHostContext.ExtHostDocumentsAndEditors,Ae.get(l.IExtHostDocumentsAndEditors)),at=ce.set(f.ExtHostContext.ExtHostCommands,Ae.get(p.IExtHostCommands)),ft=ce.set(f.ExtHostContext.ExtHostTerminalService,Ae.get(H.IExtHostTerminalService)),lt=ce.set(f.ExtHostContext.ExtHostDebugService,Ae.get(j.IExtHostDebugService)),Et=ce.set(f.ExtHostContext.ExtHostSearch,Ae.get(te.IExtHostSearch)),vt=ce.set(f.ExtHostContext.ExtHostTask,Ae.get($.IExtHostTask)),kt=ce.set(f.ExtHostContext.ExtHostOutputService,Ae.get(b.IExtHostOutputService)),At=ce.set(f.ExtHostContext.ExtHostEditorTabs,new le.ExtHostEditorTabs),Tt=ce.set(f.ExtHostContext.ExtHostUrls,new M.ExtHostUrls(ce)),_t=ce.set(f.ExtHostContext.ExtHostDocuments,new n.ExtHostDocuments(ce,Xe)),Yt=ce.set(f.ExtHostContext.ExtHostDocumentContentProviders,new w.ExtHostDocumentContentProvider(ce,Xe,Me)),Jt=ce.set(f.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(Me,_t,ce.getProxy(f.MainContext.MainThreadBulkEdits))),gt=ce.set(f.ExtHostContext.ExtHostNotebook,new fe.ExtHostNotebookController(ce,at,Xe,_t,Me,q)),Xt=ce.set(f.ExtHostContext.ExtHostNotebookKernels,new Q.ExtHostNotebookKernels(ce,xe,gt)),St=ce.set(f.ExtHostContext.ExtHostEditors,new Y.ExtHostEditors(ce,Xe)),jt=ce.set(f.ExtHostContext.ExtHostTreeViews,new W.ExtHostTreeViews(ce.getProxy(f.MainContext.MainThreadTreeViews),at,Me)),Zt=ce.set(f.ExtHostContext.ExtHostEditorInsets,new Le.ExtHostEditorInsets(ce.getProxy(f.MainContext.MainThreadEditorInsets),St,xe.environment)),qt=ce.set(f.ExtHostContext.ExtHostDiagnostics,new m.ExtHostDiagnostics(ce,Me)),ut=ce.set(f.ExtHostContext.ExtHostLanguageFeatures,new v.ExtHostLanguageFeatures(ce,pe,_t,at,qt,Me,Je)),en=ce.set(f.ExtHostContext.ExtHostFileSystem,new s.ExtHostFileSystem(ce,ut)),Rt=ce.set(f.ExtHostContext.ExtHostFileSystemEventService,new c.ExtHostFileSystemEventService(ce,Me,Xe)),xt=ce.set(f.ExtHostContext.ExtHostQuickOpen,(0,U.createExtHostQuickOpen)(ce,Qe,at)),dn=ce.set(f.ExtHostContext.ExtHostSCM,new K.ExtHostSCM(ce,at,Me)),_n=ce.set(f.ExtHostContext.ExtHostComments,new g.ExtHostComments(ce,at,_t)),hn=ce.set(f.ExtHostContext.ExtHostProgress,new R.ExtHostProgress(ce.getProxy(f.MainContext.MainThreadProgress))),tn=ce.set(f.ExtHostContext.ExtHosLabelService,new We.ExtHostLabelService(ce)),Kt=ce.set(f.ExtHostContext.ExtHostTheming,new De.ExtHostTheming(ce)),Nt=ce.set(f.ExtHostContext.ExtHostAuthentication,new we.ExtHostAuthentication(ce)),En=ce.set(f.ExtHostContext.ExtHostTimeline,new qe.ExtHostTimeline(ce,at)),nn=ce.set(f.ExtHostContext.ExtHostWebviews,new x.ExtHostWebviews(ce,xe.environment,Qe,Me,Je)),rn=ce.set(f.ExtHostContext.ExtHostWebviewPanels,new $e.ExtHostWebviewPanels(ce,nn,Qe)),Gt=ce.set(f.ExtHostContext.ExtHostCustomEditors,new Ve.ExtHostCustomEditors(ce,_t,q,nn,rn)),yn=ce.set(f.ExtHostContext.ExtHostWebviewViews,new Ne.ExtHostWebviewViews(ce,nn)),Ft=ce.set(f.ExtHostContext.ExtHostTesting,new Ee.ExtHostTesting(ce,Xe,Qe)),sn=ce.set(f.ExtHostContext.ExtHostUriOpeners,new Ce.ExtHostUriOpeners(ce)),Sn=(0,me.values)(f.ExtHostContext);ce.assertRegistered(Sn);const $t=new Ze.ExtHostBulkEdits(ce,Xe),on=new o.ExtHostClipboard(ce),Ut=new h.ExtHostMessageService(ce,Me),Lt=new u.ExtHostDialogs(ce),fn=new he.ExtHostStatusBar(ce,at.converter),Wt=new P.ExtHostLanguages(ce,_t);return r.ExtHostApiCommands.register(at),function(Oe,an,ln){const pt=function(){let Z=!Oe.isUnderDevelopment;function ue(Pe){Z||(Me.info(`Extension '${Oe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Z=!0)}return function Pe(st){if(Array.isArray(st))st.forEach(Pe);else if(typeof st=="string")ue(st);else{const wt=st;typeof wt.scheme=="undefined"&&ue(st),!Oe.enableProposedApi&&typeof wt.exclusive=="boolean"&&(0,ne.throwProposedApiError)(Oe)}return st}}(),Dn={getSession(Z,ue,Pe){return Nt.getSession(Oe,Z,ue,Pe)},get onDidChangeSessions(){return Nt.onDidChangeSessions},registerAuthenticationProvider(Z,ue,Pe,st){return Nt.registerAuthenticationProvider(Z,ue,Pe,st)},get onDidChangeAuthenticationProviders(){return(0,ne.checkProposedApiEnabled)(Oe),Nt.onDidChangeAuthenticationProviders},get providers(){return(0,ne.checkProposedApiEnabled)(Oe),Nt.providers},logout(Z,ue){return(0,ne.checkProposedApiEnabled)(Oe),Nt.removeSession(Z,ue)}},Cn={registerCommand(Z,ue,Pe){return at.registerCommand(!0,Z,ue,Pe)},registerTextEditorCommand(Z,ue,Pe){return at.registerCommand(!0,Z,(...st)=>{const wt=St.getActiveTextEditor();if(!wt){Me.warn("Cannot execute "+Z+" because there is no active text editor.");return}return wt.edit(Dt=>{ue.apply(Pe,[wt,Dt,...st])}).then(Dt=>{Dt||Me.warn("Edits from command "+Z+" were not applied.")},Dt=>{Me.warn("An error occurred while running command "+Z,Dt)})})},registerDiffInformationCommand:(Z,ue,Pe)=>((0,ne.checkProposedApiEnabled)(Oe),at.registerCommand(!0,Z,async(...st)=>{const wt=Xe.activeEditor(!0);if(!wt){Me.warn("Cannot execute "+Z+" because there is no active text editor.");return}const Dt=await St.getDiffInformation(wt.id);ue.apply(Pe,[Dt,...st])})),executeCommand(Z,...ue){return at.executeCommand(Z,...ue)},getCommands(Z=!1){return at.getCommands(Z)}},mn={get machineId(){return xe.telemetryInfo.machineId},get sessionId(){return xe.telemetryInfo.sessionId},get language(){return xe.environment.appLanguage},get appName(){return xe.environment.appName},get appRoot(){var Z,ue;return(ue=(Z=xe.environment.appRoot)===null||Z===void 0?void 0:Z.fsPath)!==null&&ue!==void 0?ue:""},get uriScheme(){return xe.environment.appUriScheme},get clipboard(){return on.value},get shell(){return ft.getDefaultShell(!1,ln)},get isTelemetryEnabled(){return mt.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return mt.onDidChangeTelemetryEnabled},get isNewAppInstall(){const Z=Date.now()-new Date(xe.telemetryInfo.firstSessionDate).getTime();return isNaN(Z)?!1:Z<1e3*60*60*24},openExternal(Z,ue){return et.openUri(Z,{allowTunneling:!!xe.remote.authority,allowContributedOpeners:ue==null?void 0:ue.allowContributedOpeners})},asExternalUri(Z){return Z.scheme===xe.environment.appUriScheme?Tt.createAppUri(Z):et.asExternalUri(Z,{allowTunneling:!!xe.remote.authority})},get remoteName(){return(0,Fe.getRemoteName)(xe.remote.authority)},get uiKind(){return xe.uiKind}};xe.environment.extensionTestsLocationURI||Object.freeze(mn);const gn=xe.remote.isRemote?L.ExtensionKind.Workspace:L.ExtensionKind.UI,Ht={registerTestController(Z){return(0,ne.checkProposedApiEnabled)(Oe),Ft.registerTestController(Oe.identifier.value,Z)},createDocumentTestObserver(Z){return(0,ne.checkProposedApiEnabled)(Oe),Ft.createTextDocumentTestObserver(Z)},createWorkspaceTestObserver(Z){return(0,ne.checkProposedApiEnabled)(Oe),Ft.createWorkspaceTestObserver(Z)},runTests(Z){return(0,ne.checkProposedApiEnabled)(Oe),Ft.runTests(Z)},createTestItem(Z,ue){return new L.TestItemImpl(Z.id,Z.label,Z.uri,ue)},createTestRun(Z,ue,Pe){return(0,ne.checkProposedApiEnabled)(Oe),Ft.createTestRun(Oe.identifier.value,Z,ue,Pe)},get onDidChangeTestResults(){return(0,ne.checkProposedApiEnabled)(Oe),Ft.onResultsChanged},get testResults(){return(0,ne.checkProposedApiEnabled)(Oe),Ft.results}};Ht.createTestRunTask=Ht.createTestRun;const kn={getExtension(Z){const ue=an.getExtensionDescription(Z);if(ue)return new a.Extension(tt,Oe.identifier,ue,gn)},get all(){return an.getAllExtensionDescriptions().map(Z=>new a.Extension(tt,Oe.identifier,Z,gn))},get onDidChange(){return an.onDidChange}},In={createDiagnosticCollection(Z){return qt.createDiagnosticCollection(Oe.identifier,Z)},get onDidChangeDiagnostics(){return qt.onDidChangeDiagnostics},getDiagnostics:Z=>qt.getDiagnostics(Z),getLanguages(){return Wt.getLanguages()},setTextDocumentLanguage(Z,ue){return Wt.changeLanguage(Z.uri,ue)},match(Z,ue){return(0,I.score)(F.LanguageSelector.from(Z),ue.uri,ue.languageId,!0)},registerCodeActionsProvider(Z,ue,Pe){return ut.registerCodeActionProvider(Oe,pt(Z),ue,Pe)},registerCodeLensProvider(Z,ue){return ut.registerCodeLensProvider(Oe,pt(Z),ue)},registerDefinitionProvider(Z,ue){return ut.registerDefinitionProvider(Oe,pt(Z),ue)},registerDeclarationProvider(Z,ue){return ut.registerDeclarationProvider(Oe,pt(Z),ue)},registerImplementationProvider(Z,ue){return ut.registerImplementationProvider(Oe,pt(Z),ue)},registerTypeDefinitionProvider(Z,ue){return ut.registerTypeDefinitionProvider(Oe,pt(Z),ue)},registerHoverProvider(Z,ue){return ut.registerHoverProvider(Oe,pt(Z),ue,Oe.identifier)},registerEvaluatableExpressionProvider(Z,ue){return ut.registerEvaluatableExpressionProvider(Oe,pt(Z),ue,Oe.identifier)},registerInlineValuesProvider(Z,ue){return ut.registerInlineValuesProvider(Oe,pt(Z),ue,Oe.identifier)},registerDocumentHighlightProvider(Z,ue){return ut.registerDocumentHighlightProvider(Oe,pt(Z),ue)},registerLinkedEditingRangeProvider(Z,ue){return ut.registerLinkedEditingRangeProvider(Oe,pt(Z),ue)},registerReferenceProvider(Z,ue){return ut.registerReferenceProvider(Oe,pt(Z),ue)},registerRenameProvider(Z,ue){return ut.registerRenameProvider(Oe,pt(Z),ue)},registerDocumentSymbolProvider(Z,ue,Pe){return ut.registerDocumentSymbolProvider(Oe,pt(Z),ue,Pe)},registerWorkspaceSymbolProvider(Z){return ut.registerWorkspaceSymbolProvider(Oe,Z)},registerDocumentFormattingEditProvider(Z,ue){return ut.registerDocumentFormattingEditProvider(Oe,pt(Z),ue)},registerDocumentRangeFormattingEditProvider(Z,ue){return ut.registerDocumentRangeFormattingEditProvider(Oe,pt(Z),ue)},registerOnTypeFormattingEditProvider(Z,ue,Pe,...st){return ut.registerOnTypeFormattingEditProvider(Oe,pt(Z),ue,[Pe].concat(st))},registerDocumentSemanticTokensProvider(Z,ue,Pe){return ut.registerDocumentSemanticTokensProvider(Oe,pt(Z),ue,Pe)},registerDocumentRangeSemanticTokensProvider(Z,ue,Pe){return ut.registerDocumentRangeSemanticTokensProvider(Oe,pt(Z),ue,Pe)},registerSignatureHelpProvider(Z,ue,Pe,...st){return typeof Pe=="object"?ut.registerSignatureHelpProvider(Oe,pt(Z),ue,Pe):ut.registerSignatureHelpProvider(Oe,pt(Z),ue,typeof Pe=="undefined"?[]:[Pe,...st])},registerCompletionItemProvider(Z,ue,...Pe){return ut.registerCompletionItemProvider(Oe,pt(Z),ue,Pe)},registerDocumentLinkProvider(Z,ue){return ut.registerDocumentLinkProvider(Oe,pt(Z),ue)},registerColorProvider(Z,ue){return ut.registerColorProvider(Oe,pt(Z),ue)},registerFoldingRangeProvider(Z,ue){return ut.registerFoldingRangeProvider(Oe,pt(Z),ue)},registerSelectionRangeProvider(Z,ue){return ut.registerSelectionRangeProvider(Oe,Z,ue)},registerCallHierarchyProvider(Z,ue){return ut.registerCallHierarchyProvider(Oe,Z,ue)},setLanguageConfiguration:(Z,ue)=>ut.setLanguageConfiguration(Oe,Z,ue),getTokenInformationAtPosition(Z,ue){return(0,ne.checkProposedApiEnabled)(Oe),Wt.tokenAtPosition(Z,ue)},registerInlayHintsProvider(Z,ue){return(0,ne.checkProposedApiEnabled)(Oe),ut.registerInlayHintsProvider(Oe,Z,ue)}},Pn={get activeTextEditor(){return St.getActiveTextEditor()},get visibleTextEditors(){return St.getVisibleTextEditors()},get activeTerminal(){return ft.activeTerminal},get terminals(){return ft.terminals},async showTextDocument(Z,ue,Pe){const st=await(D.URI.isUri(Z)?Promise.resolve(pn.openTextDocument(Z)):Promise.resolve(Z));return St.showTextDocument(st,ue,Pe)},createTextEditorDecorationType(Z){return St.createTextEditorDecorationType(Z)},onDidChangeActiveTextEditor(Z,ue,Pe){return St.onDidChangeActiveTextEditor(Z,ue,Pe)},onDidChangeVisibleTextEditors(Z,ue,Pe){return St.onDidChangeVisibleTextEditors(Z,ue,Pe)},onDidChangeTextEditorSelection(Z,ue,Pe){return St.onDidChangeTextEditorSelection(Z,ue,Pe)},onDidChangeTextEditorOptions(Z,ue,Pe){return St.onDidChangeTextEditorOptions(Z,ue,Pe)},onDidChangeTextEditorVisibleRanges(Z,ue,Pe){return St.onDidChangeTextEditorVisibleRanges(Z,ue,Pe)},onDidChangeTextEditorViewColumn(Z,ue,Pe){return St.onDidChangeTextEditorViewColumn(Z,ue,Pe)},onDidCloseTerminal(Z,ue,Pe){return ft.onDidCloseTerminal(Z,ue,Pe)},onDidOpenTerminal(Z,ue,Pe){return ft.onDidOpenTerminal(Z,ue,Pe)},onDidChangeActiveTerminal(Z,ue,Pe){return ft.onDidChangeActiveTerminal(Z,ue,Pe)},onDidChangeTerminalDimensions(Z,ue,Pe){return(0,ne.checkProposedApiEnabled)(Oe),ft.onDidChangeTerminalDimensions(Z,ue,Pe)},onDidWriteTerminalData(Z,ue,Pe){return(0,ne.checkProposedApiEnabled)(Oe),ft.onDidWriteTerminalData(Z,ue,Pe)},get state(){return et.state},onDidChangeWindowState(Z,ue,Pe){return et.onDidChangeWindowState(Z,ue,Pe)},showInformationMessage(Z,...ue){return Ut.showMessage(Oe,y.default.Info,Z,ue[0],ue.slice(1))},showWarningMessage(Z,...ue){return Ut.showMessage(Oe,y.default.Warning,Z,ue[0],ue.slice(1))},showErrorMessage(Z,...ue){return Ut.showMessage(Oe,y.default.Error,Z,ue[0],ue.slice(1))},showQuickPick(Z,ue,Pe){return xt.showQuickPick(Z,!!Oe.enableProposedApi,ue,Pe)},showWorkspaceFolderPick(Z){return xt.showWorkspaceFolderPick(Z)},showInputBox(Z,ue){return xt.showInput(Z,ue)},showOpenDialog(Z){return Lt.showOpenDialog(Z)},showSaveDialog(Z){return Lt.showSaveDialog(Z)},createStatusBarItem(Z,ue){let Pe,st,wt,Dt;return Z&&typeof Z!="number"?(Pe=Z.id,st=Z.name,wt=Z.alignment,ue=Z.priority,Dt=Z.accessibilityInformation):(Pe=Oe.identifier.value,st=_.localize(0,null,Oe.displayName||Oe.name),wt=Z),fn.createStatusBarEntry(Pe,st,wt,ue,Dt)},setStatusBarMessage(Z,ue){return fn.setStatusBarMessage(Z,ue)},withScmProgress(Z){return Je.report("window.withScmProgress",Oe,"Use 'withProgress' instead."),hn.withProgress(Oe,{location:L.ProgressLocation.SourceControl},(ue,Pe)=>Z({report(st){}}))},withProgress(Z,ue){return hn.withProgress(Oe,Z,ue)},createOutputChannel(Z){return kt.createOutputChannel(Z)},createWebviewPanel(Z,ue,Pe,st){return rn.createWebviewPanel(Oe,Z,ue,Pe,st)},createWebviewTextEditorInset(Z,ue,Pe,st){return(0,ne.checkProposedApiEnabled)(Oe),Zt.createWebviewEditorInset(Z,ue,Pe,st,Oe)},createTerminal(Z,ue,Pe){return typeof Z=="object"?"pty"in Z?ft.createExtensionTerminal(Z):(Z.icon&&(0,ne.checkProposedApiEnabled)(Oe),ft.createTerminalFromOptions(Z)):ft.createTerminal(Z,ue,Pe)},registerTerminalLinkProvider(Z){return ft.registerLinkProvider(Z)},registerTreeDataProvider(Z,ue){return jt.registerTreeDataProvider(Z,ue,Oe)},createTreeView(Z,ue){return jt.createTreeView(Z,ue,Oe)},registerWebviewPanelSerializer:(Z,ue)=>rn.registerWebviewPanelSerializer(Oe,Z,ue),registerCustomEditorProvider:(Z,ue,Pe={})=>Gt.registerCustomEditorProvider(Oe,Z,ue,Pe),registerFileDecorationProvider(Z){return ht.registerFileDecorationProvider(Z,Oe.identifier)},registerUriHandler(Z){return Tt.registerUriHandler(Oe.identifier,Z)},createQuickPick(){return xt.createQuickPick(Oe.identifier,!!Oe.enableProposedApi)},createInputBox(){return xt.createInputBox(Oe.identifier)},get activeColorTheme(){return Kt.activeColorTheme},onDidChangeActiveColorTheme(Z,ue,Pe){return Kt.onDidChangeActiveColorTheme(Z,ue,Pe)},registerWebviewViewProvider(Z,ue,Pe){return yn.registerWebviewViewProvider(Oe,Z,ue,Pe==null?void 0:Pe.webviewOptions)},get activeNotebookEditor(){return(0,ne.checkProposedApiEnabled)(Oe),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(Z,ue,Pe){return(0,ne.checkProposedApiEnabled)(Oe),gt.onDidChangeActiveNotebookEditor(Z,ue,Pe)},get visibleNotebookEditors(){return(0,ne.checkProposedApiEnabled)(Oe),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,ne.checkProposedApiEnabled)(Oe),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Z,ue,Pe){return(0,ne.checkProposedApiEnabled)(Oe),gt.onDidChangeNotebookEditorSelection(Z,ue,Pe)},onDidChangeNotebookEditorVisibleRanges(Z,ue,Pe){return(0,ne.checkProposedApiEnabled)(Oe),gt.onDidChangeNotebookEditorVisibleRanges(Z,ue,Pe)},showNotebookDocument(Z,ue){return(0,ne.checkProposedApiEnabled)(Oe),gt.showNotebookDocument(Z,ue)},registerExternalUriOpener(Z,ue,Pe){return(0,ne.checkProposedApiEnabled)(Oe),sn.registerExternalUriOpener(Oe.identifier,Z,ue,Pe)},get openEditors(){return(0,ne.checkProposedApiEnabled)(Oe),At.tabs},get onDidChangeOpenEditors(){return(0,ne.checkProposedApiEnabled)(Oe),At.onDidChangeTabs}},pn={get rootPath(){return Je.report("workspace.rootPath",Oe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Qe.getPath()},set rootPath(Z){throw A.readonly()},getWorkspaceFolder(Z){return Qe.getWorkspaceFolder(Z)},get workspaceFolders(){return Qe.getWorkspaceFolders()},get name(){return Qe.name},set name(Z){throw A.readonly()},get workspaceFile(){return Qe.workspaceFile},set workspaceFile(Z){throw A.readonly()},updateWorkspaceFolders:(Z,ue,...Pe)=>Qe.updateWorkspaceFolders(Oe,Z,ue||0,...Pe),onDidChangeWorkspaceFolders:function(Z,ue,Pe){return Qe.onDidChangeWorkspace(Z,ue,Pe)},asRelativePath:(Z,ue)=>Qe.getRelativePath(Z,ue),findFiles:(Z,ue,Pe,st)=>Qe.findFiles(F.GlobPattern.from(Z),F.GlobPattern.from(ue),Pe,Oe.identifier,st),findTextInFiles:(Z,ue,Pe,st)=>{let wt,Dt;return typeof ue=="object"?(wt=ue,Dt=Pe):(wt={},Dt=ue,st=Pe),Qe.findTextInFiles(Z,wt||{},Dt,Oe.identifier,st)},saveAll:Z=>Qe.saveAll(Z),applyEdit(Z){return $t.applyWorkspaceEdit(Z)},createFileSystemWatcher:(Z,ue,Pe,st)=>Rt.createFileSystemWatcher(F.GlobPattern.from(Z),ue,Pe,st),get textDocuments(){return _t.getAllDocumentData().map(Z=>Z.document)},set textDocuments(Z){throw A.readonly()},openTextDocument(Z){let ue;const Pe=Z;if(typeof Z=="string")ue=Promise.resolve(D.URI.file(Z));else if(D.URI.isUri(Z))ue=Promise.resolve(Z);else if(!Pe||typeof Pe=="object")ue=_t.createDocumentData(Pe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(st=>_t.ensureDocumentData(st).then(wt=>wt.document))},onDidOpenTextDocument:(Z,ue,Pe)=>_t.onDidAddDocument(Z,ue,Pe),onDidCloseTextDocument:(Z,ue,Pe)=>_t.onDidRemoveDocument(Z,ue,Pe),onDidChangeTextDocument:(Z,ue,Pe)=>_t.onDidChangeDocument(Z,ue,Pe),onDidSaveTextDocument:(Z,ue,Pe)=>_t.onDidSaveDocument(Z,ue,Pe),onWillSaveTextDocument:(Z,ue,Pe)=>Jt.getOnWillSaveTextDocumentEvent(Oe)(Z,ue,Pe),onDidChangeConfiguration:(Z,ue,Pe)=>ln.onDidChangeConfiguration(Z,ue,Pe),getConfiguration(Z,ue){return ue=arguments.length===1?void 0:ue,ln.getConfiguration(Z,ue,Oe)},registerTextDocumentContentProvider(Z,ue){return Yt.registerTextDocumentContentProvider(Z,ue)},registerTaskProvider:(Z,ue)=>(Je.report("window.registerTaskProvider",Oe,"Use the corresponding function on the 'tasks' namespace instead"),vt.registerTaskProvider(Oe,Z,ue)),registerFileSystemProvider(Z,ue,Pe){return en.registerFileSystemProvider(Oe.identifier,Z,ue,Pe)},get fs(){return rt.value},registerFileSearchProvider:(Z,ue)=>((0,ne.checkProposedApiEnabled)(Oe),Et.registerFileSearchProvider(Z,ue)),registerTextSearchProvider:(Z,ue)=>((0,ne.checkProposedApiEnabled)(Oe),Et.registerTextSearchProvider(Z,ue)),registerRemoteAuthorityResolver:(Z,ue)=>((0,ne.checkProposedApiEnabled)(Oe),tt.registerRemoteAuthorityResolver(Z,ue)),registerResourceLabelFormatter:Z=>((0,ne.checkProposedApiEnabled)(Oe),tn.$registerResourceLabelFormatter(Z)),onDidCreateFiles:(Z,ue,Pe)=>Rt.onDidCreateFile(Z,ue,Pe),onDidDeleteFiles:(Z,ue,Pe)=>Rt.onDidDeleteFile(Z,ue,Pe),onDidRenameFiles:(Z,ue,Pe)=>Rt.onDidRenameFile(Z,ue,Pe),onWillCreateFiles:(Z,ue,Pe)=>Rt.getOnWillCreateFileEvent(Oe)(Z,ue,Pe),onWillDeleteFiles:(Z,ue,Pe)=>Rt.getOnWillDeleteFileEvent(Oe)(Z,ue,Pe),onWillRenameFiles:(Z,ue,Pe)=>Rt.getOnWillRenameFileEvent(Oe)(Z,ue,Pe),openTunnel:Z=>((0,ne.checkProposedApiEnabled)(Oe),Te.openTunnel(Oe,Z).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,ne.checkProposedApiEnabled)(Oe),Te.getTunnels()},onDidChangeTunnels:(Z,ue,Pe)=>((0,ne.checkProposedApiEnabled)(Oe),Te.onDidChangeTunnels(Z,ue,Pe)),registerPortAttributesProvider:(Z,ue)=>((0,ne.checkProposedApiEnabled)(Oe),Te.registerPortsAttributesProvider(Z,ue)),registerTimelineProvider:(Z,ue)=>((0,ne.checkProposedApiEnabled)(Oe),En.registerTimelineProvider(Z,ue,Oe.identifier,at.converter)),get isTrusted(){return Qe.trusted},requestWorkspaceTrust:Z=>((0,ne.checkProposedApiEnabled)(Oe),Qe.requestWorkspaceTrust(Z)),onDidGrantWorkspaceTrust:(Z,ue,Pe)=>Qe.onDidGrantWorkspaceTrust(Z,ue,Pe)},An={get inputBox(){return Je.report("scm.inputBox",Oe,"Use 'SourceControl.inputBox' instead"),dn.getLastInputBox(Oe)},createSourceControl(Z,ue,Pe){return dn.createSourceControl(Oe,Z,ue,Pe)}},vn={createCommentController(Z,ue){return _n.createCommentController(Oe,Z,ue)}},bn={get activeDebugSession(){return lt.activeDebugSession},get activeDebugConsole(){return lt.activeDebugConsole},get breakpoints(){return lt.breakpoints},onDidStartDebugSession(Z,ue,Pe){return lt.onDidStartDebugSession(Z,ue,Pe)},onDidTerminateDebugSession(Z,ue,Pe){return lt.onDidTerminateDebugSession(Z,ue,Pe)},onDidChangeActiveDebugSession(Z,ue,Pe){return lt.onDidChangeActiveDebugSession(Z,ue,Pe)},onDidReceiveDebugSessionCustomEvent(Z,ue,Pe){return lt.onDidReceiveDebugSessionCustomEvent(Z,ue,Pe)},onDidChangeBreakpoints(Z,ue,Pe){return lt.onDidChangeBreakpoints(Z,ue,Pe)},registerDebugConfigurationProvider(Z,ue,Pe){return lt.registerDebugConfigurationProvider(Z,ue,Pe||L.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Z,ue){return lt.registerDebugAdapterDescriptorFactory(Oe,Z,ue)},registerDebugAdapterTrackerFactory(Z,ue){return lt.registerDebugAdapterTrackerFactory(Z,ue)},startDebugging(Z,ue,Pe){return!Pe||typeof Pe=="object"&&"configuration"in Pe?lt.startDebugging(Z,ue,{parentSession:Pe}):lt.startDebugging(Z,ue,Pe||{})},stopDebugging(Z){return lt.stopDebugging(Z)},addBreakpoints(Z){return lt.addBreakpoints(Z)},removeBreakpoints(Z){return lt.removeBreakpoints(Z)},asDebugSourceUri(Z,ue){return lt.asDebugSourceUri(Z,ue)}},Bt={registerTaskProvider:(Z,ue)=>vt.registerTaskProvider(Oe,Z,ue),fetchTasks:Z=>vt.fetchTasks(Z),executeTask:Z=>vt.executeTask(Oe,Z),get taskExecutions(){return vt.taskExecutions},onDidStartTask:(Z,ue,Pe)=>vt.onDidStartTask(Z,ue,Pe),onDidEndTask:(Z,ue,Pe)=>vt.onDidEndTask(Z,ue,Pe),onDidStartTaskProcess:(Z,ue,Pe)=>vt.onDidStartTaskProcess(Z,ue,Pe),onDidEndTaskProcess:(Z,ue,Pe)=>vt.onDidEndTaskProcess(Z,ue,Pe)},zt={openNotebookDocument:Z=>((0,ne.checkProposedApiEnabled)(Oe),gt.openNotebookDocument(Z)),get onDidOpenNotebookDocument(){return(0,ne.checkProposedApiEnabled)(Oe),gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,ne.checkProposedApiEnabled)(Oe),gt.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,ne.checkProposedApiEnabled)(Oe),gt.onDidSaveNotebookDocument},get notebookDocuments(){return(0,ne.checkProposedApiEnabled)(Oe),gt.notebookDocuments.map(Z=>Z.apiNotebook)},registerNotebookSerializer(Z,ue,Pe,st){return(0,ne.checkProposedApiEnabled)(Oe),gt.registerNotebookSerializer(Oe,Z,ue,Pe,Oe.enableProposedApi?st:void 0)},registerNotebookContentProvider:(Z,ue,Pe,st)=>((0,ne.checkProposedApiEnabled)(Oe),gt.registerNotebookContentProvider(Oe,Z,ue,Pe,Oe.enableProposedApi?st:void 0)),registerNotebookCellStatusBarItemProvider:(Z,ue)=>((0,ne.checkProposedApiEnabled)(Oe),gt.registerNotebookCellStatusBarItemProvider(Oe,Z,ue)),createNotebookEditorDecorationType(Z){return(0,ne.checkProposedApiEnabled)(Oe),gt.createNotebookEditorDecorationType(Z)},onDidChangeNotebookDocumentMetadata(Z,ue,Pe){return(0,ne.checkProposedApiEnabled)(Oe),gt.onDidChangeNotebookDocumentMetadata(Z,ue,Pe)},onDidChangeNotebookCells(Z,ue,Pe){return(0,ne.checkProposedApiEnabled)(Oe),gt.onDidChangeNotebookCells(Z,ue,Pe)},onDidChangeCellExecutionState(Z,ue,Pe){return(0,ne.checkProposedApiEnabled)(Oe),gt.onDidChangeNotebookCellExecutionState(Z,ue,Pe)},onDidChangeCellOutputs(Z,ue,Pe){return(0,ne.checkProposedApiEnabled)(Oe),gt.onDidChangeCellOutputs(Z,ue,Pe)},onDidChangeCellMetadata(Z,ue,Pe){return(0,ne.checkProposedApiEnabled)(Oe),gt.onDidChangeCellMetadata(Z,ue,Pe)},createConcatTextDocument(Z,ue){return(0,ne.checkProposedApiEnabled)(Oe),new z.ExtHostNotebookConcatDocument(gt,_t,Z,ue)},createNotebookController(Z,ue,Pe,st,wt){return(0,ne.checkProposedApiEnabled)(Oe),Xt.createNotebookController(Oe,Z,ue,Pe,st,wt)}};return{version:xe.version,authentication:Dn,commands:Cn,comments:vn,debug:bn,env:mn,extensions:kn,languages:In,notebook:zt,scm:An,tasks:Bt,test:Ht,window:Pn,workspace:pn,Breakpoint:L.Breakpoint,CallHierarchyIncomingCall:L.CallHierarchyIncomingCall,CallHierarchyItem:L.CallHierarchyItem,CallHierarchyOutgoingCall:L.CallHierarchyOutgoingCall,CancellationError:A.CancellationError,CancellationTokenSource:k.CancellationTokenSource,CandidatePortSource:f.CandidatePortSource,CodeAction:L.CodeAction,CodeActionKind:L.CodeActionKind,CodeActionTriggerKind:L.CodeActionTriggerKind,CodeLens:L.CodeLens,Color:L.Color,ColorInformation:L.ColorInformation,ColorPresentation:L.ColorPresentation,ColorThemeKind:L.ColorThemeKind,CommentMode:L.CommentMode,CommentThreadCollapsibleState:L.CommentThreadCollapsibleState,CompletionItem:L.CompletionItem,CompletionItemKind:L.CompletionItemKind,CompletionItemTag:L.CompletionItemTag,CompletionList:L.CompletionList,CompletionTriggerKind:L.CompletionTriggerKind,ConfigurationTarget:L.ConfigurationTarget,CustomExecution:L.CustomExecution,DebugAdapterExecutable:L.DebugAdapterExecutable,DebugAdapterInlineImplementation:L.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:L.DebugAdapterNamedPipeServer,DebugAdapterServer:L.DebugAdapterServer,DebugConfigurationProviderTriggerKind:L.DebugConfigurationProviderTriggerKind,DebugConsoleMode:L.DebugConsoleMode,DecorationRangeBehavior:L.DecorationRangeBehavior,Diagnostic:L.Diagnostic,DiagnosticRelatedInformation:L.DiagnosticRelatedInformation,DiagnosticSeverity:L.DiagnosticSeverity,DiagnosticTag:L.DiagnosticTag,Disposable:L.Disposable,DocumentHighlight:L.DocumentHighlight,DocumentHighlightKind:L.DocumentHighlightKind,DocumentLink:L.DocumentLink,DocumentSymbol:L.DocumentSymbol,EndOfLine:L.EndOfLine,EnvironmentVariableMutatorType:L.EnvironmentVariableMutatorType,EvaluatableExpression:L.EvaluatableExpression,InlineValueText:L.InlineValueText,InlineValueVariableLookup:L.InlineValueVariableLookup,InlineValueEvaluatableExpression:L.InlineValueEvaluatableExpression,EventEmitter:T.Emitter,ExtensionKind:L.ExtensionKind,ExtensionMode:L.ExtensionMode,ExternalUriOpenerPriority:L.ExternalUriOpenerPriority,FileChangeType:L.FileChangeType,FileDecoration:L.FileDecoration,FileSystemError:L.FileSystemError,FileType:d.FileType,FoldingRange:L.FoldingRange,FoldingRangeKind:L.FoldingRangeKind,FunctionBreakpoint:L.FunctionBreakpoint,Hover:L.Hover,IndentAction:i.IndentAction,Location:L.Location,MarkdownString:L.MarkdownString,OverviewRulerLane:C.OverviewRulerLane,ParameterInformation:L.ParameterInformation,PortAutoForwardAction:L.PortAutoForwardAction,Position:L.Position,ProcessExecution:L.ProcessExecution,ProgressLocation:L.ProgressLocation,QuickInputButtons:L.QuickInputButtons,Range:L.Range,RelativePattern:L.RelativePattern,Selection:L.Selection,SelectionRange:L.SelectionRange,SemanticTokens:L.SemanticTokens,SemanticTokensBuilder:L.SemanticTokensBuilder,SemanticTokensEdit:L.SemanticTokensEdit,SemanticTokensEdits:L.SemanticTokensEdits,SemanticTokensLegend:L.SemanticTokensLegend,ShellExecution:L.ShellExecution,ShellQuoting:L.ShellQuoting,SignatureHelp:L.SignatureHelp,SignatureHelpTriggerKind:L.SignatureHelpTriggerKind,SignatureInformation:L.SignatureInformation,SnippetString:L.SnippetString,SourceBreakpoint:L.SourceBreakpoint,StandardTokenType:L.StandardTokenType,StatusBarAlignment:L.StatusBarAlignment,SymbolInformation:L.SymbolInformation,SymbolKind:L.SymbolKind,SymbolTag:L.SymbolTag,Task:L.Task,TaskGroup:L.TaskGroup,TaskPanelKind:L.TaskPanelKind,TaskRevealKind:L.TaskRevealKind,TaskScope:L.TaskScope,TextDocumentSaveReason:L.TextDocumentSaveReason,TextEdit:L.TextEdit,TextEditorCursorStyle:S.TextEditorCursorStyle,TextEditorLineNumbersStyle:L.TextEditorLineNumbersStyle,TextEditorRevealType:L.TextEditorRevealType,TextEditorSelectionChangeKind:L.TextEditorSelectionChangeKind,ThemeColor:L.ThemeColor,ThemeIcon:L.ThemeIcon,TreeItem:L.TreeItem,TreeItemCollapsibleState:L.TreeItemCollapsibleState,UIKind:f.UIKind,Uri:D.URI,ViewColumn:L.ViewColumn,WorkspaceEdit:L.WorkspaceEdit,InlayHint:L.InlayHint,InlayHintKind:L.InlayHintKind,RemoteAuthorityResolverError:L.RemoteAuthorityResolverError,RemoteTrustOption:ae.RemoteTrustOption,ResolvedAuthority:L.ResolvedAuthority,SourceControlInputBoxValidationType:L.SourceControlInputBoxValidationType,ExtensionRuntime:L.ExtensionRuntime,TimelineItem:L.TimelineItem,NotebookRange:L.NotebookRange,NotebookCellKind:L.NotebookCellKind,NotebookCellExecutionState:L.NotebookCellExecutionState,NotebookDocumentMetadata:L.NotebookDocumentMetadata,NotebookCellMetadata:L.NotebookCellMetadata,NotebookCellData:L.NotebookCellData,NotebookData:L.NotebookData,NotebookKernelPreload:L.NotebookKernelPreload,NotebookCellStatusBarAlignment:L.NotebookCellStatusBarAlignment,NotebookEditorRevealType:L.NotebookEditorRevealType,NotebookCellOutput:L.NotebookCellOutput,NotebookCellOutputItem:L.NotebookCellOutputItem,NotebookCellStatusBarItem:L.NotebookCellStatusBarItem,NotebookControllerAffinity:L.NotebookControllerAffinity,LinkedEditingRanges:L.LinkedEditingRanges,TestItemStatus:L.TestItemStatus,TestResultState:L.TestResultState,TestMessage:L.TestMessage,TextSearchCompleteMessageType:ke.TextSearchCompleteMessageType,TestMessageSeverity:L.TestMessageSeverity,WorkspaceTrustState:L.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=Ie}),define(ve[226],be([0,1,61,100,30,99,34,76,39,40,103,104,105,79,78,70,75,101,77,49,74,94]),function(J,e,_,k,A,T,y,D,S,C,i,I,d,f,r,o,p,g,E,m,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,_.registerSingleton)(f.IExtensionStoragePaths,f.ExtensionStoragePaths),(0,_.registerSingleton)(p.IExtHostApiDeprecationService,p.ExtHostApiDeprecationService),(0,_.registerSingleton)(D.IExtHostCommands,D.ExtHostCommands),(0,_.registerSingleton)(y.IExtHostConfiguration,y.ExtHostConfiguration),(0,_.registerSingleton)(E.IExtHostConsumerFileSystem,E.ExtHostConsumerFileSystem),(0,_.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService),(0,_.registerSingleton)(T.IExtHostDecorations,T.ExtHostDecorations),(0,_.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors),(0,_.registerSingleton)(m.IExtHostFileSystemInfo,m.ExtHostFileSystemInfo),(0,_.registerSingleton)(k.IExtHostOutputService,k.ExtHostOutputService),(0,_.registerSingleton)(d.IExtHostSearch,d.ExtHostSearch),(0,_.registerSingleton)(r.IExtHostStorage,r.ExtHostStorage),(0,_.registerSingleton)(i.IExtHostTask,i.WorkerExtHostTask),(0,_.registerSingleton)(C.IExtHostTerminalService,C.WorkerExtHostTerminalService),(0,_.registerSingleton)(o.IExtHostTunnelService,o.ExtHostTunnelService),(0,_.registerSingleton)(g.IExtHostWindow,g.ExtHostWindow),(0,_.registerSingleton)(A.IExtHostWorkspace,A.ExtHostWorkspace),(0,_.registerSingleton)(u.IExtHostSecretState,u.ExtHostSecretState),(0,_.registerSingleton)(w.IExtHostTelemetry,w.ExtHostTelemetry)}),define(ve[227],be([0,1,225,35,221,7,11,5]),function(J,e,_,k,A,T,y,D){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var C;(function(r){var o;const p=(o=self.trustedTypes)===null||o===void 0?void 0:o.createPolicy("TrustedFunctionWorkaround",{createScript:(E,...m)=>{m.forEach(n=>{var l;if(!((l=self.trustedTypes)===null||l===void 0?void 0:l.isScript(n)))throw new Error("TrustedScripts only, please")});const u=m.slice(0,-1).join(","),w=m.pop().toString();return`(function anonymous(${u}) {
${w}
})`}});function g(...E){return p?self.eval(p.createScript("",...E)):new Function(...E)}r.create=g})(C||(C={}));class i extends A.RequireInterceptor{_installInterceptor(){}getModule(o,p){for(let g of this._alternatives){let E=g(o);if(E){o=E;break}}if(this._factories.has(o))return this._factories.get(o).load(o,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class I extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=T.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const o=this._extHostContext.getProxy(D.MainContext.MainThreadConsole);f(o,this._initData.environment.isExtensionDevelopmentDebug);const p=this._instaService.invokeFunction(_.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(i,p,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(o){return o.browser}async _loadCommonJSModule(o,p,g){var E,m,u,w,t,n,l,a;p=p.with({path:d(p.path,".js")}),o&&performance.mark(`code/extHost/willFetchExtensionCode/${o.value}`);const s=await fetch(p.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o.value}`),s.status!==200)throw new Error(s.statusText);const c=await s.text(),v=`${p.toString(!0)}#vscode-extension`,P=`${c}
//# sourceURL=${v}`;let h;try{h=C.create((m=(E=I._ttpExtensionScripts)===null||E===void 0?void 0:E.createScript("module"))!==null&&m!==void 0?m:"module",(w=(u=I._ttpExtensionScripts)===null||u===void 0?void 0:u.createScript("exports"))!==null&&w!==void 0?w:"exports",(n=(t=I._ttpExtensionScripts)===null||t===void 0?void 0:t.createScript("require"))!==null&&n!==void 0?n:"require",(a=(l=I._ttpExtensionScripts)===null||l===void 0?void 0:l.createScript(P))!==null&&a!==void 0?a:P)}catch(K){throw o?console.error(`Loading code for extension ${o.value} failed: ${K.message}`):console.error(`Loading code failed: ${K.message}`),console.error(`${p.toString(!0)}${typeof K.line=="number"?` line ${K.line}`:""}${typeof K.column=="number"?` column ${K.column}`:""}`),console.error(K),K}const b={},R={exports:b},U=K=>{const he=this._fakeModules.getModule(K,p);if(he===void 0)throw new Error(`Cannot load module '${K}'`);return he};try{return g.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o.value}`),h(R,b,U),R.exports!==b?R.exports:b}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o.value}`),g.codeLoadingStop()}}async $setRemoteEnvironment(o){throw new Error("Not supported")}async _waitForDebuggerAttachment(o=5e3){if(!!this._initData.environment.isExtensionDevelopmentDebug){const p=Date.now()+o;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,y.timeout)(10)}}}e.ExtHostExtensionService=I,I._ttpExtensionScripts=(S=self.trustedTypes)===null||S===void 0?void 0:S.createPolicy("ExtensionScripts",{createScript:r=>r});function d(r,o){return r.endsWith(o)?r:r+o}function f(r,o){p("info","log"),p("log","log"),p("warn","warn"),p("error","error");function p(m,u){const w=console[m];console[m]=function(){r.$logExtensionHostMessage({type:"__$console",severity:u,arguments:E(arguments)}),o&&w.apply(console,arguments)}}const g=1e5;function E(m){const u=[],w=[];if(m.length)for(let t=0;t<m.length;t++){if(typeof m[t]=="undefined")m[t]="undefined";else if(m[t]instanceof Error){const n=m[t];n.stack?m[t]=n.stack:m[t]=n.toString()}w.push(m[t])}try{const t=JSON.stringify(w,function(n,l){if(l&&typeof l=="object"){if(u.indexOf(l)!==-1)return"[Circular]";u.push(l)}return l});return t.length>g?"Output omitted for a large object that exceeds the limits":t}catch(t){return`Output omitted for an object that cannot be inspected ('${t.toString()}')`}}}}),define(ve[228],be([0,1,61,18,35,227,213]),function(J,e,_,k,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,_.registerSingleton)(A.IExtHostExtensionService,T.ExtHostExtensionService),(0,_.registerSingleton)(k.ILogService,y.ExtHostLogService)}),define(ve[230],be([0,1,24,3,184,222,215,13,80,226,228]),function(J,e,_,k,A,T,y,D,S){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0});const i=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const I=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const p=(C=self.trustedTypes)===null||C===void 0?void 0:C.createPolicy("extensionHostWorker",{createScriptURL:E=>E}),g=self.Worker;Worker=function(E,m){const u=`importScripts('${E}');`;m=m||{},m.name=m.name||D.basename(E.toString());const w=new Blob([u],{type:"application/javascript"}),t=URL.createObjectURL(w);return new g(p?p.createScriptURL(t):t,m)}}else self.Worker=class extends y.NestedWorker{constructor(p,g){super(I,p,Object.assign({name:D.basename(p.toString())},g))}};const d=new class{exit(p){i()}async exists(p){return!0}async realpath(p){return p}};class f{constructor(){const g=new MessageChannel,E=new k.Emitter;let m=!1;I(g.port2,[g.port2]),g.port1.onmessage=u=>{const{data:w}=u;if(!(w instanceof ArrayBuffer)){console.warn("UNKNOWN data received",w);return}const t=_.VSBuffer.wrap(new Uint8Array(w,0,w.byteLength));if((0,A.isMessageOfType)(t,2)){m=!0,o("received terminate message from renderer");return}E.fire(t)},this.protocol={onMessage:E.event,send:u=>{if(!m){const w=u.buffer.buffer.slice(u.buffer.byteOffset,u.buffer.byteOffset+u.buffer.byteLength);g.port1.postMessage(w,[w])}}}}}function r(p){return new Promise(g=>{const E=p.onMessage(m=>{E.dispose();const u=JSON.parse(m.toString());p.send((0,A.createMessageOfType)(0)),g({protocol:p,initData:u})});p.send((0,A.createMessageOfType)(1))})}let o=p=>i();(function(){const g=new f;S.mark("code/extHost/willConnectToRenderer"),r(g.protocol).then(E=>{S.mark("code/extHost/didWaitForInitData");const m=new T.ExtensionHostMain(E.protocol,E.initData,d,null);o=u=>m.terminate(u)})})()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a19565da7dfc739fa26e36aae96113e19fe3806f/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
